/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the ARM target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 85;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(ARMInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(ARMInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static ARMInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static ARMInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s1,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 16;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_NoHonorSignDependentRoundingBit = 75,
  Feature_HasV4TBit = 6,
  Feature_NoV4TBit = 7,
  Feature_HasV5TBit = 13,
  Feature_NoV5TBit = 65,
  Feature_HasV5TEBit = 11,
  Feature_HasV6Bit = 0,
  Feature_NoV6Bit = 9,
  Feature_HasV6MBit = 28,
  Feature_HasV8MBaselineBit = 35,
  Feature_HasV8_1MMainlineBit = 41,
  Feature_HasMVEIntBit = 63,
  Feature_HasMVEFloatBit = 64,
  Feature_HasCDEBit = 84,
  Feature_HasFPRegsBit = 42,
  Feature_HasFPRegs16Bit = 43,
  Feature_HasFPRegs64Bit = 76,
  Feature_HasV6T2Bit = 8,
  Feature_HasV6KBit = 18,
  Feature_HasV7Bit = 3,
  Feature_HasV8Bit = 55,
  Feature_PreV8Bit = 19,
  Feature_HasV8_1aBit = 78,
  Feature_HasV8_3aBit = 79,
  Feature_NoVFPBit = 22,
  Feature_HasVFP2Bit = 21,
  Feature_HasVFP3Bit = 52,
  Feature_HasVFP4Bit = 50,
  Feature_HasDPVFPBit = 44,
  Feature_HasFPARMv8Bit = 47,
  Feature_HasNEONBit = 53,
  Feature_HasSHA2Bit = 62,
  Feature_HasAESBit = 54,
  Feature_HasDotProdBit = 56,
  Feature_HasCRCBit = 14,
  Feature_HasLOBBit = 40,
  Feature_HasFP16Bit = 61,
  Feature_HasFullFP16Bit = 46,
  Feature_HasMatMulInt8Bit = 57,
  Feature_HasDivideInThumbBit = 37,
  Feature_HasDivideInARMBit = 12,
  Feature_HasDSPBit = 36,
  Feature_HasDBBit = 15,
  Feature_HasV7ClrexBit = 17,
  Feature_HasAcquireReleaseBit = 16,
  Feature_HasMPBit = 2,
  Feature_Has8MSecExtBit = 29,
  Feature_HasZCZBit = 58,
  Feature_UseNEONForFPBit = 82,
  Feature_DontUseNEONForFPBit = 45,
  Feature_IsThumbBit = 26,
  Feature_IsThumb1OnlyBit = 27,
  Feature_IsThumb2Bit = 34,
  Feature_IsNotMClassBit = 38,
  Feature_IsARMBit = 1,
  Feature_IsWindowsBit = 30,
  Feature_IsNotWindowsBit = 31,
  Feature_IsReadTPTPIDRURWBit = 68,
  Feature_IsReadTPTPIDRUROBit = 69,
  Feature_IsReadTPTPIDRPRWBit = 70,
  Feature_IsReadTPSoftBit = 20,
  Feature_UseNaClTrapBit = 4,
  Feature_DontUseNaClTrapBit = 5,
  Feature_UseMovtBit = 39,
  Feature_DontUseMovtBit = 23,
  Feature_UseMovtInPicBit = 24,
  Feature_DontUseMovtInPicBit = 25,
  Feature_UseFPVMLxBit = 49,
  Feature_SLSBLRMitigationBit = 67,
  Feature_NoSLSBLRMitigationBit = 66,
  Feature_UseMulOpsBit = 10,
  Feature_UseFusedMACBit = 51,
  Feature_HasFastVGETLNi32Bit = 59,
  Feature_HasSlowVGETLNi32Bit = 80,
  Feature_HasFastVDUP32Bit = 60,
  Feature_HasSlowVDUP32Bit = 81,
  Feature_UseVMOVSRBit = 48,
  Feature_DontUseVMOVSRBit = 83,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 77,
  Feature_GenExecuteOnlyBit = 33,
  Feature_DontGenExecuteOnlyBit = 32,
  Feature_GenT1ExecuteOnlyBit = 73,
  Feature_SignRetAddrBit = 72,
  Feature_NoSignRetAddrBit = 71,
};

PredicateBitset ARMInstructionSelector::
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!TM.Options.HonorSignDependentRoundingFPMath())
    Features.set(Feature_NoHonorSignDependentRoundingBit);
  if (Subtarget->hasV4TOps())
    Features.set(Feature_HasV4TBit);
  if (!Subtarget->hasV4TOps())
    Features.set(Feature_NoV4TBit);
  if (Subtarget->hasV5TOps())
    Features.set(Feature_HasV5TBit);
  if (!Subtarget->hasV5TOps())
    Features.set(Feature_NoV5TBit);
  if (Subtarget->hasV5TEOps())
    Features.set(Feature_HasV5TEBit);
  if (Subtarget->hasV6Ops())
    Features.set(Feature_HasV6Bit);
  if (!Subtarget->hasV6Ops())
    Features.set(Feature_NoV6Bit);
  if (Subtarget->hasV6MOps())
    Features.set(Feature_HasV6MBit);
  if (Subtarget->hasV8MBaselineOps())
    Features.set(Feature_HasV8MBaselineBit);
  if (Subtarget->hasV8_1MMainlineOps())
    Features.set(Feature_HasV8_1MMainlineBit);
  if (Subtarget->hasMVEIntegerOps())
    Features.set(Feature_HasMVEIntBit);
  if (Subtarget->hasMVEFloatOps())
    Features.set(Feature_HasMVEFloatBit);
  if (Subtarget->hasCDEOps())
    Features.set(Feature_HasCDEBit);
  if (Subtarget->hasFPRegs())
    Features.set(Feature_HasFPRegsBit);
  if (Subtarget->hasFPRegs16())
    Features.set(Feature_HasFPRegs16Bit);
  if (Subtarget->hasFPRegs64())
    Features.set(Feature_HasFPRegs64Bit);
  if (Subtarget->hasV6T2Ops())
    Features.set(Feature_HasV6T2Bit);
  if (Subtarget->hasV6KOps())
    Features.set(Feature_HasV6KBit);
  if (Subtarget->hasV7Ops())
    Features.set(Feature_HasV7Bit);
  if (Subtarget->hasV8Ops())
    Features.set(Feature_HasV8Bit);
  if (!Subtarget->hasV8Ops())
    Features.set(Feature_PreV8Bit);
  if (Subtarget->hasV8_1aOps())
    Features.set(Feature_HasV8_1aBit);
  if (Subtarget->hasV8_3aOps())
    Features.set(Feature_HasV8_3aBit);
  if (!Subtarget->hasVFP2Base())
    Features.set(Feature_NoVFPBit);
  if (Subtarget->hasVFP2Base())
    Features.set(Feature_HasVFP2Bit);
  if (Subtarget->hasVFP3Base())
    Features.set(Feature_HasVFP3Bit);
  if (Subtarget->hasVFP4Base())
    Features.set(Feature_HasVFP4Bit);
  if (Subtarget->hasFP64())
    Features.set(Feature_HasDPVFPBit);
  if (Subtarget->hasFPARMv8Base())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasLOB())
    Features.set(Feature_HasLOBBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasDivideInThumbMode())
    Features.set(Feature_HasDivideInThumbBit);
  if (Subtarget->hasDivideInARMMode())
    Features.set(Feature_HasDivideInARMBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDataBarrier())
    Features.set(Feature_HasDBBit);
  if (Subtarget->hasV7Clrex())
    Features.set(Feature_HasV7ClrexBit);
  if (Subtarget->hasAcquireRelease())
    Features.set(Feature_HasAcquireReleaseBit);
  if (Subtarget->hasMPExtension())
    Features.set(Feature_HasMPBit);
  if (Subtarget->has8MSecExt())
    Features.set(Feature_Has8MSecExtBit);
  if (Subtarget->hasZeroCycleZeroing())
    Features.set(Feature_HasZCZBit);
  if (Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseNEONForFPBit);
  if (!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseNEONForFPBit);
  if (Subtarget->isThumb())
    Features.set(Feature_IsThumbBit);
  if (Subtarget->isThumb1Only())
    Features.set(Feature_IsThumb1OnlyBit);
  if (Subtarget->isThumb2())
    Features.set(Feature_IsThumb2Bit);
  if (!Subtarget->isMClass())
    Features.set(Feature_IsNotMClassBit);
  if (!Subtarget->isThumb())
    Features.set(Feature_IsARMBit);
  if (Subtarget->isTargetWindows())
    Features.set(Feature_IsWindowsBit);
  if (!Subtarget->isTargetWindows())
    Features.set(Feature_IsNotWindowsBit);
  if (Subtarget->isReadTPTPIDRURW())
    Features.set(Feature_IsReadTPTPIDRURWBit);
  if (Subtarget->isReadTPTPIDRURO())
    Features.set(Feature_IsReadTPTPIDRUROBit);
  if (Subtarget->isReadTPTPIDRPRW())
    Features.set(Feature_IsReadTPTPIDRPRWBit);
  if (Subtarget->isReadTPSoft())
    Features.set(Feature_IsReadTPSoftBit);
  if (Subtarget->useNaClTrap())
    Features.set(Feature_UseNaClTrapBit);
  if (!Subtarget->useNaClTrap())
    Features.set(Feature_DontUseNaClTrapBit);
  if (Subtarget->useMulOps())
    Features.set(Feature_UseMulOpsBit);
  if (TM.Options.AllowFPOpFusion ==  FPOpFusion::Fast && Subtarget->useFPVFMx())
    Features.set(Feature_UseFusedMACBit);
  if (!Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasFastVGETLNi32Bit);
  if (Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasSlowVGETLNi32Bit);
  if (!Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasFastVDUP32Bit);
  if (Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasSlowVDUP32Bit);
  if (Subtarget->preferVMOVSR() ||!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseVMOVSRBit);
  if (!Subtarget->preferVMOVSR() &&Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseVMOVSRBit);
  if (Subtarget->genExecuteOnly())
    Features.set(Feature_GenExecuteOnlyBit);
  if (!Subtarget->genExecuteOnly())
    Features.set(Feature_DontGenExecuteOnlyBit);
  if (Subtarget->genExecuteOnly() && Subtarget->isThumb1Only() && !Subtarget->hasV8MBaselineOps())
    Features.set(Feature_GenT1ExecuteOnlyBit);
  return Features;
}

void ARMInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const ARMSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset ARMInstructionSelector::
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (Subtarget->useMovt())
    Features.set(Feature_UseMovtBit);
  if (!Subtarget->useMovt())
    Features.set(Feature_DontUseMovtBit);
  if (Subtarget->useMovt() && Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_UseMovtInPicBit);
  if (!Subtarget->useMovt() || !Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_DontUseMovtInPicBit);
  if (((Subtarget->useFPVMLx() &&  TM.Options.AllowFPOpFusion != FPOpFusion::Fast) ||Subtarget->hasMinSize()))
    Features.set(Feature_UseFPVMLxBit);
  if ( MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (MF->getDataLayout().isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (MF->getDataLayout().isBigEndian())
    Features.set(Feature_IsBEBit);
  if ( MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_SignRetAddrBit);
  if ( !MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_NoSignRetAddrBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
  GIFBS_HasFP16,
  GIFBS_HasFPARMv8,
  GIFBS_HasFPRegs,
  GIFBS_HasFullFP16,
  GIFBS_HasMVEFloat,
  GIFBS_HasMVEInt,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasVFP2,
  GIFBS_HasVFP3,
  GIFBS_HasVFP4,
  GIFBS_IsARM,
  GIFBS_IsThumb,
  GIFBS_IsThumb2,
  GIFBS_NoHonorSignDependentRounding,
  GIFBS_DontUseNEONForFP_HasVFP2,
  GIFBS_DontUseNaClTrap_IsARM,
  GIFBS_DontUseVMOVSR_HasNEON,
  GIFBS_Has8MSecExt_IsThumb,
  GIFBS_HasAES_HasV8,
  GIFBS_HasCRC_IsARM,
  GIFBS_HasCRC_IsThumb2,
  GIFBS_HasDB_IsARM,
  GIFBS_HasDB_IsThumb,
  GIFBS_HasDPVFP_HasFPARMv8,
  GIFBS_HasDPVFP_HasVFP2,
  GIFBS_HasDPVFP_HasVFP3,
  GIFBS_HasDPVFP_HasVFP4,
  GIFBS_HasDPVFP_NoHonorSignDependentRounding,
  GIFBS_HasDSP_IsThumb2,
  GIFBS_HasDivideInARM_IsARM,
  GIFBS_HasFP16_HasNEON,
  GIFBS_HasFPARMv8_HasNEON,
  GIFBS_HasFPRegs_HasFastVGETLNi32,
  GIFBS_HasFPRegs_UseVMOVSR,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasMVEInt_HasV8_1MMainline,
  GIFBS_HasMVEInt_IsBE,
  GIFBS_HasMVEInt_IsLE,
  GIFBS_HasNEON_HasV8,
  GIFBS_HasNEON_HasV8_1a,
  GIFBS_HasNEON_HasV8_3a,
  GIFBS_HasNEON_HasVFP4,
  GIFBS_HasNEON_IsBE,
  GIFBS_HasNEON_IsLE,
  GIFBS_HasNEON_UseNEONForFP,
  GIFBS_HasSHA2_HasV8,
  GIFBS_HasV5T_IsARM,
  GIFBS_HasV5T_IsThumb,
  GIFBS_HasV5TE_IsARM,
  GIFBS_HasV6_IsARM,
  GIFBS_HasV6K_IsARM,
  GIFBS_HasV6M_IsThumb,
  GIFBS_HasV6T2_IsARM,
  GIFBS_HasV7_IsARM,
  GIFBS_HasV7Clrex_IsThumb,
  GIFBS_HasV8MBaseline_IsThumb,
  GIFBS_IsARM_NoV5T,
  GIFBS_IsARM_NoV6,
  GIFBS_IsARM_PreV8,
  GIFBS_IsARM_UseNaClTrap,
  GIFBS_IsThumb_IsThumb1Only,
  GIFBS_IsThumb_IsWindows,
  GIFBS_IsThumb_NoV5T,
  GIFBS_IsThumb_UseMovt,
  GIFBS_IsThumb2_PreV8,
  GIFBS_IsThumb2_UseMulOps,
  GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only,
  GIFBS_HasDSP_IsThumb2_UseMulOps,
  GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb,
  GIFBS_HasFPARMv8_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEON_HasV8,
  GIFBS_HasFullFP16_HasNEON_HasV8_3a,
  GIFBS_HasFullFP16_HasNEON_UseFPVMLx,
  GIFBS_HasFullFP16_HasNEON_UseFusedMAC,
  GIFBS_HasLOB_HasV8_1MMainline_IsThumb2,
  GIFBS_HasNEON_UseFPVMLx_UseNEONForFP,
  GIFBS_HasV5TE_IsARM_UseMulOps,
  GIFBS_HasV6_IsARM_UseMulOps,
  GIFBS_HasV6_IsThumb_IsThumb1Only,
  GIFBS_HasV6T2_IsARM_UseMulOps,
  GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP,
  GIFBS_IsARM_NoV6_UseMulOps,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFPRegsBit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasMVEFloatBit, },
  {Feature_HasMVEIntBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasVFP2Bit, },
  {Feature_HasVFP3Bit, },
  {Feature_HasVFP4Bit, },
  {Feature_IsARMBit, },
  {Feature_IsThumbBit, },
  {Feature_IsThumb2Bit, },
  {Feature_NoHonorSignDependentRoundingBit, },
  {Feature_DontUseNEONForFPBit, Feature_HasVFP2Bit, },
  {Feature_DontUseNaClTrapBit, Feature_IsARMBit, },
  {Feature_DontUseVMOVSRBit, Feature_HasNEONBit, },
  {Feature_Has8MSecExtBit, Feature_IsThumbBit, },
  {Feature_HasAESBit, Feature_HasV8Bit, },
  {Feature_HasCRCBit, Feature_IsARMBit, },
  {Feature_HasCRCBit, Feature_IsThumb2Bit, },
  {Feature_HasDBBit, Feature_IsARMBit, },
  {Feature_HasDBBit, Feature_IsThumbBit, },
  {Feature_HasDPVFPBit, Feature_HasFPARMv8Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP2Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP3Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP4Bit, },
  {Feature_HasDPVFPBit, Feature_NoHonorSignDependentRoundingBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, },
  {Feature_HasDivideInARMBit, Feature_IsARMBit, },
  {Feature_HasFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFPARMv8Bit, Feature_HasNEONBit, },
  {Feature_HasFPRegsBit, Feature_HasFastVGETLNi32Bit, },
  {Feature_HasFPRegsBit, Feature_UseVMOVSRBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasMVEIntBit, Feature_HasV8_1MMainlineBit, },
  {Feature_HasMVEIntBit, Feature_IsBEBit, },
  {Feature_HasMVEIntBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasNEONBit, Feature_HasV8_1aBit, },
  {Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasNEONBit, Feature_HasVFP4Bit, },
  {Feature_HasNEONBit, Feature_IsBEBit, },
  {Feature_HasNEONBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_UseNEONForFPBit, },
  {Feature_HasSHA2Bit, Feature_HasV8Bit, },
  {Feature_HasV5TBit, Feature_IsARMBit, },
  {Feature_HasV5TBit, Feature_IsThumbBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, },
  {Feature_HasV6KBit, Feature_IsARMBit, },
  {Feature_HasV6MBit, Feature_IsThumbBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, },
  {Feature_HasV7Bit, Feature_IsARMBit, },
  {Feature_HasV7ClrexBit, Feature_IsThumbBit, },
  {Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_IsARMBit, Feature_NoV5TBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, },
  {Feature_IsARMBit, Feature_PreV8Bit, },
  {Feature_IsARMBit, Feature_UseNaClTrapBit, },
  {Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_IsThumbBit, Feature_IsWindowsBit, },
  {Feature_IsThumbBit, Feature_NoV5TBit, },
  {Feature_IsThumbBit, Feature_UseMovtBit, },
  {Feature_IsThumb2Bit, Feature_PreV8Bit, },
  {Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_DontUseMovtBit, Feature_GenExecuteOnlyBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_HasDivideInThumbBit, Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_HasFPARMv8Bit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFPVMLxBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFusedMACBit, },
  {Feature_HasLOBBit, Feature_HasV8_1MMainlineBit, Feature_IsThumb2Bit, },
  {Feature_HasNEONBit, Feature_UseFPVMLxBit, Feature_UseNEONForFPBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasVFP4Bit, Feature_UseFusedMACBit, Feature_UseNEONForFPBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, Feature_UseMulOpsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

ARMInstructionSelector::ComplexMatcherMemFn
ARMInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_bf_inv_mask_imm = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_or_disjoint,
  GICXXPred_MI_Predicate_vfp_f32imm,
  GICXXPred_MI_Predicate_vfp_f64imm,
};
bool ARMInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_bf_inv_mask_imm: {
    
        // There's better methods of implementing this check. IntImmLeaf<> would be
        // equivalent and have less boilerplate but we need a test for C++
        // predicates and this one causes new rules to be imported into GlobalISel
        // without requiring additional features first.
        const auto &MO = MI.getOperand(1);
        if (!MO.isCImm())
          return false;
        return ARM::isBitFieldInvertedMask(MO.getCImm()->getZExtValue());
      
    llvm_unreachable("bf_inv_mask_imm should have returned");
  }
  case GICXXPred_MI_Predicate_or_disjoint: {
    
        return MI.getFlag(MachineInstr::Disjoint);
      
  }
  case GICXXPred_MI_Predicate_vfp_f32imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP32Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f32imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f64imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP64Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f64imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex16,
  GICXXPred_I64_Predicate_VectorIndex32,
  GICXXPred_I64_Predicate_VectorIndex64,
  GICXXPred_I64_Predicate_asr_imm,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_32,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_239,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm0_255_expr,
  GICXXPred_I64_Predicate_imm0_4095,
  GICXXPred_I64_Predicate_imm0_65535,
  GICXXPred_I64_Predicate_imm0_65535_expr,
  GICXXPred_I64_Predicate_imm0_65535_neg,
  GICXXPred_I64_Predicate_imm1_7,
  GICXXPred_I64_Predicate_imm1_15,
  GICXXPred_I64_Predicate_imm1_16,
  GICXXPred_I64_Predicate_imm1_31,
  GICXXPred_I64_Predicate_imm8,
  GICXXPred_I64_Predicate_imm8_255,
  GICXXPred_I64_Predicate_imm8_or_16,
  GICXXPred_I64_Predicate_imm16,
  GICXXPred_I64_Predicate_imm16_31,
  GICXXPred_I64_Predicate_imm24b,
  GICXXPred_I64_Predicate_imm32,
  GICXXPred_I64_Predicate_imm256_510,
  GICXXPred_I64_Predicate_imm_3b,
  GICXXPred_I64_Predicate_imm_4b,
  GICXXPred_I64_Predicate_imm_6b,
  GICXXPred_I64_Predicate_imm_7b,
  GICXXPred_I64_Predicate_imm_9b,
  GICXXPred_I64_Predicate_imm_11b,
  GICXXPred_I64_Predicate_imm_12b,
  GICXXPred_I64_Predicate_imm_13b,
  GICXXPred_I64_Predicate_imm_even,
  GICXXPred_I64_Predicate_imm_odd,
  GICXXPred_I64_Predicate_imm_sr,
  GICXXPred_I64_Predicate_long_shift,
  GICXXPred_I64_Predicate_mod_imm,
  GICXXPred_I64_Predicate_mod_imm_not,
  GICXXPred_I64_Predicate_pkh_asr_amt,
  GICXXPred_I64_Predicate_pkh_lsl_amt,
  GICXXPred_I64_Predicate_shr_imm8,
  GICXXPred_I64_Predicate_shr_imm16,
  GICXXPred_I64_Predicate_shr_imm32,
  GICXXPred_I64_Predicate_shr_imm64,
  GICXXPred_I64_Predicate_t2_so_imm,
  GICXXPred_I64_Predicate_t2_so_imm_neg,
};
bool ARMInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex8: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex16: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex32: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex64: {
    
      return ((uint64_t)Imm) < 1;
    
  }
  case GICXXPred_I64_Predicate_asr_imm: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return Imm >= 0 && Imm < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return Imm >= 0 && Imm < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return Imm >= 0 && Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_32: {
    
      return Imm >= 0 && Imm < 33;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return Imm >= 0 && Imm < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_239: {
     return Imm >= 0 && Imm < 240; 
  }
  case GICXXPred_I64_Predicate_imm0_255: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_255_expr: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_4095: {
    
      return Imm >= 0 && Imm < 4096;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_expr: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_neg: {
    
      return -Imm >= 0 && -Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm1_7: {
     return Imm > 0 && Imm < 8; 
  }
  case GICXXPred_I64_Predicate_imm1_15: {
     return Imm > 0 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_imm1_16: {
    
        return Imm > 0 && Imm <= 16;
      
  }
  case GICXXPred_I64_Predicate_imm1_31: {
     return Imm > 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_imm8: {
     return Imm == 8; 
  }
  case GICXXPred_I64_Predicate_imm8_255: {
    
      return Imm >= 8 && Imm < 256;
    
  }
  case GICXXPred_I64_Predicate_imm8_or_16: {
     return Imm == 8 || Imm == 16;
  }
  case GICXXPred_I64_Predicate_imm16: {
     return Imm == 16; 
  }
  case GICXXPred_I64_Predicate_imm16_31: {
    
      return (int32_t)Imm >= 16 && (int32_t)Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm24b: {
    
      return Imm >= 0 && Imm <= 0xffffff;
    
  }
  case GICXXPred_I64_Predicate_imm32: {
     return Imm == 32; 
  }
  case GICXXPred_I64_Predicate_imm256_510: {
    
      return Imm >= 256 && Imm < 511;
    
  }
  case GICXXPred_I64_Predicate_imm_3b: {
    { return Imm >= 0 && Imm < (1 << 3); }
    llvm_unreachable("imm_3b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_4b: {
    { return Imm >= 0 && Imm < (1 << 4); }
    llvm_unreachable("imm_4b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_6b: {
    { return Imm >= 0 && Imm < (1 << 6); }
    llvm_unreachable("imm_6b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_7b: {
    { return Imm >= 0 && Imm < (1 << 7); }
    llvm_unreachable("imm_7b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_9b: {
    { return Imm >= 0 && Imm < (1 << 9); }
    llvm_unreachable("imm_9b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_11b: {
    { return Imm >= 0 && Imm < (1 << 11); }
    llvm_unreachable("imm_11b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_12b: {
    { return Imm >= 0 && Imm < (1 << 12); }
    llvm_unreachable("imm_12b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_13b: {
    { return Imm >= 0 && Imm < (1 << 13); }
    llvm_unreachable("imm_13b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_even: {
     return (Imm & 1) == 0; 
  }
  case GICXXPred_I64_Predicate_imm_odd: {
     return (Imm & 1) == 1; 
  }
  case GICXXPred_I64_Predicate_imm_sr: {
    
      return Imm > 0 && Imm <= 32;
    
  }
  case GICXXPred_I64_Predicate_long_shift: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_mod_imm: {
    
        return ARM_AM::getSOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_mod_imm_not: {
    
        return ARM_AM::getSOImmVal(~(uint32_t)Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_pkh_asr_amt: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_pkh_lsl_amt: {
     return Imm >= 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm8: {
     return Imm > 0 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_shr_imm16: {
     return Imm > 0 && Imm <= 16; 
  }
  case GICXXPred_I64_Predicate_shr_imm32: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm64: {
     return Imm > 0 && Imm <= 64; 
  }
  case GICXXPred_I64_Predicate_t2_so_imm: {
    
        return ARM_AM::getT2SOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_t2_so_imm_neg: {
    
      return Imm && ARM_AM::getT2SOImmVal(-(uint32_t)Imm) != -1;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_arm_i32imm = GICXXPred_Invalid + 1,
};
bool ARMInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_arm_i32imm: {
    
      if (Subtarget->useMovt())
        return true;
      if (ARM_AM::isSOImmTwoPartVal(Imm.getZExtValue()))
        return true;
      return ARM_AM::isSOImmTwoPartValNeg(Imm.getZExtValue());
    
    llvm_unreachable("arm_i32imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool ARMInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("ARMInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderInvertedImm,
  GICR_renderVFPF32Imm,
  GICR_renderVFPF64Imm,
};
ARMInstructionSelector::CustomRendererFn
ARMInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &ARMInstructionSelector::renderInvertedImm,
  &ARMInstructionSelector::renderVFPF32Imm,
  &ARMInstructionSelector::renderVFPF64Imm,
};

bool ARMInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool ARMInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("ARMInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *ARMInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(311), /*)*//*default:*//*Label 79*/ GIMT_Encode4(130765),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1042),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(10369),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(13613),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(15317),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(15413), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(15509),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(18689),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(24498), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(26193), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(26580), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(35592),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(36000), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 12*/ GIMT_Encode4(36375), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 13*/ GIMT_Encode4(36750), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 14*/ GIMT_Encode4(36913), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 15*/ GIMT_Encode4(36934),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 16*/ GIMT_Encode4(91002), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 17*/ GIMT_Encode4(98664),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 18*/ GIMT_Encode4(98822), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    350 */ /*TargetOpcode::G_CONSTANT*//*Label 19*/ GIMT_Encode4(98980),
     /*    354 */ /*TargetOpcode::G_FCONSTANT*//*Label 20*/ GIMT_Encode4(99301), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    366 */ /*TargetOpcode::G_SEXT*//*Label 21*/ GIMT_Encode4(99397),
     /*    370 */ /*TargetOpcode::G_SEXT_INREG*//*Label 22*/ GIMT_Encode4(99555),
     /*    374 */ /*TargetOpcode::G_ZEXT*//*Label 23*/ GIMT_Encode4(100160),
     /*    378 */ /*TargetOpcode::G_SHL*//*Label 24*/ GIMT_Encode4(100318),
     /*    382 */ /*TargetOpcode::G_LSHR*//*Label 25*/ GIMT_Encode4(100534),
     /*    386 */ /*TargetOpcode::G_ASHR*//*Label 26*/ GIMT_Encode4(100642), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    398 */ /*TargetOpcode::G_ROTR*//*Label 27*/ GIMT_Encode4(100915), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    466 */ /*TargetOpcode::G_UMULH*//*Label 28*/ GIMT_Encode4(101247),
     /*    470 */ /*TargetOpcode::G_SMULH*//*Label 29*/ GIMT_Encode4(101495),
     /*    474 */ /*TargetOpcode::G_UADDSAT*//*Label 30*/ GIMT_Encode4(101864),
     /*    478 */ /*TargetOpcode::G_SADDSAT*//*Label 31*/ GIMT_Encode4(102509),
     /*    482 */ /*TargetOpcode::G_USUBSAT*//*Label 32*/ GIMT_Encode4(103809),
     /*    486 */ /*TargetOpcode::G_SSUBSAT*//*Label 33*/ GIMT_Encode4(104454), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FADD*//*Label 34*/ GIMT_Encode4(105474),
     /*    534 */ /*TargetOpcode::G_FSUB*//*Label 35*/ GIMT_Encode4(107827),
     /*    538 */ /*TargetOpcode::G_FMUL*//*Label 36*/ GIMT_Encode4(109504),
     /*    542 */ /*TargetOpcode::G_FMA*//*Label 37*/ GIMT_Encode4(110485), GIMT_Encode4(0),
     /*    550 */ /*TargetOpcode::G_FDIV*//*Label 38*/ GIMT_Encode4(112576), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    598 */ /*TargetOpcode::G_FNEG*//*Label 39*/ GIMT_Encode4(112741),
     /*    602 */ /*TargetOpcode::G_FPEXT*//*Label 40*/ GIMT_Encode4(114272),
     /*    606 */ /*TargetOpcode::G_FPTRUNC*//*Label 41*/ GIMT_Encode4(114508),
     /*    610 */ /*TargetOpcode::G_FPTOSI*//*Label 42*/ GIMT_Encode4(114780),
     /*    614 */ /*TargetOpcode::G_FPTOUI*//*Label 43*/ GIMT_Encode4(116114),
     /*    618 */ /*TargetOpcode::G_SITOFP*//*Label 44*/ GIMT_Encode4(117448),
     /*    622 */ /*TargetOpcode::G_UITOFP*//*Label 45*/ GIMT_Encode4(118100), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    634 */ /*TargetOpcode::G_FABS*//*Label 46*/ GIMT_Encode4(118752), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    650 */ /*TargetOpcode::G_FMINNUM*//*Label 47*/ GIMT_Encode4(119528),
     /*    654 */ /*TargetOpcode::G_FMAXNUM*//*Label 48*/ GIMT_Encode4(120120), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    666 */ /*TargetOpcode::G_FMINIMUM*//*Label 49*/ GIMT_Encode4(120712),
     /*    670 */ /*TargetOpcode::G_FMAXIMUM*//*Label 50*/ GIMT_Encode4(121446), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    682 */ /*TargetOpcode::G_GET_FPENV*//*Label 51*/ GIMT_Encode4(122180),
     /*    686 */ /*TargetOpcode::G_SET_FPENV*//*Label 52*/ GIMT_Encode4(122213),
     /*    690 */ /*TargetOpcode::G_RESET_FPENV*//*Label 53*/ GIMT_Encode4(122249),
     /*    694 */ /*TargetOpcode::G_GET_FPMODE*//*Label 54*/ GIMT_Encode4(122378), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    714 */ /*TargetOpcode::G_SMIN*//*Label 55*/ GIMT_Encode4(122411),
     /*    718 */ /*TargetOpcode::G_SMAX*//*Label 56*/ GIMT_Encode4(122954),
     /*    722 */ /*TargetOpcode::G_UMIN*//*Label 57*/ GIMT_Encode4(123497),
     /*    726 */ /*TargetOpcode::G_UMAX*//*Label 58*/ GIMT_Encode4(124418),
     /*    730 */ /*TargetOpcode::G_ABS*//*Label 59*/ GIMT_Encode4(125339), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    742 */ /*TargetOpcode::G_BR*//*Label 60*/ GIMT_Encode4(125810), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    762 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 61*/ GIMT_Encode4(125883),
     /*    766 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 62*/ GIMT_Encode4(126183), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    794 */ /*TargetOpcode::G_CTLZ*//*Label 63*/ GIMT_Encode4(126240), GIMT_Encode4(0),
     /*    802 */ /*TargetOpcode::G_CTPOP*//*Label 64*/ GIMT_Encode4(126801),
     /*    806 */ /*TargetOpcode::G_BSWAP*//*Label 65*/ GIMT_Encode4(126909),
     /*    810 */ /*TargetOpcode::G_BITREVERSE*//*Label 66*/ GIMT_Encode4(127199),
     /*    814 */ /*TargetOpcode::G_FCEIL*//*Label 67*/ GIMT_Encode4(127631), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    862 */ /*TargetOpcode::G_FSQRT*//*Label 68*/ GIMT_Encode4(128006),
     /*    866 */ /*TargetOpcode::G_FFLOOR*//*Label 69*/ GIMT_Encode4(128144),
     /*    870 */ /*TargetOpcode::G_FRINT*//*Label 70*/ GIMT_Encode4(128519),
     /*    874 */ /*TargetOpcode::G_FNEARBYINT*//*Label 71*/ GIMT_Encode4(128927), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_TRAP*//*Label 72*/ GIMT_Encode4(129065),
     /*    966 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 73*/ GIMT_Encode4(129111), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 74*/ GIMT_Encode4(129198), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 75*/ GIMT_Encode4(129619),
     /*   1030 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 76*/ GIMT_Encode4(129899),
     /*   1034 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 77*/ GIMT_Encode4(130188),
     /*   1038 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 78*/ GIMT_Encode4(130469),
     /*   1042 */ // Label 0: @1042
     /*   1042 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 89*/ GIMT_Encode4(10368),
     /*   1053 */ /*GILLT_s32*//*Label 80*/ GIMT_Encode4(1113),
     /*   1057 */ /*GILLT_s64*//*Label 81*/ GIMT_Encode4(6889), GIMT_Encode4(0),
     /*   1065 */ /*GILLT_v2s32*//*Label 82*/ GIMT_Encode4(6936),
     /*   1069 */ /*GILLT_v2s64*//*Label 83*/ GIMT_Encode4(7121), GIMT_Encode4(0),
     /*   1077 */ /*GILLT_v4s16*//*Label 84*/ GIMT_Encode4(7832),
     /*   1081 */ /*GILLT_v4s32*//*Label 85*/ GIMT_Encode4(8017), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1093 */ /*GILLT_v8s8*//*Label 86*/ GIMT_Encode4(8973),
     /*   1097 */ /*GILLT_v8s16*//*Label 87*/ GIMT_Encode4(9158), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1109 */ /*GILLT_v16s8*//*Label 88*/ GIMT_Encode4(10114),
     /*   1113 */ // Label 80: @1113
     /*   1113 */ GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(6888),
     /*   1118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1124 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1199), // Rule ID 5667 //
     /*   1129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1157 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1174 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1197 */     GIR_RootConstrainSelectedInstOperands,
     /*   1198 */     // GIR_Coverage, 5667,
     /*   1198 */     GIR_EraseRootFromParent_Done,
     /*   1199 */   // Label 91: @1199
     /*   1199 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1274), // Rule ID 5668 //
     /*   1204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1232 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1249 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1272 */     GIR_RootConstrainSelectedInstOperands,
     /*   1273 */     // GIR_Coverage, 5668,
     /*   1273 */     GIR_EraseRootFromParent_Done,
     /*   1274 */   // Label 92: @1274
     /*   1274 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1349), // Rule ID 5702 //
     /*   1279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1307 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1324 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1341 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1347 */     GIR_RootConstrainSelectedInstOperands,
     /*   1348 */     // GIR_Coverage, 5702,
     /*   1348 */     GIR_EraseRootFromParent_Done,
     /*   1349 */   // Label 93: @1349
     /*   1349 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1424), // Rule ID 5703 //
     /*   1354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1382 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1399 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1422 */     GIR_RootConstrainSelectedInstOperands,
     /*   1423 */     // GIR_Coverage, 5703,
     /*   1423 */     GIR_EraseRootFromParent_Done,
     /*   1424 */   // Label 94: @1424
     /*   1424 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1499), // Rule ID 1997 //
     /*   1429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1461 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1474 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1497 */     GIR_RootConstrainSelectedInstOperands,
     /*   1498 */     // GIR_Coverage, 1997,
     /*   1498 */     GIR_EraseRootFromParent_Done,
     /*   1499 */   // Label 95: @1499
     /*   1499 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1574), // Rule ID 1998 //
     /*   1504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1536 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1549 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1572 */     GIR_RootConstrainSelectedInstOperands,
     /*   1573 */     // GIR_Coverage, 1998,
     /*   1573 */     GIR_EraseRootFromParent_Done,
     /*   1574 */   // Label 96: @1574
     /*   1574 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1649), // Rule ID 2236 //
     /*   1579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1611 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1624 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1647 */     GIR_RootConstrainSelectedInstOperands,
     /*   1648 */     // GIR_Coverage, 2236,
     /*   1648 */     GIR_EraseRootFromParent_Done,
     /*   1649 */   // Label 97: @1649
     /*   1649 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1724), // Rule ID 2237 //
     /*   1654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1686 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1699 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1722 */     GIR_RootConstrainSelectedInstOperands,
     /*   1723 */     // GIR_Coverage, 2237,
     /*   1723 */     GIR_EraseRootFromParent_Done,
     /*   1724 */   // Label 98: @1724
     /*   1724 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1852), // Rule ID 5678 //
     /*   1729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1760 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1772 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1776 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1780 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1785 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   1789 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1793 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1797 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1801 */     // MIs[4] Rm
     /*   1801 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1806 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   1810 */     // MIs[1] Operand 2
     /*   1810 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1825 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1827 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1850 */     GIR_RootConstrainSelectedInstOperands,
     /*   1851 */     // GIR_Coverage, 5678,
     /*   1851 */     GIR_EraseRootFromParent_Done,
     /*   1852 */   // Label 99: @1852
     /*   1852 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1980), // Rule ID 5679 //
     /*   1857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1904 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1908 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1913 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   1917 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1921 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1925 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1929 */     // MIs[4] Rm
     /*   1929 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1934 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   1938 */     // MIs[1] Operand 2
     /*   1938 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1953 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1955 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1978 */     GIR_RootConstrainSelectedInstOperands,
     /*   1979 */     // GIR_Coverage, 5679,
     /*   1979 */     GIR_EraseRootFromParent_Done,
     /*   1980 */   // Label 100: @1980
     /*   1980 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2108), // Rule ID 2103 //
     /*   1985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2032 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2036 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2040 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2045 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   2049 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2053 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2057 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2061 */     // MIs[4] Rm
     /*   2061 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2066 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   2070 */     // MIs[1] Operand 2
     /*   2070 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2081 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2083 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2106 */     GIR_RootConstrainSelectedInstOperands,
     /*   2107 */     // GIR_Coverage, 2103,
     /*   2107 */     GIR_EraseRootFromParent_Done,
     /*   2108 */   // Label 101: @2108
     /*   2108 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(2236), // Rule ID 5677 //
     /*   2113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   2116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2160 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2164 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2168 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2173 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   2177 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2181 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2185 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2189 */     // MIs[4] Rm
     /*   2189 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2194 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   2198 */     // MIs[1] Operand 2
     /*   2198 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2209 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2211 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2234 */     GIR_RootConstrainSelectedInstOperands,
     /*   2235 */     // GIR_Coverage, 5677,
     /*   2235 */     GIR_EraseRootFromParent_Done,
     /*   2236 */   // Label 102: @2236
     /*   2236 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(2346), // Rule ID 5446 //
     /*   2241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2285 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2297 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2301 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2305 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2310 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2320 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2344 */     GIR_RootConstrainSelectedInstOperands,
     /*   2345 */     // GIR_Coverage, 5446,
     /*   2345 */     GIR_EraseRootFromParent_Done,
     /*   2346 */   // Label 103: @2346
     /*   2346 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(2456), // Rule ID 5483 //
     /*   2351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2395 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2407 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2411 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2415 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2420 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2430 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2454 */     GIR_RootConstrainSelectedInstOperands,
     /*   2455 */     // GIR_Coverage, 5483,
     /*   2455 */     GIR_EraseRootFromParent_Done,
     /*   2456 */   // Label 104: @2456
     /*   2456 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2566), // Rule ID 192 //
     /*   2461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2509 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2521 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2525 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2529 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2534 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2540 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2564 */     GIR_RootConstrainSelectedInstOperands,
     /*   2565 */     // GIR_Coverage, 192,
     /*   2565 */     GIR_EraseRootFromParent_Done,
     /*   2566 */   // Label 105: @2566
     /*   2566 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2676), // Rule ID 521 //
     /*   2571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2619 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2631 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2635 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2639 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2644 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2648 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2650 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2674 */     GIR_RootConstrainSelectedInstOperands,
     /*   2675 */     // GIR_Coverage, 521,
     /*   2675 */     GIR_EraseRootFromParent_Done,
     /*   2676 */   // Label 106: @2676
     /*   2676 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2789), // Rule ID 5445 //
     /*   2681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2725 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2737 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2741 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2746 */     // MIs[3] Operand 2
     /*   2746 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2761 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2763 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2781 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2787 */     GIR_RootConstrainSelectedInstOperands,
     /*   2788 */     // GIR_Coverage, 5445,
     /*   2788 */     GIR_EraseRootFromParent_Done,
     /*   2789 */   // Label 107: @2789
     /*   2789 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2902), // Rule ID 5482 //
     /*   2794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2838 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2842 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2846 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2850 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2854 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2859 */     // MIs[3] Operand 2
     /*   2859 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2876 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   2879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2900 */     GIR_RootConstrainSelectedInstOperands,
     /*   2901 */     // GIR_Coverage, 5482,
     /*   2901 */     GIR_EraseRootFromParent_Done,
     /*   2902 */   // Label 108: @2902
     /*   2902 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(3015), // Rule ID 5444 //
     /*   2907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2947 */     // MIs[2] Operand 2
     /*   2947 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   2958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2970 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2974 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2979 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2989 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3013 */     GIR_RootConstrainSelectedInstOperands,
     /*   3014 */     // GIR_Coverage, 5444,
     /*   3014 */     GIR_EraseRootFromParent_Done,
     /*   3015 */   // Label 109: @3015
     /*   3015 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(3128), // Rule ID 5481 //
     /*   3020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3060 */     // MIs[2] Operand 2
     /*   3060 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3079 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3083 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3087 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3092 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3102 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3126 */     GIR_RootConstrainSelectedInstOperands,
     /*   3127 */     // GIR_Coverage, 5481,
     /*   3127 */     GIR_EraseRootFromParent_Done,
     /*   3128 */   // Label 110: @3128
     /*   3128 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(3241), // Rule ID 191 //
     /*   3133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3181 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3189 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3193 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3197 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3202 */     // MIs[3] Operand 2
     /*   3202 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3213 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3215 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLATB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*   3218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3239 */     GIR_RootConstrainSelectedInstOperands,
     /*   3240 */     // GIR_Coverage, 191,
     /*   3240 */     GIR_EraseRootFromParent_Done,
     /*   3241 */   // Label 111: @3241
     /*   3241 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(3354), // Rule ID 520 //
     /*   3246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3294 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3306 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3310 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3315 */     // MIs[3] Operand 2
     /*   3315 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3328 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLATB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*   3331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3341 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3352 */     GIR_RootConstrainSelectedInstOperands,
     /*   3353 */     // GIR_Coverage, 520,
     /*   3353 */     GIR_EraseRootFromParent_Done,
     /*   3354 */   // Label 112: @3354
     /*   3354 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(3467), // Rule ID 190 //
     /*   3359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3398 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3403 */     // MIs[2] Operand 2
     /*   3403 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3418 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3422 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3426 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3430 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3435 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3441 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   3444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3465 */     GIR_RootConstrainSelectedInstOperands,
     /*   3466 */     // GIR_Coverage, 190,
     /*   3466 */     GIR_EraseRootFromParent_Done,
     /*   3467 */   // Label 113: @3467
     /*   3467 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(3580), // Rule ID 519 //
     /*   3472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3516 */     // MIs[2] Operand 2
     /*   3516 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3535 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3539 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3543 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3548 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3554 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3578 */     GIR_RootConstrainSelectedInstOperands,
     /*   3579 */     // GIR_Coverage, 519,
     /*   3579 */     GIR_EraseRootFromParent_Done,
     /*   3580 */   // Label 114: @3580
     /*   3580 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(3671), // Rule ID 5676 //
     /*   3585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3625 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3629 */     // MIs[1] Operand 2
     /*   3629 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3646 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3669 */     GIR_RootConstrainSelectedInstOperands,
     /*   3670 */     // GIR_Coverage, 5676,
     /*   3670 */     GIR_EraseRootFromParent_Done,
     /*   3671 */   // Label 115: @3671
     /*   3671 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(3762), // Rule ID 2102 //
     /*   3676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3711 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3720 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3724 */     // MIs[1] Operand 2
     /*   3724 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3737 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3760 */     GIR_RootConstrainSelectedInstOperands,
     /*   3761 */     // GIR_Coverage, 2102,
     /*   3761 */     GIR_EraseRootFromParent_Done,
     /*   3762 */   // Label 116: @3762
     /*   3762 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(3878), // Rule ID 5443 //
     /*   3767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3807 */     // MIs[2] Operand 2
     /*   3807 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3826 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3830 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3835 */     // MIs[3] Operand 2
     /*   3835 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3852 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   3855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3876 */     GIR_RootConstrainSelectedInstOperands,
     /*   3877 */     // GIR_Coverage, 5443,
     /*   3877 */     GIR_EraseRootFromParent_Done,
     /*   3878 */   // Label 117: @3878
     /*   3878 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(3994), // Rule ID 5480 //
     /*   3883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3923 */     // MIs[2] Operand 2
     /*   3923 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3942 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3946 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3951 */     // MIs[3] Operand 2
     /*   3951 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3966 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3968 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   3971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3992 */     GIR_RootConstrainSelectedInstOperands,
     /*   3993 */     // GIR_Coverage, 5480,
     /*   3993 */     GIR_EraseRootFromParent_Done,
     /*   3994 */   // Label 118: @3994
     /*   3994 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(4110), // Rule ID 189 //
     /*   3999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   4002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4043 */     // MIs[2] Operand 2
     /*   4043 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4066 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4071 */     // MIs[3] Operand 2
     /*   4071 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4084 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   4084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   4087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4102 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4108 */     GIR_RootConstrainSelectedInstOperands,
     /*   4109 */     // GIR_Coverage, 189,
     /*   4109 */     GIR_EraseRootFromParent_Done,
     /*   4110 */   // Label 119: @4110
     /*   4110 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(4226), // Rule ID 518 //
     /*   4115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   4118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4159 */     // MIs[2] Operand 2
     /*   4159 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4178 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4182 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4187 */     // MIs[3] Operand 2
     /*   4187 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4200 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   4200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   4203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4224 */     GIR_RootConstrainSelectedInstOperands,
     /*   4225 */     // GIR_Coverage, 518,
     /*   4225 */     GIR_EraseRootFromParent_Done,
     /*   4226 */   // Label 120: @4226
     /*   4226 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(4314), // Rule ID 3245 //
     /*   4231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4282 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4287 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4312 */     GIR_RootConstrainSelectedInstOperands,
     /*   4313 */     // GIR_Coverage, 3245,
     /*   4313 */     GIR_EraseRootFromParent_Done,
     /*   4314 */   // Label 121: @4314
     /*   4314 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(4402), // Rule ID 3246 //
     /*   4319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4350 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4370 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4375 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4394 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4400 */     GIR_RootConstrainSelectedInstOperands,
     /*   4401 */     // GIR_Coverage, 3246,
     /*   4401 */     GIR_EraseRootFromParent_Done,
     /*   4402 */   // Label 122: @4402
     /*   4402 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(4490), // Rule ID 3249 //
     /*   4407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4458 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4463 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4488 */     GIR_RootConstrainSelectedInstOperands,
     /*   4489 */     // GIR_Coverage, 3249,
     /*   4489 */     GIR_EraseRootFromParent_Done,
     /*   4490 */   // Label 123: @4490
     /*   4490 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(4578), // Rule ID 5947 //
     /*   4495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4546 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)))  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4551 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4576 */     GIR_RootConstrainSelectedInstOperands,
     /*   4577 */     // GIR_Coverage, 5947,
     /*   4577 */     GIR_EraseRootFromParent_Done,
     /*   4578 */   // Label 124: @4578
     /*   4578 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(4666), // Rule ID 5948 //
     /*   4583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4618 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4634 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)))  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4639 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4664 */     GIR_RootConstrainSelectedInstOperands,
     /*   4665 */     // GIR_Coverage, 5948,
     /*   4665 */     GIR_EraseRootFromParent_Done,
     /*   4666 */   // Label 125: @4666
     /*   4666 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(4754), // Rule ID 5951 //
     /*   4671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4715 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4722 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)))  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4727 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4752 */     GIR_RootConstrainSelectedInstOperands,
     /*   4753 */     // GIR_Coverage, 5951,
     /*   4753 */     GIR_EraseRootFromParent_Done,
     /*   4754 */   // Label 126: @4754
     /*   4754 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(4811), // Rule ID 72 //
     /*   4759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   4762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*   4782 */     // MIs[1] Operand 1
     /*   4782 */     // No operand predicates
     /*   4782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4784 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ADDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDri),
     /*   4787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4809 */     GIR_RootConstrainSelectedInstOperands,
     /*   4810 */     // GIR_Coverage, 72,
     /*   4810 */     GIR_EraseRootFromParent_Done,
     /*   4811 */   // Label 127: @4811
     /*   4811 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(4868), // Rule ID 303 //
     /*   4816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*   4839 */     // MIs[1] Operand 1
     /*   4839 */     // No operand predicates
     /*   4839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4841 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm3)  =>  (tADDi3:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm3)
     /*   4841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi3),
     /*   4844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   4854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm3
     /*   4857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4866 */     GIR_RootConstrainSelectedInstOperands,
     /*   4867 */     // GIR_Coverage, 303,
     /*   4867 */     GIR_EraseRootFromParent_Done,
     /*   4868 */   // Label 128: @4868
     /*   4868 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(4925), // Rule ID 304 //
     /*   4873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*   4896 */     // MIs[1] Operand 1
     /*   4896 */     // No operand predicates
     /*   4896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4898 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8)  =>  (tADDi8:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm8)
     /*   4898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi8),
     /*   4901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   4903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*   4914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4923 */     GIR_RootConstrainSelectedInstOperands,
     /*   4924 */     // GIR_Coverage, 304,
     /*   4924 */     GIR_EraseRootFromParent_Done,
     /*   4925 */   // Label 129: @4925
     /*   4925 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(4982), // Rule ID 407 //
     /*   4930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*   4953 */     // MIs[1] Operand 1
     /*   4953 */     // No operand predicates
     /*   4953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4955 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ADDri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri),
     /*   4958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4980 */     GIR_RootConstrainSelectedInstOperands,
     /*   4981 */     // GIR_Coverage, 407,
     /*   4981 */     GIR_EraseRootFromParent_Done,
     /*   4982 */   // Label 130: @4982
     /*   4982 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(5033), // Rule ID 408 //
     /*   4987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   5006 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*   5010 */     // MIs[1] Operand 1
     /*   5010 */     // No operand predicates
     /*   5010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5012 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2ADDri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   5012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri12),
     /*   5015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   5019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   5022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5025 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5031 */     GIR_RootConstrainSelectedInstOperands,
     /*   5032 */     // GIR_Coverage, 408,
     /*   5032 */     GIR_EraseRootFromParent_Done,
     /*   5033 */   // Label 131: @5033
     /*   5033 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(5109), // Rule ID 171 //
     /*   5038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5077 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5107 */     GIR_RootConstrainSelectedInstOperands,
     /*   5108 */     // GIR_Coverage, 171,
     /*   5108 */     GIR_EraseRootFromParent_Done,
     /*   5109 */   // Label 132: @5109
     /*   5109 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(5185), // Rule ID 172 //
     /*   5114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5153 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5183 */     GIR_RootConstrainSelectedInstOperands,
     /*   5184 */     // GIR_Coverage, 172,
     /*   5184 */     GIR_EraseRootFromParent_Done,
     /*   5185 */   // Label 133: @5185
     /*   5185 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(5255), // Rule ID 503 //
     /*   5190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   5193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5229 */     // (add:{ *:[i32] } (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm), rGPR:{ *:[i32] }:$Ra)  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   5232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5253 */     GIR_RootConstrainSelectedInstOperands,
     /*   5254 */     // GIR_Coverage, 503,
     /*   5254 */     GIR_EraseRootFromParent_Done,
     /*   5255 */   // Label 134: @5255
     /*   5255 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(5326), // Rule ID 5669 //
     /*   5260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5284 */     // MIs[1] Operand 2
     /*   5284 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5301 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   5304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5324 */     GIR_RootConstrainSelectedInstOperands,
     /*   5325 */     // GIR_Coverage, 5669,
     /*   5325 */     GIR_EraseRootFromParent_Done,
     /*   5326 */   // Label 135: @5326
     /*   5326 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(5397), // Rule ID 5670 //
     /*   5331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5355 */     // MIs[1] Operand 2
     /*   5355 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5372 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   5375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5395 */     GIR_RootConstrainSelectedInstOperands,
     /*   5396 */     // GIR_Coverage, 5670,
     /*   5396 */     GIR_EraseRootFromParent_Done,
     /*   5397 */   // Label 136: @5397
     /*   5397 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(5468), // Rule ID 5704 //
     /*   5402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5426 */     // MIs[1] Operand 2
     /*   5426 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5443 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   5446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5460 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5466 */     GIR_RootConstrainSelectedInstOperands,
     /*   5467 */     // GIR_Coverage, 5704,
     /*   5467 */     GIR_EraseRootFromParent_Done,
     /*   5468 */   // Label 137: @5468
     /*   5468 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(5539), // Rule ID 5705 //
     /*   5473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5497 */     // MIs[1] Operand 2
     /*   5497 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5514 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   5517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5537 */     GIR_RootConstrainSelectedInstOperands,
     /*   5538 */     // GIR_Coverage, 5705,
     /*   5538 */     GIR_EraseRootFromParent_Done,
     /*   5539 */   // Label 138: @5539
     /*   5539 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(5609), // Rule ID 180 //
     /*   5544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5583 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm), GPR:{ *:[i32] }:$Ra)  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   5583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   5586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5607 */     GIR_RootConstrainSelectedInstOperands,
     /*   5608 */     // GIR_Coverage, 180,
     /*   5608 */     GIR_EraseRootFromParent_Done,
     /*   5609 */   // Label 139: @5609
     /*   5609 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(5679), // Rule ID 509 //
     /*   5614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   5617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5653 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   5656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   5662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5677 */     GIR_RootConstrainSelectedInstOperands,
     /*   5678 */     // GIR_Coverage, 509,
     /*   5678 */     GIR_EraseRootFromParent_Done,
     /*   5679 */   // Label 140: @5679
     /*   5679 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(5742), // Rule ID 3050 //
     /*   5684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5714 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   5714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   5717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5719 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5740 */     GIR_RootConstrainSelectedInstOperands,
     /*   5741 */     // GIR_Coverage, 3050,
     /*   5741 */     GIR_EraseRootFromParent_Done,
     /*   5742 */   // Label 141: @5742
     /*   5742 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(5805), // Rule ID 3078 //
     /*   5747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5777 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   5777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   5780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5782 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5803 */     GIR_RootConstrainSelectedInstOperands,
     /*   5804 */     // GIR_Coverage, 3078,
     /*   5804 */     GIR_EraseRootFromParent_Done,
     /*   5805 */   // Label 142: @5805
     /*   5805 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(5868), // Rule ID 3088 //
     /*   5810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5840 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   5840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   5843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5845 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5866 */     GIR_RootConstrainSelectedInstOperands,
     /*   5867 */     // GIR_Coverage, 3088,
     /*   5867 */     GIR_EraseRootFromParent_Done,
     /*   5868 */   // Label 143: @5868
     /*   5868 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(5944), // Rule ID 5440 //
     /*   5873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5912 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5942 */     GIR_RootConstrainSelectedInstOperands,
     /*   5943 */     // GIR_Coverage, 5440,
     /*   5943 */     GIR_EraseRootFromParent_Done,
     /*   5944 */   // Label 144: @5944
     /*   5944 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(6020), // Rule ID 5441 //
     /*   5949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5988 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6018 */     GIR_RootConstrainSelectedInstOperands,
     /*   6019 */     // GIR_Coverage, 5441,
     /*   6019 */     GIR_EraseRootFromParent_Done,
     /*   6020 */   // Label 145: @6020
     /*   6020 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(6090), // Rule ID 5478 //
     /*   6025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   6028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6064 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   6067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6088 */     GIR_RootConstrainSelectedInstOperands,
     /*   6089 */     // GIR_Coverage, 5478,
     /*   6089 */     GIR_EraseRootFromParent_Done,
     /*   6090 */   // Label 146: @6090
     /*   6090 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(6161), // Rule ID 2001 //
     /*   6095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6123 */     // MIs[1] Operand 2
     /*   6123 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6136 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   6139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6159 */     GIR_RootConstrainSelectedInstOperands,
     /*   6160 */     // GIR_Coverage, 2001,
     /*   6160 */     GIR_EraseRootFromParent_Done,
     /*   6161 */   // Label 147: @6161
     /*   6161 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(6232), // Rule ID 2002 //
     /*   6166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6194 */     // MIs[1] Operand 2
     /*   6194 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6207 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   6210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6212 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6230 */     GIR_RootConstrainSelectedInstOperands,
     /*   6231 */     // GIR_Coverage, 2002,
     /*   6231 */     GIR_EraseRootFromParent_Done,
     /*   6232 */   // Label 148: @6232
     /*   6232 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(6303), // Rule ID 2240 //
     /*   6237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6265 */     // MIs[1] Operand 2
     /*   6265 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6278 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   6281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6295 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6301 */     GIR_RootConstrainSelectedInstOperands,
     /*   6302 */     // GIR_Coverage, 2240,
     /*   6302 */     GIR_EraseRootFromParent_Done,
     /*   6303 */   // Label 149: @6303
     /*   6303 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(6374), // Rule ID 2241 //
     /*   6308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6336 */     // MIs[1] Operand 2
     /*   6336 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6349 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   6352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6372 */     GIR_RootConstrainSelectedInstOperands,
     /*   6373 */     // GIR_Coverage, 2241,
     /*   6373 */     GIR_EraseRootFromParent_Done,
     /*   6374 */   // Label 150: @6374
     /*   6374 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(6444), // Rule ID 5442 //
     /*   6379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   6382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6418 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   6418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   6421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6442 */     GIR_RootConstrainSelectedInstOperands,
     /*   6443 */     // GIR_Coverage, 5442,
     /*   6443 */     GIR_EraseRootFromParent_Done,
     /*   6444 */   // Label 151: @6444
     /*   6444 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(6514), // Rule ID 5479 //
     /*   6449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   6452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6488 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn))  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   6491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   6497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6501 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6512 */     GIR_RootConstrainSelectedInstOperands,
     /*   6513 */     // GIR_Coverage, 5479,
     /*   6513 */     GIR_EraseRootFromParent_Done,
     /*   6514 */   // Label 152: @6514
     /*   6514 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(6577), // Rule ID 5923 //
     /*   6519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   6542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6549 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec))  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   6549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   6552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6554 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6569 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6575 */     GIR_RootConstrainSelectedInstOperands,
     /*   6576 */     // GIR_Coverage, 5923,
     /*   6576 */     GIR_EraseRootFromParent_Done,
     /*   6577 */   // Label 153: @6577
     /*   6577 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(6640), // Rule ID 5937 //
     /*   6582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   6605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6612 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec))  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   6612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   6615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6617 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6638 */     GIR_RootConstrainSelectedInstOperands,
     /*   6639 */     // GIR_Coverage, 5937,
     /*   6639 */     GIR_EraseRootFromParent_Done,
     /*   6640 */   // Label 154: @6640
     /*   6640 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(6703), // Rule ID 5942 //
     /*   6645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6675 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec))  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   6675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   6678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6680 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6701 */     GIR_RootConstrainSelectedInstOperands,
     /*   6702 */     // GIR_Coverage, 5942,
     /*   6702 */     GIR_EraseRootFromParent_Done,
     /*   6703 */   // Label 155: @6703
     /*   6703 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(6749), // Rule ID 73 //
     /*   6708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   6711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6723 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ADDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*   6723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDrr),
     /*   6726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6741 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6747 */     GIR_RootConstrainSelectedInstOperands,
     /*   6748 */     // GIR_Coverage, 73,
     /*   6748 */     GIR_EraseRootFromParent_Done,
     /*   6749 */   // Label 156: @6749
     /*   6749 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(6795), // Rule ID 305 //
     /*   6754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   6757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6769 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tADDrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*   6769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDrr),
     /*   6772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   6780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6787 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6793 */     GIR_RootConstrainSelectedInstOperands,
     /*   6794 */     // GIR_Coverage, 305,
     /*   6794 */     GIR_EraseRootFromParent_Done,
     /*   6795 */   // Label 157: @6795
     /*   6795 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(6841), // Rule ID 409 //
     /*   6800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6815 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6839 */     GIR_RootConstrainSelectedInstOperands,
     /*   6840 */     // GIR_Coverage, 409,
     /*   6840 */     GIR_EraseRootFromParent_Done,
     /*   6841 */   // Label 158: @6841
     /*   6841 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(6887), // Rule ID 5460 //
     /*   6846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6861 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   6870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6879 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6885 */     GIR_RootConstrainSelectedInstOperands,
     /*   6886 */     // GIR_Coverage, 5460,
     /*   6886 */     GIR_EraseRootFromParent_Done,
     /*   6887 */   // Label 159: @6887
     /*   6887 */   GIM_Reject,
     /*   6888 */ // Label 90: @6888
     /*   6888 */ GIM_Reject,
     /*   6889 */ // Label 81: @6889
     /*   6889 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(6935), // Rule ID 759 //
     /*   6894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6915 */   // (add:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VADDv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*   6915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv1i64),
     /*   6918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6920 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   6922 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   6924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6927 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6933 */   GIR_RootConstrainSelectedInstOperands,
     /*   6934 */   // GIR_Coverage, 759,
     /*   6934 */   GIR_EraseRootFromParent_Done,
     /*   6935 */ // Label 160: @6935
     /*   6935 */ GIM_Reject,
     /*   6936 */ // Label 82: @6936
     /*   6936 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(7120),
     /*   6941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6951 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(7017), // Rule ID 5529 //
     /*   6956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6991 */     // (add:{ *:[v2i32] } (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), DPR:{ *:[v2i32] }:$src1)  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   6991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   6994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6996 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7015 */     GIR_RootConstrainSelectedInstOperands,
     /*   7016 */     // GIR_Coverage, 5529,
     /*   7016 */     GIR_EraseRootFromParent_Done,
     /*   7017 */   // Label 162: @7017
     /*   7017 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(7083), // Rule ID 886 //
     /*   7022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7057 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   7060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7062 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7081 */     GIR_RootConstrainSelectedInstOperands,
     /*   7082 */     // GIR_Coverage, 886,
     /*   7082 */     GIR_EraseRootFromParent_Done,
     /*   7083 */   // Label 163: @7083
     /*   7083 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(7119), // Rule ID 755 //
     /*   7088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7099 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VADDv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i32),
     /*   7102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7111 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7117 */     GIR_RootConstrainSelectedInstOperands,
     /*   7118 */     // GIR_Coverage, 755,
     /*   7118 */     GIR_EraseRootFromParent_Done,
     /*   7119 */   // Label 164: @7119
     /*   7119 */   GIM_Reject,
     /*   7120 */ // Label 161: @7120
     /*   7120 */ GIM_Reject,
     /*   7121 */ // Label 83: @7121
     /*   7121 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(7831),
     /*   7126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   7132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7136 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(7204), // Rule ID 779 //
     /*   7141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7173 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7180 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7202 */     GIR_RootConstrainSelectedInstOperands,
     /*   7203 */     // GIR_Coverage, 779,
     /*   7203 */     GIR_EraseRootFromParent_Done,
     /*   7204 */   // Label 166: @7204
     /*   7204 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(7272), // Rule ID 778 //
     /*   7209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7248 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7270 */     GIR_RootConstrainSelectedInstOperands,
     /*   7271 */     // GIR_Coverage, 778,
     /*   7271 */     GIR_EraseRootFromParent_Done,
     /*   7272 */   // Label 167: @7272
     /*   7272 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(7340), // Rule ID 767 //
     /*   7277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7316 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv2i64),
     /*   7319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7338 */     GIR_RootConstrainSelectedInstOperands,
     /*   7339 */     // GIR_Coverage, 767,
     /*   7339 */     GIR_EraseRootFromParent_Done,
     /*   7340 */   // Label 168: @7340
     /*   7340 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(7408), // Rule ID 777 //
     /*   7345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7384 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7400 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7406 */     GIR_RootConstrainSelectedInstOperands,
     /*   7407 */     // GIR_Coverage, 777,
     /*   7407 */     GIR_EraseRootFromParent_Done,
     /*   7408 */   // Label 169: @7408
     /*   7408 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(7476), // Rule ID 776 //
     /*   7413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7452 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7474 */     GIR_RootConstrainSelectedInstOperands,
     /*   7475 */     // GIR_Coverage, 776,
     /*   7475 */     GIR_EraseRootFromParent_Done,
     /*   7476 */   // Label 170: @7476
     /*   7476 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(7529), // Rule ID 5508 //
     /*   7481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7507 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7521 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7527 */     GIR_RootConstrainSelectedInstOperands,
     /*   7528 */     // GIR_Coverage, 5508,
     /*   7528 */     GIR_EraseRootFromParent_Done,
     /*   7529 */   // Label 171: @7529
     /*   7529 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(7582), // Rule ID 5502 //
     /*   7534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7560 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7580 */     GIR_RootConstrainSelectedInstOperands,
     /*   7581 */     // GIR_Coverage, 5502,
     /*   7581 */     GIR_EraseRootFromParent_Done,
     /*   7582 */   // Label 172: @7582
     /*   7582 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(7635), // Rule ID 5507 //
     /*   7587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7613 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7633 */     GIR_RootConstrainSelectedInstOperands,
     /*   7634 */     // GIR_Coverage, 5507,
     /*   7634 */     GIR_EraseRootFromParent_Done,
     /*   7635 */   // Label 173: @7635
     /*   7635 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(7688), // Rule ID 788 //
     /*   7640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7666 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7686 */     GIR_RootConstrainSelectedInstOperands,
     /*   7687 */     // GIR_Coverage, 788,
     /*   7687 */     GIR_EraseRootFromParent_Done,
     /*   7688 */   // Label 174: @7688
     /*   7688 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(7741), // Rule ID 782 //
     /*   7693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7719 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7724 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7733 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7739 */     GIR_RootConstrainSelectedInstOperands,
     /*   7740 */     // GIR_Coverage, 782,
     /*   7740 */     GIR_EraseRootFromParent_Done,
     /*   7741 */   // Label 175: @7741
     /*   7741 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(7794), // Rule ID 787 //
     /*   7746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7772 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7792 */     GIR_RootConstrainSelectedInstOperands,
     /*   7793 */     // GIR_Coverage, 787,
     /*   7793 */     GIR_EraseRootFromParent_Done,
     /*   7794 */   // Label 176: @7794
     /*   7794 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(7830), // Rule ID 760 //
     /*   7799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7810 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VADDv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*   7810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i64),
     /*   7813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7828 */     GIR_RootConstrainSelectedInstOperands,
     /*   7829 */     // GIR_Coverage, 760,
     /*   7829 */     GIR_EraseRootFromParent_Done,
     /*   7830 */   // Label 177: @7830
     /*   7830 */   GIM_Reject,
     /*   7831 */ // Label 165: @7831
     /*   7831 */ GIM_Reject,
     /*   7832 */ // Label 84: @7832
     /*   7832 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(8016),
     /*   7837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7847 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(7913), // Rule ID 5528 //
     /*   7852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7887 */     // (add:{ *:[v4i16] } (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), DPR:{ *:[v4i16] }:$src1)  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7892 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7911 */     GIR_RootConstrainSelectedInstOperands,
     /*   7912 */     // GIR_Coverage, 5528,
     /*   7912 */     GIR_EraseRootFromParent_Done,
     /*   7913 */   // Label 179: @7913
     /*   7913 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(7979), // Rule ID 885 //
     /*   7918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7953 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7958 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7971 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7977 */     GIR_RootConstrainSelectedInstOperands,
     /*   7978 */     // GIR_Coverage, 885,
     /*   7978 */     GIR_EraseRootFromParent_Done,
     /*   7979 */   // Label 180: @7979
     /*   7979 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(8015), // Rule ID 754 //
     /*   7984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7995 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VADDv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i16),
     /*   7998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8000 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   8004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8013 */     GIR_RootConstrainSelectedInstOperands,
     /*   8014 */     // GIR_Coverage, 754,
     /*   8014 */     GIR_EraseRootFromParent_Done,
     /*   8015 */   // Label 181: @8015
     /*   8015 */   GIM_Reject,
     /*   8016 */ // Label 178: @8016
     /*   8016 */ GIM_Reject,
     /*   8017 */ // Label 85: @8017
     /*   8017 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(8972),
     /*   8022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8028 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(8100), // Rule ID 775 //
     /*   8033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8076 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8098 */     GIR_RootConstrainSelectedInstOperands,
     /*   8099 */     // GIR_Coverage, 775,
     /*   8099 */     GIR_EraseRootFromParent_Done,
     /*   8100 */   // Label 183: @8100
     /*   8100 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(8172), // Rule ID 774 //
     /*   8105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8148 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8170 */     GIR_RootConstrainSelectedInstOperands,
     /*   8171 */     // GIR_Coverage, 774,
     /*   8171 */     GIR_EraseRootFromParent_Done,
     /*   8172 */   // Label 184: @8172
     /*   8172 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(8244), // Rule ID 766 //
     /*   8177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8220 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv4i32),
     /*   8223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8242 */     GIR_RootConstrainSelectedInstOperands,
     /*   8243 */     // GIR_Coverage, 766,
     /*   8243 */     GIR_EraseRootFromParent_Done,
     /*   8244 */   // Label 185: @8244
     /*   8244 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(8316), // Rule ID 773 //
     /*   8249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8292 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8314 */     GIR_RootConstrainSelectedInstOperands,
     /*   8315 */     // GIR_Coverage, 773,
     /*   8315 */     GIR_EraseRootFromParent_Done,
     /*   8316 */   // Label 186: @8316
     /*   8316 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(8388), // Rule ID 772 //
     /*   8321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8364 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8386 */     GIR_RootConstrainSelectedInstOperands,
     /*   8387 */     // GIR_Coverage, 772,
     /*   8387 */     GIR_EraseRootFromParent_Done,
     /*   8388 */   // Label 187: @8388
     /*   8388 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(8458), // Rule ID 5532 //
     /*   8393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8432 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8437 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8456 */     GIR_RootConstrainSelectedInstOperands,
     /*   8457 */     // GIR_Coverage, 5532,
     /*   8457 */     GIR_EraseRootFromParent_Done,
     /*   8458 */   // Label 188: @8458
     /*   8458 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(8515), // Rule ID 5506 //
     /*   8463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8493 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8513 */     GIR_RootConstrainSelectedInstOperands,
     /*   8514 */     // GIR_Coverage, 5506,
     /*   8514 */     GIR_EraseRootFromParent_Done,
     /*   8515 */   // Label 189: @8515
     /*   8515 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(8572), // Rule ID 5501 //
     /*   8520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8550 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8570 */     GIR_RootConstrainSelectedInstOperands,
     /*   8571 */     // GIR_Coverage, 5501,
     /*   8571 */     GIR_EraseRootFromParent_Done,
     /*   8572 */   // Label 190: @8572
     /*   8572 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(8629), // Rule ID 5505 //
     /*   8577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8607 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8627 */     GIR_RootConstrainSelectedInstOperands,
     /*   8628 */     // GIR_Coverage, 5505,
     /*   8628 */     GIR_EraseRootFromParent_Done,
     /*   8629 */   // Label 191: @8629
     /*   8629 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(8699), // Rule ID 889 //
     /*   8634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8673 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8678 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8697 */     GIR_RootConstrainSelectedInstOperands,
     /*   8698 */     // GIR_Coverage, 889,
     /*   8698 */     GIR_EraseRootFromParent_Done,
     /*   8699 */   // Label 192: @8699
     /*   8699 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(8756), // Rule ID 786 //
     /*   8704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8734 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8754 */     GIR_RootConstrainSelectedInstOperands,
     /*   8755 */     // GIR_Coverage, 786,
     /*   8755 */     GIR_EraseRootFromParent_Done,
     /*   8756 */   // Label 193: @8756
     /*   8756 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(8813), // Rule ID 781 //
     /*   8761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8791 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8811 */     GIR_RootConstrainSelectedInstOperands,
     /*   8812 */     // GIR_Coverage, 781,
     /*   8812 */     GIR_EraseRootFromParent_Done,
     /*   8813 */   // Label 194: @8813
     /*   8813 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(8870), // Rule ID 785 //
     /*   8818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8848 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8868 */     GIR_RootConstrainSelectedInstOperands,
     /*   8869 */     // GIR_Coverage, 785,
     /*   8869 */     GIR_EraseRootFromParent_Done,
     /*   8870 */   // Label 195: @8870
     /*   8870 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(8910), // Rule ID 758 //
     /*   8875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8890 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VADDv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i32),
     /*   8893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   8899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8908 */     GIR_RootConstrainSelectedInstOperands,
     /*   8909 */     // GIR_Coverage, 758,
     /*   8909 */     GIR_EraseRootFromParent_Done,
     /*   8910 */   // Label 196: @8910
     /*   8910 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(8971), // Rule ID 3493 //
     /*   8915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   8918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8930 */     // (add:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*   8930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*   8933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi32),
     /*   8945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*   8947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*   8949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*   8951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   8954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8969 */     GIR_RootConstrainSelectedInstOperands,
     /*   8970 */     // GIR_Coverage, 3493,
     /*   8970 */     GIR_EraseRootFromParent_Done,
     /*   8971 */   // Label 197: @8971
     /*   8971 */   GIM_Reject,
     /*   8972 */ // Label 182: @8972
     /*   8972 */ GIM_Reject,
     /*   8973 */ // Label 86: @8973
     /*   8973 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(9157),
     /*   8978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   8984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8988 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(9054), // Rule ID 5527 //
     /*   8993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9028 */     // (add:{ *:[v8i8] } (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm), DPR:{ *:[v8i8] }:$src1)  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9033 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9052 */     GIR_RootConstrainSelectedInstOperands,
     /*   9053 */     // GIR_Coverage, 5527,
     /*   9053 */     GIR_EraseRootFromParent_Done,
     /*   9054 */   // Label 199: @9054
     /*   9054 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(9120), // Rule ID 884 //
     /*   9059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9094 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9099 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9118 */     GIR_RootConstrainSelectedInstOperands,
     /*   9119 */     // GIR_Coverage, 884,
     /*   9119 */     GIR_EraseRootFromParent_Done,
     /*   9120 */   // Label 200: @9120
     /*   9120 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(9156), // Rule ID 753 //
     /*   9125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9136 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VADDv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i8),
     /*   9139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   9145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9148 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9154 */     GIR_RootConstrainSelectedInstOperands,
     /*   9155 */     // GIR_Coverage, 753,
     /*   9155 */     GIR_EraseRootFromParent_Done,
     /*   9156 */   // Label 201: @9156
     /*   9156 */   GIM_Reject,
     /*   9157 */ // Label 198: @9157
     /*   9157 */ GIM_Reject,
     /*   9158 */ // Label 87: @9158
     /*   9158 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(10113),
     /*   9163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9169 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(9241), // Rule ID 771 //
     /*   9174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9217 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9239 */     GIR_RootConstrainSelectedInstOperands,
     /*   9240 */     // GIR_Coverage, 771,
     /*   9240 */     GIR_EraseRootFromParent_Done,
     /*   9241 */   // Label 203: @9241
     /*   9241 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(9313), // Rule ID 770 //
     /*   9246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9282 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9289 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9311 */     GIR_RootConstrainSelectedInstOperands,
     /*   9312 */     // GIR_Coverage, 770,
     /*   9312 */     GIR_EraseRootFromParent_Done,
     /*   9313 */   // Label 204: @9313
     /*   9313 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(9385), // Rule ID 765 //
     /*   9318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9361 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv8i16),
     /*   9364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9383 */     GIR_RootConstrainSelectedInstOperands,
     /*   9384 */     // GIR_Coverage, 765,
     /*   9384 */     GIR_EraseRootFromParent_Done,
     /*   9385 */   // Label 205: @9385
     /*   9385 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(9457), // Rule ID 769 //
     /*   9390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9433 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9455 */     GIR_RootConstrainSelectedInstOperands,
     /*   9456 */     // GIR_Coverage, 769,
     /*   9456 */     GIR_EraseRootFromParent_Done,
     /*   9457 */   // Label 206: @9457
     /*   9457 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(9529), // Rule ID 768 //
     /*   9462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9505 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9521 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9527 */     GIR_RootConstrainSelectedInstOperands,
     /*   9528 */     // GIR_Coverage, 768,
     /*   9528 */     GIR_EraseRootFromParent_Done,
     /*   9529 */   // Label 207: @9529
     /*   9529 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(9599), // Rule ID 5531 //
     /*   9534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9573 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm), QPR:{ *:[v8i16] }:$src1)  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9578 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9591 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9597 */     GIR_RootConstrainSelectedInstOperands,
     /*   9598 */     // GIR_Coverage, 5531,
     /*   9598 */     GIR_EraseRootFromParent_Done,
     /*   9599 */   // Label 208: @9599
     /*   9599 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(9656), // Rule ID 5504 //
     /*   9604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9634 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9654 */     GIR_RootConstrainSelectedInstOperands,
     /*   9655 */     // GIR_Coverage, 5504,
     /*   9655 */     GIR_EraseRootFromParent_Done,
     /*   9656 */   // Label 209: @9656
     /*   9656 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(9713), // Rule ID 5500 //
     /*   9661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9691 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9705 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9711 */     GIR_RootConstrainSelectedInstOperands,
     /*   9712 */     // GIR_Coverage, 5500,
     /*   9712 */     GIR_EraseRootFromParent_Done,
     /*   9713 */   // Label 210: @9713
     /*   9713 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(9770), // Rule ID 5503 //
     /*   9718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9748 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9768 */     GIR_RootConstrainSelectedInstOperands,
     /*   9769 */     // GIR_Coverage, 5503,
     /*   9769 */     GIR_EraseRootFromParent_Done,
     /*   9770 */   // Label 211: @9770
     /*   9770 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(9840), // Rule ID 888 //
     /*   9775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9814 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9838 */     GIR_RootConstrainSelectedInstOperands,
     /*   9839 */     // GIR_Coverage, 888,
     /*   9839 */     GIR_EraseRootFromParent_Done,
     /*   9840 */   // Label 212: @9840
     /*   9840 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(9897), // Rule ID 784 //
     /*   9845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9875 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9895 */     GIR_RootConstrainSelectedInstOperands,
     /*   9896 */     // GIR_Coverage, 784,
     /*   9896 */     GIR_EraseRootFromParent_Done,
     /*   9897 */   // Label 213: @9897
     /*   9897 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(9954), // Rule ID 780 //
     /*   9902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9932 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9952 */     GIR_RootConstrainSelectedInstOperands,
     /*   9953 */     // GIR_Coverage, 780,
     /*   9953 */     GIR_EraseRootFromParent_Done,
     /*   9954 */   // Label 214: @9954
     /*   9954 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(10011), // Rule ID 783 //
     /*   9959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9989 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  10000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10003 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10009 */     GIR_RootConstrainSelectedInstOperands,
     /*  10010 */     // GIR_Coverage, 783,
     /*  10010 */     GIR_EraseRootFromParent_Done,
     /*  10011 */   // Label 215: @10011
     /*  10011 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(10051), // Rule ID 757 //
     /*  10016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10031 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VADDv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  10031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i16),
     /*  10034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10049 */     GIR_RootConstrainSelectedInstOperands,
     /*  10050 */     // GIR_Coverage, 757,
     /*  10050 */     GIR_EraseRootFromParent_Done,
     /*  10051 */   // Label 216: @10051
     /*  10051 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(10112), // Rule ID 3489 //
     /*  10056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10071 */     // (add:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  10071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi16),
     /*  10086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10110 */     GIR_RootConstrainSelectedInstOperands,
     /*  10111 */     // GIR_Coverage, 3489,
     /*  10111 */     GIR_EraseRootFromParent_Done,
     /*  10112 */   // Label 217: @10112
     /*  10112 */   GIM_Reject,
     /*  10113 */ // Label 202: @10113
     /*  10113 */ GIM_Reject,
     /*  10114 */ // Label 88: @10114
     /*  10114 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(10367),
     /*  10119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10125 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(10195), // Rule ID 5530 //
     /*  10130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10169 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm), QPR:{ *:[v16i8] }:$src1)  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10174 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10193 */     GIR_RootConstrainSelectedInstOperands,
     /*  10194 */     // GIR_Coverage, 5530,
     /*  10194 */     GIR_EraseRootFromParent_Done,
     /*  10195 */   // Label 219: @10195
     /*  10195 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(10265), // Rule ID 887 //
     /*  10200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10239 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10244 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10263 */     GIR_RootConstrainSelectedInstOperands,
     /*  10264 */     // GIR_Coverage, 887,
     /*  10264 */     GIR_EraseRootFromParent_Done,
     /*  10265 */   // Label 220: @10265
     /*  10265 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(10305), // Rule ID 756 //
     /*  10270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10285 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VADDv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv16i8),
     /*  10288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10303 */     GIR_RootConstrainSelectedInstOperands,
     /*  10304 */     // GIR_Coverage, 756,
     /*  10304 */     GIR_EraseRootFromParent_Done,
     /*  10305 */   // Label 221: @10305
     /*  10305 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(10366), // Rule ID 3485 //
     /*  10310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10325 */     // (add:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  10325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi8),
     /*  10340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10349 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10364 */     GIR_RootConstrainSelectedInstOperands,
     /*  10365 */     // GIR_Coverage, 3485,
     /*  10365 */     GIR_EraseRootFromParent_Done,
     /*  10366 */   // Label 222: @10366
     /*  10366 */   GIM_Reject,
     /*  10367 */ // Label 218: @10367
     /*  10367 */ GIM_Reject,
     /*  10368 */ // Label 89: @10368
     /*  10368 */ GIM_Reject,
     /*  10369 */ // Label 1: @10369
     /*  10369 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 232*/ GIMT_Encode4(13612),
     /*  10380 */ /*GILLT_s32*//*Label 223*/ GIMT_Encode4(10440),
     /*  10384 */ /*GILLT_s64*//*Label 224*/ GIMT_Encode4(11054), GIMT_Encode4(0),
     /*  10392 */ /*GILLT_v2s32*//*Label 225*/ GIMT_Encode4(11101),
     /*  10396 */ /*GILLT_v2s64*//*Label 226*/ GIMT_Encode4(11216), GIMT_Encode4(0),
     /*  10404 */ /*GILLT_v4s16*//*Label 227*/ GIMT_Encode4(11768),
     /*  10408 */ /*GILLT_v4s32*//*Label 228*/ GIMT_Encode4(11883), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10420 */ /*GILLT_v8s8*//*Label 229*/ GIMT_Encode4(12598),
     /*  10424 */ /*GILLT_v8s16*//*Label 230*/ GIMT_Encode4(12713), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10436 */ /*GILLT_v16s8*//*Label 231*/ GIMT_Encode4(13428),
     /*  10440 */ // Label 223: @10440
     /*  10440 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(11053),
     /*  10445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  10448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  10451 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10495), // Rule ID 330 //
     /*  10456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10463 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  10467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10471 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, tGPR:{ *:[i32] }:$Rn)  =>  (tRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  10471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tRSB),
     /*  10474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10493 */     GIR_RootConstrainSelectedInstOperands,
     /*  10494 */     // GIR_Coverage, 330,
     /*  10494 */     GIR_EraseRootFromParent_Done,
     /*  10495 */   // Label 234: @10495
     /*  10495 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10552), // Rule ID 96 //
     /*  10500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10519 */     // MIs[1] Operand 1
     /*  10519 */     // No operand predicates
     /*  10519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10525 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, GPR:{ *:[i32] }:$Rn)  =>  (RSBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RSBri),
     /*  10528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10550 */     GIR_RootConstrainSelectedInstOperands,
     /*  10551 */     // GIR_Coverage, 96,
     /*  10551 */     GIR_EraseRootFromParent_Done,
     /*  10552 */   // Label 235: @10552
     /*  10552 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10609), // Rule ID 427 //
     /*  10557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10576 */     // MIs[1] Operand 1
     /*  10576 */     // No operand predicates
     /*  10576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10582 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, rGPR:{ *:[i32] }:$Rn)  =>  (t2RSBri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RSBri),
     /*  10585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10595 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10607 */     GIR_RootConstrainSelectedInstOperands,
     /*  10608 */     // GIR_Coverage, 427,
     /*  10608 */     GIR_EraseRootFromParent_Done,
     /*  10609 */   // Label 236: @10609
     /*  10609 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10666), // Rule ID 76 //
     /*  10614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10637 */     // MIs[1] Operand 1
     /*  10637 */     // No operand predicates
     /*  10637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10639 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (SUBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBri),
     /*  10642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10664 */     GIR_RootConstrainSelectedInstOperands,
     /*  10665 */     // GIR_Coverage, 76,
     /*  10665 */     GIR_EraseRootFromParent_Done,
     /*  10666 */   // Label 237: @10666
     /*  10666 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10723), // Rule ID 411 //
     /*  10671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  10682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10694 */     // MIs[1] Operand 1
     /*  10694 */     // No operand predicates
     /*  10694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10696 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2SUBri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri),
     /*  10699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10721 */     GIR_RootConstrainSelectedInstOperands,
     /*  10722 */     // GIR_Coverage, 411,
     /*  10722 */     GIR_EraseRootFromParent_Done,
     /*  10723 */   // Label 238: @10723
     /*  10723 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10774), // Rule ID 412 //
     /*  10728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*  10751 */     // MIs[1] Operand 1
     /*  10751 */     // No operand predicates
     /*  10751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10753 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2SUBri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri12),
     /*  10756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10772 */     GIR_RootConstrainSelectedInstOperands,
     /*  10773 */     // GIR_Coverage, 412,
     /*  10773 */     GIR_EraseRootFromParent_Done,
     /*  10774 */   // Label 239: @10774
     /*  10774 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10844), // Rule ID 173 //
     /*  10779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM_UseMulOps),
     /*  10782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10818 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (MLS:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  10818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLS),
     /*  10821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10831 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10842 */     GIR_RootConstrainSelectedInstOperands,
     /*  10843 */     // GIR_Coverage, 173,
     /*  10843 */     GIR_EraseRootFromParent_Done,
     /*  10844 */   // Label 240: @10844
     /*  10844 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10914), // Rule ID 504 //
     /*  10849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*  10852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10888 */     // (sub:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLS:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  10888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLS),
     /*  10891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10912 */     GIR_RootConstrainSelectedInstOperands,
     /*  10913 */     // GIR_Coverage, 504,
     /*  10913 */     GIR_EraseRootFromParent_Done,
     /*  10914 */   // Label 241: @10914
     /*  10914 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10960), // Rule ID 77 //
     /*  10919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10934 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SUBrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  10934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBrr),
     /*  10937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10958 */     GIR_RootConstrainSelectedInstOperands,
     /*  10959 */     // GIR_Coverage, 77,
     /*  10959 */     GIR_EraseRootFromParent_Done,
     /*  10960 */   // Label 242: @10960
     /*  10960 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(11006), // Rule ID 333 //
     /*  10965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10980 */     // (sub:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tSUBrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  10980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSUBrr),
     /*  10983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10985 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11004 */     GIR_RootConstrainSelectedInstOperands,
     /*  11005 */     // GIR_Coverage, 333,
     /*  11005 */     GIR_EraseRootFromParent_Done,
     /*  11006 */   // Label 243: @11006
     /*  11006 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(11052), // Rule ID 413 //
     /*  11011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  11014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  11026 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SUBrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  11026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBrr),
     /*  11029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  11035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11050 */     GIR_RootConstrainSelectedInstOperands,
     /*  11051 */     // GIR_Coverage, 413,
     /*  11051 */     GIR_EraseRootFromParent_Done,
     /*  11052 */   // Label 244: @11052
     /*  11052 */   GIM_Reject,
     /*  11053 */ // Label 233: @11053
     /*  11053 */ GIM_Reject,
     /*  11054 */ // Label 224: @11054
     /*  11054 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11100), // Rule ID 963 //
     /*  11059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11080 */   // (sub:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VSUBv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  11080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv1i64),
     /*  11083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11085 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11087 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11092 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11098 */   GIR_RootConstrainSelectedInstOperands,
     /*  11099 */   // GIR_Coverage, 963,
     /*  11099 */   GIR_EraseRootFromParent_Done,
     /*  11100 */ // Label 245: @11100
     /*  11100 */ GIM_Reject,
     /*  11101 */ // Label 225: @11101
     /*  11101 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11215),
     /*  11106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11120 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11182), // Rule ID 914 //
     /*  11125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11156 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv2i32),
     /*  11159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11161 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11180 */     GIR_RootConstrainSelectedInstOperands,
     /*  11181 */     // GIR_Coverage, 914,
     /*  11181 */     GIR_EraseRootFromParent_Done,
     /*  11182 */   // Label 247: @11182
     /*  11182 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11214), // Rule ID 959 //
     /*  11187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11194 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VSUBv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i32),
     /*  11197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11212 */     GIR_RootConstrainSelectedInstOperands,
     /*  11213 */     // GIR_Coverage, 959,
     /*  11213 */     GIR_EraseRootFromParent_Done,
     /*  11214 */   // Label 248: @11214
     /*  11214 */   GIM_Reject,
     /*  11215 */ // Label 246: @11215
     /*  11215 */ GIM_Reject,
     /*  11216 */ // Label 226: @11216
     /*  11216 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11767),
     /*  11221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  11224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  11227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11231 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11299), // Rule ID 983 //
     /*  11236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11275 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11297 */     GIR_RootConstrainSelectedInstOperands,
     /*  11298 */     // GIR_Coverage, 983,
     /*  11298 */     GIR_EraseRootFromParent_Done,
     /*  11299 */   // Label 250: @11299
     /*  11299 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11367), // Rule ID 982 //
     /*  11304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11343 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11365 */     GIR_RootConstrainSelectedInstOperands,
     /*  11366 */     // GIR_Coverage, 982,
     /*  11366 */     GIR_EraseRootFromParent_Done,
     /*  11367 */   // Label 251: @11367
     /*  11367 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11435), // Rule ID 971 //
     /*  11372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11411 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv2i64),
     /*  11414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11433 */     GIR_RootConstrainSelectedInstOperands,
     /*  11434 */     // GIR_Coverage, 971,
     /*  11434 */     GIR_EraseRootFromParent_Done,
     /*  11435 */   // Label 252: @11435
     /*  11435 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11503), // Rule ID 981 //
     /*  11440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11479 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11501 */     GIR_RootConstrainSelectedInstOperands,
     /*  11502 */     // GIR_Coverage, 981,
     /*  11502 */     GIR_EraseRootFromParent_Done,
     /*  11503 */   // Label 253: @11503
     /*  11503 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11571), // Rule ID 980 //
     /*  11508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11547 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11569 */     GIR_RootConstrainSelectedInstOperands,
     /*  11570 */     // GIR_Coverage, 980,
     /*  11570 */     GIR_EraseRootFromParent_Done,
     /*  11571 */   // Label 254: @11571
     /*  11571 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11624), // Rule ID 992 //
     /*  11576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11602 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11622 */     GIR_RootConstrainSelectedInstOperands,
     /*  11623 */     // GIR_Coverage, 992,
     /*  11623 */     GIR_EraseRootFromParent_Done,
     /*  11624 */   // Label 255: @11624
     /*  11624 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11677), // Rule ID 986 //
     /*  11629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11655 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv2i64),
     /*  11658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11675 */     GIR_RootConstrainSelectedInstOperands,
     /*  11676 */     // GIR_Coverage, 986,
     /*  11676 */     GIR_EraseRootFromParent_Done,
     /*  11677 */   // Label 256: @11677
     /*  11677 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11730), // Rule ID 991 //
     /*  11682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11708 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11728 */     GIR_RootConstrainSelectedInstOperands,
     /*  11729 */     // GIR_Coverage, 991,
     /*  11729 */     GIR_EraseRootFromParent_Done,
     /*  11730 */   // Label 257: @11730
     /*  11730 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11766), // Rule ID 964 //
     /*  11735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11746 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VSUBv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  11746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i64),
     /*  11749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11764 */     GIR_RootConstrainSelectedInstOperands,
     /*  11765 */     // GIR_Coverage, 964,
     /*  11765 */     GIR_EraseRootFromParent_Done,
     /*  11766 */   // Label 258: @11766
     /*  11766 */   GIM_Reject,
     /*  11767 */ // Label 249: @11767
     /*  11767 */ GIM_Reject,
     /*  11768 */ // Label 227: @11768
     /*  11768 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11882),
     /*  11773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11787 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11849), // Rule ID 913 //
     /*  11792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11823 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i16),
     /*  11826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11828 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11847 */     GIR_RootConstrainSelectedInstOperands,
     /*  11848 */     // GIR_Coverage, 913,
     /*  11848 */     GIR_EraseRootFromParent_Done,
     /*  11849 */   // Label 260: @11849
     /*  11849 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11881), // Rule ID 958 //
     /*  11854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11861 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VSUBv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i16),
     /*  11864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11879 */     GIR_RootConstrainSelectedInstOperands,
     /*  11880 */     // GIR_Coverage, 958,
     /*  11880 */     GIR_EraseRootFromParent_Done,
     /*  11881 */   // Label 261: @11881
     /*  11881 */   GIM_Reject,
     /*  11882 */ // Label 259: @11882
     /*  11882 */ GIM_Reject,
     /*  11883 */ // Label 228: @11883
     /*  11883 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(12597),
     /*  11888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11894 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11966), // Rule ID 979 //
     /*  11899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11942 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  11945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11958 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11964 */     GIR_RootConstrainSelectedInstOperands,
     /*  11965 */     // GIR_Coverage, 979,
     /*  11965 */     GIR_EraseRootFromParent_Done,
     /*  11966 */   // Label 263: @11966
     /*  11966 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12038), // Rule ID 978 //
     /*  11971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12014 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12036 */     GIR_RootConstrainSelectedInstOperands,
     /*  12037 */     // GIR_Coverage, 978,
     /*  12037 */     GIR_EraseRootFromParent_Done,
     /*  12038 */   // Label 264: @12038
     /*  12038 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12110), // Rule ID 970 //
     /*  12043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12086 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv4i32),
     /*  12089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12102 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12108 */     GIR_RootConstrainSelectedInstOperands,
     /*  12109 */     // GIR_Coverage, 970,
     /*  12109 */     GIR_EraseRootFromParent_Done,
     /*  12110 */   // Label 265: @12110
     /*  12110 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12182), // Rule ID 977 //
     /*  12115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12151 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12156 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12158 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12180 */     GIR_RootConstrainSelectedInstOperands,
     /*  12181 */     // GIR_Coverage, 977,
     /*  12181 */     GIR_EraseRootFromParent_Done,
     /*  12182 */   // Label 266: @12182
     /*  12182 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12254), // Rule ID 976 //
     /*  12187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12230 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12252 */     GIR_RootConstrainSelectedInstOperands,
     /*  12253 */     // GIR_Coverage, 976,
     /*  12253 */     GIR_EraseRootFromParent_Done,
     /*  12254 */   // Label 267: @12254
     /*  12254 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12324), // Rule ID 917 //
     /*  12259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12298 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i32),
     /*  12301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12303 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12322 */     GIR_RootConstrainSelectedInstOperands,
     /*  12323 */     // GIR_Coverage, 917,
     /*  12323 */     GIR_EraseRootFromParent_Done,
     /*  12324 */   // Label 268: @12324
     /*  12324 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12381), // Rule ID 990 //
     /*  12329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12359 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12379 */     GIR_RootConstrainSelectedInstOperands,
     /*  12380 */     // GIR_Coverage, 990,
     /*  12380 */     GIR_EraseRootFromParent_Done,
     /*  12381 */   // Label 269: @12381
     /*  12381 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12438), // Rule ID 985 //
     /*  12386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12416 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv4i32),
     /*  12419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12436 */     GIR_RootConstrainSelectedInstOperands,
     /*  12437 */     // GIR_Coverage, 985,
     /*  12437 */     GIR_EraseRootFromParent_Done,
     /*  12438 */   // Label 270: @12438
     /*  12438 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12495), // Rule ID 989 //
     /*  12443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12473 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12478 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12493 */     GIR_RootConstrainSelectedInstOperands,
     /*  12494 */     // GIR_Coverage, 989,
     /*  12494 */     GIR_EraseRootFromParent_Done,
     /*  12495 */   // Label 271: @12495
     /*  12495 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12535), // Rule ID 962 //
     /*  12500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12515 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VSUBv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i32),
     /*  12518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12520 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12527 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12533 */     GIR_RootConstrainSelectedInstOperands,
     /*  12534 */     // GIR_Coverage, 962,
     /*  12534 */     GIR_EraseRootFromParent_Done,
     /*  12535 */   // Label 272: @12535
     /*  12535 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12596), // Rule ID 3505 //
     /*  12540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  12543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12555 */     // (sub:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VSUBi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  12555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi32),
     /*  12570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  12572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  12574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  12576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  12579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  12594 */     GIR_RootConstrainSelectedInstOperands,
     /*  12595 */     // GIR_Coverage, 3505,
     /*  12595 */     GIR_EraseRootFromParent_Done,
     /*  12596 */   // Label 273: @12596
     /*  12596 */   GIM_Reject,
     /*  12597 */ // Label 262: @12597
     /*  12597 */ GIM_Reject,
     /*  12598 */ // Label 229: @12598
     /*  12598 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12712),
     /*  12603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12617 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12679), // Rule ID 912 //
     /*  12622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12653 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i8),
     /*  12656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12658 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12677 */     GIR_RootConstrainSelectedInstOperands,
     /*  12678 */     // GIR_Coverage, 912,
     /*  12678 */     GIR_EraseRootFromParent_Done,
     /*  12679 */   // Label 275: @12679
     /*  12679 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(12711), // Rule ID 957 //
     /*  12684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12691 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSUBv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i8),
     /*  12694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12709 */     GIR_RootConstrainSelectedInstOperands,
     /*  12710 */     // GIR_Coverage, 957,
     /*  12710 */     GIR_EraseRootFromParent_Done,
     /*  12711 */   // Label 276: @12711
     /*  12711 */   GIM_Reject,
     /*  12712 */ // Label 274: @12712
     /*  12712 */ GIM_Reject,
     /*  12713 */ // Label 230: @12713
     /*  12713 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13427),
     /*  12718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  12721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  12724 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(12796), // Rule ID 975 //
     /*  12729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12772 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12794 */     GIR_RootConstrainSelectedInstOperands,
     /*  12795 */     // GIR_Coverage, 975,
     /*  12795 */     GIR_EraseRootFromParent_Done,
     /*  12796 */   // Label 278: @12796
     /*  12796 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(12868), // Rule ID 974 //
     /*  12801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12837 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12844 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12866 */     GIR_RootConstrainSelectedInstOperands,
     /*  12867 */     // GIR_Coverage, 974,
     /*  12867 */     GIR_EraseRootFromParent_Done,
     /*  12868 */   // Label 279: @12868
     /*  12868 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(12940), // Rule ID 969 //
     /*  12873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12916 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv8i16),
     /*  12919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12938 */     GIR_RootConstrainSelectedInstOperands,
     /*  12939 */     // GIR_Coverage, 969,
     /*  12939 */     GIR_EraseRootFromParent_Done,
     /*  12940 */   // Label 280: @12940
     /*  12940 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13012), // Rule ID 973 //
     /*  12945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12988 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  13001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13010 */     GIR_RootConstrainSelectedInstOperands,
     /*  13011 */     // GIR_Coverage, 973,
     /*  13011 */     GIR_EraseRootFromParent_Done,
     /*  13012 */   // Label 281: @13012
     /*  13012 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13084), // Rule ID 972 //
     /*  13017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13060 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  13063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  13073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13082 */     GIR_RootConstrainSelectedInstOperands,
     /*  13083 */     // GIR_Coverage, 972,
     /*  13083 */     GIR_EraseRootFromParent_Done,
     /*  13084 */   // Label 282: @13084
     /*  13084 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13154), // Rule ID 916 //
     /*  13089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13128 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i16),
     /*  13131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13133 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13152 */     GIR_RootConstrainSelectedInstOperands,
     /*  13153 */     // GIR_Coverage, 916,
     /*  13153 */     GIR_EraseRootFromParent_Done,
     /*  13154 */   // Label 283: @13154
     /*  13154 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(13211), // Rule ID 988 //
     /*  13159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13189 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13203 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13209 */     GIR_RootConstrainSelectedInstOperands,
     /*  13210 */     // GIR_Coverage, 988,
     /*  13210 */     GIR_EraseRootFromParent_Done,
     /*  13211 */   // Label 284: @13211
     /*  13211 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13268), // Rule ID 984 //
     /*  13216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13246 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv8i16),
     /*  13249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13266 */     GIR_RootConstrainSelectedInstOperands,
     /*  13267 */     // GIR_Coverage, 984,
     /*  13267 */     GIR_EraseRootFromParent_Done,
     /*  13268 */   // Label 285: @13268
     /*  13268 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13325), // Rule ID 987 //
     /*  13273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13303 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13323 */     GIR_RootConstrainSelectedInstOperands,
     /*  13324 */     // GIR_Coverage, 987,
     /*  13324 */     GIR_EraseRootFromParent_Done,
     /*  13325 */   // Label 286: @13325
     /*  13325 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13365), // Rule ID 961 //
     /*  13330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13345 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VSUBv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i16),
     /*  13348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13363 */     GIR_RootConstrainSelectedInstOperands,
     /*  13364 */     // GIR_Coverage, 961,
     /*  13364 */     GIR_EraseRootFromParent_Done,
     /*  13365 */   // Label 287: @13365
     /*  13365 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13426), // Rule ID 3501 //
     /*  13370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13385 */     // (sub:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VSUBi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  13385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi16),
     /*  13400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13424 */     GIR_RootConstrainSelectedInstOperands,
     /*  13425 */     // GIR_Coverage, 3501,
     /*  13425 */     GIR_EraseRootFromParent_Done,
     /*  13426 */   // Label 288: @13426
     /*  13426 */   GIM_Reject,
     /*  13427 */ // Label 277: @13427
     /*  13427 */ GIM_Reject,
     /*  13428 */ // Label 231: @13428
     /*  13428 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(13611),
     /*  13433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13439 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(13509), // Rule ID 915 //
     /*  13444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13483 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv16i8),
     /*  13486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13488 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13507 */     GIR_RootConstrainSelectedInstOperands,
     /*  13508 */     // GIR_Coverage, 915,
     /*  13508 */     GIR_EraseRootFromParent_Done,
     /*  13509 */   // Label 290: @13509
     /*  13509 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(13549), // Rule ID 960 //
     /*  13514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13529 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSUBv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv16i8),
     /*  13532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13547 */     GIR_RootConstrainSelectedInstOperands,
     /*  13548 */     // GIR_Coverage, 960,
     /*  13548 */     GIR_EraseRootFromParent_Done,
     /*  13549 */   // Label 291: @13549
     /*  13549 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(13610), // Rule ID 3497 //
     /*  13554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13569 */     // (sub:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VSUBi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  13569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi8),
     /*  13584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13608 */     GIR_RootConstrainSelectedInstOperands,
     /*  13609 */     // GIR_Coverage, 3497,
     /*  13609 */     GIR_EraseRootFromParent_Done,
     /*  13610 */   // Label 292: @13610
     /*  13610 */   GIM_Reject,
     /*  13611 */ // Label 289: @13611
     /*  13611 */ GIM_Reject,
     /*  13612 */ // Label 232: @13612
     /*  13612 */ GIM_Reject,
     /*  13613 */ // Label 2: @13613
     /*  13613 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 300*/ GIMT_Encode4(15316),
     /*  13624 */ /*GILLT_s32*//*Label 293*/ GIMT_Encode4(13684), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13636 */ /*GILLT_v2s32*//*Label 294*/ GIMT_Encode4(14603), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13648 */ /*GILLT_v4s16*//*Label 295*/ GIMT_Encode4(14650),
     /*  13652 */ /*GILLT_v4s32*//*Label 296*/ GIMT_Encode4(14697), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13664 */ /*GILLT_v8s8*//*Label 297*/ GIMT_Encode4(14926),
     /*  13668 */ /*GILLT_v8s16*//*Label 298*/ GIMT_Encode4(14973), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13680 */ /*GILLT_v16s8*//*Label 299*/ GIMT_Encode4(15202),
     /*  13684 */ // Label 293: @13684
     /*  13684 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(14602),
     /*  13689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  13692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  13695 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(13783), // Rule ID 186 //
     /*  13700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13728 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13753 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13759 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  13762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13781 */     GIR_RootConstrainSelectedInstOperands,
     /*  13782 */     // GIR_Coverage, 186,
     /*  13782 */     GIR_EraseRootFromParent_Done,
     /*  13783 */   // Label 302: @13783
     /*  13783 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(13871), // Rule ID 515 //
     /*  13788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13816 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13841 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13847 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  13847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  13850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13863 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13869 */     GIR_RootConstrainSelectedInstOperands,
     /*  13870 */     // GIR_Coverage, 515,
     /*  13870 */     GIR_EraseRootFromParent_Done,
     /*  13871 */   // Label 303: @13871
     /*  13871 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(13962), // Rule ID 185 //
     /*  13876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13904 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13925 */     // MIs[2] Operand 2
     /*  13925 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  13936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13938 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  13941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13960 */     GIR_RootConstrainSelectedInstOperands,
     /*  13961 */     // GIR_Coverage, 185,
     /*  13961 */     GIR_EraseRootFromParent_Done,
     /*  13962 */   // Label 304: @13962
     /*  13962 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(14053), // Rule ID 514 //
     /*  13967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13995 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14016 */     // MIs[2] Operand 2
     /*  14016 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14029 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  14032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14051 */     GIR_RootConstrainSelectedInstOperands,
     /*  14052 */     // GIR_Coverage, 514,
     /*  14052 */     GIR_EraseRootFromParent_Done,
     /*  14053 */   // Label 305: @14053
     /*  14053 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(14144), // Rule ID 184 //
     /*  14058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14082 */     // MIs[1] Operand 2
     /*  14082 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14114 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14120 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  14123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14142 */     GIR_RootConstrainSelectedInstOperands,
     /*  14143 */     // GIR_Coverage, 184,
     /*  14143 */     GIR_EraseRootFromParent_Done,
     /*  14144 */   // Label 306: @14144
     /*  14144 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14235), // Rule ID 513 //
     /*  14149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14173 */     // MIs[1] Operand 2
     /*  14173 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14205 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14211 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  14214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14227 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14233 */     GIR_RootConstrainSelectedInstOperands,
     /*  14234 */     // GIR_Coverage, 513,
     /*  14234 */     GIR_EraseRootFromParent_Done,
     /*  14235 */   // Label 307: @14235
     /*  14235 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(14329), // Rule ID 183 //
     /*  14240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14264 */     // MIs[1] Operand 2
     /*  14264 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14292 */     // MIs[2] Operand 2
     /*  14292 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14305 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  14308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14321 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14327 */     GIR_RootConstrainSelectedInstOperands,
     /*  14328 */     // GIR_Coverage, 183,
     /*  14328 */     GIR_EraseRootFromParent_Done,
     /*  14329 */   // Label 308: @14329
     /*  14329 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(14423), // Rule ID 512 //
     /*  14334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14358 */     // MIs[1] Operand 2
     /*  14358 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14386 */     // MIs[2] Operand 2
     /*  14386 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14399 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  14402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14421 */     GIR_RootConstrainSelectedInstOperands,
     /*  14422 */     // GIR_Coverage, 512,
     /*  14422 */     GIR_EraseRootFromParent_Done,
     /*  14423 */   // Label 309: @14423
     /*  14423 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(14469), // Rule ID 169 //
     /*  14428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  14431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14443 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MUL:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MUL),
     /*  14446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14467 */     GIR_RootConstrainSelectedInstOperands,
     /*  14468 */     // GIR_Coverage, 169,
     /*  14468 */     GIR_EraseRootFromParent_Done,
     /*  14469 */   // Label 310: @14469
     /*  14469 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(14515), // Rule ID 170 //
     /*  14474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6_UseMulOps),
     /*  14477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14489 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MULv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MULv5),
     /*  14492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14513 */     GIR_RootConstrainSelectedInstOperands,
     /*  14514 */     // GIR_Coverage, 170,
     /*  14514 */     GIR_EraseRootFromParent_Done,
     /*  14515 */   // Label 311: @14515
     /*  14515 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(14561), // Rule ID 323 //
     /*  14520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  14523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14535 */     // (mul:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tMUL:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  14535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMUL),
     /*  14538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  14546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14553 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14559 */     GIR_RootConstrainSelectedInstOperands,
     /*  14560 */     // GIR_Coverage, 323,
     /*  14560 */     GIR_EraseRootFromParent_Done,
     /*  14561 */   // Label 312: @14561
     /*  14561 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(14601), // Rule ID 502 //
     /*  14566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  14569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14581 */     // (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2MUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MUL),
     /*  14584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14599 */     GIR_RootConstrainSelectedInstOperands,
     /*  14600 */     // GIR_Coverage, 502,
     /*  14600 */     GIR_EraseRootFromParent_Done,
     /*  14601 */   // Label 313: @14601
     /*  14601 */   GIM_Reject,
     /*  14602 */ // Label 301: @14602
     /*  14602 */ GIM_Reject,
     /*  14603 */ // Label 294: @14603
     /*  14603 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(14649), // Rule ID 834 //
     /*  14608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14629 */   // (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMULv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  14629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv2i32),
     /*  14632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14634 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14636 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14641 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14647 */   GIR_RootConstrainSelectedInstOperands,
     /*  14648 */   // GIR_Coverage, 834,
     /*  14648 */   GIR_EraseRootFromParent_Done,
     /*  14649 */ // Label 314: @14649
     /*  14649 */ GIM_Reject,
     /*  14650 */ // Label 295: @14650
     /*  14650 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(14696), // Rule ID 833 //
     /*  14655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14676 */   // (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMULv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  14676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i16),
     /*  14679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14681 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14683 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14688 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14694 */   GIR_RootConstrainSelectedInstOperands,
     /*  14695 */   // GIR_Coverage, 833,
     /*  14695 */   GIR_EraseRootFromParent_Done,
     /*  14696 */ // Label 315: @14696
     /*  14696 */ GIM_Reject,
     /*  14697 */ // Label 296: @14697
     /*  14697 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(14925),
     /*  14702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14708 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(14823), // Rule ID 4418 //
     /*  14713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14737 */     // MIs[1] Operand 2
     /*  14737 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14765 */     // MIs[2] Operand 2
     /*  14765 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14778 */     // (mul:{ *:[v4i32] } (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, v4i16:{ *:[Other] }), (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src2, v4i16:{ *:[Other] }))  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)
     /*  14778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  14793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  14803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14821 */     GIR_RootConstrainSelectedInstOperands,
     /*  14822 */     // GIR_Coverage, 4418,
     /*  14822 */     GIR_EraseRootFromParent_Done,
     /*  14823 */   // Label 317: @14823
     /*  14823 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(14863), // Rule ID 837 //
     /*  14828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14843 */     // (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMULv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  14843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i32),
     /*  14846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14861 */     GIR_RootConstrainSelectedInstOperands,
     /*  14862 */     // GIR_Coverage, 837,
     /*  14862 */     GIR_EraseRootFromParent_Done,
     /*  14863 */   // Label 318: @14863
     /*  14863 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(14924), // Rule ID 3463 //
     /*  14868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14883 */     // (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  14883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi32),
     /*  14898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  14902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  14904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14907 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14922 */     GIR_RootConstrainSelectedInstOperands,
     /*  14923 */     // GIR_Coverage, 3463,
     /*  14923 */     GIR_EraseRootFromParent_Done,
     /*  14924 */   // Label 319: @14924
     /*  14924 */   GIM_Reject,
     /*  14925 */ // Label 316: @14925
     /*  14925 */ GIM_Reject,
     /*  14926 */ // Label 297: @14926
     /*  14926 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(14972), // Rule ID 832 //
     /*  14931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  14937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  14940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14952 */   // (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  14952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i8),
     /*  14955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14957 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14959 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14964 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14970 */   GIR_RootConstrainSelectedInstOperands,
     /*  14971 */   // GIR_Coverage, 832,
     /*  14971 */   GIR_EraseRootFromParent_Done,
     /*  14972 */ // Label 320: @14972
     /*  14972 */ GIM_Reject,
     /*  14973 */ // Label 298: @14973
     /*  14973 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(15201),
     /*  14978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  14984 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(15099), // Rule ID 4423 //
     /*  14989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  15004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  15008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15013 */     // MIs[1] Operand 2
     /*  15013 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*  15024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  15032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  15036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15041 */     // MIs[2] Operand 2
     /*  15041 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  15052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15054 */     // (mul:{ *:[v8i16] } (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, v8i8:{ *:[Other] }), (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src2, v8i8:{ *:[Other] }))  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)
     /*  15054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  15069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  15075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  15079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15097 */     GIR_RootConstrainSelectedInstOperands,
     /*  15098 */     // GIR_Coverage, 4423,
     /*  15098 */     GIR_EraseRootFromParent_Done,
     /*  15099 */   // Label 322: @15099
     /*  15099 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(15139), // Rule ID 836 //
     /*  15104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15119 */     // (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMULv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  15119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i16),
     /*  15122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15137 */     GIR_RootConstrainSelectedInstOperands,
     /*  15138 */     // GIR_Coverage, 836,
     /*  15138 */     GIR_EraseRootFromParent_Done,
     /*  15139 */   // Label 323: @15139
     /*  15139 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(15200), // Rule ID 3459 //
     /*  15144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15159 */     // (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  15159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi16),
     /*  15174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15176 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15189 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15198 */     GIR_RootConstrainSelectedInstOperands,
     /*  15199 */     // GIR_Coverage, 3459,
     /*  15199 */     GIR_EraseRootFromParent_Done,
     /*  15200 */   // Label 324: @15200
     /*  15200 */   GIM_Reject,
     /*  15201 */ // Label 321: @15201
     /*  15201 */ GIM_Reject,
     /*  15202 */ // Label 299: @15202
     /*  15202 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(15315),
     /*  15207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  15210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  15213 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(15253), // Rule ID 835 //
     /*  15218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15233 */     // (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  15233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv16i8),
     /*  15236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15251 */     GIR_RootConstrainSelectedInstOperands,
     /*  15252 */     // GIR_Coverage, 835,
     /*  15252 */     GIR_EraseRootFromParent_Done,
     /*  15253 */   // Label 326: @15253
     /*  15253 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(15314), // Rule ID 3455 //
     /*  15258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15273 */     // (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  15273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi8),
     /*  15288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15312 */     GIR_RootConstrainSelectedInstOperands,
     /*  15313 */     // GIR_Coverage, 3455,
     /*  15313 */     GIR_EraseRootFromParent_Done,
     /*  15314 */   // Label 327: @15314
     /*  15314 */   GIM_Reject,
     /*  15315 */ // Label 325: @15315
     /*  15315 */ GIM_Reject,
     /*  15316 */ // Label 300: @15316
     /*  15316 */ GIM_Reject,
     /*  15317 */ // Label 3: @15317
     /*  15317 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(15412),
     /*  15322 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15331 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(15371), // Rule ID 195 //
     /*  15336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15351 */     // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SDIV),
     /*  15354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15369 */     GIR_RootConstrainSelectedInstOperands,
     /*  15370 */     // GIR_Coverage, 195,
     /*  15370 */     GIR_EraseRootFromParent_Done,
     /*  15371 */   // Label 329: @15371
     /*  15371 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(15411), // Rule ID 532 //
     /*  15376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15391 */     // (sdiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SDIV),
     /*  15394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15409 */     GIR_RootConstrainSelectedInstOperands,
     /*  15410 */     // GIR_Coverage, 532,
     /*  15410 */     GIR_EraseRootFromParent_Done,
     /*  15411 */   // Label 330: @15411
     /*  15411 */   GIM_Reject,
     /*  15412 */ // Label 328: @15412
     /*  15412 */ GIM_Reject,
     /*  15413 */ // Label 4: @15413
     /*  15413 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(15508),
     /*  15418 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15427 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15467), // Rule ID 196 //
     /*  15432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15447 */     // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (UDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDIV),
     /*  15450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15465 */     GIR_RootConstrainSelectedInstOperands,
     /*  15466 */     // GIR_Coverage, 196,
     /*  15466 */     GIR_EraseRootFromParent_Done,
     /*  15467 */   // Label 332: @15467
     /*  15467 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(15507), // Rule ID 533 //
     /*  15472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15487 */     // (udiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDIV),
     /*  15490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15505 */     GIR_RootConstrainSelectedInstOperands,
     /*  15506 */     // GIR_Coverage, 533,
     /*  15506 */     GIR_EraseRootFromParent_Done,
     /*  15507 */   // Label 333: @15507
     /*  15507 */   GIM_Reject,
     /*  15508 */ // Label 331: @15508
     /*  15508 */ GIM_Reject,
     /*  15509 */ // Label 5: @15509
     /*  15509 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 347*/ GIMT_Encode4(18688),
     /*  15520 */ /*GILLT_s32*//*Label 334*/ GIMT_Encode4(15580),
     /*  15524 */ /*GILLT_s64*//*Label 335*/ GIMT_Encode4(17572),
     /*  15528 */ /*GILLT_v2s1*//*Label 336*/ GIMT_Encode4(17619),
     /*  15532 */ /*GILLT_v2s32*//*Label 337*/ GIMT_Encode4(17737),
     /*  15536 */ /*GILLT_v2s64*//*Label 338*/ GIMT_Encode4(17784),
     /*  15540 */ /*GILLT_v4s1*//*Label 339*/ GIMT_Encode4(17898),
     /*  15544 */ /*GILLT_v4s16*//*Label 340*/ GIMT_Encode4(18016),
     /*  15548 */ /*GILLT_v4s32*//*Label 341*/ GIMT_Encode4(18063), GIMT_Encode4(0),
     /*  15556 */ /*GILLT_v8s1*//*Label 342*/ GIMT_Encode4(18177),
     /*  15560 */ /*GILLT_v8s8*//*Label 343*/ GIMT_Encode4(18295),
     /*  15564 */ /*GILLT_v8s16*//*Label 344*/ GIMT_Encode4(18342), GIMT_Encode4(0),
     /*  15572 */ /*GILLT_v16s1*//*Label 345*/ GIMT_Encode4(18456),
     /*  15576 */ /*GILLT_v16s8*//*Label 346*/ GIMT_Encode4(18574),
     /*  15580 */ // Label 334: @15580
     /*  15580 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(17571),
     /*  15585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15591 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15664), // Rule ID 1852 //
     /*  15596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15624 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15628 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15641 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15662 */     GIR_RootConstrainSelectedInstOperands,
     /*  15663 */     // GIR_Coverage, 1852,
     /*  15663 */     GIR_EraseRootFromParent_Done,
     /*  15664 */   // Label 349: @15664
     /*  15664 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15737), // Rule ID 2109 //
     /*  15669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15697 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15701 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15714 */     // (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15735 */     GIR_RootConstrainSelectedInstOperands,
     /*  15736 */     // GIR_Coverage, 2109,
     /*  15736 */     GIR_EraseRootFromParent_Done,
     /*  15737 */   // Label 350: @15737
     /*  15737 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15785), // Rule ID 1994 //
     /*  15742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15753 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15764 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 255:{ *:[i32] })  =>  (UXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB),
     /*  15767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15783 */     GIR_RootConstrainSelectedInstOperands,
     /*  15784 */     // GIR_Coverage, 1994,
     /*  15784 */     GIR_EraseRootFromParent_Done,
     /*  15785 */   // Label 351: @15785
     /*  15785 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15833), // Rule ID 1995 //
     /*  15790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15801 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15812 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 65535:{ *:[i32] })  =>  (UXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTH),
     /*  15815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15831 */     GIR_RootConstrainSelectedInstOperands,
     /*  15832 */     // GIR_Coverage, 1995,
     /*  15832 */     GIR_EraseRootFromParent_Done,
     /*  15833 */   // Label 352: @15833
     /*  15833 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15881), // Rule ID 1996 //
     /*  15838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15849 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15860 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15879 */     GIR_RootConstrainSelectedInstOperands,
     /*  15880 */     // GIR_Coverage, 1996,
     /*  15880 */     GIR_EraseRootFromParent_Done,
     /*  15881 */   // Label 353: @15881
     /*  15881 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15929), // Rule ID 2233 //
     /*  15886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15897 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15908 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (t2UXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB),
     /*  15911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15921 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15927 */     GIR_RootConstrainSelectedInstOperands,
     /*  15928 */     // GIR_Coverage, 2233,
     /*  15928 */     GIR_EraseRootFromParent_Done,
     /*  15929 */   // Label 354: @15929
     /*  15929 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15977), // Rule ID 2234 //
     /*  15934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15945 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15956 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (t2UXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTH),
     /*  15959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15975 */     GIR_RootConstrainSelectedInstOperands,
     /*  15976 */     // GIR_Coverage, 2234,
     /*  15976 */     GIR_EraseRootFromParent_Done,
     /*  15977 */   // Label 355: @15977
     /*  15977 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(16025), // Rule ID 2235 //
     /*  15982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15993 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  16004 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  16004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  16007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  16011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16023 */     GIR_RootConstrainSelectedInstOperands,
     /*  16024 */     // GIR_Coverage, 2235,
     /*  16024 */     GIR_EraseRootFromParent_Done,
     /*  16025 */   // Label 356: @16025
     /*  16025 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(16102), // Rule ID 5436 //
     /*  16030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16053 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16065 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16069 */     // MIs[2] Operand 1
     /*  16069 */     // No operand predicates
     /*  16069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16075 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16100 */     GIR_RootConstrainSelectedInstOperands,
     /*  16101 */     // GIR_Coverage, 5436,
     /*  16101 */     GIR_EraseRootFromParent_Done,
     /*  16102 */   // Label 357: @16102
     /*  16102 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(16179), // Rule ID 5469 //
     /*  16107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16130 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16142 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16146 */     // MIs[2] Operand 1
     /*  16146 */     // No operand predicates
     /*  16146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16152 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16177 */     GIR_RootConstrainSelectedInstOperands,
     /*  16178 */     // GIR_Coverage, 5469,
     /*  16178 */     GIR_EraseRootFromParent_Done,
     /*  16179 */   // Label 358: @16179
     /*  16179 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16256), // Rule ID 5435 //
     /*  16184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16215 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16219 */     // MIs[2] Operand 1
     /*  16219 */     // No operand predicates
     /*  16219 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16229 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16254 */     GIR_RootConstrainSelectedInstOperands,
     /*  16255 */     // GIR_Coverage, 5435,
     /*  16255 */     GIR_EraseRootFromParent_Done,
     /*  16256 */   // Label 359: @16256
     /*  16256 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16333), // Rule ID 5468 //
     /*  16261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16292 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16296 */     // MIs[2] Operand 1
     /*  16296 */     // No operand predicates
     /*  16296 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16306 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16331 */     GIR_RootConstrainSelectedInstOperands,
     /*  16332 */     // GIR_Coverage, 5468,
     /*  16332 */     GIR_EraseRootFromParent_Done,
     /*  16333 */   // Label 360: @16333
     /*  16333 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16410), // Rule ID 5434 //
     /*  16338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16365 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16377 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16381 */     // MIs[2] Operand 1
     /*  16381 */     // No operand predicates
     /*  16381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16383 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16408 */     GIR_RootConstrainSelectedInstOperands,
     /*  16409 */     // GIR_Coverage, 5434,
     /*  16409 */     GIR_EraseRootFromParent_Done,
     /*  16410 */   // Label 361: @16410
     /*  16410 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16487), // Rule ID 5467 //
     /*  16415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16442 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16454 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16458 */     // MIs[2] Operand 1
     /*  16458 */     // No operand predicates
     /*  16458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16460 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16473 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16485 */     GIR_RootConstrainSelectedInstOperands,
     /*  16486 */     // GIR_Coverage, 5467,
     /*  16486 */     GIR_EraseRootFromParent_Done,
     /*  16487 */   // Label 362: @16487
     /*  16487 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16564), // Rule ID 159 //
     /*  16492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16527 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16531 */     // MIs[2] Operand 1
     /*  16531 */     // No operand predicates
     /*  16531 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16537 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16562 */     GIR_RootConstrainSelectedInstOperands,
     /*  16563 */     // GIR_Coverage, 159,
     /*  16563 */     GIR_EraseRootFromParent_Done,
     /*  16564 */   // Label 363: @16564
     /*  16564 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16641), // Rule ID 490 //
     /*  16569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16604 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16608 */     // MIs[2] Operand 1
     /*  16608 */     // No operand predicates
     /*  16608 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16614 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16639 */     GIR_RootConstrainSelectedInstOperands,
     /*  16640 */     // GIR_Coverage, 490,
     /*  16640 */     GIR_EraseRootFromParent_Done,
     /*  16641 */   // Label 364: @16641
     /*  16641 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16712), // Rule ID 5437 //
     /*  16646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16674 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16684 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16710 */     GIR_RootConstrainSelectedInstOperands,
     /*  16711 */     // GIR_Coverage, 5437,
     /*  16711 */     GIR_EraseRootFromParent_Done,
     /*  16712 */   // Label 365: @16712
     /*  16712 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16783), // Rule ID 5458 //
     /*  16717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16745 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16755 */     // (and:{ *:[i32] } (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), tGPR:{ *:[i32] }:$Rn)  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16781 */     GIR_RootConstrainSelectedInstOperands,
     /*  16782 */     // GIR_Coverage, 5458,
     /*  16782 */     GIR_EraseRootFromParent_Done,
     /*  16783 */   // Label 366: @16783
     /*  16783 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16854), // Rule ID 5470 //
     /*  16788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16816 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16826 */     // (and:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  16826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  16829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16852 */     GIR_RootConstrainSelectedInstOperands,
     /*  16853 */     // GIR_Coverage, 5470,
     /*  16853 */     GIR_EraseRootFromParent_Done,
     /*  16854 */   // Label 367: @16854
     /*  16854 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16925), // Rule ID 160 //
     /*  16859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16891 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16897 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16923 */     GIR_RootConstrainSelectedInstOperands,
     /*  16924 */     // GIR_Coverage, 160,
     /*  16924 */     GIR_EraseRootFromParent_Done,
     /*  16925 */   // Label 368: @16925
     /*  16925 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16996), // Rule ID 313 //
     /*  16930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16962 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16968 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16994 */     GIR_RootConstrainSelectedInstOperands,
     /*  16995 */     // GIR_Coverage, 313,
     /*  16995 */     GIR_EraseRootFromParent_Done,
     /*  16996 */   // Label 369: @16996
     /*  16996 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17067), // Rule ID 491 //
     /*  17001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17033 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17039 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  17042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  17050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17065 */     GIR_RootConstrainSelectedInstOperands,
     /*  17066 */     // GIR_Coverage, 491,
     /*  17066 */     GIR_EraseRootFromParent_Done,
     /*  17067 */   // Label 370: @17067
     /*  17067 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17112), // Rule ID 345 //
     /*  17072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17083 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17094 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (tUXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTB),
     /*  17097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17110 */     GIR_RootConstrainSelectedInstOperands,
     /*  17111 */     // GIR_Coverage, 345,
     /*  17111 */     GIR_EraseRootFromParent_Done,
     /*  17112 */   // Label 371: @17112
     /*  17112 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17157), // Rule ID 346 //
     /*  17117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17128 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17139 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (tUXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTH),
     /*  17142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17155 */     GIR_RootConstrainSelectedInstOperands,
     /*  17156 */     // GIR_Coverage, 346,
     /*  17156 */     GIR_EraseRootFromParent_Done,
     /*  17157 */   // Label 372: @17157
     /*  17157 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17216), // Rule ID 1891 //
     /*  17162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  17185 */     // MIs[1] Operand 1
     /*  17185 */     // No operand predicates
     /*  17185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17187 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>>:$imm))
     /*  17187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  17190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17192 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17194 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  17199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17214 */     GIR_RootConstrainSelectedInstOperands,
     /*  17215 */     // GIR_Coverage, 1891,
     /*  17215 */     GIR_EraseRootFromParent_Done,
     /*  17216 */   // Label 373: @17216
     /*  17216 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17273), // Rule ID 147 //
     /*  17221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  17244 */     // MIs[1] Operand 1
     /*  17244 */     // No operand predicates
     /*  17244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17246 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ANDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDri),
     /*  17249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17265 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17271 */     GIR_RootConstrainSelectedInstOperands,
     /*  17272 */     // GIR_Coverage, 147,
     /*  17272 */     GIR_EraseRootFromParent_Done,
     /*  17273 */   // Label 374: @17273
     /*  17273 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17330), // Rule ID 481 //
     /*  17278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  17301 */     // MIs[1] Operand 1
     /*  17301 */     // No operand predicates
     /*  17301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17303 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ANDri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDri),
     /*  17306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17328 */     GIR_RootConstrainSelectedInstOperands,
     /*  17329 */     // GIR_Coverage, 481,
     /*  17329 */     GIR_EraseRootFromParent_Done,
     /*  17330 */   // Label 375: @17330
     /*  17330 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17381), // Rule ID 163 //
     /*  17335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  17338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17354 */     // MIs[1] Operand 1
     /*  17354 */     // No operand predicates
     /*  17354 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17360 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (BFC:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BFC),
     /*  17363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17365 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17379 */     GIR_RootConstrainSelectedInstOperands,
     /*  17380 */     // GIR_Coverage, 163,
     /*  17380 */     GIR_EraseRootFromParent_Done,
     /*  17381 */   // Label 376: @17381
     /*  17381 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17432), // Rule ID 493 //
     /*  17386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17405 */     // MIs[1] Operand 1
     /*  17405 */     // No operand predicates
     /*  17405 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17411 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (t2BFC:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BFC),
     /*  17414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17416 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17430 */     GIR_RootConstrainSelectedInstOperands,
     /*  17431 */     // GIR_Coverage, 493,
     /*  17431 */     GIR_EraseRootFromParent_Done,
     /*  17432 */   // Label 377: @17432
     /*  17432 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17478), // Rule ID 148 //
     /*  17437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17452 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ANDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  17452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDrr),
     /*  17455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17476 */     GIR_RootConstrainSelectedInstOperands,
     /*  17477 */     // GIR_Coverage, 148,
     /*  17477 */     GIR_EraseRootFromParent_Done,
     /*  17478 */   // Label 378: @17478
     /*  17478 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17524), // Rule ID 310 //
     /*  17483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  17486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17498 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tAND:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  17498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tAND),
     /*  17501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  17503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  17509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17522 */     GIR_RootConstrainSelectedInstOperands,
     /*  17523 */     // GIR_Coverage, 310,
     /*  17523 */     GIR_EraseRootFromParent_Done,
     /*  17524 */   // Label 379: @17524
     /*  17524 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17570), // Rule ID 482 //
     /*  17529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17544 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ANDrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17568 */     GIR_RootConstrainSelectedInstOperands,
     /*  17569 */     // GIR_Coverage, 482,
     /*  17569 */     GIR_EraseRootFromParent_Done,
     /*  17570 */   // Label 380: @17570
     /*  17570 */   GIM_Reject,
     /*  17571 */ // Label 348: @17571
     /*  17571 */ GIM_Reject,
     /*  17572 */ // Label 335: @17572
     /*  17572 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17618), // Rule ID 2523 //
     /*  17577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  17583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17594 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17598 */   // (and:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VANDd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  17598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17603 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17605 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17610 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17616 */   GIR_RootConstrainSelectedInstOperands,
     /*  17617 */   // GIR_Coverage, 2523,
     /*  17617 */   GIR_EraseRootFromParent_Done,
     /*  17618 */ // Label 381: @17618
     /*  17618 */ GIM_Reject,
     /*  17619 */ // Label 336: @17619
     /*  17619 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17736), // Rule ID 1823 //
     /*  17624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  17630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  17633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17641 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17645 */   // (and:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17645 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17648 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17652 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17657 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17661 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17666 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17669 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17673 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17678 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17682 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17687 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17690 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17694 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17699 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17702 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17705 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17708 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17714 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17735 */   // GIR_Coverage, 1823,
     /*  17735 */   GIR_EraseRootFromParent_Done,
     /*  17736 */ // Label 382: @17736
     /*  17736 */ GIM_Reject,
     /*  17737 */ // Label 337: @17737
     /*  17737 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17783), // Rule ID 1130 //
     /*  17742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17763 */   // (and:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VANDd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  17763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17768 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  17770 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  17772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17775 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17781 */   GIR_RootConstrainSelectedInstOperands,
     /*  17782 */   // GIR_Coverage, 1130,
     /*  17782 */   GIR_EraseRootFromParent_Done,
     /*  17783 */ // Label 383: @17783
     /*  17783 */ GIM_Reject,
     /*  17784 */ // Label 338: @17784
     /*  17784 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17897),
     /*  17789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  17795 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17835), // Rule ID 2526 //
     /*  17800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17815 */     // (and:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VANDq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  17815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  17818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17820 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17822 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17833 */     GIR_RootConstrainSelectedInstOperands,
     /*  17834 */     // GIR_Coverage, 2526,
     /*  17834 */     GIR_EraseRootFromParent_Done,
     /*  17835 */   // Label 385: @17835
     /*  17835 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17896), // Rule ID 3367 //
     /*  17840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17855 */     // (and:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VAND:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  17855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  17858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  17870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  17872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  17874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  17876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17879 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17894 */     GIR_RootConstrainSelectedInstOperands,
     /*  17895 */     // GIR_Coverage, 3367,
     /*  17895 */     GIR_EraseRootFromParent_Done,
     /*  17896 */   // Label 386: @17896
     /*  17896 */   GIM_Reject,
     /*  17897 */ // Label 384: @17897
     /*  17897 */ GIM_Reject,
     /*  17898 */ // Label 339: @17898
     /*  17898 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18015), // Rule ID 1824 //
     /*  17903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  17909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  17912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17924 */   // (and:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17924 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17927 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17931 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17936 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17940 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17945 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17948 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17952 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17957 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17961 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17966 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17969 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17973 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17978 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17981 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17984 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17987 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17993 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18006 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18009 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18014 */   // GIR_Coverage, 1824,
     /*  18014 */   GIR_EraseRootFromParent_Done,
     /*  18015 */ // Label 387: @18015
     /*  18015 */ GIM_Reject,
     /*  18016 */ // Label 340: @18016
     /*  18016 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18062), // Rule ID 2522 //
     /*  18021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  18027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  18030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18038 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18042 */   // (and:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VANDd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  18042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18047 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18049 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18054 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18060 */   GIR_RootConstrainSelectedInstOperands,
     /*  18061 */   // GIR_Coverage, 2522,
     /*  18061 */   GIR_EraseRootFromParent_Done,
     /*  18062 */ // Label 388: @18062
     /*  18062 */ GIM_Reject,
     /*  18063 */ // Label 341: @18063
     /*  18063 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(18176),
     /*  18068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18074 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18114), // Rule ID 1131 //
     /*  18079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18094 */     // (and:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VANDq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  18094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  18101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  18103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18112 */     GIR_RootConstrainSelectedInstOperands,
     /*  18113 */     // GIR_Coverage, 1131,
     /*  18113 */     GIR_EraseRootFromParent_Done,
     /*  18114 */   // Label 390: @18114
     /*  18114 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18175), // Rule ID 3363 //
     /*  18119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18134 */     // (and:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VAND:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  18134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18173 */     GIR_RootConstrainSelectedInstOperands,
     /*  18174 */     // GIR_Coverage, 3363,
     /*  18174 */     GIR_EraseRootFromParent_Done,
     /*  18175 */   // Label 391: @18175
     /*  18175 */   GIM_Reject,
     /*  18176 */ // Label 389: @18176
     /*  18176 */ GIM_Reject,
     /*  18177 */ // Label 342: @18177
     /*  18177 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18294), // Rule ID 1825 //
     /*  18182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  18188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  18191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18203 */   // (and:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18203 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18206 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18210 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18215 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18219 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18224 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18227 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18231 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18236 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18240 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18245 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18248 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18252 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18257 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18260 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18263 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18266 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18272 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18288 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18293 */   // GIR_Coverage, 1825,
     /*  18293 */   GIR_EraseRootFromParent_Done,
     /*  18294 */ // Label 392: @18294
     /*  18294 */ GIM_Reject,
     /*  18295 */ // Label 343: @18295
     /*  18295 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18341), // Rule ID 2521 //
     /*  18300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  18306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  18309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18321 */   // (and:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VANDd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  18321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18326 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18328 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18333 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18339 */   GIR_RootConstrainSelectedInstOperands,
     /*  18340 */   // GIR_Coverage, 2521,
     /*  18340 */   GIR_EraseRootFromParent_Done,
     /*  18341 */ // Label 393: @18341
     /*  18341 */ GIM_Reject,
     /*  18342 */ // Label 344: @18342
     /*  18342 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18455),
     /*  18347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  18350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  18353 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18393), // Rule ID 2525 //
     /*  18358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18373 */     // (and:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VANDq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  18373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18378 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18380 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18385 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18391 */     GIR_RootConstrainSelectedInstOperands,
     /*  18392 */     // GIR_Coverage, 2525,
     /*  18392 */     GIR_EraseRootFromParent_Done,
     /*  18393 */   // Label 395: @18393
     /*  18393 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18454), // Rule ID 3359 //
     /*  18398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18413 */     // (and:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VAND:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  18413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18452 */     GIR_RootConstrainSelectedInstOperands,
     /*  18453 */     // GIR_Coverage, 3359,
     /*  18453 */     GIR_EraseRootFromParent_Done,
     /*  18454 */   // Label 396: @18454
     /*  18454 */   GIM_Reject,
     /*  18455 */ // Label 394: @18455
     /*  18455 */ GIM_Reject,
     /*  18456 */ // Label 345: @18456
     /*  18456 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18573), // Rule ID 1826 //
     /*  18461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  18467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  18470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18482 */   // (and:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18482 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18485 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18489 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18494 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18498 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18503 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18506 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18510 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18515 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18519 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18536 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18539 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18542 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18545 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18551 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18567 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18572 */   // GIR_Coverage, 1826,
     /*  18572 */   GIR_EraseRootFromParent_Done,
     /*  18573 */ // Label 397: @18573
     /*  18573 */ GIM_Reject,
     /*  18574 */ // Label 346: @18574
     /*  18574 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18687),
     /*  18579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  18582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  18585 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(18625), // Rule ID 2524 //
     /*  18590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18605 */     // (and:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VANDq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  18605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18610 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18612 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18623 */     GIR_RootConstrainSelectedInstOperands,
     /*  18624 */     // GIR_Coverage, 2524,
     /*  18624 */     GIR_EraseRootFromParent_Done,
     /*  18625 */   // Label 399: @18625
     /*  18625 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(18686), // Rule ID 3355 //
     /*  18630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18645 */     // (and:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VAND:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  18645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18684 */     GIR_RootConstrainSelectedInstOperands,
     /*  18685 */     // GIR_Coverage, 3355,
     /*  18685 */     GIR_EraseRootFromParent_Done,
     /*  18686 */   // Label 400: @18686
     /*  18686 */   GIM_Reject,
     /*  18687 */ // Label 398: @18687
     /*  18687 */ GIM_Reject,
     /*  18688 */ // Label 347: @18688
     /*  18688 */ GIM_Reject,
     /*  18689 */ // Label 6: @18689
     /*  18689 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 414*/ GIMT_Encode4(24497),
     /*  18700 */ /*GILLT_s32*//*Label 401*/ GIMT_Encode4(18760),
     /*  18704 */ /*GILLT_s64*//*Label 402*/ GIMT_Encode4(23381),
     /*  18708 */ /*GILLT_v2s1*//*Label 403*/ GIMT_Encode4(23428),
     /*  18712 */ /*GILLT_v2s32*//*Label 404*/ GIMT_Encode4(23546),
     /*  18716 */ /*GILLT_v2s64*//*Label 405*/ GIMT_Encode4(23593),
     /*  18720 */ /*GILLT_v4s1*//*Label 406*/ GIMT_Encode4(23707),
     /*  18724 */ /*GILLT_v4s16*//*Label 407*/ GIMT_Encode4(23825),
     /*  18728 */ /*GILLT_v4s32*//*Label 408*/ GIMT_Encode4(23872), GIMT_Encode4(0),
     /*  18736 */ /*GILLT_v8s1*//*Label 409*/ GIMT_Encode4(23986),
     /*  18740 */ /*GILLT_v8s8*//*Label 410*/ GIMT_Encode4(24104),
     /*  18744 */ /*GILLT_v8s16*//*Label 411*/ GIMT_Encode4(24151), GIMT_Encode4(0),
     /*  18752 */ /*GILLT_v16s1*//*Label 412*/ GIMT_Encode4(24265),
     /*  18756 */ /*GILLT_v16s8*//*Label 413*/ GIMT_Encode4(24383),
     /*  18760 */ // Label 401: @18760
     /*  18760 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(23380),
     /*  18765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  18768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18771 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(18898), // Rule ID 5652 //
     /*  18776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  18779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18820 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18824 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18843 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18847 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18851 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18855 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18859 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18863 */     // MIs[4] Rm
     /*  18863 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18868 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18872 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18876 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18878 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  18878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  18881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18896 */     GIR_RootConstrainSelectedInstOperands,
     /*  18897 */     // GIR_Coverage, 5652,
     /*  18897 */     GIR_EraseRootFromParent_Done,
     /*  18898 */   // Label 416: @18898
     /*  18898 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(19025), // Rule ID 5694 //
     /*  18903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  18906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18938 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18947 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18951 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18966 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18970 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18974 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18978 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18982 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18986 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18990 */     // MIs[4] Rm
     /*  18990 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18995 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18999 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  19003 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19005 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  19005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  19008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19023 */     GIR_RootConstrainSelectedInstOperands,
     /*  19024 */     // GIR_Coverage, 5694,
     /*  19024 */     GIR_EraseRootFromParent_Done,
     /*  19025 */   // Label 417: @19025
     /*  19025 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(19152), // Rule ID 1911 //
     /*  19030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19065 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19074 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19078 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19090 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19094 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19098 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19102 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19106 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19110 */     // MIs[4] Rm
     /*  19110 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19115 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19119 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19130 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19132 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  19132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  19135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19150 */     GIR_RootConstrainSelectedInstOperands,
     /*  19151 */     // GIR_Coverage, 1911,
     /*  19151 */     GIR_EraseRootFromParent_Done,
     /*  19152 */   // Label 418: @19152
     /*  19152 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(19279), // Rule ID 2193 //
     /*  19157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  19160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19201 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19205 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19217 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19221 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19225 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19229 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19233 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19237 */     // MIs[4] Rm
     /*  19237 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19242 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19246 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19257 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19259 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  19259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  19262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19271 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19277 */     GIR_RootConstrainSelectedInstOperands,
     /*  19278 */     // GIR_Coverage, 2193,
     /*  19278 */     GIR_EraseRootFromParent_Done,
     /*  19279 */   // Label 419: @19279
     /*  19279 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(19412), // Rule ID 5450 //
     /*  19284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19319 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19336 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19340 */     // MIs[3] Operand 1
     /*  19340 */     // No operand predicates
     /*  19340 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19351 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19355 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19359 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19363 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19367 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19372 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19383 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19385 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19410 */     GIR_RootConstrainSelectedInstOperands,
     /*  19411 */     // GIR_Coverage, 5450,
     /*  19411 */     GIR_EraseRootFromParent_Done,
     /*  19412 */   // Label 420: @19412
     /*  19412 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(19545), // Rule ID 5487 //
     /*  19417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19469 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19473 */     // MIs[3] Operand 1
     /*  19473 */     // No operand predicates
     /*  19473 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19484 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19488 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19492 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19496 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19500 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19505 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19516 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19518 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19543 */     GIR_RootConstrainSelectedInstOperands,
     /*  19544 */     // GIR_Coverage, 5487,
     /*  19544 */     GIR_EraseRootFromParent_Done,
     /*  19545 */   // Label 421: @19545
     /*  19545 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(19678), // Rule ID 5657 //
     /*  19550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19602 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19606 */     // MIs[3] Operand 1
     /*  19606 */     // No operand predicates
     /*  19606 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19617 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19621 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19625 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19629 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19633 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19638 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19649 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19651 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19676 */     GIR_RootConstrainSelectedInstOperands,
     /*  19677 */     // GIR_Coverage, 5657,
     /*  19677 */     GIR_EraseRootFromParent_Done,
     /*  19678 */   // Label 422: @19678
     /*  19678 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(19811), // Rule ID 5699 //
     /*  19683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19735 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19739 */     // MIs[3] Operand 1
     /*  19739 */     // No operand predicates
     /*  19739 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19750 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19754 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19758 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19762 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19766 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19771 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19782 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19784 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19809 */     GIR_RootConstrainSelectedInstOperands,
     /*  19810 */     // GIR_Coverage, 5699,
     /*  19810 */     GIR_EraseRootFromParent_Done,
     /*  19811 */   // Label 423: @19811
     /*  19811 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(19944), // Rule ID 5449 //
     /*  19816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19868 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19872 */     // MIs[3] Operand 1
     /*  19872 */     // No operand predicates
     /*  19872 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19883 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19887 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19891 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19895 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19899 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19904 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  19915 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19917 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  19920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19942 */     GIR_RootConstrainSelectedInstOperands,
     /*  19943 */     // GIR_Coverage, 5449,
     /*  19943 */     GIR_EraseRootFromParent_Done,
     /*  19944 */   // Label 424: @19944
     /*  19944 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20077), // Rule ID 5486 //
     /*  19949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19988 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20001 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20005 */     // MIs[3] Operand 1
     /*  20005 */     // No operand predicates
     /*  20005 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20016 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  20020 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20024 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20028 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20032 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20037 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  20048 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20050 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  20059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  20066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20069 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20075 */     GIR_RootConstrainSelectedInstOperands,
     /*  20076 */     // GIR_Coverage, 5486,
     /*  20076 */     GIR_EraseRootFromParent_Done,
     /*  20077 */   // Label 425: @20077
     /*  20077 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(20210), // Rule ID 203 //
     /*  20082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20110 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20145 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20149 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20153 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20158 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20162 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20166 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20170 */     // MIs[4] Operand 1
     /*  20170 */     // No operand predicates
     /*  20170 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20181 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20183 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20208 */     GIR_RootConstrainSelectedInstOperands,
     /*  20209 */     // GIR_Coverage, 203,
     /*  20209 */     GIR_EraseRootFromParent_Done,
     /*  20210 */   // Label 426: @20210
     /*  20210 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(20343), // Rule ID 540 //
     /*  20215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20243 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20278 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20282 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20286 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20291 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20295 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20299 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20303 */     // MIs[4] Operand 1
     /*  20303 */     // No operand predicates
     /*  20303 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20314 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20316 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20341 */     GIR_RootConstrainSelectedInstOperands,
     /*  20342 */     // GIR_Coverage, 540,
     /*  20342 */     GIR_EraseRootFromParent_Done,
     /*  20343 */   // Label 427: @20343
     /*  20343 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(20476), // Rule ID 1916 //
     /*  20348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20376 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20411 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20415 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20419 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20424 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20428 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20432 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20436 */     // MIs[4] Operand 1
     /*  20436 */     // No operand predicates
     /*  20436 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20447 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20449 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20474 */     GIR_RootConstrainSelectedInstOperands,
     /*  20475 */     // GIR_Coverage, 1916,
     /*  20475 */     GIR_EraseRootFromParent_Done,
     /*  20476 */   // Label 428: @20476
     /*  20476 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(20609), // Rule ID 2198 //
     /*  20481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20509 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20544 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20548 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20552 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20557 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20561 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20565 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20569 */     // MIs[4] Operand 1
     /*  20569 */     // No operand predicates
     /*  20569 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20580 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20582 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20607 */     GIR_RootConstrainSelectedInstOperands,
     /*  20608 */     // GIR_Coverage, 2198,
     /*  20608 */     GIR_EraseRootFromParent_Done,
     /*  20609 */   // Label 429: @20609
     /*  20609 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(20742), // Rule ID 202 //
     /*  20614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20642 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20677 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20681 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20685 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20690 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20694 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20698 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20702 */     // MIs[4] Operand 1
     /*  20702 */     // No operand predicates
     /*  20702 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20713 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20715 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20740 */     GIR_RootConstrainSelectedInstOperands,
     /*  20741 */     // GIR_Coverage, 202,
     /*  20741 */     GIR_EraseRootFromParent_Done,
     /*  20742 */   // Label 430: @20742
     /*  20742 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(20875), // Rule ID 539 //
     /*  20747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20775 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20810 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20814 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20818 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20823 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20827 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20831 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20835 */     // MIs[4] Operand 1
     /*  20835 */     // No operand predicates
     /*  20835 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20846 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20848 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20873 */     GIR_RootConstrainSelectedInstOperands,
     /*  20874 */     // GIR_Coverage, 539,
     /*  20874 */     GIR_EraseRootFromParent_Done,
     /*  20875 */   // Label 431: @20875
     /*  20875 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(20980), // Rule ID 1912 //
     /*  20880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20908 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20940 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20953 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  20953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20978 */     GIR_RootConstrainSelectedInstOperands,
     /*  20979 */     // GIR_Coverage, 1912,
     /*  20979 */     GIR_EraseRootFromParent_Done,
     /*  20980 */   // Label 432: @20980
     /*  20980 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21085), // Rule ID 2194 //
     /*  20985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21013 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21045 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21058 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21083 */     GIR_RootConstrainSelectedInstOperands,
     /*  21084 */     // GIR_Coverage, 2194,
     /*  21084 */     GIR_EraseRootFromParent_Done,
     /*  21085 */   // Label 433: @21085
     /*  21085 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21190), // Rule ID 5653 //
     /*  21090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21118 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21150 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21163 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  21163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21188 */     GIR_RootConstrainSelectedInstOperands,
     /*  21189 */     // GIR_Coverage, 5653,
     /*  21189 */     GIR_EraseRootFromParent_Done,
     /*  21190 */   // Label 434: @21190
     /*  21190 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21295), // Rule ID 5695 //
     /*  21195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21223 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21255 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21268 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  21277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  21281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21293 */     GIR_RootConstrainSelectedInstOperands,
     /*  21294 */     // GIR_Coverage, 5695,
     /*  21294 */     GIR_EraseRootFromParent_Done,
     /*  21295 */   // Label 435: @21295
     /*  21295 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21401), // Rule ID 1915 //
     /*  21300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21328 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21351 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21368 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21372 */     // MIs[3] Operand 1
     /*  21372 */     // No operand predicates
     /*  21372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21374 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21393 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21399 */     GIR_RootConstrainSelectedInstOperands,
     /*  21400 */     // GIR_Coverage, 1915,
     /*  21400 */     GIR_EraseRootFromParent_Done,
     /*  21401 */   // Label 436: @21401
     /*  21401 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(21507), // Rule ID 2197 //
     /*  21406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21434 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21474 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21478 */     // MIs[3] Operand 1
     /*  21478 */     // No operand predicates
     /*  21478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21480 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21505 */     GIR_RootConstrainSelectedInstOperands,
     /*  21506 */     // GIR_Coverage, 2197,
     /*  21506 */     GIR_EraseRootFromParent_Done,
     /*  21507 */   // Label 437: @21507
     /*  21507 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21613), // Rule ID 1914 //
     /*  21512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21540 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21580 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21584 */     // MIs[3] Operand 1
     /*  21584 */     // No operand predicates
     /*  21584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21586 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21611 */     GIR_RootConstrainSelectedInstOperands,
     /*  21612 */     // GIR_Coverage, 1914,
     /*  21612 */     GIR_EraseRootFromParent_Done,
     /*  21613 */   // Label 438: @21613
     /*  21613 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21719), // Rule ID 2196 //
     /*  21618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21646 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21673 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21686 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21690 */     // MIs[3] Operand 1
     /*  21690 */     // No operand predicates
     /*  21690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21692 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21711 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21717 */     GIR_RootConstrainSelectedInstOperands,
     /*  21718 */     // GIR_Coverage, 2196,
     /*  21718 */     GIR_EraseRootFromParent_Done,
     /*  21719 */   // Label 439: @21719
     /*  21719 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21825), // Rule ID 1913 //
     /*  21724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21752 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21792 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21796 */     // MIs[3] Operand 1
     /*  21796 */     // No operand predicates
     /*  21796 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21798 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21823 */     GIR_RootConstrainSelectedInstOperands,
     /*  21824 */     // GIR_Coverage, 1913,
     /*  21824 */     GIR_EraseRootFromParent_Done,
     /*  21825 */   // Label 440: @21825
     /*  21825 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(21931), // Rule ID 2195 //
     /*  21830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21858 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21885 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21898 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21902 */     // MIs[3] Operand 1
     /*  21902 */     // No operand predicates
     /*  21902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21904 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21929 */     GIR_RootConstrainSelectedInstOperands,
     /*  21930 */     // GIR_Coverage, 2195,
     /*  21930 */     GIR_EraseRootFromParent_Done,
     /*  21931 */   // Label 441: @21931
     /*  21931 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22037), // Rule ID 5656 //
     /*  21936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21972 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21976 */     // MIs[2] Operand 1
     /*  21976 */     // No operand predicates
     /*  21976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21984 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  21988 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21992 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21997 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22010 */     // (or:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22029 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22035 */     GIR_RootConstrainSelectedInstOperands,
     /*  22036 */     // GIR_Coverage, 5656,
     /*  22036 */     GIR_EraseRootFromParent_Done,
     /*  22037 */   // Label 442: @22037
     /*  22037 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22143), // Rule ID 5698 //
     /*  22042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  22057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22078 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22082 */     // MIs[2] Operand 1
     /*  22082 */     // No operand predicates
     /*  22082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22090 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22094 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22098 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22103 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22114 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22116 */     // (or:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22141 */     GIR_RootConstrainSelectedInstOperands,
     /*  22142 */     // GIR_Coverage, 5698,
     /*  22142 */     GIR_EraseRootFromParent_Done,
     /*  22143 */   // Label 443: @22143
     /*  22143 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22249), // Rule ID 5655 //
     /*  22148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22184 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22188 */     // MIs[2] Operand 1
     /*  22188 */     // No operand predicates
     /*  22188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22196 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22200 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22204 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22209 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22222 */     // (or:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22247 */     GIR_RootConstrainSelectedInstOperands,
     /*  22248 */     // GIR_Coverage, 5655,
     /*  22248 */     GIR_EraseRootFromParent_Done,
     /*  22249 */   // Label 444: @22249
     /*  22249 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22355), // Rule ID 5697 //
     /*  22254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22290 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22294 */     // MIs[2] Operand 1
     /*  22294 */     // No operand predicates
     /*  22294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22302 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22306 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22310 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22315 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22328 */     // (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22353 */     GIR_RootConstrainSelectedInstOperands,
     /*  22354 */     // GIR_Coverage, 5697,
     /*  22354 */     GIR_EraseRootFromParent_Done,
     /*  22355 */   // Label 445: @22355
     /*  22355 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22461), // Rule ID 5654 //
     /*  22360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22396 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22400 */     // MIs[2] Operand 1
     /*  22400 */     // No operand predicates
     /*  22400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22408 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22412 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22416 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22421 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22434 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  22437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  22443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22453 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22459 */     GIR_RootConstrainSelectedInstOperands,
     /*  22460 */     // GIR_Coverage, 5654,
     /*  22460 */     GIR_EraseRootFromParent_Done,
     /*  22461 */   // Label 446: @22461
     /*  22461 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22567), // Rule ID 5696 //
     /*  22466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22502 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22506 */     // MIs[2] Operand 1
     /*  22506 */     // No operand predicates
     /*  22506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22514 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22518 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22522 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22527 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22538 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22540 */     // (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  22543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22565 */     GIR_RootConstrainSelectedInstOperands,
     /*  22566 */     // GIR_Coverage, 5696,
     /*  22566 */     GIR_EraseRootFromParent_Done,
     /*  22567 */   // Label 447: @22567
     /*  22567 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22644), // Rule ID 5474 //
     /*  22572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22595 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22607 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22611 */     // MIs[2] Operand 1
     /*  22611 */     // No operand predicates
     /*  22611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22617 */     // (or:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22642 */     GIR_RootConstrainSelectedInstOperands,
     /*  22643 */     // GIR_Coverage, 5474,
     /*  22643 */     GIR_EraseRootFromParent_Done,
     /*  22644 */   // Label 448: @22644
     /*  22644 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22721), // Rule ID 5473 //
     /*  22649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22680 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22684 */     // MIs[2] Operand 1
     /*  22684 */     // No operand predicates
     /*  22684 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22694 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22719 */     GIR_RootConstrainSelectedInstOperands,
     /*  22720 */     // GIR_Coverage, 5473,
     /*  22720 */     GIR_EraseRootFromParent_Done,
     /*  22721 */   // Label 449: @22721
     /*  22721 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22798), // Rule ID 5472 //
     /*  22726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22753 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22765 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22769 */     // MIs[2] Operand 1
     /*  22769 */     // No operand predicates
     /*  22769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22771 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22796 */     GIR_RootConstrainSelectedInstOperands,
     /*  22797 */     // GIR_Coverage, 5472,
     /*  22797 */     GIR_EraseRootFromParent_Done,
     /*  22798 */   // Label 450: @22798
     /*  22798 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22875), // Rule ID 496 //
     /*  22803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22838 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22842 */     // MIs[2] Operand 1
     /*  22842 */     // No operand predicates
     /*  22842 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22848 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22873 */     GIR_RootConstrainSelectedInstOperands,
     /*  22874 */     // GIR_Coverage, 496,
     /*  22874 */     GIR_EraseRootFromParent_Done,
     /*  22875 */   // Label 451: @22875
     /*  22875 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(22946), // Rule ID 5475 //
     /*  22880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22908 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22918 */     // (or:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22944 */     GIR_RootConstrainSelectedInstOperands,
     /*  22945 */     // GIR_Coverage, 5475,
     /*  22945 */     GIR_EraseRootFromParent_Done,
     /*  22946 */   // Label 452: @22946
     /*  22946 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23017), // Rule ID 497 //
     /*  22951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22983 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22989 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  23000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23003 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23015 */     GIR_RootConstrainSelectedInstOperands,
     /*  23016 */     // GIR_Coverage, 497,
     /*  23016 */     GIR_EraseRootFromParent_Done,
     /*  23017 */   // Label 453: @23017
     /*  23017 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23072), // Rule ID 1845 //
     /*  23022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  23025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  23029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23033 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23044 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (MOVTi16:{ *:[i32] } GPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVTi16),
     /*  23047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23049 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23051 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23070 */     GIR_RootConstrainSelectedInstOperands,
     /*  23071 */     // GIR_Coverage, 1845,
     /*  23071 */     GIR_EraseRootFromParent_Done,
     /*  23072 */   // Label 454: @23072
     /*  23072 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23127), // Rule ID 2091 //
     /*  23077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23088 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23099 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (t2MOVTi16:{ *:[i32] } rGPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVTi16),
     /*  23102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23104 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23106 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23125 */     GIR_RootConstrainSelectedInstOperands,
     /*  23126 */     // GIR_Coverage, 2091,
     /*  23126 */     GIR_EraseRootFromParent_Done,
     /*  23127 */   // Label 455: @23127
     /*  23127 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23184), // Rule ID 151 //
     /*  23132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  23155 */     // MIs[1] Operand 1
     /*  23155 */     // No operand predicates
     /*  23155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23157 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ORRri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRri),
     /*  23160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23182 */     GIR_RootConstrainSelectedInstOperands,
     /*  23183 */     // GIR_Coverage, 151,
     /*  23183 */     GIR_EraseRootFromParent_Done,
     /*  23184 */   // Label 456: @23184
     /*  23184 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23241), // Rule ID 484 //
     /*  23189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  23212 */     // MIs[1] Operand 1
     /*  23212 */     // No operand predicates
     /*  23212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23214 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ORRri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRri),
     /*  23217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23227 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23239 */     GIR_RootConstrainSelectedInstOperands,
     /*  23240 */     // GIR_Coverage, 484,
     /*  23240 */     GIR_EraseRootFromParent_Done,
     /*  23241 */   // Label 457: @23241
     /*  23241 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23287), // Rule ID 152 //
     /*  23246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23261 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ORRrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  23261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRrr),
     /*  23264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23266 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23285 */     GIR_RootConstrainSelectedInstOperands,
     /*  23286 */     // GIR_Coverage, 152,
     /*  23286 */     GIR_EraseRootFromParent_Done,
     /*  23287 */   // Label 458: @23287
     /*  23287 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23333), // Rule ID 325 //
     /*  23292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  23295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23307 */     // (or:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tORR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  23307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tORR),
     /*  23310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  23312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  23318 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23331 */     GIR_RootConstrainSelectedInstOperands,
     /*  23332 */     // GIR_Coverage, 325,
     /*  23332 */     GIR_EraseRootFromParent_Done,
     /*  23333 */   // Label 459: @23333
     /*  23333 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23379), // Rule ID 485 //
     /*  23338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23353 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ORRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  23353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23377 */     GIR_RootConstrainSelectedInstOperands,
     /*  23378 */     // GIR_Coverage, 485,
     /*  23378 */     GIR_EraseRootFromParent_Done,
     /*  23379 */   // Label 460: @23379
     /*  23379 */   GIM_Reject,
     /*  23380 */ // Label 415: @23380
     /*  23380 */ GIM_Reject,
     /*  23381 */ // Label 402: @23381
     /*  23381 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23427), // Rule ID 2529 //
     /*  23386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  23392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  23395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23407 */   // (or:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VORRd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  23407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23412 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23414 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23419 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23425 */   GIR_RootConstrainSelectedInstOperands,
     /*  23426 */   // GIR_Coverage, 2529,
     /*  23426 */   GIR_EraseRootFromParent_Done,
     /*  23427 */ // Label 461: @23427
     /*  23427 */ GIM_Reject,
     /*  23428 */ // Label 403: @23428
     /*  23428 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23545), // Rule ID 1831 //
     /*  23433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  23439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  23442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23454 */   // (or:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23454 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23457 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23461 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23466 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23470 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23475 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23478 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23482 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23487 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23491 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23496 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23499 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23503 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23508 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23511 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23514 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23517 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23523 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23534 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23536 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23539 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23544 */   // GIR_Coverage, 1831,
     /*  23544 */   GIR_EraseRootFromParent_Done,
     /*  23545 */ // Label 462: @23545
     /*  23545 */ GIM_Reject,
     /*  23546 */ // Label 404: @23546
     /*  23546 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23592), // Rule ID 1134 //
     /*  23551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  23557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  23560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23572 */   // (or:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VORRd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  23572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23577 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23579 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23584 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23590 */   GIR_RootConstrainSelectedInstOperands,
     /*  23591 */   // GIR_Coverage, 1134,
     /*  23591 */   GIR_EraseRootFromParent_Done,
     /*  23592 */ // Label 463: @23592
     /*  23592 */ GIM_Reject,
     /*  23593 */ // Label 405: @23593
     /*  23593 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23706),
     /*  23598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  23601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  23604 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(23644), // Rule ID 2532 //
     /*  23609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23624 */     // (or:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VORRq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  23624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23629 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23631 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23642 */     GIR_RootConstrainSelectedInstOperands,
     /*  23643 */     // GIR_Coverage, 2532,
     /*  23643 */     GIR_EraseRootFromParent_Done,
     /*  23644 */   // Label 465: @23644
     /*  23644 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(23705), // Rule ID 3381 //
     /*  23649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23664 */     // (or:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VORR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  23664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23703 */     GIR_RootConstrainSelectedInstOperands,
     /*  23704 */     // GIR_Coverage, 3381,
     /*  23704 */     GIR_EraseRootFromParent_Done,
     /*  23705 */   // Label 466: @23705
     /*  23705 */   GIM_Reject,
     /*  23706 */ // Label 464: @23706
     /*  23706 */ GIM_Reject,
     /*  23707 */ // Label 406: @23707
     /*  23707 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(23824), // Rule ID 1832 //
     /*  23712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  23718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  23721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23733 */   // (or:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23733 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23736 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23740 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23745 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23749 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23754 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23757 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23761 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23766 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23770 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23775 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23778 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23782 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23787 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23790 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23793 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23796 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23802 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23815 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23818 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23823 */   // GIR_Coverage, 1832,
     /*  23823 */   GIR_EraseRootFromParent_Done,
     /*  23824 */ // Label 467: @23824
     /*  23824 */ GIM_Reject,
     /*  23825 */ // Label 407: @23825
     /*  23825 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(23871), // Rule ID 2528 //
     /*  23830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23851 */   // (or:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VORRd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  23851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23856 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23858 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23863 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23869 */   GIR_RootConstrainSelectedInstOperands,
     /*  23870 */   // GIR_Coverage, 2528,
     /*  23870 */   GIR_EraseRootFromParent_Done,
     /*  23871 */ // Label 468: @23871
     /*  23871 */ GIM_Reject,
     /*  23872 */ // Label 408: @23872
     /*  23872 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(23985),
     /*  23877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23883 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(23923), // Rule ID 1135 //
     /*  23888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23903 */     // (or:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VORRq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  23903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23921 */     GIR_RootConstrainSelectedInstOperands,
     /*  23922 */     // GIR_Coverage, 1135,
     /*  23922 */     GIR_EraseRootFromParent_Done,
     /*  23923 */   // Label 470: @23923
     /*  23923 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(23984), // Rule ID 3377 //
     /*  23928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23943 */     // (or:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VORR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  23943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23982 */     GIR_RootConstrainSelectedInstOperands,
     /*  23983 */     // GIR_Coverage, 3377,
     /*  23983 */     GIR_EraseRootFromParent_Done,
     /*  23984 */   // Label 471: @23984
     /*  23984 */   GIM_Reject,
     /*  23985 */ // Label 469: @23985
     /*  23985 */ GIM_Reject,
     /*  23986 */ // Label 409: @23986
     /*  23986 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24103), // Rule ID 1833 //
     /*  23991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  23997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  24000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24012 */   // (or:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24012 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24015 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24019 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24024 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24028 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24033 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24036 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24040 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24045 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24049 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24066 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24069 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24072 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24075 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24081 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24094 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24097 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24102 */   // GIR_Coverage, 1833,
     /*  24102 */   GIR_EraseRootFromParent_Done,
     /*  24103 */ // Label 472: @24103
     /*  24103 */ GIM_Reject,
     /*  24104 */ // Label 410: @24104
     /*  24104 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24150), // Rule ID 2527 //
     /*  24109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24126 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24130 */   // (or:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VORRd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  24130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  24133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24135 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24137 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24142 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24148 */   GIR_RootConstrainSelectedInstOperands,
     /*  24149 */   // GIR_Coverage, 2527,
     /*  24149 */   GIR_EraseRootFromParent_Done,
     /*  24150 */ // Label 473: @24150
     /*  24150 */ GIM_Reject,
     /*  24151 */ // Label 411: @24151
     /*  24151 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24264),
     /*  24156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  24162 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24202), // Rule ID 2531 //
     /*  24167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24182 */     // (or:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VORRq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  24182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24187 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24189 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24200 */     GIR_RootConstrainSelectedInstOperands,
     /*  24201 */     // GIR_Coverage, 2531,
     /*  24201 */     GIR_EraseRootFromParent_Done,
     /*  24202 */   // Label 475: @24202
     /*  24202 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24263), // Rule ID 3373 //
     /*  24207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24222 */     // (or:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VORR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  24222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24261 */     GIR_RootConstrainSelectedInstOperands,
     /*  24262 */     // GIR_Coverage, 3373,
     /*  24262 */     GIR_EraseRootFromParent_Done,
     /*  24263 */   // Label 476: @24263
     /*  24263 */   GIM_Reject,
     /*  24264 */ // Label 474: @24264
     /*  24264 */ GIM_Reject,
     /*  24265 */ // Label 412: @24265
     /*  24265 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24382), // Rule ID 1834 //
     /*  24270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  24276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  24279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24291 */   // (or:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24291 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24294 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24298 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24303 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24307 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24312 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24315 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24319 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24324 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24328 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24333 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24336 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24340 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24345 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24348 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24351 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24354 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24360 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24376 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24381 */   // GIR_Coverage, 1834,
     /*  24381 */   GIR_EraseRootFromParent_Done,
     /*  24382 */ // Label 477: @24382
     /*  24382 */ GIM_Reject,
     /*  24383 */ // Label 413: @24383
     /*  24383 */ GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(24496),
     /*  24388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  24391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  24394 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24434), // Rule ID 2530 //
     /*  24399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24414 */     // (or:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VORRq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  24414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24419 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24421 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24426 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24432 */     GIR_RootConstrainSelectedInstOperands,
     /*  24433 */     // GIR_Coverage, 2530,
     /*  24433 */     GIR_EraseRootFromParent_Done,
     /*  24434 */   // Label 479: @24434
     /*  24434 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(24495), // Rule ID 3369 //
     /*  24439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24454 */     // (or:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VORR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  24454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24471 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24484 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24493 */     GIR_RootConstrainSelectedInstOperands,
     /*  24494 */     // GIR_Coverage, 3369,
     /*  24494 */     GIR_EraseRootFromParent_Done,
     /*  24495 */   // Label 480: @24495
     /*  24495 */   GIM_Reject,
     /*  24496 */ // Label 478: @24496
     /*  24496 */ GIM_Reject,
     /*  24497 */ // Label 414: @24497
     /*  24497 */ GIM_Reject,
     /*  24498 */ // Label 7: @24498
     /*  24498 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 494*/ GIMT_Encode4(26192),
     /*  24509 */ /*GILLT_s32*//*Label 481*/ GIMT_Encode4(24569),
     /*  24513 */ /*GILLT_s64*//*Label 482*/ GIMT_Encode4(25076),
     /*  24517 */ /*GILLT_v2s1*//*Label 483*/ GIMT_Encode4(25123),
     /*  24521 */ /*GILLT_v2s32*//*Label 484*/ GIMT_Encode4(25241),
     /*  24525 */ /*GILLT_v2s64*//*Label 485*/ GIMT_Encode4(25288),
     /*  24529 */ /*GILLT_v4s1*//*Label 486*/ GIMT_Encode4(25402),
     /*  24533 */ /*GILLT_v4s16*//*Label 487*/ GIMT_Encode4(25520),
     /*  24537 */ /*GILLT_v4s32*//*Label 488*/ GIMT_Encode4(25567), GIMT_Encode4(0),
     /*  24545 */ /*GILLT_v8s1*//*Label 489*/ GIMT_Encode4(25681),
     /*  24549 */ /*GILLT_v8s8*//*Label 490*/ GIMT_Encode4(25799),
     /*  24553 */ /*GILLT_v8s16*//*Label 491*/ GIMT_Encode4(25846), GIMT_Encode4(0),
     /*  24561 */ /*GILLT_v16s1*//*Label 492*/ GIMT_Encode4(25960),
     /*  24565 */ /*GILLT_v16s8*//*Label 493*/ GIMT_Encode4(26078),
     /*  24569 */ // Label 481: @24569
     /*  24569 */ GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(25075),
     /*  24574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  24577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  24580 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(24635), // Rule ID 5477 //
     /*  24585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, uint8_t(-1),
     /*  24596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24608 */     // MIs[1] Operand 1
     /*  24608 */     // No operand predicates
     /*  24608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24610 */     // (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24633 */     GIR_RootConstrainSelectedInstOperands,
     /*  24634 */     // GIR_Coverage, 5477,
     /*  24634 */     GIR_EraseRootFromParent_Done,
     /*  24635 */   // Label 496: @24635
     /*  24635 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(24690), // Rule ID 499 //
     /*  24640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24659 */     // MIs[1] Operand 1
     /*  24659 */     // No operand predicates
     /*  24659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24665 */     // (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] })  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24688 */     GIR_RootConstrainSelectedInstOperands,
     /*  24689 */     // GIR_Coverage, 499,
     /*  24689 */     GIR_EraseRootFromParent_Done,
     /*  24690 */   // Label 497: @24690
     /*  24690 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(24734), // Rule ID 500 //
     /*  24695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24710 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (t2MVNr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  24710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNr),
     /*  24713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24732 */     GIR_RootConstrainSelectedInstOperands,
     /*  24733 */     // GIR_Coverage, 500,
     /*  24733 */     GIR_EraseRootFromParent_Done,
     /*  24734 */   // Label 498: @24734
     /*  24734 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(24778), // Rule ID 165 //
     /*  24739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24754 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (MVNr:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  24754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNr),
     /*  24757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24770 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24776 */     GIR_RootConstrainSelectedInstOperands,
     /*  24777 */     // GIR_Coverage, 165,
     /*  24777 */     GIR_EraseRootFromParent_Done,
     /*  24778 */   // Label 499: @24778
     /*  24778 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(24822), // Rule ID 324 //
     /*  24783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24798 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, -1:{ *:[i32] })  =>  (tMVN:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  24798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMVN),
     /*  24801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  24809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24820 */     GIR_RootConstrainSelectedInstOperands,
     /*  24821 */     // GIR_Coverage, 324,
     /*  24821 */     GIR_EraseRootFromParent_Done,
     /*  24822 */   // Label 500: @24822
     /*  24822 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(24879), // Rule ID 155 //
     /*  24827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24846 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  24850 */     // MIs[1] Operand 1
     /*  24850 */     // No operand predicates
     /*  24850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24852 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (EORri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORri),
     /*  24855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24865 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24877 */     GIR_RootConstrainSelectedInstOperands,
     /*  24878 */     // GIR_Coverage, 155,
     /*  24878 */     GIR_EraseRootFromParent_Done,
     /*  24879 */   // Label 501: @24879
     /*  24879 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(24936), // Rule ID 487 //
     /*  24884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24907 */     // MIs[1] Operand 1
     /*  24907 */     // No operand predicates
     /*  24907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24909 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2EORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORri),
     /*  24912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24914 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24934 */     GIR_RootConstrainSelectedInstOperands,
     /*  24935 */     // GIR_Coverage, 487,
     /*  24935 */     GIR_EraseRootFromParent_Done,
     /*  24936 */   // Label 502: @24936
     /*  24936 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(24982), // Rule ID 156 //
     /*  24941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24956 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (EORrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  24956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORrr),
     /*  24959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  24965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24980 */     GIR_RootConstrainSelectedInstOperands,
     /*  24981 */     // GIR_Coverage, 156,
     /*  24981 */     GIR_EraseRootFromParent_Done,
     /*  24982 */   // Label 503: @24982
     /*  24982 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(25028), // Rule ID 317 //
     /*  24987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  25002 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tEOR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  25002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tEOR),
     /*  25005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  25007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  25013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25026 */     GIR_RootConstrainSelectedInstOperands,
     /*  25027 */     // GIR_Coverage, 317,
     /*  25027 */     GIR_EraseRootFromParent_Done,
     /*  25028 */   // Label 504: @25028
     /*  25028 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(25074), // Rule ID 488 //
     /*  25033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  25036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25048 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2EORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  25048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  25053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25072 */     GIR_RootConstrainSelectedInstOperands,
     /*  25073 */     // GIR_Coverage, 488,
     /*  25073 */     GIR_EraseRootFromParent_Done,
     /*  25074 */   // Label 505: @25074
     /*  25074 */   GIM_Reject,
     /*  25075 */ // Label 495: @25075
     /*  25075 */ GIM_Reject,
     /*  25076 */ // Label 482: @25076
     /*  25076 */ GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(25122), // Rule ID 2535 //
     /*  25081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  25087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  25090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25102 */   // (xor:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VEORd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  25102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25107 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25109 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25114 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25120 */   GIR_RootConstrainSelectedInstOperands,
     /*  25121 */   // GIR_Coverage, 2535,
     /*  25121 */   GIR_EraseRootFromParent_Done,
     /*  25122 */ // Label 506: @25122
     /*  25122 */ GIM_Reject,
     /*  25123 */ // Label 483: @25123
     /*  25123 */ GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(25240), // Rule ID 1827 //
     /*  25128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  25134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  25137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25145 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25149 */   // (xor:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25149 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25152 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25156 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25161 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25165 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25170 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25173 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25177 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25182 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25186 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25203 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25206 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25209 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25212 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25218 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25231 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25234 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25239 */   // GIR_Coverage, 1827,
     /*  25239 */   GIR_EraseRootFromParent_Done,
     /*  25240 */ // Label 507: @25240
     /*  25240 */ GIM_Reject,
     /*  25241 */ // Label 484: @25241
     /*  25241 */ GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(25287), // Rule ID 1132 //
     /*  25246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  25252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  25255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25267 */   // (xor:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VEORd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  25267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25272 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25274 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25276 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25279 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25285 */   GIR_RootConstrainSelectedInstOperands,
     /*  25286 */   // GIR_Coverage, 1132,
     /*  25286 */   GIR_EraseRootFromParent_Done,
     /*  25287 */ // Label 508: @25287
     /*  25287 */ GIM_Reject,
     /*  25288 */ // Label 485: @25288
     /*  25288 */ GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(25401),
     /*  25293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  25296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  25299 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(25339), // Rule ID 2538 //
     /*  25304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25319 */     // (xor:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VEORq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  25319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25324 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25326 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25337 */     GIR_RootConstrainSelectedInstOperands,
     /*  25338 */     // GIR_Coverage, 2538,
     /*  25338 */     GIR_EraseRootFromParent_Done,
     /*  25339 */   // Label 510: @25339
     /*  25339 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(25400), // Rule ID 3395 //
     /*  25344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25359 */     // (xor:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VEOR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  25359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25383 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25398 */     GIR_RootConstrainSelectedInstOperands,
     /*  25399 */     // GIR_Coverage, 3395,
     /*  25399 */     GIR_EraseRootFromParent_Done,
     /*  25400 */   // Label 511: @25400
     /*  25400 */   GIM_Reject,
     /*  25401 */ // Label 509: @25401
     /*  25401 */ GIM_Reject,
     /*  25402 */ // Label 486: @25402
     /*  25402 */ GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(25519), // Rule ID 1828 //
     /*  25407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  25413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  25416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25424 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25428 */   // (xor:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25428 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25431 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25435 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25440 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25444 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25449 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25452 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25456 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25461 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25465 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25470 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25473 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25477 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25482 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25485 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25488 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25491 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25497 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25510 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25513 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25518 */   // GIR_Coverage, 1828,
     /*  25518 */   GIR_EraseRootFromParent_Done,
     /*  25519 */ // Label 512: @25519
     /*  25519 */ GIM_Reject,
     /*  25520 */ // Label 487: @25520
     /*  25520 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(25566), // Rule ID 2534 //
     /*  25525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25546 */   // (xor:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VEORd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  25546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25551 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25553 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25558 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25564 */   GIR_RootConstrainSelectedInstOperands,
     /*  25565 */   // GIR_Coverage, 2534,
     /*  25565 */   GIR_EraseRootFromParent_Done,
     /*  25566 */ // Label 513: @25566
     /*  25566 */ GIM_Reject,
     /*  25567 */ // Label 488: @25567
     /*  25567 */ GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(25680),
     /*  25572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25578 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(25618), // Rule ID 1133 //
     /*  25583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25598 */     // (xor:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VEORq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  25598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25616 */     GIR_RootConstrainSelectedInstOperands,
     /*  25617 */     // GIR_Coverage, 1133,
     /*  25617 */     GIR_EraseRootFromParent_Done,
     /*  25618 */   // Label 515: @25618
     /*  25618 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(25679), // Rule ID 3391 //
     /*  25623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25638 */     // (xor:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VEOR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  25638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25655 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25677 */     GIR_RootConstrainSelectedInstOperands,
     /*  25678 */     // GIR_Coverage, 3391,
     /*  25678 */     GIR_EraseRootFromParent_Done,
     /*  25679 */   // Label 516: @25679
     /*  25679 */   GIM_Reject,
     /*  25680 */ // Label 514: @25680
     /*  25680 */ GIM_Reject,
     /*  25681 */ // Label 489: @25681
     /*  25681 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(25798), // Rule ID 1829 //
     /*  25686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  25692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  25695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25707 */   // (xor:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25707 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25710 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25714 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25719 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25723 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25728 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25731 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25735 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25740 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25744 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25756 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25761 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25764 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25767 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25770 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25776 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25792 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25797 */   // GIR_Coverage, 1829,
     /*  25797 */   GIR_EraseRootFromParent_Done,
     /*  25798 */ // Label 517: @25798
     /*  25798 */ GIM_Reject,
     /*  25799 */ // Label 490: @25799
     /*  25799 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(25845), // Rule ID 2533 //
     /*  25804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  25813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25825 */   // (xor:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VEORd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  25825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25830 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25832 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25837 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25843 */   GIR_RootConstrainSelectedInstOperands,
     /*  25844 */   // GIR_Coverage, 2533,
     /*  25844 */   GIR_EraseRootFromParent_Done,
     /*  25845 */ // Label 518: @25845
     /*  25845 */ GIM_Reject,
     /*  25846 */ // Label 491: @25846
     /*  25846 */ GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(25959),
     /*  25851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  25857 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(25897), // Rule ID 2537 //
     /*  25862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25877 */     // (xor:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VEORq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  25877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25882 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25884 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25895 */     GIR_RootConstrainSelectedInstOperands,
     /*  25896 */     // GIR_Coverage, 2537,
     /*  25896 */     GIR_EraseRootFromParent_Done,
     /*  25897 */   // Label 520: @25897
     /*  25897 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(25958), // Rule ID 3387 //
     /*  25902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25917 */     // (xor:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VEOR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  25917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25956 */     GIR_RootConstrainSelectedInstOperands,
     /*  25957 */     // GIR_Coverage, 3387,
     /*  25957 */     GIR_EraseRootFromParent_Done,
     /*  25958 */   // Label 521: @25958
     /*  25958 */   GIM_Reject,
     /*  25959 */ // Label 519: @25959
     /*  25959 */ GIM_Reject,
     /*  25960 */ // Label 492: @25960
     /*  25960 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(26077), // Rule ID 1830 //
     /*  25965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  25971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  25974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25986 */   // (xor:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25986 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25989 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25993 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25998 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  26002 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  26007 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  26010 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26014 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26019 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  26023 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  26028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  26031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  26035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26040 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26043 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  26046 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26049 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26055 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  26076 */   // GIR_Coverage, 1830,
     /*  26076 */   GIR_EraseRootFromParent_Done,
     /*  26077 */ // Label 522: @26077
     /*  26077 */ GIM_Reject,
     /*  26078 */ // Label 493: @26078
     /*  26078 */ GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(26191),
     /*  26083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  26086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  26089 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(26129), // Rule ID 2536 //
     /*  26094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26109 */     // (xor:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VEORq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  26109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  26112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  26114 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  26116 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  26118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26121 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26127 */     GIR_RootConstrainSelectedInstOperands,
     /*  26128 */     // GIR_Coverage, 2536,
     /*  26128 */     GIR_EraseRootFromParent_Done,
     /*  26129 */   // Label 524: @26129
     /*  26129 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(26190), // Rule ID 3383 //
     /*  26134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  26137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26149 */     // (xor:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VEOR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  26149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  26152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  26164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  26166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  26168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  26170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26173 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26188 */     GIR_RootConstrainSelectedInstOperands,
     /*  26189 */     // GIR_Coverage, 3383,
     /*  26189 */     GIR_EraseRootFromParent_Done,
     /*  26190 */   // Label 525: @26190
     /*  26190 */   GIM_Reject,
     /*  26191 */ // Label 523: @26191
     /*  26191 */ GIM_Reject,
     /*  26192 */ // Label 494: @26192
     /*  26192 */ GIM_Reject,
     /*  26193 */ // Label 8: @26193
     /*  26193 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(26579),
     /*  26198 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  26201 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(16), /*)*//*default:*//*Label 531*/ GIMT_Encode4(26578),
     /*  26212 */   /*GILLT_v2s64*//*Label 527*/ GIMT_Encode4(26256), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26224 */   /*GILLT_v4s32*//*Label 528*/ GIMT_Encode4(26314), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26240 */   /*GILLT_v8s16*//*Label 529*/ GIMT_Encode4(26417), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26252 */   /*GILLT_v16s8*//*Label 530*/ GIMT_Encode4(26520),
     /*  26256 */   // Label 527: @26256
     /*  26256 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(26313), // Rule ID 3021 //
     /*  26261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26264 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  26270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26282 */     // (concat_vectors:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Dn, DPR:{ *:[v1i64] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v2i64] } QPR:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dm, dsub_1:{ *:[i32] })
     /*  26282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26289 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26294 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26307 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26312 */     // GIR_Coverage, 3021,
     /*  26312 */     GIR_EraseRootFromParent_Done,
     /*  26313 */   // Label 532: @26313
     /*  26313 */   GIM_Reject,
     /*  26314 */   // Label 528: @26314
     /*  26314 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(26416),
     /*  26319 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  26325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26337 */     GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(26376), // Rule ID 3022 //
     /*  26342 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26345 */       // (concat_vectors:{ *:[v4i32] } DPR:{ *:[v2i32] }:$Dn, DPR:{ *:[v2i32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4i32] } QPR:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26345 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26348 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26350 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26352 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26355 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26357 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26360 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26365 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26370 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26375 */       // GIR_Coverage, 3022,
     /*  26375 */       GIR_EraseRootFromParent_Done,
     /*  26376 */     // Label 534: @26376
     /*  26376 */     GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(26415), // Rule ID 3025 //
     /*  26381 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26384 */       // (concat_vectors:{ *:[v4f32] } DPR:{ *:[v2f32] }:$Dn, DPR:{ *:[v2f32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4f32] } QPR:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26384 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26387 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26389 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26391 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26394 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26396 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26399 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26404 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26409 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26414 */       // GIR_Coverage, 3025,
     /*  26414 */       GIR_EraseRootFromParent_Done,
     /*  26415 */     // Label 535: @26415
     /*  26415 */     GIM_Reject,
     /*  26416 */   // Label 533: @26416
     /*  26416 */   GIM_Reject,
     /*  26417 */   // Label 529: @26417
     /*  26417 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(26519),
     /*  26422 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26440 */     GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(26479), // Rule ID 3023 //
     /*  26445 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26448 */       // (concat_vectors:{ *:[v8i16] } DPR:{ *:[v4i16] }:$Dn, DPR:{ *:[v4i16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8i16] } QPR:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26448 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26451 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26453 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26455 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26458 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26460 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26463 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26468 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26473 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26478 */       // GIR_Coverage, 3023,
     /*  26478 */       GIR_EraseRootFromParent_Done,
     /*  26479 */     // Label 537: @26479
     /*  26479 */     GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(26518), // Rule ID 3026 //
     /*  26484 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26487 */       // (concat_vectors:{ *:[v8f16] } DPR:{ *:[v4f16] }:$Dn, DPR:{ *:[v4f16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8f16] } QPR:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26487 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26490 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26492 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26494 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26497 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26499 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26502 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26507 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26512 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26517 */       // GIR_Coverage, 3026,
     /*  26517 */       GIR_EraseRootFromParent_Done,
     /*  26518 */     // Label 538: @26518
     /*  26518 */     GIM_Reject,
     /*  26519 */   // Label 536: @26519
     /*  26519 */   GIM_Reject,
     /*  26520 */   // Label 530: @26520
     /*  26520 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(26577), // Rule ID 3024 //
     /*  26525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26528 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  26534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26546 */     // (concat_vectors:{ *:[v16i8] } DPR:{ *:[v8i8] }:$Dn, DPR:{ *:[v8i8] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v16i8] } QPR:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dm, dsub_1:{ *:[i32] })
     /*  26546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26551 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26553 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26558 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26566 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26576 */     // GIR_Coverage, 3024,
     /*  26576 */     GIR_EraseRootFromParent_Done,
     /*  26577 */   // Label 539: @26577
     /*  26577 */   GIM_Reject,
     /*  26578 */   // Label 531: @26578
     /*  26578 */   GIM_Reject,
     /*  26579 */ // Label 526: @26579
     /*  26579 */ GIM_Reject,
     /*  26580 */ // Label 9: @26580
     /*  26580 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 549*/ GIMT_Encode4(35591),
     /*  26591 */ /*GILLT_s32*//*Label 540*/ GIMT_Encode4(26651),
     /*  26595 */ /*GILLT_s64*//*Label 541*/ GIMT_Encode4(26799), GIMT_Encode4(0),
     /*  26603 */ /*GILLT_v2s32*//*Label 542*/ GIMT_Encode4(27554),
     /*  26607 */ /*GILLT_v2s64*//*Label 543*/ GIMT_Encode4(28309), GIMT_Encode4(0),
     /*  26615 */ /*GILLT_v4s16*//*Label 544*/ GIMT_Encode4(30028),
     /*  26619 */ /*GILLT_v4s32*//*Label 545*/ GIMT_Encode4(30783), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26631 */ /*GILLT_v8s8*//*Label 546*/ GIMT_Encode4(32502),
     /*  26635 */ /*GILLT_v8s16*//*Label 547*/ GIMT_Encode4(32917), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26647 */ /*GILLT_v16s8*//*Label 548*/ GIMT_Encode4(34636),
     /*  26651 */ // Label 540: @26651
     /*  26651 */ GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(26798),
     /*  26656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26659 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(26693), // Rule ID 689 //
     /*  26664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  26667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26675 */     // (bitconvert:{ *:[i32] } SPR:{ *:[f32] }:$Sn)  =>  (VMOVRS:{ *:[i32] } SPR:{ *:[f32] }:$Sn)
     /*  26675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVRS),
     /*  26678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  26680 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /*  26682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26691 */     GIR_RootConstrainSelectedInstOperands,
     /*  26692 */     // GIR_Coverage, 689,
     /*  26692 */     GIR_EraseRootFromParent_Done,
     /*  26693 */   // Label 551: @26693
     /*  26693 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(26727), // Rule ID 690 //
     /*  26698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_UseVMOVSR),
     /*  26701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26709 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$Rt)  =>  (VMOVSR:{ *:[f32] } GPR:{ *:[i32] }:$Rt)
     /*  26709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVSR),
     /*  26712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sn]
     /*  26714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  26716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26719 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26725 */     GIR_RootConstrainSelectedInstOperands,
     /*  26726 */     // GIR_Coverage, 690,
     /*  26726 */     GIR_EraseRootFromParent_Done,
     /*  26727 */   // Label 552: @26727
     /*  26727 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(26797), // Rule ID 2715 //
     /*  26732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseVMOVSR_HasNEON),
     /*  26735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26743 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VMOVDRR:{ *:[f64] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$a), ssub_0:{ *:[i32] })
     /*  26743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  26746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VMOVDRR),
     /*  26750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26759 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26763 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26766 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26779 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  26786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  26791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /*  26796 */     // GIR_Coverage, 2715,
     /*  26796 */     GIR_EraseRootFromParent_Done,
     /*  26797 */   // Label 553: @26797
     /*  26797 */   GIM_Reject,
     /*  26798 */ // Label 550: @26798
     /*  26798 */ GIM_Reject,
     /*  26799 */ // Label 541: @26799
     /*  26799 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(26831), // Rule ID 2717 //
     /*  26804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26818 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26821 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26823 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26825 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26830 */   // GIR_Coverage, 2717,
     /*  26830 */   GIR_EraseRootFromParent_Done,
     /*  26831 */ // Label 554: @26831
     /*  26831 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(26863), // Rule ID 2718 //
     /*  26836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26850 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  26850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26853 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26855 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26857 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26862 */   // GIR_Coverage, 2718,
     /*  26862 */   GIR_EraseRootFromParent_Done,
     /*  26863 */ // Label 555: @26863
     /*  26863 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(26895), // Rule ID 2729 //
     /*  26868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26882 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26885 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26887 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26889 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26894 */   // GIR_Coverage, 2729,
     /*  26894 */   GIR_EraseRootFromParent_Done,
     /*  26895 */ // Label 556: @26895
     /*  26895 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(26927), // Rule ID 2730 //
     /*  26900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26914 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26917 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26919 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26921 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26926 */   // GIR_Coverage, 2730,
     /*  26926 */   GIR_EraseRootFromParent_Done,
     /*  26927 */ // Label 557: @26927
     /*  26927 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(26959), // Rule ID 2731 //
     /*  26932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26946 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26949 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26953 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26958 */   // GIR_Coverage, 2731,
     /*  26958 */   GIR_EraseRootFromParent_Done,
     /*  26959 */ // Label 558: @26959
     /*  26959 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(26991), // Rule ID 2732 //
     /*  26964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26978 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26981 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26983 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26990 */   // GIR_Coverage, 2732,
     /*  26990 */   GIR_EraseRootFromParent_Done,
     /*  26991 */ // Label 559: @26991
     /*  26991 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(27023), // Rule ID 2733 //
     /*  26996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27010 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  27010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27013 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27015 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27017 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27022 */   // GIR_Coverage, 2733,
     /*  27022 */   GIR_EraseRootFromParent_Done,
     /*  27023 */ // Label 560: @27023
     /*  27023 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(27055), // Rule ID 2734 //
     /*  27028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27042 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27045 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27047 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27049 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27054 */   // GIR_Coverage, 2734,
     /*  27054 */   GIR_EraseRootFromParent_Done,
     /*  27055 */ // Label 561: @27055
     /*  27055 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(27087), // Rule ID 2735 //
     /*  27060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27074 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27077 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27086 */   // GIR_Coverage, 2735,
     /*  27086 */   GIR_EraseRootFromParent_Done,
     /*  27087 */ // Label 562: @27087
     /*  27087 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(27119), // Rule ID 2736 //
     /*  27092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27106 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27109 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27111 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27113 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27118 */   // GIR_Coverage, 2736,
     /*  27118 */   GIR_EraseRootFromParent_Done,
     /*  27119 */ // Label 563: @27119
     /*  27119 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(27151), // Rule ID 2737 //
     /*  27124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27138 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27141 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27143 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27145 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27150 */   // GIR_Coverage, 2737,
     /*  27150 */   GIR_EraseRootFromParent_Done,
     /*  27151 */ // Label 564: @27151
     /*  27151 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(27183), // Rule ID 2738 //
     /*  27156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27170 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27173 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27175 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27177 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27182 */   // GIR_Coverage, 2738,
     /*  27182 */   GIR_EraseRootFromParent_Done,
     /*  27183 */ // Label 565: @27183
     /*  27183 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(27220), // Rule ID 2801 //
     /*  27188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27202 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2f32] }:$src)
     /*  27202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27207 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27212 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27218 */   GIR_RootConstrainSelectedInstOperands,
     /*  27219 */   // GIR_Coverage, 2801,
     /*  27219 */   GIR_EraseRootFromParent_Done,
     /*  27220 */ // Label 566: @27220
     /*  27220 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(27257), // Rule ID 2802 //
     /*  27225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27239 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2i32] }:$src)
     /*  27239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27244 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27249 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27255 */   GIR_RootConstrainSelectedInstOperands,
     /*  27256 */   // GIR_Coverage, 2802,
     /*  27256 */   GIR_EraseRootFromParent_Done,
     /*  27257 */ // Label 567: @27257
     /*  27257 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(27294), // Rule ID 2803 //
     /*  27262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27276 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4f16] }:$src)
     /*  27276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27281 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27286 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27292 */   GIR_RootConstrainSelectedInstOperands,
     /*  27293 */   // GIR_Coverage, 2803,
     /*  27293 */   GIR_EraseRootFromParent_Done,
     /*  27294 */ // Label 568: @27294
     /*  27294 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(27331), // Rule ID 2804 //
     /*  27299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27313 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4i16] }:$src)
     /*  27313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27318 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27323 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27329 */   GIR_RootConstrainSelectedInstOperands,
     /*  27330 */   // GIR_Coverage, 2804,
     /*  27330 */   GIR_EraseRootFromParent_Done,
     /*  27331 */ // Label 569: @27331
     /*  27331 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(27368), // Rule ID 2805 //
     /*  27336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27350 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[f64] } DPR:{ *:[v8i8] }:$src)
     /*  27350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27355 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27360 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27366 */   GIR_RootConstrainSelectedInstOperands,
     /*  27367 */   // GIR_Coverage, 2805,
     /*  27367 */   GIR_EraseRootFromParent_Done,
     /*  27368 */ // Label 570: @27368
     /*  27368 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(27405), // Rule ID 2806 //
     /*  27373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27387 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)
     /*  27387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27397 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27403 */   GIR_RootConstrainSelectedInstOperands,
     /*  27404 */   // GIR_Coverage, 2806,
     /*  27404 */   GIR_EraseRootFromParent_Done,
     /*  27405 */ // Label 571: @27405
     /*  27405 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(27442), // Rule ID 2807 //
     /*  27410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27424 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)
     /*  27424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27429 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27434 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27440 */   GIR_RootConstrainSelectedInstOperands,
     /*  27441 */   // GIR_Coverage, 2807,
     /*  27441 */   GIR_EraseRootFromParent_Done,
     /*  27442 */ // Label 572: @27442
     /*  27442 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(27479), // Rule ID 2808 //
     /*  27447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27461 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)
     /*  27461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27466 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27471 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27477 */   GIR_RootConstrainSelectedInstOperands,
     /*  27478 */   // GIR_Coverage, 2808,
     /*  27478 */   GIR_EraseRootFromParent_Done,
     /*  27479 */ // Label 573: @27479
     /*  27479 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(27516), // Rule ID 2809 //
     /*  27484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27498 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)
     /*  27498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27503 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27508 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27514 */   GIR_RootConstrainSelectedInstOperands,
     /*  27515 */   // GIR_Coverage, 2809,
     /*  27515 */   GIR_EraseRootFromParent_Done,
     /*  27516 */ // Label 574: @27516
     /*  27516 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(27553), // Rule ID 2810 //
     /*  27521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27535 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)
     /*  27535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27540 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27545 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27551 */   GIR_RootConstrainSelectedInstOperands,
     /*  27552 */   // GIR_Coverage, 2810,
     /*  27552 */   GIR_EraseRootFromParent_Done,
     /*  27553 */ // Label 575: @27553
     /*  27553 */ GIM_Reject,
     /*  27554 */ // Label 542: @27554
     /*  27554 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(27586), // Rule ID 2719 //
     /*  27559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27573 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27576 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27578 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27585 */   // GIR_Coverage, 2719,
     /*  27585 */   GIR_EraseRootFromParent_Done,
     /*  27586 */ // Label 576: @27586
     /*  27586 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(27618), // Rule ID 2720 //
     /*  27591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27605 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27608 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27610 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27617 */   // GIR_Coverage, 2720,
     /*  27617 */   GIR_EraseRootFromParent_Done,
     /*  27618 */ // Label 577: @27618
     /*  27618 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(27650), // Rule ID 2739 //
     /*  27623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27637 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27640 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27642 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27649 */   // GIR_Coverage, 2739,
     /*  27649 */   GIR_EraseRootFromParent_Done,
     /*  27650 */ // Label 578: @27650
     /*  27650 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(27682), // Rule ID 2740 //
     /*  27655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27669 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27672 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27674 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27676 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27681 */   // GIR_Coverage, 2740,
     /*  27681 */   GIR_EraseRootFromParent_Done,
     /*  27682 */ // Label 579: @27682
     /*  27682 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(27714), // Rule ID 2741 //
     /*  27687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27701 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27704 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27706 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27708 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27713 */   // GIR_Coverage, 2741,
     /*  27713 */   GIR_EraseRootFromParent_Done,
     /*  27714 */ // Label 580: @27714
     /*  27714 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(27746), // Rule ID 2742 //
     /*  27719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27733 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27736 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27738 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27740 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27745 */   // GIR_Coverage, 2742,
     /*  27745 */   GIR_EraseRootFromParent_Done,
     /*  27746 */ // Label 581: @27746
     /*  27746 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(27778), // Rule ID 2743 //
     /*  27751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27765 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27768 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27770 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27772 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27777 */   // GIR_Coverage, 2743,
     /*  27777 */   GIR_EraseRootFromParent_Done,
     /*  27778 */ // Label 582: @27778
     /*  27778 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(27810), // Rule ID 2744 //
     /*  27783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27797 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27800 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27802 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27804 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27809 */   // GIR_Coverage, 2744,
     /*  27809 */   GIR_EraseRootFromParent_Done,
     /*  27810 */ // Label 583: @27810
     /*  27810 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(27842), // Rule ID 2745 //
     /*  27815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27829 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27832 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27834 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27836 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27841 */   // GIR_Coverage, 2745,
     /*  27841 */   GIR_EraseRootFromParent_Done,
     /*  27842 */ // Label 584: @27842
     /*  27842 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(27874), // Rule ID 2746 //
     /*  27847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27861 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27864 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27866 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27868 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27873 */   // GIR_Coverage, 2746,
     /*  27873 */   GIR_EraseRootFromParent_Done,
     /*  27874 */ // Label 585: @27874
     /*  27874 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(27906), // Rule ID 2747 //
     /*  27879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27893 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27896 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27898 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27900 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27905 */   // GIR_Coverage, 2747,
     /*  27905 */   GIR_EraseRootFromParent_Done,
     /*  27906 */ // Label 586: @27906
     /*  27906 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(27938), // Rule ID 2748 //
     /*  27911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27925 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27928 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27930 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27932 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27937 */   // GIR_Coverage, 2748,
     /*  27937 */   GIR_EraseRootFromParent_Done,
     /*  27938 */ // Label 587: @27938
     /*  27938 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(27975), // Rule ID 2811 //
     /*  27943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27957 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[f64] }:$src)
     /*  27957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27962 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27967 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27973 */   GIR_RootConstrainSelectedInstOperands,
     /*  27974 */   // GIR_Coverage, 2811,
     /*  27974 */   GIR_EraseRootFromParent_Done,
     /*  27975 */ // Label 588: @27975
     /*  27975 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(28012), // Rule ID 2812 //
     /*  27980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27994 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)
     /*  27994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27999 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28004 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28010 */   GIR_RootConstrainSelectedInstOperands,
     /*  28011 */   // GIR_Coverage, 2812,
     /*  28011 */   GIR_EraseRootFromParent_Done,
     /*  28012 */ // Label 589: @28012
     /*  28012 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(28049), // Rule ID 2813 //
     /*  28017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28031 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)
     /*  28031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28036 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28041 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28047 */   GIR_RootConstrainSelectedInstOperands,
     /*  28048 */   // GIR_Coverage, 2813,
     /*  28048 */   GIR_EraseRootFromParent_Done,
     /*  28049 */ // Label 590: @28049
     /*  28049 */ GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(28086), // Rule ID 2814 //
     /*  28054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28068 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)
     /*  28068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28073 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28078 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28084 */   GIR_RootConstrainSelectedInstOperands,
     /*  28085 */   // GIR_Coverage, 2814,
     /*  28085 */   GIR_EraseRootFromParent_Done,
     /*  28086 */ // Label 591: @28086
     /*  28086 */ GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(28123), // Rule ID 2815 //
     /*  28091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28105 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)
     /*  28105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28110 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28115 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28121 */   GIR_RootConstrainSelectedInstOperands,
     /*  28122 */   // GIR_Coverage, 2815,
     /*  28122 */   GIR_EraseRootFromParent_Done,
     /*  28123 */ // Label 592: @28123
     /*  28123 */ GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(28160), // Rule ID 2816 //
     /*  28128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28142 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[f64] }:$src)
     /*  28142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28147 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28152 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28158 */   GIR_RootConstrainSelectedInstOperands,
     /*  28159 */   // GIR_Coverage, 2816,
     /*  28159 */   GIR_EraseRootFromParent_Done,
     /*  28160 */ // Label 593: @28160
     /*  28160 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(28197), // Rule ID 2817 //
     /*  28165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28179 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)
     /*  28179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28184 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28189 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28195 */   GIR_RootConstrainSelectedInstOperands,
     /*  28196 */   // GIR_Coverage, 2817,
     /*  28196 */   GIR_EraseRootFromParent_Done,
     /*  28197 */ // Label 594: @28197
     /*  28197 */ GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(28234), // Rule ID 2818 //
     /*  28202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28216 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)
     /*  28216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28221 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28226 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28232 */   GIR_RootConstrainSelectedInstOperands,
     /*  28233 */   // GIR_Coverage, 2818,
     /*  28233 */   GIR_EraseRootFromParent_Done,
     /*  28234 */ // Label 595: @28234
     /*  28234 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(28271), // Rule ID 2819 //
     /*  28239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28253 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)
     /*  28253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28258 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28263 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28269 */   GIR_RootConstrainSelectedInstOperands,
     /*  28270 */   // GIR_Coverage, 2819,
     /*  28270 */   GIR_EraseRootFromParent_Done,
     /*  28271 */ // Label 596: @28271
     /*  28271 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(28308), // Rule ID 2820 //
     /*  28276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28290 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)
     /*  28290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28295 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28300 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28306 */   GIR_RootConstrainSelectedInstOperands,
     /*  28307 */   // GIR_Coverage, 2820,
     /*  28307 */   GIR_EraseRootFromParent_Done,
     /*  28308 */ // Label 597: @28308
     /*  28308 */ GIM_Reject,
     /*  28309 */ // Label 543: @28309
     /*  28309 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(28341), // Rule ID 2723 //
     /*  28314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28328 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28331 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28333 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28335 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28340 */   // GIR_Coverage, 2723,
     /*  28340 */   GIR_EraseRootFromParent_Done,
     /*  28341 */ // Label 598: @28341
     /*  28341 */ GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(28373), // Rule ID 2724 //
     /*  28346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28360 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28363 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28365 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28367 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28372 */   // GIR_Coverage, 2724,
     /*  28372 */   GIR_EraseRootFromParent_Done,
     /*  28373 */ // Label 599: @28373
     /*  28373 */ GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(28405), // Rule ID 2765 //
     /*  28378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28392 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28395 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28397 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28404 */   // GIR_Coverage, 2765,
     /*  28404 */   GIR_EraseRootFromParent_Done,
     /*  28405 */ // Label 600: @28405
     /*  28405 */ GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(28437), // Rule ID 2766 //
     /*  28410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28424 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28427 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28429 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28436 */   // GIR_Coverage, 2766,
     /*  28436 */   GIR_EraseRootFromParent_Done,
     /*  28437 */ // Label 601: @28437
     /*  28437 */ GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(28469), // Rule ID 2767 //
     /*  28442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28456 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28459 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28463 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28468 */   // GIR_Coverage, 2767,
     /*  28468 */   GIR_EraseRootFromParent_Done,
     /*  28469 */ // Label 602: @28469
     /*  28469 */ GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(28501), // Rule ID 2768 //
     /*  28474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28488 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28491 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28493 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28495 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28500 */   // GIR_Coverage, 2768,
     /*  28500 */   GIR_EraseRootFromParent_Done,
     /*  28501 */ // Label 603: @28501
     /*  28501 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(28533), // Rule ID 2769 //
     /*  28506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28520 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28523 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28525 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28532 */   // GIR_Coverage, 2769,
     /*  28532 */   GIR_EraseRootFromParent_Done,
     /*  28533 */ // Label 604: @28533
     /*  28533 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(28565), // Rule ID 2770 //
     /*  28538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28552 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28555 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28557 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28559 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28564 */   // GIR_Coverage, 2770,
     /*  28564 */   GIR_EraseRootFromParent_Done,
     /*  28565 */ // Label 605: @28565
     /*  28565 */ GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(28597), // Rule ID 2771 //
     /*  28570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28584 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28587 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28589 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28591 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28596 */   // GIR_Coverage, 2771,
     /*  28596 */   GIR_EraseRootFromParent_Done,
     /*  28597 */ // Label 606: @28597
     /*  28597 */ GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(28629), // Rule ID 2772 //
     /*  28602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28616 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28619 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28621 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28623 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28628 */   // GIR_Coverage, 2772,
     /*  28628 */   GIR_EraseRootFromParent_Done,
     /*  28629 */ // Label 607: @28629
     /*  28629 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(28661), // Rule ID 2773 //
     /*  28634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28648 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28651 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28653 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28655 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28660 */   // GIR_Coverage, 2773,
     /*  28660 */   GIR_EraseRootFromParent_Done,
     /*  28661 */ // Label 608: @28661
     /*  28661 */ GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(28693), // Rule ID 2774 //
     /*  28666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28680 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28683 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28685 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28687 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28692 */   // GIR_Coverage, 2774,
     /*  28692 */   GIR_EraseRootFromParent_Done,
     /*  28693 */ // Label 609: @28693
     /*  28693 */ GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(28730), // Rule ID 2837 //
     /*  28698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28712 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)
     /*  28712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28717 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28722 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28728 */   GIR_RootConstrainSelectedInstOperands,
     /*  28729 */   // GIR_Coverage, 2837,
     /*  28729 */   GIR_EraseRootFromParent_Done,
     /*  28730 */ // Label 610: @28730
     /*  28730 */ GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(28767), // Rule ID 2838 //
     /*  28735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28749 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)
     /*  28749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28754 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28759 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28765 */   GIR_RootConstrainSelectedInstOperands,
     /*  28766 */   // GIR_Coverage, 2838,
     /*  28766 */   GIR_EraseRootFromParent_Done,
     /*  28767 */ // Label 611: @28767
     /*  28767 */ GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(28804), // Rule ID 2839 //
     /*  28772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28786 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)
     /*  28786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28791 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28796 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28802 */   GIR_RootConstrainSelectedInstOperands,
     /*  28803 */   // GIR_Coverage, 2839,
     /*  28803 */   GIR_EraseRootFromParent_Done,
     /*  28804 */ // Label 612: @28804
     /*  28804 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(28841), // Rule ID 2840 //
     /*  28809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28823 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)
     /*  28823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28828 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28833 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28839 */   GIR_RootConstrainSelectedInstOperands,
     /*  28840 */   // GIR_Coverage, 2840,
     /*  28840 */   GIR_EraseRootFromParent_Done,
     /*  28841 */ // Label 613: @28841
     /*  28841 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(28878), // Rule ID 2841 //
     /*  28846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28860 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)
     /*  28860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  28863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28865 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28870 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28876 */   GIR_RootConstrainSelectedInstOperands,
     /*  28877 */   // GIR_Coverage, 2841,
     /*  28877 */   GIR_EraseRootFromParent_Done,
     /*  28878 */ // Label 614: @28878
     /*  28878 */ GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(28915), // Rule ID 2842 //
     /*  28883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28897 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)
     /*  28897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28902 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28907 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28913 */   GIR_RootConstrainSelectedInstOperands,
     /*  28914 */   // GIR_Coverage, 2842,
     /*  28914 */   GIR_EraseRootFromParent_Done,
     /*  28915 */ // Label 615: @28915
     /*  28915 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(28952), // Rule ID 2843 //
     /*  28920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28934 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)
     /*  28934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28944 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28950 */   GIR_RootConstrainSelectedInstOperands,
     /*  28951 */   // GIR_Coverage, 2843,
     /*  28951 */   GIR_EraseRootFromParent_Done,
     /*  28952 */ // Label 616: @28952
     /*  28952 */ GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(28989), // Rule ID 2844 //
     /*  28957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28971 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)
     /*  28971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28976 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28981 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28987 */   GIR_RootConstrainSelectedInstOperands,
     /*  28988 */   // GIR_Coverage, 2844,
     /*  28988 */   GIR_EraseRootFromParent_Done,
     /*  28989 */ // Label 617: @28989
     /*  28989 */ GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(29026), // Rule ID 2845 //
     /*  28994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29008 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)
     /*  29008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  29011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29013 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29018 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29024 */   GIR_RootConstrainSelectedInstOperands,
     /*  29025 */   // GIR_Coverage, 2845,
     /*  29025 */   GIR_EraseRootFromParent_Done,
     /*  29026 */ // Label 618: @29026
     /*  29026 */ GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(29063), // Rule ID 2846 //
     /*  29031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  29034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29045 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)
     /*  29045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  29048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29050 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29055 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29061 */   GIR_RootConstrainSelectedInstOperands,
     /*  29062 */   // GIR_Coverage, 2846,
     /*  29062 */   GIR_EraseRootFromParent_Done,
     /*  29063 */ // Label 619: @29063
     /*  29063 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(29095), // Rule ID 5280 //
     /*  29068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29082 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29085 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29087 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29089 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29094 */   // GIR_Coverage, 5280,
     /*  29094 */   GIR_EraseRootFromParent_Done,
     /*  29095 */ // Label 620: @29095
     /*  29095 */ GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(29127), // Rule ID 5281 //
     /*  29100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29114 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29117 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29119 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29121 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29126 */   // GIR_Coverage, 5281,
     /*  29126 */   GIR_EraseRootFromParent_Done,
     /*  29127 */ // Label 621: @29127
     /*  29127 */ GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(29159), // Rule ID 5286 //
     /*  29132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29146 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29149 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29151 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29153 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29158 */   // GIR_Coverage, 5286,
     /*  29158 */   GIR_EraseRootFromParent_Done,
     /*  29159 */ // Label 622: @29159
     /*  29159 */ GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(29191), // Rule ID 5287 //
     /*  29164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29178 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29181 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29183 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29185 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29190 */   // GIR_Coverage, 5287,
     /*  29190 */   GIR_EraseRootFromParent_Done,
     /*  29191 */ // Label 623: @29191
     /*  29191 */ GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(29223), // Rule ID 5288 //
     /*  29196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29210 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29213 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29215 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29217 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29222 */   // GIR_Coverage, 5288,
     /*  29222 */   GIR_EraseRootFromParent_Done,
     /*  29223 */ // Label 624: @29223
     /*  29223 */ GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(29255), // Rule ID 5289 //
     /*  29228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29242 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29245 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29247 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29249 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29254 */   // GIR_Coverage, 5289,
     /*  29254 */   GIR_EraseRootFromParent_Done,
     /*  29255 */ // Label 625: @29255
     /*  29255 */ GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(29287), // Rule ID 5290 //
     /*  29260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29274 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29277 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29279 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29281 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29286 */   // GIR_Coverage, 5290,
     /*  29286 */   GIR_EraseRootFromParent_Done,
     /*  29287 */ // Label 626: @29287
     /*  29287 */ GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(29319), // Rule ID 5291 //
     /*  29292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29306 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29309 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29311 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29313 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29318 */   // GIR_Coverage, 5291,
     /*  29318 */   GIR_EraseRootFromParent_Done,
     /*  29319 */ // Label 627: @29319
     /*  29319 */ GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(29351), // Rule ID 5292 //
     /*  29324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29338 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29341 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29343 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29345 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29350 */   // GIR_Coverage, 5292,
     /*  29350 */   GIR_EraseRootFromParent_Done,
     /*  29351 */ // Label 628: @29351
     /*  29351 */ GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(29383), // Rule ID 5293 //
     /*  29356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29370 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29373 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29375 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29377 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29382 */   // GIR_Coverage, 5293,
     /*  29382 */   GIR_EraseRootFromParent_Done,
     /*  29383 */ // Label 629: @29383
     /*  29383 */ GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(29415), // Rule ID 5294 //
     /*  29388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29402 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29405 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29407 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29409 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29414 */   // GIR_Coverage, 5294,
     /*  29414 */   GIR_EraseRootFromParent_Done,
     /*  29415 */ // Label 630: @29415
     /*  29415 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(29447), // Rule ID 5295 //
     /*  29420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29434 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29437 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29439 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29441 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29446 */   // GIR_Coverage, 5295,
     /*  29446 */   GIR_EraseRootFromParent_Done,
     /*  29447 */ // Label 631: @29447
     /*  29447 */ GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(29505), // Rule ID 5322 //
     /*  29452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29466 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)
     /*  29466 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29469 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29473 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29483 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29488 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29494 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29503 */   GIR_RootConstrainSelectedInstOperands,
     /*  29504 */   // GIR_Coverage, 5322,
     /*  29504 */   GIR_EraseRootFromParent_Done,
     /*  29505 */ // Label 632: @29505
     /*  29505 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(29563), // Rule ID 5323 //
     /*  29510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29524 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)
     /*  29524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29541 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29546 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29552 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29558 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29561 */   GIR_RootConstrainSelectedInstOperands,
     /*  29562 */   // GIR_Coverage, 5323,
     /*  29562 */   GIR_EraseRootFromParent_Done,
     /*  29563 */ // Label 633: @29563
     /*  29563 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(29621), // Rule ID 5324 //
     /*  29568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29582 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)
     /*  29582 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29585 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29589 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29599 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29604 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29610 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29619 */   GIR_RootConstrainSelectedInstOperands,
     /*  29620 */   // GIR_Coverage, 5324,
     /*  29620 */   GIR_EraseRootFromParent_Done,
     /*  29621 */ // Label 634: @29621
     /*  29621 */ GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(29679), // Rule ID 5325 //
     /*  29626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29640 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)
     /*  29640 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29643 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29647 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29657 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29662 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29668 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29674 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29677 */   GIR_RootConstrainSelectedInstOperands,
     /*  29678 */   // GIR_Coverage, 5325,
     /*  29678 */   GIR_EraseRootFromParent_Done,
     /*  29679 */ // Label 635: @29679
     /*  29679 */ GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(29737), // Rule ID 5326 //
     /*  29684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29698 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)
     /*  29698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29715 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29720 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29726 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29732 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29735 */   GIR_RootConstrainSelectedInstOperands,
     /*  29736 */   // GIR_Coverage, 5326,
     /*  29736 */   GIR_EraseRootFromParent_Done,
     /*  29737 */ // Label 636: @29737
     /*  29737 */ GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(29795), // Rule ID 5327 //
     /*  29742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29756 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)
     /*  29756 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29763 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29778 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29784 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29790 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29793 */   GIR_RootConstrainSelectedInstOperands,
     /*  29794 */   // GIR_Coverage, 5327,
     /*  29794 */   GIR_EraseRootFromParent_Done,
     /*  29795 */ // Label 637: @29795
     /*  29795 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(29853), // Rule ID 5328 //
     /*  29800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29814 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)
     /*  29814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29831 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29836 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29842 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29848 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29851 */   GIR_RootConstrainSelectedInstOperands,
     /*  29852 */   // GIR_Coverage, 5328,
     /*  29852 */   GIR_EraseRootFromParent_Done,
     /*  29853 */ // Label 638: @29853
     /*  29853 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(29911), // Rule ID 5329 //
     /*  29858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29872 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)
     /*  29872 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29875 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29879 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29889 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29894 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29900 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29906 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29909 */   GIR_RootConstrainSelectedInstOperands,
     /*  29910 */   // GIR_Coverage, 5329,
     /*  29910 */   GIR_EraseRootFromParent_Done,
     /*  29911 */ // Label 639: @29911
     /*  29911 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(29969), // Rule ID 5330 //
     /*  29916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29930 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)
     /*  29930 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29933 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29937 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29947 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29952 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29958 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29964 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29967 */   GIR_RootConstrainSelectedInstOperands,
     /*  29968 */   // GIR_Coverage, 5330,
     /*  29968 */   GIR_EraseRootFromParent_Done,
     /*  29969 */ // Label 640: @29969
     /*  29969 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(30027), // Rule ID 5331 //
     /*  29974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29988 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)
     /*  29988 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29991 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29995 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  30003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  30005 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  30010 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30016 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30022 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30025 */   GIR_RootConstrainSelectedInstOperands,
     /*  30026 */   // GIR_Coverage, 5331,
     /*  30026 */   GIR_EraseRootFromParent_Done,
     /*  30027 */ // Label 641: @30027
     /*  30027 */ GIM_Reject,
     /*  30028 */ // Label 544: @30028
     /*  30028 */ GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(30060), // Rule ID 2721 //
     /*  30033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30047 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30050 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30052 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30054 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30059 */   // GIR_Coverage, 2721,
     /*  30059 */   GIR_EraseRootFromParent_Done,
     /*  30060 */ // Label 642: @30060
     /*  30060 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(30092), // Rule ID 2722 //
     /*  30065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30079 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30082 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30084 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30086 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30091 */   // GIR_Coverage, 2722,
     /*  30091 */   GIR_EraseRootFromParent_Done,
     /*  30092 */ // Label 643: @30092
     /*  30092 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(30124), // Rule ID 2749 //
     /*  30097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30111 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30114 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30116 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30118 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30123 */   // GIR_Coverage, 2749,
     /*  30123 */   GIR_EraseRootFromParent_Done,
     /*  30124 */ // Label 644: @30124
     /*  30124 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(30156), // Rule ID 2750 //
     /*  30129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30143 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30146 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30148 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30150 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30155 */   // GIR_Coverage, 2750,
     /*  30155 */   GIR_EraseRootFromParent_Done,
     /*  30156 */ // Label 645: @30156
     /*  30156 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(30188), // Rule ID 2751 //
     /*  30161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30175 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30178 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30180 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30182 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30187 */   // GIR_Coverage, 2751,
     /*  30187 */   GIR_EraseRootFromParent_Done,
     /*  30188 */ // Label 646: @30188
     /*  30188 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(30220), // Rule ID 2752 //
     /*  30193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30207 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30210 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30212 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30214 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30219 */   // GIR_Coverage, 2752,
     /*  30219 */   GIR_EraseRootFromParent_Done,
     /*  30220 */ // Label 647: @30220
     /*  30220 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(30252), // Rule ID 2753 //
     /*  30225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30239 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30242 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30244 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30246 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30251 */   // GIR_Coverage, 2753,
     /*  30251 */   GIR_EraseRootFromParent_Done,
     /*  30252 */ // Label 648: @30252
     /*  30252 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(30284), // Rule ID 2754 //
     /*  30257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30271 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30274 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30276 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30278 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30283 */   // GIR_Coverage, 2754,
     /*  30283 */   GIR_EraseRootFromParent_Done,
     /*  30284 */ // Label 649: @30284
     /*  30284 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(30316), // Rule ID 2755 //
     /*  30289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30303 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30306 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30308 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30310 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30315 */   // GIR_Coverage, 2755,
     /*  30315 */   GIR_EraseRootFromParent_Done,
     /*  30316 */ // Label 650: @30316
     /*  30316 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(30348), // Rule ID 2756 //
     /*  30321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30335 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30338 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30340 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30342 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30347 */   // GIR_Coverage, 2756,
     /*  30347 */   GIR_EraseRootFromParent_Done,
     /*  30348 */ // Label 651: @30348
     /*  30348 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(30380), // Rule ID 2757 //
     /*  30353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30367 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30370 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30372 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30374 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30379 */   // GIR_Coverage, 2757,
     /*  30379 */   GIR_EraseRootFromParent_Done,
     /*  30380 */ // Label 652: @30380
     /*  30380 */ GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(30412), // Rule ID 2758 //
     /*  30385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30399 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30402 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30404 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30406 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30411 */   // GIR_Coverage, 2758,
     /*  30411 */   GIR_EraseRootFromParent_Done,
     /*  30412 */ // Label 653: @30412
     /*  30412 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(30449), // Rule ID 2821 //
     /*  30417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30431 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[f64] }:$src)
     /*  30431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30436 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30441 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30447 */   GIR_RootConstrainSelectedInstOperands,
     /*  30448 */   // GIR_Coverage, 2821,
     /*  30448 */   GIR_EraseRootFromParent_Done,
     /*  30449 */ // Label 654: @30449
     /*  30449 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(30486), // Rule ID 2822 //
     /*  30454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30468 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)
     /*  30468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30473 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30478 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30484 */   GIR_RootConstrainSelectedInstOperands,
     /*  30485 */   // GIR_Coverage, 2822,
     /*  30485 */   GIR_EraseRootFromParent_Done,
     /*  30486 */ // Label 655: @30486
     /*  30486 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(30523), // Rule ID 2823 //
     /*  30491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30505 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)
     /*  30505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30510 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30515 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30521 */   GIR_RootConstrainSelectedInstOperands,
     /*  30522 */   // GIR_Coverage, 2823,
     /*  30522 */   GIR_EraseRootFromParent_Done,
     /*  30523 */ // Label 656: @30523
     /*  30523 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(30560), // Rule ID 2824 //
     /*  30528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30542 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)
     /*  30542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30552 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30558 */   GIR_RootConstrainSelectedInstOperands,
     /*  30559 */   // GIR_Coverage, 2824,
     /*  30559 */   GIR_EraseRootFromParent_Done,
     /*  30560 */ // Label 657: @30560
     /*  30560 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(30597), // Rule ID 2825 //
     /*  30565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30579 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)
     /*  30579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30584 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30589 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30595 */   GIR_RootConstrainSelectedInstOperands,
     /*  30596 */   // GIR_Coverage, 2825,
     /*  30596 */   GIR_EraseRootFromParent_Done,
     /*  30597 */ // Label 658: @30597
     /*  30597 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(30634), // Rule ID 2826 //
     /*  30602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30616 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[f64] }:$src)
     /*  30616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30621 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30626 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30632 */   GIR_RootConstrainSelectedInstOperands,
     /*  30633 */   // GIR_Coverage, 2826,
     /*  30633 */   GIR_EraseRootFromParent_Done,
     /*  30634 */ // Label 659: @30634
     /*  30634 */ GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(30671), // Rule ID 2827 //
     /*  30639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30653 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)
     /*  30653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30658 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30663 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30669 */   GIR_RootConstrainSelectedInstOperands,
     /*  30670 */   // GIR_Coverage, 2827,
     /*  30670 */   GIR_EraseRootFromParent_Done,
     /*  30671 */ // Label 660: @30671
     /*  30671 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(30708), // Rule ID 2828 //
     /*  30676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30690 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)
     /*  30690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30695 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30700 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30706 */   GIR_RootConstrainSelectedInstOperands,
     /*  30707 */   // GIR_Coverage, 2828,
     /*  30707 */   GIR_EraseRootFromParent_Done,
     /*  30708 */ // Label 661: @30708
     /*  30708 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(30745), // Rule ID 2829 //
     /*  30713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30727 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)
     /*  30727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30732 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30737 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30743 */   GIR_RootConstrainSelectedInstOperands,
     /*  30744 */   // GIR_Coverage, 2829,
     /*  30744 */   GIR_EraseRootFromParent_Done,
     /*  30745 */ // Label 662: @30745
     /*  30745 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(30782), // Rule ID 2830 //
     /*  30750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30764 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)
     /*  30764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30769 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30774 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30780 */   GIR_RootConstrainSelectedInstOperands,
     /*  30781 */   // GIR_Coverage, 2830,
     /*  30781 */   GIR_EraseRootFromParent_Done,
     /*  30782 */ // Label 663: @30782
     /*  30782 */ GIM_Reject,
     /*  30783 */ // Label 545: @30783
     /*  30783 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(30815), // Rule ID 2725 //
     /*  30788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30802 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  30802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30805 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30807 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30809 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30814 */   // GIR_Coverage, 2725,
     /*  30814 */   GIR_EraseRootFromParent_Done,
     /*  30815 */ // Label 664: @30815
     /*  30815 */ GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(30847), // Rule ID 2726 //
     /*  30820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30834 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30837 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30839 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30841 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30846 */   // GIR_Coverage, 2726,
     /*  30846 */   GIR_EraseRootFromParent_Done,
     /*  30847 */ // Label 665: @30847
     /*  30847 */ GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(30879), // Rule ID 2775 //
     /*  30852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30866 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30869 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30871 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30873 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30878 */   // GIR_Coverage, 2775,
     /*  30878 */   GIR_EraseRootFromParent_Done,
     /*  30879 */ // Label 666: @30879
     /*  30879 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(30911), // Rule ID 2776 //
     /*  30884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30898 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30901 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30903 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30905 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30910 */   // GIR_Coverage, 2776,
     /*  30910 */   GIR_EraseRootFromParent_Done,
     /*  30911 */ // Label 667: @30911
     /*  30911 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(30943), // Rule ID 2777 //
     /*  30916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30930 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30933 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30937 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30942 */   // GIR_Coverage, 2777,
     /*  30942 */   GIR_EraseRootFromParent_Done,
     /*  30943 */ // Label 668: @30943
     /*  30943 */ GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(30975), // Rule ID 2778 //
     /*  30948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30962 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30965 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30967 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30969 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30974 */   // GIR_Coverage, 2778,
     /*  30974 */   GIR_EraseRootFromParent_Done,
     /*  30975 */ // Label 669: @30975
     /*  30975 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(31007), // Rule ID 2779 //
     /*  30980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30994 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30997 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30999 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31001 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31006 */   // GIR_Coverage, 2779,
     /*  31006 */   GIR_EraseRootFromParent_Done,
     /*  31007 */ // Label 670: @31007
     /*  31007 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(31039), // Rule ID 2780 //
     /*  31012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31026 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31029 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31031 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31033 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31038 */   // GIR_Coverage, 2780,
     /*  31038 */   GIR_EraseRootFromParent_Done,
     /*  31039 */ // Label 671: @31039
     /*  31039 */ GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(31071), // Rule ID 2781 //
     /*  31044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31058 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31061 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31063 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31070 */   // GIR_Coverage, 2781,
     /*  31070 */   GIR_EraseRootFromParent_Done,
     /*  31071 */ // Label 672: @31071
     /*  31071 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(31103), // Rule ID 2782 //
     /*  31076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31090 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31093 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31095 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31097 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31102 */   // GIR_Coverage, 2782,
     /*  31102 */   GIR_EraseRootFromParent_Done,
     /*  31103 */ // Label 673: @31103
     /*  31103 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(31135), // Rule ID 2783 //
     /*  31108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31122 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31134 */   // GIR_Coverage, 2783,
     /*  31134 */   GIR_EraseRootFromParent_Done,
     /*  31135 */ // Label 674: @31135
     /*  31135 */ GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(31167), // Rule ID 2784 //
     /*  31140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31154 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31157 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31159 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31166 */   // GIR_Coverage, 2784,
     /*  31166 */   GIR_EraseRootFromParent_Done,
     /*  31167 */ // Label 675: @31167
     /*  31167 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(31204), // Rule ID 2847 //
     /*  31172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31186 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)
     /*  31186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31191 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31196 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31202 */   GIR_RootConstrainSelectedInstOperands,
     /*  31203 */   // GIR_Coverage, 2847,
     /*  31203 */   GIR_EraseRootFromParent_Done,
     /*  31204 */ // Label 676: @31204
     /*  31204 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(31241), // Rule ID 2848 //
     /*  31209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31223 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)
     /*  31223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31228 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31233 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31239 */   GIR_RootConstrainSelectedInstOperands,
     /*  31240 */   // GIR_Coverage, 2848,
     /*  31240 */   GIR_EraseRootFromParent_Done,
     /*  31241 */ // Label 677: @31241
     /*  31241 */ GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(31278), // Rule ID 2849 //
     /*  31246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31260 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)
     /*  31260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31265 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31270 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31276 */   GIR_RootConstrainSelectedInstOperands,
     /*  31277 */   // GIR_Coverage, 2849,
     /*  31277 */   GIR_EraseRootFromParent_Done,
     /*  31278 */ // Label 678: @31278
     /*  31278 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(31315), // Rule ID 2850 //
     /*  31283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31297 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)
     /*  31297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31302 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31307 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31313 */   GIR_RootConstrainSelectedInstOperands,
     /*  31314 */   // GIR_Coverage, 2850,
     /*  31314 */   GIR_EraseRootFromParent_Done,
     /*  31315 */ // Label 679: @31315
     /*  31315 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(31352), // Rule ID 2851 //
     /*  31320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31334 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)
     /*  31334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31339 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31344 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31350 */   GIR_RootConstrainSelectedInstOperands,
     /*  31351 */   // GIR_Coverage, 2851,
     /*  31351 */   GIR_EraseRootFromParent_Done,
     /*  31352 */ // Label 680: @31352
     /*  31352 */ GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(31389), // Rule ID 2852 //
     /*  31357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31371 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)
     /*  31371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31376 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31381 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31387 */   GIR_RootConstrainSelectedInstOperands,
     /*  31388 */   // GIR_Coverage, 2852,
     /*  31388 */   GIR_EraseRootFromParent_Done,
     /*  31389 */ // Label 681: @31389
     /*  31389 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(31426), // Rule ID 2853 //
     /*  31394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31408 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)
     /*  31408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31413 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31418 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31424 */   GIR_RootConstrainSelectedInstOperands,
     /*  31425 */   // GIR_Coverage, 2853,
     /*  31425 */   GIR_EraseRootFromParent_Done,
     /*  31426 */ // Label 682: @31426
     /*  31426 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(31463), // Rule ID 2854 //
     /*  31431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31445 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)
     /*  31445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31450 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31455 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31461 */   GIR_RootConstrainSelectedInstOperands,
     /*  31462 */   // GIR_Coverage, 2854,
     /*  31462 */   GIR_EraseRootFromParent_Done,
     /*  31463 */ // Label 683: @31463
     /*  31463 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(31500), // Rule ID 2855 //
     /*  31468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31482 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)
     /*  31482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31487 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31492 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31498 */   GIR_RootConstrainSelectedInstOperands,
     /*  31499 */   // GIR_Coverage, 2855,
     /*  31499 */   GIR_EraseRootFromParent_Done,
     /*  31500 */ // Label 684: @31500
     /*  31500 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(31537), // Rule ID 2856 //
     /*  31505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31519 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)
     /*  31519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31524 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31529 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31535 */   GIR_RootConstrainSelectedInstOperands,
     /*  31536 */   // GIR_Coverage, 2856,
     /*  31536 */   GIR_EraseRootFromParent_Done,
     /*  31537 */ // Label 685: @31537
     /*  31537 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(31569), // Rule ID 5282 //
     /*  31542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31556 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31559 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31561 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31563 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31568 */   // GIR_Coverage, 5282,
     /*  31568 */   GIR_EraseRootFromParent_Done,
     /*  31569 */ // Label 686: @31569
     /*  31569 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(31601), // Rule ID 5283 //
     /*  31574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31588 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31591 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31593 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31595 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31600 */   // GIR_Coverage, 5283,
     /*  31600 */   GIR_EraseRootFromParent_Done,
     /*  31601 */ // Label 687: @31601
     /*  31601 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(31633), // Rule ID 5296 //
     /*  31606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31620 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31623 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31625 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31627 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31632 */   // GIR_Coverage, 5296,
     /*  31632 */   GIR_EraseRootFromParent_Done,
     /*  31633 */ // Label 688: @31633
     /*  31633 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(31665), // Rule ID 5297 //
     /*  31638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31652 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31655 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31657 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31659 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31664 */   // GIR_Coverage, 5297,
     /*  31664 */   GIR_EraseRootFromParent_Done,
     /*  31665 */ // Label 689: @31665
     /*  31665 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(31697), // Rule ID 5298 //
     /*  31670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31684 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31687 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31689 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31691 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31696 */   // GIR_Coverage, 5298,
     /*  31696 */   GIR_EraseRootFromParent_Done,
     /*  31697 */ // Label 690: @31697
     /*  31697 */ GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(31729), // Rule ID 5299 //
     /*  31702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31716 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31719 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31721 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31723 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31728 */   // GIR_Coverage, 5299,
     /*  31728 */   GIR_EraseRootFromParent_Done,
     /*  31729 */ // Label 691: @31729
     /*  31729 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(31761), // Rule ID 5300 //
     /*  31734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31748 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31751 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31753 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31760 */   // GIR_Coverage, 5300,
     /*  31760 */   GIR_EraseRootFromParent_Done,
     /*  31761 */ // Label 692: @31761
     /*  31761 */ GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(31793), // Rule ID 5301 //
     /*  31766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31780 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31783 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31785 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31792 */   // GIR_Coverage, 5301,
     /*  31792 */   GIR_EraseRootFromParent_Done,
     /*  31793 */ // Label 693: @31793
     /*  31793 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(31825), // Rule ID 5302 //
     /*  31798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31812 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31815 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31819 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31824 */   // GIR_Coverage, 5302,
     /*  31824 */   GIR_EraseRootFromParent_Done,
     /*  31825 */ // Label 694: @31825
     /*  31825 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(31857), // Rule ID 5303 //
     /*  31830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31844 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31847 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31849 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31856 */   // GIR_Coverage, 5303,
     /*  31856 */   GIR_EraseRootFromParent_Done,
     /*  31857 */ // Label 695: @31857
     /*  31857 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(31889), // Rule ID 5304 //
     /*  31862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31876 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31879 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31881 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31888 */   // GIR_Coverage, 5304,
     /*  31888 */   GIR_EraseRootFromParent_Done,
     /*  31889 */ // Label 696: @31889
     /*  31889 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(31921), // Rule ID 5305 //
     /*  31894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31908 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31911 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31913 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31920 */   // GIR_Coverage, 5305,
     /*  31920 */   GIR_EraseRootFromParent_Done,
     /*  31921 */ // Label 697: @31921
     /*  31921 */ GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(31979), // Rule ID 5332 //
     /*  31926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31940 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)
     /*  31940 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31943 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31947 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  31955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  31957 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31962 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31968 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31974 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  31977 */   GIR_RootConstrainSelectedInstOperands,
     /*  31978 */   // GIR_Coverage, 5332,
     /*  31978 */   GIR_EraseRootFromParent_Done,
     /*  31979 */ // Label 698: @31979
     /*  31979 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(32037), // Rule ID 5333 //
     /*  31984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31998 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)
     /*  31998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32015 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32020 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32026 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32032 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32035 */   GIR_RootConstrainSelectedInstOperands,
     /*  32036 */   // GIR_Coverage, 5333,
     /*  32036 */   GIR_EraseRootFromParent_Done,
     /*  32037 */ // Label 699: @32037
     /*  32037 */ GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(32095), // Rule ID 5334 //
     /*  32042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32056 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)
     /*  32056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32073 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32078 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32084 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32093 */   GIR_RootConstrainSelectedInstOperands,
     /*  32094 */   // GIR_Coverage, 5334,
     /*  32094 */   GIR_EraseRootFromParent_Done,
     /*  32095 */ // Label 700: @32095
     /*  32095 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(32153), // Rule ID 5335 //
     /*  32100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32114 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)
     /*  32114 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32117 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32121 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32131 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32136 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32142 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32148 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32151 */   GIR_RootConstrainSelectedInstOperands,
     /*  32152 */   // GIR_Coverage, 5335,
     /*  32152 */   GIR_EraseRootFromParent_Done,
     /*  32153 */ // Label 701: @32153
     /*  32153 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(32211), // Rule ID 5336 //
     /*  32158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32172 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)
     /*  32172 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32175 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32179 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32189 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32194 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32206 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32209 */   GIR_RootConstrainSelectedInstOperands,
     /*  32210 */   // GIR_Coverage, 5336,
     /*  32210 */   GIR_EraseRootFromParent_Done,
     /*  32211 */ // Label 702: @32211
     /*  32211 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(32269), // Rule ID 5337 //
     /*  32216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32230 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)
     /*  32230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32247 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32252 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32267 */   GIR_RootConstrainSelectedInstOperands,
     /*  32268 */   // GIR_Coverage, 5337,
     /*  32268 */   GIR_EraseRootFromParent_Done,
     /*  32269 */ // Label 703: @32269
     /*  32269 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(32327), // Rule ID 5338 //
     /*  32274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32288 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)
     /*  32288 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32291 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32295 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32305 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32310 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32316 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32325 */   GIR_RootConstrainSelectedInstOperands,
     /*  32326 */   // GIR_Coverage, 5338,
     /*  32326 */   GIR_EraseRootFromParent_Done,
     /*  32327 */ // Label 704: @32327
     /*  32327 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(32385), // Rule ID 5339 //
     /*  32332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32346 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)
     /*  32346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32363 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32368 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32374 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32383 */   GIR_RootConstrainSelectedInstOperands,
     /*  32384 */   // GIR_Coverage, 5339,
     /*  32384 */   GIR_EraseRootFromParent_Done,
     /*  32385 */ // Label 705: @32385
     /*  32385 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(32443), // Rule ID 5340 //
     /*  32390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32404 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  32404 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32407 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32411 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32421 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32426 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32432 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32438 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32441 */   GIR_RootConstrainSelectedInstOperands,
     /*  32442 */   // GIR_Coverage, 5340,
     /*  32442 */   GIR_EraseRootFromParent_Done,
     /*  32443 */ // Label 706: @32443
     /*  32443 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(32501), // Rule ID 5341 //
     /*  32448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32462 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)
     /*  32462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32479 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32484 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32490 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32496 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32499 */   GIR_RootConstrainSelectedInstOperands,
     /*  32500 */   // GIR_Coverage, 5341,
     /*  32500 */   GIR_EraseRootFromParent_Done,
     /*  32501 */ // Label 707: @32501
     /*  32501 */ GIM_Reject,
     /*  32502 */ // Label 546: @32502
     /*  32502 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(32534), // Rule ID 2759 //
     /*  32507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32521 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32524 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32526 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32528 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32533 */   // GIR_Coverage, 2759,
     /*  32533 */   GIR_EraseRootFromParent_Done,
     /*  32534 */ // Label 708: @32534
     /*  32534 */ GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(32566), // Rule ID 2760 //
     /*  32539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32553 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32556 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32558 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32560 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32565 */   // GIR_Coverage, 2760,
     /*  32565 */   GIR_EraseRootFromParent_Done,
     /*  32566 */ // Label 709: @32566
     /*  32566 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(32598), // Rule ID 2761 //
     /*  32571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32585 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32588 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32590 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32597 */   // GIR_Coverage, 2761,
     /*  32597 */   GIR_EraseRootFromParent_Done,
     /*  32598 */ // Label 710: @32598
     /*  32598 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(32630), // Rule ID 2762 //
     /*  32603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32617 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32620 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32622 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32624 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32629 */   // GIR_Coverage, 2762,
     /*  32629 */   GIR_EraseRootFromParent_Done,
     /*  32630 */ // Label 711: @32630
     /*  32630 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(32662), // Rule ID 2763 //
     /*  32635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32649 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32652 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32654 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32656 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32661 */   // GIR_Coverage, 2763,
     /*  32661 */   GIR_EraseRootFromParent_Done,
     /*  32662 */ // Label 712: @32662
     /*  32662 */ GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(32694), // Rule ID 2764 //
     /*  32667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32681 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32684 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32686 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32688 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32693 */   // GIR_Coverage, 2764,
     /*  32693 */   GIR_EraseRootFromParent_Done,
     /*  32694 */ // Label 713: @32694
     /*  32694 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(32731), // Rule ID 2831 //
     /*  32699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32713 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[f64] }:$src)
     /*  32713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32718 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32723 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32729 */   GIR_RootConstrainSelectedInstOperands,
     /*  32730 */   // GIR_Coverage, 2831,
     /*  32730 */   GIR_EraseRootFromParent_Done,
     /*  32731 */ // Label 714: @32731
     /*  32731 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(32768), // Rule ID 2832 //
     /*  32736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32750 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)
     /*  32750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32755 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32760 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32766 */   GIR_RootConstrainSelectedInstOperands,
     /*  32767 */   // GIR_Coverage, 2832,
     /*  32767 */   GIR_EraseRootFromParent_Done,
     /*  32768 */ // Label 715: @32768
     /*  32768 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(32805), // Rule ID 2833 //
     /*  32773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32787 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)
     /*  32787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32792 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32797 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32803 */   GIR_RootConstrainSelectedInstOperands,
     /*  32804 */   // GIR_Coverage, 2833,
     /*  32804 */   GIR_EraseRootFromParent_Done,
     /*  32805 */ // Label 716: @32805
     /*  32805 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(32842), // Rule ID 2834 //
     /*  32810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32824 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)
     /*  32824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32829 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32834 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32840 */   GIR_RootConstrainSelectedInstOperands,
     /*  32841 */   // GIR_Coverage, 2834,
     /*  32841 */   GIR_EraseRootFromParent_Done,
     /*  32842 */ // Label 717: @32842
     /*  32842 */ GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(32879), // Rule ID 2835 //
     /*  32847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32861 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)
     /*  32861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32866 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32871 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32877 */   GIR_RootConstrainSelectedInstOperands,
     /*  32878 */   // GIR_Coverage, 2835,
     /*  32878 */   GIR_EraseRootFromParent_Done,
     /*  32879 */ // Label 718: @32879
     /*  32879 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(32916), // Rule ID 2836 //
     /*  32884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32898 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)
     /*  32898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32903 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32908 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32914 */   GIR_RootConstrainSelectedInstOperands,
     /*  32915 */   // GIR_Coverage, 2836,
     /*  32915 */   GIR_EraseRootFromParent_Done,
     /*  32916 */ // Label 719: @32916
     /*  32916 */ GIM_Reject,
     /*  32917 */ // Label 547: @32917
     /*  32917 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(32949), // Rule ID 2727 //
     /*  32922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32936 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  32936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32939 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32941 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32943 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32948 */   // GIR_Coverage, 2727,
     /*  32948 */   GIR_EraseRootFromParent_Done,
     /*  32949 */ // Label 720: @32949
     /*  32949 */ GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(32981), // Rule ID 2728 //
     /*  32954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32968 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32971 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32973 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32975 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32980 */   // GIR_Coverage, 2728,
     /*  32980 */   GIR_EraseRootFromParent_Done,
     /*  32981 */ // Label 721: @32981
     /*  32981 */ GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(33013), // Rule ID 2785 //
     /*  32986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33000 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33003 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33005 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33007 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33012 */   // GIR_Coverage, 2785,
     /*  33012 */   GIR_EraseRootFromParent_Done,
     /*  33013 */ // Label 722: @33013
     /*  33013 */ GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(33045), // Rule ID 2786 //
     /*  33018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33032 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33035 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33037 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33039 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33044 */   // GIR_Coverage, 2786,
     /*  33044 */   GIR_EraseRootFromParent_Done,
     /*  33045 */ // Label 723: @33045
     /*  33045 */ GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(33077), // Rule ID 2787 //
     /*  33050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33064 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33067 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33069 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33076 */   // GIR_Coverage, 2787,
     /*  33076 */   GIR_EraseRootFromParent_Done,
     /*  33077 */ // Label 724: @33077
     /*  33077 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(33109), // Rule ID 2788 //
     /*  33082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33096 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33099 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33101 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33103 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33108 */   // GIR_Coverage, 2788,
     /*  33108 */   GIR_EraseRootFromParent_Done,
     /*  33109 */ // Label 725: @33109
     /*  33109 */ GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(33141), // Rule ID 2789 //
     /*  33114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33128 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33131 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33133 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33135 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33140 */   // GIR_Coverage, 2789,
     /*  33140 */   GIR_EraseRootFromParent_Done,
     /*  33141 */ // Label 726: @33141
     /*  33141 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(33173), // Rule ID 2790 //
     /*  33146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33160 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33163 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33165 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33172 */   // GIR_Coverage, 2790,
     /*  33172 */   GIR_EraseRootFromParent_Done,
     /*  33173 */ // Label 727: @33173
     /*  33173 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(33205), // Rule ID 2791 //
     /*  33178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33192 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33195 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33197 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33199 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33204 */   // GIR_Coverage, 2791,
     /*  33204 */   GIR_EraseRootFromParent_Done,
     /*  33205 */ // Label 728: @33205
     /*  33205 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(33237), // Rule ID 2792 //
     /*  33210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33224 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33227 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33229 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33231 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33236 */   // GIR_Coverage, 2792,
     /*  33236 */   GIR_EraseRootFromParent_Done,
     /*  33237 */ // Label 729: @33237
     /*  33237 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(33269), // Rule ID 2793 //
     /*  33242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33256 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33259 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33261 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33263 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33268 */   // GIR_Coverage, 2793,
     /*  33268 */   GIR_EraseRootFromParent_Done,
     /*  33269 */ // Label 730: @33269
     /*  33269 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(33301), // Rule ID 2794 //
     /*  33274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33288 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33291 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33293 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33300 */   // GIR_Coverage, 2794,
     /*  33300 */   GIR_EraseRootFromParent_Done,
     /*  33301 */ // Label 731: @33301
     /*  33301 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(33338), // Rule ID 2857 //
     /*  33306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33320 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)
     /*  33320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33325 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33330 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33336 */   GIR_RootConstrainSelectedInstOperands,
     /*  33337 */   // GIR_Coverage, 2857,
     /*  33337 */   GIR_EraseRootFromParent_Done,
     /*  33338 */ // Label 732: @33338
     /*  33338 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(33375), // Rule ID 2858 //
     /*  33343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33357 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)
     /*  33357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33362 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33367 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33373 */   GIR_RootConstrainSelectedInstOperands,
     /*  33374 */   // GIR_Coverage, 2858,
     /*  33374 */   GIR_EraseRootFromParent_Done,
     /*  33375 */ // Label 733: @33375
     /*  33375 */ GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(33412), // Rule ID 2859 //
     /*  33380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33394 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)
     /*  33394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33399 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33404 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33410 */   GIR_RootConstrainSelectedInstOperands,
     /*  33411 */   // GIR_Coverage, 2859,
     /*  33411 */   GIR_EraseRootFromParent_Done,
     /*  33412 */ // Label 734: @33412
     /*  33412 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(33449), // Rule ID 2860 //
     /*  33417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33431 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)
     /*  33431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33436 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33441 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33447 */   GIR_RootConstrainSelectedInstOperands,
     /*  33448 */   // GIR_Coverage, 2860,
     /*  33448 */   GIR_EraseRootFromParent_Done,
     /*  33449 */ // Label 735: @33449
     /*  33449 */ GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(33486), // Rule ID 2861 //
     /*  33454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33468 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)
     /*  33468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33473 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33478 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33484 */   GIR_RootConstrainSelectedInstOperands,
     /*  33485 */   // GIR_Coverage, 2861,
     /*  33485 */   GIR_EraseRootFromParent_Done,
     /*  33486 */ // Label 736: @33486
     /*  33486 */ GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(33523), // Rule ID 2862 //
     /*  33491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33505 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)
     /*  33505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33510 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33515 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33521 */   GIR_RootConstrainSelectedInstOperands,
     /*  33522 */   // GIR_Coverage, 2862,
     /*  33522 */   GIR_EraseRootFromParent_Done,
     /*  33523 */ // Label 737: @33523
     /*  33523 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(33560), // Rule ID 2863 //
     /*  33528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33542 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)
     /*  33542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33552 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33558 */   GIR_RootConstrainSelectedInstOperands,
     /*  33559 */   // GIR_Coverage, 2863,
     /*  33559 */   GIR_EraseRootFromParent_Done,
     /*  33560 */ // Label 738: @33560
     /*  33560 */ GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(33597), // Rule ID 2864 //
     /*  33565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33579 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)
     /*  33579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33584 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33589 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33595 */   GIR_RootConstrainSelectedInstOperands,
     /*  33596 */   // GIR_Coverage, 2864,
     /*  33596 */   GIR_EraseRootFromParent_Done,
     /*  33597 */ // Label 739: @33597
     /*  33597 */ GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(33634), // Rule ID 2865 //
     /*  33602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33616 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)
     /*  33616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33621 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33626 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33632 */   GIR_RootConstrainSelectedInstOperands,
     /*  33633 */   // GIR_Coverage, 2865,
     /*  33633 */   GIR_EraseRootFromParent_Done,
     /*  33634 */ // Label 740: @33634
     /*  33634 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(33671), // Rule ID 2866 //
     /*  33639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33653 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)
     /*  33653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33658 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33663 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33669 */   GIR_RootConstrainSelectedInstOperands,
     /*  33670 */   // GIR_Coverage, 2866,
     /*  33670 */   GIR_EraseRootFromParent_Done,
     /*  33671 */ // Label 741: @33671
     /*  33671 */ GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(33703), // Rule ID 5284 //
     /*  33676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33690 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33693 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33695 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33697 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33702 */   // GIR_Coverage, 5284,
     /*  33702 */   GIR_EraseRootFromParent_Done,
     /*  33703 */ // Label 742: @33703
     /*  33703 */ GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(33735), // Rule ID 5285 //
     /*  33708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33722 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33725 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33727 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33729 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33734 */   // GIR_Coverage, 5285,
     /*  33734 */   GIR_EraseRootFromParent_Done,
     /*  33735 */ // Label 743: @33735
     /*  33735 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(33767), // Rule ID 5306 //
     /*  33740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33754 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33757 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33759 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33761 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33766 */   // GIR_Coverage, 5306,
     /*  33766 */   GIR_EraseRootFromParent_Done,
     /*  33767 */ // Label 744: @33767
     /*  33767 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(33799), // Rule ID 5307 //
     /*  33772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33786 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33789 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33791 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33793 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33798 */   // GIR_Coverage, 5307,
     /*  33798 */   GIR_EraseRootFromParent_Done,
     /*  33799 */ // Label 745: @33799
     /*  33799 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(33831), // Rule ID 5308 //
     /*  33804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33818 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33821 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33823 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33825 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33830 */   // GIR_Coverage, 5308,
     /*  33830 */   GIR_EraseRootFromParent_Done,
     /*  33831 */ // Label 746: @33831
     /*  33831 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(33863), // Rule ID 5309 //
     /*  33836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33850 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33853 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33855 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33857 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33862 */   // GIR_Coverage, 5309,
     /*  33862 */   GIR_EraseRootFromParent_Done,
     /*  33863 */ // Label 747: @33863
     /*  33863 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(33895), // Rule ID 5310 //
     /*  33868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33882 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33885 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33887 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33889 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33894 */   // GIR_Coverage, 5310,
     /*  33894 */   GIR_EraseRootFromParent_Done,
     /*  33895 */ // Label 748: @33895
     /*  33895 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(33927), // Rule ID 5311 //
     /*  33900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33914 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33917 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33919 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33921 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33926 */   // GIR_Coverage, 5311,
     /*  33926 */   GIR_EraseRootFromParent_Done,
     /*  33927 */ // Label 749: @33927
     /*  33927 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(33959), // Rule ID 5312 //
     /*  33932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33946 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33949 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33953 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33958 */   // GIR_Coverage, 5312,
     /*  33958 */   GIR_EraseRootFromParent_Done,
     /*  33959 */ // Label 750: @33959
     /*  33959 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(33991), // Rule ID 5313 //
     /*  33964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33978 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33981 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33983 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33990 */   // GIR_Coverage, 5313,
     /*  33990 */   GIR_EraseRootFromParent_Done,
     /*  33991 */ // Label 751: @33991
     /*  33991 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(34023), // Rule ID 5314 //
     /*  33996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34010 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  34010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34013 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34015 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34017 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34022 */   // GIR_Coverage, 5314,
     /*  34022 */   GIR_EraseRootFromParent_Done,
     /*  34023 */ // Label 752: @34023
     /*  34023 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(34055), // Rule ID 5315 //
     /*  34028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  34031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34042 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  34042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34045 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34047 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34049 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34054 */   // GIR_Coverage, 5315,
     /*  34054 */   GIR_EraseRootFromParent_Done,
     /*  34055 */ // Label 753: @34055
     /*  34055 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(34113), // Rule ID 5342 //
     /*  34060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34074 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)
     /*  34074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34091 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34096 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34102 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34111 */   GIR_RootConstrainSelectedInstOperands,
     /*  34112 */   // GIR_Coverage, 5342,
     /*  34112 */   GIR_EraseRootFromParent_Done,
     /*  34113 */ // Label 754: @34113
     /*  34113 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(34171), // Rule ID 5343 //
     /*  34118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34132 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)
     /*  34132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34149 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34154 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34160 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34169 */   GIR_RootConstrainSelectedInstOperands,
     /*  34170 */   // GIR_Coverage, 5343,
     /*  34170 */   GIR_EraseRootFromParent_Done,
     /*  34171 */ // Label 755: @34171
     /*  34171 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(34229), // Rule ID 5344 //
     /*  34176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34190 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)
     /*  34190 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34193 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34197 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34207 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34212 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34218 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34227 */   GIR_RootConstrainSelectedInstOperands,
     /*  34228 */   // GIR_Coverage, 5344,
     /*  34228 */   GIR_EraseRootFromParent_Done,
     /*  34229 */ // Label 756: @34229
     /*  34229 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(34287), // Rule ID 5345 //
     /*  34234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34248 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)
     /*  34248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34265 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34270 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34276 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34282 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34285 */   GIR_RootConstrainSelectedInstOperands,
     /*  34286 */   // GIR_Coverage, 5345,
     /*  34286 */   GIR_EraseRootFromParent_Done,
     /*  34287 */ // Label 757: @34287
     /*  34287 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(34345), // Rule ID 5346 //
     /*  34292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34306 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)
     /*  34306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34323 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34328 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34334 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34340 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34343 */   GIR_RootConstrainSelectedInstOperands,
     /*  34344 */   // GIR_Coverage, 5346,
     /*  34344 */   GIR_EraseRootFromParent_Done,
     /*  34345 */ // Label 758: @34345
     /*  34345 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(34403), // Rule ID 5347 //
     /*  34350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34364 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)
     /*  34364 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34367 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34371 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34381 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34386 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34392 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34398 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34401 */   GIR_RootConstrainSelectedInstOperands,
     /*  34402 */   // GIR_Coverage, 5347,
     /*  34402 */   GIR_EraseRootFromParent_Done,
     /*  34403 */ // Label 759: @34403
     /*  34403 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(34461), // Rule ID 5348 //
     /*  34408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34422 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)
     /*  34422 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34425 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34429 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34439 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34444 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34450 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34456 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34459 */   GIR_RootConstrainSelectedInstOperands,
     /*  34460 */   // GIR_Coverage, 5348,
     /*  34460 */   GIR_EraseRootFromParent_Done,
     /*  34461 */ // Label 760: @34461
     /*  34461 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(34519), // Rule ID 5349 //
     /*  34466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34480 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)
     /*  34480 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34483 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34487 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34497 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34502 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34508 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34517 */   GIR_RootConstrainSelectedInstOperands,
     /*  34518 */   // GIR_Coverage, 5349,
     /*  34518 */   GIR_EraseRootFromParent_Done,
     /*  34519 */ // Label 761: @34519
     /*  34519 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(34577), // Rule ID 5350 //
     /*  34524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34538 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)
     /*  34538 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34541 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34545 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34555 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34560 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34566 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34575 */   GIR_RootConstrainSelectedInstOperands,
     /*  34576 */   // GIR_Coverage, 5350,
     /*  34576 */   GIR_EraseRootFromParent_Done,
     /*  34577 */ // Label 762: @34577
     /*  34577 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(34635), // Rule ID 5351 //
     /*  34582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34596 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  34596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34613 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34618 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34624 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34630 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34633 */   GIR_RootConstrainSelectedInstOperands,
     /*  34634 */   // GIR_Coverage, 5351,
     /*  34634 */   GIR_EraseRootFromParent_Done,
     /*  34635 */ // Label 763: @34635
     /*  34635 */ GIM_Reject,
     /*  34636 */ // Label 548: @34636
     /*  34636 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(34668), // Rule ID 2795 //
     /*  34641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34655 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34658 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34660 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34662 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34667 */   // GIR_Coverage, 2795,
     /*  34667 */   GIR_EraseRootFromParent_Done,
     /*  34668 */ // Label 764: @34668
     /*  34668 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(34700), // Rule ID 2796 //
     /*  34673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34687 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34690 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34692 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34694 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34699 */   // GIR_Coverage, 2796,
     /*  34699 */   GIR_EraseRootFromParent_Done,
     /*  34700 */ // Label 765: @34700
     /*  34700 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(34732), // Rule ID 2797 //
     /*  34705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34719 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34722 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34724 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34726 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34731 */   // GIR_Coverage, 2797,
     /*  34731 */   GIR_EraseRootFromParent_Done,
     /*  34732 */ // Label 766: @34732
     /*  34732 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(34764), // Rule ID 2798 //
     /*  34737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34751 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34754 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34756 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34758 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34763 */   // GIR_Coverage, 2798,
     /*  34763 */   GIR_EraseRootFromParent_Done,
     /*  34764 */ // Label 767: @34764
     /*  34764 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(34796), // Rule ID 2799 //
     /*  34769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34783 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34786 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34788 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34790 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34795 */   // GIR_Coverage, 2799,
     /*  34795 */   GIR_EraseRootFromParent_Done,
     /*  34796 */ // Label 768: @34796
     /*  34796 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(34828), // Rule ID 2800 //
     /*  34801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34815 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34818 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34820 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34822 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34827 */   // GIR_Coverage, 2800,
     /*  34827 */   GIR_EraseRootFromParent_Done,
     /*  34828 */ // Label 769: @34828
     /*  34828 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(34865), // Rule ID 2867 //
     /*  34833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34847 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)
     /*  34847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34852 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34857 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34863 */   GIR_RootConstrainSelectedInstOperands,
     /*  34864 */   // GIR_Coverage, 2867,
     /*  34864 */   GIR_EraseRootFromParent_Done,
     /*  34865 */ // Label 770: @34865
     /*  34865 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(34902), // Rule ID 2868 //
     /*  34870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34884 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)
     /*  34884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34889 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34894 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34900 */   GIR_RootConstrainSelectedInstOperands,
     /*  34901 */   // GIR_Coverage, 2868,
     /*  34901 */   GIR_EraseRootFromParent_Done,
     /*  34902 */ // Label 771: @34902
     /*  34902 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(34939), // Rule ID 2869 //
     /*  34907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34921 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)
     /*  34921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34926 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34931 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34937 */   GIR_RootConstrainSelectedInstOperands,
     /*  34938 */   // GIR_Coverage, 2869,
     /*  34938 */   GIR_EraseRootFromParent_Done,
     /*  34939 */ // Label 772: @34939
     /*  34939 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(34976), // Rule ID 2870 //
     /*  34944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34958 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)
     /*  34958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34963 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34968 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34974 */   GIR_RootConstrainSelectedInstOperands,
     /*  34975 */   // GIR_Coverage, 2870,
     /*  34975 */   GIR_EraseRootFromParent_Done,
     /*  34976 */ // Label 773: @34976
     /*  34976 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(35013), // Rule ID 2871 //
     /*  34981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34995 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)
     /*  34995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  34998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  35000 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35005 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35011 */   GIR_RootConstrainSelectedInstOperands,
     /*  35012 */   // GIR_Coverage, 2871,
     /*  35012 */   GIR_EraseRootFromParent_Done,
     /*  35013 */ // Label 774: @35013
     /*  35013 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(35050), // Rule ID 2872 //
     /*  35018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  35021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35032 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)
     /*  35032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  35035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  35037 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35042 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35048 */   GIR_RootConstrainSelectedInstOperands,
     /*  35049 */   // GIR_Coverage, 2872,
     /*  35049 */   GIR_EraseRootFromParent_Done,
     /*  35050 */ // Label 775: @35050
     /*  35050 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(35082), // Rule ID 5316 //
     /*  35055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35069 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35072 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35074 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35076 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35081 */   // GIR_Coverage, 5316,
     /*  35081 */   GIR_EraseRootFromParent_Done,
     /*  35082 */ // Label 776: @35082
     /*  35082 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(35114), // Rule ID 5317 //
     /*  35087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35101 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35104 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35106 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35108 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35113 */   // GIR_Coverage, 5317,
     /*  35113 */   GIR_EraseRootFromParent_Done,
     /*  35114 */ // Label 777: @35114
     /*  35114 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(35146), // Rule ID 5318 //
     /*  35119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35133 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35136 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35138 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35145 */   // GIR_Coverage, 5318,
     /*  35145 */   GIR_EraseRootFromParent_Done,
     /*  35146 */ // Label 778: @35146
     /*  35146 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(35178), // Rule ID 5319 //
     /*  35151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35165 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35168 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35170 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35172 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35177 */   // GIR_Coverage, 5319,
     /*  35177 */   GIR_EraseRootFromParent_Done,
     /*  35178 */ // Label 779: @35178
     /*  35178 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(35210), // Rule ID 5320 //
     /*  35183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35197 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35200 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35202 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35204 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35209 */   // GIR_Coverage, 5320,
     /*  35209 */   GIR_EraseRootFromParent_Done,
     /*  35210 */ // Label 780: @35210
     /*  35210 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(35242), // Rule ID 5321 //
     /*  35215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35229 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35232 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35234 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35236 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35241 */   // GIR_Coverage, 5321,
     /*  35241 */   GIR_EraseRootFromParent_Done,
     /*  35242 */ // Label 781: @35242
     /*  35242 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(35300), // Rule ID 5352 //
     /*  35247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35261 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)
     /*  35261 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35264 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35268 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35278 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35283 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35289 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35298 */   GIR_RootConstrainSelectedInstOperands,
     /*  35299 */   // GIR_Coverage, 5352,
     /*  35299 */   GIR_EraseRootFromParent_Done,
     /*  35300 */ // Label 782: @35300
     /*  35300 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(35358), // Rule ID 5353 //
     /*  35305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35319 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)
     /*  35319 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35322 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35326 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35336 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35341 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35347 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35353 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35356 */   GIR_RootConstrainSelectedInstOperands,
     /*  35357 */   // GIR_Coverage, 5353,
     /*  35357 */   GIR_EraseRootFromParent_Done,
     /*  35358 */ // Label 783: @35358
     /*  35358 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(35416), // Rule ID 5354 //
     /*  35363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35377 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)
     /*  35377 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35380 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35384 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35394 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35399 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35405 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35411 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35414 */   GIR_RootConstrainSelectedInstOperands,
     /*  35415 */   // GIR_Coverage, 5354,
     /*  35415 */   GIR_EraseRootFromParent_Done,
     /*  35416 */ // Label 784: @35416
     /*  35416 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(35474), // Rule ID 5355 //
     /*  35421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35435 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)
     /*  35435 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35438 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35442 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35452 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35457 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35463 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35469 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35472 */   GIR_RootConstrainSelectedInstOperands,
     /*  35473 */   // GIR_Coverage, 5355,
     /*  35473 */   GIR_EraseRootFromParent_Done,
     /*  35474 */ // Label 785: @35474
     /*  35474 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(35532), // Rule ID 5356 //
     /*  35479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35493 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)
     /*  35493 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35496 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35500 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35510 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35515 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35521 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35530 */   GIR_RootConstrainSelectedInstOperands,
     /*  35531 */   // GIR_Coverage, 5356,
     /*  35531 */   GIR_EraseRootFromParent_Done,
     /*  35532 */ // Label 786: @35532
     /*  35532 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(35590), // Rule ID 5357 //
     /*  35537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35551 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)
     /*  35551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35568 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35573 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35579 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35588 */   GIR_RootConstrainSelectedInstOperands,
     /*  35589 */   // GIR_Coverage, 5357,
     /*  35589 */   GIR_EraseRootFromParent_Done,
     /*  35590 */ // Label 787: @35590
     /*  35590 */ GIM_Reject,
     /*  35591 */ // Label 549: @35591
     /*  35591 */ GIM_Reject,
     /*  35592 */ // Label 10: @35592
     /*  35592 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 795*/ GIMT_Encode4(35999),
     /*  35603 */ /*GILLT_s16*//*Label 788*/ GIMT_Encode4(35655),
     /*  35607 */ /*GILLT_s32*//*Label 789*/ GIMT_Encode4(35693),
     /*  35611 */ /*GILLT_s64*//*Label 790*/ GIMT_Encode4(35731), GIMT_Encode4(0),
     /*  35619 */ /*GILLT_v2s32*//*Label 791*/ GIMT_Encode4(35769), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35631 */ /*GILLT_v4s16*//*Label 792*/ GIMT_Encode4(35796),
     /*  35635 */ /*GILLT_v4s32*//*Label 793*/ GIMT_Encode4(35823), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35651 */ /*GILLT_v8s16*//*Label 794*/ GIMT_Encode4(35911),
     /*  35655 */ // Label 788: @35655
     /*  35655 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(35692), // Rule ID 665 //
     /*  35660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35674 */   // (ftrunc:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTZH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZH),
     /*  35677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35679 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35684 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35690 */   GIR_RootConstrainSelectedInstOperands,
     /*  35691 */   // GIR_Coverage, 665,
     /*  35691 */   GIR_EraseRootFromParent_Done,
     /*  35692 */ // Label 796: @35692
     /*  35692 */ GIM_Reject,
     /*  35693 */ // Label 789: @35693
     /*  35693 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(35730), // Rule ID 666 //
     /*  35698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35712 */   // (ftrunc:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTZS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZS),
     /*  35715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35717 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35722 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35728 */   GIR_RootConstrainSelectedInstOperands,
     /*  35729 */   // GIR_Coverage, 666,
     /*  35729 */   GIR_EraseRootFromParent_Done,
     /*  35730 */ // Label 797: @35730
     /*  35730 */ GIM_Reject,
     /*  35731 */ // Label 790: @35731
     /*  35731 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(35768), // Rule ID 667 //
     /*  35736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  35739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35750 */   // (ftrunc:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTZD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  35750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZD),
     /*  35753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  35755 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /*  35757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35760 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35766 */   GIR_RootConstrainSelectedInstOperands,
     /*  35767 */   // GIR_Coverage, 667,
     /*  35767 */   GIR_EraseRootFromParent_Done,
     /*  35768 */ // Label 798: @35768
     /*  35768 */ GIM_Reject,
     /*  35769 */ // Label 791: @35769
     /*  35769 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(35795), // Rule ID 1700 //
     /*  35774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  35777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  35780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35788 */   // (ftrunc:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTZNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  35788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDf),
     /*  35793 */   GIR_RootConstrainSelectedInstOperands,
     /*  35794 */   // GIR_Coverage, 1700,
     /*  35794 */   GIR_Done,
     /*  35795 */ // Label 799: @35795
     /*  35795 */ GIM_Reject,
     /*  35796 */ // Label 792: @35796
     /*  35796 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(35822), // Rule ID 1702 //
     /*  35801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  35804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  35807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35815 */   // (ftrunc:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTZNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  35815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDh),
     /*  35820 */   GIR_RootConstrainSelectedInstOperands,
     /*  35821 */   // GIR_Coverage, 1702,
     /*  35821 */   GIR_Done,
     /*  35822 */ // Label 800: @35822
     /*  35822 */ GIM_Reject,
     /*  35823 */ // Label 793: @35823
     /*  35823 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(35910),
     /*  35828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35831 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(35854), // Rule ID 1701 //
     /*  35836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  35839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35847 */     // (ftrunc:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTZNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  35847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQf),
     /*  35852 */     GIR_RootConstrainSelectedInstOperands,
     /*  35853 */     // GIR_Coverage, 1701,
     /*  35853 */     GIR_Done,
     /*  35854 */   // Label 802: @35854
     /*  35854 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(35909), // Rule ID 3979 //
     /*  35859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35870 */     // (ftrunc:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32Z:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  35870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32Z),
     /*  35885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35887 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35907 */     GIR_RootConstrainSelectedInstOperands,
     /*  35908 */     // GIR_Coverage, 3979,
     /*  35908 */     GIR_EraseRootFromParent_Done,
     /*  35909 */   // Label 803: @35909
     /*  35909 */   GIM_Reject,
     /*  35910 */ // Label 801: @35910
     /*  35910 */ GIM_Reject,
     /*  35911 */ // Label 794: @35911
     /*  35911 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(35998),
     /*  35916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35919 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(35942), // Rule ID 1703 //
     /*  35924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  35927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35935 */     // (ftrunc:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTZNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  35935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQh),
     /*  35940 */     GIR_RootConstrainSelectedInstOperands,
     /*  35941 */     // GIR_Coverage, 1703,
     /*  35941 */     GIR_Done,
     /*  35942 */   // Label 805: @35942
     /*  35942 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(35997), // Rule ID 3967 //
     /*  35947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35958 */     // (ftrunc:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16Z:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  35958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16Z),
     /*  35973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35975 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35995 */     GIR_RootConstrainSelectedInstOperands,
     /*  35996 */     // GIR_Coverage, 3967,
     /*  35996 */     GIR_EraseRootFromParent_Done,
     /*  35997 */   // Label 806: @35997
     /*  35997 */   GIM_Reject,
     /*  35998 */ // Label 804: @35998
     /*  35998 */ GIM_Reject,
     /*  35999 */ // Label 795: @35999
     /*  35999 */ GIM_Reject,
     /*  36000 */ // Label 11: @36000
     /*  36000 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 814*/ GIMT_Encode4(36374),
     /*  36011 */ /*GILLT_s16*//*Label 807*/ GIMT_Encode4(36063),
     /*  36015 */ /*GILLT_s32*//*Label 808*/ GIMT_Encode4(36090),
     /*  36019 */ /*GILLT_s64*//*Label 809*/ GIMT_Encode4(36117), GIMT_Encode4(0),
     /*  36027 */ /*GILLT_v2s32*//*Label 810*/ GIMT_Encode4(36144), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36039 */ /*GILLT_v4s16*//*Label 811*/ GIMT_Encode4(36171),
     /*  36043 */ /*GILLT_v4s32*//*Label 812*/ GIMT_Encode4(36198), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36059 */ /*GILLT_v8s16*//*Label 813*/ GIMT_Encode4(36286),
     /*  36063 */ // Label 807: @36063
     /*  36063 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(36089), // Rule ID 674 //
     /*  36068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  36074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36082 */   // (fround:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTAH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAH),
     /*  36087 */   GIR_RootConstrainSelectedInstOperands,
     /*  36088 */   // GIR_Coverage, 674,
     /*  36088 */   GIR_Done,
     /*  36089 */ // Label 815: @36089
     /*  36089 */ GIM_Reject,
     /*  36090 */ // Label 808: @36090
     /*  36090 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(36116), // Rule ID 675 //
     /*  36095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36109 */   // (fround:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTAS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAS),
     /*  36114 */   GIR_RootConstrainSelectedInstOperands,
     /*  36115 */   // GIR_Coverage, 675,
     /*  36115 */   GIR_Done,
     /*  36116 */ // Label 816: @36116
     /*  36116 */ GIM_Reject,
     /*  36117 */ // Label 809: @36117
     /*  36117 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(36143), // Rule ID 676 //
     /*  36122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36136 */   // (fround:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTAD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAD),
     /*  36141 */   GIR_RootConstrainSelectedInstOperands,
     /*  36142 */   // GIR_Coverage, 676,
     /*  36142 */   GIR_Done,
     /*  36143 */ // Label 817: @36143
     /*  36143 */ GIM_Reject,
     /*  36144 */ // Label 810: @36144
     /*  36144 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(36170), // Rule ID 1696 //
     /*  36149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  36152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36163 */   // (fround:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTANDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  36163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANDf),
     /*  36168 */   GIR_RootConstrainSelectedInstOperands,
     /*  36169 */   // GIR_Coverage, 1696,
     /*  36169 */   GIR_Done,
     /*  36170 */ // Label 818: @36170
     /*  36170 */ GIM_Reject,
     /*  36171 */ // Label 811: @36171
     /*  36171 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(36197), // Rule ID 1698 //
     /*  36176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  36179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  36182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36190 */   // (fround:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTANDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  36190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANDh),
     /*  36195 */   GIR_RootConstrainSelectedInstOperands,
     /*  36196 */   // GIR_Coverage, 1698,
     /*  36196 */   GIR_Done,
     /*  36197 */ // Label 819: @36197
     /*  36197 */ GIM_Reject,
     /*  36198 */ // Label 812: @36198
     /*  36198 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(36285),
     /*  36203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36206 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(36229), // Rule ID 1697 //
     /*  36211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  36214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36222 */     // (fround:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTANQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  36222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANQf),
     /*  36227 */     GIR_RootConstrainSelectedInstOperands,
     /*  36228 */     // GIR_Coverage, 1697,
     /*  36228 */     GIR_Done,
     /*  36229 */   // Label 821: @36229
     /*  36229 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(36284), // Rule ID 3977 //
     /*  36234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36245 */     // (fround:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32A:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32A),
     /*  36260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36262 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36282 */     GIR_RootConstrainSelectedInstOperands,
     /*  36283 */     // GIR_Coverage, 3977,
     /*  36283 */     GIR_EraseRootFromParent_Done,
     /*  36284 */   // Label 822: @36284
     /*  36284 */   GIM_Reject,
     /*  36285 */ // Label 820: @36285
     /*  36285 */ GIM_Reject,
     /*  36286 */ // Label 813: @36286
     /*  36286 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(36373),
     /*  36291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36294 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(36317), // Rule ID 1699 //
     /*  36299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  36302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36310 */     // (fround:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTANQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  36310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTANQh),
     /*  36315 */     GIR_RootConstrainSelectedInstOperands,
     /*  36316 */     // GIR_Coverage, 1699,
     /*  36316 */     GIR_Done,
     /*  36317 */   // Label 824: @36317
     /*  36317 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(36372), // Rule ID 3965 //
     /*  36322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36333 */     // (fround:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16A:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16A),
     /*  36348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36350 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36370 */     GIR_RootConstrainSelectedInstOperands,
     /*  36371 */     // GIR_Coverage, 3965,
     /*  36371 */     GIR_EraseRootFromParent_Done,
     /*  36372 */   // Label 825: @36372
     /*  36372 */   GIM_Reject,
     /*  36373 */ // Label 823: @36373
     /*  36373 */ GIM_Reject,
     /*  36374 */ // Label 814: @36374
     /*  36374 */ GIM_Reject,
     /*  36375 */ // Label 12: @36375
     /*  36375 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 833*/ GIMT_Encode4(36749),
     /*  36386 */ /*GILLT_s16*//*Label 826*/ GIMT_Encode4(36438),
     /*  36390 */ /*GILLT_s32*//*Label 827*/ GIMT_Encode4(36465),
     /*  36394 */ /*GILLT_s64*//*Label 828*/ GIMT_Encode4(36492), GIMT_Encode4(0),
     /*  36402 */ /*GILLT_v2s32*//*Label 829*/ GIMT_Encode4(36519), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36414 */ /*GILLT_v4s16*//*Label 830*/ GIMT_Encode4(36546),
     /*  36418 */ /*GILLT_v4s32*//*Label 831*/ GIMT_Encode4(36573), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36434 */ /*GILLT_v8s16*//*Label 832*/ GIMT_Encode4(36661),
     /*  36438 */ // Label 826: @36438
     /*  36438 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(36464), // Rule ID 677 //
     /*  36443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  36449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36457 */   // (froundeven:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36462 */   GIR_RootConstrainSelectedInstOperands,
     /*  36463 */   // GIR_Coverage, 677,
     /*  36463 */   GIR_Done,
     /*  36464 */ // Label 834: @36464
     /*  36464 */ GIM_Reject,
     /*  36465 */ // Label 827: @36465
     /*  36465 */ GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(36491), // Rule ID 678 //
     /*  36470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36484 */   // (froundeven:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36489 */   GIR_RootConstrainSelectedInstOperands,
     /*  36490 */   // GIR_Coverage, 678,
     /*  36490 */   GIR_Done,
     /*  36491 */ // Label 835: @36491
     /*  36491 */ GIM_Reject,
     /*  36492 */ // Label 828: @36492
     /*  36492 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(36518), // Rule ID 679 //
     /*  36497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36511 */   // (froundeven:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36516 */   GIR_RootConstrainSelectedInstOperands,
     /*  36517 */   // GIR_Coverage, 679,
     /*  36517 */   GIR_Done,
     /*  36518 */ // Label 836: @36518
     /*  36518 */ GIM_Reject,
     /*  36519 */ // Label 829: @36519
     /*  36519 */ GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(36545), // Rule ID 1688 //
     /*  36524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  36527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  36530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36538 */   // (froundeven:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTNNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  36538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDf),
     /*  36543 */   GIR_RootConstrainSelectedInstOperands,
     /*  36544 */   // GIR_Coverage, 1688,
     /*  36544 */   GIR_Done,
     /*  36545 */ // Label 837: @36545
     /*  36545 */ GIM_Reject,
     /*  36546 */ // Label 830: @36546
     /*  36546 */ GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(36572), // Rule ID 1690 //
     /*  36551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  36554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  36557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36565 */   // (froundeven:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTNNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  36565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDh),
     /*  36570 */   GIR_RootConstrainSelectedInstOperands,
     /*  36571 */   // GIR_Coverage, 1690,
     /*  36571 */   GIR_Done,
     /*  36572 */ // Label 838: @36572
     /*  36572 */ GIM_Reject,
     /*  36573 */ // Label 831: @36573
     /*  36573 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(36660),
     /*  36578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36581 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(36604), // Rule ID 1689 //
     /*  36586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  36589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36597 */     // (froundeven:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTNNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  36597 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQf),
     /*  36602 */     GIR_RootConstrainSelectedInstOperands,
     /*  36603 */     // GIR_Coverage, 1689,
     /*  36603 */     GIR_Done,
     /*  36604 */   // Label 840: @36604
     /*  36604 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(36659), // Rule ID 3973 //
     /*  36609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36620 */     // (froundeven:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32N:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32N),
     /*  36635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36637 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36657 */     GIR_RootConstrainSelectedInstOperands,
     /*  36658 */     // GIR_Coverage, 3973,
     /*  36658 */     GIR_EraseRootFromParent_Done,
     /*  36659 */   // Label 841: @36659
     /*  36659 */   GIM_Reject,
     /*  36660 */ // Label 839: @36660
     /*  36660 */ GIM_Reject,
     /*  36661 */ // Label 832: @36661
     /*  36661 */ GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(36748),
     /*  36666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36669 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(36692), // Rule ID 1691 //
     /*  36674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  36677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36685 */     // (froundeven:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTNNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  36685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQh),
     /*  36690 */     GIR_RootConstrainSelectedInstOperands,
     /*  36691 */     // GIR_Coverage, 1691,
     /*  36691 */     GIR_Done,
     /*  36692 */   // Label 843: @36692
     /*  36692 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(36747), // Rule ID 3961 //
     /*  36697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36708 */     // (froundeven:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16N:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16N),
     /*  36723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36725 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36745 */     GIR_RootConstrainSelectedInstOperands,
     /*  36746 */     // GIR_Coverage, 3961,
     /*  36746 */     GIR_EraseRootFromParent_Done,
     /*  36747 */   // Label 844: @36747
     /*  36747 */   GIM_Reject,
     /*  36748 */ // Label 842: @36748
     /*  36748 */ GIM_Reject,
     /*  36749 */ // Label 833: @36749
     /*  36749 */ GIM_Reject,
     /*  36750 */ // Label 13: @36750
     /*  36750 */ GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(36912),
     /*  36755 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36758 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36761 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(36836), // Rule ID 2050 //
     /*  36766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36769 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  36776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36780 */     // MIs[0] Rn
     /*  36780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36788 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (tLDRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36800 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36806 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36809 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36812 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSB),
     /*  36823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36834 */     GIR_RootConstrainSelectedInstOperands,
     /*  36835 */     // GIR_Coverage, 2050,
     /*  36835 */     GIR_EraseRootFromParent_Done,
     /*  36836 */   // Label 846: @36836
     /*  36836 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(36911), // Rule ID 2051 //
     /*  36841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36844 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  36851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36855 */     // MIs[0] Rn
     /*  36855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36863 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (tLDRSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36875 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36881 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36884 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36887 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSH),
     /*  36898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36900 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36909 */     GIR_RootConstrainSelectedInstOperands,
     /*  36910 */     // GIR_Coverage, 2051,
     /*  36910 */     GIR_EraseRootFromParent_Done,
     /*  36911 */   // Label 847: @36911
     /*  36911 */   GIM_Reject,
     /*  36912 */ // Label 845: @36912
     /*  36912 */ GIM_Reject,
     /*  36913 */ // Label 14: @36913
     /*  36913 */ GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(36933), // Rule ID 5418 //
     /*  36918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36921 */   // MIs[0] Operand 0
     /*  36921 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  36924 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36928 */   // (atomic_fence (timm:{ *:[i32] }), 0:{ *:[i32] })  =>  (MEMBARRIER)
     /*  36928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::MEMBARRIER),
     /*  36931 */   GIR_RootConstrainSelectedInstOperands,
     /*  36932 */   // GIR_Coverage, 5418,
     /*  36932 */   GIR_EraseRootFromParent_Done,
     /*  36933 */ // Label 848: @36933
     /*  36933 */ GIM_Reject,
     /*  36934 */ // Label 15: @36934
     /*  36934 */ GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(41645),
     /*  36939 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  36942 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(36990), // Rule ID 1853 //
     /*  36947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  36950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  36965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  36969 */     // (intrinsic_wo_chain:{ *:[i32] } 3948:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  36969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  36972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  36976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36988 */     GIR_RootConstrainSelectedInstOperands,
     /*  36989 */     // GIR_Coverage, 1853,
     /*  36989 */     GIR_EraseRootFromParent_Done,
     /*  36990 */   // Label 850: @36990
     /*  36990 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(37038), // Rule ID 2107 //
     /*  36995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  36998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  37003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  37009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  37013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  37017 */     // (intrinsic_wo_chain:{ *:[i32] } 3948:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  37017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  37020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  37024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  37027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37036 */     GIR_RootConstrainSelectedInstOperands,
     /*  37037 */     // GIR_Coverage, 2107,
     /*  37037 */     GIR_EraseRootFromParent_Done,
     /*  37038 */   // Label 851: @37038
     /*  37038 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(37083), // Rule ID 693 //
     /*  37043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  37046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  37051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37065 */     // (intrinsic_wo_chain:{ *:[f32] } 3949:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOSIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  37065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRD),
     /*  37068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  37072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37081 */     GIR_RootConstrainSelectedInstOperands,
     /*  37082 */     // GIR_Coverage, 693,
     /*  37082 */     GIR_EraseRootFromParent_Done,
     /*  37083 */   // Label 852: @37083
     /*  37083 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(37128), // Rule ID 694 //
     /*  37088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  37091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  37096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  37102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37110 */     // (intrinsic_wo_chain:{ *:[f32] } 3949:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOSIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  37110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRS),
     /*  37113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  37117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37126 */     GIR_RootConstrainSelectedInstOperands,
     /*  37127 */     // GIR_Coverage, 694,
     /*  37127 */     GIR_EraseRootFromParent_Done,
     /*  37128 */   // Label 853: @37128
     /*  37128 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(37173), // Rule ID 695 //
     /*  37133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  37136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  37141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37155 */     // (intrinsic_wo_chain:{ *:[f32] } 3950:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOUIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  37155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRD),
     /*  37158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  37162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37171 */     GIR_RootConstrainSelectedInstOperands,
     /*  37172 */     // GIR_Coverage, 695,
     /*  37172 */     GIR_EraseRootFromParent_Done,
     /*  37173 */   // Label 854: @37173
     /*  37173 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(37218), // Rule ID 696 //
     /*  37178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  37181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  37186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  37189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  37192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  37200 */     // (intrinsic_wo_chain:{ *:[f32] } 3950:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOUIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  37200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRS),
     /*  37203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  37205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  37207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37216 */     GIR_RootConstrainSelectedInstOperands,
     /*  37217 */     // GIR_Coverage, 696,
     /*  37217 */     GIR_EraseRootFromParent_Done,
     /*  37218 */   // Label 855: @37218
     /*  37218 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(37263), // Rule ID 1239 //
     /*  37223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37245 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3806:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLsv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i8),
     /*  37248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37261 */     GIR_RootConstrainSelectedInstOperands,
     /*  37262 */     // GIR_Coverage, 1239,
     /*  37262 */     GIR_EraseRootFromParent_Done,
     /*  37263 */   // Label 856: @37263
     /*  37263 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(37308), // Rule ID 1240 //
     /*  37268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37290 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3806:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLsv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i16),
     /*  37293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37306 */     GIR_RootConstrainSelectedInstOperands,
     /*  37307 */     // GIR_Coverage, 1240,
     /*  37307 */     GIR_EraseRootFromParent_Done,
     /*  37308 */   // Label 857: @37308
     /*  37308 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(37353), // Rule ID 1241 //
     /*  37313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37335 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3806:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLsv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv2i32),
     /*  37338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37351 */     GIR_RootConstrainSelectedInstOperands,
     /*  37352 */     // GIR_Coverage, 1241,
     /*  37352 */     GIR_EraseRootFromParent_Done,
     /*  37353 */   // Label 858: @37353
     /*  37353 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(37398), // Rule ID 1242 //
     /*  37358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37380 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3806:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLsv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv16i8),
     /*  37383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37396 */     GIR_RootConstrainSelectedInstOperands,
     /*  37397 */     // GIR_Coverage, 1242,
     /*  37397 */     GIR_EraseRootFromParent_Done,
     /*  37398 */   // Label 859: @37398
     /*  37398 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(37443), // Rule ID 1243 //
     /*  37403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37425 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3806:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLsv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i16),
     /*  37428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37441 */     GIR_RootConstrainSelectedInstOperands,
     /*  37442 */     // GIR_Coverage, 1243,
     /*  37442 */     GIR_EraseRootFromParent_Done,
     /*  37443 */   // Label 860: @37443
     /*  37443 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(37488), // Rule ID 1244 //
     /*  37448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  37456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37470 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3806:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLsv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i32),
     /*  37473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37486 */     GIR_RootConstrainSelectedInstOperands,
     /*  37487 */     // GIR_Coverage, 1244,
     /*  37487 */     GIR_EraseRootFromParent_Done,
     /*  37488 */   // Label 861: @37488
     /*  37488 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(37533), // Rule ID 1245 //
     /*  37493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37515 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3807:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLuv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i8),
     /*  37518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37531 */     GIR_RootConstrainSelectedInstOperands,
     /*  37532 */     // GIR_Coverage, 1245,
     /*  37532 */     GIR_EraseRootFromParent_Done,
     /*  37533 */   // Label 862: @37533
     /*  37533 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(37578), // Rule ID 1246 //
     /*  37538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37560 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3807:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLuv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i16),
     /*  37563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37576 */     GIR_RootConstrainSelectedInstOperands,
     /*  37577 */     // GIR_Coverage, 1246,
     /*  37577 */     GIR_EraseRootFromParent_Done,
     /*  37578 */   // Label 863: @37578
     /*  37578 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(37623), // Rule ID 1247 //
     /*  37583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37605 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3807:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLuv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv2i32),
     /*  37608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37621 */     GIR_RootConstrainSelectedInstOperands,
     /*  37622 */     // GIR_Coverage, 1247,
     /*  37622 */     GIR_EraseRootFromParent_Done,
     /*  37623 */   // Label 864: @37623
     /*  37623 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(37668), // Rule ID 1248 //
     /*  37628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37650 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3807:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLuv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv16i8),
     /*  37653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37666 */     GIR_RootConstrainSelectedInstOperands,
     /*  37667 */     // GIR_Coverage, 1248,
     /*  37667 */     GIR_EraseRootFromParent_Done,
     /*  37668 */   // Label 865: @37668
     /*  37668 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(37713), // Rule ID 1249 //
     /*  37673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37695 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3807:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLuv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i16),
     /*  37698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37705 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37711 */     GIR_RootConstrainSelectedInstOperands,
     /*  37712 */     // GIR_Coverage, 1249,
     /*  37712 */     GIR_EraseRootFromParent_Done,
     /*  37713 */   // Label 866: @37713
     /*  37713 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(37758), // Rule ID 1250 //
     /*  37718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37740 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3807:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLuv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i32),
     /*  37743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37756 */     GIR_RootConstrainSelectedInstOperands,
     /*  37757 */     // GIR_Coverage, 1250,
     /*  37757 */     GIR_EraseRootFromParent_Done,
     /*  37758 */   // Label 867: @37758
     /*  37758 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(37803), // Rule ID 1279 //
     /*  37763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37785 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3834:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRECPEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEd),
     /*  37788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37795 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37801 */     GIR_RootConstrainSelectedInstOperands,
     /*  37802 */     // GIR_Coverage, 1279,
     /*  37802 */     GIR_EraseRootFromParent_Done,
     /*  37803 */   // Label 868: @37803
     /*  37803 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(37848), // Rule ID 1280 //
     /*  37808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37830 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3834:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRECPEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEq),
     /*  37833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37846 */     GIR_RootConstrainSelectedInstOperands,
     /*  37847 */     // GIR_Coverage, 1280,
     /*  37847 */     GIR_EraseRootFromParent_Done,
     /*  37848 */   // Label 869: @37848
     /*  37848 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(37893), // Rule ID 1281 //
     /*  37853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37875 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3834:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfd),
     /*  37878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37891 */     GIR_RootConstrainSelectedInstOperands,
     /*  37892 */     // GIR_Coverage, 1281,
     /*  37892 */     GIR_EraseRootFromParent_Done,
     /*  37893 */   // Label 870: @37893
     /*  37893 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(37938), // Rule ID 1282 //
     /*  37898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37920 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3834:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfq),
     /*  37923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37936 */     GIR_RootConstrainSelectedInstOperands,
     /*  37937 */     // GIR_Coverage, 1282,
     /*  37937 */     GIR_EraseRootFromParent_Done,
     /*  37938 */   // Label 871: @37938
     /*  37938 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(37983), // Rule ID 1283 //
     /*  37943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37965 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3834:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhd),
     /*  37968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37981 */     GIR_RootConstrainSelectedInstOperands,
     /*  37982 */     // GIR_Coverage, 1283,
     /*  37982 */     GIR_EraseRootFromParent_Done,
     /*  37983 */   // Label 872: @37983
     /*  37983 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(38028), // Rule ID 1284 //
     /*  37988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38010 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3834:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  38010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhq),
     /*  38013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38026 */     GIR_RootConstrainSelectedInstOperands,
     /*  38027 */     // GIR_Coverage, 1284,
     /*  38027 */     GIR_EraseRootFromParent_Done,
     /*  38028 */   // Label 873: @38028
     /*  38028 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(38073), // Rule ID 1289 //
     /*  38033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38055 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3841:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRSQRTEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEd),
     /*  38058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38071 */     GIR_RootConstrainSelectedInstOperands,
     /*  38072 */     // GIR_Coverage, 1289,
     /*  38072 */     GIR_EraseRootFromParent_Done,
     /*  38073 */   // Label 874: @38073
     /*  38073 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(38118), // Rule ID 1290 //
     /*  38078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38100 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3841:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSQRTEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEq),
     /*  38103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38116 */     GIR_RootConstrainSelectedInstOperands,
     /*  38117 */     // GIR_Coverage, 1290,
     /*  38117 */     GIR_EraseRootFromParent_Done,
     /*  38118 */   // Label 875: @38118
     /*  38118 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(38163), // Rule ID 1291 //
     /*  38123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38145 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3841:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  38145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfd),
     /*  38148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38161 */     GIR_RootConstrainSelectedInstOperands,
     /*  38162 */     // GIR_Coverage, 1291,
     /*  38162 */     GIR_EraseRootFromParent_Done,
     /*  38163 */   // Label 876: @38163
     /*  38163 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(38208), // Rule ID 1292 //
     /*  38168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38190 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3841:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  38190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfq),
     /*  38193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38206 */     GIR_RootConstrainSelectedInstOperands,
     /*  38207 */     // GIR_Coverage, 1292,
     /*  38207 */     GIR_EraseRootFromParent_Done,
     /*  38208 */   // Label 877: @38208
     /*  38208 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(38253), // Rule ID 1293 //
     /*  38213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  38216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38235 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3841:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  38235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhd),
     /*  38238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38251 */     GIR_RootConstrainSelectedInstOperands,
     /*  38252 */     // GIR_Coverage, 1293,
     /*  38252 */     GIR_EraseRootFromParent_Done,
     /*  38253 */   // Label 878: @38253
     /*  38253 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(38298), // Rule ID 1294 //
     /*  38258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  38261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  38266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38280 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3841:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  38280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhq),
     /*  38283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38296 */     GIR_RootConstrainSelectedInstOperands,
     /*  38297 */     // GIR_Coverage, 1294,
     /*  38297 */     GIR_EraseRootFromParent_Done,
     /*  38298 */   // Label 879: @38298
     /*  38298 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(38343), // Rule ID 1515 //
     /*  38303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38325 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3812:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i8),
     /*  38328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38341 */     GIR_RootConstrainSelectedInstOperands,
     /*  38342 */     // GIR_Coverage, 1515,
     /*  38342 */     GIR_EraseRootFromParent_Done,
     /*  38343 */   // Label 880: @38343
     /*  38343 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(38388), // Rule ID 1516 //
     /*  38348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38370 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3812:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i16),
     /*  38373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38386 */     GIR_RootConstrainSelectedInstOperands,
     /*  38387 */     // GIR_Coverage, 1516,
     /*  38387 */     GIR_EraseRootFromParent_Done,
     /*  38388 */   // Label 881: @38388
     /*  38388 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(38433), // Rule ID 1517 //
     /*  38393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38415 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3812:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv2i32),
     /*  38418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38431 */     GIR_RootConstrainSelectedInstOperands,
     /*  38432 */     // GIR_Coverage, 1517,
     /*  38432 */     GIR_EraseRootFromParent_Done,
     /*  38433 */   // Label 882: @38433
     /*  38433 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(38478), // Rule ID 1518 //
     /*  38438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38460 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3812:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv16i8),
     /*  38463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38476 */     GIR_RootConstrainSelectedInstOperands,
     /*  38477 */     // GIR_Coverage, 1518,
     /*  38477 */     GIR_EraseRootFromParent_Done,
     /*  38478 */   // Label 883: @38478
     /*  38478 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(38523), // Rule ID 1519 //
     /*  38483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38505 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3812:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i16),
     /*  38508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38521 */     GIR_RootConstrainSelectedInstOperands,
     /*  38522 */     // GIR_Coverage, 1519,
     /*  38522 */     GIR_EraseRootFromParent_Done,
     /*  38523 */   // Label 884: @38523
     /*  38523 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(38568), // Rule ID 1520 //
     /*  38528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38550 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3812:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i32),
     /*  38553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38566 */     GIR_RootConstrainSelectedInstOperands,
     /*  38567 */     // GIR_Coverage, 1520,
     /*  38567 */     GIR_EraseRootFromParent_Done,
     /*  38568 */   // Label 885: @38568
     /*  38568 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(38613), // Rule ID 1531 //
     /*  38573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38595 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3818:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQNEGv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i8),
     /*  38598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38611 */     GIR_RootConstrainSelectedInstOperands,
     /*  38612 */     // GIR_Coverage, 1531,
     /*  38612 */     GIR_EraseRootFromParent_Done,
     /*  38613 */   // Label 886: @38613
     /*  38613 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(38658), // Rule ID 1532 //
     /*  38618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38640 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3818:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQNEGv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i16),
     /*  38643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38656 */     GIR_RootConstrainSelectedInstOperands,
     /*  38657 */     // GIR_Coverage, 1532,
     /*  38657 */     GIR_EraseRootFromParent_Done,
     /*  38658 */   // Label 887: @38658
     /*  38658 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(38703), // Rule ID 1533 //
     /*  38663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38685 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3818:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQNEGv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv2i32),
     /*  38688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38701 */     GIR_RootConstrainSelectedInstOperands,
     /*  38702 */     // GIR_Coverage, 1533,
     /*  38702 */     GIR_EraseRootFromParent_Done,
     /*  38703 */   // Label 888: @38703
     /*  38703 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(38748), // Rule ID 1534 //
     /*  38708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38730 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3818:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQNEGv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv16i8),
     /*  38733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38746 */     GIR_RootConstrainSelectedInstOperands,
     /*  38747 */     // GIR_Coverage, 1534,
     /*  38747 */     GIR_EraseRootFromParent_Done,
     /*  38748 */   // Label 889: @38748
     /*  38748 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(38793), // Rule ID 1535 //
     /*  38753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38775 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3818:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQNEGv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i16),
     /*  38778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38791 */     GIR_RootConstrainSelectedInstOperands,
     /*  38792 */     // GIR_Coverage, 1535,
     /*  38792 */     GIR_EraseRootFromParent_Done,
     /*  38793 */   // Label 890: @38793
     /*  38793 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(38838), // Rule ID 1536 //
     /*  38798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38820 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3818:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQNEGv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i32),
     /*  38823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38836 */     GIR_RootConstrainSelectedInstOperands,
     /*  38837 */     // GIR_Coverage, 1536,
     /*  38837 */     GIR_EraseRootFromParent_Done,
     /*  38838 */   // Label 891: @38838
     /*  38838 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(38883), // Rule ID 1537 //
     /*  38843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38865 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3759:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VCLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i8),
     /*  38868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38881 */     GIR_RootConstrainSelectedInstOperands,
     /*  38882 */     // GIR_Coverage, 1537,
     /*  38882 */     GIR_EraseRootFromParent_Done,
     /*  38883 */   // Label 892: @38883
     /*  38883 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(38928), // Rule ID 1538 //
     /*  38888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38910 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3759:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i16),
     /*  38913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38926 */     GIR_RootConstrainSelectedInstOperands,
     /*  38927 */     // GIR_Coverage, 1538,
     /*  38927 */     GIR_EraseRootFromParent_Done,
     /*  38928 */   // Label 893: @38928
     /*  38928 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(38973), // Rule ID 1539 //
     /*  38933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38955 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3759:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VCLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv2i32),
     /*  38958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38971 */     GIR_RootConstrainSelectedInstOperands,
     /*  38972 */     // GIR_Coverage, 1539,
     /*  38972 */     GIR_EraseRootFromParent_Done,
     /*  38973 */   // Label 894: @38973
     /*  38973 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(39018), // Rule ID 1540 //
     /*  38978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39000 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3759:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VCLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  39000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv16i8),
     /*  39003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39016 */     GIR_RootConstrainSelectedInstOperands,
     /*  39017 */     // GIR_Coverage, 1540,
     /*  39017 */     GIR_EraseRootFromParent_Done,
     /*  39018 */   // Label 895: @39018
     /*  39018 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(39063), // Rule ID 1541 //
     /*  39023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  39031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39045 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3759:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VCLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  39045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i16),
     /*  39048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39061 */     GIR_RootConstrainSelectedInstOperands,
     /*  39062 */     // GIR_Coverage, 1541,
     /*  39062 */     GIR_EraseRootFromParent_Done,
     /*  39063 */   // Label 896: @39063
     /*  39063 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(39108), // Rule ID 1542 //
     /*  39068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  39076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39090 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3759:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VCLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  39090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i32),
     /*  39093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39106 */     GIR_RootConstrainSelectedInstOperands,
     /*  39107 */     // GIR_Coverage, 1542,
     /*  39107 */     GIR_EraseRootFromParent_Done,
     /*  39108 */   // Label 897: @39108
     /*  39108 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(39153), // Rule ID 1586 //
     /*  39113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  39121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39135 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3815:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv8i8),
     /*  39138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39151 */     GIR_RootConstrainSelectedInstOperands,
     /*  39152 */     // GIR_Coverage, 1586,
     /*  39152 */     GIR_EraseRootFromParent_Done,
     /*  39153 */   // Label 898: @39153
     /*  39153 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(39198), // Rule ID 1587 //
     /*  39158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  39166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39180 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3815:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv4i16),
     /*  39183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39196 */     GIR_RootConstrainSelectedInstOperands,
     /*  39197 */     // GIR_Coverage, 1587,
     /*  39197 */     GIR_EraseRootFromParent_Done,
     /*  39198 */   // Label 899: @39198
     /*  39198 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(39243), // Rule ID 1588 //
     /*  39203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  39211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39225 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3815:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv2i32),
     /*  39228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39241 */     GIR_RootConstrainSelectedInstOperands,
     /*  39242 */     // GIR_Coverage, 1588,
     /*  39242 */     GIR_EraseRootFromParent_Done,
     /*  39243 */   // Label 900: @39243
     /*  39243 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(39288), // Rule ID 1589 //
     /*  39248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39270 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3817:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv8i8),
     /*  39273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39286 */     GIR_RootConstrainSelectedInstOperands,
     /*  39287 */     // GIR_Coverage, 1589,
     /*  39287 */     GIR_EraseRootFromParent_Done,
     /*  39288 */   // Label 901: @39288
     /*  39288 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(39333), // Rule ID 1590 //
     /*  39293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39315 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3817:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv4i16),
     /*  39318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39331 */     GIR_RootConstrainSelectedInstOperands,
     /*  39332 */     // GIR_Coverage, 1590,
     /*  39332 */     GIR_EraseRootFromParent_Done,
     /*  39333 */   // Label 902: @39333
     /*  39333 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(39378), // Rule ID 1591 //
     /*  39338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  39346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39360 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3817:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv2i32),
     /*  39363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39376 */     GIR_RootConstrainSelectedInstOperands,
     /*  39377 */     // GIR_Coverage, 1591,
     /*  39377 */     GIR_EraseRootFromParent_Done,
     /*  39378 */   // Label 903: @39378
     /*  39378 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(39423), // Rule ID 1592 //
     /*  39383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  39394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39405 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3816:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  39405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv8i8),
     /*  39408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39421 */     GIR_RootConstrainSelectedInstOperands,
     /*  39422 */     // GIR_Coverage, 1592,
     /*  39422 */     GIR_EraseRootFromParent_Done,
     /*  39423 */   // Label 904: @39423
     /*  39423 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(39468), // Rule ID 1593 //
     /*  39428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39450 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3816:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  39450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv4i16),
     /*  39453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39460 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39466 */     GIR_RootConstrainSelectedInstOperands,
     /*  39467 */     // GIR_Coverage, 1593,
     /*  39467 */     GIR_EraseRootFromParent_Done,
     /*  39468 */   // Label 905: @39468
     /*  39468 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(39513), // Rule ID 1594 //
     /*  39473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  39476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  39481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  39487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39495 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3816:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  39495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv2i32),
     /*  39498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39505 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39511 */     GIR_RootConstrainSelectedInstOperands,
     /*  39512 */     // GIR_Coverage, 1594,
     /*  39512 */     GIR_EraseRootFromParent_Done,
     /*  39513 */   // Label 906: @39513
     /*  39513 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(39549), // Rule ID 1617 //
     /*  39518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39540 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3760:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDf),
     /*  39543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39547 */     GIR_RootConstrainSelectedInstOperands,
     /*  39548 */     // GIR_Coverage, 1617,
     /*  39548 */     GIR_EraseRootFromParent_Done,
     /*  39549 */   // Label 907: @39549
     /*  39549 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(39585), // Rule ID 1618 //
     /*  39554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39576 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3760:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQf),
     /*  39579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39583 */     GIR_RootConstrainSelectedInstOperands,
     /*  39584 */     // GIR_Coverage, 1618,
     /*  39584 */     GIR_EraseRootFromParent_Done,
     /*  39585 */   // Label 908: @39585
     /*  39585 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(39621), // Rule ID 1619 //
     /*  39590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39612 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3761:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDf),
     /*  39615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39619 */     GIR_RootConstrainSelectedInstOperands,
     /*  39620 */     // GIR_Coverage, 1619,
     /*  39620 */     GIR_EraseRootFromParent_Done,
     /*  39621 */   // Label 909: @39621
     /*  39621 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(39657), // Rule ID 1620 //
     /*  39626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39648 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3761:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQf),
     /*  39651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39655 */     GIR_RootConstrainSelectedInstOperands,
     /*  39656 */     // GIR_Coverage, 1620,
     /*  39656 */     GIR_EraseRootFromParent_Done,
     /*  39657 */   // Label 910: @39657
     /*  39657 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(39693), // Rule ID 1621 //
     /*  39662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39684 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3760:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDh),
     /*  39687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39691 */     GIR_RootConstrainSelectedInstOperands,
     /*  39692 */     // GIR_Coverage, 1621,
     /*  39692 */     GIR_EraseRootFromParent_Done,
     /*  39693 */   // Label 911: @39693
     /*  39693 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(39729), // Rule ID 1622 //
     /*  39698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39720 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3760:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQh),
     /*  39723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39727 */     GIR_RootConstrainSelectedInstOperands,
     /*  39728 */     // GIR_Coverage, 1622,
     /*  39728 */     GIR_EraseRootFromParent_Done,
     /*  39729 */   // Label 912: @39729
     /*  39729 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(39765), // Rule ID 1623 //
     /*  39734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39756 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3761:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDh),
     /*  39759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39763 */     GIR_RootConstrainSelectedInstOperands,
     /*  39764 */     // GIR_Coverage, 1623,
     /*  39764 */     GIR_EraseRootFromParent_Done,
     /*  39765 */   // Label 913: @39765
     /*  39765 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(39801), // Rule ID 1624 //
     /*  39770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39792 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3761:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQh),
     /*  39795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39799 */     GIR_RootConstrainSelectedInstOperands,
     /*  39800 */     // GIR_Coverage, 1624,
     /*  39800 */     GIR_EraseRootFromParent_Done,
     /*  39801 */   // Label 914: @39801
     /*  39801 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(39837), // Rule ID 1625 //
     /*  39806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39828 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3772:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDf),
     /*  39831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39835 */     GIR_RootConstrainSelectedInstOperands,
     /*  39836 */     // GIR_Coverage, 1625,
     /*  39836 */     GIR_EraseRootFromParent_Done,
     /*  39837 */   // Label 915: @39837
     /*  39837 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(39873), // Rule ID 1626 //
     /*  39842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39864 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3772:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQf),
     /*  39867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39871 */     GIR_RootConstrainSelectedInstOperands,
     /*  39872 */     // GIR_Coverage, 1626,
     /*  39872 */     GIR_EraseRootFromParent_Done,
     /*  39873 */   // Label 916: @39873
     /*  39873 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(39909), // Rule ID 1627 //
     /*  39878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39900 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3773:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDf),
     /*  39903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39907 */     GIR_RootConstrainSelectedInstOperands,
     /*  39908 */     // GIR_Coverage, 1627,
     /*  39908 */     GIR_EraseRootFromParent_Done,
     /*  39909 */   // Label 917: @39909
     /*  39909 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(39945), // Rule ID 1628 //
     /*  39914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39936 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3773:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQf),
     /*  39939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39943 */     GIR_RootConstrainSelectedInstOperands,
     /*  39944 */     // GIR_Coverage, 1628,
     /*  39944 */     GIR_EraseRootFromParent_Done,
     /*  39945 */   // Label 918: @39945
     /*  39945 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(39981), // Rule ID 1629 //
     /*  39950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39972 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3772:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDh),
     /*  39975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39979 */     GIR_RootConstrainSelectedInstOperands,
     /*  39980 */     // GIR_Coverage, 1629,
     /*  39980 */     GIR_EraseRootFromParent_Done,
     /*  39981 */   // Label 919: @39981
     /*  39981 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(40017), // Rule ID 1630 //
     /*  39986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40008 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3772:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQh),
     /*  40011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40015 */     GIR_RootConstrainSelectedInstOperands,
     /*  40016 */     // GIR_Coverage, 1630,
     /*  40016 */     GIR_EraseRootFromParent_Done,
     /*  40017 */   // Label 920: @40017
     /*  40017 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(40053), // Rule ID 1631 //
     /*  40022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  40030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40044 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3773:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDh),
     /*  40047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40051 */     GIR_RootConstrainSelectedInstOperands,
     /*  40052 */     // GIR_Coverage, 1631,
     /*  40052 */     GIR_EraseRootFromParent_Done,
     /*  40053 */   // Label 921: @40053
     /*  40053 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(40089), // Rule ID 1632 //
     /*  40058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  40066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40080 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3773:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQh),
     /*  40083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40087 */     GIR_RootConstrainSelectedInstOperands,
     /*  40088 */     // GIR_Coverage, 1632,
     /*  40088 */     GIR_EraseRootFromParent_Done,
     /*  40089 */   // Label 922: @40089
     /*  40089 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(40125), // Rule ID 1633 //
     /*  40094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40116 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3774:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDf),
     /*  40119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40123 */     GIR_RootConstrainSelectedInstOperands,
     /*  40124 */     // GIR_Coverage, 1633,
     /*  40124 */     GIR_EraseRootFromParent_Done,
     /*  40125 */   // Label 923: @40125
     /*  40125 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(40161), // Rule ID 1634 //
     /*  40130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40152 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3774:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQf),
     /*  40155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40159 */     GIR_RootConstrainSelectedInstOperands,
     /*  40160 */     // GIR_Coverage, 1634,
     /*  40160 */     GIR_EraseRootFromParent_Done,
     /*  40161 */   // Label 924: @40161
     /*  40161 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(40197), // Rule ID 1635 //
     /*  40166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40188 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3775:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDf),
     /*  40191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40195 */     GIR_RootConstrainSelectedInstOperands,
     /*  40196 */     // GIR_Coverage, 1635,
     /*  40196 */     GIR_EraseRootFromParent_Done,
     /*  40197 */   // Label 925: @40197
     /*  40197 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(40233), // Rule ID 1636 //
     /*  40202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40224 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3775:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQf),
     /*  40227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40231 */     GIR_RootConstrainSelectedInstOperands,
     /*  40232 */     // GIR_Coverage, 1636,
     /*  40232 */     GIR_EraseRootFromParent_Done,
     /*  40233 */   // Label 926: @40233
     /*  40233 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(40269), // Rule ID 1637 //
     /*  40238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40260 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3774:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDh),
     /*  40263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40267 */     GIR_RootConstrainSelectedInstOperands,
     /*  40268 */     // GIR_Coverage, 1637,
     /*  40268 */     GIR_EraseRootFromParent_Done,
     /*  40269 */   // Label 927: @40269
     /*  40269 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(40305), // Rule ID 1638 //
     /*  40274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  40282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40296 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3774:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQh),
     /*  40299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40303 */     GIR_RootConstrainSelectedInstOperands,
     /*  40304 */     // GIR_Coverage, 1638,
     /*  40304 */     GIR_EraseRootFromParent_Done,
     /*  40305 */   // Label 928: @40305
     /*  40305 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(40341), // Rule ID 1639 //
     /*  40310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40332 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3775:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDh),
     /*  40335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40339 */     GIR_RootConstrainSelectedInstOperands,
     /*  40340 */     // GIR_Coverage, 1639,
     /*  40340 */     GIR_EraseRootFromParent_Done,
     /*  40341 */   // Label 929: @40341
     /*  40341 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(40377), // Rule ID 1640 //
     /*  40346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  40354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40368 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3775:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQh),
     /*  40371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40375 */     GIR_RootConstrainSelectedInstOperands,
     /*  40376 */     // GIR_Coverage, 1640,
     /*  40376 */     GIR_EraseRootFromParent_Done,
     /*  40377 */   // Label 930: @40377
     /*  40377 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(40413), // Rule ID 1641 //
     /*  40382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40404 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3770:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDf),
     /*  40407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40411 */     GIR_RootConstrainSelectedInstOperands,
     /*  40412 */     // GIR_Coverage, 1641,
     /*  40412 */     GIR_EraseRootFromParent_Done,
     /*  40413 */   // Label 931: @40413
     /*  40413 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(40449), // Rule ID 1642 //
     /*  40418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40440 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3770:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQf),
     /*  40443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40447 */     GIR_RootConstrainSelectedInstOperands,
     /*  40448 */     // GIR_Coverage, 1642,
     /*  40448 */     GIR_EraseRootFromParent_Done,
     /*  40449 */   // Label 932: @40449
     /*  40449 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(40485), // Rule ID 1643 //
     /*  40454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40476 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3771:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDf),
     /*  40479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40483 */     GIR_RootConstrainSelectedInstOperands,
     /*  40484 */     // GIR_Coverage, 1643,
     /*  40484 */     GIR_EraseRootFromParent_Done,
     /*  40485 */   // Label 933: @40485
     /*  40485 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(40521), // Rule ID 1644 //
     /*  40490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40512 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3771:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQf),
     /*  40515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40519 */     GIR_RootConstrainSelectedInstOperands,
     /*  40520 */     // GIR_Coverage, 1644,
     /*  40520 */     GIR_EraseRootFromParent_Done,
     /*  40521 */   // Label 934: @40521
     /*  40521 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(40557), // Rule ID 1645 //
     /*  40526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40548 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3770:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDh),
     /*  40551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40555 */     GIR_RootConstrainSelectedInstOperands,
     /*  40556 */     // GIR_Coverage, 1645,
     /*  40556 */     GIR_EraseRootFromParent_Done,
     /*  40557 */   // Label 935: @40557
     /*  40557 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(40593), // Rule ID 1646 //
     /*  40562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40584 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3770:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQh),
     /*  40587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40591 */     GIR_RootConstrainSelectedInstOperands,
     /*  40592 */     // GIR_Coverage, 1646,
     /*  40592 */     GIR_EraseRootFromParent_Done,
     /*  40593 */   // Label 936: @40593
     /*  40593 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(40629), // Rule ID 1647 //
     /*  40598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40620 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3771:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDh),
     /*  40623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40627 */     GIR_RootConstrainSelectedInstOperands,
     /*  40628 */     // GIR_Coverage, 1647,
     /*  40628 */     GIR_EraseRootFromParent_Done,
     /*  40629 */   // Label 937: @40629
     /*  40629 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(40665), // Rule ID 1648 //
     /*  40634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40656 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3771:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQh),
     /*  40659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40663 */     GIR_RootConstrainSelectedInstOperands,
     /*  40664 */     // GIR_Coverage, 1648,
     /*  40664 */     GIR_EraseRootFromParent_Done,
     /*  40665 */   // Label 938: @40665
     /*  40665 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(40710), // Rule ID 1665 //
     /*  40670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2hf),
     /*  40678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40692 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3766:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2h:{ *:[v4i16] } QPR:{ *:[v4f32] }:$Vm)
     /*  40692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /*  40695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40708 */     GIR_RootConstrainSelectedInstOperands,
     /*  40709 */     // GIR_Coverage, 1665,
     /*  40709 */     GIR_EraseRootFromParent_Done,
     /*  40710 */   // Label 939: @40710
     /*  40710 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(40755), // Rule ID 1666 //
     /*  40715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvthf2fp),
     /*  40723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40737 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3769:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4i16] }:$Vm)
     /*  40737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /*  40740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40753 */     GIR_RootConstrainSelectedInstOperands,
     /*  40754 */     // GIR_Coverage, 1666,
     /*  40754 */     GIR_EraseRootFromParent_Done,
     /*  40755 */   // Label 940: @40755
     /*  40755 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(40791), // Rule ID 1714 //
     /*  40760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  40763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesimc),
     /*  40768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  40771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  40774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40782 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3729:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESIMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  40782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESIMC),
     /*  40785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40789 */     GIR_RootConstrainSelectedInstOperands,
     /*  40790 */     // GIR_Coverage, 1714,
     /*  40790 */     GIR_EraseRootFromParent_Done,
     /*  40791 */   // Label 941: @40791
     /*  40791 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(40827), // Rule ID 1715 //
     /*  40796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  40799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesmc),
     /*  40804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  40807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  40810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40818 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3730:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  40818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESMC),
     /*  40821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40825 */     GIR_RootConstrainSelectedInstOperands,
     /*  40826 */     // GIR_Coverage, 1715,
     /*  40826 */     GIR_EraseRootFromParent_Done,
     /*  40827 */   // Label 942: @40827
     /*  40827 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(40875), // Rule ID 1848 //
     /*  40832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  40835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  40840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  40843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  40846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  40850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  40854 */     // (intrinsic_wo_chain:{ *:[i32] } 3923:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (SXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  40854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB16),
     /*  40857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  40861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40873 */     GIR_RootConstrainSelectedInstOperands,
     /*  40874 */     // GIR_Coverage, 1848,
     /*  40874 */     GIR_EraseRootFromParent_Done,
     /*  40875 */   // Label 943: @40875
     /*  40875 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(40923), // Rule ID 2096 //
     /*  40880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  40883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  40888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  40891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  40894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  40898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  40902 */     // (intrinsic_wo_chain:{ *:[i32] } 3923:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 0:{ *:[i32] })
     /*  40902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB16),
     /*  40905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  40909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40921 */     GIR_RootConstrainSelectedInstOperands,
     /*  40922 */     // GIR_Coverage, 2096,
     /*  40922 */     GIR_EraseRootFromParent_Done,
     /*  40923 */   // Label 944: @40923
     /*  40923 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(40989), // Rule ID 3645 //
     /*  40928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  40931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  40936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  40939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  40942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  40946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  40950 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3612:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLSs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /*  40950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  40953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs8),
     /*  40965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  40967 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  40969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  40972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40987 */     GIR_RootConstrainSelectedInstOperands,
     /*  40988 */     // GIR_Coverage, 3645,
     /*  40988 */     GIR_EraseRootFromParent_Done,
     /*  40989 */   // Label 945: @40989
     /*  40989 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(41055), // Rule ID 3647 //
     /*  40994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  40997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41016 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3612:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLSs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /*  41016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs16),
     /*  41031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41033 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41053 */     GIR_RootConstrainSelectedInstOperands,
     /*  41054 */     // GIR_Coverage, 3647,
     /*  41054 */     GIR_EraseRootFromParent_Done,
     /*  41055 */   // Label 946: @41055
     /*  41055 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(41121), // Rule ID 3649 //
     /*  41060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41082 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3612:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLSs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /*  41082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs32),
     /*  41097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41099 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41119 */     GIR_RootConstrainSelectedInstOperands,
     /*  41120 */     // GIR_Coverage, 3649,
     /*  41120 */     GIR_EraseRootFromParent_Done,
     /*  41121 */   // Label 947: @41121
     /*  41121 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(41172), // Rule ID 4861 //
     /*  41126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp8),
     /*  41134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s1,
     /*  41137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41148 */     // (intrinsic_wo_chain:{ *:[v16i1] } 3620:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP8:{ *:[v16i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP8),
     /*  41151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41170 */     GIR_RootConstrainSelectedInstOperands,
     /*  41171 */     // GIR_Coverage, 4861,
     /*  41171 */     GIR_EraseRootFromParent_Done,
     /*  41172 */   // Label 948: @41172
     /*  41172 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(41223), // Rule ID 4863 //
     /*  41177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp16),
     /*  41185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s1,
     /*  41188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41199 */     // (intrinsic_wo_chain:{ *:[v8i1] } 3617:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP16:{ *:[v8i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP16),
     /*  41202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41221 */     GIR_RootConstrainSelectedInstOperands,
     /*  41222 */     // GIR_Coverage, 4863,
     /*  41222 */     GIR_EraseRootFromParent_Done,
     /*  41223 */   // Label 949: @41223
     /*  41223 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(41274), // Rule ID 4865 //
     /*  41228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp32),
     /*  41236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s1,
     /*  41239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41250 */     // (intrinsic_wo_chain:{ *:[v4i1] } 3618:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP32:{ *:[v4i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP32),
     /*  41253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41272 */     GIR_RootConstrainSelectedInstOperands,
     /*  41273 */     // GIR_Coverage, 4865,
     /*  41273 */     GIR_EraseRootFromParent_Done,
     /*  41274 */   // Label 950: @41274
     /*  41274 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(41325), // Rule ID 4867 //
     /*  41279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp64),
     /*  41287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s1,
     /*  41290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41301 */     // (intrinsic_wo_chain:{ *:[v2i1] } 3619:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP64:{ *:[v2i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP64),
     /*  41304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41323 */     GIR_RootConstrainSelectedInstOperands,
     /*  41324 */     // GIR_Coverage, 4867,
     /*  41324 */     GIR_EraseRootFromParent_Done,
     /*  41325 */   // Label 951: @41325
     /*  41325 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(41371), // Rule ID 600 //
     /*  41330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tt),
     /*  41338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41345 */     // MIs[0] Rn
     /*  41345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41353 */     // (intrinsic_wo_chain:{ *:[i32] } 3502:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TT),
     /*  41356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41369 */     GIR_RootConstrainSelectedInstOperands,
     /*  41370 */     // GIR_Coverage, 600,
     /*  41370 */     GIR_EraseRootFromParent_Done,
     /*  41371 */   // Label 952: @41371
     /*  41371 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(41417), // Rule ID 601 //
     /*  41376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttt),
     /*  41384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41391 */     // MIs[0] Rn
     /*  41391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41399 */     // (intrinsic_wo_chain:{ *:[i32] } 3505:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTT),
     /*  41402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41415 */     GIR_RootConstrainSelectedInstOperands,
     /*  41416 */     // GIR_Coverage, 601,
     /*  41416 */     GIR_EraseRootFromParent_Done,
     /*  41417 */   // Label 953: @41417
     /*  41417 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(41463), // Rule ID 602 //
     /*  41422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tta),
     /*  41430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41437 */     // MIs[0] Rn
     /*  41437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41445 */     // (intrinsic_wo_chain:{ *:[i32] } 3503:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTA),
     /*  41448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41461 */     GIR_RootConstrainSelectedInstOperands,
     /*  41462 */     // GIR_Coverage, 602,
     /*  41462 */     GIR_EraseRootFromParent_Done,
     /*  41463 */   // Label 954: @41463
     /*  41463 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(41509), // Rule ID 603 //
     /*  41468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttat),
     /*  41476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41483 */     // MIs[0] Rn
     /*  41483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41491 */     // (intrinsic_wo_chain:{ *:[i32] } 3504:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTAT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTAT),
     /*  41494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41507 */     GIR_RootConstrainSelectedInstOperands,
     /*  41508 */     // GIR_Coverage, 603,
     /*  41508 */     GIR_EraseRootFromParent_Done,
     /*  41509 */   // Label 955: @41509
     /*  41509 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(41644), // Rule ID 2690 //
     /*  41514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1h),
     /*  41522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  41532 */     // (intrinsic_wo_chain:{ *:[i32] } 3737:{ *:[iPTR] }, i32:{ *:[i32] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f32] } (SHA1H:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$Rn, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] }), GPR:{ *:[i32] })
     /*  41532 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  41535 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41539 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41544 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  41548 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  41553 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  41556 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  41560 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41565 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  41568 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  41571 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /*  41574 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  41579 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  41584 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  41587 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::SHA1H),
     /*  41591 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41596 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  41601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  41604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41613 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  41620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  41625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /*  41643 */     // GIR_Coverage, 2690,
     /*  41643 */     GIR_EraseRootFromParent_Done,
     /*  41644 */   // Label 956: @41644
     /*  41644 */   GIM_Reject,
     /*  41645 */ // Label 849: @41645
     /*  41645 */ GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(62199),
     /*  41650 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  41653 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(41710), // Rule ID 2114 //
     /*  41658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  41661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  41666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  41675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41687 */     // (intrinsic_wo_chain:{ *:[i32] } 3947:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  41687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB16),
     /*  41690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  41696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41708 */     GIR_RootConstrainSelectedInstOperands,
     /*  41709 */     // GIR_Coverage, 2114,
     /*  41709 */     GIR_EraseRootFromParent_Done,
     /*  41710 */   // Label 958: @41710
     /*  41710 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(41809), // Rule ID 1885 //
     /*  41715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  41718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  41723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  41732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  41744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41765 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  41769 */     // MIs[2] Operand 1
     /*  41769 */     // No operand predicates
     /*  41769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  41773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41777 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  41781 */     // MIs[3] Operand 1
     /*  41781 */     // No operand predicates
     /*  41781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41783 */     // (intrinsic_wo_chain:{ *:[i32] } 3942:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  41783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  41786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  41791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  41795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  41798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41807 */     GIR_RootConstrainSelectedInstOperands,
     /*  41808 */     // GIR_Coverage, 1885,
     /*  41808 */     GIR_EraseRootFromParent_Done,
     /*  41809 */   // Label 959: @41809
     /*  41809 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(41908), // Rule ID 2151 //
     /*  41814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  41817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  41822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  41831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  41843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  41847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41864 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  41868 */     // MIs[2] Operand 1
     /*  41868 */     // No operand predicates
     /*  41868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  41872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  41876 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  41880 */     // MIs[3] Operand 1
     /*  41880 */     // No operand predicates
     /*  41880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  41882 */     // (intrinsic_wo_chain:{ *:[i32] } 3942:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  41882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  41885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  41890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  41894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  41897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41906 */     GIR_RootConstrainSelectedInstOperands,
     /*  41907 */     // GIR_Coverage, 2151,
     /*  41907 */     GIR_EraseRootFromParent_Done,
     /*  41908 */   // Label 960: @41908
     /*  41908 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(41992), // Rule ID 5427 //
     /*  41913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  41916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  41921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  41930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41942 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41945 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  41950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  41954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41959 */     // MIs[1] Rn
     /*  41959 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41970 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn), GPRnopc:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  41970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  41973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  41977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  41981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41990 */     GIR_RootConstrainSelectedInstOperands,
     /*  41991 */     // GIR_Coverage, 5427,
     /*  41991 */     GIR_EraseRootFromParent_Done,
     /*  41992 */   // Label 961: @41992
     /*  41992 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(42076), // Rule ID 5684 //
     /*  41997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42026 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42029 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42043 */     // MIs[1] Rn
     /*  42043 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42054 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42074 */     GIR_RootConstrainSelectedInstOperands,
     /*  42075 */     // GIR_Coverage, 5684,
     /*  42075 */     GIR_EraseRootFromParent_Done,
     /*  42076 */   // Label 962: @42076
     /*  42076 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(42160), // Rule ID 109 //
     /*  42081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42114 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42117 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42131 */     // MIs[1] Rn
     /*  42131 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42138 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42158 */     GIR_RootConstrainSelectedInstOperands,
     /*  42159 */     // GIR_Coverage, 109,
     /*  42159 */     GIR_EraseRootFromParent_Done,
     /*  42160 */   // Label 963: @42160
     /*  42160 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(42244), // Rule ID 110 //
     /*  42165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42198 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42201 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42215 */     // MIs[1] Rn
     /*  42215 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42222 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /*  42225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42242 */     GIR_RootConstrainSelectedInstOperands,
     /*  42243 */     // GIR_Coverage, 110,
     /*  42243 */     GIR_EraseRootFromParent_Done,
     /*  42244 */   // Label 964: @42244
     /*  42244 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(42328), // Rule ID 2129 //
     /*  42249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42282 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42285 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42299 */     // MIs[1] Rn
     /*  42299 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42306 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42326 */     GIR_RootConstrainSelectedInstOperands,
     /*  42327 */     // GIR_Coverage, 2129,
     /*  42327 */     GIR_EraseRootFromParent_Done,
     /*  42328 */   // Label 965: @42328
     /*  42328 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(42412), // Rule ID 2130 //
     /*  42333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42366 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42369 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42383 */     // MIs[1] Rn
     /*  42383 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42390 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /*  42393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42410 */     GIR_RootConstrainSelectedInstOperands,
     /*  42411 */     // GIR_Coverage, 2130,
     /*  42411 */     GIR_EraseRootFromParent_Done,
     /*  42412 */   // Label 966: @42412
     /*  42412 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(42485), // Rule ID 4055 //
     /*  42417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  42425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42446 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3628:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16a),
     /*  42461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42463 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42483 */     GIR_RootConstrainSelectedInstOperands,
     /*  42484 */     // GIR_Coverage, 4055,
     /*  42484 */     GIR_EraseRootFromParent_Done,
     /*  42485 */   // Label 967: @42485
     /*  42485 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(42558), // Rule ID 4057 //
     /*  42490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  42498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42519 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16n),
     /*  42534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42536 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42556 */     GIR_RootConstrainSelectedInstOperands,
     /*  42557 */     // GIR_Coverage, 4057,
     /*  42557 */     GIR_EraseRootFromParent_Done,
     /*  42558 */   // Label 968: @42558
     /*  42558 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(42631), // Rule ID 4059 //
     /*  42563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  42571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42584 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42592 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3634:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16p),
     /*  42607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42609 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42629 */     GIR_RootConstrainSelectedInstOperands,
     /*  42630 */     // GIR_Coverage, 4059,
     /*  42630 */     GIR_EraseRootFromParent_Done,
     /*  42631 */   // Label 969: @42631
     /*  42631 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(42704), // Rule ID 4061 //
     /*  42636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  42644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42665 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3630:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16m),
     /*  42680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42682 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42702 */     GIR_RootConstrainSelectedInstOperands,
     /*  42703 */     // GIR_Coverage, 4061,
     /*  42703 */     GIR_EraseRootFromParent_Done,
     /*  42704 */   // Label 970: @42704
     /*  42704 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(42777), // Rule ID 4063 //
     /*  42709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  42717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  42734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42738 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3628:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16a),
     /*  42753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42755 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42775 */     GIR_RootConstrainSelectedInstOperands,
     /*  42776 */     // GIR_Coverage, 4063,
     /*  42776 */     GIR_EraseRootFromParent_Done,
     /*  42777 */   // Label 971: @42777
     /*  42777 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(42850), // Rule ID 4065 //
     /*  42782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  42790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42803 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  42807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42811 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16n),
     /*  42826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42828 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42848 */     GIR_RootConstrainSelectedInstOperands,
     /*  42849 */     // GIR_Coverage, 4065,
     /*  42849 */     GIR_EraseRootFromParent_Done,
     /*  42850 */   // Label 972: @42850
     /*  42850 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(42923), // Rule ID 4067 //
     /*  42855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  42863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  42880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42884 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3634:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16p),
     /*  42899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42901 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42921 */     GIR_RootConstrainSelectedInstOperands,
     /*  42922 */     // GIR_Coverage, 4067,
     /*  42922 */     GIR_EraseRootFromParent_Done,
     /*  42923 */   // Label 973: @42923
     /*  42923 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(42996), // Rule ID 4069 //
     /*  42928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  42936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  42953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42957 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3630:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16m),
     /*  42972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42974 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42985 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42994 */     GIR_RootConstrainSelectedInstOperands,
     /*  42995 */     // GIR_Coverage, 4069,
     /*  42995 */     GIR_EraseRootFromParent_Done,
     /*  42996 */   // Label 974: @42996
     /*  42996 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(43069), // Rule ID 4071 //
     /*  43001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43030 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3628:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32a),
     /*  43045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43047 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43067 */     GIR_RootConstrainSelectedInstOperands,
     /*  43068 */     // GIR_Coverage, 4071,
     /*  43068 */     GIR_EraseRootFromParent_Done,
     /*  43069 */   // Label 975: @43069
     /*  43069 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(43142), // Rule ID 4073 //
     /*  43074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43103 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32n),
     /*  43118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43120 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43140 */     GIR_RootConstrainSelectedInstOperands,
     /*  43141 */     // GIR_Coverage, 4073,
     /*  43141 */     GIR_EraseRootFromParent_Done,
     /*  43142 */   // Label 976: @43142
     /*  43142 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(43215), // Rule ID 4075 //
     /*  43147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43176 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3634:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32p),
     /*  43191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43193 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43213 */     GIR_RootConstrainSelectedInstOperands,
     /*  43214 */     // GIR_Coverage, 4075,
     /*  43214 */     GIR_EraseRootFromParent_Done,
     /*  43215 */   // Label 977: @43215
     /*  43215 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(43288), // Rule ID 4077 //
     /*  43220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43249 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3630:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32m),
     /*  43264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43266 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43271 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43277 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43286 */     GIR_RootConstrainSelectedInstOperands,
     /*  43287 */     // GIR_Coverage, 4077,
     /*  43287 */     GIR_EraseRootFromParent_Done,
     /*  43288 */   // Label 978: @43288
     /*  43288 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(43361), // Rule ID 4079 //
     /*  43293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43322 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3628:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32a),
     /*  43337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43339 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43359 */     GIR_RootConstrainSelectedInstOperands,
     /*  43360 */     // GIR_Coverage, 4079,
     /*  43360 */     GIR_EraseRootFromParent_Done,
     /*  43361 */   // Label 979: @43361
     /*  43361 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(43434), // Rule ID 4081 //
     /*  43366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43395 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32n),
     /*  43410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43412 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43423 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43432 */     GIR_RootConstrainSelectedInstOperands,
     /*  43433 */     // GIR_Coverage, 4081,
     /*  43433 */     GIR_EraseRootFromParent_Done,
     /*  43434 */   // Label 980: @43434
     /*  43434 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(43507), // Rule ID 4083 //
     /*  43439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43468 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3634:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32p),
     /*  43483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43485 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43505 */     GIR_RootConstrainSelectedInstOperands,
     /*  43506 */     // GIR_Coverage, 4083,
     /*  43506 */     GIR_EraseRootFromParent_Done,
     /*  43507 */   // Label 981: @43507
     /*  43507 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(43580), // Rule ID 4085 //
     /*  43512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43541 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3630:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32m),
     /*  43556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43558 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43569 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43578 */     GIR_RootConstrainSelectedInstOperands,
     /*  43579 */     // GIR_Coverage, 4085,
     /*  43579 */     GIR_EraseRootFromParent_Done,
     /*  43580 */   // Label 982: @43580
     /*  43580 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(43653), // Rule ID 4529 //
     /*  43585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  43593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  43599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  43614 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3626:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf32f16bh:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  43614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16bh),
     /*  43629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  43633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43651 */     GIR_RootConstrainSelectedInstOperands,
     /*  43652 */     // GIR_Coverage, 4529,
     /*  43652 */     GIR_EraseRootFromParent_Done,
     /*  43653 */   // Label 983: @43653
     /*  43653 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(43726), // Rule ID 4535 //
     /*  43658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  43666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  43672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  43687 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3626:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf32f16th:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  43687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16th),
     /*  43702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  43706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43724 */     GIR_RootConstrainSelectedInstOperands,
     /*  43725 */     // GIR_Coverage, 4535,
     /*  43725 */     GIR_EraseRootFromParent_Done,
     /*  43726 */   // Label 984: @43726
     /*  43726 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(43794), // Rule ID 1878 //
     /*  43731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  43734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  43739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  43742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  43752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  43756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  43760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  43768 */     // MIs[1] Operand 1
     /*  43768 */     // No operand predicates
     /*  43768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43770 */     // (intrinsic_wo_chain:{ *:[i32] } 3942:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  43770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  43773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  43778 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  43780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  43786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43792 */     GIR_RootConstrainSelectedInstOperands,
     /*  43793 */     // GIR_Coverage, 1878,
     /*  43793 */     GIR_EraseRootFromParent_Done,
     /*  43794 */   // Label 985: @43794
     /*  43794 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(43859), // Rule ID 1882 //
     /*  43799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  43802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  43807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  43810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  43820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  43824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  43828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  43836 */     // MIs[1] Operand 1
     /*  43836 */     // No operand predicates
     /*  43836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43838 */     // (intrinsic_wo_chain:{ *:[i32] } 3943:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPRnopc:{ *:[i32] }:$a)
     /*  43838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT16),
     /*  43841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  43846 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  43848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  43851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43857 */     GIR_RootConstrainSelectedInstOperands,
     /*  43858 */     // GIR_Coverage, 1882,
     /*  43858 */     GIR_EraseRootFromParent_Done,
     /*  43859 */   // Label 986: @43859
     /*  43859 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(43927), // Rule ID 2146 //
     /*  43864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  43867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  43872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  43875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  43885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  43889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  43893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  43901 */     // MIs[1] Operand 1
     /*  43901 */     // No operand predicates
     /*  43901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43903 */     // (intrinsic_wo_chain:{ *:[i32] } 3942:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  43903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  43906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  43911 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  43913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  43919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43925 */     GIR_RootConstrainSelectedInstOperands,
     /*  43926 */     // GIR_Coverage, 2146,
     /*  43926 */     GIR_EraseRootFromParent_Done,
     /*  43927 */   // Label 987: @43927
     /*  43927 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(43992), // Rule ID 2148 //
     /*  43932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  43935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  43940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  43943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  43949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  43953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  43957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  43961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  43969 */     // MIs[1] Operand 1
     /*  43969 */     // No operand predicates
     /*  43969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43971 */     // (intrinsic_wo_chain:{ *:[i32] } 3943:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (t2USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPR:{ *:[i32] }:$a)
     /*  43971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT16),
     /*  43974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  43979 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  43981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  43984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43990 */     GIR_RootConstrainSelectedInstOperands,
     /*  43991 */     // GIR_Coverage, 2148,
     /*  43991 */     GIR_EraseRootFromParent_Done,
     /*  43992 */   // Label 988: @43992
     /*  43992 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(44075), // Rule ID 3925 //
     /*  43997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  44005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  44008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  44031 */     // MIs[1] Operand 1
     /*  44031 */     // No operand predicates
     /*  44031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44033 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3687:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VQSHLU_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  44033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms8),
     /*  44048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44050 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44073 */     GIR_RootConstrainSelectedInstOperands,
     /*  44074 */     // GIR_Coverage, 3925,
     /*  44074 */     GIR_EraseRootFromParent_Done,
     /*  44075 */   // Label 989: @44075
     /*  44075 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(44158), // Rule ID 3927 //
     /*  44080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  44088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44114 */     // MIs[1] Operand 1
     /*  44114 */     // No operand predicates
     /*  44114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44116 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3687:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VQSHLU_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  44116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms16),
     /*  44131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44133 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44147 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44156 */     GIR_RootConstrainSelectedInstOperands,
     /*  44157 */     // GIR_Coverage, 3927,
     /*  44157 */     GIR_EraseRootFromParent_Done,
     /*  44158 */   // Label 990: @44158
     /*  44158 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(44241), // Rule ID 3929 //
     /*  44163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44197 */     // MIs[1] Operand 1
     /*  44197 */     // No operand predicates
     /*  44197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44199 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3687:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VQSHLU_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  44199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms32),
     /*  44214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44216 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44239 */     GIR_RootConstrainSelectedInstOperands,
     /*  44240 */     // GIR_Coverage, 3929,
     /*  44240 */     GIR_EraseRootFromParent_Done,
     /*  44241 */   // Label 991: @44241
     /*  44241 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(44302), // Rule ID 1649 //
     /*  44246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44279 */     // MIs[1] Operand 1
     /*  44279 */     // No operand predicates
     /*  44279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44281 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3764:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsd),
     /*  44284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44300 */     GIR_RootConstrainSelectedInstOperands,
     /*  44301 */     // GIR_Coverage, 1649,
     /*  44301 */     GIR_EraseRootFromParent_Done,
     /*  44302 */   // Label 992: @44302
     /*  44302 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(44363), // Rule ID 1650 //
     /*  44307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44340 */     // MIs[1] Operand 1
     /*  44340 */     // No operand predicates
     /*  44340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44342 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3765:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xud),
     /*  44345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44361 */     GIR_RootConstrainSelectedInstOperands,
     /*  44362 */     // GIR_Coverage, 1650,
     /*  44362 */     GIR_EraseRootFromParent_Done,
     /*  44363 */   // Label 993: @44363
     /*  44363 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(44424), // Rule ID 1651 //
     /*  44368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44401 */     // MIs[1] Operand 1
     /*  44401 */     // No operand predicates
     /*  44401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44403 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3767:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fd),
     /*  44406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44422 */     GIR_RootConstrainSelectedInstOperands,
     /*  44423 */     // GIR_Coverage, 1651,
     /*  44423 */     GIR_EraseRootFromParent_Done,
     /*  44424 */   // Label 994: @44424
     /*  44424 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(44485), // Rule ID 1652 //
     /*  44429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44462 */     // MIs[1] Operand 1
     /*  44462 */     // No operand predicates
     /*  44462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44464 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3768:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fd),
     /*  44467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44483 */     GIR_RootConstrainSelectedInstOperands,
     /*  44484 */     // GIR_Coverage, 1652,
     /*  44484 */     GIR_EraseRootFromParent_Done,
     /*  44485 */   // Label 995: @44485
     /*  44485 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(44546), // Rule ID 1653 //
     /*  44490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44523 */     // MIs[1] Operand 1
     /*  44523 */     // No operand predicates
     /*  44523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44525 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3764:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsd),
     /*  44528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44544 */     GIR_RootConstrainSelectedInstOperands,
     /*  44545 */     // GIR_Coverage, 1653,
     /*  44545 */     GIR_EraseRootFromParent_Done,
     /*  44546 */   // Label 996: @44546
     /*  44546 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(44607), // Rule ID 1654 //
     /*  44551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44584 */     // MIs[1] Operand 1
     /*  44584 */     // No operand predicates
     /*  44584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44586 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3765:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xud),
     /*  44589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44605 */     GIR_RootConstrainSelectedInstOperands,
     /*  44606 */     // GIR_Coverage, 1654,
     /*  44606 */     GIR_EraseRootFromParent_Done,
     /*  44607 */   // Label 997: @44607
     /*  44607 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(44668), // Rule ID 1655 //
     /*  44612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44645 */     // MIs[1] Operand 1
     /*  44645 */     // No operand predicates
     /*  44645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44647 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3767:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hd),
     /*  44650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44666 */     GIR_RootConstrainSelectedInstOperands,
     /*  44667 */     // GIR_Coverage, 1655,
     /*  44667 */     GIR_EraseRootFromParent_Done,
     /*  44668 */   // Label 998: @44668
     /*  44668 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(44729), // Rule ID 1656 //
     /*  44673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44706 */     // MIs[1] Operand 1
     /*  44706 */     // No operand predicates
     /*  44706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44708 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3768:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hd),
     /*  44711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44727 */     GIR_RootConstrainSelectedInstOperands,
     /*  44728 */     // GIR_Coverage, 1656,
     /*  44728 */     GIR_EraseRootFromParent_Done,
     /*  44729 */   // Label 999: @44729
     /*  44729 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(44790), // Rule ID 1657 //
     /*  44734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44767 */     // MIs[1] Operand 1
     /*  44767 */     // No operand predicates
     /*  44767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44769 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3764:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsq),
     /*  44772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44788 */     GIR_RootConstrainSelectedInstOperands,
     /*  44789 */     // GIR_Coverage, 1657,
     /*  44789 */     GIR_EraseRootFromParent_Done,
     /*  44790 */   // Label 1000: @44790
     /*  44790 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(44851), // Rule ID 1658 //
     /*  44795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44828 */     // MIs[1] Operand 1
     /*  44828 */     // No operand predicates
     /*  44828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44830 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3765:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xuq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xuq),
     /*  44833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44849 */     GIR_RootConstrainSelectedInstOperands,
     /*  44850 */     // GIR_Coverage, 1658,
     /*  44850 */     GIR_EraseRootFromParent_Done,
     /*  44851 */   // Label 1001: @44851
     /*  44851 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(44912), // Rule ID 1659 //
     /*  44856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44889 */     // MIs[1] Operand 1
     /*  44889 */     // No operand predicates
     /*  44889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44891 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3767:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fq),
     /*  44894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44910 */     GIR_RootConstrainSelectedInstOperands,
     /*  44911 */     // GIR_Coverage, 1659,
     /*  44911 */     GIR_EraseRootFromParent_Done,
     /*  44912 */   // Label 1002: @44912
     /*  44912 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(44973), // Rule ID 1660 //
     /*  44917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44950 */     // MIs[1] Operand 1
     /*  44950 */     // No operand predicates
     /*  44950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44952 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3768:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fq),
     /*  44955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44971 */     GIR_RootConstrainSelectedInstOperands,
     /*  44972 */     // GIR_Coverage, 1660,
     /*  44972 */     GIR_EraseRootFromParent_Done,
     /*  44973 */   // Label 1003: @44973
     /*  44973 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(45034), // Rule ID 1661 //
     /*  44978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  44989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  44999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45011 */     // MIs[1] Operand 1
     /*  45011 */     // No operand predicates
     /*  45011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45013 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3764:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsq),
     /*  45016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45032 */     GIR_RootConstrainSelectedInstOperands,
     /*  45033 */     // GIR_Coverage, 1661,
     /*  45033 */     GIR_EraseRootFromParent_Done,
     /*  45034 */   // Label 1004: @45034
     /*  45034 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(45095), // Rule ID 1662 //
     /*  45039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45072 */     // MIs[1] Operand 1
     /*  45072 */     // No operand predicates
     /*  45072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45074 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3765:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xuq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xuq),
     /*  45077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45087 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45093 */     GIR_RootConstrainSelectedInstOperands,
     /*  45094 */     // GIR_Coverage, 1662,
     /*  45094 */     GIR_EraseRootFromParent_Done,
     /*  45095 */   // Label 1005: @45095
     /*  45095 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(45156), // Rule ID 1663 //
     /*  45100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45133 */     // MIs[1] Operand 1
     /*  45133 */     // No operand predicates
     /*  45133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45135 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3767:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hq),
     /*  45138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45148 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45154 */     GIR_RootConstrainSelectedInstOperands,
     /*  45155 */     // GIR_Coverage, 1663,
     /*  45155 */     GIR_EraseRootFromParent_Done,
     /*  45156 */   // Label 1006: @45156
     /*  45156 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(45217), // Rule ID 1664 //
     /*  45161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45194 */     // MIs[1] Operand 1
     /*  45194 */     // No operand predicates
     /*  45194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45196 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3768:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hq),
     /*  45199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45215 */     GIR_RootConstrainSelectedInstOperands,
     /*  45216 */     // GIR_Coverage, 1664,
     /*  45216 */     GIR_EraseRootFromParent_Done,
     /*  45217 */   // Label 1007: @45217
     /*  45217 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(45278), // Rule ID 1722 //
     /*  45222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqshl),
     /*  45230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45255 */     // MIs[1] Operand 1
     /*  45255 */     // No operand predicates
     /*  45255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45257 */     // (intrinsic_wo_chain:{ *:[i32] } 3592:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQSHL),
     /*  45260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45262 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45270 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45276 */     GIR_RootConstrainSelectedInstOperands,
     /*  45277 */     // GIR_Coverage, 1722,
     /*  45277 */     GIR_EraseRootFromParent_Done,
     /*  45278 */   // Label 1008: @45278
     /*  45278 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(45339), // Rule ID 1723 //
     /*  45283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_srshr),
     /*  45291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45316 */     // MIs[1] Operand 1
     /*  45316 */     // No operand predicates
     /*  45316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45318 */     // (intrinsic_wo_chain:{ *:[i32] } 3594:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SRSHR),
     /*  45321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45323 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45337 */     GIR_RootConstrainSelectedInstOperands,
     /*  45338 */     // GIR_Coverage, 1723,
     /*  45338 */     GIR_EraseRootFromParent_Done,
     /*  45339 */   // Label 1009: @45339
     /*  45339 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(45400), // Rule ID 1724 //
     /*  45344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqshl),
     /*  45352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45377 */     // MIs[1] Operand 1
     /*  45377 */     // No operand predicates
     /*  45377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45379 */     // (intrinsic_wo_chain:{ *:[i32] } 3599:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_UQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQSHL),
     /*  45382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45384 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45398 */     GIR_RootConstrainSelectedInstOperands,
     /*  45399 */     // GIR_Coverage, 1724,
     /*  45399 */     GIR_EraseRootFromParent_Done,
     /*  45400 */   // Label 1010: @45400
     /*  45400 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(45461), // Rule ID 1725 //
     /*  45405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_urshr),
     /*  45413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45438 */     // MIs[1] Operand 1
     /*  45438 */     // No operand predicates
     /*  45438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45440 */     // (intrinsic_wo_chain:{ *:[i32] } 3601:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_URSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_URSHR),
     /*  45443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45445 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45453 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45459 */     GIR_RootConstrainSelectedInstOperands,
     /*  45460 */     // GIR_Coverage, 1725,
     /*  45460 */     GIR_EraseRootFromParent_Done,
     /*  45461 */   // Label 1011: @45461
     /*  45461 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(45515), // Rule ID 105 //
     /*  45466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  45474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45495 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD8),
     /*  45498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45513 */     GIR_RootConstrainSelectedInstOperands,
     /*  45514 */     // GIR_Coverage, 105,
     /*  45514 */     GIR_EraseRootFromParent_Done,
     /*  45515 */   // Label 1012: @45515
     /*  45515 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(45569), // Rule ID 106 //
     /*  45520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  45528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45549 */     // (intrinsic_wo_chain:{ *:[i32] } 3866:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD16),
     /*  45552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45561 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45567 */     GIR_RootConstrainSelectedInstOperands,
     /*  45568 */     // GIR_Coverage, 106,
     /*  45568 */     GIR_EraseRootFromParent_Done,
     /*  45569 */   // Label 1013: @45569
     /*  45569 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(45623), // Rule ID 107 //
     /*  45574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  45582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45603 */     // (intrinsic_wo_chain:{ *:[i32] } 3871:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB16),
     /*  45606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45621 */     GIR_RootConstrainSelectedInstOperands,
     /*  45622 */     // GIR_Coverage, 107,
     /*  45622 */     GIR_EraseRootFromParent_Done,
     /*  45623 */   // Label 1014: @45623
     /*  45623 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(45677), // Rule ID 108 //
     /*  45628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  45636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45657 */     // (intrinsic_wo_chain:{ *:[i32] } 3872:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB8),
     /*  45660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45675 */     GIR_RootConstrainSelectedInstOperands,
     /*  45676 */     // GIR_Coverage, 108,
     /*  45676 */     GIR_EraseRootFromParent_Done,
     /*  45677 */   // Label 1015: @45677
     /*  45677 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(45731), // Rule ID 111 //
     /*  45682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  45690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45711 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  45711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /*  45714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  45718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  45720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45729 */     GIR_RootConstrainSelectedInstOperands,
     /*  45730 */     // GIR_Coverage, 111,
     /*  45730 */     GIR_EraseRootFromParent_Done,
     /*  45731 */   // Label 1016: @45731
     /*  45731 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(45785), // Rule ID 112 //
     /*  45736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  45744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45765 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  45765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /*  45768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  45772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  45774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45783 */     GIR_RootConstrainSelectedInstOperands,
     /*  45784 */     // GIR_Coverage, 112,
     /*  45784 */     GIR_EraseRootFromParent_Done,
     /*  45785 */   // Label 1017: @45785
     /*  45785 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(45839), // Rule ID 113 //
     /*  45790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  45798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45819 */     // (intrinsic_wo_chain:{ *:[i32] } 3934:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD16),
     /*  45822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45837 */     GIR_RootConstrainSelectedInstOperands,
     /*  45838 */     // GIR_Coverage, 113,
     /*  45838 */     GIR_EraseRootFromParent_Done,
     /*  45839 */   // Label 1018: @45839
     /*  45839 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(45893), // Rule ID 114 //
     /*  45844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  45852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45873 */     // (intrinsic_wo_chain:{ *:[i32] } 3935:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD8),
     /*  45876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45891 */     GIR_RootConstrainSelectedInstOperands,
     /*  45892 */     // GIR_Coverage, 114,
     /*  45892 */     GIR_EraseRootFromParent_Done,
     /*  45893 */   // Label 1019: @45893
     /*  45893 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(45947), // Rule ID 115 //
     /*  45898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  45906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45927 */     // (intrinsic_wo_chain:{ *:[i32] } 3938:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB16),
     /*  45930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45939 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45945 */     GIR_RootConstrainSelectedInstOperands,
     /*  45946 */     // GIR_Coverage, 115,
     /*  45946 */     GIR_EraseRootFromParent_Done,
     /*  45947 */   // Label 1020: @45947
     /*  45947 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(46001), // Rule ID 116 //
     /*  45952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  45960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45981 */     // (intrinsic_wo_chain:{ *:[i32] } 3939:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB8),
     /*  45984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45999 */     GIR_RootConstrainSelectedInstOperands,
     /*  46000 */     // GIR_Coverage, 116,
     /*  46000 */     GIR_EraseRootFromParent_Done,
     /*  46001 */   // Label 1021: @46001
     /*  46001 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(46055), // Rule ID 117 //
     /*  46006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  46014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46035 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QASX),
     /*  46038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46053 */     GIR_RootConstrainSelectedInstOperands,
     /*  46054 */     // GIR_Coverage, 117,
     /*  46054 */     GIR_EraseRootFromParent_Done,
     /*  46055 */   // Label 1022: @46055
     /*  46055 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(46109), // Rule ID 118 //
     /*  46060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  46068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46089 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSAX),
     /*  46092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46107 */     GIR_RootConstrainSelectedInstOperands,
     /*  46108 */     // GIR_Coverage, 118,
     /*  46108 */     GIR_EraseRootFromParent_Done,
     /*  46109 */   // Label 1023: @46109
     /*  46109 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(46163), // Rule ID 119 //
     /*  46114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  46122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46143 */     // (intrinsic_wo_chain:{ *:[i32] } 3936:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQASX),
     /*  46146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46161 */     GIR_RootConstrainSelectedInstOperands,
     /*  46162 */     // GIR_Coverage, 119,
     /*  46162 */     GIR_EraseRootFromParent_Done,
     /*  46163 */   // Label 1024: @46163
     /*  46163 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(46217), // Rule ID 120 //
     /*  46168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  46176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46197 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSAX),
     /*  46200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46215 */     GIR_RootConstrainSelectedInstOperands,
     /*  46216 */     // GIR_Coverage, 120,
     /*  46216 */     GIR_EraseRootFromParent_Done,
     /*  46217 */   // Label 1025: @46217
     /*  46217 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(46271), // Rule ID 133 //
     /*  46222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  46230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46251 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHASX),
     /*  46254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46269 */     GIR_RootConstrainSelectedInstOperands,
     /*  46270 */     // GIR_Coverage, 133,
     /*  46270 */     GIR_EraseRootFromParent_Done,
     /*  46271 */   // Label 1026: @46271
     /*  46271 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(46325), // Rule ID 134 //
     /*  46276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  46284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46305 */     // (intrinsic_wo_chain:{ *:[i32] } 3878:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD16),
     /*  46308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46323 */     GIR_RootConstrainSelectedInstOperands,
     /*  46324 */     // GIR_Coverage, 134,
     /*  46324 */     GIR_EraseRootFromParent_Done,
     /*  46325 */   // Label 1027: @46325
     /*  46325 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(46379), // Rule ID 135 //
     /*  46330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  46338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46359 */     // (intrinsic_wo_chain:{ *:[i32] } 3879:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD8),
     /*  46362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46377 */     GIR_RootConstrainSelectedInstOperands,
     /*  46378 */     // GIR_Coverage, 135,
     /*  46378 */     GIR_EraseRootFromParent_Done,
     /*  46379 */   // Label 1028: @46379
     /*  46379 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(46433), // Rule ID 136 //
     /*  46384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  46392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46413 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSAX),
     /*  46416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46431 */     GIR_RootConstrainSelectedInstOperands,
     /*  46432 */     // GIR_Coverage, 136,
     /*  46432 */     GIR_EraseRootFromParent_Done,
     /*  46433 */   // Label 1029: @46433
     /*  46433 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(46487), // Rule ID 137 //
     /*  46438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  46446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46467 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB16),
     /*  46470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46485 */     GIR_RootConstrainSelectedInstOperands,
     /*  46486 */     // GIR_Coverage, 137,
     /*  46486 */     GIR_EraseRootFromParent_Done,
     /*  46487 */   // Label 1030: @46487
     /*  46487 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(46541), // Rule ID 138 //
     /*  46492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  46500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46521 */     // (intrinsic_wo_chain:{ *:[i32] } 3883:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB8),
     /*  46524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46539 */     GIR_RootConstrainSelectedInstOperands,
     /*  46540 */     // GIR_Coverage, 138,
     /*  46540 */     GIR_EraseRootFromParent_Done,
     /*  46541 */   // Label 1031: @46541
     /*  46541 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(46595), // Rule ID 139 //
     /*  46546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  46554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46575 */     // (intrinsic_wo_chain:{ *:[i32] } 3929:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHASX),
     /*  46578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46593 */     GIR_RootConstrainSelectedInstOperands,
     /*  46594 */     // GIR_Coverage, 139,
     /*  46594 */     GIR_EraseRootFromParent_Done,
     /*  46595 */   // Label 1032: @46595
     /*  46595 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(46649), // Rule ID 140 //
     /*  46600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  46608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46629 */     // (intrinsic_wo_chain:{ *:[i32] } 3927:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD16),
     /*  46632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46647 */     GIR_RootConstrainSelectedInstOperands,
     /*  46648 */     // GIR_Coverage, 140,
     /*  46648 */     GIR_EraseRootFromParent_Done,
     /*  46649 */   // Label 1033: @46649
     /*  46649 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(46703), // Rule ID 141 //
     /*  46654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  46662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46683 */     // (intrinsic_wo_chain:{ *:[i32] } 3928:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD8),
     /*  46686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46701 */     GIR_RootConstrainSelectedInstOperands,
     /*  46702 */     // GIR_Coverage, 141,
     /*  46702 */     GIR_EraseRootFromParent_Done,
     /*  46703 */   // Label 1034: @46703
     /*  46703 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(46757), // Rule ID 142 //
     /*  46708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  46716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46737 */     // (intrinsic_wo_chain:{ *:[i32] } 3930:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSAX),
     /*  46740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46749 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46755 */     GIR_RootConstrainSelectedInstOperands,
     /*  46756 */     // GIR_Coverage, 142,
     /*  46756 */     GIR_EraseRootFromParent_Done,
     /*  46757 */   // Label 1035: @46757
     /*  46757 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(46811), // Rule ID 143 //
     /*  46762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  46770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46791 */     // (intrinsic_wo_chain:{ *:[i32] } 3931:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB16),
     /*  46794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46809 */     GIR_RootConstrainSelectedInstOperands,
     /*  46810 */     // GIR_Coverage, 143,
     /*  46810 */     GIR_EraseRootFromParent_Done,
     /*  46811 */   // Label 1036: @46811
     /*  46811 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(46865), // Rule ID 144 //
     /*  46816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  46824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46845 */     // (intrinsic_wo_chain:{ *:[i32] } 3932:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB8),
     /*  46848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46863 */     GIR_RootConstrainSelectedInstOperands,
     /*  46864 */     // GIR_Coverage, 144,
     /*  46864 */     GIR_EraseRootFromParent_Done,
     /*  46865 */   // Label 1037: @46865
     /*  46865 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(46919), // Rule ID 145 //
     /*  46870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  46873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  46878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  46891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  46895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  46899 */     // (intrinsic_wo_chain:{ *:[i32] } 3940:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (USAD8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  46899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAD8),
     /*  46902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46917 */     GIR_RootConstrainSelectedInstOperands,
     /*  46918 */     // GIR_Coverage, 145,
     /*  46918 */     GIR_EraseRootFromParent_Done,
     /*  46919 */   // Label 1038: @46919
     /*  46919 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(46964), // Rule ID 204 //
     /*  46924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  46927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  46932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46953 */     // (intrinsic_wo_chain:{ *:[i32] } 3506:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32B:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32B),
     /*  46956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46962 */     GIR_RootConstrainSelectedInstOperands,
     /*  46963 */     // GIR_Coverage, 204,
     /*  46963 */     GIR_EraseRootFromParent_Done,
     /*  46964 */   // Label 1039: @46964
     /*  46964 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(47009), // Rule ID 205 //
     /*  46969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  46972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  46977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46998 */     // (intrinsic_wo_chain:{ *:[i32] } 3507:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CB),
     /*  47001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47007 */     GIR_RootConstrainSelectedInstOperands,
     /*  47008 */     // GIR_Coverage, 205,
     /*  47008 */     GIR_EraseRootFromParent_Done,
     /*  47009 */   // Label 1040: @47009
     /*  47009 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(47054), // Rule ID 206 //
     /*  47014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  47022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47043 */     // (intrinsic_wo_chain:{ *:[i32] } 3510:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32H:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32H),
     /*  47046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47052 */     GIR_RootConstrainSelectedInstOperands,
     /*  47053 */     // GIR_Coverage, 206,
     /*  47053 */     GIR_EraseRootFromParent_Done,
     /*  47054 */   // Label 1041: @47054
     /*  47054 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(47099), // Rule ID 207 //
     /*  47059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  47067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47088 */     // (intrinsic_wo_chain:{ *:[i32] } 3508:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CH:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CH),
     /*  47091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47097 */     GIR_RootConstrainSelectedInstOperands,
     /*  47098 */     // GIR_Coverage, 207,
     /*  47098 */     GIR_EraseRootFromParent_Done,
     /*  47099 */   // Label 1042: @47099
     /*  47099 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(47144), // Rule ID 208 //
     /*  47104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  47112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47133 */     // (intrinsic_wo_chain:{ *:[i32] } 3511:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32W:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32W),
     /*  47136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47142 */     GIR_RootConstrainSelectedInstOperands,
     /*  47143 */     // GIR_Coverage, 208,
     /*  47143 */     GIR_EraseRootFromParent_Done,
     /*  47144 */   // Label 1043: @47144
     /*  47144 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(47189), // Rule ID 209 //
     /*  47149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  47157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47178 */     // (intrinsic_wo_chain:{ *:[i32] } 3509:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CW:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CW),
     /*  47181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47187 */     GIR_RootConstrainSelectedInstOperands,
     /*  47188 */     // GIR_Coverage, 209,
     /*  47188 */     GIR_EraseRootFromParent_Done,
     /*  47189 */   // Label 1044: @47189
     /*  47189 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(47243), // Rule ID 432 //
     /*  47194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  47202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47223 */     // (intrinsic_wo_chain:{ *:[i32] } 3866:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD16),
     /*  47226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47241 */     GIR_RootConstrainSelectedInstOperands,
     /*  47242 */     // GIR_Coverage, 432,
     /*  47242 */     GIR_EraseRootFromParent_Done,
     /*  47243 */   // Label 1045: @47243
     /*  47243 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(47297), // Rule ID 433 //
     /*  47248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  47256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47277 */     // (intrinsic_wo_chain:{ *:[i32] } 3867:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD8),
     /*  47280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47295 */     GIR_RootConstrainSelectedInstOperands,
     /*  47296 */     // GIR_Coverage, 433,
     /*  47296 */     GIR_EraseRootFromParent_Done,
     /*  47297 */   // Label 1046: @47297
     /*  47297 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(47351), // Rule ID 434 //
     /*  47302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  47310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47331 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QASX),
     /*  47334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47349 */     GIR_RootConstrainSelectedInstOperands,
     /*  47350 */     // GIR_Coverage, 434,
     /*  47350 */     GIR_EraseRootFromParent_Done,
     /*  47351 */   // Label 1047: @47351
     /*  47351 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(47405), // Rule ID 435 //
     /*  47356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  47364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47385 */     // (intrinsic_wo_chain:{ *:[i32] } 3939:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB8),
     /*  47388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47403 */     GIR_RootConstrainSelectedInstOperands,
     /*  47404 */     // GIR_Coverage, 435,
     /*  47404 */     GIR_EraseRootFromParent_Done,
     /*  47405 */   // Label 1048: @47405
     /*  47405 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(47459), // Rule ID 436 //
     /*  47410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  47418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47439 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSAX),
     /*  47442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47457 */     GIR_RootConstrainSelectedInstOperands,
     /*  47458 */     // GIR_Coverage, 436,
     /*  47458 */     GIR_EraseRootFromParent_Done,
     /*  47459 */   // Label 1049: @47459
     /*  47459 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(47513), // Rule ID 437 //
     /*  47464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  47472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47493 */     // (intrinsic_wo_chain:{ *:[i32] } 3871:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB16),
     /*  47496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47505 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47511 */     GIR_RootConstrainSelectedInstOperands,
     /*  47512 */     // GIR_Coverage, 437,
     /*  47512 */     GIR_EraseRootFromParent_Done,
     /*  47513 */   // Label 1050: @47513
     /*  47513 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(47567), // Rule ID 438 //
     /*  47518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  47526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47547 */     // (intrinsic_wo_chain:{ *:[i32] } 3872:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB8),
     /*  47550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47565 */     GIR_RootConstrainSelectedInstOperands,
     /*  47566 */     // GIR_Coverage, 438,
     /*  47566 */     GIR_EraseRootFromParent_Done,
     /*  47567 */   // Label 1051: @47567
     /*  47567 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(47621), // Rule ID 439 //
     /*  47572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  47580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47601 */     // (intrinsic_wo_chain:{ *:[i32] } 3934:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD16),
     /*  47604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47619 */     GIR_RootConstrainSelectedInstOperands,
     /*  47620 */     // GIR_Coverage, 439,
     /*  47620 */     GIR_EraseRootFromParent_Done,
     /*  47621 */   // Label 1052: @47621
     /*  47621 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(47675), // Rule ID 440 //
     /*  47626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  47634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47655 */     // (intrinsic_wo_chain:{ *:[i32] } 3935:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD8),
     /*  47658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47673 */     GIR_RootConstrainSelectedInstOperands,
     /*  47674 */     // GIR_Coverage, 440,
     /*  47674 */     GIR_EraseRootFromParent_Done,
     /*  47675 */   // Label 1053: @47675
     /*  47675 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(47729), // Rule ID 441 //
     /*  47680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  47688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47709 */     // (intrinsic_wo_chain:{ *:[i32] } 3936:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQASX),
     /*  47712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47727 */     GIR_RootConstrainSelectedInstOperands,
     /*  47728 */     // GIR_Coverage, 441,
     /*  47728 */     GIR_EraseRootFromParent_Done,
     /*  47729 */   // Label 1054: @47729
     /*  47729 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(47783), // Rule ID 442 //
     /*  47734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  47742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47763 */     // (intrinsic_wo_chain:{ *:[i32] } 3937:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSAX),
     /*  47766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47781 */     GIR_RootConstrainSelectedInstOperands,
     /*  47782 */     // GIR_Coverage, 442,
     /*  47782 */     GIR_EraseRootFromParent_Done,
     /*  47783 */   // Label 1055: @47783
     /*  47783 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(47837), // Rule ID 443 //
     /*  47788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  47796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47817 */     // (intrinsic_wo_chain:{ *:[i32] } 3938:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB16),
     /*  47820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47835 */     GIR_RootConstrainSelectedInstOperands,
     /*  47836 */     // GIR_Coverage, 443,
     /*  47836 */     GIR_EraseRootFromParent_Done,
     /*  47837 */   // Label 1056: @47837
     /*  47837 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(47891), // Rule ID 456 //
     /*  47842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  47850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47871 */     // (intrinsic_wo_chain:{ *:[i32] } 3880:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHASX),
     /*  47874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47889 */     GIR_RootConstrainSelectedInstOperands,
     /*  47890 */     // GIR_Coverage, 456,
     /*  47890 */     GIR_EraseRootFromParent_Done,
     /*  47891 */   // Label 1057: @47891
     /*  47891 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(47945), // Rule ID 457 //
     /*  47896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  47904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47925 */     // (intrinsic_wo_chain:{ *:[i32] } 3878:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD16),
     /*  47928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47943 */     GIR_RootConstrainSelectedInstOperands,
     /*  47944 */     // GIR_Coverage, 457,
     /*  47944 */     GIR_EraseRootFromParent_Done,
     /*  47945 */   // Label 1058: @47945
     /*  47945 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(47999), // Rule ID 458 //
     /*  47950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  47958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47979 */     // (intrinsic_wo_chain:{ *:[i32] } 3879:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD8),
     /*  47982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47997 */     GIR_RootConstrainSelectedInstOperands,
     /*  47998 */     // GIR_Coverage, 458,
     /*  47998 */     GIR_EraseRootFromParent_Done,
     /*  47999 */   // Label 1059: @47999
     /*  47999 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(48053), // Rule ID 459 //
     /*  48004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  48012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48033 */     // (intrinsic_wo_chain:{ *:[i32] } 3881:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSAX),
     /*  48036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48051 */     GIR_RootConstrainSelectedInstOperands,
     /*  48052 */     // GIR_Coverage, 459,
     /*  48052 */     GIR_EraseRootFromParent_Done,
     /*  48053 */   // Label 1060: @48053
     /*  48053 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(48107), // Rule ID 460 //
     /*  48058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  48066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48087 */     // (intrinsic_wo_chain:{ *:[i32] } 3882:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB16),
     /*  48090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48105 */     GIR_RootConstrainSelectedInstOperands,
     /*  48106 */     // GIR_Coverage, 460,
     /*  48106 */     GIR_EraseRootFromParent_Done,
     /*  48107 */   // Label 1061: @48107
     /*  48107 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(48161), // Rule ID 461 //
     /*  48112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  48120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48141 */     // (intrinsic_wo_chain:{ *:[i32] } 3883:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB8),
     /*  48144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48159 */     GIR_RootConstrainSelectedInstOperands,
     /*  48160 */     // GIR_Coverage, 461,
     /*  48160 */     GIR_EraseRootFromParent_Done,
     /*  48161 */   // Label 1062: @48161
     /*  48161 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(48215), // Rule ID 462 //
     /*  48166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  48174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48195 */     // (intrinsic_wo_chain:{ *:[i32] } 3929:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHASX),
     /*  48198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48213 */     GIR_RootConstrainSelectedInstOperands,
     /*  48214 */     // GIR_Coverage, 462,
     /*  48214 */     GIR_EraseRootFromParent_Done,
     /*  48215 */   // Label 1063: @48215
     /*  48215 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(48269), // Rule ID 463 //
     /*  48220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  48228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48249 */     // (intrinsic_wo_chain:{ *:[i32] } 3927:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD16),
     /*  48252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48267 */     GIR_RootConstrainSelectedInstOperands,
     /*  48268 */     // GIR_Coverage, 463,
     /*  48268 */     GIR_EraseRootFromParent_Done,
     /*  48269 */   // Label 1064: @48269
     /*  48269 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(48323), // Rule ID 464 //
     /*  48274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  48282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48303 */     // (intrinsic_wo_chain:{ *:[i32] } 3928:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD8),
     /*  48306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48315 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48321 */     GIR_RootConstrainSelectedInstOperands,
     /*  48322 */     // GIR_Coverage, 464,
     /*  48322 */     GIR_EraseRootFromParent_Done,
     /*  48323 */   // Label 1065: @48323
     /*  48323 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(48377), // Rule ID 465 //
     /*  48328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  48336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48357 */     // (intrinsic_wo_chain:{ *:[i32] } 3930:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSAX),
     /*  48360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48375 */     GIR_RootConstrainSelectedInstOperands,
     /*  48376 */     // GIR_Coverage, 465,
     /*  48376 */     GIR_EraseRootFromParent_Done,
     /*  48377 */   // Label 1066: @48377
     /*  48377 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(48431), // Rule ID 466 //
     /*  48382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  48390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48411 */     // (intrinsic_wo_chain:{ *:[i32] } 3931:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB16),
     /*  48414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48423 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48429 */     GIR_RootConstrainSelectedInstOperands,
     /*  48430 */     // GIR_Coverage, 466,
     /*  48430 */     GIR_EraseRootFromParent_Done,
     /*  48431 */   // Label 1067: @48431
     /*  48431 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(48485), // Rule ID 467 //
     /*  48436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  48444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48465 */     // (intrinsic_wo_chain:{ *:[i32] } 3932:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB8),
     /*  48468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48483 */     GIR_RootConstrainSelectedInstOperands,
     /*  48484 */     // GIR_Coverage, 467,
     /*  48484 */     GIR_EraseRootFromParent_Done,
     /*  48485 */   // Label 1068: @48485
     /*  48485 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(48539), // Rule ID 468 //
     /*  48490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  48498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48519 */     // (intrinsic_wo_chain:{ *:[i32] } 3940:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAD8),
     /*  48522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48537 */     GIR_RootConstrainSelectedInstOperands,
     /*  48538 */     // GIR_Coverage, 468,
     /*  48538 */     GIR_EraseRootFromParent_Done,
     /*  48539 */   // Label 1069: @48539
     /*  48539 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(48593), // Rule ID 524 //
     /*  48544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  48552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48573 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUAD),
     /*  48576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48591 */     GIR_RootConstrainSelectedInstOperands,
     /*  48592 */     // GIR_Coverage, 524,
     /*  48592 */     GIR_EraseRootFromParent_Done,
     /*  48593 */   // Label 1070: @48593
     /*  48593 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(48647), // Rule ID 525 //
     /*  48598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  48606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48627 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUADX),
     /*  48630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48639 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48645 */     GIR_RootConstrainSelectedInstOperands,
     /*  48646 */     // GIR_Coverage, 525,
     /*  48646 */     GIR_EraseRootFromParent_Done,
     /*  48647 */   // Label 1071: @48647
     /*  48647 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(48701), // Rule ID 526 //
     /*  48652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  48660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48681 */     // (intrinsic_wo_chain:{ *:[i32] } 3906:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSD),
     /*  48684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48699 */     GIR_RootConstrainSelectedInstOperands,
     /*  48700 */     // GIR_Coverage, 526,
     /*  48700 */     GIR_EraseRootFromParent_Done,
     /*  48701 */   // Label 1072: @48701
     /*  48701 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(48755), // Rule ID 527 //
     /*  48706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  48714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48735 */     // (intrinsic_wo_chain:{ *:[i32] } 3907:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSDX),
     /*  48738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48753 */     GIR_RootConstrainSelectedInstOperands,
     /*  48754 */     // GIR_Coverage, 527,
     /*  48754 */     GIR_EraseRootFromParent_Done,
     /*  48755 */   // Label 1073: @48755
     /*  48755 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(48800), // Rule ID 541 //
     /*  48760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  48763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  48768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48789 */     // (intrinsic_wo_chain:{ *:[i32] } 3506:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32B:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32B),
     /*  48792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48798 */     GIR_RootConstrainSelectedInstOperands,
     /*  48799 */     // GIR_Coverage, 541,
     /*  48799 */     GIR_EraseRootFromParent_Done,
     /*  48800 */   // Label 1074: @48800
     /*  48800 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(48845), // Rule ID 542 //
     /*  48805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  48808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  48813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48834 */     // (intrinsic_wo_chain:{ *:[i32] } 3507:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CB),
     /*  48837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48843 */     GIR_RootConstrainSelectedInstOperands,
     /*  48844 */     // GIR_Coverage, 542,
     /*  48844 */     GIR_EraseRootFromParent_Done,
     /*  48845 */   // Label 1075: @48845
     /*  48845 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(48890), // Rule ID 543 //
     /*  48850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  48853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  48858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48879 */     // (intrinsic_wo_chain:{ *:[i32] } 3510:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32H:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32H),
     /*  48882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48888 */     GIR_RootConstrainSelectedInstOperands,
     /*  48889 */     // GIR_Coverage, 543,
     /*  48889 */     GIR_EraseRootFromParent_Done,
     /*  48890 */   // Label 1076: @48890
     /*  48890 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(48935), // Rule ID 544 //
     /*  48895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  48898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  48903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48924 */     // (intrinsic_wo_chain:{ *:[i32] } 3508:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CH),
     /*  48927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48933 */     GIR_RootConstrainSelectedInstOperands,
     /*  48934 */     // GIR_Coverage, 544,
     /*  48934 */     GIR_EraseRootFromParent_Done,
     /*  48935 */   // Label 1077: @48935
     /*  48935 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(48980), // Rule ID 545 //
     /*  48940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  48943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  48948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48969 */     // (intrinsic_wo_chain:{ *:[i32] } 3511:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32W:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32W),
     /*  48972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48978 */     GIR_RootConstrainSelectedInstOperands,
     /*  48979 */     // GIR_Coverage, 545,
     /*  48979 */     GIR_EraseRootFromParent_Done,
     /*  48980 */   // Label 1078: @48980
     /*  48980 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(49025), // Rule ID 546 //
     /*  48985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  48988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  48993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49014 */     // (intrinsic_wo_chain:{ *:[i32] } 3509:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CW:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CW),
     /*  49017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49023 */     GIR_RootConstrainSelectedInstOperands,
     /*  49024 */     // GIR_Coverage, 546,
     /*  49024 */     GIR_EraseRootFromParent_Done,
     /*  49025 */   // Label 1079: @49025
     /*  49025 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(49079), // Rule ID 789 //
     /*  49030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49059 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3776:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i16),
     /*  49062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49071 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49077 */     GIR_RootConstrainSelectedInstOperands,
     /*  49078 */     // GIR_Coverage, 789,
     /*  49078 */     GIR_EraseRootFromParent_Done,
     /*  49079 */   // Label 1080: @49079
     /*  49079 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(49133), // Rule ID 790 //
     /*  49084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49113 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3776:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv2i32),
     /*  49116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49131 */     GIR_RootConstrainSelectedInstOperands,
     /*  49132 */     // GIR_Coverage, 790,
     /*  49132 */     GIR_EraseRootFromParent_Done,
     /*  49133 */   // Label 1081: @49133
     /*  49133 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(49187), // Rule ID 791 //
     /*  49138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49167 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3776:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i16),
     /*  49170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49185 */     GIR_RootConstrainSelectedInstOperands,
     /*  49186 */     // GIR_Coverage, 791,
     /*  49186 */     GIR_EraseRootFromParent_Done,
     /*  49187 */   // Label 1082: @49187
     /*  49187 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(49241), // Rule ID 792 //
     /*  49192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49221 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3776:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i32),
     /*  49224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49239 */     GIR_RootConstrainSelectedInstOperands,
     /*  49240 */     // GIR_Coverage, 792,
     /*  49240 */     GIR_EraseRootFromParent_Done,
     /*  49241 */   // Label 1083: @49241
     /*  49241 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(49295), // Rule ID 793 //
     /*  49246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49275 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3776:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i8),
     /*  49278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49293 */     GIR_RootConstrainSelectedInstOperands,
     /*  49294 */     // GIR_Coverage, 793,
     /*  49294 */     GIR_EraseRootFromParent_Done,
     /*  49295 */   // Label 1084: @49295
     /*  49295 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(49349), // Rule ID 794 //
     /*  49300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49329 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3776:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv16i8),
     /*  49332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49341 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49347 */     GIR_RootConstrainSelectedInstOperands,
     /*  49348 */     // GIR_Coverage, 794,
     /*  49348 */     GIR_EraseRootFromParent_Done,
     /*  49349 */   // Label 1085: @49349
     /*  49349 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(49403), // Rule ID 795 //
     /*  49354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49383 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3777:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i16),
     /*  49386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49395 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49401 */     GIR_RootConstrainSelectedInstOperands,
     /*  49402 */     // GIR_Coverage, 795,
     /*  49402 */     GIR_EraseRootFromParent_Done,
     /*  49403 */   // Label 1086: @49403
     /*  49403 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(49457), // Rule ID 796 //
     /*  49408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49437 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3777:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv2i32),
     /*  49440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49455 */     GIR_RootConstrainSelectedInstOperands,
     /*  49456 */     // GIR_Coverage, 796,
     /*  49456 */     GIR_EraseRootFromParent_Done,
     /*  49457 */   // Label 1087: @49457
     /*  49457 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(49511), // Rule ID 797 //
     /*  49462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49491 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3777:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i16),
     /*  49494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49509 */     GIR_RootConstrainSelectedInstOperands,
     /*  49510 */     // GIR_Coverage, 797,
     /*  49510 */     GIR_EraseRootFromParent_Done,
     /*  49511 */   // Label 1088: @49511
     /*  49511 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(49565), // Rule ID 798 //
     /*  49516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49545 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3777:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i32),
     /*  49548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49563 */     GIR_RootConstrainSelectedInstOperands,
     /*  49564 */     // GIR_Coverage, 798,
     /*  49564 */     GIR_EraseRootFromParent_Done,
     /*  49565 */   // Label 1089: @49565
     /*  49565 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(49619), // Rule ID 799 //
     /*  49570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49599 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3777:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i8),
     /*  49602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49617 */     GIR_RootConstrainSelectedInstOperands,
     /*  49618 */     // GIR_Coverage, 799,
     /*  49618 */     GIR_EraseRootFromParent_Done,
     /*  49619 */   // Label 1090: @49619
     /*  49619 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(49673), // Rule ID 800 //
     /*  49624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49653 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3777:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv16i8),
     /*  49656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49665 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49671 */     GIR_RootConstrainSelectedInstOperands,
     /*  49672 */     // GIR_Coverage, 800,
     /*  49672 */     GIR_EraseRootFromParent_Done,
     /*  49673 */   // Label 1091: @49673
     /*  49673 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(49727), // Rule ID 801 //
     /*  49678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  49686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49707 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3836:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i16),
     /*  49710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49719 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49725 */     GIR_RootConstrainSelectedInstOperands,
     /*  49726 */     // GIR_Coverage, 801,
     /*  49726 */     GIR_EraseRootFromParent_Done,
     /*  49727 */   // Label 1092: @49727
     /*  49727 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(49781), // Rule ID 802 //
     /*  49732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  49740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49761 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3836:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv2i32),
     /*  49764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49779 */     GIR_RootConstrainSelectedInstOperands,
     /*  49780 */     // GIR_Coverage, 802,
     /*  49780 */     GIR_EraseRootFromParent_Done,
     /*  49781 */   // Label 1093: @49781
     /*  49781 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(49835), // Rule ID 803 //
     /*  49786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  49794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49815 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3836:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i16),
     /*  49818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49833 */     GIR_RootConstrainSelectedInstOperands,
     /*  49834 */     // GIR_Coverage, 803,
     /*  49834 */     GIR_EraseRootFromParent_Done,
     /*  49835 */   // Label 1094: @49835
     /*  49835 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(49889), // Rule ID 804 //
     /*  49840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  49848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49869 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3836:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i32),
     /*  49872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49881 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49887 */     GIR_RootConstrainSelectedInstOperands,
     /*  49888 */     // GIR_Coverage, 804,
     /*  49888 */     GIR_EraseRootFromParent_Done,
     /*  49889 */   // Label 1095: @49889
     /*  49889 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(49943), // Rule ID 805 //
     /*  49894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  49902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49923 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3836:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i8),
     /*  49926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49941 */     GIR_RootConstrainSelectedInstOperands,
     /*  49942 */     // GIR_Coverage, 805,
     /*  49942 */     GIR_EraseRootFromParent_Done,
     /*  49943 */   // Label 1096: @49943
     /*  49943 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(49997), // Rule ID 806 //
     /*  49948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  49956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49977 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3836:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv16i8),
     /*  49980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49995 */     GIR_RootConstrainSelectedInstOperands,
     /*  49996 */     // GIR_Coverage, 806,
     /*  49996 */     GIR_EraseRootFromParent_Done,
     /*  49997 */   // Label 1097: @49997
     /*  49997 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(50051), // Rule ID 807 //
     /*  50002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50031 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3837:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i16),
     /*  50034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50049 */     GIR_RootConstrainSelectedInstOperands,
     /*  50050 */     // GIR_Coverage, 807,
     /*  50050 */     GIR_EraseRootFromParent_Done,
     /*  50051 */   // Label 1098: @50051
     /*  50051 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(50105), // Rule ID 808 //
     /*  50056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50085 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3837:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv2i32),
     /*  50088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50097 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50103 */     GIR_RootConstrainSelectedInstOperands,
     /*  50104 */     // GIR_Coverage, 808,
     /*  50104 */     GIR_EraseRootFromParent_Done,
     /*  50105 */   // Label 1099: @50105
     /*  50105 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(50159), // Rule ID 809 //
     /*  50110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50139 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3837:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i16),
     /*  50142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50151 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50157 */     GIR_RootConstrainSelectedInstOperands,
     /*  50158 */     // GIR_Coverage, 809,
     /*  50158 */     GIR_EraseRootFromParent_Done,
     /*  50159 */   // Label 1100: @50159
     /*  50159 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(50213), // Rule ID 810 //
     /*  50164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50193 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3837:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i32),
     /*  50196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50205 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50211 */     GIR_RootConstrainSelectedInstOperands,
     /*  50212 */     // GIR_Coverage, 810,
     /*  50212 */     GIR_EraseRootFromParent_Done,
     /*  50213 */   // Label 1101: @50213
     /*  50213 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(50267), // Rule ID 811 //
     /*  50218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50247 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3837:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i8),
     /*  50250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50265 */     GIR_RootConstrainSelectedInstOperands,
     /*  50266 */     // GIR_Coverage, 811,
     /*  50266 */     GIR_EraseRootFromParent_Done,
     /*  50267 */   // Label 1102: @50267
     /*  50267 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(50321), // Rule ID 812 //
     /*  50272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50301 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3837:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv16i8),
     /*  50304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50319 */     GIR_RootConstrainSelectedInstOperands,
     /*  50320 */     // GIR_Coverage, 812,
     /*  50320 */     GIR_EraseRootFromParent_Done,
     /*  50321 */   // Label 1103: @50321
     /*  50321 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(50375), // Rule ID 829 //
     /*  50326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50355 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3833:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRADDHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv8i8),
     /*  50358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50373 */     GIR_RootConstrainSelectedInstOperands,
     /*  50374 */     // GIR_Coverage, 829,
     /*  50374 */     GIR_EraseRootFromParent_Done,
     /*  50375 */   // Label 1104: @50375
     /*  50375 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(50429), // Rule ID 830 //
     /*  50380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50409 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3833:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRADDHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv4i16),
     /*  50412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50421 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50427 */     GIR_RootConstrainSelectedInstOperands,
     /*  50428 */     // GIR_Coverage, 830,
     /*  50428 */     GIR_EraseRootFromParent_Done,
     /*  50429 */   // Label 1105: @50429
     /*  50429 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(50483), // Rule ID 831 //
     /*  50434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  50448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  50451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50463 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3833:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRADDHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  50463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv2i32),
     /*  50466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50481 */     GIR_RootConstrainSelectedInstOperands,
     /*  50482 */     // GIR_Coverage, 831,
     /*  50482 */     GIR_EraseRootFromParent_Done,
     /*  50483 */   // Label 1106: @50483
     /*  50483 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(50537), // Rule ID 838 //
     /*  50488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  50496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50517 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3802:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULpd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpd),
     /*  50520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50535 */     GIR_RootConstrainSelectedInstOperands,
     /*  50536 */     // GIR_Coverage, 838,
     /*  50536 */     GIR_EraseRootFromParent_Done,
     /*  50537 */   // Label 1107: @50537
     /*  50537 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(50591), // Rule ID 839 //
     /*  50542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  50550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50571 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3802:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULpq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpq),
     /*  50574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50589 */     GIR_RootConstrainSelectedInstOperands,
     /*  50590 */     // GIR_Coverage, 839,
     /*  50590 */     GIR_EraseRootFromParent_Done,
     /*  50591 */   // Label 1108: @50591
     /*  50591 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(50645), // Rule ID 852 //
     /*  50596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  50604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50625 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3813:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i16),
     /*  50628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50643 */     GIR_RootConstrainSelectedInstOperands,
     /*  50644 */     // GIR_Coverage, 852,
     /*  50644 */     GIR_EraseRootFromParent_Done,
     /*  50645 */   // Label 1109: @50645
     /*  50645 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(50699), // Rule ID 853 //
     /*  50650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  50658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50679 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3813:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv2i32),
     /*  50682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50697 */     GIR_RootConstrainSelectedInstOperands,
     /*  50698 */     // GIR_Coverage, 853,
     /*  50698 */     GIR_EraseRootFromParent_Done,
     /*  50699 */   // Label 1110: @50699
     /*  50699 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(50753), // Rule ID 854 //
     /*  50704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  50712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50733 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3813:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv8i16),
     /*  50736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50751 */     GIR_RootConstrainSelectedInstOperands,
     /*  50752 */     // GIR_Coverage, 854,
     /*  50752 */     GIR_EraseRootFromParent_Done,
     /*  50753 */   // Label 1111: @50753
     /*  50753 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(50807), // Rule ID 855 //
     /*  50758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  50766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50787 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3813:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i32),
     /*  50790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50805 */     GIR_RootConstrainSelectedInstOperands,
     /*  50806 */     // GIR_Coverage, 855,
     /*  50806 */     GIR_EraseRootFromParent_Done,
     /*  50807 */   // Label 1112: @50807
     /*  50807 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(50861), // Rule ID 860 //
     /*  50812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  50820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50841 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3821:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i16),
     /*  50844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50859 */     GIR_RootConstrainSelectedInstOperands,
     /*  50860 */     // GIR_Coverage, 860,
     /*  50860 */     GIR_EraseRootFromParent_Done,
     /*  50861 */   // Label 1113: @50861
     /*  50861 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(50915), // Rule ID 861 //
     /*  50866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  50874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50895 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3821:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv2i32),
     /*  50898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50907 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50913 */     GIR_RootConstrainSelectedInstOperands,
     /*  50914 */     // GIR_Coverage, 861,
     /*  50914 */     GIR_EraseRootFromParent_Done,
     /*  50915 */   // Label 1114: @50915
     /*  50915 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(50969), // Rule ID 862 //
     /*  50920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  50928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50949 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3821:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv8i16),
     /*  50952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50967 */     GIR_RootConstrainSelectedInstOperands,
     /*  50968 */     // GIR_Coverage, 862,
     /*  50968 */     GIR_EraseRootFromParent_Done,
     /*  50969 */   // Label 1115: @50969
     /*  50969 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(51023), // Rule ID 863 //
     /*  50974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  50982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51003 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3821:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i32),
     /*  51006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51015 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51021 */     GIR_RootConstrainSelectedInstOperands,
     /*  51022 */     // GIR_Coverage, 863,
     /*  51022 */     GIR_EraseRootFromParent_Done,
     /*  51023 */   // Label 1116: @51023
     /*  51023 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(51077), // Rule ID 874 //
     /*  51028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51057 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3799:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULLp8:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp8),
     /*  51060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51069 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51075 */     GIR_RootConstrainSelectedInstOperands,
     /*  51076 */     // GIR_Coverage, 874,
     /*  51076 */     GIR_EraseRootFromParent_Done,
     /*  51077 */   // Label 1117: @51077
     /*  51077 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(51122), // Rule ID 875 //
     /*  51082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  51085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  51096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  51099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51111 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3799:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VMULLp64:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  51111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp64),
     /*  51114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51120 */     GIR_RootConstrainSelectedInstOperands,
     /*  51121 */     // GIR_Coverage, 875,
     /*  51121 */     GIR_EraseRootFromParent_Done,
     /*  51122 */   // Label 1118: @51122
     /*  51122 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(51176), // Rule ID 880 //
     /*  51127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51156 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3814:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULLv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv4i32),
     /*  51159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51174 */     GIR_RootConstrainSelectedInstOperands,
     /*  51175 */     // GIR_Coverage, 880,
     /*  51175 */     GIR_EraseRootFromParent_Done,
     /*  51176 */   // Label 1119: @51176
     /*  51176 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(51230), // Rule ID 881 //
     /*  51181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51210 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3814:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULLv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv2i64),
     /*  51213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51228 */     GIR_RootConstrainSelectedInstOperands,
     /*  51229 */     // GIR_Coverage, 881,
     /*  51229 */     GIR_EraseRootFromParent_Done,
     /*  51230 */   // Label 1120: @51230
     /*  51230 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(51284), // Rule ID 993 //
     /*  51235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51264 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3778:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i16),
     /*  51267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51282 */     GIR_RootConstrainSelectedInstOperands,
     /*  51283 */     // GIR_Coverage, 993,
     /*  51283 */     GIR_EraseRootFromParent_Done,
     /*  51284 */   // Label 1121: @51284
     /*  51284 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(51338), // Rule ID 994 //
     /*  51289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51318 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3778:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv2i32),
     /*  51321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51336 */     GIR_RootConstrainSelectedInstOperands,
     /*  51337 */     // GIR_Coverage, 994,
     /*  51337 */     GIR_EraseRootFromParent_Done,
     /*  51338 */   // Label 1122: @51338
     /*  51338 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(51392), // Rule ID 995 //
     /*  51343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51372 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3778:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i16),
     /*  51375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51390 */     GIR_RootConstrainSelectedInstOperands,
     /*  51391 */     // GIR_Coverage, 995,
     /*  51391 */     GIR_EraseRootFromParent_Done,
     /*  51392 */   // Label 1123: @51392
     /*  51392 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(51446), // Rule ID 996 //
     /*  51397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51426 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3778:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i32),
     /*  51429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51444 */     GIR_RootConstrainSelectedInstOperands,
     /*  51445 */     // GIR_Coverage, 996,
     /*  51445 */     GIR_EraseRootFromParent_Done,
     /*  51446 */   // Label 1124: @51446
     /*  51446 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(51500), // Rule ID 997 //
     /*  51451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51480 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3778:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i8),
     /*  51483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51498 */     GIR_RootConstrainSelectedInstOperands,
     /*  51499 */     // GIR_Coverage, 997,
     /*  51499 */     GIR_EraseRootFromParent_Done,
     /*  51500 */   // Label 1125: @51500
     /*  51500 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(51554), // Rule ID 998 //
     /*  51505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51534 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3778:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  51534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv16i8),
     /*  51537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51552 */     GIR_RootConstrainSelectedInstOperands,
     /*  51553 */     // GIR_Coverage, 998,
     /*  51553 */     GIR_EraseRootFromParent_Done,
     /*  51554 */   // Label 1126: @51554
     /*  51554 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(51608), // Rule ID 999 //
     /*  51559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51588 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3779:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i16),
     /*  51591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51606 */     GIR_RootConstrainSelectedInstOperands,
     /*  51607 */     // GIR_Coverage, 999,
     /*  51607 */     GIR_EraseRootFromParent_Done,
     /*  51608 */   // Label 1127: @51608
     /*  51608 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(51662), // Rule ID 1000 //
     /*  51613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51642 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3779:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv2i32),
     /*  51645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51660 */     GIR_RootConstrainSelectedInstOperands,
     /*  51661 */     // GIR_Coverage, 1000,
     /*  51661 */     GIR_EraseRootFromParent_Done,
     /*  51662 */   // Label 1128: @51662
     /*  51662 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(51716), // Rule ID 1001 //
     /*  51667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51696 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3779:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i16),
     /*  51699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51714 */     GIR_RootConstrainSelectedInstOperands,
     /*  51715 */     // GIR_Coverage, 1001,
     /*  51715 */     GIR_EraseRootFromParent_Done,
     /*  51716 */   // Label 1129: @51716
     /*  51716 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(51770), // Rule ID 1002 //
     /*  51721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51750 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3779:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i32),
     /*  51753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51768 */     GIR_RootConstrainSelectedInstOperands,
     /*  51769 */     // GIR_Coverage, 1002,
     /*  51769 */     GIR_EraseRootFromParent_Done,
     /*  51770 */   // Label 1130: @51770
     /*  51770 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(51824), // Rule ID 1003 //
     /*  51775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51804 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3779:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i8),
     /*  51807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51822 */     GIR_RootConstrainSelectedInstOperands,
     /*  51823 */     // GIR_Coverage, 1003,
     /*  51823 */     GIR_EraseRootFromParent_Done,
     /*  51824 */   // Label 1131: @51824
     /*  51824 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(51878), // Rule ID 1004 //
     /*  51829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  51837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51858 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3779:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  51858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv16i8),
     /*  51861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51876 */     GIR_RootConstrainSelectedInstOperands,
     /*  51877 */     // GIR_Coverage, 1004,
     /*  51877 */     GIR_EraseRootFromParent_Done,
     /*  51878 */   // Label 1132: @51878
     /*  51878 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(51932), // Rule ID 1021 //
     /*  51883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  51891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51912 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3843:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRSUBHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv8i8),
     /*  51915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51930 */     GIR_RootConstrainSelectedInstOperands,
     /*  51931 */     // GIR_Coverage, 1021,
     /*  51931 */     GIR_EraseRootFromParent_Done,
     /*  51932 */   // Label 1133: @51932
     /*  51932 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(51986), // Rule ID 1022 //
     /*  51937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  51945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51966 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3843:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSUBHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv4i16),
     /*  51969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51984 */     GIR_RootConstrainSelectedInstOperands,
     /*  51985 */     // GIR_Coverage, 1022,
     /*  51985 */     GIR_EraseRootFromParent_Done,
     /*  51986 */   // Label 1134: @51986
     /*  51986 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(52040), // Rule ID 1023 //
     /*  51991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  51999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  52008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52020 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3843:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRSUBHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  52020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv2i32),
     /*  52023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52038 */     GIR_RootConstrainSelectedInstOperands,
     /*  52039 */     // GIR_Coverage, 1023,
     /*  52039 */     GIR_EraseRootFromParent_Done,
     /*  52040 */   // Label 1135: @52040
     /*  52040 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(52094), // Rule ID 1116 //
     /*  52045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52074 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3754:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGEfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfd),
     /*  52077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52092 */     GIR_RootConstrainSelectedInstOperands,
     /*  52093 */     // GIR_Coverage, 1116,
     /*  52093 */     GIR_EraseRootFromParent_Done,
     /*  52094 */   // Label 1136: @52094
     /*  52094 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(52148), // Rule ID 1117 //
     /*  52099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52128 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3754:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGEfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfq),
     /*  52131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52146 */     GIR_RootConstrainSelectedInstOperands,
     /*  52147 */     // GIR_Coverage, 1117,
     /*  52147 */     GIR_EraseRootFromParent_Done,
     /*  52148 */   // Label 1137: @52148
     /*  52148 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(52202), // Rule ID 1118 //
     /*  52153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52182 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3754:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGEhd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhd),
     /*  52185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52200 */     GIR_RootConstrainSelectedInstOperands,
     /*  52201 */     // GIR_Coverage, 1118,
     /*  52201 */     GIR_EraseRootFromParent_Done,
     /*  52202 */   // Label 1138: @52202
     /*  52202 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(52256), // Rule ID 1119 //
     /*  52207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52236 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3754:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGEhq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhq),
     /*  52239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52254 */     GIR_RootConstrainSelectedInstOperands,
     /*  52255 */     // GIR_Coverage, 1119,
     /*  52255 */     GIR_EraseRootFromParent_Done,
     /*  52256 */   // Label 1139: @52256
     /*  52256 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(52310), // Rule ID 1120 //
     /*  52261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52290 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3755:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGTfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfd),
     /*  52293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52308 */     GIR_RootConstrainSelectedInstOperands,
     /*  52309 */     // GIR_Coverage, 1120,
     /*  52309 */     GIR_EraseRootFromParent_Done,
     /*  52310 */   // Label 1140: @52310
     /*  52310 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(52364), // Rule ID 1121 //
     /*  52315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52344 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3755:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGTfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfq),
     /*  52347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52362 */     GIR_RootConstrainSelectedInstOperands,
     /*  52363 */     // GIR_Coverage, 1121,
     /*  52363 */     GIR_EraseRootFromParent_Done,
     /*  52364 */   // Label 1141: @52364
     /*  52364 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(52418), // Rule ID 1122 //
     /*  52369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52398 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3755:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGThd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThd),
     /*  52401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52416 */     GIR_RootConstrainSelectedInstOperands,
     /*  52417 */     // GIR_Coverage, 1122,
     /*  52417 */     GIR_EraseRootFromParent_Done,
     /*  52418 */   // Label 1142: @52418
     /*  52418 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(52472), // Rule ID 1123 //
     /*  52423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52452 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3755:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGThq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThq),
     /*  52455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52470 */     GIR_RootConstrainSelectedInstOperands,
     /*  52471 */     // GIR_Coverage, 1123,
     /*  52471 */     GIR_EraseRootFromParent_Done,
     /*  52472 */   // Label 1143: @52472
     /*  52472 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(52526), // Rule ID 1166 //
     /*  52477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52506 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3751:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VABDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfd),
     /*  52509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52524 */     GIR_RootConstrainSelectedInstOperands,
     /*  52525 */     // GIR_Coverage, 1166,
     /*  52525 */     GIR_EraseRootFromParent_Done,
     /*  52526 */   // Label 1144: @52526
     /*  52526 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(52580), // Rule ID 1167 //
     /*  52531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52560 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3751:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VABDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfq),
     /*  52563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52578 */     GIR_RootConstrainSelectedInstOperands,
     /*  52579 */     // GIR_Coverage, 1167,
     /*  52579 */     GIR_EraseRootFromParent_Done,
     /*  52580 */   // Label 1145: @52580
     /*  52580 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(52634), // Rule ID 1168 //
     /*  52585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52614 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3751:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VABDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhd),
     /*  52617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52632 */     GIR_RootConstrainSelectedInstOperands,
     /*  52633 */     // GIR_Coverage, 1168,
     /*  52633 */     GIR_EraseRootFromParent_Done,
     /*  52634 */   // Label 1146: @52634
     /*  52634 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(52688), // Rule ID 1169 //
     /*  52639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52668 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3751:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VABDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhq),
     /*  52671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52686 */     GIR_RootConstrainSelectedInstOperands,
     /*  52687 */     // GIR_Coverage, 1169,
     /*  52687 */     GIR_EraseRootFromParent_Done,
     /*  52688 */   // Label 1147: @52688
     /*  52688 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(52742), // Rule ID 1234 //
     /*  52693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  52701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52722 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3805:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  52722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi8),
     /*  52725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52740 */     GIR_RootConstrainSelectedInstOperands,
     /*  52741 */     // GIR_Coverage, 1234,
     /*  52741 */     GIR_EraseRootFromParent_Done,
     /*  52742 */   // Label 1148: @52742
     /*  52742 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(52796), // Rule ID 1235 //
     /*  52747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  52755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52776 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3805:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  52776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi16),
     /*  52779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52794 */     GIR_RootConstrainSelectedInstOperands,
     /*  52795 */     // GIR_Coverage, 1235,
     /*  52795 */     GIR_EraseRootFromParent_Done,
     /*  52796 */   // Label 1149: @52796
     /*  52796 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(52850), // Rule ID 1236 //
     /*  52801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  52809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52830 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3805:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDi32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  52830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi32),
     /*  52833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52848 */     GIR_RootConstrainSelectedInstOperands,
     /*  52849 */     // GIR_Coverage, 1236,
     /*  52849 */     GIR_EraseRootFromParent_Done,
     /*  52850 */   // Label 1150: @52850
     /*  52850 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(52904), // Rule ID 1237 //
     /*  52855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  52863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52884 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3805:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPADDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDf),
     /*  52887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52902 */     GIR_RootConstrainSelectedInstOperands,
     /*  52903 */     // GIR_Coverage, 1237,
     /*  52903 */     GIR_EraseRootFromParent_Done,
     /*  52904 */   // Label 1151: @52904
     /*  52904 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(52958), // Rule ID 1238 //
     /*  52909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  52917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52938 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3805:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPADDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDh),
     /*  52941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52956 */     GIR_RootConstrainSelectedInstOperands,
     /*  52957 */     // GIR_Coverage, 1238,
     /*  52957 */     GIR_EraseRootFromParent_Done,
     /*  52958 */   // Label 1152: @52958
     /*  52958 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(53012), // Rule ID 1251 //
     /*  52963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  52971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52992 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3803:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALsv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  52992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i8),
     /*  52995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52997 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  52999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53010 */     GIR_RootConstrainSelectedInstOperands,
     /*  53011 */     // GIR_Coverage, 1251,
     /*  53011 */     GIR_EraseRootFromParent_Done,
     /*  53012 */   // Label 1153: @53012
     /*  53012 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(53066), // Rule ID 1252 //
     /*  53017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53046 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3803:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALsv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i16),
     /*  53049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53051 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53064 */     GIR_RootConstrainSelectedInstOperands,
     /*  53065 */     // GIR_Coverage, 1252,
     /*  53065 */     GIR_EraseRootFromParent_Done,
     /*  53066 */   // Label 1154: @53066
     /*  53066 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(53120), // Rule ID 1253 //
     /*  53071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53100 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3803:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALsv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv2i32),
     /*  53103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53105 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53118 */     GIR_RootConstrainSelectedInstOperands,
     /*  53119 */     // GIR_Coverage, 1253,
     /*  53119 */     GIR_EraseRootFromParent_Done,
     /*  53120 */   // Label 1155: @53120
     /*  53120 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(53174), // Rule ID 1254 //
     /*  53125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53154 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3803:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALsv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv16i8),
     /*  53157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53159 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53172 */     GIR_RootConstrainSelectedInstOperands,
     /*  53173 */     // GIR_Coverage, 1254,
     /*  53173 */     GIR_EraseRootFromParent_Done,
     /*  53174 */   // Label 1156: @53174
     /*  53174 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(53228), // Rule ID 1255 //
     /*  53179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53208 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3803:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALsv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i16),
     /*  53211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53213 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53226 */     GIR_RootConstrainSelectedInstOperands,
     /*  53227 */     // GIR_Coverage, 1255,
     /*  53227 */     GIR_EraseRootFromParent_Done,
     /*  53228 */   // Label 1157: @53228
     /*  53228 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(53282), // Rule ID 1256 //
     /*  53233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53262 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3803:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALsv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i32),
     /*  53265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53267 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53280 */     GIR_RootConstrainSelectedInstOperands,
     /*  53281 */     // GIR_Coverage, 1256,
     /*  53281 */     GIR_EraseRootFromParent_Done,
     /*  53282 */   // Label 1158: @53282
     /*  53282 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(53336), // Rule ID 1257 //
     /*  53287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53316 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3804:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALuv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i8),
     /*  53319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53321 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53334 */     GIR_RootConstrainSelectedInstOperands,
     /*  53335 */     // GIR_Coverage, 1257,
     /*  53335 */     GIR_EraseRootFromParent_Done,
     /*  53336 */   // Label 1159: @53336
     /*  53336 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(53390), // Rule ID 1258 //
     /*  53341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53370 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3804:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALuv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i16),
     /*  53373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53375 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53388 */     GIR_RootConstrainSelectedInstOperands,
     /*  53389 */     // GIR_Coverage, 1258,
     /*  53389 */     GIR_EraseRootFromParent_Done,
     /*  53390 */   // Label 1160: @53390
     /*  53390 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(53444), // Rule ID 1259 //
     /*  53395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53424 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3804:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALuv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv2i32),
     /*  53427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53429 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53442 */     GIR_RootConstrainSelectedInstOperands,
     /*  53443 */     // GIR_Coverage, 1259,
     /*  53443 */     GIR_EraseRootFromParent_Done,
     /*  53444 */   // Label 1161: @53444
     /*  53444 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(53498), // Rule ID 1260 //
     /*  53449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53478 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3804:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALuv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv16i8),
     /*  53481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53483 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53496 */     GIR_RootConstrainSelectedInstOperands,
     /*  53497 */     // GIR_Coverage, 1260,
     /*  53497 */     GIR_EraseRootFromParent_Done,
     /*  53498 */   // Label 1162: @53498
     /*  53498 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(53552), // Rule ID 1261 //
     /*  53503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53532 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3804:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALuv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i16),
     /*  53535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53550 */     GIR_RootConstrainSelectedInstOperands,
     /*  53551 */     // GIR_Coverage, 1261,
     /*  53551 */     GIR_EraseRootFromParent_Done,
     /*  53552 */   // Label 1163: @53552
     /*  53552 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(53606), // Rule ID 1262 //
     /*  53557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53586 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3804:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALuv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i32),
     /*  53589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53591 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53604 */     GIR_RootConstrainSelectedInstOperands,
     /*  53605 */     // GIR_Coverage, 1262,
     /*  53605 */     GIR_EraseRootFromParent_Done,
     /*  53606 */   // Label 1164: @53606
     /*  53606 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(53660), // Rule ID 1263 //
     /*  53611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  53622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  53625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53640 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3808:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  53640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs8),
     /*  53643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53658 */     GIR_RootConstrainSelectedInstOperands,
     /*  53659 */     // GIR_Coverage, 1263,
     /*  53659 */     GIR_EraseRootFromParent_Done,
     /*  53660 */   // Label 1165: @53660
     /*  53660 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(53714), // Rule ID 1264 //
     /*  53665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53694 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3808:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs16),
     /*  53697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53712 */     GIR_RootConstrainSelectedInstOperands,
     /*  53713 */     // GIR_Coverage, 1264,
     /*  53713 */     GIR_EraseRootFromParent_Done,
     /*  53714 */   // Label 1166: @53714
     /*  53714 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(53768), // Rule ID 1265 //
     /*  53719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53748 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3808:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  53748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs32),
     /*  53751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53766 */     GIR_RootConstrainSelectedInstOperands,
     /*  53767 */     // GIR_Coverage, 1265,
     /*  53767 */     GIR_EraseRootFromParent_Done,
     /*  53768 */   // Label 1167: @53768
     /*  53768 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(53822), // Rule ID 1266 //
     /*  53773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  53781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  53784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  53787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53802 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3809:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  53802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu8),
     /*  53805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53820 */     GIR_RootConstrainSelectedInstOperands,
     /*  53821 */     // GIR_Coverage, 1266,
     /*  53821 */     GIR_EraseRootFromParent_Done,
     /*  53822 */   // Label 1168: @53822
     /*  53822 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(53876), // Rule ID 1267 //
     /*  53827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  53835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53856 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu16),
     /*  53859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53874 */     GIR_RootConstrainSelectedInstOperands,
     /*  53875 */     // GIR_Coverage, 1267,
     /*  53875 */     GIR_EraseRootFromParent_Done,
     /*  53876 */   // Label 1169: @53876
     /*  53876 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(53930), // Rule ID 1268 //
     /*  53881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  53889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53910 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  53910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu32),
     /*  53913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53928 */     GIR_RootConstrainSelectedInstOperands,
     /*  53929 */     // GIR_Coverage, 1268,
     /*  53929 */     GIR_EraseRootFromParent_Done,
     /*  53930 */   // Label 1170: @53930
     /*  53930 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(53984), // Rule ID 1269 //
     /*  53935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53964 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3808:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMAXf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  53964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXf),
     /*  53967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53982 */     GIR_RootConstrainSelectedInstOperands,
     /*  53983 */     // GIR_Coverage, 1269,
     /*  53983 */     GIR_EraseRootFromParent_Done,
     /*  53984 */   // Label 1171: @53984
     /*  53984 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(54038), // Rule ID 1270 //
     /*  53989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  53997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54018 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3808:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMAXh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXh),
     /*  54021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54036 */     GIR_RootConstrainSelectedInstOperands,
     /*  54037 */     // GIR_Coverage, 1270,
     /*  54037 */     GIR_EraseRootFromParent_Done,
     /*  54038 */   // Label 1172: @54038
     /*  54038 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(54092), // Rule ID 1271 //
     /*  54043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54072 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3810:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs8),
     /*  54075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54090 */     GIR_RootConstrainSelectedInstOperands,
     /*  54091 */     // GIR_Coverage, 1271,
     /*  54091 */     GIR_EraseRootFromParent_Done,
     /*  54092 */   // Label 1173: @54092
     /*  54092 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(54146), // Rule ID 1272 //
     /*  54097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54126 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3810:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs16),
     /*  54129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54144 */     GIR_RootConstrainSelectedInstOperands,
     /*  54145 */     // GIR_Coverage, 1272,
     /*  54145 */     GIR_EraseRootFromParent_Done,
     /*  54146 */   // Label 1174: @54146
     /*  54146 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(54200), // Rule ID 1273 //
     /*  54151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54180 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3810:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs32),
     /*  54183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54198 */     GIR_RootConstrainSelectedInstOperands,
     /*  54199 */     // GIR_Coverage, 1273,
     /*  54199 */     GIR_EraseRootFromParent_Done,
     /*  54200 */   // Label 1175: @54200
     /*  54200 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(54254), // Rule ID 1274 //
     /*  54205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54234 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3811:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu8),
     /*  54237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54252 */     GIR_RootConstrainSelectedInstOperands,
     /*  54253 */     // GIR_Coverage, 1274,
     /*  54253 */     GIR_EraseRootFromParent_Done,
     /*  54254 */   // Label 1176: @54254
     /*  54254 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(54308), // Rule ID 1275 //
     /*  54259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54288 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3811:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu16),
     /*  54291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54306 */     GIR_RootConstrainSelectedInstOperands,
     /*  54307 */     // GIR_Coverage, 1275,
     /*  54307 */     GIR_EraseRootFromParent_Done,
     /*  54308 */   // Label 1177: @54308
     /*  54308 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(54362), // Rule ID 1276 //
     /*  54313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54342 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3811:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu32),
     /*  54345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54360 */     GIR_RootConstrainSelectedInstOperands,
     /*  54361 */     // GIR_Coverage, 1276,
     /*  54361 */     GIR_EraseRootFromParent_Done,
     /*  54362 */   // Label 1178: @54362
     /*  54362 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(54416), // Rule ID 1277 //
     /*  54367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54396 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3810:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMINf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINf),
     /*  54399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54408 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54414 */     GIR_RootConstrainSelectedInstOperands,
     /*  54415 */     // GIR_Coverage, 1277,
     /*  54415 */     GIR_EraseRootFromParent_Done,
     /*  54416 */   // Label 1179: @54416
     /*  54416 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(54470), // Rule ID 1278 //
     /*  54421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54450 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3810:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMINh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINh),
     /*  54453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54468 */     GIR_RootConstrainSelectedInstOperands,
     /*  54469 */     // GIR_Coverage, 1278,
     /*  54469 */     GIR_EraseRootFromParent_Done,
     /*  54470 */   // Label 1180: @54470
     /*  54470 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(54524), // Rule ID 1285 //
     /*  54475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54504 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3835:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfd),
     /*  54507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54522 */     GIR_RootConstrainSelectedInstOperands,
     /*  54523 */     // GIR_Coverage, 1285,
     /*  54523 */     GIR_EraseRootFromParent_Done,
     /*  54524 */   // Label 1181: @54524
     /*  54524 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(54578), // Rule ID 1286 //
     /*  54529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  54540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  54546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54558 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3835:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  54558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfq),
     /*  54561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54576 */     GIR_RootConstrainSelectedInstOperands,
     /*  54577 */     // GIR_Coverage, 1286,
     /*  54577 */     GIR_EraseRootFromParent_Done,
     /*  54578 */   // Label 1182: @54578
     /*  54578 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(54632), // Rule ID 1287 //
     /*  54583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54612 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3835:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShd),
     /*  54615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54630 */     GIR_RootConstrainSelectedInstOperands,
     /*  54631 */     // GIR_Coverage, 1287,
     /*  54631 */     GIR_EraseRootFromParent_Done,
     /*  54632 */   // Label 1183: @54632
     /*  54632 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(54686), // Rule ID 1288 //
     /*  54637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  54648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  54651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  54654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54666 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3835:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  54666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShq),
     /*  54669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54684 */     GIR_RootConstrainSelectedInstOperands,
     /*  54685 */     // GIR_Coverage, 1288,
     /*  54685 */     GIR_EraseRootFromParent_Done,
     /*  54686 */   // Label 1184: @54686
     /*  54686 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(54740), // Rule ID 1295 //
     /*  54691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  54699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54720 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3842:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfd),
     /*  54723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54738 */     GIR_RootConstrainSelectedInstOperands,
     /*  54739 */     // GIR_Coverage, 1295,
     /*  54739 */     GIR_EraseRootFromParent_Done,
     /*  54740 */   // Label 1185: @54740
     /*  54740 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(54794), // Rule ID 1296 //
     /*  54745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  54753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  54756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  54762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54774 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3842:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  54774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfq),
     /*  54777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54792 */     GIR_RootConstrainSelectedInstOperands,
     /*  54793 */     // GIR_Coverage, 1296,
     /*  54793 */     GIR_EraseRootFromParent_Done,
     /*  54794 */   // Label 1186: @54794
     /*  54794 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(54848), // Rule ID 1297 //
     /*  54799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  54807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54828 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3842:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShd),
     /*  54831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54846 */     GIR_RootConstrainSelectedInstOperands,
     /*  54847 */     // GIR_Coverage, 1297,
     /*  54847 */     GIR_EraseRootFromParent_Done,
     /*  54848 */   // Label 1187: @54848
     /*  54848 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(54902), // Rule ID 1298 //
     /*  54853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  54861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  54864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  54867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  54870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54882 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3842:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  54882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShq),
     /*  54885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54900 */     GIR_RootConstrainSelectedInstOperands,
     /*  54901 */     // GIR_Coverage, 1298,
     /*  54901 */     GIR_EraseRootFromParent_Done,
     /*  54902 */   // Label 1188: @54902
     /*  54902 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(54956), // Rule ID 1299 //
     /*  54907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  54915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54936 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3845:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  54936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i16),
     /*  54939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  54943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  54945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54954 */     GIR_RootConstrainSelectedInstOperands,
     /*  54955 */     // GIR_Coverage, 1299,
     /*  54955 */     GIR_EraseRootFromParent_Done,
     /*  54956 */   // Label 1189: @54956
     /*  54956 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(55010), // Rule ID 1300 //
     /*  54961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  54969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54990 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3845:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  54990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i32),
     /*  54993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  54997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  54999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55008 */     GIR_RootConstrainSelectedInstOperands,
     /*  55009 */     // GIR_Coverage, 1300,
     /*  55009 */     GIR_EraseRootFromParent_Done,
     /*  55010 */   // Label 1190: @55010
     /*  55010 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(55064), // Rule ID 1301 //
     /*  55015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55044 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3845:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i16),
     /*  55047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55062 */     GIR_RootConstrainSelectedInstOperands,
     /*  55063 */     // GIR_Coverage, 1301,
     /*  55063 */     GIR_EraseRootFromParent_Done,
     /*  55064 */   // Label 1191: @55064
     /*  55064 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(55118), // Rule ID 1302 //
     /*  55069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55098 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3845:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i32),
     /*  55101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55116 */     GIR_RootConstrainSelectedInstOperands,
     /*  55117 */     // GIR_Coverage, 1302,
     /*  55117 */     GIR_EraseRootFromParent_Done,
     /*  55118 */   // Label 1192: @55118
     /*  55118 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(55172), // Rule ID 1303 //
     /*  55123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55152 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3845:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i8),
     /*  55155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55170 */     GIR_RootConstrainSelectedInstOperands,
     /*  55171 */     // GIR_Coverage, 1303,
     /*  55171 */     GIR_EraseRootFromParent_Done,
     /*  55172 */   // Label 1193: @55172
     /*  55172 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(55226), // Rule ID 1304 //
     /*  55177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55206 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3845:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv16i8),
     /*  55209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55224 */     GIR_RootConstrainSelectedInstOperands,
     /*  55225 */     // GIR_Coverage, 1304,
     /*  55225 */     GIR_EraseRootFromParent_Done,
     /*  55226 */   // Label 1194: @55226
     /*  55226 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(55280), // Rule ID 1305 //
     /*  55231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55260 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3845:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv1i64),
     /*  55263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55278 */     GIR_RootConstrainSelectedInstOperands,
     /*  55279 */     // GIR_Coverage, 1305,
     /*  55279 */     GIR_EraseRootFromParent_Done,
     /*  55280 */   // Label 1195: @55280
     /*  55280 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(55334), // Rule ID 1306 //
     /*  55285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  55296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  55302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55314 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3845:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  55314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i64),
     /*  55317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55332 */     GIR_RootConstrainSelectedInstOperands,
     /*  55333 */     // GIR_Coverage, 1306,
     /*  55333 */     GIR_EraseRootFromParent_Done,
     /*  55334 */   // Label 1196: @55334
     /*  55334 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(55388), // Rule ID 1307 //
     /*  55339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55368 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3846:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i16),
     /*  55371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55386 */     GIR_RootConstrainSelectedInstOperands,
     /*  55387 */     // GIR_Coverage, 1307,
     /*  55387 */     GIR_EraseRootFromParent_Done,
     /*  55388 */   // Label 1197: @55388
     /*  55388 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(55442), // Rule ID 1308 //
     /*  55393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55422 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3846:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i32),
     /*  55425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55440 */     GIR_RootConstrainSelectedInstOperands,
     /*  55441 */     // GIR_Coverage, 1308,
     /*  55441 */     GIR_EraseRootFromParent_Done,
     /*  55442 */   // Label 1198: @55442
     /*  55442 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(55496), // Rule ID 1309 //
     /*  55447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55476 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3846:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i16),
     /*  55479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55494 */     GIR_RootConstrainSelectedInstOperands,
     /*  55495 */     // GIR_Coverage, 1309,
     /*  55495 */     GIR_EraseRootFromParent_Done,
     /*  55496 */   // Label 1199: @55496
     /*  55496 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(55550), // Rule ID 1310 //
     /*  55501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55530 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3846:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i32),
     /*  55533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55548 */     GIR_RootConstrainSelectedInstOperands,
     /*  55549 */     // GIR_Coverage, 1310,
     /*  55549 */     GIR_EraseRootFromParent_Done,
     /*  55550 */   // Label 1200: @55550
     /*  55550 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(55604), // Rule ID 1311 //
     /*  55555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55584 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3846:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i8),
     /*  55587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55602 */     GIR_RootConstrainSelectedInstOperands,
     /*  55603 */     // GIR_Coverage, 1311,
     /*  55603 */     GIR_EraseRootFromParent_Done,
     /*  55604 */   // Label 1201: @55604
     /*  55604 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(55658), // Rule ID 1312 //
     /*  55609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55638 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3846:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv16i8),
     /*  55641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55656 */     GIR_RootConstrainSelectedInstOperands,
     /*  55657 */     // GIR_Coverage, 1312,
     /*  55657 */     GIR_EraseRootFromParent_Done,
     /*  55658 */   // Label 1202: @55658
     /*  55658 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(55712), // Rule ID 1313 //
     /*  55663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55692 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3846:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv1i64),
     /*  55695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55710 */     GIR_RootConstrainSelectedInstOperands,
     /*  55711 */     // GIR_Coverage, 1313,
     /*  55711 */     GIR_EraseRootFromParent_Done,
     /*  55712 */   // Label 1203: @55712
     /*  55712 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(55766), // Rule ID 1314 //
     /*  55717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  55728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  55734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55746 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3846:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  55746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i64),
     /*  55749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55764 */     GIR_RootConstrainSelectedInstOperands,
     /*  55765 */     // GIR_Coverage, 1314,
     /*  55765 */     GIR_EraseRootFromParent_Done,
     /*  55766 */   // Label 1204: @55766
     /*  55766 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(55820), // Rule ID 1348 //
     /*  55771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  55779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55800 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3839:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i16),
     /*  55803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55818 */     GIR_RootConstrainSelectedInstOperands,
     /*  55819 */     // GIR_Coverage, 1348,
     /*  55819 */     GIR_EraseRootFromParent_Done,
     /*  55820 */   // Label 1205: @55820
     /*  55820 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(55874), // Rule ID 1349 //
     /*  55825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  55833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55854 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3839:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i32),
     /*  55857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55872 */     GIR_RootConstrainSelectedInstOperands,
     /*  55873 */     // GIR_Coverage, 1349,
     /*  55873 */     GIR_EraseRootFromParent_Done,
     /*  55874 */   // Label 1206: @55874
     /*  55874 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(55928), // Rule ID 1350 //
     /*  55879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  55887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55908 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3839:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i16),
     /*  55911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55926 */     GIR_RootConstrainSelectedInstOperands,
     /*  55927 */     // GIR_Coverage, 1350,
     /*  55927 */     GIR_EraseRootFromParent_Done,
     /*  55928 */   // Label 1207: @55928
     /*  55928 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(55982), // Rule ID 1351 //
     /*  55933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  55941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55962 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3839:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i32),
     /*  55965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55980 */     GIR_RootConstrainSelectedInstOperands,
     /*  55981 */     // GIR_Coverage, 1351,
     /*  55981 */     GIR_EraseRootFromParent_Done,
     /*  55982 */   // Label 1208: @55982
     /*  55982 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(56036), // Rule ID 1352 //
     /*  55987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  55995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56016 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3839:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i8),
     /*  56019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56034 */     GIR_RootConstrainSelectedInstOperands,
     /*  56035 */     // GIR_Coverage, 1352,
     /*  56035 */     GIR_EraseRootFromParent_Done,
     /*  56036 */   // Label 1209: @56036
     /*  56036 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(56090), // Rule ID 1353 //
     /*  56041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56070 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3839:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv16i8),
     /*  56073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56088 */     GIR_RootConstrainSelectedInstOperands,
     /*  56089 */     // GIR_Coverage, 1353,
     /*  56089 */     GIR_EraseRootFromParent_Done,
     /*  56090 */   // Label 1210: @56090
     /*  56090 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(56144), // Rule ID 1354 //
     /*  56095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56124 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3839:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv1i64),
     /*  56127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56142 */     GIR_RootConstrainSelectedInstOperands,
     /*  56143 */     // GIR_Coverage, 1354,
     /*  56143 */     GIR_EraseRootFromParent_Done,
     /*  56144 */   // Label 1211: @56144
     /*  56144 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(56198), // Rule ID 1355 //
     /*  56149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56178 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3839:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i64),
     /*  56181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56196 */     GIR_RootConstrainSelectedInstOperands,
     /*  56197 */     // GIR_Coverage, 1355,
     /*  56197 */     GIR_EraseRootFromParent_Done,
     /*  56198 */   // Label 1212: @56198
     /*  56198 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(56252), // Rule ID 1356 //
     /*  56203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56232 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3840:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i16),
     /*  56235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56250 */     GIR_RootConstrainSelectedInstOperands,
     /*  56251 */     // GIR_Coverage, 1356,
     /*  56251 */     GIR_EraseRootFromParent_Done,
     /*  56252 */   // Label 1213: @56252
     /*  56252 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(56306), // Rule ID 1357 //
     /*  56257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56286 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3840:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i32),
     /*  56289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56304 */     GIR_RootConstrainSelectedInstOperands,
     /*  56305 */     // GIR_Coverage, 1357,
     /*  56305 */     GIR_EraseRootFromParent_Done,
     /*  56306 */   // Label 1214: @56306
     /*  56306 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(56360), // Rule ID 1358 //
     /*  56311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56340 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3840:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i16),
     /*  56343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56358 */     GIR_RootConstrainSelectedInstOperands,
     /*  56359 */     // GIR_Coverage, 1358,
     /*  56359 */     GIR_EraseRootFromParent_Done,
     /*  56360 */   // Label 1215: @56360
     /*  56360 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(56414), // Rule ID 1359 //
     /*  56365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56394 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3840:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i32),
     /*  56397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56412 */     GIR_RootConstrainSelectedInstOperands,
     /*  56413 */     // GIR_Coverage, 1359,
     /*  56413 */     GIR_EraseRootFromParent_Done,
     /*  56414 */   // Label 1216: @56414
     /*  56414 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(56468), // Rule ID 1360 //
     /*  56419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56448 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3840:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i8),
     /*  56451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56460 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56466 */     GIR_RootConstrainSelectedInstOperands,
     /*  56467 */     // GIR_Coverage, 1360,
     /*  56467 */     GIR_EraseRootFromParent_Done,
     /*  56468 */   // Label 1217: @56468
     /*  56468 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(56522), // Rule ID 1361 //
     /*  56473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56502 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3840:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv16i8),
     /*  56505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56520 */     GIR_RootConstrainSelectedInstOperands,
     /*  56521 */     // GIR_Coverage, 1361,
     /*  56521 */     GIR_EraseRootFromParent_Done,
     /*  56522 */   // Label 1218: @56522
     /*  56522 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(56576), // Rule ID 1362 //
     /*  56527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56556 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3840:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv1i64),
     /*  56559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56568 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56574 */     GIR_RootConstrainSelectedInstOperands,
     /*  56575 */     // GIR_Coverage, 1362,
     /*  56575 */     GIR_EraseRootFromParent_Done,
     /*  56576 */   // Label 1219: @56576
     /*  56576 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(56630), // Rule ID 1363 //
     /*  56581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56610 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3840:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i64),
     /*  56613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56622 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56628 */     GIR_RootConstrainSelectedInstOperands,
     /*  56629 */     // GIR_Coverage, 1363,
     /*  56629 */     GIR_EraseRootFromParent_Done,
     /*  56630 */   // Label 1220: @56630
     /*  56630 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(56684), // Rule ID 1383 //
     /*  56635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56664 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3830:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i16),
     /*  56667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56682 */     GIR_RootConstrainSelectedInstOperands,
     /*  56683 */     // GIR_Coverage, 1383,
     /*  56683 */     GIR_EraseRootFromParent_Done,
     /*  56684 */   // Label 1221: @56684
     /*  56684 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(56738), // Rule ID 1384 //
     /*  56689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56718 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3830:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i32),
     /*  56721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56736 */     GIR_RootConstrainSelectedInstOperands,
     /*  56737 */     // GIR_Coverage, 1384,
     /*  56737 */     GIR_EraseRootFromParent_Done,
     /*  56738 */   // Label 1222: @56738
     /*  56738 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(56792), // Rule ID 1385 //
     /*  56743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56772 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3830:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i16),
     /*  56775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56790 */     GIR_RootConstrainSelectedInstOperands,
     /*  56791 */     // GIR_Coverage, 1385,
     /*  56791 */     GIR_EraseRootFromParent_Done,
     /*  56792 */   // Label 1223: @56792
     /*  56792 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(56846), // Rule ID 1386 //
     /*  56797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56826 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3830:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i32),
     /*  56829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56838 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56844 */     GIR_RootConstrainSelectedInstOperands,
     /*  56845 */     // GIR_Coverage, 1386,
     /*  56845 */     GIR_EraseRootFromParent_Done,
     /*  56846 */   // Label 1224: @56846
     /*  56846 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(56900), // Rule ID 1387 //
     /*  56851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56880 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3830:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i8),
     /*  56883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56892 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56898 */     GIR_RootConstrainSelectedInstOperands,
     /*  56899 */     // GIR_Coverage, 1387,
     /*  56899 */     GIR_EraseRootFromParent_Done,
     /*  56900 */   // Label 1225: @56900
     /*  56900 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(56954), // Rule ID 1388 //
     /*  56905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56934 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3830:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv16i8),
     /*  56937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56952 */     GIR_RootConstrainSelectedInstOperands,
     /*  56953 */     // GIR_Coverage, 1388,
     /*  56953 */     GIR_EraseRootFromParent_Done,
     /*  56954 */   // Label 1226: @56954
     /*  56954 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(57008), // Rule ID 1389 //
     /*  56959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  56967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56988 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3830:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv1i64),
     /*  56991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57006 */     GIR_RootConstrainSelectedInstOperands,
     /*  57007 */     // GIR_Coverage, 1389,
     /*  57007 */     GIR_EraseRootFromParent_Done,
     /*  57008 */   // Label 1227: @57008
     /*  57008 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(57062), // Rule ID 1390 //
     /*  57013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57042 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3830:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i64),
     /*  57045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57060 */     GIR_RootConstrainSelectedInstOperands,
     /*  57061 */     // GIR_Coverage, 1390,
     /*  57061 */     GIR_EraseRootFromParent_Done,
     /*  57062 */   // Label 1228: @57062
     /*  57062 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(57116), // Rule ID 1391 //
     /*  57067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57096 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3832:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i16),
     /*  57099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57114 */     GIR_RootConstrainSelectedInstOperands,
     /*  57115 */     // GIR_Coverage, 1391,
     /*  57115 */     GIR_EraseRootFromParent_Done,
     /*  57116 */   // Label 1229: @57116
     /*  57116 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(57170), // Rule ID 1392 //
     /*  57121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57150 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3832:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i32),
     /*  57153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57168 */     GIR_RootConstrainSelectedInstOperands,
     /*  57169 */     // GIR_Coverage, 1392,
     /*  57169 */     GIR_EraseRootFromParent_Done,
     /*  57170 */   // Label 1230: @57170
     /*  57170 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(57224), // Rule ID 1393 //
     /*  57175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57204 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3832:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i16),
     /*  57207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57222 */     GIR_RootConstrainSelectedInstOperands,
     /*  57223 */     // GIR_Coverage, 1393,
     /*  57223 */     GIR_EraseRootFromParent_Done,
     /*  57224 */   // Label 1231: @57224
     /*  57224 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(57278), // Rule ID 1394 //
     /*  57229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57258 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3832:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i32),
     /*  57261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57270 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57276 */     GIR_RootConstrainSelectedInstOperands,
     /*  57277 */     // GIR_Coverage, 1394,
     /*  57277 */     GIR_EraseRootFromParent_Done,
     /*  57278 */   // Label 1232: @57278
     /*  57278 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(57332), // Rule ID 1395 //
     /*  57283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57312 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3832:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i8),
     /*  57315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57330 */     GIR_RootConstrainSelectedInstOperands,
     /*  57331 */     // GIR_Coverage, 1395,
     /*  57331 */     GIR_EraseRootFromParent_Done,
     /*  57332 */   // Label 1233: @57332
     /*  57332 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(57386), // Rule ID 1396 //
     /*  57337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57366 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3832:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv16i8),
     /*  57369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57378 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57384 */     GIR_RootConstrainSelectedInstOperands,
     /*  57385 */     // GIR_Coverage, 1396,
     /*  57385 */     GIR_EraseRootFromParent_Done,
     /*  57386 */   // Label 1234: @57386
     /*  57386 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(57440), // Rule ID 1397 //
     /*  57391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57420 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3832:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv1i64),
     /*  57423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57438 */     GIR_RootConstrainSelectedInstOperands,
     /*  57439 */     // GIR_Coverage, 1397,
     /*  57439 */     GIR_EraseRootFromParent_Done,
     /*  57440 */   // Label 1235: @57440
     /*  57440 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(57494), // Rule ID 1398 //
     /*  57445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57474 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3832:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i64),
     /*  57477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57486 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57492 */     GIR_RootConstrainSelectedInstOperands,
     /*  57493 */     // GIR_Coverage, 1398,
     /*  57493 */     GIR_EraseRootFromParent_Done,
     /*  57494 */   // Label 1236: @57494
     /*  57494 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(57548), // Rule ID 1432 //
     /*  57499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57528 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3825:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i16),
     /*  57531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57546 */     GIR_RootConstrainSelectedInstOperands,
     /*  57547 */     // GIR_Coverage, 1432,
     /*  57547 */     GIR_EraseRootFromParent_Done,
     /*  57548 */   // Label 1237: @57548
     /*  57548 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(57602), // Rule ID 1433 //
     /*  57553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57582 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3825:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i32),
     /*  57585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57600 */     GIR_RootConstrainSelectedInstOperands,
     /*  57601 */     // GIR_Coverage, 1433,
     /*  57601 */     GIR_EraseRootFromParent_Done,
     /*  57602 */   // Label 1238: @57602
     /*  57602 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(57656), // Rule ID 1434 //
     /*  57607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57636 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3825:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i16),
     /*  57639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57654 */     GIR_RootConstrainSelectedInstOperands,
     /*  57655 */     // GIR_Coverage, 1434,
     /*  57655 */     GIR_EraseRootFromParent_Done,
     /*  57656 */   // Label 1239: @57656
     /*  57656 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(57710), // Rule ID 1435 //
     /*  57661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57690 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3825:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i32),
     /*  57693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57708 */     GIR_RootConstrainSelectedInstOperands,
     /*  57709 */     // GIR_Coverage, 1435,
     /*  57709 */     GIR_EraseRootFromParent_Done,
     /*  57710 */   // Label 1240: @57710
     /*  57710 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(57764), // Rule ID 1436 //
     /*  57715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57744 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3825:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i8),
     /*  57747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57762 */     GIR_RootConstrainSelectedInstOperands,
     /*  57763 */     // GIR_Coverage, 1436,
     /*  57763 */     GIR_EraseRootFromParent_Done,
     /*  57764 */   // Label 1241: @57764
     /*  57764 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(57818), // Rule ID 1437 //
     /*  57769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57798 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3825:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv16i8),
     /*  57801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57816 */     GIR_RootConstrainSelectedInstOperands,
     /*  57817 */     // GIR_Coverage, 1437,
     /*  57817 */     GIR_EraseRootFromParent_Done,
     /*  57818 */   // Label 1242: @57818
     /*  57818 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(57872), // Rule ID 1438 //
     /*  57823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57852 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3825:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv1i64),
     /*  57855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57870 */     GIR_RootConstrainSelectedInstOperands,
     /*  57871 */     // GIR_Coverage, 1438,
     /*  57871 */     GIR_EraseRootFromParent_Done,
     /*  57872 */   // Label 1243: @57872
     /*  57872 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(57926), // Rule ID 1439 //
     /*  57877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57906 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3825:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i64),
     /*  57909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57924 */     GIR_RootConstrainSelectedInstOperands,
     /*  57925 */     // GIR_Coverage, 1439,
     /*  57925 */     GIR_EraseRootFromParent_Done,
     /*  57926 */   // Label 1244: @57926
     /*  57926 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(57980), // Rule ID 1440 //
     /*  57931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  57939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57960 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3826:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i16),
     /*  57963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57978 */     GIR_RootConstrainSelectedInstOperands,
     /*  57979 */     // GIR_Coverage, 1440,
     /*  57979 */     GIR_EraseRootFromParent_Done,
     /*  57980 */   // Label 1245: @57980
     /*  57980 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(58034), // Rule ID 1441 //
     /*  57985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  57993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58014 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3826:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i32),
     /*  58017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58032 */     GIR_RootConstrainSelectedInstOperands,
     /*  58033 */     // GIR_Coverage, 1441,
     /*  58033 */     GIR_EraseRootFromParent_Done,
     /*  58034 */   // Label 1246: @58034
     /*  58034 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(58088), // Rule ID 1442 //
     /*  58039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58068 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3826:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i16),
     /*  58071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58086 */     GIR_RootConstrainSelectedInstOperands,
     /*  58087 */     // GIR_Coverage, 1442,
     /*  58087 */     GIR_EraseRootFromParent_Done,
     /*  58088 */   // Label 1247: @58088
     /*  58088 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(58142), // Rule ID 1443 //
     /*  58093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58122 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3826:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i32),
     /*  58125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58140 */     GIR_RootConstrainSelectedInstOperands,
     /*  58141 */     // GIR_Coverage, 1443,
     /*  58141 */     GIR_EraseRootFromParent_Done,
     /*  58142 */   // Label 1248: @58142
     /*  58142 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(58196), // Rule ID 1444 //
     /*  58147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58176 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3826:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i8),
     /*  58179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58194 */     GIR_RootConstrainSelectedInstOperands,
     /*  58195 */     // GIR_Coverage, 1444,
     /*  58195 */     GIR_EraseRootFromParent_Done,
     /*  58196 */   // Label 1249: @58196
     /*  58196 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(58250), // Rule ID 1445 //
     /*  58201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58230 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3826:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv16i8),
     /*  58233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58248 */     GIR_RootConstrainSelectedInstOperands,
     /*  58249 */     // GIR_Coverage, 1445,
     /*  58249 */     GIR_EraseRootFromParent_Done,
     /*  58250 */   // Label 1250: @58250
     /*  58250 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(58304), // Rule ID 1446 //
     /*  58255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58284 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3826:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv1i64),
     /*  58287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58302 */     GIR_RootConstrainSelectedInstOperands,
     /*  58303 */     // GIR_Coverage, 1446,
     /*  58303 */     GIR_EraseRootFromParent_Done,
     /*  58304 */   // Label 1251: @58304
     /*  58304 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(58358), // Rule ID 1447 //
     /*  58309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58338 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3826:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i64),
     /*  58341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58356 */     GIR_RootConstrainSelectedInstOperands,
     /*  58357 */     // GIR_Coverage, 1447,
     /*  58357 */     GIR_EraseRootFromParent_Done,
     /*  58358 */   // Label 1252: @58358
     /*  58358 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(58403), // Rule ID 1712 //
     /*  58363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesd),
     /*  58371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58392 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3727:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESD:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESD),
     /*  58395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58397 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58401 */     GIR_RootConstrainSelectedInstOperands,
     /*  58402 */     // GIR_Coverage, 1712,
     /*  58402 */     GIR_EraseRootFromParent_Done,
     /*  58403 */   // Label 1253: @58403
     /*  58403 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(58448), // Rule ID 1713 //
     /*  58408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aese),
     /*  58416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58437 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3728:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESE:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESE),
     /*  58440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58442 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58446 */     GIR_RootConstrainSelectedInstOperands,
     /*  58447 */     // GIR_Coverage, 1713,
     /*  58447 */     GIR_EraseRootFromParent_Done,
     /*  58448 */   // Label 1254: @58448
     /*  58448 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(58493), // Rule ID 1716 //
     /*  58453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su1),
     /*  58461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58482 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3741:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  58482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU1),
     /*  58485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58487 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58491 */     GIR_RootConstrainSelectedInstOperands,
     /*  58492 */     // GIR_Coverage, 1716,
     /*  58492 */     GIR_EraseRootFromParent_Done,
     /*  58493 */   // Label 1255: @58493
     /*  58493 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(58538), // Rule ID 1717 //
     /*  58498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su0),
     /*  58506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58527 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3744:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  58527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU0),
     /*  58530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58532 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58536 */     GIR_RootConstrainSelectedInstOperands,
     /*  58537 */     // GIR_Coverage, 1717,
     /*  58537 */     GIR_EraseRootFromParent_Done,
     /*  58538 */   // Label 1256: @58538
     /*  58538 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(58592), // Rule ID 1726 //
     /*  58543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  58546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqrshr),
     /*  58551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58572 */     // (intrinsic_wo_chain:{ *:[i32] } 3590:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_SQRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  58572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQRSHR),
     /*  58575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  58577 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  58579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58590 */     GIR_RootConstrainSelectedInstOperands,
     /*  58591 */     // GIR_Coverage, 1726,
     /*  58591 */     GIR_EraseRootFromParent_Done,
     /*  58592 */   // Label 1257: @58592
     /*  58592 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(58646), // Rule ID 1727 //
     /*  58597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  58600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqrshl),
     /*  58605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  58626 */     // (intrinsic_wo_chain:{ *:[i32] } 3597:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_UQRSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  58626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQRSHL),
     /*  58629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  58631 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  58633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58644 */     GIR_RootConstrainSelectedInstOperands,
     /*  58645 */     // GIR_Coverage, 1727,
     /*  58645 */     GIR_EraseRootFromParent_Done,
     /*  58646 */   // Label 1258: @58646
     /*  58646 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(58703), // Rule ID 1850 //
     /*  58651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  58659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58680 */     // (intrinsic_wo_chain:{ *:[i32] } 3922:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (SXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  58680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB16),
     /*  58683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58685 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  58687 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  58689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58701 */     GIR_RootConstrainSelectedInstOperands,
     /*  58702 */     // GIR_Coverage, 1850,
     /*  58702 */     GIR_EraseRootFromParent_Done,
     /*  58703 */   // Label 1259: @58703
     /*  58703 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(58760), // Rule ID 1857 //
     /*  58708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  58716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  58737 */     // (intrinsic_wo_chain:{ *:[i32] } 3947:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (UXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  58737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB16),
     /*  58740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58742 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  58744 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  58746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58758 */     GIR_RootConstrainSelectedInstOperands,
     /*  58759 */     // GIR_Coverage, 1857,
     /*  58759 */     GIR_EraseRootFromParent_Done,
     /*  58760 */   // Label 1260: @58760
     /*  58760 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(58814), // Rule ID 1904 //
     /*  58765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  58773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58794 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  58794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUAD),
     /*  58797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58812 */     GIR_RootConstrainSelectedInstOperands,
     /*  58813 */     // GIR_Coverage, 1904,
     /*  58813 */     GIR_EraseRootFromParent_Done,
     /*  58814 */   // Label 1261: @58814
     /*  58814 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(58868), // Rule ID 1905 //
     /*  58819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  58827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58848 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  58848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUADX),
     /*  58851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58866 */     GIR_RootConstrainSelectedInstOperands,
     /*  58867 */     // GIR_Coverage, 1905,
     /*  58867 */     GIR_EraseRootFromParent_Done,
     /*  58868 */   // Label 1262: @58868
     /*  58868 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(58922), // Rule ID 1906 //
     /*  58873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  58881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58902 */     // (intrinsic_wo_chain:{ *:[i32] } 3906:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  58902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSD),
     /*  58905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58920 */     GIR_RootConstrainSelectedInstOperands,
     /*  58921 */     // GIR_Coverage, 1906,
     /*  58921 */     GIR_EraseRootFromParent_Done,
     /*  58922 */   // Label 1263: @58922
     /*  58922 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(58976), // Rule ID 1907 //
     /*  58927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  58930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  58935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  58956 */     // (intrinsic_wo_chain:{ *:[i32] } 3907:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  58956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSDX),
     /*  58959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  58961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  58963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  58965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58974 */     GIR_RootConstrainSelectedInstOperands,
     /*  58975 */     // GIR_Coverage, 1907,
     /*  58975 */     GIR_EraseRootFromParent_Done,
     /*  58976 */   // Label 1264: @58976
     /*  58976 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(59030), // Rule ID 1981 //
     /*  58981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  58984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  58989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  58992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  58995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  58998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59010 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  59013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59015 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59017 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59028 */     GIR_RootConstrainSelectedInstOperands,
     /*  59029 */     // GIR_Coverage, 1981,
     /*  59029 */     GIR_EraseRootFromParent_Done,
     /*  59030 */   // Label 1265: @59030
     /*  59030 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(59084), // Rule ID 1982 //
     /*  59035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59064 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  59067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59069 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59071 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59082 */     GIR_RootConstrainSelectedInstOperands,
     /*  59083 */     // GIR_Coverage, 1982,
     /*  59083 */     GIR_EraseRootFromParent_Done,
     /*  59084 */   // Label 1266: @59084
     /*  59084 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(59138), // Rule ID 1983 //
     /*  59089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59118 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  59121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59123 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59125 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59136 */     GIR_RootConstrainSelectedInstOperands,
     /*  59137 */     // GIR_Coverage, 1983,
     /*  59137 */     GIR_EraseRootFromParent_Done,
     /*  59138 */   // Label 1267: @59138
     /*  59138 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(59192), // Rule ID 1984 //
     /*  59143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59172 */     // (intrinsic_wo_chain:{ *:[i32] } 3903:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  59175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59177 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59179 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59190 */     GIR_RootConstrainSelectedInstOperands,
     /*  59191 */     // GIR_Coverage, 1984,
     /*  59191 */     GIR_EraseRootFromParent_Done,
     /*  59192 */   // Label 1268: @59192
     /*  59192 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(59246), // Rule ID 1985 //
     /*  59197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59226 */     // (intrinsic_wo_chain:{ *:[i32] } 3904:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWB),
     /*  59229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59231 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59233 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59244 */     GIR_RootConstrainSelectedInstOperands,
     /*  59245 */     // GIR_Coverage, 1985,
     /*  59245 */     GIR_EraseRootFromParent_Done,
     /*  59246 */   // Label 1269: @59246
     /*  59246 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(59300), // Rule ID 1986 //
     /*  59251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  59259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59280 */     // (intrinsic_wo_chain:{ *:[i32] } 3905:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWT),
     /*  59283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59285 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59287 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59298 */     GIR_RootConstrainSelectedInstOperands,
     /*  59299 */     // GIR_Coverage, 1986,
     /*  59299 */     GIR_EraseRootFromParent_Done,
     /*  59300 */   // Label 1270: @59300
     /*  59300 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(59357), // Rule ID 2097 //
     /*  59305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59334 */     // (intrinsic_wo_chain:{ *:[i32] } 3922:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  59334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB16),
     /*  59337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59349 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59355 */     GIR_RootConstrainSelectedInstOperands,
     /*  59356 */     // GIR_Coverage, 2097,
     /*  59356 */     GIR_EraseRootFromParent_Done,
     /*  59357 */   // Label 1271: @59357
     /*  59357 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(59411), // Rule ID 2127 //
     /*  59362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  59370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59391 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /*  59394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59409 */     GIR_RootConstrainSelectedInstOperands,
     /*  59410 */     // GIR_Coverage, 2127,
     /*  59410 */     GIR_EraseRootFromParent_Done,
     /*  59411 */   // Label 1272: @59411
     /*  59411 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(59465), // Rule ID 2128 //
     /*  59416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  59424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59445 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /*  59448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59463 */     GIR_RootConstrainSelectedInstOperands,
     /*  59464 */     // GIR_Coverage, 2128,
     /*  59464 */     GIR_EraseRootFromParent_Done,
     /*  59465 */   // Label 1273: @59465
     /*  59465 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(59519), // Rule ID 2168 //
     /*  59470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59499 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  59502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59517 */     GIR_RootConstrainSelectedInstOperands,
     /*  59518 */     // GIR_Coverage, 2168,
     /*  59518 */     GIR_EraseRootFromParent_Done,
     /*  59519 */   // Label 1274: @59519
     /*  59519 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(59573), // Rule ID 2169 //
     /*  59524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59553 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  59556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59571 */     GIR_RootConstrainSelectedInstOperands,
     /*  59572 */     // GIR_Coverage, 2169,
     /*  59572 */     GIR_EraseRootFromParent_Done,
     /*  59573 */   // Label 1275: @59573
     /*  59573 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(59627), // Rule ID 2170 //
     /*  59578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59607 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  59610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59619 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59625 */     GIR_RootConstrainSelectedInstOperands,
     /*  59626 */     // GIR_Coverage, 2170,
     /*  59626 */     GIR_EraseRootFromParent_Done,
     /*  59627 */   // Label 1276: @59627
     /*  59627 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(59681), // Rule ID 2171 //
     /*  59632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59661 */     // (intrinsic_wo_chain:{ *:[i32] } 3903:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  59664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59679 */     GIR_RootConstrainSelectedInstOperands,
     /*  59680 */     // GIR_Coverage, 2171,
     /*  59680 */     GIR_EraseRootFromParent_Done,
     /*  59681 */   // Label 1277: @59681
     /*  59681 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(59735), // Rule ID 2172 //
     /*  59686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59715 */     // (intrinsic_wo_chain:{ *:[i32] } 3904:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWB),
     /*  59718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59733 */     GIR_RootConstrainSelectedInstOperands,
     /*  59734 */     // GIR_Coverage, 2172,
     /*  59734 */     GIR_EraseRootFromParent_Done,
     /*  59735 */   // Label 1278: @59735
     /*  59735 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(59789), // Rule ID 2173 //
     /*  59740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  59748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59769 */     // (intrinsic_wo_chain:{ *:[i32] } 3905:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWT),
     /*  59772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59781 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59787 */     GIR_RootConstrainSelectedInstOperands,
     /*  59788 */     // GIR_Coverage, 2173,
     /*  59788 */     GIR_EraseRootFromParent_Done,
     /*  59789 */   // Label 1279: @59789
     /*  59789 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(59837), // Rule ID 2510 //
     /*  59794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  59797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  59802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  59805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  59808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  59811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  59815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  59819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  59823 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3758:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /*  59823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  59826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59835 */     GIR_RootConstrainSelectedInstOperands,
     /*  59836 */     // GIR_Coverage, 2510,
     /*  59836 */     GIR_EraseRootFromParent_Done,
     /*  59837 */   // Label 1280: @59837
     /*  59837 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(59885), // Rule ID 2511 //
     /*  59842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  59845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  59850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  59853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  59856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  59859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  59863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  59867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  59871 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3757:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /*  59871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  59874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  59883 */     GIR_RootConstrainSelectedInstOperands,
     /*  59884 */     // GIR_Coverage, 2511,
     /*  59884 */     GIR_EraseRootFromParent_Done,
     /*  59885 */   // Label 1281: @59885
     /*  59885 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(59933), // Rule ID 2512 //
     /*  59890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  59893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  59898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  59901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  59904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  59907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59919 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3758:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /*  59919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  59922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59931 */     GIR_RootConstrainSelectedInstOperands,
     /*  59932 */     // GIR_Coverage, 2512,
     /*  59932 */     GIR_EraseRootFromParent_Done,
     /*  59933 */   // Label 1282: @59933
     /*  59933 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(59981), // Rule ID 2513 //
     /*  59938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  59941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  59946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  59949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  59952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  59955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59967 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3757:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /*  59967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  59970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  59979 */     GIR_RootConstrainSelectedInstOperands,
     /*  59980 */     // GIR_Coverage, 2513,
     /*  59980 */     GIR_EraseRootFromParent_Done,
     /*  59981 */   // Label 1283: @59981
     /*  59981 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(60029), // Rule ID 2514 //
     /*  59986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  59989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  59994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  59997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60015 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3758:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /*  60015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60027 */     GIR_RootConstrainSelectedInstOperands,
     /*  60028 */     // GIR_Coverage, 2514,
     /*  60028 */     GIR_EraseRootFromParent_Done,
     /*  60029 */   // Label 1284: @60029
     /*  60029 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(60077), // Rule ID 2515 //
     /*  60034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60063 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3757:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /*  60063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60075 */     GIR_RootConstrainSelectedInstOperands,
     /*  60076 */     // GIR_Coverage, 2515,
     /*  60076 */     GIR_EraseRootFromParent_Done,
     /*  60077 */   // Label 1285: @60077
     /*  60077 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(60125), // Rule ID 2516 //
     /*  60082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60111 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3758:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /*  60111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60123 */     GIR_RootConstrainSelectedInstOperands,
     /*  60124 */     // GIR_Coverage, 2516,
     /*  60124 */     GIR_EraseRootFromParent_Done,
     /*  60125 */   // Label 1286: @60125
     /*  60125 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(60173), // Rule ID 2517 //
     /*  60130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60159 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3757:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /*  60159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60171 */     GIR_RootConstrainSelectedInstOperands,
     /*  60172 */     // GIR_Coverage, 2517,
     /*  60172 */     GIR_EraseRootFromParent_Done,
     /*  60173 */   // Label 1287: @60173
     /*  60173 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(60278), // Rule ID 3102 //
     /*  60178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60207 */     // (intrinsic_wo_chain:{ *:[f32] } 3566:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60207 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60210 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60214 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60223 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf32),
     /*  60235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60240 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60243 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60247 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60250 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60256 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60277 */     // GIR_Coverage, 3102,
     /*  60277 */     GIR_EraseRootFromParent_Done,
     /*  60278 */   // Label 1288: @60278
     /*  60278 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(60383), // Rule ID 3104 //
     /*  60283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60312 */     // (intrinsic_wo_chain:{ *:[f16] } 3566:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60312 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60315 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60319 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60324 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60328 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf16),
     /*  60340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60345 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60352 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60355 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60361 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60382 */     // GIR_Coverage, 3104,
     /*  60382 */     GIR_EraseRootFromParent_Done,
     /*  60383 */   // Label 1289: @60383
     /*  60383 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(60488), // Rule ID 3106 //
     /*  60388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60417 */     // (intrinsic_wo_chain:{ *:[f32] } 3557:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60417 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60420 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60424 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60433 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf32),
     /*  60445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60450 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60453 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60457 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60460 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60466 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60487 */     // GIR_Coverage, 3106,
     /*  60487 */     GIR_EraseRootFromParent_Done,
     /*  60488 */   // Label 1290: @60488
     /*  60488 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(60593), // Rule ID 3108 //
     /*  60493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60522 */     // (intrinsic_wo_chain:{ *:[f16] } 3557:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60522 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60525 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60529 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60534 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf16),
     /*  60550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60555 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60558 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60562 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60565 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60571 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60587 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60592 */     // GIR_Coverage, 3108,
     /*  60592 */     GIR_EraseRootFromParent_Done,
     /*  60593 */   // Label 1291: @60593
     /*  60593 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(60698), // Rule ID 3110 //
     /*  60598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  60606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60627 */     // (intrinsic_wo_chain:{ *:[f32] } 3564:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60627 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60630 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60634 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60639 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf32),
     /*  60655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60663 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60667 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60670 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60676 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60697 */     // GIR_Coverage, 3110,
     /*  60697 */     GIR_EraseRootFromParent_Done,
     /*  60698 */   // Label 1292: @60698
     /*  60698 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(60803), // Rule ID 3112 //
     /*  60703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  60711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60732 */     // (intrinsic_wo_chain:{ *:[f16] } 3564:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60732 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60735 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60739 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60744 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60748 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf16),
     /*  60760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60765 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60772 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60775 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60781 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60802 */     // GIR_Coverage, 3112,
     /*  60802 */     GIR_EraseRootFromParent_Done,
     /*  60803 */   // Label 1293: @60803
     /*  60803 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(60908), // Rule ID 3114 //
     /*  60808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  60816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60837 */     // (intrinsic_wo_chain:{ *:[f32] } 3555:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60837 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60840 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60844 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60849 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60853 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf32),
     /*  60865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60870 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60873 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60877 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60880 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60886 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60907 */     // GIR_Coverage, 3114,
     /*  60907 */     GIR_EraseRootFromParent_Done,
     /*  60908 */   // Label 1294: @60908
     /*  60908 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(61013), // Rule ID 3116 //
     /*  60913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  60921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60942 */     // (intrinsic_wo_chain:{ *:[f16] } 3555:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60942 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60945 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60949 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60954 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60958 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf16),
     /*  60970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60975 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60982 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60985 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60991 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61012 */     // GIR_Coverage, 3116,
     /*  61012 */     GIR_EraseRootFromParent_Done,
     /*  61013 */   // Label 1295: @61013
     /*  61013 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(61073), // Rule ID 3166 //
     /*  61018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61047 */     // (intrinsic_wo_chain:{ *:[i32] } 3562:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMINAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs8),
     /*  61050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61052 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61054 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61071 */     GIR_RootConstrainSelectedInstOperands,
     /*  61072 */     // GIR_Coverage, 3166,
     /*  61072 */     GIR_EraseRootFromParent_Done,
     /*  61073 */   // Label 1296: @61073
     /*  61073 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(61133), // Rule ID 3168 //
     /*  61078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61107 */     // (intrinsic_wo_chain:{ *:[i32] } 3562:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMINAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs16),
     /*  61110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61112 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61114 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61131 */     GIR_RootConstrainSelectedInstOperands,
     /*  61132 */     // GIR_Coverage, 3168,
     /*  61132 */     GIR_EraseRootFromParent_Done,
     /*  61133 */   // Label 1297: @61133
     /*  61133 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(61193), // Rule ID 3170 //
     /*  61138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61167 */     // (intrinsic_wo_chain:{ *:[i32] } 3562:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMINAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs32),
     /*  61170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61172 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61174 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61191 */     GIR_RootConstrainSelectedInstOperands,
     /*  61192 */     // GIR_Coverage, 3170,
     /*  61192 */     GIR_EraseRootFromParent_Done,
     /*  61193 */   // Label 1298: @61193
     /*  61193 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(61253), // Rule ID 3172 //
     /*  61198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61227 */     // (intrinsic_wo_chain:{ *:[i32] } 3553:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMAXAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs8),
     /*  61230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61232 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61234 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61251 */     GIR_RootConstrainSelectedInstOperands,
     /*  61252 */     // GIR_Coverage, 3172,
     /*  61252 */     GIR_EraseRootFromParent_Done,
     /*  61253 */   // Label 1299: @61253
     /*  61253 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(61313), // Rule ID 3174 //
     /*  61258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61287 */     // (intrinsic_wo_chain:{ *:[i32] } 3553:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMAXAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs16),
     /*  61290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61292 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61294 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61311 */     GIR_RootConstrainSelectedInstOperands,
     /*  61312 */     // GIR_Coverage, 3174,
     /*  61312 */     GIR_EraseRootFromParent_Done,
     /*  61313 */   // Label 1300: @61313
     /*  61313 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(61373), // Rule ID 3176 //
     /*  61318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61347 */     // (intrinsic_wo_chain:{ *:[i32] } 3553:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMAXAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs32),
     /*  61350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61352 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61354 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61371 */     GIR_RootConstrainSelectedInstOperands,
     /*  61372 */     // GIR_Coverage, 3176,
     /*  61372 */     GIR_EraseRootFromParent_Done,
     /*  61373 */   // Label 1301: @61373
     /*  61373 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(61448), // Rule ID 3467 //
     /*  61378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61407 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  61407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi8),
     /*  61422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61446 */     GIR_RootConstrainSelectedInstOperands,
     /*  61447 */     // GIR_Coverage, 3467,
     /*  61447 */     GIR_EraseRootFromParent_Done,
     /*  61448 */   // Label 1302: @61448
     /*  61448 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(61523), // Rule ID 3474 //
     /*  61453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61482 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  61482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi16),
     /*  61497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61521 */     GIR_RootConstrainSelectedInstOperands,
     /*  61522 */     // GIR_Coverage, 3474,
     /*  61522 */     GIR_EraseRootFromParent_Done,
     /*  61523 */   // Label 1303: @61523
     /*  61523 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(61598), // Rule ID 3478 //
     /*  61528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  61539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  61542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61557 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  61557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi32),
     /*  61572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61596 */     GIR_RootConstrainSelectedInstOperands,
     /*  61597 */     // GIR_Coverage, 3478,
     /*  61597 */     GIR_EraseRootFromParent_Done,
     /*  61598 */   // Label 1304: @61598
     /*  61598 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(61673), // Rule ID 3480 //
     /*  61603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  61611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61632 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3684:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQRDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  61632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi8),
     /*  61647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61671 */     GIR_RootConstrainSelectedInstOperands,
     /*  61672 */     // GIR_Coverage, 3480,
     /*  61672 */     GIR_EraseRootFromParent_Done,
     /*  61673 */   // Label 1305: @61673
     /*  61673 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(61748), // Rule ID 3482 //
     /*  61678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  61686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61707 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3684:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQRDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  61707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi16),
     /*  61722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61731 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61737 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61746 */     GIR_RootConstrainSelectedInstOperands,
     /*  61747 */     // GIR_Coverage, 3482,
     /*  61747 */     GIR_EraseRootFromParent_Done,
     /*  61748 */   // Label 1306: @61748
     /*  61748 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(61823), // Rule ID 3484 //
     /*  61753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  61761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  61764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  61767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61782 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3684:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQRDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  61782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi32),
     /*  61797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61821 */     GIR_RootConstrainSelectedInstOperands,
     /*  61822 */     // GIR_Coverage, 3484,
     /*  61822 */     GIR_EraseRootFromParent_Done,
     /*  61823 */   // Label 1307: @61823
     /*  61823 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(61898), // Rule ID 4752 //
     /*  61828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  61836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  61845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61857 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3608:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  61857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /*  61872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  61876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  61878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61881 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61896 */     GIR_RootConstrainSelectedInstOperands,
     /*  61897 */     // GIR_Coverage, 4752,
     /*  61897 */     GIR_EraseRootFromParent_Done,
     /*  61898 */   // Label 1308: @61898
     /*  61898 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(61973), // Rule ID 4757 //
     /*  61903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  61911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  61920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61932 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3608:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  61932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  61947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  61951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  61953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61971 */     GIR_RootConstrainSelectedInstOperands,
     /*  61972 */     // GIR_Coverage, 4757,
     /*  61972 */     GIR_EraseRootFromParent_Done,
     /*  61973 */   // Label 1309: @61973
     /*  61973 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(62048), // Rule ID 4759 //
     /*  61978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  61986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  61989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  61992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  61995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62007 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3608:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62046 */     GIR_RootConstrainSelectedInstOperands,
     /*  62047 */     // GIR_Coverage, 4759,
     /*  62047 */     GIR_EraseRootFromParent_Done,
     /*  62048 */   // Label 1310: @62048
     /*  62048 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(62123), // Rule ID 4761 //
     /*  62053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62082 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3608:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62121 */     GIR_RootConstrainSelectedInstOperands,
     /*  62122 */     // GIR_Coverage, 4761,
     /*  62122 */     GIR_EraseRootFromParent_Done,
     /*  62123 */   // Label 1311: @62123
     /*  62123 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(62198), // Rule ID 4763 //
     /*  62128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62157 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3608:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62196 */     GIR_RootConstrainSelectedInstOperands,
     /*  62197 */     // GIR_Coverage, 4763,
     /*  62197 */     GIR_EraseRootFromParent_Done,
     /*  62198 */   // Label 1312: @62198
     /*  62198 */   GIM_Reject,
     /*  62199 */ // Label 957: @62199
     /*  62199 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(73122),
     /*  62204 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  62207 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(62297), // Rule ID 3913 //
     /*  62212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62249 */     // MIs[1] Operand 1
     /*  62249 */     // No operand predicates
     /*  62249 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62255 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms8),
     /*  62270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62272 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62295 */     GIR_RootConstrainSelectedInstOperands,
     /*  62296 */     // GIR_Coverage, 3913,
     /*  62296 */     GIR_EraseRootFromParent_Done,
     /*  62297 */   // Label 1314: @62297
     /*  62297 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(62387), // Rule ID 3915 //
     /*  62302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62339 */     // MIs[1] Operand 1
     /*  62339 */     // No operand predicates
     /*  62339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62345 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3685:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu8),
     /*  62360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62362 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62385 */     GIR_RootConstrainSelectedInstOperands,
     /*  62386 */     // GIR_Coverage, 3915,
     /*  62386 */     GIR_EraseRootFromParent_Done,
     /*  62387 */   // Label 1315: @62387
     /*  62387 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(62477), // Rule ID 3917 //
     /*  62392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62429 */     // MIs[1] Operand 1
     /*  62429 */     // No operand predicates
     /*  62429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62435 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  62435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms16),
     /*  62450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62452 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62460 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62475 */     GIR_RootConstrainSelectedInstOperands,
     /*  62476 */     // GIR_Coverage, 3917,
     /*  62476 */     GIR_EraseRootFromParent_Done,
     /*  62477 */   // Label 1316: @62477
     /*  62477 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(62567), // Rule ID 3919 //
     /*  62482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62519 */     // MIs[1] Operand 1
     /*  62519 */     // No operand predicates
     /*  62519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62525 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3685:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  62525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu16),
     /*  62540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62542 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62565 */     GIR_RootConstrainSelectedInstOperands,
     /*  62566 */     // GIR_Coverage, 3919,
     /*  62566 */     GIR_EraseRootFromParent_Done,
     /*  62567 */   // Label 1317: @62567
     /*  62567 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(62657), // Rule ID 3921 //
     /*  62572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  62609 */     // MIs[1] Operand 1
     /*  62609 */     // No operand predicates
     /*  62609 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62615 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3685:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  62615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms32),
     /*  62630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62632 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62655 */     GIR_RootConstrainSelectedInstOperands,
     /*  62656 */     // GIR_Coverage, 3921,
     /*  62656 */     GIR_EraseRootFromParent_Done,
     /*  62657 */   // Label 1318: @62657
     /*  62657 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(62747), // Rule ID 3923 //
     /*  62662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  62699 */     // MIs[1] Operand 1
     /*  62699 */     // No operand predicates
     /*  62699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62705 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3685:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  62705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu32),
     /*  62720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62722 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62745 */     GIR_RootConstrainSelectedInstOperands,
     /*  62746 */     // GIR_Coverage, 3923,
     /*  62746 */     GIR_EraseRootFromParent_Done,
     /*  62747 */   // Label 1319: @62747
     /*  62747 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(62837), // Rule ID 3931 //
     /*  62752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  62757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  62789 */     // MIs[1] Operand 1
     /*  62789 */     // No operand predicates
     /*  62789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62795 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3701:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  62795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms8),
     /*  62810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62812 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62835 */     GIR_RootConstrainSelectedInstOperands,
     /*  62836 */     // GIR_Coverage, 3931,
     /*  62836 */     GIR_EraseRootFromParent_Done,
     /*  62837 */   // Label 1320: @62837
     /*  62837 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(62927), // Rule ID 3933 //
     /*  62842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  62847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  62879 */     // MIs[1] Operand 1
     /*  62879 */     // No operand predicates
     /*  62879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62885 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3701:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  62885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu8),
     /*  62900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62902 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62925 */     GIR_RootConstrainSelectedInstOperands,
     /*  62926 */     // GIR_Coverage, 3933,
     /*  62926 */     GIR_EraseRootFromParent_Done,
     /*  62927 */   // Label 1321: @62927
     /*  62927 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(63017), // Rule ID 3935 //
     /*  62932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  62937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  62969 */     // MIs[1] Operand 1
     /*  62969 */     // No operand predicates
     /*  62969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62975 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3701:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  62975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms16),
     /*  62990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62992 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63015 */     GIR_RootConstrainSelectedInstOperands,
     /*  63016 */     // GIR_Coverage, 3935,
     /*  63016 */     GIR_EraseRootFromParent_Done,
     /*  63017 */   // Label 1322: @63017
     /*  63017 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(63107), // Rule ID 3937 //
     /*  63022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63059 */     // MIs[1] Operand 1
     /*  63059 */     // No operand predicates
     /*  63059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63065 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3701:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu16),
     /*  63080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63082 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63105 */     GIR_RootConstrainSelectedInstOperands,
     /*  63106 */     // GIR_Coverage, 3937,
     /*  63106 */     GIR_EraseRootFromParent_Done,
     /*  63107 */   // Label 1323: @63107
     /*  63107 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(63197), // Rule ID 3939 //
     /*  63112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63149 */     // MIs[1] Operand 1
     /*  63149 */     // No operand predicates
     /*  63149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63155 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3701:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms32),
     /*  63170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63172 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63195 */     GIR_RootConstrainSelectedInstOperands,
     /*  63196 */     // GIR_Coverage, 3939,
     /*  63196 */     GIR_EraseRootFromParent_Done,
     /*  63197 */   // Label 1324: @63197
     /*  63197 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(63287), // Rule ID 3941 //
     /*  63202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63239 */     // MIs[1] Operand 1
     /*  63239 */     // No operand predicates
     /*  63239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63245 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3701:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu32),
     /*  63260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63262 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63270 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63285 */     GIR_RootConstrainSelectedInstOperands,
     /*  63286 */     // GIR_Coverage, 3941,
     /*  63286 */     GIR_EraseRootFromParent_Done,
     /*  63287 */   // Label 1325: @63287
     /*  63287 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(63376), // Rule ID 4039 //
     /*  63292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63332 */     // MIs[1] Operand 1
     /*  63332 */     // No operand predicates
     /*  63332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63334 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3621:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16s16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16_fix),
     /*  63349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63374 */     GIR_RootConstrainSelectedInstOperands,
     /*  63375 */     // GIR_Coverage, 4039,
     /*  63375 */     GIR_EraseRootFromParent_Done,
     /*  63376 */   // Label 1326: @63376
     /*  63376 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(63465), // Rule ID 4041 //
     /*  63381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63421 */     // MIs[1] Operand 1
     /*  63421 */     // No operand predicates
     /*  63421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63423 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3621:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16_fix),
     /*  63438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63463 */     GIR_RootConstrainSelectedInstOperands,
     /*  63464 */     // GIR_Coverage, 4041,
     /*  63464 */     GIR_EraseRootFromParent_Done,
     /*  63465 */   // Label 1327: @63465
     /*  63465 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(63554), // Rule ID 4043 //
     /*  63470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63510 */     // MIs[1] Operand 1
     /*  63510 */     // No operand predicates
     /*  63510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63512 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3621:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16u16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16_fix),
     /*  63527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63552 */     GIR_RootConstrainSelectedInstOperands,
     /*  63553 */     // GIR_Coverage, 4043,
     /*  63553 */     GIR_EraseRootFromParent_Done,
     /*  63554 */   // Label 1328: @63554
     /*  63554 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(63643), // Rule ID 4045 //
     /*  63559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63599 */     // MIs[1] Operand 1
     /*  63599 */     // No operand predicates
     /*  63599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63601 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3621:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16_fix),
     /*  63616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63641 */     GIR_RootConstrainSelectedInstOperands,
     /*  63642 */     // GIR_Coverage, 4045,
     /*  63642 */     GIR_EraseRootFromParent_Done,
     /*  63643 */   // Label 1329: @63643
     /*  63643 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(63732), // Rule ID 4047 //
     /*  63648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  63665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63688 */     // MIs[1] Operand 1
     /*  63688 */     // No operand predicates
     /*  63688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63690 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3621:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32s32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32_fix),
     /*  63705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63730 */     GIR_RootConstrainSelectedInstOperands,
     /*  63731 */     // GIR_Coverage, 4047,
     /*  63731 */     GIR_EraseRootFromParent_Done,
     /*  63732 */   // Label 1330: @63732
     /*  63732 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(63821), // Rule ID 4049 //
     /*  63737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  63754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63777 */     // MIs[1] Operand 1
     /*  63777 */     // No operand predicates
     /*  63777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63779 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3621:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32_fix),
     /*  63794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63819 */     GIR_RootConstrainSelectedInstOperands,
     /*  63820 */     // GIR_Coverage, 4049,
     /*  63820 */     GIR_EraseRootFromParent_Done,
     /*  63821 */   // Label 1331: @63821
     /*  63821 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(63910), // Rule ID 4051 //
     /*  63826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  63843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63866 */     // MIs[1] Operand 1
     /*  63866 */     // No operand predicates
     /*  63866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63868 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3621:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32u32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32_fix),
     /*  63883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63908 */     GIR_RootConstrainSelectedInstOperands,
     /*  63909 */     // GIR_Coverage, 4051,
     /*  63909 */     GIR_EraseRootFromParent_Done,
     /*  63910 */   // Label 1332: @63910
     /*  63910 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(63999), // Rule ID 4053 //
     /*  63915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  63932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63955 */     // MIs[1] Operand 1
     /*  63955 */     // No operand predicates
     /*  63955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63957 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3621:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32_fix),
     /*  63972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63997 */     GIR_RootConstrainSelectedInstOperands,
     /*  63998 */     // GIR_Coverage, 4053,
     /*  63998 */     GIR_EraseRootFromParent_Done,
     /*  63999 */   // Label 1333: @63999
     /*  63999 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(64066), // Rule ID 3118 //
     /*  64004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64040 */     // (intrinsic_wo_chain:{ *:[i32] } 3568:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /*  64043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64045 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64047 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64064 */     GIR_RootConstrainSelectedInstOperands,
     /*  64065 */     // GIR_Coverage, 3118,
     /*  64065 */     GIR_EraseRootFromParent_Done,
     /*  64066 */   // Label 1334: @64066
     /*  64066 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(64133), // Rule ID 3120 //
     /*  64071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64107 */     // (intrinsic_wo_chain:{ *:[i32] } 3568:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /*  64110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64112 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64114 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64131 */     GIR_RootConstrainSelectedInstOperands,
     /*  64132 */     // GIR_Coverage, 3120,
     /*  64132 */     GIR_EraseRootFromParent_Done,
     /*  64133 */   // Label 1335: @64133
     /*  64133 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(64200), // Rule ID 3122 //
     /*  64138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64174 */     // (intrinsic_wo_chain:{ *:[i32] } 3568:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /*  64177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64179 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64181 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64198 */     GIR_RootConstrainSelectedInstOperands,
     /*  64199 */     // GIR_Coverage, 3122,
     /*  64199 */     GIR_EraseRootFromParent_Done,
     /*  64200 */   // Label 1336: @64200
     /*  64200 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(64267), // Rule ID 3124 //
     /*  64205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64241 */     // (intrinsic_wo_chain:{ *:[i32] } 3568:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /*  64244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64246 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64248 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64265 */     GIR_RootConstrainSelectedInstOperands,
     /*  64266 */     // GIR_Coverage, 3124,
     /*  64266 */     GIR_EraseRootFromParent_Done,
     /*  64267 */   // Label 1337: @64267
     /*  64267 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(64334), // Rule ID 3126 //
     /*  64272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64308 */     // (intrinsic_wo_chain:{ *:[i32] } 3568:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /*  64311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64313 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64315 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64332 */     GIR_RootConstrainSelectedInstOperands,
     /*  64333 */     // GIR_Coverage, 3126,
     /*  64333 */     GIR_EraseRootFromParent_Done,
     /*  64334 */   // Label 1338: @64334
     /*  64334 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(64401), // Rule ID 3128 //
     /*  64339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64375 */     // (intrinsic_wo_chain:{ *:[i32] } 3568:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /*  64378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64380 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64382 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64393 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64399 */     GIR_RootConstrainSelectedInstOperands,
     /*  64400 */     // GIR_Coverage, 3128,
     /*  64400 */     GIR_EraseRootFromParent_Done,
     /*  64401 */   // Label 1339: @64401
     /*  64401 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(64468), // Rule ID 3130 //
     /*  64406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64442 */     // (intrinsic_wo_chain:{ *:[i32] } 3559:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /*  64445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64447 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64449 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64460 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64466 */     GIR_RootConstrainSelectedInstOperands,
     /*  64467 */     // GIR_Coverage, 3130,
     /*  64467 */     GIR_EraseRootFromParent_Done,
     /*  64468 */   // Label 1340: @64468
     /*  64468 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(64535), // Rule ID 3132 //
     /*  64473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64509 */     // (intrinsic_wo_chain:{ *:[i32] } 3559:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /*  64512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64514 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64516 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64521 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64527 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64533 */     GIR_RootConstrainSelectedInstOperands,
     /*  64534 */     // GIR_Coverage, 3132,
     /*  64534 */     GIR_EraseRootFromParent_Done,
     /*  64535 */   // Label 1341: @64535
     /*  64535 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(64602), // Rule ID 3134 //
     /*  64540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64576 */     // (intrinsic_wo_chain:{ *:[i32] } 3559:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /*  64579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64581 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64583 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64600 */     GIR_RootConstrainSelectedInstOperands,
     /*  64601 */     // GIR_Coverage, 3134,
     /*  64601 */     GIR_EraseRootFromParent_Done,
     /*  64602 */   // Label 1342: @64602
     /*  64602 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(64669), // Rule ID 3136 //
     /*  64607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64643 */     // (intrinsic_wo_chain:{ *:[i32] } 3559:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /*  64646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64648 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64650 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64667 */     GIR_RootConstrainSelectedInstOperands,
     /*  64668 */     // GIR_Coverage, 3136,
     /*  64668 */     GIR_EraseRootFromParent_Done,
     /*  64669 */   // Label 1343: @64669
     /*  64669 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(64736), // Rule ID 3138 //
     /*  64674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64710 */     // (intrinsic_wo_chain:{ *:[i32] } 3559:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /*  64713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64715 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64717 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64734 */     GIR_RootConstrainSelectedInstOperands,
     /*  64735 */     // GIR_Coverage, 3138,
     /*  64735 */     GIR_EraseRootFromParent_Done,
     /*  64736 */   // Label 1344: @64736
     /*  64736 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(64803), // Rule ID 3140 //
     /*  64741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64777 */     // (intrinsic_wo_chain:{ *:[i32] } 3559:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /*  64780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64782 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64784 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64795 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64801 */     GIR_RootConstrainSelectedInstOperands,
     /*  64802 */     // GIR_Coverage, 3140,
     /*  64802 */     GIR_EraseRootFromParent_Done,
     /*  64803 */   // Label 1345: @64803
     /*  64803 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(64885), // Rule ID 3545 //
     /*  64808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  64816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64844 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3605:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  64844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs8),
     /*  64859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  64863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  64865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64883 */     GIR_RootConstrainSelectedInstOperands,
     /*  64884 */     // GIR_Coverage, 3545,
     /*  64884 */     GIR_EraseRootFromParent_Done,
     /*  64885 */   // Label 1346: @64885
     /*  64885 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(64967), // Rule ID 3552 //
     /*  64890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  64898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64926 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3605:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  64926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs16),
     /*  64941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  64945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  64947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64965 */     GIR_RootConstrainSelectedInstOperands,
     /*  64966 */     // GIR_Coverage, 3552,
     /*  64966 */     GIR_EraseRootFromParent_Done,
     /*  64967 */   // Label 1347: @64967
     /*  64967 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(65049), // Rule ID 3556 //
     /*  64972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  64980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65008 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3605:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs32),
     /*  65023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65047 */     GIR_RootConstrainSelectedInstOperands,
     /*  65048 */     // GIR_Coverage, 3556,
     /*  65048 */     GIR_EraseRootFromParent_Done,
     /*  65049 */   // Label 1348: @65049
     /*  65049 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(65131), // Rule ID 3560 //
     /*  65054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65090 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3605:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu8),
     /*  65105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65129 */     GIR_RootConstrainSelectedInstOperands,
     /*  65130 */     // GIR_Coverage, 3560,
     /*  65130 */     GIR_EraseRootFromParent_Done,
     /*  65131 */   // Label 1349: @65131
     /*  65131 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(65213), // Rule ID 3564 //
     /*  65136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65172 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3605:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu16),
     /*  65187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65211 */     GIR_RootConstrainSelectedInstOperands,
     /*  65212 */     // GIR_Coverage, 3564,
     /*  65212 */     GIR_EraseRootFromParent_Done,
     /*  65213 */   // Label 1350: @65213
     /*  65213 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(65295), // Rule ID 3568 //
     /*  65218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65254 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3605:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu32),
     /*  65269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65293 */     GIR_RootConstrainSelectedInstOperands,
     /*  65294 */     // GIR_Coverage, 3568,
     /*  65294 */     GIR_EraseRootFromParent_Done,
     /*  65295 */   // Label 1351: @65295
     /*  65295 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(65377), // Rule ID 3569 //
     /*  65300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65336 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3691:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs8),
     /*  65351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65375 */     GIR_RootConstrainSelectedInstOperands,
     /*  65376 */     // GIR_Coverage, 3569,
     /*  65376 */     GIR_EraseRootFromParent_Done,
     /*  65377 */   // Label 1352: @65377
     /*  65377 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(65459), // Rule ID 3576 //
     /*  65382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65418 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3691:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs16),
     /*  65433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65457 */     GIR_RootConstrainSelectedInstOperands,
     /*  65458 */     // GIR_Coverage, 3576,
     /*  65458 */     GIR_EraseRootFromParent_Done,
     /*  65459 */   // Label 1353: @65459
     /*  65459 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(65541), // Rule ID 3580 //
     /*  65464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65500 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3691:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs32),
     /*  65515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65530 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65539 */     GIR_RootConstrainSelectedInstOperands,
     /*  65540 */     // GIR_Coverage, 3580,
     /*  65540 */     GIR_EraseRootFromParent_Done,
     /*  65541 */   // Label 1354: @65541
     /*  65541 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(65623), // Rule ID 3584 //
     /*  65546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65582 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3691:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu8),
     /*  65597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65621 */     GIR_RootConstrainSelectedInstOperands,
     /*  65622 */     // GIR_Coverage, 3584,
     /*  65622 */     GIR_EraseRootFromParent_Done,
     /*  65623 */   // Label 1355: @65623
     /*  65623 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(65705), // Rule ID 3588 //
     /*  65628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65664 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3691:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu16),
     /*  65679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65703 */     GIR_RootConstrainSelectedInstOperands,
     /*  65704 */     // GIR_Coverage, 3588,
     /*  65704 */     GIR_EraseRootFromParent_Done,
     /*  65705 */   // Label 1356: @65705
     /*  65705 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(65787), // Rule ID 3592 //
     /*  65710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65746 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3691:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu32),
     /*  65761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65770 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65785 */     GIR_RootConstrainSelectedInstOperands,
     /*  65786 */     // GIR_Coverage, 3592,
     /*  65786 */     GIR_EraseRootFromParent_Done,
     /*  65787 */   // Label 1357: @65787
     /*  65787 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(65869), // Rule ID 3593 //
     /*  65792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  65800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65828 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3640:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs8),
     /*  65843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65867 */     GIR_RootConstrainSelectedInstOperands,
     /*  65868 */     // GIR_Coverage, 3593,
     /*  65868 */     GIR_EraseRootFromParent_Done,
     /*  65869 */   // Label 1358: @65869
     /*  65869 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(65951), // Rule ID 3600 //
     /*  65874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  65882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65910 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3640:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs16),
     /*  65925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65949 */     GIR_RootConstrainSelectedInstOperands,
     /*  65950 */     // GIR_Coverage, 3600,
     /*  65950 */     GIR_EraseRootFromParent_Done,
     /*  65951 */   // Label 1359: @65951
     /*  65951 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(66033), // Rule ID 3604 //
     /*  65956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  65964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65992 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3640:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs32),
     /*  66007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66031 */     GIR_RootConstrainSelectedInstOperands,
     /*  66032 */     // GIR_Coverage, 3604,
     /*  66032 */     GIR_EraseRootFromParent_Done,
     /*  66033 */   // Label 1360: @66033
     /*  66033 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(66115), // Rule ID 3608 //
     /*  66038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66070 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66074 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3640:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu8),
     /*  66089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66113 */     GIR_RootConstrainSelectedInstOperands,
     /*  66114 */     // GIR_Coverage, 3608,
     /*  66114 */     GIR_EraseRootFromParent_Done,
     /*  66115 */   // Label 1361: @66115
     /*  66115 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(66197), // Rule ID 3612 //
     /*  66120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66156 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3640:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu16),
     /*  66171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66195 */     GIR_RootConstrainSelectedInstOperands,
     /*  66196 */     // GIR_Coverage, 3612,
     /*  66196 */     GIR_EraseRootFromParent_Done,
     /*  66197 */   // Label 1362: @66197
     /*  66197 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(66279), // Rule ID 3616 //
     /*  66202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66238 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3640:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu32),
     /*  66253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66277 */     GIR_RootConstrainSelectedInstOperands,
     /*  66278 */     // GIR_Coverage, 3616,
     /*  66278 */     GIR_EraseRootFromParent_Done,
     /*  66279 */   // Label 1363: @66279
     /*  66279 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(66361), // Rule ID 3617 //
     /*  66284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66320 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3641:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs8),
     /*  66335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66359 */     GIR_RootConstrainSelectedInstOperands,
     /*  66360 */     // GIR_Coverage, 3617,
     /*  66360 */     GIR_EraseRootFromParent_Done,
     /*  66361 */   // Label 1364: @66361
     /*  66361 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(66443), // Rule ID 3620 //
     /*  66366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66402 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs16),
     /*  66417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66426 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66441 */     GIR_RootConstrainSelectedInstOperands,
     /*  66442 */     // GIR_Coverage, 3620,
     /*  66442 */     GIR_EraseRootFromParent_Done,
     /*  66443 */   // Label 1365: @66443
     /*  66443 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(66525), // Rule ID 3623 //
     /*  66448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66484 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3641:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs32),
     /*  66499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66523 */     GIR_RootConstrainSelectedInstOperands,
     /*  66524 */     // GIR_Coverage, 3623,
     /*  66524 */     GIR_EraseRootFromParent_Done,
     /*  66525 */   // Label 1366: @66525
     /*  66525 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(66607), // Rule ID 3626 //
     /*  66530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66566 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3641:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu8),
     /*  66581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66605 */     GIR_RootConstrainSelectedInstOperands,
     /*  66606 */     // GIR_Coverage, 3626,
     /*  66606 */     GIR_EraseRootFromParent_Done,
     /*  66607 */   // Label 1367: @66607
     /*  66607 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(66689), // Rule ID 3629 //
     /*  66612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66648 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu16),
     /*  66663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66687 */     GIR_RootConstrainSelectedInstOperands,
     /*  66688 */     // GIR_Coverage, 3629,
     /*  66688 */     GIR_EraseRootFromParent_Done,
     /*  66689 */   // Label 1368: @66689
     /*  66689 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(66771), // Rule ID 3632 //
     /*  66694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66730 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3641:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu32),
     /*  66745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66769 */     GIR_RootConstrainSelectedInstOperands,
     /*  66770 */     // GIR_Coverage, 3632,
     /*  66770 */     GIR_EraseRootFromParent_Done,
     /*  66771 */   // Label 1369: @66771
     /*  66771 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(66853), // Rule ID 4033 //
     /*  66776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  66779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  66784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66812 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3605:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /*  66812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /*  66827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66851 */     GIR_RootConstrainSelectedInstOperands,
     /*  66852 */     // GIR_Coverage, 4033,
     /*  66852 */     GIR_EraseRootFromParent_Done,
     /*  66853 */   // Label 1370: @66853
     /*  66853 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(66935), // Rule ID 4035 //
     /*  66858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  66861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  66866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66894 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3605:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /*  66894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /*  66909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66933 */     GIR_RootConstrainSelectedInstOperands,
     /*  66934 */     // GIR_Coverage, 4035,
     /*  66934 */     GIR_EraseRootFromParent_Done,
     /*  66935 */   // Label 1371: @66935
     /*  66935 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(67017), // Rule ID 4408 //
     /*  66940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  66948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66976 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp8),
     /*  66991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67015 */     GIR_RootConstrainSelectedInstOperands,
     /*  67016 */     // GIR_Coverage, 4408,
     /*  67016 */     GIR_EraseRootFromParent_Done,
     /*  67017 */   // Label 1372: @67017
     /*  67017 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(67099), // Rule ID 4410 //
     /*  67022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67058 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3668:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp8),
     /*  67073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67097 */     GIR_RootConstrainSelectedInstOperands,
     /*  67098 */     // GIR_Coverage, 4410,
     /*  67098 */     GIR_EraseRootFromParent_Done,
     /*  67099 */   // Label 1373: @67099
     /*  67099 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(67181), // Rule ID 4412 //
     /*  67104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67140 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp16),
     /*  67155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67179 */     GIR_RootConstrainSelectedInstOperands,
     /*  67180 */     // GIR_Coverage, 4412,
     /*  67180 */     GIR_EraseRootFromParent_Done,
     /*  67181 */   // Label 1374: @67181
     /*  67181 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(67263), // Rule ID 4414 //
     /*  67186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67222 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3668:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp16),
     /*  67237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67261 */     GIR_RootConstrainSelectedInstOperands,
     /*  67262 */     // GIR_Coverage, 4414,
     /*  67262 */     GIR_EraseRootFromParent_Done,
     /*  67263 */   // Label 1375: @67263
     /*  67263 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(67345), // Rule ID 4441 //
     /*  67268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67304 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3666:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /*  67319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67343 */     GIR_RootConstrainSelectedInstOperands,
     /*  67344 */     // GIR_Coverage, 4441,
     /*  67344 */     GIR_EraseRootFromParent_Done,
     /*  67345 */   // Label 1376: @67345
     /*  67345 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(67427), // Rule ID 4448 //
     /*  67350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67386 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3666:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /*  67401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67425 */     GIR_RootConstrainSelectedInstOperands,
     /*  67426 */     // GIR_Coverage, 4448,
     /*  67426 */     GIR_EraseRootFromParent_Done,
     /*  67427 */   // Label 1377: @67427
     /*  67427 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(67509), // Rule ID 4452 //
     /*  67432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67468 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3666:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /*  67483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67492 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67498 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67507 */     GIR_RootConstrainSelectedInstOperands,
     /*  67508 */     // GIR_Coverage, 4452,
     /*  67508 */     GIR_EraseRootFromParent_Done,
     /*  67509 */   // Label 1378: @67509
     /*  67509 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(67591), // Rule ID 4456 //
     /*  67514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67550 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3666:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /*  67565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67574 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67589 */     GIR_RootConstrainSelectedInstOperands,
     /*  67590 */     // GIR_Coverage, 4456,
     /*  67590 */     GIR_EraseRootFromParent_Done,
     /*  67591 */   // Label 1379: @67591
     /*  67591 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(67673), // Rule ID 4460 //
     /*  67596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67632 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3666:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /*  67647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67671 */     GIR_RootConstrainSelectedInstOperands,
     /*  67672 */     // GIR_Coverage, 4460,
     /*  67672 */     GIR_EraseRootFromParent_Done,
     /*  67673 */   // Label 1380: @67673
     /*  67673 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(67755), // Rule ID 4464 //
     /*  67678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67714 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3666:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /*  67729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67753 */     GIR_RootConstrainSelectedInstOperands,
     /*  67754 */     // GIR_Coverage, 4464,
     /*  67754 */     GIR_EraseRootFromParent_Done,
     /*  67755 */   // Label 1381: @67755
     /*  67755 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(67837), // Rule ID 4465 //
     /*  67760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  67768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67796 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs8),
     /*  67811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67835 */     GIR_RootConstrainSelectedInstOperands,
     /*  67836 */     // GIR_Coverage, 4465,
     /*  67836 */     GIR_EraseRootFromParent_Done,
     /*  67837 */   // Label 1382: @67837
     /*  67837 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(67919), // Rule ID 4467 //
     /*  67842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  67850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67878 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs16),
     /*  67893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67917 */     GIR_RootConstrainSelectedInstOperands,
     /*  67918 */     // GIR_Coverage, 4467,
     /*  67918 */     GIR_EraseRootFromParent_Done,
     /*  67919 */   // Label 1383: @67919
     /*  67919 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(68001), // Rule ID 4469 //
     /*  67924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  67932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67960 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs32),
     /*  67975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67999 */     GIR_RootConstrainSelectedInstOperands,
     /*  68000 */     // GIR_Coverage, 4469,
     /*  68000 */     GIR_EraseRootFromParent_Done,
     /*  68001 */   // Label 1384: @68001
     /*  68001 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(68083), // Rule ID 4471 //
     /*  68006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68042 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3700:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu8),
     /*  68057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68081 */     GIR_RootConstrainSelectedInstOperands,
     /*  68082 */     // GIR_Coverage, 4471,
     /*  68082 */     GIR_EraseRootFromParent_Done,
     /*  68083 */   // Label 1385: @68083
     /*  68083 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(68165), // Rule ID 4473 //
     /*  68088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68124 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3700:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu16),
     /*  68139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68148 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68163 */     GIR_RootConstrainSelectedInstOperands,
     /*  68164 */     // GIR_Coverage, 4473,
     /*  68164 */     GIR_EraseRootFromParent_Done,
     /*  68165 */   // Label 1386: @68165
     /*  68165 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(68247), // Rule ID 4475 //
     /*  68170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68206 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu32),
     /*  68221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68245 */     GIR_RootConstrainSelectedInstOperands,
     /*  68246 */     // GIR_Coverage, 4475,
     /*  68246 */     GIR_EraseRootFromParent_Done,
     /*  68247 */   // Label 1387: @68247
     /*  68247 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(68314), // Rule ID 4526 //
     /*  68252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68288 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3624:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf16f32bh:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32bh),
     /*  68291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68312 */     GIR_RootConstrainSelectedInstOperands,
     /*  68313 */     // GIR_Coverage, 4526,
     /*  68313 */     GIR_EraseRootFromParent_Done,
     /*  68314 */   // Label 1388: @68314
     /*  68314 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(68381), // Rule ID 4532 //
     /*  68319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68355 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3624:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf16f32th:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32th),
     /*  68358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68379 */     GIR_RootConstrainSelectedInstOperands,
     /*  68380 */     // GIR_Coverage, 4532,
     /*  68380 */     GIR_EraseRootFromParent_Done,
     /*  68381 */   // Label 1389: @68381
     /*  68381 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(68463), // Rule ID 4550 //
     /*  68386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68422 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3676:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16bh),
     /*  68437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68461 */     GIR_RootConstrainSelectedInstOperands,
     /*  68462 */     // GIR_Coverage, 4550,
     /*  68462 */     GIR_EraseRootFromParent_Done,
     /*  68463 */   // Label 1390: @68463
     /*  68463 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(68545), // Rule ID 4552 //
     /*  68468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68504 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3676:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16th),
     /*  68519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68543 */     GIR_RootConstrainSelectedInstOperands,
     /*  68544 */     // GIR_Coverage, 4552,
     /*  68544 */     GIR_EraseRootFromParent_Done,
     /*  68545 */   // Label 1391: @68545
     /*  68545 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(68627), // Rule ID 4554 //
     /*  68550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  68561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68586 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3676:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs32bh:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32bh),
     /*  68601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68625 */     GIR_RootConstrainSelectedInstOperands,
     /*  68626 */     // GIR_Coverage, 4554,
     /*  68626 */     GIR_EraseRootFromParent_Done,
     /*  68627 */   // Label 1392: @68627
     /*  68627 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(68709), // Rule ID 4556 //
     /*  68632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  68643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68668 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3676:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs32th:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32th),
     /*  68683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68707 */     GIR_RootConstrainSelectedInstOperands,
     /*  68708 */     // GIR_Coverage, 4556,
     /*  68708 */     GIR_EraseRootFromParent_Done,
     /*  68709 */   // Label 1393: @68709
     /*  68709 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(68786), // Rule ID 3901 //
     /*  68714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  68719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  68747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  68755 */     // MIs[1] Operand 1
     /*  68755 */     // No operand predicates
     /*  68755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  68757 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3715:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VSLIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  68757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm8),
     /*  68760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68762 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  68764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  68769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68784 */     GIR_RootConstrainSelectedInstOperands,
     /*  68785 */     // GIR_Coverage, 3901,
     /*  68785 */     GIR_EraseRootFromParent_Done,
     /*  68786 */   // Label 1394: @68786
     /*  68786 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(68863), // Rule ID 3903 //
     /*  68791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  68796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  68824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  68832 */     // MIs[1] Operand 1
     /*  68832 */     // No operand predicates
     /*  68832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  68834 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3715:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VSLIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  68834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm16),
     /*  68837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68839 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  68841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  68846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68861 */     GIR_RootConstrainSelectedInstOperands,
     /*  68862 */     // GIR_Coverage, 3903,
     /*  68862 */     GIR_EraseRootFromParent_Done,
     /*  68863 */   // Label 1395: @68863
     /*  68863 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(68940), // Rule ID 3905 //
     /*  68868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  68873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  68901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  68909 */     // MIs[1] Operand 1
     /*  68909 */     // No operand predicates
     /*  68909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  68911 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3715:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VSLIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  68911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm32),
     /*  68914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68916 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  68918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  68923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68938 */     GIR_RootConstrainSelectedInstOperands,
     /*  68939 */     // GIR_Coverage, 3905,
     /*  68939 */     GIR_EraseRootFromParent_Done,
     /*  68940 */   // Label 1396: @68940
     /*  68940 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(69017), // Rule ID 3907 //
     /*  68945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  68950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  68978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  68986 */     // MIs[1] Operand 1
     /*  68986 */     // No operand predicates
     /*  68986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  68988 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3717:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)  =>  (MVE_VSRIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  68988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm8),
     /*  68991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68993 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  68995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69003 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69015 */     GIR_RootConstrainSelectedInstOperands,
     /*  69016 */     // GIR_Coverage, 3907,
     /*  69016 */     GIR_EraseRootFromParent_Done,
     /*  69017 */   // Label 1397: @69017
     /*  69017 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(69094), // Rule ID 3909 //
     /*  69022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  69063 */     // MIs[1] Operand 1
     /*  69063 */     // No operand predicates
     /*  69063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69065 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3717:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)  =>  (MVE_VSRIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  69065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm16),
     /*  69068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69070 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69092 */     GIR_RootConstrainSelectedInstOperands,
     /*  69093 */     // GIR_Coverage, 3909,
     /*  69093 */     GIR_EraseRootFromParent_Done,
     /*  69094 */   // Label 1398: @69094
     /*  69094 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(69171), // Rule ID 3911 //
     /*  69099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  69140 */     // MIs[1] Operand 1
     /*  69140 */     // No operand predicates
     /*  69140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69142 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3717:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)  =>  (MVE_VSRIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  69142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm32),
     /*  69145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69147 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69169 */     GIR_RootConstrainSelectedInstOperands,
     /*  69170 */     // GIR_Coverage, 3911,
     /*  69170 */     GIR_EraseRootFromParent_Done,
     /*  69171 */   // Label 1399: @69171
     /*  69171 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(69262), // Rule ID 4380 //
     /*  69176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  69196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69208 */     // MIs[1] Operand 1
     /*  69208 */     // No operand predicates
     /*  69208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69218 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3615:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf16),
     /*  69233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69251 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69260 */     GIR_RootConstrainSelectedInstOperands,
     /*  69261 */     // GIR_Coverage, 4380,
     /*  69261 */     GIR_EraseRootFromParent_Done,
     /*  69262 */   // Label 1400: @69262
     /*  69262 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(69353), // Rule ID 4382 //
     /*  69267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  69287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69299 */     // MIs[1] Operand 1
     /*  69299 */     // No operand predicates
     /*  69299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69309 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3615:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf32),
     /*  69324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69351 */     GIR_RootConstrainSelectedInstOperands,
     /*  69352 */     // GIR_Coverage, 4382,
     /*  69352 */     GIR_EraseRootFromParent_Done,
     /*  69353 */   // Label 1401: @69353
     /*  69353 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(69416), // Rule ID 146 //
     /*  69358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  69361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69394 */     // (intrinsic_wo_chain:{ *:[i32] } 3941:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (USADA8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  69394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USADA8),
     /*  69397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69408 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69414 */     GIR_RootConstrainSelectedInstOperands,
     /*  69415 */     // GIR_Coverage, 146,
     /*  69415 */     GIR_EraseRootFromParent_Done,
     /*  69416 */   // Label 1402: @69416
     /*  69416 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(69479), // Rule ID 469 //
     /*  69421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69457 */     // (intrinsic_wo_chain:{ *:[i32] } 3941:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2USADA8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USADA8),
     /*  69460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69477 */     GIR_RootConstrainSelectedInstOperands,
     /*  69478 */     // GIR_Coverage, 469,
     /*  69478 */     GIR_EraseRootFromParent_Done,
     /*  69479 */   // Label 1403: @69479
     /*  69479 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(69542), // Rule ID 528 //
     /*  69484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  69492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69520 */     // (intrinsic_wo_chain:{ *:[i32] } 3886:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAD),
     /*  69523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69529 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69540 */     GIR_RootConstrainSelectedInstOperands,
     /*  69541 */     // GIR_Coverage, 528,
     /*  69541 */     GIR_EraseRootFromParent_Done,
     /*  69542 */   // Label 1404: @69542
     /*  69542 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(69605), // Rule ID 529 //
     /*  69547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  69555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69583 */     // (intrinsic_wo_chain:{ *:[i32] } 3887:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLADX),
     /*  69586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69597 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69603 */     GIR_RootConstrainSelectedInstOperands,
     /*  69604 */     // GIR_Coverage, 529,
     /*  69604 */     GIR_EraseRootFromParent_Done,
     /*  69605 */   // Label 1405: @69605
     /*  69605 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(69668), // Rule ID 530 //
     /*  69610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  69618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69646 */     // (intrinsic_wo_chain:{ *:[i32] } 3894:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSD),
     /*  69649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69666 */     GIR_RootConstrainSelectedInstOperands,
     /*  69667 */     // GIR_Coverage, 530,
     /*  69667 */     GIR_EraseRootFromParent_Done,
     /*  69668 */   // Label 1406: @69668
     /*  69668 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(69731), // Rule ID 531 //
     /*  69673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  69681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69709 */     // (intrinsic_wo_chain:{ *:[i32] } 3895:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSDX),
     /*  69712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69729 */     GIR_RootConstrainSelectedInstOperands,
     /*  69730 */     // GIR_Coverage, 531,
     /*  69730 */     GIR_EraseRootFromParent_Done,
     /*  69731 */   // Label 1407: @69731
     /*  69731 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(69785), // Rule ID 948 //
     /*  69736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  69739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  69744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  69747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  69750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  69753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  69756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69772 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3747:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  69772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTD),
     /*  69775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  69779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  69781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  69783 */     GIR_RootConstrainSelectedInstOperands,
     /*  69784 */     // GIR_Coverage, 948,
     /*  69784 */     GIR_EraseRootFromParent_Done,
     /*  69785 */   // Label 1408: @69785
     /*  69785 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(69839), // Rule ID 949 //
     /*  69790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  69793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  69798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  69801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  69804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  69807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  69810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  69826 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3735:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  69826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTD),
     /*  69829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  69833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  69835 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  69837 */     GIR_RootConstrainSelectedInstOperands,
     /*  69838 */     // GIR_Coverage, 949,
     /*  69838 */     GIR_EraseRootFromParent_Done,
     /*  69839 */   // Label 1409: @69839
     /*  69839 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(69893), // Rule ID 950 //
     /*  69844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  69847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  69852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  69864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69880 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3747:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  69880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTQ),
     /*  69883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  69887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  69889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  69891 */     GIR_RootConstrainSelectedInstOperands,
     /*  69892 */     // GIR_Coverage, 950,
     /*  69892 */     GIR_EraseRootFromParent_Done,
     /*  69893 */   // Label 1410: @69893
     /*  69893 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(69947), // Rule ID 951 //
     /*  69898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  69901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  69906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  69918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69934 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3735:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  69934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTQ),
     /*  69937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  69941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  69943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  69945 */     GIR_RootConstrainSelectedInstOperands,
     /*  69946 */     // GIR_Coverage, 951,
     /*  69946 */     GIR_EraseRootFromParent_Done,
     /*  69947 */   // Label 1411: @69947
     /*  69947 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(70001), // Rule ID 952 //
     /*  69952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  69955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_smmla),
     /*  69960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  69972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  69988 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3746:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  69988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSMMLA),
     /*  69991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  69995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  69997 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  69999 */     GIR_RootConstrainSelectedInstOperands,
     /*  70000 */     // GIR_Coverage, 952,
     /*  70000 */     GIR_EraseRootFromParent_Done,
     /*  70001 */   // Label 1412: @70001
     /*  70001 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(70055), // Rule ID 953 //
     /*  70006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_ummla),
     /*  70014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70042 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3748:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUMMLA),
     /*  70045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70053 */     GIR_RootConstrainSelectedInstOperands,
     /*  70054 */     // GIR_Coverage, 953,
     /*  70054 */     GIR_EraseRootFromParent_Done,
     /*  70055 */   // Label 1413: @70055
     /*  70055 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(70109), // Rule ID 954 //
     /*  70060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usmmla),
     /*  70068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70096 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3750:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSMMLA),
     /*  70099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70107 */     GIR_RootConstrainSelectedInstOperands,
     /*  70108 */     // GIR_Coverage, 954,
     /*  70108 */     GIR_EraseRootFromParent_Done,
     /*  70109 */   // Label 1414: @70109
     /*  70109 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(70163), // Rule ID 955 //
     /*  70114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70150 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3749:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTD),
     /*  70153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70159 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70161 */     GIR_RootConstrainSelectedInstOperands,
     /*  70162 */     // GIR_Coverage, 955,
     /*  70162 */     GIR_EraseRootFromParent_Done,
     /*  70163 */   // Label 1415: @70163
     /*  70163 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(70217), // Rule ID 956 //
     /*  70168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70204 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3749:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTQ),
     /*  70207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70213 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70215 */     GIR_RootConstrainSelectedInstOperands,
     /*  70216 */     // GIR_Coverage, 956,
     /*  70216 */     GIR_EraseRootFromParent_Done,
     /*  70217 */   // Label 1416: @70217
     /*  70217 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(70280), // Rule ID 1687 //
     /*  70222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx1),
     /*  70230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  70233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70258 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3861:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VTBX1:{ *:[v8i8] } DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX1),
     /*  70261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70263 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  70265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70278 */     GIR_RootConstrainSelectedInstOperands,
     /*  70279 */     // GIR_Coverage, 1687,
     /*  70279 */     GIR_EraseRootFromParent_Done,
     /*  70280 */   // Label 1417: @70280
     /*  70280 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(70334), // Rule ID 1718 //
     /*  70285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su0),
     /*  70293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70321 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3740:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU0),
     /*  70324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70326 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70332 */     GIR_RootConstrainSelectedInstOperands,
     /*  70333 */     // GIR_Coverage, 1718,
     /*  70333 */     GIR_EraseRootFromParent_Done,
     /*  70334 */   // Label 1418: @70334
     /*  70334 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(70388), // Rule ID 1719 //
     /*  70339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h),
     /*  70347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70375 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3742:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H),
     /*  70378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70380 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70386 */     GIR_RootConstrainSelectedInstOperands,
     /*  70387 */     // GIR_Coverage, 1719,
     /*  70387 */     GIR_EraseRootFromParent_Done,
     /*  70388 */   // Label 1419: @70388
     /*  70388 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(70442), // Rule ID 1720 //
     /*  70393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h2),
     /*  70401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70429 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3743:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H2:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H2),
     /*  70432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70434 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70440 */     GIR_RootConstrainSelectedInstOperands,
     /*  70441 */     // GIR_Coverage, 1720,
     /*  70441 */     GIR_EraseRootFromParent_Done,
     /*  70442 */   // Label 1420: @70442
     /*  70442 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(70496), // Rule ID 1721 //
     /*  70447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su1),
     /*  70455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70483 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3745:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU1),
     /*  70486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70488 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70494 */     GIR_RootConstrainSelectedInstOperands,
     /*  70495 */     // GIR_Coverage, 1721,
     /*  70495 */     GIR_EraseRootFromParent_Done,
     /*  70496 */   // Label 1421: @70496
     /*  70496 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(70559), // Rule ID 1896 //
     /*  70501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  70509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70537 */     // (intrinsic_wo_chain:{ *:[i32] } 3886:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAD),
     /*  70540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70557 */     GIR_RootConstrainSelectedInstOperands,
     /*  70558 */     // GIR_Coverage, 1896,
     /*  70558 */     GIR_EraseRootFromParent_Done,
     /*  70559 */   // Label 1422: @70559
     /*  70559 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(70622), // Rule ID 1897 //
     /*  70564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  70572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70600 */     // (intrinsic_wo_chain:{ *:[i32] } 3887:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLADX),
     /*  70603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70620 */     GIR_RootConstrainSelectedInstOperands,
     /*  70621 */     // GIR_Coverage, 1897,
     /*  70621 */     GIR_EraseRootFromParent_Done,
     /*  70622 */   // Label 1423: @70622
     /*  70622 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(70685), // Rule ID 1898 //
     /*  70627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  70635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70663 */     // (intrinsic_wo_chain:{ *:[i32] } 3894:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSD),
     /*  70666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70683 */     GIR_RootConstrainSelectedInstOperands,
     /*  70684 */     // GIR_Coverage, 1898,
     /*  70684 */     GIR_EraseRootFromParent_Done,
     /*  70685 */   // Label 1424: @70685
     /*  70685 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(70748), // Rule ID 1899 //
     /*  70690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  70698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70726 */     // (intrinsic_wo_chain:{ *:[i32] } 3895:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  70726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSDX),
     /*  70729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70746 */     GIR_RootConstrainSelectedInstOperands,
     /*  70747 */     // GIR_Coverage, 1899,
     /*  70747 */     GIR_EraseRootFromParent_Done,
     /*  70748 */   // Label 1425: @70748
     /*  70748 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(70811), // Rule ID 1987 //
     /*  70753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  70756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  70761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70789 */     // (intrinsic_wo_chain:{ *:[i32] } 3884:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  70789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*  70792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70794 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  70796 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  70798 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  70800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70803 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70809 */     GIR_RootConstrainSelectedInstOperands,
     /*  70810 */     // GIR_Coverage, 1987,
     /*  70810 */     GIR_EraseRootFromParent_Done,
     /*  70811 */   // Label 1426: @70811
     /*  70811 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(70874), // Rule ID 1988 //
     /*  70816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  70819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  70824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70852 */     // (intrinsic_wo_chain:{ *:[i32] } 3885:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  70852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*  70855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70857 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  70859 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  70861 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  70863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70872 */     GIR_RootConstrainSelectedInstOperands,
     /*  70873 */     // GIR_Coverage, 1988,
     /*  70873 */     GIR_EraseRootFromParent_Done,
     /*  70874 */   // Label 1427: @70874
     /*  70874 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(70937), // Rule ID 1989 //
     /*  70879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  70882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  70887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70915 */     // (intrinsic_wo_chain:{ *:[i32] } 3890:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  70915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*  70918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70920 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  70922 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  70924 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  70926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70935 */     GIR_RootConstrainSelectedInstOperands,
     /*  70936 */     // GIR_Coverage, 1989,
     /*  70936 */     GIR_EraseRootFromParent_Done,
     /*  70937 */   // Label 1428: @70937
     /*  70937 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(71000), // Rule ID 1990 //
     /*  70942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  70945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  70950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  70966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  70978 */     // (intrinsic_wo_chain:{ *:[i32] } 3891:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  70978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*  70981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70983 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  70985 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  70987 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  70989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70998 */     GIR_RootConstrainSelectedInstOperands,
     /*  70999 */     // GIR_Coverage, 1990,
     /*  70999 */     GIR_EraseRootFromParent_Done,
     /*  71000 */   // Label 1429: @71000
     /*  71000 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(71063), // Rule ID 1991 //
     /*  71005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71041 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWB),
     /*  71044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71046 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71048 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71050 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71061 */     GIR_RootConstrainSelectedInstOperands,
     /*  71062 */     // GIR_Coverage, 1991,
     /*  71062 */     GIR_EraseRootFromParent_Done,
     /*  71063 */   // Label 1430: @71063
     /*  71063 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(71126), // Rule ID 1992 //
     /*  71068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71104 */     // (intrinsic_wo_chain:{ *:[i32] } 3893:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWT),
     /*  71107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71109 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71111 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71113 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71124 */     GIR_RootConstrainSelectedInstOperands,
     /*  71125 */     // GIR_Coverage, 1992,
     /*  71125 */     GIR_EraseRootFromParent_Done,
     /*  71126 */   // Label 1431: @71126
     /*  71126 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(71189), // Rule ID 2178 //
     /*  71131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71167 */     // (intrinsic_wo_chain:{ *:[i32] } 3884:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*  71170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71172 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71174 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71176 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71187 */     GIR_RootConstrainSelectedInstOperands,
     /*  71188 */     // GIR_Coverage, 2178,
     /*  71188 */     GIR_EraseRootFromParent_Done,
     /*  71189 */   // Label 1432: @71189
     /*  71189 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(71252), // Rule ID 2179 //
     /*  71194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71230 */     // (intrinsic_wo_chain:{ *:[i32] } 3885:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*  71233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71235 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71237 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71239 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71250 */     GIR_RootConstrainSelectedInstOperands,
     /*  71251 */     // GIR_Coverage, 2179,
     /*  71251 */     GIR_EraseRootFromParent_Done,
     /*  71252 */   // Label 1433: @71252
     /*  71252 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(71315), // Rule ID 2180 //
     /*  71257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71293 */     // (intrinsic_wo_chain:{ *:[i32] } 3890:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*  71296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71298 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71300 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71302 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71313 */     GIR_RootConstrainSelectedInstOperands,
     /*  71314 */     // GIR_Coverage, 2180,
     /*  71314 */     GIR_EraseRootFromParent_Done,
     /*  71315 */   // Label 1434: @71315
     /*  71315 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(71378), // Rule ID 2181 //
     /*  71320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71356 */     // (intrinsic_wo_chain:{ *:[i32] } 3891:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*  71359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71361 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71363 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71365 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71376 */     GIR_RootConstrainSelectedInstOperands,
     /*  71377 */     // GIR_Coverage, 2181,
     /*  71377 */     GIR_EraseRootFromParent_Done,
     /*  71378 */   // Label 1435: @71378
     /*  71378 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(71441), // Rule ID 2182 //
     /*  71383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71419 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWB),
     /*  71422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71424 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71426 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71428 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71439 */     GIR_RootConstrainSelectedInstOperands,
     /*  71440 */     // GIR_Coverage, 2182,
     /*  71440 */     GIR_EraseRootFromParent_Done,
     /*  71441 */   // Label 1436: @71441
     /*  71441 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(71504), // Rule ID 2183 //
     /*  71446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71482 */     // (intrinsic_wo_chain:{ *:[i32] } 3893:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWT),
     /*  71485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71487 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71489 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71491 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71502 */     GIR_RootConstrainSelectedInstOperands,
     /*  71503 */     // GIR_Coverage, 2183,
     /*  71503 */     GIR_EraseRootFromParent_Done,
     /*  71504 */   // Label 1437: @71504
     /*  71504 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(71567), // Rule ID 2469 //
     /*  71509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  71520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  71523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  71526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  71529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71545 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3819:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLAHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  71545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i16),
     /*  71548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71550 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71565 */     GIR_RootConstrainSelectedInstOperands,
     /*  71566 */     // GIR_Coverage, 2469,
     /*  71566 */     GIR_EraseRootFromParent_Done,
     /*  71567 */   // Label 1438: @71567
     /*  71567 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(71630), // Rule ID 2470 //
     /*  71572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  71583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  71586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  71589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  71592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71608 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3819:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLAHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  71608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv2i32),
     /*  71611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71613 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71622 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71628 */     GIR_RootConstrainSelectedInstOperands,
     /*  71629 */     // GIR_Coverage, 2470,
     /*  71629 */     GIR_EraseRootFromParent_Done,
     /*  71630 */   // Label 1439: @71630
     /*  71630 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(71693), // Rule ID 2471 //
     /*  71635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  71655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71671 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3819:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLAHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  71671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv8i16),
     /*  71674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71676 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71680 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71691 */     GIR_RootConstrainSelectedInstOperands,
     /*  71692 */     // GIR_Coverage, 2471,
     /*  71692 */     GIR_EraseRootFromParent_Done,
     /*  71693 */   // Label 1440: @71693
     /*  71693 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(71756), // Rule ID 2472 //
     /*  71698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  71706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  71718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71734 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3819:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLAHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  71734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i32),
     /*  71737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71739 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71754 */     GIR_RootConstrainSelectedInstOperands,
     /*  71755 */     // GIR_Coverage, 2472,
     /*  71755 */     GIR_EraseRootFromParent_Done,
     /*  71756 */   // Label 1441: @71756
     /*  71756 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(71819), // Rule ID 2477 //
     /*  71761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  71769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  71772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  71775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  71778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  71781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71797 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3820:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLSHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  71797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i16),
     /*  71800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71802 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71817 */     GIR_RootConstrainSelectedInstOperands,
     /*  71818 */     // GIR_Coverage, 2477,
     /*  71818 */     GIR_EraseRootFromParent_Done,
     /*  71819 */   // Label 1442: @71819
     /*  71819 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(71882), // Rule ID 2478 //
     /*  71824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  71832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  71835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  71838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  71841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  71844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  71860 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3820:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLSHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  71860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv2i32),
     /*  71863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71880 */     GIR_RootConstrainSelectedInstOperands,
     /*  71881 */     // GIR_Coverage, 2478,
     /*  71881 */     GIR_EraseRootFromParent_Done,
     /*  71882 */   // Label 1443: @71882
     /*  71882 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(71945), // Rule ID 2479 //
     /*  71887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  71895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  71907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71923 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3820:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLSHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  71923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv8i16),
     /*  71926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71928 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71932 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71943 */     GIR_RootConstrainSelectedInstOperands,
     /*  71944 */     // GIR_Coverage, 2479,
     /*  71944 */     GIR_EraseRootFromParent_Done,
     /*  71945 */   // Label 1444: @71945
     /*  71945 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(72008), // Rule ID 2480 //
     /*  71950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  71958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  71970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  71986 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3820:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLSHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  71986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i32),
     /*  71989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  71991 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  71993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  71995 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  71997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72006 */     GIR_RootConstrainSelectedInstOperands,
     /*  72007 */     // GIR_Coverage, 2480,
     /*  72007 */     GIR_EraseRootFromParent_Done,
     /*  72008 */   // Label 1445: @72008
     /*  72008 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(72077), // Rule ID 4837 //
     /*  72013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72049 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs8),
     /*  72052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72054 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72056 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72058 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72069 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72075 */     GIR_RootConstrainSelectedInstOperands,
     /*  72076 */     // GIR_Coverage, 4837,
     /*  72076 */     GIR_EraseRootFromParent_Done,
     /*  72077 */   // Label 1446: @72077
     /*  72077 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(72146), // Rule ID 4839 //
     /*  72082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72118 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs16),
     /*  72121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72123 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72125 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72127 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72144 */     GIR_RootConstrainSelectedInstOperands,
     /*  72145 */     // GIR_Coverage, 4839,
     /*  72145 */     GIR_EraseRootFromParent_Done,
     /*  72146 */   // Label 1447: @72146
     /*  72146 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(72215), // Rule ID 4841 //
     /*  72151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72187 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs32),
     /*  72190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72192 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72194 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72196 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72201 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72213 */     GIR_RootConstrainSelectedInstOperands,
     /*  72214 */     // GIR_Coverage, 4841,
     /*  72214 */     GIR_EraseRootFromParent_Done,
     /*  72215 */   // Label 1448: @72215
     /*  72215 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(72284), // Rule ID 4843 //
     /*  72220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72256 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3680:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs8),
     /*  72259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72261 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72263 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72265 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72270 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72282 */     GIR_RootConstrainSelectedInstOperands,
     /*  72283 */     // GIR_Coverage, 4843,
     /*  72283 */     GIR_EraseRootFromParent_Done,
     /*  72284 */   // Label 1449: @72284
     /*  72284 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(72353), // Rule ID 4845 //
     /*  72289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72325 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3680:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs16),
     /*  72328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72330 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72332 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72334 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72339 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72351 */     GIR_RootConstrainSelectedInstOperands,
     /*  72352 */     // GIR_Coverage, 4845,
     /*  72352 */     GIR_EraseRootFromParent_Done,
     /*  72353 */   // Label 1450: @72353
     /*  72353 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(72422), // Rule ID 4847 //
     /*  72358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72394 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3680:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs32),
     /*  72397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72399 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72401 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72403 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72408 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72420 */     GIR_RootConstrainSelectedInstOperands,
     /*  72421 */     // GIR_Coverage, 4847,
     /*  72421 */     GIR_EraseRootFromParent_Done,
     /*  72422 */   // Label 1451: @72422
     /*  72422 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(72491), // Rule ID 4849 //
     /*  72427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72463 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3673:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs8),
     /*  72466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72468 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72470 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72472 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72489 */     GIR_RootConstrainSelectedInstOperands,
     /*  72490 */     // GIR_Coverage, 4849,
     /*  72490 */     GIR_EraseRootFromParent_Done,
     /*  72491 */   // Label 1452: @72491
     /*  72491 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(72560), // Rule ID 4851 //
     /*  72496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72532 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3673:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs16),
     /*  72535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72537 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72539 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72541 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72558 */     GIR_RootConstrainSelectedInstOperands,
     /*  72559 */     // GIR_Coverage, 4851,
     /*  72559 */     GIR_EraseRootFromParent_Done,
     /*  72560 */   // Label 1453: @72560
     /*  72560 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(72629), // Rule ID 4853 //
     /*  72565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72601 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3673:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs32),
     /*  72604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72606 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72608 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72610 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72627 */     GIR_RootConstrainSelectedInstOperands,
     /*  72628 */     // GIR_Coverage, 4853,
     /*  72628 */     GIR_EraseRootFromParent_Done,
     /*  72629 */   // Label 1454: @72629
     /*  72629 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(72698), // Rule ID 4855 //
     /*  72634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  72642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72670 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3682:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs8),
     /*  72673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72675 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72677 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72679 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72696 */     GIR_RootConstrainSelectedInstOperands,
     /*  72697 */     // GIR_Coverage, 4855,
     /*  72697 */     GIR_EraseRootFromParent_Done,
     /*  72698 */   // Label 1455: @72698
     /*  72698 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(72767), // Rule ID 4857 //
     /*  72703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  72711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72739 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3682:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs16),
     /*  72742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72744 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72746 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72748 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72765 */     GIR_RootConstrainSelectedInstOperands,
     /*  72766 */     // GIR_Coverage, 4857,
     /*  72766 */     GIR_EraseRootFromParent_Done,
     /*  72767 */   // Label 1456: @72767
     /*  72767 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(72836), // Rule ID 4859 //
     /*  72772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  72780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72808 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3682:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs32),
     /*  72811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72813 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72815 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72817 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72834 */     GIR_RootConstrainSelectedInstOperands,
     /*  72835 */     // GIR_Coverage, 4859,
     /*  72835 */     GIR_EraseRootFromParent_Done,
     /*  72836 */   // Label 1457: @72836
     /*  72836 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(72931), // Rule ID 2691 //
     /*  72841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1c),
     /*  72849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72865 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3736:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1C:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  72865 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  72868 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72872 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72877 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  72881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  72886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  72889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  72893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72898 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  72901 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  72904 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  72907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  72912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  72917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1C),
     /*  72920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72922 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  72924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  72927 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  72929 */     GIR_RootConstrainSelectedInstOperands,
     /*  72930 */     // GIR_Coverage, 2691,
     /*  72930 */     GIR_EraseRootFromParent_Done,
     /*  72931 */   // Label 1458: @72931
     /*  72931 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(73026), // Rule ID 2692 //
     /*  72936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1m),
     /*  72944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72960 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3738:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1M:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  72960 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  72963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  72967 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72972 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  72976 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  72981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  72984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  72988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  72993 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  72996 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  72999 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1M),
     /*  73015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73017 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73022 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73024 */     GIR_RootConstrainSelectedInstOperands,
     /*  73025 */     // GIR_Coverage, 2692,
     /*  73025 */     GIR_EraseRootFromParent_Done,
     /*  73026 */   // Label 1459: @73026
     /*  73026 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(73121), // Rule ID 2693 //
     /*  73031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1p),
     /*  73039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73055 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3739:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1P:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73055 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73058 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73062 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73067 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73071 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73088 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73091 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73094 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1P),
     /*  73110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73112 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73117 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73119 */     GIR_RootConstrainSelectedInstOperands,
     /*  73120 */     // GIR_Coverage, 2693,
     /*  73120 */     GIR_EraseRootFromParent_Done,
     /*  73121 */   // Label 1460: @73121
     /*  73121 */   GIM_Reject,
     /*  73122 */ // Label 1313: @73122
     /*  73122 */ GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(76508),
     /*  73127 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  73130 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(73214), // Rule ID 3724 //
     /*  73135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73175 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3711:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8bh),
     /*  73190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73192 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73203 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73212 */     GIR_RootConstrainSelectedInstOperands,
     /*  73213 */     // GIR_Coverage, 3724,
     /*  73213 */     GIR_EraseRootFromParent_Done,
     /*  73214 */   // Label 1462: @73214
     /*  73214 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(73298), // Rule ID 3728 //
     /*  73219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73247 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73251 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73259 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3711:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8th),
     /*  73274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73276 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73281 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73287 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73296 */     GIR_RootConstrainSelectedInstOperands,
     /*  73297 */     // GIR_Coverage, 3728,
     /*  73297 */     GIR_EraseRootFromParent_Done,
     /*  73298 */   // Label 1463: @73298
     /*  73298 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(73382), // Rule ID 3732 //
     /*  73303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73343 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3711:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16bh),
     /*  73358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73360 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73380 */     GIR_RootConstrainSelectedInstOperands,
     /*  73381 */     // GIR_Coverage, 3732,
     /*  73381 */     GIR_EraseRootFromParent_Done,
     /*  73382 */   // Label 1464: @73382
     /*  73382 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(73466), // Rule ID 3736 //
     /*  73387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73419 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73423 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73427 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3711:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16th),
     /*  73442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73444 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73464 */     GIR_RootConstrainSelectedInstOperands,
     /*  73465 */     // GIR_Coverage, 3736,
     /*  73465 */     GIR_EraseRootFromParent_Done,
     /*  73466 */   // Label 1465: @73466
     /*  73466 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(73550), // Rule ID 3740 //
     /*  73471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73499 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73511 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3711:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8bh),
     /*  73526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73528 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73548 */     GIR_RootConstrainSelectedInstOperands,
     /*  73549 */     // GIR_Coverage, 3740,
     /*  73549 */     GIR_EraseRootFromParent_Done,
     /*  73550 */   // Label 1466: @73550
     /*  73550 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(73634), // Rule ID 3744 //
     /*  73555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73595 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3711:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8th),
     /*  73610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73612 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73623 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73632 */     GIR_RootConstrainSelectedInstOperands,
     /*  73633 */     // GIR_Coverage, 3744,
     /*  73633 */     GIR_EraseRootFromParent_Done,
     /*  73634 */   // Label 1467: @73634
     /*  73634 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(73718), // Rule ID 3748 //
     /*  73639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73675 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73679 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3711:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16bh),
     /*  73694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73696 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73716 */     GIR_RootConstrainSelectedInstOperands,
     /*  73717 */     // GIR_Coverage, 3748,
     /*  73717 */     GIR_EraseRootFromParent_Done,
     /*  73718 */   // Label 1468: @73718
     /*  73718 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(73802), // Rule ID 3752 //
     /*  73723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73763 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3711:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16th),
     /*  73778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73780 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73800 */     GIR_RootConstrainSelectedInstOperands,
     /*  73801 */     // GIR_Coverage, 3752,
     /*  73801 */     GIR_EraseRootFromParent_Done,
     /*  73802 */   // Label 1469: @73802
     /*  73802 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(73891), // Rule ID 4384 //
     /*  73807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  73815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73850 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3667:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  73850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  73865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  73869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  73871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73889 */     GIR_RootConstrainSelectedInstOperands,
     /*  73890 */     // GIR_Coverage, 4384,
     /*  73890 */     GIR_EraseRootFromParent_Done,
     /*  73891 */   // Label 1470: @73891
     /*  73891 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(73980), // Rule ID 4386 //
     /*  73896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  73904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73939 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3667:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  73939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs8),
     /*  73954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  73958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  73960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73978 */     GIR_RootConstrainSelectedInstOperands,
     /*  73979 */     // GIR_Coverage, 4386,
     /*  73979 */     GIR_EraseRootFromParent_Done,
     /*  73980 */   // Label 1471: @73980
     /*  73980 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(74069), // Rule ID 4388 //
     /*  73985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  73993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74028 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3667:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  74043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74067 */     GIR_RootConstrainSelectedInstOperands,
     /*  74068 */     // GIR_Coverage, 4388,
     /*  74068 */     GIR_EraseRootFromParent_Done,
     /*  74069 */   // Label 1472: @74069
     /*  74069 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(74158), // Rule ID 4390 //
     /*  74074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74117 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3667:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs16),
     /*  74132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74147 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74156 */     GIR_RootConstrainSelectedInstOperands,
     /*  74157 */     // GIR_Coverage, 4390,
     /*  74157 */     GIR_EraseRootFromParent_Done,
     /*  74158 */   // Label 1473: @74158
     /*  74158 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(74247), // Rule ID 4392 //
     /*  74163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74206 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3667:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs32),
     /*  74221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74245 */     GIR_RootConstrainSelectedInstOperands,
     /*  74246 */     // GIR_Coverage, 4392,
     /*  74246 */     GIR_EraseRootFromParent_Done,
     /*  74247 */   // Label 1474: @74247
     /*  74247 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(74336), // Rule ID 4394 //
     /*  74252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74295 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3667:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs32),
     /*  74310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74334 */     GIR_RootConstrainSelectedInstOperands,
     /*  74335 */     // GIR_Coverage, 4394,
     /*  74335 */     GIR_EraseRootFromParent_Done,
     /*  74336 */   // Label 1475: @74336
     /*  74336 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(74425), // Rule ID 4396 //
     /*  74341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74384 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3667:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu8),
     /*  74399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74408 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74423 */     GIR_RootConstrainSelectedInstOperands,
     /*  74424 */     // GIR_Coverage, 4396,
     /*  74424 */     GIR_EraseRootFromParent_Done,
     /*  74425 */   // Label 1476: @74425
     /*  74425 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(74514), // Rule ID 4398 //
     /*  74430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74473 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3667:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu8),
     /*  74488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74497 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74503 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74512 */     GIR_RootConstrainSelectedInstOperands,
     /*  74513 */     // GIR_Coverage, 4398,
     /*  74513 */     GIR_EraseRootFromParent_Done,
     /*  74514 */   // Label 1477: @74514
     /*  74514 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(74603), // Rule ID 4400 //
     /*  74519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74562 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3667:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu16),
     /*  74577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74601 */     GIR_RootConstrainSelectedInstOperands,
     /*  74602 */     // GIR_Coverage, 4400,
     /*  74602 */     GIR_EraseRootFromParent_Done,
     /*  74603 */   // Label 1478: @74603
     /*  74603 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(74692), // Rule ID 4402 //
     /*  74608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74651 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3667:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu16),
     /*  74666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74690 */     GIR_RootConstrainSelectedInstOperands,
     /*  74691 */     // GIR_Coverage, 4402,
     /*  74691 */     GIR_EraseRootFromParent_Done,
     /*  74692 */   // Label 1479: @74692
     /*  74692 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(74781), // Rule ID 4404 //
     /*  74697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74740 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3667:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu32),
     /*  74755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74770 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74779 */     GIR_RootConstrainSelectedInstOperands,
     /*  74780 */     // GIR_Coverage, 4404,
     /*  74780 */     GIR_EraseRootFromParent_Done,
     /*  74781 */   // Label 1480: @74781
     /*  74781 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(74870), // Rule ID 4406 //
     /*  74786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74829 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3667:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu32),
     /*  74844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74868 */     GIR_RootConstrainSelectedInstOperands,
     /*  74869 */     // GIR_Coverage, 4406,
     /*  74869 */     GIR_EraseRootFromParent_Done,
     /*  74870 */   // Label 1481: @74870
     /*  74870 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(74968), // Rule ID 4029 //
     /*  74875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  74878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  74883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  74889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  74895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  74898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  74906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  74910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  74914 */     // MIs[1] Operand 1
     /*  74914 */     // No operand predicates
     /*  74914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74924 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3610:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  74924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf16),
     /*  74939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  74943 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  74945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  74948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74951 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74966 */     GIR_RootConstrainSelectedInstOperands,
     /*  74967 */     // GIR_Coverage, 4029,
     /*  74967 */     GIR_EraseRootFromParent_Done,
     /*  74968 */   // Label 1482: @74968
     /*  74968 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(75066), // Rule ID 4031 //
     /*  74973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  74976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  74981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  74987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  74993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  74996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75012 */     // MIs[1] Operand 1
     /*  75012 */     // No operand predicates
     /*  75012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75022 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3610:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf32),
     /*  75037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75041 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75064 */     GIR_RootConstrainSelectedInstOperands,
     /*  75065 */     // GIR_Coverage, 4031,
     /*  75065 */     GIR_EraseRootFromParent_Done,
     /*  75066 */   // Label 1483: @75066
     /*  75066 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(75164), // Rule ID 4538 //
     /*  75071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75098 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75110 */     // MIs[1] Operand 1
     /*  75110 */     // No operand predicates
     /*  75110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75120 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3610:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VCADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi8),
     /*  75135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75139 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75147 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75162 */     GIR_RootConstrainSelectedInstOperands,
     /*  75163 */     // GIR_Coverage, 4538,
     /*  75163 */     GIR_EraseRootFromParent_Done,
     /*  75164 */   // Label 1484: @75164
     /*  75164 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(75262), // Rule ID 4540 //
     /*  75169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75208 */     // MIs[1] Operand 1
     /*  75208 */     // No operand predicates
     /*  75208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75218 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3610:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VCADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi16),
     /*  75233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75235 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75237 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75251 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75260 */     GIR_RootConstrainSelectedInstOperands,
     /*  75261 */     // GIR_Coverage, 4540,
     /*  75261 */     GIR_EraseRootFromParent_Done,
     /*  75262 */   // Label 1485: @75262
     /*  75262 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(75360), // Rule ID 4542 //
     /*  75267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75306 */     // MIs[1] Operand 1
     /*  75306 */     // No operand predicates
     /*  75306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75316 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3610:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VCADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi32),
     /*  75331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75335 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75349 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75358 */     GIR_RootConstrainSelectedInstOperands,
     /*  75359 */     // GIR_Coverage, 4542,
     /*  75359 */     GIR_EraseRootFromParent_Done,
     /*  75360 */   // Label 1486: @75360
     /*  75360 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(75458), // Rule ID 4544 //
     /*  75365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75404 */     // MIs[1] Operand 1
     /*  75404 */     // No operand predicates
     /*  75404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75414 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3610:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VHCADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs8),
     /*  75429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75433 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75456 */     GIR_RootConstrainSelectedInstOperands,
     /*  75457 */     // GIR_Coverage, 4544,
     /*  75457 */     GIR_EraseRootFromParent_Done,
     /*  75458 */   // Label 1487: @75458
     /*  75458 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(75556), // Rule ID 4546 //
     /*  75463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75502 */     // MIs[1] Operand 1
     /*  75502 */     // No operand predicates
     /*  75502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75512 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3610:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VHCADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs16),
     /*  75527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75529 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75531 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75554 */     GIR_RootConstrainSelectedInstOperands,
     /*  75555 */     // GIR_Coverage, 4546,
     /*  75555 */     GIR_EraseRootFromParent_Done,
     /*  75556 */   // Label 1488: @75556
     /*  75556 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(75654), // Rule ID 4548 //
     /*  75561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75600 */     // MIs[1] Operand 1
     /*  75600 */     // No operand predicates
     /*  75600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75610 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3610:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VHCADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs32),
     /*  75625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75629 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75652 */     GIR_RootConstrainSelectedInstOperands,
     /*  75653 */     // GIR_Coverage, 4548,
     /*  75653 */     GIR_EraseRootFromParent_Done,
     /*  75654 */   // Label 1489: @75654
     /*  75654 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(75730), // Rule ID 3034 //
     /*  75659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  75667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  75670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75702 */     // (intrinsic_wo_chain:{ *:[i32] } 3603:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  75702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs8),
     /*  75705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  75707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  75709 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75711 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75728 */     GIR_RootConstrainSelectedInstOperands,
     /*  75729 */     // GIR_Coverage, 3034,
     /*  75729 */     GIR_EraseRootFromParent_Done,
     /*  75730 */   // Label 1490: @75730
     /*  75730 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(75806), // Rule ID 3036 //
     /*  75735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  75743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  75746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75778 */     // (intrinsic_wo_chain:{ *:[i32] } 3603:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  75778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs16),
     /*  75781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  75783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  75785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75787 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75804 */     GIR_RootConstrainSelectedInstOperands,
     /*  75805 */     // GIR_Coverage, 3036,
     /*  75805 */     GIR_EraseRootFromParent_Done,
     /*  75806 */   // Label 1491: @75806
     /*  75806 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(75882), // Rule ID 3038 //
     /*  75811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  75819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  75822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75838 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75854 */     // (intrinsic_wo_chain:{ *:[i32] } 3603:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  75854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs32),
     /*  75857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  75859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  75861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75863 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75880 */     GIR_RootConstrainSelectedInstOperands,
     /*  75881 */     // GIR_Coverage, 3038,
     /*  75881 */     GIR_EraseRootFromParent_Done,
     /*  75882 */   // Label 1492: @75882
     /*  75882 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(75958), // Rule ID 3040 //
     /*  75887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  75895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  75898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75930 */     // (intrinsic_wo_chain:{ *:[i32] } 3603:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVu8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  75930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu8),
     /*  75933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  75935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  75937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75939 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75956 */     GIR_RootConstrainSelectedInstOperands,
     /*  75957 */     // GIR_Coverage, 3040,
     /*  75957 */     GIR_EraseRootFromParent_Done,
     /*  75958 */   // Label 1493: @75958
     /*  75958 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(76034), // Rule ID 3042 //
     /*  75963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  75971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  75974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  75998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76006 */     // (intrinsic_wo_chain:{ *:[i32] } 3603:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVu16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu16),
     /*  76009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76015 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76032 */     GIR_RootConstrainSelectedInstOperands,
     /*  76033 */     // GIR_Coverage, 3042,
     /*  76033 */     GIR_EraseRootFromParent_Done,
     /*  76034 */   // Label 1494: @76034
     /*  76034 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(76110), // Rule ID 3044 //
     /*  76039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76066 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76082 */     // (intrinsic_wo_chain:{ *:[i32] } 3603:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVu32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu32),
     /*  76085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76091 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76102 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76108 */     GIR_RootConstrainSelectedInstOperands,
     /*  76109 */     // GIR_Coverage, 3044,
     /*  76109 */     GIR_EraseRootFromParent_Done,
     /*  76110 */   // Label 1495: @76110
     /*  76110 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(76195), // Rule ID 3993 //
     /*  76115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76150 */     // MIs[1] Operand 1
     /*  76150 */     // No operand predicates
     /*  76150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76164 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3613:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMLAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf16),
     /*  76167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76173 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76193 */     GIR_RootConstrainSelectedInstOperands,
     /*  76194 */     // GIR_Coverage, 3993,
     /*  76194 */     GIR_EraseRootFromParent_Done,
     /*  76195 */   // Label 1496: @76195
     /*  76195 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(76280), // Rule ID 3996 //
     /*  76200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76235 */     // MIs[1] Operand 1
     /*  76235 */     // No operand predicates
     /*  76235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76249 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3613:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMLAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf32),
     /*  76252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76258 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76278 */     GIR_RootConstrainSelectedInstOperands,
     /*  76279 */     // GIR_Coverage, 3996,
     /*  76279 */     GIR_EraseRootFromParent_Done,
     /*  76280 */   // Label 1497: @76280
     /*  76280 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(76376), // Rule ID 2685 //
     /*  76285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx2),
     /*  76293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76312 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3862:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX2:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v16i8] } DPair:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  76315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  76328 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76331 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  76335 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPairRegClassID),
     /*  76343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX2),
     /*  76356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76358 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  76360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76363 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76374 */     GIR_RootConstrainSelectedInstOperands,
     /*  76375 */     // GIR_Coverage, 2685,
     /*  76375 */     GIR_EraseRootFromParent_Done,
     /*  76376 */   // Label 1498: @76376
     /*  76376 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(76507), // Rule ID 2686 //
     /*  76381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl3),
     /*  76389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76408 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3859:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL3Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76408 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  76411 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76415 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  76425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76434 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  76438 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76441 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  76445 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76448 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  76452 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  76455 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76458 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  76461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  76466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL3Pseudo),
     /*  76489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76494 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76505 */     GIR_RootConstrainSelectedInstOperands,
     /*  76506 */     // GIR_Coverage, 2686,
     /*  76506 */     GIR_EraseRootFromParent_Done,
     /*  76507 */   // Label 1499: @76507
     /*  76507 */   GIM_Reject,
     /*  76508 */ // Label 1461: @76508
     /*  76508 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(81814),
     /*  76513 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  76516 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(76609), // Rule ID 3835 //
     /*  76521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  76560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  76564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  76568 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3707:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  76568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs8),
     /*  76583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76585 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  76587 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  76589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76607 */     GIR_RootConstrainSelectedInstOperands,
     /*  76608 */     // GIR_Coverage, 3835,
     /*  76608 */     GIR_EraseRootFromParent_Done,
     /*  76609 */   // Label 1501: @76609
     /*  76609 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(76702), // Rule ID 3837 //
     /*  76614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  76653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  76657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  76661 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3707:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  76661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs16),
     /*  76676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76678 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  76680 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  76682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76700 */     GIR_RootConstrainSelectedInstOperands,
     /*  76701 */     // GIR_Coverage, 3837,
     /*  76701 */     GIR_EraseRootFromParent_Done,
     /*  76702 */   // Label 1502: @76702
     /*  76702 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(76795), // Rule ID 3839 //
     /*  76707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  76746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  76750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  76754 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3707:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  76754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs32),
     /*  76769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76771 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  76773 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  76775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76793 */     GIR_RootConstrainSelectedInstOperands,
     /*  76794 */     // GIR_Coverage, 3839,
     /*  76794 */     GIR_EraseRootFromParent_Done,
     /*  76795 */   // Label 1503: @76795
     /*  76795 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(76888), // Rule ID 3841 //
     /*  76800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  76839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  76843 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  76847 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3707:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  76847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu8),
     /*  76862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76864 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  76866 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  76868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76886 */     GIR_RootConstrainSelectedInstOperands,
     /*  76887 */     // GIR_Coverage, 3841,
     /*  76887 */     GIR_EraseRootFromParent_Done,
     /*  76888 */   // Label 1504: @76888
     /*  76888 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(76981), // Rule ID 3843 //
     /*  76893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  76913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  76916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  76932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  76936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  76940 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3707:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  76940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu16),
     /*  76955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76957 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  76959 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  76961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76979 */     GIR_RootConstrainSelectedInstOperands,
     /*  76980 */     // GIR_Coverage, 3843,
     /*  76980 */     GIR_EraseRootFromParent_Done,
     /*  76981 */   // Label 1505: @76981
     /*  76981 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(77074), // Rule ID 3845 //
     /*  76986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  76991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77033 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3707:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu32),
     /*  77048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77050 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77052 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77072 */     GIR_RootConstrainSelectedInstOperands,
     /*  77073 */     // GIR_Coverage, 3845,
     /*  77073 */     GIR_EraseRootFromParent_Done,
     /*  77074 */   // Label 1506: @77074
     /*  77074 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(77167), // Rule ID 3847 //
     /*  77079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77126 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3707:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs8),
     /*  77141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77143 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77145 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77156 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77165 */     GIR_RootConstrainSelectedInstOperands,
     /*  77166 */     // GIR_Coverage, 3847,
     /*  77166 */     GIR_EraseRootFromParent_Done,
     /*  77167 */   // Label 1507: @77167
     /*  77167 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(77260), // Rule ID 3849 //
     /*  77172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77215 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77219 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3707:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs16),
     /*  77234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77236 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77238 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77249 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77258 */     GIR_RootConstrainSelectedInstOperands,
     /*  77259 */     // GIR_Coverage, 3849,
     /*  77259 */     GIR_EraseRootFromParent_Done,
     /*  77260 */   // Label 1508: @77260
     /*  77260 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(77353), // Rule ID 3851 //
     /*  77265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77312 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3707:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs32),
     /*  77327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77329 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77331 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77351 */     GIR_RootConstrainSelectedInstOperands,
     /*  77352 */     // GIR_Coverage, 3851,
     /*  77352 */     GIR_EraseRootFromParent_Done,
     /*  77353 */   // Label 1509: @77353
     /*  77353 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(77446), // Rule ID 3853 //
     /*  77358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77405 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3707:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu8),
     /*  77420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77422 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77424 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77444 */     GIR_RootConstrainSelectedInstOperands,
     /*  77445 */     // GIR_Coverage, 3853,
     /*  77445 */     GIR_EraseRootFromParent_Done,
     /*  77446 */   // Label 1510: @77446
     /*  77446 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(77539), // Rule ID 3855 //
     /*  77451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77486 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77498 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3707:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu16),
     /*  77513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77515 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77517 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77537 */     GIR_RootConstrainSelectedInstOperands,
     /*  77538 */     // GIR_Coverage, 3855,
     /*  77538 */     GIR_EraseRootFromParent_Done,
     /*  77539 */   // Label 1511: @77539
     /*  77539 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(77632), // Rule ID 3857 //
     /*  77544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77591 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3707:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu32),
     /*  77606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77608 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77610 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77630 */     GIR_RootConstrainSelectedInstOperands,
     /*  77631 */     // GIR_Coverage, 3857,
     /*  77631 */     GIR_EraseRootFromParent_Done,
     /*  77632 */   // Label 1512: @77632
     /*  77632 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(77725), // Rule ID 3859 //
     /*  77637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  77680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77684 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3707:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs8),
     /*  77699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77701 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77703 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77723 */     GIR_RootConstrainSelectedInstOperands,
     /*  77724 */     // GIR_Coverage, 3859,
     /*  77724 */     GIR_EraseRootFromParent_Done,
     /*  77725 */   // Label 1513: @77725
     /*  77725 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(77818), // Rule ID 3861 //
     /*  77730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  77773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77777 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3707:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs16),
     /*  77792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77794 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77796 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77816 */     GIR_RootConstrainSelectedInstOperands,
     /*  77817 */     // GIR_Coverage, 3861,
     /*  77817 */     GIR_EraseRootFromParent_Done,
     /*  77818 */   // Label 1514: @77818
     /*  77818 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(77911), // Rule ID 3863 //
     /*  77823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  77866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77870 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3707:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs32),
     /*  77885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77887 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77889 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77900 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77909 */     GIR_RootConstrainSelectedInstOperands,
     /*  77910 */     // GIR_Coverage, 3863,
     /*  77910 */     GIR_EraseRootFromParent_Done,
     /*  77911 */   // Label 1515: @77911
     /*  77911 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(78004), // Rule ID 3865 //
     /*  77916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77955 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  77959 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77963 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3707:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu8),
     /*  77978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77980 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77982 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78002 */     GIR_RootConstrainSelectedInstOperands,
     /*  78003 */     // GIR_Coverage, 3865,
     /*  78003 */     GIR_EraseRootFromParent_Done,
     /*  78004 */   // Label 1516: @78004
     /*  78004 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(78097), // Rule ID 3867 //
     /*  78009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78056 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3707:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu16),
     /*  78071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78073 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78075 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78095 */     GIR_RootConstrainSelectedInstOperands,
     /*  78096 */     // GIR_Coverage, 3867,
     /*  78096 */     GIR_EraseRootFromParent_Done,
     /*  78097 */   // Label 1517: @78097
     /*  78097 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(78190), // Rule ID 3869 //
     /*  78102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78149 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3707:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu32),
     /*  78164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78166 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78168 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78173 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78188 */     GIR_RootConstrainSelectedInstOperands,
     /*  78189 */     // GIR_Coverage, 3869,
     /*  78189 */     GIR_EraseRootFromParent_Done,
     /*  78190 */   // Label 1518: @78190
     /*  78190 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(78283), // Rule ID 3871 //
     /*  78195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78242 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3707:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs8),
     /*  78257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78259 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78261 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78281 */     GIR_RootConstrainSelectedInstOperands,
     /*  78282 */     // GIR_Coverage, 3871,
     /*  78282 */     GIR_EraseRootFromParent_Done,
     /*  78283 */   // Label 1519: @78283
     /*  78283 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(78376), // Rule ID 3873 //
     /*  78288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78335 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3707:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs16),
     /*  78350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78352 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78354 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78374 */     GIR_RootConstrainSelectedInstOperands,
     /*  78375 */     // GIR_Coverage, 3873,
     /*  78375 */     GIR_EraseRootFromParent_Done,
     /*  78376 */   // Label 1520: @78376
     /*  78376 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(78469), // Rule ID 3875 //
     /*  78381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78428 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3707:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs32),
     /*  78443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78445 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78447 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78467 */     GIR_RootConstrainSelectedInstOperands,
     /*  78468 */     // GIR_Coverage, 3875,
     /*  78468 */     GIR_EraseRootFromParent_Done,
     /*  78469 */   // Label 1521: @78469
     /*  78469 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(78562), // Rule ID 3877 //
     /*  78474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78521 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3707:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu8),
     /*  78536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78538 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78540 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78560 */     GIR_RootConstrainSelectedInstOperands,
     /*  78561 */     // GIR_Coverage, 3877,
     /*  78561 */     GIR_EraseRootFromParent_Done,
     /*  78562 */   // Label 1522: @78562
     /*  78562 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(78655), // Rule ID 3879 //
     /*  78567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78614 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3707:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu16),
     /*  78629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78631 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78633 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78653 */     GIR_RootConstrainSelectedInstOperands,
     /*  78654 */     // GIR_Coverage, 3879,
     /*  78654 */     GIR_EraseRootFromParent_Done,
     /*  78655 */   // Label 1523: @78655
     /*  78655 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(78748), // Rule ID 3881 //
     /*  78660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78707 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3707:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu32),
     /*  78722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78724 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78726 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78731 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78737 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78746 */     GIR_RootConstrainSelectedInstOperands,
     /*  78747 */     // GIR_Coverage, 3881,
     /*  78747 */     GIR_EraseRootFromParent_Done,
     /*  78748 */   // Label 1524: @78748
     /*  78748 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(78826), // Rule ID 4486 //
     /*  78753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  78758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78800 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3678:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  78800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32bh),
     /*  78803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  78807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  78809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78824 */     GIR_RootConstrainSelectedInstOperands,
     /*  78825 */     // GIR_Coverage, 4486,
     /*  78825 */     GIR_EraseRootFromParent_Done,
     /*  78826 */   // Label 1525: @78826
     /*  78826 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(78904), // Rule ID 4488 //
     /*  78831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  78836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78878 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3678:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  78878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32th),
     /*  78881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  78885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  78887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78902 */     GIR_RootConstrainSelectedInstOperands,
     /*  78903 */     // GIR_Coverage, 4488,
     /*  78903 */     GIR_EraseRootFromParent_Done,
     /*  78904 */   // Label 1526: @78904
     /*  78904 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(78982), // Rule ID 4490 //
     /*  78909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  78914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78956 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3678:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  78956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16bh),
     /*  78959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  78963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  78965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78980 */     GIR_RootConstrainSelectedInstOperands,
     /*  78981 */     // GIR_Coverage, 4490,
     /*  78981 */     GIR_EraseRootFromParent_Done,
     /*  78982 */   // Label 1527: @78982
     /*  78982 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(79060), // Rule ID 4492 //
     /*  78987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  78992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79034 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3678:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16th),
     /*  79037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79058 */     GIR_RootConstrainSelectedInstOperands,
     /*  79059 */     // GIR_Coverage, 4492,
     /*  79059 */     GIR_EraseRootFromParent_Done,
     /*  79060 */   // Label 1528: @79060
     /*  79060 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(79138), // Rule ID 4494 //
     /*  79065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79108 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79112 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3678:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32bh),
     /*  79115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79136 */     GIR_RootConstrainSelectedInstOperands,
     /*  79137 */     // GIR_Coverage, 4494,
     /*  79137 */     GIR_EraseRootFromParent_Done,
     /*  79138 */   // Label 1529: @79138
     /*  79138 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(79216), // Rule ID 4496 //
     /*  79143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79182 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79190 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3678:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32th),
     /*  79193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79214 */     GIR_RootConstrainSelectedInstOperands,
     /*  79215 */     // GIR_Coverage, 4496,
     /*  79215 */     GIR_EraseRootFromParent_Done,
     /*  79216 */   // Label 1530: @79216
     /*  79216 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(79294), // Rule ID 4498 //
     /*  79221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79268 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3678:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16bh),
     /*  79271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79292 */     GIR_RootConstrainSelectedInstOperands,
     /*  79293 */     // GIR_Coverage, 4498,
     /*  79293 */     GIR_EraseRootFromParent_Done,
     /*  79294 */   // Label 1531: @79294
     /*  79294 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(79372), // Rule ID 4500 //
     /*  79299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79334 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79338 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79346 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3678:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16th),
     /*  79349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79370 */     GIR_RootConstrainSelectedInstOperands,
     /*  79371 */     // GIR_Coverage, 4500,
     /*  79371 */     GIR_EraseRootFromParent_Done,
     /*  79372 */   // Label 1532: @79372
     /*  79372 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(79450), // Rule ID 4502 //
     /*  79377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79424 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3678:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32bh),
     /*  79427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79448 */     GIR_RootConstrainSelectedInstOperands,
     /*  79449 */     // GIR_Coverage, 4502,
     /*  79449 */     GIR_EraseRootFromParent_Done,
     /*  79450 */   // Label 1533: @79450
     /*  79450 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(79528), // Rule ID 4504 //
     /*  79455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79498 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79502 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3678:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32th),
     /*  79505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79526 */     GIR_RootConstrainSelectedInstOperands,
     /*  79527 */     // GIR_Coverage, 4504,
     /*  79527 */     GIR_EraseRootFromParent_Done,
     /*  79528 */   // Label 1534: @79528
     /*  79528 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(79606), // Rule ID 4506 //
     /*  79533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79580 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3678:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16bh),
     /*  79583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79604 */     GIR_RootConstrainSelectedInstOperands,
     /*  79605 */     // GIR_Coverage, 4506,
     /*  79605 */     GIR_EraseRootFromParent_Done,
     /*  79606 */   // Label 1535: @79606
     /*  79606 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(79684), // Rule ID 4508 //
     /*  79611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79658 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3678:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16th),
     /*  79661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79682 */     GIR_RootConstrainSelectedInstOperands,
     /*  79683 */     // GIR_Coverage, 4508,
     /*  79683 */     GIR_EraseRootFromParent_Done,
     /*  79684 */   // Label 1536: @79684
     /*  79684 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(79762), // Rule ID 4698 //
     /*  79689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  79694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  79703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  79724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79736 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3705:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  79736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs8),
     /*  79739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79741 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79743 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79760 */     GIR_RootConstrainSelectedInstOperands,
     /*  79761 */     // GIR_Coverage, 4698,
     /*  79761 */     GIR_EraseRootFromParent_Done,
     /*  79762 */   // Label 1537: @79762
     /*  79762 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(79840), // Rule ID 4700 //
     /*  79767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  79772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  79781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  79802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79814 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3705:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  79814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs16),
     /*  79817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79819 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79821 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79838 */     GIR_RootConstrainSelectedInstOperands,
     /*  79839 */     // GIR_Coverage, 4700,
     /*  79839 */     GIR_EraseRootFromParent_Done,
     /*  79840 */   // Label 1538: @79840
     /*  79840 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(79918), // Rule ID 4702 //
     /*  79845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  79850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  79853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  79859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  79880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79892 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3705:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  79892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs32),
     /*  79895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79897 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79899 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79916 */     GIR_RootConstrainSelectedInstOperands,
     /*  79917 */     // GIR_Coverage, 4702,
     /*  79917 */     GIR_EraseRootFromParent_Done,
     /*  79918 */   // Label 1539: @79918
     /*  79918 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(79996), // Rule ID 4704 //
     /*  79923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  79928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  79937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  79958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79966 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79970 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3705:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  79970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru8),
     /*  79973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79975 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79977 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79994 */     GIR_RootConstrainSelectedInstOperands,
     /*  79995 */     // GIR_Coverage, 4704,
     /*  79995 */     GIR_EraseRootFromParent_Done,
     /*  79996 */   // Label 1540: @79996
     /*  79996 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(80074), // Rule ID 4706 //
     /*  80001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80048 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3705:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru16),
     /*  80051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80053 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80055 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80072 */     GIR_RootConstrainSelectedInstOperands,
     /*  80073 */     // GIR_Coverage, 4706,
     /*  80073 */     GIR_EraseRootFromParent_Done,
     /*  80074 */   // Label 1541: @80074
     /*  80074 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(80152), // Rule ID 4708 //
     /*  80079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80114 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80126 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3705:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru32),
     /*  80129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80131 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80133 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80150 */     GIR_RootConstrainSelectedInstOperands,
     /*  80151 */     // GIR_Coverage, 4708,
     /*  80151 */     GIR_EraseRootFromParent_Done,
     /*  80152 */   // Label 1542: @80152
     /*  80152 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(80230), // Rule ID 4710 //
     /*  80157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80204 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3705:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs8),
     /*  80207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80209 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80211 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80228 */     GIR_RootConstrainSelectedInstOperands,
     /*  80229 */     // GIR_Coverage, 4710,
     /*  80229 */     GIR_EraseRootFromParent_Done,
     /*  80230 */   // Label 1543: @80230
     /*  80230 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(80308), // Rule ID 4712 //
     /*  80235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80282 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3705:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs16),
     /*  80285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80287 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80289 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80306 */     GIR_RootConstrainSelectedInstOperands,
     /*  80307 */     // GIR_Coverage, 4712,
     /*  80307 */     GIR_EraseRootFromParent_Done,
     /*  80308 */   // Label 1544: @80308
     /*  80308 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(80386), // Rule ID 4714 //
     /*  80313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80360 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3705:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs32),
     /*  80363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80365 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80367 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80378 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80384 */     GIR_RootConstrainSelectedInstOperands,
     /*  80385 */     // GIR_Coverage, 4714,
     /*  80385 */     GIR_EraseRootFromParent_Done,
     /*  80386 */   // Label 1545: @80386
     /*  80386 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(80464), // Rule ID 4716 //
     /*  80391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80438 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3705:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru8),
     /*  80441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80443 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80445 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80462 */     GIR_RootConstrainSelectedInstOperands,
     /*  80463 */     // GIR_Coverage, 4716,
     /*  80463 */     GIR_EraseRootFromParent_Done,
     /*  80464 */   // Label 1546: @80464
     /*  80464 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(80542), // Rule ID 4718 //
     /*  80469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80516 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3705:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru16),
     /*  80519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80521 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80523 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80540 */     GIR_RootConstrainSelectedInstOperands,
     /*  80541 */     // GIR_Coverage, 4718,
     /*  80541 */     GIR_EraseRootFromParent_Done,
     /*  80542 */   // Label 1547: @80542
     /*  80542 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(80620), // Rule ID 4720 //
     /*  80547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80594 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3705:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru32),
     /*  80597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80599 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80601 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80618 */     GIR_RootConstrainSelectedInstOperands,
     /*  80619 */     // GIR_Coverage, 4720,
     /*  80619 */     GIR_EraseRootFromParent_Done,
     /*  80620 */   // Label 1548: @80620
     /*  80620 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(80698), // Rule ID 4722 //
     /*  80625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80672 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3705:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs8),
     /*  80675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80677 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80679 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80696 */     GIR_RootConstrainSelectedInstOperands,
     /*  80697 */     // GIR_Coverage, 4722,
     /*  80697 */     GIR_EraseRootFromParent_Done,
     /*  80698 */   // Label 1549: @80698
     /*  80698 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(80776), // Rule ID 4724 //
     /*  80703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80750 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3705:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs16),
     /*  80753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80755 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80757 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80774 */     GIR_RootConstrainSelectedInstOperands,
     /*  80775 */     // GIR_Coverage, 4724,
     /*  80775 */     GIR_EraseRootFromParent_Done,
     /*  80776 */   // Label 1550: @80776
     /*  80776 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(80854), // Rule ID 4726 //
     /*  80781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80828 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3705:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs32),
     /*  80831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80833 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80835 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80852 */     GIR_RootConstrainSelectedInstOperands,
     /*  80853 */     // GIR_Coverage, 4726,
     /*  80853 */     GIR_EraseRootFromParent_Done,
     /*  80854 */   // Label 1551: @80854
     /*  80854 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(80932), // Rule ID 4728 //
     /*  80859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80906 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3705:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru8),
     /*  80909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80911 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80913 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80930 */     GIR_RootConstrainSelectedInstOperands,
     /*  80931 */     // GIR_Coverage, 4728,
     /*  80931 */     GIR_EraseRootFromParent_Done,
     /*  80932 */   // Label 1552: @80932
     /*  80932 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(81010), // Rule ID 4730 //
     /*  80937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80984 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3705:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru16),
     /*  80987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80989 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80991 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81008 */     GIR_RootConstrainSelectedInstOperands,
     /*  81009 */     // GIR_Coverage, 4730,
     /*  81009 */     GIR_EraseRootFromParent_Done,
     /*  81010 */   // Label 1553: @81010
     /*  81010 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(81088), // Rule ID 4732 //
     /*  81015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81062 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3705:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru32),
     /*  81065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81067 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81069 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81086 */     GIR_RootConstrainSelectedInstOperands,
     /*  81087 */     // GIR_Coverage, 4732,
     /*  81087 */     GIR_EraseRootFromParent_Done,
     /*  81088 */   // Label 1554: @81088
     /*  81088 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(81166), // Rule ID 4734 //
     /*  81093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81140 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3705:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs8),
     /*  81143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81145 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81147 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81164 */     GIR_RootConstrainSelectedInstOperands,
     /*  81165 */     // GIR_Coverage, 4734,
     /*  81165 */     GIR_EraseRootFromParent_Done,
     /*  81166 */   // Label 1555: @81166
     /*  81166 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(81244), // Rule ID 4736 //
     /*  81171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81206 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81214 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81218 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3705:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs16),
     /*  81221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81223 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81225 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81242 */     GIR_RootConstrainSelectedInstOperands,
     /*  81243 */     // GIR_Coverage, 4736,
     /*  81243 */     GIR_EraseRootFromParent_Done,
     /*  81244 */   // Label 1556: @81244
     /*  81244 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(81322), // Rule ID 4738 //
     /*  81249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81292 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81296 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3705:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs32),
     /*  81299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81301 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81303 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81314 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81320 */     GIR_RootConstrainSelectedInstOperands,
     /*  81321 */     // GIR_Coverage, 4738,
     /*  81321 */     GIR_EraseRootFromParent_Done,
     /*  81322 */   // Label 1557: @81322
     /*  81322 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(81400), // Rule ID 4740 //
     /*  81327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81366 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81374 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3705:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru8),
     /*  81377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81379 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81381 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81398 */     GIR_RootConstrainSelectedInstOperands,
     /*  81399 */     // GIR_Coverage, 4740,
     /*  81399 */     GIR_EraseRootFromParent_Done,
     /*  81400 */   // Label 1558: @81400
     /*  81400 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(81478), // Rule ID 4742 //
     /*  81405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81452 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3705:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru16),
     /*  81455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81457 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81459 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81476 */     GIR_RootConstrainSelectedInstOperands,
     /*  81477 */     // GIR_Coverage, 4742,
     /*  81477 */     GIR_EraseRootFromParent_Done,
     /*  81478 */   // Label 1559: @81478
     /*  81478 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(81556), // Rule ID 4744 //
     /*  81483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81530 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3705:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru32),
     /*  81533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81535 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81537 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81554 */     GIR_RootConstrainSelectedInstOperands,
     /*  81555 */     // GIR_Coverage, 4744,
     /*  81555 */     GIR_EraseRootFromParent_Done,
     /*  81556 */   // Label 1560: @81556
     /*  81556 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(81692), // Rule ID 2687 //
     /*  81561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx3),
     /*  81569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  81572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  81575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  81578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  81581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  81584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  81587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  81591 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3863:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX3Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  81591 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  81594 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81598 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  81608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  81612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  81621 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  81624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  81628 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  81631 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  81635 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  81638 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81641 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  81644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  81649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX3Pseudo),
     /*  81672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81674 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  81676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81679 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  81681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  81684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81690 */     GIR_RootConstrainSelectedInstOperands,
     /*  81691 */     // GIR_Coverage, 2687,
     /*  81691 */     GIR_EraseRootFromParent_Done,
     /*  81692 */   // Label 1561: @81692
     /*  81692 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(81813), // Rule ID 2688 //
     /*  81697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl4),
     /*  81705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  81708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  81711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  81714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  81717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  81720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  81723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  81727 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3860:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL4Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  81727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  81730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  81734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81739 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  81743 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  81746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  81750 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  81753 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  81757 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  81760 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn3
     /*  81764 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  81767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  81772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  81792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL4Pseudo),
     /*  81795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81800 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  81802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  81805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81811 */     GIR_RootConstrainSelectedInstOperands,
     /*  81812 */     // GIR_Coverage, 2688,
     /*  81812 */     GIR_EraseRootFromParent_Done,
     /*  81813 */   // Label 1562: @81813
     /*  81813 */   GIM_Reject,
     /*  81814 */ // Label 1500: @81814
     /*  81814 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(86707),
     /*  81819 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  81822 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(81910), // Rule ID 3178 //
     /*  81827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  81830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  81835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  81838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  81841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  81853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  81856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  81860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  81864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  81868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  81872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81876 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81880 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81884 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  81884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs8),
     /*  81887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  81889 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  81891 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  81893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81908 */     GIR_RootConstrainSelectedInstOperands,
     /*  81909 */     // GIR_Coverage, 3178,
     /*  81909 */     GIR_EraseRootFromParent_Done,
     /*  81910 */   // Label 1564: @81910
     /*  81910 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(81998), // Rule ID 3182 //
     /*  81915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  81918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  81923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  81926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  81929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  81941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  81944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  81948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  81952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  81956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81964 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81968 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81972 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  81972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs8),
     /*  81975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  81977 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  81979 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  81981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81996 */     GIR_RootConstrainSelectedInstOperands,
     /*  81997 */     // GIR_Coverage, 3182,
     /*  81997 */     GIR_EraseRootFromParent_Done,
     /*  81998 */   // Label 1565: @81998
     /*  81998 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(82086), // Rule ID 3186 //
     /*  82003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82052 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82056 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82060 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVu8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /*  82063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82065 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82067 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82084 */     GIR_RootConstrainSelectedInstOperands,
     /*  82085 */     // GIR_Coverage, 3186,
     /*  82085 */     GIR_EraseRootFromParent_Done,
     /*  82086 */   // Label 1566: @82086
     /*  82086 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(82174), // Rule ID 3190 //
     /*  82091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82140 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82144 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82148 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs16),
     /*  82151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82153 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82155 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82160 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82172 */     GIR_RootConstrainSelectedInstOperands,
     /*  82173 */     // GIR_Coverage, 3190,
     /*  82173 */     GIR_EraseRootFromParent_Done,
     /*  82174 */   // Label 1567: @82174
     /*  82174 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(82262), // Rule ID 3194 //
     /*  82179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82228 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82232 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82236 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs16),
     /*  82239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82241 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82243 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82260 */     GIR_RootConstrainSelectedInstOperands,
     /*  82261 */     // GIR_Coverage, 3194,
     /*  82261 */     GIR_EraseRootFromParent_Done,
     /*  82262 */   // Label 1568: @82262
     /*  82262 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(82350), // Rule ID 3198 //
     /*  82267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82316 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82320 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82324 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVu16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /*  82327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82329 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82331 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82348 */     GIR_RootConstrainSelectedInstOperands,
     /*  82349 */     // GIR_Coverage, 3198,
     /*  82349 */     GIR_EraseRootFromParent_Done,
     /*  82350 */   // Label 1569: @82350
     /*  82350 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(82438), // Rule ID 3202 //
     /*  82355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82404 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82408 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82412 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs32),
     /*  82415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82417 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82419 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82436 */     GIR_RootConstrainSelectedInstOperands,
     /*  82437 */     // GIR_Coverage, 3202,
     /*  82437 */     GIR_EraseRootFromParent_Done,
     /*  82438 */   // Label 1570: @82438
     /*  82438 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(82526), // Rule ID 3206 //
     /*  82443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82492 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82496 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82500 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs32),
     /*  82503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82505 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82507 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82524 */     GIR_RootConstrainSelectedInstOperands,
     /*  82525 */     // GIR_Coverage, 3206,
     /*  82525 */     GIR_EraseRootFromParent_Done,
     /*  82526 */   // Label 1571: @82526
     /*  82526 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(82614), // Rule ID 3210 //
     /*  82531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82580 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82584 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82588 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVu32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /*  82591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82593 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82595 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82612 */     GIR_RootConstrainSelectedInstOperands,
     /*  82613 */     // GIR_Coverage, 3210,
     /*  82613 */     GIR_EraseRootFromParent_Done,
     /*  82614 */   // Label 1572: @82614
     /*  82614 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(82702), // Rule ID 3214 //
     /*  82619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  82660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82668 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82672 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82676 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs8),
     /*  82679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82681 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82683 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82700 */     GIR_RootConstrainSelectedInstOperands,
     /*  82701 */     // GIR_Coverage, 3214,
     /*  82701 */     GIR_EraseRootFromParent_Done,
     /*  82702 */   // Label 1573: @82702
     /*  82702 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(82790), // Rule ID 3218 //
     /*  82707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  82748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82756 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82760 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82764 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs8),
     /*  82767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82769 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82771 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82788 */     GIR_RootConstrainSelectedInstOperands,
     /*  82789 */     // GIR_Coverage, 3218,
     /*  82789 */     GIR_EraseRootFromParent_Done,
     /*  82790 */   // Label 1574: @82790
     /*  82790 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(82878), // Rule ID 3222 //
     /*  82795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  82836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82844 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82848 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82852 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs16),
     /*  82855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82857 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82859 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82876 */     GIR_RootConstrainSelectedInstOperands,
     /*  82877 */     // GIR_Coverage, 3222,
     /*  82877 */     GIR_EraseRootFromParent_Done,
     /*  82878 */   // Label 1575: @82878
     /*  82878 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(82966), // Rule ID 3226 //
     /*  82883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  82924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82932 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82936 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82940 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs16),
     /*  82943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82945 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82947 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82958 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82964 */     GIR_RootConstrainSelectedInstOperands,
     /*  82965 */     // GIR_Coverage, 3226,
     /*  82965 */     GIR_EraseRootFromParent_Done,
     /*  82966 */   // Label 1576: @82966
     /*  82966 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(83054), // Rule ID 3230 //
     /*  82971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83020 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83024 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83028 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs32),
     /*  83031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83033 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83035 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83052 */     GIR_RootConstrainSelectedInstOperands,
     /*  83053 */     // GIR_Coverage, 3230,
     /*  83053 */     GIR_EraseRootFromParent_Done,
     /*  83054 */   // Label 1577: @83054
     /*  83054 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(83142), // Rule ID 3234 //
     /*  83059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83108 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83112 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83116 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs32),
     /*  83119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83121 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83123 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83128 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83140 */     GIR_RootConstrainSelectedInstOperands,
     /*  83141 */     // GIR_Coverage, 3234,
     /*  83141 */     GIR_EraseRootFromParent_Done,
     /*  83142 */   // Label 1578: @83142
     /*  83142 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(83232), // Rule ID 3180 //
     /*  83147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83196 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83200 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83204 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas8),
     /*  83207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83209 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83211 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83213 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83230 */     GIR_RootConstrainSelectedInstOperands,
     /*  83231 */     // GIR_Coverage, 3180,
     /*  83231 */     GIR_EraseRootFromParent_Done,
     /*  83232 */   // Label 1579: @83232
     /*  83232 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(83322), // Rule ID 3184 //
     /*  83237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83270 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83286 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83290 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83294 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs8),
     /*  83297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83299 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83301 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83303 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83314 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83320 */     GIR_RootConstrainSelectedInstOperands,
     /*  83321 */     // GIR_Coverage, 3184,
     /*  83321 */     GIR_EraseRootFromParent_Done,
     /*  83322 */   // Label 1580: @83322
     /*  83322 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(83412), // Rule ID 3188 //
     /*  83327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83376 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83380 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83384 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVau8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*  83387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83389 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83391 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83393 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83410 */     GIR_RootConstrainSelectedInstOperands,
     /*  83411 */     // GIR_Coverage, 3188,
     /*  83411 */     GIR_EraseRootFromParent_Done,
     /*  83412 */   // Label 1581: @83412
     /*  83412 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(83502), // Rule ID 3192 //
     /*  83417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83466 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83470 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83474 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas16),
     /*  83477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83479 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83481 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83483 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83500 */     GIR_RootConstrainSelectedInstOperands,
     /*  83501 */     // GIR_Coverage, 3192,
     /*  83501 */     GIR_EraseRootFromParent_Done,
     /*  83502 */   // Label 1582: @83502
     /*  83502 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(83592), // Rule ID 3196 //
     /*  83507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83556 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83560 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83564 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs16),
     /*  83567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83569 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83571 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83573 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83590 */     GIR_RootConstrainSelectedInstOperands,
     /*  83591 */     // GIR_Coverage, 3196,
     /*  83591 */     GIR_EraseRootFromParent_Done,
     /*  83592 */   // Label 1583: @83592
     /*  83592 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(83682), // Rule ID 3200 //
     /*  83597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83646 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83650 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83654 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVau16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*  83657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83659 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83661 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83663 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83680 */     GIR_RootConstrainSelectedInstOperands,
     /*  83681 */     // GIR_Coverage, 3200,
     /*  83681 */     GIR_EraseRootFromParent_Done,
     /*  83682 */   // Label 1584: @83682
     /*  83682 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(83772), // Rule ID 3204 //
     /*  83687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83736 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83740 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83744 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas32),
     /*  83747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83749 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83751 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83753 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83770 */     GIR_RootConstrainSelectedInstOperands,
     /*  83771 */     // GIR_Coverage, 3204,
     /*  83771 */     GIR_EraseRootFromParent_Done,
     /*  83772 */   // Label 1585: @83772
     /*  83772 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(83862), // Rule ID 3208 //
     /*  83777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83810 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83814 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83818 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83826 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83830 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83834 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs32),
     /*  83837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83839 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83841 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83843 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83860 */     GIR_RootConstrainSelectedInstOperands,
     /*  83861 */     // GIR_Coverage, 3208,
     /*  83861 */     GIR_EraseRootFromParent_Done,
     /*  83862 */   // Label 1586: @83862
     /*  83862 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(83952), // Rule ID 3212 //
     /*  83867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83916 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83920 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83924 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVau32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*  83927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83929 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83931 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83933 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83950 */     GIR_RootConstrainSelectedInstOperands,
     /*  83951 */     // GIR_Coverage, 3212,
     /*  83951 */     GIR_EraseRootFromParent_Done,
     /*  83952 */   // Label 1587: @83952
     /*  83952 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(84042), // Rule ID 3216 //
     /*  83957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84006 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84010 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84014 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas8),
     /*  84017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84019 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84021 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84023 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84040 */     GIR_RootConstrainSelectedInstOperands,
     /*  84041 */     // GIR_Coverage, 3216,
     /*  84041 */     GIR_EraseRootFromParent_Done,
     /*  84042 */   // Label 1588: @84042
     /*  84042 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(84132), // Rule ID 3220 //
     /*  84047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84096 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84100 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84104 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs8),
     /*  84107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84109 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84111 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84113 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84130 */     GIR_RootConstrainSelectedInstOperands,
     /*  84131 */     // GIR_Coverage, 3220,
     /*  84131 */     GIR_EraseRootFromParent_Done,
     /*  84132 */   // Label 1589: @84132
     /*  84132 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(84222), // Rule ID 3224 //
     /*  84137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84186 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84190 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84194 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas16),
     /*  84197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84199 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84201 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84203 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84220 */     GIR_RootConstrainSelectedInstOperands,
     /*  84221 */     // GIR_Coverage, 3224,
     /*  84221 */     GIR_EraseRootFromParent_Done,
     /*  84222 */   // Label 1590: @84222
     /*  84222 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(84312), // Rule ID 3228 //
     /*  84227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84264 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84268 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84276 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84280 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84284 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs16),
     /*  84287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84289 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84291 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84293 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84310 */     GIR_RootConstrainSelectedInstOperands,
     /*  84311 */     // GIR_Coverage, 3228,
     /*  84311 */     GIR_EraseRootFromParent_Done,
     /*  84312 */   // Label 1591: @84312
     /*  84312 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(84402), // Rule ID 3232 //
     /*  84317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84358 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84366 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84370 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84374 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas32),
     /*  84377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84379 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84381 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84383 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84394 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84400 */     GIR_RootConstrainSelectedInstOperands,
     /*  84401 */     // GIR_Coverage, 3232,
     /*  84401 */     GIR_EraseRootFromParent_Done,
     /*  84402 */   // Label 1592: @84402
     /*  84402 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(84492), // Rule ID 3236 //
     /*  84407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84456 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84460 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84464 */     // (intrinsic_wo_chain:{ *:[i32] } 3660:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs32),
     /*  84467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84469 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84471 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84473 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84484 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84490 */     GIR_RootConstrainSelectedInstOperands,
     /*  84491 */     // GIR_Coverage, 3236,
     /*  84491 */     GIR_EraseRootFromParent_Done,
     /*  84492 */   // Label 1593: @84492
     /*  84492 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(84579), // Rule ID 4332 //
     /*  84497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  84505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  84543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84551 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  84551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs8),
     /*  84554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84556 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84558 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84560 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84577 */     GIR_RootConstrainSelectedInstOperands,
     /*  84578 */     // GIR_Coverage, 4332,
     /*  84578 */     GIR_EraseRootFromParent_Done,
     /*  84579 */   // Label 1594: @84579
     /*  84579 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(84666), // Rule ID 4334 //
     /*  84584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  84592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  84598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  84601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  84630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84638 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  84638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs16),
     /*  84641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84643 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84645 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84647 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84664 */     GIR_RootConstrainSelectedInstOperands,
     /*  84665 */     // GIR_Coverage, 4334,
     /*  84665 */     GIR_EraseRootFromParent_Done,
     /*  84666 */   // Label 1595: @84666
     /*  84666 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(84753), // Rule ID 4336 //
     /*  84671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  84679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  84688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84713 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  84717 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84725 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  84725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs32),
     /*  84728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84730 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84732 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84734 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84751 */     GIR_RootConstrainSelectedInstOperands,
     /*  84752 */     // GIR_Coverage, 4336,
     /*  84752 */     GIR_EraseRootFromParent_Done,
     /*  84753 */   // Label 1596: @84753
     /*  84753 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(84840), // Rule ID 4338 //
     /*  84758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  84766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  84804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84812 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  84812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs8),
     /*  84815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84817 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84819 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84821 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84838 */     GIR_RootConstrainSelectedInstOperands,
     /*  84839 */     // GIR_Coverage, 4338,
     /*  84839 */     GIR_EraseRootFromParent_Done,
     /*  84840 */   // Label 1597: @84840
     /*  84840 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(84927), // Rule ID 4340 //
     /*  84845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  84853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  84856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  84859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  84862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  84891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84899 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  84899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs16),
     /*  84902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84904 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84906 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84908 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84925 */     GIR_RootConstrainSelectedInstOperands,
     /*  84926 */     // GIR_Coverage, 4340,
     /*  84926 */     GIR_EraseRootFromParent_Done,
     /*  84927 */   // Label 1598: @84927
     /*  84927 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(85014), // Rule ID 4342 //
     /*  84932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  84940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  84949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  84958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84974 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  84978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  84982 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  84986 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  84986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs32),
     /*  84989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  84991 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  84993 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  84995 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  84997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85012 */     GIR_RootConstrainSelectedInstOperands,
     /*  85013 */     // GIR_Coverage, 4342,
     /*  85013 */     GIR_EraseRootFromParent_Done,
     /*  85014 */   // Label 1599: @85014
     /*  85014 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(85101), // Rule ID 4344 //
     /*  85019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85073 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs8),
     /*  85076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85078 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85080 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85082 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85087 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85099 */     GIR_RootConstrainSelectedInstOperands,
     /*  85100 */     // GIR_Coverage, 4344,
     /*  85100 */     GIR_EraseRootFromParent_Done,
     /*  85101 */   // Label 1600: @85101
     /*  85101 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(85188), // Rule ID 4346 //
     /*  85106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85160 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs16),
     /*  85163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85165 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85167 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85169 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85186 */     GIR_RootConstrainSelectedInstOperands,
     /*  85187 */     // GIR_Coverage, 4346,
     /*  85187 */     GIR_EraseRootFromParent_Done,
     /*  85188 */   // Label 1601: @85188
     /*  85188 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(85275), // Rule ID 4348 //
     /*  85193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85247 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs32),
     /*  85250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85252 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85254 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85256 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85273 */     GIR_RootConstrainSelectedInstOperands,
     /*  85274 */     // GIR_Coverage, 4348,
     /*  85274 */     GIR_EraseRootFromParent_Done,
     /*  85275 */   // Label 1602: @85275
     /*  85275 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(85362), // Rule ID 4350 //
     /*  85280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85326 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85334 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs8),
     /*  85337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85339 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85341 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85343 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85360 */     GIR_RootConstrainSelectedInstOperands,
     /*  85361 */     // GIR_Coverage, 4350,
     /*  85361 */     GIR_EraseRootFromParent_Done,
     /*  85362 */   // Label 1603: @85362
     /*  85362 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(85449), // Rule ID 4352 //
     /*  85367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85421 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs16),
     /*  85424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85426 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85428 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85430 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85447 */     GIR_RootConstrainSelectedInstOperands,
     /*  85448 */     // GIR_Coverage, 4352,
     /*  85448 */     GIR_EraseRootFromParent_Done,
     /*  85449 */   // Label 1604: @85449
     /*  85449 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(85536), // Rule ID 4354 //
     /*  85454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85508 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs32),
     /*  85511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85513 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85515 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85517 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85534 */     GIR_RootConstrainSelectedInstOperands,
     /*  85535 */     // GIR_Coverage, 4354,
     /*  85535 */     GIR_EraseRootFromParent_Done,
     /*  85536 */   // Label 1605: @85536
     /*  85536 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(85623), // Rule ID 4356 //
     /*  85541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  85595 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs8),
     /*  85598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85600 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85602 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85604 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85621 */     GIR_RootConstrainSelectedInstOperands,
     /*  85622 */     // GIR_Coverage, 4356,
     /*  85622 */     GIR_EraseRootFromParent_Done,
     /*  85623 */   // Label 1606: @85623
     /*  85623 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(85710), // Rule ID 4358 //
     /*  85628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85674 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  85682 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs16),
     /*  85685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85687 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85689 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85691 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85708 */     GIR_RootConstrainSelectedInstOperands,
     /*  85709 */     // GIR_Coverage, 4358,
     /*  85709 */     GIR_EraseRootFromParent_Done,
     /*  85710 */   // Label 1607: @85710
     /*  85710 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(85797), // Rule ID 4360 //
     /*  85715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85757 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  85769 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs32),
     /*  85772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85774 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85776 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85778 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85795 */     GIR_RootConstrainSelectedInstOperands,
     /*  85796 */     // GIR_Coverage, 4360,
     /*  85796 */     GIR_EraseRootFromParent_Done,
     /*  85797 */   // Label 1608: @85797
     /*  85797 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(85884), // Rule ID 4362 //
     /*  85802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  85856 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs8),
     /*  85859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85861 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85863 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85865 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85876 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85882 */     GIR_RootConstrainSelectedInstOperands,
     /*  85883 */     // GIR_Coverage, 4362,
     /*  85883 */     GIR_EraseRootFromParent_Done,
     /*  85884 */   // Label 1609: @85884
     /*  85884 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(85971), // Rule ID 4364 //
     /*  85889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  85943 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs16),
     /*  85946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85948 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85950 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85952 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85969 */     GIR_RootConstrainSelectedInstOperands,
     /*  85970 */     // GIR_Coverage, 4364,
     /*  85970 */     GIR_EraseRootFromParent_Done,
     /*  85971 */   // Label 1610: @85971
     /*  85971 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(86058), // Rule ID 4366 //
     /*  85976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86030 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs32),
     /*  86033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86035 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86037 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86039 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86056 */     GIR_RootConstrainSelectedInstOperands,
     /*  86057 */     // GIR_Coverage, 4366,
     /*  86057 */     GIR_EraseRootFromParent_Done,
     /*  86058 */   // Label 1611: @86058
     /*  86058 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(86145), // Rule ID 4368 //
     /*  86063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86105 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86117 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs8),
     /*  86120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86122 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86124 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86126 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86143 */     GIR_RootConstrainSelectedInstOperands,
     /*  86144 */     // GIR_Coverage, 4368,
     /*  86144 */     GIR_EraseRootFromParent_Done,
     /*  86145 */   // Label 1612: @86145
     /*  86145 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(86232), // Rule ID 4370 //
     /*  86150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86204 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs16),
     /*  86207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86209 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86211 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86213 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86218 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86230 */     GIR_RootConstrainSelectedInstOperands,
     /*  86231 */     // GIR_Coverage, 4370,
     /*  86231 */     GIR_EraseRootFromParent_Done,
     /*  86232 */   // Label 1613: @86232
     /*  86232 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(86319), // Rule ID 4372 //
     /*  86237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86279 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86283 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86291 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs32),
     /*  86294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86296 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86298 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86300 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86317 */     GIR_RootConstrainSelectedInstOperands,
     /*  86318 */     // GIR_Coverage, 4372,
     /*  86318 */     GIR_EraseRootFromParent_Done,
     /*  86319 */   // Label 1614: @86319
     /*  86319 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(86406), // Rule ID 4374 //
     /*  86324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86366 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86378 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs8),
     /*  86381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86383 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86385 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86387 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86404 */     GIR_RootConstrainSelectedInstOperands,
     /*  86405 */     // GIR_Coverage, 4374,
     /*  86405 */     GIR_EraseRootFromParent_Done,
     /*  86406 */   // Label 1615: @86406
     /*  86406 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(86493), // Rule ID 4376 //
     /*  86411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86465 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs16),
     /*  86468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86470 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86472 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86474 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86491 */     GIR_RootConstrainSelectedInstOperands,
     /*  86492 */     // GIR_Coverage, 4376,
     /*  86492 */     GIR_EraseRootFromParent_Done,
     /*  86493 */   // Label 1616: @86493
     /*  86493 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(86580), // Rule ID 4378 //
     /*  86498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86552 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs32),
     /*  86555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86557 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86559 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86561 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86578 */     GIR_RootConstrainSelectedInstOperands,
     /*  86579 */     // GIR_Coverage, 4378,
     /*  86579 */     GIR_EraseRootFromParent_Done,
     /*  86580 */   // Label 1617: @86580
     /*  86580 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(86706), // Rule ID 2689 //
     /*  86585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx4),
     /*  86593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  86596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  86599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  86602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  86605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  86608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  86611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s8,
     /*  86614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  86618 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3864:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX4Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  86618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  86621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  86625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86630 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  86634 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  86637 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  86641 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  86644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  86648 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  86651 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // Vn3
     /*  86655 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  86658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  86663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  86683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX4Pseudo),
     /*  86686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86688 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  86690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86693 */     GIR_RootToRootCopy, /*OpIdx*/7, // Vm
     /*  86695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  86698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86704 */     GIR_RootConstrainSelectedInstOperands,
     /*  86705 */     // GIR_Coverage, 2689,
     /*  86705 */     GIR_EraseRootFromParent_Done,
     /*  86706 */   // Label 1618: @86706
     /*  86706 */   GIM_Reject,
     /*  86707 */ // Label 1563: @86707
     /*  86707 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(91001),
     /*  86712 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/10,
     /*  86715 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshrn),
     /*  86720 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(86827), // Rule ID 3755 //
     /*  86725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  86737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86746 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  86749 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  86752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  86768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  86776 */     // MIs[1] Operand 1
     /*  86776 */     // No operand predicates
     /*  86776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  86788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  86792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  86796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86798 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  86798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  86801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86803 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  86805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  86807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  86810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86825 */     GIR_RootConstrainSelectedInstOperands,
     /*  86826 */     // GIR_Coverage, 3755,
     /*  86826 */     GIR_EraseRootFromParent_Done,
     /*  86827 */   // Label 1620: @86827
     /*  86827 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(86934), // Rule ID 3757 //
     /*  86832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  86844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86853 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  86856 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  86859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  86875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  86883 */     // MIs[1] Operand 1
     /*  86883 */     // No operand predicates
     /*  86883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  86895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  86899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  86903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86905 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  86905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  86908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86910 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  86912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  86914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  86917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86932 */     GIR_RootConstrainSelectedInstOperands,
     /*  86933 */     // GIR_Coverage, 3757,
     /*  86933 */     GIR_EraseRootFromParent_Done,
     /*  86934 */   // Label 1621: @86934
     /*  86934 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(87041), // Rule ID 3759 //
     /*  86939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  86951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86960 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  86963 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  86966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  86982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  86990 */     // MIs[1] Operand 1
     /*  86990 */     // No operand predicates
     /*  86990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87012 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87017 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87039 */     GIR_RootConstrainSelectedInstOperands,
     /*  87040 */     // GIR_Coverage, 3759,
     /*  87040 */     GIR_EraseRootFromParent_Done,
     /*  87041 */   // Label 1622: @87041
     /*  87041 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(87148), // Rule ID 3761 //
     /*  87046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87067 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87070 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87097 */     // MIs[1] Operand 1
     /*  87097 */     // No operand predicates
     /*  87097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87105 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87119 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87124 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87146 */     GIR_RootConstrainSelectedInstOperands,
     /*  87147 */     // GIR_Coverage, 3761,
     /*  87147 */     GIR_EraseRootFromParent_Done,
     /*  87148 */   // Label 1623: @87148
     /*  87148 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(87255), // Rule ID 3763 //
     /*  87153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87174 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87177 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87204 */     // MIs[1] Operand 1
     /*  87204 */     // No operand predicates
     /*  87204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87226 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87231 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87253 */     GIR_RootConstrainSelectedInstOperands,
     /*  87254 */     // GIR_Coverage, 3763,
     /*  87254 */     GIR_EraseRootFromParent_Done,
     /*  87255 */   // Label 1624: @87255
     /*  87255 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(87362), // Rule ID 3765 //
     /*  87260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87281 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87284 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87311 */     // MIs[1] Operand 1
     /*  87311 */     // No operand predicates
     /*  87311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87333 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87338 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87360 */     GIR_RootConstrainSelectedInstOperands,
     /*  87361 */     // GIR_Coverage, 3765,
     /*  87361 */     GIR_EraseRootFromParent_Done,
     /*  87362 */   // Label 1625: @87362
     /*  87362 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(87469), // Rule ID 3767 //
     /*  87367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87388 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87391 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87418 */     // MIs[1] Operand 1
     /*  87418 */     // No operand predicates
     /*  87418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87440 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87445 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87467 */     GIR_RootConstrainSelectedInstOperands,
     /*  87468 */     // GIR_Coverage, 3767,
     /*  87468 */     GIR_EraseRootFromParent_Done,
     /*  87469 */   // Label 1626: @87469
     /*  87469 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(87576), // Rule ID 3769 //
     /*  87474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87495 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87498 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87525 */     // MIs[1] Operand 1
     /*  87525 */     // No operand predicates
     /*  87525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87547 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87552 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87568 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87574 */     GIR_RootConstrainSelectedInstOperands,
     /*  87575 */     // GIR_Coverage, 3769,
     /*  87575 */     GIR_EraseRootFromParent_Done,
     /*  87576 */   // Label 1627: @87576
     /*  87576 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(87683), // Rule ID 3771 //
     /*  87581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87602 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87605 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87632 */     // MIs[1] Operand 1
     /*  87632 */     // No operand predicates
     /*  87632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87654 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  87657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87659 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87681 */     GIR_RootConstrainSelectedInstOperands,
     /*  87682 */     // GIR_Coverage, 3771,
     /*  87682 */     GIR_EraseRootFromParent_Done,
     /*  87683 */   // Label 1628: @87683
     /*  87683 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(87790), // Rule ID 3773 //
     /*  87688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87709 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87712 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87739 */     // MIs[1] Operand 1
     /*  87739 */     // No operand predicates
     /*  87739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87761 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  87764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87766 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87788 */     GIR_RootConstrainSelectedInstOperands,
     /*  87789 */     // GIR_Coverage, 3773,
     /*  87789 */     GIR_EraseRootFromParent_Done,
     /*  87790 */   // Label 1629: @87790
     /*  87790 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(87897), // Rule ID 3775 //
     /*  87795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87816 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87819 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87846 */     // MIs[1] Operand 1
     /*  87846 */     // No operand predicates
     /*  87846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87868 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  87871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87873 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87895 */     GIR_RootConstrainSelectedInstOperands,
     /*  87896 */     // GIR_Coverage, 3775,
     /*  87896 */     GIR_EraseRootFromParent_Done,
     /*  87897 */   // Label 1630: @87897
     /*  87897 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(88004), // Rule ID 3777 //
     /*  87902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87923 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87926 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87953 */     // MIs[1] Operand 1
     /*  87953 */     // No operand predicates
     /*  87953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87975 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  87978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87980 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88002 */     GIR_RootConstrainSelectedInstOperands,
     /*  88003 */     // GIR_Coverage, 3777,
     /*  88003 */     GIR_EraseRootFromParent_Done,
     /*  88004 */   // Label 1631: @88004
     /*  88004 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(88111), // Rule ID 3779 //
     /*  88009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88030 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88033 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88060 */     // MIs[1] Operand 1
     /*  88060 */     // No operand predicates
     /*  88060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88082 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88087 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88097 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88109 */     GIR_RootConstrainSelectedInstOperands,
     /*  88110 */     // GIR_Coverage, 3779,
     /*  88110 */     GIR_EraseRootFromParent_Done,
     /*  88111 */   // Label 1632: @88111
     /*  88111 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(88218), // Rule ID 3781 //
     /*  88116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88137 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88140 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88167 */     // MIs[1] Operand 1
     /*  88167 */     // No operand predicates
     /*  88167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88183 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88189 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88194 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88210 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88216 */     GIR_RootConstrainSelectedInstOperands,
     /*  88217 */     // GIR_Coverage, 3781,
     /*  88217 */     GIR_EraseRootFromParent_Done,
     /*  88218 */   // Label 1633: @88218
     /*  88218 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(88325), // Rule ID 3783 //
     /*  88223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88244 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88247 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88274 */     // MIs[1] Operand 1
     /*  88274 */     // No operand predicates
     /*  88274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88282 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88296 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88301 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88323 */     GIR_RootConstrainSelectedInstOperands,
     /*  88324 */     // GIR_Coverage, 3783,
     /*  88324 */     GIR_EraseRootFromParent_Done,
     /*  88325 */   // Label 1634: @88325
     /*  88325 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(88432), // Rule ID 3785 //
     /*  88330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88351 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88354 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88381 */     // MIs[1] Operand 1
     /*  88381 */     // No operand predicates
     /*  88381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88389 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88403 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88408 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88430 */     GIR_RootConstrainSelectedInstOperands,
     /*  88431 */     // GIR_Coverage, 3785,
     /*  88431 */     GIR_EraseRootFromParent_Done,
     /*  88432 */   // Label 1635: @88432
     /*  88432 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(88539), // Rule ID 3787 //
     /*  88437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88458 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88461 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88488 */     // MIs[1] Operand 1
     /*  88488 */     // No operand predicates
     /*  88488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88510 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs16),
     /*  88513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88515 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88537 */     GIR_RootConstrainSelectedInstOperands,
     /*  88538 */     // GIR_Coverage, 3787,
     /*  88538 */     GIR_EraseRootFromParent_Done,
     /*  88539 */   // Label 1636: @88539
     /*  88539 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(88646), // Rule ID 3789 //
     /*  88544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88565 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88568 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88595 */     // MIs[1] Operand 1
     /*  88595 */     // No operand predicates
     /*  88595 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88617 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths16),
     /*  88620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88622 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88644 */     GIR_RootConstrainSelectedInstOperands,
     /*  88645 */     // GIR_Coverage, 3789,
     /*  88645 */     GIR_EraseRootFromParent_Done,
     /*  88646 */   // Label 1637: @88646
     /*  88646 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(88753), // Rule ID 3791 //
     /*  88651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88669 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88672 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88675 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88702 */     // MIs[1] Operand 1
     /*  88702 */     // No operand predicates
     /*  88702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88724 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs32),
     /*  88727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88729 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88751 */     GIR_RootConstrainSelectedInstOperands,
     /*  88752 */     // GIR_Coverage, 3791,
     /*  88752 */     GIR_EraseRootFromParent_Done,
     /*  88753 */   // Label 1638: @88753
     /*  88753 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(88860), // Rule ID 3793 //
     /*  88758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88779 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88782 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88809 */     // MIs[1] Operand 1
     /*  88809 */     // No operand predicates
     /*  88809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88817 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88831 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths32),
     /*  88834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88836 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88858 */     GIR_RootConstrainSelectedInstOperands,
     /*  88859 */     // GIR_Coverage, 3793,
     /*  88859 */     GIR_EraseRootFromParent_Done,
     /*  88860 */   // Label 1639: @88860
     /*  88860 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(88967), // Rule ID 3795 //
     /*  88865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88886 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88889 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88916 */     // MIs[1] Operand 1
     /*  88916 */     // No operand predicates
     /*  88916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88932 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88938 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu16),
     /*  88941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88943 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88965 */     GIR_RootConstrainSelectedInstOperands,
     /*  88966 */     // GIR_Coverage, 3795,
     /*  88966 */     GIR_EraseRootFromParent_Done,
     /*  88967 */   // Label 1640: @88967
     /*  88967 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(89074), // Rule ID 3797 //
     /*  88972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88993 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88996 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89023 */     // MIs[1] Operand 1
     /*  89023 */     // No operand predicates
     /*  89023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89027 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89031 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89035 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89045 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu16),
     /*  89048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89050 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89072 */     GIR_RootConstrainSelectedInstOperands,
     /*  89073 */     // GIR_Coverage, 3797,
     /*  89073 */     GIR_EraseRootFromParent_Done,
     /*  89074 */   // Label 1641: @89074
     /*  89074 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(89181), // Rule ID 3799 //
     /*  89079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89100 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89103 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89130 */     // MIs[1] Operand 1
     /*  89130 */     // No operand predicates
     /*  89130 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89152 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu32),
     /*  89155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89157 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89173 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89179 */     GIR_RootConstrainSelectedInstOperands,
     /*  89180 */     // GIR_Coverage, 3799,
     /*  89180 */     GIR_EraseRootFromParent_Done,
     /*  89181 */   // Label 1642: @89181
     /*  89181 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(89288), // Rule ID 3801 //
     /*  89186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89207 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89210 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89237 */     // MIs[1] Operand 1
     /*  89237 */     // No operand predicates
     /*  89237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89249 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89253 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89259 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu32),
     /*  89262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89264 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89286 */     GIR_RootConstrainSelectedInstOperands,
     /*  89287 */     // GIR_Coverage, 3801,
     /*  89287 */     GIR_EraseRootFromParent_Done,
     /*  89288 */   // Label 1643: @89288
     /*  89288 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(89395), // Rule ID 3803 //
     /*  89293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89314 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89317 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89344 */     // MIs[1] Operand 1
     /*  89344 */     // No operand predicates
     /*  89344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89366 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs16),
     /*  89369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89371 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89393 */     GIR_RootConstrainSelectedInstOperands,
     /*  89394 */     // GIR_Coverage, 3803,
     /*  89394 */     GIR_EraseRootFromParent_Done,
     /*  89395 */   // Label 1644: @89395
     /*  89395 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(89502), // Rule ID 3805 //
     /*  89400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89421 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89424 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89451 */     // MIs[1] Operand 1
     /*  89451 */     // No operand predicates
     /*  89451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89455 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89463 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89473 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths16),
     /*  89476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89478 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89500 */     GIR_RootConstrainSelectedInstOperands,
     /*  89501 */     // GIR_Coverage, 3805,
     /*  89501 */     GIR_EraseRootFromParent_Done,
     /*  89502 */   // Label 1645: @89502
     /*  89502 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(89609), // Rule ID 3807 //
     /*  89507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89528 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89531 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89558 */     // MIs[1] Operand 1
     /*  89558 */     // No operand predicates
     /*  89558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89570 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89580 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs32),
     /*  89583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89585 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89595 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89607 */     GIR_RootConstrainSelectedInstOperands,
     /*  89608 */     // GIR_Coverage, 3807,
     /*  89608 */     GIR_EraseRootFromParent_Done,
     /*  89609 */   // Label 1646: @89609
     /*  89609 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(89716), // Rule ID 3809 //
     /*  89614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89635 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89638 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89665 */     // MIs[1] Operand 1
     /*  89665 */     // No operand predicates
     /*  89665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89687 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths32),
     /*  89690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89692 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89714 */     GIR_RootConstrainSelectedInstOperands,
     /*  89715 */     // GIR_Coverage, 3809,
     /*  89715 */     GIR_EraseRootFromParent_Done,
     /*  89716 */   // Label 1647: @89716
     /*  89716 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(89823), // Rule ID 3811 //
     /*  89721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89742 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89745 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89772 */     // MIs[1] Operand 1
     /*  89772 */     // No operand predicates
     /*  89772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89794 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu16),
     /*  89797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89799 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89809 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89821 */     GIR_RootConstrainSelectedInstOperands,
     /*  89822 */     // GIR_Coverage, 3811,
     /*  89822 */     GIR_EraseRootFromParent_Done,
     /*  89823 */   // Label 1648: @89823
     /*  89823 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(89930), // Rule ID 3813 //
     /*  89828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89849 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89852 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89879 */     // MIs[1] Operand 1
     /*  89879 */     // No operand predicates
     /*  89879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89901 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu16),
     /*  89904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89906 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89928 */     GIR_RootConstrainSelectedInstOperands,
     /*  89929 */     // GIR_Coverage, 3813,
     /*  89929 */     GIR_EraseRootFromParent_Done,
     /*  89930 */   // Label 1649: @89930
     /*  89930 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(90037), // Rule ID 3815 //
     /*  89935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89953 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89956 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89959 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89986 */     // MIs[1] Operand 1
     /*  89986 */     // No operand predicates
     /*  89986 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90008 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu32),
     /*  90011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90013 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90023 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90029 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90035 */     GIR_RootConstrainSelectedInstOperands,
     /*  90036 */     // GIR_Coverage, 3815,
     /*  90036 */     GIR_EraseRootFromParent_Done,
     /*  90037 */   // Label 1650: @90037
     /*  90037 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(90144), // Rule ID 3817 //
     /*  90042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90063 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90066 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90093 */     // MIs[1] Operand 1
     /*  90093 */     // No operand predicates
     /*  90093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90105 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90115 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu32),
     /*  90118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90120 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90142 */     GIR_RootConstrainSelectedInstOperands,
     /*  90143 */     // GIR_Coverage, 3817,
     /*  90143 */     GIR_EraseRootFromParent_Done,
     /*  90144 */   // Label 1651: @90144
     /*  90144 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(90251), // Rule ID 3819 //
     /*  90149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90170 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90173 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90200 */     // MIs[1] Operand 1
     /*  90200 */     // No operand predicates
     /*  90200 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90222 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16bh),
     /*  90225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90227 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90249 */     GIR_RootConstrainSelectedInstOperands,
     /*  90250 */     // GIR_Coverage, 3819,
     /*  90250 */     GIR_EraseRootFromParent_Done,
     /*  90251 */   // Label 1652: @90251
     /*  90251 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(90358), // Rule ID 3821 //
     /*  90256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90277 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90280 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90307 */     // MIs[1] Operand 1
     /*  90307 */     // No operand predicates
     /*  90307 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90329 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16th),
     /*  90332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90334 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90356 */     GIR_RootConstrainSelectedInstOperands,
     /*  90357 */     // GIR_Coverage, 3821,
     /*  90357 */     GIR_EraseRootFromParent_Done,
     /*  90358 */   // Label 1653: @90358
     /*  90358 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(90465), // Rule ID 3823 //
     /*  90363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90384 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90387 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90414 */     // MIs[1] Operand 1
     /*  90414 */     // No operand predicates
     /*  90414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90418 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90430 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90436 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32bh),
     /*  90439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90441 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90463 */     GIR_RootConstrainSelectedInstOperands,
     /*  90464 */     // GIR_Coverage, 3823,
     /*  90464 */     GIR_EraseRootFromParent_Done,
     /*  90465 */   // Label 1654: @90465
     /*  90465 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(90572), // Rule ID 3825 //
     /*  90470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90491 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90494 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90521 */     // MIs[1] Operand 1
     /*  90521 */     // No operand predicates
     /*  90521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90543 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32th),
     /*  90546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90548 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90570 */     GIR_RootConstrainSelectedInstOperands,
     /*  90571 */     // GIR_Coverage, 3825,
     /*  90571 */     GIR_EraseRootFromParent_Done,
     /*  90572 */   // Label 1655: @90572
     /*  90572 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(90679), // Rule ID 3827 //
     /*  90577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90598 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90601 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90628 */     // MIs[1] Operand 1
     /*  90628 */     // No operand predicates
     /*  90628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90650 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16bh),
     /*  90653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90655 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90665 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90677 */     GIR_RootConstrainSelectedInstOperands,
     /*  90678 */     // GIR_Coverage, 3827,
     /*  90678 */     GIR_EraseRootFromParent_Done,
     /*  90679 */   // Label 1656: @90679
     /*  90679 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(90786), // Rule ID 3829 //
     /*  90684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90705 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90708 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90735 */     // MIs[1] Operand 1
     /*  90735 */     // No operand predicates
     /*  90735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90757 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3713:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16th),
     /*  90760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90762 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90784 */     GIR_RootConstrainSelectedInstOperands,
     /*  90785 */     // GIR_Coverage, 3829,
     /*  90785 */     GIR_EraseRootFromParent_Done,
     /*  90786 */   // Label 1657: @90786
     /*  90786 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(90893), // Rule ID 3831 //
     /*  90791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90812 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90815 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90842 */     // MIs[1] Operand 1
     /*  90842 */     // No operand predicates
     /*  90842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90864 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32bh),
     /*  90867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90869 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90879 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90891 */     GIR_RootConstrainSelectedInstOperands,
     /*  90892 */     // GIR_Coverage, 3831,
     /*  90892 */     GIR_EraseRootFromParent_Done,
     /*  90893 */   // Label 1658: @90893
     /*  90893 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(91000), // Rule ID 3833 //
     /*  90898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90919 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90922 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90949 */     // MIs[1] Operand 1
     /*  90949 */     // No operand predicates
     /*  90949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90971 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3713:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32th),
     /*  90974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90976 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90998 */     GIR_RootConstrainSelectedInstOperands,
     /*  90999 */     // GIR_Coverage, 3833,
     /*  90999 */     GIR_EraseRootFromParent_Done,
     /*  91000 */   // Label 1659: @91000
     /*  91000 */   GIM_Reject,
     /*  91001 */ // Label 1619: @91001
     /*  91001 */ GIM_Reject,
     /*  91002 */ // Label 16: @91002
     /*  91002 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91059),
     /*  91007 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  91010 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_clrex),
     /*  91015 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91032), // Rule ID 245 //
     /*  91020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6K_IsARM),
     /*  91023 */     // (intrinsic_void 3499:{ *:[iPTR] })  =>  (CLREX)
     /*  91023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLREX),
     /*  91026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91030 */     GIR_RootConstrainSelectedInstOperands,
     /*  91031 */     // GIR_Coverage, 245,
     /*  91031 */     GIR_EraseRootFromParent_Done,
     /*  91032 */   // Label 1661: @91032
     /*  91032 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(91058), // Rule ID 574 //
     /*  91037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7Clrex_IsThumb),
     /*  91040 */     // (intrinsic_void 3499:{ *:[iPTR] })  =>  (t2CLREX)
     /*  91040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLREX),
     /*  91043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91056 */     GIR_RootConstrainSelectedInstOperands,
     /*  91057 */     // GIR_Coverage, 574,
     /*  91057 */     GIR_EraseRootFromParent_Done,
     /*  91058 */   // Label 1662: @91058
     /*  91058 */   GIM_Reject,
     /*  91059 */ // Label 1660: @91059
     /*  91059 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91861),
     /*  91064 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91067 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91103), // Rule ID 344 //
     /*  91072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsWindows),
     /*  91075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91080 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91083 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/1, GIMT_Encode8(249),
     /*  91094 */     // (intrinsic_void 3933:{ *:[iPTR] }, 249:{ *:[i32] })  =>  (t__brkdiv0)
     /*  91094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t__brkdiv0),
     /*  91097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91101 */     GIR_RootConstrainSelectedInstOperands,
     /*  91102 */     // GIR_Coverage, 344,
     /*  91102 */     GIR_EraseRootFromParent_Done,
     /*  91103 */   // Label 1664: @91103
     /*  91103 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91155), // Rule ID 2 //
     /*  91108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  91111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91116 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  91131 */     // MIs[1] Operand 1
     /*  91131 */     // No operand predicates
     /*  91131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91133 */     // (intrinsic_void 3517:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /*  91133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::HINT),
     /*  91136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91153 */     GIR_RootConstrainSelectedInstOperands,
     /*  91154 */     // GIR_Coverage, 2,
     /*  91154 */     GIR_EraseRootFromParent_Done,
     /*  91155 */   // Label 1665: @91155
     /*  91155 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(91207), // Rule ID 10 //
     /*  91160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7_IsARM),
     /*  91163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  91168 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91183 */     // MIs[1] Operand 1
     /*  91183 */     // No operand predicates
     /*  91183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91185 */     // (intrinsic_void 3512:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DBG (imm:{ *:[i32] }):$opt)
     /*  91185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DBG),
     /*  91188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91205 */     GIR_RootConstrainSelectedInstOperands,
     /*  91206 */     // GIR_Coverage, 10,
     /*  91206 */     GIR_EraseRootFromParent_Done,
     /*  91207 */   // Label 1666: @91207
     /*  91207 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(91250), // Rule ID 11 //
     /*  91212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  91215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91220 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91235 */     // MIs[1] Operand 1
     /*  91235 */     // No operand predicates
     /*  91235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91237 */     // (intrinsic_void 3933:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (UDF (imm:{ *:[i32] }):$imm16)
     /*  91237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /*  91240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91248 */     GIR_RootConstrainSelectedInstOperands,
     /*  91249 */     // GIR_Coverage, 11,
     /*  91249 */     GIR_EraseRootFromParent_Done,
     /*  91250 */   // Label 1667: @91250
     /*  91250 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(91293), // Rule ID 228 //
     /*  91255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91263 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91278 */     // MIs[1] Operand 1
     /*  91278 */     // No operand predicates
     /*  91278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91280 */     // (intrinsic_void 3513:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DMB (imm:{ *:[i32] }):$opt)
     /*  91280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DMB),
     /*  91283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91291 */     GIR_RootConstrainSelectedInstOperands,
     /*  91292 */     // GIR_Coverage, 228,
     /*  91292 */     GIR_EraseRootFromParent_Done,
     /*  91293 */   // Label 1668: @91293
     /*  91293 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(91336), // Rule ID 229 //
     /*  91298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91306 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91321 */     // MIs[1] Operand 1
     /*  91321 */     // No operand predicates
     /*  91321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91323 */     // (intrinsic_void 3514:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DSB (imm:{ *:[i32] }):$opt)
     /*  91323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DSB),
     /*  91326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91334 */     GIR_RootConstrainSelectedInstOperands,
     /*  91335 */     // GIR_Coverage, 229,
     /*  91335 */     GIR_EraseRootFromParent_Done,
     /*  91336 */   // Label 1669: @91336
     /*  91336 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(91379), // Rule ID 230 //
     /*  91341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91349 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91364 */     // MIs[1] Operand 1
     /*  91364 */     // No operand predicates
     /*  91364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91366 */     // (intrinsic_void 3518:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (ISB (imm:{ *:[i32] }):$opt)
     /*  91366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ISB),
     /*  91369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91377 */     GIR_RootConstrainSelectedInstOperands,
     /*  91378 */     // GIR_Coverage, 230,
     /*  91378 */     GIR_EraseRootFromParent_Done,
     /*  91379 */   // Label 1670: @91379
     /*  91379 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(91431), // Rule ID 276 //
     /*  91384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6M_IsThumb),
     /*  91387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91392 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91407 */     // MIs[1] Operand 1
     /*  91407 */     // No operand predicates
     /*  91407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91409 */     // (intrinsic_void 3517:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (tHINT (imm:{ *:[i32] }):$imm)
     /*  91409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tHINT),
     /*  91412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91429 */     GIR_RootConstrainSelectedInstOperands,
     /*  91430 */     // GIR_Coverage, 276,
     /*  91430 */     GIR_EraseRootFromParent_Done,
     /*  91431 */   // Label 1671: @91431
     /*  91431 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(91474), // Rule ID 343 //
     /*  91436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /*  91439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91444 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /*  91459 */     // MIs[1] Operand 1
     /*  91459 */     // No operand predicates
     /*  91459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91461 */     // (intrinsic_void 3933:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$imm8)  =>  (tUDF (imm:{ *:[i32] }):$imm8)
     /*  91461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /*  91464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*  91467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91472 */     GIR_RootConstrainSelectedInstOperands,
     /*  91473 */     // GIR_Coverage, 343,
     /*  91473 */     GIR_EraseRootFromParent_Done,
     /*  91474 */   // Label 1672: @91474
     /*  91474 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(91517), // Rule ID 494 //
     /*  91479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91487 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91502 */     // MIs[1] Operand 1
     /*  91502 */     // No operand predicates
     /*  91502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91504 */     // (intrinsic_void 3933:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (t2UDF (imm:{ *:[i32] }):$imm16)
     /*  91504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDF),
     /*  91507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91515 */     GIR_RootConstrainSelectedInstOperands,
     /*  91516 */     // GIR_Coverage, 494,
     /*  91516 */     GIR_EraseRootFromParent_Done,
     /*  91517 */   // Label 1673: @91517
     /*  91517 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(91569), // Rule ID 559 //
     /*  91522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  91525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91530 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91545 */     // MIs[1] Operand 1
     /*  91545 */     // No operand predicates
     /*  91545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91547 */     // (intrinsic_void 3513:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DMB (imm:{ *:[i32] }):$opt)
     /*  91547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DMB),
     /*  91550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91567 */     GIR_RootConstrainSelectedInstOperands,
     /*  91568 */     // GIR_Coverage, 559,
     /*  91568 */     GIR_EraseRootFromParent_Done,
     /*  91569 */   // Label 1674: @91569
     /*  91569 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(91621), // Rule ID 560 //
     /*  91574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  91577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91582 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91597 */     // MIs[1] Operand 1
     /*  91597 */     // No operand predicates
     /*  91597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91599 */     // (intrinsic_void 3514:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DSB (imm:{ *:[i32] }):$opt)
     /*  91599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DSB),
     /*  91602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91619 */     GIR_RootConstrainSelectedInstOperands,
     /*  91620 */     // GIR_Coverage, 560,
     /*  91620 */     GIR_EraseRootFromParent_Done,
     /*  91621 */   // Label 1675: @91621
     /*  91621 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(91673), // Rule ID 561 //
     /*  91626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  91629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91634 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91649 */     // MIs[1] Operand 1
     /*  91649 */     // No operand predicates
     /*  91649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91651 */     // (intrinsic_void 3518:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2ISB (imm:{ *:[i32] }):$opt)
     /*  91651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ISB),
     /*  91654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91671 */     GIR_RootConstrainSelectedInstOperands,
     /*  91672 */     // GIR_Coverage, 561,
     /*  91672 */     GIR_EraseRootFromParent_Done,
     /*  91673 */   // Label 1676: @91673
     /*  91673 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(91725), // Rule ID 579 //
     /*  91678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91686 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  91701 */     // MIs[1] Operand 1
     /*  91701 */     // No operand predicates
     /*  91701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91703 */     // (intrinsic_void 3517:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (t2HINT (imm:{ *:[i32] }):$imm)
     /*  91703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2HINT),
     /*  91706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91723 */     GIR_RootConstrainSelectedInstOperands,
     /*  91724 */     // GIR_Coverage, 579,
     /*  91724 */     GIR_EraseRootFromParent_Done,
     /*  91725 */   // Label 1677: @91725
     /*  91725 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(91777), // Rule ID 580 //
     /*  91730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  91738 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91753 */     // MIs[1] Operand 1
     /*  91753 */     // No operand predicates
     /*  91753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91755 */     // (intrinsic_void 3512:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DBG (imm:{ *:[i32] }):$opt)
     /*  91755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DBG),
     /*  91758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91775 */     GIR_RootConstrainSelectedInstOperands,
     /*  91776 */     // GIR_Coverage, 580,
     /*  91776 */     GIR_EraseRootFromParent_Done,
     /*  91777 */   // Label 1678: @91777
     /*  91777 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(91817), // Rule ID 722 //
     /*  91782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  91785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_get_fpscr),
     /*  91790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  91793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  91797 */     // (intrinsic_w_chain:{ *:[i32] } 3515:{ *:[iPTR] })  =>  (VMRS:{ *:[i32] })
     /*  91797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /*  91800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  91802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91815 */     GIR_RootConstrainSelectedInstOperands,
     /*  91816 */     // GIR_Coverage, 722,
     /*  91816 */     GIR_EraseRootFromParent_Done,
     /*  91817 */   // Label 1679: @91817
     /*  91817 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(91860), // Rule ID 723 //
     /*  91822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  91825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_set_fpscr),
     /*  91830 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  91837 */     // (intrinsic_void 3877:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /*  91837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /*  91840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  91842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /*  91854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91858 */     GIR_RootConstrainSelectedInstOperands,
     /*  91859 */     // GIR_Coverage, 723,
     /*  91859 */     GIR_EraseRootFromParent_Done,
     /*  91860 */   // Label 1680: @91860
     /*  91860 */   GIM_Reject,
     /*  91861 */ // Label 1663: @91861
     /*  91861 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(91904), // Rule ID 604 //
     /*  91866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLOB_HasV8_1MMainline_IsThumb2),
     /*  91869 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  91872 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::start_loop_iterations),
     /*  91877 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  91880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  91883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRlrRegClassID),
     /*  91887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  91891 */   // (intrinsic_w_chain:{ *:[i32] } 348:{ *:[iPTR] }, rGPR:{ *:[i32] }:$tc)  =>  (t2DoLoopStart:{ *:[i32] } rGPR:{ *:[i32] }:$tc)
     /*  91891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DoLoopStart),
     /*  91894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[X]
     /*  91896 */   GIR_RootToRootCopy, /*OpIdx*/2, // tc
     /*  91898 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91902 */   GIR_RootConstrainSelectedInstOperands,
     /*  91903 */   // GIR_Coverage, 604,
     /*  91903 */   GIR_EraseRootFromParent_Done,
     /*  91904 */ // Label 1681: @91904
     /*  91904 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(93895),
     /*  91909 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  91912 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(91966), // Rule ID 5048 //
     /*  91917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  91922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  91931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91947 */     // MIs[1] Operand 1
     /*  91947 */     // No operand predicates
     /*  91947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91949 */     // (intrinsic_w_chain:{ *:[v4i32] } 3648:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  91949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  91952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91954 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  91956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  91959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91964 */     GIR_RootConstrainSelectedInstOperands,
     /*  91965 */     // GIR_Coverage, 5048,
     /*  91965 */     GIR_EraseRootFromParent_Done,
     /*  91966 */   // Label 1683: @91966
     /*  91966 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92020), // Rule ID 5054 //
     /*  91971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  91976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  91985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92001 */     // MIs[1] Operand 1
     /*  92001 */     // No operand predicates
     /*  92001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92003 */     // (intrinsic_w_chain:{ *:[v4f32] } 3648:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92008 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92018 */     GIR_RootConstrainSelectedInstOperands,
     /*  92019 */     // GIR_Coverage, 5054,
     /*  92019 */     GIR_EraseRootFromParent_Done,
     /*  92020 */   // Label 1684: @92020
     /*  92020 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(92074), // Rule ID 5056 //
     /*  92025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92055 */     // MIs[1] Operand 1
     /*  92055 */     // No operand predicates
     /*  92055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92057 */     // (intrinsic_w_chain:{ *:[v2i64] } 3648:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92062 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92072 */     GIR_RootConstrainSelectedInstOperands,
     /*  92073 */     // GIR_Coverage, 5056,
     /*  92073 */     GIR_EraseRootFromParent_Done,
     /*  92074 */   // Label 1685: @92074
     /*  92074 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92128), // Rule ID 5058 //
     /*  92079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92109 */     // MIs[1] Operand 1
     /*  92109 */     // No operand predicates
     /*  92109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92111 */     // (intrinsic_w_chain:{ *:[v2f64] } 3648:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92116 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92126 */     GIR_RootConstrainSelectedInstOperands,
     /*  92127 */     // GIR_Coverage, 5058,
     /*  92127 */     GIR_EraseRootFromParent_Done,
     /*  92128 */   // Label 1686: @92128
     /*  92128 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(92170), // Rule ID 1738 //
     /*  92133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_space),
     /*  92138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92148 */     // MIs[0] size
     /*  92148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92155 */     // (intrinsic_w_chain:{ *:[i32] } 3908:{ *:[iPTR] }, (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)  =>  (SPACE:{ *:[i32] } (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)
     /*  92155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SPACE),
     /*  92158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92160 */     GIR_RootToRootCopy, /*OpIdx*/2, // size
     /*  92162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  92164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92168 */     GIR_RootConstrainSelectedInstOperands,
     /*  92169 */     // GIR_Coverage, 1738,
     /*  92169 */     GIR_EraseRootFromParent_Done,
     /*  92170 */   // Label 1687: @92170
     /*  92170 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(92224), // Rule ID 5050 //
     /*  92175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92180 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92201 */     // MIs[1] Operand 1
     /*  92201 */     // No operand predicates
     /*  92201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92207 */     // (intrinsic_void 3721:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92210 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92212 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92222 */     GIR_RootConstrainSelectedInstOperands,
     /*  92223 */     // GIR_Coverage, 5050,
     /*  92223 */     GIR_EraseRootFromParent_Done,
     /*  92224 */   // Label 1688: @92224
     /*  92224 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(92278), // Rule ID 5060 //
     /*  92229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92234 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92255 */     // MIs[1] Operand 1
     /*  92255 */     // No operand predicates
     /*  92255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92261 */     // (intrinsic_void 3721:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92264 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92266 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92276 */     GIR_RootConstrainSelectedInstOperands,
     /*  92277 */     // GIR_Coverage, 5060,
     /*  92277 */     GIR_EraseRootFromParent_Done,
     /*  92278 */   // Label 1689: @92278
     /*  92278 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(92332), // Rule ID 5064 //
     /*  92283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92288 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92309 */     // MIs[1] Operand 1
     /*  92309 */     // No operand predicates
     /*  92309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92315 */     // (intrinsic_void 3721:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92318 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92320 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92330 */     GIR_RootConstrainSelectedInstOperands,
     /*  92331 */     // GIR_Coverage, 5064,
     /*  92331 */     GIR_EraseRootFromParent_Done,
     /*  92332 */   // Label 1690: @92332
     /*  92332 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(92386), // Rule ID 5068 //
     /*  92337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92342 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92363 */     // MIs[1] Operand 1
     /*  92363 */     // No operand predicates
     /*  92363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92369 */     // (intrinsic_void 3721:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92372 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92374 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92384 */     GIR_RootConstrainSelectedInstOperands,
     /*  92385 */     // GIR_Coverage, 5068,
     /*  92385 */     GIR_EraseRootFromParent_Done,
     /*  92386 */   // Label 1691: @92386
     /*  92386 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(92444), // Rule ID 3 //
     /*  92391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  92394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  92399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92420 */     // (intrinsic_w_chain:{ *:[i32] } 3876:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  92420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SEL),
     /*  92423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92442 */     GIR_RootConstrainSelectedInstOperands,
     /*  92443 */     // GIR_Coverage, 3,
     /*  92443 */     GIR_EraseRootFromParent_Done,
     /*  92444 */   // Label 1692: @92444
     /*  92444 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(92502), // Rule ID 121 //
     /*  92449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  92457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92478 */     // (intrinsic_w_chain:{ *:[i32] } 3875:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SASX),
     /*  92481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92500 */     GIR_RootConstrainSelectedInstOperands,
     /*  92501 */     // GIR_Coverage, 121,
     /*  92501 */     GIR_EraseRootFromParent_Done,
     /*  92502 */   // Label 1693: @92502
     /*  92502 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(92560), // Rule ID 122 //
     /*  92507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  92515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92536 */     // (intrinsic_w_chain:{ *:[i32] } 3873:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD16),
     /*  92539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92558 */     GIR_RootConstrainSelectedInstOperands,
     /*  92559 */     // GIR_Coverage, 122,
     /*  92559 */     GIR_EraseRootFromParent_Done,
     /*  92560 */   // Label 1694: @92560
     /*  92560 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(92618), // Rule ID 123 //
     /*  92565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  92573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92594 */     // (intrinsic_w_chain:{ *:[i32] } 3874:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD8),
     /*  92597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92616 */     GIR_RootConstrainSelectedInstOperands,
     /*  92617 */     // GIR_Coverage, 123,
     /*  92617 */     GIR_EraseRootFromParent_Done,
     /*  92618 */   // Label 1695: @92618
     /*  92618 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(92676), // Rule ID 124 //
     /*  92623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  92631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92652 */     // (intrinsic_w_chain:{ *:[i32] } 3911:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSAX),
     /*  92655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92674 */     GIR_RootConstrainSelectedInstOperands,
     /*  92675 */     // GIR_Coverage, 124,
     /*  92675 */     GIR_EraseRootFromParent_Done,
     /*  92676 */   // Label 1696: @92676
     /*  92676 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(92734), // Rule ID 125 //
     /*  92681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  92689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92710 */     // (intrinsic_w_chain:{ *:[i32] } 3912:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB16),
     /*  92713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92732 */     GIR_RootConstrainSelectedInstOperands,
     /*  92733 */     // GIR_Coverage, 125,
     /*  92733 */     GIR_EraseRootFromParent_Done,
     /*  92734 */   // Label 1697: @92734
     /*  92734 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(92792), // Rule ID 126 //
     /*  92739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  92747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92768 */     // (intrinsic_w_chain:{ *:[i32] } 3913:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB8),
     /*  92771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92790 */     GIR_RootConstrainSelectedInstOperands,
     /*  92791 */     // GIR_Coverage, 126,
     /*  92791 */     GIR_EraseRootFromParent_Done,
     /*  92792 */   // Label 1698: @92792
     /*  92792 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(92850), // Rule ID 127 //
     /*  92797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  92805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92826 */     // (intrinsic_w_chain:{ *:[i32] } 3926:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UASX),
     /*  92829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92838 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92848 */     GIR_RootConstrainSelectedInstOperands,
     /*  92849 */     // GIR_Coverage, 127,
     /*  92849 */     GIR_EraseRootFromParent_Done,
     /*  92850 */   // Label 1699: @92850
     /*  92850 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(92908), // Rule ID 128 //
     /*  92855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  92863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92884 */     // (intrinsic_w_chain:{ *:[i32] } 3924:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD16),
     /*  92887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92906 */     GIR_RootConstrainSelectedInstOperands,
     /*  92907 */     // GIR_Coverage, 128,
     /*  92907 */     GIR_EraseRootFromParent_Done,
     /*  92908 */   // Label 1700: @92908
     /*  92908 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(92966), // Rule ID 129 //
     /*  92913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  92921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92942 */     // (intrinsic_w_chain:{ *:[i32] } 3925:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD8),
     /*  92945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92964 */     GIR_RootConstrainSelectedInstOperands,
     /*  92965 */     // GIR_Coverage, 129,
     /*  92965 */     GIR_EraseRootFromParent_Done,
     /*  92966 */   // Label 1701: @92966
     /*  92966 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(93024), // Rule ID 130 //
     /*  92971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  92979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93000 */     // (intrinsic_w_chain:{ *:[i32] } 3944:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAX),
     /*  93003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93022 */     GIR_RootConstrainSelectedInstOperands,
     /*  93023 */     // GIR_Coverage, 130,
     /*  93023 */     GIR_EraseRootFromParent_Done,
     /*  93024 */   // Label 1702: @93024
     /*  93024 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(93082), // Rule ID 131 //
     /*  93029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  93037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93058 */     // (intrinsic_w_chain:{ *:[i32] } 3945:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB16),
     /*  93061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93080 */     GIR_RootConstrainSelectedInstOperands,
     /*  93081 */     // GIR_Coverage, 131,
     /*  93081 */     GIR_EraseRootFromParent_Done,
     /*  93082 */   // Label 1703: @93082
     /*  93082 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(93140), // Rule ID 132 //
     /*  93087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  93095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93116 */     // (intrinsic_w_chain:{ *:[i32] } 3946:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB8),
     /*  93119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93128 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93138 */     GIR_RootConstrainSelectedInstOperands,
     /*  93139 */     // GIR_Coverage, 132,
     /*  93139 */     GIR_EraseRootFromParent_Done,
     /*  93140 */   // Label 1704: @93140
     /*  93140 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(93198), // Rule ID 431 //
     /*  93145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  93153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93174 */     // (intrinsic_w_chain:{ *:[i32] } 3876:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (t2SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  93174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SEL),
     /*  93177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93196 */     GIR_RootConstrainSelectedInstOperands,
     /*  93197 */     // GIR_Coverage, 431,
     /*  93197 */     GIR_EraseRootFromParent_Done,
     /*  93198 */   // Label 1705: @93198
     /*  93198 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(93256), // Rule ID 444 //
     /*  93203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  93211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93232 */     // (intrinsic_w_chain:{ *:[i32] } 3875:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SASX),
     /*  93235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93254 */     GIR_RootConstrainSelectedInstOperands,
     /*  93255 */     // GIR_Coverage, 444,
     /*  93255 */     GIR_EraseRootFromParent_Done,
     /*  93256 */   // Label 1706: @93256
     /*  93256 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(93314), // Rule ID 445 //
     /*  93261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93290 */     // (intrinsic_w_chain:{ *:[i32] } 3873:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD16),
     /*  93293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93312 */     GIR_RootConstrainSelectedInstOperands,
     /*  93313 */     // GIR_Coverage, 445,
     /*  93313 */     GIR_EraseRootFromParent_Done,
     /*  93314 */   // Label 1707: @93314
     /*  93314 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(93372), // Rule ID 446 //
     /*  93319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93348 */     // (intrinsic_w_chain:{ *:[i32] } 3874:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD8),
     /*  93351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93370 */     GIR_RootConstrainSelectedInstOperands,
     /*  93371 */     // GIR_Coverage, 446,
     /*  93371 */     GIR_EraseRootFromParent_Done,
     /*  93372 */   // Label 1708: @93372
     /*  93372 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(93430), // Rule ID 447 //
     /*  93377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93406 */     // (intrinsic_w_chain:{ *:[i32] } 3911:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSAX),
     /*  93409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93428 */     GIR_RootConstrainSelectedInstOperands,
     /*  93429 */     // GIR_Coverage, 447,
     /*  93429 */     GIR_EraseRootFromParent_Done,
     /*  93430 */   // Label 1709: @93430
     /*  93430 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(93488), // Rule ID 448 //
     /*  93435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93464 */     // (intrinsic_w_chain:{ *:[i32] } 3912:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB16),
     /*  93467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93486 */     GIR_RootConstrainSelectedInstOperands,
     /*  93487 */     // GIR_Coverage, 448,
     /*  93487 */     GIR_EraseRootFromParent_Done,
     /*  93488 */   // Label 1710: @93488
     /*  93488 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(93546), // Rule ID 449 //
     /*  93493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93522 */     // (intrinsic_w_chain:{ *:[i32] } 3913:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB8),
     /*  93525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93544 */     GIR_RootConstrainSelectedInstOperands,
     /*  93545 */     // GIR_Coverage, 449,
     /*  93545 */     GIR_EraseRootFromParent_Done,
     /*  93546 */   // Label 1711: @93546
     /*  93546 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(93604), // Rule ID 450 //
     /*  93551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  93559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93580 */     // (intrinsic_w_chain:{ *:[i32] } 3926:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UASX),
     /*  93583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93602 */     GIR_RootConstrainSelectedInstOperands,
     /*  93603 */     // GIR_Coverage, 450,
     /*  93603 */     GIR_EraseRootFromParent_Done,
     /*  93604 */   // Label 1712: @93604
     /*  93604 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(93662), // Rule ID 451 //
     /*  93609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  93617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93638 */     // (intrinsic_w_chain:{ *:[i32] } 3924:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD16),
     /*  93641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93660 */     GIR_RootConstrainSelectedInstOperands,
     /*  93661 */     // GIR_Coverage, 451,
     /*  93661 */     GIR_EraseRootFromParent_Done,
     /*  93662 */   // Label 1713: @93662
     /*  93662 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(93720), // Rule ID 452 //
     /*  93667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  93675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93696 */     // (intrinsic_w_chain:{ *:[i32] } 3925:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD8),
     /*  93699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93718 */     GIR_RootConstrainSelectedInstOperands,
     /*  93719 */     // GIR_Coverage, 452,
     /*  93719 */     GIR_EraseRootFromParent_Done,
     /*  93720 */   // Label 1714: @93720
     /*  93720 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(93778), // Rule ID 453 //
     /*  93725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  93733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93754 */     // (intrinsic_w_chain:{ *:[i32] } 3944:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAX),
     /*  93757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93776 */     GIR_RootConstrainSelectedInstOperands,
     /*  93777 */     // GIR_Coverage, 453,
     /*  93777 */     GIR_EraseRootFromParent_Done,
     /*  93778 */   // Label 1715: @93778
     /*  93778 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(93836), // Rule ID 454 //
     /*  93783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  93791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93812 */     // (intrinsic_w_chain:{ *:[i32] } 3945:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB16),
     /*  93815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93834 */     GIR_RootConstrainSelectedInstOperands,
     /*  93835 */     // GIR_Coverage, 454,
     /*  93835 */     GIR_EraseRootFromParent_Done,
     /*  93836 */   // Label 1716: @93836
     /*  93836 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(93894), // Rule ID 455 //
     /*  93841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  93849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93870 */     // (intrinsic_w_chain:{ *:[i32] } 3946:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB8),
     /*  93873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93892 */     GIR_RootConstrainSelectedInstOperands,
     /*  93893 */     // GIR_Coverage, 455,
     /*  93893 */     GIR_EraseRootFromParent_Done,
     /*  93894 */   // Label 1717: @93894
     /*  93894 */   GIM_Reject,
     /*  93895 */ // Label 1682: @93895
     /*  93895 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(94141),
     /*  93900 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  93903 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base_wb),
     /*  93908 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(93966), // Rule ID 5052 //
     /*  93913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  93925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  93929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  93933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93941 */     // MIs[1] Operand 1
     /*  93941 */     // No operand predicates
     /*  93941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  93945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93947 */     // (intrinsic_w_chain:{ *:[v4i32] } 3723:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  93947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  93950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  93952 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  93954 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  93956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  93959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93964 */     GIR_RootConstrainSelectedInstOperands,
     /*  93965 */     // GIR_Coverage, 5052,
     /*  93965 */     GIR_EraseRootFromParent_Done,
     /*  93966 */   // Label 1719: @93966
     /*  93966 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(94024), // Rule ID 5062 //
     /*  93971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  93983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  93987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  93991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93999 */     // MIs[1] Operand 1
     /*  93999 */     // No operand predicates
     /*  93999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94005 */     // (intrinsic_w_chain:{ *:[v4i32] } 3723:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94010 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94012 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94022 */     GIR_RootConstrainSelectedInstOperands,
     /*  94023 */     // GIR_Coverage, 5062,
     /*  94023 */     GIR_EraseRootFromParent_Done,
     /*  94024 */   // Label 1720: @94024
     /*  94024 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(94082), // Rule ID 5066 //
     /*  94029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94057 */     // MIs[1] Operand 1
     /*  94057 */     // No operand predicates
     /*  94057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94063 */     // (intrinsic_w_chain:{ *:[v2i64] } 3723:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94068 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94070 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94080 */     GIR_RootConstrainSelectedInstOperands,
     /*  94081 */     // GIR_Coverage, 5066,
     /*  94081 */     GIR_EraseRootFromParent_Done,
     /*  94082 */   // Label 1721: @94082
     /*  94082 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(94140), // Rule ID 5070 //
     /*  94087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94115 */     // MIs[1] Operand 1
     /*  94115 */     // No operand predicates
     /*  94115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94121 */     // (intrinsic_w_chain:{ *:[v2i64] } 3723:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94126 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94128 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94138 */     GIR_RootConstrainSelectedInstOperands,
     /*  94139 */     // GIR_Coverage, 5070,
     /*  94139 */     GIR_EraseRootFromParent_Done,
     /*  94140 */   // Label 1722: @94140
     /*  94140 */   GIM_Reject,
     /*  94141 */ // Label 1718: @94141
     /*  94141 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(95312),
     /*  94146 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  94149 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(94210), // Rule ID 4940 //
     /*  94154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94171 */     // MIs[0] base
     /*  94171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94195 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94198 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94200 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94202 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94208 */     GIR_RootConstrainSelectedInstOperands,
     /*  94209 */     // GIR_Coverage, 4940,
     /*  94209 */     GIR_EraseRootFromParent_Done,
     /*  94210 */   // Label 1724: @94210
     /*  94210 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(94271), // Rule ID 4941 //
     /*  94215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94232 */     // MIs[0] base
     /*  94232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94256 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94259 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94261 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94263 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94269 */     GIR_RootConstrainSelectedInstOperands,
     /*  94270 */     // GIR_Coverage, 4941,
     /*  94270 */     GIR_EraseRootFromParent_Done,
     /*  94271 */   // Label 1725: @94271
     /*  94271 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(94332), // Rule ID 4944 //
     /*  94276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  94284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94293 */     // MIs[0] base
     /*  94293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94317 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, MQPR:{ *:[v16i8] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB8_rq MQPR:{ *:[v16i8] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  94317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB8_rq),
     /*  94320 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94322 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94324 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94330 */     GIR_RootConstrainSelectedInstOperands,
     /*  94331 */     // GIR_Coverage, 4944,
     /*  94331 */     GIR_EraseRootFromParent_Done,
     /*  94332 */   // Label 1726: @94332
     /*  94332 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(94393), // Rule ID 5024 //
     /*  94337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94354 */     // MIs[0] base
     /*  94354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94370 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94378 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB16_rq),
     /*  94381 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94383 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94385 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94391 */     GIR_RootConstrainSelectedInstOperands,
     /*  94392 */     // GIR_Coverage, 5024,
     /*  94392 */     GIR_EraseRootFromParent_Done,
     /*  94393 */   // Label 1727: @94393
     /*  94393 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(94454), // Rule ID 5026 //
     /*  94398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94415 */     // MIs[0] base
     /*  94415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94439 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB32_rq),
     /*  94442 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94444 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94446 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94452 */     GIR_RootConstrainSelectedInstOperands,
     /*  94453 */     // GIR_Coverage, 5026,
     /*  94453 */     GIR_EraseRootFromParent_Done,
     /*  94454 */   // Label 1728: @94454
     /*  94454 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(94515), // Rule ID 5028 //
     /*  94459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94476 */     // MIs[0] base
     /*  94476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94496 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94500 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94503 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94505 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94507 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94513 */     GIR_RootConstrainSelectedInstOperands,
     /*  94514 */     // GIR_Coverage, 5028,
     /*  94514 */     GIR_EraseRootFromParent_Done,
     /*  94515 */   // Label 1729: @94515
     /*  94515 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(94576), // Rule ID 5029 //
     /*  94520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94537 */     // MIs[0] base
     /*  94537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94561 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94564 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94566 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94568 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94574 */     GIR_RootConstrainSelectedInstOperands,
     /*  94575 */     // GIR_Coverage, 5029,
     /*  94575 */     GIR_EraseRootFromParent_Done,
     /*  94576 */   // Label 1730: @94576
     /*  94576 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(94637), // Rule ID 5032 //
     /*  94581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94598 */     // MIs[0] base
     /*  94598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94618 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94622 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq_u),
     /*  94625 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94627 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94629 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94635 */     GIR_RootConstrainSelectedInstOperands,
     /*  94636 */     // GIR_Coverage, 5032,
     /*  94636 */     GIR_EraseRootFromParent_Done,
     /*  94637 */   // Label 1731: @94637
     /*  94637 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(94698), // Rule ID 5033 //
     /*  94642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94659 */     // MIs[0] base
     /*  94659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94675 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94679 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94683 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq),
     /*  94686 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94688 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94690 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94696 */     GIR_RootConstrainSelectedInstOperands,
     /*  94697 */     // GIR_Coverage, 5033,
     /*  94697 */     GIR_EraseRootFromParent_Done,
     /*  94698 */   // Label 1732: @94698
     /*  94698 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(94759), // Rule ID 5036 //
     /*  94703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94720 */     // MIs[0] base
     /*  94720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  94740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94744 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  94747 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94749 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94751 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94757 */     GIR_RootConstrainSelectedInstOperands,
     /*  94758 */     // GIR_Coverage, 5036,
     /*  94758 */     GIR_EraseRootFromParent_Done,
     /*  94759 */   // Label 1733: @94759
     /*  94759 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(94820), // Rule ID 5037 //
     /*  94764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94781 */     // MIs[0] base
     /*  94781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  94801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  94805 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  94808 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94810 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94812 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94818 */     GIR_RootConstrainSelectedInstOperands,
     /*  94819 */     // GIR_Coverage, 5037,
     /*  94819 */     GIR_EraseRootFromParent_Done,
     /*  94820 */   // Label 1734: @94820
     /*  94820 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(94881), // Rule ID 5040 //
     /*  94825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94842 */     // MIs[0] base
     /*  94842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  94862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94866 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  94869 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94871 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94873 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94879 */     GIR_RootConstrainSelectedInstOperands,
     /*  94880 */     // GIR_Coverage, 5040,
     /*  94880 */     GIR_EraseRootFromParent_Done,
     /*  94881 */   // Label 1735: @94881
     /*  94881 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(94942), // Rule ID 5041 //
     /*  94886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94903 */     // MIs[0] base
     /*  94903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  94923 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  94927 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  94930 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94932 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94934 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94940 */     GIR_RootConstrainSelectedInstOperands,
     /*  94941 */     // GIR_Coverage, 5041,
     /*  94941 */     GIR_EraseRootFromParent_Done,
     /*  94942 */   // Label 1736: @94942
     /*  94942 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(95003), // Rule ID 5044 //
     /*  94947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94964 */     // MIs[0] base
     /*  94964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  94984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94988 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRD64_rq_u MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  94988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq_u),
     /*  94991 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94993 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94995 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95001 */     GIR_RootConstrainSelectedInstOperands,
     /*  95002 */     // GIR_Coverage, 5044,
     /*  95002 */     GIR_EraseRootFromParent_Done,
     /*  95003 */   // Label 1737: @95003
     /*  95003 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(95064), // Rule ID 5045 //
     /*  95008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95025 */     // MIs[0] base
     /*  95025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  95049 */     // (intrinsic_void 3725:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 3:{ *:[i32] })  =>  (MVE_VSTRD64_rq MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq),
     /*  95052 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95054 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95056 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95062 */     GIR_RootConstrainSelectedInstOperands,
     /*  95063 */     // GIR_Coverage, 5045,
     /*  95063 */     GIR_EraseRootFromParent_Done,
     /*  95064 */   // Label 1738: @95064
     /*  95064 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(95128), // Rule ID 258 //
     /*  95069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  95072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95083 */     // MIs[0] cop
     /*  95083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95086 */     // MIs[0] opc1
     /*  95086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95097 */     // MIs[0] CRm
     /*  95097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95100 */     // (intrinsic_void 3529:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR),
     /*  95103 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95105 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95111 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95126 */     GIR_RootConstrainSelectedInstOperands,
     /*  95127 */     // GIR_Coverage, 258,
     /*  95127 */     GIR_EraseRootFromParent_Done,
     /*  95128 */   // Label 1739: @95128
     /*  95128 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(95183), // Rule ID 259 //
     /*  95133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95147 */     // MIs[0] cop
     /*  95147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95150 */     // MIs[0] opc1
     /*  95150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95161 */     // MIs[0] CRm
     /*  95161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95164 */     // (intrinsic_void 3530:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR2),
     /*  95167 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95169 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95175 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95181 */     GIR_RootConstrainSelectedInstOperands,
     /*  95182 */     // GIR_Coverage, 259,
     /*  95182 */     GIR_EraseRootFromParent_Done,
     /*  95183 */   // Label 1740: @95183
     /*  95183 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(95247), // Rule ID 596 //
     /*  95188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  95191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95202 */     // MIs[0] cop
     /*  95202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95205 */     // MIs[0] opc1
     /*  95205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95216 */     // MIs[0] CRm
     /*  95216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95219 */     // (intrinsic_void 3529:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR),
     /*  95222 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95224 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95230 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95245 */     GIR_RootConstrainSelectedInstOperands,
     /*  95246 */     // GIR_Coverage, 596,
     /*  95246 */     GIR_EraseRootFromParent_Done,
     /*  95247 */   // Label 1741: @95247
     /*  95247 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(95311), // Rule ID 597 //
     /*  95252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95266 */     // MIs[0] cop
     /*  95266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95269 */     // MIs[0] opc1
     /*  95269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95280 */     // MIs[0] CRm
     /*  95280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95283 */     // (intrinsic_void 3530:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR2),
     /*  95286 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95288 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95294 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95309 */     GIR_RootConstrainSelectedInstOperands,
     /*  95310 */     // GIR_Coverage, 597,
     /*  95310 */     GIR_EraseRootFromParent_Done,
     /*  95311 */   // Label 1742: @95311
     /*  95311 */   GIM_Reject,
     /*  95312 */ // Label 1723: @95312
     /*  95312 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(98663),
     /*  95317 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  95320 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(95381), // Rule ID 246 //
     /*  95325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95333 */     // MIs[0] cop
     /*  95333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95336 */     // MIs[0] opc1
     /*  95336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95339 */     // MIs[0] CRd
     /*  95339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95342 */     // MIs[0] CRn
     /*  95342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95345 */     // MIs[0] CRm
     /*  95345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95348 */     // MIs[0] opc2
     /*  95348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95351 */     // (intrinsic_void 3497:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP),
     /*  95354 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95356 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95358 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95360 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95362 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95364 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95379 */     GIR_RootConstrainSelectedInstOperands,
     /*  95380 */     // GIR_Coverage, 246,
     /*  95380 */     GIR_EraseRootFromParent_Done,
     /*  95381 */   // Label 1744: @95381
     /*  95381 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(95433), // Rule ID 247 //
     /*  95386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95394 */     // MIs[0] cop
     /*  95394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95397 */     // MIs[0] opc1
     /*  95397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95400 */     // MIs[0] CRd
     /*  95400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95403 */     // MIs[0] CRn
     /*  95403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95406 */     // MIs[0] CRm
     /*  95406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95409 */     // MIs[0] opc2
     /*  95409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95412 */     // (intrinsic_void 3498:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP2),
     /*  95415 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95417 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95419 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95421 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95423 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95425 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95431 */     GIR_RootConstrainSelectedInstOperands,
     /*  95432 */     // GIR_Coverage, 247,
     /*  95432 */     GIR_EraseRootFromParent_Done,
     /*  95433 */   // Label 1745: @95433
     /*  95433 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(95494), // Rule ID 598 //
     /*  95438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95446 */     // MIs[0] cop
     /*  95446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95449 */     // MIs[0] opc1
     /*  95449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95452 */     // MIs[0] CRd
     /*  95452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95455 */     // MIs[0] CRn
     /*  95455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95458 */     // MIs[0] CRm
     /*  95458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95461 */     // MIs[0] opc2
     /*  95461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95464 */     // (intrinsic_void 3497:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP),
     /*  95467 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95469 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95471 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95473 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95475 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95477 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95492 */     GIR_RootConstrainSelectedInstOperands,
     /*  95493 */     // GIR_Coverage, 598,
     /*  95493 */     GIR_EraseRootFromParent_Done,
     /*  95494 */   // Label 1746: @95494
     /*  95494 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(95555), // Rule ID 599 //
     /*  95499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95507 */     // MIs[0] cop
     /*  95507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95510 */     // MIs[0] opc1
     /*  95510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95513 */     // MIs[0] CRd
     /*  95513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95516 */     // MIs[0] CRn
     /*  95516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95519 */     // MIs[0] CRm
     /*  95519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95522 */     // MIs[0] opc2
     /*  95522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95525 */     // (intrinsic_void 3498:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP2),
     /*  95528 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95530 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95532 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95534 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95536 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95538 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95553 */     GIR_RootConstrainSelectedInstOperands,
     /*  95554 */     // GIR_Coverage, 599,
     /*  95554 */     GIR_EraseRootFromParent_Done,
     /*  95555 */   // Label 1747: @95555
     /*  95555 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(95623), // Rule ID 4934 //
     /*  95560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  95568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95584 */     // MIs[0] base
     /*  95584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  95608 */     // (intrinsic_w_chain:{ *:[v8i16] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  95611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95613 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95615 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95621 */     GIR_RootConstrainSelectedInstOperands,
     /*  95622 */     // GIR_Coverage, 4934,
     /*  95622 */     GIR_EraseRootFromParent_Done,
     /*  95623 */   // Label 1748: @95623
     /*  95623 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(95691), // Rule ID 4935 //
     /*  95628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  95636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95652 */     // MIs[0] base
     /*  95652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  95676 */     // (intrinsic_w_chain:{ *:[v8i16] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  95679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95681 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95683 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95689 */     GIR_RootConstrainSelectedInstOperands,
     /*  95690 */     // GIR_Coverage, 4935,
     /*  95690 */     GIR_EraseRootFromParent_Done,
     /*  95691 */   // Label 1749: @95691
     /*  95691 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(95759), // Rule ID 4938 //
     /*  95696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  95704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  95707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95720 */     // MIs[0] base
     /*  95720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  95736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  95744 */     // (intrinsic_w_chain:{ *:[v16i8] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  95744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  95747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95749 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95751 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95757 */     GIR_RootConstrainSelectedInstOperands,
     /*  95758 */     // GIR_Coverage, 4938,
     /*  95758 */     GIR_EraseRootFromParent_Done,
     /*  95759 */   // Label 1750: @95759
     /*  95759 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(95827), // Rule ID 4946 //
     /*  95764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  95772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  95775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95788 */     // MIs[0] base
     /*  95788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  95804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  95812 */     // (intrinsic_w_chain:{ *:[v16i8] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  95812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  95815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95817 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95819 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95825 */     GIR_RootConstrainSelectedInstOperands,
     /*  95826 */     // GIR_Coverage, 4946,
     /*  95826 */     GIR_EraseRootFromParent_Done,
     /*  95827 */   // Label 1751: @95827
     /*  95827 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(95895), // Rule ID 4948 //
     /*  95832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  95840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95856 */     // MIs[0] base
     /*  95856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  95872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  95880 */     // (intrinsic_w_chain:{ *:[v8i16] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU16_rq),
     /*  95883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95885 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95887 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95893 */     GIR_RootConstrainSelectedInstOperands,
     /*  95894 */     // GIR_Coverage, 4948,
     /*  95894 */     GIR_EraseRootFromParent_Done,
     /*  95895 */   // Label 1752: @95895
     /*  95895 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(95963), // Rule ID 4950 //
     /*  95900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  95908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95924 */     // MIs[0] base
     /*  95924 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  95940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  95948 */     // (intrinsic_w_chain:{ *:[v8i16] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS16_rq),
     /*  95951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  95953 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  95955 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  95957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95961 */     GIR_RootConstrainSelectedInstOperands,
     /*  95962 */     // GIR_Coverage, 4950,
     /*  95962 */     GIR_EraseRootFromParent_Done,
     /*  95963 */   // Label 1753: @95963
     /*  95963 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(96031), // Rule ID 4952 //
     /*  95968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  95973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  95988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95992 */     // MIs[0] base
     /*  95992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  95996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96016 */     // (intrinsic_w_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU32_rq),
     /*  96019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96021 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96023 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96029 */     GIR_RootConstrainSelectedInstOperands,
     /*  96030 */     // GIR_Coverage, 4952,
     /*  96030 */     GIR_EraseRootFromParent_Done,
     /*  96031 */   // Label 1754: @96031
     /*  96031 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(96099), // Rule ID 4954 //
     /*  96036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96060 */     // MIs[0] base
     /*  96060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96084 */     // (intrinsic_w_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS32_rq),
     /*  96087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96089 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96091 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96097 */     GIR_RootConstrainSelectedInstOperands,
     /*  96098 */     // GIR_Coverage, 4954,
     /*  96098 */     GIR_EraseRootFromParent_Done,
     /*  96099 */   // Label 1755: @96099
     /*  96099 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(96167), // Rule ID 4956 //
     /*  96104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96128 */     // MIs[0] base
     /*  96128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96144 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96152 */     // (intrinsic_w_chain:{ *:[v8i16] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96157 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96159 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96165 */     GIR_RootConstrainSelectedInstOperands,
     /*  96166 */     // GIR_Coverage, 4956,
     /*  96166 */     GIR_EraseRootFromParent_Done,
     /*  96167 */   // Label 1756: @96167
     /*  96167 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(96235), // Rule ID 4957 //
     /*  96172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96196 */     // MIs[0] base
     /*  96196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96216 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96220 */     // (intrinsic_w_chain:{ *:[v8i16] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96225 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96227 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96233 */     GIR_RootConstrainSelectedInstOperands,
     /*  96234 */     // GIR_Coverage, 4957,
     /*  96234 */     GIR_EraseRootFromParent_Done,
     /*  96235 */   // Label 1757: @96235
     /*  96235 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(96303), // Rule ID 4960 //
     /*  96240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96264 */     // MIs[0] base
     /*  96264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96288 */     // (intrinsic_w_chain:{ *:[v8i16] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96293 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96295 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96301 */     GIR_RootConstrainSelectedInstOperands,
     /*  96302 */     // GIR_Coverage, 4960,
     /*  96302 */     GIR_EraseRootFromParent_Done,
     /*  96303 */   // Label 1758: @96303
     /*  96303 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(96371), // Rule ID 4961 //
     /*  96308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96332 */     // MIs[0] base
     /*  96332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96348 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96356 */     // (intrinsic_w_chain:{ *:[v8i16] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96361 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96363 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96369 */     GIR_RootConstrainSelectedInstOperands,
     /*  96370 */     // GIR_Coverage, 4961,
     /*  96370 */     GIR_EraseRootFromParent_Done,
     /*  96371 */   // Label 1759: @96371
     /*  96371 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(96439), // Rule ID 4964 //
     /*  96376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96400 */     // MIs[0] base
     /*  96400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96424 */     // (intrinsic_w_chain:{ *:[v8i16] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96429 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96431 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96437 */     GIR_RootConstrainSelectedInstOperands,
     /*  96438 */     // GIR_Coverage, 4964,
     /*  96438 */     GIR_EraseRootFromParent_Done,
     /*  96439 */   // Label 1760: @96439
     /*  96439 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(96507), // Rule ID 4965 //
     /*  96444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96468 */     // MIs[0] base
     /*  96468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96492 */     // (intrinsic_w_chain:{ *:[v8i16] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96497 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96499 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96505 */     GIR_RootConstrainSelectedInstOperands,
     /*  96506 */     // GIR_Coverage, 4965,
     /*  96506 */     GIR_EraseRootFromParent_Done,
     /*  96507 */   // Label 1761: @96507
     /*  96507 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(96575), // Rule ID 4968 //
     /*  96512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96536 */     // MIs[0] base
     /*  96536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96560 */     // (intrinsic_w_chain:{ *:[v8f16] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96565 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96567 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96573 */     GIR_RootConstrainSelectedInstOperands,
     /*  96574 */     // GIR_Coverage, 4968,
     /*  96574 */     GIR_EraseRootFromParent_Done,
     /*  96575 */   // Label 1762: @96575
     /*  96575 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(96643), // Rule ID 4969 //
     /*  96580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96604 */     // MIs[0] base
     /*  96604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96624 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96628 */     // (intrinsic_w_chain:{ *:[v8f16] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96633 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96635 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96641 */     GIR_RootConstrainSelectedInstOperands,
     /*  96642 */     // GIR_Coverage, 4969,
     /*  96642 */     GIR_EraseRootFromParent_Done,
     /*  96643 */   // Label 1763: @96643
     /*  96643 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(96711), // Rule ID 4972 //
     /*  96648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96672 */     // MIs[0] base
     /*  96672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96696 */     // (intrinsic_w_chain:{ *:[v8f16] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96701 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96703 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96709 */     GIR_RootConstrainSelectedInstOperands,
     /*  96710 */     // GIR_Coverage, 4972,
     /*  96710 */     GIR_EraseRootFromParent_Done,
     /*  96711 */   // Label 1764: @96711
     /*  96711 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(96779), // Rule ID 4973 //
     /*  96716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96740 */     // MIs[0] base
     /*  96740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96752 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96764 */     // (intrinsic_w_chain:{ *:[v8f16] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96769 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96771 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96777 */     GIR_RootConstrainSelectedInstOperands,
     /*  96778 */     // GIR_Coverage, 4973,
     /*  96778 */     GIR_EraseRootFromParent_Done,
     /*  96779 */   // Label 1765: @96779
     /*  96779 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(96847), // Rule ID 4976 //
     /*  96784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96808 */     // MIs[0] base
     /*  96808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96832 */     // (intrinsic_w_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq_u),
     /*  96835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96837 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96839 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96845 */     GIR_RootConstrainSelectedInstOperands,
     /*  96846 */     // GIR_Coverage, 4976,
     /*  96846 */     GIR_EraseRootFromParent_Done,
     /*  96847 */   // Label 1766: @96847
     /*  96847 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(96915), // Rule ID 4977 //
     /*  96852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96876 */     // MIs[0] base
     /*  96876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96900 */     // (intrinsic_w_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq),
     /*  96903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96905 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96907 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96913 */     GIR_RootConstrainSelectedInstOperands,
     /*  96914 */     // GIR_Coverage, 4977,
     /*  96914 */     GIR_EraseRootFromParent_Done,
     /*  96915 */   // Label 1767: @96915
     /*  96915 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(96983), // Rule ID 4980 //
     /*  96920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96944 */     // MIs[0] base
     /*  96944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96964 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96968 */     // (intrinsic_w_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq_u),
     /*  96971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96973 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96975 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96981 */     GIR_RootConstrainSelectedInstOperands,
     /*  96982 */     // GIR_Coverage, 4980,
     /*  96982 */     GIR_EraseRootFromParent_Done,
     /*  96983 */   // Label 1768: @96983
     /*  96983 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(97051), // Rule ID 4981 //
     /*  96988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97012 */     // MIs[0] base
     /*  97012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97036 */     // (intrinsic_w_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq),
     /*  97039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97041 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97043 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97049 */     GIR_RootConstrainSelectedInstOperands,
     /*  97050 */     // GIR_Coverage, 4981,
     /*  97050 */     GIR_EraseRootFromParent_Done,
     /*  97051 */   // Label 1769: @97051
     /*  97051 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(97119), // Rule ID 4984 //
     /*  97056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97080 */     // MIs[0] base
     /*  97080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97104 */     // (intrinsic_w_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97109 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97111 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97117 */     GIR_RootConstrainSelectedInstOperands,
     /*  97118 */     // GIR_Coverage, 4984,
     /*  97118 */     GIR_EraseRootFromParent_Done,
     /*  97119 */   // Label 1770: @97119
     /*  97119 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(97187), // Rule ID 4985 //
     /*  97124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97148 */     // MIs[0] base
     /*  97148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97172 */     // (intrinsic_w_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97177 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97179 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97185 */     GIR_RootConstrainSelectedInstOperands,
     /*  97186 */     // GIR_Coverage, 4985,
     /*  97186 */     GIR_EraseRootFromParent_Done,
     /*  97187 */   // Label 1771: @97187
     /*  97187 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(97255), // Rule ID 4988 //
     /*  97192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97216 */     // MIs[0] base
     /*  97216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97240 */     // (intrinsic_w_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97245 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97247 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97253 */     GIR_RootConstrainSelectedInstOperands,
     /*  97254 */     // GIR_Coverage, 4988,
     /*  97254 */     GIR_EraseRootFromParent_Done,
     /*  97255 */   // Label 1772: @97255
     /*  97255 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(97323), // Rule ID 4989 //
     /*  97260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97284 */     // MIs[0] base
     /*  97284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97300 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97308 */     // (intrinsic_w_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97313 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97315 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97321 */     GIR_RootConstrainSelectedInstOperands,
     /*  97322 */     // GIR_Coverage, 4989,
     /*  97322 */     GIR_EraseRootFromParent_Done,
     /*  97323 */   // Label 1773: @97323
     /*  97323 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(97391), // Rule ID 4992 //
     /*  97328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97352 */     // MIs[0] base
     /*  97352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97376 */     // (intrinsic_w_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97381 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97383 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97389 */     GIR_RootConstrainSelectedInstOperands,
     /*  97390 */     // GIR_Coverage, 4992,
     /*  97390 */     GIR_EraseRootFromParent_Done,
     /*  97391 */   // Label 1774: @97391
     /*  97391 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(97459), // Rule ID 4993 //
     /*  97396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97420 */     // MIs[0] base
     /*  97420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97444 */     // (intrinsic_w_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97449 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97451 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97457 */     GIR_RootConstrainSelectedInstOperands,
     /*  97458 */     // GIR_Coverage, 4993,
     /*  97458 */     GIR_EraseRootFromParent_Done,
     /*  97459 */   // Label 1775: @97459
     /*  97459 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(97527), // Rule ID 4996 //
     /*  97464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97488 */     // MIs[0] base
     /*  97488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97500 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97512 */     // (intrinsic_w_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97517 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97519 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97525 */     GIR_RootConstrainSelectedInstOperands,
     /*  97526 */     // GIR_Coverage, 4996,
     /*  97526 */     GIR_EraseRootFromParent_Done,
     /*  97527 */   // Label 1776: @97527
     /*  97527 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(97595), // Rule ID 4997 //
     /*  97532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97556 */     // MIs[0] base
     /*  97556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97568 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97580 */     // (intrinsic_w_chain:{ *:[v4i32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97585 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97587 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97593 */     GIR_RootConstrainSelectedInstOperands,
     /*  97594 */     // GIR_Coverage, 4997,
     /*  97594 */     GIR_EraseRootFromParent_Done,
     /*  97595 */   // Label 1777: @97595
     /*  97595 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(97663), // Rule ID 5000 //
     /*  97600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97624 */     // MIs[0] base
     /*  97624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97640 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97648 */     // (intrinsic_w_chain:{ *:[v4f32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97653 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97655 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97661 */     GIR_RootConstrainSelectedInstOperands,
     /*  97662 */     // GIR_Coverage, 5000,
     /*  97662 */     GIR_EraseRootFromParent_Done,
     /*  97663 */   // Label 1778: @97663
     /*  97663 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(97731), // Rule ID 5001 //
     /*  97668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97692 */     // MIs[0] base
     /*  97692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97716 */     // (intrinsic_w_chain:{ *:[v4f32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97721 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97723 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97729 */     GIR_RootConstrainSelectedInstOperands,
     /*  97730 */     // GIR_Coverage, 5001,
     /*  97730 */     GIR_EraseRootFromParent_Done,
     /*  97731 */   // Label 1779: @97731
     /*  97731 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(97799), // Rule ID 5004 //
     /*  97736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97760 */     // MIs[0] base
     /*  97760 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97784 */     // (intrinsic_w_chain:{ *:[v4f32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97789 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97791 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97797 */     GIR_RootConstrainSelectedInstOperands,
     /*  97798 */     // GIR_Coverage, 5004,
     /*  97798 */     GIR_EraseRootFromParent_Done,
     /*  97799 */   // Label 1780: @97799
     /*  97799 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(97867), // Rule ID 5005 //
     /*  97804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97828 */     // MIs[0] base
     /*  97828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97840 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97852 */     // (intrinsic_w_chain:{ *:[v4f32] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97857 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97859 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97865 */     GIR_RootConstrainSelectedInstOperands,
     /*  97866 */     // GIR_Coverage, 5005,
     /*  97866 */     GIR_EraseRootFromParent_Done,
     /*  97867 */   // Label 1781: @97867
     /*  97867 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(97935), // Rule ID 5008 //
     /*  97872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  97883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97896 */     // MIs[0] base
     /*  97896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  97912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97920 */     // (intrinsic_w_chain:{ *:[v2i64] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  97920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  97923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97925 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97927 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97933 */     GIR_RootConstrainSelectedInstOperands,
     /*  97934 */     // GIR_Coverage, 5008,
     /*  97934 */     GIR_EraseRootFromParent_Done,
     /*  97935 */   // Label 1782: @97935
     /*  97935 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(98003), // Rule ID 5009 //
     /*  97940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  97951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97964 */     // MIs[0] base
     /*  97964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  97980 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  97984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97988 */     // (intrinsic_w_chain:{ *:[v2i64] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  97988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  97991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97993 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97995 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98001 */     GIR_RootConstrainSelectedInstOperands,
     /*  98002 */     // GIR_Coverage, 5009,
     /*  98002 */     GIR_EraseRootFromParent_Done,
     /*  98003 */   // Label 1783: @98003
     /*  98003 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(98071), // Rule ID 5012 //
     /*  98008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98032 */     // MIs[0] base
     /*  98032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98056 */     // (intrinsic_w_chain:{ *:[v2i64] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98061 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98063 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98069 */     GIR_RootConstrainSelectedInstOperands,
     /*  98070 */     // GIR_Coverage, 5012,
     /*  98070 */     GIR_EraseRootFromParent_Done,
     /*  98071 */   // Label 1784: @98071
     /*  98071 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(98139), // Rule ID 5013 //
     /*  98076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98100 */     // MIs[0] base
     /*  98100 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98120 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98124 */     // (intrinsic_w_chain:{ *:[v2i64] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98129 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98131 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98137 */     GIR_RootConstrainSelectedInstOperands,
     /*  98138 */     // GIR_Coverage, 5013,
     /*  98138 */     GIR_EraseRootFromParent_Done,
     /*  98139 */   // Label 1785: @98139
     /*  98139 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(98207), // Rule ID 5016 //
     /*  98144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98168 */     // MIs[0] base
     /*  98168 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98192 */     // (intrinsic_w_chain:{ *:[v2i64] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98197 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98199 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98205 */     GIR_RootConstrainSelectedInstOperands,
     /*  98206 */     // GIR_Coverage, 5016,
     /*  98206 */     GIR_EraseRootFromParent_Done,
     /*  98207 */   // Label 1786: @98207
     /*  98207 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(98275), // Rule ID 5017 //
     /*  98212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98236 */     // MIs[0] base
     /*  98236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98260 */     // (intrinsic_w_chain:{ *:[v2i64] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98265 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98267 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98273 */     GIR_RootConstrainSelectedInstOperands,
     /*  98274 */     // GIR_Coverage, 5017,
     /*  98274 */     GIR_EraseRootFromParent_Done,
     /*  98275 */   // Label 1787: @98275
     /*  98275 */   GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(98343), // Rule ID 5020 //
     /*  98280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98304 */     // MIs[0] base
     /*  98304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98328 */     // (intrinsic_w_chain:{ *:[v2i64] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98333 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98335 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98341 */     GIR_RootConstrainSelectedInstOperands,
     /*  98342 */     // GIR_Coverage, 5020,
     /*  98342 */     GIR_EraseRootFromParent_Done,
     /*  98343 */   // Label 1788: @98343
     /*  98343 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(98411), // Rule ID 5021 //
     /*  98348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98372 */     // MIs[0] base
     /*  98372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98396 */     // (intrinsic_w_chain:{ *:[v2i64] } 3652:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98401 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98403 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98409 */     GIR_RootConstrainSelectedInstOperands,
     /*  98410 */     // GIR_Coverage, 5021,
     /*  98410 */     GIR_EraseRootFromParent_Done,
     /*  98411 */   // Label 1789: @98411
     /*  98411 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(98476), // Rule ID 256 //
     /*  98416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  98419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  98424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98427 */     // MIs[0] cop
     /*  98427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98430 */     // MIs[0] opc1
     /*  98430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98437 */     // MIs[0] CRn
     /*  98437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98440 */     // MIs[0] CRm
     /*  98440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98443 */     // MIs[0] opc2
     /*  98443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98446 */     // (intrinsic_void 3527:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR),
     /*  98449 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98451 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98455 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98457 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98459 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98474 */     GIR_RootConstrainSelectedInstOperands,
     /*  98475 */     // GIR_Coverage, 256,
     /*  98475 */     GIR_EraseRootFromParent_Done,
     /*  98476 */   // Label 1790: @98476
     /*  98476 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(98532), // Rule ID 257 //
     /*  98481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  98484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  98489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98492 */     // MIs[0] cop
     /*  98492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98495 */     // MIs[0] opc1
     /*  98495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98502 */     // MIs[0] CRn
     /*  98502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98505 */     // MIs[0] CRm
     /*  98505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98508 */     // MIs[0] opc2
     /*  98508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98511 */     // (intrinsic_void 3528:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR2),
     /*  98514 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98516 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98520 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98522 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98524 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98530 */     GIR_RootConstrainSelectedInstOperands,
     /*  98531 */     // GIR_Coverage, 257,
     /*  98531 */     GIR_EraseRootFromParent_Done,
     /*  98532 */   // Label 1791: @98532
     /*  98532 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(98597), // Rule ID 594 //
     /*  98537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  98540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  98545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98548 */     // MIs[0] cop
     /*  98548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98551 */     // MIs[0] opc1
     /*  98551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98558 */     // MIs[0] CRn
     /*  98558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98561 */     // MIs[0] CRm
     /*  98561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98564 */     // MIs[0] opc2
     /*  98564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98567 */     // (intrinsic_void 3527:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR),
     /*  98570 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98572 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98576 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98578 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98580 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98595 */     GIR_RootConstrainSelectedInstOperands,
     /*  98596 */     // GIR_Coverage, 594,
     /*  98596 */     GIR_EraseRootFromParent_Done,
     /*  98597 */   // Label 1792: @98597
     /*  98597 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(98662), // Rule ID 595 //
     /*  98602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  98605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  98610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98613 */     // MIs[0] cop
     /*  98613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98616 */     // MIs[0] opc1
     /*  98616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98623 */     // MIs[0] CRn
     /*  98623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98626 */     // MIs[0] CRm
     /*  98626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98629 */     // MIs[0] opc2
     /*  98629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98632 */     // (intrinsic_void 3528:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR2),
     /*  98635 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98637 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98641 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98643 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98645 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98660 */     GIR_RootConstrainSelectedInstOperands,
     /*  98661 */     // GIR_Coverage, 595,
     /*  98661 */     GIR_EraseRootFromParent_Done,
     /*  98662 */   // Label 1793: @98662
     /*  98662 */   GIM_Reject,
     /*  98663 */ // Label 1743: @98663
     /*  98663 */ GIM_Reject,
     /*  98664 */ // Label 17: @98664
     /*  98664 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1797*/ GIMT_Encode4(98821),
     /*  98675 */ /*GILLT_v2s64*//*Label 1794*/ GIMT_Encode4(98707), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98687 */ /*GILLT_v4s32*//*Label 1795*/ GIMT_Encode4(98745), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98703 */ /*GILLT_v8s16*//*Label 1796*/ GIMT_Encode4(98783),
     /*  98707 */ // Label 1794: @98707
     /*  98707 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(98744), // Rule ID 2665 //
     /*  98712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  98718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  98722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  98726 */   // (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  98726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /*  98729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  98731 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  98733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98736 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98742 */   GIR_RootConstrainSelectedInstOperands,
     /*  98743 */   // GIR_Coverage, 2665,
     /*  98743 */   GIR_EraseRootFromParent_Done,
     /*  98744 */ // Label 1798: @98744
     /*  98744 */ GIM_Reject,
     /*  98745 */ // Label 1795: @98745
     /*  98745 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(98782), // Rule ID 2664 //
     /*  98750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  98756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  98760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  98764 */   // (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  98764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /*  98767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  98769 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  98771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98774 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98780 */   GIR_RootConstrainSelectedInstOperands,
     /*  98781 */   // GIR_Coverage, 2664,
     /*  98781 */   GIR_EraseRootFromParent_Done,
     /*  98782 */ // Label 1799: @98782
     /*  98782 */ GIM_Reject,
     /*  98783 */ // Label 1796: @98783
     /*  98783 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(98820), // Rule ID 2663 //
     /*  98788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  98794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  98798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  98802 */   // (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  98802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /*  98805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  98807 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  98809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98812 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98818 */   GIR_RootConstrainSelectedInstOperands,
     /*  98819 */   // GIR_Coverage, 2663,
     /*  98819 */   GIR_EraseRootFromParent_Done,
     /*  98820 */ // Label 1800: @98820
     /*  98820 */ GIM_Reject,
     /*  98821 */ // Label 1797: @98821
     /*  98821 */ GIM_Reject,
     /*  98822 */ // Label 18: @98822
     /*  98822 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(12), /*)*//*default:*//*Label 1804*/ GIMT_Encode4(98979),
     /*  98833 */ /*GILLT_v2s32*//*Label 1801*/ GIMT_Encode4(98865), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98845 */ /*GILLT_v4s16*//*Label 1802*/ GIMT_Encode4(98903), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98861 */ /*GILLT_v8s8*//*Label 1803*/ GIMT_Encode4(98941),
     /*  98865 */ // Label 1801: @98865
     /*  98865 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(98902), // Rule ID 1585 //
     /*  98870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  98880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  98884 */   // (trunc:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)  =>  (VMOVNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  98884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv2i32),
     /*  98887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  98889 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  98891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98894 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98900 */   GIR_RootConstrainSelectedInstOperands,
     /*  98901 */   // GIR_Coverage, 1585,
     /*  98901 */   GIR_EraseRootFromParent_Done,
     /*  98902 */ // Label 1805: @98902
     /*  98902 */ GIM_Reject,
     /*  98903 */ // Label 1802: @98903
     /*  98903 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(98940), // Rule ID 1584 //
     /*  98908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  98914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  98918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  98922 */   // (trunc:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)  =>  (VMOVNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  98922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv4i16),
     /*  98925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  98927 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  98929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98932 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98938 */   GIR_RootConstrainSelectedInstOperands,
     /*  98939 */   // GIR_Coverage, 1584,
     /*  98939 */   GIR_EraseRootFromParent_Done,
     /*  98940 */ // Label 1806: @98940
     /*  98940 */ GIM_Reject,
     /*  98941 */ // Label 1803: @98941
     /*  98941 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(98978), // Rule ID 1583 //
     /*  98946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  98952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  98956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  98960 */   // (trunc:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)  =>  (VMOVNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  98960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv8i8),
     /*  98963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  98965 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  98967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98970 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98976 */   GIR_RootConstrainSelectedInstOperands,
     /*  98977 */   // GIR_Coverage, 1583,
     /*  98977 */   GIR_EraseRootFromParent_Done,
     /*  98978 */ // Label 1807: @98978
     /*  98978 */ GIM_Reject,
     /*  98979 */ // Label 1804: @98979
     /*  98979 */ GIM_Reject,
     /*  98980 */ // Label 19: @98980
     /*  98980 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(99300),
     /*  98985 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  98988 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(99029), // Rule ID 404 //
     /*  98993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  98996 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  99000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99004 */     // MIs[0] Operand 1
     /*  99004 */     // No operand predicates
     /*  99004 */     // (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm  =>  (t2MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /*  99007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99015 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99027 */     GIR_RootConstrainSelectedInstOperands,
     /*  99028 */     // GIR_Coverage, 404,
     /*  99028 */     GIR_EraseRootFromParent_Done,
     /*  99029 */   // Label 1809: @99029
     /*  99029 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(99070), // Rule ID 57 //
     /*  99034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99037 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  99041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99045 */     // MIs[0] Operand 1
     /*  99045 */     // No operand predicates
     /*  99045 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm  =>  (MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /*  99048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99068 */     GIR_RootConstrainSelectedInstOperands,
     /*  99069 */     // GIR_Coverage, 57,
     /*  99069 */     GIR_EraseRootFromParent_Done,
     /*  99070 */   // Label 1810: @99070
     /*  99070 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(99105), // Rule ID 58 //
     /*  99075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  99078 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99086 */     // MIs[0] Operand 1
     /*  99086 */     // No operand predicates
     /*  99086 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi16),
     /*  99089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99097 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99103 */     GIR_RootConstrainSelectedInstOperands,
     /*  99104 */     // GIR_Coverage, 58,
     /*  99104 */     GIR_EraseRootFromParent_Done,
     /*  99105 */   // Label 1811: @99105
     /*  99105 */   GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(99148), // Rule ID 168 //
     /*  99110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99113 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  99117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99121 */     // MIs[0] Operand 1
     /*  99121 */     // No operand predicates
     /*  99121 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm  =>  (MVNi:{ *:[i32] } (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  99121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNi),
     /*  99124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99126 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  99131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99146 */     GIR_RootConstrainSelectedInstOperands,
     /*  99147 */     // GIR_Coverage, 168,
     /*  99147 */     GIR_EraseRootFromParent_Done,
     /*  99148 */   // Label 1812: @99148
     /*  99148 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(99174), // Rule ID 268 //
     /*  99153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99156 */     GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_arm_i32imm),
     /*  99160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99164 */     // MIs[0] Operand 1
     /*  99164 */     // No operand predicates
     /*  99164 */     // (imm:{ *:[i32] })<<P:Predicate_arm_i32imm>>:$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi32imm),
     /*  99167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99172 */     GIR_RootConstrainSelectedInstOperands,
     /*  99173 */     // GIR_Coverage, 268,
     /*  99173 */     GIR_EraseRootFromParent_Done,
     /*  99174 */   // Label 1813: @99174
     /*  99174 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(99215), // Rule ID 322 //
     /*  99179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  99182 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*  99186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99190 */     // MIs[0] Operand 1
     /*  99190 */     // No operand predicates
     /*  99190 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8  =>  (tMOVi8:{ *:[i32] } (imm:{ *:[i32] }):$imm8)
     /*  99190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  99193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  99201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm8
     /*  99204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99213 */     GIR_RootConstrainSelectedInstOperands,
     /*  99214 */     // GIR_Coverage, 322,
     /*  99214 */     GIR_EraseRootFromParent_Done,
     /*  99215 */   // Label 1814: @99215
     /*  99215 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(99250), // Rule ID 405 //
     /*  99220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /*  99223 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99231 */     // MIs[0] Operand 1
     /*  99231 */     // No operand predicates
     /*  99231 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (t2MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /*  99234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99248 */     GIR_RootConstrainSelectedInstOperands,
     /*  99249 */     // GIR_Coverage, 405,
     /*  99249 */     GIR_EraseRootFromParent_Done,
     /*  99250 */   // Label 1815: @99250
     /*  99250 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(99299),
     /*  99255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99259 */     GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(99280), // Rule ID 353 //
     /*  99264 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only),
     /*  99267 */       // MIs[0] Operand 1
     /*  99267 */       // No operand predicates
     /*  99267 */       // (imm:{ *:[i32] }):$src  =>  (tMOVi32imm:{ *:[i32] }:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99267 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi32imm),
     /*  99270 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99272 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99275 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::CPSR*/0,
     /*  99278 */       GIR_RootConstrainSelectedInstOperands,
     /*  99279 */       // GIR_Coverage, 353,
     /*  99279 */       GIR_EraseRootFromParent_Done,
     /*  99280 */     // Label 1817: @99280
     /*  99280 */     GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(99298), // Rule ID 582 //
     /*  99285 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_UseMovt),
     /*  99288 */       // MIs[0] Operand 1
     /*  99288 */       // No operand predicates
     /*  99288 */       // (imm:{ *:[i32] }):$src  =>  (t2MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99288 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /*  99291 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99293 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99296 */       GIR_RootConstrainSelectedInstOperands,
     /*  99297 */       // GIR_Coverage, 582,
     /*  99297 */       GIR_EraseRootFromParent_Done,
     /*  99298 */     // Label 1818: @99298
     /*  99298 */     GIM_Reject,
     /*  99299 */   // Label 1816: @99299
     /*  99299 */   GIM_Reject,
     /*  99300 */ // Label 1808: @99300
     /*  99300 */ GIM_Reject,
     /*  99301 */ // Label 20: @99301
     /*  99301 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1821*/ GIMT_Encode4(99396),
     /*  99312 */ /*GILLT_s32*//*Label 1819*/ GIMT_Encode4(99320),
     /*  99316 */ /*GILLT_s64*//*Label 1820*/ GIMT_Encode4(99358),
     /*  99320 */ // Label 1819: @99320
     /*  99320 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(99357), // Rule ID 725 //
     /*  99325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP3),
     /*  99328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  99332 */   // MIs[0] Operand 1
     /*  99332 */   // No operand predicates
     /*  99332 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f32imm),
     /*  99336 */   // (fpimm:{ *:[f32] })<<P:Predicate_vfp_f32imm>><<X:vfp_f32imm_xform>>:$imm  =>  (FCONSTS:{ *:[f32] } (vfp_f32imm_xform:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /*  99336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTS),
     /*  99339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  99341 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF32Imm), // imm
     /*  99346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99349 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99355 */   GIR_RootConstrainSelectedInstOperands,
     /*  99356 */   // GIR_Coverage, 725,
     /*  99356 */   GIR_EraseRootFromParent_Done,
     /*  99357 */ // Label 1822: @99357
     /*  99357 */ GIM_Reject,
     /*  99358 */ // Label 1820: @99358
     /*  99358 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(99395), // Rule ID 724 //
     /*  99363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP3),
     /*  99366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99370 */   // MIs[0] Operand 1
     /*  99370 */   // No operand predicates
     /*  99370 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f64imm),
     /*  99374 */   // (fpimm:{ *:[f64] })<<P:Predicate_vfp_f64imm>><<X:vfp_f64imm_xform>>:$imm  =>  (FCONSTD:{ *:[f64] } (vfp_f64imm_xform:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /*  99374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTD),
     /*  99377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  99379 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF64Imm), // imm
     /*  99384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99387 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99393 */   GIR_RootConstrainSelectedInstOperands,
     /*  99394 */   // GIR_Coverage, 724,
     /*  99394 */   GIR_EraseRootFromParent_Done,
     /*  99395 */ // Label 1823: @99395
     /*  99395 */ GIM_Reject,
     /*  99396 */ // Label 1821: @99396
     /*  99396 */ GIM_Reject,
     /*  99397 */ // Label 21: @99397
     /*  99397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1827*/ GIMT_Encode4(99554),
     /*  99408 */ /*GILLT_v2s64*//*Label 1824*/ GIMT_Encode4(99440), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99420 */ /*GILLT_v4s32*//*Label 1825*/ GIMT_Encode4(99478), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99436 */ /*GILLT_v8s16*//*Label 1826*/ GIMT_Encode4(99516),
     /*  99440 */ // Label 1824: @99440
     /*  99440 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(99477), // Rule ID 1597 //
     /*  99445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99459 */   // (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv2i64),
     /*  99462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99464 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99469 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99475 */   GIR_RootConstrainSelectedInstOperands,
     /*  99476 */   // GIR_Coverage, 1597,
     /*  99476 */   GIR_EraseRootFromParent_Done,
     /*  99477 */ // Label 1828: @99477
     /*  99477 */ GIM_Reject,
     /*  99478 */ // Label 1825: @99478
     /*  99478 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(99515), // Rule ID 1596 //
     /*  99483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99497 */   // (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv4i32),
     /*  99500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99502 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99507 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99513 */   GIR_RootConstrainSelectedInstOperands,
     /*  99514 */   // GIR_Coverage, 1596,
     /*  99514 */   GIR_EraseRootFromParent_Done,
     /*  99515 */ // Label 1829: @99515
     /*  99515 */ GIM_Reject,
     /*  99516 */ // Label 1826: @99516
     /*  99516 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(99553), // Rule ID 1595 //
     /*  99521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  99527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99535 */   // (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  99535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv8i16),
     /*  99538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99540 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99545 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99551 */   GIR_RootConstrainSelectedInstOperands,
     /*  99552 */   // GIR_Coverage, 1595,
     /*  99552 */   GIR_EraseRootFromParent_Done,
     /*  99553 */ // Label 1830: @99553
     /*  99553 */ GIM_Reject,
     /*  99554 */ // Label 1827: @99554
     /*  99554 */ GIM_Reject,
     /*  99555 */ // Label 22: @99555
     /*  99555 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 1834*/ GIMT_Encode4(100159),
     /*  99566 */ /*GILLT_s32*//*Label 1831*/ GIMT_Encode4(99614), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99594 */ /*GILLT_v4s32*//*Label 1832*/ GIMT_Encode4(99906), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99610 */ /*GILLT_v8s16*//*Label 1833*/ GIMT_Encode4(100089),
     /*  99614 */ // Label 1831: @99614
     /*  99614 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(99905),
     /*  99619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  99622 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(99667), // Rule ID 340 //
     /*  99627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  99630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99638 */     // MIs[0] Operand 2
     /*  99638 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /*  99649 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] })  =>  (tSXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  99649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTB),
     /*  99652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99654 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  99656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99665 */     GIR_RootConstrainSelectedInstOperands,
     /*  99666 */     // GIR_Coverage, 340,
     /*  99666 */     GIR_EraseRootFromParent_Done,
     /*  99667 */   // Label 1836: @99667
     /*  99667 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(99712), // Rule ID 341 //
     /*  99672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  99675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99683 */     // MIs[0] Operand 2
     /*  99683 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /*  99694 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })  =>  (tSXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  99694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTH),
     /*  99697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  99701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99710 */     GIR_RootConstrainSelectedInstOperands,
     /*  99711 */     // GIR_Coverage, 341,
     /*  99711 */     GIR_EraseRootFromParent_Done,
     /*  99712 */   // Label 1837: @99712
     /*  99712 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(99760), // Rule ID 1999 //
     /*  99717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  99720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  99724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99728 */     // MIs[0] Operand 2
     /*  99728 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /*  99739 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (SXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  99739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB),
     /*  99742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  99746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99758 */     GIR_RootConstrainSelectedInstOperands,
     /*  99759 */     // GIR_Coverage, 1999,
     /*  99759 */     GIR_EraseRootFromParent_Done,
     /*  99760 */   // Label 1838: @99760
     /*  99760 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(99808), // Rule ID 2000 //
     /*  99765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  99768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  99772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99776 */     // MIs[0] Operand 2
     /*  99776 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /*  99787 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (SXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  99787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTH),
     /*  99790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  99794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99806 */     GIR_RootConstrainSelectedInstOperands,
     /*  99807 */     // GIR_Coverage, 2000,
     /*  99807 */     GIR_EraseRootFromParent_Done,
     /*  99808 */   // Label 1839: @99808
     /*  99808 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(99856), // Rule ID 2238 //
     /*  99813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99824 */     // MIs[0] Operand 2
     /*  99824 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /*  99835 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (t2SXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  99835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB),
     /*  99838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  99842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99854 */     GIR_RootConstrainSelectedInstOperands,
     /*  99855 */     // GIR_Coverage, 2238,
     /*  99855 */     GIR_EraseRootFromParent_Done,
     /*  99856 */   // Label 1840: @99856
     /*  99856 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(99904), // Rule ID 2239 //
     /*  99861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99872 */     // MIs[0] Operand 2
     /*  99872 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /*  99883 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (t2SXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  99883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTH),
     /*  99886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  99890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99902 */     GIR_RootConstrainSelectedInstOperands,
     /*  99903 */     // GIR_Coverage, 2239,
     /*  99903 */     GIR_EraseRootFromParent_Done,
     /*  99904 */   // Label 1841: @99904
     /*  99904 */   GIM_Reject,
     /*  99905 */ // Label 1835: @99905
     /*  99905 */ GIM_Reject,
     /*  99906 */ // Label 1832: @99906
     /*  99906 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(100088),
     /*  99911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  99914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  99918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  99922 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(99980), // Rule ID 3710 //
     /*  99927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  99930 */     // MIs[0] Operand 2
     /*  99930 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /*  99941 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i16:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /*  99941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  99944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /*  99956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  99958 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  99960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99978 */     GIR_RootConstrainSelectedInstOperands,
     /*  99979 */     // GIR_Coverage, 3710,
     /*  99979 */     GIR_EraseRootFromParent_Done,
     /*  99980 */   // Label 1843: @99980
     /*  99980 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(100087), // Rule ID 3712 //
     /*  99985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  99988 */     // MIs[0] Operand 2
     /*  99988 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /*  99999 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i8:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } (MVE_VMOVLs8bh:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src))
     /*  99999 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 100002 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100006 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100011 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100014 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100018 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 100026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100035 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 100039 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100042 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100048 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100054 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100085 */     GIR_RootConstrainSelectedInstOperands,
     /* 100086 */     // GIR_Coverage, 3712,
     /* 100086 */     GIR_EraseRootFromParent_Done,
     /* 100087 */   // Label 1844: @100087
     /* 100087 */   GIM_Reject,
     /* 100088 */ // Label 1842: @100088
     /* 100088 */ GIM_Reject,
     /* 100089 */ // Label 1833: @100089
     /* 100089 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(100158), // Rule ID 3711 //
     /* 100094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 100100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100108 */   // MIs[0] Operand 2
     /* 100108 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100119 */   // (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, v8i8:{ *:[Other] })  =>  (MVE_VMOVLs8bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 100119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100136 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100141 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100147 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100153 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100156 */   GIR_RootConstrainSelectedInstOperands,
     /* 100157 */   // GIR_Coverage, 3711,
     /* 100157 */   GIR_EraseRootFromParent_Done,
     /* 100158 */ // Label 1845: @100158
     /* 100158 */ GIM_Reject,
     /* 100159 */ // Label 1834: @100159
     /* 100159 */ GIM_Reject,
     /* 100160 */ // Label 23: @100160
     /* 100160 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1849*/ GIMT_Encode4(100317),
     /* 100171 */ /*GILLT_v2s64*//*Label 1846*/ GIMT_Encode4(100203), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100183 */ /*GILLT_v4s32*//*Label 1847*/ GIMT_Encode4(100241), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100199 */ /*GILLT_v8s16*//*Label 1848*/ GIMT_Encode4(100279),
     /* 100203 */ // Label 1846: @100203
     /* 100203 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(100240), // Rule ID 1600 //
     /* 100208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 100214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100222 */   // (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /* 100222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /* 100225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100227 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100232 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100238 */   GIR_RootConstrainSelectedInstOperands,
     /* 100239 */   // GIR_Coverage, 1600,
     /* 100239 */   GIR_EraseRootFromParent_Done,
     /* 100240 */ // Label 1850: @100240
     /* 100240 */ GIM_Reject,
     /* 100241 */ // Label 1847: @100241
     /* 100241 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(100278), // Rule ID 1599 //
     /* 100246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100260 */   // (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /* 100260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /* 100263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100265 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100270 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100276 */   GIR_RootConstrainSelectedInstOperands,
     /* 100277 */   // GIR_Coverage, 1599,
     /* 100277 */   GIR_EraseRootFromParent_Done,
     /* 100278 */ // Label 1851: @100278
     /* 100278 */ GIM_Reject,
     /* 100279 */ // Label 1848: @100279
     /* 100279 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(100316), // Rule ID 1598 //
     /* 100284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100298 */   // (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /* 100301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100303 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100308 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100314 */   GIR_RootConstrainSelectedInstOperands,
     /* 100315 */   // GIR_Coverage, 1598,
     /* 100315 */   GIR_EraseRootFromParent_Done,
     /* 100316 */ // Label 1852: @100316
     /* 100316 */ GIM_Reject,
     /* 100317 */ // Label 1849: @100317
     /* 100317 */ GIM_Reject,
     /* 100318 */ // Label 24: @100318
     /* 100318 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(100533),
     /* 100323 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100332 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(100389), // Rule ID 470 //
     /* 100337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 100360 */     // MIs[1] Operand 1
     /* 100360 */     // No operand predicates
     /* 100360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100362 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2LSLri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 100362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLri),
     /* 100365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 100372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100375 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100387 */     GIR_RootConstrainSelectedInstOperands,
     /* 100388 */     // GIR_Coverage, 470,
     /* 100388 */     GIR_EraseRootFromParent_Done,
     /* 100389 */   // Label 1854: @100389
     /* 100389 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(100486),
     /* 100394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100402 */     GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(100447), // Rule ID 318 //
     /* 100407 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100410 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100414 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100418 */       // MIs[1] Operand 1
     /* 100418 */       // No operand predicates
     /* 100418 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100420 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)  =>  (tLSLri:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)
     /* 100420 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLri),
     /* 100423 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100425 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100431 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100433 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm5
     /* 100436 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100439 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100445 */       GIR_RootConstrainSelectedInstOperands,
     /* 100446 */       // GIR_Coverage, 318,
     /* 100446 */       GIR_EraseRootFromParent_Done,
     /* 100447 */     // Label 1856: @100447
     /* 100447 */     GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(100485), // Rule ID 319 //
     /* 100452 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100455 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100459 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSLrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100459 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLrr),
     /* 100462 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100464 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100470 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100472 */       GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100474 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100477 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100483 */       GIR_RootConstrainSelectedInstOperands,
     /* 100484 */       // GIR_Coverage, 319,
     /* 100484 */       GIR_EraseRootFromParent_Done,
     /* 100485 */     // Label 1857: @100485
     /* 100485 */     GIM_Reject,
     /* 100486 */   // Label 1855: @100486
     /* 100486 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(100532), // Rule ID 471 //
     /* 100491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100506 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSLrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLrr),
     /* 100509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100530 */     GIR_RootConstrainSelectedInstOperands,
     /* 100531 */     // GIR_Coverage, 471,
     /* 100531 */     GIR_EraseRootFromParent_Done,
     /* 100532 */   // Label 1858: @100532
     /* 100532 */   GIM_Reject,
     /* 100533 */ // Label 1853: @100533
     /* 100533 */ GIM_Reject,
     /* 100534 */ // Label 25: @100534
     /* 100534 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(100641),
     /* 100539 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100548 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(100594), // Rule ID 321 //
     /* 100553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100568 */     // (srl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSRrr),
     /* 100571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100592 */     GIR_RootConstrainSelectedInstOperands,
     /* 100593 */     // GIR_Coverage, 321,
     /* 100593 */     GIR_EraseRootFromParent_Done,
     /* 100594 */   // Label 1860: @100594
     /* 100594 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(100640), // Rule ID 473 //
     /* 100599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100614 */     // (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSRrr),
     /* 100617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100638 */     GIR_RootConstrainSelectedInstOperands,
     /* 100639 */     // GIR_Coverage, 473,
     /* 100639 */     GIR_EraseRootFromParent_Done,
     /* 100640 */   // Label 1861: @100640
     /* 100640 */   GIM_Reject,
     /* 100641 */ // Label 1859: @100641
     /* 100641 */ GIM_Reject,
     /* 100642 */ // Label 26: @100642
     /* 100642 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(100914),
     /* 100647 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100656 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(100711), // Rule ID 201 //
     /* 100661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 100676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 100680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 100689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100691 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 100691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /* 100694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 100700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100709 */     GIR_RootConstrainSelectedInstOperands,
     /* 100710 */     // GIR_Coverage, 201,
     /* 100710 */     GIR_EraseRootFromParent_Done,
     /* 100711 */   // Label 1863: @100711
     /* 100711 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(100766), // Rule ID 328 //
     /* 100716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 100731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 100735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 100744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100746 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREVSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREVSH),
     /* 100749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 100755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100764 */     GIR_RootConstrainSelectedInstOperands,
     /* 100765 */     // GIR_Coverage, 328,
     /* 100765 */     GIR_EraseRootFromParent_Done,
     /* 100766 */   // Label 1864: @100766
     /* 100766 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(100821), // Rule ID 538 //
     /* 100771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 100786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 100790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 100799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100801 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 100801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /* 100804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 100810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100819 */     GIR_RootConstrainSelectedInstOperands,
     /* 100820 */     // GIR_Coverage, 538,
     /* 100820 */     GIR_EraseRootFromParent_Done,
     /* 100821 */   // Label 1865: @100821
     /* 100821 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(100867), // Rule ID 312 //
     /* 100826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100841 */     // (sra:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tASRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tASRrr),
     /* 100844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100846 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100865 */     GIR_RootConstrainSelectedInstOperands,
     /* 100866 */     // GIR_Coverage, 312,
     /* 100866 */     GIR_EraseRootFromParent_Done,
     /* 100867 */   // Label 1866: @100867
     /* 100867 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(100913), // Rule ID 475 //
     /* 100872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100887 */     // (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ASRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ASRrr),
     /* 100890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100892 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100911 */     GIR_RootConstrainSelectedInstOperands,
     /* 100912 */     // GIR_Coverage, 475,
     /* 100912 */     GIR_EraseRootFromParent_Done,
     /* 100913 */   // Label 1867: @100913
     /* 100913 */   GIM_Reject,
     /* 100914 */ // Label 1862: @100914
     /* 100914 */ GIM_Reject,
     /* 100915 */ // Label 27: @100915
     /* 100915 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(101246),
     /* 100920 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100929 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(100984), // Rule ID 200 //
     /* 100934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 100949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 100953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 100962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100964 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REV16:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 100964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV16),
     /* 100967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 100973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100982 */     GIR_RootConstrainSelectedInstOperands,
     /* 100983 */     // GIR_Coverage, 200,
     /* 100983 */     GIR_EraseRootFromParent_Done,
     /* 100984 */   // Label 1869: @100984
     /* 100984 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(101039), // Rule ID 327 //
     /* 100989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101013 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101019 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREV16:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV16),
     /* 101022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101037 */     GIR_RootConstrainSelectedInstOperands,
     /* 101038 */     // GIR_Coverage, 327,
     /* 101038 */     GIR_EraseRootFromParent_Done,
     /* 101039 */   // Label 1870: @101039
     /* 101039 */   GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(101153),
     /* 101044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101048 */     GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(101099), // Rule ID 537 //
     /* 101053 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101056 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101060 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101064 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101068 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101073 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101077 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101079 */       // (rotr:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REV16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101079 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV16),
     /* 101082 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101084 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101088 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101091 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101097 */       GIR_RootConstrainSelectedInstOperands,
     /* 101098 */       // GIR_Coverage, 537,
     /* 101098 */       GIR_EraseRootFromParent_Done,
     /* 101099 */     // Label 1872: @101099
     /* 101099 */     GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(101152), // Rule ID 476 //
     /* 101104 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101107 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101111 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101115 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101119 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 101123 */       // MIs[1] Operand 1
     /* 101123 */       // No operand predicates
     /* 101123 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101125 */       // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2RORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 101125 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORri),
     /* 101128 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101130 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 101132 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 101135 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101138 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101144 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101150 */       GIR_RootConstrainSelectedInstOperands,
     /* 101151 */       // GIR_Coverage, 476,
     /* 101151 */       GIR_EraseRootFromParent_Done,
     /* 101152 */     // Label 1873: @101152
     /* 101152 */     GIM_Reject,
     /* 101153 */   // Label 1871: @101153
     /* 101153 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(101199), // Rule ID 329 //
     /* 101158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101173 */     // (rotr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tROR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tROR),
     /* 101176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101197 */     GIR_RootConstrainSelectedInstOperands,
     /* 101198 */     // GIR_Coverage, 329,
     /* 101198 */     GIR_EraseRootFromParent_Done,
     /* 101199 */   // Label 1874: @101199
     /* 101199 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(101245), // Rule ID 477 //
     /* 101204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101219 */     // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2RORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORrr),
     /* 101222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101243 */     GIR_RootConstrainSelectedInstOperands,
     /* 101244 */     // GIR_Coverage, 477,
     /* 101244 */     GIR_EraseRootFromParent_Done,
     /* 101245 */   // Label 1875: @101245
     /* 101245 */   GIM_Reject,
     /* 101246 */ // Label 1868: @101246
     /* 101246 */ GIM_Reject,
     /* 101247 */ // Label 28: @101247
     /* 101247 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 1879*/ GIMT_Encode4(101494),
     /* 101258 */ /*GILLT_v4s32*//*Label 1876*/ GIMT_Encode4(101290), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101274 */ /*GILLT_v8s16*//*Label 1877*/ GIMT_Encode4(101358), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101286 */ /*GILLT_v16s8*//*Label 1878*/ GIMT_Encode4(101426),
     /* 101290 */ // Label 1876: @101290
     /* 101290 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(101357), // Rule ID 4461 //
     /* 101295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101312 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101316 */   // (mulhu:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101316 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101319 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101323 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /* 101331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101333 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101335 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101340 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101346 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101355 */   GIR_RootConstrainSelectedInstOperands,
     /* 101356 */   // GIR_Coverage, 4461,
     /* 101356 */   GIR_EraseRootFromParent_Done,
     /* 101357 */ // Label 1880: @101357
     /* 101357 */ GIM_Reject,
     /* 101358 */ // Label 1877: @101358
     /* 101358 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(101425), // Rule ID 4457 //
     /* 101363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 101369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 101372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101384 */   // (mulhu:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 101384 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101387 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101391 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /* 101399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101401 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101403 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101408 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101414 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101420 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101423 */   GIR_RootConstrainSelectedInstOperands,
     /* 101424 */   // GIR_Coverage, 4457,
     /* 101424 */   GIR_EraseRootFromParent_Done,
     /* 101425 */ // Label 1881: @101425
     /* 101425 */ GIM_Reject,
     /* 101426 */ // Label 1878: @101426
     /* 101426 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(101493), // Rule ID 4453 //
     /* 101431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 101437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 101440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101452 */   // (mulhu:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 101452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /* 101467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101469 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101471 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101476 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101482 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101491 */   GIR_RootConstrainSelectedInstOperands,
     /* 101492 */   // GIR_Coverage, 4453,
     /* 101492 */   GIR_EraseRootFromParent_Done,
     /* 101493 */ // Label 1882: @101493
     /* 101493 */ GIM_Reject,
     /* 101494 */ // Label 1879: @101494
     /* 101494 */ GIM_Reject,
     /* 101495 */ // Label 29: @101495
     /* 101495 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1887*/ GIMT_Encode4(101863),
     /* 101506 */ /*GILLT_s32*//*Label 1883*/ GIMT_Encode4(101566), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101534 */ /*GILLT_v4s32*//*Label 1884*/ GIMT_Encode4(101659), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101550 */ /*GILLT_v8s16*//*Label 1885*/ GIMT_Encode4(101727), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101562 */ /*GILLT_v16s8*//*Label 1886*/ GIMT_Encode4(101795),
     /* 101566 */ // Label 1883: @101566
     /* 101566 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(101658),
     /* 101571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101577 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(101617), // Rule ID 178 //
     /* 101582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101597 */     // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SMMUL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /* 101597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMUL),
     /* 101600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101615 */     GIR_RootConstrainSelectedInstOperands,
     /* 101616 */     // GIR_Coverage, 178,
     /* 101616 */     GIR_EraseRootFromParent_Done,
     /* 101617 */   // Label 1889: @101617
     /* 101617 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(101657), // Rule ID 507 //
     /* 101622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 101625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101637 */     // (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMMUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMUL),
     /* 101640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101642 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101649 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101655 */     GIR_RootConstrainSelectedInstOperands,
     /* 101656 */     // GIR_Coverage, 507,
     /* 101656 */     GIR_EraseRootFromParent_Done,
     /* 101657 */   // Label 1890: @101657
     /* 101657 */   GIM_Reject,
     /* 101658 */ // Label 1888: @101658
     /* 101658 */ GIM_Reject,
     /* 101659 */ // Label 1884: @101659
     /* 101659 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(101726), // Rule ID 4449 //
     /* 101664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101681 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101685 */   // (mulhs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /* 101700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101702 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101704 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101709 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101715 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101721 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101724 */   GIR_RootConstrainSelectedInstOperands,
     /* 101725 */   // GIR_Coverage, 4449,
     /* 101725 */   GIR_EraseRootFromParent_Done,
     /* 101726 */ // Label 1891: @101726
     /* 101726 */ GIM_Reject,
     /* 101727 */ // Label 1885: @101727
     /* 101727 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(101794), // Rule ID 4445 //
     /* 101732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 101738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 101741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101753 */   // (mulhs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 101753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /* 101768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101770 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101772 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101777 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101783 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101792 */   GIR_RootConstrainSelectedInstOperands,
     /* 101793 */   // GIR_Coverage, 4445,
     /* 101793 */   GIR_EraseRootFromParent_Done,
     /* 101794 */ // Label 1892: @101794
     /* 101794 */ GIM_Reject,
     /* 101795 */ // Label 1886: @101795
     /* 101795 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(101862), // Rule ID 4442 //
     /* 101800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 101806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 101809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101817 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101821 */   // (mulhs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 101821 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101824 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101828 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /* 101836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101838 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101840 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101845 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101851 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101857 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101860 */   GIR_RootConstrainSelectedInstOperands,
     /* 101861 */   // GIR_Coverage, 4442,
     /* 101861 */   GIR_EraseRootFromParent_Done,
     /* 101862 */ // Label 1893: @101862
     /* 101862 */ GIM_Reject,
     /* 101863 */ // Label 1887: @101863
     /* 101863 */ GIM_Reject,
     /* 101864 */ // Label 30: @101864
     /* 101864 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1902*/ GIMT_Encode4(102508),
     /* 101875 */ /*GILLT_s64*//*Label 1894*/ GIMT_Encode4(101931), GIMT_Encode4(0),
     /* 101883 */ /*GILLT_v2s32*//*Label 1895*/ GIMT_Encode4(101978),
     /* 101887 */ /*GILLT_v2s64*//*Label 1896*/ GIMT_Encode4(102025), GIMT_Encode4(0),
     /* 101895 */ /*GILLT_v4s16*//*Label 1897*/ GIMT_Encode4(102072),
     /* 101899 */ /*GILLT_v4s32*//*Label 1898*/ GIMT_Encode4(102119), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101911 */ /*GILLT_v8s8*//*Label 1899*/ GIMT_Encode4(102233),
     /* 101915 */ /*GILLT_v8s16*//*Label 1900*/ GIMT_Encode4(102280), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101927 */ /*GILLT_v16s8*//*Label 1901*/ GIMT_Encode4(102394),
     /* 101931 */ // Label 1894: @101931
     /* 101931 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(101977), // Rule ID 827 //
     /* 101936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 101942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 101945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 101949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 101953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 101957 */   // (uaddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 101957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv1i64),
     /* 101960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 101962 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 101964 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 101966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101969 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101975 */   GIR_RootConstrainSelectedInstOperands,
     /* 101976 */   // GIR_Coverage, 827,
     /* 101976 */   GIR_EraseRootFromParent_Done,
     /* 101977 */ // Label 1903: @101977
     /* 101977 */ GIM_Reject,
     /* 101978 */ // Label 1895: @101978
     /* 101978 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(102024), // Rule ID 822 //
     /* 101983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 101989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 101992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 101996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102000 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102004 */   // (uaddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 102004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i32),
     /* 102007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102009 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102011 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102016 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102022 */   GIR_RootConstrainSelectedInstOperands,
     /* 102023 */   // GIR_Coverage, 822,
     /* 102023 */   GIR_EraseRootFromParent_Done,
     /* 102024 */ // Label 1904: @102024
     /* 102024 */ GIM_Reject,
     /* 102025 */ // Label 1896: @102025
     /* 102025 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102071), // Rule ID 828 //
     /* 102030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 102036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 102039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102047 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102051 */   // (uaddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 102051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i64),
     /* 102054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102056 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102058 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102063 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102069 */   GIR_RootConstrainSelectedInstOperands,
     /* 102070 */   // GIR_Coverage, 828,
     /* 102070 */   GIR_EraseRootFromParent_Done,
     /* 102071 */ // Label 1905: @102071
     /* 102071 */ GIM_Reject,
     /* 102072 */ // Label 1897: @102072
     /* 102072 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102118), // Rule ID 821 //
     /* 102077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 102083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 102086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102098 */   // (uaddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 102098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i16),
     /* 102101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102103 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102105 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102110 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102116 */   GIR_RootConstrainSelectedInstOperands,
     /* 102117 */   // GIR_Coverage, 821,
     /* 102117 */   GIR_EraseRootFromParent_Done,
     /* 102118 */ // Label 1906: @102118
     /* 102118 */ GIM_Reject,
     /* 102119 */ // Label 1898: @102119
     /* 102119 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102232),
     /* 102124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102130 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102170), // Rule ID 824 //
     /* 102135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102150 */     // (uaddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 102150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i32),
     /* 102153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102168 */     GIR_RootConstrainSelectedInstOperands,
     /* 102169 */     // GIR_Coverage, 824,
     /* 102169 */     GIR_EraseRootFromParent_Done,
     /* 102170 */   // Label 1908: @102170
     /* 102170 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102231), // Rule ID 3524 //
     /* 102175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102190 */     // (uaddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu32),
     /* 102205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102229 */     GIR_RootConstrainSelectedInstOperands,
     /* 102230 */     // GIR_Coverage, 3524,
     /* 102230 */     GIR_EraseRootFromParent_Done,
     /* 102231 */   // Label 1909: @102231
     /* 102231 */   GIM_Reject,
     /* 102232 */ // Label 1907: @102232
     /* 102232 */ GIM_Reject,
     /* 102233 */ // Label 1899: @102233
     /* 102233 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(102279), // Rule ID 825 //
     /* 102238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102259 */   // (uaddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 102259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i8),
     /* 102262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102264 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102266 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102271 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102277 */   GIR_RootConstrainSelectedInstOperands,
     /* 102278 */   // GIR_Coverage, 825,
     /* 102278 */   GIR_EraseRootFromParent_Done,
     /* 102279 */ // Label 1910: @102279
     /* 102279 */ GIM_Reject,
     /* 102280 */ // Label 1900: @102280
     /* 102280 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(102393),
     /* 102285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102291 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(102331), // Rule ID 823 //
     /* 102296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102311 */     // (uaddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 102311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i16),
     /* 102314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102329 */     GIR_RootConstrainSelectedInstOperands,
     /* 102330 */     // GIR_Coverage, 823,
     /* 102330 */     GIR_EraseRootFromParent_Done,
     /* 102331 */   // Label 1912: @102331
     /* 102331 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(102392), // Rule ID 3521 //
     /* 102336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102351 */     // (uaddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu16),
     /* 102366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102375 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102390 */     GIR_RootConstrainSelectedInstOperands,
     /* 102391 */     // GIR_Coverage, 3521,
     /* 102391 */     GIR_EraseRootFromParent_Done,
     /* 102392 */   // Label 1913: @102392
     /* 102392 */   GIM_Reject,
     /* 102393 */ // Label 1911: @102393
     /* 102393 */ GIM_Reject,
     /* 102394 */ // Label 1901: @102394
     /* 102394 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(102507),
     /* 102399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102405 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(102445), // Rule ID 826 //
     /* 102410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102425 */     // (uaddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 102425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv16i8),
     /* 102428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102443 */     GIR_RootConstrainSelectedInstOperands,
     /* 102444 */     // GIR_Coverage, 826,
     /* 102444 */     GIR_EraseRootFromParent_Done,
     /* 102445 */   // Label 1915: @102445
     /* 102445 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(102506), // Rule ID 3518 //
     /* 102450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102465 */     // (uaddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu8),
     /* 102480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102504 */     GIR_RootConstrainSelectedInstOperands,
     /* 102505 */     // GIR_Coverage, 3518,
     /* 102505 */     GIR_EraseRootFromParent_Done,
     /* 102506 */   // Label 1916: @102506
     /* 102506 */   GIM_Reject,
     /* 102507 */ // Label 1914: @102507
     /* 102507 */ GIM_Reject,
     /* 102508 */ // Label 1902: @102508
     /* 102508 */ GIM_Reject,
     /* 102509 */ // Label 31: @102509
     /* 102509 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1926*/ GIMT_Encode4(103808),
     /* 102520 */ /*GILLT_s32*//*Label 1917*/ GIMT_Encode4(102580),
     /* 102524 */ /*GILLT_s64*//*Label 1918*/ GIMT_Encode4(102921), GIMT_Encode4(0),
     /* 102532 */ /*GILLT_v2s32*//*Label 1919*/ GIMT_Encode4(102968),
     /* 102536 */ /*GILLT_v2s64*//*Label 1920*/ GIMT_Encode4(103015), GIMT_Encode4(0),
     /* 102544 */ /*GILLT_v4s16*//*Label 1921*/ GIMT_Encode4(103216),
     /* 102548 */ /*GILLT_v4s32*//*Label 1922*/ GIMT_Encode4(103263), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102560 */ /*GILLT_v8s8*//*Label 1923*/ GIMT_Encode4(103533),
     /* 102564 */ /*GILLT_v8s16*//*Label 1924*/ GIMT_Encode4(103580), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102576 */ /*GILLT_v16s8*//*Label 1925*/ GIMT_Encode4(103694),
     /* 102580 */ // Label 1917: @102580
     /* 102580 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(102920),
     /* 102585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 102591 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(102653), // Rule ID 5651 //
     /* 102596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 102599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 102603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 102611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 102615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102620 */     // MIs[1] Rn
     /* 102620 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 102625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102631 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 102631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 102634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102651 */     GIR_RootConstrainSelectedInstOperands,
     /* 102652 */     // GIR_Coverage, 5651,
     /* 102652 */     GIR_EraseRootFromParent_Done,
     /* 102653 */   // Label 1928: @102653
     /* 102653 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(102715), // Rule ID 5685 //
     /* 102658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 102673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 102677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102682 */     // MIs[1] Rn
     /* 102682 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 102687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102693 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 102693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 102696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102713 */     GIR_RootConstrainSelectedInstOperands,
     /* 102714 */     // GIR_Coverage, 5685,
     /* 102714 */     GIR_EraseRootFromParent_Done,
     /* 102715 */   // Label 1929: @102715
     /* 102715 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(102777), // Rule ID 1867 //
     /* 102720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 102723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 102727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 102739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 102743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102748 */     // MIs[1] Rn
     /* 102748 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 102753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102755 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 102755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 102758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 102762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102775 */     GIR_RootConstrainSelectedInstOperands,
     /* 102776 */     // GIR_Coverage, 1867,
     /* 102776 */     GIR_EraseRootFromParent_Done,
     /* 102777 */   // Label 1930: @102777
     /* 102777 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(102839), // Rule ID 2133 //
     /* 102782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 102801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 102805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102810 */     // MIs[1] Rn
     /* 102810 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 102815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102817 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 102817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 102820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 102824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102837 */     GIR_RootConstrainSelectedInstOperands,
     /* 102838 */     // GIR_Coverage, 2133,
     /* 102838 */     GIR_EraseRootFromParent_Done,
     /* 102839 */   // Label 1931: @102839
     /* 102839 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(102879), // Rule ID 1865 //
     /* 102844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 102847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 102851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102859 */     // (saddsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QADD:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 102859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /* 102862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102864 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 102866 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 102868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102877 */     GIR_RootConstrainSelectedInstOperands,
     /* 102878 */     // GIR_Coverage, 1865,
     /* 102878 */     GIR_EraseRootFromParent_Done,
     /* 102879 */   // Label 1932: @102879
     /* 102879 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(102919), // Rule ID 2131 //
     /* 102884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102899 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 102899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /* 102902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 102906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 102908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102917 */     GIR_RootConstrainSelectedInstOperands,
     /* 102918 */     // GIR_Coverage, 2131,
     /* 102918 */     GIR_EraseRootFromParent_Done,
     /* 102919 */   // Label 1933: @102919
     /* 102919 */   GIM_Reject,
     /* 102920 */ // Label 1927: @102920
     /* 102920 */ GIM_Reject,
     /* 102921 */ // Label 1918: @102921
     /* 102921 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(102967), // Rule ID 819 //
     /* 102926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 102935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102947 */   // (saddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 102947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv1i64),
     /* 102950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102952 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102954 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102959 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102965 */   GIR_RootConstrainSelectedInstOperands,
     /* 102966 */   // GIR_Coverage, 819,
     /* 102966 */   GIR_EraseRootFromParent_Done,
     /* 102967 */ // Label 1934: @102967
     /* 102967 */ GIM_Reject,
     /* 102968 */ // Label 1919: @102968
     /* 102968 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(103014), // Rule ID 814 //
     /* 102973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 102979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 102982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102990 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102994 */   // (saddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 102994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i32),
     /* 102997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102999 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103001 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103006 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103012 */   GIR_RootConstrainSelectedInstOperands,
     /* 103013 */   // GIR_Coverage, 814,
     /* 103013 */   GIR_EraseRootFromParent_Done,
     /* 103014 */ // Label 1935: @103014
     /* 103014 */ GIM_Reject,
     /* 103015 */ // Label 1920: @103015
     /* 103015 */ GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(103215),
     /* 103020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 103023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 103026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103030 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(103104), // Rule ID 5742 //
     /* 103035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103046 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103049 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103058 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103078 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 3814:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$src1)  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103083 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103102 */     GIR_RootConstrainSelectedInstOperands,
     /* 103103 */     // GIR_Coverage, 5742,
     /* 103103 */     GIR_EraseRootFromParent_Done,
     /* 103104 */   // Label 1937: @103104
     /* 103104 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(103178), // Rule ID 2486 //
     /* 103109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103124 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103127 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103136 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103152 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3814:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103176 */     GIR_RootConstrainSelectedInstOperands,
     /* 103177 */     // GIR_Coverage, 2486,
     /* 103177 */     GIR_EraseRootFromParent_Done,
     /* 103178 */   // Label 1938: @103178
     /* 103178 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(103214), // Rule ID 820 //
     /* 103183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103194 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 103194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i64),
     /* 103197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103212 */     GIR_RootConstrainSelectedInstOperands,
     /* 103213 */     // GIR_Coverage, 820,
     /* 103213 */     GIR_EraseRootFromParent_Done,
     /* 103214 */   // Label 1939: @103214
     /* 103214 */   GIM_Reject,
     /* 103215 */ // Label 1936: @103215
     /* 103215 */ GIM_Reject,
     /* 103216 */ // Label 1921: @103216
     /* 103216 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(103262), // Rule ID 813 //
     /* 103221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 103227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103238 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103242 */   // (saddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i16),
     /* 103245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103247 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103249 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103254 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103260 */   GIR_RootConstrainSelectedInstOperands,
     /* 103261 */   // GIR_Coverage, 813,
     /* 103261 */   GIR_EraseRootFromParent_Done,
     /* 103262 */ // Label 1940: @103262
     /* 103262 */ GIM_Reject,
     /* 103263 */ // Label 1922: @103263
     /* 103263 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(103532),
     /* 103268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103274 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(103352), // Rule ID 5741 //
     /* 103279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103294 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103297 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103306 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103326 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 3814:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103331 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103350 */     GIR_RootConstrainSelectedInstOperands,
     /* 103351 */     // GIR_Coverage, 5741,
     /* 103351 */     GIR_EraseRootFromParent_Done,
     /* 103352 */   // Label 1942: @103352
     /* 103352 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(103430), // Rule ID 2485 //
     /* 103357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103376 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103379 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103388 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103404 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3814:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103409 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103428 */     GIR_RootConstrainSelectedInstOperands,
     /* 103429 */     // GIR_Coverage, 2485,
     /* 103429 */     GIR_EraseRootFromParent_Done,
     /* 103430 */   // Label 1943: @103430
     /* 103430 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(103470), // Rule ID 816 //
     /* 103435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103450 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 103450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i32),
     /* 103453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103455 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103468 */     GIR_RootConstrainSelectedInstOperands,
     /* 103469 */     // GIR_Coverage, 816,
     /* 103469 */     GIR_EraseRootFromParent_Done,
     /* 103470 */   // Label 1944: @103470
     /* 103470 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(103531), // Rule ID 3515 //
     /* 103475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103490 */     // (saddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 103490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs32),
     /* 103505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103529 */     GIR_RootConstrainSelectedInstOperands,
     /* 103530 */     // GIR_Coverage, 3515,
     /* 103530 */     GIR_EraseRootFromParent_Done,
     /* 103531 */   // Label 1945: @103531
     /* 103531 */   GIM_Reject,
     /* 103532 */ // Label 1941: @103532
     /* 103532 */ GIM_Reject,
     /* 103533 */ // Label 1923: @103533
     /* 103533 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(103579), // Rule ID 817 //
     /* 103538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 103544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 103547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103559 */   // (saddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 103559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i8),
     /* 103562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103564 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103566 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103571 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103577 */   GIR_RootConstrainSelectedInstOperands,
     /* 103578 */   // GIR_Coverage, 817,
     /* 103578 */   GIR_EraseRootFromParent_Done,
     /* 103579 */ // Label 1946: @103579
     /* 103579 */ GIM_Reject,
     /* 103580 */ // Label 1924: @103580
     /* 103580 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(103693),
     /* 103585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103591 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(103631), // Rule ID 815 //
     /* 103596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103611 */     // (saddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 103611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i16),
     /* 103614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103623 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103629 */     GIR_RootConstrainSelectedInstOperands,
     /* 103630 */     // GIR_Coverage, 815,
     /* 103630 */     GIR_EraseRootFromParent_Done,
     /* 103631 */   // Label 1948: @103631
     /* 103631 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(103692), // Rule ID 3512 //
     /* 103636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103651 */     // (saddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 103651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs16),
     /* 103666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103690 */     GIR_RootConstrainSelectedInstOperands,
     /* 103691 */     // GIR_Coverage, 3512,
     /* 103691 */     GIR_EraseRootFromParent_Done,
     /* 103692 */   // Label 1949: @103692
     /* 103692 */   GIM_Reject,
     /* 103693 */ // Label 1947: @103693
     /* 103693 */ GIM_Reject,
     /* 103694 */ // Label 1925: @103694
     /* 103694 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(103807),
     /* 103699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 103702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 103705 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(103745), // Rule ID 818 //
     /* 103710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103725 */     // (saddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 103725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv16i8),
     /* 103728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103737 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103743 */     GIR_RootConstrainSelectedInstOperands,
     /* 103744 */     // GIR_Coverage, 818,
     /* 103744 */     GIR_EraseRootFromParent_Done,
     /* 103745 */   // Label 1951: @103745
     /* 103745 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(103806), // Rule ID 3509 //
     /* 103750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103765 */     // (saddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 103765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs8),
     /* 103780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103795 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103804 */     GIR_RootConstrainSelectedInstOperands,
     /* 103805 */     // GIR_Coverage, 3509,
     /* 103805 */     GIR_EraseRootFromParent_Done,
     /* 103806 */   // Label 1952: @103806
     /* 103806 */   GIM_Reject,
     /* 103807 */ // Label 1950: @103807
     /* 103807 */ GIM_Reject,
     /* 103808 */ // Label 1926: @103808
     /* 103808 */ GIM_Reject,
     /* 103809 */ // Label 32: @103809
     /* 103809 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1961*/ GIMT_Encode4(104453),
     /* 103820 */ /*GILLT_s64*//*Label 1953*/ GIMT_Encode4(103876), GIMT_Encode4(0),
     /* 103828 */ /*GILLT_v2s32*//*Label 1954*/ GIMT_Encode4(103923),
     /* 103832 */ /*GILLT_v2s64*//*Label 1955*/ GIMT_Encode4(103970), GIMT_Encode4(0),
     /* 103840 */ /*GILLT_v4s16*//*Label 1956*/ GIMT_Encode4(104017),
     /* 103844 */ /*GILLT_v4s32*//*Label 1957*/ GIMT_Encode4(104064), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103856 */ /*GILLT_v8s8*//*Label 1958*/ GIMT_Encode4(104178),
     /* 103860 */ /*GILLT_v8s16*//*Label 1959*/ GIMT_Encode4(104225), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103872 */ /*GILLT_v16s8*//*Label 1960*/ GIMT_Encode4(104339),
     /* 103876 */ // Label 1953: @103876
     /* 103876 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(103922), // Rule ID 1019 //
     /* 103881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 103887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 103890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103902 */   // (usubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 103902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv1i64),
     /* 103905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103907 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103909 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103914 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103920 */   GIR_RootConstrainSelectedInstOperands,
     /* 103921 */   // GIR_Coverage, 1019,
     /* 103921 */   GIR_EraseRootFromParent_Done,
     /* 103922 */ // Label 1962: @103922
     /* 103922 */ GIM_Reject,
     /* 103923 */ // Label 1954: @103923
     /* 103923 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(103969), // Rule ID 1014 //
     /* 103928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 103934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103949 */   // (usubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i32),
     /* 103952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103954 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103956 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103961 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103967 */   GIR_RootConstrainSelectedInstOperands,
     /* 103968 */   // GIR_Coverage, 1014,
     /* 103968 */   GIR_EraseRootFromParent_Done,
     /* 103969 */ // Label 1963: @103969
     /* 103969 */ GIM_Reject,
     /* 103970 */ // Label 1955: @103970
     /* 103970 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(104016), // Rule ID 1020 //
     /* 103975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 103981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 103984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103996 */   // (usubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 103996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i64),
     /* 103999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104001 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104003 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104008 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104014 */   GIR_RootConstrainSelectedInstOperands,
     /* 104015 */   // GIR_Coverage, 1020,
     /* 104015 */   GIR_EraseRootFromParent_Done,
     /* 104016 */ // Label 1964: @104016
     /* 104016 */ GIM_Reject,
     /* 104017 */ // Label 1956: @104017
     /* 104017 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(104063), // Rule ID 1013 //
     /* 104022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 104028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 104031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104043 */   // (usubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i16),
     /* 104046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104048 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104050 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104055 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104061 */   GIR_RootConstrainSelectedInstOperands,
     /* 104062 */   // GIR_Coverage, 1013,
     /* 104062 */   GIR_EraseRootFromParent_Done,
     /* 104063 */ // Label 1965: @104063
     /* 104063 */ GIM_Reject,
     /* 104064 */ // Label 1957: @104064
     /* 104064 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(104177),
     /* 104069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 104072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 104075 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(104115), // Rule ID 1016 //
     /* 104080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104095 */     // (usubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 104095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i32),
     /* 104098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104113 */     GIR_RootConstrainSelectedInstOperands,
     /* 104114 */     // GIR_Coverage, 1016,
     /* 104114 */     GIR_EraseRootFromParent_Done,
     /* 104115 */   // Label 1967: @104115
     /* 104115 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(104176), // Rule ID 3542 //
     /* 104120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104135 */     // (usubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 104135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu32),
     /* 104150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104174 */     GIR_RootConstrainSelectedInstOperands,
     /* 104175 */     // GIR_Coverage, 3542,
     /* 104175 */     GIR_EraseRootFromParent_Done,
     /* 104176 */   // Label 1968: @104176
     /* 104176 */   GIM_Reject,
     /* 104177 */ // Label 1966: @104177
     /* 104177 */ GIM_Reject,
     /* 104178 */ // Label 1958: @104178
     /* 104178 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(104224), // Rule ID 1017 //
     /* 104183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104204 */   // (usubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i8),
     /* 104207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104209 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104211 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104216 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104222 */   GIR_RootConstrainSelectedInstOperands,
     /* 104223 */   // GIR_Coverage, 1017,
     /* 104223 */   GIR_EraseRootFromParent_Done,
     /* 104224 */ // Label 1969: @104224
     /* 104224 */ GIM_Reject,
     /* 104225 */ // Label 1959: @104225
     /* 104225 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(104338),
     /* 104230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104236 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(104276), // Rule ID 1015 //
     /* 104241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104256 */     // (usubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i16),
     /* 104259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104274 */     GIR_RootConstrainSelectedInstOperands,
     /* 104275 */     // GIR_Coverage, 1015,
     /* 104275 */     GIR_EraseRootFromParent_Done,
     /* 104276 */   // Label 1971: @104276
     /* 104276 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(104337), // Rule ID 3539 //
     /* 104281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104296 */     // (usubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu16),
     /* 104311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104335 */     GIR_RootConstrainSelectedInstOperands,
     /* 104336 */     // GIR_Coverage, 3539,
     /* 104336 */     GIR_EraseRootFromParent_Done,
     /* 104337 */   // Label 1972: @104337
     /* 104337 */   GIM_Reject,
     /* 104338 */ // Label 1970: @104338
     /* 104338 */ GIM_Reject,
     /* 104339 */ // Label 1960: @104339
     /* 104339 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(104452),
     /* 104344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104350 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(104390), // Rule ID 1018 //
     /* 104355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104370 */     // (usubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv16i8),
     /* 104373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104388 */     GIR_RootConstrainSelectedInstOperands,
     /* 104389 */     // GIR_Coverage, 1018,
     /* 104389 */     GIR_EraseRootFromParent_Done,
     /* 104390 */   // Label 1974: @104390
     /* 104390 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(104451), // Rule ID 3536 //
     /* 104395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104410 */     // (usubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu8),
     /* 104425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104427 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104449 */     GIR_RootConstrainSelectedInstOperands,
     /* 104450 */     // GIR_Coverage, 3536,
     /* 104450 */     GIR_EraseRootFromParent_Done,
     /* 104451 */   // Label 1975: @104451
     /* 104451 */   GIM_Reject,
     /* 104452 */ // Label 1973: @104452
     /* 104452 */ GIM_Reject,
     /* 104453 */ // Label 1961: @104453
     /* 104453 */ GIM_Reject,
     /* 104454 */ // Label 33: @104454
     /* 104454 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1985*/ GIMT_Encode4(105473),
     /* 104465 */ /*GILLT_s32*//*Label 1976*/ GIMT_Encode4(104525),
     /* 104469 */ /*GILLT_s64*//*Label 1977*/ GIMT_Encode4(104742), GIMT_Encode4(0),
     /* 104477 */ /*GILLT_v2s32*//*Label 1978*/ GIMT_Encode4(104789),
     /* 104481 */ /*GILLT_v2s64*//*Label 1979*/ GIMT_Encode4(104836), GIMT_Encode4(0),
     /* 104489 */ /*GILLT_v4s16*//*Label 1980*/ GIMT_Encode4(104959),
     /* 104493 */ /*GILLT_v4s32*//*Label 1981*/ GIMT_Encode4(105006), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104505 */ /*GILLT_v8s8*//*Label 1982*/ GIMT_Encode4(105198),
     /* 104509 */ /*GILLT_v8s16*//*Label 1983*/ GIMT_Encode4(105245), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104521 */ /*GILLT_v16s8*//*Label 1984*/ GIMT_Encode4(105359),
     /* 104525 */ // Label 1976: @104525
     /* 104525 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(104741),
     /* 104530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 104536 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(104598), // Rule ID 1868 //
     /* 104541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 104544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 104548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 104560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 104564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104569 */     // MIs[1] Rn
     /* 104569 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 104574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104576 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 104576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /* 104579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 104583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 104587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104596 */     GIR_RootConstrainSelectedInstOperands,
     /* 104597 */     // GIR_Coverage, 1868,
     /* 104597 */     GIR_EraseRootFromParent_Done,
     /* 104598 */   // Label 1987: @104598
     /* 104598 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(104660), // Rule ID 2134 //
     /* 104603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 104606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 104622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 104626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104631 */     // MIs[1] Rn
     /* 104631 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 104636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104638 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 104638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /* 104641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 104645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 104649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104658 */     GIR_RootConstrainSelectedInstOperands,
     /* 104659 */     // GIR_Coverage, 2134,
     /* 104659 */     GIR_EraseRootFromParent_Done,
     /* 104660 */   // Label 1988: @104660
     /* 104660 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(104700), // Rule ID 1866 //
     /* 104665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 104668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 104672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 104676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 104680 */     // (ssubsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QSUB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 104680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /* 104683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104685 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 104687 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 104689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104698 */     GIR_RootConstrainSelectedInstOperands,
     /* 104699 */     // GIR_Coverage, 1866,
     /* 104699 */     GIR_EraseRootFromParent_Done,
     /* 104700 */   // Label 1989: @104700
     /* 104700 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(104740), // Rule ID 2132 //
     /* 104705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 104708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 104720 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 104720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /* 104723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 104727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 104729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104738 */     GIR_RootConstrainSelectedInstOperands,
     /* 104739 */     // GIR_Coverage, 2132,
     /* 104739 */     GIR_EraseRootFromParent_Done,
     /* 104740 */   // Label 1990: @104740
     /* 104740 */   GIM_Reject,
     /* 104741 */ // Label 1986: @104741
     /* 104741 */ GIM_Reject,
     /* 104742 */ // Label 1977: @104742
     /* 104742 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(104788), // Rule ID 1011 //
     /* 104747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 104756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104768 */   // (ssubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 104768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv1i64),
     /* 104771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104773 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104775 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104780 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104786 */   GIR_RootConstrainSelectedInstOperands,
     /* 104787 */   // GIR_Coverage, 1011,
     /* 104787 */   GIR_EraseRootFromParent_Done,
     /* 104788 */ // Label 1991: @104788
     /* 104788 */ GIM_Reject,
     /* 104789 */ // Label 1978: @104789
     /* 104789 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(104835), // Rule ID 1006 //
     /* 104794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 104800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 104803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104815 */   // (ssubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 104815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i32),
     /* 104818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104820 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104822 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104827 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104833 */   GIR_RootConstrainSelectedInstOperands,
     /* 104834 */   // GIR_Coverage, 1006,
     /* 104834 */   GIR_EraseRootFromParent_Done,
     /* 104835 */ // Label 1992: @104835
     /* 104835 */ GIM_Reject,
     /* 104836 */ // Label 1979: @104836
     /* 104836 */ GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(104958),
     /* 104841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 104844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 104847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104855 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(104925), // Rule ID 2493 //
     /* 104860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 104871 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 104874 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 104879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 104883 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 104887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104899 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3814:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLSLv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 104899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv2i64),
     /* 104902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104904 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 104906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 104910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 104914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104923 */     GIR_RootConstrainSelectedInstOperands,
     /* 104924 */     // GIR_Coverage, 2493,
     /* 104924 */     GIR_EraseRootFromParent_Done,
     /* 104925 */   // Label 1994: @104925
     /* 104925 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(104957), // Rule ID 1012 //
     /* 104930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104937 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 104937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i64),
     /* 104940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104955 */     GIR_RootConstrainSelectedInstOperands,
     /* 104956 */     // GIR_Coverage, 1012,
     /* 104956 */     GIR_EraseRootFromParent_Done,
     /* 104957 */   // Label 1995: @104957
     /* 104957 */   GIM_Reject,
     /* 104958 */ // Label 1993: @104958
     /* 104958 */ GIM_Reject,
     /* 104959 */ // Label 1980: @104959
     /* 104959 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(105005), // Rule ID 1005 //
     /* 104964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 104970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 104973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104985 */   // (ssubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i16),
     /* 104988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104990 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104992 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104997 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105003 */   GIR_RootConstrainSelectedInstOperands,
     /* 105004 */   // GIR_Coverage, 1005,
     /* 105004 */   GIR_EraseRootFromParent_Done,
     /* 105005 */ // Label 1996: @105005
     /* 105005 */ GIM_Reject,
     /* 105006 */ // Label 1981: @105006
     /* 105006 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(105197),
     /* 105011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 105017 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(105095), // Rule ID 2492 //
     /* 105022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105041 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105044 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105053 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 105057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105069 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3814:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLSLv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv4i32),
     /* 105072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105074 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105087 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105093 */     GIR_RootConstrainSelectedInstOperands,
     /* 105094 */     // GIR_Coverage, 2492,
     /* 105094 */     GIR_EraseRootFromParent_Done,
     /* 105095 */   // Label 1998: @105095
     /* 105095 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(105135), // Rule ID 1008 //
     /* 105100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105115 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 105115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i32),
     /* 105118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105120 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105127 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105133 */     GIR_RootConstrainSelectedInstOperands,
     /* 105134 */     // GIR_Coverage, 1008,
     /* 105134 */     GIR_EraseRootFromParent_Done,
     /* 105135 */   // Label 1999: @105135
     /* 105135 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(105196), // Rule ID 3533 //
     /* 105140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105155 */     // (ssubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 105155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs32),
     /* 105170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105194 */     GIR_RootConstrainSelectedInstOperands,
     /* 105195 */     // GIR_Coverage, 3533,
     /* 105195 */     GIR_EraseRootFromParent_Done,
     /* 105196 */   // Label 2000: @105196
     /* 105196 */   GIM_Reject,
     /* 105197 */ // Label 1997: @105197
     /* 105197 */ GIM_Reject,
     /* 105198 */ // Label 1982: @105198
     /* 105198 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(105244), // Rule ID 1009 //
     /* 105203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 105212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105224 */   // (ssubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 105224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i8),
     /* 105227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105229 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105231 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105236 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105242 */   GIR_RootConstrainSelectedInstOperands,
     /* 105243 */   // GIR_Coverage, 1009,
     /* 105243 */   GIR_EraseRootFromParent_Done,
     /* 105244 */ // Label 2001: @105244
     /* 105244 */ GIM_Reject,
     /* 105245 */ // Label 1983: @105245
     /* 105245 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(105358),
     /* 105250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105256 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(105296), // Rule ID 1007 //
     /* 105261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105276 */     // (ssubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 105276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i16),
     /* 105279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105294 */     GIR_RootConstrainSelectedInstOperands,
     /* 105295 */     // GIR_Coverage, 1007,
     /* 105295 */     GIR_EraseRootFromParent_Done,
     /* 105296 */   // Label 2003: @105296
     /* 105296 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(105357), // Rule ID 3530 //
     /* 105301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105316 */     // (ssubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 105316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs16),
     /* 105331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105340 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105355 */     GIR_RootConstrainSelectedInstOperands,
     /* 105356 */     // GIR_Coverage, 3530,
     /* 105356 */     GIR_EraseRootFromParent_Done,
     /* 105357 */   // Label 2004: @105357
     /* 105357 */   GIM_Reject,
     /* 105358 */ // Label 2002: @105358
     /* 105358 */ GIM_Reject,
     /* 105359 */ // Label 1984: @105359
     /* 105359 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(105472),
     /* 105364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 105367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 105370 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(105410), // Rule ID 1010 //
     /* 105375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105390 */     // (ssubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 105390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv16i8),
     /* 105393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105408 */     GIR_RootConstrainSelectedInstOperands,
     /* 105409 */     // GIR_Coverage, 1010,
     /* 105409 */     GIR_EraseRootFromParent_Done,
     /* 105410 */   // Label 2006: @105410
     /* 105410 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(105471), // Rule ID 3527 //
     /* 105415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105430 */     // (ssubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 105430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs8),
     /* 105445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105460 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105469 */     GIR_RootConstrainSelectedInstOperands,
     /* 105470 */     // GIR_Coverage, 3527,
     /* 105470 */     GIR_EraseRootFromParent_Done,
     /* 105471 */   // Label 2007: @105471
     /* 105471 */   GIM_Reject,
     /* 105472 */ // Label 2005: @105472
     /* 105472 */ GIM_Reject,
     /* 105473 */ // Label 1985: @105473
     /* 105473 */ GIM_Reject,
     /* 105474 */ // Label 34: @105474
     /* 105474 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2015*/ GIMT_Encode4(107826),
     /* 105485 */ /*GILLT_s16*//*Label 2008*/ GIMT_Encode4(105537),
     /* 105489 */ /*GILLT_s32*//*Label 2009*/ GIMT_Encode4(105584),
     /* 105493 */ /*GILLT_s64*//*Label 2010*/ GIMT_Encode4(107179), GIMT_Encode4(0),
     /* 105501 */ /*GILLT_v2s32*//*Label 2011*/ GIMT_Encode4(107226), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105513 */ /*GILLT_v4s16*//*Label 2012*/ GIMT_Encode4(107273),
     /* 105517 */ /*GILLT_v4s32*//*Label 2013*/ GIMT_Encode4(107458), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105533 */ /*GILLT_v8s16*//*Label 2014*/ GIMT_Encode4(107572),
     /* 105537 */ // Label 2008: @105537
     /* 105537 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(105583), // Rule ID 614 //
     /* 105542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 105545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 105548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 105551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 105555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 105559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 105563 */   // (fadd:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VADDH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 105563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDH),
     /* 105566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 105568 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 105570 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 105572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105575 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105581 */   GIR_RootConstrainSelectedInstOperands,
     /* 105582 */   // GIR_Coverage, 614,
     /* 105582 */   GIR_EraseRootFromParent_Done,
     /* 105583 */ // Label 2016: @105583
     /* 105583 */ GIM_Reject,
     /* 105584 */ // Label 2009: @105584
     /* 105584 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(107178),
     /* 105589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105599 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(105927), // Rule ID 5918 //
     /* 105604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 105607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 105615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105639 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 105639 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 105642 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105646 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 105653 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 105656 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105660 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105665 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 105668 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105673 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 105676 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105680 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105685 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 105688 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 105692 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 105695 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105700 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105705 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 105710 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 105713 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105717 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 105724 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 105727 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105731 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105736 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 105739 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105744 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 105747 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105751 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105756 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 105759 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 105763 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 105766 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105771 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105776 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 105781 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 105784 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105788 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 105795 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 105798 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105802 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105807 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 105810 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105815 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 105818 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105822 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105827 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 105830 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 105834 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 105837 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105842 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105847 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 105852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 105855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 105859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105864 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105867 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 105870 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 105873 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 105876 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 105887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105896 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 105916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 105921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 105926 */     // GIR_Coverage, 5918,
     /* 105926 */     GIR_EraseRootFromParent_Done,
     /* 105927 */   // Label 2018: @105927
     /* 105927 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(106255), // Rule ID 5919 //
     /* 105932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 105935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 105943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 105965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105967 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 105967 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 105970 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105974 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 105981 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 105984 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105988 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105993 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 105996 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106001 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106004 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106008 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106013 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106016 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106020 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106023 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106028 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106033 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106038 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106041 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106045 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106052 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106055 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106059 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106064 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106067 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106072 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106075 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106079 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106084 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106087 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106091 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106094 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106099 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106104 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106109 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106112 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106116 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106123 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106126 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106130 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106135 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106138 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106143 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106146 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106150 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106155 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106158 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106162 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106165 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106170 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106175 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106180 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106183 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 106187 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106192 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106195 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106198 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106201 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106204 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106224 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106237 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106249 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106254 */     // GIR_Coverage, 5919,
     /* 106254 */     GIR_EraseRootFromParent_Done,
     /* 106255 */   // Label 2019: @106255
     /* 106255 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(106583), // Rule ID 2697 //
     /* 106260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106295 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106295 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106298 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106302 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106309 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106312 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106316 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106321 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106324 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106329 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106332 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106336 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106341 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106344 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106348 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106351 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106356 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106361 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106366 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106369 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106373 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106380 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106383 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106387 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106392 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106395 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106400 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106403 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106407 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106412 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106415 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106419 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106422 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106427 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106432 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106437 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106440 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106444 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106451 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106454 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106458 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106463 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106466 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106471 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106474 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106478 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106483 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106486 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 106490 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106493 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106498 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106503 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106508 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106511 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106515 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106520 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106523 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106526 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106529 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106532 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106552 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106565 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106582 */     // GIR_Coverage, 2697,
     /* 106582 */     GIR_EraseRootFromParent_Done,
     /* 106583 */   // Label 2020: @106583
     /* 106583 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(106911), // Rule ID 2699 //
     /* 106588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 106591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106623 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106623 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106626 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106630 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106637 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106640 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106644 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106649 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106652 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106657 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106660 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106664 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106669 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106672 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106676 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106679 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106684 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106689 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106694 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106697 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106701 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106708 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106711 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106715 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106720 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106723 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106728 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106731 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106735 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106740 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106743 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106747 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106750 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106755 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106760 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106765 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106768 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106772 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106779 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106782 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106786 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106791 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106794 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106799 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106802 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106806 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106811 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106814 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 106818 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106821 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106826 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106831 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106836 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106839 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 106843 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106848 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106851 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106854 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106857 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106860 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106880 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106893 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106910 */     // GIR_Coverage, 2699,
     /* 106910 */     GIR_EraseRootFromParent_Done,
     /* 106911 */   // Label 2021: @106911
     /* 106911 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(106947), // Rule ID 613 //
     /* 106916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 106919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106927 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VADDS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 106927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDS),
     /* 106930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 106932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 106934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 106936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 106939 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106945 */     GIR_RootConstrainSelectedInstOperands,
     /* 106946 */     // GIR_Coverage, 613,
     /* 106946 */     GIR_EraseRootFromParent_Done,
     /* 106947 */   // Label 2022: @106947
     /* 106947 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(107177), // Rule ID 2694 //
     /* 106952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 106955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106963 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VADDfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106963 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106966 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106970 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106977 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106980 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106984 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106989 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106992 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106997 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107000 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107004 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107009 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107012 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 107016 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107019 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107024 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107029 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107034 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107037 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107041 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107048 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107051 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107055 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107060 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107063 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107068 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107071 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107075 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107080 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107083 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 107087 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107090 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107095 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107100 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107105 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107108 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107112 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107117 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107120 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107123 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107126 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107146 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107159 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107176 */     // GIR_Coverage, 2694,
     /* 107176 */     GIR_EraseRootFromParent_Done,
     /* 107177 */   // Label 2023: @107177
     /* 107177 */   GIM_Reject,
     /* 107178 */ // Label 2017: @107178
     /* 107178 */ GIM_Reject,
     /* 107179 */ // Label 2010: @107179
     /* 107179 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(107225), // Rule ID 612 //
     /* 107184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 107187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 107193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107201 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107205 */   // (fadd:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VADDD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 107205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDD),
     /* 107208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 107210 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 107212 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 107214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107217 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107223 */   GIR_RootConstrainSelectedInstOperands,
     /* 107224 */   // GIR_Coverage, 612,
     /* 107224 */   GIR_EraseRootFromParent_Done,
     /* 107225 */ // Label 2024: @107225
     /* 107225 */ GIM_Reject,
     /* 107226 */ // Label 2011: @107226
     /* 107226 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(107272), // Rule ID 761 //
     /* 107231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 107240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107252 */   // (fadd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VADDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 107252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107257 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107259 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107264 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107270 */   GIR_RootConstrainSelectedInstOperands,
     /* 107271 */   // GIR_Coverage, 761,
     /* 107271 */   GIR_EraseRootFromParent_Done,
     /* 107272 */ // Label 2025: @107272
     /* 107272 */ GIM_Reject,
     /* 107273 */ // Label 2012: @107273
     /* 107273 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(107457),
     /* 107278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107288 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(107354), // Rule ID 5581 //
     /* 107293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107328 */     // (fadd:{ *:[v4f16] } (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm), DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107333 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107352 */     GIR_RootConstrainSelectedInstOperands,
     /* 107353 */     // GIR_Coverage, 5581,
     /* 107353 */     GIR_EraseRootFromParent_Done,
     /* 107354 */   // Label 2027: @107354
     /* 107354 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(107420), // Rule ID 942 //
     /* 107359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107394 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107399 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107418 */     GIR_RootConstrainSelectedInstOperands,
     /* 107419 */     // GIR_Coverage, 942,
     /* 107419 */     GIR_EraseRootFromParent_Done,
     /* 107420 */   // Label 2028: @107420
     /* 107420 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(107456), // Rule ID 763 //
     /* 107425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 107428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107436 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VADDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhd),
     /* 107439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107454 */     GIR_RootConstrainSelectedInstOperands,
     /* 107455 */     // GIR_Coverage, 763,
     /* 107455 */     GIR_EraseRootFromParent_Done,
     /* 107456 */   // Label 2029: @107456
     /* 107456 */   GIM_Reject,
     /* 107457 */ // Label 2026: @107457
     /* 107457 */ GIM_Reject,
     /* 107458 */ // Label 2013: @107458
     /* 107458 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(107571),
     /* 107463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 107469 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(107509), // Rule ID 762 //
     /* 107474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107489 */     // (fadd:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VADDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 107489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfq),
     /* 107492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107507 */     GIR_RootConstrainSelectedInstOperands,
     /* 107508 */     // GIR_Coverage, 762,
     /* 107508 */     GIR_EraseRootFromParent_Done,
     /* 107509 */   // Label 2031: @107509
     /* 107509 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(107570), // Rule ID 4013 //
     /* 107514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 107517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107529 */     // (fadd:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 107529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 107532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf32),
     /* 107544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 107546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 107548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 107550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107553 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107568 */     GIR_RootConstrainSelectedInstOperands,
     /* 107569 */     // GIR_Coverage, 4013,
     /* 107569 */     GIR_EraseRootFromParent_Done,
     /* 107570 */   // Label 2032: @107570
     /* 107570 */   GIM_Reject,
     /* 107571 */ // Label 2030: @107571
     /* 107571 */ GIM_Reject,
     /* 107572 */ // Label 2014: @107572
     /* 107572 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(107825),
     /* 107577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 107583 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(107653), // Rule ID 5582 //
     /* 107588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 107611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107627 */     // (fadd:{ *:[v8f16] } (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm), QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 107627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 107630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107632 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107651 */     GIR_RootConstrainSelectedInstOperands,
     /* 107652 */     // GIR_Coverage, 5582,
     /* 107652 */     GIR_EraseRootFromParent_Done,
     /* 107653 */   // Label 2034: @107653
     /* 107653 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(107723), // Rule ID 943 //
     /* 107658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 107685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107697 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 107697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 107700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107702 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107721 */     GIR_RootConstrainSelectedInstOperands,
     /* 107722 */     // GIR_Coverage, 943,
     /* 107722 */     GIR_EraseRootFromParent_Done,
     /* 107723 */   // Label 2035: @107723
     /* 107723 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(107763), // Rule ID 764 //
     /* 107728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 107731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107743 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VADDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 107743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhq),
     /* 107746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107761 */     GIR_RootConstrainSelectedInstOperands,
     /* 107762 */     // GIR_Coverage, 764,
     /* 107762 */     GIR_EraseRootFromParent_Done,
     /* 107763 */   // Label 2036: @107763
     /* 107763 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(107824), // Rule ID 4017 //
     /* 107768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 107771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 107783 */     // (fadd:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 107783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 107786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf16),
     /* 107798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 107800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 107802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 107804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107822 */     GIR_RootConstrainSelectedInstOperands,
     /* 107823 */     // GIR_Coverage, 4017,
     /* 107823 */     GIR_EraseRootFromParent_Done,
     /* 107824 */   // Label 2037: @107824
     /* 107824 */   GIM_Reject,
     /* 107825 */ // Label 2033: @107825
     /* 107825 */ GIM_Reject,
     /* 107826 */ // Label 2015: @107826
     /* 107826 */ GIM_Reject,
     /* 107827 */ // Label 35: @107827
     /* 107827 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2045*/ GIMT_Encode4(109503),
     /* 107838 */ /*GILLT_s16*//*Label 2038*/ GIMT_Encode4(107890),
     /* 107842 */ /*GILLT_s32*//*Label 2039*/ GIMT_Encode4(107937),
     /* 107846 */ /*GILLT_s64*//*Label 2040*/ GIMT_Encode4(108864), GIMT_Encode4(0),
     /* 107854 */ /*GILLT_v2s32*//*Label 2041*/ GIMT_Encode4(108911), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 107866 */ /*GILLT_v4s16*//*Label 2042*/ GIMT_Encode4(108958),
     /* 107870 */ /*GILLT_v4s32*//*Label 2043*/ GIMT_Encode4(109135), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 107886 */ /*GILLT_v8s16*//*Label 2044*/ GIMT_Encode4(109249),
     /* 107890 */ // Label 2038: @107890
     /* 107890 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(107936), // Rule ID 617 //
     /* 107895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 107898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 107901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 107904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 107908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 107912 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 107916 */   // (fsub:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VSUBH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 107916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBH),
     /* 107919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 107921 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 107923 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 107925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107928 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107934 */   GIR_RootConstrainSelectedInstOperands,
     /* 107935 */   // GIR_Coverage, 617,
     /* 107935 */   GIR_EraseRootFromParent_Done,
     /* 107936 */ // Label 2046: @107936
     /* 107936 */ GIM_Reject,
     /* 107937 */ // Label 2039: @107937
     /* 107937 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(108863),
     /* 107942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 107945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107956 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(108280), // Rule ID 2698 //
     /* 107961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 107964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 107976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107992 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107992 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 107995 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107999 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108006 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108009 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108013 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108018 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108021 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108026 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108029 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108033 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108038 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108041 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108045 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108048 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108053 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108058 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108063 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108066 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108070 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108077 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108080 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108084 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108089 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108092 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108097 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108100 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108104 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108109 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108112 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108116 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108119 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108124 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108129 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108134 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108137 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108141 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108148 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108151 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108155 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108160 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108163 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108168 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108171 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108175 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108180 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108183 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108187 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108190 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108195 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108200 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108205 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108208 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLSfd),
     /* 108212 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108217 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108220 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108223 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108226 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108229 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108249 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108262 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108274 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108279 */     // GIR_Coverage, 2698,
     /* 108279 */     GIR_EraseRootFromParent_Done,
     /* 108280 */   // Label 2048: @108280
     /* 108280 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(108604), // Rule ID 2700 //
     /* 108285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 108288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108316 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108316 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108319 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108323 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108330 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108333 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108337 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108342 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108345 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108350 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108353 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108357 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108362 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108365 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108369 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108372 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108377 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108382 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108387 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108390 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108394 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108401 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108404 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108408 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108413 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108416 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108421 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108424 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108428 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108433 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108436 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108440 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108443 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108448 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108453 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108458 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108461 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108465 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108472 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108475 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108479 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108484 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108487 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108492 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108504 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108507 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108511 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108514 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108519 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108524 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108529 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108532 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 108536 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108541 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108544 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108547 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108550 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108553 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108573 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108586 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108603 */     // GIR_Coverage, 2700,
     /* 108603 */     GIR_EraseRootFromParent_Done,
     /* 108604 */   // Label 2049: @108604
     /* 108604 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(108636), // Rule ID 616 //
     /* 108609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 108612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108616 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VSUBS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 108616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBS),
     /* 108619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 108621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 108623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 108625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108634 */     GIR_RootConstrainSelectedInstOperands,
     /* 108635 */     // GIR_Coverage, 616,
     /* 108635 */     GIR_EraseRootFromParent_Done,
     /* 108636 */   // Label 2050: @108636
     /* 108636 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(108862), // Rule ID 2695 //
     /* 108641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 108644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108648 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VSUBfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108648 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108651 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108655 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108662 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108665 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108669 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108674 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108677 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108682 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108685 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108689 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108694 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108697 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 108701 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108704 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108709 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108714 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108719 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108722 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108726 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108733 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108736 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108740 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108745 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108748 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108753 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108756 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108760 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108765 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108768 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 108772 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108775 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108780 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108785 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 108797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108802 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108805 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108808 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108811 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108831 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108844 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108861 */     // GIR_Coverage, 2695,
     /* 108861 */     GIR_EraseRootFromParent_Done,
     /* 108862 */   // Label 2051: @108862
     /* 108862 */   GIM_Reject,
     /* 108863 */ // Label 2047: @108863
     /* 108863 */ GIM_Reject,
     /* 108864 */ // Label 2040: @108864
     /* 108864 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(108910), // Rule ID 615 //
     /* 108869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 108872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 108878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108890 */   // (fsub:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VSUBD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 108890 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBD),
     /* 108893 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 108895 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 108897 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 108899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108902 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108908 */   GIR_RootConstrainSelectedInstOperands,
     /* 108909 */   // GIR_Coverage, 615,
     /* 108909 */   GIR_EraseRootFromParent_Done,
     /* 108910 */ // Label 2052: @108910
     /* 108910 */ GIM_Reject,
     /* 108911 */ // Label 2041: @108911
     /* 108911 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(108957), // Rule ID 965 //
     /* 108916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 108919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 108925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108937 */   // (fsub:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VSUBfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 108937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 108940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108942 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108944 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108949 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108955 */   GIR_RootConstrainSelectedInstOperands,
     /* 108956 */   // GIR_Coverage, 965,
     /* 108956 */   GIR_EraseRootFromParent_Done,
     /* 108957 */ // Label 2053: @108957
     /* 108957 */ GIM_Reject,
     /* 108958 */ // Label 2042: @108958
     /* 108958 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(109134),
     /* 108963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 108969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 108977 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(109039), // Rule ID 920 //
     /* 108982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 108985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109013 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VMLShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShd),
     /* 109016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109018 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109037 */     GIR_RootConstrainSelectedInstOperands,
     /* 109038 */     // GIR_Coverage, 920,
     /* 109038 */     GIR_EraseRootFromParent_Done,
     /* 109039 */   // Label 2055: @109039
     /* 109039 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(109101), // Rule ID 946 //
     /* 109044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109075 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShd),
     /* 109078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109080 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109099 */     GIR_RootConstrainSelectedInstOperands,
     /* 109100 */     // GIR_Coverage, 946,
     /* 109100 */     GIR_EraseRootFromParent_Done,
     /* 109101 */   // Label 2056: @109101
     /* 109101 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(109133), // Rule ID 967 //
     /* 109106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109113 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VSUBhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhd),
     /* 109116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109131 */     GIR_RootConstrainSelectedInstOperands,
     /* 109132 */     // GIR_Coverage, 967,
     /* 109132 */     GIR_EraseRootFromParent_Done,
     /* 109133 */   // Label 2057: @109133
     /* 109133 */   GIM_Reject,
     /* 109134 */ // Label 2054: @109134
     /* 109134 */ GIM_Reject,
     /* 109135 */ // Label 2043: @109135
     /* 109135 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109248),
     /* 109140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 109146 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(109186), // Rule ID 966 //
     /* 109151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109166 */     // (fsub:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VSUBfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 109166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfq),
     /* 109169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109184 */     GIR_RootConstrainSelectedInstOperands,
     /* 109185 */     // GIR_Coverage, 966,
     /* 109185 */     GIR_EraseRootFromParent_Done,
     /* 109186 */   // Label 2059: @109186
     /* 109186 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(109247), // Rule ID 4021 //
     /* 109191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109206 */     // (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VSUBf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 109206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf32),
     /* 109221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109245 */     GIR_RootConstrainSelectedInstOperands,
     /* 109246 */     // GIR_Coverage, 4021,
     /* 109246 */     GIR_EraseRootFromParent_Done,
     /* 109247 */   // Label 2060: @109247
     /* 109247 */   GIM_Reject,
     /* 109248 */ // Label 2058: @109248
     /* 109248 */ GIM_Reject,
     /* 109249 */ // Label 2044: @109249
     /* 109249 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(109502),
     /* 109254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109260 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(109330), // Rule ID 921 //
     /* 109265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109304 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VMLShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShq),
     /* 109307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109309 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109328 */     GIR_RootConstrainSelectedInstOperands,
     /* 109329 */     // GIR_Coverage, 921,
     /* 109329 */     GIR_EraseRootFromParent_Done,
     /* 109330 */   // Label 2062: @109330
     /* 109330 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109400), // Rule ID 947 //
     /* 109335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109374 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShq),
     /* 109377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109379 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109398 */     GIR_RootConstrainSelectedInstOperands,
     /* 109399 */     // GIR_Coverage, 947,
     /* 109399 */     GIR_EraseRootFromParent_Done,
     /* 109400 */   // Label 2063: @109400
     /* 109400 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(109440), // Rule ID 968 //
     /* 109405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109420 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VSUBhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhq),
     /* 109423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109438 */     GIR_RootConstrainSelectedInstOperands,
     /* 109439 */     // GIR_Coverage, 968,
     /* 109439 */     GIR_EraseRootFromParent_Done,
     /* 109440 */   // Label 2064: @109440
     /* 109440 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(109501), // Rule ID 4025 //
     /* 109445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109460 */     // (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VSUBf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 109460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf16),
     /* 109475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109484 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109499 */     GIR_RootConstrainSelectedInstOperands,
     /* 109500 */     // GIR_Coverage, 4025,
     /* 109500 */     GIR_EraseRootFromParent_Done,
     /* 109501 */   // Label 2065: @109501
     /* 109501 */   GIM_Reject,
     /* 109502 */ // Label 2061: @109502
     /* 109502 */ GIM_Reject,
     /* 109503 */ // Label 2045: @109503
     /* 109503 */ GIM_Reject,
     /* 109504 */ // Label 36: @109504
     /* 109504 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2073*/ GIMT_Encode4(110484),
     /* 109515 */ /*GILLT_s16*//*Label 2066*/ GIMT_Encode4(109567),
     /* 109519 */ /*GILLT_s32*//*Label 2067*/ GIMT_Encode4(109614),
     /* 109523 */ /*GILLT_s64*//*Label 2068*/ GIMT_Encode4(110003), GIMT_Encode4(0),
     /* 109531 */ /*GILLT_v2s32*//*Label 2069*/ GIMT_Encode4(110162), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109543 */ /*GILLT_v4s16*//*Label 2070*/ GIMT_Encode4(110209),
     /* 109547 */ /*GILLT_v4s32*//*Label 2071*/ GIMT_Encode4(110256), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 109563 */ /*GILLT_v8s16*//*Label 2072*/ GIMT_Encode4(110370),
     /* 109567 */ // Label 2066: @109567
     /* 109567 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(109613), // Rule ID 623 //
     /* 109572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 109575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 109581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 109585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 109589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 109593 */   // (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 109593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULH),
     /* 109596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109598 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 109600 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 109602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109605 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109611 */   GIR_RootConstrainSelectedInstOperands,
     /* 109612 */   // GIR_Coverage, 623,
     /* 109612 */   GIR_EraseRootFromParent_Done,
     /* 109613 */ // Label 2074: @109613
     /* 109613 */ GIM_Reject,
     /* 109614 */ // Label 2067: @109614
     /* 109614 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(110002),
     /* 109619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109629 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(109682), // Rule ID 2299 //
     /* 109634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 109637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 109645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 109649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109660 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a), SPR:{ *:[f32] }:$b)  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 109660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 109663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 109669 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 109671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109680 */     GIR_RootConstrainSelectedInstOperands,
     /* 109681 */     // GIR_Coverage, 2299,
     /* 109681 */     GIR_EraseRootFromParent_Done,
     /* 109682 */   // Label 2076: @109682
     /* 109682 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(109735), // Rule ID 5708 //
     /* 109687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 109690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 109702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 109706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109713 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$b, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 109713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 109716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 109722 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 109724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109733 */     GIR_RootConstrainSelectedInstOperands,
     /* 109734 */     // GIR_Coverage, 5708,
     /* 109734 */     GIR_EraseRootFromParent_Done,
     /* 109735 */   // Label 2077: @109735
     /* 109735 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(109771), // Rule ID 622 //
     /* 109740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 109743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109751 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 109751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULS),
     /* 109754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 109758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 109760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109769 */     GIR_RootConstrainSelectedInstOperands,
     /* 109770 */     // GIR_Coverage, 622,
     /* 109770 */     GIR_EraseRootFromParent_Done,
     /* 109771 */   // Label 2078: @109771
     /* 109771 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(110001), // Rule ID 2696 //
     /* 109776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 109779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109787 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMULfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 109787 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 109790 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109794 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 109801 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 109804 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109808 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109813 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 109816 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109821 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 109824 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109828 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109833 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 109836 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 109840 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 109843 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109848 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109853 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109858 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 109861 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109865 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 109872 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 109875 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109879 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109884 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 109887 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109892 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 109895 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109899 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109904 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 109907 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 109911 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 109914 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109919 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109924 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109929 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109932 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 109936 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109941 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109944 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109947 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109950 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109970 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109983 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110000 */     // GIR_Coverage, 2696,
     /* 110000 */     GIR_EraseRootFromParent_Done,
     /* 110001 */   // Label 2079: @110001
     /* 110001 */   GIM_Reject,
     /* 110002 */ // Label 2075: @110002
     /* 110002 */ GIM_Reject,
     /* 110003 */ // Label 2068: @110003
     /* 110003 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110161),
     /* 110008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 110014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110018 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110071), // Rule ID 2298 //
     /* 110023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110049 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a), DPR:{ *:[f64] }:$b)  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110058 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110069 */     GIR_RootConstrainSelectedInstOperands,
     /* 110070 */     // GIR_Coverage, 2298,
     /* 110070 */     GIR_EraseRootFromParent_Done,
     /* 110071 */   // Label 2081: @110071
     /* 110071 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110124), // Rule ID 5707 //
     /* 110076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110102 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$b, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110111 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110122 */     GIR_RootConstrainSelectedInstOperands,
     /* 110123 */     // GIR_Coverage, 5707,
     /* 110123 */     GIR_EraseRootFromParent_Done,
     /* 110124 */   // Label 2082: @110124
     /* 110124 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110160), // Rule ID 621 //
     /* 110129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 110132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110140 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 110140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULD),
     /* 110143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 110147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 110149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110158 */     GIR_RootConstrainSelectedInstOperands,
     /* 110159 */     // GIR_Coverage, 621,
     /* 110159 */     GIR_EraseRootFromParent_Done,
     /* 110160 */   // Label 2083: @110160
     /* 110160 */   GIM_Reject,
     /* 110161 */ // Label 2080: @110161
     /* 110161 */ GIM_Reject,
     /* 110162 */ // Label 2069: @110162
     /* 110162 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110208), // Rule ID 840 //
     /* 110167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 110176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110188 */   // (fmul:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMULfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 110188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110193 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110195 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110206 */   GIR_RootConstrainSelectedInstOperands,
     /* 110207 */   // GIR_Coverage, 840,
     /* 110207 */   GIR_EraseRootFromParent_Done,
     /* 110208 */ // Label 2084: @110208
     /* 110208 */ GIM_Reject,
     /* 110209 */ // Label 2070: @110209
     /* 110209 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110255), // Rule ID 842 //
     /* 110214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 110223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110235 */   // (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMULhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 110235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhd),
     /* 110238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110240 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110242 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110247 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110253 */   GIR_RootConstrainSelectedInstOperands,
     /* 110254 */   // GIR_Coverage, 842,
     /* 110254 */   GIR_EraseRootFromParent_Done,
     /* 110255 */ // Label 2085: @110255
     /* 110255 */ GIM_Reject,
     /* 110256 */ // Label 2071: @110256
     /* 110256 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110369),
     /* 110261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 110267 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110307), // Rule ID 841 //
     /* 110272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110287 */     // (fmul:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMULfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 110287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfq),
     /* 110290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110305 */     GIR_RootConstrainSelectedInstOperands,
     /* 110306 */     // GIR_Coverage, 841,
     /* 110306 */     GIR_EraseRootFromParent_Done,
     /* 110307 */   // Label 2087: @110307
     /* 110307 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(110368), // Rule ID 3985 //
     /* 110312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110327 */     // (fmul:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 110327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf32),
     /* 110342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110366 */     GIR_RootConstrainSelectedInstOperands,
     /* 110367 */     // GIR_Coverage, 3985,
     /* 110367 */     GIR_EraseRootFromParent_Done,
     /* 110368 */   // Label 2088: @110368
     /* 110368 */   GIM_Reject,
     /* 110369 */ // Label 2086: @110369
     /* 110369 */ GIM_Reject,
     /* 110370 */ // Label 2072: @110370
     /* 110370 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(110483),
     /* 110375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 110381 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(110421), // Rule ID 843 //
     /* 110386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110401 */     // (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMULhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 110401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhq),
     /* 110404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110419 */     GIR_RootConstrainSelectedInstOperands,
     /* 110420 */     // GIR_Coverage, 843,
     /* 110420 */     GIR_EraseRootFromParent_Done,
     /* 110421 */   // Label 2090: @110421
     /* 110421 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(110482), // Rule ID 3989 //
     /* 110426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110441 */     // (fmul:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 110441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf16),
     /* 110456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110480 */     GIR_RootConstrainSelectedInstOperands,
     /* 110481 */     // GIR_Coverage, 3989,
     /* 110481 */     GIR_EraseRootFromParent_Done,
     /* 110482 */   // Label 2091: @110482
     /* 110482 */   GIM_Reject,
     /* 110483 */ // Label 2089: @110483
     /* 110483 */ GIM_Reject,
     /* 110484 */ // Label 2073: @110484
     /* 110484 */ GIM_Reject,
     /* 110485 */ // Label 37: @110485
     /* 110485 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2099*/ GIMT_Encode4(112575),
     /* 110496 */ /*GILLT_s16*//*Label 2092*/ GIMT_Encode4(110548),
     /* 110500 */ /*GILLT_s32*//*Label 2093*/ GIMT_Encode4(110935),
     /* 110504 */ /*GILLT_s64*//*Label 2094*/ GIMT_Encode4(111322), GIMT_Encode4(0),
     /* 110512 */ /*GILLT_v2s32*//*Label 2095*/ GIMT_Encode4(111709), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110524 */ /*GILLT_v4s16*//*Label 2096*/ GIMT_Encode4(111889),
     /* 110528 */ /*GILLT_v4s32*//*Label 2097*/ GIMT_Encode4(111945), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110544 */ /*GILLT_v8s16*//*Label 2098*/ GIMT_Encode4(112323),
     /* 110548 */ // Label 2092: @110548
     /* 110548 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(110934),
     /* 110553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 110559 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 110562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110566 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(110640), // Rule ID 2403 //
     /* 110571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 110586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 110599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 110607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 110614 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 110617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 110623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 110627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110638 */     GIR_RootConstrainSelectedInstOperands,
     /* 110639 */     // GIR_Coverage, 2403,
     /* 110639 */     GIR_EraseRootFromParent_Done,
     /* 110640 */   // Label 2101: @110640
     /* 110640 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(110714), // Rule ID 5716 //
     /* 110645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 110664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 110673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 110681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 110688 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 110691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 110697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 110701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 110703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110712 */     GIR_RootConstrainSelectedInstOperands,
     /* 110713 */     // GIR_Coverage, 5716,
     /* 110713 */     GIR_EraseRootFromParent_Done,
     /* 110714 */   // Label 2102: @110714
     /* 110714 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(110773), // Rule ID 2395 //
     /* 110719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 110734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110749 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 110752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 110756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 110760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110771 */     GIR_RootConstrainSelectedInstOperands,
     /* 110772 */     // GIR_Coverage, 2395,
     /* 110772 */     GIR_EraseRootFromParent_Done,
     /* 110773 */   // Label 2103: @110773
     /* 110773 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(110832), // Rule ID 5713 //
     /* 110778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 110797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110808 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 110811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 110815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 110819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 110821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110830 */     GIR_RootConstrainSelectedInstOperands,
     /* 110831 */     // GIR_Coverage, 5713,
     /* 110831 */     GIR_EraseRootFromParent_Done,
     /* 110832 */   // Label 2104: @110832
     /* 110832 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(110891), // Rule ID 2408 //
     /* 110837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 110852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 110860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110867 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 110870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 110876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110889 */     GIR_RootConstrainSelectedInstOperands,
     /* 110890 */     // GIR_Coverage, 2408,
     /* 110890 */     GIR_EraseRootFromParent_Done,
     /* 110891 */   // Label 2105: @110891
     /* 110891 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(110933), // Rule ID 2389 //
     /* 110896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110911 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAH),
     /* 110914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 110918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110931 */     GIR_RootConstrainSelectedInstOperands,
     /* 110932 */     // GIR_Coverage, 2389,
     /* 110932 */     GIR_EraseRootFromParent_Done,
     /* 110933 */   // Label 2106: @110933
     /* 110933 */   GIM_Reject,
     /* 110934 */ // Label 2100: @110934
     /* 110934 */ GIM_Reject,
     /* 110935 */ // Label 2093: @110935
     /* 110935 */ GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(111321),
     /* 110940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 110946 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 110949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110953 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(111027), // Rule ID 2402 //
     /* 110958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 110961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 110986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 110994 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111001 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111025 */     GIR_RootConstrainSelectedInstOperands,
     /* 111026 */     // GIR_Coverage, 2402,
     /* 111026 */     GIR_EraseRootFromParent_Done,
     /* 111027 */   // Label 2108: @111027
     /* 111027 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(111101), // Rule ID 5715 //
     /* 111032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111075 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111099 */     GIR_RootConstrainSelectedInstOperands,
     /* 111100 */     // GIR_Coverage, 5715,
     /* 111100 */     GIR_EraseRootFromParent_Done,
     /* 111101 */   // Label 2109: @111101
     /* 111101 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(111160), // Rule ID 2394 //
     /* 111106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111136 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111158 */     GIR_RootConstrainSelectedInstOperands,
     /* 111159 */     // GIR_Coverage, 2394,
     /* 111159 */     GIR_EraseRootFromParent_Done,
     /* 111160 */   // Label 2110: @111160
     /* 111160 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(111219), // Rule ID 5712 //
     /* 111165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111195 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111217 */     GIR_RootConstrainSelectedInstOperands,
     /* 111218 */     // GIR_Coverage, 5712,
     /* 111218 */     GIR_EraseRootFromParent_Done,
     /* 111219 */   // Label 2111: @111219
     /* 111219 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(111278), // Rule ID 2407 //
     /* 111224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111254 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 111257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111270 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111276 */     GIR_RootConstrainSelectedInstOperands,
     /* 111277 */     // GIR_Coverage, 2407,
     /* 111277 */     GIR_EraseRootFromParent_Done,
     /* 111278 */   // Label 2112: @111278
     /* 111278 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(111320), // Rule ID 2388 //
     /* 111283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111298 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAS),
     /* 111301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111318 */     GIR_RootConstrainSelectedInstOperands,
     /* 111319 */     // GIR_Coverage, 2388,
     /* 111319 */     GIR_EraseRootFromParent_Done,
     /* 111320 */   // Label 2113: @111320
     /* 111320 */   GIM_Reject,
     /* 111321 */ // Label 2107: @111321
     /* 111321 */ GIM_Reject,
     /* 111322 */ // Label 2094: @111322
     /* 111322 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(111708),
     /* 111327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 111333 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 111336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111340 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(111414), // Rule ID 2401 //
     /* 111345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111388 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111412 */     GIR_RootConstrainSelectedInstOperands,
     /* 111413 */     // GIR_Coverage, 2401,
     /* 111413 */     GIR_EraseRootFromParent_Done,
     /* 111414 */   // Label 2115: @111414
     /* 111414 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(111488), // Rule ID 5714 //
     /* 111419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111462 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 111477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111486 */     GIR_RootConstrainSelectedInstOperands,
     /* 111487 */     // GIR_Coverage, 5714,
     /* 111487 */     GIR_EraseRootFromParent_Done,
     /* 111488 */   // Label 2116: @111488
     /* 111488 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(111547), // Rule ID 2393 //
     /* 111493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111523 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 111526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 111530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111545 */     GIR_RootConstrainSelectedInstOperands,
     /* 111546 */     // GIR_Coverage, 2393,
     /* 111546 */     GIR_EraseRootFromParent_Done,
     /* 111547 */   // Label 2117: @111547
     /* 111547 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(111606), // Rule ID 5711 //
     /* 111552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111582 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 111585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 111589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 111595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111604 */     GIR_RootConstrainSelectedInstOperands,
     /* 111605 */     // GIR_Coverage, 5711,
     /* 111605 */     GIR_EraseRootFromParent_Done,
     /* 111606 */   // Label 2118: @111606
     /* 111606 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(111665), // Rule ID 2406 //
     /* 111611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111641 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 111644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ddin
     /* 111650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 111652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111663 */     GIR_RootConstrainSelectedInstOperands,
     /* 111664 */     // GIR_Coverage, 2406,
     /* 111664 */     GIR_EraseRootFromParent_Done,
     /* 111665 */   // Label 2119: @111665
     /* 111665 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(111707), // Rule ID 2387 //
     /* 111670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111685 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAD),
     /* 111688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 111692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 111694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111705 */     GIR_RootConstrainSelectedInstOperands,
     /* 111706 */     // GIR_Coverage, 2387,
     /* 111706 */     GIR_EraseRootFromParent_Done,
     /* 111707 */   // Label 2120: @111707
     /* 111707 */   GIM_Reject,
     /* 111708 */ // Label 2114: @111708
     /* 111708 */ GIM_Reject,
     /* 111709 */ // Label 2095: @111709
     /* 111709 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(111888),
     /* 111714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 111720 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 111723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111727 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(111786), // Rule ID 2500 //
     /* 111732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 111735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111762 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 111762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 111765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 111767 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 111769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 111773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 111775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111784 */     GIR_RootConstrainSelectedInstOperands,
     /* 111785 */     // GIR_Coverage, 2500,
     /* 111785 */     GIR_EraseRootFromParent_Done,
     /* 111786 */   // Label 2122: @111786
     /* 111786 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(111845), // Rule ID 5754 //
     /* 111791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 111794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111821 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm, (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 111821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 111824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 111826 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 111828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 111832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 111834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111843 */     GIR_RootConstrainSelectedInstOperands,
     /* 111844 */     // GIR_Coverage, 5754,
     /* 111844 */     GIR_EraseRootFromParent_Done,
     /* 111845 */   // Label 2123: @111845
     /* 111845 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(111887), // Rule ID 2498 //
     /* 111850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 111853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111865 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMAfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 111865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 111868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 111870 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 111872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 111874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 111876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111879 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111885 */     GIR_RootConstrainSelectedInstOperands,
     /* 111886 */     // GIR_Coverage, 2498,
     /* 111886 */     GIR_EraseRootFromParent_Done,
     /* 111887 */   // Label 2124: @111887
     /* 111887 */   GIM_Reject,
     /* 111888 */ // Label 2121: @111888
     /* 111888 */ GIM_Reject,
     /* 111889 */ // Label 2096: @111889
     /* 111889 */ GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(111944), // Rule ID 2496 //
     /* 111894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 111897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 111903 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 111906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111914 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111918 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111922 */   // (fma:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm, DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 111922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 111925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 111927 */   GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 111929 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 111931 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 111933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111936 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111942 */   GIR_RootConstrainSelectedInstOperands,
     /* 111943 */   // GIR_Coverage, 2496,
     /* 111943 */   GIR_EraseRootFromParent_Done,
     /* 111944 */ // Label 2125: @111944
     /* 111944 */ GIM_Reject,
     /* 111945 */ // Label 2097: @111945
     /* 111945 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(112322),
     /* 111950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 111956 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 111959 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(112022), // Rule ID 2501 //
     /* 111964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 111967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 111971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 111988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 111992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 111996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111998 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 111998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112003 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112020 */     GIR_RootConstrainSelectedInstOperands,
     /* 112021 */     // GIR_Coverage, 2501,
     /* 112021 */     GIR_EraseRootFromParent_Done,
     /* 112022 */   // Label 2127: @112022
     /* 112022 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112091), // Rule ID 3999 //
     /* 112027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112061 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112066 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112072 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112089 */     GIR_RootConstrainSelectedInstOperands,
     /* 112090 */     // GIR_Coverage, 3999,
     /* 112090 */     GIR_EraseRootFromParent_Done,
     /* 112091 */   // Label 2128: @112091
     /* 112091 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(112154), // Rule ID 5755 //
     /* 112096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112130 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm, (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112135 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112152 */     GIR_RootConstrainSelectedInstOperands,
     /* 112153 */     // GIR_Coverage, 5755,
     /* 112153 */     GIR_EraseRootFromParent_Done,
     /* 112154 */   // Label 2129: @112154
     /* 112154 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(112223), // Rule ID 6035 //
     /* 112159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112193 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m2, (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112198 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112204 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112221 */     GIR_RootConstrainSelectedInstOperands,
     /* 112222 */     // GIR_Coverage, 6035,
     /* 112222 */     GIR_EraseRootFromParent_Done,
     /* 112223 */   // Label 2130: @112223
     /* 112223 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112269), // Rule ID 2499 //
     /* 112228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112247 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMAfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfq),
     /* 112250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112252 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112267 */     GIR_RootConstrainSelectedInstOperands,
     /* 112268 */     // GIR_Coverage, 2499,
     /* 112268 */     GIR_EraseRootFromParent_Done,
     /* 112269 */   // Label 2131: @112269
     /* 112269 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112321), // Rule ID 4003 //
     /* 112274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112293 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1, MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMAf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf32),
     /* 112296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112298 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112300 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112302 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112319 */     GIR_RootConstrainSelectedInstOperands,
     /* 112320 */     // GIR_Coverage, 4003,
     /* 112320 */     GIR_EraseRootFromParent_Done,
     /* 112321 */   // Label 2132: @112321
     /* 112321 */   GIM_Reject,
     /* 112322 */ // Label 2126: @112322
     /* 112322 */ GIM_Reject,
     /* 112323 */ // Label 2098: @112323
     /* 112323 */ GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112574),
     /* 112328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 112334 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 112337 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112406), // Rule ID 4009 //
     /* 112342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112376 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112381 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112387 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112404 */     GIR_RootConstrainSelectedInstOperands,
     /* 112405 */     // GIR_Coverage, 4009,
     /* 112405 */     GIR_EraseRootFromParent_Done,
     /* 112406 */   // Label 2134: @112406
     /* 112406 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(112475), // Rule ID 6037 //
     /* 112411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112445 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m2, (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112450 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112456 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112473 */     GIR_RootConstrainSelectedInstOperands,
     /* 112474 */     // GIR_Coverage, 6037,
     /* 112474 */     GIR_EraseRootFromParent_Done,
     /* 112475 */   // Label 2135: @112475
     /* 112475 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(112521), // Rule ID 2497 //
     /* 112480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112499 */     // (fma:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm, QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 112499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 112502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112504 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112519 */     GIR_RootConstrainSelectedInstOperands,
     /* 112520 */     // GIR_Coverage, 2497,
     /* 112520 */     GIR_EraseRootFromParent_Done,
     /* 112521 */   // Label 2136: @112521
     /* 112521 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(112573), // Rule ID 4006 //
     /* 112526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112545 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1, MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMAf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf16),
     /* 112548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112550 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112552 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112554 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112571 */     GIR_RootConstrainSelectedInstOperands,
     /* 112572 */     // GIR_Coverage, 4006,
     /* 112572 */     GIR_EraseRootFromParent_Done,
     /* 112573 */   // Label 2137: @112573
     /* 112573 */   GIM_Reject,
     /* 112574 */ // Label 2133: @112574
     /* 112574 */ GIM_Reject,
     /* 112575 */ // Label 2099: @112575
     /* 112575 */ GIM_Reject,
     /* 112576 */ // Label 38: @112576
     /* 112576 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2141*/ GIMT_Encode4(112740),
     /* 112587 */ /*GILLT_s16*//*Label 2138*/ GIMT_Encode4(112599),
     /* 112591 */ /*GILLT_s32*//*Label 2139*/ GIMT_Encode4(112646),
     /* 112595 */ /*GILLT_s64*//*Label 2140*/ GIMT_Encode4(112693),
     /* 112599 */ // Label 2138: @112599
     /* 112599 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(112645), // Rule ID 620 //
     /* 112604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 112607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 112613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112625 */   // (fdiv:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VDIVH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 112625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVH),
     /* 112628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 112630 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 112632 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 112634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112637 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112643 */   GIR_RootConstrainSelectedInstOperands,
     /* 112644 */   // GIR_Coverage, 620,
     /* 112644 */   GIR_EraseRootFromParent_Done,
     /* 112645 */ // Label 2142: @112645
     /* 112645 */ GIM_Reject,
     /* 112646 */ // Label 2139: @112646
     /* 112646 */ GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(112692), // Rule ID 619 //
     /* 112651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 112654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 112657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 112660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 112664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 112668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 112672 */   // (fdiv:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VDIVS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 112672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVS),
     /* 112675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 112677 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 112679 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 112681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112684 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112690 */   GIR_RootConstrainSelectedInstOperands,
     /* 112691 */   // GIR_Coverage, 619,
     /* 112691 */   GIR_EraseRootFromParent_Done,
     /* 112692 */ // Label 2143: @112692
     /* 112692 */ GIM_Reject,
     /* 112693 */ // Label 2140: @112693
     /* 112693 */ GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(112739), // Rule ID 618 //
     /* 112698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 112701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 112707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112719 */   // (fdiv:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VDIVD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVD),
     /* 112722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112724 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112726 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112731 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112737 */   GIR_RootConstrainSelectedInstOperands,
     /* 112738 */   // GIR_Coverage, 618,
     /* 112738 */   GIR_EraseRootFromParent_Done,
     /* 112739 */ // Label 2144: @112739
     /* 112739 */ GIM_Reject,
     /* 112740 */ // Label 2141: @112740
     /* 112740 */ GIM_Reject,
     /* 112741 */ // Label 39: @112741
     /* 112741 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2152*/ GIMT_Encode4(114271),
     /* 112752 */ /*GILLT_s16*//*Label 2145*/ GIMT_Encode4(112804),
     /* 112756 */ /*GILLT_s32*//*Label 2146*/ GIMT_Encode4(113151),
     /* 112760 */ /*GILLT_s64*//*Label 2147*/ GIMT_Encode4(113650), GIMT_Encode4(0),
     /* 112768 */ /*GILLT_v2s32*//*Label 2148*/ GIMT_Encode4(113997), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 112780 */ /*GILLT_v4s16*//*Label 2149*/ GIMT_Encode4(114035),
     /* 112784 */ /*GILLT_v4s32*//*Label 2150*/ GIMT_Encode4(114073), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 112800 */ /*GILLT_v8s16*//*Label 2151*/ GIMT_Encode4(114172),
     /* 112804 */ // Label 2145: @112804
     /* 112804 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(113150),
     /* 112809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112816 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(112901), // Rule ID 2411 //
     /* 112821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 112824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 112832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 112836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 112840 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 112844 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 112848 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112852 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 112856 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112873 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 112873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 112876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 112878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 112882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 112886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 112890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112899 */     GIR_RootConstrainSelectedInstOperands,
     /* 112900 */     // GIR_Coverage, 2411,
     /* 112900 */     GIR_EraseRootFromParent_Done,
     /* 112901 */   // Label 2154: @112901
     /* 112901 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(112986), // Rule ID 5719 //
     /* 112906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 112909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 112917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 112921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 112925 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 112929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 112946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 112956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112958 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 112958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 112961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 112963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 112967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 112971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 112975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112984 */     GIR_RootConstrainSelectedInstOperands,
     /* 112985 */     // GIR_Coverage, 5719,
     /* 112985 */     GIR_EraseRootFromParent_Done,
     /* 112986 */   // Label 2155: @112986
     /* 112986 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113059), // Rule ID 2400 //
     /* 112991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 112994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113010 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113031 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 113034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113051 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113057 */     GIR_RootConstrainSelectedInstOperands,
     /* 113058 */     // GIR_Coverage, 2400,
     /* 113058 */     GIR_EraseRootFromParent_Done,
     /* 113059 */   // Label 2156: @113059
     /* 113059 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113119), // Rule ID 626 //
     /* 113064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113095 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm))  =>  (VNMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULH),
     /* 113098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113111 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113117 */     GIR_RootConstrainSelectedInstOperands,
     /* 113118 */     // GIR_Coverage, 626,
     /* 113118 */     GIR_EraseRootFromParent_Done,
     /* 113119 */   // Label 2157: @113119
     /* 113119 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(113149), // Rule ID 664 //
     /* 113124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113131 */     // (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VNEGH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 113131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGH),
     /* 113134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113147 */     GIR_RootConstrainSelectedInstOperands,
     /* 113148 */     // GIR_Coverage, 664,
     /* 113148 */     GIR_EraseRootFromParent_Done,
     /* 113149 */   // Label 2158: @113149
     /* 113149 */   GIM_Reject,
     /* 113150 */ // Label 2153: @113150
     /* 113150 */ GIM_Reject,
     /* 113151 */ // Label 2146: @113151
     /* 113151 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(113649),
     /* 113156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113163 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(113248), // Rule ID 2410 //
     /* 113168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113187 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113220 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113246 */     GIR_RootConstrainSelectedInstOperands,
     /* 113247 */     // GIR_Coverage, 2410,
     /* 113247 */     GIR_EraseRootFromParent_Done,
     /* 113248 */   // Label 2160: @113248
     /* 113248 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(113333), // Rule ID 5718 //
     /* 113253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113272 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113305 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113331 */     GIR_RootConstrainSelectedInstOperands,
     /* 113332 */     // GIR_Coverage, 5718,
     /* 113332 */     GIR_EraseRootFromParent_Done,
     /* 113333 */   // Label 2161: @113333
     /* 113333 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(113406), // Rule ID 2399 //
     /* 113338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113357 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113378 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 113381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113404 */     GIR_RootConstrainSelectedInstOperands,
     /* 113405 */     // GIR_Coverage, 2399,
     /* 113405 */     GIR_EraseRootFromParent_Done,
     /* 113406 */   // Label 2162: @113406
     /* 113406 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(113466), // Rule ID 625 //
     /* 113411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113442 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 113445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113464 */     GIR_RootConstrainSelectedInstOperands,
     /* 113465 */     // GIR_Coverage, 625,
     /* 113465 */     GIR_EraseRootFromParent_Done,
     /* 113466 */   // Label 2163: @113466
     /* 113466 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(113496), // Rule ID 663 //
     /* 113471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 113474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113478 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VNEGS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 113478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGS),
     /* 113481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113494 */     GIR_RootConstrainSelectedInstOperands,
     /* 113495 */     // GIR_Coverage, 663,
     /* 113495 */     GIR_EraseRootFromParent_Done,
     /* 113496 */   // Label 2164: @113496
     /* 113496 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(113648), // Rule ID 2702 //
     /* 113501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 113504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113508 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VNEGfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 113508 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 113511 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 113515 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 113522 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 113525 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113529 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113534 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 113537 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113542 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 113545 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 113549 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113554 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 113557 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 113561 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 113564 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113569 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113574 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 113579 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 113582 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 113586 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113591 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 113594 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 113597 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 113608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113617 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 113620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113630 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 113637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 113642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 113647 */     // GIR_Coverage, 2702,
     /* 113647 */     GIR_EraseRootFromParent_Done,
     /* 113648 */   // Label 2165: @113648
     /* 113648 */   GIM_Reject,
     /* 113649 */ // Label 2159: @113649
     /* 113649 */ GIM_Reject,
     /* 113650 */ // Label 2147: @113650
     /* 113650 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(113996),
     /* 113655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113662 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(113747), // Rule ID 2409 //
     /* 113667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 113670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 113682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113686 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 113702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113719 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 113722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 113728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 113732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 113736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113745 */     GIR_RootConstrainSelectedInstOperands,
     /* 113746 */     // GIR_Coverage, 2409,
     /* 113746 */     GIR_EraseRootFromParent_Done,
     /* 113747 */   // Label 2167: @113747
     /* 113747 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(113832), // Rule ID 5717 //
     /* 113752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 113755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 113767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113771 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 113792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113804 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 113807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 113813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 113817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dm
     /* 113821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113830 */     GIR_RootConstrainSelectedInstOperands,
     /* 113831 */     // GIR_Coverage, 5717,
     /* 113831 */     GIR_EraseRootFromParent_Done,
     /* 113832 */   // Label 2168: @113832
     /* 113832 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(113905), // Rule ID 2398 //
     /* 113837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 113840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 113852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113856 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113877 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 113880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 113886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 113890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 113894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113903 */     GIR_RootConstrainSelectedInstOperands,
     /* 113904 */     // GIR_Coverage, 2398,
     /* 113904 */     GIR_EraseRootFromParent_Done,
     /* 113905 */   // Label 2169: @113905
     /* 113905 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(113965), // Rule ID 624 //
     /* 113910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 113913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 113925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113941 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 113944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 113950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 113954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113963 */     GIR_RootConstrainSelectedInstOperands,
     /* 113964 */     // GIR_Coverage, 624,
     /* 113964 */     GIR_EraseRootFromParent_Done,
     /* 113965 */   // Label 2170: @113965
     /* 113965 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(113995), // Rule ID 662 //
     /* 113970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 113973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113977 */     // (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VNEGD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 113977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGD),
     /* 113980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 113984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113993 */     GIR_RootConstrainSelectedInstOperands,
     /* 113994 */     // GIR_Coverage, 662,
     /* 113994 */     GIR_EraseRootFromParent_Done,
     /* 113995 */   // Label 2171: @113995
     /* 113995 */   GIM_Reject,
     /* 113996 */ // Label 2166: @113996
     /* 113996 */ GIM_Reject,
     /* 113997 */ // Label 2148: @113997
     /* 113997 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114034), // Rule ID 1527 //
     /* 114002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114016 */   // (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VNEGfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 114016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114021 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114026 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114032 */   GIR_RootConstrainSelectedInstOperands,
     /* 114033 */   // GIR_Coverage, 1527,
     /* 114033 */   GIR_EraseRootFromParent_Done,
     /* 114034 */ // Label 2172: @114034
     /* 114034 */ GIM_Reject,
     /* 114035 */ // Label 2149: @114035
     /* 114035 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(114072), // Rule ID 1529 //
     /* 114040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114054 */   // (fneg:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VNEGhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 114054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhd),
     /* 114057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114059 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114064 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114070 */   GIR_RootConstrainSelectedInstOperands,
     /* 114071 */   // GIR_Coverage, 1529,
     /* 114071 */   GIR_EraseRootFromParent_Done,
     /* 114072 */ // Label 2173: @114072
     /* 114072 */ GIM_Reject,
     /* 114073 */ // Label 2150: @114073
     /* 114073 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(114171),
     /* 114078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114081 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(114115), // Rule ID 1528 //
     /* 114086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114097 */     // (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VNEGf32q:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 114097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGf32q),
     /* 114100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114113 */     GIR_RootConstrainSelectedInstOperands,
     /* 114114 */     // GIR_Coverage, 1528,
     /* 114114 */     GIR_EraseRootFromParent_Done,
     /* 114115 */   // Label 2175: @114115
     /* 114115 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(114170), // Rule ID 4113 //
     /* 114120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114131 */     // (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VNEGf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 114131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf32),
     /* 114146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114148 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114168 */     GIR_RootConstrainSelectedInstOperands,
     /* 114169 */     // GIR_Coverage, 4113,
     /* 114169 */     GIR_EraseRootFromParent_Done,
     /* 114170 */   // Label 2176: @114170
     /* 114170 */   GIM_Reject,
     /* 114171 */ // Label 2174: @114171
     /* 114171 */ GIM_Reject,
     /* 114172 */ // Label 2151: @114172
     /* 114172 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(114270),
     /* 114177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114180 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(114214), // Rule ID 1530 //
     /* 114185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114196 */     // (fneg:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VNEGhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 114196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhq),
     /* 114199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114212 */     GIR_RootConstrainSelectedInstOperands,
     /* 114213 */     // GIR_Coverage, 1530,
     /* 114213 */     GIR_EraseRootFromParent_Done,
     /* 114214 */   // Label 2178: @114214
     /* 114214 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(114269), // Rule ID 4111 //
     /* 114219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114230 */     // (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VNEGf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 114230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf16),
     /* 114245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114247 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114267 */     GIR_RootConstrainSelectedInstOperands,
     /* 114268 */     // GIR_Coverage, 4111,
     /* 114268 */     GIR_EraseRootFromParent_Done,
     /* 114269 */   // Label 2179: @114269
     /* 114269 */   GIM_Reject,
     /* 114270 */ // Label 2177: @114270
     /* 114270 */ GIM_Reject,
     /* 114271 */ // Label 2152: @114271
     /* 114271 */ GIM_Reject,
     /* 114272 */ // Label 40: @114272
     /* 114272 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 2183*/ GIMT_Encode4(114507),
     /* 114283 */ /*GILLT_s32*//*Label 2180*/ GIMT_Encode4(114315),
     /* 114287 */ /*GILLT_s64*//*Label 2181*/ GIMT_Encode4(114375), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114311 */ /*GILLT_v4s32*//*Label 2182*/ GIMT_Encode4(114472),
     /* 114315 */ // Label 2180: @114315
     /* 114315 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(114374), // Rule ID 2300 //
     /* 114320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114334 */   // (fpextend:{ *:[f32] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114346 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114350 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHS),
     /* 114358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114360 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114366 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114372 */   GIR_RootConstrainSelectedInstOperands,
     /* 114373 */   // GIR_Coverage, 2300,
     /* 114373 */   GIR_EraseRootFromParent_Done,
     /* 114374 */ // Label 2184: @114374
     /* 114374 */ GIM_Reject,
     /* 114375 */ // Label 2181: @114375
     /* 114375 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(114412), // Rule ID 660 //
     /* 114380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114394 */   // (fpextend:{ *:[f64] } SPR:{ *:[f32] }:$Sm)  =>  (VCVTDS:{ *:[f64] } SPR:{ *:[f32] }:$Sm)
     /* 114394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTDS),
     /* 114397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114399 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 114401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114404 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114410 */   GIR_RootConstrainSelectedInstOperands,
     /* 114411 */   // GIR_Coverage, 660,
     /* 114411 */   GIR_EraseRootFromParent_Done,
     /* 114412 */ // Label 2185: @114412
     /* 114412 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(114471), // Rule ID 2310 //
     /* 114417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114431 */   // (fpextend:{ *:[f64] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114431 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114434 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114438 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114443 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114447 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHD),
     /* 114455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114463 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114469 */   GIR_RootConstrainSelectedInstOperands,
     /* 114470 */   // GIR_Coverage, 2310,
     /* 114470 */   GIR_EraseRootFromParent_Done,
     /* 114471 */ // Label 2186: @114471
     /* 114471 */ GIM_Reject,
     /* 114472 */ // Label 2182: @114472
     /* 114472 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(114506), // Rule ID 2667 //
     /* 114477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114488 */   // (fpextend:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)
     /* 114488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /* 114491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114493 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114498 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114504 */   GIR_RootConstrainSelectedInstOperands,
     /* 114505 */   // GIR_Coverage, 2667,
     /* 114505 */   GIR_EraseRootFromParent_Done,
     /* 114506 */ // Label 2187: @114506
     /* 114506 */ GIM_Reject,
     /* 114507 */ // Label 2183: @114507
     /* 114507 */ GIM_Reject,
     /* 114508 */ // Label 41: @114508
     /* 114508 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2191*/ GIMT_Encode4(114779),
     /* 114519 */ /*GILLT_s16*//*Label 2188*/ GIMT_Encode4(114551),
     /* 114523 */ /*GILLT_s32*//*Label 2189*/ GIMT_Encode4(114706), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114547 */ /*GILLT_v4s16*//*Label 2190*/ GIMT_Encode4(114744),
     /* 114551 */ // Label 2188: @114551
     /* 114551 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(114628), // Rule ID 2302 //
     /* 114556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114570 */   // (fpround:{ *:[f16] } SPR:{ *:[f32] }:$Sm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBSH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), SPR:{ *:[f32] }:$Sm), HPR:{ *:[i32] })
     /* 114570 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114573 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114577 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBSH),
     /* 114591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114596 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114599 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114603 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 114606 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114612 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114622 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 114627 */   // GIR_Coverage, 2302,
     /* 114627 */   GIR_EraseRootFromParent_Done,
     /* 114628 */ // Label 2192: @114628
     /* 114628 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(114705), // Rule ID 2312 //
     /* 114633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114647 */   // (fpround:{ *:[f16] } DPR:{ *:[f64] }:$Dm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBDH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), DPR:{ *:[f64] }:$Dm), HPR:{ *:[i32] })
     /* 114647 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114650 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114654 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114661 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114664 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBDH),
     /* 114668 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114673 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114676 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Dm
     /* 114680 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 114683 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114696 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 114704 */   // GIR_Coverage, 2312,
     /* 114704 */   GIR_EraseRootFromParent_Done,
     /* 114705 */ // Label 2193: @114705
     /* 114705 */ GIM_Reject,
     /* 114706 */ // Label 2189: @114706
     /* 114706 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(114743), // Rule ID 661 //
     /* 114711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114725 */   // (fpround:{ *:[f32] } DPR:{ *:[f64] }:$Dm)  =>  (VCVTSD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /* 114725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTSD),
     /* 114728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114730 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 114732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114735 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114741 */   GIR_RootConstrainSelectedInstOperands,
     /* 114742 */   // GIR_Coverage, 661,
     /* 114742 */   GIR_EraseRootFromParent_Done,
     /* 114743 */ // Label 2194: @114743
     /* 114743 */ GIM_Reject,
     /* 114744 */ // Label 2190: @114744
     /* 114744 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(114778), // Rule ID 2666 //
     /* 114749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114760 */   // (fpround:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)  =>  (VCVTf2h:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)
     /* 114760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /* 114763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114765 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114770 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114776 */   GIR_RootConstrainSelectedInstOperands,
     /* 114777 */   // GIR_Coverage, 2666,
     /* 114777 */   GIR_EraseRootFromParent_Done,
     /* 114778 */ // Label 2195: @114778
     /* 114778 */ GIM_Reject,
     /* 114779 */ // Label 2191: @114779
     /* 114779 */ GIM_Reject,
     /* 114780 */ // Label 42: @114780
     /* 114780 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2203*/ GIMT_Encode4(116113),
     /* 114791 */ /*GILLT_s32*//*Label 2196*/ GIMT_Encode4(114839), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114803 */ /*GILLT_v2s32*//*Label 2197*/ GIMT_Encode4(115733), GIMT_Encode4(0),
     /* 114811 */ /*GILLT_v4s1*//*Label 2198*/ GIMT_Encode4(115771),
     /* 114815 */ /*GILLT_v4s16*//*Label 2199*/ GIMT_Encode4(115824),
     /* 114819 */ /*GILLT_v4s32*//*Label 2200*/ GIMT_Encode4(115862), GIMT_Encode4(0),
     /* 114827 */ /*GILLT_v8s1*//*Label 2201*/ GIMT_Encode4(115961), GIMT_Encode4(0),
     /* 114835 */ /*GILLT_v8s16*//*Label 2202*/ GIMT_Encode4(116014),
     /* 114839 */ // Label 2196: @114839
     /* 114839 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(114905), // Rule ID 2320 //
     /* 114844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 114847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 114854 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114858 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 114862 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114866 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114873 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 114873 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114876 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSH),
     /* 114880 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114885 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 114889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114899 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 114904 */   // GIR_Coverage, 2320,
     /* 114904 */   GIR_EraseRootFromParent_Done,
     /* 114905 */ // Label 2204: @114905
     /* 114905 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(114971), // Rule ID 2322 //
     /* 114910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 114913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 114920 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114924 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 114928 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 114932 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114937 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114939 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 114939 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114942 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSS),
     /* 114946 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114951 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 114955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114965 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 114970 */   // GIR_Coverage, 2322,
     /* 114970 */   GIR_EraseRootFromParent_Done,
     /* 114971 */ // Label 2205: @114971
     /* 114971 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(115037), // Rule ID 2324 //
     /* 114976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 114986 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114990 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 114994 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114998 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115003 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115005 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSD),
     /* 115012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115017 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115031 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115036 */   // GIR_Coverage, 2324,
     /* 115036 */   GIR_EraseRootFromParent_Done,
     /* 115037 */ // Label 2206: @115037
     /* 115037 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(115103), // Rule ID 2326 //
     /* 115042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115052 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115056 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115060 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115064 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115071 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115071 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115074 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSH),
     /* 115078 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115083 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115094 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115097 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115102 */   // GIR_Coverage, 2326,
     /* 115102 */   GIR_EraseRootFromParent_Done,
     /* 115103 */ // Label 2207: @115103
     /* 115103 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(115169), // Rule ID 2328 //
     /* 115108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115118 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115122 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115126 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115130 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115135 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115137 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115137 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115140 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSS),
     /* 115144 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115149 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115160 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115163 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115168 */   // GIR_Coverage, 2328,
     /* 115168 */   GIR_EraseRootFromParent_Done,
     /* 115169 */ // Label 2208: @115169
     /* 115169 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(115235), // Rule ID 2330 //
     /* 115174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115184 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115188 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115192 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115196 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115201 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115203 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSD),
     /* 115210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115215 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115229 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115234 */   // GIR_Coverage, 2330,
     /* 115234 */   GIR_EraseRootFromParent_Done,
     /* 115235 */ // Label 2209: @115235
     /* 115235 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(115301), // Rule ID 2314 //
     /* 115240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115250 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115254 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115258 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115262 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115267 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115269 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASH),
     /* 115276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115281 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115300 */   // GIR_Coverage, 2314,
     /* 115300 */   GIR_EraseRootFromParent_Done,
     /* 115301 */ // Label 2210: @115301
     /* 115301 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(115367), // Rule ID 2316 //
     /* 115306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115316 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115320 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115324 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115328 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115333 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115335 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115335 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115338 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASS),
     /* 115342 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115347 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115361 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115366 */   // GIR_Coverage, 2316,
     /* 115366 */   GIR_EraseRootFromParent_Done,
     /* 115367 */ // Label 2211: @115367
     /* 115367 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(115433), // Rule ID 2318 //
     /* 115372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115390 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115394 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115399 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115401 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115401 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115404 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASD),
     /* 115408 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115413 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115427 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115432 */   // GIR_Coverage, 2318,
     /* 115432 */   GIR_EraseRootFromParent_Done,
     /* 115433 */ // Label 2212: @115433
     /* 115433 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(115493), // Rule ID 2349 //
     /* 115438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115452 */   // (fp_to_sint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZD),
     /* 115459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115464 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115468 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115471 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115492 */   // GIR_Coverage, 2349,
     /* 115492 */   GIR_EraseRootFromParent_Done,
     /* 115493 */ // Label 2213: @115493
     /* 115493 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(115553), // Rule ID 2353 //
     /* 115498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 115501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115512 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZS),
     /* 115519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115524 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115528 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115531 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115544 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115552 */   // GIR_Coverage, 2353,
     /* 115552 */   GIR_EraseRootFromParent_Done,
     /* 115553 */ // Label 2214: @115553
     /* 115553 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(115613), // Rule ID 2357 //
     /* 115558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 115561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115572 */   // (fp_to_sint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115572 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115575 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZH),
     /* 115579 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115584 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115588 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115591 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115607 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115612 */   // GIR_Coverage, 2357,
     /* 115612 */   GIR_EraseRootFromParent_Done,
     /* 115613 */ // Label 2215: @115613
     /* 115613 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(115732), // Rule ID 2707 //
     /* 115618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 115621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115632 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2sd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 115632 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 115635 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115639 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115646 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 115649 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 115653 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115658 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 115661 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115665 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 115668 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 115673 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 115678 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 115683 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 115686 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 115690 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115695 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115698 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115701 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115707 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115714 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 115721 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 115726 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 115731 */   // GIR_Coverage, 2707,
     /* 115731 */   GIR_EraseRootFromParent_Done,
     /* 115732 */ // Label 2216: @115732
     /* 115732 */ GIM_Reject,
     /* 115733 */ // Label 2197: @115733
     /* 115733 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(115770), // Rule ID 1601 //
     /* 115738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115752 */   // (fp_to_sint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2sd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 115752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 115755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115757 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 115759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115762 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115768 */   GIR_RootConstrainSelectedInstOperands,
     /* 115769 */   // GIR_Coverage, 1601,
     /* 115769 */   GIR_EraseRootFromParent_Done,
     /* 115770 */ // Label 2217: @115770
     /* 115770 */ GIM_Reject,
     /* 115771 */ // Label 2198: @115771
     /* 115771 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(115823), // Rule ID 5102 //
     /* 115776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 115779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 115786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 115790 */   // (fp_to_sint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 115790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 115793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 115795 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 115797 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 115806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115809 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115815 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115821 */   GIR_RootConstrainSelectedInstOperands,
     /* 115822 */   // GIR_Coverage, 5102,
     /* 115822 */   GIR_EraseRootFromParent_Done,
     /* 115823 */ // Label 2218: @115823
     /* 115823 */ GIM_Reject,
     /* 115824 */ // Label 2199: @115824
     /* 115824 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(115861), // Rule ID 1609 //
     /* 115829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 115832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 115835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115843 */   // (fp_to_sint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2sd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 115843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sd),
     /* 115846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115848 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 115850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115853 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115859 */   GIR_RootConstrainSelectedInstOperands,
     /* 115860 */   // GIR_Coverage, 1609,
     /* 115860 */   GIR_EraseRootFromParent_Done,
     /* 115861 */ // Label 2219: @115861
     /* 115861 */ GIM_Reject,
     /* 115862 */ // Label 2200: @115862
     /* 115862 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(115960),
     /* 115867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115870 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(115904), // Rule ID 1605 //
     /* 115875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115886 */     // (fp_to_sint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2sq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 115886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sq),
     /* 115889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 115893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115902 */     GIR_RootConstrainSelectedInstOperands,
     /* 115903 */     // GIR_Coverage, 1605,
     /* 115903 */     GIR_EraseRootFromParent_Done,
     /* 115904 */   // Label 2221: @115904
     /* 115904 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(115959), // Rule ID 4091 //
     /* 115909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 115912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 115916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 115920 */     // (fp_to_sint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTs32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 115920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 115923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32z),
     /* 115935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 115937 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115957 */     GIR_RootConstrainSelectedInstOperands,
     /* 115958 */     // GIR_Coverage, 4091,
     /* 115958 */     GIR_EraseRootFromParent_Done,
     /* 115959 */   // Label 2222: @115959
     /* 115959 */   GIM_Reject,
     /* 115960 */ // Label 2220: @115960
     /* 115960 */ GIM_Reject,
     /* 115961 */ // Label 2201: @115961
     /* 115961 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(116013), // Rule ID 5103 //
     /* 115966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 115969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 115976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 115980 */   // (fp_to_sint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 115980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 115983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 115985 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 115987 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 115996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115999 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116005 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116011 */   GIR_RootConstrainSelectedInstOperands,
     /* 116012 */   // GIR_Coverage, 5103,
     /* 116012 */   GIR_EraseRootFromParent_Done,
     /* 116013 */ // Label 2223: @116013
     /* 116013 */ GIM_Reject,
     /* 116014 */ // Label 2202: @116014
     /* 116014 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(116112),
     /* 116019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116022 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(116056), // Rule ID 1613 //
     /* 116027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116038 */     // (fp_to_sint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2sq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 116038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sq),
     /* 116041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116054 */     GIR_RootConstrainSelectedInstOperands,
     /* 116055 */     // GIR_Coverage, 1613,
     /* 116055 */     GIR_EraseRootFromParent_Done,
     /* 116056 */   // Label 2225: @116056
     /* 116056 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(116111), // Rule ID 4087 //
     /* 116061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116072 */     // (fp_to_sint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTs16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 116072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16z),
     /* 116087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116089 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116109 */     GIR_RootConstrainSelectedInstOperands,
     /* 116110 */     // GIR_Coverage, 4087,
     /* 116110 */     GIR_EraseRootFromParent_Done,
     /* 116111 */   // Label 2226: @116111
     /* 116111 */   GIM_Reject,
     /* 116112 */ // Label 2224: @116112
     /* 116112 */ GIM_Reject,
     /* 116113 */ // Label 2203: @116113
     /* 116113 */ GIM_Reject,
     /* 116114 */ // Label 43: @116114
     /* 116114 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2234*/ GIMT_Encode4(117447),
     /* 116125 */ /*GILLT_s32*//*Label 2227*/ GIMT_Encode4(116173), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116137 */ /*GILLT_v2s32*//*Label 2228*/ GIMT_Encode4(117067), GIMT_Encode4(0),
     /* 116145 */ /*GILLT_v4s1*//*Label 2229*/ GIMT_Encode4(117105),
     /* 116149 */ /*GILLT_v4s16*//*Label 2230*/ GIMT_Encode4(117158),
     /* 116153 */ /*GILLT_v4s32*//*Label 2231*/ GIMT_Encode4(117196), GIMT_Encode4(0),
     /* 116161 */ /*GILLT_v8s1*//*Label 2232*/ GIMT_Encode4(117295), GIMT_Encode4(0),
     /* 116169 */ /*GILLT_v8s16*//*Label 2233*/ GIMT_Encode4(117348),
     /* 116173 */ // Label 2227: @116173
     /* 116173 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(116239), // Rule ID 2321 //
     /* 116178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116188 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116192 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116196 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116200 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116205 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116207 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUH),
     /* 116214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116219 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116230 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116238 */   // GIR_Coverage, 2321,
     /* 116238 */   GIR_EraseRootFromParent_Done,
     /* 116239 */ // Label 2235: @116239
     /* 116239 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(116305), // Rule ID 2323 //
     /* 116244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116254 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116258 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116262 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116266 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116271 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116273 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUS),
     /* 116280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116285 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116296 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116299 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116304 */   // GIR_Coverage, 2323,
     /* 116304 */   GIR_EraseRootFromParent_Done,
     /* 116305 */ // Label 2236: @116305
     /* 116305 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(116371), // Rule ID 2325 //
     /* 116310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116320 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116328 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116332 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116337 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116339 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116339 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116342 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUD),
     /* 116346 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116351 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116370 */   // GIR_Coverage, 2325,
     /* 116370 */   GIR_EraseRootFromParent_Done,
     /* 116371 */ // Label 2237: @116371
     /* 116371 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(116437), // Rule ID 2327 //
     /* 116376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116386 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116390 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116394 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116398 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116403 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116405 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116405 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116408 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUH),
     /* 116412 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116417 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116436 */   // GIR_Coverage, 2327,
     /* 116436 */   GIR_EraseRootFromParent_Done,
     /* 116437 */ // Label 2238: @116437
     /* 116437 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(116503), // Rule ID 2329 //
     /* 116442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116452 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116456 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116460 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116464 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116471 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUS),
     /* 116478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116483 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116487 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116494 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116497 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116502 */   // GIR_Coverage, 2329,
     /* 116502 */   GIR_EraseRootFromParent_Done,
     /* 116503 */ // Label 2239: @116503
     /* 116503 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(116569), // Rule ID 2331 //
     /* 116508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116518 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116522 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116526 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116530 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116535 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116537 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116537 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116540 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUD),
     /* 116544 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116549 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116563 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116568 */   // GIR_Coverage, 2331,
     /* 116568 */   GIR_EraseRootFromParent_Done,
     /* 116569 */ // Label 2240: @116569
     /* 116569 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(116635), // Rule ID 2315 //
     /* 116574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116584 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116588 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 116592 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116596 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116603 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUH),
     /* 116610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116615 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116629 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116634 */   // GIR_Coverage, 2315,
     /* 116634 */   GIR_EraseRootFromParent_Done,
     /* 116635 */ // Label 2241: @116635
     /* 116635 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(116701), // Rule ID 2317 //
     /* 116640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116650 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116654 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 116658 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116662 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116667 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116669 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUS),
     /* 116676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116681 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116700 */   // GIR_Coverage, 2317,
     /* 116700 */   GIR_EraseRootFromParent_Done,
     /* 116701 */ // Label 2242: @116701
     /* 116701 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(116767), // Rule ID 2319 //
     /* 116706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116716 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116720 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 116724 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116728 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116735 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUD),
     /* 116742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116747 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116758 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116761 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116766 */   // GIR_Coverage, 2319,
     /* 116766 */   GIR_EraseRootFromParent_Done,
     /* 116767 */ // Label 2243: @116767
     /* 116767 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(116827), // Rule ID 2359 //
     /* 116772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 116775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116786 */   // (fp_to_uint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116786 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116789 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZD),
     /* 116793 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116798 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116802 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116805 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116818 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116821 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116826 */   // GIR_Coverage, 2359,
     /* 116826 */   GIR_EraseRootFromParent_Done,
     /* 116827 */ // Label 2244: @116827
     /* 116827 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(116887), // Rule ID 2363 //
     /* 116832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 116835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116846 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116846 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116849 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZS),
     /* 116853 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116858 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116862 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116865 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116878 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116881 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116886 */   // GIR_Coverage, 2363,
     /* 116886 */   GIR_EraseRootFromParent_Done,
     /* 116887 */ // Label 2245: @116887
     /* 116887 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(116947), // Rule ID 2367 //
     /* 116892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 116895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116906 */   // (fp_to_uint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116906 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116909 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZH),
     /* 116913 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116918 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116922 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116925 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116946 */   // GIR_Coverage, 2367,
     /* 116946 */   GIR_EraseRootFromParent_Done,
     /* 116947 */ // Label 2246: @116947
     /* 116947 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(117066), // Rule ID 2708 //
     /* 116952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 116955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116966 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2ud:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 116966 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 116969 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116973 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116980 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 116983 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116987 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116992 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 116995 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116999 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 117002 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117007 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117012 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117017 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 117020 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117024 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117029 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117032 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117035 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117048 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 117055 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117060 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117065 */   // GIR_Coverage, 2708,
     /* 117065 */   GIR_EraseRootFromParent_Done,
     /* 117066 */ // Label 2247: @117066
     /* 117066 */ GIM_Reject,
     /* 117067 */ // Label 2228: @117067
     /* 117067 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(117104), // Rule ID 1602 //
     /* 117072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117086 */   // (fp_to_uint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2ud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 117086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117091 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117096 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117102 */   GIR_RootConstrainSelectedInstOperands,
     /* 117103 */   // GIR_Coverage, 1602,
     /* 117103 */   GIR_EraseRootFromParent_Done,
     /* 117104 */ // Label 2248: @117104
     /* 117104 */ GIM_Reject,
     /* 117105 */ // Label 2229: @117105
     /* 117105 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(117157), // Rule ID 5100 //
     /* 117110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117124 */   // (fp_to_uint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 117127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117129 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117131 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117143 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117149 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117155 */   GIR_RootConstrainSelectedInstOperands,
     /* 117156 */   // GIR_Coverage, 5100,
     /* 117156 */   GIR_EraseRootFromParent_Done,
     /* 117157 */ // Label 2249: @117157
     /* 117157 */ GIM_Reject,
     /* 117158 */ // Label 2230: @117158
     /* 117158 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(117195), // Rule ID 1610 //
     /* 117163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117177 */   // (fp_to_uint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2ud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 117177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2ud),
     /* 117180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117182 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117187 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117193 */   GIR_RootConstrainSelectedInstOperands,
     /* 117194 */   // GIR_Coverage, 1610,
     /* 117194 */   GIR_EraseRootFromParent_Done,
     /* 117195 */ // Label 2250: @117195
     /* 117195 */ GIM_Reject,
     /* 117196 */ // Label 2231: @117196
     /* 117196 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(117294),
     /* 117201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117204 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(117238), // Rule ID 1606 //
     /* 117209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117220 */     // (fp_to_uint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2uq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 117220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2uq),
     /* 117223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117236 */     GIR_RootConstrainSelectedInstOperands,
     /* 117237 */     // GIR_Coverage, 1606,
     /* 117237 */     GIR_EraseRootFromParent_Done,
     /* 117238 */   // Label 2252: @117238
     /* 117238 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(117293), // Rule ID 4093 //
     /* 117243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117254 */     // (fp_to_uint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTu32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 117254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32z),
     /* 117269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117271 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117291 */     GIR_RootConstrainSelectedInstOperands,
     /* 117292 */     // GIR_Coverage, 4093,
     /* 117292 */     GIR_EraseRootFromParent_Done,
     /* 117293 */   // Label 2253: @117293
     /* 117293 */   GIM_Reject,
     /* 117294 */ // Label 2251: @117294
     /* 117294 */ GIM_Reject,
     /* 117295 */ // Label 2232: @117295
     /* 117295 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(117347), // Rule ID 5101 //
     /* 117300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117314 */   // (fp_to_uint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 117317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117319 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117321 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117333 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117339 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117345 */   GIR_RootConstrainSelectedInstOperands,
     /* 117346 */   // GIR_Coverage, 5101,
     /* 117346 */   GIR_EraseRootFromParent_Done,
     /* 117347 */ // Label 2254: @117347
     /* 117347 */ GIM_Reject,
     /* 117348 */ // Label 2233: @117348
     /* 117348 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(117446),
     /* 117353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117356 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(117390), // Rule ID 1614 //
     /* 117361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117372 */     // (fp_to_uint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2uq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 117372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2uq),
     /* 117375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117388 */     GIR_RootConstrainSelectedInstOperands,
     /* 117389 */     // GIR_Coverage, 1614,
     /* 117389 */     GIR_EraseRootFromParent_Done,
     /* 117390 */   // Label 2256: @117390
     /* 117390 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(117445), // Rule ID 4089 //
     /* 117395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117406 */     // (fp_to_uint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTu16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 117406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16z),
     /* 117421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117428 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117443 */     GIR_RootConstrainSelectedInstOperands,
     /* 117444 */     // GIR_Coverage, 4089,
     /* 117444 */     GIR_EraseRootFromParent_Done,
     /* 117445 */   // Label 2257: @117445
     /* 117445 */   GIM_Reject,
     /* 117446 */ // Label 2255: @117446
     /* 117446 */ GIM_Reject,
     /* 117447 */ // Label 2234: @117447
     /* 117447 */ GIM_Reject,
     /* 117448 */ // Label 44: @117448
     /* 117448 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2265*/ GIMT_Encode4(118099),
     /* 117459 */ /*GILLT_s16*//*Label 2258*/ GIMT_Encode4(117511),
     /* 117463 */ /*GILLT_s32*//*Label 2259*/ GIMT_Encode4(117571),
     /* 117467 */ /*GILLT_s64*//*Label 2260*/ GIMT_Encode4(117765), GIMT_Encode4(0),
     /* 117475 */ /*GILLT_v2s32*//*Label 2261*/ GIMT_Encode4(117825), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117487 */ /*GILLT_v4s16*//*Label 2262*/ GIMT_Encode4(117863),
     /* 117491 */ /*GILLT_v4s32*//*Label 2263*/ GIMT_Encode4(117901), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117507 */ /*GILLT_v8s16*//*Label 2264*/ GIMT_Encode4(118000),
     /* 117511 */ // Label 2258: @117511
     /* 117511 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(117570), // Rule ID 2343 //
     /* 117516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117530 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VSITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 117530 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117533 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117537 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117542 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117546 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOH),
     /* 117554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 117556 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117562 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117568 */   GIR_RootConstrainSelectedInstOperands,
     /* 117569 */   // GIR_Coverage, 2343,
     /* 117569 */   GIR_EraseRootFromParent_Done,
     /* 117570 */ // Label 2266: @117570
     /* 117570 */ GIM_Reject,
     /* 117571 */ // Label 2259: @117571
     /* 117571 */ GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(117764),
     /* 117576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117587 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(117635), // Rule ID 2341 //
     /* 117592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117595 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VSITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 117595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117607 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOS),
     /* 117619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 117621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117633 */     GIR_RootConstrainSelectedInstOperands,
     /* 117634 */     // GIR_Coverage, 2341,
     /* 117634 */     GIR_EraseRootFromParent_Done,
     /* 117635 */   // Label 2268: @117635
     /* 117635 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(117763), // Rule ID 2709 //
     /* 117640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 117643 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTs2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 117643 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117646 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117650 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117655 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117659 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117664 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 117667 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117671 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117678 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 117681 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117685 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117690 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 117693 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 117696 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 117699 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117704 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117709 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 117717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 117721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117726 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117729 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117732 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117745 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 117752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117762 */     // GIR_Coverage, 2709,
     /* 117762 */     GIR_EraseRootFromParent_Done,
     /* 117763 */   // Label 2269: @117763
     /* 117763 */   GIM_Reject,
     /* 117764 */ // Label 2267: @117764
     /* 117764 */ GIM_Reject,
     /* 117765 */ // Label 2260: @117765
     /* 117765 */ GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(117824), // Rule ID 2339 //
     /* 117770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 117773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117784 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VSITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 117784 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117787 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117791 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117796 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117800 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOD),
     /* 117808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 117810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117816 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117822 */   GIR_RootConstrainSelectedInstOperands,
     /* 117823 */   // GIR_Coverage, 2339,
     /* 117823 */   GIR_EraseRootFromParent_Done,
     /* 117824 */ // Label 2270: @117824
     /* 117824 */ GIM_Reject,
     /* 117825 */ // Label 2261: @117825
     /* 117825 */ GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(117862), // Rule ID 1603 //
     /* 117830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117844 */   // (sint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 117844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 117847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117849 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117854 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117860 */   GIR_RootConstrainSelectedInstOperands,
     /* 117861 */   // GIR_Coverage, 1603,
     /* 117861 */   GIR_EraseRootFromParent_Done,
     /* 117862 */ // Label 2271: @117862
     /* 117862 */ GIM_Reject,
     /* 117863 */ // Label 2262: @117863
     /* 117863 */ GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(117900), // Rule ID 1611 //
     /* 117868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117882 */   // (sint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 117882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hd),
     /* 117885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117887 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117892 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117898 */   GIR_RootConstrainSelectedInstOperands,
     /* 117899 */   // GIR_Coverage, 1611,
     /* 117899 */   GIR_EraseRootFromParent_Done,
     /* 117900 */ // Label 2272: @117900
     /* 117900 */ GIM_Reject,
     /* 117901 */ // Label 2263: @117901
     /* 117901 */ GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(117999),
     /* 117906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117909 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(117943), // Rule ID 1607 //
     /* 117914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117925 */     // (sint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 117925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fq),
     /* 117928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117941 */     GIR_RootConstrainSelectedInstOperands,
     /* 117942 */     // GIR_Coverage, 1607,
     /* 117942 */     GIR_EraseRootFromParent_Done,
     /* 117943 */   // Label 2274: @117943
     /* 117943 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(117998), // Rule ID 4099 //
     /* 117948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117959 */     // (sint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32s32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 117959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32n),
     /* 117974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117976 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117996 */     GIR_RootConstrainSelectedInstOperands,
     /* 117997 */     // GIR_Coverage, 4099,
     /* 117997 */     GIR_EraseRootFromParent_Done,
     /* 117998 */   // Label 2275: @117998
     /* 117998 */   GIM_Reject,
     /* 117999 */ // Label 2273: @117999
     /* 117999 */ GIM_Reject,
     /* 118000 */ // Label 2264: @118000
     /* 118000 */ GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(118098),
     /* 118005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118008 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(118042), // Rule ID 1615 //
     /* 118013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118024 */     // (sint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hq),
     /* 118027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118040 */     GIR_RootConstrainSelectedInstOperands,
     /* 118041 */     // GIR_Coverage, 1615,
     /* 118041 */     GIR_EraseRootFromParent_Done,
     /* 118042 */   // Label 2277: @118042
     /* 118042 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(118097), // Rule ID 4095 //
     /* 118047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118058 */     // (sint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16s16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 118058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16n),
     /* 118073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118075 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118095 */     GIR_RootConstrainSelectedInstOperands,
     /* 118096 */     // GIR_Coverage, 4095,
     /* 118096 */     GIR_EraseRootFromParent_Done,
     /* 118097 */   // Label 2278: @118097
     /* 118097 */   GIM_Reject,
     /* 118098 */ // Label 2276: @118098
     /* 118098 */ GIM_Reject,
     /* 118099 */ // Label 2265: @118099
     /* 118099 */ GIM_Reject,
     /* 118100 */ // Label 45: @118100
     /* 118100 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2286*/ GIMT_Encode4(118751),
     /* 118111 */ /*GILLT_s16*//*Label 2279*/ GIMT_Encode4(118163),
     /* 118115 */ /*GILLT_s32*//*Label 2280*/ GIMT_Encode4(118223),
     /* 118119 */ /*GILLT_s64*//*Label 2281*/ GIMT_Encode4(118417), GIMT_Encode4(0),
     /* 118127 */ /*GILLT_v2s32*//*Label 2282*/ GIMT_Encode4(118477), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118139 */ /*GILLT_v4s16*//*Label 2283*/ GIMT_Encode4(118515),
     /* 118143 */ /*GILLT_v4s32*//*Label 2284*/ GIMT_Encode4(118553), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118159 */ /*GILLT_v8s16*//*Label 2285*/ GIMT_Encode4(118652),
     /* 118163 */ // Label 2279: @118163
     /* 118163 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(118222), // Rule ID 2348 //
     /* 118168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118182 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VUITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118182 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118185 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118189 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118194 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118198 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOH),
     /* 118206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118208 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118214 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118220 */   GIR_RootConstrainSelectedInstOperands,
     /* 118221 */   // GIR_Coverage, 2348,
     /* 118221 */   GIR_EraseRootFromParent_Done,
     /* 118222 */ // Label 2287: @118222
     /* 118222 */ GIM_Reject,
     /* 118223 */ // Label 2280: @118223
     /* 118223 */ GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(118416),
     /* 118228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118239 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(118287), // Rule ID 2346 //
     /* 118244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118247 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VUITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118259 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOS),
     /* 118271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118285 */     GIR_RootConstrainSelectedInstOperands,
     /* 118286 */     // GIR_Coverage, 2346,
     /* 118286 */     GIR_EraseRootFromParent_Done,
     /* 118287 */   // Label 2289: @118287
     /* 118287 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(118415), // Rule ID 2710 //
     /* 118292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118295 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTu2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118295 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118298 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118302 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118307 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118311 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118316 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118319 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118323 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118330 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118333 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118337 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118342 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118345 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118348 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118361 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118378 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118381 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118384 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118397 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118414 */     // GIR_Coverage, 2710,
     /* 118414 */     GIR_EraseRootFromParent_Done,
     /* 118415 */   // Label 2290: @118415
     /* 118415 */   GIM_Reject,
     /* 118416 */ // Label 2288: @118416
     /* 118416 */ GIM_Reject,
     /* 118417 */ // Label 2281: @118417
     /* 118417 */ GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(118476), // Rule ID 2344 //
     /* 118422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118436 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VUITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118448 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118452 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOD),
     /* 118460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118462 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118468 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118474 */   GIR_RootConstrainSelectedInstOperands,
     /* 118475 */   // GIR_Coverage, 2344,
     /* 118475 */   GIR_EraseRootFromParent_Done,
     /* 118476 */ // Label 2291: @118476
     /* 118476 */ GIM_Reject,
     /* 118477 */ // Label 2282: @118477
     /* 118477 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(118514), // Rule ID 1604 //
     /* 118482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118496 */   // (uint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118501 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118506 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118512 */   GIR_RootConstrainSelectedInstOperands,
     /* 118513 */   // GIR_Coverage, 1604,
     /* 118513 */   GIR_EraseRootFromParent_Done,
     /* 118514 */ // Label 2292: @118514
     /* 118514 */ GIM_Reject,
     /* 118515 */ // Label 2283: @118515
     /* 118515 */ GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(118552), // Rule ID 1612 //
     /* 118520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118534 */   // (uint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 118534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hd),
     /* 118537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118539 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118544 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118550 */   GIR_RootConstrainSelectedInstOperands,
     /* 118551 */   // GIR_Coverage, 1612,
     /* 118551 */   GIR_EraseRootFromParent_Done,
     /* 118552 */ // Label 2293: @118552
     /* 118552 */ GIM_Reject,
     /* 118553 */ // Label 2284: @118553
     /* 118553 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(118651),
     /* 118558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 118561 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(118595), // Rule ID 1608 //
     /* 118566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118577 */     // (uint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 118577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fq),
     /* 118580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118593 */     GIR_RootConstrainSelectedInstOperands,
     /* 118594 */     // GIR_Coverage, 1608,
     /* 118594 */     GIR_EraseRootFromParent_Done,
     /* 118595 */   // Label 2295: @118595
     /* 118595 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(118650), // Rule ID 4101 //
     /* 118600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118611 */     // (uint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32u32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 118611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32n),
     /* 118626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118628 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118639 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118648 */     GIR_RootConstrainSelectedInstOperands,
     /* 118649 */     // GIR_Coverage, 4101,
     /* 118649 */     GIR_EraseRootFromParent_Done,
     /* 118650 */   // Label 2296: @118650
     /* 118650 */   GIM_Reject,
     /* 118651 */ // Label 2294: @118651
     /* 118651 */ GIM_Reject,
     /* 118652 */ // Label 2285: @118652
     /* 118652 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(118750),
     /* 118657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118660 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(118694), // Rule ID 1616 //
     /* 118665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118676 */     // (uint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hq),
     /* 118679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118692 */     GIR_RootConstrainSelectedInstOperands,
     /* 118693 */     // GIR_Coverage, 1616,
     /* 118693 */     GIR_EraseRootFromParent_Done,
     /* 118694 */   // Label 2298: @118694
     /* 118694 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(118749), // Rule ID 4097 //
     /* 118699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118710 */     // (uint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16u16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 118710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16n),
     /* 118725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118727 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118747 */     GIR_RootConstrainSelectedInstOperands,
     /* 118748 */     // GIR_Coverage, 4097,
     /* 118748 */     GIR_EraseRootFromParent_Done,
     /* 118749 */   // Label 2299: @118749
     /* 118749 */   GIM_Reject,
     /* 118750 */ // Label 2297: @118750
     /* 118750 */ GIM_Reject,
     /* 118751 */ // Label 2286: @118751
     /* 118751 */ GIM_Reject,
     /* 118752 */ // Label 46: @118752
     /* 118752 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2307*/ GIMT_Encode4(119527),
     /* 118763 */ /*GILLT_s16*//*Label 2300*/ GIMT_Encode4(118815),
     /* 118767 */ /*GILLT_s32*//*Label 2301*/ GIMT_Encode4(118853),
     /* 118771 */ /*GILLT_s64*//*Label 2302*/ GIMT_Encode4(119045), GIMT_Encode4(0),
     /* 118779 */ /*GILLT_v2s32*//*Label 2303*/ GIMT_Encode4(119083), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118791 */ /*GILLT_v4s16*//*Label 2304*/ GIMT_Encode4(119121),
     /* 118795 */ /*GILLT_v4s32*//*Label 2305*/ GIMT_Encode4(119159), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118811 */ /*GILLT_v8s16*//*Label 2306*/ GIMT_Encode4(119343),
     /* 118815 */ // Label 2300: @118815
     /* 118815 */ GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(118852), // Rule ID 653 //
     /* 118820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 118823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 118826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118834 */   // (fabs:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VABSH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 118834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSH),
     /* 118837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118839 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 118841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118844 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118850 */   GIR_RootConstrainSelectedInstOperands,
     /* 118851 */   // GIR_Coverage, 653,
     /* 118851 */   GIR_EraseRootFromParent_Done,
     /* 118852 */ // Label 2308: @118852
     /* 118852 */ GIM_Reject,
     /* 118853 */ // Label 2301: @118853
     /* 118853 */ GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(119044),
     /* 118858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118869 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(118895), // Rule ID 652 //
     /* 118874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118877 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VABSS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 118877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSS),
     /* 118880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 118884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118893 */     GIR_RootConstrainSelectedInstOperands,
     /* 118894 */     // GIR_Coverage, 652,
     /* 118894 */     GIR_EraseRootFromParent_Done,
     /* 118895 */   // Label 2310: @118895
     /* 118895 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(119043), // Rule ID 2701 //
     /* 118900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118903 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VABSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 118903 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 118906 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118910 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 118917 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 118920 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118924 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118929 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 118932 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118937 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118940 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118944 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118949 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 118952 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118956 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 118959 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118964 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118969 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118974 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 118977 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 118981 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118986 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118989 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 118992 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 119003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119012 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119015 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119025 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 119032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119042 */     // GIR_Coverage, 2701,
     /* 119042 */     GIR_EraseRootFromParent_Done,
     /* 119043 */   // Label 2311: @119043
     /* 119043 */   GIM_Reject,
     /* 119044 */ // Label 2309: @119044
     /* 119044 */ GIM_Reject,
     /* 119045 */ // Label 2302: @119045
     /* 119045 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(119082), // Rule ID 651 //
     /* 119050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 119053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119064 */   // (fabs:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VABSD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 119064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSD),
     /* 119067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 119069 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 119071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119074 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119080 */   GIR_RootConstrainSelectedInstOperands,
     /* 119081 */   // GIR_Coverage, 651,
     /* 119081 */   GIR_EraseRootFromParent_Done,
     /* 119082 */ // Label 2312: @119082
     /* 119082 */ GIM_Reject,
     /* 119083 */ // Label 2303: @119083
     /* 119083 */ GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(119120), // Rule ID 1511 //
     /* 119088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119102 */   // (fabs:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VABSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 119102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119107 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119112 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119118 */   GIR_RootConstrainSelectedInstOperands,
     /* 119119 */   // GIR_Coverage, 1511,
     /* 119119 */   GIR_EraseRootFromParent_Done,
     /* 119120 */ // Label 2313: @119120
     /* 119120 */ GIM_Reject,
     /* 119121 */ // Label 2304: @119121
     /* 119121 */ GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(119158), // Rule ID 1513 //
     /* 119126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119140 */   // (fabs:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VABShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 119140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShd),
     /* 119143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119145 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119150 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119156 */   GIR_RootConstrainSelectedInstOperands,
     /* 119157 */   // GIR_Coverage, 1513,
     /* 119157 */   GIR_EraseRootFromParent_Done,
     /* 119158 */ // Label 2314: @119158
     /* 119158 */ GIM_Reject,
     /* 119159 */ // Label 2305: @119159
     /* 119159 */ GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(119342),
     /* 119164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119167 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(119252), // Rule ID 4038 //
     /* 119172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 119195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119207 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn))  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 119207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /* 119222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119250 */     GIR_RootConstrainSelectedInstOperands,
     /* 119251 */     // GIR_Coverage, 4038,
     /* 119251 */     GIR_EraseRootFromParent_Done,
     /* 119252 */   // Label 2316: @119252
     /* 119252 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(119286), // Rule ID 1512 //
     /* 119257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119268 */     // (fabs:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VABSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 119268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfq),
     /* 119271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119284 */     GIR_RootConstrainSelectedInstOperands,
     /* 119285 */     // GIR_Coverage, 1512,
     /* 119285 */     GIR_EraseRootFromParent_Done,
     /* 119286 */   // Label 2317: @119286
     /* 119286 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(119341), // Rule ID 4109 //
     /* 119291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119302 */     // (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VABSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 119302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf32),
     /* 119317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119319 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119339 */     GIR_RootConstrainSelectedInstOperands,
     /* 119340 */     // GIR_Coverage, 4109,
     /* 119340 */     GIR_EraseRootFromParent_Done,
     /* 119341 */   // Label 2318: @119341
     /* 119341 */   GIM_Reject,
     /* 119342 */ // Label 2315: @119342
     /* 119342 */ GIM_Reject,
     /* 119343 */ // Label 2306: @119343
     /* 119343 */ GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(119526),
     /* 119348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119351 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(119436), // Rule ID 4037 //
     /* 119356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 119379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119391 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn))  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 119391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /* 119406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119434 */     GIR_RootConstrainSelectedInstOperands,
     /* 119435 */     // GIR_Coverage, 4037,
     /* 119435 */     GIR_EraseRootFromParent_Done,
     /* 119436 */   // Label 2320: @119436
     /* 119436 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(119470), // Rule ID 1514 //
     /* 119441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119452 */     // (fabs:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VABShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 119452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShq),
     /* 119455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119468 */     GIR_RootConstrainSelectedInstOperands,
     /* 119469 */     // GIR_Coverage, 1514,
     /* 119469 */     GIR_EraseRootFromParent_Done,
     /* 119470 */   // Label 2321: @119470
     /* 119470 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(119525), // Rule ID 4107 //
     /* 119475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119486 */     // (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VABSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 119486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf16),
     /* 119501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119503 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119523 */     GIR_RootConstrainSelectedInstOperands,
     /* 119524 */     // GIR_Coverage, 4107,
     /* 119524 */     GIR_EraseRootFromParent_Done,
     /* 119525 */   // Label 2322: @119525
     /* 119525 */   GIM_Reject,
     /* 119526 */ // Label 2319: @119526
     /* 119526 */ GIM_Reject,
     /* 119527 */ // Label 2307: @119527
     /* 119527 */ GIM_Reject,
     /* 119528 */ // Label 47: @119528
     /* 119528 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2330*/ GIMT_Encode4(120119),
     /* 119539 */ /*GILLT_s16*//*Label 2323*/ GIMT_Encode4(119591),
     /* 119543 */ /*GILLT_s32*//*Label 2324*/ GIMT_Encode4(119625),
     /* 119547 */ /*GILLT_s64*//*Label 2325*/ GIMT_Encode4(119659), GIMT_Encode4(0),
     /* 119555 */ /*GILLT_v2s32*//*Label 2326*/ GIMT_Encode4(119693), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119567 */ /*GILLT_v4s16*//*Label 2327*/ GIMT_Encode4(119727),
     /* 119571 */ /*GILLT_v4s32*//*Label 2328*/ GIMT_Encode4(119761), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119587 */ /*GILLT_v8s16*//*Label 2329*/ GIMT_Encode4(119940),
     /* 119591 */ // Label 2323: @119591
     /* 119591 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(119624), // Rule ID 642 //
     /* 119596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 119599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 119602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 119605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119617 */   // (fminnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMINNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 119617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMH),
     /* 119622 */   GIR_RootConstrainSelectedInstOperands,
     /* 119623 */   // GIR_Coverage, 642,
     /* 119623 */   GIR_Done,
     /* 119624 */ // Label 2331: @119624
     /* 119624 */ GIM_Reject,
     /* 119625 */ // Label 2324: @119625
     /* 119625 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(119658), // Rule ID 643 //
     /* 119630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 119639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119651 */   // (fminnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMINNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 119651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMS),
     /* 119656 */   GIR_RootConstrainSelectedInstOperands,
     /* 119657 */   // GIR_Coverage, 643,
     /* 119657 */   GIR_Done,
     /* 119658 */ // Label 2332: @119658
     /* 119658 */ GIM_Reject,
     /* 119659 */ // Label 2325: @119659
     /* 119659 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(119692), // Rule ID 644 //
     /* 119664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 119667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 119673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119681 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119685 */   // (fminnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMINNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 119685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMD),
     /* 119690 */   GIR_RootConstrainSelectedInstOperands,
     /* 119691 */   // GIR_Coverage, 644,
     /* 119691 */   GIR_Done,
     /* 119692 */ // Label 2333: @119692
     /* 119692 */ GIM_Reject,
     /* 119693 */ // Label 2326: @119693
     /* 119693 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(119726), // Rule ID 1230 //
     /* 119698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 119701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 119707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119719 */   // (fminnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMINNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 119719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDf),
     /* 119724 */   GIR_RootConstrainSelectedInstOperands,
     /* 119725 */   // GIR_Coverage, 1230,
     /* 119725 */   GIR_Done,
     /* 119726 */ // Label 2334: @119726
     /* 119726 */ GIM_Reject,
     /* 119727 */ // Label 2327: @119727
     /* 119727 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(119760), // Rule ID 1232 //
     /* 119732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 119735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 119741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119753 */   // (fminnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMINNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 119753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDh),
     /* 119758 */   GIR_RootConstrainSelectedInstOperands,
     /* 119759 */   // GIR_Coverage, 1232,
     /* 119759 */   GIR_Done,
     /* 119760 */ // Label 2335: @119760
     /* 119760 */ GIM_Reject,
     /* 119761 */ // Label 2328: @119761
     /* 119761 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(119939),
     /* 119766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 119772 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(119850), // Rule ID 4119 //
     /* 119777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 119792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 119805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 119809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119813 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119820 */     // (fminnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMINNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 119820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf32),
     /* 119823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 119829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 119833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119848 */     GIR_RootConstrainSelectedInstOperands,
     /* 119849 */     // GIR_Coverage, 4119,
     /* 119849 */     GIR_EraseRootFromParent_Done,
     /* 119850 */   // Label 2337: @119850
     /* 119850 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(119877), // Rule ID 1231 //
     /* 119855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 119858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119870 */     // (fminnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMINNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 119870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQf),
     /* 119875 */     GIR_RootConstrainSelectedInstOperands,
     /* 119876 */     // GIR_Coverage, 1231,
     /* 119876 */     GIR_Done,
     /* 119877 */   // Label 2338: @119877
     /* 119877 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(119938), // Rule ID 3285 //
     /* 119882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119897 */     // (fminnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMINNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 119897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf32),
     /* 119912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119914 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 119916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 119918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119921 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119936 */     GIR_RootConstrainSelectedInstOperands,
     /* 119937 */     // GIR_Coverage, 3285,
     /* 119937 */     GIR_EraseRootFromParent_Done,
     /* 119938 */   // Label 2339: @119938
     /* 119938 */   GIM_Reject,
     /* 119939 */ // Label 2336: @119939
     /* 119939 */ GIM_Reject,
     /* 119940 */ // Label 2329: @119940
     /* 119940 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(120118),
     /* 119945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 119951 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(120029), // Rule ID 4121 //
     /* 119956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 119971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 119984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 119988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119992 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119999 */     // (fminnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMINNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 119999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf16),
     /* 120002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120015 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120027 */     GIR_RootConstrainSelectedInstOperands,
     /* 120028 */     // GIR_Coverage, 4121,
     /* 120028 */     GIR_EraseRootFromParent_Done,
     /* 120029 */   // Label 2341: @120029
     /* 120029 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(120056), // Rule ID 1233 //
     /* 120034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120049 */     // (fminnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMINNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQh),
     /* 120054 */     GIR_RootConstrainSelectedInstOperands,
     /* 120055 */     // GIR_Coverage, 1233,
     /* 120055 */     GIR_Done,
     /* 120056 */   // Label 2342: @120056
     /* 120056 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(120117), // Rule ID 3288 //
     /* 120061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120076 */     // (fminnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMINNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf16),
     /* 120091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120115 */     GIR_RootConstrainSelectedInstOperands,
     /* 120116 */     // GIR_Coverage, 3288,
     /* 120116 */     GIR_EraseRootFromParent_Done,
     /* 120117 */   // Label 2343: @120117
     /* 120117 */   GIM_Reject,
     /* 120118 */ // Label 2340: @120118
     /* 120118 */ GIM_Reject,
     /* 120119 */ // Label 2330: @120119
     /* 120119 */ GIM_Reject,
     /* 120120 */ // Label 48: @120120
     /* 120120 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2351*/ GIMT_Encode4(120711),
     /* 120131 */ /*GILLT_s16*//*Label 2344*/ GIMT_Encode4(120183),
     /* 120135 */ /*GILLT_s32*//*Label 2345*/ GIMT_Encode4(120217),
     /* 120139 */ /*GILLT_s64*//*Label 2346*/ GIMT_Encode4(120251), GIMT_Encode4(0),
     /* 120147 */ /*GILLT_v2s32*//*Label 2347*/ GIMT_Encode4(120285), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120159 */ /*GILLT_v4s16*//*Label 2348*/ GIMT_Encode4(120319),
     /* 120163 */ /*GILLT_v4s32*//*Label 2349*/ GIMT_Encode4(120353), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120179 */ /*GILLT_v8s16*//*Label 2350*/ GIMT_Encode4(120532),
     /* 120183 */ // Label 2344: @120183
     /* 120183 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(120216), // Rule ID 639 //
     /* 120188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120209 */   // (fmaxnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMAXNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMH),
     /* 120214 */   GIR_RootConstrainSelectedInstOperands,
     /* 120215 */   // GIR_Coverage, 639,
     /* 120215 */   GIR_Done,
     /* 120216 */ // Label 2352: @120216
     /* 120216 */ GIM_Reject,
     /* 120217 */ // Label 2345: @120217
     /* 120217 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(120250), // Rule ID 640 //
     /* 120222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120243 */   // (fmaxnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMAXNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120243 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMS),
     /* 120248 */   GIR_RootConstrainSelectedInstOperands,
     /* 120249 */   // GIR_Coverage, 640,
     /* 120249 */   GIR_Done,
     /* 120250 */ // Label 2353: @120250
     /* 120250 */ GIM_Reject,
     /* 120251 */ // Label 2346: @120251
     /* 120251 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(120284), // Rule ID 641 //
     /* 120256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120277 */   // (fmaxnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMAXNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMD),
     /* 120282 */   GIR_RootConstrainSelectedInstOperands,
     /* 120283 */   // GIR_Coverage, 641,
     /* 120283 */   GIR_Done,
     /* 120284 */ // Label 2354: @120284
     /* 120284 */ GIM_Reject,
     /* 120285 */ // Label 2347: @120285
     /* 120285 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(120318), // Rule ID 1210 //
     /* 120290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120311 */   // (fmaxnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMAXNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDf),
     /* 120316 */   GIR_RootConstrainSelectedInstOperands,
     /* 120317 */   // GIR_Coverage, 1210,
     /* 120317 */   GIR_Done,
     /* 120318 */ // Label 2355: @120318
     /* 120318 */ GIM_Reject,
     /* 120319 */ // Label 2348: @120319
     /* 120319 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(120352), // Rule ID 1212 //
     /* 120324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120345 */   // (fmaxnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMAXNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDh),
     /* 120350 */   GIR_RootConstrainSelectedInstOperands,
     /* 120351 */   // GIR_Coverage, 1212,
     /* 120351 */   GIR_Done,
     /* 120352 */ // Label 2356: @120352
     /* 120352 */ GIM_Reject,
     /* 120353 */ // Label 2349: @120353
     /* 120353 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(120531),
     /* 120358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120364 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(120442), // Rule ID 4115 //
     /* 120369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120412 */     // (fmaxnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMAXNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf32),
     /* 120415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120428 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120440 */     GIR_RootConstrainSelectedInstOperands,
     /* 120441 */     // GIR_Coverage, 4115,
     /* 120441 */     GIR_EraseRootFromParent_Done,
     /* 120442 */   // Label 2358: @120442
     /* 120442 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(120469), // Rule ID 1211 //
     /* 120447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120462 */     // (fmaxnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMAXNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQf),
     /* 120467 */     GIR_RootConstrainSelectedInstOperands,
     /* 120468 */     // GIR_Coverage, 1211,
     /* 120468 */     GIR_Done,
     /* 120469 */   // Label 2359: @120469
     /* 120469 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(120530), // Rule ID 3027 //
     /* 120474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120489 */     // (fmaxnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMAXNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf32),
     /* 120504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120528 */     GIR_RootConstrainSelectedInstOperands,
     /* 120529 */     // GIR_Coverage, 3027,
     /* 120529 */     GIR_EraseRootFromParent_Done,
     /* 120530 */   // Label 2360: @120530
     /* 120530 */   GIM_Reject,
     /* 120531 */ // Label 2357: @120531
     /* 120531 */ GIM_Reject,
     /* 120532 */ // Label 2350: @120532
     /* 120532 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(120710),
     /* 120537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120543 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(120621), // Rule ID 4117 //
     /* 120548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120591 */     // (fmaxnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMAXNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 120591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf16),
     /* 120594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120619 */     GIR_RootConstrainSelectedInstOperands,
     /* 120620 */     // GIR_Coverage, 4117,
     /* 120620 */     GIR_EraseRootFromParent_Done,
     /* 120621 */   // Label 2362: @120621
     /* 120621 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(120648), // Rule ID 1213 //
     /* 120626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120641 */     // (fmaxnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMAXNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQh),
     /* 120646 */     GIR_RootConstrainSelectedInstOperands,
     /* 120647 */     // GIR_Coverage, 1213,
     /* 120647 */     GIR_Done,
     /* 120648 */   // Label 2363: @120648
     /* 120648 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(120709), // Rule ID 3282 //
     /* 120653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120668 */     // (fmaxnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMAXNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf16),
     /* 120683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120707 */     GIR_RootConstrainSelectedInstOperands,
     /* 120708 */     // GIR_Coverage, 3282,
     /* 120708 */     GIR_EraseRootFromParent_Done,
     /* 120709 */   // Label 2364: @120709
     /* 120709 */   GIM_Reject,
     /* 120710 */ // Label 2361: @120710
     /* 120710 */ GIM_Reject,
     /* 120711 */ // Label 2351: @120711
     /* 120711 */ GIM_Reject,
     /* 120712 */ // Label 49: @120712
     /* 120712 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2371*/ GIMT_Encode4(121445),
     /* 120723 */ /*GILLT_s16*//*Label 2365*/ GIMT_Encode4(120775),
     /* 120727 */ /*GILLT_s32*//*Label 2366*/ GIMT_Encode4(121016), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120739 */ /*GILLT_v2s32*//*Label 2367*/ GIMT_Encode4(121257), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120751 */ /*GILLT_v4s16*//*Label 2368*/ GIMT_Encode4(121304),
     /* 120755 */ /*GILLT_v4s32*//*Label 2369*/ GIMT_Encode4(121351), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120771 */ /*GILLT_v8s16*//*Label 2370*/ GIMT_Encode4(121398),
     /* 120775 */ // Label 2365: @120775
     /* 120775 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(121015), // Rule ID 2704 //
     /* 120780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120801 */   // (fminimum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMINhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 120801 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 120804 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120808 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 120815 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 120818 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120822 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120827 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 120830 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 120835 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 120838 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120842 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120847 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 120850 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 120854 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 120857 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 120862 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 120867 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 120872 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 120875 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120879 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 120886 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 120889 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120893 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120898 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 120901 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 120906 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 120909 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120913 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120918 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 120921 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 120925 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 120928 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 120933 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 120938 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 120943 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120946 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 120950 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120955 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 120958 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 120961 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 120964 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 120975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120984 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120987 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 120992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120997 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121004 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121009 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121014 */   // GIR_Coverage, 2704,
     /* 121014 */   GIR_EraseRootFromParent_Done,
     /* 121015 */ // Label 2372: @121015
     /* 121015 */ GIM_Reject,
     /* 121016 */ // Label 2366: @121016
     /* 121016 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(121256), // Rule ID 2706 //
     /* 121021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121038 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121042 */   // (fminimum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMINfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121042 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 121045 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121049 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121056 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 121059 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121063 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121068 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121071 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121076 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 121079 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121083 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121088 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121091 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121095 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121098 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121103 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121108 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121113 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 121116 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121120 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121127 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 121130 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121134 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121139 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121142 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121147 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 121150 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121154 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121159 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121162 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121166 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121169 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121174 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121179 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121184 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121187 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121191 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121196 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121199 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121202 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121205 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121213 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 121216 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121220 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121225 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121228 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121238 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121250 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121255 */   // GIR_Coverage, 2706,
     /* 121255 */   GIR_EraseRootFromParent_Done,
     /* 121256 */ // Label 2373: @121256
     /* 121256 */ GIM_Reject,
     /* 121257 */ // Label 2367: @121257
     /* 121257 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(121303), // Rule ID 1226 //
     /* 121262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 121268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 121271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121283 */   // (fminimum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMINfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 121283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121288 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121290 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121295 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121301 */   GIR_RootConstrainSelectedInstOperands,
     /* 121302 */   // GIR_Coverage, 1226,
     /* 121302 */   GIR_EraseRootFromParent_Done,
     /* 121303 */ // Label 2374: @121303
     /* 121303 */ GIM_Reject,
     /* 121304 */ // Label 2368: @121304
     /* 121304 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(121350), // Rule ID 1228 //
     /* 121309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 121315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 121318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121330 */   // (fminimum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMINhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 121330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121335 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121337 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121342 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121348 */   GIR_RootConstrainSelectedInstOperands,
     /* 121349 */   // GIR_Coverage, 1228,
     /* 121349 */   GIR_EraseRootFromParent_Done,
     /* 121350 */ // Label 2375: @121350
     /* 121350 */ GIM_Reject,
     /* 121351 */ // Label 2369: @121351
     /* 121351 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(121397), // Rule ID 1227 //
     /* 121356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 121362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 121365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121377 */   // (fminimum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMINfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 121377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfq),
     /* 121380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121382 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121384 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121389 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121395 */   GIR_RootConstrainSelectedInstOperands,
     /* 121396 */   // GIR_Coverage, 1227,
     /* 121396 */   GIR_EraseRootFromParent_Done,
     /* 121397 */ // Label 2376: @121397
     /* 121397 */ GIM_Reject,
     /* 121398 */ // Label 2370: @121398
     /* 121398 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(121444), // Rule ID 1229 //
     /* 121403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121424 */   // (fminimum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMINhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhq),
     /* 121427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121429 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121431 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121436 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121442 */   GIR_RootConstrainSelectedInstOperands,
     /* 121443 */   // GIR_Coverage, 1229,
     /* 121443 */   GIR_EraseRootFromParent_Done,
     /* 121444 */ // Label 2377: @121444
     /* 121444 */ GIM_Reject,
     /* 121445 */ // Label 2371: @121445
     /* 121445 */ GIM_Reject,
     /* 121446 */ // Label 50: @121446
     /* 121446 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2384*/ GIMT_Encode4(122179),
     /* 121457 */ /*GILLT_s16*//*Label 2378*/ GIMT_Encode4(121509),
     /* 121461 */ /*GILLT_s32*//*Label 2379*/ GIMT_Encode4(121750), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121473 */ /*GILLT_v2s32*//*Label 2380*/ GIMT_Encode4(121991), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121485 */ /*GILLT_v4s16*//*Label 2381*/ GIMT_Encode4(122038),
     /* 121489 */ /*GILLT_v4s32*//*Label 2382*/ GIMT_Encode4(122085), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121505 */ /*GILLT_v8s16*//*Label 2383*/ GIMT_Encode4(122132),
     /* 121509 */ // Label 2378: @121509
     /* 121509 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(121749), // Rule ID 2703 //
     /* 121514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 121523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121535 */   // (fmaximum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMAXhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121535 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 121538 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121542 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121549 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 121552 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121556 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121561 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121564 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121569 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 121572 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121576 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121581 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121584 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121588 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121591 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121596 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121601 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121606 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 121609 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121613 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121620 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 121623 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121627 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121632 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121635 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121640 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 121643 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121647 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121652 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121655 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121659 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121662 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121667 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121672 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121677 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121680 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 121684 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121689 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121692 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121695 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121698 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 121709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121718 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121721 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121731 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121738 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121748 */   // GIR_Coverage, 2703,
     /* 121748 */   GIR_EraseRootFromParent_Done,
     /* 121749 */ // Label 2385: @121749
     /* 121749 */ GIM_Reject,
     /* 121750 */ // Label 2379: @121750
     /* 121750 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(121990), // Rule ID 2705 //
     /* 121755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121776 */   // (fmaximum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMAXfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121776 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 121779 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121783 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121790 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 121793 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121797 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121802 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121805 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121810 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 121813 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121817 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121822 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121825 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121829 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121832 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121837 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121842 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121847 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 121850 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121854 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121861 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 121864 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121868 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121873 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121876 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121881 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 121884 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121888 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121893 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121896 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121900 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121903 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121908 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121913 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121918 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121921 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 121925 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121930 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121933 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121936 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121939 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121947 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 121950 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121954 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121959 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121962 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121972 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121984 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121989 */   // GIR_Coverage, 2705,
     /* 121989 */   GIR_EraseRootFromParent_Done,
     /* 121990 */ // Label 2386: @121990
     /* 121990 */ GIM_Reject,
     /* 121991 */ // Label 2380: @121991
     /* 121991 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(122037), // Rule ID 1206 //
     /* 121996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122017 */   // (fmaximum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMAXfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 122017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122022 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122024 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122029 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122035 */   GIR_RootConstrainSelectedInstOperands,
     /* 122036 */   // GIR_Coverage, 1206,
     /* 122036 */   GIR_EraseRootFromParent_Done,
     /* 122037 */ // Label 2387: @122037
     /* 122037 */ GIM_Reject,
     /* 122038 */ // Label 2381: @122038
     /* 122038 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(122084), // Rule ID 1208 //
     /* 122043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122064 */   // (fmaximum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMAXhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 122064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122069 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122071 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122076 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122082 */   GIR_RootConstrainSelectedInstOperands,
     /* 122083 */   // GIR_Coverage, 1208,
     /* 122083 */   GIR_EraseRootFromParent_Done,
     /* 122084 */ // Label 2388: @122084
     /* 122084 */ GIM_Reject,
     /* 122085 */ // Label 2382: @122085
     /* 122085 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(122131), // Rule ID 1207 //
     /* 122090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122111 */   // (fmaximum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMAXfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 122111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfq),
     /* 122114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122116 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122118 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122123 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122129 */   GIR_RootConstrainSelectedInstOperands,
     /* 122130 */   // GIR_Coverage, 1207,
     /* 122130 */   GIR_EraseRootFromParent_Done,
     /* 122131 */ // Label 2389: @122131
     /* 122131 */ GIM_Reject,
     /* 122132 */ // Label 2383: @122132
     /* 122132 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(122178), // Rule ID 1209 //
     /* 122137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122158 */   // (fmaximum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMAXhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 122158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhq),
     /* 122161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122163 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122165 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122170 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122176 */   GIR_RootConstrainSelectedInstOperands,
     /* 122177 */   // GIR_Coverage, 1209,
     /* 122177 */   GIR_EraseRootFromParent_Done,
     /* 122178 */ // Label 2390: @122178
     /* 122178 */ GIM_Reject,
     /* 122179 */ // Label 2384: @122179
     /* 122179 */ GIM_Reject,
     /* 122180 */ // Label 51: @122180
     /* 122180 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(122212), // Rule ID 2416 //
     /* 122185 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122192 */   // (get_fpenv:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122206 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122210 */   GIR_RootConstrainSelectedInstOperands,
     /* 122211 */   // GIR_Coverage, 2416,
     /* 122211 */   GIR_EraseRootFromParent_Done,
     /* 122212 */ // Label 2391: @122212
     /* 122212 */ GIM_Reject,
     /* 122213 */ // Label 52: @122213
     /* 122213 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(122248), // Rule ID 2417 //
     /* 122218 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122225 */   // (set_fpenv GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /* 122225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122228 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122233 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122239 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122246 */   GIR_RootConstrainSelectedInstOperands,
     /* 122247 */   // GIR_Coverage, 2417,
     /* 122247 */   GIR_EraseRootFromParent_Done,
     /* 122248 */ // Label 2392: @122248
     /* 122248 */ GIM_Reject,
     /* 122249 */ // Label 53: @122249
     /* 122249 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(122313), // Rule ID 2418 //
     /* 122254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 122257 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (MOVi:{ *:[i32] } 0:{ *:[i32] }))
     /* 122257 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122260 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /* 122264 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122269 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122272 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122275 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122281 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122298 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122304 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122307 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122311 */   GIR_RootConstrainSelectedInstOperands,
     /* 122312 */   // GIR_Coverage, 2418,
     /* 122312 */   GIR_EraseRootFromParent_Done,
     /* 122313 */ // Label 2393: @122313
     /* 122313 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(122377), // Rule ID 2419 //
     /* 122318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 122321 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /* 122321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /* 122328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122333 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 122339 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122342 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122345 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122356 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122362 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122368 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122371 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122375 */   GIR_RootConstrainSelectedInstOperands,
     /* 122376 */   // GIR_Coverage, 2419,
     /* 122376 */   GIR_EraseRootFromParent_Done,
     /* 122377 */ // Label 2394: @122377
     /* 122377 */ GIM_Reject,
     /* 122378 */ // Label 54: @122378
     /* 122378 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(122410), // Rule ID 2420 //
     /* 122383 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122390 */   // (get_fpmode:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122398 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122408 */   GIR_RootConstrainSelectedInstOperands,
     /* 122409 */   // GIR_Coverage, 2420,
     /* 122409 */   GIR_EraseRootFromParent_Done,
     /* 122410 */ // Label 2395: @122410
     /* 122410 */ GIM_Reject,
     /* 122411 */ // Label 55: @122411
     /* 122411 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2402*/ GIMT_Encode4(122953),
     /* 122422 */ /*GILLT_v2s32*//*Label 2396*/ GIMT_Encode4(122470), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122434 */ /*GILLT_v4s16*//*Label 2397*/ GIMT_Encode4(122517),
     /* 122438 */ /*GILLT_v4s32*//*Label 2398*/ GIMT_Encode4(122564), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122450 */ /*GILLT_v8s8*//*Label 2399*/ GIMT_Encode4(122678),
     /* 122454 */ /*GILLT_v8s16*//*Label 2400*/ GIMT_Encode4(122725), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122466 */ /*GILLT_v16s8*//*Label 2401*/ GIMT_Encode4(122839),
     /* 122470 */ // Label 2396: @122470
     /* 122470 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(122516), // Rule ID 1215 //
     /* 122475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122496 */   // (smin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 122496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv2i32),
     /* 122499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122501 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122503 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122508 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122514 */   GIR_RootConstrainSelectedInstOperands,
     /* 122515 */   // GIR_Coverage, 1215,
     /* 122515 */   GIR_EraseRootFromParent_Done,
     /* 122516 */ // Label 2403: @122516
     /* 122516 */ GIM_Reject,
     /* 122517 */ // Label 2397: @122517
     /* 122517 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(122563), // Rule ID 1214 //
     /* 122522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122543 */   // (smin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 122543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i16),
     /* 122546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122548 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122550 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122555 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122561 */   GIR_RootConstrainSelectedInstOperands,
     /* 122562 */   // GIR_Coverage, 1214,
     /* 122562 */   GIR_EraseRootFromParent_Done,
     /* 122563 */ // Label 2404: @122563
     /* 122563 */ GIM_Reject,
     /* 122564 */ // Label 2398: @122564
     /* 122564 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(122677),
     /* 122569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122575 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(122615), // Rule ID 1217 //
     /* 122580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122595 */     // (smin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 122595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i32),
     /* 122598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122600 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122613 */     GIR_RootConstrainSelectedInstOperands,
     /* 122614 */     // GIR_Coverage, 1217,
     /* 122614 */     GIR_EraseRootFromParent_Done,
     /* 122615 */   // Label 2406: @122615
     /* 122615 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(122676), // Rule ID 3297 //
     /* 122620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 122623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122635 */     // (smin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 122635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 122638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs32),
     /* 122650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 122652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 122654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 122656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122665 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122674 */     GIR_RootConstrainSelectedInstOperands,
     /* 122675 */     // GIR_Coverage, 3297,
     /* 122675 */     GIR_EraseRootFromParent_Done,
     /* 122676 */   // Label 2407: @122676
     /* 122676 */   GIM_Reject,
     /* 122677 */ // Label 2405: @122677
     /* 122677 */ GIM_Reject,
     /* 122678 */ // Label 2399: @122678
     /* 122678 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(122724), // Rule ID 1218 //
     /* 122683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 122689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 122692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122704 */   // (smin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 122704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i8),
     /* 122707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122709 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122711 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122716 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122722 */   GIR_RootConstrainSelectedInstOperands,
     /* 122723 */   // GIR_Coverage, 1218,
     /* 122723 */   GIR_EraseRootFromParent_Done,
     /* 122724 */ // Label 2408: @122724
     /* 122724 */ GIM_Reject,
     /* 122725 */ // Label 2400: @122725
     /* 122725 */ GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(122838),
     /* 122730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122736 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(122776), // Rule ID 1216 //
     /* 122741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122756 */     // (smin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 122756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i16),
     /* 122759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122774 */     GIR_RootConstrainSelectedInstOperands,
     /* 122775 */     // GIR_Coverage, 1216,
     /* 122775 */     GIR_EraseRootFromParent_Done,
     /* 122776 */   // Label 2410: @122776
     /* 122776 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(122837), // Rule ID 3294 //
     /* 122781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 122784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122796 */     // (smin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 122796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 122799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs16),
     /* 122811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 122813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 122815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 122817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122835 */     GIR_RootConstrainSelectedInstOperands,
     /* 122836 */     // GIR_Coverage, 3294,
     /* 122836 */     GIR_EraseRootFromParent_Done,
     /* 122837 */   // Label 2411: @122837
     /* 122837 */   GIM_Reject,
     /* 122838 */ // Label 2409: @122838
     /* 122838 */ GIM_Reject,
     /* 122839 */ // Label 2401: @122839
     /* 122839 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(122952),
     /* 122844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 122847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 122850 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(122890), // Rule ID 1219 //
     /* 122855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122870 */     // (smin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 122870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv16i8),
     /* 122873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122888 */     GIR_RootConstrainSelectedInstOperands,
     /* 122889 */     // GIR_Coverage, 1219,
     /* 122889 */     GIR_EraseRootFromParent_Done,
     /* 122890 */   // Label 2413: @122890
     /* 122890 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(122951), // Rule ID 3291 //
     /* 122895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 122898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 122910 */     // (smin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 122910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 122913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs8),
     /* 122925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 122927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 122929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 122931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122949 */     GIR_RootConstrainSelectedInstOperands,
     /* 122950 */     // GIR_Coverage, 3291,
     /* 122950 */     GIR_EraseRootFromParent_Done,
     /* 122951 */   // Label 2414: @122951
     /* 122951 */   GIM_Reject,
     /* 122952 */ // Label 2412: @122952
     /* 122952 */ GIM_Reject,
     /* 122953 */ // Label 2402: @122953
     /* 122953 */ GIM_Reject,
     /* 122954 */ // Label 56: @122954
     /* 122954 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2421*/ GIMT_Encode4(123496),
     /* 122965 */ /*GILLT_v2s32*//*Label 2415*/ GIMT_Encode4(123013), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122977 */ /*GILLT_v4s16*//*Label 2416*/ GIMT_Encode4(123060),
     /* 122981 */ /*GILLT_v4s32*//*Label 2417*/ GIMT_Encode4(123107), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122993 */ /*GILLT_v8s8*//*Label 2418*/ GIMT_Encode4(123221),
     /* 122997 */ /*GILLT_v8s16*//*Label 2419*/ GIMT_Encode4(123268), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123009 */ /*GILLT_v16s8*//*Label 2420*/ GIMT_Encode4(123382),
     /* 123013 */ // Label 2415: @123013
     /* 123013 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(123059), // Rule ID 1195 //
     /* 123018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123039 */   // (smax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv2i32),
     /* 123042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123044 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123046 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123051 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123057 */   GIR_RootConstrainSelectedInstOperands,
     /* 123058 */   // GIR_Coverage, 1195,
     /* 123058 */   GIR_EraseRootFromParent_Done,
     /* 123059 */ // Label 2422: @123059
     /* 123059 */ GIM_Reject,
     /* 123060 */ // Label 2416: @123060
     /* 123060 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(123106), // Rule ID 1194 //
     /* 123065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123082 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123086 */   // (smax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i16),
     /* 123089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123091 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123093 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123098 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123104 */   GIR_RootConstrainSelectedInstOperands,
     /* 123105 */   // GIR_Coverage, 1194,
     /* 123105 */   GIR_EraseRootFromParent_Done,
     /* 123106 */ // Label 2423: @123106
     /* 123106 */ GIM_Reject,
     /* 123107 */ // Label 2417: @123107
     /* 123107 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(123220),
     /* 123112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123118 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(123158), // Rule ID 1197 //
     /* 123123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123138 */     // (smax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i32),
     /* 123141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123156 */     GIR_RootConstrainSelectedInstOperands,
     /* 123157 */     // GIR_Coverage, 1197,
     /* 123157 */     GIR_EraseRootFromParent_Done,
     /* 123158 */   // Label 2425: @123158
     /* 123158 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(123219), // Rule ID 3315 //
     /* 123163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123178 */     // (smax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs32),
     /* 123193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123217 */     GIR_RootConstrainSelectedInstOperands,
     /* 123218 */     // GIR_Coverage, 3315,
     /* 123218 */     GIR_EraseRootFromParent_Done,
     /* 123219 */   // Label 2426: @123219
     /* 123219 */   GIM_Reject,
     /* 123220 */ // Label 2424: @123220
     /* 123220 */ GIM_Reject,
     /* 123221 */ // Label 2418: @123221
     /* 123221 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(123267), // Rule ID 1198 //
     /* 123226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123247 */   // (smax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i8),
     /* 123250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123252 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123254 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123259 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123265 */   GIR_RootConstrainSelectedInstOperands,
     /* 123266 */   // GIR_Coverage, 1198,
     /* 123266 */   GIR_EraseRootFromParent_Done,
     /* 123267 */ // Label 2427: @123267
     /* 123267 */ GIM_Reject,
     /* 123268 */ // Label 2419: @123268
     /* 123268 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(123381),
     /* 123273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123279 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(123319), // Rule ID 1196 //
     /* 123284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123299 */     // (smax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i16),
     /* 123302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123317 */     GIR_RootConstrainSelectedInstOperands,
     /* 123318 */     // GIR_Coverage, 1196,
     /* 123318 */     GIR_EraseRootFromParent_Done,
     /* 123319 */   // Label 2429: @123319
     /* 123319 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(123380), // Rule ID 3312 //
     /* 123324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123339 */     // (smax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs16),
     /* 123354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123378 */     GIR_RootConstrainSelectedInstOperands,
     /* 123379 */     // GIR_Coverage, 3312,
     /* 123379 */     GIR_EraseRootFromParent_Done,
     /* 123380 */   // Label 2430: @123380
     /* 123380 */   GIM_Reject,
     /* 123381 */ // Label 2428: @123381
     /* 123381 */ GIM_Reject,
     /* 123382 */ // Label 2420: @123382
     /* 123382 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(123495),
     /* 123387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123393 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(123433), // Rule ID 1199 //
     /* 123398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123413 */     // (smax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv16i8),
     /* 123416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123431 */     GIR_RootConstrainSelectedInstOperands,
     /* 123432 */     // GIR_Coverage, 1199,
     /* 123432 */     GIR_EraseRootFromParent_Done,
     /* 123433 */   // Label 2432: @123433
     /* 123433 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(123494), // Rule ID 3309 //
     /* 123438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123453 */     // (smax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs8),
     /* 123468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123492 */     GIR_RootConstrainSelectedInstOperands,
     /* 123493 */     // GIR_Coverage, 3309,
     /* 123493 */     GIR_EraseRootFromParent_Done,
     /* 123494 */   // Label 2433: @123494
     /* 123494 */   GIM_Reject,
     /* 123495 */ // Label 2431: @123495
     /* 123495 */ GIM_Reject,
     /* 123496 */ // Label 2421: @123496
     /* 123496 */ GIM_Reject,
     /* 123497 */ // Label 57: @123497
     /* 123497 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2440*/ GIMT_Encode4(124417),
     /* 123508 */ /*GILLT_v2s32*//*Label 2434*/ GIMT_Encode4(123556), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123520 */ /*GILLT_v4s16*//*Label 2435*/ GIMT_Encode4(123603),
     /* 123524 */ /*GILLT_v4s32*//*Label 2436*/ GIMT_Encode4(123650), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123536 */ /*GILLT_v8s8*//*Label 2437*/ GIMT_Encode4(123890),
     /* 123540 */ /*GILLT_v8s16*//*Label 2438*/ GIMT_Encode4(123937), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123552 */ /*GILLT_v16s8*//*Label 2439*/ GIMT_Encode4(124177),
     /* 123556 */ // Label 2434: @123556
     /* 123556 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(123602), // Rule ID 1221 //
     /* 123561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123578 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123582 */   // (umin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv2i32),
     /* 123585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123587 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123589 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123594 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123600 */   GIR_RootConstrainSelectedInstOperands,
     /* 123601 */   // GIR_Coverage, 1221,
     /* 123601 */   GIR_EraseRootFromParent_Done,
     /* 123602 */ // Label 2441: @123602
     /* 123602 */ GIM_Reject,
     /* 123603 */ // Label 2435: @123603
     /* 123603 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(123649), // Rule ID 1220 //
     /* 123608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123629 */   // (umin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i16),
     /* 123632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123634 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123636 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123641 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123647 */   GIR_RootConstrainSelectedInstOperands,
     /* 123648 */   // GIR_Coverage, 1220,
     /* 123648 */   GIR_EraseRootFromParent_Done,
     /* 123649 */ // Label 2442: @123649
     /* 123649 */ GIM_Reject,
     /* 123650 */ // Label 2436: @123650
     /* 123650 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(123889),
     /* 123655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123661 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(123724), // Rule ID 6024 //
     /* 123666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 123681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123696 */     // (umin:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 123696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 123699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 123703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 123707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123722 */     GIR_RootConstrainSelectedInstOperands,
     /* 123723 */     // GIR_Coverage, 6024,
     /* 123723 */     GIR_EraseRootFromParent_Done,
     /* 123724 */   // Label 2444: @123724
     /* 123724 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(123787), // Rule ID 3694 //
     /* 123729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 123748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123759 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 123759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 123762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 123766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 123770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123785 */     GIR_RootConstrainSelectedInstOperands,
     /* 123786 */     // GIR_Coverage, 3694,
     /* 123786 */     GIR_EraseRootFromParent_Done,
     /* 123787 */   // Label 2445: @123787
     /* 123787 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(123827), // Rule ID 1223 //
     /* 123792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123807 */     // (umin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i32),
     /* 123810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123825 */     GIR_RootConstrainSelectedInstOperands,
     /* 123826 */     // GIR_Coverage, 1223,
     /* 123826 */     GIR_EraseRootFromParent_Done,
     /* 123827 */   // Label 2446: @123827
     /* 123827 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(123888), // Rule ID 3306 //
     /* 123832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123847 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu32),
     /* 123862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123886 */     GIR_RootConstrainSelectedInstOperands,
     /* 123887 */     // GIR_Coverage, 3306,
     /* 123887 */     GIR_EraseRootFromParent_Done,
     /* 123888 */   // Label 2447: @123888
     /* 123888 */   GIM_Reject,
     /* 123889 */ // Label 2443: @123889
     /* 123889 */ GIM_Reject,
     /* 123890 */ // Label 2437: @123890
     /* 123890 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(123936), // Rule ID 1224 //
     /* 123895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123912 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123916 */   // (umin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i8),
     /* 123919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123921 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123923 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123928 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123934 */   GIR_RootConstrainSelectedInstOperands,
     /* 123935 */   // GIR_Coverage, 1224,
     /* 123935 */   GIR_EraseRootFromParent_Done,
     /* 123936 */ // Label 2448: @123936
     /* 123936 */ GIM_Reject,
     /* 123937 */ // Label 2438: @123937
     /* 123937 */ GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(124176),
     /* 123942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123948 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(124011), // Rule ID 6023 //
     /* 123953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 123968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123983 */     // (umin:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 123983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 123986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 123990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 123994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124003 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124009 */     GIR_RootConstrainSelectedInstOperands,
     /* 124010 */     // GIR_Coverage, 6023,
     /* 124010 */     GIR_EraseRootFromParent_Done,
     /* 124011 */   // Label 2450: @124011
     /* 124011 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(124074), // Rule ID 3692 //
     /* 124016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124046 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124072 */     GIR_RootConstrainSelectedInstOperands,
     /* 124073 */     // GIR_Coverage, 3692,
     /* 124073 */     GIR_EraseRootFromParent_Done,
     /* 124074 */   // Label 2451: @124074
     /* 124074 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(124114), // Rule ID 1222 //
     /* 124079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124094 */     // (umin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 124094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i16),
     /* 124097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124112 */     GIR_RootConstrainSelectedInstOperands,
     /* 124113 */     // GIR_Coverage, 1222,
     /* 124113 */     GIR_EraseRootFromParent_Done,
     /* 124114 */   // Label 2452: @124114
     /* 124114 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(124175), // Rule ID 3303 //
     /* 124119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124134 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 124134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu16),
     /* 124149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124173 */     GIR_RootConstrainSelectedInstOperands,
     /* 124174 */     // GIR_Coverage, 3303,
     /* 124174 */     GIR_EraseRootFromParent_Done,
     /* 124175 */   // Label 2453: @124175
     /* 124175 */   GIM_Reject,
     /* 124176 */ // Label 2449: @124176
     /* 124176 */ GIM_Reject,
     /* 124177 */ // Label 2439: @124177
     /* 124177 */ GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(124416),
     /* 124182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 124188 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(124251), // Rule ID 6022 //
     /* 124193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124223 */     // (umin:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124249 */     GIR_RootConstrainSelectedInstOperands,
     /* 124250 */     // GIR_Coverage, 6022,
     /* 124250 */     GIR_EraseRootFromParent_Done,
     /* 124251 */   // Label 2455: @124251
     /* 124251 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(124314), // Rule ID 3690 //
     /* 124256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124286 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124312 */     GIR_RootConstrainSelectedInstOperands,
     /* 124313 */     // GIR_Coverage, 3690,
     /* 124313 */     GIR_EraseRootFromParent_Done,
     /* 124314 */   // Label 2456: @124314
     /* 124314 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(124354), // Rule ID 1225 //
     /* 124319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124334 */     // (umin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 124334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv16i8),
     /* 124337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124352 */     GIR_RootConstrainSelectedInstOperands,
     /* 124353 */     // GIR_Coverage, 1225,
     /* 124353 */     GIR_EraseRootFromParent_Done,
     /* 124354 */   // Label 2457: @124354
     /* 124354 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(124415), // Rule ID 3300 //
     /* 124359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124374 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 124374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu8),
     /* 124389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124413 */     GIR_RootConstrainSelectedInstOperands,
     /* 124414 */     // GIR_Coverage, 3300,
     /* 124414 */     GIR_EraseRootFromParent_Done,
     /* 124415 */   // Label 2458: @124415
     /* 124415 */   GIM_Reject,
     /* 124416 */ // Label 2454: @124416
     /* 124416 */ GIM_Reject,
     /* 124417 */ // Label 2440: @124417
     /* 124417 */ GIM_Reject,
     /* 124418 */ // Label 58: @124418
     /* 124418 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2465*/ GIMT_Encode4(125338),
     /* 124429 */ /*GILLT_v2s32*//*Label 2459*/ GIMT_Encode4(124477), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124441 */ /*GILLT_v4s16*//*Label 2460*/ GIMT_Encode4(124524),
     /* 124445 */ /*GILLT_v4s32*//*Label 2461*/ GIMT_Encode4(124571), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124457 */ /*GILLT_v8s8*//*Label 2462*/ GIMT_Encode4(124811),
     /* 124461 */ /*GILLT_v8s16*//*Label 2463*/ GIMT_Encode4(124858), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124473 */ /*GILLT_v16s8*//*Label 2464*/ GIMT_Encode4(125098),
     /* 124477 */ // Label 2459: @124477
     /* 124477 */ GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(124523), // Rule ID 1201 //
     /* 124482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124503 */   // (umax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv2i32),
     /* 124506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124508 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124510 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124515 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124521 */   GIR_RootConstrainSelectedInstOperands,
     /* 124522 */   // GIR_Coverage, 1201,
     /* 124522 */   GIR_EraseRootFromParent_Done,
     /* 124523 */ // Label 2466: @124523
     /* 124523 */ GIM_Reject,
     /* 124524 */ // Label 2460: @124524
     /* 124524 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(124570), // Rule ID 1200 //
     /* 124529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 124535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 124538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124550 */   // (umax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 124550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i16),
     /* 124553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124555 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124557 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124562 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124568 */   GIR_RootConstrainSelectedInstOperands,
     /* 124569 */   // GIR_Coverage, 1200,
     /* 124569 */   GIR_EraseRootFromParent_Done,
     /* 124570 */ // Label 2467: @124570
     /* 124570 */ GIM_Reject,
     /* 124571 */ // Label 2461: @124571
     /* 124571 */ GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(124810),
     /* 124576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 124582 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(124645), // Rule ID 6027 //
     /* 124587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124617 */     // (umax:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 124620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124631 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124643 */     GIR_RootConstrainSelectedInstOperands,
     /* 124644 */     // GIR_Coverage, 6027,
     /* 124644 */     GIR_EraseRootFromParent_Done,
     /* 124645 */   // Label 2469: @124645
     /* 124645 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(124708), // Rule ID 3700 //
     /* 124650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124680 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 124683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124706 */     GIR_RootConstrainSelectedInstOperands,
     /* 124707 */     // GIR_Coverage, 3700,
     /* 124707 */     GIR_EraseRootFromParent_Done,
     /* 124708 */   // Label 2470: @124708
     /* 124708 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(124748), // Rule ID 1203 //
     /* 124713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124728 */     // (umax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 124728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i32),
     /* 124731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124746 */     GIR_RootConstrainSelectedInstOperands,
     /* 124747 */     // GIR_Coverage, 1203,
     /* 124747 */     GIR_EraseRootFromParent_Done,
     /* 124748 */   // Label 2471: @124748
     /* 124748 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(124809), // Rule ID 3324 //
     /* 124753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124768 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 124768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu32),
     /* 124783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124807 */     GIR_RootConstrainSelectedInstOperands,
     /* 124808 */     // GIR_Coverage, 3324,
     /* 124808 */     GIR_EraseRootFromParent_Done,
     /* 124809 */   // Label 2472: @124809
     /* 124809 */   GIM_Reject,
     /* 124810 */ // Label 2468: @124810
     /* 124810 */ GIM_Reject,
     /* 124811 */ // Label 2462: @124811
     /* 124811 */ GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(124857), // Rule ID 1204 //
     /* 124816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 124822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 124825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124837 */   // (umax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 124837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i8),
     /* 124840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124842 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124844 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124849 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124855 */   GIR_RootConstrainSelectedInstOperands,
     /* 124856 */   // GIR_Coverage, 1204,
     /* 124856 */   GIR_EraseRootFromParent_Done,
     /* 124857 */ // Label 2473: @124857
     /* 124857 */ GIM_Reject,
     /* 124858 */ // Label 2463: @124858
     /* 124858 */ GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(125097),
     /* 124863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 124869 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(124932), // Rule ID 6026 //
     /* 124874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124904 */     // (umax:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 124907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124930 */     GIR_RootConstrainSelectedInstOperands,
     /* 124931 */     // GIR_Coverage, 6026,
     /* 124931 */     GIR_EraseRootFromParent_Done,
     /* 124932 */   // Label 2475: @124932
     /* 124932 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(124995), // Rule ID 3698 //
     /* 124937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124967 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 124970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124993 */     GIR_RootConstrainSelectedInstOperands,
     /* 124994 */     // GIR_Coverage, 3698,
     /* 124994 */     GIR_EraseRootFromParent_Done,
     /* 124995 */   // Label 2476: @124995
     /* 124995 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(125035), // Rule ID 1202 //
     /* 125000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125015 */     // (umax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 125015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i16),
     /* 125018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125033 */     GIR_RootConstrainSelectedInstOperands,
     /* 125034 */     // GIR_Coverage, 1202,
     /* 125034 */     GIR_EraseRootFromParent_Done,
     /* 125035 */   // Label 2477: @125035
     /* 125035 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(125096), // Rule ID 3321 //
     /* 125040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125055 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 125055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu16),
     /* 125070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125079 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125094 */     GIR_RootConstrainSelectedInstOperands,
     /* 125095 */     // GIR_Coverage, 3321,
     /* 125095 */     GIR_EraseRootFromParent_Done,
     /* 125096 */   // Label 2478: @125096
     /* 125096 */   GIM_Reject,
     /* 125097 */ // Label 2474: @125097
     /* 125097 */ GIM_Reject,
     /* 125098 */ // Label 2464: @125098
     /* 125098 */ GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(125337),
     /* 125103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 125109 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(125172), // Rule ID 6025 //
     /* 125114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125144 */     // (umax:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125170 */     GIR_RootConstrainSelectedInstOperands,
     /* 125171 */     // GIR_Coverage, 6025,
     /* 125171 */     GIR_EraseRootFromParent_Done,
     /* 125172 */   // Label 2480: @125172
     /* 125172 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(125235), // Rule ID 3696 //
     /* 125177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125207 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125212 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125227 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125233 */     GIR_RootConstrainSelectedInstOperands,
     /* 125234 */     // GIR_Coverage, 3696,
     /* 125234 */     GIR_EraseRootFromParent_Done,
     /* 125235 */   // Label 2481: @125235
     /* 125235 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(125275), // Rule ID 1205 //
     /* 125240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125255 */     // (umax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 125255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv16i8),
     /* 125258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125273 */     GIR_RootConstrainSelectedInstOperands,
     /* 125274 */     // GIR_Coverage, 1205,
     /* 125274 */     GIR_EraseRootFromParent_Done,
     /* 125275 */   // Label 2482: @125275
     /* 125275 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(125336), // Rule ID 3318 //
     /* 125280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125295 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 125295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu8),
     /* 125310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125334 */     GIR_RootConstrainSelectedInstOperands,
     /* 125335 */     // GIR_Coverage, 3318,
     /* 125335 */     GIR_EraseRootFromParent_Done,
     /* 125336 */   // Label 2483: @125336
     /* 125336 */   GIM_Reject,
     /* 125337 */ // Label 2479: @125337
     /* 125337 */ GIM_Reject,
     /* 125338 */ // Label 2465: @125338
     /* 125338 */ GIM_Reject,
     /* 125339 */ // Label 59: @125339
     /* 125339 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2490*/ GIMT_Encode4(125809),
     /* 125350 */ /*GILLT_v2s32*//*Label 2484*/ GIMT_Encode4(125398), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125362 */ /*GILLT_v4s16*//*Label 2485*/ GIMT_Encode4(125436),
     /* 125366 */ /*GILLT_v4s32*//*Label 2486*/ GIMT_Encode4(125474), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125378 */ /*GILLT_v8s8*//*Label 2487*/ GIMT_Encode4(125573),
     /* 125382 */ /*GILLT_v8s16*//*Label 2488*/ GIMT_Encode4(125611), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125394 */ /*GILLT_v16s8*//*Label 2489*/ GIMT_Encode4(125710),
     /* 125398 */ // Label 2484: @125398
     /* 125398 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(125435), // Rule ID 1507 //
     /* 125403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 125409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125417 */   // (abs:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 125417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv2i32),
     /* 125420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125422 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125427 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125433 */   GIR_RootConstrainSelectedInstOperands,
     /* 125434 */   // GIR_Coverage, 1507,
     /* 125434 */   GIR_EraseRootFromParent_Done,
     /* 125435 */ // Label 2491: @125435
     /* 125435 */ GIM_Reject,
     /* 125436 */ // Label 2485: @125436
     /* 125436 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(125473), // Rule ID 1506 //
     /* 125441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125455 */   // (abs:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 125455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i16),
     /* 125458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125460 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125465 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125471 */   GIR_RootConstrainSelectedInstOperands,
     /* 125472 */   // GIR_Coverage, 1506,
     /* 125472 */   GIR_EraseRootFromParent_Done,
     /* 125473 */ // Label 2492: @125473
     /* 125473 */ GIM_Reject,
     /* 125474 */ // Label 2486: @125474
     /* 125474 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(125572),
     /* 125479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125482 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(125516), // Rule ID 1510 //
     /* 125487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125498 */     // (abs:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 125498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i32),
     /* 125501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125514 */     GIR_RootConstrainSelectedInstOperands,
     /* 125515 */     // GIR_Coverage, 1510,
     /* 125515 */     GIR_EraseRootFromParent_Done,
     /* 125516 */   // Label 2494: @125516
     /* 125516 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(125571), // Rule ID 3669 //
     /* 125521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125532 */     // (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v)  =>  (MVE_VABSs32:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
     /* 125532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs32),
     /* 125547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125549 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 125551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125569 */     GIR_RootConstrainSelectedInstOperands,
     /* 125570 */     // GIR_Coverage, 3669,
     /* 125570 */     GIR_EraseRootFromParent_Done,
     /* 125571 */   // Label 2495: @125571
     /* 125571 */   GIM_Reject,
     /* 125572 */ // Label 2493: @125572
     /* 125572 */ GIM_Reject,
     /* 125573 */ // Label 2487: @125573
     /* 125573 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(125610), // Rule ID 1505 //
     /* 125578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 125584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125592 */   // (abs:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 125592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i8),
     /* 125595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125597 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125602 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125608 */   GIR_RootConstrainSelectedInstOperands,
     /* 125609 */   // GIR_Coverage, 1505,
     /* 125609 */   GIR_EraseRootFromParent_Done,
     /* 125610 */ // Label 2496: @125610
     /* 125610 */ GIM_Reject,
     /* 125611 */ // Label 2488: @125611
     /* 125611 */ GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(125709),
     /* 125616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125619 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(125653), // Rule ID 1509 //
     /* 125624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125635 */     // (abs:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 125635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i16),
     /* 125638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125651 */     GIR_RootConstrainSelectedInstOperands,
     /* 125652 */     // GIR_Coverage, 1509,
     /* 125652 */     GIR_EraseRootFromParent_Done,
     /* 125653 */   // Label 2498: @125653
     /* 125653 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(125708), // Rule ID 3663 //
     /* 125658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125669 */     // (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v)  =>  (MVE_VABSs16:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
     /* 125669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs16),
     /* 125684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125686 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 125688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125706 */     GIR_RootConstrainSelectedInstOperands,
     /* 125707 */     // GIR_Coverage, 3663,
     /* 125707 */     GIR_EraseRootFromParent_Done,
     /* 125708 */   // Label 2499: @125708
     /* 125708 */   GIM_Reject,
     /* 125709 */ // Label 2497: @125709
     /* 125709 */ GIM_Reject,
     /* 125710 */ // Label 2489: @125710
     /* 125710 */ GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(125808),
     /* 125715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125718 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(125752), // Rule ID 1508 //
     /* 125723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125734 */     // (abs:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 125734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv16i8),
     /* 125737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125750 */     GIR_RootConstrainSelectedInstOperands,
     /* 125751 */     // GIR_Coverage, 1508,
     /* 125751 */     GIR_EraseRootFromParent_Done,
     /* 125752 */   // Label 2501: @125752
     /* 125752 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(125807), // Rule ID 3657 //
     /* 125757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125768 */     // (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v)  =>  (MVE_VABSs8:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
     /* 125768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs8),
     /* 125783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125785 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 125787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125796 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125805 */     GIR_RootConstrainSelectedInstOperands,
     /* 125806 */     // GIR_Coverage, 3657,
     /* 125806 */     GIR_EraseRootFromParent_Done,
     /* 125807 */   // Label 2502: @125807
     /* 125807 */   GIM_Reject,
     /* 125808 */ // Label 2500: @125808
     /* 125808 */ GIM_Reject,
     /* 125809 */ // Label 2490: @125809
     /* 125809 */ GIM_Reject,
     /* 125810 */ // Label 60: @125810
     /* 125810 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(125882),
     /* 125815 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 125818 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(125833), // Rule ID 32 //
     /* 125823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 125826 */     // (br (bb:{ *:[Other] }):$target)  =>  (B (bb:{ *:[Other] }):$target)
     /* 125826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::B),
     /* 125831 */     GIR_RootConstrainSelectedInstOperands,
     /* 125832 */     // GIR_Coverage, 32,
     /* 125832 */     GIR_Done,
     /* 125833 */   // Label 2504: @125833
     /* 125833 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(125857), // Rule ID 283 //
     /* 125838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 125841 */     // (br (bb:{ *:[Other] }):$target)  =>  (tB (bb:{ *:[Other] }):$target)
     /* 125841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tB),
     /* 125844 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 125846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125855 */     GIR_RootConstrainSelectedInstOperands,
     /* 125856 */     // GIR_Coverage, 283,
     /* 125856 */     GIR_EraseRootFromParent_Done,
     /* 125857 */   // Label 2505: @125857
     /* 125857 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(125881), // Rule ID 577 //
     /* 125862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /* 125865 */     // (br (bb:{ *:[Other] }):$target)  =>  (t2B (bb:{ *:[Other] }):$target)
     /* 125865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2B),
     /* 125868 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 125870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125879 */     GIR_RootConstrainSelectedInstOperands,
     /* 125880 */     // GIR_Coverage, 577,
     /* 125880 */     GIR_EraseRootFromParent_Done,
     /* 125881 */   // Label 2506: @125881
     /* 125881 */   GIM_Reject,
     /* 125882 */ // Label 2503: @125882
     /* 125882 */ GIM_Reject,
     /* 125883 */ // Label 61: @125883
     /* 125883 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(16), /*)*//*default:*//*Label 2511*/ GIMT_Encode4(126182),
     /* 125894 */ /*GILLT_v4s16*//*Label 2507*/ GIMT_Encode4(125930), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125910 */ /*GILLT_v8s8*//*Label 2508*/ GIMT_Encode4(125993),
     /* 125914 */ /*GILLT_v8s16*//*Label 2509*/ GIMT_Encode4(126056), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125926 */ /*GILLT_v16s8*//*Label 2510*/ GIMT_Encode4(126119),
     /* 125930 */ // Label 2507: @125930
     /* 125930 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(125992), // Rule ID 1569 //
     /* 125935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 125944 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 125947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125955 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 125959 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 125963 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125967 */   // MIs[1] Operand 1
     /* 125967 */   // No operand predicates
     /* 125967 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125969 */   // (vector_insert:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 125969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi16),
     /* 125972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 125974 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125976 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 125978 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 125981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125984 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125990 */   GIR_RootConstrainSelectedInstOperands,
     /* 125991 */   // GIR_Coverage, 1569,
     /* 125991 */   GIR_EraseRootFromParent_Done,
     /* 125992 */ // Label 2512: @125992
     /* 125992 */ GIM_Reject,
     /* 125993 */ // Label 2508: @125993
     /* 125993 */ GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(126055), // Rule ID 1568 //
     /* 125998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126007 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126022 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126026 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126030 */   // MIs[1] Operand 1
     /* 126030 */   // No operand predicates
     /* 126030 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126032 */   // (vector_insert:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi8),
     /* 126035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126037 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126039 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126041 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126047 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126053 */   GIR_RootConstrainSelectedInstOperands,
     /* 126054 */   // GIR_Coverage, 1568,
     /* 126054 */   GIR_EraseRootFromParent_Done,
     /* 126055 */ // Label 2513: @126055
     /* 126055 */ GIM_Reject,
     /* 126056 */ // Label 2509: @126056
     /* 126056 */ GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(126118), // Rule ID 3433 //
     /* 126061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126070 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126085 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126089 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126093 */   // MIs[1] Operand 1
     /* 126093 */   // No operand predicates
     /* 126093 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126095 */   // (vector_insert:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_16),
     /* 126098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126100 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126102 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126104 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126110 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126116 */   GIR_RootConstrainSelectedInstOperands,
     /* 126117 */   // GIR_Coverage, 3433,
     /* 126117 */   GIR_EraseRootFromParent_Done,
     /* 126118 */ // Label 2514: @126118
     /* 126118 */ GIM_Reject,
     /* 126119 */ // Label 2510: @126119
     /* 126119 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(126181), // Rule ID 3432 //
     /* 126124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126133 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126144 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126156 */   // MIs[1] Operand 1
     /* 126156 */   // No operand predicates
     /* 126156 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126158 */   // (vector_insert:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_8),
     /* 126161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126163 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126165 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126167 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126173 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126179 */   GIR_RootConstrainSelectedInstOperands,
     /* 126180 */   // GIR_Coverage, 3432,
     /* 126180 */   GIR_EraseRootFromParent_Done,
     /* 126181 */ // Label 2515: @126181
     /* 126181 */ GIM_Reject,
     /* 126182 */ // Label 2511: @126182
     /* 126182 */ GIM_Reject,
     /* 126183 */ // Label 62: @126183
     /* 126183 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(126239), // Rule ID 1567 //
     /* 126188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_HasFastVGETLNi32),
     /* 126191 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 126194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126208 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126212 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126216 */   // MIs[1] Operand 1
     /* 126216 */   // No operand predicates
     /* 126216 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126218 */   // (extractelt:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)  =>  (VGETLNi32:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)
     /* 126218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VGETLNi32),
     /* 126221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[R]
     /* 126223 */   GIR_RootToRootCopy, /*OpIdx*/1, // V
     /* 126225 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126231 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126237 */   GIR_RootConstrainSelectedInstOperands,
     /* 126238 */   // GIR_Coverage, 1567,
     /* 126238 */   GIR_EraseRootFromParent_Done,
     /* 126239 */ // Label 2516: @126239
     /* 126239 */ GIM_Reject,
     /* 126240 */ // Label 63: @126240
     /* 126240 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2524*/ GIMT_Encode4(126800),
     /* 126251 */ /*GILLT_s32*//*Label 2517*/ GIMT_Encode4(126311), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126263 */ /*GILLT_v2s32*//*Label 2518*/ GIMT_Encode4(126389), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126275 */ /*GILLT_v4s16*//*Label 2519*/ GIMT_Encode4(126427),
     /* 126279 */ /*GILLT_v4s32*//*Label 2520*/ GIMT_Encode4(126465), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126291 */ /*GILLT_v8s8*//*Label 2521*/ GIMT_Encode4(126564),
     /* 126295 */ /*GILLT_v8s16*//*Label 2522*/ GIMT_Encode4(126602), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126307 */ /*GILLT_v16s8*//*Label 2523*/ GIMT_Encode4(126701),
     /* 126311 */ // Label 2517: @126311
     /* 126311 */ GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(126388),
     /* 126316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 126319 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(126353), // Rule ID 197 //
     /* 126324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 126327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126335 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 126335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLZ),
     /* 126338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126351 */     GIR_RootConstrainSelectedInstOperands,
     /* 126352 */     // GIR_Coverage, 197,
     /* 126352 */     GIR_EraseRootFromParent_Done,
     /* 126353 */   // Label 2526: @126353
     /* 126353 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(126387), // Rule ID 534 //
     /* 126358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 126361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126369 */     // (ctlz:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2CLZ:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 126369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLZ),
     /* 126372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126379 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126385 */     GIR_RootConstrainSelectedInstOperands,
     /* 126386 */     // GIR_Coverage, 534,
     /* 126386 */     GIR_EraseRootFromParent_Done,
     /* 126387 */   // Label 2527: @126387
     /* 126387 */   GIM_Reject,
     /* 126388 */ // Label 2525: @126388
     /* 126388 */ GIM_Reject,
     /* 126389 */ // Label 2518: @126389
     /* 126389 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(126426), // Rule ID 1545 //
     /* 126394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126408 */   // (ctlz:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCLZv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 126408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv2i32),
     /* 126411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126413 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126418 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126424 */   GIR_RootConstrainSelectedInstOperands,
     /* 126425 */   // GIR_Coverage, 1545,
     /* 126425 */   GIR_EraseRootFromParent_Done,
     /* 126426 */ // Label 2528: @126426
     /* 126426 */ GIM_Reject,
     /* 126427 */ // Label 2519: @126427
     /* 126427 */ GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(126464), // Rule ID 1544 //
     /* 126432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126446 */   // (ctlz:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCLZv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 126446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i16),
     /* 126449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126451 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126456 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126462 */   GIR_RootConstrainSelectedInstOperands,
     /* 126463 */   // GIR_Coverage, 1544,
     /* 126463 */   GIR_EraseRootFromParent_Done,
     /* 126464 */ // Label 2529: @126464
     /* 126464 */ GIM_Reject,
     /* 126465 */ // Label 2520: @126465
     /* 126465 */ GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(126563),
     /* 126470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126473 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(126507), // Rule ID 1548 //
     /* 126478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126489 */     // (ctlz:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCLZv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 126489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i32),
     /* 126492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126505 */     GIR_RootConstrainSelectedInstOperands,
     /* 126506 */     // GIR_Coverage, 1548,
     /* 126506 */     GIR_EraseRootFromParent_Done,
     /* 126507 */   // Label 2531: @126507
     /* 126507 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(126562), // Rule ID 3655 //
     /* 126512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126523 */     // (ctlz:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLZs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /* 126523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs32),
     /* 126538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126540 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 126542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126560 */     GIR_RootConstrainSelectedInstOperands,
     /* 126561 */     // GIR_Coverage, 3655,
     /* 126561 */     GIR_EraseRootFromParent_Done,
     /* 126562 */   // Label 2532: @126562
     /* 126562 */   GIM_Reject,
     /* 126563 */ // Label 2530: @126563
     /* 126563 */ GIM_Reject,
     /* 126564 */ // Label 2521: @126564
     /* 126564 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(126601), // Rule ID 1543 //
     /* 126569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126583 */   // (ctlz:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCLZv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 126583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i8),
     /* 126586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126588 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126593 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126599 */   GIR_RootConstrainSelectedInstOperands,
     /* 126600 */   // GIR_Coverage, 1543,
     /* 126600 */   GIR_EraseRootFromParent_Done,
     /* 126601 */ // Label 2533: @126601
     /* 126601 */ GIM_Reject,
     /* 126602 */ // Label 2522: @126602
     /* 126602 */ GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(126700),
     /* 126607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126610 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(126644), // Rule ID 1547 //
     /* 126615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126626 */     // (ctlz:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCLZv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 126626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i16),
     /* 126629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126631 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126642 */     GIR_RootConstrainSelectedInstOperands,
     /* 126643 */     // GIR_Coverage, 1547,
     /* 126643 */     GIR_EraseRootFromParent_Done,
     /* 126644 */   // Label 2535: @126644
     /* 126644 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(126699), // Rule ID 3653 //
     /* 126649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126660 */     // (ctlz:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLZs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /* 126660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs16),
     /* 126675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126677 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 126679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126697 */     GIR_RootConstrainSelectedInstOperands,
     /* 126698 */     // GIR_Coverage, 3653,
     /* 126698 */     GIR_EraseRootFromParent_Done,
     /* 126699 */   // Label 2536: @126699
     /* 126699 */   GIM_Reject,
     /* 126700 */ // Label 2534: @126700
     /* 126700 */ GIM_Reject,
     /* 126701 */ // Label 2523: @126701
     /* 126701 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(126799),
     /* 126706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126709 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(126743), // Rule ID 1546 //
     /* 126714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126725 */     // (ctlz:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCLZv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 126725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv16i8),
     /* 126728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126741 */     GIR_RootConstrainSelectedInstOperands,
     /* 126742 */     // GIR_Coverage, 1546,
     /* 126742 */     GIR_EraseRootFromParent_Done,
     /* 126743 */   // Label 2538: @126743
     /* 126743 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(126798), // Rule ID 3651 //
     /* 126748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126759 */     // (ctlz:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLZs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /* 126759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs8),
     /* 126774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126776 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 126778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126781 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126787 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126796 */     GIR_RootConstrainSelectedInstOperands,
     /* 126797 */     // GIR_Coverage, 3651,
     /* 126797 */     GIR_EraseRootFromParent_Done,
     /* 126798 */   // Label 2539: @126798
     /* 126798 */   GIM_Reject,
     /* 126799 */ // Label 2537: @126799
     /* 126799 */ GIM_Reject,
     /* 126800 */ // Label 2524: @126800
     /* 126800 */ GIM_Reject,
     /* 126801 */ // Label 64: @126801
     /* 126801 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(11), GIMT_Encode2(16), /*)*//*default:*//*Label 2542*/ GIMT_Encode4(126908),
     /* 126812 */ /*GILLT_v8s8*//*Label 2540*/ GIMT_Encode4(126832), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126828 */ /*GILLT_v16s8*//*Label 2541*/ GIMT_Encode4(126870),
     /* 126832 */ // Label 2540: @126832
     /* 126832 */ GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(126869), // Rule ID 1549 //
     /* 126837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126851 */   // (ctpop:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCNTd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 126851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTd),
     /* 126854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126856 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126861 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126867 */   GIR_RootConstrainSelectedInstOperands,
     /* 126868 */   // GIR_Coverage, 1549,
     /* 126868 */   GIR_EraseRootFromParent_Done,
     /* 126869 */ // Label 2543: @126869
     /* 126869 */ GIM_Reject,
     /* 126870 */ // Label 2541: @126870
     /* 126870 */ GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(126907), // Rule ID 1550 //
     /* 126875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126889 */   // (ctpop:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCNTq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 126889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTq),
     /* 126892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126894 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126899 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126905 */   GIR_RootConstrainSelectedInstOperands,
     /* 126906 */   // GIR_Coverage, 1550,
     /* 126906 */   GIR_EraseRootFromParent_Done,
     /* 126907 */ // Label 2544: @126907
     /* 126907 */ GIM_Reject,
     /* 126908 */ // Label 2542: @126908
     /* 126908 */ GIM_Reject,
     /* 126909 */ // Label 65: @126909
     /* 126909 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2548*/ GIMT_Encode4(127198),
     /* 126920 */ /*GILLT_s32*//*Label 2545*/ GIMT_Encode4(126968), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126948 */ /*GILLT_v4s32*//*Label 2546*/ GIMT_Encode4(127080), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126964 */ /*GILLT_v8s16*//*Label 2547*/ GIMT_Encode4(127139),
     /* 126968 */ // Label 2545: @126968
     /* 126968 */ GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(127079),
     /* 126973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 126976 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(127010), // Rule ID 199 //
     /* 126981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 126984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126992 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (REV:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 126992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV),
     /* 126995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127008 */     GIR_RootConstrainSelectedInstOperands,
     /* 127009 */     // GIR_Coverage, 199,
     /* 127009 */     GIR_EraseRootFromParent_Done,
     /* 127010 */   // Label 2550: @127010
     /* 127010 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(127044), // Rule ID 326 //
     /* 127015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 127018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127026 */     // (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)  =>  (tREV:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 127026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV),
     /* 127029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127042 */     GIR_RootConstrainSelectedInstOperands,
     /* 127043 */     // GIR_Coverage, 326,
     /* 127043 */     GIR_EraseRootFromParent_Done,
     /* 127044 */   // Label 2551: @127044
     /* 127044 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(127078), // Rule ID 536 //
     /* 127049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127060 */     // (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2REV:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV),
     /* 127063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127076 */     GIR_RootConstrainSelectedInstOperands,
     /* 127077 */     // GIR_Coverage, 536,
     /* 127077 */     GIR_EraseRootFromParent_Done,
     /* 127078 */   // Label 2552: @127078
     /* 127078 */   GIM_Reject,
     /* 127079 */ // Label 2549: @127079
     /* 127079 */ GIM_Reject,
     /* 127080 */ // Label 2546: @127080
     /* 127080 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(127138), // Rule ID 3328 //
     /* 127085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127099 */   // (bswap:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 127099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /* 127114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127116 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127121 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127127 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127133 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127136 */   GIR_RootConstrainSelectedInstOperands,
     /* 127137 */   // GIR_Coverage, 3328,
     /* 127137 */   GIR_EraseRootFromParent_Done,
     /* 127138 */ // Label 2553: @127138
     /* 127138 */ GIM_Reject,
     /* 127139 */ // Label 2547: @127139
     /* 127139 */ GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(127197), // Rule ID 3327 //
     /* 127144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127158 */   // (bswap:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 127158 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127161 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127165 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /* 127173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127175 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127180 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127186 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127192 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127195 */   GIR_RootConstrainSelectedInstOperands,
     /* 127196 */   // GIR_Coverage, 3327,
     /* 127196 */   GIR_EraseRootFromParent_Done,
     /* 127197 */ // Label 2554: @127197
     /* 127197 */ GIM_Reject,
     /* 127198 */ // Label 2548: @127198
     /* 127198 */ GIM_Reject,
     /* 127199 */ // Label 66: @127199
     /* 127199 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2559*/ GIMT_Encode4(127630),
     /* 127210 */ /*GILLT_s32*//*Label 2555*/ GIMT_Encode4(127270), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127238 */ /*GILLT_v4s32*//*Label 2556*/ GIMT_Encode4(127348), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127254 */ /*GILLT_v8s16*//*Label 2557*/ GIMT_Encode4(127442), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127266 */ /*GILLT_v16s8*//*Label 2558*/ GIMT_Encode4(127536),
     /* 127270 */ // Label 2555: @127270
     /* 127270 */ GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(127347),
     /* 127275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127278 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(127312), // Rule ID 198 //
     /* 127283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /* 127286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127294 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (RBIT:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RBIT),
     /* 127297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127310 */     GIR_RootConstrainSelectedInstOperands,
     /* 127311 */     // GIR_Coverage, 198,
     /* 127311 */     GIR_EraseRootFromParent_Done,
     /* 127312 */   // Label 2561: @127312
     /* 127312 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(127346), // Rule ID 535 //
     /* 127317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127328 */     // (bitreverse:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2RBIT:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RBIT),
     /* 127331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127344 */     GIR_RootConstrainSelectedInstOperands,
     /* 127345 */     // GIR_Coverage, 535,
     /* 127345 */     GIR_EraseRootFromParent_Done,
     /* 127346 */   // Label 2562: @127346
     /* 127346 */   GIM_Reject,
     /* 127347 */ // Label 2560: @127347
     /* 127347 */ GIM_Reject,
     /* 127348 */ // Label 2556: @127348
     /* 127348 */ GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(127441), // Rule ID 4755 //
     /* 127353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127367 */   // (bitreverse:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1, (t2MOVi:{ *:[i32] } 32:{ *:[i32] }))
     /* 127367 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127370 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127374 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127379 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127382 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127386 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127391 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 127394 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127397 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127403 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /* 127414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127416 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127418 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127424 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127430 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127439 */   GIR_RootConstrainSelectedInstOperands,
     /* 127440 */   // GIR_Coverage, 4755,
     /* 127440 */   GIR_EraseRootFromParent_Done,
     /* 127441 */ // Label 2563: @127441
     /* 127441 */ GIM_Reject,
     /* 127442 */ // Label 2557: @127442
     /* 127442 */ GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(127535), // Rule ID 4756 //
     /* 127447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127461 */   // (bitreverse:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1, (t2MOVi:{ *:[i32] } 16:{ *:[i32] }))
     /* 127461 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127464 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127468 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127473 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127476 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127480 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127485 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 127488 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127491 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127497 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /* 127508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127510 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127512 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127518 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127524 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127533 */   GIR_RootConstrainSelectedInstOperands,
     /* 127534 */   // GIR_Coverage, 4756,
     /* 127534 */   GIR_EraseRootFromParent_Done,
     /* 127535 */ // Label 2564: @127535
     /* 127535 */ GIM_Reject,
     /* 127536 */ // Label 2558: @127536
     /* 127536 */ GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(127629), // Rule ID 4754 //
     /* 127541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127555 */   // (bitreverse:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1, (t2MOVi:{ *:[i32] } 8:{ *:[i32] }))
     /* 127555 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127558 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127562 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127579 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 127582 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127585 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127591 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /* 127602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127604 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127606 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127612 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127618 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127624 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127627 */   GIR_RootConstrainSelectedInstOperands,
     /* 127628 */   // GIR_Coverage, 4754,
     /* 127628 */   GIR_EraseRootFromParent_Done,
     /* 127629 */ // Label 2565: @127629
     /* 127629 */ GIM_Reject,
     /* 127630 */ // Label 2559: @127630
     /* 127630 */ GIM_Reject,
     /* 127631 */ // Label 67: @127631
     /* 127631 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2573*/ GIMT_Encode4(128005),
     /* 127642 */ /*GILLT_s16*//*Label 2566*/ GIMT_Encode4(127694),
     /* 127646 */ /*GILLT_s32*//*Label 2567*/ GIMT_Encode4(127721),
     /* 127650 */ /*GILLT_s64*//*Label 2568*/ GIMT_Encode4(127748), GIMT_Encode4(0),
     /* 127658 */ /*GILLT_v2s32*//*Label 2569*/ GIMT_Encode4(127775), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127670 */ /*GILLT_v4s16*//*Label 2570*/ GIMT_Encode4(127802),
     /* 127674 */ /*GILLT_v4s32*//*Label 2571*/ GIMT_Encode4(127829), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127690 */ /*GILLT_v8s16*//*Label 2572*/ GIMT_Encode4(127917),
     /* 127694 */ // Label 2566: @127694
     /* 127694 */ GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(127720), // Rule ID 680 //
     /* 127699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 127702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 127705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 127709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 127713 */   // (fceil:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTPH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 127713 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPH),
     /* 127718 */   GIR_RootConstrainSelectedInstOperands,
     /* 127719 */   // GIR_Coverage, 680,
     /* 127719 */   GIR_Done,
     /* 127720 */ // Label 2574: @127720
     /* 127720 */ GIM_Reject,
     /* 127721 */ // Label 2567: @127721
     /* 127721 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(127747), // Rule ID 681 //
     /* 127726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 127729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 127736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 127740 */   // (fceil:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTPS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 127740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPS),
     /* 127745 */   GIR_RootConstrainSelectedInstOperands,
     /* 127746 */   // GIR_Coverage, 681,
     /* 127746 */   GIR_Done,
     /* 127747 */ // Label 2575: @127747
     /* 127747 */ GIM_Reject,
     /* 127748 */ // Label 2568: @127748
     /* 127748 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(127774), // Rule ID 682 //
     /* 127753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 127756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 127759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127767 */   // (fceil:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTPD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 127767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPD),
     /* 127772 */   GIR_RootConstrainSelectedInstOperands,
     /* 127773 */   // GIR_Coverage, 682,
     /* 127773 */   GIR_Done,
     /* 127774 */ // Label 2576: @127774
     /* 127774 */ GIM_Reject,
     /* 127775 */ // Label 2569: @127775
     /* 127775 */ GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(127801), // Rule ID 1708 //
     /* 127780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 127783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 127786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127794 */   // (fceil:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTPNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 127794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDf),
     /* 127799 */   GIR_RootConstrainSelectedInstOperands,
     /* 127800 */   // GIR_Coverage, 1708,
     /* 127800 */   GIR_Done,
     /* 127801 */ // Label 2577: @127801
     /* 127801 */ GIM_Reject,
     /* 127802 */ // Label 2570: @127802
     /* 127802 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(127828), // Rule ID 1710 //
     /* 127807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 127810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 127813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127821 */   // (fceil:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTPNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 127821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDh),
     /* 127826 */   GIR_RootConstrainSelectedInstOperands,
     /* 127827 */   // GIR_Coverage, 1710,
     /* 127827 */   GIR_Done,
     /* 127828 */ // Label 2578: @127828
     /* 127828 */ GIM_Reject,
     /* 127829 */ // Label 2571: @127829
     /* 127829 */ GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(127916),
     /* 127834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127837 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(127860), // Rule ID 1709 //
     /* 127842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 127845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127853 */     // (fceil:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTPNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 127853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQf),
     /* 127858 */     GIR_RootConstrainSelectedInstOperands,
     /* 127859 */     // GIR_Coverage, 1709,
     /* 127859 */     GIR_Done,
     /* 127860 */   // Label 2580: @127860
     /* 127860 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(127915), // Rule ID 3983 //
     /* 127865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 127868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127876 */     // (fceil:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32P:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 127876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32P),
     /* 127891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127893 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127913 */     GIR_RootConstrainSelectedInstOperands,
     /* 127914 */     // GIR_Coverage, 3983,
     /* 127914 */     GIR_EraseRootFromParent_Done,
     /* 127915 */   // Label 2581: @127915
     /* 127915 */   GIM_Reject,
     /* 127916 */ // Label 2579: @127916
     /* 127916 */ GIM_Reject,
     /* 127917 */ // Label 2572: @127917
     /* 127917 */ GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(128004),
     /* 127922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127925 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(127948), // Rule ID 1711 //
     /* 127930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 127933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127941 */     // (fceil:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTPNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 127941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQh),
     /* 127946 */     GIR_RootConstrainSelectedInstOperands,
     /* 127947 */     // GIR_Coverage, 1711,
     /* 127947 */     GIR_Done,
     /* 127948 */   // Label 2583: @127948
     /* 127948 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(128003), // Rule ID 3971 //
     /* 127953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 127956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127964 */     // (fceil:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16P:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 127964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16P),
     /* 127979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127981 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128001 */     GIR_RootConstrainSelectedInstOperands,
     /* 128002 */     // GIR_Coverage, 3971,
     /* 128002 */     GIR_EraseRootFromParent_Done,
     /* 128003 */   // Label 2584: @128003
     /* 128003 */   GIM_Reject,
     /* 128004 */ // Label 2582: @128004
     /* 128004 */ GIM_Reject,
     /* 128005 */ // Label 2573: @128005
     /* 128005 */ GIM_Reject,
     /* 128006 */ // Label 68: @128006
     /* 128006 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2588*/ GIMT_Encode4(128143),
     /* 128017 */ /*GILLT_s16*//*Label 2585*/ GIMT_Encode4(128029),
     /* 128021 */ /*GILLT_s32*//*Label 2586*/ GIMT_Encode4(128067),
     /* 128025 */ /*GILLT_s64*//*Label 2587*/ GIMT_Encode4(128105),
     /* 128029 */ // Label 2585: @128029
     /* 128029 */ GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(128066), // Rule ID 688 //
     /* 128034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128048 */   // (fsqrt:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VSQRTH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTH),
     /* 128051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128053 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128058 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128064 */   GIR_RootConstrainSelectedInstOperands,
     /* 128065 */   // GIR_Coverage, 688,
     /* 128065 */   GIR_EraseRootFromParent_Done,
     /* 128066 */ // Label 2589: @128066
     /* 128066 */ GIM_Reject,
     /* 128067 */ // Label 2586: @128067
     /* 128067 */ GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(128104), // Rule ID 687 //
     /* 128072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 128075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128086 */   // (fsqrt:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VSQRTS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTS),
     /* 128089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128091 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128096 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128102 */   GIR_RootConstrainSelectedInstOperands,
     /* 128103 */   // GIR_Coverage, 687,
     /* 128103 */   GIR_EraseRootFromParent_Done,
     /* 128104 */ // Label 2590: @128104
     /* 128104 */ GIM_Reject,
     /* 128105 */ // Label 2587: @128105
     /* 128105 */ GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(128142), // Rule ID 686 //
     /* 128110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 128113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128124 */   // (fsqrt:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VSQRTD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTD),
     /* 128127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128129 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128134 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128140 */   GIR_RootConstrainSelectedInstOperands,
     /* 128141 */   // GIR_Coverage, 686,
     /* 128141 */   GIR_EraseRootFromParent_Done,
     /* 128142 */ // Label 2591: @128142
     /* 128142 */ GIM_Reject,
     /* 128143 */ // Label 2588: @128143
     /* 128143 */ GIM_Reject,
     /* 128144 */ // Label 69: @128144
     /* 128144 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2599*/ GIMT_Encode4(128518),
     /* 128155 */ /*GILLT_s16*//*Label 2592*/ GIMT_Encode4(128207),
     /* 128159 */ /*GILLT_s32*//*Label 2593*/ GIMT_Encode4(128234),
     /* 128163 */ /*GILLT_s64*//*Label 2594*/ GIMT_Encode4(128261), GIMT_Encode4(0),
     /* 128171 */ /*GILLT_v2s32*//*Label 2595*/ GIMT_Encode4(128288), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128183 */ /*GILLT_v4s16*//*Label 2596*/ GIMT_Encode4(128315),
     /* 128187 */ /*GILLT_v4s32*//*Label 2597*/ GIMT_Encode4(128342), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128203 */ /*GILLT_v8s16*//*Label 2598*/ GIMT_Encode4(128430),
     /* 128207 */ // Label 2592: @128207
     /* 128207 */ GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(128233), // Rule ID 683 //
     /* 128212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128226 */   // (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTMH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128226 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMH),
     /* 128231 */   GIR_RootConstrainSelectedInstOperands,
     /* 128232 */   // GIR_Coverage, 683,
     /* 128232 */   GIR_Done,
     /* 128233 */ // Label 2600: @128233
     /* 128233 */ GIM_Reject,
     /* 128234 */ // Label 2593: @128234
     /* 128234 */ GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(128260), // Rule ID 684 //
     /* 128239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128253 */   // (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTMS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMS),
     /* 128258 */   GIR_RootConstrainSelectedInstOperands,
     /* 128259 */   // GIR_Coverage, 684,
     /* 128259 */   GIR_Done,
     /* 128260 */ // Label 2601: @128260
     /* 128260 */ GIM_Reject,
     /* 128261 */ // Label 2594: @128261
     /* 128261 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(128287), // Rule ID 685 //
     /* 128266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128280 */   // (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTMD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMD),
     /* 128285 */   GIR_RootConstrainSelectedInstOperands,
     /* 128286 */   // GIR_Coverage, 685,
     /* 128286 */   GIR_Done,
     /* 128287 */ // Label 2602: @128287
     /* 128287 */ GIM_Reject,
     /* 128288 */ // Label 2595: @128288
     /* 128288 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(128314), // Rule ID 1704 //
     /* 128293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 128299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128307 */   // (ffloor:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 128307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDf),
     /* 128312 */   GIR_RootConstrainSelectedInstOperands,
     /* 128313 */   // GIR_Coverage, 1704,
     /* 128313 */   GIR_Done,
     /* 128314 */ // Label 2603: @128314
     /* 128314 */ GIM_Reject,
     /* 128315 */ // Label 2596: @128315
     /* 128315 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(128341), // Rule ID 1706 //
     /* 128320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 128326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128334 */   // (ffloor:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 128334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDh),
     /* 128339 */   GIR_RootConstrainSelectedInstOperands,
     /* 128340 */   // GIR_Coverage, 1706,
     /* 128340 */   GIR_Done,
     /* 128341 */ // Label 2604: @128341
     /* 128341 */ GIM_Reject,
     /* 128342 */ // Label 2597: @128342
     /* 128342 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(128429),
     /* 128347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128350 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(128373), // Rule ID 1705 //
     /* 128355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128366 */     // (ffloor:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 128366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQf),
     /* 128371 */     GIR_RootConstrainSelectedInstOperands,
     /* 128372 */     // GIR_Coverage, 1705,
     /* 128372 */     GIR_Done,
     /* 128373 */   // Label 2606: @128373
     /* 128373 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(128428), // Rule ID 3981 //
     /* 128378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128389 */     // (ffloor:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32M:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32M),
     /* 128404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128406 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128426 */     GIR_RootConstrainSelectedInstOperands,
     /* 128427 */     // GIR_Coverage, 3981,
     /* 128427 */     GIR_EraseRootFromParent_Done,
     /* 128428 */   // Label 2607: @128428
     /* 128428 */   GIM_Reject,
     /* 128429 */ // Label 2605: @128429
     /* 128429 */ GIM_Reject,
     /* 128430 */ // Label 2598: @128430
     /* 128430 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(128517),
     /* 128435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128438 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(128461), // Rule ID 1707 //
     /* 128443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128454 */     // (ffloor:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 128454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQh),
     /* 128459 */     GIR_RootConstrainSelectedInstOperands,
     /* 128460 */     // GIR_Coverage, 1707,
     /* 128460 */     GIR_Done,
     /* 128461 */   // Label 2609: @128461
     /* 128461 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(128516), // Rule ID 3969 //
     /* 128466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128477 */     // (ffloor:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16M:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16M),
     /* 128492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128494 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128505 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128514 */     GIR_RootConstrainSelectedInstOperands,
     /* 128515 */     // GIR_Coverage, 3969,
     /* 128515 */     GIR_EraseRootFromParent_Done,
     /* 128516 */   // Label 2610: @128516
     /* 128516 */   GIM_Reject,
     /* 128517 */ // Label 2608: @128517
     /* 128517 */ GIM_Reject,
     /* 128518 */ // Label 2599: @128518
     /* 128518 */ GIM_Reject,
     /* 128519 */ // Label 70: @128519
     /* 128519 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2618*/ GIMT_Encode4(128926),
     /* 128530 */ /*GILLT_s16*//*Label 2611*/ GIMT_Encode4(128582),
     /* 128534 */ /*GILLT_s32*//*Label 2612*/ GIMT_Encode4(128620),
     /* 128538 */ /*GILLT_s64*//*Label 2613*/ GIMT_Encode4(128658), GIMT_Encode4(0),
     /* 128546 */ /*GILLT_v2s32*//*Label 2614*/ GIMT_Encode4(128696), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128558 */ /*GILLT_v4s16*//*Label 2615*/ GIMT_Encode4(128723),
     /* 128562 */ /*GILLT_v4s32*//*Label 2616*/ GIMT_Encode4(128750), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128578 */ /*GILLT_v8s16*//*Label 2617*/ GIMT_Encode4(128838),
     /* 128582 */ // Label 2611: @128582
     /* 128582 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(128619), // Rule ID 671 //
     /* 128587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128601 */   // (frint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTXH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXH),
     /* 128604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128606 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128611 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128617 */   GIR_RootConstrainSelectedInstOperands,
     /* 128618 */   // GIR_Coverage, 671,
     /* 128618 */   GIR_EraseRootFromParent_Done,
     /* 128619 */ // Label 2619: @128619
     /* 128619 */ GIM_Reject,
     /* 128620 */ // Label 2612: @128620
     /* 128620 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(128657), // Rule ID 672 //
     /* 128625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128639 */   // (frint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTXS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXS),
     /* 128642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128644 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128649 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128655 */   GIR_RootConstrainSelectedInstOperands,
     /* 128656 */   // GIR_Coverage, 672,
     /* 128656 */   GIR_EraseRootFromParent_Done,
     /* 128657 */ // Label 2620: @128657
     /* 128657 */ GIM_Reject,
     /* 128658 */ // Label 2613: @128658
     /* 128658 */ GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(128695), // Rule ID 673 //
     /* 128663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128677 */   // (frint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTXD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXD),
     /* 128680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128682 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128687 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128693 */   GIR_RootConstrainSelectedInstOperands,
     /* 128694 */   // GIR_Coverage, 673,
     /* 128694 */   GIR_EraseRootFromParent_Done,
     /* 128695 */ // Label 2621: @128695
     /* 128695 */ GIM_Reject,
     /* 128696 */ // Label 2614: @128696
     /* 128696 */ GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(128722), // Rule ID 1692 //
     /* 128701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 128707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128715 */   // (frint:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTXNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 128715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDf),
     /* 128720 */   GIR_RootConstrainSelectedInstOperands,
     /* 128721 */   // GIR_Coverage, 1692,
     /* 128721 */   GIR_Done,
     /* 128722 */ // Label 2622: @128722
     /* 128722 */ GIM_Reject,
     /* 128723 */ // Label 2615: @128723
     /* 128723 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(128749), // Rule ID 1694 //
     /* 128728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 128734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128742 */   // (frint:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTXNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 128742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDh),
     /* 128747 */   GIR_RootConstrainSelectedInstOperands,
     /* 128748 */   // GIR_Coverage, 1694,
     /* 128748 */   GIR_Done,
     /* 128749 */ // Label 2623: @128749
     /* 128749 */ GIM_Reject,
     /* 128750 */ // Label 2616: @128750
     /* 128750 */ GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(128837),
     /* 128755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128758 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(128781), // Rule ID 1693 //
     /* 128763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /* 128766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128774 */     // (frint:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTXNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 128774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQf),
     /* 128779 */     GIR_RootConstrainSelectedInstOperands,
     /* 128780 */     // GIR_Coverage, 1693,
     /* 128780 */     GIR_Done,
     /* 128781 */   // Label 2625: @128781
     /* 128781 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(128836), // Rule ID 3975 //
     /* 128786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128797 */     // (frint:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32X:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32X),
     /* 128812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128814 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128834 */     GIR_RootConstrainSelectedInstOperands,
     /* 128835 */     // GIR_Coverage, 3975,
     /* 128835 */     GIR_EraseRootFromParent_Done,
     /* 128836 */   // Label 2626: @128836
     /* 128836 */   GIM_Reject,
     /* 128837 */ // Label 2624: @128837
     /* 128837 */ GIM_Reject,
     /* 128838 */ // Label 2617: @128838
     /* 128838 */ GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(128925),
     /* 128843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128846 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(128869), // Rule ID 1695 //
     /* 128851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /* 128854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 128862 */     // (frint:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTXNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 128862 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQh),
     /* 128867 */     GIR_RootConstrainSelectedInstOperands,
     /* 128868 */     // GIR_Coverage, 1695,
     /* 128868 */     GIR_Done,
     /* 128869 */   // Label 2628: @128869
     /* 128869 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(128924), // Rule ID 3963 //
     /* 128874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128885 */     // (frint:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16X:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16X),
     /* 128900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128902 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128907 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128922 */     GIR_RootConstrainSelectedInstOperands,
     /* 128923 */     // GIR_Coverage, 3963,
     /* 128923 */     GIR_EraseRootFromParent_Done,
     /* 128924 */   // Label 2629: @128924
     /* 128924 */   GIM_Reject,
     /* 128925 */ // Label 2627: @128925
     /* 128925 */ GIM_Reject,
     /* 128926 */ // Label 2618: @128926
     /* 128926 */ GIM_Reject,
     /* 128927 */ // Label 71: @128927
     /* 128927 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2633*/ GIMT_Encode4(129064),
     /* 128938 */ /*GILLT_s16*//*Label 2630*/ GIMT_Encode4(128950),
     /* 128942 */ /*GILLT_s32*//*Label 2631*/ GIMT_Encode4(128988),
     /* 128946 */ /*GILLT_s64*//*Label 2632*/ GIMT_Encode4(129026),
     /* 128950 */ // Label 2630: @128950
     /* 128950 */ GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(128987), // Rule ID 668 //
     /* 128955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128969 */   // (fnearbyint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTRH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRH),
     /* 128972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128974 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128979 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128985 */   GIR_RootConstrainSelectedInstOperands,
     /* 128986 */   // GIR_Coverage, 668,
     /* 128986 */   GIR_EraseRootFromParent_Done,
     /* 128987 */ // Label 2634: @128987
     /* 128987 */ GIM_Reject,
     /* 128988 */ // Label 2631: @128988
     /* 128988 */ GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(129025), // Rule ID 669 //
     /* 128993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129007 */   // (fnearbyint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 129007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRS),
     /* 129010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129012 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129017 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129023 */   GIR_RootConstrainSelectedInstOperands,
     /* 129024 */   // GIR_Coverage, 669,
     /* 129024 */   GIR_EraseRootFromParent_Done,
     /* 129025 */ // Label 2635: @129025
     /* 129025 */ GIM_Reject,
     /* 129026 */ // Label 2632: @129026
     /* 129026 */ GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(129063), // Rule ID 670 //
     /* 129031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129045 */   // (fnearbyint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTRD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRD),
     /* 129048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129050 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129055 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129061 */   GIR_RootConstrainSelectedInstOperands,
     /* 129062 */   // GIR_Coverage, 670,
     /* 129062 */   GIR_EraseRootFromParent_Done,
     /* 129063 */ // Label 2636: @129063
     /* 129063 */ GIM_Reject,
     /* 129064 */ // Label 2633: @129064
     /* 129064 */ GIM_Reject,
     /* 129065 */ // Label 72: @129065
     /* 129065 */ GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(129080), // Rule ID 12 //
     /* 129070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_UseNaClTrap),
     /* 129073 */   // (trap)  =>  (TRAPNaCl)
     /* 129073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAPNaCl),
     /* 129078 */   GIR_RootConstrainSelectedInstOperands,
     /* 129079 */   // GIR_Coverage, 12,
     /* 129079 */   GIR_Done,
     /* 129080 */ // Label 2637: @129080
     /* 129080 */ GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(129095), // Rule ID 13 //
     /* 129085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNaClTrap_IsARM),
     /* 129088 */   // (trap)  =>  (TRAP)
     /* 129088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAP),
     /* 129093 */   GIR_RootConstrainSelectedInstOperands,
     /* 129094 */   // GIR_Coverage, 13,
     /* 129094 */   GIR_Done,
     /* 129095 */ // Label 2638: @129095
     /* 129095 */ GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(129110), // Rule ID 285 //
     /* 129100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 129103 */   // (trap)  =>  (tTRAP)
     /* 129103 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::tTRAP),
     /* 129108 */   GIR_RootConstrainSelectedInstOperands,
     /* 129109 */   // GIR_Coverage, 285,
     /* 129109 */   GIR_Done,
     /* 129110 */ // Label 2639: @129110
     /* 129110 */ GIM_Reject,
     /* 129111 */ // Label 73: @129111
     /* 129111 */ GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(129127), // Rule ID 1835 //
     /* 129116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 129119 */   // (debugtrap)  =>  (BKPT 0:{ *:[i32] })
     /* 129119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BKPT),
     /* 129122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129125 */   GIR_RootConstrainSelectedInstOperands,
     /* 129126 */   // GIR_Coverage, 1835,
     /* 129126 */   GIR_EraseRootFromParent_Done,
     /* 129127 */ // Label 2640: @129127
     /* 129127 */ GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(129154), // Rule ID 1836 //
     /* 129132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV5T),
     /* 129135 */   // (debugtrap)  =>  (UDF 254:{ *:[i32] })
     /* 129135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /* 129138 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129148 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129152 */   GIR_RootConstrainSelectedInstOperands,
     /* 129153 */   // GIR_Coverage, 1836,
     /* 129153 */   GIR_EraseRootFromParent_Done,
     /* 129154 */ // Label 2641: @129154
     /* 129154 */ GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(129170), // Rule ID 2021 //
     /* 129159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsThumb),
     /* 129162 */   // (debugtrap)  =>  (tBKPT 0:{ *:[i32] })
     /* 129162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBKPT),
     /* 129165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129168 */   GIR_RootConstrainSelectedInstOperands,
     /* 129169 */   // GIR_Coverage, 2021,
     /* 129169 */   GIR_EraseRootFromParent_Done,
     /* 129170 */ // Label 2642: @129170
     /* 129170 */ GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(129197), // Rule ID 2022 //
     /* 129175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_NoV5T),
     /* 129178 */   // (debugtrap)  =>  (tUDF 254:{ *:[i32] })
     /* 129178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /* 129181 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129191 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129195 */   GIR_RootConstrainSelectedInstOperands,
     /* 129196 */   // GIR_Coverage, 2022,
     /* 129196 */   GIR_EraseRootFromParent_Done,
     /* 129197 */ // Label 2643: @129197
     /* 129197 */ GIM_Reject,
     /* 129198 */ // Label 74: @129198
     /* 129198 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(129618),
     /* 129203 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129206 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2648*/ GIMT_Encode4(129504),
     /* 129217 */   /*GILLT_v4s32*//*Label 2645*/ GIMT_Encode4(129249), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129233 */   /*GILLT_v8s16*//*Label 2646*/ GIMT_Encode4(129320), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129245 */   /*GILLT_v16s8*//*Label 2647*/ GIMT_Encode4(129391),
     /* 129249 */   // Label 2645: @129249
     /* 129249 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(129319), // Rule ID 3238 //
     /* 129254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129289 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2))  =>  (MVE_VMLADAVu32:{ *:[i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 129289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /* 129292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129317 */     GIR_RootConstrainSelectedInstOperands,
     /* 129318 */     // GIR_Coverage, 3238,
     /* 129318 */     GIR_EraseRootFromParent_Done,
     /* 129319 */   // Label 2649: @129319
     /* 129319 */   GIM_Reject,
     /* 129320 */   // Label 2646: @129320
     /* 129320 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(129390), // Rule ID 3239 //
     /* 129325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 129348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129360 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2))  =>  (MVE_VMLADAVu16:{ *:[i32] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 129360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /* 129363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129388 */     GIR_RootConstrainSelectedInstOperands,
     /* 129389 */     // GIR_Coverage, 3239,
     /* 129389 */     GIR_EraseRootFromParent_Done,
     /* 129390 */   // Label 2650: @129390
     /* 129390 */   GIM_Reject,
     /* 129391 */   // Label 2647: @129391
     /* 129391 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(129503),
     /* 129396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129400 */     GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(129466), // Rule ID 3242 //
     /* 129405 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129408 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129412 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129416 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129420 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 129424 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129429 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129434 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129436 */       // (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2))  =>  (MVE_VMLADAVu8:{ *:[i32] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 129436 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /* 129439 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129441 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129445 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129449 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129452 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129458 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129464 */       GIR_RootConstrainSelectedInstOperands,
     /* 129465 */       // GIR_Coverage, 3242,
     /* 129465 */       GIR_EraseRootFromParent_Done,
     /* 129466 */     // Label 2652: @129466
     /* 129466 */     GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(129502), // Rule ID 3046 //
     /* 129471 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129474 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129478 */       // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VADDVu8no_acc:{ *:[i32] } ?:{ *:[v16i8] }:$vec)
     /* 129478 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8no_acc),
     /* 129481 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129483 */       GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129485 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129488 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129494 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129500 */       GIR_RootConstrainSelectedInstOperands,
     /* 129501 */       // GIR_Coverage, 3046,
     /* 129501 */       GIR_EraseRootFromParent_Done,
     /* 129502 */     // Label 2653: @129502
     /* 129502 */     GIM_Reject,
     /* 129503 */   // Label 2651: @129503
     /* 129503 */   GIM_Reject,
     /* 129504 */   // Label 2648: @129504
     /* 129504 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 2656*/ GIMT_Encode4(129617),
     /* 129515 */   /*GILLT_v4s32*//*Label 2654*/ GIMT_Encode4(129535), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129531 */   /*GILLT_v8s16*//*Label 2655*/ GIMT_Encode4(129576),
     /* 129535 */   // Label 2654: @129535
     /* 129535 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(129575), // Rule ID 3084 //
     /* 129540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129551 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VADDVu32no_acc:{ *:[i32] } ?:{ *:[v4i32] }:$vec)
     /* 129551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32no_acc),
     /* 129554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129556 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129561 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129573 */     GIR_RootConstrainSelectedInstOperands,
     /* 129574 */     // GIR_Coverage, 3084,
     /* 129574 */     GIR_EraseRootFromParent_Done,
     /* 129575 */   // Label 2657: @129575
     /* 129575 */   GIM_Reject,
     /* 129576 */   // Label 2655: @129576
     /* 129576 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(129616), // Rule ID 3074 //
     /* 129581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129592 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VADDVu16no_acc:{ *:[i32] } ?:{ *:[v8i16] }:$vec)
     /* 129592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16no_acc),
     /* 129595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129597 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129602 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129608 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129614 */     GIR_RootConstrainSelectedInstOperands,
     /* 129615 */     // GIR_Coverage, 3074,
     /* 129615 */     GIR_EraseRootFromParent_Done,
     /* 129616 */   // Label 2658: @129616
     /* 129616 */   GIM_Reject,
     /* 129617 */   // Label 2656: @129617
     /* 129617 */   GIM_Reject,
     /* 129618 */ // Label 2644: @129618
     /* 129618 */ GIM_Reject,
     /* 129619 */ // Label 75: @129619
     /* 129619 */ GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(129898),
     /* 129624 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129627 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2663*/ GIMT_Encode4(129897),
     /* 129638 */   /*GILLT_v4s32*//*Label 2660*/ GIMT_Encode4(129670), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129654 */   /*GILLT_v8s16*//*Label 2661*/ GIMT_Encode4(129753), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129666 */   /*GILLT_v16s8*//*Label 2662*/ GIMT_Encode4(129821),
     /* 129670 */   // Label 2660: @129670
     /* 129670 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(129752), // Rule ID 3144 //
     /* 129675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129686 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVs32:{ *:[i32] } (t2MOVi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 129686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 129693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129698 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 129708 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129711 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129717 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /* 129728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129733 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129750 */     GIR_RootConstrainSelectedInstOperands,
     /* 129751 */     // GIR_Coverage, 3144,
     /* 129751 */     GIR_EraseRootFromParent_Done,
     /* 129752 */   // Label 2664: @129752
     /* 129752 */   GIM_Reject,
     /* 129753 */   // Label 2661: @129753
     /* 129753 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(129820), // Rule ID 3143 //
     /* 129758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129769 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVs16:{ *:[i32] } (t2MOVi32imm:{ *:[i32] } -32768:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 129769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /* 129776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129781 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 129791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /* 129796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129801 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129818 */     GIR_RootConstrainSelectedInstOperands,
     /* 129819 */     // GIR_Coverage, 3143,
     /* 129819 */     GIR_EraseRootFromParent_Done,
     /* 129820 */   // Label 2665: @129820
     /* 129820 */   GIM_Reject,
     /* 129821 */   // Label 2662: @129821
     /* 129821 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(129896), // Rule ID 3142 //
     /* 129826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129837 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVs8:{ *:[i32] } (t2MVNi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 129837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 129844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129849 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 129852 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129855 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129861 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /* 129872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129877 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129888 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129894 */     GIR_RootConstrainSelectedInstOperands,
     /* 129895 */     // GIR_Coverage, 3142,
     /* 129895 */     GIR_EraseRootFromParent_Done,
     /* 129896 */   // Label 2666: @129896
     /* 129896 */   GIM_Reject,
     /* 129897 */   // Label 2663: @129897
     /* 129897 */   GIM_Reject,
     /* 129898 */ // Label 2659: @129898
     /* 129898 */ GIM_Reject,
     /* 129899 */ // Label 76: @129899
     /* 129899 */ GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(130187),
     /* 129904 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129907 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2671*/ GIMT_Encode4(130186),
     /* 129918 */   /*GILLT_v4s32*//*Label 2668*/ GIMT_Encode4(129950), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129934 */   /*GILLT_v8s16*//*Label 2669*/ GIMT_Encode4(130033), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129946 */   /*GILLT_v16s8*//*Label 2670*/ GIMT_Encode4(130110),
     /* 129950 */   // Label 2668: @129950
     /* 129950 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(130032), // Rule ID 3150 //
     /* 129955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129966 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVs32:{ *:[i32] } (t2MVNi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 129966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 129973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129978 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 129988 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129991 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129997 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /* 130008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130013 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130024 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130030 */     GIR_RootConstrainSelectedInstOperands,
     /* 130031 */     // GIR_Coverage, 3150,
     /* 130031 */     GIR_EraseRootFromParent_Done,
     /* 130032 */   // Label 2672: @130032
     /* 130032 */   GIM_Reject,
     /* 130033 */   // Label 2669: @130033
     /* 130033 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(130109), // Rule ID 3149 //
     /* 130038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130049 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVs16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 32767:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130061 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 130071 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130074 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /* 130085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130090 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130107 */     GIR_RootConstrainSelectedInstOperands,
     /* 130108 */     // GIR_Coverage, 3149,
     /* 130108 */     GIR_EraseRootFromParent_Done,
     /* 130109 */   // Label 2673: @130109
     /* 130109 */   GIM_Reject,
     /* 130110 */   // Label 2670: @130110
     /* 130110 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(130185), // Rule ID 3148 //
     /* 130115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130126 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVs8:{ *:[i32] } (t2MOVi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130138 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130141 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130144 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130150 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /* 130161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130166 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130183 */     GIR_RootConstrainSelectedInstOperands,
     /* 130184 */     // GIR_Coverage, 3148,
     /* 130184 */     GIR_EraseRootFromParent_Done,
     /* 130185 */   // Label 2674: @130185
     /* 130185 */   GIM_Reject,
     /* 130186 */   // Label 2671: @130186
     /* 130186 */   GIM_Reject,
     /* 130187 */ // Label 2667: @130187
     /* 130187 */ GIM_Reject,
     /* 130188 */ // Label 77: @130188
     /* 130188 */ GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(130468),
     /* 130193 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130196 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2679*/ GIMT_Encode4(130467),
     /* 130207 */   /*GILLT_v4s32*//*Label 2676*/ GIMT_Encode4(130239), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130223 */   /*GILLT_v8s16*//*Label 2677*/ GIMT_Encode4(130315), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130235 */   /*GILLT_v16s8*//*Label 2678*/ GIMT_Encode4(130391),
     /* 130239 */   // Label 2676: @130239
     /* 130239 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(130314), // Rule ID 3147 //
     /* 130244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130255 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130267 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130270 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130273 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130279 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /* 130290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130295 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130312 */     GIR_RootConstrainSelectedInstOperands,
     /* 130313 */     // GIR_Coverage, 3147,
     /* 130313 */     GIR_EraseRootFromParent_Done,
     /* 130314 */   // Label 2680: @130314
     /* 130314 */   GIM_Reject,
     /* 130315 */   // Label 2677: @130315
     /* 130315 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(130390), // Rule ID 3146 //
     /* 130320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130331 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVu16:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130343 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130346 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130349 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130355 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /* 130366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130371 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130388 */     GIR_RootConstrainSelectedInstOperands,
     /* 130389 */     // GIR_Coverage, 3146,
     /* 130389 */     GIR_EraseRootFromParent_Done,
     /* 130390 */   // Label 2681: @130390
     /* 130390 */   GIM_Reject,
     /* 130391 */   // Label 2678: @130391
     /* 130391 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(130466), // Rule ID 3145 //
     /* 130396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130407 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130419 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130422 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130425 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130431 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /* 130442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130447 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130464 */     GIR_RootConstrainSelectedInstOperands,
     /* 130465 */     // GIR_Coverage, 3145,
     /* 130465 */     GIR_EraseRootFromParent_Done,
     /* 130466 */   // Label 2682: @130466
     /* 130466 */   GIM_Reject,
     /* 130467 */   // Label 2679: @130467
     /* 130467 */   GIM_Reject,
     /* 130468 */ // Label 2675: @130468
     /* 130468 */ GIM_Reject,
     /* 130469 */ // Label 78: @130469
     /* 130469 */ GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(130764),
     /* 130474 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130477 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2687*/ GIMT_Encode4(130763),
     /* 130488 */   /*GILLT_v4s32*//*Label 2684*/ GIMT_Encode4(130520), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130504 */   /*GILLT_v8s16*//*Label 2685*/ GIMT_Encode4(130603), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130516 */   /*GILLT_v16s8*//*Label 2686*/ GIMT_Encode4(130680),
     /* 130520 */   // Label 2684: @130520
     /* 130520 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(130602), // Rule ID 3153 //
     /* 130525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130536 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 4294967295:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130548 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(4294967295),
     /* 130558 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130561 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130567 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /* 130578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130583 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130600 */     GIR_RootConstrainSelectedInstOperands,
     /* 130601 */     // GIR_Coverage, 3153,
     /* 130601 */     GIR_EraseRootFromParent_Done,
     /* 130602 */   // Label 2688: @130602
     /* 130602 */   GIM_Reject,
     /* 130603 */   // Label 2685: @130603
     /* 130603 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(130679), // Rule ID 3152 //
     /* 130608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130619 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVu16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130631 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 130641 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130644 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /* 130655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130660 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130665 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130677 */     GIR_RootConstrainSelectedInstOperands,
     /* 130678 */     // GIR_Coverage, 3152,
     /* 130678 */     GIR_EraseRootFromParent_Done,
     /* 130679 */   // Label 2689: @130679
     /* 130679 */   GIM_Reject,
     /* 130680 */   // Label 2686: @130680
     /* 130680 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(130762), // Rule ID 3151 //
     /* 130685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130696 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 255:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130708 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(255),
     /* 130718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130721 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130727 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /* 130738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130743 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130760 */     GIR_RootConstrainSelectedInstOperands,
     /* 130761 */     // GIR_Coverage, 3151,
     /* 130761 */     GIR_EraseRootFromParent_Done,
     /* 130762 */   // Label 2690: @130762
     /* 130762 */   GIM_Reject,
     /* 130763 */   // Label 2687: @130763
     /* 130763 */   GIM_Reject,
     /* 130764 */ // Label 2683: @130764
     /* 130764 */ GIM_Reject,
     /* 130765 */ // Label 79: @130765
     /* 130765 */ GIM_Reject,
     /* 130766 */ }; // Size: 130766 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
