/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the Mips target                            *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 44;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(MipsInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(MipsInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static MipsInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static MipsInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s16,
  GILLT_v2s64,
  GILLT_v4s8,
  GILLT_v4s32,
  GILLT_v8s16,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 9;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 16),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 8),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasMips2Bit = 7,
  Feature_HasMips3Bit = 17,
  Feature_HasMips4_32Bit = 27,
  Feature_NotMips4_32Bit = 28,
  Feature_HasMips4_32r2Bit = 18,
  Feature_HasMips32Bit = 3,
  Feature_HasMips32r2Bit = 6,
  Feature_HasMips32r6Bit = 29,
  Feature_NotMips32r6Bit = 4,
  Feature_IsGP64bitBit = 22,
  Feature_IsPTR64bitBit = 24,
  Feature_HasMips64Bit = 25,
  Feature_HasMips64r2Bit = 23,
  Feature_HasMips64r6Bit = 30,
  Feature_NotMips64r6Bit = 5,
  Feature_InMips16ModeBit = 31,
  Feature_NotInMips16ModeBit = 0,
  Feature_HasCnMipsBit = 26,
  Feature_NotCnMipsBit = 8,
  Feature_IsSym32Bit = 38,
  Feature_IsSym64Bit = 39,
  Feature_IsN64Bit = 40,
  Feature_RelocNotPICBit = 9,
  Feature_RelocPICBit = 37,
  Feature_NoNaNsFPMathBit = 21,
  Feature_UseAbsBit = 14,
  Feature_HasStdEncBit = 1,
  Feature_NotDSPBit = 11,
  Feature_InMicroMipsBit = 35,
  Feature_NotInMicroMipsBit = 2,
  Feature_IsLEBit = 42,
  Feature_IsBEBit = 43,
  Feature_IsNotNaClBit = 19,
  Feature_HasEVABit = 36,
  Feature_HasMSABit = 34,
  Feature_HasMadd4Bit = 20,
  Feature_UseIndirectJumpsHazardBit = 12,
  Feature_NoIndirectJumpGuardsBit = 10,
  Feature_AllowFPOpFusionBit = 41,
  Feature_IsFP64bitBit = 16,
  Feature_NotFP64bitBit = 15,
  Feature_IsNotSoftFloatBit = 13,
  Feature_HasDSPBit = 32,
  Feature_HasDSPR2Bit = 33,
};

PredicateBitset MipsInstructionSelector::
computeAvailableModuleFeatures(const MipsSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasMips2())
    Features.set(Feature_HasMips2Bit);
  if (Subtarget->hasMips3())
    Features.set(Feature_HasMips3Bit);
  if (Subtarget->hasMips4_32())
    Features.set(Feature_HasMips4_32Bit);
  if (!Subtarget->hasMips4_32())
    Features.set(Feature_NotMips4_32Bit);
  if (Subtarget->hasMips4_32r2())
    Features.set(Feature_HasMips4_32r2Bit);
  if (Subtarget->hasMips32())
    Features.set(Feature_HasMips32Bit);
  if (Subtarget->hasMips32r2())
    Features.set(Feature_HasMips32r2Bit);
  if (Subtarget->hasMips32r6())
    Features.set(Feature_HasMips32r6Bit);
  if (!Subtarget->hasMips32r6())
    Features.set(Feature_NotMips32r6Bit);
  if (Subtarget->isGP64bit())
    Features.set(Feature_IsGP64bitBit);
  if (Subtarget->isABI_N64())
    Features.set(Feature_IsPTR64bitBit);
  if (Subtarget->hasMips64())
    Features.set(Feature_HasMips64Bit);
  if (Subtarget->hasMips64r2())
    Features.set(Feature_HasMips64r2Bit);
  if (Subtarget->hasMips64r6())
    Features.set(Feature_HasMips64r6Bit);
  if (!Subtarget->hasMips64r6())
    Features.set(Feature_NotMips64r6Bit);
  if (Subtarget->inMips16Mode())
    Features.set(Feature_InMips16ModeBit);
  if (!Subtarget->inMips16Mode())
    Features.set(Feature_NotInMips16ModeBit);
  if (Subtarget->hasCnMips())
    Features.set(Feature_HasCnMipsBit);
  if (!Subtarget->hasCnMips())
    Features.set(Feature_NotCnMipsBit);
  if (Subtarget->hasSym32())
    Features.set(Feature_IsSym32Bit);
  if (!Subtarget->hasSym32())
    Features.set(Feature_IsSym64Bit);
  if (Subtarget->isABI_N64())
    Features.set(Feature_IsN64Bit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_RelocNotPICBit);
  if (TM.isPositionIndependent())
    Features.set(Feature_RelocPICBit);
  if (TM.Options.NoNaNsFPMath)
    Features.set(Feature_NoNaNsFPMathBit);
  if (Subtarget->inAbs2008Mode() ||TM.Options.NoNaNsFPMath)
    Features.set(Feature_UseAbsBit);
  if (Subtarget->hasStandardEncoding())
    Features.set(Feature_HasStdEncBit);
  if (!Subtarget->hasDSP())
    Features.set(Feature_NotDSPBit);
  if (Subtarget->inMicroMipsMode())
    Features.set(Feature_InMicroMipsBit);
  if (!Subtarget->inMicroMipsMode())
    Features.set(Feature_NotInMicroMipsBit);
  if (Subtarget->isLittle())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittle())
    Features.set(Feature_IsBEBit);
  if (!Subtarget->isTargetNaCl())
    Features.set(Feature_IsNotNaClBit);
  if (Subtarget->hasEVA())
    Features.set(Feature_HasEVABit);
  if (Subtarget->hasMSA())
    Features.set(Feature_HasMSABit);
  if (!Subtarget->disableMadd4())
    Features.set(Feature_HasMadd4Bit);
  if (Subtarget->useIndirectJumpsHazard())
    Features.set(Feature_UseIndirectJumpsHazardBit);
  if (!Subtarget->useIndirectJumpsHazard())
    Features.set(Feature_NoIndirectJumpGuardsBit);
  if (TM.Options.AllowFPOpFusion == FPOpFusion::Fast)
    Features.set(Feature_AllowFPOpFusionBit);
  if (Subtarget->isFP64bit())
    Features.set(Feature_IsFP64bitBit);
  if (!Subtarget->isFP64bit())
    Features.set(Feature_NotFP64bitBit);
  if (!Subtarget->useSoftFloat())
    Features.set(Feature_IsNotSoftFloatBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDSPR2())
    Features.set(Feature_HasDSPR2Bit);
  return Features;
}

void MipsInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const MipsSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset MipsInstructionSelector::
computeAvailableFunctionFeatures(const MipsSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasCnMips,
  GIFBS_HasDSP,
  GIFBS_HasDSPR2,
  GIFBS_HasMSA,
  GIFBS_InMicroMips,
  GIFBS_InMips16Mode,
  GIFBS_IsFP64bit,
  GIFBS_NotFP64bit,
  GIFBS_NotInMips16Mode,
  GIFBS_HasDSP_InMicroMips,
  GIFBS_HasDSP_NotInMicroMips,
  GIFBS_HasDSPR2_InMicroMips,
  GIFBS_HasMSA_HasStdEnc,
  GIFBS_HasMSA_IsBE,
  GIFBS_HasMSA_IsLE,
  GIFBS_HasMips32r6_HasStdEnc,
  GIFBS_HasMips32r6_InMicroMips,
  GIFBS_HasMips64r2_HasStdEnc,
  GIFBS_HasMips64r6_HasStdEnc,
  GIFBS_HasStdEnc_IsNotSoftFloat,
  GIFBS_HasStdEnc_NotInMicroMips,
  GIFBS_HasStdEnc_NotMips4_32,
  GIFBS_InMicroMips_IsFP64bit,
  GIFBS_InMicroMips_IsNotSoftFloat,
  GIFBS_InMicroMips_NotFP64bit,
  GIFBS_InMicroMips_NotMips32r6,
  GIFBS_IsGP64bit_NotInMips16Mode,
  GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc,
  GIFBS_HasMSA_HasMips64_HasStdEnc,
  GIFBS_HasMips3_HasStdEnc_IsGP64bit,
  GIFBS_HasMips3_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips32r2_HasStdEnc_IsGP64bit,
  GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat,
  GIFBS_HasMips64r2_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips,
  GIFBS_HasStdEnc_IsFP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_IsFP64bit_NotMips4_32,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasStdEnc_NotFP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_NotFP64bit_NotMips4_32,
  GIFBS_HasStdEnc_NotInMicroMips_RelocNotPIC,
  GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat,
  GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit,
  GIFBS_InMicroMips_IsNotSoftFloat_UseAbs,
  GIFBS_InMicroMips_NotFP64bit_NotMips32r6,
  GIFBS_InMicroMips_NotMips32r6_RelocNotPIC,
  GIFBS_InMicroMips_NotMips32r6_RelocPIC,
  GIFBS_IsFP64bit_IsNotSoftFloat_NotInMips16Mode,
  GIFBS_IsNotSoftFloat_NotFP64bit_NotInMips16Mode,
  GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6,
  GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips,
  GIFBS_HasMips3_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips32_HasStdEnc_NotMips32r6_NotMips64r6,
  GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6,
  GIFBS_HasMips64r2_HasStdEnc_IsGP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips_UseAbs,
  GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6,
  GIFBS_HasMips2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips,
  GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips64_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips64r6,
  GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_UseAbs,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_UseAbs,
  GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasCnMipsBit, },
  {Feature_HasDSPBit, },
  {Feature_HasDSPR2Bit, },
  {Feature_HasMSABit, },
  {Feature_InMicroMipsBit, },
  {Feature_InMips16ModeBit, },
  {Feature_IsFP64bitBit, },
  {Feature_NotFP64bitBit, },
  {Feature_NotInMips16ModeBit, },
  {Feature_HasDSPBit, Feature_InMicroMipsBit, },
  {Feature_HasDSPBit, Feature_NotInMicroMipsBit, },
  {Feature_HasDSPR2Bit, Feature_InMicroMipsBit, },
  {Feature_HasMSABit, Feature_HasStdEncBit, },
  {Feature_HasMSABit, Feature_IsBEBit, },
  {Feature_HasMSABit, Feature_IsLEBit, },
  {Feature_HasMips32r6Bit, Feature_HasStdEncBit, },
  {Feature_HasMips32r6Bit, Feature_InMicroMipsBit, },
  {Feature_HasMips64r2Bit, Feature_HasStdEncBit, },
  {Feature_HasMips64r6Bit, Feature_HasStdEncBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, },
  {Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_NotMips4_32Bit, },
  {Feature_InMicroMipsBit, Feature_IsFP64bitBit, },
  {Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, },
  {Feature_InMicroMipsBit, Feature_NotFP64bitBit, },
  {Feature_InMicroMipsBit, Feature_NotMips32r6Bit, },
  {Feature_IsGP64bitBit, Feature_NotInMips16ModeBit, },
  {Feature_AllowFPOpFusionBit, Feature_HasMSABit, Feature_HasStdEncBit, },
  {Feature_HasMSABit, Feature_HasMips64Bit, Feature_HasStdEncBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32r2Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, },
  {Feature_HasMips32r2Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32r6Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32r6Bit, Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, },
  {Feature_HasMips64r2Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips64r6Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NotMips4_32Bit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_NotFP64bitBit, Feature_NotMips4_32Bit, },
  {Feature_HasStdEncBit, Feature_NotInMicroMipsBit, Feature_RelocNotPICBit, },
  {Feature_InMicroMipsBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, },
  {Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, },
  {Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, Feature_UseAbsBit, },
  {Feature_InMicroMipsBit, Feature_NotFP64bitBit, Feature_NotMips32r6Bit, },
  {Feature_InMicroMipsBit, Feature_NotMips32r6Bit, Feature_RelocNotPICBit, },
  {Feature_InMicroMipsBit, Feature_NotMips32r6Bit, Feature_RelocPICBit, },
  {Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMips16ModeBit, },
  {Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMips16ModeBit, },
  {Feature_HasMadd4Bit, Feature_InMicroMipsBit, Feature_NoNaNsFPMathBit, Feature_NotMips32r6Bit, },
  {Feature_HasMips2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32Bit, Feature_HasStdEncBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips32r6Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips64r2Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_UseAbsBit, },
  {Feature_HasMadd4Bit, Feature_InMicroMipsBit, Feature_NoNaNsFPMathBit, Feature_NotFP64bitBit, Feature_NotMips32r6Bit, },
  {Feature_HasMips2Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips64Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips64r6Bit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_UseAbsBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_UseAbsBit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_NoNaNsFPMathBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NoNaNsFPMathBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_NoNaNsFPMathBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

MipsInstructionSelector::ComplexMatcherMemFn
MipsInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_or_disjoint = GICXXPred_Invalid + 1,
};
bool MipsInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_or_disjoint: {
    
        return MI.getFlag(MachineInstr::Disjoint);
      
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool MipsInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_immLi16 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_immSExt6,
  GICXXPred_I64_Predicate_immSExt10,
  GICXXPred_I64_Predicate_immSExtAddiur2,
  GICXXPred_I64_Predicate_immSExtAddius5,
  GICXXPred_I64_Predicate_immZExt1,
  GICXXPred_I64_Predicate_immZExt1Ptr,
  GICXXPred_I64_Predicate_immZExt2,
  GICXXPred_I64_Predicate_immZExt2Lsa,
  GICXXPred_I64_Predicate_immZExt2Ptr,
  GICXXPred_I64_Predicate_immZExt2Shift,
  GICXXPred_I64_Predicate_immZExt3,
  GICXXPred_I64_Predicate_immZExt3Ptr,
  GICXXPred_I64_Predicate_immZExt4,
  GICXXPred_I64_Predicate_immZExt4Ptr,
  GICXXPred_I64_Predicate_immZExt5,
  GICXXPred_I64_Predicate_immZExt5_64,
  GICXXPred_I64_Predicate_immZExt6,
  GICXXPred_I64_Predicate_immZExt8,
  GICXXPred_I64_Predicate_immZExt10,
  GICXXPred_I64_Predicate_immZExtAndi16,
  GICXXPred_I64_Predicate_immi32Cst7,
  GICXXPred_I64_Predicate_immi32Cst15,
  GICXXPred_I64_Predicate_immi32Cst31,
  GICXXPred_I64_Predicate_timmSExt6,
  GICXXPred_I64_Predicate_timmZExt1,
  GICXXPred_I64_Predicate_timmZExt1Ptr,
  GICXXPred_I64_Predicate_timmZExt2,
  GICXXPred_I64_Predicate_timmZExt2Ptr,
  GICXXPred_I64_Predicate_timmZExt3,
  GICXXPred_I64_Predicate_timmZExt3Ptr,
  GICXXPred_I64_Predicate_timmZExt4,
  GICXXPred_I64_Predicate_timmZExt4Ptr,
  GICXXPred_I64_Predicate_timmZExt5,
  GICXXPred_I64_Predicate_timmZExt6,
  GICXXPred_I64_Predicate_timmZExt8,
  GICXXPred_I64_Predicate_timmZExt10,
};
bool MipsInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_immLi16: {
    return Imm >= -1 && Imm <= 126;
  }
  case GICXXPred_I64_Predicate_immSExt6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_immSExt10: {
    return isInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immSExtAddiur2: {
    return Imm == 1 || Imm == -1 ||
                                               ((Imm % 4 == 0) &&
                                                Imm < 28 && Imm > 0);
  }
  case GICXXPred_I64_Predicate_immSExtAddius5: {
    return Imm >= -8 && Imm <= 7;
  }
  case GICXXPred_I64_Predicate_immZExt1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt1Ptr: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt2Lsa: {
    return isUInt<2>(Imm - 1);
  }
  case GICXXPred_I64_Predicate_immZExt2Ptr: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt2Shift: {
    return Imm >= 1 && Imm <= 8;
  }
  case GICXXPred_I64_Predicate_immZExt3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt3Ptr: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt4Ptr: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt5: {
    return Imm == (Imm & 0x1f);
  }
  case GICXXPred_I64_Predicate_immZExt5_64: {
     return Imm == (Imm & 0x1f); 
  }
  case GICXXPred_I64_Predicate_immZExt6: {
    return Imm == (Imm & 0x3f);
  }
  case GICXXPred_I64_Predicate_immZExt8: {
    return isUInt<8>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExtAndi16: {
    return (Imm == 128 || (Imm >= 1 && Imm <= 4) || Imm == 7 || Imm == 8 ||
                Imm == 15 || Imm == 16 || Imm == 31 || Imm == 32 || Imm == 63 ||
                Imm == 64 || Imm == 255 || Imm == 32768 || Imm == 65535 );
  }
  case GICXXPred_I64_Predicate_immi32Cst7: {
    return isUInt<32>(Imm) && Imm == 7;
  }
  case GICXXPred_I64_Predicate_immi32Cst15: {
    return isUInt<32>(Imm) && Imm == 15;
  }
  case GICXXPred_I64_Predicate_immi32Cst31: {
    return isUInt<32>(Imm) && Imm == 31;
  }
  case GICXXPred_I64_Predicate_timmSExt6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt1Ptr: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt2Ptr: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt3Ptr: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt4Ptr: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt5: {
    return Imm == (Imm & 0x1f);
  }
  case GICXXPred_I64_Predicate_timmZExt6: {
    return Imm == (Imm & 0x3f);
  }
  case GICXXPred_I64_Predicate_timmZExt8: {
    return isUInt<8>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt10: {
    return isUInt<10>(Imm);
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool MipsInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_imm32SExt16 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_imm32ZExt16,
};
bool MipsInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_imm32SExt16: {
     return isInt<16>(Imm.getSExtValue()); 
  }
  case GICXXPred_APInt_Predicate_imm32ZExt16: {
    
      return (uint32_t)Imm.getZExtValue() == (unsigned short)Imm.getZExtValue();
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool MipsInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("MipsInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
MipsInstructionSelector::CustomRendererFn
MipsInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool MipsInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool MipsInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("MipsInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *MipsInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*     0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(292), /*)*//*default:*//*Label 79*/ GIMT_Encode4(69789),
     /*    10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(966),
     /*    14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(2264),
     /*    18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(2955),
     /*    22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(3436),
     /*    26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(3705),
     /*    30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(3974),
     /*    34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(4243), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(4512),
     /*    50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(5068),
     /*    54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(5472), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   102 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 10*/ GIMT_Encode4(6364),
     /*   106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 11*/ GIMT_Encode4(6437), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   126 */ /*TargetOpcode::G_BITCAST*//*Label 12*/ GIMT_Encode4(6778), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   170 */ /*TargetOpcode::G_LOAD*//*Label 13*/ GIMT_Encode4(11089),
     /*   174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 14*/ GIMT_Encode4(11154),
     /*   178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 15*/ GIMT_Encode4(11222), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 16*/ GIMT_Encode4(11290),
     /*   210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 17*/ GIMT_Encode4(11482),
     /*   214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 18*/ GIMT_Encode4(11652),
     /*   218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 19*/ GIMT_Encode4(11822),
     /*   222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 20*/ GIMT_Encode4(11992),
     /*   226 */ /*TargetOpcode::G_ATOMICRMW_NAND*//*Label 21*/ GIMT_Encode4(12162),
     /*   230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 22*/ GIMT_Encode4(12332),
     /*   234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 23*/ GIMT_Encode4(12502),
     /*   238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 24*/ GIMT_Encode4(12672),
     /*   242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 25*/ GIMT_Encode4(12842),
     /*   246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 26*/ GIMT_Encode4(13012),
     /*   250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 27*/ GIMT_Encode4(13182), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   302 */ /*TargetOpcode::G_BRCOND*//*Label 28*/ GIMT_Encode4(13352), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   314 */ /*TargetOpcode::G_INTRINSIC*//*Label 29*/ GIMT_Encode4(18073),
     /*   318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 30*/ GIMT_Encode4(32338), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   330 */ /*TargetOpcode::G_ANYEXT*//*Label 31*/ GIMT_Encode4(37432),
     /*   334 */ /*TargetOpcode::G_TRUNC*//*Label 32*/ GIMT_Encode4(37498), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   350 */ /*TargetOpcode::G_CONSTANT*//*Label 33*/ GIMT_Encode4(37562), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   366 */ /*TargetOpcode::G_SEXT*//*Label 34*/ GIMT_Encode4(37623),
     /*   370 */ /*TargetOpcode::G_SEXT_INREG*//*Label 35*/ GIMT_Encode4(39087),
     /*   374 */ /*TargetOpcode::G_ZEXT*//*Label 36*/ GIMT_Encode4(39435),
     /*   378 */ /*TargetOpcode::G_SHL*//*Label 37*/ GIMT_Encode4(39636),
     /*   382 */ /*TargetOpcode::G_LSHR*//*Label 38*/ GIMT_Encode4(41433),
     /*   386 */ /*TargetOpcode::G_ASHR*//*Label 39*/ GIMT_Encode4(43230), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   398 */ /*TargetOpcode::G_ROTR*//*Label 40*/ GIMT_Encode4(44985), GIMT_Encode4(0),
     /*   406 */ /*TargetOpcode::G_ICMP*//*Label 41*/ GIMT_Encode4(45273),
     /*   410 */ /*TargetOpcode::G_FCMP*//*Label 42*/ GIMT_Encode4(47804), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   422 */ /*TargetOpcode::G_SELECT*//*Label 43*/ GIMT_Encode4(49510), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   466 */ /*TargetOpcode::G_UMULH*//*Label 44*/ GIMT_Encode4(61548),
     /*   470 */ /*TargetOpcode::G_SMULH*//*Label 45*/ GIMT_Encode4(61657), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   530 */ /*TargetOpcode::G_FADD*//*Label 46*/ GIMT_Encode4(61766),
     /*   534 */ /*TargetOpcode::G_FSUB*//*Label 47*/ GIMT_Encode4(62679),
     /*   538 */ /*TargetOpcode::G_FMUL*//*Label 48*/ GIMT_Encode4(63291),
     /*   542 */ /*TargetOpcode::G_FMA*//*Label 49*/ GIMT_Encode4(63778), GIMT_Encode4(0),
     /*   550 */ /*TargetOpcode::G_FDIV*//*Label 50*/ GIMT_Encode4(63884), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   570 */ /*TargetOpcode::G_FEXP2*//*Label 51*/ GIMT_Encode4(64183), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   582 */ /*TargetOpcode::G_FLOG2*//*Label 52*/ GIMT_Encode4(64261), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   598 */ /*TargetOpcode::G_FNEG*//*Label 53*/ GIMT_Encode4(64339),
     /*   602 */ /*TargetOpcode::G_FPEXT*//*Label 54*/ GIMT_Encode4(65708),
     /*   606 */ /*TargetOpcode::G_FPTRUNC*//*Label 55*/ GIMT_Encode4(65886),
     /*   610 */ /*TargetOpcode::G_FPTOSI*//*Label 56*/ GIMT_Encode4(66049),
     /*   614 */ /*TargetOpcode::G_FPTOUI*//*Label 57*/ GIMT_Encode4(66127),
     /*   618 */ /*TargetOpcode::G_SITOFP*//*Label 58*/ GIMT_Encode4(66205),
     /*   622 */ /*TargetOpcode::G_UITOFP*//*Label 59*/ GIMT_Encode4(66458), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   634 */ /*TargetOpcode::G_FABS*//*Label 60*/ GIMT_Encode4(66536), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   646 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 61*/ GIMT_Encode4(66776),
     /*   650 */ /*TargetOpcode::G_FMINNUM*//*Label 62*/ GIMT_Encode4(66850),
     /*   654 */ /*TargetOpcode::G_FMAXNUM*//*Label 63*/ GIMT_Encode4(66922),
     /*   658 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 64*/ GIMT_Encode4(66994),
     /*   662 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 65*/ GIMT_Encode4(67066), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   714 */ /*TargetOpcode::G_SMIN*//*Label 66*/ GIMT_Encode4(67138),
     /*   718 */ /*TargetOpcode::G_SMAX*//*Label 67*/ GIMT_Encode4(67306),
     /*   722 */ /*TargetOpcode::G_UMIN*//*Label 68*/ GIMT_Encode4(67474),
     /*   726 */ /*TargetOpcode::G_UMAX*//*Label 69*/ GIMT_Encode4(67642), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   742 */ /*TargetOpcode::G_BR*//*Label 70*/ GIMT_Encode4(67810), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   762 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 71*/ GIMT_Encode4(67934),
     /*   766 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 72*/ GIMT_Encode4(68498), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   794 */ /*TargetOpcode::G_CTLZ*//*Label 73*/ GIMT_Encode4(68550), GIMT_Encode4(0),
     /*   802 */ /*TargetOpcode::G_CTPOP*//*Label 74*/ GIMT_Encode4(69055),
     /*   806 */ /*TargetOpcode::G_BSWAP*//*Label 75*/ GIMT_Encode4(69261), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   862 */ /*TargetOpcode::G_FSQRT*//*Label 76*/ GIMT_Encode4(69425), GIMT_Encode4(0),
     /*   870 */ /*TargetOpcode::G_FRINT*//*Label 77*/ GIMT_Encode4(69665), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   962 */ /*TargetOpcode::G_TRAP*//*Label 78*/ GIMT_Encode4(69743),
     /*   966 */ // Label 0: @966
     /*   966 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 88*/ GIMT_Encode4(2263),
     /*   977 */ /*GILLT_s32*//*Label 80*/ GIMT_Encode4(1009),
     /*   981 */ /*GILLT_s64*//*Label 81*/ GIMT_Encode4(1417),
     /*   985 */ /*GILLT_v2s16*//*Label 82*/ GIMT_Encode4(1583),
     /*   989 */ /*GILLT_v2s64*//*Label 83*/ GIMT_Encode4(1615),
     /*   993 */ /*GILLT_v4s8*//*Label 84*/ GIMT_Encode4(1769),
     /*   997 */ /*GILLT_v4s32*//*Label 85*/ GIMT_Encode4(1801),
     /*  1001 */ /*GILLT_v8s16*//*Label 86*/ GIMT_Encode4(1955),
     /*  1005 */ /*GILLT_v16s8*//*Label 87*/ GIMT_Encode4(2109),
     /*  1009 */ // Label 80: @1009
     /*  1009 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1416),
     /*  1014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  1017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  1020 */   GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1087), // Rule ID 2400 //
     /*  1025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  1044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1061 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1065 */     // MIs[2] Operand 1
     /*  1065 */     // No operand predicates
     /*  1065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1071 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa), GPR32Opnd:{ *:[i32] }:$rt)  =>  (LSA:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LSA),
     /*  1074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /*  1082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1085 */     GIR_RootConstrainSelectedInstOperands,
     /*  1086 */     // GIR_Coverage, 2400,
     /*  1086 */     GIR_EraseRootFromParent_Done,
     /*  1087 */   // Label 90: @1087
     /*  1087 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1154), // Rule ID 834 //
     /*  1092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  1115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1132 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1136 */     // MIs[2] Operand 1
     /*  1136 */     // No operand predicates
     /*  1136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1138 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa))  =>  (LSA:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LSA),
     /*  1141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /*  1149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1152 */     GIR_RootConstrainSelectedInstOperands,
     /*  1153 */     // GIR_Coverage, 834,
     /*  1153 */     GIR_EraseRootFromParent_Done,
     /*  1154 */   // Label 91: @1154
     /*  1154 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1196), // Rule ID 40 //
     /*  1159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  1162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1178 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32SExt16),
     /*  1182 */     // MIs[1] Operand 1
     /*  1182 */     // No operand predicates
     /*  1182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1184 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm16)  =>  (ADDiu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  1184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDiu),
     /*  1187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  1189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  1191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  1194 */     GIR_RootConstrainSelectedInstOperands,
     /*  1195 */     // GIR_Coverage, 40,
     /*  1195 */     GIR_EraseRootFromParent_Done,
     /*  1196 */   // Label 92: @1196
     /*  1196 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1238), // Rule ID 2169 //
     /*  1201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  1204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExtAddiur2),
     /*  1224 */     // MIs[1] Operand 1
     /*  1224 */     // No operand predicates
     /*  1224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1226 */     // (add:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddiur2>>:$imm)  =>  (ADDIUR2_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddiur2>>:$imm)
     /*  1226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDIUR2_MM),
     /*  1229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1231 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  1236 */     GIR_RootConstrainSelectedInstOperands,
     /*  1237 */     // GIR_Coverage, 2169,
     /*  1237 */     GIR_EraseRootFromParent_Done,
     /*  1238 */   // Label 93: @1238
     /*  1238 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1280), // Rule ID 2170 //
     /*  1243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  1246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExtAddius5),
     /*  1266 */     // MIs[1] Operand 1
     /*  1266 */     // No operand predicates
     /*  1266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1268 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddius5>>:$imm)  =>  (ADDIUS5_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddius5>>:$imm)
     /*  1268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDIUS5_MM),
     /*  1271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1273 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  1278 */     GIR_RootConstrainSelectedInstOperands,
     /*  1279 */     // GIR_Coverage, 2170,
     /*  1279 */     GIR_EraseRootFromParent_Done,
     /*  1280 */   // Label 94: @1280
     /*  1280 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1307), // Rule ID 1208 //
     /*  1285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  1288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1300 */     // (add:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (ADDU16_MMR6:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  1300 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDU16_MMR6),
     /*  1305 */     GIR_RootConstrainSelectedInstOperands,
     /*  1306 */     // GIR_Coverage, 1208,
     /*  1306 */     GIR_Done,
     /*  1307 */   // Label 95: @1307
     /*  1307 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1334), // Rule ID 46 //
     /*  1312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  1315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1327 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  1327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDu),
     /*  1332 */     GIR_RootConstrainSelectedInstOperands,
     /*  1333 */     // GIR_Coverage, 46,
     /*  1333 */     GIR_Done,
     /*  1334 */   // Label 96: @1334
     /*  1334 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1361), // Rule ID 1060 //
     /*  1339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  1342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1354 */     // (add:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (ADDU16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  1354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDU16_MM),
     /*  1359 */     GIR_RootConstrainSelectedInstOperands,
     /*  1360 */     // GIR_Coverage, 1060,
     /*  1360 */     GIR_Done,
     /*  1361 */   // Label 97: @1361
     /*  1361 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1388), // Rule ID 1072 //
     /*  1366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  1369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1381 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDu_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  1381 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDu_MM),
     /*  1386 */     GIR_RootConstrainSelectedInstOperands,
     /*  1387 */     // GIR_Coverage, 1072,
     /*  1387 */     GIR_Done,
     /*  1388 */   // Label 98: @1388
     /*  1388 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1415), // Rule ID 1827 //
     /*  1393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  1396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  1400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  1404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  1408 */     // (add:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (AdduRxRyRz16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  1408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AdduRxRyRz16),
     /*  1413 */     GIR_RootConstrainSelectedInstOperands,
     /*  1414 */     // GIR_Coverage, 1827,
     /*  1414 */     GIR_Done,
     /*  1415 */   // Label 99: @1415
     /*  1415 */   GIM_Reject,
     /*  1416 */ // Label 89: @1416
     /*  1416 */ GIM_Reject,
     /*  1417 */ // Label 81: @1417
     /*  1417 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1582),
     /*  1422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  1425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  1428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1432 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1495), // Rule ID 2401 //
     /*  1437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasMips64_HasStdEnc),
     /*  1440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  1452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1469 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1473 */     // MIs[2] Operand 1
     /*  1473 */     // No operand predicates
     /*  1473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1479 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa), GPR64Opnd:{ *:[i64] }:$rt)  =>  (DLSA:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DLSA),
     /*  1482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /*  1490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1493 */     GIR_RootConstrainSelectedInstOperands,
     /*  1494 */     // GIR_Coverage, 2401,
     /*  1494 */     GIR_EraseRootFromParent_Done,
     /*  1495 */   // Label 101: @1495
     /*  1495 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1558), // Rule ID 835 //
     /*  1500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasMips64_HasStdEnc),
     /*  1503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  1519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1536 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1540 */     // MIs[2] Operand 1
     /*  1540 */     // No operand predicates
     /*  1540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1542 */     // (add:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa))  =>  (DLSA:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DLSA),
     /*  1545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /*  1553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1556 */     GIR_RootConstrainSelectedInstOperands,
     /*  1557 */     // GIR_Coverage, 835,
     /*  1557 */     GIR_EraseRootFromParent_Done,
     /*  1558 */   // Label 102: @1558
     /*  1558 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1581), // Rule ID 202 //
     /*  1563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /*  1566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1574 */     // (add:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DADDu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  1574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DADDu),
     /*  1579 */     GIR_RootConstrainSelectedInstOperands,
     /*  1580 */     // GIR_Coverage, 202,
     /*  1580 */     GIR_Done,
     /*  1581 */   // Label 103: @1581
     /*  1581 */   GIM_Reject,
     /*  1582 */ // Label 100: @1582
     /*  1582 */ GIM_Reject,
     /*  1583 */ // Label 82: @1583
     /*  1583 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1614), // Rule ID 1926 //
     /*  1588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  1591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  1594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  1597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  1601 */   // (add:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (ADDQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /*  1601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDQ_PH),
     /*  1606 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  1612 */   GIR_RootConstrainSelectedInstOperands,
     /*  1613 */   // GIR_Coverage, 1926,
     /*  1613 */   GIR_Done,
     /*  1614 */ // Label 104: @1614
     /*  1614 */ GIM_Reject,
     /*  1615 */ // Label 83: @1615
     /*  1615 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1768),
     /*  1620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  1623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  1626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1630 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1687), // Rule ID 2405 //
     /*  1635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  1650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  1654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1670 */     // (add:{ *:[v2i64] } (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt), MSA128DOpnd:{ *:[v2i64] }:$wd_in)  =>  (MADDV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  1670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_D),
     /*  1673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1675 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  1677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1685 */     GIR_RootConstrainSelectedInstOperands,
     /*  1686 */     // GIR_Coverage, 2405,
     /*  1686 */     GIR_EraseRootFromParent_Done,
     /*  1687 */   // Label 106: @1687
     /*  1687 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1744), // Rule ID 843 //
     /*  1692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  1711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  1715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1727 */     // (add:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt))  =>  (MADDV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  1727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_D),
     /*  1730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1732 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  1734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1742 */     GIR_RootConstrainSelectedInstOperands,
     /*  1743 */     // GIR_Coverage, 843,
     /*  1743 */     GIR_EraseRootFromParent_Done,
     /*  1744 */   // Label 107: @1744
     /*  1744 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1767), // Rule ID 510 //
     /*  1749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1760 */     // (add:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  1760 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_D),
     /*  1765 */     GIR_RootConstrainSelectedInstOperands,
     /*  1766 */     // GIR_Coverage, 510,
     /*  1766 */     GIR_Done,
     /*  1767 */   // Label 108: @1767
     /*  1767 */   GIM_Reject,
     /*  1768 */ // Label 105: @1768
     /*  1768 */ GIM_Reject,
     /*  1769 */ // Label 84: @1769
     /*  1769 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1800), // Rule ID 1932 //
     /*  1774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  1777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  1780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /*  1783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  1787 */   // (add:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (ADDU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /*  1787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDU_QB),
     /*  1792 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  1798 */   GIR_RootConstrainSelectedInstOperands,
     /*  1799 */   // GIR_Coverage, 1932,
     /*  1799 */   GIR_Done,
     /*  1800 */ // Label 109: @1800
     /*  1800 */ GIM_Reject,
     /*  1801 */ // Label 85: @1801
     /*  1801 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1954),
     /*  1806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  1809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  1812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1816 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1873), // Rule ID 2404 //
     /*  1821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  1836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  1840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1856 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt), MSA128WOpnd:{ *:[v4i32] }:$wd_in)  =>  (MADDV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  1856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_W),
     /*  1859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1861 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  1863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1871 */     GIR_RootConstrainSelectedInstOperands,
     /*  1872 */     // GIR_Coverage, 2404,
     /*  1872 */     GIR_EraseRootFromParent_Done,
     /*  1873 */   // Label 111: @1873
     /*  1873 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1930), // Rule ID 842 //
     /*  1878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  1897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  1901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1913 */     // (add:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt))  =>  (MADDV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  1913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_W),
     /*  1916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1918 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  1920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1928 */     GIR_RootConstrainSelectedInstOperands,
     /*  1929 */     // GIR_Coverage, 842,
     /*  1929 */     GIR_EraseRootFromParent_Done,
     /*  1930 */   // Label 112: @1930
     /*  1930 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1953), // Rule ID 509 //
     /*  1935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1946 */     // (add:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  1946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_W),
     /*  1951 */     GIR_RootConstrainSelectedInstOperands,
     /*  1952 */     // GIR_Coverage, 509,
     /*  1952 */     GIR_Done,
     /*  1953 */   // Label 113: @1953
     /*  1953 */   GIM_Reject,
     /*  1954 */ // Label 110: @1954
     /*  1954 */ GIM_Reject,
     /*  1955 */ // Label 86: @1955
     /*  1955 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(2108),
     /*  1960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  1963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  1966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  1970 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(2027), // Rule ID 2403 //
     /*  1975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  1990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  1994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  1999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2010 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt), MSA128HOpnd:{ *:[v8i16] }:$wd_in)  =>  (MADDV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_H),
     /*  2013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2015 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  2017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2025 */     GIR_RootConstrainSelectedInstOperands,
     /*  2026 */     // GIR_Coverage, 2403,
     /*  2026 */     GIR_EraseRootFromParent_Done,
     /*  2027 */   // Label 115: @2027
     /*  2027 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(2084), // Rule ID 841 //
     /*  2032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2067 */     // (add:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt))  =>  (MADDV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_H),
     /*  2070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2072 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2082 */     GIR_RootConstrainSelectedInstOperands,
     /*  2083 */     // GIR_Coverage, 841,
     /*  2083 */     GIR_EraseRootFromParent_Done,
     /*  2084 */   // Label 116: @2084
     /*  2084 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(2107), // Rule ID 508 //
     /*  2089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2100 */     // (add:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_H),
     /*  2105 */     GIR_RootConstrainSelectedInstOperands,
     /*  2106 */     // GIR_Coverage, 508,
     /*  2106 */     GIR_Done,
     /*  2107 */   // Label 117: @2107
     /*  2107 */   GIM_Reject,
     /*  2108 */ // Label 114: @2108
     /*  2108 */ GIM_Reject,
     /*  2109 */ // Label 87: @2109
     /*  2109 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(2262),
     /*  2114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2124 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2181), // Rule ID 2402 //
     /*  2129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  2136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2164 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt), MSA128BOpnd:{ *:[v16i8] }:$wd_in)  =>  (MADDV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_B),
     /*  2167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2169 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  2171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2179 */     GIR_RootConstrainSelectedInstOperands,
     /*  2180 */     // GIR_Coverage, 2402,
     /*  2180 */     GIR_EraseRootFromParent_Done,
     /*  2181 */   // Label 119: @2181
     /*  2181 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(2238), // Rule ID 840 //
     /*  2186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2221 */     // (add:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt))  =>  (MADDV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_B),
     /*  2224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2226 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2236 */     GIR_RootConstrainSelectedInstOperands,
     /*  2237 */     // GIR_Coverage, 840,
     /*  2237 */     GIR_EraseRootFromParent_Done,
     /*  2238 */   // Label 120: @2238
     /*  2238 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(2261), // Rule ID 507 //
     /*  2243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2254 */     // (add:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_B),
     /*  2259 */     GIR_RootConstrainSelectedInstOperands,
     /*  2260 */     // GIR_Coverage, 507,
     /*  2260 */     GIR_Done,
     /*  2261 */   // Label 121: @2261
     /*  2261 */   GIM_Reject,
     /*  2262 */ // Label 118: @2262
     /*  2262 */ GIM_Reject,
     /*  2263 */ // Label 88: @2263
     /*  2263 */ GIM_Reject,
     /*  2264 */ // Label 1: @2264
     /*  2264 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 130*/ GIMT_Encode4(2954),
     /*  2275 */ /*GILLT_s32*//*Label 122*/ GIMT_Encode4(2307),
     /*  2279 */ /*GILLT_s64*//*Label 123*/ GIMT_Encode4(2484),
     /*  2283 */ /*GILLT_v2s16*//*Label 124*/ GIMT_Encode4(2518),
     /*  2287 */ /*GILLT_v2s64*//*Label 125*/ GIMT_Encode4(2550),
     /*  2291 */ /*GILLT_v4s8*//*Label 126*/ GIMT_Encode4(2643),
     /*  2295 */ /*GILLT_v4s32*//*Label 127*/ GIMT_Encode4(2675),
     /*  2299 */ /*GILLT_v8s16*//*Label 128*/ GIMT_Encode4(2768),
     /*  2303 */ /*GILLT_v16s8*//*Label 129*/ GIMT_Encode4(2861),
     /*  2307 */ // Label 122: @2307
     /*  2307 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(2483),
     /*  2312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  2315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  2318 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2347), // Rule ID 1826 //
     /*  2323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  2326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  2334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2338 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, CPU16Regs:{ *:[i32] }:$r)  =>  (NegRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r)
     /*  2338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NegRxRy16),
     /*  2341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /*  2343 */     GIR_RootToRootCopy, /*OpIdx*/2, // r
     /*  2345 */     GIR_RootConstrainSelectedInstOperands,
     /*  2346 */     // GIR_Coverage, 1826,
     /*  2346 */     GIR_EraseRootFromParent_Done,
     /*  2347 */   // Label 132: @2347
     /*  2347 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2374), // Rule ID 1210 //
     /*  2352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  2355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2367 */     // (sub:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (SUBU16_MMR6:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  2367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBU16_MMR6),
     /*  2372 */     GIR_RootConstrainSelectedInstOperands,
     /*  2373 */     // GIR_Coverage, 1210,
     /*  2373 */     GIR_Done,
     /*  2374 */   // Label 133: @2374
     /*  2374 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2401), // Rule ID 47 //
     /*  2379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  2382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2394 */     // (sub:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  2394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBu),
     /*  2399 */     GIR_RootConstrainSelectedInstOperands,
     /*  2400 */     // GIR_Coverage, 47,
     /*  2400 */     GIR_Done,
     /*  2401 */   // Label 134: @2401
     /*  2401 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2428), // Rule ID 1064 //
     /*  2406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  2409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2421 */     // (sub:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (SUBU16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  2421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBU16_MM),
     /*  2426 */     GIR_RootConstrainSelectedInstOperands,
     /*  2427 */     // GIR_Coverage, 1064,
     /*  2427 */     GIR_Done,
     /*  2428 */   // Label 135: @2428
     /*  2428 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2455), // Rule ID 1073 //
     /*  2433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  2436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2448 */     // (sub:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBu_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  2448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBu_MM),
     /*  2453 */     GIR_RootConstrainSelectedInstOperands,
     /*  2454 */     // GIR_Coverage, 1073,
     /*  2454 */     GIR_Done,
     /*  2455 */   // Label 136: @2455
     /*  2455 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2482), // Rule ID 1831 //
     /*  2460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  2463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2475 */     // (sub:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (SubuRxRyRz16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  2475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SubuRxRyRz16),
     /*  2480 */     GIR_RootConstrainSelectedInstOperands,
     /*  2481 */     // GIR_Coverage, 1831,
     /*  2481 */     GIR_Done,
     /*  2482 */   // Label 137: @2482
     /*  2482 */   GIM_Reject,
     /*  2483 */ // Label 131: @2483
     /*  2483 */ GIM_Reject,
     /*  2484 */ // Label 123: @2484
     /*  2484 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2517), // Rule ID 203 //
     /*  2489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /*  2492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  2495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  2498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  2502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  2506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  2510 */   // (sub:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DSUBu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  2510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSUBu),
     /*  2515 */   GIR_RootConstrainSelectedInstOperands,
     /*  2516 */   // GIR_Coverage, 203,
     /*  2516 */   GIR_Done,
     /*  2517 */ // Label 138: @2517
     /*  2517 */ GIM_Reject,
     /*  2518 */ // Label 124: @2518
     /*  2518 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2549), // Rule ID 1928 //
     /*  2523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  2526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  2529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  2532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  2536 */   // (sub:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (SUBQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /*  2536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBQ_PH),
     /*  2541 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  2547 */   GIR_RootConstrainSelectedInstOperands,
     /*  2548 */   // GIR_Coverage, 1928,
     /*  2548 */   GIR_Done,
     /*  2549 */ // Label 139: @2549
     /*  2549 */ GIM_Reject,
     /*  2550 */ // Label 125: @2550
     /*  2550 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2642),
     /*  2555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  2558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  2561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2569 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2622), // Rule ID 899 //
     /*  2574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  2589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  2593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2605 */     // (sub:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt))  =>  (MSUBV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  2605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_D),
     /*  2608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2610 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2620 */     GIR_RootConstrainSelectedInstOperands,
     /*  2621 */     // GIR_Coverage, 899,
     /*  2621 */     GIR_EraseRootFromParent_Done,
     /*  2622 */   // Label 141: @2622
     /*  2622 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2641), // Rule ID 1028 //
     /*  2627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2634 */     // (sub:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  2634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_D),
     /*  2639 */     GIR_RootConstrainSelectedInstOperands,
     /*  2640 */     // GIR_Coverage, 1028,
     /*  2640 */     GIR_Done,
     /*  2641 */   // Label 142: @2641
     /*  2641 */   GIM_Reject,
     /*  2642 */ // Label 140: @2642
     /*  2642 */ GIM_Reject,
     /*  2643 */ // Label 126: @2643
     /*  2643 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2674), // Rule ID 1934 //
     /*  2648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  2651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  2654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /*  2657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  2661 */   // (sub:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (SUBU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /*  2661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBU_QB),
     /*  2666 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  2672 */   GIR_RootConstrainSelectedInstOperands,
     /*  2673 */   // GIR_Coverage, 1934,
     /*  2673 */   GIR_Done,
     /*  2674 */ // Label 143: @2674
     /*  2674 */ GIM_Reject,
     /*  2675 */ // Label 127: @2675
     /*  2675 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2767),
     /*  2680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  2683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  2686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2694 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2747), // Rule ID 898 //
     /*  2699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  2714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  2718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2730 */     // (sub:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt))  =>  (MSUBV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  2730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_W),
     /*  2733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2735 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2745 */     GIR_RootConstrainSelectedInstOperands,
     /*  2746 */     // GIR_Coverage, 898,
     /*  2746 */     GIR_EraseRootFromParent_Done,
     /*  2747 */   // Label 145: @2747
     /*  2747 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2766), // Rule ID 1027 //
     /*  2752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2759 */     // (sub:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  2759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_W),
     /*  2764 */     GIR_RootConstrainSelectedInstOperands,
     /*  2765 */     // GIR_Coverage, 1027,
     /*  2765 */     GIR_Done,
     /*  2766 */   // Label 146: @2766
     /*  2766 */   GIM_Reject,
     /*  2767 */ // Label 144: @2767
     /*  2767 */ GIM_Reject,
     /*  2768 */ // Label 128: @2768
     /*  2768 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2860),
     /*  2773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2787 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2840), // Rule ID 897 //
     /*  2792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2823 */     // (sub:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt))  =>  (MSUBV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_H),
     /*  2826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2828 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2838 */     GIR_RootConstrainSelectedInstOperands,
     /*  2839 */     // GIR_Coverage, 897,
     /*  2839 */     GIR_EraseRootFromParent_Done,
     /*  2840 */   // Label 148: @2840
     /*  2840 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2859), // Rule ID 1026 //
     /*  2845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2852 */     // (sub:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_H),
     /*  2857 */     GIR_RootConstrainSelectedInstOperands,
     /*  2858 */     // GIR_Coverage, 1026,
     /*  2858 */     GIR_Done,
     /*  2859 */   // Label 149: @2859
     /*  2859 */   GIM_Reject,
     /*  2860 */ // Label 147: @2860
     /*  2860 */ GIM_Reject,
     /*  2861 */ // Label 129: @2861
     /*  2861 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2953),
     /*  2866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2880 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2933), // Rule ID 896 //
     /*  2885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2916 */     // (sub:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt))  =>  (MSUBV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_B),
     /*  2919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2921 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2931 */     GIR_RootConstrainSelectedInstOperands,
     /*  2932 */     // GIR_Coverage, 896,
     /*  2932 */     GIR_EraseRootFromParent_Done,
     /*  2933 */   // Label 151: @2933
     /*  2933 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(2952), // Rule ID 1025 //
     /*  2938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2945 */     // (sub:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_B),
     /*  2950 */     GIR_RootConstrainSelectedInstOperands,
     /*  2951 */     // GIR_Coverage, 1025,
     /*  2951 */     GIR_Done,
     /*  2952 */   // Label 152: @2952
     /*  2952 */   GIM_Reject,
     /*  2953 */ // Label 150: @2953
     /*  2953 */ GIM_Reject,
     /*  2954 */ // Label 130: @2954
     /*  2954 */ GIM_Reject,
     /*  2955 */ // Label 2: @2955
     /*  2955 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 160*/ GIMT_Encode4(3435),
     /*  2966 */ /*GILLT_s32*//*Label 153*/ GIMT_Encode4(2998),
     /*  2970 */ /*GILLT_s64*//*Label 154*/ GIMT_Encode4(3182),
     /*  2974 */ /*GILLT_v2s16*//*Label 155*/ GIMT_Encode4(3267),
     /*  2978 */ /*GILLT_v2s64*//*Label 156*/ GIMT_Encode4(3299), GIMT_Encode4(0),
     /*  2986 */ /*GILLT_v4s32*//*Label 157*/ GIMT_Encode4(3333),
     /*  2990 */ /*GILLT_v8s16*//*Label 158*/ GIMT_Encode4(3367),
     /*  2994 */ /*GILLT_v16s8*//*Label 159*/ GIMT_Encode4(3401),
     /*  2998 */ // Label 153: @2998
     /*  2998 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(3181),
     /*  3003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  3006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  3009 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(3048), // Rule ID 48 //
     /*  3014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /*  3017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3029 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL:{ *:[i32] }:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL),
     /*  3034 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3040 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3046 */     GIR_RootConstrainSelectedInstOperands,
     /*  3047 */     // GIR_Coverage, 48,
     /*  3047 */     GIR_Done,
     /*  3048 */   // Label 162: @3048
     /*  3048 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(3075), // Rule ID 332 //
     /*  3053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  3056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3068 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL_R6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_R6),
     /*  3073 */     GIR_RootConstrainSelectedInstOperands,
     /*  3074 */     // GIR_Coverage, 332,
     /*  3074 */     GIR_Done,
     /*  3075 */   // Label 163: @3075
     /*  3075 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(3114), // Rule ID 1074 //
     /*  3080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  3083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3095 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL_MM:{ *:[i32] }:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_MM),
     /*  3100 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3106 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3112 */     GIR_RootConstrainSelectedInstOperands,
     /*  3113 */     // GIR_Coverage, 1074,
     /*  3113 */     GIR_Done,
     /*  3114 */   // Label 164: @3114
     /*  3114 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(3141), // Rule ID 1179 //
     /*  3119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  3122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3134 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_MMR6),
     /*  3139 */     GIR_RootConstrainSelectedInstOperands,
     /*  3140 */     // GIR_Coverage, 1179,
     /*  3140 */     GIR_Done,
     /*  3141 */   // Label 165: @3141
     /*  3141 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(3180), // Rule ID 1829 //
     /*  3146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  3149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  3153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  3157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  3161 */     // (mul:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (MultRxRyRz16:{ *:[i32] }:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  3161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MultRxRyRz16),
     /*  3166 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3172 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3178 */     GIR_RootConstrainSelectedInstOperands,
     /*  3179 */     // GIR_Coverage, 1829,
     /*  3179 */     GIR_Done,
     /*  3180 */   // Label 166: @3180
     /*  3180 */   GIM_Reject,
     /*  3181 */ // Label 161: @3181
     /*  3181 */ GIM_Reject,
     /*  3182 */ // Label 154: @3182
     /*  3182 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(3266),
     /*  3187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  3190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  3193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3201 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3205 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(3250), // Rule ID 274 //
     /*  3210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /*  3213 */     // (mul:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUL:{ *:[i64] }:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUL),
     /*  3218 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3224 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3230 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::P0), GIMT_Encode2(RegState::Dead),
     /*  3236 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::P1), GIMT_Encode2(RegState::Dead),
     /*  3242 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::P2), GIMT_Encode2(RegState::Dead),
     /*  3248 */     GIR_RootConstrainSelectedInstOperands,
     /*  3249 */     // GIR_Coverage, 274,
     /*  3249 */     GIR_Done,
     /*  3250 */   // Label 168: @3250
     /*  3250 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(3265), // Rule ID 347 //
     /*  3255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  3258 */     // (mul:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUL_R6:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3258 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUL_R6),
     /*  3263 */     GIR_RootConstrainSelectedInstOperands,
     /*  3264 */     // GIR_Coverage, 347,
     /*  3264 */     GIR_Done,
     /*  3265 */   // Label 169: @3265
     /*  3265 */   GIM_Reject,
     /*  3266 */ // Label 167: @3266
     /*  3266 */ GIM_Reject,
     /*  3267 */ // Label 155: @3267
     /*  3267 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3298), // Rule ID 1930 //
     /*  3272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /*  3275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  3278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  3281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  3285 */   // (mul:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (MUL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /*  3285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_PH),
     /*  3290 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag21), GIMT_Encode2(RegState::Dead),
     /*  3296 */   GIR_RootConstrainSelectedInstOperands,
     /*  3297 */   // GIR_Coverage, 1930,
     /*  3297 */   GIR_Done,
     /*  3298 */ // Label 170: @3298
     /*  3298 */ GIM_Reject,
     /*  3299 */ // Label 156: @3299
     /*  3299 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3332), // Rule ID 907 //
     /*  3304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  3310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  3313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3321 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3325 */   // (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MULV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  3325 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_D),
     /*  3330 */   GIR_RootConstrainSelectedInstOperands,
     /*  3331 */   // GIR_Coverage, 907,
     /*  3331 */   GIR_Done,
     /*  3332 */ // Label 171: @3332
     /*  3332 */ GIM_Reject,
     /*  3333 */ // Label 157: @3333
     /*  3333 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3366), // Rule ID 906 //
     /*  3338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  3344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  3347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3359 */   // (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MULV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  3359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_W),
     /*  3364 */   GIR_RootConstrainSelectedInstOperands,
     /*  3365 */   // GIR_Coverage, 906,
     /*  3365 */   GIR_Done,
     /*  3366 */ // Label 172: @3366
     /*  3366 */ GIM_Reject,
     /*  3367 */ // Label 158: @3367
     /*  3367 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3400), // Rule ID 905 //
     /*  3372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  3378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  3381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3393 */   // (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MULV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  3393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_H),
     /*  3398 */   GIR_RootConstrainSelectedInstOperands,
     /*  3399 */   // GIR_Coverage, 905,
     /*  3399 */   GIR_Done,
     /*  3400 */ // Label 173: @3400
     /*  3400 */ GIM_Reject,
     /*  3401 */ // Label 159: @3401
     /*  3401 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(3434), // Rule ID 904 //
     /*  3406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  3412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  3415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3427 */   // (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MULV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  3427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_B),
     /*  3432 */   GIR_RootConstrainSelectedInstOperands,
     /*  3433 */   // GIR_Coverage, 904,
     /*  3433 */   GIR_Done,
     /*  3434 */ // Label 174: @3434
     /*  3434 */ GIM_Reject,
     /*  3435 */ // Label 160: @3435
     /*  3435 */ GIM_Reject,
     /*  3436 */ // Label 3: @3436
     /*  3436 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 181*/ GIMT_Encode4(3704),
     /*  3447 */ /*GILLT_s32*//*Label 175*/ GIMT_Encode4(3479),
     /*  3451 */ /*GILLT_s64*//*Label 176*/ GIMT_Encode4(3534), GIMT_Encode4(0),
     /*  3459 */ /*GILLT_v2s64*//*Label 177*/ GIMT_Encode4(3568), GIMT_Encode4(0),
     /*  3467 */ /*GILLT_v4s32*//*Label 178*/ GIMT_Encode4(3602),
     /*  3471 */ /*GILLT_v8s16*//*Label 179*/ GIMT_Encode4(3636),
     /*  3475 */ /*GILLT_v16s8*//*Label 180*/ GIMT_Encode4(3670),
     /*  3479 */ // Label 175: @3479
     /*  3479 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(3533),
     /*  3484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  3487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  3490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3502 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(3517), // Rule ID 326 //
     /*  3507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  3510 */     // (sdiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV),
     /*  3515 */     GIR_RootConstrainSelectedInstOperands,
     /*  3516 */     // GIR_Coverage, 326,
     /*  3516 */     GIR_Done,
     /*  3517 */   // Label 183: @3517
     /*  3517 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(3532), // Rule ID 1172 //
     /*  3522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  3525 */     // (sdiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIV_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_MMR6),
     /*  3530 */     GIR_RootConstrainSelectedInstOperands,
     /*  3531 */     // GIR_Coverage, 1172,
     /*  3531 */     GIR_Done,
     /*  3532 */   // Label 184: @3532
     /*  3532 */   GIM_Reject,
     /*  3533 */ // Label 182: @3533
     /*  3533 */ GIM_Reject,
     /*  3534 */ // Label 176: @3534
     /*  3534 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3567), // Rule ID 341 //
     /*  3539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  3542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  3545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  3548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3560 */   // (sdiv:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DDIV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DDIV),
     /*  3565 */   GIR_RootConstrainSelectedInstOperands,
     /*  3566 */   // GIR_Coverage, 341,
     /*  3566 */   GIR_Done,
     /*  3567 */ // Label 185: @3567
     /*  3567 */ GIM_Reject,
     /*  3568 */ // Label 177: @3568
     /*  3568 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3601), // Rule ID 647 //
     /*  3573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  3579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  3582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3594 */   // (sdiv:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (DIV_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  3594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_D),
     /*  3599 */   GIR_RootConstrainSelectedInstOperands,
     /*  3600 */   // GIR_Coverage, 647,
     /*  3600 */   GIR_Done,
     /*  3601 */ // Label 186: @3601
     /*  3601 */ GIM_Reject,
     /*  3602 */ // Label 178: @3602
     /*  3602 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3635), // Rule ID 646 //
     /*  3607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  3613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  3616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3628 */   // (sdiv:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DIV_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  3628 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_W),
     /*  3633 */   GIR_RootConstrainSelectedInstOperands,
     /*  3634 */   // GIR_Coverage, 646,
     /*  3634 */   GIR_Done,
     /*  3635 */ // Label 187: @3635
     /*  3635 */ GIM_Reject,
     /*  3636 */ // Label 179: @3636
     /*  3636 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(3669), // Rule ID 645 //
     /*  3641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  3647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  3650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3658 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3662 */   // (sdiv:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DIV_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  3662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_H),
     /*  3667 */   GIR_RootConstrainSelectedInstOperands,
     /*  3668 */   // GIR_Coverage, 645,
     /*  3668 */   GIR_Done,
     /*  3669 */ // Label 188: @3669
     /*  3669 */ GIM_Reject,
     /*  3670 */ // Label 180: @3670
     /*  3670 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(3703), // Rule ID 644 //
     /*  3675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  3681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  3684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3692 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3696 */   // (sdiv:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DIV_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  3696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_B),
     /*  3701 */   GIR_RootConstrainSelectedInstOperands,
     /*  3702 */   // GIR_Coverage, 644,
     /*  3702 */   GIR_Done,
     /*  3703 */ // Label 189: @3703
     /*  3703 */ GIM_Reject,
     /*  3704 */ // Label 181: @3704
     /*  3704 */ GIM_Reject,
     /*  3705 */ // Label 4: @3705
     /*  3705 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 196*/ GIMT_Encode4(3973),
     /*  3716 */ /*GILLT_s32*//*Label 190*/ GIMT_Encode4(3748),
     /*  3720 */ /*GILLT_s64*//*Label 191*/ GIMT_Encode4(3803), GIMT_Encode4(0),
     /*  3728 */ /*GILLT_v2s64*//*Label 192*/ GIMT_Encode4(3837), GIMT_Encode4(0),
     /*  3736 */ /*GILLT_v4s32*//*Label 193*/ GIMT_Encode4(3871),
     /*  3740 */ /*GILLT_v8s16*//*Label 194*/ GIMT_Encode4(3905),
     /*  3744 */ /*GILLT_v16s8*//*Label 195*/ GIMT_Encode4(3939),
     /*  3748 */ // Label 190: @3748
     /*  3748 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(3802),
     /*  3753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  3756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  3759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3771 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(3786), // Rule ID 327 //
     /*  3776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  3779 */     // (udiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIVU:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIVU),
     /*  3784 */     GIR_RootConstrainSelectedInstOperands,
     /*  3785 */     // GIR_Coverage, 327,
     /*  3785 */     GIR_Done,
     /*  3786 */   // Label 198: @3786
     /*  3786 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(3801), // Rule ID 1173 //
     /*  3791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  3794 */     // (udiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIVU_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIVU_MMR6),
     /*  3799 */     GIR_RootConstrainSelectedInstOperands,
     /*  3800 */     // GIR_Coverage, 1173,
     /*  3800 */     GIR_Done,
     /*  3801 */   // Label 199: @3801
     /*  3801 */   GIM_Reject,
     /*  3802 */ // Label 197: @3802
     /*  3802 */ GIM_Reject,
     /*  3803 */ // Label 191: @3803
     /*  3803 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(3836), // Rule ID 342 //
     /*  3808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  3811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  3814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  3817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3829 */   // (udiv:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DDIVU:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DDIVU),
     /*  3834 */   GIR_RootConstrainSelectedInstOperands,
     /*  3835 */   // GIR_Coverage, 342,
     /*  3835 */   GIR_Done,
     /*  3836 */ // Label 200: @3836
     /*  3836 */ GIM_Reject,
     /*  3837 */ // Label 192: @3837
     /*  3837 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(3870), // Rule ID 651 //
     /*  3842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  3848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  3851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3863 */   // (udiv:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (DIV_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  3863 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_D),
     /*  3868 */   GIR_RootConstrainSelectedInstOperands,
     /*  3869 */   // GIR_Coverage, 651,
     /*  3869 */   GIR_Done,
     /*  3870 */ // Label 201: @3870
     /*  3870 */ GIM_Reject,
     /*  3871 */ // Label 193: @3871
     /*  3871 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3904), // Rule ID 650 //
     /*  3876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  3882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  3885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3897 */   // (udiv:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DIV_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  3897 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_W),
     /*  3902 */   GIR_RootConstrainSelectedInstOperands,
     /*  3903 */   // GIR_Coverage, 650,
     /*  3903 */   GIR_Done,
     /*  3904 */ // Label 202: @3904
     /*  3904 */ GIM_Reject,
     /*  3905 */ // Label 194: @3905
     /*  3905 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(3938), // Rule ID 649 //
     /*  3910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  3916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  3919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3931 */   // (udiv:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DIV_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  3931 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_H),
     /*  3936 */   GIR_RootConstrainSelectedInstOperands,
     /*  3937 */   // GIR_Coverage, 649,
     /*  3937 */   GIR_Done,
     /*  3938 */ // Label 203: @3938
     /*  3938 */ GIM_Reject,
     /*  3939 */ // Label 195: @3939
     /*  3939 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(3972), // Rule ID 648 //
     /*  3944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  3950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  3953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3965 */   // (udiv:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DIV_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  3965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_B),
     /*  3970 */   GIR_RootConstrainSelectedInstOperands,
     /*  3971 */   // GIR_Coverage, 648,
     /*  3971 */   GIR_Done,
     /*  3972 */ // Label 204: @3972
     /*  3972 */ GIM_Reject,
     /*  3973 */ // Label 196: @3973
     /*  3973 */ GIM_Reject,
     /*  3974 */ // Label 5: @3974
     /*  3974 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 211*/ GIMT_Encode4(4242),
     /*  3985 */ /*GILLT_s32*//*Label 205*/ GIMT_Encode4(4017),
     /*  3989 */ /*GILLT_s64*//*Label 206*/ GIMT_Encode4(4072), GIMT_Encode4(0),
     /*  3997 */ /*GILLT_v2s64*//*Label 207*/ GIMT_Encode4(4106), GIMT_Encode4(0),
     /*  4005 */ /*GILLT_v4s32*//*Label 208*/ GIMT_Encode4(4140),
     /*  4009 */ /*GILLT_v8s16*//*Label 209*/ GIMT_Encode4(4174),
     /*  4013 */ /*GILLT_v16s8*//*Label 210*/ GIMT_Encode4(4208),
     /*  4017 */ // Label 205: @4017
     /*  4017 */ GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(4071),
     /*  4022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  4025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  4028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4040 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(4055), // Rule ID 328 //
     /*  4045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  4048 */     // (srem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MOD:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD),
     /*  4053 */     GIR_RootConstrainSelectedInstOperands,
     /*  4054 */     // GIR_Coverage, 328,
     /*  4054 */     GIR_Done,
     /*  4055 */   // Label 213: @4055
     /*  4055 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(4070), // Rule ID 1177 //
     /*  4060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4063 */     // (srem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MOD_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_MMR6),
     /*  4068 */     GIR_RootConstrainSelectedInstOperands,
     /*  4069 */     // GIR_Coverage, 1177,
     /*  4069 */     GIR_Done,
     /*  4070 */   // Label 214: @4070
     /*  4070 */   GIM_Reject,
     /*  4071 */ // Label 212: @4071
     /*  4071 */ GIM_Reject,
     /*  4072 */ // Label 206: @4072
     /*  4072 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(4105), // Rule ID 343 //
     /*  4077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  4080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  4083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  4086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4098 */   // (srem:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMOD:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMOD),
     /*  4103 */   GIR_RootConstrainSelectedInstOperands,
     /*  4104 */   // GIR_Coverage, 343,
     /*  4104 */   GIR_Done,
     /*  4105 */ // Label 215: @4105
     /*  4105 */ GIM_Reject,
     /*  4106 */ // Label 207: @4106
     /*  4106 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(4139), // Rule ID 887 //
     /*  4111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  4117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  4120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4132 */   // (srem:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MOD_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  4132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_D),
     /*  4137 */   GIR_RootConstrainSelectedInstOperands,
     /*  4138 */   // GIR_Coverage, 887,
     /*  4138 */   GIR_Done,
     /*  4139 */ // Label 216: @4139
     /*  4139 */ GIM_Reject,
     /*  4140 */ // Label 208: @4140
     /*  4140 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(4173), // Rule ID 886 //
     /*  4145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  4151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  4154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4162 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4166 */   // (srem:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MOD_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  4166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_W),
     /*  4171 */   GIR_RootConstrainSelectedInstOperands,
     /*  4172 */   // GIR_Coverage, 886,
     /*  4172 */   GIR_Done,
     /*  4173 */ // Label 217: @4173
     /*  4173 */ GIM_Reject,
     /*  4174 */ // Label 209: @4174
     /*  4174 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(4207), // Rule ID 885 //
     /*  4179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  4185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  4188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4200 */   // (srem:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MOD_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  4200 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_H),
     /*  4205 */   GIR_RootConstrainSelectedInstOperands,
     /*  4206 */   // GIR_Coverage, 885,
     /*  4206 */   GIR_Done,
     /*  4207 */ // Label 218: @4207
     /*  4207 */ GIM_Reject,
     /*  4208 */ // Label 210: @4208
     /*  4208 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(4241), // Rule ID 884 //
     /*  4213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  4219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  4222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4234 */   // (srem:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MOD_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  4234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_B),
     /*  4239 */   GIR_RootConstrainSelectedInstOperands,
     /*  4240 */   // GIR_Coverage, 884,
     /*  4240 */   GIR_Done,
     /*  4241 */ // Label 219: @4241
     /*  4241 */ GIM_Reject,
     /*  4242 */ // Label 211: @4242
     /*  4242 */ GIM_Reject,
     /*  4243 */ // Label 6: @4243
     /*  4243 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 226*/ GIMT_Encode4(4511),
     /*  4254 */ /*GILLT_s32*//*Label 220*/ GIMT_Encode4(4286),
     /*  4258 */ /*GILLT_s64*//*Label 221*/ GIMT_Encode4(4341), GIMT_Encode4(0),
     /*  4266 */ /*GILLT_v2s64*//*Label 222*/ GIMT_Encode4(4375), GIMT_Encode4(0),
     /*  4274 */ /*GILLT_v4s32*//*Label 223*/ GIMT_Encode4(4409),
     /*  4278 */ /*GILLT_v8s16*//*Label 224*/ GIMT_Encode4(4443),
     /*  4282 */ /*GILLT_v16s8*//*Label 225*/ GIMT_Encode4(4477),
     /*  4286 */ // Label 220: @4286
     /*  4286 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(4340),
     /*  4291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  4294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  4297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4309 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(4324), // Rule ID 329 //
     /*  4314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  4317 */     // (urem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODU:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MODU),
     /*  4322 */     GIR_RootConstrainSelectedInstOperands,
     /*  4323 */     // GIR_Coverage, 329,
     /*  4323 */     GIR_Done,
     /*  4324 */   // Label 228: @4324
     /*  4324 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(4339), // Rule ID 1178 //
     /*  4329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4332 */     // (urem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODU_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MODU_MMR6),
     /*  4337 */     GIR_RootConstrainSelectedInstOperands,
     /*  4338 */     // GIR_Coverage, 1178,
     /*  4338 */     GIR_Done,
     /*  4339 */   // Label 229: @4339
     /*  4339 */   GIM_Reject,
     /*  4340 */ // Label 227: @4340
     /*  4340 */ GIM_Reject,
     /*  4341 */ // Label 221: @4341
     /*  4341 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(4374), // Rule ID 344 //
     /*  4346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  4349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  4352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  4355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4367 */   // (urem:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMODU:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMODU),
     /*  4372 */   GIR_RootConstrainSelectedInstOperands,
     /*  4373 */   // GIR_Coverage, 344,
     /*  4373 */   GIR_Done,
     /*  4374 */ // Label 230: @4374
     /*  4374 */ GIM_Reject,
     /*  4375 */ // Label 222: @4375
     /*  4375 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(4408), // Rule ID 891 //
     /*  4380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  4386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  4389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4401 */   // (urem:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MOD_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  4401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_D),
     /*  4406 */   GIR_RootConstrainSelectedInstOperands,
     /*  4407 */   // GIR_Coverage, 891,
     /*  4407 */   GIR_Done,
     /*  4408 */ // Label 231: @4408
     /*  4408 */ GIM_Reject,
     /*  4409 */ // Label 223: @4409
     /*  4409 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(4442), // Rule ID 890 //
     /*  4414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  4420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  4423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4435 */   // (urem:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MOD_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  4435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_W),
     /*  4440 */   GIR_RootConstrainSelectedInstOperands,
     /*  4441 */   // GIR_Coverage, 890,
     /*  4441 */   GIR_Done,
     /*  4442 */ // Label 232: @4442
     /*  4442 */ GIM_Reject,
     /*  4443 */ // Label 224: @4443
     /*  4443 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(4476), // Rule ID 889 //
     /*  4448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  4454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  4457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4469 */   // (urem:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MOD_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  4469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_H),
     /*  4474 */   GIR_RootConstrainSelectedInstOperands,
     /*  4475 */   // GIR_Coverage, 889,
     /*  4475 */   GIR_Done,
     /*  4476 */ // Label 233: @4476
     /*  4476 */ GIM_Reject,
     /*  4477 */ // Label 225: @4477
     /*  4477 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(4510), // Rule ID 888 //
     /*  4482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  4488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  4491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4503 */   // (urem:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MOD_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  4503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_B),
     /*  4508 */   GIR_RootConstrainSelectedInstOperands,
     /*  4509 */   // GIR_Coverage, 888,
     /*  4509 */   GIR_Done,
     /*  4510 */ // Label 234: @4510
     /*  4510 */ GIM_Reject,
     /*  4511 */ // Label 226: @4511
     /*  4511 */ GIM_Reject,
     /*  4512 */ // Label 7: @4512
     /*  4512 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 241*/ GIMT_Encode4(5067),
     /*  4523 */ /*GILLT_s32*//*Label 235*/ GIMT_Encode4(4555),
     /*  4527 */ /*GILLT_s64*//*Label 236*/ GIMT_Encode4(4829), GIMT_Encode4(0),
     /*  4535 */ /*GILLT_v2s64*//*Label 237*/ GIMT_Encode4(4931), GIMT_Encode4(0),
     /*  4543 */ /*GILLT_v4s32*//*Label 238*/ GIMT_Encode4(4965),
     /*  4547 */ /*GILLT_v8s16*//*Label 239*/ GIMT_Encode4(4999),
     /*  4551 */ /*GILLT_v16s8*//*Label 240*/ GIMT_Encode4(5033),
     /*  4555 */ // Label 235: @4555
     /*  4555 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(4828),
     /*  4560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  4563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  4566 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(4608), // Rule ID 41 //
     /*  4571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  4574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4590 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32ZExt16),
     /*  4594 */     // MIs[1] Operand 1
     /*  4594 */     // No operand predicates
     /*  4594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4596 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32ZExt16>>:$imm16)  =>  (ANDi:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  4596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ANDi),
     /*  4599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  4601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  4603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  4606 */     GIR_RootConstrainSelectedInstOperands,
     /*  4607 */     // GIR_Coverage, 41,
     /*  4607 */     GIR_EraseRootFromParent_Done,
     /*  4608 */   // Label 243: @4608
     /*  4608 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(4650), // Rule ID 2172 //
     /*  4613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  4616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExtAndi16),
     /*  4636 */     // MIs[1] Operand 1
     /*  4636 */     // No operand predicates
     /*  4636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4638 */     // (and:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)  =>  (ANDI16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)
     /*  4638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ANDI16_MM),
     /*  4641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  4643 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  4645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  4648 */     GIR_RootConstrainSelectedInstOperands,
     /*  4649 */     // GIR_Coverage, 2172,
     /*  4649 */     GIR_EraseRootFromParent_Done,
     /*  4650 */   // Label 244: @4650
     /*  4650 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(4692), // Rule ID 2331 //
     /*  4655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExtAndi16),
     /*  4678 */     // MIs[1] Operand 1
     /*  4678 */     // No operand predicates
     /*  4678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4680 */     // (and:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)  =>  (ANDI16_MMR6:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)
     /*  4680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ANDI16_MMR6),
     /*  4683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  4685 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  4687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  4690 */     GIR_RootConstrainSelectedInstOperands,
     /*  4691 */     // GIR_Coverage, 2331,
     /*  4691 */     GIR_EraseRootFromParent_Done,
     /*  4692 */   // Label 245: @4692
     /*  4692 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(4719), // Rule ID 51 //
     /*  4697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  4700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4712 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (AND:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND),
     /*  4717 */     GIR_RootConstrainSelectedInstOperands,
     /*  4718 */     // GIR_Coverage, 51,
     /*  4718 */     GIR_Done,
     /*  4719 */   // Label 246: @4719
     /*  4719 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(4746), // Rule ID 1061 //
     /*  4724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  4727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4739 */     // (and:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (AND16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  4739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND16_MM),
     /*  4744 */     GIR_RootConstrainSelectedInstOperands,
     /*  4745 */     // GIR_Coverage, 1061,
     /*  4745 */     GIR_Done,
     /*  4746 */   // Label 247: @4746
     /*  4746 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(4773), // Rule ID 1077 //
     /*  4751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  4754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4766 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (AND_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_MM),
     /*  4771 */     GIR_RootConstrainSelectedInstOperands,
     /*  4772 */     // GIR_Coverage, 1077,
     /*  4772 */     GIR_Done,
     /*  4773 */   // Label 248: @4773
     /*  4773 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(4800), // Rule ID 1170 //
     /*  4778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4793 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (AND_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_MMR6),
     /*  4798 */     GIR_RootConstrainSelectedInstOperands,
     /*  4799 */     // GIR_Coverage, 1170,
     /*  4799 */     GIR_Done,
     /*  4800 */   // Label 249: @4800
     /*  4800 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(4827), // Rule ID 1828 //
     /*  4805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  4808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  4812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  4816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  4820 */     // (and:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (AndRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  4820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AndRxRxRy16),
     /*  4825 */     GIR_RootConstrainSelectedInstOperands,
     /*  4826 */     // GIR_Coverage, 1828,
     /*  4826 */     GIR_Done,
     /*  4827 */   // Label 250: @4827
     /*  4827 */   GIM_Reject,
     /*  4828 */ // Label 242: @4828
     /*  4828 */ GIM_Reject,
     /*  4829 */ // Label 236: @4829
     /*  4829 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(4930),
     /*  4834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  4837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  4840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4844 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(4906), // Rule ID 269 //
     /*  4849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /*  4852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  4856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  4860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  4864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  4868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4878 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  4889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4891 */     // (and:{ *:[i64] } (add:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt), 255:{ *:[i64] })  =>  (BADDu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BADDu),
     /*  4894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  4896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  4900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  4904 */     GIR_RootConstrainSelectedInstOperands,
     /*  4905 */     // GIR_Coverage, 269,
     /*  4905 */     GIR_EraseRootFromParent_Done,
     /*  4906 */   // Label 252: @4906
     /*  4906 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(4929), // Rule ID 206 //
     /*  4911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  4914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4922 */     // (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (AND64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4922 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND64),
     /*  4927 */     GIR_RootConstrainSelectedInstOperands,
     /*  4928 */     // GIR_Coverage, 206,
     /*  4928 */     GIR_Done,
     /*  4929 */   // Label 253: @4929
     /*  4929 */   GIM_Reject,
     /*  4930 */ // Label 251: @4930
     /*  4930 */ GIM_Reject,
     /*  4931 */ // Label 237: @4931
     /*  4931 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(4964), // Rule ID 518 //
     /*  4936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  4942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  4945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4957 */   // (and:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AND_V_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  4957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V_D_PSEUDO),
     /*  4962 */   GIR_RootConstrainSelectedInstOperands,
     /*  4963 */   // GIR_Coverage, 518,
     /*  4963 */   GIR_Done,
     /*  4964 */ // Label 254: @4964
     /*  4964 */ GIM_Reject,
     /*  4965 */ // Label 238: @4965
     /*  4965 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(4998), // Rule ID 517 //
     /*  4970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  4976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  4979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4991 */   // (and:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AND_V_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  4991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V_W_PSEUDO),
     /*  4996 */   GIR_RootConstrainSelectedInstOperands,
     /*  4997 */   // GIR_Coverage, 517,
     /*  4997 */   GIR_Done,
     /*  4998 */ // Label 255: @4998
     /*  4998 */ GIM_Reject,
     /*  4999 */ // Label 239: @4999
     /*  4999 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(5032), // Rule ID 516 //
     /*  5004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  5010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  5013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5025 */   // (and:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AND_V_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  5025 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V_H_PSEUDO),
     /*  5030 */   GIR_RootConstrainSelectedInstOperands,
     /*  5031 */   // GIR_Coverage, 516,
     /*  5031 */   GIR_Done,
     /*  5032 */ // Label 256: @5032
     /*  5032 */ GIM_Reject,
     /*  5033 */ // Label 240: @5033
     /*  5033 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(5066), // Rule ID 515 //
     /*  5038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  5044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  5047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5059 */   // (and:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AND_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  5059 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V),
     /*  5064 */   GIR_RootConstrainSelectedInstOperands,
     /*  5065 */   // GIR_Coverage, 515,
     /*  5065 */   GIR_Done,
     /*  5066 */ // Label 257: @5066
     /*  5066 */ GIM_Reject,
     /*  5067 */ // Label 241: @5067
     /*  5067 */ GIM_Reject,
     /*  5068 */ // Label 8: @5068
     /*  5068 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 264*/ GIMT_Encode4(5471),
     /*  5079 */ /*GILLT_s32*//*Label 258*/ GIMT_Encode4(5111),
     /*  5083 */ /*GILLT_s64*//*Label 259*/ GIMT_Encode4(5301), GIMT_Encode4(0),
     /*  5091 */ /*GILLT_v2s64*//*Label 260*/ GIMT_Encode4(5335), GIMT_Encode4(0),
     /*  5099 */ /*GILLT_v4s32*//*Label 261*/ GIMT_Encode4(5369),
     /*  5103 */ /*GILLT_v8s16*//*Label 262*/ GIMT_Encode4(5403),
     /*  5107 */ /*GILLT_v16s8*//*Label 263*/ GIMT_Encode4(5437),
     /*  5111 */ // Label 258: @5111
     /*  5111 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(5300),
     /*  5116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  5119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  5122 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(5164), // Rule ID 42 //
     /*  5127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  5142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  5146 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32ZExt16),
     /*  5150 */     // MIs[1] Operand 1
     /*  5150 */     // No operand predicates
     /*  5150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5152 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32ZExt16>>:$imm16)  =>  (ORi:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  5152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ORi),
     /*  5155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  5162 */     GIR_RootConstrainSelectedInstOperands,
     /*  5163 */     // GIR_Coverage, 42,
     /*  5163 */     GIR_EraseRootFromParent_Done,
     /*  5164 */   // Label 266: @5164
     /*  5164 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(5191), // Rule ID 52 //
     /*  5169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5184 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (OR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR),
     /*  5189 */     GIR_RootConstrainSelectedInstOperands,
     /*  5190 */     // GIR_Coverage, 52,
     /*  5190 */     GIR_Done,
     /*  5191 */   // Label 267: @5191
     /*  5191 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(5218), // Rule ID 1063 //
     /*  5196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5211 */     // (or:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (OR16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  5211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR16_MM),
     /*  5216 */     GIR_RootConstrainSelectedInstOperands,
     /*  5217 */     // GIR_Coverage, 1063,
     /*  5217 */     GIR_Done,
     /*  5218 */   // Label 268: @5218
     /*  5218 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(5245), // Rule ID 1078 //
     /*  5223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5238 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (OR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_MM),
     /*  5243 */     GIR_RootConstrainSelectedInstOperands,
     /*  5244 */     // GIR_Coverage, 1078,
     /*  5244 */     GIR_Done,
     /*  5245 */   // Label 269: @5245
     /*  5245 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(5272), // Rule ID 1183 //
     /*  5250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5265 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (OR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_MMR6),
     /*  5270 */     GIR_RootConstrainSelectedInstOperands,
     /*  5271 */     // GIR_Coverage, 1183,
     /*  5271 */     GIR_Done,
     /*  5272 */   // Label 270: @5272
     /*  5272 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(5299), // Rule ID 1830 //
     /*  5277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  5280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5292 */     // (or:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (OrRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  5292 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OrRxRxRy16),
     /*  5297 */     GIR_RootConstrainSelectedInstOperands,
     /*  5298 */     // GIR_Coverage, 1830,
     /*  5298 */     GIR_Done,
     /*  5299 */   // Label 271: @5299
     /*  5299 */   GIM_Reject,
     /*  5300 */ // Label 265: @5300
     /*  5300 */ GIM_Reject,
     /*  5301 */ // Label 259: @5301
     /*  5301 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(5334), // Rule ID 207 //
     /*  5306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  5309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  5312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  5315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  5319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  5323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  5327 */   // (or:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (OR64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  5327 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR64),
     /*  5332 */   GIR_RootConstrainSelectedInstOperands,
     /*  5333 */   // GIR_Coverage, 207,
     /*  5333 */   GIR_Done,
     /*  5334 */ // Label 272: @5334
     /*  5334 */ GIM_Reject,
     /*  5335 */ // Label 260: @5335
     /*  5335 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(5368), // Rule ID 924 //
     /*  5340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  5346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  5349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  5353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  5357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  5361 */   // (or:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (OR_V_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  5361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V_D_PSEUDO),
     /*  5366 */   GIR_RootConstrainSelectedInstOperands,
     /*  5367 */   // GIR_Coverage, 924,
     /*  5367 */   GIR_Done,
     /*  5368 */ // Label 273: @5368
     /*  5368 */ GIM_Reject,
     /*  5369 */ // Label 261: @5369
     /*  5369 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(5402), // Rule ID 923 //
     /*  5374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  5380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  5383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  5387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  5391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  5395 */   // (or:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (OR_V_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  5395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V_W_PSEUDO),
     /*  5400 */   GIR_RootConstrainSelectedInstOperands,
     /*  5401 */   // GIR_Coverage, 923,
     /*  5401 */   GIR_Done,
     /*  5402 */ // Label 274: @5402
     /*  5402 */ GIM_Reject,
     /*  5403 */ // Label 262: @5403
     /*  5403 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(5436), // Rule ID 922 //
     /*  5408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  5414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  5417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5429 */   // (or:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (OR_V_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  5429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V_H_PSEUDO),
     /*  5434 */   GIR_RootConstrainSelectedInstOperands,
     /*  5435 */   // GIR_Coverage, 922,
     /*  5435 */   GIR_Done,
     /*  5436 */ // Label 275: @5436
     /*  5436 */ GIM_Reject,
     /*  5437 */ // Label 263: @5437
     /*  5437 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(5470), // Rule ID 921 //
     /*  5442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  5448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  5451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5463 */   // (or:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (OR_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  5463 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V),
     /*  5468 */   GIR_RootConstrainSelectedInstOperands,
     /*  5469 */   // GIR_Coverage, 921,
     /*  5469 */   GIR_Done,
     /*  5470 */ // Label 276: @5470
     /*  5470 */ GIM_Reject,
     /*  5471 */ // Label 264: @5471
     /*  5471 */ GIM_Reject,
     /*  5472 */ // Label 9: @5472
     /*  5472 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 283*/ GIMT_Encode4(6363),
     /*  5483 */ /*GILLT_s32*//*Label 277*/ GIMT_Encode4(5515),
     /*  5487 */ /*GILLT_s64*//*Label 278*/ GIMT_Encode4(6132), GIMT_Encode4(0),
     /*  5495 */ /*GILLT_v2s64*//*Label 279*/ GIMT_Encode4(6227), GIMT_Encode4(0),
     /*  5503 */ /*GILLT_v4s32*//*Label 280*/ GIMT_Encode4(6261),
     /*  5507 */ /*GILLT_v8s16*//*Label 281*/ GIMT_Encode4(6295),
     /*  5511 */ /*GILLT_v16s8*//*Label 282*/ GIMT_Encode4(6329),
     /*  5515 */ // Label 277: @5515
     /*  5515 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(6131),
     /*  5520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  5523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  5526 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(5585), // Rule ID 54 //
     /*  5531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  5542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  5546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  5550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  5554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5570 */     // (xor:{ *:[i32] } (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt), -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /*  5573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  5579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  5583 */     GIR_RootConstrainSelectedInstOperands,
     /*  5584 */     // GIR_Coverage, 54,
     /*  5584 */     GIR_EraseRootFromParent_Done,
     /*  5585 */   // Label 285: @5585
     /*  5585 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(5644), // Rule ID 1080 //
     /*  5590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  5601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  5605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  5609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  5613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5629 */     // (xor:{ *:[i32] } (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt), -1:{ *:[i32] })  =>  (NOR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MM),
     /*  5632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  5638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  5642 */     GIR_RootConstrainSelectedInstOperands,
     /*  5643 */     // GIR_Coverage, 1080,
     /*  5643 */     GIR_EraseRootFromParent_Done,
     /*  5644 */   // Label 286: @5644
     /*  5644 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(5703), // Rule ID 1182 //
     /*  5649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  5660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  5664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  5668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  5672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5682 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5688 */     // (xor:{ *:[i32] } (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt), -1:{ *:[i32] })  =>  (NOR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /*  5691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  5697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  5701 */     GIR_RootConstrainSelectedInstOperands,
     /*  5702 */     // GIR_Coverage, 1182,
     /*  5702 */     GIR_EraseRootFromParent_Done,
     /*  5703 */   // Label 287: @5703
     /*  5703 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(5732), // Rule ID 1209 //
     /*  5708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5723 */     // (xor:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] })  =>  (NOT16_MMR6:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs)
     /*  5723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MMR6),
     /*  5726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5730 */     GIR_RootConstrainSelectedInstOperands,
     /*  5731 */     // GIR_Coverage, 1209,
     /*  5731 */     GIR_EraseRootFromParent_Done,
     /*  5732 */   // Label 288: @5732
     /*  5732 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(5761), // Rule ID 1062 //
     /*  5737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5752 */     // (xor:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] })  =>  (NOT16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs)
     /*  5752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MM),
     /*  5755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5759 */     GIR_RootConstrainSelectedInstOperands,
     /*  5760 */     // GIR_Coverage, 1062,
     /*  5760 */     GIR_EraseRootFromParent_Done,
     /*  5761 */   // Label 289: @5761
     /*  5761 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(5796), // Rule ID 1397 //
     /*  5766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5781 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$in, ZERO:{ *:[i32] })
     /*  5781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /*  5784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5786 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  5794 */     GIR_RootConstrainSelectedInstOperands,
     /*  5795 */     // GIR_Coverage, 1397,
     /*  5795 */     GIR_EraseRootFromParent_Done,
     /*  5796 */   // Label 290: @5796
     /*  5796 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(5825), // Rule ID 1825 //
     /*  5801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  5804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5816 */     // (xor:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, -1:{ *:[i32] })  =>  (NotRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r)
     /*  5816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NotRxRy16),
     /*  5819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /*  5821 */     GIR_RootToRootCopy, /*OpIdx*/1, // r
     /*  5823 */     GIR_RootConstrainSelectedInstOperands,
     /*  5824 */     // GIR_Coverage, 1825,
     /*  5824 */     GIR_EraseRootFromParent_Done,
     /*  5825 */   // Label 291: @5825
     /*  5825 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(5854), // Rule ID 2167 //
     /*  5830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  5833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5845 */     // (xor:{ *:[i32] } GPRMM16:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOT16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$in)
     /*  5845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MM),
     /*  5848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5850 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5852 */     GIR_RootConstrainSelectedInstOperands,
     /*  5853 */     // GIR_Coverage, 2167,
     /*  5853 */     GIR_EraseRootFromParent_Done,
     /*  5854 */   // Label 292: @5854
     /*  5854 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(5889), // Rule ID 2168 //
     /*  5859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  5862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5874 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$in, ZERO:{ *:[i32] })
     /*  5874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MM),
     /*  5877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5879 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5881 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  5887 */     GIR_RootConstrainSelectedInstOperands,
     /*  5888 */     // GIR_Coverage, 2168,
     /*  5888 */     GIR_EraseRootFromParent_Done,
     /*  5889 */   // Label 293: @5889
     /*  5889 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(5918), // Rule ID 2334 //
     /*  5894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5909 */     // (xor:{ *:[i32] } GPRMM16:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOT16_MMR6:{ *:[i32] } GPRMM16:{ *:[i32] }:$in)
     /*  5909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MMR6),
     /*  5912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5914 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5916 */     GIR_RootConstrainSelectedInstOperands,
     /*  5917 */     // GIR_Coverage, 2334,
     /*  5917 */     GIR_EraseRootFromParent_Done,
     /*  5918 */   // Label 294: @5918
     /*  5918 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(5953), // Rule ID 2335 //
     /*  5923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5938 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$in, ZERO:{ *:[i32] })
     /*  5938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /*  5941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5943 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  5951 */     GIR_RootConstrainSelectedInstOperands,
     /*  5952 */     // GIR_Coverage, 2335,
     /*  5952 */     GIR_EraseRootFromParent_Done,
     /*  5953 */   // Label 295: @5953
     /*  5953 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(5995), // Rule ID 43 //
     /*  5958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  5973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  5977 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32ZExt16),
     /*  5981 */     // MIs[1] Operand 1
     /*  5981 */     // No operand predicates
     /*  5981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5983 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32ZExt16>>:$imm16)  =>  (XORi:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  5983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /*  5986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  5993 */     GIR_RootConstrainSelectedInstOperands,
     /*  5994 */     // GIR_Coverage, 43,
     /*  5994 */     GIR_EraseRootFromParent_Done,
     /*  5995 */   // Label 296: @5995
     /*  5995 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(6022), // Rule ID 53 //
     /*  6000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  6003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6015 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (XOR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  6015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /*  6020 */     GIR_RootConstrainSelectedInstOperands,
     /*  6021 */     // GIR_Coverage, 53,
     /*  6021 */     GIR_Done,
     /*  6022 */   // Label 297: @6022
     /*  6022 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(6049), // Rule ID 1065 //
     /*  6027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  6030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  6034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  6038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  6042 */     // (xor:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (XOR16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  6042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR16_MM),
     /*  6047 */     GIR_RootConstrainSelectedInstOperands,
     /*  6048 */     // GIR_Coverage, 1065,
     /*  6048 */     GIR_Done,
     /*  6049 */   // Label 298: @6049
     /*  6049 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(6076), // Rule ID 1079 //
     /*  6054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  6057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6069 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (XOR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  6069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /*  6074 */     GIR_RootConstrainSelectedInstOperands,
     /*  6075 */     // GIR_Coverage, 1079,
     /*  6075 */     GIR_Done,
     /*  6076 */   // Label 299: @6076
     /*  6076 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(6103), // Rule ID 1186 //
     /*  6081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  6084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6096 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (XOR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  6096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_MMR6),
     /*  6101 */     GIR_RootConstrainSelectedInstOperands,
     /*  6102 */     // GIR_Coverage, 1186,
     /*  6102 */     GIR_Done,
     /*  6103 */   // Label 300: @6103
     /*  6103 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(6130), // Rule ID 1832 //
     /*  6108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  6111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  6115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  6119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  6123 */     // (xor:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (XorRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  6123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /*  6128 */     GIR_RootConstrainSelectedInstOperands,
     /*  6129 */     // GIR_Coverage, 1832,
     /*  6129 */     GIR_Done,
     /*  6130 */   // Label 301: @6130
     /*  6130 */   GIM_Reject,
     /*  6131 */ // Label 284: @6131
     /*  6131 */ GIM_Reject,
     /*  6132 */ // Label 278: @6132
     /*  6132 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(6226),
     /*  6137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  6140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  6143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6147 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(6202), // Rule ID 209 //
     /*  6152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  6155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  6159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  6163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  6167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  6171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  6185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  6187 */     // (xor:{ *:[i64] } (or:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt), -1:{ *:[i64] })  =>  (NOR64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  6187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR64),
     /*  6190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  6192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  6196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  6200 */     GIR_RootConstrainSelectedInstOperands,
     /*  6201 */     // GIR_Coverage, 209,
     /*  6201 */     GIR_EraseRootFromParent_Done,
     /*  6202 */   // Label 303: @6202
     /*  6202 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(6225), // Rule ID 208 //
     /*  6207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  6210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6218 */     // (xor:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (XOR64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  6218 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /*  6223 */     GIR_RootConstrainSelectedInstOperands,
     /*  6224 */     // GIR_Coverage, 208,
     /*  6224 */     GIR_Done,
     /*  6225 */   // Label 304: @6225
     /*  6225 */   GIM_Reject,
     /*  6226 */ // Label 302: @6226
     /*  6226 */ GIM_Reject,
     /*  6227 */ // Label 279: @6227
     /*  6227 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(6260), // Rule ID 1040 //
     /*  6232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  6238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  6241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6253 */   // (xor:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (XOR_V_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  6253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V_D_PSEUDO),
     /*  6258 */   GIR_RootConstrainSelectedInstOperands,
     /*  6259 */   // GIR_Coverage, 1040,
     /*  6259 */   GIR_Done,
     /*  6260 */ // Label 305: @6260
     /*  6260 */ GIM_Reject,
     /*  6261 */ // Label 280: @6261
     /*  6261 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(6294), // Rule ID 1039 //
     /*  6266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  6272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  6275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6287 */   // (xor:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (XOR_V_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  6287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V_W_PSEUDO),
     /*  6292 */   GIR_RootConstrainSelectedInstOperands,
     /*  6293 */   // GIR_Coverage, 1039,
     /*  6293 */   GIR_Done,
     /*  6294 */ // Label 306: @6294
     /*  6294 */ GIM_Reject,
     /*  6295 */ // Label 281: @6295
     /*  6295 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(6328), // Rule ID 1038 //
     /*  6300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  6306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  6309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6321 */   // (xor:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (XOR_V_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  6321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V_H_PSEUDO),
     /*  6326 */   GIR_RootConstrainSelectedInstOperands,
     /*  6327 */   // GIR_Coverage, 1038,
     /*  6327 */   GIR_Done,
     /*  6328 */ // Label 307: @6328
     /*  6328 */ GIM_Reject,
     /*  6329 */ // Label 282: @6329
     /*  6329 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(6362), // Rule ID 1037 //
     /*  6334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  6340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  6343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6355 */   // (xor:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (XOR_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  6355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V),
     /*  6360 */   GIR_RootConstrainSelectedInstOperands,
     /*  6361 */   // GIR_Coverage, 1037,
     /*  6361 */   GIR_Done,
     /*  6362 */ // Label 308: @6362
     /*  6362 */ GIM_Reject,
     /*  6363 */ // Label 283: @6363
     /*  6363 */ GIM_Reject,
     /*  6364 */ // Label 10: @6364
     /*  6364 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(6436),
     /*  6369 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  6372 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  6375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  6381 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(6408), // Rule ID 180 //
     /*  6386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotSoftFloat_NotFP64bit_NotInMips16Mode),
     /*  6389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /*  6393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6401 */     // (MipsBuildPairF64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)  =>  (BuildPairF64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)
     /*  6401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BuildPairF64),
     /*  6406 */     GIR_RootConstrainSelectedInstOperands,
     /*  6407 */     // GIR_Coverage, 180,
     /*  6407 */     GIR_Done,
     /*  6408 */   // Label 310: @6408
     /*  6408 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(6435), // Rule ID 181 //
     /*  6413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit_IsNotSoftFloat_NotInMips16Mode),
     /*  6416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  6420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6428 */     // (MipsBuildPairF64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)  =>  (BuildPairF64_64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)
     /*  6428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BuildPairF64_64),
     /*  6433 */     GIR_RootConstrainSelectedInstOperands,
     /*  6434 */     // GIR_Coverage, 181,
     /*  6434 */     GIR_Done,
     /*  6435 */   // Label 311: @6435
     /*  6435 */   GIM_Reject,
     /*  6436 */ // Label 309: @6436
     /*  6436 */ GIM_Reject,
     /*  6437 */ // Label 11: @6437
     /*  6437 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(6508),
     /*  6442 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  6445 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  6448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  6451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6455 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(6481), // Rule ID 719 //
     /*  6460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasMips64_HasStdEnc),
     /*  6463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6467 */     // MIs[0] rs
     /*  6467 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6472 */     // (build_vector:{ *:[v2i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rs)  =>  (FILL_D:{ *:[v2i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /*  6472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_D),
     /*  6475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6479 */     GIR_RootConstrainSelectedInstOperands,
     /*  6480 */     // GIR_Coverage, 719,
     /*  6480 */     GIR_EraseRootFromParent_Done,
     /*  6481 */   // Label 313: @6481
     /*  6481 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(6507), // Rule ID 721 //
     /*  6486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  6493 */     // MIs[0] fs
     /*  6493 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6498 */     // (build_vector:{ *:[v2f64] } FGR64:{ *:[f64] }:$fs, FGR64:{ *:[f64] }:$fs)  =>  (FILL_FD_PSEUDO:{ *:[v2f64] } FGR64:{ *:[f64] }:$fs)
     /*  6498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_FD_PSEUDO),
     /*  6501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6503 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /*  6505 */     GIR_RootConstrainSelectedInstOperands,
     /*  6506 */     // GIR_Coverage, 721,
     /*  6506 */     GIR_EraseRootFromParent_Done,
     /*  6507 */   // Label 314: @6507
     /*  6507 */   GIM_Reject,
     /*  6508 */ // Label 312: @6508
     /*  6508 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(6599),
     /*  6513 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  6516 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  6519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6526 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(6562), // Rule ID 718 //
     /*  6531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6538 */     // MIs[0] rs
     /*  6538 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6543 */     // MIs[0] rs
     /*  6543 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6548 */     // MIs[0] rs
     /*  6548 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6553 */     // (build_vector:{ *:[v4i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs)  =>  (FILL_W:{ *:[v4i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /*  6553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_W),
     /*  6556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6560 */     GIR_RootConstrainSelectedInstOperands,
     /*  6561 */     // GIR_Coverage, 718,
     /*  6561 */     GIR_EraseRootFromParent_Done,
     /*  6562 */   // Label 316: @6562
     /*  6562 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(6598), // Rule ID 720 //
     /*  6567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6574 */     // MIs[0] fs
     /*  6574 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6579 */     // MIs[0] fs
     /*  6579 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6584 */     // MIs[0] fs
     /*  6584 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6589 */     // (build_vector:{ *:[v4f32] } FGR32:{ *:[f32] }:$fs, FGR32:{ *:[f32] }:$fs, FGR32:{ *:[f32] }:$fs, FGR32:{ *:[f32] }:$fs)  =>  (FILL_FW_PSEUDO:{ *:[v4f32] } FGR32:{ *:[f32] }:$fs)
     /*  6589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_FW_PSEUDO),
     /*  6592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6594 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /*  6596 */     GIR_RootConstrainSelectedInstOperands,
     /*  6597 */     // GIR_Coverage, 720,
     /*  6597 */     GIR_EraseRootFromParent_Done,
     /*  6598 */   // Label 317: @6598
     /*  6598 */   GIM_Reject,
     /*  6599 */ // Label 315: @6599
     /*  6599 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(6668), // Rule ID 717 //
     /*  6604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6607 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /*  6610 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  6613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6624 */   // MIs[0] rs
     /*  6624 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6629 */   // MIs[0] rs
     /*  6629 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6634 */   // MIs[0] rs
     /*  6634 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6639 */   // MIs[0] rs
     /*  6639 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/5, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6644 */   // MIs[0] rs
     /*  6644 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/6, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6649 */   // MIs[0] rs
     /*  6649 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/7, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6654 */   // MIs[0] rs
     /*  6654 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/8, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6659 */   // (build_vector:{ *:[v8i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs)  =>  (FILL_H:{ *:[v8i16] } GPR32Opnd:{ *:[i32] }:$rs)
     /*  6659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_H),
     /*  6662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6664 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6666 */   GIR_RootConstrainSelectedInstOperands,
     /*  6667 */   // GIR_Coverage, 717,
     /*  6667 */   GIR_EraseRootFromParent_Done,
     /*  6668 */ // Label 318: @6668
     /*  6668 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(6777), // Rule ID 716 //
     /*  6673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6676 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/17,
     /*  6679 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  6682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6693 */   // MIs[0] rs
     /*  6693 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6698 */   // MIs[0] rs
     /*  6698 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6703 */   // MIs[0] rs
     /*  6703 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6708 */   // MIs[0] rs
     /*  6708 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/5, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6713 */   // MIs[0] rs
     /*  6713 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/6, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6718 */   // MIs[0] rs
     /*  6718 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/7, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6723 */   // MIs[0] rs
     /*  6723 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/8, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6728 */   // MIs[0] rs
     /*  6728 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/9, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6733 */   // MIs[0] rs
     /*  6733 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/10, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6738 */   // MIs[0] rs
     /*  6738 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/11, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6743 */   // MIs[0] rs
     /*  6743 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/12, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6748 */   // MIs[0] rs
     /*  6748 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/13, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6753 */   // MIs[0] rs
     /*  6753 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/14, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6758 */   // MIs[0] rs
     /*  6758 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/15, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6763 */   // MIs[0] rs
     /*  6763 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/16, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6768 */   // (build_vector:{ *:[v16i8] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs)  =>  (FILL_B:{ *:[v16i8] } GPR32Opnd:{ *:[i32] }:$rs)
     /*  6768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_B),
     /*  6771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6773 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6775 */   GIR_RootConstrainSelectedInstOperands,
     /*  6776 */   // GIR_Coverage, 716,
     /*  6776 */   GIR_EraseRootFromParent_Done,
     /*  6777 */ // Label 319: @6777
     /*  6777 */ GIM_Reject,
     /*  6778 */ // Label 12: @6778
     /*  6778 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 328*/ GIMT_Encode4(11088),
     /*  6789 */ /*GILLT_s32*//*Label 320*/ GIMT_Encode4(6821),
     /*  6793 */ /*GILLT_s64*//*Label 321*/ GIMT_Encode4(7098),
     /*  6797 */ /*GILLT_v2s16*//*Label 322*/ GIMT_Encode4(7154),
     /*  6801 */ /*GILLT_v2s64*//*Label 323*/ GIMT_Encode4(7214),
     /*  6805 */ /*GILLT_v4s8*//*Label 324*/ GIMT_Encode4(8349),
     /*  6809 */ /*GILLT_v4s32*//*Label 325*/ GIMT_Encode4(8409),
     /*  6813 */ /*GILLT_v8s16*//*Label 326*/ GIMT_Encode4(9478),
     /*  6817 */ /*GILLT_v16s8*//*Label 327*/ GIMT_Encode4(10403),
     /*  6821 */ // Label 320: @6821
     /*  6821 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(6847), // Rule ID 135 //
     /*  6826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  6829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6840 */   // (bitconvert:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MFC1:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)
     /*  6840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MFC1),
     /*  6845 */   GIR_RootConstrainSelectedInstOperands,
     /*  6846 */   // GIR_Coverage, 135,
     /*  6846 */   GIR_Done,
     /*  6847 */ // Label 329: @6847
     /*  6847 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(6873), // Rule ID 136 //
     /*  6852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  6855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6866 */   // (bitconvert:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)  =>  (MTC1:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)
     /*  6866 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MTC1),
     /*  6871 */   GIR_RootConstrainSelectedInstOperands,
     /*  6872 */   // GIR_Coverage, 136,
     /*  6872 */   GIR_Done,
     /*  6873 */ // Label 330: @6873
     /*  6873 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(6899), // Rule ID 1160 //
     /*  6878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /*  6881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6892 */   // (bitconvert:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MFC1_MM:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)
     /*  6892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MFC1_MM),
     /*  6897 */   GIR_RootConstrainSelectedInstOperands,
     /*  6898 */   // GIR_Coverage, 1160,
     /*  6898 */   GIR_Done,
     /*  6899 */ // Label 331: @6899
     /*  6899 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(6925), // Rule ID 1161 //
     /*  6904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /*  6907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6918 */   // (bitconvert:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)  =>  (MTC1_MM:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)
     /*  6918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MTC1_MM),
     /*  6923 */   GIR_RootConstrainSelectedInstOperands,
     /*  6924 */   // GIR_Coverage, 1161,
     /*  6924 */   GIR_Done,
     /*  6925 */ // Label 332: @6925
     /*  6925 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(6951), // Rule ID 1175 //
     /*  6930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /*  6933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6944 */   // (bitconvert:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)  =>  (MTC1_MMR6:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)
     /*  6944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MTC1_MMR6),
     /*  6949 */   GIR_RootConstrainSelectedInstOperands,
     /*  6950 */   // GIR_Coverage, 1175,
     /*  6950 */   GIR_Done,
     /*  6951 */ // Label 333: @6951
     /*  6951 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(6977), // Rule ID 1176 //
     /*  6956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /*  6959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6970 */   // (bitconvert:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MFC1_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)
     /*  6970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MFC1_MMR6),
     /*  6975 */   GIR_RootConstrainSelectedInstOperands,
     /*  6976 */   // GIR_Coverage, 1176,
     /*  6976 */   GIR_Done,
     /*  6977 */ // Label 334: @6977
     /*  6977 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(7007), // Rule ID 1913 //
     /*  6982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  6985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  6988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  6996 */   // (bitconvert:{ *:[i32] } DSPR:{ *:[v2i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } DSPR:{ *:[v2i16] }:$src, GPR32:{ *:[i32] })
     /*  6996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7001 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR32RegClassID),
     /*  7006 */   // GIR_Coverage, 1913,
     /*  7006 */   GIR_Done,
     /*  7007 */ // Label 335: @7007
     /*  7007 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(7037), // Rule ID 1914 //
     /*  7012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  7018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  7022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7026 */   // (bitconvert:{ *:[i32] } DSPR:{ *:[v4i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } DSPR:{ *:[v4i8] }:$src, GPR32:{ *:[i32] })
     /*  7026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7031 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR32RegClassID),
     /*  7036 */   // GIR_Coverage, 1914,
     /*  7036 */   GIR_Done,
     /*  7037 */ // Label 336: @7037
     /*  7037 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(7067), // Rule ID 1917 //
     /*  7042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  7048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7056 */   // (bitconvert:{ *:[f32] } DSPR:{ *:[v2i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } DSPR:{ *:[v2i16] }:$src, FGR32:{ *:[i32] })
     /*  7056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7061 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7066 */   // GIR_Coverage, 1917,
     /*  7066 */   GIR_Done,
     /*  7067 */ // Label 337: @7067
     /*  7067 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(7097), // Rule ID 1918 //
     /*  7072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  7078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7086 */   // (bitconvert:{ *:[f32] } DSPR:{ *:[v4i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } DSPR:{ *:[v4i8] }:$src, FGR32:{ *:[i32] })
     /*  7086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7096 */   // GIR_Coverage, 1918,
     /*  7096 */   GIR_Done,
     /*  7097 */ // Label 338: @7097
     /*  7097 */ GIM_Reject,
     /*  7098 */ // Label 321: @7098
     /*  7098 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(7153),
     /*  7103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  7106 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(7129), // Rule ID 137 //
     /*  7111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  7114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  7118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  7122 */     // (bitconvert:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMTC1:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$rt)
     /*  7122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMTC1),
     /*  7127 */     GIR_RootConstrainSelectedInstOperands,
     /*  7128 */     // GIR_Coverage, 137,
     /*  7128 */     GIR_Done,
     /*  7129 */   // Label 340: @7129
     /*  7129 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(7152), // Rule ID 138 //
     /*  7134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  7137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  7141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  7145 */     // (bitconvert:{ *:[i64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (DMFC1:{ *:[i64] } FGR64Opnd:{ *:[f64] }:$fs)
     /*  7145 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMFC1),
     /*  7150 */     GIR_RootConstrainSelectedInstOperands,
     /*  7151 */     // GIR_Coverage, 138,
     /*  7151 */     GIR_Done,
     /*  7152 */   // Label 341: @7152
     /*  7152 */   GIM_Reject,
     /*  7153 */ // Label 339: @7153
     /*  7153 */ GIM_Reject,
     /*  7154 */ // Label 322: @7154
     /*  7154 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(7213),
     /*  7159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  7162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7166 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(7189), // Rule ID 1915 //
     /*  7171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  7178 */     // (bitconvert:{ *:[v2i16] } GPR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } GPR32:{ *:[i32] }:$src, DSPR:{ *:[i32] })
     /*  7178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7188 */     // GIR_Coverage, 1915,
     /*  7188 */     GIR_Done,
     /*  7189 */   // Label 343: @7189
     /*  7189 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(7212), // Rule ID 1919 //
     /*  7194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7201 */     // (bitconvert:{ *:[v2i16] } FGR32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } FGR32:{ *:[f32] }:$src, DSPR:{ *:[i32] })
     /*  7201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7211 */     // GIR_Coverage, 1919,
     /*  7211 */     GIR_Done,
     /*  7212 */   // Label 344: @7212
     /*  7212 */   GIM_Reject,
     /*  7213 */ // Label 342: @7213
     /*  7213 */ GIM_Reject,
     /*  7214 */ // Label 323: @7214
     /*  7214 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(7240), // Rule ID 2000 //
     /*  7219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  7222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  7225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7229 */   // (bitconvert:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$src, MSA128D:{ *:[i32] })
     /*  7229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7234 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7239 */   // GIR_Coverage, 2000,
     /*  7239 */   GIR_Done,
     /*  7240 */ // Label 345: @7240
     /*  7240 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(7266), // Rule ID 2003 //
     /*  7245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  7248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  7251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7255 */   // (bitconvert:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$src, MSA128D:{ *:[i32] })
     /*  7255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7265 */   // GIR_Coverage, 2003,
     /*  7265 */   GIR_Done,
     /*  7266 */ // Label 346: @7266
     /*  7266 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(7292), // Rule ID 2020 //
     /*  7271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7281 */   // (bitconvert:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$src, MSA128D:{ *:[i32] })
     /*  7281 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7286 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7291 */   // GIR_Coverage, 2020,
     /*  7291 */   GIR_Done,
     /*  7292 */ // Label 347: @7292
     /*  7292 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(7318), // Rule ID 2021 //
     /*  7297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7307 */   // (bitconvert:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$src, MSA128D:{ *:[i32] })
     /*  7307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7312 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7317 */   // GIR_Coverage, 2021,
     /*  7317 */   GIR_Done,
     /*  7318 */ // Label 348: @7318
     /*  7318 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(7344), // Rule ID 2022 //
     /*  7323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7333 */   // (bitconvert:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$src, MSA128D:{ *:[i32] })
     /*  7333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7338 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7343 */   // GIR_Coverage, 2022,
     /*  7343 */   GIR_Done,
     /*  7344 */ // Label 349: @7344
     /*  7344 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(7370), // Rule ID 2023 //
     /*  7349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7359 */   // (bitconvert:{ *:[v2i64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v8f16:{ *:[v8f16] }:$src, MSA128D:{ *:[i32] })
     /*  7359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7369 */   // GIR_Coverage, 2023,
     /*  7369 */   GIR_Done,
     /*  7370 */ // Label 350: @7370
     /*  7370 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(7396), // Rule ID 2024 //
     /*  7375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7385 */   // (bitconvert:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$src, MSA128D:{ *:[i32] })
     /*  7385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7390 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7395 */   // GIR_Coverage, 2024,
     /*  7395 */   GIR_Done,
     /*  7396 */ // Label 351: @7396
     /*  7396 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(7422), // Rule ID 2030 //
     /*  7401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7411 */   // (bitconvert:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$src, MSA128D:{ *:[i32] })
     /*  7411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7421 */   // GIR_Coverage, 2030,
     /*  7421 */   GIR_Done,
     /*  7422 */ // Label 352: @7422
     /*  7422 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(7448), // Rule ID 2031 //
     /*  7427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7437 */   // (bitconvert:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$src, MSA128D:{ *:[i32] })
     /*  7437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7447 */   // GIR_Coverage, 2031,
     /*  7447 */   GIR_Done,
     /*  7448 */ // Label 353: @7448
     /*  7448 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(7474), // Rule ID 2032 //
     /*  7453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7463 */   // (bitconvert:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$src, MSA128D:{ *:[i32] })
     /*  7463 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7468 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7473 */   // GIR_Coverage, 2032,
     /*  7473 */   GIR_Done,
     /*  7474 */ // Label 354: @7474
     /*  7474 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(7500), // Rule ID 2033 //
     /*  7479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7489 */   // (bitconvert:{ *:[v2f64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v8f16:{ *:[v8f16] }:$src, MSA128D:{ *:[i32] })
     /*  7489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7494 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7499 */   // GIR_Coverage, 2033,
     /*  7499 */   GIR_Done,
     /*  7500 */ // Label 355: @7500
     /*  7500 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(7526), // Rule ID 2034 //
     /*  7505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7515 */   // (bitconvert:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$src, MSA128D:{ *:[i32] })
     /*  7515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7520 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7525 */   // GIR_Coverage, 2034,
     /*  7525 */   GIR_Done,
     /*  7526 */ // Label 356: @7526
     /*  7526 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(7643), // Rule ID 2039 //
     /*  7531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7541 */   // (bitconvert:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7541 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /*  7544 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7548 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7553 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7557 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  7562 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  7565 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  7569 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7574 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  7577 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /*  7580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  7582 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  7585 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7589 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7594 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  7597 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  7602 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  7605 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  7609 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7614 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7617 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  7627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7637 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7642 */   // GIR_Coverage, 2039,
     /*  7642 */   GIR_EraseRootFromParent_Done,
     /*  7643 */ // Label 357: @7643
     /*  7643 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(7760), // Rule ID 2040 //
     /*  7648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7658 */   // (bitconvert:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7658 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /*  7661 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7665 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7670 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7674 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  7679 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  7682 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  7686 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7691 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  7694 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /*  7697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  7699 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  7702 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7706 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7711 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  7714 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  7719 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  7722 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  7726 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7731 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7734 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  7744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7751 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7754 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7759 */   // GIR_Coverage, 2040,
     /*  7759 */   GIR_EraseRootFromParent_Done,
     /*  7760 */ // Label 358: @7760
     /*  7760 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(7830), // Rule ID 2044 //
     /*  7765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7775 */   // (bitconvert:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7775 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7778 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7782 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7787 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7791 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  7803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7808 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7811 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  7814 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7829 */   // GIR_Coverage, 2044,
     /*  7829 */   GIR_EraseRootFromParent_Done,
     /*  7830 */ // Label 359: @7830
     /*  7830 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(7900), // Rule ID 2045 //
     /*  7835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7845 */   // (bitconvert:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7845 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7848 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7852 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7857 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7861 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7866 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  7873 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7878 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7881 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  7884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7899 */   // GIR_Coverage, 2045,
     /*  7899 */   GIR_EraseRootFromParent_Done,
     /*  7900 */ // Label 360: @7900
     /*  7900 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(7970), // Rule ID 2049 //
     /*  7905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7915 */   // (bitconvert:{ *:[v2i64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7915 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7918 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7922 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7927 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7931 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7936 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7939 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  7943 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7948 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7951 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  7954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7961 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7964 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7969 */   // GIR_Coverage, 2049,
     /*  7969 */   GIR_EraseRootFromParent_Done,
     /*  7970 */ // Label 361: @7970
     /*  7970 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(8040), // Rule ID 2050 //
     /*  7975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7985 */   // (bitconvert:{ *:[v2f64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7985 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7988 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7992 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7997 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8001 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  8006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  8009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  8013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8018 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8021 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  8024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8034 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8039 */   // GIR_Coverage, 2050,
     /*  8039 */   GIR_EraseRootFromParent_Done,
     /*  8040 */ // Label 362: @8040
     /*  8040 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(8117), // Rule ID 2054 //
     /*  8045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8055 */   // (bitconvert:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8055 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8058 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8062 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8067 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8071 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8088 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8091 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8111 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8116 */   // GIR_Coverage, 2054,
     /*  8116 */   GIR_EraseRootFromParent_Done,
     /*  8117 */ // Label 363: @8117
     /*  8117 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(8194), // Rule ID 2055 //
     /*  8122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8132 */   // (bitconvert:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8132 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8135 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8139 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8144 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8148 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8153 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8156 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8160 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8165 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8168 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8188 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8193 */   // GIR_Coverage, 2055,
     /*  8193 */   GIR_EraseRootFromParent_Done,
     /*  8194 */ // Label 364: @8194
     /*  8194 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(8271), // Rule ID 2059 //
     /*  8199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8209 */   // (bitconvert:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8209 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8212 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8216 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8221 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8225 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8242 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8245 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8265 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8270 */   // GIR_Coverage, 2059,
     /*  8270 */   GIR_EraseRootFromParent_Done,
     /*  8271 */ // Label 365: @8271
     /*  8271 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(8348), // Rule ID 2060 //
     /*  8276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8286 */   // (bitconvert:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8286 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8289 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8293 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8298 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8302 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8319 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8322 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8339 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8342 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8347 */   // GIR_Coverage, 2060,
     /*  8347 */   GIR_EraseRootFromParent_Done,
     /*  8348 */ // Label 366: @8348
     /*  8348 */ GIM_Reject,
     /*  8349 */ // Label 324: @8349
     /*  8349 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(8408),
     /*  8354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  8357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  8361 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(8384), // Rule ID 1916 //
     /*  8366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  8369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  8373 */     // (bitconvert:{ *:[v4i8] } GPR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i8] } GPR32:{ *:[i32] }:$src, DSPR:{ *:[i32] })
     /*  8373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  8383 */     // GIR_Coverage, 1916,
     /*  8383 */     GIR_Done,
     /*  8384 */   // Label 368: @8384
     /*  8384 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(8407), // Rule ID 1920 //
     /*  8389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  8392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  8396 */     // (bitconvert:{ *:[v4i8] } FGR32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i8] } FGR32:{ *:[f32] }:$src, DSPR:{ *:[i32] })
     /*  8396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  8406 */     // GIR_Coverage, 1920,
     /*  8406 */     GIR_Done,
     /*  8407 */   // Label 369: @8407
     /*  8407 */   GIM_Reject,
     /*  8408 */ // Label 367: @8408
     /*  8408 */ GIM_Reject,
     /*  8409 */ // Label 325: @8409
     /*  8409 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(8435), // Rule ID 1999 //
     /*  8414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  8417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8424 */   // (bitconvert:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src, MSA128W:{ *:[i32] })
     /*  8424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8434 */   // GIR_Coverage, 1999,
     /*  8434 */   GIR_Done,
     /*  8435 */ // Label 370: @8435
     /*  8435 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(8461), // Rule ID 2002 //
     /*  8440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  8443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8450 */   // (bitconvert:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src, MSA128W:{ *:[i32] })
     /*  8450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8455 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8460 */   // GIR_Coverage, 2002,
     /*  8460 */   GIR_Done,
     /*  8461 */ // Label 371: @8461
     /*  8461 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(8487), // Rule ID 2015 //
     /*  8466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8476 */   // (bitconvert:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$src, MSA128W:{ *:[i32] })
     /*  8476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8481 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8486 */   // GIR_Coverage, 2015,
     /*  8486 */   GIR_Done,
     /*  8487 */ // Label 372: @8487
     /*  8487 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(8513), // Rule ID 2016 //
     /*  8492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8502 */   // (bitconvert:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$src, MSA128W:{ *:[i32] })
     /*  8502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8507 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8512 */   // GIR_Coverage, 2016,
     /*  8512 */   GIR_Done,
     /*  8513 */ // Label 373: @8513
     /*  8513 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(8539), // Rule ID 2017 //
     /*  8518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8528 */   // (bitconvert:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] })
     /*  8528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8538 */   // GIR_Coverage, 2017,
     /*  8538 */   GIR_Done,
     /*  8539 */ // Label 374: @8539
     /*  8539 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(8565), // Rule ID 2018 //
     /*  8544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8554 */   // (bitconvert:{ *:[v4i32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v8f16:{ *:[v8f16] }:$src, MSA128W:{ *:[i32] })
     /*  8554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8559 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8564 */   // GIR_Coverage, 2018,
     /*  8564 */   GIR_Done,
     /*  8565 */ // Label 375: @8565
     /*  8565 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(8591), // Rule ID 2019 //
     /*  8570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8580 */   // (bitconvert:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] })
     /*  8580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8585 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8590 */   // GIR_Coverage, 2019,
     /*  8590 */   GIR_Done,
     /*  8591 */ // Label 376: @8591
     /*  8591 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(8617), // Rule ID 2025 //
     /*  8596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8606 */   // (bitconvert:{ *:[v4f32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v16i8:{ *:[v16i8] }:$src, MSA128W:{ *:[i32] })
     /*  8606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8616 */   // GIR_Coverage, 2025,
     /*  8616 */   GIR_Done,
     /*  8617 */ // Label 377: @8617
     /*  8617 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(8643), // Rule ID 2026 //
     /*  8622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8632 */   // (bitconvert:{ *:[v4f32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v8i16:{ *:[v8i16] }:$src, MSA128W:{ *:[i32] })
     /*  8632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8637 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8642 */   // GIR_Coverage, 2026,
     /*  8642 */   GIR_Done,
     /*  8643 */ // Label 378: @8643
     /*  8643 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(8669), // Rule ID 2027 //
     /*  8648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8658 */   // (bitconvert:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] })
     /*  8658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8663 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8668 */   // GIR_Coverage, 2027,
     /*  8668 */   GIR_Done,
     /*  8669 */ // Label 379: @8669
     /*  8669 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(8695), // Rule ID 2028 //
     /*  8674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8684 */   // (bitconvert:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src, MSA128W:{ *:[i32] })
     /*  8684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8689 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8694 */   // GIR_Coverage, 2028,
     /*  8694 */   GIR_Done,
     /*  8695 */ // Label 380: @8695
     /*  8695 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(8721), // Rule ID 2029 //
     /*  8700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8710 */   // (bitconvert:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] })
     /*  8710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8715 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8720 */   // GIR_Coverage, 2029,
     /*  8720 */   GIR_Done,
     /*  8721 */ // Label 381: @8721
     /*  8721 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(8791), // Rule ID 2037 //
     /*  8726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8736 */   // (bitconvert:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8736 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  8739 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8743 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8748 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8752 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  8757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  8760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  8764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8769 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8772 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  8775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8782 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8785 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8790 */   // GIR_Coverage, 2037,
     /*  8790 */   GIR_EraseRootFromParent_Done,
     /*  8791 */ // Label 382: @8791
     /*  8791 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(8861), // Rule ID 2038 //
     /*  8796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8806 */   // (bitconvert:{ *:[v4f32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8806 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  8809 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8813 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8818 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8822 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  8827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  8830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  8834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8839 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8842 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  8845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8855 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8860 */   // GIR_Coverage, 2038,
     /*  8860 */   GIR_EraseRootFromParent_Done,
     /*  8861 */ // Label 383: @8861
     /*  8861 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(8938), // Rule ID 2042 //
     /*  8866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8876 */   // (bitconvert:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8876 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  8879 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8883 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8888 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8892 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  8897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  8900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  8904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8909 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8912 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8932 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8937 */   // GIR_Coverage, 2042,
     /*  8937 */   GIR_EraseRootFromParent_Done,
     /*  8938 */ // Label 384: @8938
     /*  8938 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(9015), // Rule ID 2043 //
     /*  8943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8953 */   // (bitconvert:{ *:[v4f32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8953 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  8956 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8960 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8965 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8969 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  8974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  8977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  8981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8986 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8989 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9006 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9009 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9014 */   // GIR_Coverage, 2043,
     /*  9014 */   GIR_EraseRootFromParent_Done,
     /*  9015 */ // Label 385: @9015
     /*  9015 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(9092), // Rule ID 2047 //
     /*  9020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9030 */   // (bitconvert:{ *:[v4i32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9030 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9033 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9037 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9042 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9046 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9051 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9054 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9058 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9063 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9066 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9086 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9091 */   // GIR_Coverage, 2047,
     /*  9091 */   GIR_EraseRootFromParent_Done,
     /*  9092 */ // Label 386: @9092
     /*  9092 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(9169), // Rule ID 2048 //
     /*  9097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9107 */   // (bitconvert:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9107 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9110 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9114 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9119 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9123 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9128 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9131 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9135 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9140 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9143 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9160 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9163 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9168 */   // GIR_Coverage, 2048,
     /*  9168 */   GIR_EraseRootFromParent_Done,
     /*  9169 */ // Label 387: @9169
     /*  9169 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(9246), // Rule ID 2064 //
     /*  9174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9184 */   // (bitconvert:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9184 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9187 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9191 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9196 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9200 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9205 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9208 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9212 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9217 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9220 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9240 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9245 */   // GIR_Coverage, 2064,
     /*  9245 */   GIR_EraseRootFromParent_Done,
     /*  9246 */ // Label 388: @9246
     /*  9246 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(9323), // Rule ID 2065 //
     /*  9251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9261 */   // (bitconvert:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9261 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9264 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9268 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9273 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9277 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9294 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9297 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9314 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9322 */   // GIR_Coverage, 2065,
     /*  9322 */   GIR_EraseRootFromParent_Done,
     /*  9323 */ // Label 389: @9323
     /*  9323 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(9400), // Rule ID 2069 //
     /*  9328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9338 */   // (bitconvert:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9338 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9341 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9345 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9350 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9354 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9359 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9362 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9366 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9371 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9374 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9399 */   // GIR_Coverage, 2069,
     /*  9399 */   GIR_EraseRootFromParent_Done,
     /*  9400 */ // Label 390: @9400
     /*  9400 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(9477), // Rule ID 2070 //
     /*  9405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9415 */   // (bitconvert:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9415 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9418 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9422 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9427 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9431 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9448 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9451 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9471 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9476 */   // GIR_Coverage, 2070,
     /*  9476 */   GIR_EraseRootFromParent_Done,
     /*  9477 */ // Label 391: @9477
     /*  9477 */ GIM_Reject,
     /*  9478 */ // Label 326: @9478
     /*  9478 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(9504), // Rule ID 1998 //
     /*  9483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  9486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9493 */   // (bitconvert:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] })
     /*  9493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9498 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9503 */   // GIR_Coverage, 1998,
     /*  9503 */   GIR_Done,
     /*  9504 */ // Label 392: @9504
     /*  9504 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(9530), // Rule ID 2001 //
     /*  9509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  9512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9519 */   // (bitconvert:{ *:[v8f16] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] })
     /*  9519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9524 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9529 */   // GIR_Coverage, 2001,
     /*  9529 */   GIR_Done,
     /*  9530 */ // Label 393: @9530
     /*  9530 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(9556), // Rule ID 2010 //
     /*  9535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  9541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9545 */   // (bitconvert:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$src, MSA128H:{ *:[i32] })
     /*  9545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9550 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9555 */   // GIR_Coverage, 2010,
     /*  9555 */   GIR_Done,
     /*  9556 */ // Label 394: @9556
     /*  9556 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(9582), // Rule ID 2011 //
     /*  9561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9571 */   // (bitconvert:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src, MSA128H:{ *:[i32] })
     /*  9571 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9581 */   // GIR_Coverage, 2011,
     /*  9581 */   GIR_Done,
     /*  9582 */ // Label 395: @9582
     /*  9582 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(9608), // Rule ID 2012 //
     /*  9587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9597 */   // (bitconvert:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src, MSA128H:{ *:[i32] })
     /*  9597 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9602 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9607 */   // GIR_Coverage, 2012,
     /*  9607 */   GIR_Done,
     /*  9608 */ // Label 396: @9608
     /*  9608 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(9634), // Rule ID 2013 //
     /*  9613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9623 */   // (bitconvert:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src, MSA128H:{ *:[i32] })
     /*  9623 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9628 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9633 */   // GIR_Coverage, 2013,
     /*  9633 */   GIR_Done,
     /*  9634 */ // Label 397: @9634
     /*  9634 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(9660), // Rule ID 2014 //
     /*  9639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9649 */   // (bitconvert:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src, MSA128H:{ *:[i32] })
     /*  9649 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9654 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9659 */   // GIR_Coverage, 2014,
     /*  9659 */   GIR_Done,
     /*  9660 */ // Label 398: @9660
     /*  9660 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(9737), // Rule ID 2035 //
     /*  9665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  9671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9675 */   // (bitconvert:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9675 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  9678 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9682 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9687 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9691 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  9696 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  9699 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  9703 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9708 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9711 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9731 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9736 */   // GIR_Coverage, 2035,
     /*  9736 */   GIR_EraseRootFromParent_Done,
     /*  9737 */ // Label 399: @9737
     /*  9737 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(9814), // Rule ID 2036 //
     /*  9742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  9748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9752 */   // (bitconvert:{ *:[v8f16] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9752 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  9755 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9759 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9764 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9768 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  9773 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  9776 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  9780 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9785 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9788 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9805 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9808 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9813 */   // GIR_Coverage, 2036,
     /*  9813 */   GIR_EraseRootFromParent_Done,
     /*  9814 */ // Label 400: @9814
     /*  9814 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(9891), // Rule ID 2052 //
     /*  9819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9829 */   // (bitconvert:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9829 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9832 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9836 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9841 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9845 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9850 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9853 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9857 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9862 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9865 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9882 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9885 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9890 */   // GIR_Coverage, 2052,
     /*  9890 */   GIR_EraseRootFromParent_Done,
     /*  9891 */ // Label 401: @9891
     /*  9891 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(9968), // Rule ID 2053 //
     /*  9896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9906 */   // (bitconvert:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9906 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9909 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9913 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9918 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9922 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9939 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9942 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9962 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9967 */   // GIR_Coverage, 2053,
     /*  9967 */   GIR_EraseRootFromParent_Done,
     /*  9968 */ // Label 402: @9968
     /*  9968 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(10045), // Rule ID 2057 //
     /*  9973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9983 */   // (bitconvert:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9983 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9986 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9990 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9995 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9999 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10004 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10007 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10011 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10016 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10019 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10039 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10044 */   // GIR_Coverage, 2057,
     /* 10044 */   GIR_EraseRootFromParent_Done,
     /* 10045 */ // Label 403: @10045
     /* 10045 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(10122), // Rule ID 2058 //
     /* 10050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10060 */   // (bitconvert:{ *:[v8f16] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10060 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10063 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10067 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10072 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10076 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10093 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10096 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10113 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10116 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10121 */   // GIR_Coverage, 2058,
     /* 10121 */   GIR_EraseRootFromParent_Done,
     /* 10122 */ // Label 404: @10122
     /* 10122 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(10192), // Rule ID 2062 //
     /* 10127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10137 */   // (bitconvert:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10137 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10140 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10144 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10149 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10153 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10158 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10161 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10165 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10170 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10173 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10191 */   // GIR_Coverage, 2062,
     /* 10191 */   GIR_EraseRootFromParent_Done,
     /* 10192 */ // Label 405: @10192
     /* 10192 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(10262), // Rule ID 2063 //
     /* 10197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10207 */   // (bitconvert:{ *:[v8f16] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10207 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10210 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10214 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10219 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10223 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10228 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10231 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10235 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10240 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10243 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10253 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10256 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10261 */   // GIR_Coverage, 2063,
     /* 10261 */   GIR_EraseRootFromParent_Done,
     /* 10262 */ // Label 406: @10262
     /* 10262 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(10332), // Rule ID 2067 //
     /* 10267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10277 */   // (bitconvert:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10277 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10280 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10284 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10289 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10293 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10310 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10313 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10323 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10326 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10331 */   // GIR_Coverage, 2067,
     /* 10331 */   GIR_EraseRootFromParent_Done,
     /* 10332 */ // Label 407: @10332
     /* 10332 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(10402), // Rule ID 2068 //
     /* 10337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10347 */   // (bitconvert:{ *:[v8f16] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10347 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10350 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10354 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10359 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10363 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10368 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10371 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10375 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10380 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10383 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10401 */   // GIR_Coverage, 2068,
     /* 10401 */   GIR_EraseRootFromParent_Done,
     /* 10402 */ // Label 408: @10402
     /* 10402 */ GIM_Reject,
     /* 10403 */ // Label 327: @10403
     /* 10403 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(10429), // Rule ID 2004 //
     /* 10408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10418 */   // (bitconvert:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src, MSA128B:{ *:[i32] })
     /* 10418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10423 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10428 */   // GIR_Coverage, 2004,
     /* 10428 */   GIR_Done,
     /* 10429 */ // Label 409: @10429
     /* 10429 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(10455), // Rule ID 2005 //
     /* 10434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10444 */   // (bitconvert:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src, MSA128B:{ *:[i32] })
     /* 10444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10449 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10454 */   // GIR_Coverage, 2005,
     /* 10454 */   GIR_Done,
     /* 10455 */ // Label 410: @10455
     /* 10455 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(10481), // Rule ID 2006 //
     /* 10460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10470 */   // (bitconvert:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src, MSA128B:{ *:[i32] })
     /* 10470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10475 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10480 */   // GIR_Coverage, 2006,
     /* 10480 */   GIR_Done,
     /* 10481 */ // Label 411: @10481
     /* 10481 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(10507), // Rule ID 2007 //
     /* 10486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10496 */   // (bitconvert:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src, MSA128B:{ *:[i32] })
     /* 10496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10506 */   // GIR_Coverage, 2007,
     /* 10506 */   GIR_Done,
     /* 10507 */ // Label 412: @10507
     /* 10507 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(10533), // Rule ID 2008 //
     /* 10512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10522 */   // (bitconvert:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src, MSA128B:{ *:[i32] })
     /* 10522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10532 */   // GIR_Coverage, 2008,
     /* 10532 */   GIR_Done,
     /* 10533 */ // Label 413: @10533
     /* 10533 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(10559), // Rule ID 2009 //
     /* 10538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10548 */   // (bitconvert:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src, MSA128B:{ *:[i32] })
     /* 10548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10553 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10558 */   // GIR_Coverage, 2009,
     /* 10558 */   GIR_Done,
     /* 10559 */ // Label 414: @10559
     /* 10559 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(10636), // Rule ID 2041 //
     /* 10564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10574 */   // (bitconvert:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10574 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10577 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10581 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10586 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10590 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10607 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10610 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10627 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10630 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10635 */   // GIR_Coverage, 2041,
     /* 10635 */   GIR_EraseRootFromParent_Done,
     /* 10636 */ // Label 415: @10636
     /* 10636 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(10713), // Rule ID 2046 //
     /* 10641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10651 */   // (bitconvert:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10651 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10654 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10658 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10663 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10667 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10672 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10675 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10679 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10684 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10687 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10704 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10707 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10712 */   // GIR_Coverage, 2046,
     /* 10712 */   GIR_EraseRootFromParent_Done,
     /* 10713 */ // Label 416: @10713
     /* 10713 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(10783), // Rule ID 2051 //
     /* 10718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10728 */   // (bitconvert:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10728 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10731 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10735 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10740 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10744 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10756 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10761 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10764 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10774 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10777 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10782 */   // GIR_Coverage, 2051,
     /* 10782 */   GIR_EraseRootFromParent_Done,
     /* 10783 */ // Label 417: @10783
     /* 10783 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(10853), // Rule ID 2056 //
     /* 10788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10798 */   // (bitconvert:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10798 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10801 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10805 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10810 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10814 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10831 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10834 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10844 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10847 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10852 */   // GIR_Coverage, 2056,
     /* 10852 */   GIR_EraseRootFromParent_Done,
     /* 10853 */ // Label 418: @10853
     /* 10853 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(10970), // Rule ID 2061 //
     /* 10858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10868 */   // (bitconvert:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10868 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 10871 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10875 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10880 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10884 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10889 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 10892 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10896 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10901 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 10904 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /* 10907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 10909 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 10912 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10916 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10921 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 10924 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 10929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 10932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /* 10936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10941 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10944 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10961 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10964 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10969 */   // GIR_Coverage, 2061,
     /* 10969 */   GIR_EraseRootFromParent_Done,
     /* 10970 */ // Label 419: @10970
     /* 10970 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(11087), // Rule ID 2066 //
     /* 10975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10985 */   // (bitconvert:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10985 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 10988 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10992 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10997 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 11001 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 11006 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 11009 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 11013 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11018 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 11021 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /* 11024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 11026 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 11029 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 11033 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11038 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 11041 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 11046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 11049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /* 11053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11058 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 11061 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 11071 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 11073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 11076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 11078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 11081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 11086 */   // GIR_Coverage, 2066,
     /* 11086 */   GIR_EraseRootFromParent_Done,
     /* 11087 */ // Label 420: @11087
     /* 11087 */ GIM_Reject,
     /* 11088 */ // Label 328: @11088
     /* 11088 */ GIM_Reject,
     /* 11089 */ // Label 13: @11089
     /* 11089 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(11153), // Rule ID 1989 //
     /* 11094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 11097 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 11100 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 11103 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 11107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11111 */   // MIs[0] Operand 1
     /* 11111 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 11115 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11119 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 11123 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 11127 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 11131 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 11133 */   // (ld:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LWX:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index)
     /* 11133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LWX),
     /* 11136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 11138 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // base
     /* 11142 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // index
     /* 11146 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 11151 */   GIR_RootConstrainSelectedInstOperands,
     /* 11152 */   // GIR_Coverage, 1989,
     /* 11152 */   GIR_EraseRootFromParent_Done,
     /* 11153 */ // Label 421: @11153
     /* 11153 */ GIM_Reject,
     /* 11154 */ // Label 14: @11154
     /* 11154 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(11221), // Rule ID 1988 //
     /* 11159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 11162 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 11165 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 11168 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11179 */   // MIs[0] Operand 1
     /* 11179 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 11183 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11187 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 11191 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 11195 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 11199 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 11201 */   // (ld:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LHX:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index)
     /* 11201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LHX),
     /* 11204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 11206 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // base
     /* 11210 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // index
     /* 11214 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 11219 */   GIR_RootConstrainSelectedInstOperands,
     /* 11220 */   // GIR_Coverage, 1988,
     /* 11220 */   GIR_EraseRootFromParent_Done,
     /* 11221 */ // Label 422: @11221
     /* 11221 */ GIM_Reject,
     /* 11222 */ // Label 15: @11222
     /* 11222 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(11289), // Rule ID 1987 //
     /* 11227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 11230 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 11233 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 11236 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11247 */   // MIs[0] Operand 1
     /* 11247 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 11251 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11255 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 11259 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 11263 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 11267 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 11269 */   // (ld:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBUX:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index)
     /* 11269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LBUX),
     /* 11272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 11274 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // base
     /* 11278 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // index
     /* 11282 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 11287 */   GIR_RootConstrainSelectedInstOperands,
     /* 11288 */   // GIR_Coverage, 1987,
     /* 11288 */   GIR_EraseRootFromParent_Done,
     /* 11289 */ // Label 423: @11289
     /* 11289 */ GIM_Reject,
     /* 11290 */ // Label 16: @11290
     /* 11290 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 426*/ GIMT_Encode4(11481),
     /* 11301 */ /*GILLT_s32*//*Label 424*/ GIMT_Encode4(11309),
     /* 11305 */ /*GILLT_s64*//*Label 425*/ GIMT_Encode4(11436),
     /* 11309 */ // Label 424: @11309
     /* 11309 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(11435),
     /* 11314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11317 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 11320 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(11358), // Rule ID 25 //
     /* 11325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11339 */     // MIs[0] ptr
     /* 11339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11351 */     // (atomic_cmp_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (ATOMIC_CMP_SWAP_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)
     /* 11351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I8),
     /* 11356 */     GIR_RootConstrainSelectedInstOperands,
     /* 11357 */     // GIR_Coverage, 25,
     /* 11357 */     GIR_Done,
     /* 11358 */   // Label 428: @11358
     /* 11358 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(11396), // Rule ID 26 //
     /* 11363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11366 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11377 */     // MIs[0] ptr
     /* 11377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11389 */     // (atomic_cmp_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (ATOMIC_CMP_SWAP_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)
     /* 11389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I16),
     /* 11394 */     GIR_RootConstrainSelectedInstOperands,
     /* 11395 */     // GIR_Coverage, 26,
     /* 11395 */     GIR_Done,
     /* 11396 */   // Label 429: @11396
     /* 11396 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(11434), // Rule ID 27 //
     /* 11401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11404 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11415 */     // MIs[0] ptr
     /* 11415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11427 */     // (atomic_cmp_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (ATOMIC_CMP_SWAP_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)
     /* 11427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I32),
     /* 11432 */     GIR_RootConstrainSelectedInstOperands,
     /* 11433 */     // GIR_Coverage, 27,
     /* 11433 */     GIR_Done,
     /* 11434 */   // Label 430: @11434
     /* 11434 */   GIM_Reject,
     /* 11435 */ // Label 427: @11435
     /* 11435 */ GIM_Reject,
     /* 11436 */ // Label 425: @11436
     /* 11436 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(11480), // Rule ID 191 //
     /* 11441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11447 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 11450 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11461 */   // MIs[0] ptr
     /* 11461 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11469 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11473 */   // (atomic_cmp_swap:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$cmp, GPR64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (ATOMIC_CMP_SWAP_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$cmp, GPR64:{ *:[i64] }:$swap)
     /* 11473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I64),
     /* 11478 */   GIR_RootConstrainSelectedInstOperands,
     /* 11479 */   // GIR_Coverage, 191,
     /* 11479 */   GIR_Done,
     /* 11480 */ // Label 431: @11480
     /* 11480 */ GIM_Reject,
     /* 11481 */ // Label 426: @11481
     /* 11481 */ GIM_Reject,
     /* 11482 */ // Label 17: @11482
     /* 11482 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 434*/ GIMT_Encode4(11651),
     /* 11493 */ /*GILLT_s32*//*Label 432*/ GIMT_Encode4(11501),
     /* 11497 */ /*GILLT_s64*//*Label 433*/ GIMT_Encode4(11613),
     /* 11501 */ // Label 432: @11501
     /* 11501 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(11612),
     /* 11506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11509 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(11543), // Rule ID 22 //
     /* 11514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11517 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11528 */     // MIs[0] ptr
     /* 11528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11536 */     // (atomic_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_swap_i8>>  =>  (ATOMIC_SWAP_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I8),
     /* 11541 */     GIR_RootConstrainSelectedInstOperands,
     /* 11542 */     // GIR_Coverage, 22,
     /* 11542 */     GIR_Done,
     /* 11543 */   // Label 436: @11543
     /* 11543 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(11577), // Rule ID 23 //
     /* 11548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11551 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11562 */     // MIs[0] ptr
     /* 11562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11570 */     // (atomic_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_swap_i16>>  =>  (ATOMIC_SWAP_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I16),
     /* 11575 */     GIR_RootConstrainSelectedInstOperands,
     /* 11576 */     // GIR_Coverage, 23,
     /* 11576 */     GIR_Done,
     /* 11577 */   // Label 437: @11577
     /* 11577 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(11611), // Rule ID 24 //
     /* 11582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11585 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11596 */     // MIs[0] ptr
     /* 11596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11604 */     // (atomic_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_swap_i32>>  =>  (ATOMIC_SWAP_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I32),
     /* 11609 */     GIR_RootConstrainSelectedInstOperands,
     /* 11610 */     // GIR_Coverage, 24,
     /* 11610 */     GIR_Done,
     /* 11611 */   // Label 438: @11611
     /* 11611 */   GIM_Reject,
     /* 11612 */ // Label 435: @11612
     /* 11612 */ GIM_Reject,
     /* 11613 */ // Label 433: @11613
     /* 11613 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(11650), // Rule ID 190 //
     /* 11618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11624 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11635 */   // MIs[0] ptr
     /* 11635 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11643 */   // (atomic_swap:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_swap_i64>>  =>  (ATOMIC_SWAP_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 11643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I64),
     /* 11648 */   GIR_RootConstrainSelectedInstOperands,
     /* 11649 */   // GIR_Coverage, 190,
     /* 11649 */   GIR_Done,
     /* 11650 */ // Label 439: @11650
     /* 11650 */ GIM_Reject,
     /* 11651 */ // Label 434: @11651
     /* 11651 */ GIM_Reject,
     /* 11652 */ // Label 18: @11652
     /* 11652 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 442*/ GIMT_Encode4(11821),
     /* 11663 */ /*GILLT_s32*//*Label 440*/ GIMT_Encode4(11671),
     /* 11667 */ /*GILLT_s64*//*Label 441*/ GIMT_Encode4(11783),
     /* 11671 */ // Label 440: @11671
     /* 11671 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(11782),
     /* 11676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11679 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(11713), // Rule ID 4 //
     /* 11684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11698 */     // MIs[0] ptr
     /* 11698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11706 */     // (atomic_load_add:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_add_i8>>  =>  (ATOMIC_LOAD_ADD_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I8),
     /* 11711 */     GIR_RootConstrainSelectedInstOperands,
     /* 11712 */     // GIR_Coverage, 4,
     /* 11712 */     GIR_Done,
     /* 11713 */   // Label 444: @11713
     /* 11713 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(11747), // Rule ID 5 //
     /* 11718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11721 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11732 */     // MIs[0] ptr
     /* 11732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11740 */     // (atomic_load_add:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_add_i16>>  =>  (ATOMIC_LOAD_ADD_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I16),
     /* 11745 */     GIR_RootConstrainSelectedInstOperands,
     /* 11746 */     // GIR_Coverage, 5,
     /* 11746 */     GIR_Done,
     /* 11747 */   // Label 445: @11747
     /* 11747 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(11781), // Rule ID 6 //
     /* 11752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11755 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11766 */     // MIs[0] ptr
     /* 11766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11774 */     // (atomic_load_add:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_add_i32>>  =>  (ATOMIC_LOAD_ADD_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I32),
     /* 11779 */     GIR_RootConstrainSelectedInstOperands,
     /* 11780 */     // GIR_Coverage, 6,
     /* 11780 */     GIR_Done,
     /* 11781 */   // Label 446: @11781
     /* 11781 */   GIM_Reject,
     /* 11782 */ // Label 443: @11782
     /* 11782 */ GIM_Reject,
     /* 11783 */ // Label 441: @11783
     /* 11783 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(11820), // Rule ID 184 //
     /* 11788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11794 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11805 */   // MIs[0] ptr
     /* 11805 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11813 */   // (atomic_load_add:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_add_i64>>  =>  (ATOMIC_LOAD_ADD_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 11813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I64),
     /* 11818 */   GIR_RootConstrainSelectedInstOperands,
     /* 11819 */   // GIR_Coverage, 184,
     /* 11819 */   GIR_Done,
     /* 11820 */ // Label 447: @11820
     /* 11820 */ GIM_Reject,
     /* 11821 */ // Label 442: @11821
     /* 11821 */ GIM_Reject,
     /* 11822 */ // Label 19: @11822
     /* 11822 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 450*/ GIMT_Encode4(11991),
     /* 11833 */ /*GILLT_s32*//*Label 448*/ GIMT_Encode4(11841),
     /* 11837 */ /*GILLT_s64*//*Label 449*/ GIMT_Encode4(11953),
     /* 11841 */ // Label 448: @11841
     /* 11841 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(11952),
     /* 11846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11849 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(11883), // Rule ID 7 //
     /* 11854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11857 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11868 */     // MIs[0] ptr
     /* 11868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11876 */     // (atomic_load_sub:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_sub_i8>>  =>  (ATOMIC_LOAD_SUB_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I8),
     /* 11881 */     GIR_RootConstrainSelectedInstOperands,
     /* 11882 */     // GIR_Coverage, 7,
     /* 11882 */     GIR_Done,
     /* 11883 */   // Label 452: @11883
     /* 11883 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(11917), // Rule ID 8 //
     /* 11888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11902 */     // MIs[0] ptr
     /* 11902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11910 */     // (atomic_load_sub:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_sub_i16>>  =>  (ATOMIC_LOAD_SUB_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I16),
     /* 11915 */     GIR_RootConstrainSelectedInstOperands,
     /* 11916 */     // GIR_Coverage, 8,
     /* 11916 */     GIR_Done,
     /* 11917 */   // Label 453: @11917
     /* 11917 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(11951), // Rule ID 9 //
     /* 11922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11936 */     // MIs[0] ptr
     /* 11936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11944 */     // (atomic_load_sub:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_sub_i32>>  =>  (ATOMIC_LOAD_SUB_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11944 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I32),
     /* 11949 */     GIR_RootConstrainSelectedInstOperands,
     /* 11950 */     // GIR_Coverage, 9,
     /* 11950 */     GIR_Done,
     /* 11951 */   // Label 454: @11951
     /* 11951 */   GIM_Reject,
     /* 11952 */ // Label 451: @11952
     /* 11952 */ GIM_Reject,
     /* 11953 */ // Label 449: @11953
     /* 11953 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(11990), // Rule ID 185 //
     /* 11958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11964 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11975 */   // MIs[0] ptr
     /* 11975 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11983 */   // (atomic_load_sub:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_sub_i64>>  =>  (ATOMIC_LOAD_SUB_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 11983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I64),
     /* 11988 */   GIR_RootConstrainSelectedInstOperands,
     /* 11989 */   // GIR_Coverage, 185,
     /* 11989 */   GIR_Done,
     /* 11990 */ // Label 455: @11990
     /* 11990 */ GIM_Reject,
     /* 11991 */ // Label 450: @11991
     /* 11991 */ GIM_Reject,
     /* 11992 */ // Label 20: @11992
     /* 11992 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 458*/ GIMT_Encode4(12161),
     /* 12003 */ /*GILLT_s32*//*Label 456*/ GIMT_Encode4(12011),
     /* 12007 */ /*GILLT_s64*//*Label 457*/ GIMT_Encode4(12123),
     /* 12011 */ // Label 456: @12011
     /* 12011 */ GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(12122),
     /* 12016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12019 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(12053), // Rule ID 10 //
     /* 12024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12027 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12038 */     // MIs[0] ptr
     /* 12038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12046 */     // (atomic_load_and:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_and_i8>>  =>  (ATOMIC_LOAD_AND_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12046 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I8),
     /* 12051 */     GIR_RootConstrainSelectedInstOperands,
     /* 12052 */     // GIR_Coverage, 10,
     /* 12052 */     GIR_Done,
     /* 12053 */   // Label 460: @12053
     /* 12053 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(12087), // Rule ID 11 //
     /* 12058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12061 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12072 */     // MIs[0] ptr
     /* 12072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12080 */     // (atomic_load_and:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_and_i16>>  =>  (ATOMIC_LOAD_AND_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I16),
     /* 12085 */     GIR_RootConstrainSelectedInstOperands,
     /* 12086 */     // GIR_Coverage, 11,
     /* 12086 */     GIR_Done,
     /* 12087 */   // Label 461: @12087
     /* 12087 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(12121), // Rule ID 12 //
     /* 12092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12095 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12106 */     // MIs[0] ptr
     /* 12106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12114 */     // (atomic_load_and:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_and_i32>>  =>  (ATOMIC_LOAD_AND_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I32),
     /* 12119 */     GIR_RootConstrainSelectedInstOperands,
     /* 12120 */     // GIR_Coverage, 12,
     /* 12120 */     GIR_Done,
     /* 12121 */   // Label 462: @12121
     /* 12121 */   GIM_Reject,
     /* 12122 */ // Label 459: @12122
     /* 12122 */ GIM_Reject,
     /* 12123 */ // Label 457: @12123
     /* 12123 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(12160), // Rule ID 186 //
     /* 12128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12134 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12145 */   // MIs[0] ptr
     /* 12145 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12153 */   // (atomic_load_and:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_and_i64>>  =>  (ATOMIC_LOAD_AND_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I64),
     /* 12158 */   GIR_RootConstrainSelectedInstOperands,
     /* 12159 */   // GIR_Coverage, 186,
     /* 12159 */   GIR_Done,
     /* 12160 */ // Label 463: @12160
     /* 12160 */ GIM_Reject,
     /* 12161 */ // Label 458: @12161
     /* 12161 */ GIM_Reject,
     /* 12162 */ // Label 21: @12162
     /* 12162 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 466*/ GIMT_Encode4(12331),
     /* 12173 */ /*GILLT_s32*//*Label 464*/ GIMT_Encode4(12181),
     /* 12177 */ /*GILLT_s64*//*Label 465*/ GIMT_Encode4(12293),
     /* 12181 */ // Label 464: @12181
     /* 12181 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(12292),
     /* 12186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12189 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(12223), // Rule ID 19 //
     /* 12194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12197 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12208 */     // MIs[0] ptr
     /* 12208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12216 */     // (atomic_load_nand:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i8>>  =>  (ATOMIC_LOAD_NAND_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I8),
     /* 12221 */     GIR_RootConstrainSelectedInstOperands,
     /* 12222 */     // GIR_Coverage, 19,
     /* 12222 */     GIR_Done,
     /* 12223 */   // Label 468: @12223
     /* 12223 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(12257), // Rule ID 20 //
     /* 12228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12242 */     // MIs[0] ptr
     /* 12242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12250 */     // (atomic_load_nand:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i16>>  =>  (ATOMIC_LOAD_NAND_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I16),
     /* 12255 */     GIR_RootConstrainSelectedInstOperands,
     /* 12256 */     // GIR_Coverage, 20,
     /* 12256 */     GIR_Done,
     /* 12257 */   // Label 469: @12257
     /* 12257 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(12291), // Rule ID 21 //
     /* 12262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12265 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12276 */     // MIs[0] ptr
     /* 12276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12284 */     // (atomic_load_nand:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>>  =>  (ATOMIC_LOAD_NAND_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I32),
     /* 12289 */     GIR_RootConstrainSelectedInstOperands,
     /* 12290 */     // GIR_Coverage, 21,
     /* 12290 */     GIR_Done,
     /* 12291 */   // Label 470: @12291
     /* 12291 */   GIM_Reject,
     /* 12292 */ // Label 467: @12292
     /* 12292 */ GIM_Reject,
     /* 12293 */ // Label 465: @12293
     /* 12293 */ GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(12330), // Rule ID 189 //
     /* 12298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12304 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12315 */   // MIs[0] ptr
     /* 12315 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12323 */   // (atomic_load_nand:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>>  =>  (ATOMIC_LOAD_NAND_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I64),
     /* 12328 */   GIR_RootConstrainSelectedInstOperands,
     /* 12329 */   // GIR_Coverage, 189,
     /* 12329 */   GIR_Done,
     /* 12330 */ // Label 471: @12330
     /* 12330 */ GIM_Reject,
     /* 12331 */ // Label 466: @12331
     /* 12331 */ GIM_Reject,
     /* 12332 */ // Label 22: @12332
     /* 12332 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 474*/ GIMT_Encode4(12501),
     /* 12343 */ /*GILLT_s32*//*Label 472*/ GIMT_Encode4(12351),
     /* 12347 */ /*GILLT_s64*//*Label 473*/ GIMT_Encode4(12463),
     /* 12351 */ // Label 472: @12351
     /* 12351 */ GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(12462),
     /* 12356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12359 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(12393), // Rule ID 13 //
     /* 12364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12367 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12378 */     // MIs[0] ptr
     /* 12378 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12386 */     // (atomic_load_or:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_or_i8>>  =>  (ATOMIC_LOAD_OR_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I8),
     /* 12391 */     GIR_RootConstrainSelectedInstOperands,
     /* 12392 */     // GIR_Coverage, 13,
     /* 12392 */     GIR_Done,
     /* 12393 */   // Label 476: @12393
     /* 12393 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(12427), // Rule ID 14 //
     /* 12398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12412 */     // MIs[0] ptr
     /* 12412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12420 */     // (atomic_load_or:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_or_i16>>  =>  (ATOMIC_LOAD_OR_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I16),
     /* 12425 */     GIR_RootConstrainSelectedInstOperands,
     /* 12426 */     // GIR_Coverage, 14,
     /* 12426 */     GIR_Done,
     /* 12427 */   // Label 477: @12427
     /* 12427 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(12461), // Rule ID 15 //
     /* 12432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12435 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12446 */     // MIs[0] ptr
     /* 12446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12454 */     // (atomic_load_or:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_or_i32>>  =>  (ATOMIC_LOAD_OR_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I32),
     /* 12459 */     GIR_RootConstrainSelectedInstOperands,
     /* 12460 */     // GIR_Coverage, 15,
     /* 12460 */     GIR_Done,
     /* 12461 */   // Label 478: @12461
     /* 12461 */   GIM_Reject,
     /* 12462 */ // Label 475: @12462
     /* 12462 */ GIM_Reject,
     /* 12463 */ // Label 473: @12463
     /* 12463 */ GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(12500), // Rule ID 187 //
     /* 12468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12474 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12485 */   // MIs[0] ptr
     /* 12485 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12489 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12493 */   // (atomic_load_or:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_or_i64>>  =>  (ATOMIC_LOAD_OR_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I64),
     /* 12498 */   GIR_RootConstrainSelectedInstOperands,
     /* 12499 */   // GIR_Coverage, 187,
     /* 12499 */   GIR_Done,
     /* 12500 */ // Label 479: @12500
     /* 12500 */ GIM_Reject,
     /* 12501 */ // Label 474: @12501
     /* 12501 */ GIM_Reject,
     /* 12502 */ // Label 23: @12502
     /* 12502 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 482*/ GIMT_Encode4(12671),
     /* 12513 */ /*GILLT_s32*//*Label 480*/ GIMT_Encode4(12521),
     /* 12517 */ /*GILLT_s64*//*Label 481*/ GIMT_Encode4(12633),
     /* 12521 */ // Label 480: @12521
     /* 12521 */ GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(12632),
     /* 12526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12529 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(12563), // Rule ID 16 //
     /* 12534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12537 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12548 */     // MIs[0] ptr
     /* 12548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12556 */     // (atomic_load_xor:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_xor_i8>>  =>  (ATOMIC_LOAD_XOR_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I8),
     /* 12561 */     GIR_RootConstrainSelectedInstOperands,
     /* 12562 */     // GIR_Coverage, 16,
     /* 12562 */     GIR_Done,
     /* 12563 */   // Label 484: @12563
     /* 12563 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(12597), // Rule ID 17 //
     /* 12568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12571 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12582 */     // MIs[0] ptr
     /* 12582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12590 */     // (atomic_load_xor:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_xor_i16>>  =>  (ATOMIC_LOAD_XOR_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I16),
     /* 12595 */     GIR_RootConstrainSelectedInstOperands,
     /* 12596 */     // GIR_Coverage, 17,
     /* 12596 */     GIR_Done,
     /* 12597 */   // Label 485: @12597
     /* 12597 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(12631), // Rule ID 18 //
     /* 12602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12605 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12616 */     // MIs[0] ptr
     /* 12616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12624 */     // (atomic_load_xor:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_xor_i32>>  =>  (ATOMIC_LOAD_XOR_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I32),
     /* 12629 */     GIR_RootConstrainSelectedInstOperands,
     /* 12630 */     // GIR_Coverage, 18,
     /* 12630 */     GIR_Done,
     /* 12631 */   // Label 486: @12631
     /* 12631 */   GIM_Reject,
     /* 12632 */ // Label 483: @12632
     /* 12632 */ GIM_Reject,
     /* 12633 */ // Label 481: @12633
     /* 12633 */ GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(12670), // Rule ID 188 //
     /* 12638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12644 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12655 */   // MIs[0] ptr
     /* 12655 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12663 */   // (atomic_load_xor:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_xor_i64>>  =>  (ATOMIC_LOAD_XOR_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I64),
     /* 12668 */   GIR_RootConstrainSelectedInstOperands,
     /* 12669 */   // GIR_Coverage, 188,
     /* 12669 */   GIR_Done,
     /* 12670 */ // Label 487: @12670
     /* 12670 */ GIM_Reject,
     /* 12671 */ // Label 482: @12671
     /* 12671 */ GIM_Reject,
     /* 12672 */ // Label 24: @12672
     /* 12672 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 490*/ GIMT_Encode4(12841),
     /* 12683 */ /*GILLT_s32*//*Label 488*/ GIMT_Encode4(12691),
     /* 12687 */ /*GILLT_s64*//*Label 489*/ GIMT_Encode4(12803),
     /* 12691 */ // Label 488: @12691
     /* 12691 */ GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(12802),
     /* 12696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12699 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(12733), // Rule ID 31 //
     /* 12704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12707 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12718 */     // MIs[0] ptr
     /* 12718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12726 */     // (atomic_load_max:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_max_i8>>  =>  (ATOMIC_LOAD_MAX_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I8),
     /* 12731 */     GIR_RootConstrainSelectedInstOperands,
     /* 12732 */     // GIR_Coverage, 31,
     /* 12732 */     GIR_Done,
     /* 12733 */   // Label 492: @12733
     /* 12733 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(12767), // Rule ID 32 //
     /* 12738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12741 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12752 */     // MIs[0] ptr
     /* 12752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12760 */     // (atomic_load_max:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_max_i16>>  =>  (ATOMIC_LOAD_MAX_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12760 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I16),
     /* 12765 */     GIR_RootConstrainSelectedInstOperands,
     /* 12766 */     // GIR_Coverage, 32,
     /* 12766 */     GIR_Done,
     /* 12767 */   // Label 493: @12767
     /* 12767 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(12801), // Rule ID 33 //
     /* 12772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12775 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12786 */     // MIs[0] ptr
     /* 12786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12794 */     // (atomic_load_max:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_max_i32>>  =>  (ATOMIC_LOAD_MAX_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I32),
     /* 12799 */     GIR_RootConstrainSelectedInstOperands,
     /* 12800 */     // GIR_Coverage, 33,
     /* 12800 */     GIR_Done,
     /* 12801 */   // Label 494: @12801
     /* 12801 */   GIM_Reject,
     /* 12802 */ // Label 491: @12802
     /* 12802 */ GIM_Reject,
     /* 12803 */ // Label 489: @12803
     /* 12803 */ GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(12840), // Rule ID 193 //
     /* 12808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12814 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12825 */   // MIs[0] ptr
     /* 12825 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12833 */   // (atomic_load_max:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_max_i64>>  =>  (ATOMIC_LOAD_MAX_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I64),
     /* 12838 */   GIR_RootConstrainSelectedInstOperands,
     /* 12839 */   // GIR_Coverage, 193,
     /* 12839 */   GIR_Done,
     /* 12840 */ // Label 495: @12840
     /* 12840 */ GIM_Reject,
     /* 12841 */ // Label 490: @12841
     /* 12841 */ GIM_Reject,
     /* 12842 */ // Label 25: @12842
     /* 12842 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 498*/ GIMT_Encode4(13011),
     /* 12853 */ /*GILLT_s32*//*Label 496*/ GIMT_Encode4(12861),
     /* 12857 */ /*GILLT_s64*//*Label 497*/ GIMT_Encode4(12973),
     /* 12861 */ // Label 496: @12861
     /* 12861 */ GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(12972),
     /* 12866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12869 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(12903), // Rule ID 28 //
     /* 12874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12877 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12888 */     // MIs[0] ptr
     /* 12888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12896 */     // (atomic_load_min:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_min_i8>>  =>  (ATOMIC_LOAD_MIN_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I8),
     /* 12901 */     GIR_RootConstrainSelectedInstOperands,
     /* 12902 */     // GIR_Coverage, 28,
     /* 12902 */     GIR_Done,
     /* 12903 */   // Label 500: @12903
     /* 12903 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(12937), // Rule ID 29 //
     /* 12908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12911 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12922 */     // MIs[0] ptr
     /* 12922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12930 */     // (atomic_load_min:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_min_i16>>  =>  (ATOMIC_LOAD_MIN_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I16),
     /* 12935 */     GIR_RootConstrainSelectedInstOperands,
     /* 12936 */     // GIR_Coverage, 29,
     /* 12936 */     GIR_Done,
     /* 12937 */   // Label 501: @12937
     /* 12937 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(12971), // Rule ID 30 //
     /* 12942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12945 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12956 */     // MIs[0] ptr
     /* 12956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12964 */     // (atomic_load_min:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_min_i32>>  =>  (ATOMIC_LOAD_MIN_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12964 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I32),
     /* 12969 */     GIR_RootConstrainSelectedInstOperands,
     /* 12970 */     // GIR_Coverage, 30,
     /* 12970 */     GIR_Done,
     /* 12971 */   // Label 502: @12971
     /* 12971 */   GIM_Reject,
     /* 12972 */ // Label 499: @12972
     /* 12972 */ GIM_Reject,
     /* 12973 */ // Label 497: @12973
     /* 12973 */ GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(13010), // Rule ID 192 //
     /* 12978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12984 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12995 */   // MIs[0] ptr
     /* 12995 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13003 */   // (atomic_load_min:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_min_i64>>  =>  (ATOMIC_LOAD_MIN_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 13003 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I64),
     /* 13008 */   GIR_RootConstrainSelectedInstOperands,
     /* 13009 */   // GIR_Coverage, 192,
     /* 13009 */   GIR_Done,
     /* 13010 */ // Label 503: @13010
     /* 13010 */ GIM_Reject,
     /* 13011 */ // Label 498: @13011
     /* 13011 */ GIM_Reject,
     /* 13012 */ // Label 26: @13012
     /* 13012 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 506*/ GIMT_Encode4(13181),
     /* 13023 */ /*GILLT_s32*//*Label 504*/ GIMT_Encode4(13031),
     /* 13027 */ /*GILLT_s64*//*Label 505*/ GIMT_Encode4(13143),
     /* 13031 */ // Label 504: @13031
     /* 13031 */ GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(13142),
     /* 13036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13039 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(13073), // Rule ID 37 //
     /* 13044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13047 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 13054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13058 */     // MIs[0] ptr
     /* 13058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13066 */     // (atomic_load_umax:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umax_i8>>  =>  (ATOMIC_LOAD_UMAX_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I8),
     /* 13071 */     GIR_RootConstrainSelectedInstOperands,
     /* 13072 */     // GIR_Coverage, 37,
     /* 13072 */     GIR_Done,
     /* 13073 */   // Label 508: @13073
     /* 13073 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(13107), // Rule ID 38 //
     /* 13078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13081 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 13088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13092 */     // MIs[0] ptr
     /* 13092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13100 */     // (atomic_load_umax:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umax_i16>>  =>  (ATOMIC_LOAD_UMAX_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I16),
     /* 13105 */     GIR_RootConstrainSelectedInstOperands,
     /* 13106 */     // GIR_Coverage, 38,
     /* 13106 */     GIR_Done,
     /* 13107 */   // Label 509: @13107
     /* 13107 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(13141), // Rule ID 39 //
     /* 13112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13115 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 13122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13126 */     // MIs[0] ptr
     /* 13126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13134 */     // (atomic_load_umax:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umax_i32>>  =>  (ATOMIC_LOAD_UMAX_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I32),
     /* 13139 */     GIR_RootConstrainSelectedInstOperands,
     /* 13140 */     // GIR_Coverage, 39,
     /* 13140 */     GIR_Done,
     /* 13141 */   // Label 510: @13141
     /* 13141 */   GIM_Reject,
     /* 13142 */ // Label 507: @13142
     /* 13142 */ GIM_Reject,
     /* 13143 */ // Label 505: @13143
     /* 13143 */ GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(13180), // Rule ID 195 //
     /* 13148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 13154 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 13161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13165 */   // MIs[0] ptr
     /* 13165 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13169 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13173 */   // (atomic_load_umax:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_umax_i64>>  =>  (ATOMIC_LOAD_UMAX_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 13173 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I64),
     /* 13178 */   GIR_RootConstrainSelectedInstOperands,
     /* 13179 */   // GIR_Coverage, 195,
     /* 13179 */   GIR_Done,
     /* 13180 */ // Label 511: @13180
     /* 13180 */ GIM_Reject,
     /* 13181 */ // Label 506: @13181
     /* 13181 */ GIM_Reject,
     /* 13182 */ // Label 27: @13182
     /* 13182 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 514*/ GIMT_Encode4(13351),
     /* 13193 */ /*GILLT_s32*//*Label 512*/ GIMT_Encode4(13201),
     /* 13197 */ /*GILLT_s64*//*Label 513*/ GIMT_Encode4(13313),
     /* 13201 */ // Label 512: @13201
     /* 13201 */ GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(13312),
     /* 13206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13209 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(13243), // Rule ID 34 //
     /* 13214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13217 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 13224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13228 */     // MIs[0] ptr
     /* 13228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13236 */     // (atomic_load_umin:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umin_i8>>  =>  (ATOMIC_LOAD_UMIN_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I8),
     /* 13241 */     GIR_RootConstrainSelectedInstOperands,
     /* 13242 */     // GIR_Coverage, 34,
     /* 13242 */     GIR_Done,
     /* 13243 */   // Label 516: @13243
     /* 13243 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(13277), // Rule ID 35 //
     /* 13248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13251 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 13258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13262 */     // MIs[0] ptr
     /* 13262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13270 */     // (atomic_load_umin:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umin_i16>>  =>  (ATOMIC_LOAD_UMIN_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I16),
     /* 13275 */     GIR_RootConstrainSelectedInstOperands,
     /* 13276 */     // GIR_Coverage, 35,
     /* 13276 */     GIR_Done,
     /* 13277 */   // Label 517: @13277
     /* 13277 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(13311), // Rule ID 36 //
     /* 13282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13285 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 13292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13296 */     // MIs[0] ptr
     /* 13296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13304 */     // (atomic_load_umin:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umin_i32>>  =>  (ATOMIC_LOAD_UMIN_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I32),
     /* 13309 */     GIR_RootConstrainSelectedInstOperands,
     /* 13310 */     // GIR_Coverage, 36,
     /* 13310 */     GIR_Done,
     /* 13311 */   // Label 518: @13311
     /* 13311 */   GIM_Reject,
     /* 13312 */ // Label 515: @13312
     /* 13312 */ GIM_Reject,
     /* 13313 */ // Label 513: @13313
     /* 13313 */ GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(13350), // Rule ID 194 //
     /* 13318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 13324 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 13331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13335 */   // MIs[0] ptr
     /* 13335 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13339 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13343 */   // (atomic_load_umin:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_umin_i64>>  =>  (ATOMIC_LOAD_UMIN_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 13343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I64),
     /* 13348 */   GIR_RootConstrainSelectedInstOperands,
     /* 13349 */   // GIR_Coverage, 194,
     /* 13349 */   GIR_Done,
     /* 13350 */ // Label 519: @13350
     /* 13350 */ GIM_Reject,
     /* 13351 */ // Label 514: @13351
     /* 13351 */ GIM_Reject,
     /* 13352 */ // Label 28: @13352
     /* 13352 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 522*/ GIMT_Encode4(18072),
     /* 13363 */ /*GILLT_s32*//*Label 520*/ GIMT_Encode4(13371),
     /* 13367 */ /*GILLT_s64*//*Label 521*/ GIMT_Encode4(18038),
     /* 13371 */ // Label 520: @13371
     /* 13371 */ GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(13479), // Rule ID 2365 //
     /* 13376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13379 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13383 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13387 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13391 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13395 */   // MIs[1] Operand 1
     /* 13395 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13400 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13404 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13408 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13412 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13416 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13420 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13424 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13428 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13432 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 13436 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13440 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13444 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13448 */   // MIs[4] Operand 1
     /* 13448 */   // No operand predicates
     /* 13448 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13453 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13457 */   // MIs[0] offset
     /* 13457 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13460 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13462 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT0 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT0),
     /* 13465 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13469 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13472 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13474 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13477 */   GIR_RootConstrainSelectedInstOperands,
     /* 13478 */   // GIR_Coverage, 2365,
     /* 13478 */   GIR_EraseRootFromParent_Done,
     /* 13479 */ // Label 523: @13479
     /* 13479 */ GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(13594), // Rule ID 2366 //
     /* 13484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13487 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13491 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13495 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13499 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13503 */   // MIs[1] Operand 1
     /* 13503 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13508 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13512 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13516 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13520 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13524 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13528 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13532 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13536 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13540 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 13551 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13555 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13559 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13563 */   // MIs[4] Operand 1
     /* 13563 */   // No operand predicates
     /* 13563 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13568 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13572 */   // MIs[0] offset
     /* 13572 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13575 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13577 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT032 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT032),
     /* 13580 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13584 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13587 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13589 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13592 */   GIR_RootConstrainSelectedInstOperands,
     /* 13593 */   // GIR_Coverage, 2366,
     /* 13593 */   GIR_EraseRootFromParent_Done,
     /* 13594 */ // Label 524: @13594
     /* 13594 */ GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(13702), // Rule ID 2367 //
     /* 13599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13602 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13606 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13610 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13614 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13618 */   // MIs[1] Operand 1
     /* 13618 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 13623 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13627 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13631 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13635 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13639 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13643 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13647 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13651 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13655 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 13659 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13663 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13667 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13671 */   // MIs[4] Operand 1
     /* 13671 */   // No operand predicates
     /* 13671 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13676 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13680 */   // MIs[0] offset
     /* 13680 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13683 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13685 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT1 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT1),
     /* 13688 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13692 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13695 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13697 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13700 */   GIR_RootConstrainSelectedInstOperands,
     /* 13701 */   // GIR_Coverage, 2367,
     /* 13701 */   GIR_EraseRootFromParent_Done,
     /* 13702 */ // Label 525: @13702
     /* 13702 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(13817), // Rule ID 2368 //
     /* 13707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13710 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13714 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13718 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13722 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13726 */   // MIs[1] Operand 1
     /* 13726 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 13731 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13735 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13739 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13743 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13747 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13751 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13755 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13759 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13763 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 13774 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13778 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13782 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13786 */   // MIs[4] Operand 1
     /* 13786 */   // No operand predicates
     /* 13786 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13791 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13795 */   // MIs[0] offset
     /* 13795 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13798 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13800 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT132 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT132),
     /* 13803 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13807 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13810 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13812 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13815 */   GIR_RootConstrainSelectedInstOperands,
     /* 13816 */   // GIR_Coverage, 2368,
     /* 13816 */   GIR_EraseRootFromParent_Done,
     /* 13817 */ // Label 526: @13817
     /* 13817 */ GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(13925), // Rule ID 270 //
     /* 13822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13825 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13829 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13833 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13837 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13841 */   // MIs[1] Operand 1
     /* 13841 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13846 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13850 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13854 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13858 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13862 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13867 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 13871 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13875 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13879 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13883 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 13887 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13891 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13895 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13899 */   // MIs[4] Operand 1
     /* 13899 */   // No operand predicates
     /* 13899 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13903 */   // MIs[0] offset
     /* 13903 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13906 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13908 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT0 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT0),
     /* 13911 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 13915 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13918 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13920 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13923 */   GIR_RootConstrainSelectedInstOperands,
     /* 13924 */   // GIR_Coverage, 270,
     /* 13924 */   GIR_EraseRootFromParent_Done,
     /* 13925 */ // Label 527: @13925
     /* 13925 */ GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(14040), // Rule ID 271 //
     /* 13930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13933 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13937 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13941 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13945 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13949 */   // MIs[1] Operand 1
     /* 13949 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13954 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13958 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13962 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13966 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13970 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13975 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 13979 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13983 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13987 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13991 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 14002 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 14006 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 14010 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 14014 */   // MIs[4] Operand 1
     /* 14014 */   // No operand predicates
     /* 14014 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14018 */   // MIs[0] offset
     /* 14018 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14021 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 14023 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT032 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 14023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT032),
     /* 14026 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 14030 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 14033 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14035 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14038 */   GIR_RootConstrainSelectedInstOperands,
     /* 14039 */   // GIR_Coverage, 271,
     /* 14039 */   GIR_EraseRootFromParent_Done,
     /* 14040 */ // Label 528: @14040
     /* 14040 */ GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(14148), // Rule ID 272 //
     /* 14045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 14048 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14052 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14056 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14060 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14064 */   // MIs[1] Operand 1
     /* 14064 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 14069 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 14073 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 14077 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 14081 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14085 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14090 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 14094 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 14098 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 14102 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 14106 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 14110 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 14114 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 14118 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 14122 */   // MIs[4] Operand 1
     /* 14122 */   // No operand predicates
     /* 14122 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14126 */   // MIs[0] offset
     /* 14126 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14129 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 14131 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT1 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 14131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT1),
     /* 14134 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 14138 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 14141 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14143 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14146 */   GIR_RootConstrainSelectedInstOperands,
     /* 14147 */   // GIR_Coverage, 272,
     /* 14147 */   GIR_EraseRootFromParent_Done,
     /* 14148 */ // Label 529: @14148
     /* 14148 */ GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(14263), // Rule ID 273 //
     /* 14153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 14156 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14160 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14164 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14168 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14172 */   // MIs[1] Operand 1
     /* 14172 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 14177 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 14181 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 14185 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 14189 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14193 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14198 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 14202 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 14206 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 14210 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 14214 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 14225 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 14229 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 14233 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 14237 */   // MIs[4] Operand 1
     /* 14237 */   // No operand predicates
     /* 14237 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14241 */   // MIs[0] offset
     /* 14241 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14244 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 14246 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT132 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 14246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT132),
     /* 14249 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 14253 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 14256 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14258 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14261 */   GIR_RootConstrainSelectedInstOperands,
     /* 14262 */   // GIR_Coverage, 273,
     /* 14262 */   GIR_EraseRootFromParent_Done,
     /* 14263 */ // Label 530: @14263
     /* 14263 */ GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(14320), // Rule ID 94 //
     /* 14268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14271 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14275 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14279 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14283 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14287 */   // MIs[1] Operand 1
     /* 14287 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 14292 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14297 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14301 */   // MIs[0] offset
     /* 14301 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14304 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14306 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGEZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ),
     /* 14309 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14313 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14315 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14318 */   GIR_RootConstrainSelectedInstOperands,
     /* 14319 */   // GIR_Coverage, 94,
     /* 14319 */   GIR_EraseRootFromParent_Done,
     /* 14320 */ // Label 531: @14320
     /* 14320 */ GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(14377), // Rule ID 95 //
     /* 14325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14328 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14332 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14336 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14340 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14344 */   // MIs[1] Operand 1
     /* 14344 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 14349 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14354 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14358 */   // MIs[0] offset
     /* 14358 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14361 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14363 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGTZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGTZ),
     /* 14366 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14370 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14372 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14375 */   GIR_RootConstrainSelectedInstOperands,
     /* 14376 */   // GIR_Coverage, 95,
     /* 14376 */   GIR_EraseRootFromParent_Done,
     /* 14377 */ // Label 532: @14377
     /* 14377 */ GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(14434), // Rule ID 96 //
     /* 14382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14385 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14389 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14393 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14397 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14401 */   // MIs[1] Operand 1
     /* 14401 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 14406 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14411 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14415 */   // MIs[0] offset
     /* 14415 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14418 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14420 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLEZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ),
     /* 14423 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14427 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14429 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14432 */   GIR_RootConstrainSelectedInstOperands,
     /* 14433 */   // GIR_Coverage, 96,
     /* 14433 */   GIR_EraseRootFromParent_Done,
     /* 14434 */ // Label 533: @14434
     /* 14434 */ GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(14491), // Rule ID 97 //
     /* 14439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14442 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14446 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14450 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14454 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14458 */   // MIs[1] Operand 1
     /* 14458 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 14463 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14468 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14472 */   // MIs[0] offset
     /* 14472 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14475 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14477 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLTZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLTZ),
     /* 14480 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14484 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14486 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14489 */   GIR_RootConstrainSelectedInstOperands,
     /* 14490 */   // GIR_Coverage, 97,
     /* 14490 */   GIR_EraseRootFromParent_Done,
     /* 14491 */ // Label 534: @14491
     /* 14491 */ GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(14548), // Rule ID 245 //
     /* 14496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14499 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14507 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14511 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14515 */   // MIs[1] Operand 1
     /* 14515 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 14520 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14525 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14529 */   // MIs[0] offset
     /* 14529 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14532 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14534 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGEZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ64),
     /* 14537 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14541 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14543 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14546 */   GIR_RootConstrainSelectedInstOperands,
     /* 14547 */   // GIR_Coverage, 245,
     /* 14547 */   GIR_EraseRootFromParent_Done,
     /* 14548 */ // Label 535: @14548
     /* 14548 */ GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(14605), // Rule ID 246 //
     /* 14553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14556 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14564 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14568 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14572 */   // MIs[1] Operand 1
     /* 14572 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 14577 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14582 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14586 */   // MIs[0] offset
     /* 14586 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14589 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14591 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGTZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGTZ64),
     /* 14594 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14598 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14600 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14603 */   GIR_RootConstrainSelectedInstOperands,
     /* 14604 */   // GIR_Coverage, 246,
     /* 14604 */   GIR_EraseRootFromParent_Done,
     /* 14605 */ // Label 536: @14605
     /* 14605 */ GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(14662), // Rule ID 247 //
     /* 14610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14613 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14617 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14621 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14625 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14629 */   // MIs[1] Operand 1
     /* 14629 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 14634 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14639 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14643 */   // MIs[0] offset
     /* 14643 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14646 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14648 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLEZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ64),
     /* 14651 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14655 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14657 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14660 */   GIR_RootConstrainSelectedInstOperands,
     /* 14661 */   // GIR_Coverage, 247,
     /* 14661 */   GIR_EraseRootFromParent_Done,
     /* 14662 */ // Label 537: @14662
     /* 14662 */ GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(14719), // Rule ID 248 //
     /* 14667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14670 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14674 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14678 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14682 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14686 */   // MIs[1] Operand 1
     /* 14686 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 14691 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14696 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14700 */   // MIs[0] offset
     /* 14700 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14703 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14705 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLTZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLTZ64),
     /* 14708 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14712 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14714 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14717 */   GIR_RootConstrainSelectedInstOperands,
     /* 14718 */   // GIR_Coverage, 248,
     /* 14718 */   GIR_EraseRootFromParent_Done,
     /* 14719 */ // Label 538: @14719
     /* 14719 */ GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(14776), // Rule ID 1109 //
     /* 14724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14735 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14739 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14743 */   // MIs[1] Operand 1
     /* 14743 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 14748 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14753 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14757 */   // MIs[0] offset
     /* 14757 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14760 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14762 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGEZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ_MM),
     /* 14765 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14769 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14771 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14774 */   GIR_RootConstrainSelectedInstOperands,
     /* 14775 */   // GIR_Coverage, 1109,
     /* 14775 */   GIR_EraseRootFromParent_Done,
     /* 14776 */ // Label 539: @14776
     /* 14776 */ GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(14833), // Rule ID 1110 //
     /* 14781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14784 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14788 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14792 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14796 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14800 */   // MIs[1] Operand 1
     /* 14800 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 14805 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14810 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14814 */   // MIs[0] offset
     /* 14814 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14817 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14819 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGTZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGTZ_MM),
     /* 14822 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14826 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14828 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14831 */   GIR_RootConstrainSelectedInstOperands,
     /* 14832 */   // GIR_Coverage, 1110,
     /* 14832 */   GIR_EraseRootFromParent_Done,
     /* 14833 */ // Label 540: @14833
     /* 14833 */ GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(14890), // Rule ID 1111 //
     /* 14838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14841 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14845 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14849 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14853 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14857 */   // MIs[1] Operand 1
     /* 14857 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 14862 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14867 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14871 */   // MIs[0] offset
     /* 14871 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14874 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14876 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLEZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ_MM),
     /* 14879 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14883 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14885 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14888 */   GIR_RootConstrainSelectedInstOperands,
     /* 14889 */   // GIR_Coverage, 1111,
     /* 14889 */   GIR_EraseRootFromParent_Done,
     /* 14890 */ // Label 541: @14890
     /* 14890 */ GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(14947), // Rule ID 1112 //
     /* 14895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14898 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14906 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14910 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14914 */   // MIs[1] Operand 1
     /* 14914 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 14919 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14924 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14928 */   // MIs[0] offset
     /* 14928 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14931 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14933 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLTZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLTZ_MM),
     /* 14936 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14940 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14942 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14945 */   GIR_RootConstrainSelectedInstOperands,
     /* 14946 */   // GIR_Coverage, 1112,
     /* 14946 */   GIR_EraseRootFromParent_Done,
     /* 14947 */ // Label 542: @14947
     /* 14947 */ GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(15010), // Rule ID 1402 //
     /* 14952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14955 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14959 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14963 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14967 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14971 */   // MIs[1] Operand 1
     /* 14971 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 14976 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14981 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14985 */   // MIs[0] dst
     /* 14985 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14988 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14990 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNE GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 14990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE),
     /* 14993 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 14997 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15003 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15005 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15008 */   GIR_RootConstrainSelectedInstOperands,
     /* 15009 */   // GIR_Coverage, 1402,
     /* 15009 */   GIR_EraseRootFromParent_Done,
     /* 15010 */ // Label 543: @15010
     /* 15010 */ GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(15073), // Rule ID 1403 //
     /* 15015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15018 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15022 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15026 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15030 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15034 */   // MIs[1] Operand 1
     /* 15034 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15039 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15044 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15048 */   // MIs[0] dst
     /* 15048 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15053 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 15053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 15056 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15060 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15066 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15068 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15071 */   GIR_RootConstrainSelectedInstOperands,
     /* 15072 */   // GIR_Coverage, 1403,
     /* 15072 */   GIR_EraseRootFromParent_Done,
     /* 15073 */ // Label 544: @15073
     /* 15073 */ GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(15136), // Rule ID 1548 //
     /* 15078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15081 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15085 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15089 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15093 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15097 */   // MIs[1] Operand 1
     /* 15097 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15102 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 15107 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15111 */   // MIs[0] dst
     /* 15111 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15114 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15116 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNE64 GPR64:{ *:[i64] }:$lhs, ZERO_64:{ *:[i64] }, (bb:{ *:[Other] }):$dst)
     /* 15116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE64),
     /* 15119 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15123 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15129 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15131 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15134 */   GIR_RootConstrainSelectedInstOperands,
     /* 15135 */   // GIR_Coverage, 1548,
     /* 15135 */   GIR_EraseRootFromParent_Done,
     /* 15136 */ // Label 545: @15136
     /* 15136 */ GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(15199), // Rule ID 1549 //
     /* 15141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15144 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15148 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15152 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15156 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15160 */   // MIs[1] Operand 1
     /* 15160 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15165 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 15170 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15174 */   // MIs[0] dst
     /* 15174 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15177 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15179 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ64 GPR64:{ *:[i64] }:$lhs, ZERO_64:{ *:[i64] }, (bb:{ *:[Other] }):$dst)
     /* 15179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ64),
     /* 15182 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15186 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15192 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15194 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15197 */   GIR_RootConstrainSelectedInstOperands,
     /* 15198 */   // GIR_Coverage, 1549,
     /* 15198 */   GIR_EraseRootFromParent_Done,
     /* 15199 */ // Label 546: @15199
     /* 15199 */ GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(15253), // Rule ID 1856 //
     /* 15204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 15207 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15211 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15215 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15219 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15223 */   // MIs[1] Operand 1
     /* 15223 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15228 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 15233 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15237 */   // MIs[0] targ16
     /* 15237 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15240 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15242 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$targ16)  =>  (BeqzRxImm16 CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)
     /* 15242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BeqzRxImm16),
     /* 15245 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 15249 */   GIR_RootToRootCopy, /*OpIdx*/1, // targ16
     /* 15251 */   GIR_RootConstrainSelectedInstOperands,
     /* 15252 */   // GIR_Coverage, 1856,
     /* 15252 */   GIR_EraseRootFromParent_Done,
     /* 15253 */ // Label 547: @15253
     /* 15253 */ GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(15307), // Rule ID 1865 //
     /* 15258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 15261 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15265 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15269 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15273 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15277 */   // MIs[1] Operand 1
     /* 15277 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15282 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 15287 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15291 */   // MIs[0] targ16
     /* 15291 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15294 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15296 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$targ16)  =>  (BnezRxImm16 CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)
     /* 15296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BnezRxImm16),
     /* 15299 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 15303 */   GIR_RootToRootCopy, /*OpIdx*/1, // targ16
     /* 15305 */   GIR_RootConstrainSelectedInstOperands,
     /* 15306 */   // GIR_Coverage, 1865,
     /* 15306 */   GIR_EraseRootFromParent_Done,
     /* 15307 */ // Label 548: @15307
     /* 15307 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(15370), // Rule ID 2195 //
     /* 15312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15315 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15319 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15323 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15327 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15331 */   // MIs[1] Operand 1
     /* 15331 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15336 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15341 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15345 */   // MIs[0] dst
     /* 15345 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15348 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15350 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNE_MM GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 15350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE_MM),
     /* 15353 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15357 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15363 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15365 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15368 */   GIR_RootConstrainSelectedInstOperands,
     /* 15369 */   // GIR_Coverage, 2195,
     /* 15369 */   GIR_EraseRootFromParent_Done,
     /* 15370 */ // Label 549: @15370
     /* 15370 */ GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(15433), // Rule ID 2196 //
     /* 15375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15378 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15382 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15386 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15390 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15394 */   // MIs[1] Operand 1
     /* 15394 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15399 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15404 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15408 */   // MIs[0] dst
     /* 15408 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15411 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15413 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 15413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 15416 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15420 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15426 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15428 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15431 */   GIR_RootConstrainSelectedInstOperands,
     /* 15432 */   // GIR_Coverage, 2196,
     /* 15432 */   GIR_EraseRootFromParent_Done,
     /* 15433 */ // Label 550: @15433
     /* 15433 */ GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(15490), // Rule ID 2342 //
     /* 15438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 15441 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15445 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15449 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15453 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15457 */   // MIs[1] Operand 1
     /* 15457 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15462 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15467 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15471 */   // MIs[0] dst
     /* 15471 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15474 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15476 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNEZC_MMR6 GPR32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNEZC_MMR6),
     /* 15479 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15483 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15485 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15488 */   GIR_RootConstrainSelectedInstOperands,
     /* 15489 */   // GIR_Coverage, 2342,
     /* 15489 */   GIR_EraseRootFromParent_Done,
     /* 15490 */ // Label 551: @15490
     /* 15490 */ GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(15547), // Rule ID 2343 //
     /* 15495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 15498 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15502 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15506 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15510 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15514 */   // MIs[1] Operand 1
     /* 15514 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15519 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15524 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15528 */   // MIs[0] dst
     /* 15528 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15531 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15533 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 GPR32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 15536 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15540 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15542 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15545 */   GIR_RootConstrainSelectedInstOperands,
     /* 15546 */   // GIR_Coverage, 2343,
     /* 15546 */   GIR_EraseRootFromParent_Done,
     /* 15547 */ // Label 552: @15547
     /* 15547 */ GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(15599), // Rule ID 1413 //
     /* 15552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15555 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15559 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15563 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15567 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15571 */   // MIs[1] Operand 1
     /* 15571 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 15576 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 1,
     /* 15580 */   // MIs[0] dst
     /* 15580 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15583 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15585 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, 1:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BLEZ i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ),
     /* 15588 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15592 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15594 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15597 */   GIR_RootConstrainSelectedInstOperands,
     /* 15598 */   // GIR_Coverage, 1413,
     /* 15598 */   GIR_EraseRootFromParent_Done,
     /* 15599 */ // Label 553: @15599
     /* 15599 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(15651), // Rule ID 1414 //
     /* 15604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15607 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15611 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15615 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15619 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15623 */   // MIs[1] Operand 1
     /* 15623 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 15628 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 15632 */   // MIs[0] dst
     /* 15632 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15635 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15637 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, -1:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BGEZ i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ),
     /* 15640 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15644 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15646 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15649 */   GIR_RootConstrainSelectedInstOperands,
     /* 15650 */   // GIR_Coverage, 1414,
     /* 15650 */   GIR_EraseRootFromParent_Done,
     /* 15651 */ // Label 554: @15651
     /* 15651 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(15703), // Rule ID 1559 //
     /* 15656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15659 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15663 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15667 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15671 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15675 */   // MIs[1] Operand 1
     /* 15675 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 15680 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 1,
     /* 15684 */   // MIs[0] dst
     /* 15684 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15687 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15689 */   // (brcond (setcc:{ *:[i32] } i64:{ *:[i64] }:$lhs, 1:{ *:[i64] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BLEZ64 i64:{ *:[i64] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ64),
     /* 15692 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15696 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15698 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15701 */   GIR_RootConstrainSelectedInstOperands,
     /* 15702 */   // GIR_Coverage, 1559,
     /* 15702 */   GIR_EraseRootFromParent_Done,
     /* 15703 */ // Label 555: @15703
     /* 15703 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(15755), // Rule ID 1560 //
     /* 15708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15711 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15715 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15719 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15723 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15727 */   // MIs[1] Operand 1
     /* 15727 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 15732 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 15736 */   // MIs[0] dst
     /* 15736 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15739 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15741 */   // (brcond (setcc:{ *:[i32] } i64:{ *:[i64] }:$lhs, -1:{ *:[i64] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BGEZ64 i64:{ *:[i64] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ64),
     /* 15744 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15748 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15750 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15753 */   GIR_RootConstrainSelectedInstOperands,
     /* 15754 */   // GIR_Coverage, 1560,
     /* 15754 */   GIR_EraseRootFromParent_Done,
     /* 15755 */ // Label 556: @15755
     /* 15755 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(15807), // Rule ID 2206 //
     /* 15760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15763 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15767 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15771 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15775 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15779 */   // MIs[1] Operand 1
     /* 15779 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 15784 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 1,
     /* 15788 */   // MIs[0] dst
     /* 15788 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15791 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15793 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, 1:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BLEZ_MM i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ_MM),
     /* 15796 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15800 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15802 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15805 */   GIR_RootConstrainSelectedInstOperands,
     /* 15806 */   // GIR_Coverage, 2206,
     /* 15806 */   GIR_EraseRootFromParent_Done,
     /* 15807 */ // Label 557: @15807
     /* 15807 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(15859), // Rule ID 2207 //
     /* 15812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15815 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15823 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15827 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15831 */   // MIs[1] Operand 1
     /* 15831 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 15836 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 15840 */   // MIs[0] dst
     /* 15840 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15843 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15845 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, -1:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BGEZ_MM i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ_MM),
     /* 15848 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15852 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15854 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15857 */   GIR_RootConstrainSelectedInstOperands,
     /* 15858 */   // GIR_Coverage, 2207,
     /* 15858 */   GIR_EraseRootFromParent_Done,
     /* 15859 */ // Label 558: @15859
     /* 15859 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(15921), // Rule ID 92 //
     /* 15864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15867 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15871 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15875 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15879 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15883 */   // MIs[1] Operand 1
     /* 15883 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15888 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15893 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15898 */   // MIs[0] offset
     /* 15898 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15901 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15903 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BEQ GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 15903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 15906 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 15910 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 15914 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 15916 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15919 */   GIR_RootConstrainSelectedInstOperands,
     /* 15920 */   // GIR_Coverage, 92,
     /* 15920 */   GIR_EraseRootFromParent_Done,
     /* 15921 */ // Label 559: @15921
     /* 15921 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(15983), // Rule ID 93 //
     /* 15926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15929 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15933 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15937 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15941 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15945 */   // MIs[1] Operand 1
     /* 15945 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15950 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15955 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15960 */   // MIs[0] offset
     /* 15960 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15963 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15965 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BNE GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 15965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE),
     /* 15968 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 15972 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 15976 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 15978 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15981 */   GIR_RootConstrainSelectedInstOperands,
     /* 15982 */   // GIR_Coverage, 93,
     /* 15982 */   GIR_EraseRootFromParent_Done,
     /* 15983 */ // Label 560: @15983
     /* 15983 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(16045), // Rule ID 243 //
     /* 15988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 15991 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15995 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15999 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16003 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16007 */   // MIs[1] Operand 1
     /* 16007 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 16012 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16017 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16022 */   // MIs[0] offset
     /* 16022 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16025 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16027 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BEQ64 GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ64),
     /* 16030 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16034 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16038 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16040 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16043 */   GIR_RootConstrainSelectedInstOperands,
     /* 16044 */   // GIR_Coverage, 243,
     /* 16044 */   GIR_EraseRootFromParent_Done,
     /* 16045 */ // Label 561: @16045
     /* 16045 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(16107), // Rule ID 244 //
     /* 16050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 16053 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16061 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16065 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16069 */   // MIs[1] Operand 1
     /* 16069 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 16074 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16079 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16084 */   // MIs[0] offset
     /* 16084 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16087 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16089 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BNE64 GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE64),
     /* 16092 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16096 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16100 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16102 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16105 */   GIR_RootConstrainSelectedInstOperands,
     /* 16106 */   // GIR_Coverage, 244,
     /* 16106 */   GIR_EraseRootFromParent_Done,
     /* 16107 */ // Label 562: @16107
     /* 16107 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(16169), // Rule ID 1107 //
     /* 16112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 16115 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16119 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16123 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16127 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16131 */   // MIs[1] Operand 1
     /* 16131 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 16136 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16141 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16146 */   // MIs[0] offset
     /* 16146 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16149 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16151 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BEQ_MM GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 16154 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16158 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16162 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16164 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16167 */   GIR_RootConstrainSelectedInstOperands,
     /* 16168 */   // GIR_Coverage, 1107,
     /* 16168 */   GIR_EraseRootFromParent_Done,
     /* 16169 */ // Label 563: @16169
     /* 16169 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(16231), // Rule ID 1108 //
     /* 16174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 16177 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16181 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16185 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16189 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16193 */   // MIs[1] Operand 1
     /* 16193 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 16198 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16203 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16208 */   // MIs[0] offset
     /* 16208 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16211 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16213 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BNE_MM GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE_MM),
     /* 16216 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16220 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16224 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16226 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16229 */   GIR_RootConstrainSelectedInstOperands,
     /* 16230 */   // GIR_Coverage, 1108,
     /* 16230 */   GIR_EraseRootFromParent_Done,
     /* 16231 */ // Label 564: @16231
     /* 16231 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(16316), // Rule ID 1404 //
     /* 16236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16239 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16243 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16247 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16251 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16255 */   // MIs[1] Operand 1
     /* 16255 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 16260 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16265 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16270 */   // MIs[0] dst
     /* 16270 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16273 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16275 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16275 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16278 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 16282 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16287 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16291 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16300 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16303 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16309 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16311 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16314 */   GIR_RootConstrainSelectedInstOperands,
     /* 16315 */   // GIR_Coverage, 1404,
     /* 16315 */   GIR_EraseRootFromParent_Done,
     /* 16316 */ // Label 565: @16316
     /* 16316 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(16401), // Rule ID 1405 //
     /* 16321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16324 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16332 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16336 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16340 */   // MIs[1] Operand 1
     /* 16340 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 16345 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16350 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16355 */   // MIs[0] dst
     /* 16355 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16358 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16360 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 16367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16372 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16376 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16385 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16388 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16394 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16396 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16399 */   GIR_RootConstrainSelectedInstOperands,
     /* 16400 */   // GIR_Coverage, 1405,
     /* 16400 */   GIR_EraseRootFromParent_Done,
     /* 16401 */ // Label 566: @16401
     /* 16401 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(16486), // Rule ID 1410 //
     /* 16406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16409 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16413 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16417 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16421 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16425 */   // MIs[1] Operand 1
     /* 16425 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 16430 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16435 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16440 */   // MIs[0] dst
     /* 16440 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16443 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16445 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16445 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16448 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 16452 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16457 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16461 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16465 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16470 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16473 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16479 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16481 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16484 */   GIR_RootConstrainSelectedInstOperands,
     /* 16485 */   // GIR_Coverage, 1410,
     /* 16485 */   GIR_EraseRootFromParent_Done,
     /* 16486 */ // Label 567: @16486
     /* 16486 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(16571), // Rule ID 1411 //
     /* 16491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16494 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16498 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16502 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16506 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16510 */   // MIs[1] Operand 1
     /* 16510 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 16515 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16520 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16525 */   // MIs[0] dst
     /* 16525 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16528 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16530 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16530 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16533 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 16537 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16542 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16546 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16555 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16558 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16564 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16566 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16569 */   GIR_RootConstrainSelectedInstOperands,
     /* 16570 */   // GIR_Coverage, 1411,
     /* 16570 */   GIR_EraseRootFromParent_Done,
     /* 16571 */ // Label 568: @16571
     /* 16571 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(16656), // Rule ID 1550 //
     /* 16576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16579 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16583 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16587 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16591 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16595 */   // MIs[1] Operand 1
     /* 16595 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 16600 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16605 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16610 */   // MIs[0] dst
     /* 16610 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16613 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16615 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16615 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16618 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 16622 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16627 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16631 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16640 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16643 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16649 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16651 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16654 */   GIR_RootConstrainSelectedInstOperands,
     /* 16655 */   // GIR_Coverage, 1550,
     /* 16655 */   GIR_EraseRootFromParent_Done,
     /* 16656 */ // Label 569: @16656
     /* 16656 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(16741), // Rule ID 1551 //
     /* 16661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16664 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16668 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16672 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16676 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16680 */   // MIs[1] Operand 1
     /* 16680 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 16685 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16690 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16695 */   // MIs[0] dst
     /* 16695 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16698 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16700 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 16707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16712 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16716 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16728 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16734 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16736 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16739 */   GIR_RootConstrainSelectedInstOperands,
     /* 16740 */   // GIR_Coverage, 1551,
     /* 16740 */   GIR_EraseRootFromParent_Done,
     /* 16741 */ // Label 570: @16741
     /* 16741 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(16826), // Rule ID 1556 //
     /* 16746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16749 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16753 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16757 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16761 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16765 */   // MIs[1] Operand 1
     /* 16765 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 16770 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16775 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16780 */   // MIs[0] dst
     /* 16780 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16783 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16785 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 16792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16797 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16801 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16813 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16819 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16821 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16824 */   GIR_RootConstrainSelectedInstOperands,
     /* 16825 */   // GIR_Coverage, 1556,
     /* 16825 */   GIR_EraseRootFromParent_Done,
     /* 16826 */ // Label 571: @16826
     /* 16826 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(16911), // Rule ID 1557 //
     /* 16831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16834 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16838 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16842 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16846 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16850 */   // MIs[1] Operand 1
     /* 16850 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 16855 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16860 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16865 */   // MIs[0] dst
     /* 16865 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16868 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16870 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16870 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16873 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 16877 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16882 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16886 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16895 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16898 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16904 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16906 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16909 */   GIR_RootConstrainSelectedInstOperands,
     /* 16910 */   // GIR_Coverage, 1557,
     /* 16910 */   GIR_EraseRootFromParent_Done,
     /* 16911 */ // Label 572: @16911
     /* 16911 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(16970), // Rule ID 1854 //
     /* 16916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 16919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16927 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16931 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16935 */   // MIs[1] Operand 1
     /* 16935 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 16940 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 16945 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 16950 */   // MIs[0] imm16
     /* 16950 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16953 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16955 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BteqzT8CmpX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 16955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BteqzT8CmpX16),
     /* 16958 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 16962 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 16966 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 16968 */   GIR_RootConstrainSelectedInstOperands,
     /* 16969 */   // GIR_Coverage, 1854,
     /* 16969 */   GIR_EraseRootFromParent_Done,
     /* 16970 */ // Label 573: @16970
     /* 16970 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(17029), // Rule ID 1857 //
     /* 16975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 16978 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16982 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16986 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16990 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16994 */   // MIs[1] Operand 1
     /* 16994 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 16999 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17004 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17009 */   // MIs[0] imm16
     /* 17009 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17012 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17014 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BtnezT8SltX16 CPU16Regs:{ *:[i32] }:$ry, CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$imm16)
     /* 17014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BtnezT8SltX16),
     /* 17017 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17021 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17025 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17027 */   GIR_RootConstrainSelectedInstOperands,
     /* 17028 */   // GIR_Coverage, 1857,
     /* 17028 */   GIR_EraseRootFromParent_Done,
     /* 17029 */ // Label 574: @17029
     /* 17029 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(17088), // Rule ID 1858 //
     /* 17034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17037 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17041 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17045 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17049 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17053 */   // MIs[1] Operand 1
     /* 17053 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 17058 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17063 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17068 */   // MIs[0] imm16
     /* 17068 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17071 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17073 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BteqzT8SltX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 17073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BteqzT8SltX16),
     /* 17076 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17080 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17084 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17086 */   GIR_RootConstrainSelectedInstOperands,
     /* 17087 */   // GIR_Coverage, 1858,
     /* 17087 */   GIR_EraseRootFromParent_Done,
     /* 17088 */ // Label 575: @17088
     /* 17088 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(17147), // Rule ID 1860 //
     /* 17093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17096 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17100 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17104 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17108 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17112 */   // MIs[1] Operand 1
     /* 17112 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 17117 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17122 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17127 */   // MIs[0] imm16
     /* 17127 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17130 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17132 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BtnezT8SltX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 17132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BtnezT8SltX16),
     /* 17135 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17139 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17143 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17145 */   GIR_RootConstrainSelectedInstOperands,
     /* 17146 */   // GIR_Coverage, 1860,
     /* 17146 */   GIR_EraseRootFromParent_Done,
     /* 17147 */ // Label 576: @17147
     /* 17147 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(17206), // Rule ID 1862 //
     /* 17152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17155 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17159 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17163 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17167 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17171 */   // MIs[1] Operand 1
     /* 17171 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 17176 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17181 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17186 */   // MIs[0] imm16
     /* 17186 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17189 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17191 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BteqzT8SltX16 CPU16Regs:{ *:[i32] }:$ry, CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$imm16)
     /* 17191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BteqzT8SltX16),
     /* 17194 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17198 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17202 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17204 */   GIR_RootConstrainSelectedInstOperands,
     /* 17205 */   // GIR_Coverage, 1862,
     /* 17205 */   GIR_EraseRootFromParent_Done,
     /* 17206 */ // Label 577: @17206
     /* 17206 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(17265), // Rule ID 1863 //
     /* 17211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17214 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17218 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17222 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17226 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17230 */   // MIs[1] Operand 1
     /* 17230 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 17235 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17240 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17245 */   // MIs[0] imm16
     /* 17245 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17248 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17250 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BtnezT8CmpX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 17250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BtnezT8CmpX16),
     /* 17253 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17257 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17261 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17263 */   GIR_RootConstrainSelectedInstOperands,
     /* 17264 */   // GIR_Coverage, 1863,
     /* 17264 */   GIR_EraseRootFromParent_Done,
     /* 17265 */ // Label 578: @17265
     /* 17265 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(17350), // Rule ID 2197 //
     /* 17270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17273 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17277 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17281 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17285 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17289 */   // MIs[1] Operand 1
     /* 17289 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 17294 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17299 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17304 */   // MIs[0] dst
     /* 17304 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17307 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17309 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17309 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17312 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17316 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17321 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17325 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17337 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17343 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17345 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17348 */   GIR_RootConstrainSelectedInstOperands,
     /* 17349 */   // GIR_Coverage, 2197,
     /* 17349 */   GIR_EraseRootFromParent_Done,
     /* 17350 */ // Label 579: @17350
     /* 17350 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(17435), // Rule ID 2198 //
     /* 17355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17366 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17370 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17374 */   // MIs[1] Operand 1
     /* 17374 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 17379 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17384 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17389 */   // MIs[0] dst
     /* 17389 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17392 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17394 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17394 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17397 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17401 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17406 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17410 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17419 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17422 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17428 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17430 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17433 */   GIR_RootConstrainSelectedInstOperands,
     /* 17434 */   // GIR_Coverage, 2198,
     /* 17434 */   GIR_EraseRootFromParent_Done,
     /* 17435 */ // Label 580: @17435
     /* 17435 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(17520), // Rule ID 2203 //
     /* 17440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17443 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17447 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17451 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17455 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17459 */   // MIs[1] Operand 1
     /* 17459 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 17464 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17469 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17474 */   // MIs[0] dst
     /* 17474 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17477 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17479 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17491 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17495 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17504 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17507 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17513 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17515 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17518 */   GIR_RootConstrainSelectedInstOperands,
     /* 17519 */   // GIR_Coverage, 2203,
     /* 17519 */   GIR_EraseRootFromParent_Done,
     /* 17520 */ // Label 581: @17520
     /* 17520 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(17605), // Rule ID 2204 //
     /* 17525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17528 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17532 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17536 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17540 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17544 */   // MIs[1] Operand 1
     /* 17544 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 17549 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17554 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17559 */   // MIs[0] dst
     /* 17559 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17562 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17564 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17564 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17567 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17571 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17576 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17580 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17592 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17598 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17600 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17603 */   GIR_RootConstrainSelectedInstOperands,
     /* 17604 */   // GIR_Coverage, 2204,
     /* 17604 */   GIR_EraseRootFromParent_Done,
     /* 17605 */ // Label 582: @17605
     /* 17605 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(17684), // Rule ID 2344 //
     /* 17610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17613 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17617 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17621 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17625 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17629 */   // MIs[1] Operand 1
     /* 17629 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 17634 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17639 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17644 */   // MIs[0] dst
     /* 17644 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17647 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17649 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), (bb:{ *:[Other] }):$dst)
     /* 17649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17661 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17665 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17674 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17677 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17679 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17682 */   GIR_RootConstrainSelectedInstOperands,
     /* 17683 */   // GIR_Coverage, 2344,
     /* 17683 */   GIR_EraseRootFromParent_Done,
     /* 17684 */ // Label 583: @17684
     /* 17684 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(17763), // Rule ID 2345 //
     /* 17689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17692 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17700 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17704 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17708 */   // MIs[1] Operand 1
     /* 17708 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 17713 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17718 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17723 */   // MIs[0] dst
     /* 17723 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17726 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17728 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), (bb:{ *:[Other] }):$dst)
     /* 17728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17740 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17744 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17756 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17758 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17761 */   GIR_RootConstrainSelectedInstOperands,
     /* 17762 */   // GIR_Coverage, 2345,
     /* 17762 */   GIR_EraseRootFromParent_Done,
     /* 17763 */ // Label 584: @17763
     /* 17763 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(17842), // Rule ID 2350 //
     /* 17768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17771 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17775 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17779 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17783 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17787 */   // MIs[1] Operand 1
     /* 17787 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 17792 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17797 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17802 */   // MIs[0] dst
     /* 17802 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17805 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17807 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), (bb:{ *:[Other] }):$dst)
     /* 17807 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17810 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17814 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17819 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17823 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17835 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17837 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17840 */   GIR_RootConstrainSelectedInstOperands,
     /* 17841 */   // GIR_Coverage, 2350,
     /* 17841 */   GIR_EraseRootFromParent_Done,
     /* 17842 */ // Label 585: @17842
     /* 17842 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(17921), // Rule ID 2351 //
     /* 17847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17858 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17862 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17866 */   // MIs[1] Operand 1
     /* 17866 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 17871 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17876 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17881 */   // MIs[0] dst
     /* 17881 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17884 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17886 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), (bb:{ *:[Other] }):$dst)
     /* 17886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17898 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17902 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17911 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17914 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17916 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17919 */   GIR_RootConstrainSelectedInstOperands,
     /* 17920 */   // GIR_Coverage, 2351,
     /* 17920 */   GIR_EraseRootFromParent_Done,
     /* 17921 */ // Label 586: @17921
     /* 17921 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(17954), // Rule ID 1412 //
     /* 17926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 17929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17933 */   // MIs[0] dst
     /* 17933 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17936 */   // (brcond GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNE GPR32:{ *:[i32] }:$cond, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE),
     /* 17939 */   GIR_RootToRootCopy, /*OpIdx*/0, // cond
     /* 17941 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17947 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17949 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17952 */   GIR_RootConstrainSelectedInstOperands,
     /* 17953 */   // GIR_Coverage, 1412,
     /* 17953 */   GIR_EraseRootFromParent_Done,
     /* 17954 */ // Label 587: @17954
     /* 17954 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(17976), // Rule ID 1866 //
     /* 17959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17966 */   // MIs[0] targ16
     /* 17966 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17969 */   // (brcond CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)  =>  (BnezRxImm16 CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)
     /* 17969 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BnezRxImm16),
     /* 17974 */   GIR_RootConstrainSelectedInstOperands,
     /* 17975 */   // GIR_Coverage, 1866,
     /* 17975 */   GIR_Done,
     /* 17976 */ // Label 588: @17976
     /* 17976 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(18009), // Rule ID 2205 //
     /* 17981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17988 */   // MIs[0] dst
     /* 17988 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17991 */   // (brcond GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNE_MM GPR32:{ *:[i32] }:$cond, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE_MM),
     /* 17994 */   GIR_RootToRootCopy, /*OpIdx*/0, // cond
     /* 17996 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 18002 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 18004 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 18007 */   GIR_RootConstrainSelectedInstOperands,
     /* 18008 */   // GIR_Coverage, 2205,
     /* 18008 */   GIR_EraseRootFromParent_Done,
     /* 18009 */ // Label 589: @18009
     /* 18009 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(18037), // Rule ID 2352 //
     /* 18014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 18017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18021 */   // MIs[0] dst
     /* 18021 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 18024 */   // (brcond GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNEZC_MMR6 GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)
     /* 18024 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BNEZC_MMR6),
     /* 18029 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 18035 */   GIR_RootConstrainSelectedInstOperands,
     /* 18036 */   // GIR_Coverage, 2352,
     /* 18036 */   GIR_Done,
     /* 18037 */ // Label 590: @18037
     /* 18037 */ GIM_Reject,
     /* 18038 */ // Label 521: @18038
     /* 18038 */ GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(18071), // Rule ID 1558 //
     /* 18043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 18046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 18050 */   // MIs[0] dst
     /* 18050 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 18053 */   // (brcond GPR64:{ *:[i64] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNE64 GPR64:{ *:[i64] }:$cond, ZERO_64:{ *:[i64] }, (bb:{ *:[Other] }):$dst)
     /* 18053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE64),
     /* 18056 */   GIR_RootToRootCopy, /*OpIdx*/0, // cond
     /* 18058 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 18064 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 18066 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 18069 */   GIR_RootConstrainSelectedInstOperands,
     /* 18070 */   // GIR_Coverage, 1558,
     /* 18070 */   GIR_EraseRootFromParent_Done,
     /* 18071 */ // Label 591: @18071
     /* 18071 */ GIM_Reject,
     /* 18072 */ // Label 522: @18072
     /* 18072 */ GIM_Reject,
     /* 18073 */ // Label 29: @18073
     /* 18073 */ GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(20070),
     /* 18078 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 18081 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(18128), // Rule ID 428 //
     /* 18086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 18094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 18097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt8),
     /* 18116 */     // MIs[1] Operand 1
     /* 18116 */     // No operand predicates
     /* 18116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18118 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8133:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immZExt8>>:$imm)  =>  (REPL_QB:{ *:[v4i8] } (imm:{ *:[i32] }):$imm)
     /* 18118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_QB),
     /* 18121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18126 */     GIR_RootConstrainSelectedInstOperands,
     /* 18127 */     // GIR_Coverage, 428,
     /* 18127 */     GIR_EraseRootFromParent_Done,
     /* 18128 */   // Label 593: @18128
     /* 18128 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(18175), // Rule ID 429 //
     /* 18133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 18141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExt10),
     /* 18163 */     // MIs[1] Operand 1
     /* 18163 */     // No operand predicates
     /* 18163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18165 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8132:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immSExt10>>:$imm)  =>  (REPL_PH:{ *:[v2i16] } (imm:{ *:[i32] }):$imm)
     /* 18165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_PH),
     /* 18168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18173 */     GIR_RootConstrainSelectedInstOperands,
     /* 18174 */     // GIR_Coverage, 429,
     /* 18174 */     GIR_EraseRootFromParent_Done,
     /* 18175 */   // Label 594: @18175
     /* 18175 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(18222), // Rule ID 1288 //
     /* 18180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 18183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 18188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExt10),
     /* 18210 */     // MIs[1] Operand 1
     /* 18210 */     // No operand predicates
     /* 18210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18212 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8132:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immSExt10>>:$imm)  =>  (REPL_PH_MM:{ *:[v2i16] } (imm:{ *:[i32] }):$imm)
     /* 18212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_PH_MM),
     /* 18215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18220 */     GIR_RootConstrainSelectedInstOperands,
     /* 18221 */     // GIR_Coverage, 1288,
     /* 18221 */     GIR_EraseRootFromParent_Done,
     /* 18222 */   // Label 595: @18222
     /* 18222 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(18269), // Rule ID 1289 //
     /* 18227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 18230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 18235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 18238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt8),
     /* 18257 */     // MIs[1] Operand 1
     /* 18257 */     // No operand predicates
     /* 18257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18259 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8133:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immZExt8>>:$imm)  =>  (REPL_QB_MM:{ *:[v4i8] } (imm:{ *:[i32] }):$imm)
     /* 18259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_QB_MM),
     /* 18262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 18264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18267 */     GIR_RootConstrainSelectedInstOperands,
     /* 18268 */     // GIR_Coverage, 1289,
     /* 18268 */     GIR_EraseRootFromParent_Done,
     /* 18269 */   // Label 596: @18269
     /* 18269 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(18305), // Rule ID 362 //
     /* 18274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_raddu_w_qb),
     /* 18282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18296 */     // (intrinsic_wo_chain:{ *:[i32] } 8130:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (RADDU_W_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 18296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RADDU_W_QB),
     /* 18299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 18303 */     GIR_RootConstrainSelectedInstOperands,
     /* 18304 */     // GIR_Coverage, 362,
     /* 18304 */     GIR_EraseRootFromParent_Done,
     /* 18305 */   // Label 597: @18305
     /* 18305 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(18341), // Rule ID 369 //
     /* 18310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phl),
     /* 18318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 18324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18332 */     // (intrinsic_wo_chain:{ *:[i32] } 8112:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECEQ_W_PHL:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rt)
     /* 18332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHL),
     /* 18335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18339 */     GIR_RootConstrainSelectedInstOperands,
     /* 18340 */     // GIR_Coverage, 369,
     /* 18340 */     GIR_EraseRootFromParent_Done,
     /* 18341 */   // Label 598: @18341
     /* 18341 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(18377), // Rule ID 370 //
     /* 18346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phr),
     /* 18354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 18360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18368 */     // (intrinsic_wo_chain:{ *:[i32] } 8113:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECEQ_W_PHR:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rt)
     /* 18368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHR),
     /* 18371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18375 */     GIR_RootConstrainSelectedInstOperands,
     /* 18376 */     // GIR_Coverage, 370,
     /* 18376 */     GIR_EraseRootFromParent_Done,
     /* 18377 */   // Label 599: @18377
     /* 18377 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(18413), // Rule ID 371 //
     /* 18382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbl),
     /* 18390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18404 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8114:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBL:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBL),
     /* 18407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18411 */     GIR_RootConstrainSelectedInstOperands,
     /* 18412 */     // GIR_Coverage, 371,
     /* 18412 */     GIR_EraseRootFromParent_Done,
     /* 18413 */   // Label 600: @18413
     /* 18413 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(18449), // Rule ID 372 //
     /* 18418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbr),
     /* 18426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18440 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8116:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBR:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBR),
     /* 18443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18447 */     GIR_RootConstrainSelectedInstOperands,
     /* 18448 */     // GIR_Coverage, 372,
     /* 18448 */     GIR_EraseRootFromParent_Done,
     /* 18449 */   // Label 601: @18449
     /* 18449 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(18485), // Rule ID 373 //
     /* 18454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbla),
     /* 18462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18476 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8115:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBLA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBLA),
     /* 18479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18483 */     GIR_RootConstrainSelectedInstOperands,
     /* 18484 */     // GIR_Coverage, 373,
     /* 18484 */     GIR_EraseRootFromParent_Done,
     /* 18485 */   // Label 602: @18485
     /* 18485 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(18521), // Rule ID 374 //
     /* 18490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbra),
     /* 18498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18512 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8117:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBRA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBRA),
     /* 18515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18519 */     GIR_RootConstrainSelectedInstOperands,
     /* 18520 */     // GIR_Coverage, 374,
     /* 18520 */     GIR_EraseRootFromParent_Done,
     /* 18521 */   // Label 603: @18521
     /* 18521 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(18557), // Rule ID 375 //
     /* 18526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbl),
     /* 18534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18548 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8118:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBL:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBL),
     /* 18551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18555 */     GIR_RootConstrainSelectedInstOperands,
     /* 18556 */     // GIR_Coverage, 375,
     /* 18556 */     GIR_EraseRootFromParent_Done,
     /* 18557 */   // Label 604: @18557
     /* 18557 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(18593), // Rule ID 376 //
     /* 18562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbr),
     /* 18570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18584 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8120:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBR:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBR),
     /* 18587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18591 */     GIR_RootConstrainSelectedInstOperands,
     /* 18592 */     // GIR_Coverage, 376,
     /* 18592 */     GIR_EraseRootFromParent_Done,
     /* 18593 */   // Label 605: @18593
     /* 18593 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(18629), // Rule ID 377 //
     /* 18598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbla),
     /* 18606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18620 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8119:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBLA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBLA),
     /* 18623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18627 */     GIR_RootConstrainSelectedInstOperands,
     /* 18628 */     // GIR_Coverage, 377,
     /* 18628 */     GIR_EraseRootFromParent_Done,
     /* 18629 */   // Label 606: @18629
     /* 18629 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(18665), // Rule ID 378 //
     /* 18634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbra),
     /* 18642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18656 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8121:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBRA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBRA),
     /* 18659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18663 */     GIR_RootConstrainSelectedInstOperands,
     /* 18664 */     // GIR_Coverage, 378,
     /* 18664 */     GIR_EraseRootFromParent_Done,
     /* 18665 */   // Label 607: @18665
     /* 18665 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(18701), // Rule ID 426 //
     /* 18670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_bitrev),
     /* 18678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18692 */     // (intrinsic_wo_chain:{ *:[i32] } 7686:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (BITREV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 18692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BITREV),
     /* 18695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18699 */     GIR_RootConstrainSelectedInstOperands,
     /* 18700 */     // GIR_Coverage, 426,
     /* 18700 */     GIR_EraseRootFromParent_Done,
     /* 18701 */   // Label 608: @18701
     /* 18701 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(18737), // Rule ID 430 //
     /* 18706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 18714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 18717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18728 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8133:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (REPLV_QB:{ *:[v4i8] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 18728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_QB),
     /* 18731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18735 */     GIR_RootConstrainSelectedInstOperands,
     /* 18736 */     // GIR_Coverage, 430,
     /* 18736 */     GIR_EraseRootFromParent_Done,
     /* 18737 */   // Label 609: @18737
     /* 18737 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(18773), // Rule ID 431 //
     /* 18742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 18750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18764 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8132:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (REPLV_PH:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 18764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_PH),
     /* 18767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18771 */     GIR_RootConstrainSelectedInstOperands,
     /* 18772 */     // GIR_Coverage, 431,
     /* 18772 */     GIR_EraseRootFromParent_Done,
     /* 18773 */   // Label 610: @18773
     /* 18773 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(18809), // Rule ID 680 //
     /* 18778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fclass_w),
     /* 18786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 18792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18800 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7838:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FCLASS_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 18800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCLASS_W),
     /* 18803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18805 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18807 */     GIR_RootConstrainSelectedInstOperands,
     /* 18808 */     // GIR_Coverage, 680,
     /* 18808 */     GIR_EraseRootFromParent_Done,
     /* 18809 */   // Label 611: @18809
     /* 18809 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(18845), // Rule ID 681 //
     /* 18814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fclass_d),
     /* 18822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 18825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 18828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18836 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7837:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FCLASS_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 18836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCLASS_D),
     /* 18839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18841 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18843 */     GIR_RootConstrainSelectedInstOperands,
     /* 18844 */     // GIR_Coverage, 681,
     /* 18844 */     GIR_EraseRootFromParent_Done,
     /* 18845 */   // Label 612: @18845
     /* 18845 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(18881), // Rule ID 704 //
     /* 18850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupl_w),
     /* 18858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 18864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 18872 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7864:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8f16] }:$ws)  =>  (FEXUPL_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8f16] }:$ws)
     /* 18872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPL_W),
     /* 18875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18877 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18879 */     GIR_RootConstrainSelectedInstOperands,
     /* 18880 */     // GIR_Coverage, 704,
     /* 18880 */     GIR_EraseRootFromParent_Done,
     /* 18881 */   // Label 613: @18881
     /* 18881 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(18917), // Rule ID 705 //
     /* 18886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupl_d),
     /* 18894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 18897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 18900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18908 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7863:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FEXUPL_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 18908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPL_D),
     /* 18911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18913 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18915 */     GIR_RootConstrainSelectedInstOperands,
     /* 18916 */     // GIR_Coverage, 705,
     /* 18916 */     GIR_EraseRootFromParent_Done,
     /* 18917 */   // Label 614: @18917
     /* 18917 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(18953), // Rule ID 706 //
     /* 18922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupr_w),
     /* 18930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 18936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 18944 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7866:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8f16] }:$ws)  =>  (FEXUPR_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8f16] }:$ws)
     /* 18944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPR_W),
     /* 18947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18949 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18951 */     GIR_RootConstrainSelectedInstOperands,
     /* 18952 */     // GIR_Coverage, 706,
     /* 18952 */     GIR_EraseRootFromParent_Done,
     /* 18953 */   // Label 615: @18953
     /* 18953 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(18989), // Rule ID 707 //
     /* 18958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupr_d),
     /* 18966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 18969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 18972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18980 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7865:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FEXUPR_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 18980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPR_D),
     /* 18983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18985 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18987 */     GIR_RootConstrainSelectedInstOperands,
     /* 18988 */     // GIR_Coverage, 707,
     /* 18988 */     GIR_EraseRootFromParent_Done,
     /* 18989 */   // Label 616: @18989
     /* 18989 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(19025), // Rule ID 712 //
     /* 18994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffql_w),
     /* 19002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 19008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 19016 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7872:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (FFQL_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 19016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQL_W),
     /* 19019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19021 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19023 */     GIR_RootConstrainSelectedInstOperands,
     /* 19024 */     // GIR_Coverage, 712,
     /* 19024 */     GIR_EraseRootFromParent_Done,
     /* 19025 */   // Label 617: @19025
     /* 19025 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(19061), // Rule ID 713 //
     /* 19030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffql_d),
     /* 19038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19052 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7871:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFQL_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 19052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQL_D),
     /* 19055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19057 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19059 */     GIR_RootConstrainSelectedInstOperands,
     /* 19060 */     // GIR_Coverage, 713,
     /* 19060 */     GIR_EraseRootFromParent_Done,
     /* 19061 */   // Label 618: @19061
     /* 19061 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(19097), // Rule ID 714 //
     /* 19066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffqr_w),
     /* 19074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 19080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 19088 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7874:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (FFQR_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 19088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQR_W),
     /* 19091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19093 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19095 */     GIR_RootConstrainSelectedInstOperands,
     /* 19096 */     // GIR_Coverage, 714,
     /* 19096 */     GIR_EraseRootFromParent_Done,
     /* 19097 */   // Label 619: @19097
     /* 19097 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(19133), // Rule ID 715 //
     /* 19102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffqr_d),
     /* 19110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19124 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7873:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFQR_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 19124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQR_D),
     /* 19127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19129 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19131 */     GIR_RootConstrainSelectedInstOperands,
     /* 19132 */     // GIR_Coverage, 715,
     /* 19132 */     GIR_EraseRootFromParent_Done,
     /* 19133 */   // Label 620: @19133
     /* 19133 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(19169), // Rule ID 740 //
     /* 19138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frcp_w),
     /* 19146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19160 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7896:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FRCP_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRCP_W),
     /* 19163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19165 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19167 */     GIR_RootConstrainSelectedInstOperands,
     /* 19168 */     // GIR_Coverage, 740,
     /* 19168 */     GIR_EraseRootFromParent_Done,
     /* 19169 */   // Label 621: @19169
     /* 19169 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(19205), // Rule ID 741 //
     /* 19174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frcp_d),
     /* 19182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19196 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7895:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FRCP_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRCP_D),
     /* 19199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19201 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19203 */     GIR_RootConstrainSelectedInstOperands,
     /* 19204 */     // GIR_Coverage, 741,
     /* 19204 */     GIR_EraseRootFromParent_Done,
     /* 19205 */   // Label 622: @19205
     /* 19205 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(19241), // Rule ID 742 //
     /* 19210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frsqrt_w),
     /* 19218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19232 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7900:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FRSQRT_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRSQRT_W),
     /* 19235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19237 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19239 */     GIR_RootConstrainSelectedInstOperands,
     /* 19240 */     // GIR_Coverage, 742,
     /* 19240 */     GIR_EraseRootFromParent_Done,
     /* 19241 */   // Label 623: @19241
     /* 19241 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(19277), // Rule ID 743 //
     /* 19246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frsqrt_d),
     /* 19254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19268 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7899:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FRSQRT_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRSQRT_D),
     /* 19271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19273 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19275 */     GIR_RootConstrainSelectedInstOperands,
     /* 19276 */     // GIR_Coverage, 743,
     /* 19276 */     GIR_EraseRootFromParent_Done,
     /* 19277 */   // Label 624: @19277
     /* 19277 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(19313), // Rule ID 770 //
     /* 19282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_s_w),
     /* 19290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19304 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7928:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTINT_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_S_W),
     /* 19307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19309 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19311 */     GIR_RootConstrainSelectedInstOperands,
     /* 19312 */     // GIR_Coverage, 770,
     /* 19312 */     GIR_EraseRootFromParent_Done,
     /* 19313 */   // Label 625: @19313
     /* 19313 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(19349), // Rule ID 771 //
     /* 19318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_s_d),
     /* 19326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19340 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7927:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTINT_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_S_D),
     /* 19343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19345 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19347 */     GIR_RootConstrainSelectedInstOperands,
     /* 19348 */     // GIR_Coverage, 771,
     /* 19348 */     GIR_EraseRootFromParent_Done,
     /* 19349 */   // Label 626: @19349
     /* 19349 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(19385), // Rule ID 772 //
     /* 19354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_u_w),
     /* 19362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19376 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7930:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTINT_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_U_W),
     /* 19379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19381 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19383 */     GIR_RootConstrainSelectedInstOperands,
     /* 19384 */     // GIR_Coverage, 772,
     /* 19384 */     GIR_EraseRootFromParent_Done,
     /* 19385 */   // Label 627: @19385
     /* 19385 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(19421), // Rule ID 773 //
     /* 19390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_u_d),
     /* 19398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19412 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7929:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTINT_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_U_D),
     /* 19415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19417 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19419 */     GIR_RootConstrainSelectedInstOperands,
     /* 19420 */     // GIR_Coverage, 773,
     /* 19420 */     GIR_EraseRootFromParent_Done,
     /* 19421 */   // Label 628: @19421
     /* 19421 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(19457), // Rule ID 908 //
     /* 19426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_b),
     /* 19434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 19437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 19440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 19444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 19448 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8085:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (NLOC_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)
     /* 19448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_B),
     /* 19451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19453 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19455 */     GIR_RootConstrainSelectedInstOperands,
     /* 19456 */     // GIR_Coverage, 908,
     /* 19456 */     GIR_EraseRootFromParent_Done,
     /* 19457 */   // Label 629: @19457
     /* 19457 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(19493), // Rule ID 909 //
     /* 19462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_h),
     /* 19470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 19473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 19476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 19480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 19484 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8087:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (NLOC_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 19484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_H),
     /* 19487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19489 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19491 */     GIR_RootConstrainSelectedInstOperands,
     /* 19492 */     // GIR_Coverage, 909,
     /* 19492 */     GIR_EraseRootFromParent_Done,
     /* 19493 */   // Label 630: @19493
     /* 19493 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(19529), // Rule ID 910 //
     /* 19498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_w),
     /* 19506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19520 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8088:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (NLOC_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 19520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_W),
     /* 19523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19525 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19527 */     GIR_RootConstrainSelectedInstOperands,
     /* 19528 */     // GIR_Coverage, 910,
     /* 19528 */     GIR_EraseRootFromParent_Done,
     /* 19529 */   // Label 631: @19529
     /* 19529 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(19565), // Rule ID 911 //
     /* 19534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_d),
     /* 19542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19556 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8086:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (NLOC_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 19556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_D),
     /* 19559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19561 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19563 */     GIR_RootConstrainSelectedInstOperands,
     /* 19564 */     // GIR_Coverage, 911,
     /* 19564 */     GIR_EraseRootFromParent_Done,
     /* 19565 */   // Label 632: @19565
     /* 19565 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(19601), // Rule ID 1251 //
     /* 19570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phl),
     /* 19578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 19581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 19584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19592 */     // (intrinsic_wo_chain:{ *:[i32] } 8112:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs)  =>  (PRECEQ_W_PHL_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs)
     /* 19592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHL_MM),
     /* 19595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19599 */     GIR_RootConstrainSelectedInstOperands,
     /* 19600 */     // GIR_Coverage, 1251,
     /* 19600 */     GIR_EraseRootFromParent_Done,
     /* 19601 */   // Label 633: @19601
     /* 19601 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(19637), // Rule ID 1252 //
     /* 19606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phr),
     /* 19614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 19617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 19620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19628 */     // (intrinsic_wo_chain:{ *:[i32] } 8113:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs)  =>  (PRECEQ_W_PHR_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs)
     /* 19628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHR_MM),
     /* 19631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19635 */     GIR_RootConstrainSelectedInstOperands,
     /* 19636 */     // GIR_Coverage, 1252,
     /* 19636 */     GIR_EraseRootFromParent_Done,
     /* 19637 */   // Label 634: @19637
     /* 19637 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(19673), // Rule ID 1253 //
     /* 19642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbl),
     /* 19650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19664 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8114:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBL_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBL_MM),
     /* 19667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19671 */     GIR_RootConstrainSelectedInstOperands,
     /* 19672 */     // GIR_Coverage, 1253,
     /* 19672 */     GIR_EraseRootFromParent_Done,
     /* 19673 */   // Label 635: @19673
     /* 19673 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(19709), // Rule ID 1254 //
     /* 19678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbla),
     /* 19686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19700 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8115:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBLA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBLA_MM),
     /* 19703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19707 */     GIR_RootConstrainSelectedInstOperands,
     /* 19708 */     // GIR_Coverage, 1254,
     /* 19708 */     GIR_EraseRootFromParent_Done,
     /* 19709 */   // Label 636: @19709
     /* 19709 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(19745), // Rule ID 1255 //
     /* 19714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbr),
     /* 19722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19736 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8116:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBR_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBR_MM),
     /* 19739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19743 */     GIR_RootConstrainSelectedInstOperands,
     /* 19744 */     // GIR_Coverage, 1255,
     /* 19744 */     GIR_EraseRootFromParent_Done,
     /* 19745 */   // Label 637: @19745
     /* 19745 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(19781), // Rule ID 1256 //
     /* 19750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbra),
     /* 19758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19772 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8117:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBRA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBRA_MM),
     /* 19775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19779 */     GIR_RootConstrainSelectedInstOperands,
     /* 19780 */     // GIR_Coverage, 1256,
     /* 19780 */     GIR_EraseRootFromParent_Done,
     /* 19781 */   // Label 638: @19781
     /* 19781 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(19817), // Rule ID 1257 //
     /* 19786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbl),
     /* 19794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19808 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8118:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBL_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBL_MM),
     /* 19811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19815 */     GIR_RootConstrainSelectedInstOperands,
     /* 19816 */     // GIR_Coverage, 1257,
     /* 19816 */     GIR_EraseRootFromParent_Done,
     /* 19817 */   // Label 639: @19817
     /* 19817 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(19853), // Rule ID 1258 //
     /* 19822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbla),
     /* 19830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19844 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8119:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBLA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBLA_MM),
     /* 19847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19851 */     GIR_RootConstrainSelectedInstOperands,
     /* 19852 */     // GIR_Coverage, 1258,
     /* 19852 */     GIR_EraseRootFromParent_Done,
     /* 19853 */   // Label 640: @19853
     /* 19853 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(19889), // Rule ID 1259 //
     /* 19858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbr),
     /* 19866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19880 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8120:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBR_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBR_MM),
     /* 19883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19887 */     GIR_RootConstrainSelectedInstOperands,
     /* 19888 */     // GIR_Coverage, 1259,
     /* 19888 */     GIR_EraseRootFromParent_Done,
     /* 19889 */   // Label 641: @19889
     /* 19889 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(19925), // Rule ID 1260 //
     /* 19894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbra),
     /* 19902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19916 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8121:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBRA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBRA_MM),
     /* 19919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19923 */     GIR_RootConstrainSelectedInstOperands,
     /* 19924 */     // GIR_Coverage, 1260,
     /* 19924 */     GIR_EraseRootFromParent_Done,
     /* 19925 */   // Label 642: @19925
     /* 19925 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(19961), // Rule ID 1286 //
     /* 19930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_raddu_w_qb),
     /* 19938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 19941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19952 */     // (intrinsic_wo_chain:{ *:[i32] } 8130:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (RADDU_W_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RADDU_W_QB_MM),
     /* 19955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19959 */     GIR_RootConstrainSelectedInstOperands,
     /* 19960 */     // GIR_Coverage, 1286,
     /* 19960 */     GIR_EraseRootFromParent_Done,
     /* 19961 */   // Label 643: @19961
     /* 19961 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(19997), // Rule ID 1290 //
     /* 19966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 19974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 19980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19988 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8132:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (REPLV_PH_MM:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 19988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_PH_MM),
     /* 19991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19995 */     GIR_RootConstrainSelectedInstOperands,
     /* 19996 */     // GIR_Coverage, 1290,
     /* 19996 */     GIR_EraseRootFromParent_Done,
     /* 19997 */   // Label 644: @19997
     /* 19997 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(20033), // Rule ID 1291 //
     /* 20002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 20005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 20010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 20013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 20016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20024 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8133:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (REPLV_QB_MM:{ *:[v4i8] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 20024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_QB_MM),
     /* 20027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 20029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 20031 */     GIR_RootConstrainSelectedInstOperands,
     /* 20032 */     // GIR_Coverage, 1291,
     /* 20032 */     GIR_EraseRootFromParent_Done,
     /* 20033 */   // Label 645: @20033
     /* 20033 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(20069), // Rule ID 1301 //
     /* 20038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 20041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_bitrev),
     /* 20046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 20049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 20052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20060 */     // (intrinsic_wo_chain:{ *:[i32] } 7686:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (BITREV_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 20060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BITREV_MM),
     /* 20063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 20065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 20067 */     GIR_RootConstrainSelectedInstOperands,
     /* 20068 */     // GIR_Coverage, 1301,
     /* 20068 */     GIR_EraseRootFromParent_Done,
     /* 20069 */   // Label 646: @20069
     /* 20069 */   GIM_Reject,
     /* 20070 */ // Label 592: @20070
     /* 20070 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(29823),
     /* 20075 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 20078 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(20124), // Rule ID 938 //
     /* 20083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_b),
     /* 20091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20105 */     // MIs[0] m
     /* 20105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20108 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20113 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8134:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SAT_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_B),
     /* 20116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20118 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20120 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20122 */     GIR_RootConstrainSelectedInstOperands,
     /* 20123 */     // GIR_Coverage, 938,
     /* 20123 */     GIR_EraseRootFromParent_Done,
     /* 20124 */   // Label 648: @20124
     /* 20124 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(20170), // Rule ID 939 //
     /* 20129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_h),
     /* 20137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20151 */     // MIs[0] m
     /* 20151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20159 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8136:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SAT_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_H),
     /* 20162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20164 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20166 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20168 */     GIR_RootConstrainSelectedInstOperands,
     /* 20169 */     // GIR_Coverage, 939,
     /* 20169 */     GIR_EraseRootFromParent_Done,
     /* 20170 */   // Label 649: @20170
     /* 20170 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(20216), // Rule ID 940 //
     /* 20175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_w),
     /* 20183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20197 */     // MIs[0] m
     /* 20197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20200 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20205 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8137:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SAT_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_W),
     /* 20208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20210 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20212 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20214 */     GIR_RootConstrainSelectedInstOperands,
     /* 20215 */     // GIR_Coverage, 940,
     /* 20215 */     GIR_EraseRootFromParent_Done,
     /* 20216 */   // Label 650: @20216
     /* 20216 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(20262), // Rule ID 941 //
     /* 20221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_d),
     /* 20229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20243 */     // MIs[0] m
     /* 20243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20251 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8135:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SAT_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_D),
     /* 20254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20256 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20258 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20260 */     GIR_RootConstrainSelectedInstOperands,
     /* 20261 */     // GIR_Coverage, 941,
     /* 20261 */     GIR_EraseRootFromParent_Done,
     /* 20262 */   // Label 651: @20262
     /* 20262 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(20308), // Rule ID 942 //
     /* 20267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_b),
     /* 20275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20289 */     // MIs[0] m
     /* 20289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20297 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8138:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SAT_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_B),
     /* 20300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20302 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20304 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20306 */     GIR_RootConstrainSelectedInstOperands,
     /* 20307 */     // GIR_Coverage, 942,
     /* 20307 */     GIR_EraseRootFromParent_Done,
     /* 20308 */   // Label 652: @20308
     /* 20308 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(20354), // Rule ID 943 //
     /* 20313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_h),
     /* 20321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20335 */     // MIs[0] m
     /* 20335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20343 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8140:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SAT_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_H),
     /* 20346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20348 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20350 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20352 */     GIR_RootConstrainSelectedInstOperands,
     /* 20353 */     // GIR_Coverage, 943,
     /* 20353 */     GIR_EraseRootFromParent_Done,
     /* 20354 */   // Label 653: @20354
     /* 20354 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(20400), // Rule ID 944 //
     /* 20359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_w),
     /* 20367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20381 */     // MIs[0] m
     /* 20381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20384 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20389 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8141:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SAT_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_W),
     /* 20392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20394 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20396 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20398 */     GIR_RootConstrainSelectedInstOperands,
     /* 20399 */     // GIR_Coverage, 944,
     /* 20399 */     GIR_EraseRootFromParent_Done,
     /* 20400 */   // Label 654: @20400
     /* 20400 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(20446), // Rule ID 945 //
     /* 20405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_d),
     /* 20413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20427 */     // MIs[0] m
     /* 20427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20430 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20435 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8139:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SAT_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_D),
     /* 20438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20440 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20442 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20444 */     GIR_RootConstrainSelectedInstOperands,
     /* 20445 */     // GIR_Coverage, 945,
     /* 20445 */     GIR_EraseRootFromParent_Done,
     /* 20446 */   // Label 655: @20446
     /* 20446 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(20492), // Rule ID 985 //
     /* 20451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_b),
     /* 20459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20473 */     // MIs[0] m
     /* 20473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20476 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20481 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8193:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SRARI_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_B),
     /* 20484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20486 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20488 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20490 */     GIR_RootConstrainSelectedInstOperands,
     /* 20491 */     // GIR_Coverage, 985,
     /* 20491 */     GIR_EraseRootFromParent_Done,
     /* 20492 */   // Label 656: @20492
     /* 20492 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(20538), // Rule ID 986 //
     /* 20497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_h),
     /* 20505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20519 */     // MIs[0] m
     /* 20519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20522 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20527 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8195:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SRARI_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_H),
     /* 20530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20532 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20534 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20536 */     GIR_RootConstrainSelectedInstOperands,
     /* 20537 */     // GIR_Coverage, 986,
     /* 20537 */     GIR_EraseRootFromParent_Done,
     /* 20538 */   // Label 657: @20538
     /* 20538 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(20584), // Rule ID 987 //
     /* 20543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_w),
     /* 20551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20565 */     // MIs[0] m
     /* 20565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20568 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20573 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8196:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SRARI_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_W),
     /* 20576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20578 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20580 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20582 */     GIR_RootConstrainSelectedInstOperands,
     /* 20583 */     // GIR_Coverage, 987,
     /* 20583 */     GIR_EraseRootFromParent_Done,
     /* 20584 */   // Label 658: @20584
     /* 20584 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(20630), // Rule ID 988 //
     /* 20589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_d),
     /* 20597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20611 */     // MIs[0] m
     /* 20611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20614 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20619 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8194:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SRARI_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_D),
     /* 20622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20624 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20626 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20628 */     GIR_RootConstrainSelectedInstOperands,
     /* 20629 */     // GIR_Coverage, 988,
     /* 20629 */     GIR_EraseRootFromParent_Done,
     /* 20630 */   // Label 659: @20630
     /* 20630 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(20676), // Rule ID 1001 //
     /* 20635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_b),
     /* 20643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20657 */     // MIs[0] m
     /* 20657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20665 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8209:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SRLRI_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_B),
     /* 20668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20670 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20672 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20674 */     GIR_RootConstrainSelectedInstOperands,
     /* 20675 */     // GIR_Coverage, 1001,
     /* 20675 */     GIR_EraseRootFromParent_Done,
     /* 20676 */   // Label 660: @20676
     /* 20676 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(20722), // Rule ID 1002 //
     /* 20681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_h),
     /* 20689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20703 */     // MIs[0] m
     /* 20703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20711 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8211:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SRLRI_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_H),
     /* 20714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20716 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20718 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20720 */     GIR_RootConstrainSelectedInstOperands,
     /* 20721 */     // GIR_Coverage, 1002,
     /* 20721 */     GIR_EraseRootFromParent_Done,
     /* 20722 */   // Label 661: @20722
     /* 20722 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(20768), // Rule ID 1003 //
     /* 20727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_w),
     /* 20735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20749 */     // MIs[0] m
     /* 20749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20752 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20757 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8212:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SRLRI_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_W),
     /* 20760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20762 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20764 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20766 */     GIR_RootConstrainSelectedInstOperands,
     /* 20767 */     // GIR_Coverage, 1003,
     /* 20767 */     GIR_EraseRootFromParent_Done,
     /* 20768 */   // Label 662: @20768
     /* 20768 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(20814), // Rule ID 1004 //
     /* 20773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_d),
     /* 20781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20795 */     // MIs[0] m
     /* 20795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20803 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8210:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SRLRI_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_D),
     /* 20806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20808 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20810 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20812 */     GIR_RootConstrainSelectedInstOperands,
     /* 20813 */     // GIR_Coverage, 1004,
     /* 20813 */     GIR_EraseRootFromParent_Done,
     /* 20814 */   // Label 663: @20814
     /* 20814 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(20870), // Rule ID 385 //
     /* 20819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 20822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 20827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 20830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 20833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 20856 */     // MIs[1] Operand 1
     /* 20856 */     // No operand predicates
     /* 20856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20858 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8152:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$rs_sa)  =>  (SHRA_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 20858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_PH),
     /* 20861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 20863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 20865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 20868 */     GIR_RootConstrainSelectedInstOperands,
     /* 20869 */     // GIR_Coverage, 385,
     /* 20869 */     GIR_EraseRootFromParent_Done,
     /* 20870 */   // Label 664: @20870
     /* 20870 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(20926), // Rule ID 389 //
     /* 20875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 20878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 20883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 20886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 20889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 20912 */     // MIs[1] Operand 1
     /* 20912 */     // No operand predicates
     /* 20912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20914 */     // (intrinsic_wo_chain:{ *:[i32] } 8154:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$rs_sa)  =>  (SHRA_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 20914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_W),
     /* 20917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 20919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 20921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 20924 */     GIR_RootConstrainSelectedInstOperands,
     /* 20925 */     // GIR_Coverage, 389,
     /* 20925 */     GIR_EraseRootFromParent_Done,
     /* 20926 */   // Label 665: @20926
     /* 20926 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(20982), // Rule ID 480 //
     /* 20931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 20934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 20939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 20942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 20945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 20968 */     // MIs[1] Operand 1
     /* 20968 */     // No operand predicates
     /* 20968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20970 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8153:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$rs_sa)  =>  (SHRA_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 20970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_QB),
     /* 20973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 20975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 20977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 20980 */     GIR_RootConstrainSelectedInstOperands,
     /* 20981 */     // GIR_Coverage, 480,
     /* 20981 */     GIR_EraseRootFromParent_Done,
     /* 20982 */   // Label 666: @20982
     /* 20982 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(21038), // Rule ID 1245 //
     /* 20987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 20990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 20995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 20998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 21024 */     // MIs[1] Operand 1
     /* 21024 */     // No operand predicates
     /* 21024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21026 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8152:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$sa)  =>  (SHRA_R_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 21026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_PH_MM),
     /* 21029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 21031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 21036 */     GIR_RootConstrainSelectedInstOperands,
     /* 21037 */     // GIR_Coverage, 1245,
     /* 21037 */     GIR_EraseRootFromParent_Done,
     /* 21038 */   // Label 667: @21038
     /* 21038 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(21094), // Rule ID 1249 //
     /* 21043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 21046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 21051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 21054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 21080 */     // MIs[1] Operand 1
     /* 21080 */     // No operand predicates
     /* 21080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21082 */     // (intrinsic_wo_chain:{ *:[i32] } 8154:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$sa)  =>  (SHRA_R_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 21082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_W_MM),
     /* 21085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 21087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 21092 */     GIR_RootConstrainSelectedInstOperands,
     /* 21093 */     // GIR_Coverage, 1249,
     /* 21093 */     GIR_EraseRootFromParent_Done,
     /* 21094 */   // Label 668: @21094
     /* 21094 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(21150), // Rule ID 1324 //
     /* 21099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 21102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 21107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 21136 */     // MIs[1] Operand 1
     /* 21136 */     // No operand predicates
     /* 21136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21138 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8153:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$sa)  =>  (SHRA_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 21138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_QB_MMR2),
     /* 21141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 21143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 21148 */     GIR_RootConstrainSelectedInstOperands,
     /* 21149 */     // GIR_Coverage, 1324,
     /* 21149 */     GIR_EraseRootFromParent_Done,
     /* 21150 */   // Label 669: @21150
     /* 21150 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(21202), // Rule ID 1943 //
     /* 21155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_ph),
     /* 21163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 21188 */     // MIs[1] Operand 1
     /* 21188 */     // No operand predicates
     /* 21188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21190 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8150:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)  =>  (SHRA_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)
     /* 21190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_PH),
     /* 21193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21195 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21200 */     GIR_RootConstrainSelectedInstOperands,
     /* 21201 */     // GIR_Coverage, 1943,
     /* 21201 */     GIR_EraseRootFromParent_Done,
     /* 21202 */   // Label 670: @21202
     /* 21202 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(21254), // Rule ID 1944 //
     /* 21207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_ph),
     /* 21215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 21240 */     // MIs[1] Operand 1
     /* 21240 */     // No operand predicates
     /* 21240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21242 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8155:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)  =>  (SHRL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)
     /* 21242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRL_PH),
     /* 21245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21247 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21252 */     GIR_RootConstrainSelectedInstOperands,
     /* 21253 */     // GIR_Coverage, 1944,
     /* 21253 */     GIR_EraseRootFromParent_Done,
     /* 21254 */   // Label 671: @21254
     /* 21254 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(21306), // Rule ID 1949 //
     /* 21259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_qb),
     /* 21267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 21292 */     // MIs[1] Operand 1
     /* 21292 */     // No operand predicates
     /* 21292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21294 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8151:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)  =>  (SHRA_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)
     /* 21294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_QB),
     /* 21297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21299 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21304 */     GIR_RootConstrainSelectedInstOperands,
     /* 21305 */     // GIR_Coverage, 1949,
     /* 21305 */     GIR_EraseRootFromParent_Done,
     /* 21306 */   // Label 672: @21306
     /* 21306 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(21358), // Rule ID 1950 //
     /* 21311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_qb),
     /* 21319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 21344 */     // MIs[1] Operand 1
     /* 21344 */     // No operand predicates
     /* 21344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21346 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8156:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)  =>  (SHRL_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)
     /* 21346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRL_QB),
     /* 21349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21351 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21356 */     GIR_RootConstrainSelectedInstOperands,
     /* 21357 */     // GIR_Coverage, 1950,
     /* 21357 */     GIR_EraseRootFromParent_Done,
     /* 21358 */   // Label 673: @21358
     /* 21358 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(21406), // Rule ID 355 //
     /* 21363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_qb),
     /* 21371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21392 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7622:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDU_S_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_QB),
     /* 21395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21404 */     GIR_RootConstrainSelectedInstOperands,
     /* 21405 */     // GIR_Coverage, 355,
     /* 21405 */     GIR_EraseRootFromParent_Done,
     /* 21406 */   // Label 674: @21406
     /* 21406 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(21454), // Rule ID 356 //
     /* 21411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_qb),
     /* 21419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21440 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8245:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBU_S_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_QB),
     /* 21443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21452 */     GIR_RootConstrainSelectedInstOperands,
     /* 21453 */     // GIR_Coverage, 356,
     /* 21453 */     GIR_EraseRootFromParent_Done,
     /* 21454 */   // Label 675: @21454
     /* 21454 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(21502), // Rule ID 357 //
     /* 21459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_ph),
     /* 21467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21488 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7600:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_PH),
     /* 21491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21500 */     GIR_RootConstrainSelectedInstOperands,
     /* 21501 */     // GIR_Coverage, 357,
     /* 21501 */     GIR_EraseRootFromParent_Done,
     /* 21502 */   // Label 676: @21502
     /* 21502 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(21550), // Rule ID 358 //
     /* 21507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_ph),
     /* 21515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21536 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8220:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_PH),
     /* 21539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21548 */     GIR_RootConstrainSelectedInstOperands,
     /* 21549 */     // GIR_Coverage, 358,
     /* 21549 */     GIR_EraseRootFromParent_Done,
     /* 21550 */   // Label 677: @21550
     /* 21550 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(21595), // Rule ID 361 //
     /* 21555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_modsub),
     /* 21563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 21566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21584 */     // (intrinsic_wo_chain:{ *:[i32] } 8050:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODSUB:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 21584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MODSUB),
     /* 21587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21593 */     GIR_RootConstrainSelectedInstOperands,
     /* 21594 */     // GIR_Coverage, 361,
     /* 21594 */     GIR_EraseRootFromParent_Done,
     /* 21595 */   // Label 678: @21595
     /* 21595 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(21640), // Rule ID 365 //
     /* 21600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_qb_ph),
     /* 21608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21629 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8126:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQ_QB_PH:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_QB_PH),
     /* 21632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21638 */     GIR_RootConstrainSelectedInstOperands,
     /* 21639 */     // GIR_Coverage, 365,
     /* 21639 */     GIR_EraseRootFromParent_Done,
     /* 21640 */   // Label 679: @21640
     /* 21640 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(21685), // Rule ID 366 //
     /* 21645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_ph_w),
     /* 21653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21674 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8125:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 21674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_PH_W),
     /* 21677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21683 */     GIR_RootConstrainSelectedInstOperands,
     /* 21684 */     // GIR_Coverage, 366,
     /* 21684 */     GIR_EraseRootFromParent_Done,
     /* 21685 */   // Label 680: @21685
     /* 21685 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(21730), // Rule ID 380 //
     /* 21690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_qb),
     /* 21698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21719 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8156:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRLV_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_QB),
     /* 21722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21728 */     GIR_RootConstrainSelectedInstOperands,
     /* 21729 */     // GIR_Coverage, 380,
     /* 21729 */     GIR_EraseRootFromParent_Done,
     /* 21730 */   // Label 681: @21730
     /* 21730 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(21775), // Rule ID 384 //
     /* 21735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_ph),
     /* 21743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21764 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8150:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_PH),
     /* 21767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21773 */     GIR_RootConstrainSelectedInstOperands,
     /* 21774 */     // GIR_Coverage, 384,
     /* 21774 */     GIR_EraseRootFromParent_Done,
     /* 21775 */   // Label 682: @21775
     /* 21775 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(21820), // Rule ID 386 //
     /* 21780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 21788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21809 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8152:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_PH),
     /* 21812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21818 */     GIR_RootConstrainSelectedInstOperands,
     /* 21819 */     // GIR_Coverage, 386,
     /* 21819 */     GIR_EraseRootFromParent_Done,
     /* 21820 */   // Label 683: @21820
     /* 21820 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(21865), // Rule ID 390 //
     /* 21825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 21833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 21836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21854 */     // (intrinsic_wo_chain:{ *:[i32] } 8154:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_W),
     /* 21857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21863 */     GIR_RootConstrainSelectedInstOperands,
     /* 21864 */     // GIR_Coverage, 390,
     /* 21864 */     GIR_EraseRootFromParent_Done,
     /* 21865 */   // Label 684: @21865
     /* 21865 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(21910), // Rule ID 427 //
     /* 21870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_packrl_ph),
     /* 21878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21899 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8097:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PACKRL_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PACKRL_PH),
     /* 21902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21908 */     GIR_RootConstrainSelectedInstOperands,
     /* 21909 */     // GIR_Coverage, 427,
     /* 21909 */     GIR_EraseRootFromParent_Done,
     /* 21910 */   // Label 685: @21910
     /* 21910 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(21955), // Rule ID 451 //
     /* 21915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_qb),
     /* 21923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21944 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7623:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_QB),
     /* 21947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21953 */     GIR_RootConstrainSelectedInstOperands,
     /* 21954 */     // GIR_Coverage, 451,
     /* 21954 */     GIR_EraseRootFromParent_Done,
     /* 21955 */   // Label 686: @21955
     /* 21955 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(22000), // Rule ID 452 //
     /* 21960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_r_qb),
     /* 21968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21989 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7624:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_R_QB),
     /* 21992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21998 */     GIR_RootConstrainSelectedInstOperands,
     /* 21999 */     // GIR_Coverage, 452,
     /* 21999 */     GIR_EraseRootFromParent_Done,
     /* 22000 */   // Label 687: @22000
     /* 22000 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(22045), // Rule ID 453 //
     /* 22005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_qb),
     /* 22013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 22016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 22019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 22022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22034 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8246:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 22034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_QB),
     /* 22037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22043 */     GIR_RootConstrainSelectedInstOperands,
     /* 22044 */     // GIR_Coverage, 453,
     /* 22044 */     GIR_EraseRootFromParent_Done,
     /* 22045 */   // Label 688: @22045
     /* 22045 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(22090), // Rule ID 454 //
     /* 22050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_r_qb),
     /* 22058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 22061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 22064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 22067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22079 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8247:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 22079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_R_QB),
     /* 22082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22088 */     GIR_RootConstrainSelectedInstOperands,
     /* 22089 */     // GIR_Coverage, 454,
     /* 22089 */     GIR_EraseRootFromParent_Done,
     /* 22090 */   // Label 689: @22090
     /* 22090 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(22135), // Rule ID 455 //
     /* 22095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_ph),
     /* 22103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22124 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7602:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_PH),
     /* 22127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22133 */     GIR_RootConstrainSelectedInstOperands,
     /* 22134 */     // GIR_Coverage, 455,
     /* 22134 */     GIR_EraseRootFromParent_Done,
     /* 22135 */   // Label 690: @22135
     /* 22135 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(22180), // Rule ID 456 //
     /* 22140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_ph),
     /* 22148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22169 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7603:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_PH),
     /* 22172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22178 */     GIR_RootConstrainSelectedInstOperands,
     /* 22179 */     // GIR_Coverage, 456,
     /* 22179 */     GIR_EraseRootFromParent_Done,
     /* 22180 */   // Label 691: @22180
     /* 22180 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(22225), // Rule ID 457 //
     /* 22185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_ph),
     /* 22193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22214 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8222:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_PH),
     /* 22217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22223 */     GIR_RootConstrainSelectedInstOperands,
     /* 22224 */     // GIR_Coverage, 457,
     /* 22224 */     GIR_EraseRootFromParent_Done,
     /* 22225 */   // Label 692: @22225
     /* 22225 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(22270), // Rule ID 458 //
     /* 22230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_ph),
     /* 22238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22259 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8223:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_PH),
     /* 22262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22268 */     GIR_RootConstrainSelectedInstOperands,
     /* 22269 */     // GIR_Coverage, 458,
     /* 22269 */     GIR_EraseRootFromParent_Done,
     /* 22270 */   // Label 693: @22270
     /* 22270 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(22315), // Rule ID 459 //
     /* 22275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_w),
     /* 22283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22304 */     // (intrinsic_wo_chain:{ *:[i32] } 7605:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_W),
     /* 22307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22313 */     GIR_RootConstrainSelectedInstOperands,
     /* 22314 */     // GIR_Coverage, 459,
     /* 22314 */     GIR_EraseRootFromParent_Done,
     /* 22315 */   // Label 694: @22315
     /* 22315 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(22360), // Rule ID 460 //
     /* 22320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_w),
     /* 22328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22349 */     // (intrinsic_wo_chain:{ *:[i32] } 7604:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_W),
     /* 22352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22358 */     GIR_RootConstrainSelectedInstOperands,
     /* 22359 */     // GIR_Coverage, 460,
     /* 22359 */     GIR_EraseRootFromParent_Done,
     /* 22360 */   // Label 695: @22360
     /* 22360 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(22405), // Rule ID 461 //
     /* 22365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_w),
     /* 22373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22394 */     // (intrinsic_wo_chain:{ *:[i32] } 8225:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_W),
     /* 22397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22403 */     GIR_RootConstrainSelectedInstOperands,
     /* 22404 */     // GIR_Coverage, 461,
     /* 22404 */     GIR_EraseRootFromParent_Done,
     /* 22405 */   // Label 696: @22405
     /* 22405 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(22450), // Rule ID 462 //
     /* 22410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_w),
     /* 22418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22439 */     // (intrinsic_wo_chain:{ *:[i32] } 8224:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_W),
     /* 22442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22448 */     GIR_RootConstrainSelectedInstOperands,
     /* 22449 */     // GIR_Coverage, 462,
     /* 22449 */     GIR_EraseRootFromParent_Done,
     /* 22450 */   // Label 697: @22450
     /* 22450 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(22495), // Rule ID 479 //
     /* 22455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_qb),
     /* 22463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 22466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 22469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22484 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8151:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 22484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_QB),
     /* 22487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 22491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 22493 */     GIR_RootConstrainSelectedInstOperands,
     /* 22494 */     // GIR_Coverage, 479,
     /* 22494 */     GIR_EraseRootFromParent_Done,
     /* 22495 */   // Label 698: @22495
     /* 22495 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(22540), // Rule ID 481 //
     /* 22500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 22508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 22511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 22514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22529 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8153:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 22529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_QB),
     /* 22532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 22536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 22538 */     GIR_RootConstrainSelectedInstOperands,
     /* 22539 */     // GIR_Coverage, 481,
     /* 22539 */     GIR_EraseRootFromParent_Done,
     /* 22540 */   // Label 699: @22540
     /* 22540 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(22585), // Rule ID 482 //
     /* 22545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_ph),
     /* 22553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22574 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8155:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRLV_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 22574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_PH),
     /* 22577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 22581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 22583 */     GIR_RootConstrainSelectedInstOperands,
     /* 22584 */     // GIR_Coverage, 482,
     /* 22584 */     GIR_EraseRootFromParent_Done,
     /* 22585 */   // Label 700: @22585
     /* 22585 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(22630), // Rule ID 491 //
     /* 22590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_b),
     /* 22598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 22601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 22604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 22607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22619 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7595:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADD_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 22619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_B),
     /* 22622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22624 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22626 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22628 */     GIR_RootConstrainSelectedInstOperands,
     /* 22629 */     // GIR_Coverage, 491,
     /* 22629 */     GIR_EraseRootFromParent_Done,
     /* 22630 */   // Label 701: @22630
     /* 22630 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(22675), // Rule ID 492 //
     /* 22635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_h),
     /* 22643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 22646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 22649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 22652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22664 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7597:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADD_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 22664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_H),
     /* 22667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22669 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22671 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22673 */     GIR_RootConstrainSelectedInstOperands,
     /* 22674 */     // GIR_Coverage, 492,
     /* 22674 */     GIR_EraseRootFromParent_Done,
     /* 22675 */   // Label 702: @22675
     /* 22675 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(22720), // Rule ID 493 //
     /* 22680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_w),
     /* 22688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 22691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 22694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 22697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22709 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7598:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADD_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 22709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_W),
     /* 22712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22714 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22716 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22718 */     GIR_RootConstrainSelectedInstOperands,
     /* 22719 */     // GIR_Coverage, 493,
     /* 22719 */     GIR_EraseRootFromParent_Done,
     /* 22720 */   // Label 703: @22720
     /* 22720 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(22765), // Rule ID 494 //
     /* 22725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_d),
     /* 22733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 22736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 22739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 22742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22754 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7596:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADD_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 22754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_D),
     /* 22757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22759 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22761 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22763 */     GIR_RootConstrainSelectedInstOperands,
     /* 22764 */     // GIR_Coverage, 494,
     /* 22764 */     GIR_EraseRootFromParent_Done,
     /* 22765 */   // Label 704: @22765
     /* 22765 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(22810), // Rule ID 495 //
     /* 22770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_b),
     /* 22778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 22781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 22784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 22787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22799 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7606:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDS_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 22799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_B),
     /* 22802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22804 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22806 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22808 */     GIR_RootConstrainSelectedInstOperands,
     /* 22809 */     // GIR_Coverage, 495,
     /* 22809 */     GIR_EraseRootFromParent_Done,
     /* 22810 */   // Label 705: @22810
     /* 22810 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(22855), // Rule ID 496 //
     /* 22815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_h),
     /* 22823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 22826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 22829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 22832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22844 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7608:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDS_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 22844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_H),
     /* 22847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22849 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22851 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22853 */     GIR_RootConstrainSelectedInstOperands,
     /* 22854 */     // GIR_Coverage, 496,
     /* 22854 */     GIR_EraseRootFromParent_Done,
     /* 22855 */   // Label 706: @22855
     /* 22855 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(22900), // Rule ID 497 //
     /* 22860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_w),
     /* 22868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 22871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 22874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 22877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22889 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7609:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDS_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 22889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_W),
     /* 22892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22894 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22896 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22898 */     GIR_RootConstrainSelectedInstOperands,
     /* 22899 */     // GIR_Coverage, 497,
     /* 22899 */     GIR_EraseRootFromParent_Done,
     /* 22900 */   // Label 707: @22900
     /* 22900 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(22945), // Rule ID 498 //
     /* 22905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_d),
     /* 22913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 22916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 22919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 22922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22934 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7607:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDS_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 22934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_D),
     /* 22937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22939 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22941 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22943 */     GIR_RootConstrainSelectedInstOperands,
     /* 22944 */     // GIR_Coverage, 498,
     /* 22944 */     GIR_EraseRootFromParent_Done,
     /* 22945 */   // Label 708: @22945
     /* 22945 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(22990), // Rule ID 499 //
     /* 22950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_b),
     /* 22958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 22961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 22964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 22967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22979 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7610:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDS_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 22979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_B),
     /* 22982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22984 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22986 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22988 */     GIR_RootConstrainSelectedInstOperands,
     /* 22989 */     // GIR_Coverage, 499,
     /* 22989 */     GIR_EraseRootFromParent_Done,
     /* 22990 */   // Label 709: @22990
     /* 22990 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(23035), // Rule ID 500 //
     /* 22995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_h),
     /* 23003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23024 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7612:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDS_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_H),
     /* 23027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23029 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23031 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23033 */     GIR_RootConstrainSelectedInstOperands,
     /* 23034 */     // GIR_Coverage, 500,
     /* 23034 */     GIR_EraseRootFromParent_Done,
     /* 23035 */   // Label 710: @23035
     /* 23035 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(23080), // Rule ID 501 //
     /* 23040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_w),
     /* 23048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23069 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7613:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDS_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_W),
     /* 23072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23074 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23076 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23078 */     GIR_RootConstrainSelectedInstOperands,
     /* 23079 */     // GIR_Coverage, 501,
     /* 23079 */     GIR_EraseRootFromParent_Done,
     /* 23080 */   // Label 711: @23080
     /* 23080 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(23125), // Rule ID 502 //
     /* 23085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_d),
     /* 23093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23114 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7611:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDS_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_D),
     /* 23117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23119 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23121 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23123 */     GIR_RootConstrainSelectedInstOperands,
     /* 23124 */     // GIR_Coverage, 502,
     /* 23124 */     GIR_EraseRootFromParent_Done,
     /* 23125 */   // Label 712: @23125
     /* 23125 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(23170), // Rule ID 503 //
     /* 23130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_b),
     /* 23138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23159 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7614:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDS_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_B),
     /* 23162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23164 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23166 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23168 */     GIR_RootConstrainSelectedInstOperands,
     /* 23169 */     // GIR_Coverage, 503,
     /* 23169 */     GIR_EraseRootFromParent_Done,
     /* 23170 */   // Label 713: @23170
     /* 23170 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(23215), // Rule ID 504 //
     /* 23175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_h),
     /* 23183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23204 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7616:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDS_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_H),
     /* 23207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23209 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23211 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23213 */     GIR_RootConstrainSelectedInstOperands,
     /* 23214 */     // GIR_Coverage, 504,
     /* 23214 */     GIR_EraseRootFromParent_Done,
     /* 23215 */   // Label 714: @23215
     /* 23215 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(23260), // Rule ID 505 //
     /* 23220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_w),
     /* 23228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23249 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7617:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDS_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_W),
     /* 23252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23254 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23256 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23258 */     GIR_RootConstrainSelectedInstOperands,
     /* 23259 */     // GIR_Coverage, 505,
     /* 23259 */     GIR_EraseRootFromParent_Done,
     /* 23260 */   // Label 715: @23260
     /* 23260 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(23305), // Rule ID 506 //
     /* 23265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_d),
     /* 23273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23294 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7615:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDS_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_D),
     /* 23297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23299 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23301 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23303 */     GIR_RootConstrainSelectedInstOperands,
     /* 23304 */     // GIR_Coverage, 506,
     /* 23304 */     GIR_EraseRootFromParent_Done,
     /* 23305 */   // Label 716: @23305
     /* 23305 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(23350), // Rule ID 520 //
     /* 23310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_b),
     /* 23318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23339 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7637:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ASUB_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_B),
     /* 23342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23344 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23346 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23348 */     GIR_RootConstrainSelectedInstOperands,
     /* 23349 */     // GIR_Coverage, 520,
     /* 23349 */     GIR_EraseRootFromParent_Done,
     /* 23350 */   // Label 717: @23350
     /* 23350 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(23395), // Rule ID 521 //
     /* 23355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_h),
     /* 23363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23384 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7639:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ASUB_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_H),
     /* 23387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23389 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23391 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23393 */     GIR_RootConstrainSelectedInstOperands,
     /* 23394 */     // GIR_Coverage, 521,
     /* 23394 */     GIR_EraseRootFromParent_Done,
     /* 23395 */   // Label 718: @23395
     /* 23395 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(23440), // Rule ID 522 //
     /* 23400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_w),
     /* 23408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23429 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7640:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ASUB_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_W),
     /* 23432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23434 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23436 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23438 */     GIR_RootConstrainSelectedInstOperands,
     /* 23439 */     // GIR_Coverage, 522,
     /* 23439 */     GIR_EraseRootFromParent_Done,
     /* 23440 */   // Label 719: @23440
     /* 23440 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(23485), // Rule ID 523 //
     /* 23445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_d),
     /* 23453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23474 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7638:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ASUB_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_D),
     /* 23477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23479 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23481 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23483 */     GIR_RootConstrainSelectedInstOperands,
     /* 23484 */     // GIR_Coverage, 523,
     /* 23484 */     GIR_EraseRootFromParent_Done,
     /* 23485 */   // Label 720: @23485
     /* 23485 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(23530), // Rule ID 524 //
     /* 23490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_b),
     /* 23498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23519 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7641:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ASUB_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_B),
     /* 23522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23524 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23526 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23528 */     GIR_RootConstrainSelectedInstOperands,
     /* 23529 */     // GIR_Coverage, 524,
     /* 23529 */     GIR_EraseRootFromParent_Done,
     /* 23530 */   // Label 721: @23530
     /* 23530 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(23575), // Rule ID 525 //
     /* 23535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_h),
     /* 23543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23564 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7643:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ASUB_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_H),
     /* 23567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23569 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23571 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23573 */     GIR_RootConstrainSelectedInstOperands,
     /* 23574 */     // GIR_Coverage, 525,
     /* 23574 */     GIR_EraseRootFromParent_Done,
     /* 23575 */   // Label 722: @23575
     /* 23575 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(23620), // Rule ID 526 //
     /* 23580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_w),
     /* 23588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23609 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7644:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ASUB_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_W),
     /* 23612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23614 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23616 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23618 */     GIR_RootConstrainSelectedInstOperands,
     /* 23619 */     // GIR_Coverage, 526,
     /* 23619 */     GIR_EraseRootFromParent_Done,
     /* 23620 */   // Label 723: @23620
     /* 23620 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(23665), // Rule ID 527 //
     /* 23625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_d),
     /* 23633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23654 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7642:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ASUB_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_D),
     /* 23657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23659 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23661 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23663 */     GIR_RootConstrainSelectedInstOperands,
     /* 23664 */     // GIR_Coverage, 527,
     /* 23664 */     GIR_EraseRootFromParent_Done,
     /* 23665 */   // Label 724: @23665
     /* 23665 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(23710), // Rule ID 528 //
     /* 23670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_b),
     /* 23678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23699 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7645:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVE_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_B),
     /* 23702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23704 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23706 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23708 */     GIR_RootConstrainSelectedInstOperands,
     /* 23709 */     // GIR_Coverage, 528,
     /* 23709 */     GIR_EraseRootFromParent_Done,
     /* 23710 */   // Label 725: @23710
     /* 23710 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(23755), // Rule ID 529 //
     /* 23715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_h),
     /* 23723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23744 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7647:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVE_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_H),
     /* 23747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23749 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23751 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23753 */     GIR_RootConstrainSelectedInstOperands,
     /* 23754 */     // GIR_Coverage, 529,
     /* 23754 */     GIR_EraseRootFromParent_Done,
     /* 23755 */   // Label 726: @23755
     /* 23755 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(23800), // Rule ID 530 //
     /* 23760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_w),
     /* 23768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23789 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7648:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVE_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_W),
     /* 23792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23794 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23796 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23798 */     GIR_RootConstrainSelectedInstOperands,
     /* 23799 */     // GIR_Coverage, 530,
     /* 23799 */     GIR_EraseRootFromParent_Done,
     /* 23800 */   // Label 727: @23800
     /* 23800 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(23845), // Rule ID 531 //
     /* 23805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_d),
     /* 23813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23834 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7646:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVE_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_D),
     /* 23837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23839 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23841 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23843 */     GIR_RootConstrainSelectedInstOperands,
     /* 23844 */     // GIR_Coverage, 531,
     /* 23844 */     GIR_EraseRootFromParent_Done,
     /* 23845 */   // Label 728: @23845
     /* 23845 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(23890), // Rule ID 532 //
     /* 23850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_b),
     /* 23858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23879 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7649:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVE_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_B),
     /* 23882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23884 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23886 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23888 */     GIR_RootConstrainSelectedInstOperands,
     /* 23889 */     // GIR_Coverage, 532,
     /* 23889 */     GIR_EraseRootFromParent_Done,
     /* 23890 */   // Label 729: @23890
     /* 23890 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(23935), // Rule ID 533 //
     /* 23895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_h),
     /* 23903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23924 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7651:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVE_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_H),
     /* 23927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23929 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23931 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23933 */     GIR_RootConstrainSelectedInstOperands,
     /* 23934 */     // GIR_Coverage, 533,
     /* 23934 */     GIR_EraseRootFromParent_Done,
     /* 23935 */   // Label 730: @23935
     /* 23935 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(23980), // Rule ID 534 //
     /* 23940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_w),
     /* 23948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23969 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7652:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVE_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_W),
     /* 23972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23974 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23976 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23978 */     GIR_RootConstrainSelectedInstOperands,
     /* 23979 */     // GIR_Coverage, 534,
     /* 23979 */     GIR_EraseRootFromParent_Done,
     /* 23980 */   // Label 731: @23980
     /* 23980 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(24025), // Rule ID 535 //
     /* 23985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_d),
     /* 23993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24014 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7650:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVE_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 24014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_D),
     /* 24017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24019 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24021 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24023 */     GIR_RootConstrainSelectedInstOperands,
     /* 24024 */     // GIR_Coverage, 535,
     /* 24024 */     GIR_EraseRootFromParent_Done,
     /* 24025 */   // Label 732: @24025
     /* 24025 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(24070), // Rule ID 536 //
     /* 24030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_b),
     /* 24038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 24041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24059 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7653:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVER_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_B),
     /* 24062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24064 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24066 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24068 */     GIR_RootConstrainSelectedInstOperands,
     /* 24069 */     // GIR_Coverage, 536,
     /* 24069 */     GIR_EraseRootFromParent_Done,
     /* 24070 */   // Label 733: @24070
     /* 24070 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(24115), // Rule ID 537 //
     /* 24075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_h),
     /* 24083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24104 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7655:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVER_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_H),
     /* 24107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24109 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24111 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24113 */     GIR_RootConstrainSelectedInstOperands,
     /* 24114 */     // GIR_Coverage, 537,
     /* 24114 */     GIR_EraseRootFromParent_Done,
     /* 24115 */   // Label 734: @24115
     /* 24115 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(24160), // Rule ID 538 //
     /* 24120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_w),
     /* 24128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24149 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7656:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVER_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_W),
     /* 24152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24154 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24156 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24158 */     GIR_RootConstrainSelectedInstOperands,
     /* 24159 */     // GIR_Coverage, 538,
     /* 24159 */     GIR_EraseRootFromParent_Done,
     /* 24160 */   // Label 735: @24160
     /* 24160 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(24205), // Rule ID 539 //
     /* 24165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_d),
     /* 24173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24194 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7654:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVER_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 24194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_D),
     /* 24197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24199 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24201 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24203 */     GIR_RootConstrainSelectedInstOperands,
     /* 24204 */     // GIR_Coverage, 539,
     /* 24204 */     GIR_EraseRootFromParent_Done,
     /* 24205 */   // Label 736: @24205
     /* 24205 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(24250), // Rule ID 540 //
     /* 24210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_b),
     /* 24218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 24221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24239 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7657:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVER_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_B),
     /* 24242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24244 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24246 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24248 */     GIR_RootConstrainSelectedInstOperands,
     /* 24249 */     // GIR_Coverage, 540,
     /* 24249 */     GIR_EraseRootFromParent_Done,
     /* 24250 */   // Label 737: @24250
     /* 24250 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(24295), // Rule ID 541 //
     /* 24255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_h),
     /* 24263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24284 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7659:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVER_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_H),
     /* 24287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24289 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24291 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24293 */     GIR_RootConstrainSelectedInstOperands,
     /* 24294 */     // GIR_Coverage, 541,
     /* 24294 */     GIR_EraseRootFromParent_Done,
     /* 24295 */   // Label 738: @24295
     /* 24295 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(24340), // Rule ID 542 //
     /* 24300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_w),
     /* 24308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24329 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7660:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVER_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_W),
     /* 24332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24334 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24336 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24338 */     GIR_RootConstrainSelectedInstOperands,
     /* 24339 */     // GIR_Coverage, 542,
     /* 24339 */     GIR_EraseRootFromParent_Done,
     /* 24340 */   // Label 739: @24340
     /* 24340 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(24385), // Rule ID 543 //
     /* 24345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_d),
     /* 24353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24374 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7658:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVER_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 24374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_D),
     /* 24377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24379 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24381 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24383 */     GIR_RootConstrainSelectedInstOperands,
     /* 24384 */     // GIR_Coverage, 543,
     /* 24384 */     GIR_EraseRootFromParent_Done,
     /* 24385 */   // Label 740: @24385
     /* 24385 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(24430), // Rule ID 652 //
     /* 24390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_s_h),
     /* 24398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24419 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7792:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DOTP_S_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_S_H),
     /* 24422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24424 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24426 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24428 */     GIR_RootConstrainSelectedInstOperands,
     /* 24429 */     // GIR_Coverage, 652,
     /* 24429 */     GIR_EraseRootFromParent_Done,
     /* 24430 */   // Label 741: @24430
     /* 24430 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(24475), // Rule ID 653 //
     /* 24435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_s_w),
     /* 24443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24464 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7793:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DOTP_S_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_S_W),
     /* 24467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24469 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24471 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24473 */     GIR_RootConstrainSelectedInstOperands,
     /* 24474 */     // GIR_Coverage, 653,
     /* 24474 */     GIR_EraseRootFromParent_Done,
     /* 24475 */   // Label 742: @24475
     /* 24475 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(24520), // Rule ID 654 //
     /* 24480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_s_d),
     /* 24488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24509 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7791:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DOTP_S_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_S_D),
     /* 24512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24514 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24516 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24518 */     GIR_RootConstrainSelectedInstOperands,
     /* 24519 */     // GIR_Coverage, 654,
     /* 24519 */     GIR_EraseRootFromParent_Done,
     /* 24520 */   // Label 743: @24520
     /* 24520 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(24565), // Rule ID 655 //
     /* 24525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_u_h),
     /* 24533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24554 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7795:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DOTP_U_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_U_H),
     /* 24557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24559 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24561 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24563 */     GIR_RootConstrainSelectedInstOperands,
     /* 24564 */     // GIR_Coverage, 655,
     /* 24564 */     GIR_EraseRootFromParent_Done,
     /* 24565 */   // Label 744: @24565
     /* 24565 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(24610), // Rule ID 656 //
     /* 24570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_u_w),
     /* 24578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24599 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7796:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DOTP_U_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_U_W),
     /* 24602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24604 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24606 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24608 */     GIR_RootConstrainSelectedInstOperands,
     /* 24609 */     // GIR_Coverage, 656,
     /* 24609 */     GIR_EraseRootFromParent_Done,
     /* 24610 */   // Label 745: @24610
     /* 24610 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(24655), // Rule ID 657 //
     /* 24615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_u_d),
     /* 24623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24644 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7794:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DOTP_U_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_U_D),
     /* 24647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24649 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24651 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24653 */     GIR_RootConstrainSelectedInstOperands,
     /* 24654 */     // GIR_Coverage, 657,
     /* 24654 */     GIR_EraseRootFromParent_Done,
     /* 24655 */   // Label 746: @24655
     /* 24655 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(24700), // Rule ID 672 //
     /* 24660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fcaf_w),
     /* 24668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24689 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7834:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FCAF_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCAF_W),
     /* 24692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24694 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24696 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24698 */     GIR_RootConstrainSelectedInstOperands,
     /* 24699 */     // GIR_Coverage, 672,
     /* 24699 */     GIR_EraseRootFromParent_Done,
     /* 24700 */   // Label 747: @24700
     /* 24700 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(24745), // Rule ID 673 //
     /* 24705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fcaf_d),
     /* 24713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24734 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7833:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FCAF_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCAF_D),
     /* 24737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24739 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24741 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24743 */     GIR_RootConstrainSelectedInstOperands,
     /* 24744 */     // GIR_Coverage, 673,
     /* 24744 */     GIR_EraseRootFromParent_Done,
     /* 24745 */   // Label 748: @24745
     /* 24745 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(24790), // Rule ID 698 //
     /* 24750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexdo_h),
     /* 24758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24779 */     // (intrinsic_wo_chain:{ *:[v8f16] } 7859:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FEXDO_H:{ *:[v8f16] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXDO_H),
     /* 24782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24784 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24786 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24788 */     GIR_RootConstrainSelectedInstOperands,
     /* 24789 */     // GIR_Coverage, 698,
     /* 24789 */     GIR_EraseRootFromParent_Done,
     /* 24790 */   // Label 749: @24790
     /* 24790 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(24835), // Rule ID 699 //
     /* 24795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexdo_w),
     /* 24803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24824 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7860:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FEXDO_W:{ *:[v4f32] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXDO_W),
     /* 24827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24829 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24831 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24833 */     GIR_RootConstrainSelectedInstOperands,
     /* 24834 */     // GIR_Coverage, 699,
     /* 24834 */     GIR_EraseRootFromParent_Done,
     /* 24835 */   // Label 750: @24835
     /* 24835 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(24880), // Rule ID 726 //
     /* 24840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_w),
     /* 24848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24869 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7886:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMAX_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_W),
     /* 24872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24874 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24876 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24878 */     GIR_RootConstrainSelectedInstOperands,
     /* 24879 */     // GIR_Coverage, 726,
     /* 24879 */     GIR_EraseRootFromParent_Done,
     /* 24880 */   // Label 751: @24880
     /* 24880 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(24925), // Rule ID 727 //
     /* 24885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_d),
     /* 24893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24914 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7885:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMAX_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_D),
     /* 24917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24919 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24921 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24923 */     GIR_RootConstrainSelectedInstOperands,
     /* 24924 */     // GIR_Coverage, 727,
     /* 24924 */     GIR_EraseRootFromParent_Done,
     /* 24925 */   // Label 752: @24925
     /* 24925 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(24970), // Rule ID 728 //
     /* 24930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_a_w),
     /* 24938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24959 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7884:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMAX_A_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_A_W),
     /* 24962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24964 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24966 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24968 */     GIR_RootConstrainSelectedInstOperands,
     /* 24969 */     // GIR_Coverage, 728,
     /* 24969 */     GIR_EraseRootFromParent_Done,
     /* 24970 */   // Label 753: @24970
     /* 24970 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(25015), // Rule ID 729 //
     /* 24975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_a_d),
     /* 24983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25004 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7883:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMAX_A_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_A_D),
     /* 25007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25009 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25011 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25013 */     GIR_RootConstrainSelectedInstOperands,
     /* 25014 */     // GIR_Coverage, 729,
     /* 25014 */     GIR_EraseRootFromParent_Done,
     /* 25015 */   // Label 754: @25015
     /* 25015 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(25060), // Rule ID 730 //
     /* 25020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_w),
     /* 25028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25049 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7890:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMIN_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_W),
     /* 25052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25054 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25056 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25058 */     GIR_RootConstrainSelectedInstOperands,
     /* 25059 */     // GIR_Coverage, 730,
     /* 25059 */     GIR_EraseRootFromParent_Done,
     /* 25060 */   // Label 755: @25060
     /* 25060 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(25105), // Rule ID 731 //
     /* 25065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_d),
     /* 25073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25094 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7889:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMIN_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_D),
     /* 25097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25099 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25101 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25103 */     GIR_RootConstrainSelectedInstOperands,
     /* 25104 */     // GIR_Coverage, 731,
     /* 25104 */     GIR_EraseRootFromParent_Done,
     /* 25105 */   // Label 756: @25105
     /* 25105 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(25150), // Rule ID 732 //
     /* 25110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_a_w),
     /* 25118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25139 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7888:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMIN_A_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_A_W),
     /* 25142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25144 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25146 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25148 */     GIR_RootConstrainSelectedInstOperands,
     /* 25149 */     // GIR_Coverage, 732,
     /* 25149 */     GIR_EraseRootFromParent_Done,
     /* 25150 */   // Label 757: @25150
     /* 25150 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(25195), // Rule ID 733 //
     /* 25155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_a_d),
     /* 25163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25184 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7887:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMIN_A_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_A_D),
     /* 25187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25189 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25191 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25193 */     GIR_RootConstrainSelectedInstOperands,
     /* 25194 */     // GIR_Coverage, 733,
     /* 25194 */     GIR_EraseRootFromParent_Done,
     /* 25195 */   // Label 758: @25195
     /* 25195 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(25240), // Rule ID 744 //
     /* 25200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsaf_w),
     /* 25208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25229 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7902:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSAF_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSAF_W),
     /* 25232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25234 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25236 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25238 */     GIR_RootConstrainSelectedInstOperands,
     /* 25239 */     // GIR_Coverage, 744,
     /* 25239 */     GIR_EraseRootFromParent_Done,
     /* 25240 */   // Label 759: @25240
     /* 25240 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(25285), // Rule ID 745 //
     /* 25245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsaf_d),
     /* 25253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25274 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7901:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSAF_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSAF_D),
     /* 25277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25279 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25281 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25283 */     GIR_RootConstrainSelectedInstOperands,
     /* 25284 */     // GIR_Coverage, 745,
     /* 25284 */     GIR_EraseRootFromParent_Done,
     /* 25285 */   // Label 760: @25285
     /* 25285 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(25330), // Rule ID 746 //
     /* 25290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fseq_w),
     /* 25298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25319 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7904:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSEQ_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSEQ_W),
     /* 25322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25324 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25326 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25328 */     GIR_RootConstrainSelectedInstOperands,
     /* 25329 */     // GIR_Coverage, 746,
     /* 25329 */     GIR_EraseRootFromParent_Done,
     /* 25330 */   // Label 761: @25330
     /* 25330 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(25375), // Rule ID 747 //
     /* 25335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fseq_d),
     /* 25343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25364 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7903:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSEQ_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSEQ_D),
     /* 25367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25369 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25371 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25373 */     GIR_RootConstrainSelectedInstOperands,
     /* 25374 */     // GIR_Coverage, 747,
     /* 25374 */     GIR_EraseRootFromParent_Done,
     /* 25375 */   // Label 762: @25375
     /* 25375 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(25420), // Rule ID 748 //
     /* 25380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsle_w),
     /* 25388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25409 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7906:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSLE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLE_W),
     /* 25412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25414 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25416 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25418 */     GIR_RootConstrainSelectedInstOperands,
     /* 25419 */     // GIR_Coverage, 748,
     /* 25419 */     GIR_EraseRootFromParent_Done,
     /* 25420 */   // Label 763: @25420
     /* 25420 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(25465), // Rule ID 749 //
     /* 25425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsle_d),
     /* 25433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25454 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7905:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSLE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLE_D),
     /* 25457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25459 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25461 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25463 */     GIR_RootConstrainSelectedInstOperands,
     /* 25464 */     // GIR_Coverage, 749,
     /* 25464 */     GIR_EraseRootFromParent_Done,
     /* 25465 */   // Label 764: @25465
     /* 25465 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(25510), // Rule ID 750 //
     /* 25470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fslt_w),
     /* 25478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25499 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7908:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSLT_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLT_W),
     /* 25502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25504 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25506 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25508 */     GIR_RootConstrainSelectedInstOperands,
     /* 25509 */     // GIR_Coverage, 750,
     /* 25509 */     GIR_EraseRootFromParent_Done,
     /* 25510 */   // Label 765: @25510
     /* 25510 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(25555), // Rule ID 751 //
     /* 25515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fslt_d),
     /* 25523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25544 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7907:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSLT_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLT_D),
     /* 25547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25549 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25551 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25553 */     GIR_RootConstrainSelectedInstOperands,
     /* 25554 */     // GIR_Coverage, 751,
     /* 25554 */     GIR_EraseRootFromParent_Done,
     /* 25555 */   // Label 766: @25555
     /* 25555 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(25600), // Rule ID 752 //
     /* 25560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsne_w),
     /* 25568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25589 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7910:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSNE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSNE_W),
     /* 25592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25594 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25596 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25598 */     GIR_RootConstrainSelectedInstOperands,
     /* 25599 */     // GIR_Coverage, 752,
     /* 25599 */     GIR_EraseRootFromParent_Done,
     /* 25600 */   // Label 767: @25600
     /* 25600 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(25645), // Rule ID 753 //
     /* 25605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsne_d),
     /* 25613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25634 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7909:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSNE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSNE_D),
     /* 25637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25639 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25641 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25643 */     GIR_RootConstrainSelectedInstOperands,
     /* 25644 */     // GIR_Coverage, 753,
     /* 25644 */     GIR_EraseRootFromParent_Done,
     /* 25645 */   // Label 768: @25645
     /* 25645 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(25690), // Rule ID 754 //
     /* 25650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsor_w),
     /* 25658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25679 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7912:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSOR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSOR_W),
     /* 25682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25684 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25686 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25688 */     GIR_RootConstrainSelectedInstOperands,
     /* 25689 */     // GIR_Coverage, 754,
     /* 25689 */     GIR_EraseRootFromParent_Done,
     /* 25690 */   // Label 769: @25690
     /* 25690 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(25735), // Rule ID 755 //
     /* 25695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsor_d),
     /* 25703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25724 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7911:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSOR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSOR_D),
     /* 25727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25729 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25731 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25733 */     GIR_RootConstrainSelectedInstOperands,
     /* 25734 */     // GIR_Coverage, 755,
     /* 25734 */     GIR_EraseRootFromParent_Done,
     /* 25735 */   // Label 770: @25735
     /* 25735 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(25780), // Rule ID 760 //
     /* 25740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsueq_w),
     /* 25748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25769 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7918:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUEQ_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUEQ_W),
     /* 25772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25774 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25776 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25778 */     GIR_RootConstrainSelectedInstOperands,
     /* 25779 */     // GIR_Coverage, 760,
     /* 25779 */     GIR_EraseRootFromParent_Done,
     /* 25780 */   // Label 771: @25780
     /* 25780 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(25825), // Rule ID 761 //
     /* 25785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsueq_d),
     /* 25793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25814 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7917:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUEQ_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUEQ_D),
     /* 25817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25819 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25821 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25823 */     GIR_RootConstrainSelectedInstOperands,
     /* 25824 */     // GIR_Coverage, 761,
     /* 25824 */     GIR_EraseRootFromParent_Done,
     /* 25825 */   // Label 772: @25825
     /* 25825 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(25870), // Rule ID 762 //
     /* 25830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsule_w),
     /* 25838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25859 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7920:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSULE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULE_W),
     /* 25862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25864 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25866 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25868 */     GIR_RootConstrainSelectedInstOperands,
     /* 25869 */     // GIR_Coverage, 762,
     /* 25869 */     GIR_EraseRootFromParent_Done,
     /* 25870 */   // Label 773: @25870
     /* 25870 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(25915), // Rule ID 763 //
     /* 25875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsule_d),
     /* 25883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25904 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7919:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSULE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULE_D),
     /* 25907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25909 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25911 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25913 */     GIR_RootConstrainSelectedInstOperands,
     /* 25914 */     // GIR_Coverage, 763,
     /* 25914 */     GIR_EraseRootFromParent_Done,
     /* 25915 */   // Label 774: @25915
     /* 25915 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(25960), // Rule ID 764 //
     /* 25920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsult_w),
     /* 25928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25949 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7922:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSULT_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULT_W),
     /* 25952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25954 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25956 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25958 */     GIR_RootConstrainSelectedInstOperands,
     /* 25959 */     // GIR_Coverage, 764,
     /* 25959 */     GIR_EraseRootFromParent_Done,
     /* 25960 */   // Label 775: @25960
     /* 25960 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(26005), // Rule ID 765 //
     /* 25965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsult_d),
     /* 25973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25994 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7921:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSULT_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULT_D),
     /* 25997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25999 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26001 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26003 */     GIR_RootConstrainSelectedInstOperands,
     /* 26004 */     // GIR_Coverage, 765,
     /* 26004 */     GIR_EraseRootFromParent_Done,
     /* 26005 */   // Label 776: @26005
     /* 26005 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(26050), // Rule ID 766 //
     /* 26010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsun_w),
     /* 26018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26039 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7924:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUN_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 26039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUN_W),
     /* 26042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26044 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26046 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26048 */     GIR_RootConstrainSelectedInstOperands,
     /* 26049 */     // GIR_Coverage, 766,
     /* 26049 */     GIR_EraseRootFromParent_Done,
     /* 26050 */   // Label 777: @26050
     /* 26050 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(26095), // Rule ID 767 //
     /* 26055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsun_d),
     /* 26063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26084 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7923:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUN_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 26084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUN_D),
     /* 26087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26089 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26091 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26093 */     GIR_RootConstrainSelectedInstOperands,
     /* 26094 */     // GIR_Coverage, 767,
     /* 26094 */     GIR_EraseRootFromParent_Done,
     /* 26095 */   // Label 778: @26095
     /* 26095 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(26140), // Rule ID 768 //
     /* 26100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsune_w),
     /* 26108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26129 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7926:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUNE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 26129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUNE_W),
     /* 26132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26134 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26136 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26138 */     GIR_RootConstrainSelectedInstOperands,
     /* 26139 */     // GIR_Coverage, 768,
     /* 26139 */     GIR_EraseRootFromParent_Done,
     /* 26140 */   // Label 779: @26140
     /* 26140 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(26185), // Rule ID 769 //
     /* 26145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsune_d),
     /* 26153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26174 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7925:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUNE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 26174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUNE_D),
     /* 26177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26179 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26181 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26183 */     GIR_RootConstrainSelectedInstOperands,
     /* 26184 */     // GIR_Coverage, 769,
     /* 26184 */     GIR_EraseRootFromParent_Done,
     /* 26185 */   // Label 780: @26185
     /* 26185 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(26230), // Rule ID 774 //
     /* 26190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftq_h),
     /* 26198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26219 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7931:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FTQ_H:{ *:[v8i16] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 26219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTQ_H),
     /* 26222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26224 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26226 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26228 */     GIR_RootConstrainSelectedInstOperands,
     /* 26229 */     // GIR_Coverage, 774,
     /* 26229 */     GIR_EraseRootFromParent_Done,
     /* 26230 */   // Label 781: @26230
     /* 26230 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(26275), // Rule ID 775 //
     /* 26235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftq_w),
     /* 26243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26264 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7932:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FTQ_W:{ *:[v4i32] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 26264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTQ_W),
     /* 26267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26269 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26271 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26273 */     GIR_RootConstrainSelectedInstOperands,
     /* 26274 */     // GIR_Coverage, 775,
     /* 26274 */     GIR_EraseRootFromParent_Done,
     /* 26275 */   // Label 782: @26275
     /* 26275 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(26320), // Rule ID 780 //
     /* 26280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_s_h),
     /* 26288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26309 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7938:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HADD_S_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_S_H),
     /* 26312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26314 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26316 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26318 */     GIR_RootConstrainSelectedInstOperands,
     /* 26319 */     // GIR_Coverage, 780,
     /* 26319 */     GIR_EraseRootFromParent_Done,
     /* 26320 */   // Label 783: @26320
     /* 26320 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(26365), // Rule ID 781 //
     /* 26325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_s_w),
     /* 26333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26354 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7939:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HADD_S_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_S_W),
     /* 26357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26359 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26361 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26363 */     GIR_RootConstrainSelectedInstOperands,
     /* 26364 */     // GIR_Coverage, 781,
     /* 26364 */     GIR_EraseRootFromParent_Done,
     /* 26365 */   // Label 784: @26365
     /* 26365 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(26410), // Rule ID 782 //
     /* 26370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_s_d),
     /* 26378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26399 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7937:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HADD_S_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_S_D),
     /* 26402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26404 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26406 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26408 */     GIR_RootConstrainSelectedInstOperands,
     /* 26409 */     // GIR_Coverage, 782,
     /* 26409 */     GIR_EraseRootFromParent_Done,
     /* 26410 */   // Label 785: @26410
     /* 26410 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(26455), // Rule ID 783 //
     /* 26415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_u_h),
     /* 26423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26444 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7941:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HADD_U_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_U_H),
     /* 26447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26449 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26451 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26453 */     GIR_RootConstrainSelectedInstOperands,
     /* 26454 */     // GIR_Coverage, 783,
     /* 26454 */     GIR_EraseRootFromParent_Done,
     /* 26455 */   // Label 786: @26455
     /* 26455 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(26500), // Rule ID 784 //
     /* 26460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_u_w),
     /* 26468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26489 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7942:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HADD_U_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_U_W),
     /* 26492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26494 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26496 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26498 */     GIR_RootConstrainSelectedInstOperands,
     /* 26499 */     // GIR_Coverage, 784,
     /* 26499 */     GIR_EraseRootFromParent_Done,
     /* 26500 */   // Label 787: @26500
     /* 26500 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(26545), // Rule ID 785 //
     /* 26505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_u_d),
     /* 26513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26534 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7940:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HADD_U_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_U_D),
     /* 26537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26539 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26541 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26543 */     GIR_RootConstrainSelectedInstOperands,
     /* 26544 */     // GIR_Coverage, 785,
     /* 26544 */     GIR_EraseRootFromParent_Done,
     /* 26545 */   // Label 788: @26545
     /* 26545 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(26590), // Rule ID 786 //
     /* 26550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_s_h),
     /* 26558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26579 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7944:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HSUB_S_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_S_H),
     /* 26582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26584 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26586 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26588 */     GIR_RootConstrainSelectedInstOperands,
     /* 26589 */     // GIR_Coverage, 786,
     /* 26589 */     GIR_EraseRootFromParent_Done,
     /* 26590 */   // Label 789: @26590
     /* 26590 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(26635), // Rule ID 787 //
     /* 26595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_s_w),
     /* 26603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26624 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7945:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HSUB_S_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_S_W),
     /* 26627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26629 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26631 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26633 */     GIR_RootConstrainSelectedInstOperands,
     /* 26634 */     // GIR_Coverage, 787,
     /* 26634 */     GIR_EraseRootFromParent_Done,
     /* 26635 */   // Label 790: @26635
     /* 26635 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(26680), // Rule ID 788 //
     /* 26640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_s_d),
     /* 26648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26669 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7943:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HSUB_S_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_S_D),
     /* 26672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26674 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26676 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26678 */     GIR_RootConstrainSelectedInstOperands,
     /* 26679 */     // GIR_Coverage, 788,
     /* 26679 */     GIR_EraseRootFromParent_Done,
     /* 26680 */   // Label 791: @26680
     /* 26680 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(26725), // Rule ID 789 //
     /* 26685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_u_h),
     /* 26693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26714 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7947:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HSUB_U_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_U_H),
     /* 26717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26719 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26721 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26723 */     GIR_RootConstrainSelectedInstOperands,
     /* 26724 */     // GIR_Coverage, 789,
     /* 26724 */     GIR_EraseRootFromParent_Done,
     /* 26725 */   // Label 792: @26725
     /* 26725 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(26770), // Rule ID 790 //
     /* 26730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_u_w),
     /* 26738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26759 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7948:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HSUB_U_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_U_W),
     /* 26762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26764 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26766 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26768 */     GIR_RootConstrainSelectedInstOperands,
     /* 26769 */     // GIR_Coverage, 790,
     /* 26769 */     GIR_EraseRootFromParent_Done,
     /* 26770 */   // Label 793: @26770
     /* 26770 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(26815), // Rule ID 791 //
     /* 26775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_u_d),
     /* 26783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26804 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7946:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HSUB_U_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_U_D),
     /* 26807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26809 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26811 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26813 */     GIR_RootConstrainSelectedInstOperands,
     /* 26814 */     // GIR_Coverage, 791,
     /* 26814 */     GIR_EraseRootFromParent_Done,
     /* 26815 */   // Label 794: @26815
     /* 26815 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(26860), // Rule ID 844 //
     /* 26820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_b),
     /* 26828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 26831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26849 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8002:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MAX_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_B),
     /* 26852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26854 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26856 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26858 */     GIR_RootConstrainSelectedInstOperands,
     /* 26859 */     // GIR_Coverage, 844,
     /* 26859 */     GIR_EraseRootFromParent_Done,
     /* 26860 */   // Label 795: @26860
     /* 26860 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(26905), // Rule ID 845 //
     /* 26865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_h),
     /* 26873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26894 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8004:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MAX_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_H),
     /* 26897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26899 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26901 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26903 */     GIR_RootConstrainSelectedInstOperands,
     /* 26904 */     // GIR_Coverage, 845,
     /* 26904 */     GIR_EraseRootFromParent_Done,
     /* 26905 */   // Label 796: @26905
     /* 26905 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(26950), // Rule ID 846 //
     /* 26910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_w),
     /* 26918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26939 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8005:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MAX_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_W),
     /* 26942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26944 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26946 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26948 */     GIR_RootConstrainSelectedInstOperands,
     /* 26949 */     // GIR_Coverage, 846,
     /* 26949 */     GIR_EraseRootFromParent_Done,
     /* 26950 */   // Label 797: @26950
     /* 26950 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(26995), // Rule ID 847 //
     /* 26955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_d),
     /* 26963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26984 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8003:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MAX_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 26984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_D),
     /* 26987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26989 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26991 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26993 */     GIR_RootConstrainSelectedInstOperands,
     /* 26994 */     // GIR_Coverage, 847,
     /* 26994 */     GIR_EraseRootFromParent_Done,
     /* 26995 */   // Label 798: @26995
     /* 26995 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(27040), // Rule ID 864 //
     /* 27000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_b),
     /* 27008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27029 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8022:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MIN_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_B),
     /* 27032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27034 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27036 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27038 */     GIR_RootConstrainSelectedInstOperands,
     /* 27039 */     // GIR_Coverage, 864,
     /* 27039 */     GIR_EraseRootFromParent_Done,
     /* 27040 */   // Label 799: @27040
     /* 27040 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(27085), // Rule ID 865 //
     /* 27045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_h),
     /* 27053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27074 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8024:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MIN_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_H),
     /* 27077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27079 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27081 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27083 */     GIR_RootConstrainSelectedInstOperands,
     /* 27084 */     // GIR_Coverage, 865,
     /* 27084 */     GIR_EraseRootFromParent_Done,
     /* 27085 */   // Label 800: @27085
     /* 27085 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(27130), // Rule ID 866 //
     /* 27090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_w),
     /* 27098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27119 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8025:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MIN_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_W),
     /* 27122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27124 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27126 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27128 */     GIR_RootConstrainSelectedInstOperands,
     /* 27129 */     // GIR_Coverage, 866,
     /* 27129 */     GIR_EraseRootFromParent_Done,
     /* 27130 */   // Label 801: @27130
     /* 27130 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(27175), // Rule ID 867 //
     /* 27135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_d),
     /* 27143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27164 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8023:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MIN_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_D),
     /* 27167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27169 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27171 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27173 */     GIR_RootConstrainSelectedInstOperands,
     /* 27174 */     // GIR_Coverage, 867,
     /* 27174 */     GIR_EraseRootFromParent_Done,
     /* 27175 */   // Label 802: @27175
     /* 27175 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(27220), // Rule ID 900 //
     /* 27180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_q_h),
     /* 27188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27209 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8064:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MUL_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_Q_H),
     /* 27212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27214 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27216 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27218 */     GIR_RootConstrainSelectedInstOperands,
     /* 27219 */     // GIR_Coverage, 900,
     /* 27219 */     GIR_EraseRootFromParent_Done,
     /* 27220 */   // Label 803: @27220
     /* 27220 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(27265), // Rule ID 901 //
     /* 27225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_q_w),
     /* 27233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27254 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8065:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MUL_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_Q_W),
     /* 27257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27259 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27261 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27263 */     GIR_RootConstrainSelectedInstOperands,
     /* 27264 */     // GIR_Coverage, 901,
     /* 27264 */     GIR_EraseRootFromParent_Done,
     /* 27265 */   // Label 804: @27265
     /* 27265 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(27310), // Rule ID 902 //
     /* 27270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulr_q_h),
     /* 27278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27299 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8075:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MULR_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULR_Q_H),
     /* 27302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27304 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27306 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27308 */     GIR_RootConstrainSelectedInstOperands,
     /* 27309 */     // GIR_Coverage, 902,
     /* 27309 */     GIR_EraseRootFromParent_Done,
     /* 27310 */   // Label 805: @27310
     /* 27310 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(27355), // Rule ID 903 //
     /* 27315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulr_q_w),
     /* 27323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27344 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8076:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MULR_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULR_Q_W),
     /* 27347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27349 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27351 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27353 */     GIR_RootConstrainSelectedInstOperands,
     /* 27354 */     // GIR_Coverage, 903,
     /* 27354 */     GIR_EraseRootFromParent_Done,
     /* 27355 */   // Label 806: @27355
     /* 27355 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(27400), // Rule ID 981 //
     /* 27360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_b),
     /* 27368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27389 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8189:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRAR_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_B),
     /* 27392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27394 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27396 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27398 */     GIR_RootConstrainSelectedInstOperands,
     /* 27399 */     // GIR_Coverage, 981,
     /* 27399 */     GIR_EraseRootFromParent_Done,
     /* 27400 */   // Label 807: @27400
     /* 27400 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(27445), // Rule ID 982 //
     /* 27405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_h),
     /* 27413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27434 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8191:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRAR_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_H),
     /* 27437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27439 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27441 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27443 */     GIR_RootConstrainSelectedInstOperands,
     /* 27444 */     // GIR_Coverage, 982,
     /* 27444 */     GIR_EraseRootFromParent_Done,
     /* 27445 */   // Label 808: @27445
     /* 27445 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(27490), // Rule ID 983 //
     /* 27450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_w),
     /* 27458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27479 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8192:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRAR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_W),
     /* 27482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27484 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27486 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27488 */     GIR_RootConstrainSelectedInstOperands,
     /* 27489 */     // GIR_Coverage, 983,
     /* 27489 */     GIR_EraseRootFromParent_Done,
     /* 27490 */   // Label 809: @27490
     /* 27490 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(27535), // Rule ID 984 //
     /* 27495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_d),
     /* 27503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27524 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8190:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRAR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_D),
     /* 27527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27529 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27531 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27533 */     GIR_RootConstrainSelectedInstOperands,
     /* 27534 */     // GIR_Coverage, 984,
     /* 27534 */     GIR_EraseRootFromParent_Done,
     /* 27535 */   // Label 810: @27535
     /* 27535 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(27580), // Rule ID 997 //
     /* 27540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_b),
     /* 27548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27569 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8205:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRLR_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_B),
     /* 27572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27574 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27576 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27578 */     GIR_RootConstrainSelectedInstOperands,
     /* 27579 */     // GIR_Coverage, 997,
     /* 27579 */     GIR_EraseRootFromParent_Done,
     /* 27580 */   // Label 811: @27580
     /* 27580 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(27625), // Rule ID 998 //
     /* 27585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_h),
     /* 27593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27614 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8207:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRLR_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_H),
     /* 27617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27619 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27621 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27623 */     GIR_RootConstrainSelectedInstOperands,
     /* 27624 */     // GIR_Coverage, 998,
     /* 27624 */     GIR_EraseRootFromParent_Done,
     /* 27625 */   // Label 812: @27625
     /* 27625 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(27670), // Rule ID 999 //
     /* 27630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_w),
     /* 27638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27659 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8208:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRLR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_W),
     /* 27662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27664 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27666 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27668 */     GIR_RootConstrainSelectedInstOperands,
     /* 27669 */     // GIR_Coverage, 999,
     /* 27669 */     GIR_EraseRootFromParent_Done,
     /* 27670 */   // Label 813: @27670
     /* 27670 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(27715), // Rule ID 1000 //
     /* 27675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_d),
     /* 27683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27704 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8206:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRLR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_D),
     /* 27707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27709 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27711 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27713 */     GIR_RootConstrainSelectedInstOperands,
     /* 27714 */     // GIR_Coverage, 1000,
     /* 27714 */     GIR_EraseRootFromParent_Done,
     /* 27715 */   // Label 814: @27715
     /* 27715 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(27760), // Rule ID 1009 //
     /* 27720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_b),
     /* 27728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27749 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8226:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBS_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_B),
     /* 27752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27754 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27756 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27758 */     GIR_RootConstrainSelectedInstOperands,
     /* 27759 */     // GIR_Coverage, 1009,
     /* 27759 */     GIR_EraseRootFromParent_Done,
     /* 27760 */   // Label 815: @27760
     /* 27760 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(27805), // Rule ID 1010 //
     /* 27765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_h),
     /* 27773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27794 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8228:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBS_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_H),
     /* 27797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27799 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27801 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27803 */     GIR_RootConstrainSelectedInstOperands,
     /* 27804 */     // GIR_Coverage, 1010,
     /* 27804 */     GIR_EraseRootFromParent_Done,
     /* 27805 */   // Label 816: @27805
     /* 27805 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(27850), // Rule ID 1011 //
     /* 27810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_w),
     /* 27818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27839 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8229:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBS_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_W),
     /* 27842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27844 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27846 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27848 */     GIR_RootConstrainSelectedInstOperands,
     /* 27849 */     // GIR_Coverage, 1011,
     /* 27849 */     GIR_EraseRootFromParent_Done,
     /* 27850 */   // Label 817: @27850
     /* 27850 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(27895), // Rule ID 1012 //
     /* 27855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_d),
     /* 27863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27884 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8227:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBS_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_D),
     /* 27887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27889 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27891 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27893 */     GIR_RootConstrainSelectedInstOperands,
     /* 27894 */     // GIR_Coverage, 1012,
     /* 27894 */     GIR_EraseRootFromParent_Done,
     /* 27895 */   // Label 818: @27895
     /* 27895 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(27940), // Rule ID 1013 //
     /* 27900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_b),
     /* 27908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27929 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8230:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBS_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_B),
     /* 27932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27934 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27936 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27938 */     GIR_RootConstrainSelectedInstOperands,
     /* 27939 */     // GIR_Coverage, 1013,
     /* 27939 */     GIR_EraseRootFromParent_Done,
     /* 27940 */   // Label 819: @27940
     /* 27940 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(27985), // Rule ID 1014 //
     /* 27945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_h),
     /* 27953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27974 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8232:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBS_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_H),
     /* 27977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27979 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27981 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27983 */     GIR_RootConstrainSelectedInstOperands,
     /* 27984 */     // GIR_Coverage, 1014,
     /* 27984 */     GIR_EraseRootFromParent_Done,
     /* 27985 */   // Label 820: @27985
     /* 27985 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(28030), // Rule ID 1015 //
     /* 27990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_w),
     /* 27998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 28007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28019 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8233:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBS_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 28019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_W),
     /* 28022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28024 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28026 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28028 */     GIR_RootConstrainSelectedInstOperands,
     /* 28029 */     // GIR_Coverage, 1015,
     /* 28029 */     GIR_EraseRootFromParent_Done,
     /* 28030 */   // Label 821: @28030
     /* 28030 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(28075), // Rule ID 1016 //
     /* 28035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_d),
     /* 28043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 28052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28064 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8231:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBS_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 28064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_D),
     /* 28067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28069 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28071 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28073 */     GIR_RootConstrainSelectedInstOperands,
     /* 28074 */     // GIR_Coverage, 1016,
     /* 28074 */     GIR_EraseRootFromParent_Done,
     /* 28075 */   // Label 822: @28075
     /* 28075 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(28120), // Rule ID 1017 //
     /* 28080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_b),
     /* 28088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 28091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 28097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28109 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8234:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBSUS_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 28109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_B),
     /* 28112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28114 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28116 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28118 */     GIR_RootConstrainSelectedInstOperands,
     /* 28119 */     // GIR_Coverage, 1017,
     /* 28119 */     GIR_EraseRootFromParent_Done,
     /* 28120 */   // Label 823: @28120
     /* 28120 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(28165), // Rule ID 1018 //
     /* 28125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_h),
     /* 28133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 28136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 28142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28154 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8236:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBSUS_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 28154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_H),
     /* 28157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28159 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28161 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28163 */     GIR_RootConstrainSelectedInstOperands,
     /* 28164 */     // GIR_Coverage, 1018,
     /* 28164 */     GIR_EraseRootFromParent_Done,
     /* 28165 */   // Label 824: @28165
     /* 28165 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(28210), // Rule ID 1019 //
     /* 28170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_w),
     /* 28178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 28187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28199 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8237:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBSUS_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 28199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_W),
     /* 28202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28204 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28206 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28208 */     GIR_RootConstrainSelectedInstOperands,
     /* 28209 */     // GIR_Coverage, 1019,
     /* 28209 */     GIR_EraseRootFromParent_Done,
     /* 28210 */   // Label 825: @28210
     /* 28210 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(28255), // Rule ID 1020 //
     /* 28215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_d),
     /* 28223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 28232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28244 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8235:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBSUS_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 28244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_D),
     /* 28247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28249 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28251 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28253 */     GIR_RootConstrainSelectedInstOperands,
     /* 28254 */     // GIR_Coverage, 1020,
     /* 28254 */     GIR_EraseRootFromParent_Done,
     /* 28255 */   // Label 826: @28255
     /* 28255 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(28300), // Rule ID 1021 //
     /* 28260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_b),
     /* 28268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 28271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 28277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28289 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8238:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBSUU_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 28289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_B),
     /* 28292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28294 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28296 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28298 */     GIR_RootConstrainSelectedInstOperands,
     /* 28299 */     // GIR_Coverage, 1021,
     /* 28299 */     GIR_EraseRootFromParent_Done,
     /* 28300 */   // Label 827: @28300
     /* 28300 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(28345), // Rule ID 1022 //
     /* 28305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_h),
     /* 28313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 28316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 28322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28334 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8240:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBSUU_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 28334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_H),
     /* 28337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28339 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28341 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28343 */     GIR_RootConstrainSelectedInstOperands,
     /* 28344 */     // GIR_Coverage, 1022,
     /* 28344 */     GIR_EraseRootFromParent_Done,
     /* 28345 */   // Label 828: @28345
     /* 28345 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(28390), // Rule ID 1023 //
     /* 28350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_w),
     /* 28358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 28367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28379 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8241:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBSUU_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 28379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_W),
     /* 28382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28384 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28386 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28388 */     GIR_RootConstrainSelectedInstOperands,
     /* 28389 */     // GIR_Coverage, 1023,
     /* 28389 */     GIR_EraseRootFromParent_Done,
     /* 28390 */   // Label 829: @28390
     /* 28390 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(28435), // Rule ID 1024 //
     /* 28395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_d),
     /* 28403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 28412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28424 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8239:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBSUU_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 28424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_D),
     /* 28427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28429 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28431 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28433 */     GIR_RootConstrainSelectedInstOperands,
     /* 28434 */     // GIR_Coverage, 1024,
     /* 28434 */     GIR_EraseRootFromParent_Done,
     /* 28435 */   // Label 830: @28435
     /* 28435 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(28483), // Rule ID 1223 //
     /* 28440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_ph),
     /* 28448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28469 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7600:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQ_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_PH_MM),
     /* 28472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28481 */     GIR_RootConstrainSelectedInstOperands,
     /* 28482 */     // GIR_Coverage, 1223,
     /* 28482 */     GIR_EraseRootFromParent_Done,
     /* 28483 */   // Label 831: @28483
     /* 28483 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(28531), // Rule ID 1225 //
     /* 28488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_qb),
     /* 28496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 28502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 28505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28517 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7622:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDU_S_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 28517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_QB_MM),
     /* 28520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28529 */     GIR_RootConstrainSelectedInstOperands,
     /* 28530 */     // GIR_Coverage, 1225,
     /* 28530 */     GIR_EraseRootFromParent_Done,
     /* 28531 */   // Label 832: @28531
     /* 28531 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(28576), // Rule ID 1246 //
     /* 28536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_ph),
     /* 28544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28565 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8150:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_PH_MM),
     /* 28568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28574 */     GIR_RootConstrainSelectedInstOperands,
     /* 28575 */     // GIR_Coverage, 1246,
     /* 28575 */     GIR_EraseRootFromParent_Done,
     /* 28576 */   // Label 833: @28576
     /* 28576 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(28621), // Rule ID 1247 //
     /* 28581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 28589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28610 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8152:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_R_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_PH_MM),
     /* 28613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28619 */     GIR_RootConstrainSelectedInstOperands,
     /* 28620 */     // GIR_Coverage, 1247,
     /* 28620 */     GIR_EraseRootFromParent_Done,
     /* 28621 */   // Label 834: @28621
     /* 28621 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(28666), // Rule ID 1248 //
     /* 28626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 28634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 28637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 28640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28655 */     // (intrinsic_wo_chain:{ *:[i32] } 8154:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_R_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_W_MM),
     /* 28658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28664 */     GIR_RootConstrainSelectedInstOperands,
     /* 28665 */     // GIR_Coverage, 1248,
     /* 28665 */     GIR_EraseRootFromParent_Done,
     /* 28666 */   // Label 835: @28666
     /* 28666 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(28711), // Rule ID 1250 //
     /* 28671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_qb),
     /* 28679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 28685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28700 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8156:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRLV_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_QB_MM),
     /* 28703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28709 */     GIR_RootConstrainSelectedInstOperands,
     /* 28710 */     // GIR_Coverage, 1250,
     /* 28710 */     GIR_EraseRootFromParent_Done,
     /* 28711 */   // Label 836: @28711
     /* 28711 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(28759), // Rule ID 1261 //
     /* 28716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_ph),
     /* 28724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28745 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8220:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQ_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_PH_MM),
     /* 28748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28757 */     GIR_RootConstrainSelectedInstOperands,
     /* 28758 */     // GIR_Coverage, 1261,
     /* 28758 */     GIR_EraseRootFromParent_Done,
     /* 28759 */   // Label 837: @28759
     /* 28759 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(28807), // Rule ID 1263 //
     /* 28764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_qb),
     /* 28772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 28778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 28781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28793 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8245:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBU_S_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 28793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_QB_MM),
     /* 28796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28805 */     GIR_RootConstrainSelectedInstOperands,
     /* 28806 */     // GIR_Coverage, 1263,
     /* 28806 */     GIR_EraseRootFromParent_Done,
     /* 28807 */   // Label 838: @28807
     /* 28807 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(28852), // Rule ID 1273 //
     /* 28812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_ph_w),
     /* 28820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 28826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28841 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8125:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_PH_W_MM:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 28841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_PH_W_MM),
     /* 28844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28850 */     GIR_RootConstrainSelectedInstOperands,
     /* 28851 */     // GIR_Coverage, 1273,
     /* 28851 */     GIR_EraseRootFromParent_Done,
     /* 28852 */   // Label 839: @28852
     /* 28852 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(28897), // Rule ID 1274 //
     /* 28857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_qb_ph),
     /* 28865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28886 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8126:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQ_QB_PH_MM:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_QB_PH_MM),
     /* 28889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28895 */     GIR_RootConstrainSelectedInstOperands,
     /* 28896 */     // GIR_Coverage, 1274,
     /* 28896 */     GIR_EraseRootFromParent_Done,
     /* 28897 */   // Label 840: @28897
     /* 28897 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(28942), // Rule ID 1293 //
     /* 28902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_packrl_ph),
     /* 28910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28931 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8097:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PACKRL_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PACKRL_PH_MM),
     /* 28934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28940 */     GIR_RootConstrainSelectedInstOperands,
     /* 28941 */     // GIR_Coverage, 1293,
     /* 28941 */     GIR_EraseRootFromParent_Done,
     /* 28942 */   // Label 841: @28942
     /* 28942 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(28987), // Rule ID 1299 //
     /* 28947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_modsub),
     /* 28955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 28958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 28961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28976 */     // (intrinsic_wo_chain:{ *:[i32] } 8050:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODSUB_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 28976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MODSUB_MM),
     /* 28979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28985 */     GIR_RootConstrainSelectedInstOperands,
     /* 28986 */     // GIR_Coverage, 1299,
     /* 28986 */     GIR_EraseRootFromParent_Done,
     /* 28987 */   // Label 842: @28987
     /* 28987 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(29032), // Rule ID 1312 //
     /* 28992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 28995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_ph),
     /* 29000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29021 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7602:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_PH_MMR2),
     /* 29024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29030 */     GIR_RootConstrainSelectedInstOperands,
     /* 29031 */     // GIR_Coverage, 1312,
     /* 29031 */     GIR_EraseRootFromParent_Done,
     /* 29032 */   // Label 843: @29032
     /* 29032 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(29077), // Rule ID 1313 //
     /* 29037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_ph),
     /* 29045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29066 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7603:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_R_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_PH_MMR2),
     /* 29069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29075 */     GIR_RootConstrainSelectedInstOperands,
     /* 29076 */     // GIR_Coverage, 1313,
     /* 29076 */     GIR_EraseRootFromParent_Done,
     /* 29077 */   // Label 844: @29077
     /* 29077 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(29122), // Rule ID 1314 //
     /* 29082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_w),
     /* 29090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29111 */     // (intrinsic_wo_chain:{ *:[i32] } 7605:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_W_MMR2),
     /* 29114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29120 */     GIR_RootConstrainSelectedInstOperands,
     /* 29121 */     // GIR_Coverage, 1314,
     /* 29121 */     GIR_EraseRootFromParent_Done,
     /* 29122 */   // Label 845: @29122
     /* 29122 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(29167), // Rule ID 1315 //
     /* 29127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_w),
     /* 29135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29156 */     // (intrinsic_wo_chain:{ *:[i32] } 7604:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_R_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_W_MMR2),
     /* 29159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29165 */     GIR_RootConstrainSelectedInstOperands,
     /* 29166 */     // GIR_Coverage, 1315,
     /* 29166 */     GIR_EraseRootFromParent_Done,
     /* 29167 */   // Label 846: @29167
     /* 29167 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(29212), // Rule ID 1318 //
     /* 29172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_qb),
     /* 29180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29201 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7623:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_QB_MMR2),
     /* 29204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29210 */     GIR_RootConstrainSelectedInstOperands,
     /* 29211 */     // GIR_Coverage, 1318,
     /* 29211 */     GIR_EraseRootFromParent_Done,
     /* 29212 */   // Label 847: @29212
     /* 29212 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(29257), // Rule ID 1319 //
     /* 29217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_r_qb),
     /* 29225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29246 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7624:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_R_QB_MMR2),
     /* 29249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29255 */     GIR_RootConstrainSelectedInstOperands,
     /* 29256 */     // GIR_Coverage, 1319,
     /* 29256 */     GIR_EraseRootFromParent_Done,
     /* 29257 */   // Label 848: @29257
     /* 29257 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(29302), // Rule ID 1325 //
     /* 29262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_qb),
     /* 29270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29291 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8151:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 29291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_QB_MMR2),
     /* 29294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 29298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29300 */     GIR_RootConstrainSelectedInstOperands,
     /* 29301 */     // GIR_Coverage, 1325,
     /* 29301 */     GIR_EraseRootFromParent_Done,
     /* 29302 */   // Label 849: @29302
     /* 29302 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(29347), // Rule ID 1326 //
     /* 29307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 29315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29336 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8153:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 29336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_QB_MMR2),
     /* 29339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 29343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29345 */     GIR_RootConstrainSelectedInstOperands,
     /* 29346 */     // GIR_Coverage, 1326,
     /* 29346 */     GIR_EraseRootFromParent_Done,
     /* 29347 */   // Label 850: @29347
     /* 29347 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(29392), // Rule ID 1331 //
     /* 29352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_ph),
     /* 29360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29381 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8155:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRLV_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 29381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_PH_MMR2),
     /* 29384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 29388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29390 */     GIR_RootConstrainSelectedInstOperands,
     /* 29391 */     // GIR_Coverage, 1331,
     /* 29391 */     GIR_EraseRootFromParent_Done,
     /* 29392 */   // Label 851: @29392
     /* 29392 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(29437), // Rule ID 1332 //
     /* 29397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_ph),
     /* 29405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29426 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8222:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_PH_MMR2),
     /* 29429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29435 */     GIR_RootConstrainSelectedInstOperands,
     /* 29436 */     // GIR_Coverage, 1332,
     /* 29436 */     GIR_EraseRootFromParent_Done,
     /* 29437 */   // Label 852: @29437
     /* 29437 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(29482), // Rule ID 1333 //
     /* 29442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_ph),
     /* 29450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29471 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8223:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_R_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_PH_MMR2),
     /* 29474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29480 */     GIR_RootConstrainSelectedInstOperands,
     /* 29481 */     // GIR_Coverage, 1333,
     /* 29481 */     GIR_EraseRootFromParent_Done,
     /* 29482 */   // Label 853: @29482
     /* 29482 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(29527), // Rule ID 1334 //
     /* 29487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_w),
     /* 29495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29516 */     // (intrinsic_wo_chain:{ *:[i32] } 8225:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_W_MMR2),
     /* 29519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29525 */     GIR_RootConstrainSelectedInstOperands,
     /* 29526 */     // GIR_Coverage, 1334,
     /* 29526 */     GIR_EraseRootFromParent_Done,
     /* 29527 */   // Label 854: @29527
     /* 29527 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(29572), // Rule ID 1335 //
     /* 29532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_w),
     /* 29540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29561 */     // (intrinsic_wo_chain:{ *:[i32] } 8224:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_R_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_W_MMR2),
     /* 29564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29570 */     GIR_RootConstrainSelectedInstOperands,
     /* 29571 */     // GIR_Coverage, 1335,
     /* 29571 */     GIR_EraseRootFromParent_Done,
     /* 29572 */   // Label 855: @29572
     /* 29572 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(29617), // Rule ID 1338 //
     /* 29577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_qb),
     /* 29585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29606 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8246:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_QB_MMR2),
     /* 29609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29615 */     GIR_RootConstrainSelectedInstOperands,
     /* 29616 */     // GIR_Coverage, 1338,
     /* 29616 */     GIR_EraseRootFromParent_Done,
     /* 29617 */   // Label 856: @29617
     /* 29617 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(29662), // Rule ID 1339 //
     /* 29622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_r_qb),
     /* 29630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29651 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8247:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_R_QB_MMR2),
     /* 29654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29660 */     GIR_RootConstrainSelectedInstOperands,
     /* 29661 */     // GIR_Coverage, 1339,
     /* 29661 */     GIR_EraseRootFromParent_Done,
     /* 29662 */   // Label 857: @29662
     /* 29662 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(29702), // Rule ID 1925 //
     /* 29667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_ph),
     /* 29675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29688 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7599:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (ADDQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /* 29688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_PH),
     /* 29691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29693 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29695 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29700 */     GIR_RootConstrainSelectedInstOperands,
     /* 29701 */     // GIR_Coverage, 1925,
     /* 29701 */     GIR_EraseRootFromParent_Done,
     /* 29702 */   // Label 858: @29702
     /* 29702 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(29742), // Rule ID 1927 //
     /* 29707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_ph),
     /* 29715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29728 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8219:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (SUBQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /* 29728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_PH),
     /* 29731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29733 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29735 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29740 */     GIR_RootConstrainSelectedInstOperands,
     /* 29741 */     // GIR_Coverage, 1927,
     /* 29741 */     GIR_EraseRootFromParent_Done,
     /* 29742 */   // Label 859: @29742
     /* 29742 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(29782), // Rule ID 1931 //
     /* 29747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_qb),
     /* 29755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29768 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7620:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (ADDU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /* 29768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_QB),
     /* 29771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29773 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29775 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29780 */     GIR_RootConstrainSelectedInstOperands,
     /* 29781 */     // GIR_Coverage, 1931,
     /* 29781 */     GIR_EraseRootFromParent_Done,
     /* 29782 */   // Label 860: @29782
     /* 29782 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(29822), // Rule ID 1933 //
     /* 29787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_qb),
     /* 29795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29808 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8243:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (SUBU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /* 29808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_QB),
     /* 29811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29813 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29815 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29820 */     GIR_RootConstrainSelectedInstOperands,
     /* 29821 */     // GIR_Coverage, 1933,
     /* 29821 */     GIR_EraseRootFromParent_Done,
     /* 29822 */   // Label 861: @29822
     /* 29822 */   GIM_Reject,
     /* 29823 */ // Label 647: @29823
     /* 29823 */ GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(32337),
     /* 29828 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 29831 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(29886), // Rule ID 477 //
     /* 29836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_ph_w),
     /* 29844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29865 */     // MIs[0] sa
     /* 29865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 29868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 29873 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8123:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 29873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_PH_W),
     /* 29876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 29878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29880 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 29882 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29884 */     GIR_RootConstrainSelectedInstOperands,
     /* 29885 */     // GIR_Coverage, 477,
     /* 29885 */     GIR_EraseRootFromParent_Done,
     /* 29886 */   // Label 863: @29886
     /* 29886 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(29941), // Rule ID 478 //
     /* 29891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_r_ph_w),
     /* 29899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29920 */     // MIs[0] sa
     /* 29920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 29923 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 29928 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8124:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_R_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 29928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_R_PH_W),
     /* 29931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 29933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29935 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 29937 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29939 */     GIR_RootConstrainSelectedInstOperands,
     /* 29940 */     // GIR_Coverage, 478,
     /* 29940 */     GIR_EraseRootFromParent_Done,
     /* 29941 */   // Label 864: @29941
     /* 29941 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(29996), // Rule ID 483 //
     /* 29946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_append),
     /* 29954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29975 */     // MIs[0] sa
     /* 29975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 29978 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 29983 */     // (intrinsic_wo_chain:{ *:[i32] } 7636:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (APPEND:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 29983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::APPEND),
     /* 29986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 29988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29990 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 29992 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29994 */     GIR_RootConstrainSelectedInstOperands,
     /* 29995 */     // GIR_Coverage, 483,
     /* 29995 */     GIR_EraseRootFromParent_Done,
     /* 29996 */   // Label 865: @29996
     /* 29996 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(30051), // Rule ID 484 //
     /* 30001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 30004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_balign),
     /* 30009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30030 */     // MIs[0] sa
     /* 30030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30033 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt2),
     /* 30038 */     // (intrinsic_wo_chain:{ *:[i32] } 7661:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt2>>:$sa)  =>  (BALIGN:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BALIGN),
     /* 30041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30045 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30047 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30049 */     GIR_RootConstrainSelectedInstOperands,
     /* 30050 */     // GIR_Coverage, 484,
     /* 30050 */     GIR_EraseRootFromParent_Done,
     /* 30051 */   // Label 866: @30051
     /* 30051 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(30106), // Rule ID 485 //
     /* 30056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 30059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_prepend),
     /* 30064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30085 */     // MIs[0] sa
     /* 30085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30088 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30093 */     // (intrinsic_wo_chain:{ *:[i32] } 8129:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PREPEND:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PREPEND),
     /* 30096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30100 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30102 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30104 */     GIR_RootConstrainSelectedInstOperands,
     /* 30105 */     // GIR_Coverage, 485,
     /* 30105 */     GIR_EraseRootFromParent_Done,
     /* 30106 */   // Label 867: @30106
     /* 30106 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(30161), // Rule ID 953 //
     /* 30111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_b),
     /* 30119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 30122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 30125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 30128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30140 */     // MIs[0] n
     /* 30140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 30148 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8161:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$n)  =>  (SLDI_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_B),
     /* 30151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30153 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30155 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30157 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30159 */     GIR_RootConstrainSelectedInstOperands,
     /* 30160 */     // GIR_Coverage, 953,
     /* 30160 */     GIR_EraseRootFromParent_Done,
     /* 30161 */   // Label 868: @30161
     /* 30161 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(30216), // Rule ID 954 //
     /* 30166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_h),
     /* 30174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30195 */     // MIs[0] n
     /* 30195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 30203 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8163:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$n)  =>  (SLDI_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_H),
     /* 30206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30208 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30210 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30212 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30214 */     GIR_RootConstrainSelectedInstOperands,
     /* 30215 */     // GIR_Coverage, 954,
     /* 30215 */     GIR_EraseRootFromParent_Done,
     /* 30216 */   // Label 869: @30216
     /* 30216 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(30271), // Rule ID 955 //
     /* 30221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_w),
     /* 30229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30250 */     // MIs[0] n
     /* 30250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt2),
     /* 30258 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8164:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt2>>:$n)  =>  (SLDI_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_W),
     /* 30261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30263 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30265 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30267 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30269 */     GIR_RootConstrainSelectedInstOperands,
     /* 30270 */     // GIR_Coverage, 955,
     /* 30270 */     GIR_EraseRootFromParent_Done,
     /* 30271 */   // Label 870: @30271
     /* 30271 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(30326), // Rule ID 956 //
     /* 30276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_d),
     /* 30284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30305 */     // MIs[0] n
     /* 30305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30308 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt1),
     /* 30313 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8162:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt1>>:$n)  =>  (SLDI_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_D),
     /* 30316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30318 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30320 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30322 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30324 */     GIR_RootConstrainSelectedInstOperands,
     /* 30325 */     // GIR_Coverage, 956,
     /* 30325 */     GIR_EraseRootFromParent_Done,
     /* 30326 */   // Label 871: @30326
     /* 30326 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(30381), // Rule ID 1349 //
     /* 30331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_ph_w),
     /* 30339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 30342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 30352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30360 */     // MIs[0] sa
     /* 30360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30363 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30368 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8123:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_PH_W_MMR2:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_PH_W_MMR2),
     /* 30371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30375 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30377 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30379 */     GIR_RootConstrainSelectedInstOperands,
     /* 30380 */     // GIR_Coverage, 1349,
     /* 30380 */     GIR_EraseRootFromParent_Done,
     /* 30381 */   // Label 872: @30381
     /* 30381 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(30436), // Rule ID 1350 //
     /* 30386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_r_ph_w),
     /* 30394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 30397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 30407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30415 */     // MIs[0] sa
     /* 30415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30423 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8124:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_R_PH_W_MMR2:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_R_PH_W_MMR2),
     /* 30426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30430 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30432 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30434 */     GIR_RootConstrainSelectedInstOperands,
     /* 30435 */     // GIR_Coverage, 1350,
     /* 30435 */     GIR_EraseRootFromParent_Done,
     /* 30436 */   // Label 873: @30436
     /* 30436 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(30491), // Rule ID 1351 //
     /* 30441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_prepend),
     /* 30449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30470 */     // MIs[0] sa
     /* 30470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30478 */     // (intrinsic_wo_chain:{ *:[i32] } 8129:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PREPEND_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PREPEND_MMR2),
     /* 30481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30485 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30487 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30489 */     GIR_RootConstrainSelectedInstOperands,
     /* 30490 */     // GIR_Coverage, 1351,
     /* 30490 */     GIR_EraseRootFromParent_Done,
     /* 30491 */   // Label 874: @30491
     /* 30491 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(30546), // Rule ID 1352 //
     /* 30496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_append),
     /* 30504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30525 */     // MIs[0] sa
     /* 30525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30533 */     // (intrinsic_wo_chain:{ *:[i32] } 7636:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (APPEND_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::APPEND_MMR2),
     /* 30536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30540 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30542 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30544 */     GIR_RootConstrainSelectedInstOperands,
     /* 30545 */     // GIR_Coverage, 1352,
     /* 30545 */     GIR_EraseRootFromParent_Done,
     /* 30546 */   // Label 875: @30546
     /* 30546 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(30608), // Rule ID 1327 //
     /* 30551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_balign),
     /* 30559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30580 */     // MIs[0] bp
     /* 30580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 30584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 30588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2),
     /* 30592 */     // MIs[1] Operand 1
     /* 30592 */     // No operand predicates
     /* 30592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 30594 */     // (intrinsic_wo_chain:{ *:[i32] } 7661:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2>>:$bp)  =>  (BALIGN_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$bp, GPR32Opnd:{ *:[i32] }:$src)
     /* 30594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BALIGN_MMR2),
     /* 30597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // bp
     /* 30604 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30606 */     GIR_RootConstrainSelectedInstOperands,
     /* 30607 */     // GIR_Coverage, 1327,
     /* 30607 */     GIR_EraseRootFromParent_Done,
     /* 30608 */   // Label 876: @30608
     /* 30608 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(30662), // Rule ID 552 //
     /* 30613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_b),
     /* 30621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 30624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 30627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 30630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 30633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30649 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7670:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (BINSL_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 30649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_B),
     /* 30652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30654 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30656 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30658 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30660 */     GIR_RootConstrainSelectedInstOperands,
     /* 30661 */     // GIR_Coverage, 552,
     /* 30661 */     GIR_EraseRootFromParent_Done,
     /* 30662 */   // Label 877: @30662
     /* 30662 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(30716), // Rule ID 553 //
     /* 30667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_h),
     /* 30675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 30687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30703 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7672:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (BINSL_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 30703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_H),
     /* 30706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30708 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30710 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30712 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30714 */     GIR_RootConstrainSelectedInstOperands,
     /* 30715 */     // GIR_Coverage, 553,
     /* 30715 */     GIR_EraseRootFromParent_Done,
     /* 30716 */   // Label 878: @30716
     /* 30716 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(30770), // Rule ID 554 //
     /* 30721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_w),
     /* 30729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 30741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30757 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7673:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (BINSL_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 30757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_W),
     /* 30760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30762 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30764 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30766 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30768 */     GIR_RootConstrainSelectedInstOperands,
     /* 30769 */     // GIR_Coverage, 554,
     /* 30769 */     GIR_EraseRootFromParent_Done,
     /* 30770 */   // Label 879: @30770
     /* 30770 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(30824), // Rule ID 555 //
     /* 30775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_d),
     /* 30783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 30795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30811 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7671:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (BINSL_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 30811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_D),
     /* 30814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30816 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30818 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30820 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30822 */     GIR_RootConstrainSelectedInstOperands,
     /* 30823 */     // GIR_Coverage, 555,
     /* 30823 */     GIR_EraseRootFromParent_Done,
     /* 30824 */   // Label 880: @30824
     /* 30824 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(30878), // Rule ID 560 //
     /* 30829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_b),
     /* 30837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 30840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 30843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 30846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 30849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30865 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7678:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (BINSR_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 30865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_B),
     /* 30868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30870 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30872 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30874 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30876 */     GIR_RootConstrainSelectedInstOperands,
     /* 30877 */     // GIR_Coverage, 560,
     /* 30877 */     GIR_EraseRootFromParent_Done,
     /* 30878 */   // Label 881: @30878
     /* 30878 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(30932), // Rule ID 561 //
     /* 30883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_h),
     /* 30891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 30903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30919 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7680:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (BINSR_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 30919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_H),
     /* 30922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30924 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30926 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30928 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30930 */     GIR_RootConstrainSelectedInstOperands,
     /* 30931 */     // GIR_Coverage, 561,
     /* 30931 */     GIR_EraseRootFromParent_Done,
     /* 30932 */   // Label 882: @30932
     /* 30932 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(30986), // Rule ID 562 //
     /* 30937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_w),
     /* 30945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 30957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30973 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7681:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (BINSR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 30973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_W),
     /* 30976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30978 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30980 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30982 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30984 */     GIR_RootConstrainSelectedInstOperands,
     /* 30985 */     // GIR_Coverage, 562,
     /* 30985 */     GIR_EraseRootFromParent_Done,
     /* 30986 */   // Label 883: @30986
     /* 30986 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(31040), // Rule ID 563 //
     /* 30991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_d),
     /* 30999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 31008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 31011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31027 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7679:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (BINSR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 31027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_D),
     /* 31030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31032 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31034 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31036 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31038 */     GIR_RootConstrainSelectedInstOperands,
     /* 31039 */     // GIR_Coverage, 563,
     /* 31039 */     GIR_EraseRootFromParent_Done,
     /* 31040 */   // Label 884: @31040
     /* 31040 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(31094), // Rule ID 658 //
     /* 31045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_s_h),
     /* 31053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31081 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7799:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPADD_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_S_H),
     /* 31084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31086 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31088 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31090 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31092 */     GIR_RootConstrainSelectedInstOperands,
     /* 31093 */     // GIR_Coverage, 658,
     /* 31093 */     GIR_EraseRootFromParent_Done,
     /* 31094 */   // Label 885: @31094
     /* 31094 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(31148), // Rule ID 659 //
     /* 31099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_s_w),
     /* 31107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31135 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7800:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPADD_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_S_W),
     /* 31138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31140 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31142 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31144 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31146 */     GIR_RootConstrainSelectedInstOperands,
     /* 31147 */     // GIR_Coverage, 659,
     /* 31147 */     GIR_EraseRootFromParent_Done,
     /* 31148 */   // Label 886: @31148
     /* 31148 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(31202), // Rule ID 660 //
     /* 31153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_s_d),
     /* 31161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31189 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7798:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPADD_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_S_D),
     /* 31192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31194 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31196 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31198 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31200 */     GIR_RootConstrainSelectedInstOperands,
     /* 31201 */     // GIR_Coverage, 660,
     /* 31201 */     GIR_EraseRootFromParent_Done,
     /* 31202 */   // Label 887: @31202
     /* 31202 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(31256), // Rule ID 661 //
     /* 31207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_u_h),
     /* 31215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31243 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7802:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPADD_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_U_H),
     /* 31246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31248 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31250 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31252 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31254 */     GIR_RootConstrainSelectedInstOperands,
     /* 31255 */     // GIR_Coverage, 661,
     /* 31255 */     GIR_EraseRootFromParent_Done,
     /* 31256 */   // Label 888: @31256
     /* 31256 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(31310), // Rule ID 662 //
     /* 31261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_u_w),
     /* 31269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31297 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7803:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPADD_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_U_W),
     /* 31300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31302 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31304 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31306 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31308 */     GIR_RootConstrainSelectedInstOperands,
     /* 31309 */     // GIR_Coverage, 662,
     /* 31309 */     GIR_EraseRootFromParent_Done,
     /* 31310 */   // Label 889: @31310
     /* 31310 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(31364), // Rule ID 663 //
     /* 31315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_u_d),
     /* 31323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31351 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7801:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPADD_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_U_D),
     /* 31354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31356 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31358 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31360 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31362 */     GIR_RootConstrainSelectedInstOperands,
     /* 31363 */     // GIR_Coverage, 663,
     /* 31363 */     GIR_EraseRootFromParent_Done,
     /* 31364 */   // Label 890: @31364
     /* 31364 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(31418), // Rule ID 664 //
     /* 31369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_s_h),
     /* 31377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31405 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7819:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPSUB_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_S_H),
     /* 31408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31410 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31412 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31414 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31416 */     GIR_RootConstrainSelectedInstOperands,
     /* 31417 */     // GIR_Coverage, 664,
     /* 31417 */     GIR_EraseRootFromParent_Done,
     /* 31418 */   // Label 891: @31418
     /* 31418 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(31472), // Rule ID 665 //
     /* 31423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_s_w),
     /* 31431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31459 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7820:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPSUB_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_S_W),
     /* 31462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31464 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31466 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31468 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31470 */     GIR_RootConstrainSelectedInstOperands,
     /* 31471 */     // GIR_Coverage, 665,
     /* 31471 */     GIR_EraseRootFromParent_Done,
     /* 31472 */   // Label 892: @31472
     /* 31472 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(31526), // Rule ID 666 //
     /* 31477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_s_d),
     /* 31485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31513 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7818:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPSUB_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_S_D),
     /* 31516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31518 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31520 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31522 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31524 */     GIR_RootConstrainSelectedInstOperands,
     /* 31525 */     // GIR_Coverage, 666,
     /* 31525 */     GIR_EraseRootFromParent_Done,
     /* 31526 */   // Label 893: @31526
     /* 31526 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(31580), // Rule ID 667 //
     /* 31531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_u_h),
     /* 31539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31567 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7822:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPSUB_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_U_H),
     /* 31570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31572 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31574 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31576 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31578 */     GIR_RootConstrainSelectedInstOperands,
     /* 31579 */     // GIR_Coverage, 667,
     /* 31579 */     GIR_EraseRootFromParent_Done,
     /* 31580 */   // Label 894: @31580
     /* 31580 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(31634), // Rule ID 668 //
     /* 31585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_u_w),
     /* 31593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31621 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7823:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPSUB_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_U_W),
     /* 31624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31626 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31628 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31630 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31632 */     GIR_RootConstrainSelectedInstOperands,
     /* 31633 */     // GIR_Coverage, 668,
     /* 31633 */     GIR_EraseRootFromParent_Done,
     /* 31634 */   // Label 895: @31634
     /* 31634 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(31688), // Rule ID 669 //
     /* 31639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_u_d),
     /* 31647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31675 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7821:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPSUB_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_U_D),
     /* 31678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31680 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31682 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31684 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31686 */     GIR_RootConstrainSelectedInstOperands,
     /* 31687 */     // GIR_Coverage, 669,
     /* 31687 */     GIR_EraseRootFromParent_Done,
     /* 31688 */   // Label 896: @31688
     /* 31688 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(31742), // Rule ID 836 //
     /* 31693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_madd_q_h),
     /* 31701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31729 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7989:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MADD_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_Q_H),
     /* 31732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31734 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31736 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31738 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31740 */     GIR_RootConstrainSelectedInstOperands,
     /* 31741 */     // GIR_Coverage, 836,
     /* 31741 */     GIR_EraseRootFromParent_Done,
     /* 31742 */   // Label 897: @31742
     /* 31742 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(31796), // Rule ID 837 //
     /* 31747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_madd_q_w),
     /* 31755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31783 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7990:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MADD_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_Q_W),
     /* 31786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31788 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31790 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31792 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31794 */     GIR_RootConstrainSelectedInstOperands,
     /* 31795 */     // GIR_Coverage, 837,
     /* 31795 */     GIR_EraseRootFromParent_Done,
     /* 31796 */   // Label 898: @31796
     /* 31796 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(31850), // Rule ID 838 //
     /* 31801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_maddr_q_h),
     /* 31809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31837 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7991:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MADDR_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDR_Q_H),
     /* 31840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31842 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31844 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31846 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31848 */     GIR_RootConstrainSelectedInstOperands,
     /* 31849 */     // GIR_Coverage, 838,
     /* 31849 */     GIR_EraseRootFromParent_Done,
     /* 31850 */   // Label 899: @31850
     /* 31850 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(31904), // Rule ID 839 //
     /* 31855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_maddr_q_w),
     /* 31863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31891 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7992:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MADDR_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDR_Q_W),
     /* 31894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31896 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31898 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31900 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31902 */     GIR_RootConstrainSelectedInstOperands,
     /* 31903 */     // GIR_Coverage, 839,
     /* 31903 */     GIR_EraseRootFromParent_Done,
     /* 31904 */   // Label 900: @31904
     /* 31904 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(31958), // Rule ID 892 //
     /* 31909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msub_q_h),
     /* 31917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31945 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8053:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MSUB_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_Q_H),
     /* 31948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31950 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31952 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31954 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31956 */     GIR_RootConstrainSelectedInstOperands,
     /* 31957 */     // GIR_Coverage, 892,
     /* 31957 */     GIR_EraseRootFromParent_Done,
     /* 31958 */   // Label 901: @31958
     /* 31958 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(32012), // Rule ID 893 //
     /* 31963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msub_q_w),
     /* 31971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31999 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8054:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MSUB_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_Q_W),
     /* 32002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32004 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32006 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32008 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 32010 */     GIR_RootConstrainSelectedInstOperands,
     /* 32011 */     // GIR_Coverage, 893,
     /* 32011 */     GIR_EraseRootFromParent_Done,
     /* 32012 */   // Label 902: @32012
     /* 32012 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(32066), // Rule ID 894 //
     /* 32017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msubr_q_h),
     /* 32025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 32028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 32031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 32034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 32037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32053 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8055:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MSUBR_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 32053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBR_Q_H),
     /* 32056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32058 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32060 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32062 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 32064 */     GIR_RootConstrainSelectedInstOperands,
     /* 32065 */     // GIR_Coverage, 894,
     /* 32065 */     GIR_EraseRootFromParent_Done,
     /* 32066 */   // Label 903: @32066
     /* 32066 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(32120), // Rule ID 895 //
     /* 32071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msubr_q_w),
     /* 32079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 32085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 32088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 32091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32107 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8056:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MSUBR_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 32107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBR_Q_W),
     /* 32110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32112 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32114 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32116 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 32118 */     GIR_RootConstrainSelectedInstOperands,
     /* 32119 */     // GIR_Coverage, 895,
     /* 32119 */     GIR_EraseRootFromParent_Done,
     /* 32120 */   // Label 904: @32120
     /* 32120 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(32174), // Rule ID 949 //
     /* 32125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_b),
     /* 32133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 32136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 32139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 32142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 32149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 32153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 32157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32161 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8157:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_B),
     /* 32164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32166 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32168 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32172 */     GIR_RootConstrainSelectedInstOperands,
     /* 32173 */     // GIR_Coverage, 949,
     /* 32173 */     GIR_EraseRootFromParent_Done,
     /* 32174 */   // Label 905: @32174
     /* 32174 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(32228), // Rule ID 950 //
     /* 32179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_h),
     /* 32187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 32190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 32193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 32196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32215 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8159:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_H),
     /* 32218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32220 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32222 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32226 */     GIR_RootConstrainSelectedInstOperands,
     /* 32227 */     // GIR_Coverage, 950,
     /* 32227 */     GIR_EraseRootFromParent_Done,
     /* 32228 */   // Label 906: @32228
     /* 32228 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(32282), // Rule ID 951 //
     /* 32233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_w),
     /* 32241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 32247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 32250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32269 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8160:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_W),
     /* 32272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32274 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32276 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32280 */     GIR_RootConstrainSelectedInstOperands,
     /* 32281 */     // GIR_Coverage, 951,
     /* 32281 */     GIR_EraseRootFromParent_Done,
     /* 32282 */   // Label 907: @32282
     /* 32282 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(32336), // Rule ID 952 //
     /* 32287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_d),
     /* 32295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 32311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 32315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 32319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32323 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8158:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_D),
     /* 32326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32328 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32330 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32334 */     GIR_RootConstrainSelectedInstOperands,
     /* 32335 */     // GIR_Coverage, 952,
     /* 32335 */     GIR_EraseRootFromParent_Done,
     /* 32336 */   // Label 908: @32336
     /* 32336 */   GIM_Reject,
     /* 32337 */ // Label 862: @32337
     /* 32337 */ GIM_Reject,
     /* 32338 */ // Label 30: @32338
     /* 32338 */ GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(32369), // Rule ID 354 //
     /* 32343 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 32346 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_bposge32),
     /* 32351 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32358 */   // (intrinsic_w_chain:{ *:[i32] } 7704:{ *:[iPTR] })  =>  (BPOSGE32_PSEUDO:{ *:[i32] })
     /* 32358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BPOSGE32_PSEUDO),
     /* 32361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32367 */   GIR_RootConstrainSelectedInstOperands,
     /* 32368 */   // GIR_Coverage, 354,
     /* 32368 */   GIR_EraseRootFromParent_Done,
     /* 32369 */ // Label 909: @32369
     /* 32369 */ GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(33306),
     /* 32374 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 32377 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(32418), // Rule ID 441 //
     /* 32382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_rddsp),
     /* 32390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32397 */     // MIs[0] mask
     /* 32397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32400 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt10),
     /* 32405 */     // (intrinsic_w_chain:{ *:[i32] } 8131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timmZExt10>>:$mask)  =>  (RDDSP:{ *:[i32] } (timm:{ *:[i32] }):$mask)
     /* 32405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RDDSP),
     /* 32408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32410 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32416 */     GIR_RootConstrainSelectedInstOperands,
     /* 32417 */     // GIR_Coverage, 441,
     /* 32417 */     GIR_EraseRootFromParent_Done,
     /* 32418 */   // Label 911: @32418
     /* 32418 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(32454), // Rule ID 1287 //
     /* 32423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_rddsp),
     /* 32431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32438 */     // MIs[0] mask
     /* 32438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32441 */     // (intrinsic_w_chain:{ *:[i32] } 8131:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timmZExt7>>:$mask)  =>  (RDDSP_MM:{ *:[i32] } (timm:{ *:[i32] }):$mask)
     /* 32441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RDDSP_MM),
     /* 32444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32446 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32452 */     GIR_RootConstrainSelectedInstOperands,
     /* 32453 */     // GIR_Coverage, 1287,
     /* 32453 */     GIR_EraseRootFromParent_Done,
     /* 32454 */   // Label 912: @32454
     /* 32454 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(32495), // Rule ID 442 //
     /* 32459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_NotInMicroMips),
     /* 32462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_wrdsp),
     /* 32467 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 32470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32474 */     // MIs[0] mask
     /* 32474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt10),
     /* 32482 */     // (intrinsic_void 8260:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt10>>:$mask)  =>  (WRDSP GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$mask)
     /* 32482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::WRDSP),
     /* 32485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32487 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32493 */     GIR_RootConstrainSelectedInstOperands,
     /* 32494 */     // GIR_Coverage, 442,
     /* 32494 */     GIR_EraseRootFromParent_Done,
     /* 32495 */   // Label 913: @32495
     /* 32495 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(32531), // Rule ID 1298 //
     /* 32500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_wrdsp),
     /* 32508 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 32511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32515 */     // MIs[0] mask
     /* 32515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32518 */     // (intrinsic_void 8260:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, (timm:{ *:[i32] })<<P:Predicate_timmZExt7>>:$mask)  =>  (WRDSP_MM GPR32Opnd:{ *:[i32] }:$rt, (timm:{ *:[i32] }):$mask)
     /* 32518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::WRDSP_MM),
     /* 32521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 32523 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32529 */     GIR_RootConstrainSelectedInstOperands,
     /* 32530 */     // GIR_Coverage, 1298,
     /* 32530 */     GIR_EraseRootFromParent_Done,
     /* 32531 */   // Label 914: @32531
     /* 32531 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(32574), // Rule ID 363 //
     /* 32536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_ph),
     /* 32544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 32547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32558 */     // (intrinsic_w_chain:{ *:[v2i16] } 7592:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ABSQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt)
     /* 32558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_PH),
     /* 32561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32572 */     GIR_RootConstrainSelectedInstOperands,
     /* 32573 */     // GIR_Coverage, 363,
     /* 32573 */     GIR_EraseRootFromParent_Done,
     /* 32574 */   // Label 915: @32574
     /* 32574 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(32617), // Rule ID 364 //
     /* 32579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_w),
     /* 32587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 32593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32601 */     // (intrinsic_w_chain:{ *:[i32] } 7594:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ABSQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 32601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_W),
     /* 32604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32615 */     GIR_RootConstrainSelectedInstOperands,
     /* 32616 */     // GIR_Coverage, 364,
     /* 32616 */     GIR_EraseRootFromParent_Done,
     /* 32617 */   // Label 916: @32617
     /* 32617 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(32660), // Rule ID 450 //
     /* 32622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 32625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_qb),
     /* 32630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 32633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32644 */     // (intrinsic_w_chain:{ *:[v4i8] } 7593:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ABSQ_S_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_QB),
     /* 32647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32658 */     GIR_RootConstrainSelectedInstOperands,
     /* 32659 */     // GIR_Coverage, 450,
     /* 32659 */     GIR_EraseRootFromParent_Done,
     /* 32660 */   // Label 917: @32660
     /* 32660 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(32703), // Rule ID 1230 //
     /* 32665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_ph),
     /* 32673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 32676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32687 */     // (intrinsic_w_chain:{ *:[v2i16] } 7592:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs)  =>  (ABSQ_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs)
     /* 32687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_PH_MM),
     /* 32690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 32694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32701 */     GIR_RootConstrainSelectedInstOperands,
     /* 32702 */     // GIR_Coverage, 1230,
     /* 32702 */     GIR_EraseRootFromParent_Done,
     /* 32703 */   // Label 918: @32703
     /* 32703 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(32746), // Rule ID 1231 //
     /* 32708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_w),
     /* 32716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 32722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32730 */     // (intrinsic_w_chain:{ *:[i32] } 7594:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (ABSQ_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 32730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_W_MM),
     /* 32733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 32737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32744 */     GIR_RootConstrainSelectedInstOperands,
     /* 32745 */     // GIR_Coverage, 1231,
     /* 32745 */     GIR_EraseRootFromParent_Done,
     /* 32746 */   // Label 919: @32746
     /* 32746 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(32789), // Rule ID 1311 //
     /* 32751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 32754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_qb),
     /* 32759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 32762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32773 */     // (intrinsic_w_chain:{ *:[v4i8] } 7593:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (ABSQ_S_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 32773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_QB_MMR2),
     /* 32776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 32780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32787 */     GIR_RootConstrainSelectedInstOperands,
     /* 32788 */     // GIR_Coverage, 1311,
     /* 32788 */     GIR_EraseRootFromParent_Done,
     /* 32789 */   // Label 920: @32789
     /* 32789 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(32832), // Rule ID 417 //
     /* 32794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_eq_qb),
     /* 32802 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 32805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32816 */     // (intrinsic_void 7770:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_EQ_QB DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_EQ_QB),
     /* 32819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32830 */     GIR_RootConstrainSelectedInstOperands,
     /* 32831 */     // GIR_Coverage, 417,
     /* 32831 */     GIR_EraseRootFromParent_Done,
     /* 32832 */   // Label 921: @32832
     /* 32832 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(32875), // Rule ID 418 //
     /* 32837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_lt_qb),
     /* 32845 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 32848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32859 */     // (intrinsic_void 7772:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LT_QB DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LT_QB),
     /* 32862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32873 */     GIR_RootConstrainSelectedInstOperands,
     /* 32874 */     // GIR_Coverage, 418,
     /* 32874 */     GIR_EraseRootFromParent_Done,
     /* 32875 */   // Label 922: @32875
     /* 32875 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(32918), // Rule ID 419 //
     /* 32880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_le_qb),
     /* 32888 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 32891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32902 */     // (intrinsic_void 7771:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LE_QB DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LE_QB),
     /* 32905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32916 */     GIR_RootConstrainSelectedInstOperands,
     /* 32917 */     // GIR_Coverage, 419,
     /* 32917 */     GIR_EraseRootFromParent_Done,
     /* 32918 */   // Label 923: @32918
     /* 32918 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(32961), // Rule ID 423 //
     /* 32923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_eq_ph),
     /* 32931 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 32934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32945 */     // (intrinsic_void 7761:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_EQ_PH DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 32945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_PH),
     /* 32948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32959 */     GIR_RootConstrainSelectedInstOperands,
     /* 32960 */     // GIR_Coverage, 423,
     /* 32960 */     GIR_EraseRootFromParent_Done,
     /* 32961 */   // Label 924: @32961
     /* 32961 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(33004), // Rule ID 424 //
     /* 32966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_lt_ph),
     /* 32974 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 32977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32988 */     // (intrinsic_void 7763:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LT_PH DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 32988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_PH),
     /* 32991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33002 */     GIR_RootConstrainSelectedInstOperands,
     /* 33003 */     // GIR_Coverage, 424,
     /* 33003 */     GIR_EraseRootFromParent_Done,
     /* 33004 */   // Label 925: @33004
     /* 33004 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(33047), // Rule ID 425 //
     /* 33009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_le_ph),
     /* 33017 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33031 */     // (intrinsic_void 7762:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LE_PH DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_PH),
     /* 33034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33045 */     GIR_RootConstrainSelectedInstOperands,
     /* 33046 */     // GIR_Coverage, 425,
     /* 33046 */     GIR_EraseRootFromParent_Done,
     /* 33047 */   // Label 926: @33047
     /* 33047 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(33090), // Rule ID 1302 //
     /* 33052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_eq_ph),
     /* 33060 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33074 */     // (intrinsic_void 7761:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_EQ_PH_MM DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_PH_MM),
     /* 33077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33088 */     GIR_RootConstrainSelectedInstOperands,
     /* 33089 */     // GIR_Coverage, 1302,
     /* 33089 */     GIR_EraseRootFromParent_Done,
     /* 33090 */   // Label 927: @33090
     /* 33090 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(33133), // Rule ID 1303 //
     /* 33095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_lt_ph),
     /* 33103 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33117 */     // (intrinsic_void 7763:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LT_PH_MM DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_PH_MM),
     /* 33120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33131 */     GIR_RootConstrainSelectedInstOperands,
     /* 33132 */     // GIR_Coverage, 1303,
     /* 33132 */     GIR_EraseRootFromParent_Done,
     /* 33133 */   // Label 928: @33133
     /* 33133 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(33176), // Rule ID 1304 //
     /* 33138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_le_ph),
     /* 33146 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33160 */     // (intrinsic_void 7762:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LE_PH_MM DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_PH_MM),
     /* 33163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33174 */     GIR_RootConstrainSelectedInstOperands,
     /* 33175 */     // GIR_Coverage, 1304,
     /* 33175 */     GIR_EraseRootFromParent_Done,
     /* 33176 */   // Label 929: @33176
     /* 33176 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(33219), // Rule ID 1308 //
     /* 33181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_eq_qb),
     /* 33189 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 33192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33203 */     // (intrinsic_void 7770:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_EQ_QB_MM DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 33203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_EQ_QB_MM),
     /* 33206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33217 */     GIR_RootConstrainSelectedInstOperands,
     /* 33218 */     // GIR_Coverage, 1308,
     /* 33218 */     GIR_EraseRootFromParent_Done,
     /* 33219 */   // Label 930: @33219
     /* 33219 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(33262), // Rule ID 1309 //
     /* 33224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_lt_qb),
     /* 33232 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 33235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33246 */     // (intrinsic_void 7772:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LT_QB_MM DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 33246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LT_QB_MM),
     /* 33249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33260 */     GIR_RootConstrainSelectedInstOperands,
     /* 33261 */     // GIR_Coverage, 1309,
     /* 33261 */     GIR_EraseRootFromParent_Done,
     /* 33262 */   // Label 931: @33262
     /* 33262 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(33305), // Rule ID 1310 //
     /* 33267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_le_qb),
     /* 33275 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 33278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33289 */     // (intrinsic_void 7771:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LE_QB_MM DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 33289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LE_QB_MM),
     /* 33292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33303 */     GIR_RootConstrainSelectedInstOperands,
     /* 33304 */     // GIR_Coverage, 1310,
     /* 33304 */     GIR_EraseRootFromParent_Done,
     /* 33305 */   // Label 932: @33305
     /* 33305 */   GIM_Reject,
     /* 33306 */ // Label 910: @33306
     /* 33306 */ GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(37431),
     /* 33311 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 33314 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(33378), // Rule ID 382 //
     /* 33319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 33327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 33356 */     // MIs[1] Operand 1
     /* 33356 */     // No operand predicates
     /* 33356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33358 */     // (intrinsic_w_chain:{ *:[v2i16] } 8148:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$rs_sa)  =>  (SHLL_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 33358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_PH),
     /* 33361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 33368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33376 */     GIR_RootConstrainSelectedInstOperands,
     /* 33377 */     // GIR_Coverage, 382,
     /* 33377 */     GIR_EraseRootFromParent_Done,
     /* 33378 */   // Label 934: @33378
     /* 33378 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(33442), // Rule ID 387 //
     /* 33383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 33391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 33420 */     // MIs[1] Operand 1
     /* 33420 */     // No operand predicates
     /* 33420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33422 */     // (intrinsic_w_chain:{ *:[i32] } 8149:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$rs_sa)  =>  (SHLL_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 33422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_W),
     /* 33425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 33432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33440 */     GIR_RootConstrainSelectedInstOperands,
     /* 33441 */     // GIR_Coverage, 387,
     /* 33441 */     GIR_EraseRootFromParent_Done,
     /* 33442 */   // Label 935: @33442
     /* 33442 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(33506), // Rule ID 1239 //
     /* 33447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 33455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 33484 */     // MIs[1] Operand 1
     /* 33484 */     // No operand predicates
     /* 33484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33486 */     // (intrinsic_w_chain:{ *:[v2i16] } 8148:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$sa)  =>  (SHLL_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 33486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_PH_MM),
     /* 33489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 33491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 33496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33504 */     GIR_RootConstrainSelectedInstOperands,
     /* 33505 */     // GIR_Coverage, 1239,
     /* 33505 */     GIR_EraseRootFromParent_Done,
     /* 33506 */   // Label 936: @33506
     /* 33506 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(33570), // Rule ID 1244 //
     /* 33511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 33519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 33548 */     // MIs[1] Operand 1
     /* 33548 */     // No operand predicates
     /* 33548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33550 */     // (intrinsic_w_chain:{ *:[i32] } 8149:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$sa)  =>  (SHLL_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 33550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_W_MM),
     /* 33553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 33555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 33560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33568 */     GIR_RootConstrainSelectedInstOperands,
     /* 33569 */     // GIR_Coverage, 1244,
     /* 33569 */     GIR_EraseRootFromParent_Done,
     /* 33570 */   // Label 937: @33570
     /* 33570 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(33625), // Rule ID 1942 //
     /* 33575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_ph),
     /* 33583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 33608 */     // MIs[1] Operand 1
     /* 33608 */     // No operand predicates
     /* 33608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33610 */     // (intrinsic_w_chain:{ *:[v2i16] } 8146:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)  =>  (SHLL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)
     /* 33610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_PH),
     /* 33613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33615 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 33617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 33620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33623 */     GIR_RootConstrainSelectedInstOperands,
     /* 33624 */     // GIR_Coverage, 1942,
     /* 33624 */     GIR_EraseRootFromParent_Done,
     /* 33625 */   // Label 938: @33625
     /* 33625 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(33680), // Rule ID 1948 //
     /* 33630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_qb),
     /* 33638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 33641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 33663 */     // MIs[1] Operand 1
     /* 33663 */     // No operand predicates
     /* 33663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33665 */     // (intrinsic_w_chain:{ *:[v4i8] } 8147:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)  =>  (SHLL_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)
     /* 33665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_QB),
     /* 33668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33670 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 33672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 33675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33678 */     GIR_RootConstrainSelectedInstOperands,
     /* 33679 */     // GIR_Coverage, 1948,
     /* 33679 */     GIR_EraseRootFromParent_Done,
     /* 33680 */   // Label 939: @33680
     /* 33680 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(33732), // Rule ID 359 //
     /* 33685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_w),
     /* 33693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33714 */     // (intrinsic_w_chain:{ *:[i32] } 7601:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 33714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_W),
     /* 33717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 33726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33730 */     GIR_RootConstrainSelectedInstOperands,
     /* 33731 */     // GIR_Coverage, 359,
     /* 33731 */     GIR_EraseRootFromParent_Done,
     /* 33732 */   // Label 940: @33732
     /* 33732 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(33784), // Rule ID 360 //
     /* 33737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_w),
     /* 33745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33766 */     // (intrinsic_w_chain:{ *:[i32] } 8221:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 33766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_W),
     /* 33769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 33778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33782 */     GIR_RootConstrainSelectedInstOperands,
     /* 33783 */     // GIR_Coverage, 360,
     /* 33783 */     GIR_EraseRootFromParent_Done,
     /* 33784 */   // Label 941: @33784
     /* 33784 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(33836), // Rule ID 367 //
     /* 33789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_rs_ph_w),
     /* 33797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33818 */     // (intrinsic_w_chain:{ *:[v2i16] } 8127:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_RS_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 33818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_RS_PH_W),
     /* 33821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33834 */     GIR_RootConstrainSelectedInstOperands,
     /* 33835 */     // GIR_Coverage, 367,
     /* 33835 */     GIR_EraseRootFromParent_Done,
     /* 33836 */   // Label 942: @33836
     /* 33836 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(33888), // Rule ID 368 //
     /* 33841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrqu_s_qb_ph),
     /* 33849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 33852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 33858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33870 */     // (intrinsic_w_chain:{ *:[v4i8] } 8128:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQU_S_QB_PH:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQU_S_QB_PH),
     /* 33873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33886 */     GIR_RootConstrainSelectedInstOperands,
     /* 33887 */     // GIR_Coverage, 368,
     /* 33887 */     GIR_EraseRootFromParent_Done,
     /* 33888 */   // Label 943: @33888
     /* 33888 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(33940), // Rule ID 379 //
     /* 33893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_qb),
     /* 33901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 33904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33922 */     // (intrinsic_w_chain:{ *:[v4i8] } 8147:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 33922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_QB),
     /* 33925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 33931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33938 */     GIR_RootConstrainSelectedInstOperands,
     /* 33939 */     // GIR_Coverage, 379,
     /* 33939 */     GIR_EraseRootFromParent_Done,
     /* 33940 */   // Label 944: @33940
     /* 33940 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(33992), // Rule ID 381 //
     /* 33945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_ph),
     /* 33953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33974 */     // (intrinsic_w_chain:{ *:[v2i16] } 8146:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 33974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_PH),
     /* 33977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 33983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33990 */     GIR_RootConstrainSelectedInstOperands,
     /* 33991 */     // GIR_Coverage, 381,
     /* 33991 */     GIR_EraseRootFromParent_Done,
     /* 33992 */   // Label 945: @33992
     /* 33992 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(34044), // Rule ID 383 //
     /* 33997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 34005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 34014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34026 */     // (intrinsic_w_chain:{ *:[v2i16] } 8148:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 34026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_PH),
     /* 34029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 34033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 34035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 34038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34042 */     GIR_RootConstrainSelectedInstOperands,
     /* 34043 */     // GIR_Coverage, 383,
     /* 34043 */     GIR_EraseRootFromParent_Done,
     /* 34044 */   // Label 946: @34044
     /* 34044 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(34096), // Rule ID 388 //
     /* 34049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 34057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 34063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 34066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34078 */     // (intrinsic_w_chain:{ *:[i32] } 8149:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 34078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_W),
     /* 34081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 34085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 34087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 34090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34094 */     GIR_RootConstrainSelectedInstOperands,
     /* 34095 */     // GIR_Coverage, 388,
     /* 34095 */     GIR_EraseRootFromParent_Done,
     /* 34096 */   // Label 947: @34096
     /* 34096 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(34148), // Rule ID 391 //
     /* 34101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbl),
     /* 34109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34130 */     // (intrinsic_w_chain:{ *:[v2i16] } 8069:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBL:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBL),
     /* 34133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34146 */     GIR_RootConstrainSelectedInstOperands,
     /* 34147 */     // GIR_Coverage, 391,
     /* 34147 */     GIR_EraseRootFromParent_Done,
     /* 34148 */   // Label 948: @34148
     /* 34148 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(34200), // Rule ID 392 //
     /* 34153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbr),
     /* 34161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34182 */     // (intrinsic_w_chain:{ *:[v2i16] } 8070:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBR:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBR),
     /* 34185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34198 */     GIR_RootConstrainSelectedInstOperands,
     /* 34199 */     // GIR_Coverage, 392,
     /* 34199 */     GIR_EraseRootFromParent_Done,
     /* 34200 */   // Label 949: @34200
     /* 34200 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(34252), // Rule ID 393 //
     /* 34205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phl),
     /* 34213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34234 */     // (intrinsic_w_chain:{ *:[i32] } 8067:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHL:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHL),
     /* 34237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34243 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34250 */     GIR_RootConstrainSelectedInstOperands,
     /* 34251 */     // GIR_Coverage, 393,
     /* 34251 */     GIR_EraseRootFromParent_Done,
     /* 34252 */   // Label 950: @34252
     /* 34252 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(34304), // Rule ID 394 //
     /* 34257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phr),
     /* 34265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34286 */     // (intrinsic_w_chain:{ *:[i32] } 8068:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHR:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHR),
     /* 34289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34302 */     GIR_RootConstrainSelectedInstOperands,
     /* 34303 */     // GIR_Coverage, 394,
     /* 34303 */     GIR_EraseRootFromParent_Done,
     /* 34304 */   // Label 951: @34304
     /* 34304 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(34356), // Rule ID 395 //
     /* 34309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_ph),
     /* 34317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34338 */     // (intrinsic_w_chain:{ *:[v2i16] } 8071:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_RS_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_PH),
     /* 34341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34354 */     GIR_RootConstrainSelectedInstOperands,
     /* 34355 */     // GIR_Coverage, 395,
     /* 34355 */     GIR_EraseRootFromParent_Done,
     /* 34356 */   // Label 952: @34356
     /* 34356 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(34405), // Rule ID 420 //
     /* 34361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_eq_qb),
     /* 34369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34390 */     // (intrinsic_w_chain:{ *:[i32] } 7767:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_EQ_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_EQ_QB),
     /* 34393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34403 */     GIR_RootConstrainSelectedInstOperands,
     /* 34404 */     // GIR_Coverage, 420,
     /* 34404 */     GIR_EraseRootFromParent_Done,
     /* 34405 */   // Label 953: @34405
     /* 34405 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(34454), // Rule ID 421 //
     /* 34410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_lt_qb),
     /* 34418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34439 */     // (intrinsic_w_chain:{ *:[i32] } 7769:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LT_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LT_QB),
     /* 34442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34452 */     GIR_RootConstrainSelectedInstOperands,
     /* 34453 */     // GIR_Coverage, 421,
     /* 34453 */     GIR_EraseRootFromParent_Done,
     /* 34454 */   // Label 954: @34454
     /* 34454 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(34503), // Rule ID 422 //
     /* 34459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_le_qb),
     /* 34467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34488 */     // (intrinsic_w_chain:{ *:[i32] } 7768:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LE_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LE_QB),
     /* 34491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34501 */     GIR_RootConstrainSelectedInstOperands,
     /* 34502 */     // GIR_Coverage, 422,
     /* 34502 */     GIR_EraseRootFromParent_Done,
     /* 34503 */   // Label 955: @34503
     /* 34503 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(34552), // Rule ID 432 //
     /* 34508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_qb),
     /* 34516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 34519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34537 */     // (intrinsic_w_chain:{ *:[v4i8] } 8111:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PICK_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_QB),
     /* 34540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34550 */     GIR_RootConstrainSelectedInstOperands,
     /* 34551 */     // GIR_Coverage, 432,
     /* 34551 */     GIR_EraseRootFromParent_Done,
     /* 34552 */   // Label 956: @34552
     /* 34552 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(34601), // Rule ID 433 //
     /* 34557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_ph),
     /* 34565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34586 */     // (intrinsic_w_chain:{ *:[v2i16] } 8110:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PICK_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_PH),
     /* 34589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34599 */     GIR_RootConstrainSelectedInstOperands,
     /* 34600 */     // GIR_Coverage, 433,
     /* 34600 */     GIR_EraseRootFromParent_Done,
     /* 34601 */   // Label 957: @34601
     /* 34601 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(34650), // Rule ID 437 //
     /* 34606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_insv),
     /* 34614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 34620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 34623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34635 */     // (intrinsic_w_chain:{ *:[i32] } 7969:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)  =>  (INSV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)
     /* 34635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSV),
     /* 34638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 34640 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 34642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 34644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34648 */     GIR_RootConstrainSelectedInstOperands,
     /* 34649 */     // GIR_Coverage, 437,
     /* 34649 */     GIR_EraseRootFromParent_Done,
     /* 34650 */   // Label 958: @34650
     /* 34650 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(34702), // Rule ID 443 //
     /* 34655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_ph),
     /* 34663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34684 */     // (intrinsic_w_chain:{ *:[v2i16] } 7619:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_PH),
     /* 34687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34700 */     GIR_RootConstrainSelectedInstOperands,
     /* 34701 */     // GIR_Coverage, 443,
     /* 34701 */     GIR_EraseRootFromParent_Done,
     /* 34702 */   // Label 959: @34702
     /* 34702 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(34754), // Rule ID 444 //
     /* 34707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_ph),
     /* 34715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34736 */     // (intrinsic_w_chain:{ *:[v2i16] } 7621:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_PH),
     /* 34739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34745 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34752 */     GIR_RootConstrainSelectedInstOperands,
     /* 34753 */     // GIR_Coverage, 444,
     /* 34753 */     GIR_EraseRootFromParent_Done,
     /* 34754 */   // Label 960: @34754
     /* 34754 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(34806), // Rule ID 445 //
     /* 34759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_ph),
     /* 34767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34788 */     // (intrinsic_w_chain:{ *:[v2i16] } 8242:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_PH),
     /* 34791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34804 */     GIR_RootConstrainSelectedInstOperands,
     /* 34805 */     // GIR_Coverage, 445,
     /* 34805 */     GIR_EraseRootFromParent_Done,
     /* 34806 */   // Label 961: @34806
     /* 34806 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(34858), // Rule ID 446 //
     /* 34811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_ph),
     /* 34819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34840 */     // (intrinsic_w_chain:{ *:[v2i16] } 8244:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_PH),
     /* 34843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34856 */     GIR_RootConstrainSelectedInstOperands,
     /* 34857 */     // GIR_Coverage, 446,
     /* 34857 */     GIR_EraseRootFromParent_Done,
     /* 34858 */   // Label 962: @34858
     /* 34858 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(34910), // Rule ID 447 //
     /* 34863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_eq_qb),
     /* 34871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34892 */     // (intrinsic_w_chain:{ *:[i32] } 7764:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_EQ_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_EQ_QB),
     /* 34895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 34904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34908 */     GIR_RootConstrainSelectedInstOperands,
     /* 34909 */     // GIR_Coverage, 447,
     /* 34909 */     GIR_EraseRootFromParent_Done,
     /* 34910 */   // Label 963: @34910
     /* 34910 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(34962), // Rule ID 448 //
     /* 34915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_lt_qb),
     /* 34923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34944 */     // (intrinsic_w_chain:{ *:[i32] } 7766:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LT_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LT_QB),
     /* 34947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 34956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34960 */     GIR_RootConstrainSelectedInstOperands,
     /* 34961 */     // GIR_Coverage, 448,
     /* 34961 */     GIR_EraseRootFromParent_Done,
     /* 34962 */   // Label 964: @34962
     /* 34962 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(35014), // Rule ID 449 //
     /* 34967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_le_qb),
     /* 34975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34996 */     // (intrinsic_w_chain:{ *:[i32] } 7765:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LE_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LE_QB),
     /* 34999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 35008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35012 */     GIR_RootConstrainSelectedInstOperands,
     /* 35013 */     // GIR_Coverage, 449,
     /* 35013 */     GIR_EraseRootFromParent_Done,
     /* 35014 */   // Label 965: @35014
     /* 35014 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(35066), // Rule ID 463 //
     /* 35019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_s_ph),
     /* 35027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35048 */     // (intrinsic_w_chain:{ *:[v2i16] } 8066:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MUL_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_S_PH),
     /* 35051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35064 */     GIR_RootConstrainSelectedInstOperands,
     /* 35065 */     // GIR_Coverage, 463,
     /* 35065 */     GIR_EraseRootFromParent_Done,
     /* 35066 */   // Label 966: @35066
     /* 35066 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(35118), // Rule ID 464 //
     /* 35071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_w),
     /* 35079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35100 */     // (intrinsic_w_chain:{ *:[i32] } 8074:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_W),
     /* 35103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35116 */     GIR_RootConstrainSelectedInstOperands,
     /* 35117 */     // GIR_Coverage, 464,
     /* 35117 */     GIR_EraseRootFromParent_Done,
     /* 35118 */   // Label 967: @35118
     /* 35118 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(35170), // Rule ID 465 //
     /* 35123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_w),
     /* 35131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35152 */     // (intrinsic_w_chain:{ *:[i32] } 8072:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_RS_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_W),
     /* 35155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35168 */     GIR_RootConstrainSelectedInstOperands,
     /* 35169 */     // GIR_Coverage, 465,
     /* 35169 */     GIR_EraseRootFromParent_Done,
     /* 35170 */   // Label 968: @35170
     /* 35170 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(35222), // Rule ID 466 //
     /* 35175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_ph),
     /* 35183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35204 */     // (intrinsic_w_chain:{ *:[v2i16] } 8073:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_PH),
     /* 35207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35220 */     GIR_RootConstrainSelectedInstOperands,
     /* 35221 */     // GIR_Coverage, 466,
     /* 35221 */     GIR_EraseRootFromParent_Done,
     /* 35222 */   // Label 969: @35222
     /* 35222 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(35271), // Rule ID 476 //
     /* 35227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_qb_ph),
     /* 35235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 35238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35256 */     // (intrinsic_w_chain:{ *:[v4i8] } 8122:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECR_QB_PH:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_QB_PH),
     /* 35259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35269 */     GIR_RootConstrainSelectedInstOperands,
     /* 35270 */     // GIR_Coverage, 476,
     /* 35270 */     GIR_EraseRootFromParent_Done,
     /* 35271 */   // Label 970: @35271
     /* 35271 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(35323), // Rule ID 1224 //
     /* 35276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_w),
     /* 35284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35305 */     // (intrinsic_w_chain:{ *:[i32] } 7601:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQ_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_W_MM),
     /* 35308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 35317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35321 */     GIR_RootConstrainSelectedInstOperands,
     /* 35322 */     // GIR_Coverage, 1224,
     /* 35322 */     GIR_EraseRootFromParent_Done,
     /* 35323 */   // Label 971: @35323
     /* 35323 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(35372), // Rule ID 1232 //
     /* 35328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_insv),
     /* 35336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35357 */     // (intrinsic_w_chain:{ *:[i32] } 7969:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)  =>  (INSV_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSV_MM),
     /* 35360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 35362 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35366 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35370 */     GIR_RootConstrainSelectedInstOperands,
     /* 35371 */     // GIR_Coverage, 1232,
     /* 35371 */     GIR_EraseRootFromParent_Done,
     /* 35372 */   // Label 972: @35372
     /* 35372 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(35424), // Rule ID 1240 //
     /* 35377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_ph),
     /* 35385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35406 */     // (intrinsic_w_chain:{ *:[v2i16] } 8146:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_PH_MM),
     /* 35409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35422 */     GIR_RootConstrainSelectedInstOperands,
     /* 35423 */     // GIR_Coverage, 1240,
     /* 35423 */     GIR_EraseRootFromParent_Done,
     /* 35424 */   // Label 973: @35424
     /* 35424 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(35476), // Rule ID 1241 //
     /* 35429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 35437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35458 */     // (intrinsic_w_chain:{ *:[v2i16] } 8148:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_PH_MM),
     /* 35461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35474 */     GIR_RootConstrainSelectedInstOperands,
     /* 35475 */     // GIR_Coverage, 1241,
     /* 35475 */     GIR_EraseRootFromParent_Done,
     /* 35476 */   // Label 974: @35476
     /* 35476 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(35528), // Rule ID 1242 //
     /* 35481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_qb),
     /* 35489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 35492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 35495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35510 */     // (intrinsic_w_chain:{ *:[v4i8] } 8147:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_QB_MM),
     /* 35513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35526 */     GIR_RootConstrainSelectedInstOperands,
     /* 35527 */     // GIR_Coverage, 1242,
     /* 35527 */     GIR_EraseRootFromParent_Done,
     /* 35528 */   // Label 975: @35528
     /* 35528 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(35580), // Rule ID 1243 //
     /* 35533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 35541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35562 */     // (intrinsic_w_chain:{ *:[i32] } 8149:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_W_MM),
     /* 35565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35578 */     GIR_RootConstrainSelectedInstOperands,
     /* 35579 */     // GIR_Coverage, 1243,
     /* 35579 */     GIR_EraseRootFromParent_Done,
     /* 35580 */   // Label 976: @35580
     /* 35580 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(35632), // Rule ID 1262 //
     /* 35585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_w),
     /* 35593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35614 */     // (intrinsic_w_chain:{ *:[i32] } 8221:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQ_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_W_MM),
     /* 35617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 35626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35630 */     GIR_RootConstrainSelectedInstOperands,
     /* 35631 */     // GIR_Coverage, 1262,
     /* 35631 */     GIR_EraseRootFromParent_Done,
     /* 35632 */   // Label 977: @35632
     /* 35632 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(35684), // Rule ID 1268 //
     /* 35637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phl),
     /* 35645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35666 */     // (intrinsic_w_chain:{ *:[i32] } 8067:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHL_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHL_MM),
     /* 35669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35682 */     GIR_RootConstrainSelectedInstOperands,
     /* 35683 */     // GIR_Coverage, 1268,
     /* 35683 */     GIR_EraseRootFromParent_Done,
     /* 35684 */   // Label 978: @35684
     /* 35684 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(35736), // Rule ID 1269 //
     /* 35689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phr),
     /* 35697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35718 */     // (intrinsic_w_chain:{ *:[i32] } 8068:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHR_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHR_MM),
     /* 35721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35734 */     GIR_RootConstrainSelectedInstOperands,
     /* 35735 */     // GIR_Coverage, 1269,
     /* 35735 */     GIR_EraseRootFromParent_Done,
     /* 35736 */   // Label 979: @35736
     /* 35736 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(35788), // Rule ID 1270 //
     /* 35741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbl),
     /* 35749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 35755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35770 */     // (intrinsic_w_chain:{ *:[v2i16] } 8069:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBL_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBL_MM),
     /* 35773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35786 */     GIR_RootConstrainSelectedInstOperands,
     /* 35787 */     // GIR_Coverage, 1270,
     /* 35787 */     GIR_EraseRootFromParent_Done,
     /* 35788 */   // Label 980: @35788
     /* 35788 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(35840), // Rule ID 1271 //
     /* 35793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbr),
     /* 35801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 35807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35822 */     // (intrinsic_w_chain:{ *:[v2i16] } 8070:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBR_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBR_MM),
     /* 35825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35838 */     GIR_RootConstrainSelectedInstOperands,
     /* 35839 */     // GIR_Coverage, 1271,
     /* 35839 */     GIR_EraseRootFromParent_Done,
     /* 35840 */   // Label 981: @35840
     /* 35840 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(35892), // Rule ID 1272 //
     /* 35845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_ph),
     /* 35853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35874 */     // (intrinsic_w_chain:{ *:[v2i16] } 8071:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_RS_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_PH_MM),
     /* 35877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35890 */     GIR_RootConstrainSelectedInstOperands,
     /* 35891 */     // GIR_Coverage, 1272,
     /* 35891 */     GIR_EraseRootFromParent_Done,
     /* 35892 */   // Label 982: @35892
     /* 35892 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(35944), // Rule ID 1275 //
     /* 35897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrqu_s_qb_ph),
     /* 35905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 35908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35926 */     // (intrinsic_w_chain:{ *:[v4i8] } 8128:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQU_S_QB_PH_MM:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQU_S_QB_PH_MM),
     /* 35929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35942 */     GIR_RootConstrainSelectedInstOperands,
     /* 35943 */     // GIR_Coverage, 1275,
     /* 35943 */     GIR_EraseRootFromParent_Done,
     /* 35944 */   // Label 983: @35944
     /* 35944 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(35996), // Rule ID 1276 //
     /* 35949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_rs_ph_w),
     /* 35957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35978 */     // (intrinsic_w_chain:{ *:[v2i16] } 8127:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_RS_PH_W_MM:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_RS_PH_W_MM),
     /* 35981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35994 */     GIR_RootConstrainSelectedInstOperands,
     /* 35995 */     // GIR_Coverage, 1276,
     /* 35995 */     GIR_EraseRootFromParent_Done,
     /* 35996 */   // Label 984: @35996
     /* 35996 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(36045), // Rule ID 1294 //
     /* 36001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_ph),
     /* 36009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36030 */     // (intrinsic_w_chain:{ *:[v2i16] } 8110:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PICK_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_PH_MM),
     /* 36033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36043 */     GIR_RootConstrainSelectedInstOperands,
     /* 36044 */     // GIR_Coverage, 1294,
     /* 36044 */     GIR_EraseRootFromParent_Done,
     /* 36045 */   // Label 985: @36045
     /* 36045 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(36094), // Rule ID 1295 //
     /* 36050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_qb),
     /* 36058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 36061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36079 */     // (intrinsic_w_chain:{ *:[v4i8] } 8111:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PICK_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_QB_MM),
     /* 36082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36092 */     GIR_RootConstrainSelectedInstOperands,
     /* 36093 */     // GIR_Coverage, 1295,
     /* 36093 */     GIR_EraseRootFromParent_Done,
     /* 36094 */   // Label 986: @36094
     /* 36094 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(36143), // Rule ID 1305 //
     /* 36099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_eq_qb),
     /* 36107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36128 */     // (intrinsic_w_chain:{ *:[i32] } 7767:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_EQ_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_EQ_QB_MM),
     /* 36131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36141 */     GIR_RootConstrainSelectedInstOperands,
     /* 36142 */     // GIR_Coverage, 1305,
     /* 36142 */     GIR_EraseRootFromParent_Done,
     /* 36143 */   // Label 987: @36143
     /* 36143 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(36192), // Rule ID 1306 //
     /* 36148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_lt_qb),
     /* 36156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36177 */     // (intrinsic_w_chain:{ *:[i32] } 7769:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LT_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LT_QB_MM),
     /* 36180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36190 */     GIR_RootConstrainSelectedInstOperands,
     /* 36191 */     // GIR_Coverage, 1306,
     /* 36191 */     GIR_EraseRootFromParent_Done,
     /* 36192 */   // Label 988: @36192
     /* 36192 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(36241), // Rule ID 1307 //
     /* 36197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_le_qb),
     /* 36205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36226 */     // (intrinsic_w_chain:{ *:[i32] } 7768:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LE_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LE_QB_MM),
     /* 36229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36239 */     GIR_RootConstrainSelectedInstOperands,
     /* 36240 */     // GIR_Coverage, 1307,
     /* 36240 */     GIR_EraseRootFromParent_Done,
     /* 36241 */   // Label 989: @36241
     /* 36241 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(36293), // Rule ID 1316 //
     /* 36246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_ph),
     /* 36254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36275 */     // (intrinsic_w_chain:{ *:[v2i16] } 7619:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_PH_MMR2),
     /* 36278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36291 */     GIR_RootConstrainSelectedInstOperands,
     /* 36292 */     // GIR_Coverage, 1316,
     /* 36292 */     GIR_EraseRootFromParent_Done,
     /* 36293 */   // Label 990: @36293
     /* 36293 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(36345), // Rule ID 1317 //
     /* 36298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_ph),
     /* 36306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36327 */     // (intrinsic_w_chain:{ *:[v2i16] } 7621:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_PH_MMR2),
     /* 36330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36343 */     GIR_RootConstrainSelectedInstOperands,
     /* 36344 */     // GIR_Coverage, 1317,
     /* 36344 */     GIR_EraseRootFromParent_Done,
     /* 36345 */   // Label 991: @36345
     /* 36345 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(36397), // Rule ID 1328 //
     /* 36350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_eq_qb),
     /* 36358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36379 */     // (intrinsic_w_chain:{ *:[i32] } 7764:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_EQ_QB_MMR2:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_EQ_QB_MMR2),
     /* 36382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 36391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36395 */     GIR_RootConstrainSelectedInstOperands,
     /* 36396 */     // GIR_Coverage, 1328,
     /* 36396 */     GIR_EraseRootFromParent_Done,
     /* 36397 */   // Label 992: @36397
     /* 36397 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(36449), // Rule ID 1329 //
     /* 36402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_lt_qb),
     /* 36410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36431 */     // (intrinsic_w_chain:{ *:[i32] } 7766:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LT_QB_MMR2:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LT_QB_MMR2),
     /* 36434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 36443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36447 */     GIR_RootConstrainSelectedInstOperands,
     /* 36448 */     // GIR_Coverage, 1329,
     /* 36448 */     GIR_EraseRootFromParent_Done,
     /* 36449 */   // Label 993: @36449
     /* 36449 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(36501), // Rule ID 1330 //
     /* 36454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_le_qb),
     /* 36462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36483 */     // (intrinsic_w_chain:{ *:[i32] } 7765:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LE_QB_MMR2:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LE_QB_MMR2),
     /* 36486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 36495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36499 */     GIR_RootConstrainSelectedInstOperands,
     /* 36500 */     // GIR_Coverage, 1330,
     /* 36500 */     GIR_EraseRootFromParent_Done,
     /* 36501 */   // Label 994: @36501
     /* 36501 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(36553), // Rule ID 1336 //
     /* 36506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_ph),
     /* 36514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36535 */     // (intrinsic_w_chain:{ *:[v2i16] } 8242:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_PH_MMR2),
     /* 36538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36551 */     GIR_RootConstrainSelectedInstOperands,
     /* 36552 */     // GIR_Coverage, 1336,
     /* 36552 */     GIR_EraseRootFromParent_Done,
     /* 36553 */   // Label 995: @36553
     /* 36553 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(36605), // Rule ID 1337 //
     /* 36558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_ph),
     /* 36566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36587 */     // (intrinsic_w_chain:{ *:[v2i16] } 8244:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_PH_MMR2),
     /* 36590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36603 */     GIR_RootConstrainSelectedInstOperands,
     /* 36604 */     // GIR_Coverage, 1337,
     /* 36604 */     GIR_EraseRootFromParent_Done,
     /* 36605 */   // Label 996: @36605
     /* 36605 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(36657), // Rule ID 1344 //
     /* 36610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_s_ph),
     /* 36618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36639 */     // (intrinsic_w_chain:{ *:[v2i16] } 8066:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MUL_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_S_PH_MMR2),
     /* 36642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36655 */     GIR_RootConstrainSelectedInstOperands,
     /* 36656 */     // GIR_Coverage, 1344,
     /* 36656 */     GIR_EraseRootFromParent_Done,
     /* 36657 */   // Label 997: @36657
     /* 36657 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(36709), // Rule ID 1345 //
     /* 36662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_w),
     /* 36670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36691 */     // (intrinsic_w_chain:{ *:[i32] } 8072:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_RS_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 36691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_W_MMR2),
     /* 36694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36707 */     GIR_RootConstrainSelectedInstOperands,
     /* 36708 */     // GIR_Coverage, 1345,
     /* 36708 */     GIR_EraseRootFromParent_Done,
     /* 36709 */   // Label 998: @36709
     /* 36709 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(36761), // Rule ID 1346 //
     /* 36714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_ph),
     /* 36722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36743 */     // (intrinsic_w_chain:{ *:[v2i16] } 8073:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_PH_MMR2),
     /* 36746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36759 */     GIR_RootConstrainSelectedInstOperands,
     /* 36760 */     // GIR_Coverage, 1346,
     /* 36760 */     GIR_EraseRootFromParent_Done,
     /* 36761 */   // Label 999: @36761
     /* 36761 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(36813), // Rule ID 1347 //
     /* 36766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_w),
     /* 36774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36795 */     // (intrinsic_w_chain:{ *:[i32] } 8074:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_S_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 36795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_W_MMR2),
     /* 36798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36811 */     GIR_RootConstrainSelectedInstOperands,
     /* 36812 */     // GIR_Coverage, 1347,
     /* 36812 */     GIR_EraseRootFromParent_Done,
     /* 36813 */   // Label 1000: @36813
     /* 36813 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(36862), // Rule ID 1348 //
     /* 36818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_qb_ph),
     /* 36826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 36829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36847 */     // (intrinsic_w_chain:{ *:[v4i8] } 8122:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECR_QB_PH_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_QB_PH_MMR2),
     /* 36850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36860 */     GIR_RootConstrainSelectedInstOperands,
     /* 36861 */     // GIR_Coverage, 1348,
     /* 36861 */     GIR_EraseRootFromParent_Done,
     /* 36862 */   // Label 1001: @36862
     /* 36862 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(36906), // Rule ID 1929 //
     /* 36867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 36870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_ph),
     /* 36875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36888 */     // (intrinsic_w_chain:{ *:[v2i16] } 8063:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (MUL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /* 36888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_PH),
     /* 36891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36893 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 36895 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 36897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36904 */     GIR_RootConstrainSelectedInstOperands,
     /* 36905 */     // GIR_Coverage, 1929,
     /* 36905 */     GIR_EraseRootFromParent_Done,
     /* 36906 */   // Label 1002: @36906
     /* 36906 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(36950), // Rule ID 1935 //
     /* 36911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 36914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addsc),
     /* 36919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36932 */     // (intrinsic_w_chain:{ *:[i32] } 7618:{ *:[iPTR] }, i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)  =>  (ADDSC:{ *:[i32] } i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)
     /* 36932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDSC),
     /* 36935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36937 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 36939 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 36941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCarry*/0,
     /* 36944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36948 */     GIR_RootConstrainSelectedInstOperands,
     /* 36949 */     // GIR_Coverage, 1935,
     /* 36949 */     GIR_EraseRootFromParent_Done,
     /* 36950 */   // Label 1003: @36950
     /* 36950 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(36994), // Rule ID 1937 //
     /* 36955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 36958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addwc),
     /* 36963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36976 */     // (intrinsic_w_chain:{ *:[i32] } 7633:{ *:[iPTR] }, i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)  =>  (ADDWC:{ *:[i32] } i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)
     /* 36976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDWC),
     /* 36979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36981 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 36983 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 36985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36992 */     GIR_RootConstrainSelectedInstOperands,
     /* 36993 */     // GIR_Coverage, 1937,
     /* 36993 */     GIR_EraseRootFromParent_Done,
     /* 36994 */   // Label 1004: @36994
     /* 36994 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(37040), // Rule ID 487 //
     /* 36999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 37002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ldr_d),
     /* 37007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 37010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 37017 */     // MIs[0] ptr
     /* 37017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37025 */     // (intrinsic_w_chain:{ *:[v2i64] } 7983:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (LDR_D:{ *:[v2i64] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LDR_D),
     /* 37028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37030 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37032 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37038 */     GIR_RootConstrainSelectedInstOperands,
     /* 37039 */     // GIR_Coverage, 487,
     /* 37039 */     GIR_EraseRootFromParent_Done,
     /* 37040 */   // Label 1005: @37040
     /* 37040 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(37086), // Rule ID 488 //
     /* 37045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 37048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ldr_w),
     /* 37053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 37056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 37063 */     // MIs[0] ptr
     /* 37063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37071 */     // (intrinsic_w_chain:{ *:[v4i32] } 7984:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (LDR_W:{ *:[v4i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LDR_W),
     /* 37074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37076 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37078 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37084 */     GIR_RootConstrainSelectedInstOperands,
     /* 37085 */     // GIR_Coverage, 488,
     /* 37085 */     GIR_EraseRootFromParent_Done,
     /* 37086 */   // Label 1006: @37086
     /* 37086 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(37128), // Rule ID 434 //
     /* 37091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 37094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lwx),
     /* 37099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37109 */     // MIs[0] base
     /* 37109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37113 */     // (intrinsic_w_chain:{ *:[i32] } 7987:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LWX:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LWX),
     /* 37116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37118 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37120 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37126 */     GIR_RootConstrainSelectedInstOperands,
     /* 37127 */     // GIR_Coverage, 434,
     /* 37127 */     GIR_EraseRootFromParent_Done,
     /* 37128 */   // Label 1007: @37128
     /* 37128 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(37170), // Rule ID 435 //
     /* 37133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 37136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lhx),
     /* 37141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37151 */     // MIs[0] base
     /* 37151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37155 */     // (intrinsic_w_chain:{ *:[i32] } 7985:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LHX:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LHX),
     /* 37158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37160 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37162 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37168 */     GIR_RootConstrainSelectedInstOperands,
     /* 37169 */     // GIR_Coverage, 435,
     /* 37169 */     GIR_EraseRootFromParent_Done,
     /* 37170 */   // Label 1008: @37170
     /* 37170 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(37212), // Rule ID 436 //
     /* 37175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 37178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lbux),
     /* 37183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37193 */     // MIs[0] base
     /* 37193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37197 */     // (intrinsic_w_chain:{ *:[i32] } 7974:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LBUX:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LBUX),
     /* 37200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37202 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37204 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37210 */     GIR_RootConstrainSelectedInstOperands,
     /* 37211 */     // GIR_Coverage, 436,
     /* 37211 */     GIR_EraseRootFromParent_Done,
     /* 37212 */   // Label 1009: @37212
     /* 37212 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(37254), // Rule ID 1277 //
     /* 37217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 37220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lbux),
     /* 37225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37235 */     // MIs[0] base
     /* 37235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37239 */     // (intrinsic_w_chain:{ *:[i32] } 7974:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LBUX_MM:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LBUX_MM),
     /* 37242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37244 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37246 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37252 */     GIR_RootConstrainSelectedInstOperands,
     /* 37253 */     // GIR_Coverage, 1277,
     /* 37253 */     GIR_EraseRootFromParent_Done,
     /* 37254 */   // Label 1010: @37254
     /* 37254 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(37296), // Rule ID 1278 //
     /* 37259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 37262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lhx),
     /* 37267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37277 */     // MIs[0] base
     /* 37277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37281 */     // (intrinsic_w_chain:{ *:[i32] } 7985:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LHX_MM:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LHX_MM),
     /* 37284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37286 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37288 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37290 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37294 */     GIR_RootConstrainSelectedInstOperands,
     /* 37295 */     // GIR_Coverage, 1278,
     /* 37295 */     GIR_EraseRootFromParent_Done,
     /* 37296 */   // Label 1011: @37296
     /* 37296 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(37338), // Rule ID 1279 //
     /* 37301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 37304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lwx),
     /* 37309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37319 */     // MIs[0] base
     /* 37319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37323 */     // (intrinsic_w_chain:{ *:[i32] } 7987:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LWX_MM:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LWX_MM),
     /* 37326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37328 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37330 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37336 */     GIR_RootConstrainSelectedInstOperands,
     /* 37337 */     // GIR_Coverage, 1279,
     /* 37337 */     GIR_EraseRootFromParent_Done,
     /* 37338 */   // Label 1012: @37338
     /* 37338 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(37384), // Rule ID 489 //
     /* 37343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 37346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_str_d),
     /* 37351 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 37354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 37361 */     // MIs[0] ptr
     /* 37361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37369 */     // (intrinsic_void 8217:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (STR_D MSA128DOpnd:{ *:[v2i64] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::STR_D),
     /* 37372 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 37374 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37376 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37382 */     GIR_RootConstrainSelectedInstOperands,
     /* 37383 */     // GIR_Coverage, 489,
     /* 37383 */     GIR_EraseRootFromParent_Done,
     /* 37384 */   // Label 1013: @37384
     /* 37384 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(37430), // Rule ID 490 //
     /* 37389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 37392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_str_w),
     /* 37397 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 37400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 37407 */     // MIs[0] ptr
     /* 37407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37415 */     // (intrinsic_void 8218:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (STR_W MSA128WOpnd:{ *:[v4i32] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::STR_W),
     /* 37418 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 37420 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37422 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37428 */     GIR_RootConstrainSelectedInstOperands,
     /* 37429 */     // GIR_Coverage, 490,
     /* 37429 */     GIR_EraseRootFromParent_Done,
     /* 37430 */   // Label 1014: @37430
     /* 37430 */   GIM_Reject,
     /* 37431 */ // Label 933: @37431
     /* 37431 */ GIM_Reject,
     /* 37432 */ // Label 31: @37432
     /* 37432 */ GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(37497), // Rule ID 1582 //
     /* 37437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 37440 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 37443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 37446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37454 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 37454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37473 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37476 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 37478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37481 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37486 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37496 */   // GIR_Coverage, 1582,
     /* 37496 */   GIR_EraseRootFromParent_Done,
     /* 37497 */ // Label 1015: @37497
     /* 37497 */ GIM_Reject,
     /* 37498 */ // Label 32: @37498
     /* 37498 */ GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(37561), // Rule ID 1575 //
     /* 37503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 37506 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 37512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37520 */   // (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$src)  =>  (SLL:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i32] })
     /* 37520 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 37523 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37527 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37532 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 37538 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 37543 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL),
     /* 37551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 37559 */   GIR_RootConstrainSelectedInstOperands,
     /* 37560 */   // GIR_Coverage, 1575,
     /* 37560 */   GIR_EraseRootFromParent_Done,
     /* 37561 */ // Label 1016: @37561
     /* 37561 */ GIM_Reject,
     /* 37562 */ // Label 33: @37562
     /* 37562 */ GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(37622),
     /* 37567 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37570 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(37596), // Rule ID 2162 //
     /* 37575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 37578 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immLi16),
     /* 37582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 37586 */     // MIs[0] Operand 1
     /* 37586 */     // No operand predicates
     /* 37586 */     // (imm:{ *:[i32] })<<P:Predicate_immLi16>>:$imm  =>  (LI16_MM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_immLi16>>:$imm)
     /* 37586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LI16_MM),
     /* 37589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 37594 */     GIR_RootConstrainSelectedInstOperands,
     /* 37595 */     // GIR_Coverage, 2162,
     /* 37595 */     GIR_EraseRootFromParent_Done,
     /* 37596 */   // Label 1018: @37596
     /* 37596 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(37621), // Rule ID 1853 //
     /* 37601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 37604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 37608 */     // MIs[0] Operand 1
     /* 37608 */     // No operand predicates
     /* 37608 */     // (imm:{ *:[i32] }):$imm  =>  (LwConstant32:{ *:[i32] } (imm:{ *:[i32] }):$imm, -1:{ *:[i32] })
     /* 37608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LwConstant32),
     /* 37611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 37613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 37616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 37619 */     GIR_RootConstrainSelectedInstOperands,
     /* 37620 */     // GIR_Coverage, 1853,
     /* 37620 */     GIR_EraseRootFromParent_Done,
     /* 37621 */   // Label 1019: @37621
     /* 37621 */   GIM_Reject,
     /* 37622 */ // Label 1017: @37622
     /* 37622 */ GIM_Reject,
     /* 37623 */ // Label 34: @37623
     /* 37623 */ GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(39086),
     /* 37628 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 37631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 37634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37638 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(37743), // Rule ID 1631 //
     /* 37643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 37651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 37668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 37672 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 37676 */     // MIs[2] Operand 1
     /* 37676 */     // No operand predicates
     /* 37676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 37678 */     // (sext:{ *:[i64] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRA:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5), sub_32:{ *:[i32] })
     /* 37678 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37681 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRA),
     /* 37685 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37690 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm5
     /* 37697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 37724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37742 */     // GIR_Coverage, 1631,
     /* 37742 */     GIR_EraseRootFromParent_Done,
     /* 37743 */   // Label 1021: @37743
     /* 37743 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(37848), // Rule ID 1627 //
     /* 37748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 37756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 37773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 37777 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 37781 */     // MIs[2] Operand 1
     /* 37781 */     // No operand predicates
     /* 37781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 37783 */     // (sext:{ *:[i64] } (srl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRL:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5), sub_32:{ *:[i32] })
     /* 37783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRL),
     /* 37790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37795 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm5
     /* 37802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 37829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37847 */     // GIR_Coverage, 1627,
     /* 37847 */     GIR_EraseRootFromParent_Done,
     /* 37848 */   // Label 1022: @37848
     /* 37848 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(37953), // Rule ID 1623 //
     /* 37853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 37861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 37878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 37882 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 37886 */     // MIs[2] Operand 1
     /* 37886 */     // No operand predicates
     /* 37886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 37888 */     // (sext:{ *:[i64] } (shl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SLL:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5), sub_32:{ *:[i32] })
     /* 37888 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37891 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SLL),
     /* 37895 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37900 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm5
     /* 37907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 37934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37952 */     // GIR_Coverage, 1623,
     /* 37952 */     GIR_EraseRootFromParent_Done,
     /* 37953 */   // Label 1023: @37953
     /* 37953 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(38052), // Rule ID 1613 //
     /* 37958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 37966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 37986 */     // (sext:{ *:[i64] } (add:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ADDu:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 37986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::ADDu),
     /* 37993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37998 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38002 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38046 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38051 */     // GIR_Coverage, 1613,
     /* 38051 */     GIR_EraseRootFromParent_Done,
     /* 38052 */   // Label 1024: @38052
     /* 38052 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(38151), // Rule ID 1633 //
     /* 38057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 38065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38085 */     // (sext:{ *:[i64] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRAV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38085 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38088 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRAV),
     /* 38092 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38097 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38101 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38140 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38150 */     // GIR_Coverage, 1633,
     /* 38150 */     GIR_EraseRootFromParent_Done,
     /* 38151 */   // Label 1025: @38151
     /* 38151 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(38250), // Rule ID 1629 //
     /* 38156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 38164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38184 */     // (sext:{ *:[i64] } (srl:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRLV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38184 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38187 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRLV),
     /* 38191 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38196 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38200 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38249 */     // GIR_Coverage, 1629,
     /* 38249 */     GIR_EraseRootFromParent_Done,
     /* 38250 */   // Label 1026: @38250
     /* 38250 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(38358), // Rule ID 1617 //
     /* 38255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 38258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 38266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38286 */     // (sext:{ *:[i64] } (mul:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MUL:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MUL),
     /* 38293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38298 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38302 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38306 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for Mips::HI0*/0,
     /* 38309 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for Mips::LO0*/1,
     /* 38312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38357 */     // GIR_Coverage, 1617,
     /* 38357 */     GIR_EraseRootFromParent_Done,
     /* 38358 */   // Label 1027: @38358
     /* 38358 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(38460), // Rule ID 1820 //
     /* 38363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 38374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38394 */     // (sext:{ *:[i64] } (mul:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MUL_R6:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38394 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38397 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MUL_R6),
     /* 38401 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38406 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38410 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38444 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38459 */     // GIR_Coverage, 1820,
     /* 38459 */     GIR_EraseRootFromParent_Done,
     /* 38460 */   // Label 1028: @38460
     /* 38460 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(38562), // Rule ID 1821 //
     /* 38465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SDIV),
     /* 38476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38496 */     // (sext:{ *:[i64] } (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (DIV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38496 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38499 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::DIV),
     /* 38503 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38508 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38512 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38561 */     // GIR_Coverage, 1821,
     /* 38561 */     GIR_EraseRootFromParent_Done,
     /* 38562 */   // Label 1029: @38562
     /* 38562 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(38661), // Rule ID 1625 //
     /* 38567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 38575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38595 */     // (sext:{ *:[i64] } (shl:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SLLV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38595 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38598 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SLLV),
     /* 38602 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38607 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38611 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38660 */     // GIR_Coverage, 1625,
     /* 38660 */     GIR_EraseRootFromParent_Done,
     /* 38661 */   // Label 1030: @38661
     /* 38661 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(38763), // Rule ID 1823 //
     /* 38666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SREM),
     /* 38677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38697 */     // (sext:{ *:[i64] } (srem:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MOD:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MOD),
     /* 38704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38709 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38713 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38762 */     // GIR_Coverage, 1823,
     /* 38762 */     GIR_EraseRootFromParent_Done,
     /* 38763 */   // Label 1031: @38763
     /* 38763 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(38862), // Rule ID 1615 //
     /* 38768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 38776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38796 */     // (sext:{ *:[i64] } (sub:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SUBu:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38796 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38799 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SUBu),
     /* 38803 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38808 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38812 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38861 */     // GIR_Coverage, 1615,
     /* 38861 */     GIR_EraseRootFromParent_Done,
     /* 38862 */   // Label 1032: @38862
     /* 38862 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(38964), // Rule ID 1822 //
     /* 38867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UDIV),
     /* 38878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38898 */     // (sext:{ *:[i64] } (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (DIVU:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38898 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38901 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::DIVU),
     /* 38905 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38910 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38914 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38963 */     // GIR_Coverage, 1822,
     /* 38963 */     GIR_EraseRootFromParent_Done,
     /* 38964 */   // Label 1033: @38964
     /* 38964 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(39066), // Rule ID 1824 //
     /* 38969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UREM),
     /* 38980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39000 */     // (sext:{ *:[i64] } (urem:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MODU:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 39000 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 39003 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MODU),
     /* 39007 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39012 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 39016 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 39020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 39022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 39025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 39029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 39039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 39047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 39050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39065 */     // GIR_Coverage, 1824,
     /* 39065 */     GIR_EraseRootFromParent_Done,
     /* 39066 */   // Label 1034: @39066
     /* 39066 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(39085), // Rule ID 1585 //
     /* 39071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39078 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SLL64_32:{ *:[i64] } GPR32:{ *:[i32] }:$src)
     /* 39078 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL64_32),
     /* 39083 */     GIR_RootConstrainSelectedInstOperands,
     /* 39084 */     // GIR_Coverage, 1585,
     /* 39084 */     GIR_Done,
     /* 39085 */   // Label 1035: @39085
     /* 39085 */   GIM_Reject,
     /* 39086 */ // Label 1020: @39086
     /* 39086 */ GIM_Reject,
     /* 39087 */ // Label 35: @39087
     /* 39087 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1038*/ GIMT_Encode4(39434),
     /* 39098 */ /*GILLT_s32*//*Label 1036*/ GIMT_Encode4(39106),
     /* 39102 */ /*GILLT_s64*//*Label 1037*/ GIMT_Encode4(39332),
     /* 39106 */ // Label 1036: @39106
     /* 39106 */ GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(39331),
     /* 39111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 39114 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(39150), // Rule ID 106 //
     /* 39119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 39122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39130 */     // MIs[0] Operand 2
     /* 39130 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39141 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i8:{ *:[Other] })  =>  (SEB:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEB),
     /* 39144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39148 */     GIR_RootConstrainSelectedInstOperands,
     /* 39149 */     // GIR_Coverage, 106,
     /* 39149 */     GIR_EraseRootFromParent_Done,
     /* 39150 */   // Label 1040: @39150
     /* 39150 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(39186), // Rule ID 107 //
     /* 39155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 39158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39166 */     // MIs[0] Operand 2
     /* 39166 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39177 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i16:{ *:[Other] })  =>  (SEH:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEH),
     /* 39180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39184 */     GIR_RootConstrainSelectedInstOperands,
     /* 39185 */     // GIR_Coverage, 107,
     /* 39185 */     GIR_EraseRootFromParent_Done,
     /* 39186 */   // Label 1041: @39186
     /* 39186 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(39222), // Rule ID 1101 //
     /* 39191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39202 */     // MIs[0] Operand 2
     /* 39202 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39213 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i8:{ *:[Other] })  =>  (SEB_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEB_MM),
     /* 39216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39220 */     GIR_RootConstrainSelectedInstOperands,
     /* 39221 */     // GIR_Coverage, 1101,
     /* 39221 */     GIR_EraseRootFromParent_Done,
     /* 39222 */   // Label 1042: @39222
     /* 39222 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(39258), // Rule ID 1102 //
     /* 39227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39238 */     // MIs[0] Operand 2
     /* 39238 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39249 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i16:{ *:[Other] })  =>  (SEH_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEH_MM),
     /* 39252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39256 */     GIR_RootConstrainSelectedInstOperands,
     /* 39257 */     // GIR_Coverage, 1102,
     /* 39257 */     GIR_EraseRootFromParent_Done,
     /* 39258 */   // Label 1043: @39258
     /* 39258 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(39294), // Rule ID 1911 //
     /* 39263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39274 */     // MIs[0] Operand 2
     /* 39274 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39285 */     // (sext_inreg:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val, i8:{ *:[Other] })  =>  (SebRx16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val)
     /* 39285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SebRx16),
     /* 39288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 39290 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 39292 */     GIR_RootConstrainSelectedInstOperands,
     /* 39293 */     // GIR_Coverage, 1911,
     /* 39293 */     GIR_EraseRootFromParent_Done,
     /* 39294 */   // Label 1044: @39294
     /* 39294 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(39330), // Rule ID 1912 //
     /* 39299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39310 */     // MIs[0] Operand 2
     /* 39310 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39321 */     // (sext_inreg:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val, i16:{ *:[Other] })  =>  (SehRx16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val)
     /* 39321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SehRx16),
     /* 39324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 39326 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 39328 */     GIR_RootConstrainSelectedInstOperands,
     /* 39329 */     // GIR_Coverage, 1912,
     /* 39329 */     GIR_EraseRootFromParent_Done,
     /* 39330 */   // Label 1045: @39330
     /* 39330 */   GIM_Reject,
     /* 39331 */ // Label 1039: @39331
     /* 39331 */ GIM_Reject,
     /* 39332 */ // Label 1037: @39332
     /* 39332 */ GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(39433),
     /* 39337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 39340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39348 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(39376), // Rule ID 261 //
     /* 39353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_IsGP64bit),
     /* 39356 */     // MIs[0] Operand 2
     /* 39356 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39367 */     // (sext_inreg:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, i8:{ *:[Other] })  =>  (SEB64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt)
     /* 39367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEB64),
     /* 39370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39374 */     GIR_RootConstrainSelectedInstOperands,
     /* 39375 */     // GIR_Coverage, 261,
     /* 39375 */     GIR_EraseRootFromParent_Done,
     /* 39376 */   // Label 1047: @39376
     /* 39376 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(39404), // Rule ID 262 //
     /* 39381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_IsGP64bit),
     /* 39384 */     // MIs[0] Operand 2
     /* 39384 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39395 */     // (sext_inreg:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, i16:{ *:[Other] })  =>  (SEH64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt)
     /* 39395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEH64),
     /* 39398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39402 */     GIR_RootConstrainSelectedInstOperands,
     /* 39403 */     // GIR_Coverage, 262,
     /* 39403 */     GIR_EraseRootFromParent_Done,
     /* 39404 */   // Label 1048: @39404
     /* 39404 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(39432), // Rule ID 1588 //
     /* 39409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39412 */     // MIs[0] Operand 2
     /* 39412 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 39423 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SLL64_64:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 39423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL64_64),
     /* 39426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39428 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39430 */     GIR_RootConstrainSelectedInstOperands,
     /* 39431 */     // GIR_Coverage, 1588,
     /* 39431 */     GIR_EraseRootFromParent_Done,
     /* 39432 */   // Label 1049: @39432
     /* 39432 */   GIM_Reject,
     /* 39433 */ // Label 1046: @39433
     /* 39433 */ GIM_Reject,
     /* 39434 */ // Label 1038: @39434
     /* 39434 */ GIM_Reject,
     /* 39435 */ // Label 36: @39435
     /* 39435 */ GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(39635),
     /* 39440 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 39443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 39446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39450 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(39506), // Rule ID 280 //
     /* 39455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 39458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 39462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 39466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 39470 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 39474 */     // MIs[1] Operand 1
     /* 39474 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 39479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39491 */     // (zext:{ *:[i64] } (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETEQ:{ *:[Other] }))  =>  (SEQ:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 39491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEQ),
     /* 39494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 39500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 39504 */     GIR_RootConstrainSelectedInstOperands,
     /* 39505 */     // GIR_Coverage, 280,
     /* 39505 */     GIR_EraseRootFromParent_Done,
     /* 39506 */   // Label 1051: @39506
     /* 39506 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(39562), // Rule ID 282 //
     /* 39511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 39514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 39518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 39522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 39526 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 39530 */     // MIs[1] Operand 1
     /* 39530 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 39535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39547 */     // (zext:{ *:[i64] } (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETNE:{ *:[Other] }))  =>  (SNE:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 39547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SNE),
     /* 39550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 39556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 39560 */     GIR_RootConstrainSelectedInstOperands,
     /* 39561 */     // GIR_Coverage, 282,
     /* 39561 */     GIR_EraseRootFromParent_Done,
     /* 39562 */   // Label 1052: @39562
     /* 39562 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(39634),
     /* 39567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39571 */     GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(39610), // Rule ID 1583 //
     /* 39576 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39579 */       // (zext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (DSRL:{ *:[i64] } (DSLL64_32:{ *:[i64] } GPR32:{ *:[i32] }:$src), 32:{ *:[i32] })
     /* 39579 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 39582 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::DSLL64_32),
     /* 39586 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39591 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 39595 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39597 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRL),
     /* 39600 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39602 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39605 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 39608 */       GIR_RootConstrainSelectedInstOperands,
     /* 39609 */       // GIR_Coverage, 1583,
     /* 39609 */       GIR_EraseRootFromParent_Done,
     /* 39610 */     // Label 1054: @39610
     /* 39610 */     GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(39633), // Rule ID 1586 //
     /* 39615 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 39618 */       // (zext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (DEXT64_32:{ *:[i64] } GPR32:{ *:[i32] }:$src, 0:{ *:[i32] }, 32:{ *:[i32] })
     /* 39618 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DEXT64_32),
     /* 39621 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 39623 */       GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39625 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 39628 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 39631 */       GIR_RootConstrainSelectedInstOperands,
     /* 39632 */       // GIR_Coverage, 1586,
     /* 39632 */       GIR_EraseRootFromParent_Done,
     /* 39633 */     // Label 1055: @39633
     /* 39633 */     GIM_Reject,
     /* 39634 */   // Label 1053: @39634
     /* 39634 */   GIM_Reject,
     /* 39635 */ // Label 1050: @39635
     /* 39635 */ GIM_Reject,
     /* 39636 */ // Label 37: @39636
     /* 39636 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1062*/ GIMT_Encode4(41432),
     /* 39647 */ /*GILLT_s32*//*Label 1056*/ GIMT_Encode4(39679),
     /* 39651 */ /*GILLT_s64*//*Label 1057*/ GIMT_Encode4(39941), GIMT_Encode4(0),
     /* 39659 */ /*GILLT_v2s64*//*Label 1058*/ GIMT_Encode4(40082), GIMT_Encode4(0),
     /* 39667 */ /*GILLT_v4s32*//*Label 1059*/ GIMT_Encode4(40116),
     /* 39671 */ /*GILLT_v8s16*//*Label 1060*/ GIMT_Encode4(40384),
     /* 39675 */ /*GILLT_v16s8*//*Label 1061*/ GIMT_Encode4(40780),
     /* 39679 */ // Label 1056: @39679
     /* 39679 */ GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(39940),
     /* 39684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 39687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 39690 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(39732), // Rule ID 55 //
     /* 39695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 39698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 39718 */     // MIs[1] Operand 1
     /* 39718 */     // No operand predicates
     /* 39718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39720 */     // (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (SLL:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 39720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL),
     /* 39723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 39730 */     GIR_RootConstrainSelectedInstOperands,
     /* 39731 */     // GIR_Coverage, 55,
     /* 39731 */     GIR_EraseRootFromParent_Done,
     /* 39732 */   // Label 1064: @39732
     /* 39732 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(39774), // Rule ID 1835 //
     /* 39737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 39760 */     // MIs[1] Operand 1
     /* 39760 */     // No operand predicates
     /* 39760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39762 */     // (shl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SllX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 39762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SllX16),
     /* 39765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 39767 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 39769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 39772 */     GIR_RootConstrainSelectedInstOperands,
     /* 39773 */     // GIR_Coverage, 1835,
     /* 39773 */     GIR_EraseRootFromParent_Done,
     /* 39774 */   // Label 1065: @39774
     /* 39774 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(39816), // Rule ID 2174 //
     /* 39779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 39786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 39790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Shift),
     /* 39802 */     // MIs[1] Operand 1
     /* 39802 */     // No operand predicates
     /* 39802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39804 */     // (shl:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)  =>  (SLL16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)
     /* 39804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL16_MM),
     /* 39807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 39814 */     GIR_RootConstrainSelectedInstOperands,
     /* 39815 */     // GIR_Coverage, 2174,
     /* 39815 */     GIR_EraseRootFromParent_Done,
     /* 39816 */   // Label 1066: @39816
     /* 39816 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(39858), // Rule ID 2175 //
     /* 39821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 39844 */     // MIs[1] Operand 1
     /* 39844 */     // No operand predicates
     /* 39844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39846 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SLL_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 39846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_MM),
     /* 39849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39851 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 39856 */     GIR_RootConstrainSelectedInstOperands,
     /* 39857 */     // GIR_Coverage, 2175,
     /* 39857 */     GIR_EraseRootFromParent_Done,
     /* 39858 */   // Label 1067: @39858
     /* 39858 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(39885), // Rule ID 61 //
     /* 39863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 39866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39878 */     // (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SLLV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 39878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLLV),
     /* 39883 */     GIR_RootConstrainSelectedInstOperands,
     /* 39884 */     // GIR_Coverage, 61,
     /* 39884 */     GIR_Done,
     /* 39885 */   // Label 1068: @39885
     /* 39885 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(39912), // Rule ID 1838 //
     /* 39890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39905 */     // (shl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)  =>  (SllvRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)
     /* 39905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SllvRxRy16),
     /* 39910 */     GIR_RootConstrainSelectedInstOperands,
     /* 39911 */     // GIR_Coverage, 1838,
     /* 39911 */     GIR_Done,
     /* 39912 */   // Label 1069: @39912
     /* 39912 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(39939), // Rule ID 2176 //
     /* 39917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39932 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)  =>  (SLLV_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)
     /* 39932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLLV_MM),
     /* 39937 */     GIR_RootConstrainSelectedInstOperands,
     /* 39938 */     // GIR_Coverage, 2176,
     /* 39938 */     GIR_Done,
     /* 39939 */   // Label 1070: @39939
     /* 39939 */   GIM_Reject,
     /* 39940 */ // Label 1063: @39940
     /* 39940 */ GIM_Reject,
     /* 39941 */ // Label 1057: @39941
     /* 39941 */ GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(40081),
     /* 39946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 39949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 39952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39960 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(39994), // Rule ID 210 //
     /* 39965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 39968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 39980 */     // MIs[1] Operand 1
     /* 39980 */     // No operand predicates
     /* 39980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39982 */     // (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DSLL:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 39982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSLL),
     /* 39985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 39992 */     GIR_RootConstrainSelectedInstOperands,
     /* 39993 */     // GIR_Coverage, 210,
     /* 39993 */     GIR_EraseRootFromParent_Done,
     /* 39994 */   // Label 1072: @39994
     /* 39994 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(40061), // Rule ID 1576 //
     /* 39999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 40002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 40010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 40014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 40019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 40021 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DSLLV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 40021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 40024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 40028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40033 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 40039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 40044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 40049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSLLV),
     /* 40052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 40054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 40056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 40059 */     GIR_RootConstrainSelectedInstOperands,
     /* 40060 */     // GIR_Coverage, 1576,
     /* 40060 */     GIR_EraseRootFromParent_Done,
     /* 40061 */   // Label 1073: @40061
     /* 40061 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(40080), // Rule ID 216 //
     /* 40066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 40069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 40073 */     // (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DSLLV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 40073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSLLV),
     /* 40078 */     GIR_RootConstrainSelectedInstOperands,
     /* 40079 */     // GIR_Coverage, 216,
     /* 40079 */     GIR_Done,
     /* 40080 */   // Label 1074: @40080
     /* 40080 */   GIM_Reject,
     /* 40081 */ // Label 1071: @40081
     /* 40081 */ GIM_Reject,
     /* 40082 */ // Label 1058: @40082
     /* 40082 */ GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(40115), // Rule ID 960 //
     /* 40087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 40090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 40093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 40096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 40100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 40104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 40108 */   // (shl:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SLL_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 40108 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_D),
     /* 40113 */   GIR_RootConstrainSelectedInstOperands,
     /* 40114 */   // GIR_Coverage, 960,
     /* 40114 */   GIR_Done,
     /* 40115 */ // Label 1075: @40115
     /* 40115 */ GIM_Reject,
     /* 40116 */ // Label 1059: @40116
     /* 40116 */ GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(40383),
     /* 40121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 40127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 40131 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(40245), // Rule ID 2466 //
     /* 40136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 40155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 40159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40163 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 40166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40174 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40178 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40190 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40194 */     // MIs[3] Operand 1
     /* 40194 */     // No operand predicates
     /* 40194 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40198 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40202 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40206 */     // MIs[4] Operand 1
     /* 40206 */     // No operand predicates
     /* 40206 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40210 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40214 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40218 */     // MIs[5] Operand 1
     /* 40218 */     // No operand predicates
     /* 40218 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40222 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40226 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40230 */     // MIs[6] Operand 1
     /* 40230 */     // No operand predicates
     /* 40230 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 40232 */     // (shl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>), v4i32:{ *:[v4i32] }:$wt))  =>  (SLL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 40232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_W),
     /* 40235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40237 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 40243 */     GIR_RootConstrainSelectedInstOperands,
     /* 40244 */     // GIR_Coverage, 2466,
     /* 40244 */     GIR_EraseRootFromParent_Done,
     /* 40245 */   // Label 1077: @40245
     /* 40245 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(40359), // Rule ID 2075 //
     /* 40250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 40269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 40273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40277 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 40280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40288 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40292 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40304 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40308 */     // MIs[3] Operand 1
     /* 40308 */     // No operand predicates
     /* 40308 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40312 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40316 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40320 */     // MIs[4] Operand 1
     /* 40320 */     // No operand predicates
     /* 40320 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40324 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40328 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40332 */     // MIs[5] Operand 1
     /* 40332 */     // No operand predicates
     /* 40332 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40336 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40340 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40344 */     // MIs[6] Operand 1
     /* 40344 */     // No operand predicates
     /* 40344 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 40346 */     // (shl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$wt, (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>)))  =>  (SLL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 40346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_W),
     /* 40349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40351 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 40357 */     GIR_RootConstrainSelectedInstOperands,
     /* 40358 */     // GIR_Coverage, 2075,
     /* 40358 */     GIR_EraseRootFromParent_Done,
     /* 40359 */   // Label 1078: @40359
     /* 40359 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(40382), // Rule ID 959 //
     /* 40364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 40367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 40371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 40375 */     // (shl:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SLL_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 40375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_W),
     /* 40380 */     GIR_RootConstrainSelectedInstOperands,
     /* 40381 */     // GIR_Coverage, 959,
     /* 40381 */     GIR_Done,
     /* 40382 */   // Label 1079: @40382
     /* 40382 */   GIM_Reject,
     /* 40383 */ // Label 1076: @40383
     /* 40383 */ GIM_Reject,
     /* 40384 */ // Label 1060: @40384
     /* 40384 */ GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(40779),
     /* 40389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 40395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 40399 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(40577), // Rule ID 2465 //
     /* 40404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 40423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 40427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40431 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 40434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40442 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40446 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40450 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 40454 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 40458 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 40462 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 40466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40474 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40478 */     // MIs[3] Operand 1
     /* 40478 */     // No operand predicates
     /* 40478 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40482 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40486 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40490 */     // MIs[4] Operand 1
     /* 40490 */     // No operand predicates
     /* 40490 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40494 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40498 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40502 */     // MIs[5] Operand 1
     /* 40502 */     // No operand predicates
     /* 40502 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40506 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40510 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40514 */     // MIs[6] Operand 1
     /* 40514 */     // No operand predicates
     /* 40514 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 40518 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40522 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40526 */     // MIs[7] Operand 1
     /* 40526 */     // No operand predicates
     /* 40526 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 40530 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40534 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40538 */     // MIs[8] Operand 1
     /* 40538 */     // No operand predicates
     /* 40538 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 40542 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40546 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40550 */     // MIs[9] Operand 1
     /* 40550 */     // No operand predicates
     /* 40550 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 40554 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40558 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40562 */     // MIs[10] Operand 1
     /* 40562 */     // No operand predicates
     /* 40562 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 40564 */     // (shl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>), v8i16:{ *:[v8i16] }:$wt))  =>  (SLL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 40564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_H),
     /* 40567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40569 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 40575 */     GIR_RootConstrainSelectedInstOperands,
     /* 40576 */     // GIR_Coverage, 2465,
     /* 40576 */     GIR_EraseRootFromParent_Done,
     /* 40577 */   // Label 1081: @40577
     /* 40577 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(40755), // Rule ID 2074 //
     /* 40582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 40601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 40605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40609 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 40612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40620 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40624 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40628 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 40632 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 40636 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 40640 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 40644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40652 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40656 */     // MIs[3] Operand 1
     /* 40656 */     // No operand predicates
     /* 40656 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40660 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40664 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40668 */     // MIs[4] Operand 1
     /* 40668 */     // No operand predicates
     /* 40668 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40672 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40676 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40680 */     // MIs[5] Operand 1
     /* 40680 */     // No operand predicates
     /* 40680 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40684 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40688 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40692 */     // MIs[6] Operand 1
     /* 40692 */     // No operand predicates
     /* 40692 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 40696 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40700 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40704 */     // MIs[7] Operand 1
     /* 40704 */     // No operand predicates
     /* 40704 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 40708 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40712 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40716 */     // MIs[8] Operand 1
     /* 40716 */     // No operand predicates
     /* 40716 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 40720 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40724 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40728 */     // MIs[9] Operand 1
     /* 40728 */     // No operand predicates
     /* 40728 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 40732 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40736 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40740 */     // MIs[10] Operand 1
     /* 40740 */     // No operand predicates
     /* 40740 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 40742 */     // (shl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$wt, (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>)))  =>  (SLL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 40742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_H),
     /* 40745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40747 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 40753 */     GIR_RootConstrainSelectedInstOperands,
     /* 40754 */     // GIR_Coverage, 2074,
     /* 40754 */     GIR_EraseRootFromParent_Done,
     /* 40755 */   // Label 1082: @40755
     /* 40755 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(40778), // Rule ID 958 //
     /* 40760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 40763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 40767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 40771 */     // (shl:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SLL_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 40771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_H),
     /* 40776 */     GIR_RootConstrainSelectedInstOperands,
     /* 40777 */     // GIR_Coverage, 958,
     /* 40777 */     GIR_Done,
     /* 40778 */   // Label 1083: @40778
     /* 40778 */   GIM_Reject,
     /* 40779 */ // Label 1080: @40779
     /* 40779 */ GIM_Reject,
     /* 40780 */ // Label 1061: @40780
     /* 40780 */ GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(41431),
     /* 40785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 40788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 40791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 40795 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(41101), // Rule ID 2464 //
     /* 40800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 40815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 40819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 40823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40827 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 40830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40838 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40842 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40846 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 40850 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 40854 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 40858 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 40862 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 40866 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 40870 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 40874 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 40878 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 40882 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 40886 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 40890 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 40894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40902 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40906 */     // MIs[3] Operand 1
     /* 40906 */     // No operand predicates
     /* 40906 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40910 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40914 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40918 */     // MIs[4] Operand 1
     /* 40918 */     // No operand predicates
     /* 40918 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40922 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40926 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40930 */     // MIs[5] Operand 1
     /* 40930 */     // No operand predicates
     /* 40930 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40934 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40938 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40942 */     // MIs[6] Operand 1
     /* 40942 */     // No operand predicates
     /* 40942 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 40946 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40950 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40954 */     // MIs[7] Operand 1
     /* 40954 */     // No operand predicates
     /* 40954 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 40958 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40962 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40966 */     // MIs[8] Operand 1
     /* 40966 */     // No operand predicates
     /* 40966 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 40970 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40974 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40978 */     // MIs[9] Operand 1
     /* 40978 */     // No operand predicates
     /* 40978 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 40982 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40986 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40990 */     // MIs[10] Operand 1
     /* 40990 */     // No operand predicates
     /* 40990 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 40994 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40998 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41002 */     // MIs[11] Operand 1
     /* 41002 */     // No operand predicates
     /* 41002 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 41006 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41010 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41014 */     // MIs[12] Operand 1
     /* 41014 */     // No operand predicates
     /* 41014 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 41018 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41022 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41026 */     // MIs[13] Operand 1
     /* 41026 */     // No operand predicates
     /* 41026 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 41030 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41034 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41038 */     // MIs[14] Operand 1
     /* 41038 */     // No operand predicates
     /* 41038 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 41042 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41046 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41050 */     // MIs[15] Operand 1
     /* 41050 */     // No operand predicates
     /* 41050 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 41054 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41058 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41062 */     // MIs[16] Operand 1
     /* 41062 */     // No operand predicates
     /* 41062 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 41066 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41070 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41074 */     // MIs[17] Operand 1
     /* 41074 */     // No operand predicates
     /* 41074 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 41078 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41082 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41086 */     // MIs[18] Operand 1
     /* 41086 */     // No operand predicates
     /* 41086 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 41088 */     // (shl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>), v16i8:{ *:[v16i8] }:$wt))  =>  (SLL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 41088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_B),
     /* 41091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 41093 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 41095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 41099 */     GIR_RootConstrainSelectedInstOperands,
     /* 41100 */     // GIR_Coverage, 2464,
     /* 41100 */     GIR_EraseRootFromParent_Done,
     /* 41101 */   // Label 1085: @41101
     /* 41101 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(41407), // Rule ID 2073 //
     /* 41106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 41109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 41117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 41121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 41125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 41129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 41133 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 41136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 41140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 41144 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 41148 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 41152 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 41156 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 41160 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 41164 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 41168 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 41172 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 41176 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 41180 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 41184 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 41188 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 41192 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 41196 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 41200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 41204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41208 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41212 */     // MIs[3] Operand 1
     /* 41212 */     // No operand predicates
     /* 41212 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 41216 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41220 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41224 */     // MIs[4] Operand 1
     /* 41224 */     // No operand predicates
     /* 41224 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 41228 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41232 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41236 */     // MIs[5] Operand 1
     /* 41236 */     // No operand predicates
     /* 41236 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 41240 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41244 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41248 */     // MIs[6] Operand 1
     /* 41248 */     // No operand predicates
     /* 41248 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 41252 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41256 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41260 */     // MIs[7] Operand 1
     /* 41260 */     // No operand predicates
     /* 41260 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 41264 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41268 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41272 */     // MIs[8] Operand 1
     /* 41272 */     // No operand predicates
     /* 41272 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 41276 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41280 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41284 */     // MIs[9] Operand 1
     /* 41284 */     // No operand predicates
     /* 41284 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 41288 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41292 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41296 */     // MIs[10] Operand 1
     /* 41296 */     // No operand predicates
     /* 41296 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 41300 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41304 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41308 */     // MIs[11] Operand 1
     /* 41308 */     // No operand predicates
     /* 41308 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 41312 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41316 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41320 */     // MIs[12] Operand 1
     /* 41320 */     // No operand predicates
     /* 41320 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 41324 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41328 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41332 */     // MIs[13] Operand 1
     /* 41332 */     // No operand predicates
     /* 41332 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 41336 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41340 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41344 */     // MIs[14] Operand 1
     /* 41344 */     // No operand predicates
     /* 41344 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 41348 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41352 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41356 */     // MIs[15] Operand 1
     /* 41356 */     // No operand predicates
     /* 41356 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 41360 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41364 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41368 */     // MIs[16] Operand 1
     /* 41368 */     // No operand predicates
     /* 41368 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 41372 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41376 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41380 */     // MIs[17] Operand 1
     /* 41380 */     // No operand predicates
     /* 41380 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 41384 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41388 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41392 */     // MIs[18] Operand 1
     /* 41392 */     // No operand predicates
     /* 41392 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 41394 */     // (shl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$wt, (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>)))  =>  (SLL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 41394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_B),
     /* 41397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 41399 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 41401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 41405 */     GIR_RootConstrainSelectedInstOperands,
     /* 41406 */     // GIR_Coverage, 2073,
     /* 41406 */     GIR_EraseRootFromParent_Done,
     /* 41407 */   // Label 1086: @41407
     /* 41407 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(41430), // Rule ID 957 //
     /* 41412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 41415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 41419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 41423 */     // (shl:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SLL_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 41423 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_B),
     /* 41428 */     GIR_RootConstrainSelectedInstOperands,
     /* 41429 */     // GIR_Coverage, 957,
     /* 41429 */     GIR_Done,
     /* 41430 */   // Label 1087: @41430
     /* 41430 */   GIM_Reject,
     /* 41431 */ // Label 1084: @41431
     /* 41431 */ GIM_Reject,
     /* 41432 */ // Label 1062: @41432
     /* 41432 */ GIM_Reject,
     /* 41433 */ // Label 38: @41433
     /* 41433 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1094*/ GIMT_Encode4(43229),
     /* 41444 */ /*GILLT_s32*//*Label 1088*/ GIMT_Encode4(41476),
     /* 41448 */ /*GILLT_s64*//*Label 1089*/ GIMT_Encode4(41738), GIMT_Encode4(0),
     /* 41456 */ /*GILLT_v2s64*//*Label 1090*/ GIMT_Encode4(41879), GIMT_Encode4(0),
     /* 41464 */ /*GILLT_v4s32*//*Label 1091*/ GIMT_Encode4(41913),
     /* 41468 */ /*GILLT_v8s16*//*Label 1092*/ GIMT_Encode4(42181),
     /* 41472 */ /*GILLT_v16s8*//*Label 1093*/ GIMT_Encode4(42577),
     /* 41476 */ // Label 1088: @41476
     /* 41476 */ GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(41737),
     /* 41481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 41484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 41487 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(41529), // Rule ID 57 //
     /* 41492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 41495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 41515 */     // MIs[1] Operand 1
     /* 41515 */     // No operand predicates
     /* 41515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41517 */     // (srl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (SRL:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 41517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL),
     /* 41520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 41524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 41527 */     GIR_RootConstrainSelectedInstOperands,
     /* 41528 */     // GIR_Coverage, 57,
     /* 41528 */     GIR_EraseRootFromParent_Done,
     /* 41529 */   // Label 1096: @41529
     /* 41529 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(41571), // Rule ID 1836 //
     /* 41534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 41537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 41557 */     // MIs[1] Operand 1
     /* 41557 */     // No operand predicates
     /* 41557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41559 */     // (srl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SrlX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 41559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SrlX16),
     /* 41562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 41564 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 41566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 41569 */     GIR_RootConstrainSelectedInstOperands,
     /* 41570 */     // GIR_Coverage, 1836,
     /* 41570 */     GIR_EraseRootFromParent_Done,
     /* 41571 */   // Label 1097: @41571
     /* 41571 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(41613), // Rule ID 2177 //
     /* 41576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 41579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 41583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 41587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Shift),
     /* 41599 */     // MIs[1] Operand 1
     /* 41599 */     // No operand predicates
     /* 41599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41601 */     // (srl:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)  =>  (SRL16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)
     /* 41601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL16_MM),
     /* 41604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41606 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 41608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 41611 */     GIR_RootConstrainSelectedInstOperands,
     /* 41612 */     // GIR_Coverage, 2177,
     /* 41612 */     GIR_EraseRootFromParent_Done,
     /* 41613 */   // Label 1098: @41613
     /* 41613 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(41655), // Rule ID 2178 //
     /* 41618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 41621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 41641 */     // MIs[1] Operand 1
     /* 41641 */     // No operand predicates
     /* 41641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41643 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SRL_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 41643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_MM),
     /* 41646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 41650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 41653 */     GIR_RootConstrainSelectedInstOperands,
     /* 41654 */     // GIR_Coverage, 2178,
     /* 41654 */     GIR_EraseRootFromParent_Done,
     /* 41655 */   // Label 1099: @41655
     /* 41655 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(41682), // Rule ID 63 //
     /* 41660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 41663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41675 */     // (srl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SRLV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 41675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRLV),
     /* 41680 */     GIR_RootConstrainSelectedInstOperands,
     /* 41681 */     // GIR_Coverage, 63,
     /* 41681 */     GIR_Done,
     /* 41682 */   // Label 1100: @41682
     /* 41682 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(41709), // Rule ID 1840 //
     /* 41687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 41690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41702 */     // (srl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)  =>  (SrlvRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)
     /* 41702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SrlvRxRy16),
     /* 41707 */     GIR_RootConstrainSelectedInstOperands,
     /* 41708 */     // GIR_Coverage, 1840,
     /* 41708 */     GIR_Done,
     /* 41709 */   // Label 1101: @41709
     /* 41709 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(41736), // Rule ID 2179 //
     /* 41714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 41717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41729 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)  =>  (SRLV_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)
     /* 41729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRLV_MM),
     /* 41734 */     GIR_RootConstrainSelectedInstOperands,
     /* 41735 */     // GIR_Coverage, 2179,
     /* 41735 */     GIR_Done,
     /* 41736 */   // Label 1102: @41736
     /* 41736 */   GIM_Reject,
     /* 41737 */ // Label 1095: @41737
     /* 41737 */ GIM_Reject,
     /* 41738 */ // Label 1089: @41738
     /* 41738 */ GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(41878),
     /* 41743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 41746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 41749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41757 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(41791), // Rule ID 212 //
     /* 41762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 41765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 41777 */     // MIs[1] Operand 1
     /* 41777 */     // No operand predicates
     /* 41777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41779 */     // (srl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DSRL:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 41779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRL),
     /* 41782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 41786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 41789 */     GIR_RootConstrainSelectedInstOperands,
     /* 41790 */     // GIR_Coverage, 212,
     /* 41790 */     GIR_EraseRootFromParent_Done,
     /* 41791 */   // Label 1104: @41791
     /* 41791 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(41858), // Rule ID 1577 //
     /* 41796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 41799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 41807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 41811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41818 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DSRLV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 41818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 41821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 41825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41830 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 41836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 41841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRLV),
     /* 41849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 41853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41856 */     GIR_RootConstrainSelectedInstOperands,
     /* 41857 */     // GIR_Coverage, 1577,
     /* 41857 */     GIR_EraseRootFromParent_Done,
     /* 41858 */   // Label 1105: @41858
     /* 41858 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(41877), // Rule ID 220 //
     /* 41863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 41866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41870 */     // (srl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DSRLV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 41870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSRLV),
     /* 41875 */     GIR_RootConstrainSelectedInstOperands,
     /* 41876 */     // GIR_Coverage, 220,
     /* 41876 */     GIR_Done,
     /* 41877 */   // Label 1106: @41877
     /* 41877 */   GIM_Reject,
     /* 41878 */ // Label 1103: @41878
     /* 41878 */ GIM_Reject,
     /* 41879 */ // Label 1090: @41879
     /* 41879 */ GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(41912), // Rule ID 992 //
     /* 41884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 41887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 41890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 41893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 41897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 41901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 41905 */   // (srl:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRL_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 41905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_D),
     /* 41910 */   GIR_RootConstrainSelectedInstOperands,
     /* 41911 */   // GIR_Coverage, 992,
     /* 41911 */   GIR_Done,
     /* 41912 */ // Label 1107: @41912
     /* 41912 */ GIM_Reject,
     /* 41913 */ // Label 1091: @41913
     /* 41913 */ GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(42180),
     /* 41918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 41921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 41924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 41928 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(42042), // Rule ID 2482 //
     /* 41933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 41936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 41944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 41948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 41952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 41956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 41960 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 41963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 41967 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 41971 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 41975 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 41979 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 41983 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41987 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 41991 */     // MIs[3] Operand 1
     /* 41991 */     // No operand predicates
     /* 41991 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 41995 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41999 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42003 */     // MIs[4] Operand 1
     /* 42003 */     // No operand predicates
     /* 42003 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42007 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42011 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42015 */     // MIs[5] Operand 1
     /* 42015 */     // No operand predicates
     /* 42015 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42019 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42023 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42027 */     // MIs[6] Operand 1
     /* 42027 */     // No operand predicates
     /* 42027 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 42029 */     // (srl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>), v4i32:{ *:[v4i32] }:$wt))  =>  (SRL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 42029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_W),
     /* 42032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42034 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 42040 */     GIR_RootConstrainSelectedInstOperands,
     /* 42041 */     // GIR_Coverage, 2482,
     /* 42041 */     GIR_EraseRootFromParent_Done,
     /* 42042 */   // Label 1109: @42042
     /* 42042 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(42156), // Rule ID 2083 //
     /* 42047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 42062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 42066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 42070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42074 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 42077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42085 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42089 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42101 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42105 */     // MIs[3] Operand 1
     /* 42105 */     // No operand predicates
     /* 42105 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42109 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42113 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42117 */     // MIs[4] Operand 1
     /* 42117 */     // No operand predicates
     /* 42117 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42121 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42125 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42129 */     // MIs[5] Operand 1
     /* 42129 */     // No operand predicates
     /* 42129 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42133 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42137 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42141 */     // MIs[6] Operand 1
     /* 42141 */     // No operand predicates
     /* 42141 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 42143 */     // (srl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$wt, (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>)))  =>  (SRL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 42143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_W),
     /* 42146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42148 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 42154 */     GIR_RootConstrainSelectedInstOperands,
     /* 42155 */     // GIR_Coverage, 2083,
     /* 42155 */     GIR_EraseRootFromParent_Done,
     /* 42156 */   // Label 1110: @42156
     /* 42156 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(42179), // Rule ID 991 //
     /* 42161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 42164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 42168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 42172 */     // (srl:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRL_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 42172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_W),
     /* 42177 */     GIR_RootConstrainSelectedInstOperands,
     /* 42178 */     // GIR_Coverage, 991,
     /* 42178 */     GIR_Done,
     /* 42179 */   // Label 1111: @42179
     /* 42179 */   GIM_Reject,
     /* 42180 */ // Label 1108: @42180
     /* 42180 */ GIM_Reject,
     /* 42181 */ // Label 1092: @42181
     /* 42181 */ GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(42576),
     /* 42186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 42192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 42196 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(42374), // Rule ID 2481 //
     /* 42201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 42220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 42224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42228 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 42231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42235 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42239 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42243 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42247 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42251 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42255 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42259 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42271 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42275 */     // MIs[3] Operand 1
     /* 42275 */     // No operand predicates
     /* 42275 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42279 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42283 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42287 */     // MIs[4] Operand 1
     /* 42287 */     // No operand predicates
     /* 42287 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42291 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42295 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42299 */     // MIs[5] Operand 1
     /* 42299 */     // No operand predicates
     /* 42299 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42303 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42307 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42311 */     // MIs[6] Operand 1
     /* 42311 */     // No operand predicates
     /* 42311 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 42315 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42319 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42323 */     // MIs[7] Operand 1
     /* 42323 */     // No operand predicates
     /* 42323 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 42327 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42331 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42335 */     // MIs[8] Operand 1
     /* 42335 */     // No operand predicates
     /* 42335 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 42339 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42343 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42347 */     // MIs[9] Operand 1
     /* 42347 */     // No operand predicates
     /* 42347 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 42351 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42355 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42359 */     // MIs[10] Operand 1
     /* 42359 */     // No operand predicates
     /* 42359 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 42361 */     // (srl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>), v8i16:{ *:[v8i16] }:$wt))  =>  (SRL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 42361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_H),
     /* 42364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42366 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 42372 */     GIR_RootConstrainSelectedInstOperands,
     /* 42373 */     // GIR_Coverage, 2481,
     /* 42373 */     GIR_EraseRootFromParent_Done,
     /* 42374 */   // Label 1113: @42374
     /* 42374 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(42552), // Rule ID 2082 //
     /* 42379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 42398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 42402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42406 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 42409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42417 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42421 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42425 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42429 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42433 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42437 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42449 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42453 */     // MIs[3] Operand 1
     /* 42453 */     // No operand predicates
     /* 42453 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42457 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42461 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42465 */     // MIs[4] Operand 1
     /* 42465 */     // No operand predicates
     /* 42465 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42469 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42473 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42477 */     // MIs[5] Operand 1
     /* 42477 */     // No operand predicates
     /* 42477 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42481 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42485 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42489 */     // MIs[6] Operand 1
     /* 42489 */     // No operand predicates
     /* 42489 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 42493 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42497 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42501 */     // MIs[7] Operand 1
     /* 42501 */     // No operand predicates
     /* 42501 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 42505 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42509 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42513 */     // MIs[8] Operand 1
     /* 42513 */     // No operand predicates
     /* 42513 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 42517 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42521 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42525 */     // MIs[9] Operand 1
     /* 42525 */     // No operand predicates
     /* 42525 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 42529 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42533 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42537 */     // MIs[10] Operand 1
     /* 42537 */     // No operand predicates
     /* 42537 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 42539 */     // (srl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$wt, (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>)))  =>  (SRL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 42539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_H),
     /* 42542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42544 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 42550 */     GIR_RootConstrainSelectedInstOperands,
     /* 42551 */     // GIR_Coverage, 2082,
     /* 42551 */     GIR_EraseRootFromParent_Done,
     /* 42552 */   // Label 1114: @42552
     /* 42552 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(42575), // Rule ID 990 //
     /* 42557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 42560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 42564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 42568 */     // (srl:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRL_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 42568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_H),
     /* 42573 */     GIR_RootConstrainSelectedInstOperands,
     /* 42574 */     // GIR_Coverage, 990,
     /* 42574 */     GIR_Done,
     /* 42575 */   // Label 1115: @42575
     /* 42575 */   GIM_Reject,
     /* 42576 */ // Label 1112: @42576
     /* 42576 */ GIM_Reject,
     /* 42577 */ // Label 1093: @42577
     /* 42577 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(43228),
     /* 42582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 42588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 42592 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(42898), // Rule ID 2480 //
     /* 42597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 42616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 42620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42624 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 42627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42635 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42639 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42643 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42647 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42651 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42655 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42659 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 42663 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 42667 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 42671 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 42675 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 42679 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 42683 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 42687 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 42691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42699 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42703 */     // MIs[3] Operand 1
     /* 42703 */     // No operand predicates
     /* 42703 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42707 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42711 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42715 */     // MIs[4] Operand 1
     /* 42715 */     // No operand predicates
     /* 42715 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42719 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42723 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42727 */     // MIs[5] Operand 1
     /* 42727 */     // No operand predicates
     /* 42727 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42731 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42735 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42739 */     // MIs[6] Operand 1
     /* 42739 */     // No operand predicates
     /* 42739 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 42743 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42747 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42751 */     // MIs[7] Operand 1
     /* 42751 */     // No operand predicates
     /* 42751 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 42755 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42759 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42763 */     // MIs[8] Operand 1
     /* 42763 */     // No operand predicates
     /* 42763 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 42767 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42771 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42775 */     // MIs[9] Operand 1
     /* 42775 */     // No operand predicates
     /* 42775 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 42779 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42783 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42787 */     // MIs[10] Operand 1
     /* 42787 */     // No operand predicates
     /* 42787 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 42791 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42795 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42799 */     // MIs[11] Operand 1
     /* 42799 */     // No operand predicates
     /* 42799 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 42803 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42807 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42811 */     // MIs[12] Operand 1
     /* 42811 */     // No operand predicates
     /* 42811 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 42815 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42819 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42823 */     // MIs[13] Operand 1
     /* 42823 */     // No operand predicates
     /* 42823 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 42827 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42831 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42835 */     // MIs[14] Operand 1
     /* 42835 */     // No operand predicates
     /* 42835 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 42839 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42843 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42847 */     // MIs[15] Operand 1
     /* 42847 */     // No operand predicates
     /* 42847 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 42851 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42855 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42859 */     // MIs[16] Operand 1
     /* 42859 */     // No operand predicates
     /* 42859 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 42863 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42867 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42871 */     // MIs[17] Operand 1
     /* 42871 */     // No operand predicates
     /* 42871 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 42875 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42879 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42883 */     // MIs[18] Operand 1
     /* 42883 */     // No operand predicates
     /* 42883 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 42885 */     // (srl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>), v16i8:{ *:[v16i8] }:$wt))  =>  (SRL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 42885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_B),
     /* 42888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42890 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 42896 */     GIR_RootConstrainSelectedInstOperands,
     /* 42897 */     // GIR_Coverage, 2480,
     /* 42897 */     GIR_EraseRootFromParent_Done,
     /* 42898 */   // Label 1117: @42898
     /* 42898 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(43204), // Rule ID 2081 //
     /* 42903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 42922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 42926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42930 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 42933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42941 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42945 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42949 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42953 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42957 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42961 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42965 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 42969 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 42973 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 42977 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 42981 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 42985 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 42989 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 42993 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 42997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 43001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43005 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43009 */     // MIs[3] Operand 1
     /* 43009 */     // No operand predicates
     /* 43009 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 43013 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43017 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43021 */     // MIs[4] Operand 1
     /* 43021 */     // No operand predicates
     /* 43021 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 43025 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43029 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43033 */     // MIs[5] Operand 1
     /* 43033 */     // No operand predicates
     /* 43033 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 43037 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43041 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43045 */     // MIs[6] Operand 1
     /* 43045 */     // No operand predicates
     /* 43045 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 43049 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43053 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43057 */     // MIs[7] Operand 1
     /* 43057 */     // No operand predicates
     /* 43057 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 43061 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43065 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43069 */     // MIs[8] Operand 1
     /* 43069 */     // No operand predicates
     /* 43069 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 43073 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43077 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43081 */     // MIs[9] Operand 1
     /* 43081 */     // No operand predicates
     /* 43081 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 43085 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43089 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43093 */     // MIs[10] Operand 1
     /* 43093 */     // No operand predicates
     /* 43093 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 43097 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43101 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43105 */     // MIs[11] Operand 1
     /* 43105 */     // No operand predicates
     /* 43105 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 43109 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43113 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43117 */     // MIs[12] Operand 1
     /* 43117 */     // No operand predicates
     /* 43117 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 43121 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43125 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43129 */     // MIs[13] Operand 1
     /* 43129 */     // No operand predicates
     /* 43129 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 43133 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43137 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43141 */     // MIs[14] Operand 1
     /* 43141 */     // No operand predicates
     /* 43141 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 43145 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43149 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43153 */     // MIs[15] Operand 1
     /* 43153 */     // No operand predicates
     /* 43153 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 43157 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43161 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43165 */     // MIs[16] Operand 1
     /* 43165 */     // No operand predicates
     /* 43165 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 43169 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43173 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43177 */     // MIs[17] Operand 1
     /* 43177 */     // No operand predicates
     /* 43177 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 43181 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43185 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43189 */     // MIs[18] Operand 1
     /* 43189 */     // No operand predicates
     /* 43189 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 43191 */     // (srl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$wt, (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>)))  =>  (SRL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 43191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_B),
     /* 43194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 43196 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 43198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 43202 */     GIR_RootConstrainSelectedInstOperands,
     /* 43203 */     // GIR_Coverage, 2081,
     /* 43203 */     GIR_EraseRootFromParent_Done,
     /* 43204 */   // Label 1118: @43204
     /* 43204 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(43227), // Rule ID 989 //
     /* 43209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 43212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 43216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 43220 */     // (srl:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRL_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 43220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_B),
     /* 43225 */     GIR_RootConstrainSelectedInstOperands,
     /* 43226 */     // GIR_Coverage, 989,
     /* 43226 */     GIR_Done,
     /* 43227 */   // Label 1119: @43227
     /* 43227 */   GIM_Reject,
     /* 43228 */ // Label 1116: @43228
     /* 43228 */ GIM_Reject,
     /* 43229 */ // Label 1094: @43229
     /* 43229 */ GIM_Reject,
     /* 43230 */ // Label 39: @43230
     /* 43230 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1126*/ GIMT_Encode4(44984),
     /* 43241 */ /*GILLT_s32*//*Label 1120*/ GIMT_Encode4(43273),
     /* 43245 */ /*GILLT_s64*//*Label 1121*/ GIMT_Encode4(43493), GIMT_Encode4(0),
     /* 43253 */ /*GILLT_v2s64*//*Label 1122*/ GIMT_Encode4(43634), GIMT_Encode4(0),
     /* 43261 */ /*GILLT_v4s32*//*Label 1123*/ GIMT_Encode4(43668),
     /* 43265 */ /*GILLT_v8s16*//*Label 1124*/ GIMT_Encode4(43936),
     /* 43269 */ /*GILLT_v16s8*//*Label 1125*/ GIMT_Encode4(44332),
     /* 43273 */ // Label 1120: @43273
     /* 43273 */ GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(43492),
     /* 43278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 43281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 43284 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(43326), // Rule ID 59 //
     /* 43289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 43292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 43312 */     // MIs[1] Operand 1
     /* 43312 */     // No operand predicates
     /* 43312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43314 */     // (sra:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (SRA:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 43314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA),
     /* 43317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 43321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 43324 */     GIR_RootConstrainSelectedInstOperands,
     /* 43325 */     // GIR_Coverage, 59,
     /* 43325 */     GIR_EraseRootFromParent_Done,
     /* 43326 */   // Label 1128: @43326
     /* 43326 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(43368), // Rule ID 1837 //
     /* 43331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 43334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 43354 */     // MIs[1] Operand 1
     /* 43354 */     // No operand predicates
     /* 43354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43356 */     // (sra:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SraX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 43356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SraX16),
     /* 43359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 43361 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 43363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 43366 */     GIR_RootConstrainSelectedInstOperands,
     /* 43367 */     // GIR_Coverage, 1837,
     /* 43367 */     GIR_EraseRootFromParent_Done,
     /* 43368 */   // Label 1129: @43368
     /* 43368 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(43410), // Rule ID 2180 //
     /* 43373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 43376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 43396 */     // MIs[1] Operand 1
     /* 43396 */     // No operand predicates
     /* 43396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43398 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SRA_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 43398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_MM),
     /* 43401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43403 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 43405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 43408 */     GIR_RootConstrainSelectedInstOperands,
     /* 43409 */     // GIR_Coverage, 2180,
     /* 43409 */     GIR_EraseRootFromParent_Done,
     /* 43410 */   // Label 1130: @43410
     /* 43410 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(43437), // Rule ID 65 //
     /* 43415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 43418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43430 */     // (sra:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SRAV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 43430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRAV),
     /* 43435 */     GIR_RootConstrainSelectedInstOperands,
     /* 43436 */     // GIR_Coverage, 65,
     /* 43436 */     GIR_Done,
     /* 43437 */   // Label 1131: @43437
     /* 43437 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(43464), // Rule ID 1839 //
     /* 43442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 43445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43457 */     // (sra:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)  =>  (SravRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)
     /* 43457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SravRxRy16),
     /* 43462 */     GIR_RootConstrainSelectedInstOperands,
     /* 43463 */     // GIR_Coverage, 1839,
     /* 43463 */     GIR_Done,
     /* 43464 */   // Label 1132: @43464
     /* 43464 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(43491), // Rule ID 2181 //
     /* 43469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 43472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43484 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)  =>  (SRAV_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)
     /* 43484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRAV_MM),
     /* 43489 */     GIR_RootConstrainSelectedInstOperands,
     /* 43490 */     // GIR_Coverage, 2181,
     /* 43490 */     GIR_Done,
     /* 43491 */   // Label 1133: @43491
     /* 43491 */   GIM_Reject,
     /* 43492 */ // Label 1127: @43492
     /* 43492 */ GIM_Reject,
     /* 43493 */ // Label 1121: @43493
     /* 43493 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(43633),
     /* 43498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 43501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 43504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43512 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(43546), // Rule ID 214 //
     /* 43517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 43520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 43532 */     // MIs[1] Operand 1
     /* 43532 */     // No operand predicates
     /* 43532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43534 */     // (sra:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DSRA:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 43534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRA),
     /* 43537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 43541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 43544 */     GIR_RootConstrainSelectedInstOperands,
     /* 43545 */     // GIR_Coverage, 214,
     /* 43545 */     GIR_EraseRootFromParent_Done,
     /* 43546 */   // Label 1135: @43546
     /* 43546 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(43613), // Rule ID 1578 //
     /* 43551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 43554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 43562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 43566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43573 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DSRAV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 43573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 43576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43585 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 43591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 43596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRAV),
     /* 43604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 43608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 43611 */     GIR_RootConstrainSelectedInstOperands,
     /* 43612 */     // GIR_Coverage, 1578,
     /* 43612 */     GIR_EraseRootFromParent_Done,
     /* 43613 */   // Label 1136: @43613
     /* 43613 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(43632), // Rule ID 218 //
     /* 43618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 43621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43625 */     // (sra:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DSRAV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 43625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSRAV),
     /* 43630 */     GIR_RootConstrainSelectedInstOperands,
     /* 43631 */     // GIR_Coverage, 218,
     /* 43631 */     GIR_Done,
     /* 43632 */   // Label 1137: @43632
     /* 43632 */   GIM_Reject,
     /* 43633 */ // Label 1134: @43633
     /* 43633 */ GIM_Reject,
     /* 43634 */ // Label 1122: @43634
     /* 43634 */ GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(43667), // Rule ID 976 //
     /* 43639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 43642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 43645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 43648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 43652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 43656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 43660 */   // (sra:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRA_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 43660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_D),
     /* 43665 */   GIR_RootConstrainSelectedInstOperands,
     /* 43666 */   // GIR_Coverage, 976,
     /* 43666 */   GIR_Done,
     /* 43667 */ // Label 1138: @43667
     /* 43667 */ GIM_Reject,
     /* 43668 */ // Label 1123: @43668
     /* 43668 */ GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(43935),
     /* 43673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 43676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 43679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 43683 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(43797), // Rule ID 2486 //
     /* 43688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 43691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 43699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 43703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 43707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 43711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 43715 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 43718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 43722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 43726 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 43730 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 43734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 43738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43742 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43746 */     // MIs[3] Operand 1
     /* 43746 */     // No operand predicates
     /* 43746 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 43750 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43754 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43758 */     // MIs[4] Operand 1
     /* 43758 */     // No operand predicates
     /* 43758 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 43762 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43766 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43770 */     // MIs[5] Operand 1
     /* 43770 */     // No operand predicates
     /* 43770 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 43774 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43778 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43782 */     // MIs[6] Operand 1
     /* 43782 */     // No operand predicates
     /* 43782 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 43784 */     // (sra:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>), v4i32:{ *:[v4i32] }:$wt))  =>  (SRA_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 43784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_W),
     /* 43787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 43789 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 43791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 43795 */     GIR_RootConstrainSelectedInstOperands,
     /* 43796 */     // GIR_Coverage, 2486,
     /* 43796 */     GIR_EraseRootFromParent_Done,
     /* 43797 */   // Label 1140: @43797
     /* 43797 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(43911), // Rule ID 2087 //
     /* 43802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 43805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 43813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 43817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 43821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 43825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 43829 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 43832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 43836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 43840 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 43844 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 43848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 43852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43856 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43860 */     // MIs[3] Operand 1
     /* 43860 */     // No operand predicates
     /* 43860 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 43864 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43868 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43872 */     // MIs[4] Operand 1
     /* 43872 */     // No operand predicates
     /* 43872 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 43876 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43880 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43884 */     // MIs[5] Operand 1
     /* 43884 */     // No operand predicates
     /* 43884 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 43888 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43892 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43896 */     // MIs[6] Operand 1
     /* 43896 */     // No operand predicates
     /* 43896 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 43898 */     // (sra:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$wt, (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>)))  =>  (SRA_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 43898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_W),
     /* 43901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 43903 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 43905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 43909 */     GIR_RootConstrainSelectedInstOperands,
     /* 43910 */     // GIR_Coverage, 2087,
     /* 43910 */     GIR_EraseRootFromParent_Done,
     /* 43911 */   // Label 1141: @43911
     /* 43911 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(43934), // Rule ID 975 //
     /* 43916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 43919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 43923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 43927 */     // (sra:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRA_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 43927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_W),
     /* 43932 */     GIR_RootConstrainSelectedInstOperands,
     /* 43933 */     // GIR_Coverage, 975,
     /* 43933 */     GIR_Done,
     /* 43934 */   // Label 1142: @43934
     /* 43934 */   GIM_Reject,
     /* 43935 */ // Label 1139: @43935
     /* 43935 */ GIM_Reject,
     /* 43936 */ // Label 1124: @43936
     /* 43936 */ GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(44331),
     /* 43941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 43944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 43947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 43951 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(44129), // Rule ID 2485 //
     /* 43956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 43959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 43967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 43971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 43975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 43979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 43983 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 43986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 43990 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 43994 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 43998 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 44002 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 44006 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 44010 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 44014 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 44018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44026 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44030 */     // MIs[3] Operand 1
     /* 44030 */     // No operand predicates
     /* 44030 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44034 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44038 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44042 */     // MIs[4] Operand 1
     /* 44042 */     // No operand predicates
     /* 44042 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44046 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44050 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44054 */     // MIs[5] Operand 1
     /* 44054 */     // No operand predicates
     /* 44054 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44058 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44062 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44066 */     // MIs[6] Operand 1
     /* 44066 */     // No operand predicates
     /* 44066 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44070 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44074 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44078 */     // MIs[7] Operand 1
     /* 44078 */     // No operand predicates
     /* 44078 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44082 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44086 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44090 */     // MIs[8] Operand 1
     /* 44090 */     // No operand predicates
     /* 44090 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44094 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44098 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44102 */     // MIs[9] Operand 1
     /* 44102 */     // No operand predicates
     /* 44102 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44106 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44110 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44114 */     // MIs[10] Operand 1
     /* 44114 */     // No operand predicates
     /* 44114 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 44116 */     // (sra:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>), v8i16:{ *:[v8i16] }:$wt))  =>  (SRA_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 44116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_H),
     /* 44119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44121 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 44127 */     GIR_RootConstrainSelectedInstOperands,
     /* 44128 */     // GIR_Coverage, 2485,
     /* 44128 */     GIR_EraseRootFromParent_Done,
     /* 44129 */   // Label 1144: @44129
     /* 44129 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(44307), // Rule ID 2086 //
     /* 44134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 44137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 44145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 44149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 44153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 44157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 44161 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 44164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 44168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 44172 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 44176 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 44180 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 44184 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 44188 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 44192 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 44196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44204 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44208 */     // MIs[3] Operand 1
     /* 44208 */     // No operand predicates
     /* 44208 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44212 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44216 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44220 */     // MIs[4] Operand 1
     /* 44220 */     // No operand predicates
     /* 44220 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44224 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44228 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44232 */     // MIs[5] Operand 1
     /* 44232 */     // No operand predicates
     /* 44232 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44236 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44240 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44244 */     // MIs[6] Operand 1
     /* 44244 */     // No operand predicates
     /* 44244 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44248 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44252 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44256 */     // MIs[7] Operand 1
     /* 44256 */     // No operand predicates
     /* 44256 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44260 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44264 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44268 */     // MIs[8] Operand 1
     /* 44268 */     // No operand predicates
     /* 44268 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44272 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44276 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44280 */     // MIs[9] Operand 1
     /* 44280 */     // No operand predicates
     /* 44280 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44284 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44288 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44292 */     // MIs[10] Operand 1
     /* 44292 */     // No operand predicates
     /* 44292 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 44294 */     // (sra:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$wt, (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>)))  =>  (SRA_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 44294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_H),
     /* 44297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44299 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 44305 */     GIR_RootConstrainSelectedInstOperands,
     /* 44306 */     // GIR_Coverage, 2086,
     /* 44306 */     GIR_EraseRootFromParent_Done,
     /* 44307 */   // Label 1145: @44307
     /* 44307 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(44330), // Rule ID 974 //
     /* 44312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 44315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 44319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 44323 */     // (sra:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRA_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 44323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_H),
     /* 44328 */     GIR_RootConstrainSelectedInstOperands,
     /* 44329 */     // GIR_Coverage, 974,
     /* 44329 */     GIR_Done,
     /* 44330 */   // Label 1146: @44330
     /* 44330 */   GIM_Reject,
     /* 44331 */ // Label 1143: @44331
     /* 44331 */ GIM_Reject,
     /* 44332 */ // Label 1125: @44332
     /* 44332 */ GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(44983),
     /* 44337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 44340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 44343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 44347 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(44653), // Rule ID 2484 //
     /* 44352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 44355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 44363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 44367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 44371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 44375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 44379 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 44382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 44386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 44390 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 44394 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 44398 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 44402 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 44406 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 44410 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 44414 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 44418 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 44422 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 44426 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 44430 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 44434 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 44438 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 44442 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 44446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44454 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44458 */     // MIs[3] Operand 1
     /* 44458 */     // No operand predicates
     /* 44458 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44462 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44466 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44470 */     // MIs[4] Operand 1
     /* 44470 */     // No operand predicates
     /* 44470 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44474 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44478 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44482 */     // MIs[5] Operand 1
     /* 44482 */     // No operand predicates
     /* 44482 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44486 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44490 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44494 */     // MIs[6] Operand 1
     /* 44494 */     // No operand predicates
     /* 44494 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44498 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44502 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44506 */     // MIs[7] Operand 1
     /* 44506 */     // No operand predicates
     /* 44506 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44510 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44514 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44518 */     // MIs[8] Operand 1
     /* 44518 */     // No operand predicates
     /* 44518 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44522 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44526 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44530 */     // MIs[9] Operand 1
     /* 44530 */     // No operand predicates
     /* 44530 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44534 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44538 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44542 */     // MIs[10] Operand 1
     /* 44542 */     // No operand predicates
     /* 44542 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 44546 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44550 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44554 */     // MIs[11] Operand 1
     /* 44554 */     // No operand predicates
     /* 44554 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 44558 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44562 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44566 */     // MIs[12] Operand 1
     /* 44566 */     // No operand predicates
     /* 44566 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 44570 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44574 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44578 */     // MIs[13] Operand 1
     /* 44578 */     // No operand predicates
     /* 44578 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 44582 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44586 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44590 */     // MIs[14] Operand 1
     /* 44590 */     // No operand predicates
     /* 44590 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 44594 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44598 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44602 */     // MIs[15] Operand 1
     /* 44602 */     // No operand predicates
     /* 44602 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 44606 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44610 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44614 */     // MIs[16] Operand 1
     /* 44614 */     // No operand predicates
     /* 44614 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 44618 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44622 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44626 */     // MIs[17] Operand 1
     /* 44626 */     // No operand predicates
     /* 44626 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 44630 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44634 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44638 */     // MIs[18] Operand 1
     /* 44638 */     // No operand predicates
     /* 44638 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 44640 */     // (sra:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>), v16i8:{ *:[v16i8] }:$wt))  =>  (SRA_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 44640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_B),
     /* 44643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44645 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 44651 */     GIR_RootConstrainSelectedInstOperands,
     /* 44652 */     // GIR_Coverage, 2484,
     /* 44652 */     GIR_EraseRootFromParent_Done,
     /* 44653 */   // Label 1148: @44653
     /* 44653 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(44959), // Rule ID 2085 //
     /* 44658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 44661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 44669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 44673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 44677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 44681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 44685 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 44688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 44692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 44696 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 44700 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 44704 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 44708 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 44712 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 44716 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 44720 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 44724 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 44728 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 44732 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 44736 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 44740 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 44744 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 44748 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 44752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44760 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44764 */     // MIs[3] Operand 1
     /* 44764 */     // No operand predicates
     /* 44764 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44768 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44772 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44776 */     // MIs[4] Operand 1
     /* 44776 */     // No operand predicates
     /* 44776 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44780 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44784 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44788 */     // MIs[5] Operand 1
     /* 44788 */     // No operand predicates
     /* 44788 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44792 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44796 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44800 */     // MIs[6] Operand 1
     /* 44800 */     // No operand predicates
     /* 44800 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44804 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44808 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44812 */     // MIs[7] Operand 1
     /* 44812 */     // No operand predicates
     /* 44812 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44816 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44820 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44824 */     // MIs[8] Operand 1
     /* 44824 */     // No operand predicates
     /* 44824 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44828 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44832 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44836 */     // MIs[9] Operand 1
     /* 44836 */     // No operand predicates
     /* 44836 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44840 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44844 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44848 */     // MIs[10] Operand 1
     /* 44848 */     // No operand predicates
     /* 44848 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 44852 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44856 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44860 */     // MIs[11] Operand 1
     /* 44860 */     // No operand predicates
     /* 44860 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 44864 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44868 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44872 */     // MIs[12] Operand 1
     /* 44872 */     // No operand predicates
     /* 44872 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 44876 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44880 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44884 */     // MIs[13] Operand 1
     /* 44884 */     // No operand predicates
     /* 44884 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 44888 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44892 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44896 */     // MIs[14] Operand 1
     /* 44896 */     // No operand predicates
     /* 44896 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 44900 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44904 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44908 */     // MIs[15] Operand 1
     /* 44908 */     // No operand predicates
     /* 44908 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 44912 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44916 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44920 */     // MIs[16] Operand 1
     /* 44920 */     // No operand predicates
     /* 44920 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 44924 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44928 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44932 */     // MIs[17] Operand 1
     /* 44932 */     // No operand predicates
     /* 44932 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 44936 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44940 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44944 */     // MIs[18] Operand 1
     /* 44944 */     // No operand predicates
     /* 44944 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 44946 */     // (sra:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$wt, (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>)))  =>  (SRA_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 44946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_B),
     /* 44949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44951 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 44957 */     GIR_RootConstrainSelectedInstOperands,
     /* 44958 */     // GIR_Coverage, 2085,
     /* 44958 */     GIR_EraseRootFromParent_Done,
     /* 44959 */   // Label 1149: @44959
     /* 44959 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(44982), // Rule ID 973 //
     /* 44964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 44967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 44971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 44975 */     // (sra:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRA_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 44975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_B),
     /* 44980 */     GIR_RootConstrainSelectedInstOperands,
     /* 44981 */     // GIR_Coverage, 973,
     /* 44981 */     GIR_Done,
     /* 44982 */   // Label 1150: @44982
     /* 44982 */   GIM_Reject,
     /* 44983 */ // Label 1147: @44983
     /* 44983 */ GIM_Reject,
     /* 44984 */ // Label 1126: @44984
     /* 44984 */ GIM_Reject,
     /* 44985 */ // Label 40: @44985
     /* 44985 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1153*/ GIMT_Encode4(45272),
     /* 44996 */ /*GILLT_s32*//*Label 1151*/ GIMT_Encode4(45004),
     /* 45000 */ /*GILLT_s64*//*Label 1152*/ GIMT_Encode4(45131),
     /* 45004 */ // Label 1151: @45004
     /* 45004 */ GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(45130),
     /* 45009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 45012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 45015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45023 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(45057), // Rule ID 67 //
     /* 45028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 45031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 45043 */     // MIs[1] Operand 1
     /* 45043 */     // No operand predicates
     /* 45043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45045 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (ROTR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 45045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR),
     /* 45048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 45055 */     GIR_RootConstrainSelectedInstOperands,
     /* 45056 */     // GIR_Coverage, 67,
     /* 45056 */     GIR_EraseRootFromParent_Done,
     /* 45057 */   // Label 1155: @45057
     /* 45057 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(45091), // Rule ID 1081 //
     /* 45062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 45077 */     // MIs[1] Operand 1
     /* 45077 */     // No operand predicates
     /* 45077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45079 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (ROTR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 45079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR_MM),
     /* 45082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 45089 */     GIR_RootConstrainSelectedInstOperands,
     /* 45090 */     // GIR_Coverage, 1081,
     /* 45090 */     GIR_EraseRootFromParent_Done,
     /* 45091 */   // Label 1156: @45091
     /* 45091 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(45110), // Rule ID 68 //
     /* 45096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 45099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45103 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (ROTRV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 45103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ROTRV),
     /* 45108 */     GIR_RootConstrainSelectedInstOperands,
     /* 45109 */     // GIR_Coverage, 68,
     /* 45109 */     GIR_Done,
     /* 45110 */   // Label 1157: @45110
     /* 45110 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(45129), // Rule ID 1082 //
     /* 45115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45122 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (ROTRV_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 45122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ROTRV_MM),
     /* 45127 */     GIR_RootConstrainSelectedInstOperands,
     /* 45128 */     // GIR_Coverage, 1082,
     /* 45128 */     GIR_Done,
     /* 45129 */   // Label 1158: @45129
     /* 45129 */   GIM_Reject,
     /* 45130 */ // Label 1154: @45130
     /* 45130 */ GIM_Reject,
     /* 45131 */ // Label 1152: @45131
     /* 45131 */ GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(45271),
     /* 45136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 45139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 45142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45150 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(45184), // Rule ID 222 //
     /* 45155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc_NotInMicroMips),
     /* 45158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 45170 */     // MIs[1] Operand 1
     /* 45170 */     // No operand predicates
     /* 45170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45172 */     // (rotr:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DROTR:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 45172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DROTR),
     /* 45175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 45182 */     GIR_RootConstrainSelectedInstOperands,
     /* 45183 */     // GIR_Coverage, 222,
     /* 45183 */     GIR_EraseRootFromParent_Done,
     /* 45184 */   // Label 1160: @45184
     /* 45184 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(45251), // Rule ID 1579 //
     /* 45189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 45192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 45200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 45204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45211 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DROTRV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 45211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45223 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 45229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 45234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DROTRV),
     /* 45242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45249 */     GIR_RootConstrainSelectedInstOperands,
     /* 45250 */     // GIR_Coverage, 1579,
     /* 45250 */     GIR_EraseRootFromParent_Done,
     /* 45251 */   // Label 1161: @45251
     /* 45251 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(45270), // Rule ID 223 //
     /* 45256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc_NotInMicroMips),
     /* 45259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45263 */     // (rotr:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DROTRV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 45263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DROTRV),
     /* 45268 */     GIR_RootConstrainSelectedInstOperands,
     /* 45269 */     // GIR_Coverage, 223,
     /* 45269 */     GIR_Done,
     /* 45270 */   // Label 1162: @45270
     /* 45270 */   GIM_Reject,
     /* 45271 */ // Label 1159: @45271
     /* 45271 */ GIM_Reject,
     /* 45272 */ // Label 1153: @45272
     /* 45272 */ GIM_Reject,
     /* 45273 */ // Label 41: @45273
     /* 45273 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(47803),
     /* 45278 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 45281 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1166*/ GIMT_Encode4(45466),
     /* 45292 */   /*GILLT_s32*//*Label 1164*/ GIMT_Encode4(45300),
     /* 45296 */   /*GILLT_s64*//*Label 1165*/ GIMT_Encode4(45383),
     /* 45300 */   // Label 1164: @45300
     /* 45300 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(45382),
     /* 45305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 45308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45312 */     GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(45345), // Rule ID 1415 //
     /* 45317 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45320 */       // MIs[0] Operand 1
     /* 45320 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45325 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45329 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45333 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTiu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 1:{ *:[i32] })
     /* 45333 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu),
     /* 45336 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45338 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45340 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45343 */       GIR_RootConstrainSelectedInstOperands,
     /* 45344 */       // GIR_Coverage, 1415,
     /* 45344 */       GIR_EraseRootFromParent_Done,
     /* 45345 */     // Label 1168: @45345
     /* 45345 */     GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(45381), // Rule ID 1416 //
     /* 45350 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45353 */       // MIs[0] Operand 1
     /* 45353 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 45358 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45362 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45366 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTu:{ *:[i32] } ZERO:{ *:[i32] }, GPR32:{ *:[i32] }:$lhs)
     /* 45366 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 45369 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45371 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 45377 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45379 */       GIR_RootConstrainSelectedInstOperands,
     /* 45380 */       // GIR_Coverage, 1416,
     /* 45380 */       GIR_EraseRootFromParent_Done,
     /* 45381 */     // Label 1169: @45381
     /* 45381 */     GIM_Reject,
     /* 45382 */   // Label 1167: @45382
     /* 45382 */   GIM_Reject,
     /* 45383 */   // Label 1165: @45383
     /* 45383 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(45465),
     /* 45388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 45391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45395 */     GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(45428), // Rule ID 1561 //
     /* 45400 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 45403 */       // MIs[0] Operand 1
     /* 45403 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45408 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45412 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45416 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTiu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 1:{ *:[i64] })
     /* 45416 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu64),
     /* 45419 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45421 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45423 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45426 */       GIR_RootConstrainSelectedInstOperands,
     /* 45427 */       // GIR_Coverage, 1561,
     /* 45427 */       GIR_EraseRootFromParent_Done,
     /* 45428 */     // Label 1171: @45428
     /* 45428 */     GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(45464), // Rule ID 1562 //
     /* 45433 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 45436 */       // MIs[0] Operand 1
     /* 45436 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 45441 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45445 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45449 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } ZERO_64:{ *:[i64] }, GPR64:{ *:[i64] }:$lhs)
     /* 45449 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 45452 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45454 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 45460 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45462 */       GIR_RootConstrainSelectedInstOperands,
     /* 45463 */       // GIR_Coverage, 1562,
     /* 45463 */       GIR_EraseRootFromParent_Done,
     /* 45464 */     // Label 1172: @45464
     /* 45464 */     GIM_Reject,
     /* 45465 */   // Label 1170: @45465
     /* 45465 */   GIM_Reject,
     /* 45466 */   // Label 1166: @45466
     /* 45466 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1175*/ GIMT_Encode4(45849),
     /* 45477 */   /*GILLT_s32*//*Label 1173*/ GIMT_Encode4(45485),
     /* 45481 */   /*GILLT_s64*//*Label 1174*/ GIMT_Encode4(45771),
     /* 45485 */   // Label 1173: @45485
     /* 45485 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(45770),
     /* 45490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 45493 */     GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(45530), // Rule ID 1887 //
     /* 45498 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 45501 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45505 */       // MIs[0] Operand 1
     /* 45505 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45510 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45514 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45518 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SltiuCCRxImmX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, 1:{ *:[i32] })
     /* 45518 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltiuCCRxImmX16),
     /* 45521 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 45523 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45525 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45528 */       GIR_RootConstrainSelectedInstOperands,
     /* 45529 */       // GIR_Coverage, 1887,
     /* 45529 */       GIR_EraseRootFromParent_Done,
     /* 45530 */     // Label 1177: @45530
     /* 45530 */     GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(45620), // Rule ID 1889 //
     /* 45535 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 45538 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45542 */       // MIs[0] Operand 1
     /* 45542 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 45547 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45551 */       GIM_CheckConstantInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-32769),
     /* 45562 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, -32769:{ *:[i32] }, SETGT:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltiCCRxImmX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, -32768:{ *:[i32] }), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 45562 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 45565 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 45569 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45574 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 45577 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 45579 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45582 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltiCCRxImmX16),
     /* 45586 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45591 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 45595 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 45605 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 45607 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 45610 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 45612 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45615 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 45618 */       GIR_RootConstrainSelectedInstOperands,
     /* 45619 */       // GIR_Coverage, 1889,
     /* 45619 */       GIR_EraseRootFromParent_Done,
     /* 45620 */     // Label 1178: @45620
     /* 45620 */     GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(45657), // Rule ID 2208 //
     /* 45625 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45628 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45632 */       // MIs[0] Operand 1
     /* 45632 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45637 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45641 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45645 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTiu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 1:{ *:[i32] })
     /* 45645 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu_MM),
     /* 45648 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45650 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45652 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45655 */       GIR_RootConstrainSelectedInstOperands,
     /* 45656 */       // GIR_Coverage, 2208,
     /* 45656 */       GIR_EraseRootFromParent_Done,
     /* 45657 */     // Label 1179: @45657
     /* 45657 */     GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(45697), // Rule ID 2209 //
     /* 45662 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45665 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45669 */       // MIs[0] Operand 1
     /* 45669 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 45674 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45678 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45682 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } ZERO:{ *:[i32] }, GPR32:{ *:[i32] }:$lhs)
     /* 45682 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 45685 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45687 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 45693 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45695 */       GIR_RootConstrainSelectedInstOperands,
     /* 45696 */       // GIR_Coverage, 2209,
     /* 45696 */       GIR_EraseRootFromParent_Done,
     /* 45697 */     // Label 1180: @45697
     /* 45697 */     GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(45733), // Rule ID 49 //
     /* 45702 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45705 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45709 */       // MIs[0] Operand 1
     /* 45709 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 45714 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45718 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45722 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45722 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 45725 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45727 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45729 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45731 */       GIR_RootConstrainSelectedInstOperands,
     /* 45732 */       // GIR_Coverage, 49,
     /* 45732 */       GIR_EraseRootFromParent_Done,
     /* 45733 */     // Label 1181: @45733
     /* 45733 */     GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(45769), // Rule ID 50 //
     /* 45738 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45741 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45745 */       // MIs[0] Operand 1
     /* 45745 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 45750 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45754 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45758 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETULT:{ *:[Other] })  =>  (SLTu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45758 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 45761 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45763 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45765 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45767 */       GIR_RootConstrainSelectedInstOperands,
     /* 45768 */       // GIR_Coverage, 50,
     /* 45768 */       GIR_EraseRootFromParent_Done,
     /* 45769 */     // Label 1182: @45769
     /* 45769 */     GIM_Reject,
     /* 45770 */   // Label 1176: @45770
     /* 45770 */   GIM_Reject,
     /* 45771 */   // Label 1174: @45771
     /* 45771 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(45848),
     /* 45776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 45779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45783 */     GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(45815), // Rule ID 204 //
     /* 45788 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 45791 */       // MIs[0] Operand 1
     /* 45791 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 45796 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45800 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45804 */       // (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETLT:{ *:[Other] })  =>  (SLT64:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 45804 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 45807 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45809 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45811 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45813 */       GIR_RootConstrainSelectedInstOperands,
     /* 45814 */       // GIR_Coverage, 204,
     /* 45814 */       GIR_EraseRootFromParent_Done,
     /* 45815 */     // Label 1184: @45815
     /* 45815 */     GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(45847), // Rule ID 205 //
     /* 45820 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 45823 */       // MIs[0] Operand 1
     /* 45823 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 45828 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45832 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45836 */       // (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETULT:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 45836 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 45839 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45841 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45843 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45845 */       GIR_RootConstrainSelectedInstOperands,
     /* 45846 */       // GIR_Coverage, 205,
     /* 45846 */       GIR_EraseRootFromParent_Done,
     /* 45847 */     // Label 1185: @45847
     /* 45847 */     GIM_Reject,
     /* 45848 */   // Label 1183: @45848
     /* 45848 */   GIM_Reject,
     /* 45849 */   // Label 1175: @45849
     /* 45849 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1188*/ GIMT_Encode4(46766),
     /* 45860 */   /*GILLT_s32*//*Label 1186*/ GIMT_Encode4(45868),
     /* 45864 */   /*GILLT_s64*//*Label 1187*/ GIMT_Encode4(46349),
     /* 45868 */   // Label 1186: @45868
     /* 45868 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(46348),
     /* 45873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 45876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45880 */     GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(45912), // Rule ID 1075 //
     /* 45885 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45888 */       // MIs[0] Operand 1
     /* 45888 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 45893 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45897 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45901 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETLT:{ *:[Other] })  =>  (SLT_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45901 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 45904 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45906 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45908 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45910 */       GIR_RootConstrainSelectedInstOperands,
     /* 45911 */       // GIR_Coverage, 1075,
     /* 45911 */       GIR_EraseRootFromParent_Done,
     /* 45912 */     // Label 1190: @45912
     /* 45912 */     GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(45944), // Rule ID 1076 //
     /* 45917 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45920 */       // MIs[0] Operand 1
     /* 45920 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 45925 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45929 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45933 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETULT:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45933 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 45936 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45938 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45940 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45942 */       GIR_RootConstrainSelectedInstOperands,
     /* 45943 */       // GIR_Coverage, 1076,
     /* 45943 */       GIR_EraseRootFromParent_Done,
     /* 45944 */     // Label 1191: @45944
     /* 45944 */     GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(46000), // Rule ID 1417 //
     /* 45949 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45952 */       // MIs[0] Operand 1
     /* 45952 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45957 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45961 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45965 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] })  =>  (SLTiu:{ *:[i32] } (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 45965 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45968 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 45972 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45977 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 45981 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 45985 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 45987 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu),
     /* 45990 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45992 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45995 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45998 */       GIR_RootConstrainSelectedInstOperands,
     /* 45999 */       // GIR_Coverage, 1417,
     /* 45999 */       GIR_EraseRootFromParent_Done,
     /* 46000 */     // Label 1192: @46000
     /* 46000 */     GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(46059), // Rule ID 1418 //
     /* 46005 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46008 */       // MIs[0] Operand 1
     /* 46008 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 46013 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46017 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46021 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] })  =>  (SLTu:{ *:[i32] } ZERO:{ *:[i32] }, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs))
     /* 46021 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46024 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 46028 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46033 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46037 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46041 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46043 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46046 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46048 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 46054 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46057 */       GIR_RootConstrainSelectedInstOperands,
     /* 46058 */       // GIR_Coverage, 1418,
     /* 46058 */       GIR_EraseRootFromParent_Done,
     /* 46059 */     // Label 1193: @46059
     /* 46059 */     GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(46115), // Rule ID 1419 //
     /* 46064 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46067 */       // MIs[0] Operand 1
     /* 46067 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 46072 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46076 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46080 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 46080 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46083 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 46087 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46092 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46096 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46100 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46102 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46105 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46107 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46110 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46113 */       GIR_RootConstrainSelectedInstOperands,
     /* 46114 */       // GIR_Coverage, 1419,
     /* 46114 */       GIR_EraseRootFromParent_Done,
     /* 46115 */     // Label 1194: @46115
     /* 46115 */     GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(46171), // Rule ID 1420 //
     /* 46120 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46123 */       // MIs[0] Operand 1
     /* 46123 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 46128 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46132 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46136 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 46136 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46139 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46143 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46148 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46152 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46156 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46158 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46161 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46163 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46166 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46169 */       GIR_RootConstrainSelectedInstOperands,
     /* 46170 */       // GIR_Coverage, 1420,
     /* 46170 */       GIR_EraseRootFromParent_Done,
     /* 46171 */     // Label 1195: @46171
     /* 46171 */     GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(46203), // Rule ID 1421 //
     /* 46176 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46179 */       // MIs[0] Operand 1
     /* 46179 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 46184 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46188 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46192 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 46192 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 46195 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46197 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46199 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46201 */       GIR_RootConstrainSelectedInstOperands,
     /* 46202 */       // GIR_Coverage, 1421,
     /* 46202 */       GIR_EraseRootFromParent_Done,
     /* 46203 */     // Label 1196: @46203
     /* 46203 */     GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(46235), // Rule ID 1422 //
     /* 46208 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46211 */       // MIs[0] Operand 1
     /* 46211 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 46216 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46220 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46224 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] })  =>  (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 46224 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46227 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46229 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46231 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46233 */       GIR_RootConstrainSelectedInstOperands,
     /* 46234 */       // GIR_Coverage, 1422,
     /* 46234 */       GIR_EraseRootFromParent_Done,
     /* 46235 */     // Label 1197: @46235
     /* 46235 */     GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(46291), // Rule ID 1423 //
     /* 46240 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46243 */       // MIs[0] Operand 1
     /* 46243 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 46248 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46252 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46256 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 46256 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46259 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 46263 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46268 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46272 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46276 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46278 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46281 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46283 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46286 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46289 */       GIR_RootConstrainSelectedInstOperands,
     /* 46290 */       // GIR_Coverage, 1423,
     /* 46290 */       GIR_EraseRootFromParent_Done,
     /* 46291 */     // Label 1198: @46291
     /* 46291 */     GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(46347), // Rule ID 1424 //
     /* 46296 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46299 */       // MIs[0] Operand 1
     /* 46299 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 46304 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46308 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46312 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 46312 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46315 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46319 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46324 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46328 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46332 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46334 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46337 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46339 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46342 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46345 */       GIR_RootConstrainSelectedInstOperands,
     /* 46346 */       // GIR_Coverage, 1424,
     /* 46346 */       GIR_EraseRootFromParent_Done,
     /* 46347 */     // Label 1199: @46347
     /* 46347 */     GIM_Reject,
     /* 46348 */   // Label 1189: @46348
     /* 46348 */   GIM_Reject,
     /* 46349 */   // Label 1187: @46349
     /* 46349 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(46765),
     /* 46354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 46357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46361 */     GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(46417), // Rule ID 1563 //
     /* 46366 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46369 */       // MIs[0] Operand 1
     /* 46369 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 46374 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46378 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46382 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] })  =>  (SLTiu64:{ *:[i32] } (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), 1:{ *:[i64] })
     /* 46382 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 46385 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 46389 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46394 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46398 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46402 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46404 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu64),
     /* 46407 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46409 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46412 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46415 */       GIR_RootConstrainSelectedInstOperands,
     /* 46416 */       // GIR_Coverage, 1563,
     /* 46416 */       GIR_EraseRootFromParent_Done,
     /* 46417 */     // Label 1201: @46417
     /* 46417 */     GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(46476), // Rule ID 1564 //
     /* 46422 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46425 */       // MIs[0] Operand 1
     /* 46425 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 46430 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46434 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46438 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } ZERO_64:{ *:[i64] }, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs))
     /* 46438 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 46441 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 46445 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46450 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46454 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46458 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46460 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46463 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46465 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 46471 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46474 */       GIR_RootConstrainSelectedInstOperands,
     /* 46475 */       // GIR_Coverage, 1564,
     /* 46475 */       GIR_EraseRootFromParent_Done,
     /* 46476 */     // Label 1202: @46476
     /* 46476 */     GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(46532), // Rule ID 1565 //
     /* 46481 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46484 */       // MIs[0] Operand 1
     /* 46484 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 46489 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46493 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46497 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), 1:{ *:[i32] })
     /* 46497 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46500 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 46504 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46509 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46513 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46517 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46519 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46522 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46524 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46527 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46530 */       GIR_RootConstrainSelectedInstOperands,
     /* 46531 */       // GIR_Coverage, 1565,
     /* 46531 */       GIR_EraseRootFromParent_Done,
     /* 46532 */     // Label 1203: @46532
     /* 46532 */     GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(46588), // Rule ID 1566 //
     /* 46537 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46540 */       // MIs[0] Operand 1
     /* 46540 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 46545 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46549 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46553 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), 1:{ *:[i32] })
     /* 46553 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46556 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46560 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46565 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46569 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46573 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46575 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46578 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46580 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46583 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46586 */       GIR_RootConstrainSelectedInstOperands,
     /* 46587 */       // GIR_Coverage, 1566,
     /* 46587 */       GIR_EraseRootFromParent_Done,
     /* 46588 */     // Label 1204: @46588
     /* 46588 */     GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(46620), // Rule ID 1567 //
     /* 46593 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46596 */       // MIs[0] Operand 1
     /* 46596 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 46601 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46605 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46609 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] })  =>  (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs)
     /* 46609 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 46612 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46614 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46616 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46618 */       GIR_RootConstrainSelectedInstOperands,
     /* 46619 */       // GIR_Coverage, 1567,
     /* 46619 */       GIR_EraseRootFromParent_Done,
     /* 46620 */     // Label 1205: @46620
     /* 46620 */     GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(46652), // Rule ID 1568 //
     /* 46625 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46628 */       // MIs[0] Operand 1
     /* 46628 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 46633 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46637 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46641 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs)
     /* 46641 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46644 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46646 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46648 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46650 */       GIR_RootConstrainSelectedInstOperands,
     /* 46651 */       // GIR_Coverage, 1568,
     /* 46651 */       GIR_EraseRootFromParent_Done,
     /* 46652 */     // Label 1206: @46652
     /* 46652 */     GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(46708), // Rule ID 1569 //
     /* 46657 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46660 */       // MIs[0] Operand 1
     /* 46660 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 46665 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46669 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46673 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), 1:{ *:[i32] })
     /* 46673 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46676 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 46680 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46685 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46689 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46693 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46695 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46698 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46700 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46703 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46706 */       GIR_RootConstrainSelectedInstOperands,
     /* 46707 */       // GIR_Coverage, 1569,
     /* 46707 */       GIR_EraseRootFromParent_Done,
     /* 46708 */     // Label 1207: @46708
     /* 46708 */     GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(46764), // Rule ID 1570 //
     /* 46713 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46716 */       // MIs[0] Operand 1
     /* 46716 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 46721 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46725 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46729 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), 1:{ *:[i32] })
     /* 46729 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46732 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46736 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46741 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46745 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46749 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46751 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46754 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46756 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46759 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46762 */       GIR_RootConstrainSelectedInstOperands,
     /* 46763 */       // GIR_Coverage, 1570,
     /* 46763 */       GIR_EraseRootFromParent_Done,
     /* 46764 */     // Label 1208: @46764
     /* 46764 */     GIM_Reject,
     /* 46765 */   // Label 1200: @46765
     /* 46765 */   GIM_Reject,
     /* 46766 */   // Label 1188: @46766
     /* 46766 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(47802),
     /* 46771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 46774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 46777 */     GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(46837), // Rule ID 1886 //
     /* 46782 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46785 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46789 */       // MIs[0] Operand 1
     /* 46789 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 46794 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46798 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46802 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] })  =>  (SltiuCCRxImmX16:{ *:[i32] } (XorRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 46802 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46805 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 46809 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46814 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46818 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46822 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46824 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltiuCCRxImmX16),
     /* 46827 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 46829 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46832 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46835 */       GIR_RootConstrainSelectedInstOperands,
     /* 46836 */       // GIR_Coverage, 1886,
     /* 46836 */       GIR_EraseRootFromParent_Done,
     /* 46837 */     // Label 1210: @46837
     /* 46837 */     GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(46914), // Rule ID 1888 //
     /* 46842 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46845 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46849 */       // MIs[0] Operand 1
     /* 46849 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 46854 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46858 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46862 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETGE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 46862 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 46865 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 46869 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46874 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 46877 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 46879 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46882 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 46886 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46891 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46895 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46899 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46901 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 46904 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 46906 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46909 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 46912 */       GIR_RootConstrainSelectedInstOperands,
     /* 46913 */       // GIR_Coverage, 1888,
     /* 46913 */       GIR_EraseRootFromParent_Done,
     /* 46914 */     // Label 1211: @46914
     /* 46914 */     GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(46950), // Rule ID 1890 //
     /* 46919 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46922 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46926 */       // MIs[0] Operand 1
     /* 46926 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 46931 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46935 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46939 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETGT:{ *:[Other] })  =>  (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs)
     /* 46939 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 46942 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 46944 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46946 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46948 */       GIR_RootConstrainSelectedInstOperands,
     /* 46949 */       // GIR_Coverage, 1890,
     /* 46949 */       GIR_EraseRootFromParent_Done,
     /* 46950 */     // Label 1212: @46950
     /* 46950 */     GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(47027), // Rule ID 1891 //
     /* 46955 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46958 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46962 */       // MIs[0] Operand 1
     /* 46962 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 46967 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46971 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46975 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETLE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs), (LiRxImm16:{ *:[i32] } 1:{ *:[i32] }))
     /* 46975 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 46978 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImm16),
     /* 46982 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46987 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 46990 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 46992 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46995 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 46999 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47004 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47008 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47012 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47014 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 47017 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 47019 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47022 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47025 */       GIR_RootConstrainSelectedInstOperands,
     /* 47026 */       // GIR_Coverage, 1891,
     /* 47026 */       GIR_EraseRootFromParent_Done,
     /* 47027 */     // Label 1213: @47027
     /* 47027 */     GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(47063), // Rule ID 1892 //
     /* 47032 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47035 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47039 */       // MIs[0] Operand 1
     /* 47039 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 47044 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47048 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47052 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETLT:{ *:[Other] })  =>  (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry)
     /* 47052 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 47055 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47057 */       GIR_RootToRootCopy, /*OpIdx*/2, // rx
     /* 47059 */       GIR_RootToRootCopy, /*OpIdx*/3, // ry
     /* 47061 */       GIR_RootConstrainSelectedInstOperands,
     /* 47062 */       // GIR_Coverage, 1892,
     /* 47062 */       GIR_EraseRootFromParent_Done,
     /* 47063 */     // Label 1214: @47063
     /* 47063 */     GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(47140), // Rule ID 1894 //
     /* 47068 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47071 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47075 */       // MIs[0] Operand 1
     /* 47075 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 47080 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47084 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47088 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETNE:{ *:[Other] })  =>  (SltuCCRxRy16:{ *:[i32] } (LiRxImmX16:{ *:[i32] } 0:{ *:[i32] }), (XorRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs))
     /* 47088 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 47091 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 47095 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47100 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47104 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47108 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 47110 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47113 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 47117 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47122 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 47125 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47127 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47130 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47132 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47135 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47138 */       GIR_RootConstrainSelectedInstOperands,
     /* 47139 */       // GIR_Coverage, 1894,
     /* 47139 */       GIR_EraseRootFromParent_Done,
     /* 47140 */     // Label 1215: @47140
     /* 47140 */     GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(47217), // Rule ID 1895 //
     /* 47145 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47148 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47152 */       // MIs[0] Operand 1
     /* 47152 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 47157 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47161 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47165 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 47165 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 47168 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 47172 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47177 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 47180 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 47182 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47185 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47189 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47194 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47198 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47202 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47204 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 47207 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 47209 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47212 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47215 */       GIR_RootConstrainSelectedInstOperands,
     /* 47216 */       // GIR_Coverage, 1895,
     /* 47216 */       GIR_EraseRootFromParent_Done,
     /* 47217 */     // Label 1216: @47217
     /* 47217 */     GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(47253), // Rule ID 1896 //
     /* 47222 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47225 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47229 */       // MIs[0] Operand 1
     /* 47229 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 47234 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47238 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47242 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] })  =>  (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs)
     /* 47242 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47245 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47247 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 47249 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 47251 */       GIR_RootConstrainSelectedInstOperands,
     /* 47252 */       // GIR_Coverage, 1896,
     /* 47252 */       GIR_EraseRootFromParent_Done,
     /* 47253 */     // Label 1217: @47253
     /* 47253 */     GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(47330), // Rule ID 1897 //
     /* 47258 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47261 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47265 */       // MIs[0] Operand 1
     /* 47265 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 47270 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47274 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47278 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETULE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 47278 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 47281 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 47285 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47290 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 47293 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 47295 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47298 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47302 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47307 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47311 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47315 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47317 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 47320 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 47322 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47325 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47328 */       GIR_RootConstrainSelectedInstOperands,
     /* 47329 */       // GIR_Coverage, 1897,
     /* 47329 */       GIR_EraseRootFromParent_Done,
     /* 47330 */     // Label 1218: @47330
     /* 47330 */     GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(47366), // Rule ID 1898 //
     /* 47335 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47338 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47342 */       // MIs[0] Operand 1
     /* 47342 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 47347 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47351 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47355 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETULT:{ *:[Other] })  =>  (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry)
     /* 47355 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47358 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47360 */       GIR_RootToRootCopy, /*OpIdx*/2, // rx
     /* 47362 */       GIR_RootToRootCopy, /*OpIdx*/3, // ry
     /* 47364 */       GIR_RootConstrainSelectedInstOperands,
     /* 47365 */       // GIR_Coverage, 1898,
     /* 47365 */       GIR_EraseRootFromParent_Done,
     /* 47366 */     // Label 1219: @47366
     /* 47366 */     GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(47426), // Rule ID 2210 //
     /* 47371 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47374 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47378 */       // MIs[0] Operand 1
     /* 47378 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 47383 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47387 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47391 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] })  =>  (SLTiu_MM:{ *:[i32] } (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 47391 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47394 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 47398 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47403 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47407 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47411 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47413 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu_MM),
     /* 47416 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47418 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47421 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47424 */       GIR_RootConstrainSelectedInstOperands,
     /* 47425 */       // GIR_Coverage, 2210,
     /* 47425 */       GIR_EraseRootFromParent_Done,
     /* 47426 */     // Label 1220: @47426
     /* 47426 */     GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(47489), // Rule ID 2211 //
     /* 47431 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47434 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47438 */       // MIs[0] Operand 1
     /* 47438 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 47443 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47447 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47451 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } ZERO:{ *:[i32] }, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs))
     /* 47451 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47454 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 47458 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47463 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47467 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47471 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47473 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47476 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 47478 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 47484 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47487 */       GIR_RootConstrainSelectedInstOperands,
     /* 47488 */       // GIR_Coverage, 2211,
     /* 47488 */       GIR_EraseRootFromParent_Done,
     /* 47489 */     // Label 1221: @47489
     /* 47489 */     GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(47549), // Rule ID 2212 //
     /* 47494 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47497 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47501 */       // MIs[0] Operand 1
     /* 47501 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 47506 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47510 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47514 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 47514 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47517 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 47521 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47526 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47530 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47534 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47536 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47539 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47541 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47544 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47547 */       GIR_RootConstrainSelectedInstOperands,
     /* 47548 */       // GIR_Coverage, 2212,
     /* 47548 */       GIR_EraseRootFromParent_Done,
     /* 47549 */     // Label 1222: @47549
     /* 47549 */     GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(47609), // Rule ID 2213 //
     /* 47554 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47557 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47561 */       // MIs[0] Operand 1
     /* 47561 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 47566 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47570 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47574 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 47574 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47577 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47581 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47586 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47590 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47594 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47596 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47599 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47601 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47604 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47607 */       GIR_RootConstrainSelectedInstOperands,
     /* 47608 */       // GIR_Coverage, 2213,
     /* 47608 */       GIR_EraseRootFromParent_Done,
     /* 47609 */     // Label 1223: @47609
     /* 47609 */     GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(47645), // Rule ID 2214 //
     /* 47614 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47617 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47621 */       // MIs[0] Operand 1
     /* 47621 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 47626 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47630 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47634 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] })  =>  (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 47634 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 47637 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 47639 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 47641 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 47643 */       GIR_RootConstrainSelectedInstOperands,
     /* 47644 */       // GIR_Coverage, 2214,
     /* 47644 */       GIR_EraseRootFromParent_Done,
     /* 47645 */     // Label 1224: @47645
     /* 47645 */     GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(47681), // Rule ID 2215 //
     /* 47650 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47653 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47657 */       // MIs[0] Operand 1
     /* 47657 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 47662 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47666 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47670 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 47670 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47673 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 47675 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 47677 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 47679 */       GIR_RootConstrainSelectedInstOperands,
     /* 47680 */       // GIR_Coverage, 2215,
     /* 47680 */       GIR_EraseRootFromParent_Done,
     /* 47681 */     // Label 1225: @47681
     /* 47681 */     GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(47741), // Rule ID 2216 //
     /* 47686 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47689 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47693 */       // MIs[0] Operand 1
     /* 47693 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 47698 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47702 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47706 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 47706 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47709 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 47713 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47718 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47722 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47726 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47728 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47731 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47733 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47736 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47739 */       GIR_RootConstrainSelectedInstOperands,
     /* 47740 */       // GIR_Coverage, 2216,
     /* 47740 */       GIR_EraseRootFromParent_Done,
     /* 47741 */     // Label 1226: @47741
     /* 47741 */     GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(47801), // Rule ID 2217 //
     /* 47746 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47749 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47753 */       // MIs[0] Operand 1
     /* 47753 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 47758 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47762 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47766 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 47766 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47769 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47773 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47778 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47782 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47786 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47788 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47791 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47793 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47796 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47799 */       GIR_RootConstrainSelectedInstOperands,
     /* 47800 */       // GIR_Coverage, 2217,
     /* 47800 */       GIR_EraseRootFromParent_Done,
     /* 47801 */     // Label 1227: @47801
     /* 47801 */     GIM_Reject,
     /* 47802 */   // Label 1209: @47802
     /* 47802 */   GIM_Reject,
     /* 47803 */ // Label 1163: @47803
     /* 47803 */ GIM_Reject,
     /* 47804 */ // Label 42: @47804
     /* 47804 */ GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(49509),
     /* 47809 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 47812 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1231*/ GIMT_Encode4(48307),
     /* 47823 */   /*GILLT_s32*//*Label 1229*/ GIMT_Encode4(47831),
     /* 47827 */   /*GILLT_s64*//*Label 1230*/ GIMT_Encode4(48069),
     /* 47831 */   // Label 1229: @47831
     /* 47831 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(48068),
     /* 47836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 47839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 47843 */     GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(47875), // Rule ID 312 //
     /* 47848 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47851 */       // MIs[0] Operand 1
     /* 47851 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 47856 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47860 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47864 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47864 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S),
     /* 47867 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47869 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47871 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47873 */       GIR_RootConstrainSelectedInstOperands,
     /* 47874 */       // GIR_Coverage, 312,
     /* 47874 */       GIR_EraseRootFromParent_Done,
     /* 47875 */     // Label 1233: @47875
     /* 47875 */     GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(47907), // Rule ID 313 //
     /* 47880 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47883 */       // MIs[0] Operand 1
     /* 47883 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 47888 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47892 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47896 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47896 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S),
     /* 47899 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47901 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47903 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47905 */       GIR_RootConstrainSelectedInstOperands,
     /* 47906 */       // GIR_Coverage, 313,
     /* 47906 */       GIR_EraseRootFromParent_Done,
     /* 47907 */     // Label 1234: @47907
     /* 47907 */     GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(47939), // Rule ID 314 //
     /* 47912 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47915 */       // MIs[0] Operand 1
     /* 47915 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 47920 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47924 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47928 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47928 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S),
     /* 47931 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47933 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47935 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47937 */       GIR_RootConstrainSelectedInstOperands,
     /* 47938 */       // GIR_Coverage, 314,
     /* 47938 */       GIR_EraseRootFromParent_Done,
     /* 47939 */     // Label 1235: @47939
     /* 47939 */     GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(47971), // Rule ID 315 //
     /* 47944 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47947 */       // MIs[0] Operand 1
     /* 47947 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 47952 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47956 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47960 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47960 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_S),
     /* 47963 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47965 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47967 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47969 */       GIR_RootConstrainSelectedInstOperands,
     /* 47970 */       // GIR_Coverage, 315,
     /* 47970 */       GIR_EraseRootFromParent_Done,
     /* 47971 */     // Label 1236: @47971
     /* 47971 */     GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(48003), // Rule ID 316 //
     /* 47976 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47979 */       // MIs[0] Operand 1
     /* 47979 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 47984 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47988 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47992 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47992 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_S),
     /* 47995 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47997 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47999 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48001 */       GIR_RootConstrainSelectedInstOperands,
     /* 48002 */       // GIR_Coverage, 316,
     /* 48002 */       GIR_EraseRootFromParent_Done,
     /* 48003 */     // Label 1237: @48003
     /* 48003 */     GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(48035), // Rule ID 317 //
     /* 48008 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48011 */       // MIs[0] Operand 1
     /* 48011 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 48016 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48020 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48024 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48024 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_S),
     /* 48027 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48029 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48031 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48033 */       GIR_RootConstrainSelectedInstOperands,
     /* 48034 */       // GIR_Coverage, 317,
     /* 48034 */       GIR_EraseRootFromParent_Done,
     /* 48035 */     // Label 1238: @48035
     /* 48035 */     GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(48067), // Rule ID 318 //
     /* 48040 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48043 */       // MIs[0] Operand 1
     /* 48043 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48048 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48052 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48056 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48056 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_S),
     /* 48059 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48061 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48063 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48065 */       GIR_RootConstrainSelectedInstOperands,
     /* 48066 */       // GIR_Coverage, 318,
     /* 48066 */       GIR_EraseRootFromParent_Done,
     /* 48067 */     // Label 1239: @48067
     /* 48067 */     GIM_Reject,
     /* 48068 */   // Label 1232: @48068
     /* 48068 */   GIM_Reject,
     /* 48069 */   // Label 1230: @48069
     /* 48069 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(48306),
     /* 48074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 48077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 48081 */     GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(48113), // Rule ID 319 //
     /* 48086 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48089 */       // MIs[0] Operand 1
     /* 48089 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 48094 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48098 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48102 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48102 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D),
     /* 48105 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48107 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48109 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48111 */       GIR_RootConstrainSelectedInstOperands,
     /* 48112 */       // GIR_Coverage, 319,
     /* 48112 */       GIR_EraseRootFromParent_Done,
     /* 48113 */     // Label 1241: @48113
     /* 48113 */     GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(48145), // Rule ID 320 //
     /* 48118 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48121 */       // MIs[0] Operand 1
     /* 48121 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 48126 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48130 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48134 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48134 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D),
     /* 48137 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48139 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48141 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48143 */       GIR_RootConstrainSelectedInstOperands,
     /* 48144 */       // GIR_Coverage, 320,
     /* 48144 */       GIR_EraseRootFromParent_Done,
     /* 48145 */     // Label 1242: @48145
     /* 48145 */     GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(48177), // Rule ID 321 //
     /* 48150 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48153 */       // MIs[0] Operand 1
     /* 48153 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 48158 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48162 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48166 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48166 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D),
     /* 48169 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48171 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48173 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48175 */       GIR_RootConstrainSelectedInstOperands,
     /* 48176 */       // GIR_Coverage, 321,
     /* 48176 */       GIR_EraseRootFromParent_Done,
     /* 48177 */     // Label 1243: @48177
     /* 48177 */     GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(48209), // Rule ID 322 //
     /* 48182 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48185 */       // MIs[0] Operand 1
     /* 48185 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 48190 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48194 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48198 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48198 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_D),
     /* 48201 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48203 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48205 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48207 */       GIR_RootConstrainSelectedInstOperands,
     /* 48208 */       // GIR_Coverage, 322,
     /* 48208 */       GIR_EraseRootFromParent_Done,
     /* 48209 */     // Label 1244: @48209
     /* 48209 */     GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(48241), // Rule ID 323 //
     /* 48214 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48217 */       // MIs[0] Operand 1
     /* 48217 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 48222 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48226 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48230 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48230 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_D),
     /* 48233 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48235 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48237 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48239 */       GIR_RootConstrainSelectedInstOperands,
     /* 48240 */       // GIR_Coverage, 323,
     /* 48240 */       GIR_EraseRootFromParent_Done,
     /* 48241 */     // Label 1245: @48241
     /* 48241 */     GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(48273), // Rule ID 324 //
     /* 48246 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48249 */       // MIs[0] Operand 1
     /* 48249 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 48254 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48258 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48262 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48262 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_D),
     /* 48265 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48267 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48269 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48271 */       GIR_RootConstrainSelectedInstOperands,
     /* 48272 */       // GIR_Coverage, 324,
     /* 48272 */       GIR_EraseRootFromParent_Done,
     /* 48273 */     // Label 1246: @48273
     /* 48273 */     GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(48305), // Rule ID 325 //
     /* 48278 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48281 */       // MIs[0] Operand 1
     /* 48281 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48286 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48290 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48294 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48294 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_D),
     /* 48297 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48299 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48301 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48303 */       GIR_RootConstrainSelectedInstOperands,
     /* 48304 */       // GIR_Coverage, 325,
     /* 48304 */       GIR_EraseRootFromParent_Done,
     /* 48305 */     // Label 1247: @48305
     /* 48305 */     GIM_Reject,
     /* 48306 */   // Label 1240: @48306
     /* 48306 */   GIM_Reject,
     /* 48307 */   // Label 1231: @48307
     /* 48307 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1250*/ GIMT_Encode4(48802),
     /* 48318 */   /*GILLT_s32*//*Label 1248*/ GIMT_Encode4(48326),
     /* 48322 */   /*GILLT_s64*//*Label 1249*/ GIMT_Encode4(48564),
     /* 48326 */   // Label 1248: @48326
     /* 48326 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(48563),
     /* 48331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 48334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 48338 */     GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(48370), // Rule ID 1193 //
     /* 48343 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48346 */       // MIs[0] Operand 1
     /* 48346 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 48351 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48355 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48359 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48359 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S_MMR6),
     /* 48362 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48364 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48366 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48368 */       GIR_RootConstrainSelectedInstOperands,
     /* 48369 */       // GIR_Coverage, 1193,
     /* 48369 */       GIR_EraseRootFromParent_Done,
     /* 48370 */     // Label 1252: @48370
     /* 48370 */     GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(48402), // Rule ID 1194 //
     /* 48375 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48378 */       // MIs[0] Operand 1
     /* 48378 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 48383 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48387 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48391 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48391 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S_MMR6),
     /* 48394 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48396 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48398 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48400 */       GIR_RootConstrainSelectedInstOperands,
     /* 48401 */       // GIR_Coverage, 1194,
     /* 48401 */       GIR_EraseRootFromParent_Done,
     /* 48402 */     // Label 1253: @48402
     /* 48402 */     GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(48434), // Rule ID 1195 //
     /* 48407 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48410 */       // MIs[0] Operand 1
     /* 48410 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 48415 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48419 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48423 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48423 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S_MMR6),
     /* 48426 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48428 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48430 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48432 */       GIR_RootConstrainSelectedInstOperands,
     /* 48433 */       // GIR_Coverage, 1195,
     /* 48433 */       GIR_EraseRootFromParent_Done,
     /* 48434 */     // Label 1254: @48434
     /* 48434 */     GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(48466), // Rule ID 1196 //
     /* 48439 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48442 */       // MIs[0] Operand 1
     /* 48442 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 48447 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48451 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48455 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48455 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_S_MMR6),
     /* 48458 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48460 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48462 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48464 */       GIR_RootConstrainSelectedInstOperands,
     /* 48465 */       // GIR_Coverage, 1196,
     /* 48465 */       GIR_EraseRootFromParent_Done,
     /* 48466 */     // Label 1255: @48466
     /* 48466 */     GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(48498), // Rule ID 1197 //
     /* 48471 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48474 */       // MIs[0] Operand 1
     /* 48474 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 48479 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48483 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48487 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48487 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_S_MMR6),
     /* 48490 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48492 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48494 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48496 */       GIR_RootConstrainSelectedInstOperands,
     /* 48497 */       // GIR_Coverage, 1197,
     /* 48497 */       GIR_EraseRootFromParent_Done,
     /* 48498 */     // Label 1256: @48498
     /* 48498 */     GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(48530), // Rule ID 1198 //
     /* 48503 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48506 */       // MIs[0] Operand 1
     /* 48506 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 48511 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48515 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48519 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48519 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_S_MMR6),
     /* 48522 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48524 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48526 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48528 */       GIR_RootConstrainSelectedInstOperands,
     /* 48529 */       // GIR_Coverage, 1198,
     /* 48529 */       GIR_EraseRootFromParent_Done,
     /* 48530 */     // Label 1257: @48530
     /* 48530 */     GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(48562), // Rule ID 1199 //
     /* 48535 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48538 */       // MIs[0] Operand 1
     /* 48538 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48543 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48547 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48551 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48551 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_S_MMR6),
     /* 48554 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48556 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48558 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48560 */       GIR_RootConstrainSelectedInstOperands,
     /* 48561 */       // GIR_Coverage, 1199,
     /* 48561 */       GIR_EraseRootFromParent_Done,
     /* 48562 */     // Label 1258: @48562
     /* 48562 */     GIM_Reject,
     /* 48563 */   // Label 1251: @48563
     /* 48563 */   GIM_Reject,
     /* 48564 */   // Label 1249: @48564
     /* 48564 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(48801),
     /* 48569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 48572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 48576 */     GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(48608), // Rule ID 1200 //
     /* 48581 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48584 */       // MIs[0] Operand 1
     /* 48584 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 48589 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48593 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48597 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48597 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D_MMR6),
     /* 48600 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48602 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48604 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48606 */       GIR_RootConstrainSelectedInstOperands,
     /* 48607 */       // GIR_Coverage, 1200,
     /* 48607 */       GIR_EraseRootFromParent_Done,
     /* 48608 */     // Label 1260: @48608
     /* 48608 */     GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(48640), // Rule ID 1201 //
     /* 48613 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48616 */       // MIs[0] Operand 1
     /* 48616 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 48621 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48625 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48629 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48629 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D_MMR6),
     /* 48632 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48634 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48636 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48638 */       GIR_RootConstrainSelectedInstOperands,
     /* 48639 */       // GIR_Coverage, 1201,
     /* 48639 */       GIR_EraseRootFromParent_Done,
     /* 48640 */     // Label 1261: @48640
     /* 48640 */     GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(48672), // Rule ID 1202 //
     /* 48645 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48648 */       // MIs[0] Operand 1
     /* 48648 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 48653 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48657 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48661 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48661 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D_MMR6),
     /* 48664 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48666 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48668 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48670 */       GIR_RootConstrainSelectedInstOperands,
     /* 48671 */       // GIR_Coverage, 1202,
     /* 48671 */       GIR_EraseRootFromParent_Done,
     /* 48672 */     // Label 1262: @48672
     /* 48672 */     GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(48704), // Rule ID 1203 //
     /* 48677 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48680 */       // MIs[0] Operand 1
     /* 48680 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 48685 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48689 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48693 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48693 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_D_MMR6),
     /* 48696 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48698 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48700 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48702 */       GIR_RootConstrainSelectedInstOperands,
     /* 48703 */       // GIR_Coverage, 1203,
     /* 48703 */       GIR_EraseRootFromParent_Done,
     /* 48704 */     // Label 1263: @48704
     /* 48704 */     GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(48736), // Rule ID 1204 //
     /* 48709 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48712 */       // MIs[0] Operand 1
     /* 48712 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 48717 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48721 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48725 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48725 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_D_MMR6),
     /* 48728 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48730 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48732 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48734 */       GIR_RootConstrainSelectedInstOperands,
     /* 48735 */       // GIR_Coverage, 1204,
     /* 48735 */       GIR_EraseRootFromParent_Done,
     /* 48736 */     // Label 1264: @48736
     /* 48736 */     GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(48768), // Rule ID 1205 //
     /* 48741 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48744 */       // MIs[0] Operand 1
     /* 48744 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 48749 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48753 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48757 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48757 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_D_MMR6),
     /* 48760 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48762 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48764 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48766 */       GIR_RootConstrainSelectedInstOperands,
     /* 48767 */       // GIR_Coverage, 1205,
     /* 48767 */       GIR_EraseRootFromParent_Done,
     /* 48768 */     // Label 1265: @48768
     /* 48768 */     GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(48800), // Rule ID 1206 //
     /* 48773 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48776 */       // MIs[0] Operand 1
     /* 48776 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48781 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48785 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48789 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48789 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_D_MMR6),
     /* 48792 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48794 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48796 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48798 */       GIR_RootConstrainSelectedInstOperands,
     /* 48799 */       // GIR_Coverage, 1206,
     /* 48799 */       GIR_EraseRootFromParent_Done,
     /* 48800 */     // Label 1266: @48800
     /* 48800 */     GIM_Reject,
     /* 48801 */   // Label 1259: @48801
     /* 48801 */   GIM_Reject,
     /* 48802 */   // Label 1250: @48802
     /* 48802 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1269*/ GIMT_Encode4(49155),
     /* 48813 */   /*GILLT_s32*//*Label 1267*/ GIMT_Encode4(48821),
     /* 48817 */   /*GILLT_s64*//*Label 1268*/ GIMT_Encode4(48988),
     /* 48821 */   // Label 1267: @48821
     /* 48821 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(48987),
     /* 48826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 48829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 48833 */     GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(48884), // Rule ID 1755 //
     /* 48838 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48841 */       // MIs[0] Operand 1
     /* 48841 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 48846 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UEQ_S:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 48846 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 48849 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S),
     /* 48853 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48858 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 48862 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 48866 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48868 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 48871 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 48873 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 48876 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 48882 */       GIR_RootConstrainSelectedInstOperands,
     /* 48883 */       // GIR_Coverage, 1755,
     /* 48883 */       GIR_EraseRootFromParent_Done,
     /* 48884 */     // Label 1271: @48884
     /* 48884 */     GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(48935), // Rule ID 1756 //
     /* 48889 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48892 */       // MIs[0] Operand 1
     /* 48892 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 48897 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETO:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UN_S:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 48897 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 48900 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S),
     /* 48904 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48909 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 48913 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 48917 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48919 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 48922 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 48924 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 48927 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 48933 */       GIR_RootConstrainSelectedInstOperands,
     /* 48934 */       // GIR_Coverage, 1756,
     /* 48934 */       GIR_EraseRootFromParent_Done,
     /* 48935 */     // Label 1272: @48935
     /* 48935 */     GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(48986), // Rule ID 1757 //
     /* 48940 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48943 */       // MIs[0] Operand 1
     /* 48943 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 48948 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_EQ_S:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 48948 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 48951 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S),
     /* 48955 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48960 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 48964 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 48968 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48970 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 48973 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 48975 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 48978 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 48984 */       GIR_RootConstrainSelectedInstOperands,
     /* 48985 */       // GIR_Coverage, 1757,
     /* 48985 */       GIR_EraseRootFromParent_Done,
     /* 48986 */     // Label 1273: @48986
     /* 48986 */     GIM_Reject,
     /* 48987 */   // Label 1270: @48987
     /* 48987 */   GIM_Reject,
     /* 48988 */   // Label 1268: @48988
     /* 48988 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(49154),
     /* 48993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 48996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49000 */     GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(49051), // Rule ID 1764 //
     /* 49005 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 49008 */       // MIs[0] Operand 1
     /* 49008 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 49013 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UEQ_D:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49013 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49016 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D),
     /* 49020 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49025 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49029 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49033 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49035 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 49038 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49040 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49043 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49049 */       GIR_RootConstrainSelectedInstOperands,
     /* 49050 */       // GIR_Coverage, 1764,
     /* 49050 */       GIR_EraseRootFromParent_Done,
     /* 49051 */     // Label 1275: @49051
     /* 49051 */     GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(49102), // Rule ID 1765 //
     /* 49056 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 49059 */       // MIs[0] Operand 1
     /* 49059 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 49064 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETO:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UN_D:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49064 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49067 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D),
     /* 49071 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49076 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49080 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49084 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49086 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 49089 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49091 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49094 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49100 */       GIR_RootConstrainSelectedInstOperands,
     /* 49101 */       // GIR_Coverage, 1765,
     /* 49101 */       GIR_EraseRootFromParent_Done,
     /* 49102 */     // Label 1276: @49102
     /* 49102 */     GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(49153), // Rule ID 1766 //
     /* 49107 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 49110 */       // MIs[0] Operand 1
     /* 49110 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 49115 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_EQ_D:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49115 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49118 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D),
     /* 49122 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49127 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49131 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49135 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49137 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 49140 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49142 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49145 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49151 */       GIR_RootConstrainSelectedInstOperands,
     /* 49152 */       // GIR_Coverage, 1766,
     /* 49152 */       GIR_EraseRootFromParent_Done,
     /* 49153 */     // Label 1277: @49153
     /* 49153 */     GIM_Reject,
     /* 49154 */   // Label 1274: @49154
     /* 49154 */   GIM_Reject,
     /* 49155 */   // Label 1269: @49155
     /* 49155 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1280*/ GIMT_Encode4(49508),
     /* 49166 */   /*GILLT_s32*//*Label 1278*/ GIMT_Encode4(49174),
     /* 49170 */   /*GILLT_s64*//*Label 1279*/ GIMT_Encode4(49341),
     /* 49174 */   // Label 1278: @49174
     /* 49174 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(49340),
     /* 49179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49186 */     GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(49237), // Rule ID 2309 //
     /* 49191 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49194 */       // MIs[0] Operand 1
     /* 49194 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 49199 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UEQ_S_MMR6:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 49199 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49202 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S_MMR6),
     /* 49206 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49211 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49215 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49219 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49221 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49224 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49226 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49229 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49235 */       GIR_RootConstrainSelectedInstOperands,
     /* 49236 */       // GIR_Coverage, 2309,
     /* 49236 */       GIR_EraseRootFromParent_Done,
     /* 49237 */     // Label 1282: @49237
     /* 49237 */     GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(49288), // Rule ID 2310 //
     /* 49242 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49245 */       // MIs[0] Operand 1
     /* 49245 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 49250 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETO:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UN_S_MMR6:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 49250 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49253 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S_MMR6),
     /* 49257 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49262 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49266 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49270 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49272 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49275 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49277 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49280 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49286 */       GIR_RootConstrainSelectedInstOperands,
     /* 49287 */       // GIR_Coverage, 2310,
     /* 49287 */       GIR_EraseRootFromParent_Done,
     /* 49288 */     // Label 1283: @49288
     /* 49288 */     GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(49339), // Rule ID 2311 //
     /* 49293 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49296 */       // MIs[0] Operand 1
     /* 49296 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 49301 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_EQ_S_MMR6:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 49301 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49304 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S_MMR6),
     /* 49308 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49313 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49317 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49321 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49323 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49326 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49328 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49331 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49337 */       GIR_RootConstrainSelectedInstOperands,
     /* 49338 */       // GIR_Coverage, 2311,
     /* 49338 */       GIR_EraseRootFromParent_Done,
     /* 49339 */     // Label 1284: @49339
     /* 49339 */     GIM_Reject,
     /* 49340 */   // Label 1281: @49340
     /* 49340 */   GIM_Reject,
     /* 49341 */   // Label 1279: @49341
     /* 49341 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(49507),
     /* 49346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 49349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49353 */     GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(49404), // Rule ID 2318 //
     /* 49358 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49361 */       // MIs[0] Operand 1
     /* 49361 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 49366 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UEQ_D_MMR6:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49366 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49369 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D_MMR6),
     /* 49373 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49378 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49382 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49386 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49388 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49391 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49393 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49396 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49402 */       GIR_RootConstrainSelectedInstOperands,
     /* 49403 */       // GIR_Coverage, 2318,
     /* 49403 */       GIR_EraseRootFromParent_Done,
     /* 49404 */     // Label 1286: @49404
     /* 49404 */     GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(49455), // Rule ID 2319 //
     /* 49409 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49412 */       // MIs[0] Operand 1
     /* 49412 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 49417 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETO:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UN_D_MMR6:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49417 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49420 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D_MMR6),
     /* 49424 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49429 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49433 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49437 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49439 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49442 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49444 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49447 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49453 */       GIR_RootConstrainSelectedInstOperands,
     /* 49454 */       // GIR_Coverage, 2319,
     /* 49454 */       GIR_EraseRootFromParent_Done,
     /* 49455 */     // Label 1287: @49455
     /* 49455 */     GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(49506), // Rule ID 2320 //
     /* 49460 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49463 */       // MIs[0] Operand 1
     /* 49463 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 49468 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_EQ_D_MMR6:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49468 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49471 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D_MMR6),
     /* 49475 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49480 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49484 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49488 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49490 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49493 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49495 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49498 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49504 */       GIR_RootConstrainSelectedInstOperands,
     /* 49505 */       // GIR_Coverage, 2320,
     /* 49505 */       GIR_EraseRootFromParent_Done,
     /* 49506 */     // Label 1288: @49506
     /* 49506 */     GIM_Reject,
     /* 49507 */   // Label 1285: @49507
     /* 49507 */   GIM_Reject,
     /* 49508 */   // Label 1280: @49508
     /* 49508 */   GIM_Reject,
     /* 49509 */ // Label 1228: @49509
     /* 49509 */ GIM_Reject,
     /* 49510 */ // Label 43: @49510
     /* 49510 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1295*/ GIMT_Encode4(61547),
     /* 49521 */ /*GILLT_s32*//*Label 1289*/ GIMT_Encode4(49553),
     /* 49525 */ /*GILLT_s64*//*Label 1290*/ GIMT_Encode4(56230), GIMT_Encode4(0),
     /* 49533 */ /*GILLT_v2s64*//*Label 1291*/ GIMT_Encode4(61257), GIMT_Encode4(0),
     /* 49541 */ /*GILLT_v4s32*//*Label 1292*/ GIMT_Encode4(61331),
     /* 49545 */ /*GILLT_v8s16*//*Label 1293*/ GIMT_Encode4(61405),
     /* 49549 */ /*GILLT_v16s8*//*Label 1294*/ GIMT_Encode4(61452),
     /* 49553 */ // Label 1289: @49553
     /* 49553 */ GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(49629), // Rule ID 1643 //
     /* 49558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49567 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49582 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49586 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49590 */   // MIs[1] Operand 1
     /* 49590 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 49595 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49600 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49608 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49612 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49614 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 49617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49619 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49621 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49625 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49627 */   GIR_RootConstrainSelectedInstOperands,
     /* 49628 */   // GIR_Coverage, 1643,
     /* 49628 */   GIR_EraseRootFromParent_Done,
     /* 49629 */ // Label 1296: @49629
     /* 49629 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(49705), // Rule ID 1647 //
     /* 49634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49643 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49650 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49654 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49658 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49662 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49666 */   // MIs[1] Operand 1
     /* 49666 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 49671 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49676 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49684 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49688 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49690 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I),
     /* 49693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49695 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49697 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49701 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49703 */   GIR_RootConstrainSelectedInstOperands,
     /* 49704 */   // GIR_Coverage, 1647,
     /* 49704 */   GIR_EraseRootFromParent_Done,
     /* 49705 */ // Label 1297: @49705
     /* 49705 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(49781), // Rule ID 1675 //
     /* 49710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49719 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49726 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49730 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49734 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 49738 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 49742 */   // MIs[1] Operand 1
     /* 49742 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 49747 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 49752 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49760 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49764 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49766 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR64:{ *:[i64] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I),
     /* 49769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49771 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49773 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49777 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49779 */   GIR_RootConstrainSelectedInstOperands,
     /* 49780 */   // GIR_Coverage, 1675,
     /* 49780 */   GIR_EraseRootFromParent_Done,
     /* 49781 */ // Label 1298: @49781
     /* 49781 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(49857), // Rule ID 1686 //
     /* 49786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49795 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49802 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49806 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49810 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 49814 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 49818 */   // MIs[1] Operand 1
     /* 49818 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 49823 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 49828 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49836 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49840 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49842 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR64:{ *:[i64] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I),
     /* 49845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49847 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49849 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49853 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49855 */   GIR_RootConstrainSelectedInstOperands,
     /* 49856 */   // GIR_Coverage, 1686,
     /* 49856 */   GIR_EraseRootFromParent_Done,
     /* 49857 */ // Label 1299: @49857
     /* 49857 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(49933), // Rule ID 1699 //
     /* 49862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49871 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49878 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49886 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49890 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49894 */   // MIs[1] Operand 1
     /* 49894 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 49899 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49904 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49912 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49916 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49918 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 49918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 49921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 49923 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49925 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49929 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49931 */   GIR_RootConstrainSelectedInstOperands,
     /* 49932 */   // GIR_Coverage, 1699,
     /* 49932 */   GIR_EraseRootFromParent_Done,
     /* 49933 */ // Label 1300: @49933
     /* 49933 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(50009), // Rule ID 1702 //
     /* 49938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49947 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49954 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49958 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49962 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49966 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49970 */   // MIs[1] Operand 1
     /* 49970 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 49975 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49980 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49988 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49992 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49994 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 49994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S),
     /* 49997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 49999 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50001 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50005 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50007 */   GIR_RootConstrainSelectedInstOperands,
     /* 50008 */   // GIR_Coverage, 1702,
     /* 50008 */   GIR_EraseRootFromParent_Done,
     /* 50009 */ // Label 1301: @50009
     /* 50009 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(50085), // Rule ID 1712 //
     /* 50014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50023 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50030 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50034 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50038 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 50042 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 50046 */   // MIs[1] Operand 1
     /* 50046 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50051 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 50056 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50064 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50068 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50070 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR64:{ *:[i64] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_S),
     /* 50073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50075 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50077 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50081 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50083 */   GIR_RootConstrainSelectedInstOperands,
     /* 50084 */   // GIR_Coverage, 1712,
     /* 50084 */   GIR_EraseRootFromParent_Done,
     /* 50085 */ // Label 1302: @50085
     /* 50085 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(50161), // Rule ID 1715 //
     /* 50090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50099 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50106 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50110 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50114 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 50118 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 50122 */   // MIs[1] Operand 1
     /* 50122 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50127 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 50132 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50136 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50140 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50144 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50146 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR64:{ *:[i64] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_S),
     /* 50149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50151 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50153 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50157 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50159 */   GIR_RootConstrainSelectedInstOperands,
     /* 50160 */   // GIR_Coverage, 1715,
     /* 50160 */   GIR_EraseRootFromParent_Done,
     /* 50161 */ // Label 1303: @50161
     /* 50161 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(50237), // Rule ID 1880 //
     /* 50166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 50169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50175 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50182 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50186 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50190 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50194 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50198 */   // MIs[1] Operand 1
     /* 50198 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50203 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50208 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50216 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50220 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50222 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelBeqZ:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a)
     /* 50222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelBeqZ),
     /* 50225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 50227 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 50229 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 50231 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 50235 */   GIR_RootConstrainSelectedInstOperands,
     /* 50236 */   // GIR_Coverage, 1880,
     /* 50236 */   GIR_EraseRootFromParent_Done,
     /* 50237 */ // Label 1304: @50237
     /* 50237 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(50313), // Rule ID 1883 //
     /* 50242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 50245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50251 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50266 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50270 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50274 */   // MIs[1] Operand 1
     /* 50274 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50279 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50284 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50292 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50296 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50298 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, 0:{ *:[i32] }, SETNE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelBneZ:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a)
     /* 50298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelBneZ),
     /* 50301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 50303 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 50305 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 50307 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 50311 */   GIR_RootConstrainSelectedInstOperands,
     /* 50312 */   // GIR_Coverage, 1883,
     /* 50312 */   GIR_EraseRootFromParent_Done,
     /* 50313 */ // Label 1305: @50313
     /* 50313 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(50389), // Rule ID 2229 //
     /* 50318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50327 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50334 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50342 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50346 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50350 */   // MIs[1] Operand 1
     /* 50350 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50355 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50360 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50368 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50372 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50374 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 50377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50379 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50381 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50385 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50387 */   GIR_RootConstrainSelectedInstOperands,
     /* 50388 */   // GIR_Coverage, 2229,
     /* 50388 */   GIR_EraseRootFromParent_Done,
     /* 50389 */ // Label 1306: @50389
     /* 50389 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(50465), // Rule ID 2233 //
     /* 50394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 50397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50403 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50410 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50414 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50418 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50422 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50426 */   // MIs[1] Operand 1
     /* 50426 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50431 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50436 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50444 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50448 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50450 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 50453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50455 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50457 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50461 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50463 */   GIR_RootConstrainSelectedInstOperands,
     /* 50464 */   // GIR_Coverage, 2233,
     /* 50464 */   GIR_EraseRootFromParent_Done,
     /* 50465 */ // Label 1307: @50465
     /* 50465 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(50541), // Rule ID 2243 //
     /* 50470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50479 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50486 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50490 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50494 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50498 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50502 */   // MIs[1] Operand 1
     /* 50502 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50507 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50512 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50520 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50524 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50526 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 50529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50531 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50533 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50537 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50539 */   GIR_RootConstrainSelectedInstOperands,
     /* 50540 */   // GIR_Coverage, 2243,
     /* 50540 */   GIR_EraseRootFromParent_Done,
     /* 50541 */ // Label 1308: @50541
     /* 50541 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(50617), // Rule ID 2247 //
     /* 50546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50555 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50562 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50566 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50570 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50574 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50578 */   // MIs[1] Operand 1
     /* 50578 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50583 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50588 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50596 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50600 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50602 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 50605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50607 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50609 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50613 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50615 */   GIR_RootConstrainSelectedInstOperands,
     /* 50616 */   // GIR_Coverage, 2247,
     /* 50616 */   GIR_EraseRootFromParent_Done,
     /* 50617 */ // Label 1309: @50617
     /* 50617 */ GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(50693), // Rule ID 2277 //
     /* 50622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50631 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50638 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50642 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50646 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50650 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50654 */   // MIs[1] Operand 1
     /* 50654 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50659 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50664 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50672 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50676 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50678 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 50681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50683 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50685 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50689 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50691 */   GIR_RootConstrainSelectedInstOperands,
     /* 50692 */   // GIR_Coverage, 2277,
     /* 50692 */   GIR_EraseRootFromParent_Done,
     /* 50693 */ // Label 1310: @50693
     /* 50693 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(50769), // Rule ID 2280 //
     /* 50698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50714 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50718 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50722 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50726 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50730 */   // MIs[1] Operand 1
     /* 50730 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50735 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50740 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50748 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50752 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50754 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S_MM),
     /* 50757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50759 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50761 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50765 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50767 */   GIR_RootConstrainSelectedInstOperands,
     /* 50768 */   // GIR_Coverage, 2280,
     /* 50768 */   GIR_EraseRootFromParent_Done,
     /* 50769 */ // Label 1311: @50769
     /* 50769 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(50867), // Rule ID 1634 //
     /* 50774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50783 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50790 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50794 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50798 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50802 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50806 */   // MIs[1] Operand 1
     /* 50806 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 50811 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50816 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50825 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50829 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50831 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 50831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 50834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 50838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50843 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50847 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 50851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 50856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50858 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50860 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 50863 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50865 */   GIR_RootConstrainSelectedInstOperands,
     /* 50866 */   // GIR_Coverage, 1634,
     /* 50866 */   GIR_EraseRootFromParent_Done,
     /* 50867 */ // Label 1312: @50867
     /* 50867 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(50965), // Rule ID 1635 //
     /* 50872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50881 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50888 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50892 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50896 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50900 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50904 */   // MIs[1] Operand 1
     /* 50904 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 50909 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50914 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50923 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50927 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50929 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 50929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 50932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 50936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50941 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50945 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 50949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 50954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50956 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 50961 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50963 */   GIR_RootConstrainSelectedInstOperands,
     /* 50964 */   // GIR_Coverage, 1635,
     /* 50964 */   GIR_EraseRootFromParent_Done,
     /* 50965 */ // Label 1313: @50965
     /* 50965 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(51063), // Rule ID 1638 //
     /* 50970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50979 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50986 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50990 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50994 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50998 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51002 */   // MIs[1] Operand 1
     /* 51002 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 51007 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51012 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51021 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51025 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51027 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 51034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51039 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51043 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51054 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51059 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51061 */   GIR_RootConstrainSelectedInstOperands,
     /* 51062 */   // GIR_Coverage, 1638,
     /* 51062 */   GIR_EraseRootFromParent_Done,
     /* 51063 */ // Label 1314: @51063
     /* 51063 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(51161), // Rule ID 1639 //
     /* 51068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51077 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51084 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51088 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51092 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51096 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51100 */   // MIs[1] Operand 1
     /* 51100 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 51105 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51110 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51119 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51123 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51125 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 51132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51137 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51141 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51152 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51157 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51159 */   GIR_RootConstrainSelectedInstOperands,
     /* 51160 */   // GIR_Coverage, 1639,
     /* 51160 */   GIR_EraseRootFromParent_Done,
     /* 51161 */ // Label 1315: @51161
     /* 51161 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(51259), // Rule ID 1642 //
     /* 51166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51175 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51182 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51186 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51190 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51194 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51198 */   // MIs[1] Operand 1
     /* 51198 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 51203 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51208 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51217 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51221 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51223 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 51230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51235 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51239 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51250 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51255 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51257 */   GIR_RootConstrainSelectedInstOperands,
     /* 51258 */   // GIR_Coverage, 1642,
     /* 51258 */   GIR_EraseRootFromParent_Done,
     /* 51259 */ // Label 1316: @51259
     /* 51259 */ GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(51357), // Rule ID 1645 //
     /* 51264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51273 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51280 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51284 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51288 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51292 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51296 */   // MIs[1] Operand 1
     /* 51296 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 51301 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51306 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51315 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51319 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51321 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 51328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51333 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51337 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I),
     /* 51346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51348 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51353 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51355 */   GIR_RootConstrainSelectedInstOperands,
     /* 51356 */   // GIR_Coverage, 1645,
     /* 51356 */   GIR_EraseRootFromParent_Done,
     /* 51357 */ // Label 1317: @51357
     /* 51357 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(51455), // Rule ID 1656 //
     /* 51362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51371 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51378 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51382 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51386 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51390 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51394 */   // MIs[1] Operand 1
     /* 51394 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 51399 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51404 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51413 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51417 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51419 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51419 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51422 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 51426 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51431 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51435 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51446 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51451 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51453 */   GIR_RootConstrainSelectedInstOperands,
     /* 51454 */   // GIR_Coverage, 1656,
     /* 51454 */   GIR_EraseRootFromParent_Done,
     /* 51455 */ // Label 1318: @51455
     /* 51455 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(51553), // Rule ID 1657 //
     /* 51460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51469 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51476 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51480 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51484 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51488 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51492 */   // MIs[1] Operand 1
     /* 51492 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 51497 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51502 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51511 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51515 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51517 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51517 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51520 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 51524 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51529 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51533 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51544 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51549 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51551 */   GIR_RootConstrainSelectedInstOperands,
     /* 51552 */   // GIR_Coverage, 1657,
     /* 51552 */   GIR_EraseRootFromParent_Done,
     /* 51553 */ // Label 1319: @51553
     /* 51553 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(51651), // Rule ID 1660 //
     /* 51558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51567 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51582 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51586 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51590 */   // MIs[1] Operand 1
     /* 51590 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 51595 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51600 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51609 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51613 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51615 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51615 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51618 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 51622 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51627 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51631 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51642 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51647 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51649 */   GIR_RootConstrainSelectedInstOperands,
     /* 51650 */   // GIR_Coverage, 1660,
     /* 51650 */   GIR_EraseRootFromParent_Done,
     /* 51651 */ // Label 1320: @51651
     /* 51651 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(51749), // Rule ID 1661 //
     /* 51656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51665 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51672 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51676 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51680 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51684 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51688 */   // MIs[1] Operand 1
     /* 51688 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 51693 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51698 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51707 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51711 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51713 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51713 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51716 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 51720 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51725 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51729 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51740 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51742 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51745 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51747 */   GIR_RootConstrainSelectedInstOperands,
     /* 51748 */   // GIR_Coverage, 1661,
     /* 51748 */   GIR_EraseRootFromParent_Done,
     /* 51749 */ // Label 1321: @51749
     /* 51749 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(51847), // Rule ID 1674 //
     /* 51754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51763 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51770 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51774 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51778 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51782 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51786 */   // MIs[1] Operand 1
     /* 51786 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 51791 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51796 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51805 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51809 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51811 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 51814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 51818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51823 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51827 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I),
     /* 51836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51838 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51840 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51843 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51845 */   GIR_RootConstrainSelectedInstOperands,
     /* 51846 */   // GIR_Coverage, 1674,
     /* 51846 */   GIR_EraseRootFromParent_Done,
     /* 51847 */ // Label 1322: @51847
     /* 51847 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(51945), // Rule ID 1684 //
     /* 51852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51861 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51868 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51876 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51880 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51884 */   // MIs[1] Operand 1
     /* 51884 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 51889 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51894 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51903 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51907 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51909 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51909 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 51912 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 51916 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51921 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51925 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I),
     /* 51934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51936 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51941 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51943 */   GIR_RootConstrainSelectedInstOperands,
     /* 51944 */   // GIR_Coverage, 1684,
     /* 51944 */   GIR_EraseRootFromParent_Done,
     /* 51945 */ // Label 1323: @51945
     /* 51945 */ GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(52043), // Rule ID 1690 //
     /* 51950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51959 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 51966 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51970 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51974 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51978 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51982 */   // MIs[1] Operand 1
     /* 51982 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 51987 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51992 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52001 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52005 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52007 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 52014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52019 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52023 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52034 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52039 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52041 */   GIR_RootConstrainSelectedInstOperands,
     /* 52042 */   // GIR_Coverage, 1690,
     /* 52042 */   GIR_EraseRootFromParent_Done,
     /* 52043 */ // Label 1324: @52043
     /* 52043 */ GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(52141), // Rule ID 1691 //
     /* 52048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52057 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52064 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52068 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52072 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52076 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52080 */   // MIs[1] Operand 1
     /* 52080 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 52085 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52090 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52099 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52105 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 52112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52117 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52121 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52132 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52137 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52139 */   GIR_RootConstrainSelectedInstOperands,
     /* 52140 */   // GIR_Coverage, 1691,
     /* 52140 */   GIR_EraseRootFromParent_Done,
     /* 52141 */ // Label 1325: @52141
     /* 52141 */ GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(52239), // Rule ID 1694 //
     /* 52146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52155 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52162 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52170 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52174 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52178 */   // MIs[1] Operand 1
     /* 52178 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 52183 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52188 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52197 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52201 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52203 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 52210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52215 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52219 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52230 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52235 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52237 */   GIR_RootConstrainSelectedInstOperands,
     /* 52238 */   // GIR_Coverage, 1694,
     /* 52238 */   GIR_EraseRootFromParent_Done,
     /* 52239 */ // Label 1326: @52239
     /* 52239 */ GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(52337), // Rule ID 1695 //
     /* 52244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52253 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52260 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52264 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52268 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52272 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52276 */   // MIs[1] Operand 1
     /* 52276 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 52281 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52286 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52295 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52299 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52301 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 52308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52313 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52317 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52328 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52330 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52333 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52335 */   GIR_RootConstrainSelectedInstOperands,
     /* 52336 */   // GIR_Coverage, 1695,
     /* 52336 */   GIR_EraseRootFromParent_Done,
     /* 52337 */ // Label 1327: @52337
     /* 52337 */ GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(52435), // Rule ID 1698 //
     /* 52342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52351 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52366 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52370 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52374 */   // MIs[1] Operand 1
     /* 52374 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 52379 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52384 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52393 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52397 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52399 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 52406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52411 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52415 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52426 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52431 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52433 */   GIR_RootConstrainSelectedInstOperands,
     /* 52434 */   // GIR_Coverage, 1698,
     /* 52434 */   GIR_EraseRootFromParent_Done,
     /* 52435 */ // Label 1328: @52435
     /* 52435 */ GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(52533), // Rule ID 1700 //
     /* 52440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52456 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52460 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52464 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52468 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52472 */   // MIs[1] Operand 1
     /* 52472 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 52477 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52482 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52491 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52495 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52497 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 52504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52509 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52513 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S),
     /* 52522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52524 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52526 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52529 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52531 */   GIR_RootConstrainSelectedInstOperands,
     /* 52532 */   // GIR_Coverage, 1700,
     /* 52532 */   GIR_EraseRootFromParent_Done,
     /* 52533 */ // Label 1329: @52533
     /* 52533 */ GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(52631), // Rule ID 1703 //
     /* 52538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52554 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52562 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52566 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52570 */   // MIs[1] Operand 1
     /* 52570 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 52575 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52580 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52589 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52593 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52595 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 52602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52607 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52611 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52622 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52624 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52627 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52629 */   GIR_RootConstrainSelectedInstOperands,
     /* 52630 */   // GIR_Coverage, 1703,
     /* 52630 */   GIR_EraseRootFromParent_Done,
     /* 52631 */ // Label 1330: @52631
     /* 52631 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(52729), // Rule ID 1704 //
     /* 52636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52645 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52660 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52664 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52668 */   // MIs[1] Operand 1
     /* 52668 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 52673 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52678 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52687 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52691 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52693 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 52700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52705 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52709 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52720 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52725 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52727 */   GIR_RootConstrainSelectedInstOperands,
     /* 52728 */   // GIR_Coverage, 1704,
     /* 52728 */   GIR_EraseRootFromParent_Done,
     /* 52729 */ // Label 1331: @52729
     /* 52729 */ GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(52827), // Rule ID 1707 //
     /* 52734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52750 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52758 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52762 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52766 */   // MIs[1] Operand 1
     /* 52766 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 52771 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52776 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52781 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52785 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52789 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52791 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52791 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52794 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 52798 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52803 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52807 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52818 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52823 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52825 */   GIR_RootConstrainSelectedInstOperands,
     /* 52826 */   // GIR_Coverage, 1707,
     /* 52826 */   GIR_EraseRootFromParent_Done,
     /* 52827 */ // Label 1332: @52827
     /* 52827 */ GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(52925), // Rule ID 1708 //
     /* 52832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52841 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52848 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52852 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52856 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52860 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52864 */   // MIs[1] Operand 1
     /* 52864 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 52869 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52874 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52883 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52887 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52889 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52889 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52892 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 52896 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52901 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52905 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52916 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52921 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52923 */   GIR_RootConstrainSelectedInstOperands,
     /* 52924 */   // GIR_Coverage, 1708,
     /* 52924 */   GIR_EraseRootFromParent_Done,
     /* 52925 */ // Label 1333: @52925
     /* 52925 */ GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(53023), // Rule ID 1711 //
     /* 52930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52939 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52946 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52954 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52958 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52962 */   // MIs[1] Operand 1
     /* 52962 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 52967 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52972 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52981 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52985 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52987 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52987 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 52990 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 52994 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52999 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 53003 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 53007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_S),
     /* 53012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 53014 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 53016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 53019 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53021 */   GIR_RootConstrainSelectedInstOperands,
     /* 53022 */   // GIR_Coverage, 1711,
     /* 53022 */   GIR_EraseRootFromParent_Done,
     /* 53023 */ // Label 1334: @53023
     /* 53023 */ GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(53121), // Rule ID 1713 //
     /* 53028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 53031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53037 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 53044 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53048 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53052 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 53056 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 53060 */   // MIs[1] Operand 1
     /* 53060 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 53065 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 53070 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 53075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 53079 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 53083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53085 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 53085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 53088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 53092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53097 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 53101 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 53105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_S),
     /* 53110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 53112 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 53114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 53117 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53119 */   GIR_RootConstrainSelectedInstOperands,
     /* 53120 */   // GIR_Coverage, 1713,
     /* 53120 */   GIR_EraseRootFromParent_Done,
     /* 53121 */ // Label 1335: @53121
     /* 53121 */ GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(53202), // Rule ID 1872 //
     /* 53126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53135 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53142 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53150 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53154 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53158 */   // MIs[1] Operand 1
     /* 53158 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 53163 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53168 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53177 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53181 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53183 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETGE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSlt:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b)
     /* 53183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSlt),
     /* 53186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53188 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53190 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53192 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53196 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53200 */   GIR_RootConstrainSelectedInstOperands,
     /* 53201 */   // GIR_Coverage, 1872,
     /* 53201 */   GIR_EraseRootFromParent_Done,
     /* 53202 */ // Label 1336: @53202
     /* 53202 */ GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(53283), // Rule ID 1873 //
     /* 53207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53216 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53223 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53231 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53235 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53239 */   // MIs[1] Operand 1
     /* 53239 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 53244 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53249 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53258 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53262 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53264 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETGT:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBtneZSlt:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBtneZSlt),
     /* 53267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53269 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53271 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53273 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53277 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53281 */   GIR_RootConstrainSelectedInstOperands,
     /* 53282 */   // GIR_Coverage, 1873,
     /* 53282 */   GIR_EraseRootFromParent_Done,
     /* 53283 */ // Label 1337: @53283
     /* 53283 */ GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(53364), // Rule ID 1874 //
     /* 53288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53297 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53304 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53308 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53312 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53316 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53320 */   // MIs[1] Operand 1
     /* 53320 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 53325 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53330 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53339 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53343 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53345 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETUGE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSltu:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b)
     /* 53345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSltu),
     /* 53348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53350 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53352 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53354 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53358 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53362 */   GIR_RootConstrainSelectedInstOperands,
     /* 53363 */   // GIR_Coverage, 1874,
     /* 53363 */   GIR_EraseRootFromParent_Done,
     /* 53364 */ // Label 1338: @53364
     /* 53364 */ GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(53445), // Rule ID 1875 //
     /* 53369 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53385 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53389 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53393 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53397 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53401 */   // MIs[1] Operand 1
     /* 53401 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 53406 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53411 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53420 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53424 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53426 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETUGT:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBtneZSltu:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBtneZSltu),
     /* 53429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53431 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53433 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53435 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53439 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53443 */   GIR_RootConstrainSelectedInstOperands,
     /* 53444 */   // GIR_Coverage, 1875,
     /* 53444 */   GIR_EraseRootFromParent_Done,
     /* 53445 */ // Label 1339: @53445
     /* 53445 */ GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(53526), // Rule ID 1877 //
     /* 53450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53459 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53466 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53470 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53474 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53478 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53482 */   // MIs[1] Operand 1
     /* 53482 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 53487 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53492 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53497 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53501 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53505 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53507 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETLE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSlt:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSlt),
     /* 53510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53512 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53514 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53516 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53520 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53524 */   GIR_RootConstrainSelectedInstOperands,
     /* 53525 */   // GIR_Coverage, 1877,
     /* 53525 */   GIR_EraseRootFromParent_Done,
     /* 53526 */ // Label 1340: @53526
     /* 53526 */ GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(53607), // Rule ID 1878 //
     /* 53531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53540 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53547 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53551 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53555 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53559 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53563 */   // MIs[1] Operand 1
     /* 53563 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 53568 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53573 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53578 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53582 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53586 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53588 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETULE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSltu:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSltu),
     /* 53591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53593 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53595 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53597 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53601 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53605 */   GIR_RootConstrainSelectedInstOperands,
     /* 53606 */   // GIR_Coverage, 1878,
     /* 53606 */   GIR_EraseRootFromParent_Done,
     /* 53607 */ // Label 1341: @53607
     /* 53607 */ GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(53688), // Rule ID 1879 //
     /* 53612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53621 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53628 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53632 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53636 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53640 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53644 */   // MIs[1] Operand 1
     /* 53644 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 53649 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53654 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53663 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53667 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53669 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETEQ:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZCmp:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZCmp),
     /* 53672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53674 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53676 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53678 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53682 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53686 */   GIR_RootConstrainSelectedInstOperands,
     /* 53687 */   // GIR_Coverage, 1879,
     /* 53687 */   GIR_EraseRootFromParent_Done,
     /* 53688 */ // Label 1342: @53688
     /* 53688 */ GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(53769), // Rule ID 1882 //
     /* 53693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53702 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53709 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53713 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53717 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53721 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53725 */   // MIs[1] Operand 1
     /* 53725 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 53730 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53735 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53744 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53748 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53750 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETNE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBtneZCmp:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBtneZCmp),
     /* 53753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53755 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53757 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53759 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53763 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53767 */   GIR_RootConstrainSelectedInstOperands,
     /* 53768 */   // GIR_Coverage, 1882,
     /* 53768 */   GIR_EraseRootFromParent_Done,
     /* 53769 */ // Label 1343: @53769
     /* 53769 */ GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(53867), // Rule ID 2220 //
     /* 53774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 53777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53783 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53790 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53794 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53798 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53802 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53806 */   // MIs[1] Operand 1
     /* 53806 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 53811 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53816 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53825 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53829 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53831 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 53831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 53834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 53838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53843 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 53847 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 53851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 53856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 53858 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 53860 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 53863 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53865 */   GIR_RootConstrainSelectedInstOperands,
     /* 53866 */   // GIR_Coverage, 2220,
     /* 53866 */   GIR_EraseRootFromParent_Done,
     /* 53867 */ // Label 1344: @53867
     /* 53867 */ GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(53965), // Rule ID 2221 //
     /* 53872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 53875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53881 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53888 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53892 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53896 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53900 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53904 */   // MIs[1] Operand 1
     /* 53904 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 53909 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53914 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53923 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53927 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53929 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 53929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 53932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 53936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53941 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 53945 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 53949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 53954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 53956 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 53958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 53961 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53963 */   GIR_RootConstrainSelectedInstOperands,
     /* 53964 */   // GIR_Coverage, 2221,
     /* 53964 */   GIR_EraseRootFromParent_Done,
     /* 53965 */ // Label 1345: @53965
     /* 53965 */ GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(54063), // Rule ID 2224 //
     /* 53970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 53973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53979 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53986 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53990 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53994 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53998 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54002 */   // MIs[1] Operand 1
     /* 54002 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 54007 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54012 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54021 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54025 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54027 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 54034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54039 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54043 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54054 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54059 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54061 */   GIR_RootConstrainSelectedInstOperands,
     /* 54062 */   // GIR_Coverage, 2224,
     /* 54062 */   GIR_EraseRootFromParent_Done,
     /* 54063 */ // Label 1346: @54063
     /* 54063 */ GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(54161), // Rule ID 2225 //
     /* 54068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54077 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54084 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54088 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54092 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54096 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54100 */   // MIs[1] Operand 1
     /* 54100 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 54105 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54110 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54119 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54123 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54125 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 54132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54137 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54141 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54152 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54157 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54159 */   GIR_RootConstrainSelectedInstOperands,
     /* 54160 */   // GIR_Coverage, 2225,
     /* 54160 */   GIR_EraseRootFromParent_Done,
     /* 54161 */ // Label 1347: @54161
     /* 54161 */ GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(54259), // Rule ID 2228 //
     /* 54166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54175 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54182 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54186 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54190 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54194 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54198 */   // MIs[1] Operand 1
     /* 54198 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 54203 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54208 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54217 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54221 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54223 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54235 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54239 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54250 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54255 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54257 */   GIR_RootConstrainSelectedInstOperands,
     /* 54258 */   // GIR_Coverage, 2228,
     /* 54258 */   GIR_EraseRootFromParent_Done,
     /* 54259 */ // Label 1348: @54259
     /* 54259 */ GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(54357), // Rule ID 2231 //
     /* 54264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 54267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54273 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54280 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54284 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54288 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54292 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54296 */   // MIs[1] Operand 1
     /* 54296 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 54301 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54306 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54315 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54319 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54321 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54333 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54337 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 54346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54348 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54353 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54355 */   GIR_RootConstrainSelectedInstOperands,
     /* 54356 */   // GIR_Coverage, 2231,
     /* 54356 */   GIR_EraseRootFromParent_Done,
     /* 54357 */ // Label 1349: @54357
     /* 54357 */ GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(54455), // Rule ID 2234 //
     /* 54362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54371 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54378 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54382 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54386 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54390 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54394 */   // MIs[1] Operand 1
     /* 54394 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 54399 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54404 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54409 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54413 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54417 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54419 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54419 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54422 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 54426 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54431 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54435 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54446 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54451 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54453 */   GIR_RootConstrainSelectedInstOperands,
     /* 54454 */   // GIR_Coverage, 2234,
     /* 54454 */   GIR_EraseRootFromParent_Done,
     /* 54455 */ // Label 1350: @54455
     /* 54455 */ GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(54553), // Rule ID 2235 //
     /* 54460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54469 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54476 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54480 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54484 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54488 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54492 */   // MIs[1] Operand 1
     /* 54492 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 54497 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54502 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54511 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54515 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54517 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54517 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54520 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 54524 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54529 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54533 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54544 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54549 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54551 */   GIR_RootConstrainSelectedInstOperands,
     /* 54552 */   // GIR_Coverage, 2235,
     /* 54552 */   GIR_EraseRootFromParent_Done,
     /* 54553 */ // Label 1351: @54553
     /* 54553 */ GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(54651), // Rule ID 2238 //
     /* 54558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54567 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54582 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54586 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54590 */   // MIs[1] Operand 1
     /* 54590 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 54595 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54600 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54609 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54613 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54615 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54615 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54618 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 54622 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54627 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54631 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54642 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54647 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54649 */   GIR_RootConstrainSelectedInstOperands,
     /* 54650 */   // GIR_Coverage, 2238,
     /* 54650 */   GIR_EraseRootFromParent_Done,
     /* 54651 */ // Label 1352: @54651
     /* 54651 */ GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(54749), // Rule ID 2239 //
     /* 54656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54665 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54672 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54676 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54680 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54684 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54688 */   // MIs[1] Operand 1
     /* 54688 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 54693 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54698 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54707 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54711 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54713 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54713 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54716 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 54720 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54725 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54729 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54740 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54742 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54745 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54747 */   GIR_RootConstrainSelectedInstOperands,
     /* 54748 */   // GIR_Coverage, 2239,
     /* 54748 */   GIR_EraseRootFromParent_Done,
     /* 54749 */ // Label 1353: @54749
     /* 54749 */ GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(54847), // Rule ID 2242 //
     /* 54754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54763 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54770 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54774 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54778 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54782 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54786 */   // MIs[1] Operand 1
     /* 54786 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 54791 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54796 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54805 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54809 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54811 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54823 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54827 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54838 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54840 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54843 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54845 */   GIR_RootConstrainSelectedInstOperands,
     /* 54846 */   // GIR_Coverage, 2242,
     /* 54846 */   GIR_EraseRootFromParent_Done,
     /* 54847 */ // Label 1354: @54847
     /* 54847 */ GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(54945), // Rule ID 2245 //
     /* 54852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54861 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54868 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54876 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54880 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54884 */   // MIs[1] Operand 1
     /* 54884 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 54889 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54894 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54903 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54907 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54909 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54909 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54912 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54916 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54921 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54925 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 54934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54936 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54941 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54943 */   GIR_RootConstrainSelectedInstOperands,
     /* 54944 */   // GIR_Coverage, 2245,
     /* 54944 */   GIR_EraseRootFromParent_Done,
     /* 54945 */ // Label 1355: @54945
     /* 54945 */ GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(55043), // Rule ID 2268 //
     /* 54950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54959 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 54966 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54970 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54974 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54978 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54982 */   // MIs[1] Operand 1
     /* 54982 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 54987 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54992 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55001 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55005 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55007 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 55007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 55014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55019 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55023 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55034 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55039 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55041 */   GIR_RootConstrainSelectedInstOperands,
     /* 55042 */   // GIR_Coverage, 2268,
     /* 55042 */   GIR_EraseRootFromParent_Done,
     /* 55043 */ // Label 1356: @55043
     /* 55043 */ GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(55141), // Rule ID 2269 //
     /* 55048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55057 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55064 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55068 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55072 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55076 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55080 */   // MIs[1] Operand 1
     /* 55080 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 55085 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55090 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55099 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55105 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 55105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 55112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55117 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55121 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55132 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55137 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55139 */   GIR_RootConstrainSelectedInstOperands,
     /* 55140 */   // GIR_Coverage, 2269,
     /* 55140 */   GIR_EraseRootFromParent_Done,
     /* 55141 */ // Label 1357: @55141
     /* 55141 */ GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(55239), // Rule ID 2272 //
     /* 55146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55155 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55162 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55170 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55174 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55178 */   // MIs[1] Operand 1
     /* 55178 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 55183 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55188 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55197 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55201 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55203 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 55203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 55210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55215 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55219 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55230 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55235 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55237 */   GIR_RootConstrainSelectedInstOperands,
     /* 55238 */   // GIR_Coverage, 2272,
     /* 55238 */   GIR_EraseRootFromParent_Done,
     /* 55239 */ // Label 1358: @55239
     /* 55239 */ GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(55337), // Rule ID 2273 //
     /* 55244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55253 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55260 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55264 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55268 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55272 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55276 */   // MIs[1] Operand 1
     /* 55276 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 55281 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55286 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55295 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55299 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55301 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 55301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 55308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55313 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55317 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55328 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55330 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55333 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55335 */   GIR_RootConstrainSelectedInstOperands,
     /* 55336 */   // GIR_Coverage, 2273,
     /* 55336 */   GIR_EraseRootFromParent_Done,
     /* 55337 */ // Label 1359: @55337
     /* 55337 */ GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(55435), // Rule ID 2276 //
     /* 55342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55351 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55366 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55370 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55374 */   // MIs[1] Operand 1
     /* 55374 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 55379 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55384 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55393 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55397 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55399 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 55399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 55406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55411 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55415 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55426 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55431 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55433 */   GIR_RootConstrainSelectedInstOperands,
     /* 55434 */   // GIR_Coverage, 2276,
     /* 55434 */   GIR_EraseRootFromParent_Done,
     /* 55435 */ // Label 1360: @55435
     /* 55435 */ GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(55533), // Rule ID 2278 //
     /* 55440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55456 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55460 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55464 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55468 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55472 */   // MIs[1] Operand 1
     /* 55472 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 55477 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55482 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55491 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55495 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55497 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 55497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 55504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55509 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55513 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S_MM),
     /* 55522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55524 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55526 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55529 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55531 */   GIR_RootConstrainSelectedInstOperands,
     /* 55532 */   // GIR_Coverage, 2278,
     /* 55532 */   GIR_EraseRootFromParent_Done,
     /* 55533 */ // Label 1361: @55533
     /* 55533 */ GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(55573), // Rule ID 295 //
     /* 55538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotMips4_32),
     /* 55541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55562 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55566 */   // (select:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$cond, GPR32Opnd:{ *:[i32] }:$T, GPR32Opnd:{ *:[i32] }:$F)  =>  (PseudoSELECT_I:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$cond, GPR32Opnd:{ *:[i32] }:$T, GPR32Opnd:{ *:[i32] }:$F)
     /* 55566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_I),
     /* 55571 */   GIR_RootConstrainSelectedInstOperands,
     /* 55572 */   // GIR_Coverage, 295,
     /* 55572 */   GIR_Done,
     /* 55573 */ // Label 1362: @55573
     /* 55573 */ GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(55613), // Rule ID 297 //
     /* 55578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotMips4_32),
     /* 55581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55587 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55602 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55606 */   // (select:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$cond, FGR32Opnd:{ *:[f32] }:$T, FGR32Opnd:{ *:[f32] }:$F)  =>  (PseudoSELECT_S:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$cond, FGR32Opnd:{ *:[f32] }:$T, FGR32Opnd:{ *:[f32] }:$F)
     /* 55606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_S),
     /* 55611 */   GIR_RootConstrainSelectedInstOperands,
     /* 55612 */   // GIR_Coverage, 297,
     /* 55612 */   GIR_Done,
     /* 55613 */ // Label 1363: @55613
     /* 55613 */ GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(55659), // Rule ID 334 //
     /* 55618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 55621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55627 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 55638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55642 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55646 */   // (select:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)  =>  (SEL_S:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 55646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEL_S),
     /* 55649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55651 */   GIR_RootToRootCopy, /*OpIdx*/1, // fd_in
     /* 55653 */   GIR_RootToRootCopy, /*OpIdx*/3, // fs
     /* 55655 */   GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 55657 */   GIR_RootConstrainSelectedInstOperands,
     /* 55658 */   // GIR_Coverage, 334,
     /* 55658 */   GIR_EraseRootFromParent_Done,
     /* 55659 */ // Label 1364: @55659
     /* 55659 */ GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(55705), // Rule ID 1213 //
     /* 55664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 55667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55673 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 55684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55688 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55692 */   // (select:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)  =>  (SEL_S_MMR6:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 55692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEL_S_MMR6),
     /* 55695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55697 */   GIR_RootToRootCopy, /*OpIdx*/1, // fd_in
     /* 55699 */   GIR_RootToRootCopy, /*OpIdx*/3, // fs
     /* 55701 */   GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 55703 */   GIR_RootConstrainSelectedInstOperands,
     /* 55704 */   // GIR_Coverage, 1213,
     /* 55704 */   GIR_EraseRootFromParent_Done,
     /* 55705 */ // Label 1365: @55705
     /* 55705 */ GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(55751), // Rule ID 1646 //
     /* 55710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55719 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55734 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55738 */   // (select:{ *:[i32] } GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 55738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I),
     /* 55741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 55743 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55745 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55747 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55749 */   GIR_RootConstrainSelectedInstOperands,
     /* 55750 */   // GIR_Coverage, 1646,
     /* 55750 */   GIR_EraseRootFromParent_Done,
     /* 55751 */ // Label 1366: @55751
     /* 55751 */ GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(55797), // Rule ID 1685 //
     /* 55756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 55762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 55776 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55780 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55784 */   // (select:{ *:[i32] } GPR64:{ *:[i64] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR64:{ *:[i64] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 55784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I),
     /* 55787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 55789 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55791 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55793 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55795 */   GIR_RootConstrainSelectedInstOperands,
     /* 55796 */   // GIR_Coverage, 1685,
     /* 55796 */   GIR_EraseRootFromParent_Done,
     /* 55797 */ // Label 1367: @55797
     /* 55797 */ GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(55843), // Rule ID 1701 //
     /* 55802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55811 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55826 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55830 */   // (select:{ *:[f32] } GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$F)
     /* 55830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S),
     /* 55833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55835 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55837 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55839 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55841 */   GIR_RootConstrainSelectedInstOperands,
     /* 55842 */   // GIR_Coverage, 1701,
     /* 55842 */   GIR_EraseRootFromParent_Done,
     /* 55843 */ // Label 1368: @55843
     /* 55843 */ GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(55889), // Rule ID 1714 //
     /* 55848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 55854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55857 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 55868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55872 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55876 */   // (select:{ *:[f32] } GPR64:{ *:[i64] }:$cond, FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR64:{ *:[i64] }:$cond, FGR32:{ *:[f32] }:$F)
     /* 55876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_S),
     /* 55879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55881 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55883 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55885 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55887 */   GIR_RootConstrainSelectedInstOperands,
     /* 55888 */   // GIR_Coverage, 1714,
     /* 55888 */   GIR_EraseRootFromParent_Done,
     /* 55889 */ // Label 1369: @55889
     /* 55889 */ GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(55935), // Rule ID 1884 //
     /* 55894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 55897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55903 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55914 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55918 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55922 */   // (select:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelBneZ:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a)
     /* 55922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelBneZ),
     /* 55925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 55927 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 55929 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 55931 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 55933 */   GIR_RootConstrainSelectedInstOperands,
     /* 55934 */   // GIR_Coverage, 1884,
     /* 55934 */   GIR_EraseRootFromParent_Done,
     /* 55935 */ // Label 1370: @55935
     /* 55935 */ GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(55981), // Rule ID 2232 //
     /* 55940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 55943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55949 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55964 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55968 */   // (select:{ *:[i32] } GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 55968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 55971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 55973 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55975 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55977 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55979 */   GIR_RootConstrainSelectedInstOperands,
     /* 55980 */   // GIR_Coverage, 2232,
     /* 55980 */   GIR_EraseRootFromParent_Done,
     /* 55981 */ // Label 1371: @55981
     /* 55981 */ GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(56027), // Rule ID 2246 //
     /* 55986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55995 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56010 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56014 */   // (select:{ *:[i32] } GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 56014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 56017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56019 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56021 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 56023 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56025 */   GIR_RootConstrainSelectedInstOperands,
     /* 56026 */   // GIR_Coverage, 2246,
     /* 56026 */   GIR_EraseRootFromParent_Done,
     /* 56027 */ // Label 1372: @56027
     /* 56027 */ GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(56073), // Rule ID 2279 //
     /* 56032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 56035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 56041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 56044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 56048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 56056 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 56060 */   // (select:{ *:[f32] } GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$F)
     /* 56060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S_MM),
     /* 56063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56065 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56067 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 56069 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56071 */   GIR_RootConstrainSelectedInstOperands,
     /* 56072 */   // GIR_Coverage, 2279,
     /* 56072 */   GIR_EraseRootFromParent_Done,
     /* 56073 */ // Label 1373: @56073
     /* 56073 */ GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(56151), // Rule ID 1783 //
     /* 56078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 56081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 56087 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 56090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56094 */   // (select:{ *:[i32] } i32:{ *:[i32] }:$cond, i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$f)  =>  (OR:{ *:[i32] } (SELNEZ:{ *:[i32] } i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$cond), (SELEQZ:{ *:[i32] } i32:{ *:[i32] }:$f, i32:{ *:[i32] }:$cond))
     /* 56094 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 56097 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SELEQZ),
     /* 56101 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56106 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 56110 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56114 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 56116 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 56119 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ),
     /* 56123 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56128 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 56132 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 56138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR),
     /* 56141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56143 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 56146 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 56149 */   GIR_RootConstrainSelectedInstOperands,
     /* 56150 */   // GIR_Coverage, 1783,
     /* 56150 */   GIR_EraseRootFromParent_Done,
     /* 56151 */ // Label 1374: @56151
     /* 56151 */ GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(56229), // Rule ID 2296 //
     /* 56156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 56159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 56165 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 56168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56172 */   // (select:{ *:[i32] } i32:{ *:[i32] }:$cond, i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$f)  =>  (OR_MM:{ *:[i32] } (SELNEZ_MMR6:{ *:[i32] } i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$cond), (SELEQZ_MMR6:{ *:[i32] } i32:{ *:[i32] }:$f, i32:{ *:[i32] }:$cond))
     /* 56172 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 56175 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SELEQZ_MMR6),
     /* 56179 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56184 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 56188 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 56194 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 56197 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ_MMR6),
     /* 56201 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56206 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 56210 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 56216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR_MM),
     /* 56219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56221 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 56224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 56227 */   GIR_RootConstrainSelectedInstOperands,
     /* 56228 */   // GIR_Coverage, 2296,
     /* 56228 */   GIR_EraseRootFromParent_Done,
     /* 56229 */ // Label 1375: @56229
     /* 56229 */ GIM_Reject,
     /* 56230 */ // Label 1290: @56230
     /* 56230 */ GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(56306), // Rule ID 1673 //
     /* 56235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56244 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56251 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56255 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56259 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56263 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56267 */   // MIs[1] Operand 1
     /* 56267 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56272 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56277 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56285 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56289 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56291 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR32:{ *:[i32] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 56294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56296 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56298 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56302 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56304 */   GIR_RootConstrainSelectedInstOperands,
     /* 56305 */   // GIR_Coverage, 1673,
     /* 56305 */   GIR_EraseRootFromParent_Done,
     /* 56306 */ // Label 1376: @56306
     /* 56306 */ GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(56382), // Rule ID 1677 //
     /* 56311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56320 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56327 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56331 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56335 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56339 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56343 */   // MIs[1] Operand 1
     /* 56343 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56348 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56353 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56361 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56365 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56367 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I64),
     /* 56370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56372 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56374 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56378 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56380 */   GIR_RootConstrainSelectedInstOperands,
     /* 56381 */   // GIR_Coverage, 1677,
     /* 56381 */   GIR_EraseRootFromParent_Done,
     /* 56382 */ // Label 1377: @56382
     /* 56382 */ GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(56458), // Rule ID 1683 //
     /* 56387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56396 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56403 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56407 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56411 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56415 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56419 */   // MIs[1] Operand 1
     /* 56419 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56424 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56429 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56433 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56437 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56441 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56443 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR32:{ *:[i32] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I64),
     /* 56446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56448 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56450 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56454 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56456 */   GIR_RootConstrainSelectedInstOperands,
     /* 56457 */   // GIR_Coverage, 1683,
     /* 56457 */   GIR_EraseRootFromParent_Done,
     /* 56458 */ // Label 1378: @56458
     /* 56458 */ GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(56534), // Rule ID 1689 //
     /* 56463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56472 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56479 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56483 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56487 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56491 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56495 */   // MIs[1] Operand 1
     /* 56495 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56500 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56505 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56513 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56517 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56519 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I64),
     /* 56522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56524 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56526 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56530 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56532 */   GIR_RootConstrainSelectedInstOperands,
     /* 56533 */   // GIR_Coverage, 1689,
     /* 56533 */   GIR_EraseRootFromParent_Done,
     /* 56534 */ // Label 1379: @56534
     /* 56534 */ GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(56610), // Rule ID 1725 //
     /* 56539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56548 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56555 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56559 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56563 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56567 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56571 */   // MIs[1] Operand 1
     /* 56571 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56576 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56581 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56589 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56593 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56595 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 56595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 56598 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56600 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56602 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56606 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56608 */   GIR_RootConstrainSelectedInstOperands,
     /* 56609 */   // GIR_Coverage, 1725,
     /* 56609 */   GIR_EraseRootFromParent_Done,
     /* 56610 */ // Label 1380: @56610
     /* 56610 */ GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(56686), // Rule ID 1728 //
     /* 56615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56624 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56631 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56635 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56639 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56643 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56647 */   // MIs[1] Operand 1
     /* 56647 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56652 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56657 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56665 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56669 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56671 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 56671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32),
     /* 56674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56676 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56678 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56682 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56684 */   GIR_RootConstrainSelectedInstOperands,
     /* 56685 */   // GIR_Coverage, 1728,
     /* 56685 */   GIR_EraseRootFromParent_Done,
     /* 56686 */ // Label 1381: @56686
     /* 56686 */ GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(56762), // Rule ID 1746 //
     /* 56691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56700 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56707 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56711 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56715 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56719 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56723 */   // MIs[1] Operand 1
     /* 56723 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56728 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56733 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56737 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56741 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56745 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56747 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 56750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56752 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56754 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56758 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56760 */   GIR_RootConstrainSelectedInstOperands,
     /* 56761 */   // GIR_Coverage, 1746,
     /* 56761 */   GIR_EraseRootFromParent_Done,
     /* 56762 */ // Label 1382: @56762
     /* 56762 */ GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(56838), // Rule ID 1748 //
     /* 56767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56776 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56783 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56787 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56791 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56795 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56799 */   // MIs[1] Operand 1
     /* 56799 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56804 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56809 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56817 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56821 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56823 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR64:{ *:[i64] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_D64),
     /* 56826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56828 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56830 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56834 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56836 */   GIR_RootConstrainSelectedInstOperands,
     /* 56837 */   // GIR_Coverage, 1748,
     /* 56837 */   GIR_EraseRootFromParent_Done,
     /* 56838 */ // Label 1383: @56838
     /* 56838 */ GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(56914), // Rule ID 1751 //
     /* 56843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56852 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56859 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56863 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56867 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56871 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56875 */   // MIs[1] Operand 1
     /* 56875 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56880 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56885 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56893 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56897 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56899 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D64),
     /* 56902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56904 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56906 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56910 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56912 */   GIR_RootConstrainSelectedInstOperands,
     /* 56913 */   // GIR_Coverage, 1751,
     /* 56913 */   GIR_EraseRootFromParent_Done,
     /* 56914 */ // Label 1384: @56914
     /* 56914 */ GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(56990), // Rule ID 1754 //
     /* 56919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56928 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56935 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56939 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56943 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56947 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56951 */   // MIs[1] Operand 1
     /* 56951 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56956 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56961 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56969 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56973 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56975 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR64:{ *:[i64] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_D64),
     /* 56978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56980 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56982 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56986 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56988 */   GIR_RootConstrainSelectedInstOperands,
     /* 56989 */   // GIR_Coverage, 1754,
     /* 56989 */   GIR_EraseRootFromParent_Done,
     /* 56990 */ // Label 1385: @56990
     /* 56990 */ GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(57066), // Rule ID 2290 //
     /* 56995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 56998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57004 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57011 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57019 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57023 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57027 */   // MIs[1] Operand 1
     /* 57027 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 57032 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57037 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 57041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57045 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57049 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57051 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 57051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 57054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 57056 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57058 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57062 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57064 */   GIR_RootConstrainSelectedInstOperands,
     /* 57065 */   // GIR_Coverage, 2290,
     /* 57065 */   GIR_EraseRootFromParent_Done,
     /* 57066 */ // Label 1386: @57066
     /* 57066 */ GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(57142), // Rule ID 2293 //
     /* 57071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 57074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57080 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57087 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57095 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57099 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57103 */   // MIs[1] Operand 1
     /* 57103 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 57108 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57113 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 57117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57121 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57127 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 57127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32_MM),
     /* 57130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 57132 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57134 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57138 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57140 */   GIR_RootConstrainSelectedInstOperands,
     /* 57141 */   // GIR_Coverage, 2293,
     /* 57141 */   GIR_EraseRootFromParent_Done,
     /* 57142 */ // Label 1387: @57142
     /* 57142 */ GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(57240), // Rule ID 1648 //
     /* 57147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57156 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57163 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57167 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57171 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57175 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57179 */   // MIs[1] Operand 1
     /* 57179 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 57184 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57189 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57194 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57198 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57202 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57204 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 57211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57216 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57220 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57231 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57236 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57238 */   GIR_RootConstrainSelectedInstOperands,
     /* 57239 */   // GIR_Coverage, 1648,
     /* 57239 */   GIR_EraseRootFromParent_Done,
     /* 57240 */ // Label 1388: @57240
     /* 57240 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(57338), // Rule ID 1649 //
     /* 57245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57254 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57261 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57265 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57269 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57273 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57277 */   // MIs[1] Operand 1
     /* 57277 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 57282 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57287 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57296 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57300 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57302 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57302 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57305 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 57309 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57314 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57318 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57329 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57331 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57334 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57336 */   GIR_RootConstrainSelectedInstOperands,
     /* 57337 */   // GIR_Coverage, 1649,
     /* 57337 */   GIR_EraseRootFromParent_Done,
     /* 57338 */ // Label 1389: @57338
     /* 57338 */ GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(57436), // Rule ID 1652 //
     /* 57343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57352 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57367 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57371 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57375 */   // MIs[1] Operand 1
     /* 57375 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 57380 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57385 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57394 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57398 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57400 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57400 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57403 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 57407 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57412 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57416 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57427 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57432 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57434 */   GIR_RootConstrainSelectedInstOperands,
     /* 57435 */   // GIR_Coverage, 1652,
     /* 57435 */   GIR_EraseRootFromParent_Done,
     /* 57436 */ // Label 1390: @57436
     /* 57436 */ GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(57534), // Rule ID 1653 //
     /* 57441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57450 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57457 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57461 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57465 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57469 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57473 */   // MIs[1] Operand 1
     /* 57473 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 57478 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57483 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57492 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57496 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57498 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 57505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57510 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57514 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57525 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57530 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57532 */   GIR_RootConstrainSelectedInstOperands,
     /* 57533 */   // GIR_Coverage, 1653,
     /* 57533 */   GIR_EraseRootFromParent_Done,
     /* 57534 */ // Label 1391: @57534
     /* 57534 */ GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(57632), // Rule ID 1664 //
     /* 57539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57548 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57555 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57559 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57563 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57567 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57571 */   // MIs[1] Operand 1
     /* 57571 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 57576 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57581 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57586 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57590 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57594 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57596 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 57603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57608 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57612 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57623 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57625 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57628 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57630 */   GIR_RootConstrainSelectedInstOperands,
     /* 57631 */   // GIR_Coverage, 1664,
     /* 57631 */   GIR_EraseRootFromParent_Done,
     /* 57632 */ // Label 1392: @57632
     /* 57632 */ GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(57730), // Rule ID 1665 //
     /* 57637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57646 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57653 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57657 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57661 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57665 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57669 */   // MIs[1] Operand 1
     /* 57669 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 57674 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57679 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57688 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57692 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57694 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57694 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57697 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 57701 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57706 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57710 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57721 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57723 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57726 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57728 */   GIR_RootConstrainSelectedInstOperands,
     /* 57729 */   // GIR_Coverage, 1665,
     /* 57729 */   GIR_EraseRootFromParent_Done,
     /* 57730 */ // Label 1393: @57730
     /* 57730 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(57828), // Rule ID 1668 //
     /* 57735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57751 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57755 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57759 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57763 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57767 */   // MIs[1] Operand 1
     /* 57767 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 57772 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57777 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57786 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57790 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57792 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57792 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57795 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 57799 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57804 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57808 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57819 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57824 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57826 */   GIR_RootConstrainSelectedInstOperands,
     /* 57827 */   // GIR_Coverage, 1668,
     /* 57827 */   GIR_EraseRootFromParent_Done,
     /* 57828 */ // Label 1394: @57828
     /* 57828 */ GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(57926), // Rule ID 1669 //
     /* 57833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57842 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57849 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57853 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57857 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57861 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57865 */   // MIs[1] Operand 1
     /* 57865 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 57870 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57875 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57884 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57888 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57890 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 57897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57902 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57906 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57917 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57919 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57922 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57924 */   GIR_RootConstrainSelectedInstOperands,
     /* 57925 */   // GIR_Coverage, 1669,
     /* 57925 */   GIR_EraseRootFromParent_Done,
     /* 57926 */ // Label 1395: @57926
     /* 57926 */ GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(58024), // Rule ID 1672 //
     /* 57931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57940 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57947 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57951 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57955 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57959 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57963 */   // MIs[1] Operand 1
     /* 57963 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 57968 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57973 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57978 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57982 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57986 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57988 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57988 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57991 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 57995 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58000 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58004 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 58013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 58015 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58017 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58020 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58022 */   GIR_RootConstrainSelectedInstOperands,
     /* 58023 */   // GIR_Coverage, 1672,
     /* 58023 */   GIR_EraseRootFromParent_Done,
     /* 58024 */ // Label 1396: @58024
     /* 58024 */ GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(58122), // Rule ID 1676 //
     /* 58029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58038 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58045 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58049 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58053 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 58057 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 58061 */   // MIs[1] Operand 1
     /* 58061 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 58066 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58071 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58080 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58084 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58086 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 58086 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 58089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 58093 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58098 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58102 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I64),
     /* 58111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 58113 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58115 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58118 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58120 */   GIR_RootConstrainSelectedInstOperands,
     /* 58121 */   // GIR_Coverage, 1676,
     /* 58121 */   GIR_EraseRootFromParent_Done,
     /* 58122 */ // Label 1397: @58122
     /* 58122 */ GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(58220), // Rule ID 1681 //
     /* 58127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58136 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58143 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58151 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58155 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58159 */   // MIs[1] Operand 1
     /* 58159 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 58164 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58169 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58174 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58178 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58182 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58184 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 58184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 58191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58196 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58200 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I64),
     /* 58209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 58211 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58213 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58216 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58218 */   GIR_RootConstrainSelectedInstOperands,
     /* 58219 */   // GIR_Coverage, 1681,
     /* 58219 */   GIR_EraseRootFromParent_Done,
     /* 58220 */ // Label 1398: @58220
     /* 58220 */ GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(58318), // Rule ID 1687 //
     /* 58225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58234 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58241 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58245 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58249 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 58253 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 58257 */   // MIs[1] Operand 1
     /* 58257 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 58262 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58267 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58276 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58280 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58282 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 58282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 58285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 58289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58294 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58298 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I64),
     /* 58307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 58309 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58314 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58316 */   GIR_RootConstrainSelectedInstOperands,
     /* 58317 */   // GIR_Coverage, 1687,
     /* 58317 */   GIR_EraseRootFromParent_Done,
     /* 58318 */ // Label 1399: @58318
     /* 58318 */ GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(58416), // Rule ID 1716 //
     /* 58323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58332 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58339 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58347 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58351 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58355 */   // MIs[1] Operand 1
     /* 58355 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 58360 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58365 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58370 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58374 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58378 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58380 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 58387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58392 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58396 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58407 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58412 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58414 */   GIR_RootConstrainSelectedInstOperands,
     /* 58415 */   // GIR_Coverage, 1716,
     /* 58415 */   GIR_EraseRootFromParent_Done,
     /* 58416 */ // Label 1400: @58416
     /* 58416 */ GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(58514), // Rule ID 1717 //
     /* 58421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58430 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58437 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58441 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58445 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58449 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58453 */   // MIs[1] Operand 1
     /* 58453 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 58458 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58463 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58472 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58476 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58478 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58478 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58481 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 58485 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58490 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58494 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58505 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58510 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58512 */   GIR_RootConstrainSelectedInstOperands,
     /* 58513 */   // GIR_Coverage, 1717,
     /* 58513 */   GIR_EraseRootFromParent_Done,
     /* 58514 */ // Label 1401: @58514
     /* 58514 */ GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(58612), // Rule ID 1720 //
     /* 58519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58528 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58535 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58539 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58543 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58547 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58551 */   // MIs[1] Operand 1
     /* 58551 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 58556 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58561 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58570 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58576 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 58576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 58583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58588 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58592 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58603 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58608 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58610 */   GIR_RootConstrainSelectedInstOperands,
     /* 58611 */   // GIR_Coverage, 1720,
     /* 58611 */   GIR_EraseRootFromParent_Done,
     /* 58612 */ // Label 1402: @58612
     /* 58612 */ GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(58710), // Rule ID 1721 //
     /* 58617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58641 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58645 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58649 */   // MIs[1] Operand 1
     /* 58649 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 58654 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58659 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58668 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58672 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58674 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 58674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 58681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58686 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58690 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58701 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58703 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58706 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58708 */   GIR_RootConstrainSelectedInstOperands,
     /* 58709 */   // GIR_Coverage, 1721,
     /* 58709 */   GIR_EraseRootFromParent_Done,
     /* 58710 */ // Label 1403: @58710
     /* 58710 */ GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(58808), // Rule ID 1724 //
     /* 58715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58724 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58731 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58735 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58739 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58743 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58747 */   // MIs[1] Operand 1
     /* 58747 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 58752 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58757 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58766 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58770 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58772 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58772 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58775 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 58779 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58784 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58788 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58792 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58799 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58804 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58806 */   GIR_RootConstrainSelectedInstOperands,
     /* 58807 */   // GIR_Coverage, 1724,
     /* 58807 */   GIR_EraseRootFromParent_Done,
     /* 58808 */ // Label 1404: @58808
     /* 58808 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(58906), // Rule ID 1726 //
     /* 58813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58822 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58829 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58833 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58837 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58841 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58845 */   // MIs[1] Operand 1
     /* 58845 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 58850 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58855 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58864 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58868 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58870 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58870 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58873 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 58877 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58882 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58886 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32),
     /* 58895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58897 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58902 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58904 */   GIR_RootConstrainSelectedInstOperands,
     /* 58905 */   // GIR_Coverage, 1726,
     /* 58905 */   GIR_EraseRootFromParent_Done,
     /* 58906 */ // Label 1405: @58906
     /* 58906 */ GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(59004), // Rule ID 1729 //
     /* 58911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58920 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 58927 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58935 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58939 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58943 */   // MIs[1] Operand 1
     /* 58943 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 58948 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58953 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 58962 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 58966 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58968 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 58968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 58975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58980 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58984 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 58993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58995 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59000 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59002 */   GIR_RootConstrainSelectedInstOperands,
     /* 59003 */   // GIR_Coverage, 1729,
     /* 59003 */   GIR_EraseRootFromParent_Done,
     /* 59004 */ // Label 1406: @59004
     /* 59004 */ GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(59102), // Rule ID 1730 //
     /* 59009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59018 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59033 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59037 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59041 */   // MIs[1] Operand 1
     /* 59041 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 59046 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59051 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59060 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59064 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59066 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 59073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59078 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59082 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59093 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59095 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59098 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59100 */   GIR_RootConstrainSelectedInstOperands,
     /* 59101 */   // GIR_Coverage, 1730,
     /* 59101 */   GIR_EraseRootFromParent_Done,
     /* 59102 */ // Label 1407: @59102
     /* 59102 */ GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(59200), // Rule ID 1733 //
     /* 59107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59116 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59123 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59127 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59131 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59135 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59139 */   // MIs[1] Operand 1
     /* 59139 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 59144 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59149 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59158 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59162 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59164 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 59171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59176 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59180 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59191 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59193 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59196 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59198 */   GIR_RootConstrainSelectedInstOperands,
     /* 59199 */   // GIR_Coverage, 1733,
     /* 59199 */   GIR_EraseRootFromParent_Done,
     /* 59200 */ // Label 1408: @59200
     /* 59200 */ GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(59298), // Rule ID 1734 //
     /* 59205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59214 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59221 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59225 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59229 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59233 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59237 */   // MIs[1] Operand 1
     /* 59237 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 59242 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59247 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59256 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59260 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59262 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 59269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59274 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59278 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59289 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59291 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59294 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59296 */   GIR_RootConstrainSelectedInstOperands,
     /* 59297 */   // GIR_Coverage, 1734,
     /* 59297 */   GIR_EraseRootFromParent_Done,
     /* 59298 */ // Label 1409: @59298
     /* 59298 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(59396), // Rule ID 1737 //
     /* 59303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59312 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59319 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59323 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59327 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59331 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59335 */   // MIs[1] Operand 1
     /* 59335 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 59340 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59345 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59354 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59358 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59360 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 59367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59372 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59376 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59387 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59392 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59394 */   GIR_RootConstrainSelectedInstOperands,
     /* 59395 */   // GIR_Coverage, 1737,
     /* 59395 */   GIR_EraseRootFromParent_Done,
     /* 59396 */ // Label 1410: @59396
     /* 59396 */ GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(59494), // Rule ID 1738 //
     /* 59401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59410 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59417 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59421 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59425 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59429 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59433 */   // MIs[1] Operand 1
     /* 59433 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 59438 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59443 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59452 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59456 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59458 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 59465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59470 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59474 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59485 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59487 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59490 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59492 */   GIR_RootConstrainSelectedInstOperands,
     /* 59493 */   // GIR_Coverage, 1738,
     /* 59493 */   GIR_EraseRootFromParent_Done,
     /* 59494 */ // Label 1411: @59494
     /* 59494 */ GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(59592), // Rule ID 1741 //
     /* 59499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59508 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59515 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59519 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59523 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59527 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59531 */   // MIs[1] Operand 1
     /* 59531 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 59536 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59541 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59550 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59554 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59556 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 59563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59568 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59572 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59583 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59588 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59590 */   GIR_RootConstrainSelectedInstOperands,
     /* 59591 */   // GIR_Coverage, 1741,
     /* 59591 */   GIR_EraseRootFromParent_Done,
     /* 59592 */ // Label 1412: @59592
     /* 59592 */ GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(59690), // Rule ID 1742 //
     /* 59597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59606 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59613 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59617 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59621 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59625 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59629 */   // MIs[1] Operand 1
     /* 59629 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 59634 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59639 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59648 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59652 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59654 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59654 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59657 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 59661 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59666 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59670 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59681 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59683 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59686 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59688 */   GIR_RootConstrainSelectedInstOperands,
     /* 59689 */   // GIR_Coverage, 1742,
     /* 59689 */   GIR_EraseRootFromParent_Done,
     /* 59690 */ // Label 1413: @59690
     /* 59690 */ GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(59788), // Rule ID 1745 //
     /* 59695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59704 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59711 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59715 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59719 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59723 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59727 */   // MIs[1] Operand 1
     /* 59727 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 59732 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59737 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59742 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59746 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59750 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59752 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59752 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59755 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 59759 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59764 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59768 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59779 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59781 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59784 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59786 */   GIR_RootConstrainSelectedInstOperands,
     /* 59787 */   // GIR_Coverage, 1745,
     /* 59787 */   GIR_EraseRootFromParent_Done,
     /* 59788 */ // Label 1414: @59788
     /* 59788 */ GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(59886), // Rule ID 1747 //
     /* 59793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59802 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59809 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59813 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59817 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59821 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59825 */   // MIs[1] Operand 1
     /* 59825 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 59830 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59835 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59844 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59848 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59850 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59850 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 59853 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 59857 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59862 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59866 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_D64),
     /* 59875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59877 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59879 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59882 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59884 */   GIR_RootConstrainSelectedInstOperands,
     /* 59885 */   // GIR_Coverage, 1747,
     /* 59885 */   GIR_EraseRootFromParent_Done,
     /* 59886 */ // Label 1415: @59886
     /* 59886 */ GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(59984), // Rule ID 1749 //
     /* 59891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59900 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59907 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59911 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59915 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59919 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59923 */   // MIs[1] Operand 1
     /* 59923 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 59928 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59933 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59942 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59946 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59948 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59948 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59951 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 59955 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59960 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59964 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D64),
     /* 59973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59975 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59980 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59982 */   GIR_RootConstrainSelectedInstOperands,
     /* 59983 */   // GIR_Coverage, 1749,
     /* 59983 */   GIR_EraseRootFromParent_Done,
     /* 59984 */ // Label 1416: @59984
     /* 59984 */ GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(60082), // Rule ID 1752 //
     /* 59989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59998 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60005 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60013 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 60017 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 60021 */   // MIs[1] Operand 1
     /* 60021 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 60026 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60031 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60040 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60044 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60046 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 60046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 60049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 60053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60058 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60062 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_D64),
     /* 60071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60073 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60075 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60078 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60080 */   GIR_RootConstrainSelectedInstOperands,
     /* 60081 */   // GIR_Coverage, 1752,
     /* 60081 */   GIR_EraseRootFromParent_Done,
     /* 60082 */ // Label 1417: @60082
     /* 60082 */ GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(60180), // Rule ID 2281 //
     /* 60087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60096 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60111 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60115 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60119 */   // MIs[1] Operand 1
     /* 60119 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 60124 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60129 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60138 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60142 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60144 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 60151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60156 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60160 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60171 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60173 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60176 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60178 */   GIR_RootConstrainSelectedInstOperands,
     /* 60179 */   // GIR_Coverage, 2281,
     /* 60179 */   GIR_EraseRootFromParent_Done,
     /* 60180 */ // Label 1418: @60180
     /* 60180 */ GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(60278), // Rule ID 2282 //
     /* 60185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60194 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60201 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60205 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60209 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60213 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60217 */   // MIs[1] Operand 1
     /* 60217 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 60222 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60227 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60232 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60236 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60240 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60242 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 60249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60254 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60258 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60269 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60271 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60274 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60276 */   GIR_RootConstrainSelectedInstOperands,
     /* 60277 */   // GIR_Coverage, 2282,
     /* 60277 */   GIR_EraseRootFromParent_Done,
     /* 60278 */ // Label 1419: @60278
     /* 60278 */ GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(60376), // Rule ID 2285 //
     /* 60283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60292 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60299 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60303 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60307 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60311 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60315 */   // MIs[1] Operand 1
     /* 60315 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 60320 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60325 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60330 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60334 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60338 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60340 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 60340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 60347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60352 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60356 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60367 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60372 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60374 */   GIR_RootConstrainSelectedInstOperands,
     /* 60375 */   // GIR_Coverage, 2285,
     /* 60375 */   GIR_EraseRootFromParent_Done,
     /* 60376 */ // Label 1420: @60376
     /* 60376 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(60474), // Rule ID 2286 //
     /* 60381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60390 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60397 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60401 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60405 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60409 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60413 */   // MIs[1] Operand 1
     /* 60413 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 60418 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60423 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60432 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60436 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60438 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 60438 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60441 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 60445 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60450 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60454 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60465 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60467 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60470 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60472 */   GIR_RootConstrainSelectedInstOperands,
     /* 60473 */   // GIR_Coverage, 2286,
     /* 60473 */   GIR_EraseRootFromParent_Done,
     /* 60474 */ // Label 1421: @60474
     /* 60474 */ GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(60572), // Rule ID 2289 //
     /* 60479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60488 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60495 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60499 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60503 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60507 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60511 */   // MIs[1] Operand 1
     /* 60511 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 60516 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60521 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60530 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60534 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60536 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60536 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60539 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 60543 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60548 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60552 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60563 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60568 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60570 */   GIR_RootConstrainSelectedInstOperands,
     /* 60571 */   // GIR_Coverage, 2289,
     /* 60571 */   GIR_EraseRootFromParent_Done,
     /* 60572 */ // Label 1422: @60572
     /* 60572 */ GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(60670), // Rule ID 2291 //
     /* 60577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60586 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60601 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60605 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60609 */   // MIs[1] Operand 1
     /* 60609 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 60614 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60619 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60628 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60632 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60634 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60637 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 60641 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60646 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60650 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32_MM),
     /* 60659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60661 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60666 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60668 */   GIR_RootConstrainSelectedInstOperands,
     /* 60669 */   // GIR_Coverage, 2291,
     /* 60669 */   GIR_EraseRootFromParent_Done,
     /* 60670 */ // Label 1423: @60670
     /* 60670 */ GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(60710), // Rule ID 296 //
     /* 60675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotMips4_32),
     /* 60678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60684 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60699 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60703 */   // (select:{ *:[i64] } GPR32Opnd:{ *:[i32] }:$cond, GPR64Opnd:{ *:[i64] }:$T, GPR64Opnd:{ *:[i64] }:$F)  =>  (PseudoSELECT_I64:{ *:[i64] } GPR32Opnd:{ *:[i32] }:$cond, GPR64Opnd:{ *:[i64] }:$T, GPR64Opnd:{ *:[i64] }:$F)
     /* 60703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_I64),
     /* 60708 */   GIR_RootConstrainSelectedInstOperands,
     /* 60709 */   // GIR_Coverage, 296,
     /* 60709 */   GIR_Done,
     /* 60710 */ // Label 1424: @60710
     /* 60710 */ GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(60750), // Rule ID 298 //
     /* 60715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotFP64bit_NotMips4_32),
     /* 60718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60724 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60739 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60743 */   // (select:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, AFGR64Opnd:{ *:[f64] }:$T, AFGR64Opnd:{ *:[f64] }:$F)  =>  (PseudoSELECT_D32:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, AFGR64Opnd:{ *:[f64] }:$T, AFGR64Opnd:{ *:[f64] }:$F)
     /* 60743 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_D32),
     /* 60748 */   GIR_RootConstrainSelectedInstOperands,
     /* 60749 */   // GIR_Coverage, 298,
     /* 60749 */   GIR_Done,
     /* 60750 */ // Label 1425: @60750
     /* 60750 */ GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(60790), // Rule ID 299 //
     /* 60755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_NotMips4_32),
     /* 60758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60764 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60779 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60783 */   // (select:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, FGR64Opnd:{ *:[f64] }:$T, FGR64Opnd:{ *:[f64] }:$F)  =>  (PseudoSELECT_D64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, FGR64Opnd:{ *:[f64] }:$T, FGR64Opnd:{ *:[f64] }:$F)
     /* 60783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_D64),
     /* 60788 */   GIR_RootConstrainSelectedInstOperands,
     /* 60789 */   // GIR_Coverage, 299,
     /* 60789 */   GIR_Done,
     /* 60790 */ // Label 1426: @60790
     /* 60790 */ GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(60836), // Rule ID 1682 //
     /* 60795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60804 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60819 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60823 */   // (select:{ *:[i64] } GPR32:{ *:[i32] }:$cond, GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR32:{ *:[i32] }:$cond, GPR64:{ *:[i64] }:$F)
     /* 60823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I64),
     /* 60826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 60828 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60830 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60832 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60834 */   GIR_RootConstrainSelectedInstOperands,
     /* 60835 */   // GIR_Coverage, 1682,
     /* 60835 */   GIR_EraseRootFromParent_Done,
     /* 60836 */ // Label 1427: @60836
     /* 60836 */ GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(60882), // Rule ID 1688 //
     /* 60841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 60847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60850 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60865 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60869 */   // (select:{ *:[i64] } GPR64:{ *:[i64] }:$cond, GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$cond, GPR64:{ *:[i64] }:$F)
     /* 60869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I64),
     /* 60872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 60874 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60876 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60878 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60880 */   GIR_RootConstrainSelectedInstOperands,
     /* 60881 */   // GIR_Coverage, 1688,
     /* 60881 */   GIR_EraseRootFromParent_Done,
     /* 60882 */ // Label 1428: @60882
     /* 60882 */ GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(60928), // Rule ID 1727 //
     /* 60887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60896 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60907 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60911 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60915 */   // (select:{ *:[f64] } GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$F)
     /* 60915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32),
     /* 60918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60920 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60922 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60924 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60926 */   GIR_RootConstrainSelectedInstOperands,
     /* 60927 */   // GIR_Coverage, 1727,
     /* 60927 */   GIR_EraseRootFromParent_Done,
     /* 60928 */ // Label 1429: @60928
     /* 60928 */ GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(60974), // Rule ID 1750 //
     /* 60933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60942 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60957 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60961 */   // (select:{ *:[f64] } GPR32:{ *:[i32] }:$cond, FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$cond, FGR64:{ *:[f64] }:$F)
     /* 60961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D64),
     /* 60964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60966 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60968 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60970 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60972 */   GIR_RootConstrainSelectedInstOperands,
     /* 60973 */   // GIR_Coverage, 1750,
     /* 60973 */   GIR_EraseRootFromParent_Done,
     /* 60974 */ // Label 1430: @60974
     /* 60974 */ GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(61020), // Rule ID 1753 //
     /* 60979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 60985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60988 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 61003 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 61007 */   // (select:{ *:[f64] } GPR64:{ *:[i64] }:$cond, FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR64:{ *:[i64] }:$cond, FGR64:{ *:[f64] }:$F)
     /* 61007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_D64),
     /* 61010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61012 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 61014 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 61016 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 61018 */   GIR_RootConstrainSelectedInstOperands,
     /* 61019 */   // GIR_Coverage, 1753,
     /* 61019 */   GIR_EraseRootFromParent_Done,
     /* 61020 */ // Label 1431: @61020
     /* 61020 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(61066), // Rule ID 2292 //
     /* 61025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 61028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61034 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 61037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 61041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 61049 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 61053 */   // (select:{ *:[f64] } GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$F)
     /* 61053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32_MM),
     /* 61056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61058 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 61060 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 61062 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 61064 */   GIR_RootConstrainSelectedInstOperands,
     /* 61065 */   // GIR_Coverage, 2292,
     /* 61065 */   GIR_EraseRootFromParent_Done,
     /* 61066 */ // Label 1432: @61066
     /* 61066 */ GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(61144), // Rule ID 1798 //
     /* 61071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 61074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61080 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 61083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61087 */   // (select:{ *:[i64] } i64:{ *:[i64] }:$cond, i64:{ *:[i64] }:$t, i64:{ *:[i64] }:$f)  =>  (OR64:{ *:[i64] } (SELNEZ64:{ *:[i64] } i64:{ *:[i64] }:$t, i64:{ *:[i64] }:$cond), (SELEQZ64:{ *:[i64] } i64:{ *:[i64] }:$f, i64:{ *:[i64] }:$cond))
     /* 61087 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 61090 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SELEQZ64),
     /* 61094 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61099 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 61103 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 61109 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 61112 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ64),
     /* 61116 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61121 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 61125 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61129 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 61131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR64),
     /* 61134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 61136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 61139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 61142 */   GIR_RootConstrainSelectedInstOperands,
     /* 61143 */   // GIR_Coverage, 1798,
     /* 61143 */   GIR_EraseRootFromParent_Done,
     /* 61144 */ // Label 1433: @61144
     /* 61144 */ GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(61256), // Rule ID 1809 //
     /* 61149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 61152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61158 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 61161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61165 */   // (select:{ *:[i64] } i32:{ *:[i32] }:$cond, i64:{ *:[i64] }:$t, i64:{ *:[i64] }:$f)  =>  (OR64:{ *:[i64] } (SELNEZ64:{ *:[i64] } i64:{ *:[i64] }:$t, (SLL64_32:{ *:[i64] } i32:{ *:[i32] }:$cond)), (SELEQZ64:{ *:[i64] } i64:{ *:[i64] }:$f, (SLL64_32:{ *:[i64] } i32:{ *:[i32] }:$cond)))
     /* 61165 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 61168 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(Mips::SLL64_32),
     /* 61172 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61177 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 61183 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 61186 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SELEQZ64),
     /* 61190 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61195 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 61199 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 61202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 61204 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 61207 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SLL64_32),
     /* 61211 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61216 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 61222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 61225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ64),
     /* 61229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61234 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 61238 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 61241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 61243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR64),
     /* 61246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 61248 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 61251 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 61254 */   GIR_RootConstrainSelectedInstOperands,
     /* 61255 */   // GIR_Coverage, 1809,
     /* 61255 */   GIR_EraseRootFromParent_Done,
     /* 61256 */ // Label 1434: @61256
     /* 61256 */ GIM_Reject,
     /* 61257 */ // Label 1291: @61257
     /* 61257 */ GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(61330),
     /* 61262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 61265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 61268 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 61271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61283 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61287 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(61308), // Rule ID 583 //
     /* 61292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61295 */     // (vselect:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$wt, MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (BSEL_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 61295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_D_PSEUDO),
     /* 61298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61300 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61302 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61304 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61306 */     GIR_RootConstrainSelectedInstOperands,
     /* 61307 */     // GIR_Coverage, 583,
     /* 61307 */     GIR_EraseRootFromParent_Done,
     /* 61308 */   // Label 1436: @61308
     /* 61308 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(61329), // Rule ID 585 //
     /* 61313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61316 */     // (vselect:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$wt, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (BSEL_FD_PSEUDO:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 61316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_FD_PSEUDO),
     /* 61319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61321 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61323 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61325 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61327 */     GIR_RootConstrainSelectedInstOperands,
     /* 61328 */     // GIR_Coverage, 585,
     /* 61328 */     GIR_EraseRootFromParent_Done,
     /* 61329 */   // Label 1437: @61329
     /* 61329 */   GIM_Reject,
     /* 61330 */ // Label 1435: @61330
     /* 61330 */ GIM_Reject,
     /* 61331 */ // Label 1292: @61331
     /* 61331 */ GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(61404),
     /* 61336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 61339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 61342 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 61345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61353 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61357 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61361 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(61382), // Rule ID 582 //
     /* 61366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61369 */     // (vselect:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$wt, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (BSEL_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 61369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_W_PSEUDO),
     /* 61372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61374 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61376 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61378 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61380 */     GIR_RootConstrainSelectedInstOperands,
     /* 61381 */     // GIR_Coverage, 582,
     /* 61381 */     GIR_EraseRootFromParent_Done,
     /* 61382 */   // Label 1439: @61382
     /* 61382 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(61403), // Rule ID 584 //
     /* 61387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61390 */     // (vselect:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$wt, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (BSEL_FW_PSEUDO:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 61390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_FW_PSEUDO),
     /* 61393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61395 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61397 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61399 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61401 */     GIR_RootConstrainSelectedInstOperands,
     /* 61402 */     // GIR_Coverage, 584,
     /* 61402 */     GIR_EraseRootFromParent_Done,
     /* 61403 */   // Label 1440: @61403
     /* 61403 */   GIM_Reject,
     /* 61404 */ // Label 1438: @61404
     /* 61404 */ GIM_Reject,
     /* 61405 */ // Label 1293: @61405
     /* 61405 */ GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(61451), // Rule ID 581 //
     /* 61410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 61416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 61419 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 61422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61434 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61438 */   // (vselect:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$wt, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (BSEL_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 61438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_H_PSEUDO),
     /* 61441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61443 */   GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61445 */   GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61447 */   GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61449 */   GIR_RootConstrainSelectedInstOperands,
     /* 61450 */   // GIR_Coverage, 581,
     /* 61450 */   GIR_EraseRootFromParent_Done,
     /* 61451 */ // Label 1441: @61451
     /* 61451 */ GIM_Reject,
     /* 61452 */ // Label 1294: @61452
     /* 61452 */ GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(61546),
     /* 61457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 61460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 61463 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 61466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61478 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61482 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(61503), // Rule ID 568 //
     /* 61487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61490 */     // (vselect:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wt, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wd_in)  =>  (BMNZ_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 61490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BMNZ_V),
     /* 61493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61495 */     GIR_RootToRootCopy, /*OpIdx*/3, // wd_in
     /* 61497 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 61499 */     GIR_RootToRootCopy, /*OpIdx*/1, // wt
     /* 61501 */     GIR_RootConstrainSelectedInstOperands,
     /* 61502 */     // GIR_Coverage, 568,
     /* 61502 */     GIR_EraseRootFromParent_Done,
     /* 61503 */   // Label 1443: @61503
     /* 61503 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(61524), // Rule ID 570 //
     /* 61508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61511 */     // (vselect:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wt, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (BMZ_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 61511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BMZ_V),
     /* 61514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61516 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 61518 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61520 */     GIR_RootToRootCopy, /*OpIdx*/1, // wt
     /* 61522 */     GIR_RootConstrainSelectedInstOperands,
     /* 61523 */     // GIR_Coverage, 570,
     /* 61523 */     GIR_EraseRootFromParent_Done,
     /* 61524 */   // Label 1444: @61524
     /* 61524 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(61545), // Rule ID 580 //
     /* 61529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61532 */     // (vselect:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$wt, MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (BSEL_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 61532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_V),
     /* 61535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61537 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61539 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61541 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61543 */     GIR_RootConstrainSelectedInstOperands,
     /* 61544 */     // GIR_Coverage, 580,
     /* 61544 */     GIR_EraseRootFromParent_Done,
     /* 61545 */   // Label 1445: @61545
     /* 61545 */   GIM_Reject,
     /* 61546 */ // Label 1442: @61546
     /* 61546 */ GIM_Reject,
     /* 61547 */ // Label 1295: @61547
     /* 61547 */ GIM_Reject,
     /* 61548 */ // Label 44: @61548
     /* 61548 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1448*/ GIMT_Encode4(61656),
     /* 61559 */ /*GILLT_s32*//*Label 1446*/ GIMT_Encode4(61567),
     /* 61563 */ /*GILLT_s64*//*Label 1447*/ GIMT_Encode4(61622),
     /* 61567 */ // Label 1446: @61567
     /* 61567 */ GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(61621),
     /* 61572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 61578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61586 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61590 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(61605), // Rule ID 331 //
     /* 61595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 61598 */     // (mulhu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUHU:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUHU),
     /* 61603 */     GIR_RootConstrainSelectedInstOperands,
     /* 61604 */     // GIR_Coverage, 331,
     /* 61604 */     GIR_Done,
     /* 61605 */   // Label 1450: @61605
     /* 61605 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(61620), // Rule ID 1181 //
     /* 61610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 61613 */     // (mulhu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUHU_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUHU_MMR6),
     /* 61618 */     GIR_RootConstrainSelectedInstOperands,
     /* 61619 */     // GIR_Coverage, 1181,
     /* 61619 */     GIR_Done,
     /* 61620 */   // Label 1451: @61620
     /* 61620 */   GIM_Reject,
     /* 61621 */ // Label 1449: @61621
     /* 61621 */ GIM_Reject,
     /* 61622 */ // Label 1447: @61622
     /* 61622 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(61655), // Rule ID 346 //
     /* 61627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 61630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61648 */   // (mulhu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUHU:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 61648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUHU),
     /* 61653 */   GIR_RootConstrainSelectedInstOperands,
     /* 61654 */   // GIR_Coverage, 346,
     /* 61654 */   GIR_Done,
     /* 61655 */ // Label 1452: @61655
     /* 61655 */ GIM_Reject,
     /* 61656 */ // Label 1448: @61656
     /* 61656 */ GIM_Reject,
     /* 61657 */ // Label 45: @61657
     /* 61657 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1455*/ GIMT_Encode4(61765),
     /* 61668 */ /*GILLT_s32*//*Label 1453*/ GIMT_Encode4(61676),
     /* 61672 */ /*GILLT_s64*//*Label 1454*/ GIMT_Encode4(61731),
     /* 61676 */ // Label 1453: @61676
     /* 61676 */ GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(61730),
     /* 61681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 61687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61699 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(61714), // Rule ID 330 //
     /* 61704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 61707 */     // (mulhs:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUH:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61707 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUH),
     /* 61712 */     GIR_RootConstrainSelectedInstOperands,
     /* 61713 */     // GIR_Coverage, 330,
     /* 61713 */     GIR_Done,
     /* 61714 */   // Label 1457: @61714
     /* 61714 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(61729), // Rule ID 1180 //
     /* 61719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 61722 */     // (mulhs:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUH_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUH_MMR6),
     /* 61727 */     GIR_RootConstrainSelectedInstOperands,
     /* 61728 */     // GIR_Coverage, 1180,
     /* 61728 */     GIR_Done,
     /* 61729 */   // Label 1458: @61729
     /* 61729 */   GIM_Reject,
     /* 61730 */ // Label 1456: @61730
     /* 61730 */ GIM_Reject,
     /* 61731 */ // Label 1454: @61731
     /* 61731 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(61764), // Rule ID 345 //
     /* 61736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 61739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61753 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61757 */   // (mulhs:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUH:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 61757 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUH),
     /* 61762 */   GIR_RootConstrainSelectedInstOperands,
     /* 61763 */   // GIR_Coverage, 345,
     /* 61763 */   GIR_Done,
     /* 61764 */ // Label 1459: @61764
     /* 61764 */ GIM_Reject,
     /* 61765 */ // Label 1455: @61765
     /* 61765 */ GIM_Reject,
     /* 61766 */ // Label 46: @61766
     /* 61766 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1464*/ GIMT_Encode4(62678),
     /* 61777 */ /*GILLT_s32*//*Label 1460*/ GIMT_Encode4(61801),
     /* 61781 */ /*GILLT_s64*//*Label 1461*/ GIMT_Encode4(62005), GIMT_Encode4(0),
     /* 61789 */ /*GILLT_v2s64*//*Label 1462*/ GIMT_Encode4(62370), GIMT_Encode4(0),
     /* 61797 */ /*GILLT_v4s32*//*Label 1463*/ GIMT_Encode4(62524),
     /* 61801 */ // Label 1460: @61801
     /* 61801 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(62004),
     /* 61806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 61812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61816 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(61873), // Rule ID 163 //
     /* 61821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 61824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 61828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 61832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 61836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 61840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 61856 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr)  =>  (MADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_S),
     /* 61859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61861 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 61863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 61867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 61871 */     GIR_RootConstrainSelectedInstOperands,
     /* 61872 */     // GIR_Coverage, 163,
     /* 61872 */     GIR_EraseRootFromParent_Done,
     /* 61873 */   // Label 1466: @61873
     /* 61873 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(61930), // Rule ID 2356 //
     /* 61878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 61881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 61889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 61893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 61897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 61901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 61913 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft))  =>  (MADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_S),
     /* 61916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61918 */     GIR_RootToRootCopy, /*OpIdx*/1, // fr
     /* 61920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 61924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 61928 */     GIR_RootConstrainSelectedInstOperands,
     /* 61929 */     // GIR_Coverage, 2356,
     /* 61929 */     GIR_EraseRootFromParent_Done,
     /* 61930 */   // Label 1467: @61930
     /* 61930 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(61953), // Rule ID 151 //
     /* 61935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 61938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61946 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_S),
     /* 61951 */     GIR_RootConstrainSelectedInstOperands,
     /* 61952 */     // GIR_Coverage, 151,
     /* 61952 */     GIR_Done,
     /* 61953 */   // Label 1468: @61953
     /* 61953 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(61976), // Rule ID 1130 //
     /* 61958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 61961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61969 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FADD_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_S_MM),
     /* 61974 */     GIR_RootConstrainSelectedInstOperands,
     /* 61975 */     // GIR_Coverage, 1130,
     /* 61975 */     GIR_Done,
     /* 61976 */   // Label 1469: @61976
     /* 61976 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(62003), // Rule ID 1188 //
     /* 61981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 61984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61992 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FADD_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 61992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FADD_S_MMR6),
     /* 61995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61997 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 61999 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 62001 */     GIR_RootConstrainSelectedInstOperands,
     /* 62002 */     // GIR_Coverage, 1188,
     /* 62002 */     GIR_EraseRootFromParent_Done,
     /* 62003 */   // Label 1470: @62003
     /* 62003 */   GIM_Reject,
     /* 62004 */ // Label 1465: @62004
     /* 62004 */ GIM_Reject,
     /* 62005 */ // Label 1461: @62005
     /* 62005 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(62369),
     /* 62010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 62013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 62016 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(62077), // Rule ID 165 //
     /* 62021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62060 */     // (fadd:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr)  =>  (MADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D32),
     /* 62063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62065 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62075 */     GIR_RootConstrainSelectedInstOperands,
     /* 62076 */     // GIR_Coverage, 165,
     /* 62076 */     GIR_EraseRootFromParent_Done,
     /* 62077 */   // Label 1472: @62077
     /* 62077 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(62138), // Rule ID 167 //
     /* 62082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62121 */     // (fadd:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr)  =>  (MADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D64),
     /* 62124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62126 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62136 */     GIR_RootConstrainSelectedInstOperands,
     /* 62137 */     // GIR_Coverage, 167,
     /* 62137 */     GIR_EraseRootFromParent_Done,
     /* 62138 */   // Label 1473: @62138
     /* 62138 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(62199), // Rule ID 2357 //
     /* 62143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62182 */     // (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft))  =>  (MADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D32),
     /* 62185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62187 */     GIR_RootToRootCopy, /*OpIdx*/1, // fr
     /* 62189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62197 */     GIR_RootConstrainSelectedInstOperands,
     /* 62198 */     // GIR_Coverage, 2357,
     /* 62198 */     GIR_EraseRootFromParent_Done,
     /* 62199 */   // Label 1474: @62199
     /* 62199 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(62260), // Rule ID 2358 //
     /* 62204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62243 */     // (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft))  =>  (MADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D64),
     /* 62246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62248 */     GIR_RootToRootCopy, /*OpIdx*/1, // fr
     /* 62250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62258 */     GIR_RootConstrainSelectedInstOperands,
     /* 62259 */     // GIR_Coverage, 2358,
     /* 62259 */     GIR_EraseRootFromParent_Done,
     /* 62260 */   // Label 1475: @62260
     /* 62260 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(62287), // Rule ID 152 //
     /* 62265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 62268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62280 */     // (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D32),
     /* 62285 */     GIR_RootConstrainSelectedInstOperands,
     /* 62286 */     // GIR_Coverage, 152,
     /* 62286 */     GIR_Done,
     /* 62287 */   // Label 1476: @62287
     /* 62287 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(62314), // Rule ID 153 //
     /* 62292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 62295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62307 */     // (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D64),
     /* 62312 */     GIR_RootConstrainSelectedInstOperands,
     /* 62313 */     // GIR_Coverage, 153,
     /* 62313 */     GIR_Done,
     /* 62314 */   // Label 1477: @62314
     /* 62314 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(62341), // Rule ID 1134 //
     /* 62319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 62322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62334 */     // (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D32_MM),
     /* 62339 */     GIR_RootConstrainSelectedInstOperands,
     /* 62340 */     // GIR_Coverage, 1134,
     /* 62340 */     GIR_Done,
     /* 62341 */   // Label 1478: @62341
     /* 62341 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(62368), // Rule ID 1135 //
     /* 62346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 62349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62361 */     // (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D64_MM),
     /* 62366 */     GIR_RootConstrainSelectedInstOperands,
     /* 62367 */     // GIR_Coverage, 1135,
     /* 62367 */     GIR_Done,
     /* 62368 */   // Label 1479: @62368
     /* 62368 */   GIM_Reject,
     /* 62369 */ // Label 1471: @62369
     /* 62369 */ GIM_Reject,
     /* 62370 */ // Label 1462: @62370
     /* 62370 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(62523),
     /* 62375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 62378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 62381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62385 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(62442), // Rule ID 2463 //
     /* 62390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 62405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 62409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62425 */     // (fadd:{ *:[v2f64] } (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt), MSA128DOpnd:{ *:[v2f64] }:$wd)  =>  (FMADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 62425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_D),
     /* 62428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62430 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd
     /* 62432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62440 */     GIR_RootConstrainSelectedInstOperands,
     /* 62441 */     // GIR_Coverage, 2463,
     /* 62441 */     GIR_EraseRootFromParent_Done,
     /* 62442 */   // Label 1481: @62442
     /* 62442 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(62499), // Rule ID 1993 //
     /* 62447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 62466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 62470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62482 */     // (fadd:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt))  =>  (FMADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 62482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_D),
     /* 62485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62487 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 62489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62497 */     GIR_RootConstrainSelectedInstOperands,
     /* 62498 */     // GIR_Coverage, 1993,
     /* 62498 */     GIR_EraseRootFromParent_Done,
     /* 62499 */   // Label 1482: @62499
     /* 62499 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(62522), // Rule ID 671 //
     /* 62504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 62507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62515 */     // (fadd:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 62515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D),
     /* 62520 */     GIR_RootConstrainSelectedInstOperands,
     /* 62521 */     // GIR_Coverage, 671,
     /* 62521 */     GIR_Done,
     /* 62522 */   // Label 1483: @62522
     /* 62522 */   GIM_Reject,
     /* 62523 */ // Label 1480: @62523
     /* 62523 */ GIM_Reject,
     /* 62524 */ // Label 1463: @62524
     /* 62524 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(62677),
     /* 62529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 62532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 62535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62539 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(62596), // Rule ID 2462 //
     /* 62544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 62559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 62563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62579 */     // (fadd:{ *:[v4f32] } (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt), MSA128WOpnd:{ *:[v4f32] }:$wd)  =>  (FMADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 62579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_W),
     /* 62582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62584 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd
     /* 62586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62594 */     GIR_RootConstrainSelectedInstOperands,
     /* 62595 */     // GIR_Coverage, 2462,
     /* 62595 */     GIR_EraseRootFromParent_Done,
     /* 62596 */   // Label 1485: @62596
     /* 62596 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(62653), // Rule ID 1992 //
     /* 62601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 62620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 62624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62636 */     // (fadd:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt))  =>  (FMADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 62636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_W),
     /* 62639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62641 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 62643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62651 */     GIR_RootConstrainSelectedInstOperands,
     /* 62652 */     // GIR_Coverage, 1992,
     /* 62652 */     GIR_EraseRootFromParent_Done,
     /* 62653 */   // Label 1486: @62653
     /* 62653 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(62676), // Rule ID 670 //
     /* 62658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 62661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62669 */     // (fadd:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 62669 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_W),
     /* 62674 */     GIR_RootConstrainSelectedInstOperands,
     /* 62675 */     // GIR_Coverage, 670,
     /* 62675 */     GIR_Done,
     /* 62676 */   // Label 1487: @62676
     /* 62676 */   GIM_Reject,
     /* 62677 */ // Label 1484: @62677
     /* 62677 */ GIM_Reject,
     /* 62678 */ // Label 1464: @62678
     /* 62678 */ GIM_Reject,
     /* 62679 */ // Label 47: @62679
     /* 62679 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1492*/ GIMT_Encode4(63290),
     /* 62690 */ /*GILLT_s32*//*Label 1488*/ GIMT_Encode4(62714),
     /* 62694 */ /*GILLT_s64*//*Label 1489*/ GIMT_Encode4(62861), GIMT_Encode4(0),
     /* 62702 */ /*GILLT_v2s64*//*Label 1490*/ GIMT_Encode4(63104), GIMT_Encode4(0),
     /* 62710 */ /*GILLT_v4s32*//*Label 1491*/ GIMT_Encode4(63197),
     /* 62714 */ // Label 1488: @62714
     /* 62714 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(62860),
     /* 62719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 62722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 62725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62729 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(62786), // Rule ID 164 //
     /* 62734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 62749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 62753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62769 */     // (fsub:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr)  =>  (MSUB_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 62769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_S),
     /* 62772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62774 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62784 */     GIR_RootConstrainSelectedInstOperands,
     /* 62785 */     // GIR_Coverage, 164,
     /* 62785 */     GIR_EraseRootFromParent_Done,
     /* 62786 */   // Label 1494: @62786
     /* 62786 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(62809), // Rule ID 160 //
     /* 62791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 62794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62802 */     // (fsub:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FSUB_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 62802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_S),
     /* 62807 */     GIR_RootConstrainSelectedInstOperands,
     /* 62808 */     // GIR_Coverage, 160,
     /* 62808 */     GIR_Done,
     /* 62809 */   // Label 1495: @62809
     /* 62809 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(62832), // Rule ID 1133 //
     /* 62814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 62817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62825 */     // (fsub:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FSUB_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 62825 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_S_MM),
     /* 62830 */     GIR_RootConstrainSelectedInstOperands,
     /* 62831 */     // GIR_Coverage, 1133,
     /* 62831 */     GIR_Done,
     /* 62832 */   // Label 1496: @62832
     /* 62832 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(62859), // Rule ID 1189 //
     /* 62837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 62840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62848 */     // (fsub:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FSUB_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 62848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUB_S_MMR6),
     /* 62851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62853 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 62855 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 62857 */     GIR_RootConstrainSelectedInstOperands,
     /* 62858 */     // GIR_Coverage, 1189,
     /* 62858 */     GIR_EraseRootFromParent_Done,
     /* 62859 */   // Label 1497: @62859
     /* 62859 */   GIM_Reject,
     /* 62860 */ // Label 1493: @62860
     /* 62860 */ GIM_Reject,
     /* 62861 */ // Label 1489: @62861
     /* 62861 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(63103),
     /* 62866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 62869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 62872 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(62933), // Rule ID 166 //
     /* 62877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62916 */     // (fsub:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr)  =>  (MSUB_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_D32),
     /* 62919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62921 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62931 */     GIR_RootConstrainSelectedInstOperands,
     /* 62932 */     // GIR_Coverage, 166,
     /* 62932 */     GIR_EraseRootFromParent_Done,
     /* 62933 */   // Label 1499: @62933
     /* 62933 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(62994), // Rule ID 168 //
     /* 62938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62977 */     // (fsub:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr)  =>  (MSUB_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_D64),
     /* 62980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62982 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62992 */     GIR_RootConstrainSelectedInstOperands,
     /* 62993 */     // GIR_Coverage, 168,
     /* 62993 */     GIR_EraseRootFromParent_Done,
     /* 62994 */   // Label 1500: @62994
     /* 62994 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(63021), // Rule ID 161 //
     /* 62999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 63002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63014 */     // (fsub:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D32),
     /* 63019 */     GIR_RootConstrainSelectedInstOperands,
     /* 63020 */     // GIR_Coverage, 161,
     /* 63020 */     GIR_Done,
     /* 63021 */   // Label 1501: @63021
     /* 63021 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(63048), // Rule ID 162 //
     /* 63026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 63029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63041 */     // (fsub:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D64),
     /* 63046 */     GIR_RootConstrainSelectedInstOperands,
     /* 63047 */     // GIR_Coverage, 162,
     /* 63047 */     GIR_Done,
     /* 63048 */   // Label 1502: @63048
     /* 63048 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(63075), // Rule ID 1140 //
     /* 63053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 63056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63068 */     // (fsub:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D32_MM),
     /* 63073 */     GIR_RootConstrainSelectedInstOperands,
     /* 63074 */     // GIR_Coverage, 1140,
     /* 63074 */     GIR_Done,
     /* 63075 */   // Label 1503: @63075
     /* 63075 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(63102), // Rule ID 1141 //
     /* 63080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 63083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63095 */     // (fsub:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D64_MM),
     /* 63100 */     GIR_RootConstrainSelectedInstOperands,
     /* 63101 */     // GIR_Coverage, 1141,
     /* 63101 */     GIR_Done,
     /* 63102 */   // Label 1504: @63102
     /* 63102 */   GIM_Reject,
     /* 63103 */ // Label 1498: @63103
     /* 63103 */ GIM_Reject,
     /* 63104 */ // Label 1490: @63104
     /* 63104 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(63196),
     /* 63109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63123 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(63176), // Rule ID 1991 //
     /* 63128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 63131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 63139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63159 */     // (fsub:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt))  =>  (FMSUB_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMSUB_D),
     /* 63162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63164 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 63166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 63170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 63174 */     GIR_RootConstrainSelectedInstOperands,
     /* 63175 */     // GIR_Coverage, 1991,
     /* 63175 */     GIR_EraseRootFromParent_Done,
     /* 63176 */   // Label 1506: @63176
     /* 63176 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(63195), // Rule ID 759 //
     /* 63181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63188 */     // (fsub:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUB_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D),
     /* 63193 */     GIR_RootConstrainSelectedInstOperands,
     /* 63194 */     // GIR_Coverage, 759,
     /* 63194 */     GIR_Done,
     /* 63195 */   // Label 1507: @63195
     /* 63195 */   GIM_Reject,
     /* 63196 */ // Label 1505: @63196
     /* 63196 */ GIM_Reject,
     /* 63197 */ // Label 1491: @63197
     /* 63197 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(63289),
     /* 63202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63216 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(63269), // Rule ID 1990 //
     /* 63221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 63224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 63232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63252 */     // (fsub:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt))  =>  (FMSUB_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMSUB_W),
     /* 63255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63257 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 63259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 63263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 63267 */     GIR_RootConstrainSelectedInstOperands,
     /* 63268 */     // GIR_Coverage, 1990,
     /* 63268 */     GIR_EraseRootFromParent_Done,
     /* 63269 */   // Label 1509: @63269
     /* 63269 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(63288), // Rule ID 758 //
     /* 63274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63281 */     // (fsub:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUB_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_W),
     /* 63286 */     GIR_RootConstrainSelectedInstOperands,
     /* 63287 */     // GIR_Coverage, 758,
     /* 63287 */     GIR_Done,
     /* 63288 */   // Label 1510: @63288
     /* 63288 */   GIM_Reject,
     /* 63289 */ // Label 1508: @63289
     /* 63289 */ GIM_Reject,
     /* 63290 */ // Label 1492: @63290
     /* 63290 */ GIM_Reject,
     /* 63291 */ // Label 48: @63291
     /* 63291 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1515*/ GIMT_Encode4(63777),
     /* 63302 */ /*GILLT_s32*//*Label 1511*/ GIMT_Encode4(63326),
     /* 63306 */ /*GILLT_s64*//*Label 1512*/ GIMT_Encode4(63400), GIMT_Encode4(0),
     /* 63314 */ /*GILLT_v2s64*//*Label 1513*/ GIMT_Encode4(63521), GIMT_Encode4(0),
     /* 63322 */ /*GILLT_v4s32*//*Label 1514*/ GIMT_Encode4(63649),
     /* 63326 */ // Label 1511: @63326
     /* 63326 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(63399),
     /* 63331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 63334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 63337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63349 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(63364), // Rule ID 157 //
     /* 63354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 63357 */     // (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FMUL_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_S),
     /* 63362 */     GIR_RootConstrainSelectedInstOperands,
     /* 63363 */     // GIR_Coverage, 157,
     /* 63363 */     GIR_Done,
     /* 63364 */   // Label 1517: @63364
     /* 63364 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(63379), // Rule ID 1132 //
     /* 63369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 63372 */     // (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FMUL_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_S_MM),
     /* 63377 */     GIR_RootConstrainSelectedInstOperands,
     /* 63378 */     // GIR_Coverage, 1132,
     /* 63378 */     GIR_Done,
     /* 63379 */   // Label 1518: @63379
     /* 63379 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(63398), // Rule ID 1190 //
     /* 63384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 63387 */     // (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FMUL_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 63387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMUL_S_MMR6),
     /* 63390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 63392 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 63394 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 63396 */     GIR_RootConstrainSelectedInstOperands,
     /* 63397 */     // GIR_Coverage, 1190,
     /* 63397 */     GIR_EraseRootFromParent_Done,
     /* 63398 */   // Label 1519: @63398
     /* 63398 */   GIM_Reject,
     /* 63399 */ // Label 1516: @63399
     /* 63399 */ GIM_Reject,
     /* 63400 */ // Label 1512: @63400
     /* 63400 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(63520),
     /* 63405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 63408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 63411 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(63438), // Rule ID 158 //
     /* 63416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 63419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63431 */     // (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D32),
     /* 63436 */     GIR_RootConstrainSelectedInstOperands,
     /* 63437 */     // GIR_Coverage, 158,
     /* 63437 */     GIR_Done,
     /* 63438 */   // Label 1521: @63438
     /* 63438 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(63465), // Rule ID 159 //
     /* 63443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 63446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63458 */     // (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63458 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D64),
     /* 63463 */     GIR_RootConstrainSelectedInstOperands,
     /* 63464 */     // GIR_Coverage, 159,
     /* 63464 */     GIR_Done,
     /* 63465 */   // Label 1522: @63465
     /* 63465 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(63492), // Rule ID 1138 //
     /* 63470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 63473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63485 */     // (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D32_MM),
     /* 63490 */     GIR_RootConstrainSelectedInstOperands,
     /* 63491 */     // GIR_Coverage, 1138,
     /* 63491 */     GIR_Done,
     /* 63492 */   // Label 1523: @63492
     /* 63492 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(63519), // Rule ID 1139 //
     /* 63497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 63500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63512 */     // (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D64_MM),
     /* 63517 */     GIR_RootConstrainSelectedInstOperands,
     /* 63518 */     // GIR_Coverage, 1139,
     /* 63518 */     GIR_Done,
     /* 63519 */   // Label 1524: @63519
     /* 63519 */   GIM_Reject,
     /* 63520 */ // Label 1520: @63520
     /* 63520 */ GIM_Reject,
     /* 63521 */ // Label 1513: @63521
     /* 63521 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(63648),
     /* 63526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63536 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(63580), // Rule ID 2399 //
     /* 63541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 63548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63567 */     // (fmul:{ *:[v2f64] } (fexp2:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wt), MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FEXP2_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_D),
     /* 63570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63572 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 63574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63578 */     GIR_RootConstrainSelectedInstOperands,
     /* 63579 */     // GIR_Coverage, 2399,
     /* 63579 */     GIR_EraseRootFromParent_Done,
     /* 63580 */   // Label 1526: @63580
     /* 63580 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(63624), // Rule ID 701 //
     /* 63585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63611 */     // (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, (fexp2:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wt))  =>  (FEXP2_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_D),
     /* 63614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63616 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 63618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63622 */     GIR_RootConstrainSelectedInstOperands,
     /* 63623 */     // GIR_Coverage, 701,
     /* 63623 */     GIR_EraseRootFromParent_Done,
     /* 63624 */   // Label 1527: @63624
     /* 63624 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(63647), // Rule ID 737 //
     /* 63629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63640 */     // (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMUL_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D),
     /* 63645 */     GIR_RootConstrainSelectedInstOperands,
     /* 63646 */     // GIR_Coverage, 737,
     /* 63646 */     GIR_Done,
     /* 63647 */   // Label 1528: @63647
     /* 63647 */   GIM_Reject,
     /* 63648 */ // Label 1525: @63648
     /* 63648 */ GIM_Reject,
     /* 63649 */ // Label 1514: @63649
     /* 63649 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(63776),
     /* 63654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63664 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(63708), // Rule ID 2398 //
     /* 63669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 63676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63695 */     // (fmul:{ *:[v4f32] } (fexp2:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wt), MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FEXP2_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_W),
     /* 63698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63700 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 63702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63706 */     GIR_RootConstrainSelectedInstOperands,
     /* 63707 */     // GIR_Coverage, 2398,
     /* 63707 */     GIR_EraseRootFromParent_Done,
     /* 63708 */   // Label 1530: @63708
     /* 63708 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(63752), // Rule ID 700 //
     /* 63713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63739 */     // (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, (fexp2:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wt))  =>  (FEXP2_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_W),
     /* 63742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63744 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 63746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63750 */     GIR_RootConstrainSelectedInstOperands,
     /* 63751 */     // GIR_Coverage, 700,
     /* 63751 */     GIR_EraseRootFromParent_Done,
     /* 63752 */   // Label 1531: @63752
     /* 63752 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(63775), // Rule ID 736 //
     /* 63757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63768 */     // (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMUL_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_W),
     /* 63773 */     GIR_RootConstrainSelectedInstOperands,
     /* 63774 */     // GIR_Coverage, 736,
     /* 63774 */     GIR_Done,
     /* 63775 */   // Label 1532: @63775
     /* 63775 */   GIM_Reject,
     /* 63776 */ // Label 1529: @63776
     /* 63776 */ GIM_Reject,
     /* 63777 */ // Label 1515: @63777
     /* 63777 */ GIM_Reject,
     /* 63778 */ // Label 49: @63778
     /* 63778 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1535*/ GIMT_Encode4(63883),
     /* 63789 */ /*GILLT_v2s64*//*Label 1533*/ GIMT_Encode4(63801), GIMT_Encode4(0),
     /* 63797 */ /*GILLT_v4s32*//*Label 1534*/ GIMT_Encode4(63842),
     /* 63801 */ // Label 1533: @63801
     /* 63801 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(63841), // Rule ID 725 //
     /* 63806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63815 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 63818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63826 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63830 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63834 */   // (fma:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMADD_D),
     /* 63839 */   GIR_RootConstrainSelectedInstOperands,
     /* 63840 */   // GIR_Coverage, 725,
     /* 63840 */   GIR_Done,
     /* 63841 */ // Label 1536: @63841
     /* 63841 */ GIM_Reject,
     /* 63842 */ // Label 1534: @63842
     /* 63842 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(63882), // Rule ID 724 //
     /* 63847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63856 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 63859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63871 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63875 */   // (fma:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63875 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMADD_W),
     /* 63880 */   GIR_RootConstrainSelectedInstOperands,
     /* 63881 */   // GIR_Coverage, 724,
     /* 63881 */   GIR_Done,
     /* 63882 */ // Label 1537: @63882
     /* 63882 */ GIM_Reject,
     /* 63883 */ // Label 1535: @63883
     /* 63883 */ GIM_Reject,
     /* 63884 */ // Label 50: @63884
     /* 63884 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1542*/ GIMT_Encode4(64182),
     /* 63895 */ /*GILLT_s32*//*Label 1538*/ GIMT_Encode4(63919),
     /* 63899 */ /*GILLT_s64*//*Label 1539*/ GIMT_Encode4(63993), GIMT_Encode4(0),
     /* 63907 */ /*GILLT_v2s64*//*Label 1540*/ GIMT_Encode4(64114), GIMT_Encode4(0),
     /* 63915 */ /*GILLT_v4s32*//*Label 1541*/ GIMT_Encode4(64148),
     /* 63919 */ // Label 1538: @63919
     /* 63919 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(63992),
     /* 63924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 63927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 63930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63942 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(63957), // Rule ID 154 //
     /* 63947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 63950 */     // (fdiv:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FDIV_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_S),
     /* 63955 */     GIR_RootConstrainSelectedInstOperands,
     /* 63956 */     // GIR_Coverage, 154,
     /* 63956 */     GIR_Done,
     /* 63957 */   // Label 1544: @63957
     /* 63957 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(63972), // Rule ID 1131 //
     /* 63962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 63965 */     // (fdiv:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FDIV_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_S_MM),
     /* 63970 */     GIR_RootConstrainSelectedInstOperands,
     /* 63971 */     // GIR_Coverage, 1131,
     /* 63971 */     GIR_Done,
     /* 63972 */   // Label 1545: @63972
     /* 63972 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(63991), // Rule ID 1191 //
     /* 63977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 63980 */     // (fdiv:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FDIV_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 63980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FDIV_S_MMR6),
     /* 63983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 63985 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 63987 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 63989 */     GIR_RootConstrainSelectedInstOperands,
     /* 63990 */     // GIR_Coverage, 1191,
     /* 63990 */     GIR_EraseRootFromParent_Done,
     /* 63991 */   // Label 1546: @63991
     /* 63991 */   GIM_Reject,
     /* 63992 */ // Label 1543: @63992
     /* 63992 */ GIM_Reject,
     /* 63993 */ // Label 1539: @63993
     /* 63993 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(64113),
     /* 63998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 64001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 64004 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(64031), // Rule ID 155 //
     /* 64009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 64012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64024 */     // (fdiv:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 64024 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D32),
     /* 64029 */     GIR_RootConstrainSelectedInstOperands,
     /* 64030 */     // GIR_Coverage, 155,
     /* 64030 */     GIR_Done,
     /* 64031 */   // Label 1548: @64031
     /* 64031 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(64058), // Rule ID 156 //
     /* 64036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 64039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64051 */     // (fdiv:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 64051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D64),
     /* 64056 */     GIR_RootConstrainSelectedInstOperands,
     /* 64057 */     // GIR_Coverage, 156,
     /* 64057 */     GIR_Done,
     /* 64058 */   // Label 1549: @64058
     /* 64058 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(64085), // Rule ID 1136 //
     /* 64063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 64066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64078 */     // (fdiv:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 64078 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D32_MM),
     /* 64083 */     GIR_RootConstrainSelectedInstOperands,
     /* 64084 */     // GIR_Coverage, 1136,
     /* 64084 */     GIR_Done,
     /* 64085 */   // Label 1550: @64085
     /* 64085 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(64112), // Rule ID 1137 //
     /* 64090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 64093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64105 */     // (fdiv:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 64105 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D64_MM),
     /* 64110 */     GIR_RootConstrainSelectedInstOperands,
     /* 64111 */     // GIR_Coverage, 1137,
     /* 64111 */     GIR_Done,
     /* 64112 */   // Label 1551: @64112
     /* 64112 */   GIM_Reject,
     /* 64113 */ // Label 1547: @64113
     /* 64113 */ GIM_Reject,
     /* 64114 */ // Label 1540: @64114
     /* 64114 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(64147), // Rule ID 697 //
     /* 64119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 64125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 64128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64136 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64140 */   // (fdiv:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FDIV_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 64140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D),
     /* 64145 */   GIR_RootConstrainSelectedInstOperands,
     /* 64146 */   // GIR_Coverage, 697,
     /* 64146 */   GIR_Done,
     /* 64147 */ // Label 1552: @64147
     /* 64147 */ GIM_Reject,
     /* 64148 */ // Label 1541: @64148
     /* 64148 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(64181), // Rule ID 696 //
     /* 64153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 64159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 64162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64174 */   // (fdiv:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FDIV_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 64174 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_W),
     /* 64179 */   GIR_RootConstrainSelectedInstOperands,
     /* 64180 */   // GIR_Coverage, 696,
     /* 64180 */   GIR_Done,
     /* 64181 */ // Label 1553: @64181
     /* 64181 */ GIM_Reject,
     /* 64182 */ // Label 1542: @64182
     /* 64182 */ GIM_Reject,
     /* 64183 */ // Label 51: @64183
     /* 64183 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1556*/ GIMT_Encode4(64260),
     /* 64194 */ /*GILLT_v2s64*//*Label 1554*/ GIMT_Encode4(64206), GIMT_Encode4(0),
     /* 64202 */ /*GILLT_v4s32*//*Label 1555*/ GIMT_Encode4(64233),
     /* 64206 */ // Label 1554: @64206
     /* 64206 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(64232), // Rule ID 703 //
     /* 64211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 64217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64225 */   // (fexp2:{ *:[v2f64] } MSA128D:{ *:[v2f64] }:$ws)  =>  (FEXP2_D_1_PSEUDO:{ *:[v2f64] } MSA128D:{ *:[v2f64] }:$ws)
     /* 64225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FEXP2_D_1_PSEUDO),
     /* 64230 */   GIR_RootConstrainSelectedInstOperands,
     /* 64231 */   // GIR_Coverage, 703,
     /* 64231 */   GIR_Done,
     /* 64232 */ // Label 1557: @64232
     /* 64232 */ GIM_Reject,
     /* 64233 */ // Label 1555: @64233
     /* 64233 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(64259), // Rule ID 702 //
     /* 64238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 64244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64252 */   // (fexp2:{ *:[v4f32] } MSA128W:{ *:[v4f32] }:$ws)  =>  (FEXP2_W_1_PSEUDO:{ *:[v4f32] } MSA128W:{ *:[v4f32] }:$ws)
     /* 64252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FEXP2_W_1_PSEUDO),
     /* 64257 */   GIR_RootConstrainSelectedInstOperands,
     /* 64258 */   // GIR_Coverage, 702,
     /* 64258 */   GIR_Done,
     /* 64259 */ // Label 1558: @64259
     /* 64259 */ GIM_Reject,
     /* 64260 */ // Label 1556: @64260
     /* 64260 */ GIM_Reject,
     /* 64261 */ // Label 52: @64261
     /* 64261 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1561*/ GIMT_Encode4(64338),
     /* 64272 */ /*GILLT_v2s64*//*Label 1559*/ GIMT_Encode4(64284), GIMT_Encode4(0),
     /* 64280 */ /*GILLT_v4s32*//*Label 1560*/ GIMT_Encode4(64311),
     /* 64284 */ // Label 1559: @64284
     /* 64284 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(64310), // Rule ID 723 //
     /* 64289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 64295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64303 */   // (flog2:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FLOG2_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 64303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FLOG2_D),
     /* 64308 */   GIR_RootConstrainSelectedInstOperands,
     /* 64309 */   // GIR_Coverage, 723,
     /* 64309 */   GIR_Done,
     /* 64310 */ // Label 1562: @64310
     /* 64310 */ GIM_Reject,
     /* 64311 */ // Label 1560: @64311
     /* 64311 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(64337), // Rule ID 722 //
     /* 64316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 64322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64330 */   // (flog2:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FLOG2_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 64330 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FLOG2_W),
     /* 64335 */   GIR_RootConstrainSelectedInstOperands,
     /* 64336 */   // GIR_Coverage, 722,
     /* 64336 */   GIR_Done,
     /* 64337 */ // Label 1563: @64337
     /* 64337 */ GIM_Reject,
     /* 64338 */ // Label 1561: @64338
     /* 64338 */ GIM_Reject,
     /* 64339 */ // Label 53: @64339
     /* 64339 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1566*/ GIMT_Encode4(65707),
     /* 64350 */ /*GILLT_s32*//*Label 1564*/ GIMT_Encode4(64358),
     /* 64354 */ /*GILLT_s64*//*Label 1565*/ GIMT_Encode4(64885),
     /* 64358 */ // Label 1564: @64358
     /* 64358 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(64884),
     /* 64363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 64366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64370 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(64446), // Rule ID 1460 //
     /* 64375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64427 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S),
     /* 64430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64444 */     GIR_RootConstrainSelectedInstOperands,
     /* 64445 */     // GIR_Coverage, 1460,
     /* 64445 */     GIR_EraseRootFromParent_Done,
     /* 64446 */   // Label 1568: @64446
     /* 64446 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(64522), // Rule ID 2248 //
     /* 64451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6),
     /* 64454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64503 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMADD_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S_MM),
     /* 64506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64520 */     GIR_RootConstrainSelectedInstOperands,
     /* 64521 */     // GIR_Coverage, 2248,
     /* 64521 */     GIR_EraseRootFromParent_Done,
     /* 64522 */   // Label 1569: @64522
     /* 64522 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(64598), // Rule ID 2434 //
     /* 64527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 64555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64579 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)))  =>  (NMADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S),
     /* 64582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 64588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64596 */     GIR_RootConstrainSelectedInstOperands,
     /* 64597 */     // GIR_Coverage, 2434,
     /* 64597 */     GIR_EraseRootFromParent_Done,
     /* 64598 */   // Label 1570: @64598
     /* 64598 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(64674), // Rule ID 2520 //
     /* 64603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6),
     /* 64606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 64631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64655 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)))  =>  (NMADD_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S_MM),
     /* 64658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 64664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64672 */     GIR_RootConstrainSelectedInstOperands,
     /* 64673 */     // GIR_Coverage, 2520,
     /* 64673 */     GIR_EraseRootFromParent_Done,
     /* 64674 */   // Label 1571: @64674
     /* 64674 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(64750), // Rule ID 1461 //
     /* 64679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 64690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64719 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64731 */     // (fneg:{ *:[f32] } (fsub:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMSUB_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_S),
     /* 64734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64748 */     GIR_RootConstrainSelectedInstOperands,
     /* 64749 */     // GIR_Coverage, 1461,
     /* 64749 */     GIR_EraseRootFromParent_Done,
     /* 64750 */   // Label 1572: @64750
     /* 64750 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(64826), // Rule ID 2249 //
     /* 64755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6),
     /* 64758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 64766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64795 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64807 */     // (fneg:{ *:[f32] } (fsub:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMSUB_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_S_MM),
     /* 64810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64824 */     GIR_RootConstrainSelectedInstOperands,
     /* 64825 */     // GIR_Coverage, 2249,
     /* 64825 */     GIR_EraseRootFromParent_Done,
     /* 64826 */   // Label 1573: @64826
     /* 64826 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(64845), // Rule ID 129 //
     /* 64831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat),
     /* 64834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64838 */     // (fneg:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FNEG_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 64838 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_S),
     /* 64843 */     GIR_RootConstrainSelectedInstOperands,
     /* 64844 */     // GIR_Coverage, 129,
     /* 64844 */     GIR_Done,
     /* 64845 */   // Label 1574: @64845
     /* 64845 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(64864), // Rule ID 1153 //
     /* 64850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 64853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64857 */     // (fneg:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FNEG_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 64857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_S_MM),
     /* 64862 */     GIR_RootConstrainSelectedInstOperands,
     /* 64863 */     // GIR_Coverage, 1153,
     /* 64863 */     GIR_Done,
     /* 64864 */   // Label 1575: @64864
     /* 64864 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(64883), // Rule ID 1192 //
     /* 64869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 64872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64876 */     // (fneg:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FNEG_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 64876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_S_MMR6),
     /* 64881 */     GIR_RootConstrainSelectedInstOperands,
     /* 64882 */     // GIR_Coverage, 1192,
     /* 64882 */     GIR_Done,
     /* 64883 */   // Label 1576: @64883
     /* 64883 */   GIM_Reject,
     /* 64884 */ // Label 1567: @64884
     /* 64884 */ GIM_Reject,
     /* 64885 */ // Label 1565: @64885
     /* 64885 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(65706),
     /* 64890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 64893 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(64973), // Rule ID 1462 //
     /* 64898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 64917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 64921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 64933 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 64937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64954 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 64954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32),
     /* 64957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64971 */     GIR_RootConstrainSelectedInstOperands,
     /* 64972 */     // GIR_Coverage, 1462,
     /* 64972 */     GIR_EraseRootFromParent_Done,
     /* 64973 */   // Label 1578: @64973
     /* 64973 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(65053), // Rule ID 1464 //
     /* 64978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 64997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65034 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr))  =>  (NMADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 65034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D64),
     /* 65037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65051 */     GIR_RootConstrainSelectedInstOperands,
     /* 65052 */     // GIR_Coverage, 1464,
     /* 65052 */     GIR_EraseRootFromParent_Done,
     /* 65053 */   // Label 1579: @65053
     /* 65053 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(65133), // Rule ID 2250 //
     /* 65058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6),
     /* 65061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65102 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65114 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMADD_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32_MM),
     /* 65117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65131 */     GIR_RootConstrainSelectedInstOperands,
     /* 65132 */     // GIR_Coverage, 2250,
     /* 65132 */     GIR_EraseRootFromParent_Done,
     /* 65133 */   // Label 1580: @65133
     /* 65133 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(65213), // Rule ID 2435 //
     /* 65138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 65170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65178 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65182 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65194 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)))  =>  (NMADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32),
     /* 65197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 65203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65211 */     GIR_RootConstrainSelectedInstOperands,
     /* 65212 */     // GIR_Coverage, 2435,
     /* 65212 */     GIR_EraseRootFromParent_Done,
     /* 65213 */   // Label 1581: @65213
     /* 65213 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(65293), // Rule ID 2436 //
     /* 65218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 65250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65274 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)))  =>  (NMADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 65274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D64),
     /* 65277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 65283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65291 */     GIR_RootConstrainSelectedInstOperands,
     /* 65292 */     // GIR_Coverage, 2436,
     /* 65292 */     GIR_EraseRootFromParent_Done,
     /* 65293 */   // Label 1582: @65293
     /* 65293 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(65373), // Rule ID 2521 //
     /* 65298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6),
     /* 65301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 65330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65354 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)))  =>  (NMADD_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32_MM),
     /* 65357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 65363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65371 */     GIR_RootConstrainSelectedInstOperands,
     /* 65372 */     // GIR_Coverage, 2521,
     /* 65372 */     GIR_EraseRootFromParent_Done,
     /* 65373 */   // Label 1583: @65373
     /* 65373 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(65453), // Rule ID 1463 //
     /* 65378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 65393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65434 */     // (fneg:{ *:[f64] } (fsub:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMSUB_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_D32),
     /* 65437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65451 */     GIR_RootConstrainSelectedInstOperands,
     /* 65452 */     // GIR_Coverage, 1463,
     /* 65452 */     GIR_EraseRootFromParent_Done,
     /* 65453 */   // Label 1584: @65453
     /* 65453 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(65533), // Rule ID 1465 //
     /* 65458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 65473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65514 */     // (fneg:{ *:[f64] } (fsub:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr))  =>  (NMSUB_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 65514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_D64),
     /* 65517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65531 */     GIR_RootConstrainSelectedInstOperands,
     /* 65532 */     // GIR_Coverage, 1465,
     /* 65532 */     GIR_EraseRootFromParent_Done,
     /* 65533 */   // Label 1585: @65533
     /* 65533 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(65613), // Rule ID 2251 //
     /* 65538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6),
     /* 65541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 65553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65594 */     // (fneg:{ *:[f64] } (fsub:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMSUB_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_D32_MM),
     /* 65597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65611 */     GIR_RootConstrainSelectedInstOperands,
     /* 65612 */     // GIR_Coverage, 2251,
     /* 65612 */     GIR_EraseRootFromParent_Done,
     /* 65613 */   // Label 1586: @65613
     /* 65613 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(65636), // Rule ID 130 //
     /* 65618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 65621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65629 */     // (fneg:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 65629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D32),
     /* 65634 */     GIR_RootConstrainSelectedInstOperands,
     /* 65635 */     // GIR_Coverage, 130,
     /* 65635 */     GIR_Done,
     /* 65636 */   // Label 1587: @65636
     /* 65636 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(65659), // Rule ID 131 //
     /* 65641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 65644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65652 */     // (fneg:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 65652 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D64),
     /* 65657 */     GIR_RootConstrainSelectedInstOperands,
     /* 65658 */     // GIR_Coverage, 131,
     /* 65658 */     GIR_Done,
     /* 65659 */   // Label 1588: @65659
     /* 65659 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(65682), // Rule ID 1154 //
     /* 65664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 65667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65675 */     // (fneg:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 65675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D32_MM),
     /* 65680 */     GIR_RootConstrainSelectedInstOperands,
     /* 65681 */     // GIR_Coverage, 1154,
     /* 65681 */     GIR_Done,
     /* 65682 */   // Label 1589: @65682
     /* 65682 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(65705), // Rule ID 1155 //
     /* 65687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 65690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65698 */     // (fneg:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 65698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D64_MM),
     /* 65703 */     GIR_RootConstrainSelectedInstOperands,
     /* 65704 */     // GIR_Coverage, 1155,
     /* 65704 */     GIR_Done,
     /* 65705 */   // Label 1590: @65705
     /* 65705 */   GIM_Reject,
     /* 65706 */ // Label 1577: @65706
     /* 65706 */ GIM_Reject,
     /* 65707 */ // Label 1566: @65707
     /* 65707 */ GIM_Reject,
     /* 65708 */ // Label 54: @65708
     /* 65708 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1593*/ GIMT_Encode4(65885),
     /* 65719 */ /*GILLT_s32*//*Label 1591*/ GIMT_Encode4(65727),
     /* 65723 */ /*GILLT_s64*//*Label 1592*/ GIMT_Encode4(65754),
     /* 65727 */ // Label 1591: @65727
     /* 65727 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(65753), // Rule ID 1056 //
     /* 65732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 65738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65746 */   // (fpextend:{ *:[f32] } MSA128F16:{ *:[f16] }:$ws)  =>  (MSA_FP_EXTEND_W_PSEUDO:{ *:[f32] } MSA128F16:{ *:[f16] }:$ws)
     /* 65746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_EXTEND_W_PSEUDO),
     /* 65751 */   GIR_RootConstrainSelectedInstOperands,
     /* 65752 */   // GIR_Coverage, 1056,
     /* 65752 */   GIR_Done,
     /* 65753 */ // Label 1594: @65753
     /* 65753 */ GIM_Reject,
     /* 65754 */ // Label 1592: @65754
     /* 65754 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(65780), // Rule ID 1058 //
     /* 65759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 65765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65773 */   // (fpextend:{ *:[f64] } MSA128F16:{ *:[f16] }:$ws)  =>  (MSA_FP_EXTEND_D_PSEUDO:{ *:[f64] } MSA128F16:{ *:[f16] }:$ws)
     /* 65773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_EXTEND_D_PSEUDO),
     /* 65778 */   GIR_RootConstrainSelectedInstOperands,
     /* 65779 */   // GIR_Coverage, 1058,
     /* 65779 */   GIR_Done,
     /* 65780 */ // Label 1595: @65780
     /* 65780 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(65806), // Rule ID 1449 //
     /* 65785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotFP64bit_NotInMicroMips),
     /* 65788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65799 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D32_S:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65799 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D32_S),
     /* 65804 */   GIR_RootConstrainSelectedInstOperands,
     /* 65805 */   // GIR_Coverage, 1449,
     /* 65805 */   GIR_Done,
     /* 65806 */ // Label 1596: @65806
     /* 65806 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(65832), // Rule ID 1459 //
     /* 65811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_NotInMicroMips),
     /* 65814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65825 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D64_S:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D64_S),
     /* 65830 */   GIR_RootConstrainSelectedInstOperands,
     /* 65831 */   // GIR_Coverage, 1459,
     /* 65831 */   GIR_Done,
     /* 65832 */ // Label 1597: @65832
     /* 65832 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(65858), // Rule ID 2262 //
     /* 65837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit),
     /* 65840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65851 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D64_S_MM:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D64_S_MM),
     /* 65856 */   GIR_RootConstrainSelectedInstOperands,
     /* 65857 */   // GIR_Coverage, 2262,
     /* 65857 */   GIR_Done,
     /* 65858 */ // Label 1598: @65858
     /* 65858 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(65884), // Rule ID 2264 //
     /* 65863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit),
     /* 65866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65877 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D32_S_MM:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D32_S_MM),
     /* 65882 */   GIR_RootConstrainSelectedInstOperands,
     /* 65883 */   // GIR_Coverage, 2264,
     /* 65883 */   GIR_Done,
     /* 65884 */ // Label 1599: @65884
     /* 65884 */ GIM_Reject,
     /* 65885 */ // Label 1593: @65885
     /* 65885 */ GIM_Reject,
     /* 65886 */ // Label 55: @65886
     /* 65886 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 1602*/ GIMT_Encode4(66048),
     /* 65897 */ /*GILLT_s16*//*Label 1600*/ GIMT_Encode4(65905),
     /* 65901 */ /*GILLT_s32*//*Label 1601*/ GIMT_Encode4(65958),
     /* 65905 */ // Label 1600: @65905
     /* 65905 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(65931), // Rule ID 1057 //
     /* 65910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65924 */   // (fpround:{ *:[f16] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MSA_FP_ROUND_W_PSEUDO:{ *:[f16] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 65924 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_ROUND_W_PSEUDO),
     /* 65929 */   GIR_RootConstrainSelectedInstOperands,
     /* 65930 */   // GIR_Coverage, 1057,
     /* 65930 */   GIR_Done,
     /* 65931 */ // Label 1603: @65931
     /* 65931 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(65957), // Rule ID 1059 //
     /* 65936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 65942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65950 */   // (fpround:{ *:[f16] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (MSA_FP_ROUND_D_PSEUDO:{ *:[f16] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 65950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_ROUND_D_PSEUDO),
     /* 65955 */   GIR_RootConstrainSelectedInstOperands,
     /* 65956 */   // GIR_Coverage, 1059,
     /* 65956 */   GIR_Done,
     /* 65957 */ // Label 1604: @65957
     /* 65957 */ GIM_Reject,
     /* 65958 */ // Label 1601: @65958
     /* 65958 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(66047),
     /* 65963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 65966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65970 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(65989), // Rule ID 1448 //
     /* 65975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotFP64bit_NotInMicroMips),
     /* 65978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65982 */     // (fpround:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D32:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)
     /* 65982 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D32),
     /* 65987 */     GIR_RootConstrainSelectedInstOperands,
     /* 65988 */     // GIR_Coverage, 1448,
     /* 65988 */     GIR_Done,
     /* 65989 */   // Label 1606: @65989
     /* 65989 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(66008), // Rule ID 1458 //
     /* 65994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_NotInMicroMips),
     /* 65997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66001 */     // (fpround:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D64:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)
     /* 66001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D64),
     /* 66006 */     GIR_RootConstrainSelectedInstOperands,
     /* 66007 */     // GIR_Coverage, 1458,
     /* 66007 */     GIR_Done,
     /* 66008 */   // Label 1607: @66008
     /* 66008 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(66027), // Rule ID 2261 //
     /* 66013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit),
     /* 66016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66020 */     // (fpround:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D64_MM:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)
     /* 66020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D64_MM),
     /* 66025 */     GIR_RootConstrainSelectedInstOperands,
     /* 66026 */     // GIR_Coverage, 2261,
     /* 66026 */     GIR_Done,
     /* 66027 */   // Label 1608: @66027
     /* 66027 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(66046), // Rule ID 2263 //
     /* 66032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit),
     /* 66035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66039 */     // (fpround:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D32_MM:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)
     /* 66039 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D32_MM),
     /* 66044 */     GIR_RootConstrainSelectedInstOperands,
     /* 66045 */     // GIR_Coverage, 2263,
     /* 66045 */     GIR_Done,
     /* 66046 */   // Label 1609: @66046
     /* 66046 */   GIM_Reject,
     /* 66047 */ // Label 1605: @66047
     /* 66047 */ GIM_Reject,
     /* 66048 */ // Label 1602: @66048
     /* 66048 */ GIM_Reject,
     /* 66049 */ // Label 56: @66049
     /* 66049 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1612*/ GIMT_Encode4(66126),
     /* 66060 */ /*GILLT_v2s64*//*Label 1610*/ GIMT_Encode4(66072), GIMT_Encode4(0),
     /* 66068 */ /*GILLT_v4s32*//*Label 1611*/ GIMT_Encode4(66099),
     /* 66072 */ // Label 1610: @66072
     /* 66072 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(66098), // Rule ID 777 //
     /* 66077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66091 */   // (fp_to_sint:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTRUNC_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 66091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_S_D),
     /* 66096 */   GIR_RootConstrainSelectedInstOperands,
     /* 66097 */   // GIR_Coverage, 777,
     /* 66097 */   GIR_Done,
     /* 66098 */ // Label 1613: @66098
     /* 66098 */ GIM_Reject,
     /* 66099 */ // Label 1611: @66099
     /* 66099 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(66125), // Rule ID 776 //
     /* 66104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66118 */   // (fp_to_sint:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTRUNC_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 66118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_S_W),
     /* 66123 */   GIR_RootConstrainSelectedInstOperands,
     /* 66124 */   // GIR_Coverage, 776,
     /* 66124 */   GIR_Done,
     /* 66125 */ // Label 1614: @66125
     /* 66125 */ GIM_Reject,
     /* 66126 */ // Label 1612: @66126
     /* 66126 */ GIM_Reject,
     /* 66127 */ // Label 57: @66127
     /* 66127 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1617*/ GIMT_Encode4(66204),
     /* 66138 */ /*GILLT_v2s64*//*Label 1615*/ GIMT_Encode4(66150), GIMT_Encode4(0),
     /* 66146 */ /*GILLT_v4s32*//*Label 1616*/ GIMT_Encode4(66177),
     /* 66150 */ // Label 1615: @66150
     /* 66150 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(66176), // Rule ID 779 //
     /* 66155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66169 */   // (fp_to_uint:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTRUNC_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 66169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_U_D),
     /* 66174 */   GIR_RootConstrainSelectedInstOperands,
     /* 66175 */   // GIR_Coverage, 779,
     /* 66175 */   GIR_Done,
     /* 66176 */ // Label 1618: @66176
     /* 66176 */ GIM_Reject,
     /* 66177 */ // Label 1616: @66177
     /* 66177 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(66203), // Rule ID 778 //
     /* 66182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66196 */   // (fp_to_uint:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTRUNC_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 66196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_U_W),
     /* 66201 */   GIR_RootConstrainSelectedInstOperands,
     /* 66202 */   // GIR_Coverage, 778,
     /* 66202 */   GIR_Done,
     /* 66203 */ // Label 1619: @66203
     /* 66203 */ GIM_Reject,
     /* 66204 */ // Label 1617: @66204
     /* 66204 */ GIM_Reject,
     /* 66205 */ // Label 58: @66205
     /* 66205 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1624*/ GIMT_Encode4(66457),
     /* 66216 */ /*GILLT_s32*//*Label 1620*/ GIMT_Encode4(66240),
     /* 66220 */ /*GILLT_s64*//*Label 1621*/ GIMT_Encode4(66324), GIMT_Encode4(0),
     /* 66228 */ /*GILLT_v2s64*//*Label 1622*/ GIMT_Encode4(66403), GIMT_Encode4(0),
     /* 66236 */ /*GILLT_v4s32*//*Label 1623*/ GIMT_Encode4(66430),
     /* 66240 */ // Label 1620: @66240
     /* 66240 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(66263), // Rule ID 1443 //
     /* 66245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 66256 */   // (sint_to_fp:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$src)  =>  (PseudoCVT_S_W:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$src)
     /* 66256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_S_W),
     /* 66261 */   GIR_RootConstrainSelectedInstOperands,
     /* 66262 */   // GIR_Coverage, 1443,
     /* 66262 */   GIR_Done,
     /* 66263 */ // Label 1625: @66263
     /* 66263 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(66323), // Rule ID 1453 //
     /* 66268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit),
     /* 66271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 66282 */   // (sint_to_fp:{ *:[f32] } GPR64Opnd:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[f32] } (PseudoCVT_S_L:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$src), sub_lo:{ *:[i32] })
     /* 66282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 66285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_S_L),
     /* 66289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 66294 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 66298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 66300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 66303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 66305 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(Mips::sub_lo),
     /* 66312 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66317 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66322 */   // GIR_Coverage, 1453,
     /* 66322 */   GIR_EraseRootFromParent_Done,
     /* 66323 */ // Label 1626: @66323
     /* 66323 */ GIM_Reject,
     /* 66324 */ // Label 1621: @66324
     /* 66324 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(66350), // Rule ID 1446 //
     /* 66329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotFP64bit),
     /* 66332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 66343 */   // (sint_to_fp:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)  =>  (PseudoCVT_D32_W:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)
     /* 66343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_D32_W),
     /* 66348 */   GIR_RootConstrainSelectedInstOperands,
     /* 66349 */   // GIR_Coverage, 1446,
     /* 66349 */   GIR_Done,
     /* 66350 */ // Label 1627: @66350
     /* 66350 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(66376), // Rule ID 1452 //
     /* 66355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit),
     /* 66358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 66369 */   // (sint_to_fp:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)  =>  (PseudoCVT_D64_W:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)
     /* 66369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_D64_W),
     /* 66374 */   GIR_RootConstrainSelectedInstOperands,
     /* 66375 */   // GIR_Coverage, 1452,
     /* 66375 */   GIR_Done,
     /* 66376 */ // Label 1628: @66376
     /* 66376 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(66402), // Rule ID 1454 //
     /* 66381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit),
     /* 66384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 66395 */   // (sint_to_fp:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$src)  =>  (PseudoCVT_D64_L:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$src)
     /* 66395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_D64_L),
     /* 66400 */   GIR_RootConstrainSelectedInstOperands,
     /* 66401 */   // GIR_Coverage, 1454,
     /* 66401 */   GIR_Done,
     /* 66402 */ // Label 1629: @66402
     /* 66402 */ GIM_Reject,
     /* 66403 */ // Label 1622: @66403
     /* 66403 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(66429), // Rule ID 709 //
     /* 66408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66422 */   // (sint_to_fp:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (FFINT_S_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 66422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_S_D),
     /* 66427 */   GIR_RootConstrainSelectedInstOperands,
     /* 66428 */   // GIR_Coverage, 709,
     /* 66428 */   GIR_Done,
     /* 66429 */ // Label 1630: @66429
     /* 66429 */ GIM_Reject,
     /* 66430 */ // Label 1623: @66430
     /* 66430 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(66456), // Rule ID 708 //
     /* 66435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66449 */   // (sint_to_fp:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFINT_S_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 66449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_S_W),
     /* 66454 */   GIR_RootConstrainSelectedInstOperands,
     /* 66455 */   // GIR_Coverage, 708,
     /* 66455 */   GIR_Done,
     /* 66456 */ // Label 1631: @66456
     /* 66456 */ GIM_Reject,
     /* 66457 */ // Label 1624: @66457
     /* 66457 */ GIM_Reject,
     /* 66458 */ // Label 59: @66458
     /* 66458 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1634*/ GIMT_Encode4(66535),
     /* 66469 */ /*GILLT_v2s64*//*Label 1632*/ GIMT_Encode4(66481), GIMT_Encode4(0),
     /* 66477 */ /*GILLT_v4s32*//*Label 1633*/ GIMT_Encode4(66508),
     /* 66481 */ // Label 1632: @66481
     /* 66481 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(66507), // Rule ID 711 //
     /* 66486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66500 */   // (uint_to_fp:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (FFINT_U_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 66500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_U_D),
     /* 66505 */   GIR_RootConstrainSelectedInstOperands,
     /* 66506 */   // GIR_Coverage, 711,
     /* 66506 */   GIR_Done,
     /* 66507 */ // Label 1635: @66507
     /* 66507 */ GIM_Reject,
     /* 66508 */ // Label 1633: @66508
     /* 66508 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(66534), // Rule ID 710 //
     /* 66513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66527 */   // (uint_to_fp:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFINT_U_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 66527 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_U_W),
     /* 66532 */   GIR_RootConstrainSelectedInstOperands,
     /* 66533 */   // GIR_Coverage, 710,
     /* 66533 */   GIR_Done,
     /* 66534 */ // Label 1636: @66534
     /* 66534 */ GIM_Reject,
     /* 66535 */ // Label 1634: @66535
     /* 66535 */ GIM_Reject,
     /* 66536 */ // Label 60: @66536
     /* 66536 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1641*/ GIMT_Encode4(66775),
     /* 66547 */ /*GILLT_s32*//*Label 1637*/ GIMT_Encode4(66571),
     /* 66551 */ /*GILLT_s64*//*Label 1638*/ GIMT_Encode4(66619), GIMT_Encode4(0),
     /* 66559 */ /*GILLT_v2s64*//*Label 1639*/ GIMT_Encode4(66721), GIMT_Encode4(0),
     /* 66567 */ /*GILLT_v4s32*//*Label 1640*/ GIMT_Encode4(66748),
     /* 66571 */ // Label 1637: @66571
     /* 66571 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(66618),
     /* 66576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66587 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(66602), // Rule ID 126 //
     /* 66592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips_UseAbs),
     /* 66595 */     // (fabs:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FABS_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 66595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_S),
     /* 66600 */     GIR_RootConstrainSelectedInstOperands,
     /* 66601 */     // GIR_Coverage, 126,
     /* 66601 */     GIR_Done,
     /* 66602 */   // Label 1643: @66602
     /* 66602 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(66617), // Rule ID 1152 //
     /* 66607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_UseAbs),
     /* 66610 */     // (fabs:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FABS_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 66610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_S_MM),
     /* 66615 */     GIR_RootConstrainSelectedInstOperands,
     /* 66616 */     // GIR_Coverage, 1152,
     /* 66616 */     GIR_Done,
     /* 66617 */   // Label 1644: @66617
     /* 66617 */   GIM_Reject,
     /* 66618 */ // Label 1642: @66618
     /* 66618 */ GIM_Reject,
     /* 66619 */ // Label 1638: @66619
     /* 66619 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(66720),
     /* 66624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66627 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(66650), // Rule ID 127 //
     /* 66632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_UseAbs),
     /* 66635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66643 */     // (fabs:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 66643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D32),
     /* 66648 */     GIR_RootConstrainSelectedInstOperands,
     /* 66649 */     // GIR_Coverage, 127,
     /* 66649 */     GIR_Done,
     /* 66650 */   // Label 1646: @66650
     /* 66650 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(66673), // Rule ID 128 //
     /* 66655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_UseAbs),
     /* 66658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66666 */     // (fabs:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 66666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D64),
     /* 66671 */     GIR_RootConstrainSelectedInstOperands,
     /* 66672 */     // GIR_Coverage, 128,
     /* 66672 */     GIR_Done,
     /* 66673 */   // Label 1647: @66673
     /* 66673 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(66696), // Rule ID 1150 //
     /* 66678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 66681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66689 */     // (fabs:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 66689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D32_MM),
     /* 66694 */     GIR_RootConstrainSelectedInstOperands,
     /* 66695 */     // GIR_Coverage, 1150,
     /* 66695 */     GIR_Done,
     /* 66696 */   // Label 1648: @66696
     /* 66696 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(66719), // Rule ID 1151 //
     /* 66701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 66704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66712 */     // (fabs:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 66712 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D64_MM),
     /* 66717 */     GIR_RootConstrainSelectedInstOperands,
     /* 66718 */     // GIR_Coverage, 1151,
     /* 66718 */     GIR_Done,
     /* 66719 */   // Label 1649: @66719
     /* 66719 */   GIM_Reject,
     /* 66720 */ // Label 1645: @66720
     /* 66720 */ GIM_Reject,
     /* 66721 */ // Label 1639: @66721
     /* 66721 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(66747), // Rule ID 1043 //
     /* 66726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66740 */   // (fabs:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FABS_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 66740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D),
     /* 66745 */   GIR_RootConstrainSelectedInstOperands,
     /* 66746 */   // GIR_Coverage, 1043,
     /* 66746 */   GIR_Done,
     /* 66747 */ // Label 1650: @66747
     /* 66747 */ GIM_Reject,
     /* 66748 */ // Label 1640: @66748
     /* 66748 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(66774), // Rule ID 1042 //
     /* 66753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66767 */   // (fabs:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FABS_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 66767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_W),
     /* 66772 */   GIR_RootConstrainSelectedInstOperands,
     /* 66773 */   // GIR_Coverage, 1042,
     /* 66773 */   GIR_Done,
     /* 66774 */ // Label 1651: @66774
     /* 66774 */ GIM_Reject,
     /* 66775 */ // Label 1641: @66775
     /* 66775 */ GIM_Reject,
     /* 66776 */ // Label 61: @66776
     /* 66776 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1654*/ GIMT_Encode4(66849),
     /* 66787 */ /*GILLT_s32*//*Label 1652*/ GIMT_Encode4(66795),
     /* 66791 */ /*GILLT_s64*//*Label 1653*/ GIMT_Encode4(66822),
     /* 66795 */ // Label 1652: @66795
     /* 66795 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(66821), // Rule ID 1794 //
     /* 66800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66810 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$src)  =>  (MIN_S:{ *:[f32] } f32:{ *:[f32] }:$src, f32:{ *:[f32] }:$src)
     /* 66810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_S),
     /* 66813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 66815 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66819 */   GIR_RootConstrainSelectedInstOperands,
     /* 66820 */   // GIR_Coverage, 1794,
     /* 66820 */   GIR_EraseRootFromParent_Done,
     /* 66821 */ // Label 1655: @66821
     /* 66821 */ GIM_Reject,
     /* 66822 */ // Label 1653: @66822
     /* 66822 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(66848), // Rule ID 1795 //
     /* 66827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66837 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$src)  =>  (MIN_D:{ *:[f64] } f64:{ *:[f64] }:$src, f64:{ *:[f64] }:$src)
     /* 66837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_D),
     /* 66840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 66842 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66844 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66846 */   GIR_RootConstrainSelectedInstOperands,
     /* 66847 */   // GIR_Coverage, 1795,
     /* 66847 */   GIR_EraseRootFromParent_Done,
     /* 66848 */ // Label 1656: @66848
     /* 66848 */ GIM_Reject,
     /* 66849 */ // Label 1654: @66849
     /* 66849 */ GIM_Reject,
     /* 66850 */ // Label 62: @66850
     /* 66850 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1659*/ GIMT_Encode4(66921),
     /* 66861 */ /*GILLT_s32*//*Label 1657*/ GIMT_Encode4(66869),
     /* 66865 */ /*GILLT_s64*//*Label 1658*/ GIMT_Encode4(66895),
     /* 66869 */ // Label 1657: @66869
     /* 66869 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(66894), // Rule ID 1791 //
     /* 66874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 66883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66887 */   // (fminnum:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)  =>  (MIN_S:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
     /* 66887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S),
     /* 66892 */   GIR_RootConstrainSelectedInstOperands,
     /* 66893 */   // GIR_Coverage, 1791,
     /* 66893 */   GIR_Done,
     /* 66894 */ // Label 1660: @66894
     /* 66894 */ GIM_Reject,
     /* 66895 */ // Label 1658: @66895
     /* 66895 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(66920), // Rule ID 1793 //
     /* 66900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 66909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66913 */   // (fminnum:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)  =>  (MIN_D:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
     /* 66913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_D),
     /* 66918 */   GIR_RootConstrainSelectedInstOperands,
     /* 66919 */   // GIR_Coverage, 1793,
     /* 66919 */   GIR_Done,
     /* 66920 */ // Label 1661: @66920
     /* 66920 */ GIM_Reject,
     /* 66921 */ // Label 1659: @66921
     /* 66921 */ GIM_Reject,
     /* 66922 */ // Label 63: @66922
     /* 66922 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1664*/ GIMT_Encode4(66993),
     /* 66933 */ /*GILLT_s32*//*Label 1662*/ GIMT_Encode4(66941),
     /* 66937 */ /*GILLT_s64*//*Label 1663*/ GIMT_Encode4(66967),
     /* 66941 */ // Label 1662: @66941
     /* 66941 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(66966), // Rule ID 1787 //
     /* 66946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 66955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66959 */   // (fmaxnum:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)  =>  (MAX_S:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
     /* 66959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S),
     /* 66964 */   GIR_RootConstrainSelectedInstOperands,
     /* 66965 */   // GIR_Coverage, 1787,
     /* 66965 */   GIR_Done,
     /* 66966 */ // Label 1665: @66966
     /* 66966 */ GIM_Reject,
     /* 66967 */ // Label 1663: @66967
     /* 66967 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(66992), // Rule ID 1789 //
     /* 66972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 66981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66985 */   // (fmaxnum:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)  =>  (MAX_D:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
     /* 66985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_D),
     /* 66990 */   GIR_RootConstrainSelectedInstOperands,
     /* 66991 */   // GIR_Coverage, 1789,
     /* 66991 */   GIR_Done,
     /* 66992 */ // Label 1666: @66992
     /* 66992 */ GIM_Reject,
     /* 66993 */ // Label 1664: @66993
     /* 66993 */ GIM_Reject,
     /* 66994 */ // Label 64: @66994
     /* 66994 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1669*/ GIMT_Encode4(67065),
     /* 67005 */ /*GILLT_s32*//*Label 1667*/ GIMT_Encode4(67013),
     /* 67009 */ /*GILLT_s64*//*Label 1668*/ GIMT_Encode4(67039),
     /* 67013 */ // Label 1667: @67013
     /* 67013 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(67038), // Rule ID 1790 //
     /* 67018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 67021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 67027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 67031 */   // (fminnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)  =>  (MIN_S:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
     /* 67031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S),
     /* 67036 */   GIR_RootConstrainSelectedInstOperands,
     /* 67037 */   // GIR_Coverage, 1790,
     /* 67037 */   GIR_Done,
     /* 67038 */ // Label 1670: @67038
     /* 67038 */ GIM_Reject,
     /* 67039 */ // Label 1668: @67039
     /* 67039 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(67064), // Rule ID 1792 //
     /* 67044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 67047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 67053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 67057 */   // (fminnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)  =>  (MIN_D:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
     /* 67057 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_D),
     /* 67062 */   GIR_RootConstrainSelectedInstOperands,
     /* 67063 */   // GIR_Coverage, 1792,
     /* 67063 */   GIR_Done,
     /* 67064 */ // Label 1671: @67064
     /* 67064 */ GIM_Reject,
     /* 67065 */ // Label 1669: @67065
     /* 67065 */ GIM_Reject,
     /* 67066 */ // Label 65: @67066
     /* 67066 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1674*/ GIMT_Encode4(67137),
     /* 67077 */ /*GILLT_s32*//*Label 1672*/ GIMT_Encode4(67085),
     /* 67081 */ /*GILLT_s64*//*Label 1673*/ GIMT_Encode4(67111),
     /* 67085 */ // Label 1672: @67085
     /* 67085 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(67110), // Rule ID 1786 //
     /* 67090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 67093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 67096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 67099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 67103 */   // (fmaxnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)  =>  (MAX_S:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
     /* 67103 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S),
     /* 67108 */   GIR_RootConstrainSelectedInstOperands,
     /* 67109 */   // GIR_Coverage, 1786,
     /* 67109 */   GIR_Done,
     /* 67110 */ // Label 1675: @67110
     /* 67110 */ GIM_Reject,
     /* 67111 */ // Label 1673: @67111
     /* 67111 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(67136), // Rule ID 1788 //
     /* 67116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 67119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 67122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 67125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 67129 */   // (fmaxnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)  =>  (MAX_D:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
     /* 67129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_D),
     /* 67134 */   GIR_RootConstrainSelectedInstOperands,
     /* 67135 */   // GIR_Coverage, 1788,
     /* 67135 */   GIR_Done,
     /* 67136 */ // Label 1676: @67136
     /* 67136 */ GIM_Reject,
     /* 67137 */ // Label 1674: @67137
     /* 67137 */ GIM_Reject,
     /* 67138 */ // Label 66: @67138
     /* 67138 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1681*/ GIMT_Encode4(67305),
     /* 67149 */ /*GILLT_v2s64*//*Label 1677*/ GIMT_Encode4(67169), GIMT_Encode4(0),
     /* 67157 */ /*GILLT_v4s32*//*Label 1678*/ GIMT_Encode4(67203),
     /* 67161 */ /*GILLT_v8s16*//*Label 1679*/ GIMT_Encode4(67237),
     /* 67165 */ /*GILLT_v16s8*//*Label 1680*/ GIMT_Encode4(67271),
     /* 67169 */ // Label 1677: @67169
     /* 67169 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(67202), // Rule ID 871 //
     /* 67174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67195 */   // (smin:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MIN_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_D),
     /* 67200 */   GIR_RootConstrainSelectedInstOperands,
     /* 67201 */   // GIR_Coverage, 871,
     /* 67201 */   GIR_Done,
     /* 67202 */ // Label 1682: @67202
     /* 67202 */ GIM_Reject,
     /* 67203 */ // Label 1678: @67203
     /* 67203 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(67236), // Rule ID 870 //
     /* 67208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67229 */   // (smin:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MIN_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67229 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_W),
     /* 67234 */   GIR_RootConstrainSelectedInstOperands,
     /* 67235 */   // GIR_Coverage, 870,
     /* 67235 */   GIR_Done,
     /* 67236 */ // Label 1683: @67236
     /* 67236 */ GIM_Reject,
     /* 67237 */ // Label 1679: @67237
     /* 67237 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(67270), // Rule ID 869 //
     /* 67242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67259 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67263 */   // (smin:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MIN_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67263 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_H),
     /* 67268 */   GIR_RootConstrainSelectedInstOperands,
     /* 67269 */   // GIR_Coverage, 869,
     /* 67269 */   GIR_Done,
     /* 67270 */ // Label 1684: @67270
     /* 67270 */ GIM_Reject,
     /* 67271 */ // Label 1680: @67271
     /* 67271 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(67304), // Rule ID 868 //
     /* 67276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67297 */   // (smin:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MIN_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_B),
     /* 67302 */   GIR_RootConstrainSelectedInstOperands,
     /* 67303 */   // GIR_Coverage, 868,
     /* 67303 */   GIR_Done,
     /* 67304 */ // Label 1685: @67304
     /* 67304 */ GIM_Reject,
     /* 67305 */ // Label 1681: @67305
     /* 67305 */ GIM_Reject,
     /* 67306 */ // Label 67: @67306
     /* 67306 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1690*/ GIMT_Encode4(67473),
     /* 67317 */ /*GILLT_v2s64*//*Label 1686*/ GIMT_Encode4(67337), GIMT_Encode4(0),
     /* 67325 */ /*GILLT_v4s32*//*Label 1687*/ GIMT_Encode4(67371),
     /* 67329 */ /*GILLT_v8s16*//*Label 1688*/ GIMT_Encode4(67405),
     /* 67333 */ /*GILLT_v16s8*//*Label 1689*/ GIMT_Encode4(67439),
     /* 67337 */ // Label 1686: @67337
     /* 67337 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(67370), // Rule ID 851 //
     /* 67342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67363 */   // (smax:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MAX_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_D),
     /* 67368 */   GIR_RootConstrainSelectedInstOperands,
     /* 67369 */   // GIR_Coverage, 851,
     /* 67369 */   GIR_Done,
     /* 67370 */ // Label 1691: @67370
     /* 67370 */ GIM_Reject,
     /* 67371 */ // Label 1687: @67371
     /* 67371 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(67404), // Rule ID 850 //
     /* 67376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67397 */   // (smax:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MAX_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67397 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_W),
     /* 67402 */   GIR_RootConstrainSelectedInstOperands,
     /* 67403 */   // GIR_Coverage, 850,
     /* 67403 */   GIR_Done,
     /* 67404 */ // Label 1692: @67404
     /* 67404 */ GIM_Reject,
     /* 67405 */ // Label 1688: @67405
     /* 67405 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(67438), // Rule ID 849 //
     /* 67410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67431 */   // (smax:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MAX_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_H),
     /* 67436 */   GIR_RootConstrainSelectedInstOperands,
     /* 67437 */   // GIR_Coverage, 849,
     /* 67437 */   GIR_Done,
     /* 67438 */ // Label 1693: @67438
     /* 67438 */ GIM_Reject,
     /* 67439 */ // Label 1689: @67439
     /* 67439 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(67472), // Rule ID 848 //
     /* 67444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67465 */   // (smax:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MAX_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_B),
     /* 67470 */   GIR_RootConstrainSelectedInstOperands,
     /* 67471 */   // GIR_Coverage, 848,
     /* 67471 */   GIR_Done,
     /* 67472 */ // Label 1694: @67472
     /* 67472 */ GIM_Reject,
     /* 67473 */ // Label 1690: @67473
     /* 67473 */ GIM_Reject,
     /* 67474 */ // Label 68: @67474
     /* 67474 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1699*/ GIMT_Encode4(67641),
     /* 67485 */ /*GILLT_v2s64*//*Label 1695*/ GIMT_Encode4(67505), GIMT_Encode4(0),
     /* 67493 */ /*GILLT_v4s32*//*Label 1696*/ GIMT_Encode4(67539),
     /* 67497 */ /*GILLT_v8s16*//*Label 1697*/ GIMT_Encode4(67573),
     /* 67501 */ /*GILLT_v16s8*//*Label 1698*/ GIMT_Encode4(67607),
     /* 67505 */ // Label 1695: @67505
     /* 67505 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(67538), // Rule ID 875 //
     /* 67510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67531 */   // (umin:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MIN_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_D),
     /* 67536 */   GIR_RootConstrainSelectedInstOperands,
     /* 67537 */   // GIR_Coverage, 875,
     /* 67537 */   GIR_Done,
     /* 67538 */ // Label 1700: @67538
     /* 67538 */ GIM_Reject,
     /* 67539 */ // Label 1696: @67539
     /* 67539 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(67572), // Rule ID 874 //
     /* 67544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67561 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67565 */   // (umin:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MIN_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_W),
     /* 67570 */   GIR_RootConstrainSelectedInstOperands,
     /* 67571 */   // GIR_Coverage, 874,
     /* 67571 */   GIR_Done,
     /* 67572 */ // Label 1701: @67572
     /* 67572 */ GIM_Reject,
     /* 67573 */ // Label 1697: @67573
     /* 67573 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(67606), // Rule ID 873 //
     /* 67578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67595 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67599 */   // (umin:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MIN_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_H),
     /* 67604 */   GIR_RootConstrainSelectedInstOperands,
     /* 67605 */   // GIR_Coverage, 873,
     /* 67605 */   GIR_Done,
     /* 67606 */ // Label 1702: @67606
     /* 67606 */ GIM_Reject,
     /* 67607 */ // Label 1698: @67607
     /* 67607 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(67640), // Rule ID 872 //
     /* 67612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67633 */   // (umin:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MIN_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_B),
     /* 67638 */   GIR_RootConstrainSelectedInstOperands,
     /* 67639 */   // GIR_Coverage, 872,
     /* 67639 */   GIR_Done,
     /* 67640 */ // Label 1703: @67640
     /* 67640 */ GIM_Reject,
     /* 67641 */ // Label 1699: @67641
     /* 67641 */ GIM_Reject,
     /* 67642 */ // Label 69: @67642
     /* 67642 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1708*/ GIMT_Encode4(67809),
     /* 67653 */ /*GILLT_v2s64*//*Label 1704*/ GIMT_Encode4(67673), GIMT_Encode4(0),
     /* 67661 */ /*GILLT_v4s32*//*Label 1705*/ GIMT_Encode4(67707),
     /* 67665 */ /*GILLT_v8s16*//*Label 1706*/ GIMT_Encode4(67741),
     /* 67669 */ /*GILLT_v16s8*//*Label 1707*/ GIMT_Encode4(67775),
     /* 67673 */ // Label 1704: @67673
     /* 67673 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(67706), // Rule ID 855 //
     /* 67678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67699 */   // (umax:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MAX_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67699 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_D),
     /* 67704 */   GIR_RootConstrainSelectedInstOperands,
     /* 67705 */   // GIR_Coverage, 855,
     /* 67705 */   GIR_Done,
     /* 67706 */ // Label 1709: @67706
     /* 67706 */ GIM_Reject,
     /* 67707 */ // Label 1705: @67707
     /* 67707 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(67740), // Rule ID 854 //
     /* 67712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67733 */   // (umax:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MAX_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_W),
     /* 67738 */   GIR_RootConstrainSelectedInstOperands,
     /* 67739 */   // GIR_Coverage, 854,
     /* 67739 */   GIR_Done,
     /* 67740 */ // Label 1710: @67740
     /* 67740 */ GIM_Reject,
     /* 67741 */ // Label 1706: @67741
     /* 67741 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(67774), // Rule ID 853 //
     /* 67746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67763 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67767 */   // (umax:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MAX_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_H),
     /* 67772 */   GIR_RootConstrainSelectedInstOperands,
     /* 67773 */   // GIR_Coverage, 853,
     /* 67773 */   GIR_Done,
     /* 67774 */ // Label 1711: @67774
     /* 67774 */ GIM_Reject,
     /* 67775 */ // Label 1707: @67775
     /* 67775 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(67808), // Rule ID 852 //
     /* 67780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67801 */   // (umax:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MAX_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_B),
     /* 67806 */   GIR_RootConstrainSelectedInstOperands,
     /* 67807 */   // GIR_Coverage, 852,
     /* 67807 */   GIR_Done,
     /* 67808 */ // Label 1712: @67808
     /* 67808 */ GIM_Reject,
     /* 67809 */ // Label 1708: @67809
     /* 67809 */ GIM_Reject,
     /* 67810 */ // Label 70: @67810
     /* 67810 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(67933),
     /* 67815 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 67818 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(67839), // Rule ID 91 //
     /* 67823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips_RelocNotPIC),
     /* 67826 */     // (br (bb:{ *:[Other] }):$target)  =>  (J (bb:{ *:[Other] }):$target)
     /* 67826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::J),
     /* 67831 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67837 */     GIR_RootConstrainSelectedInstOperands,
     /* 67838 */     // GIR_Coverage, 91,
     /* 67838 */     GIR_Done,
     /* 67839 */   // Label 1714: @67839
     /* 67839 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(67860), // Rule ID 98 //
     /* 67844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 67847 */     // (br (bb:{ *:[Other] }):$offset)  =>  (B (bb:{ *:[Other] }):$offset)
     /* 67847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::B),
     /* 67852 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67858 */     GIR_RootConstrainSelectedInstOperands,
     /* 67859 */     // GIR_Coverage, 98,
     /* 67859 */     GIR_Done,
     /* 67860 */   // Label 1715: @67860
     /* 67860 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(67881), // Rule ID 1104 //
     /* 67865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6_RelocNotPIC),
     /* 67868 */     // (br (bb:{ *:[Other] }):$target)  =>  (J_MM (bb:{ *:[Other] }):$target)
     /* 67868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::J_MM),
     /* 67873 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67879 */     GIR_RootConstrainSelectedInstOperands,
     /* 67880 */     // GIR_Coverage, 1104,
     /* 67880 */     GIR_Done,
     /* 67881 */   // Label 1716: @67881
     /* 67881 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(67902), // Rule ID 1113 //
     /* 67886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6_RelocPIC),
     /* 67889 */     // (br (bb:{ *:[Other] }):$offset)  =>  (B_MM (bb:{ *:[Other] }):$offset)
     /* 67889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::B_MM),
     /* 67894 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67900 */     GIR_RootConstrainSelectedInstOperands,
     /* 67901 */     // GIR_Coverage, 1113,
     /* 67901 */     GIR_Done,
     /* 67902 */   // Label 1717: @67902
     /* 67902 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(67917), // Rule ID 1171 //
     /* 67907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 67910 */     // (br (bb:{ *:[Other] }):$offset)  =>  (BC_MMR6 (bb:{ *:[Other] }):$offset)
     /* 67910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BC_MMR6),
     /* 67915 */     GIR_RootConstrainSelectedInstOperands,
     /* 67916 */     // GIR_Coverage, 1171,
     /* 67916 */     GIR_Done,
     /* 67917 */   // Label 1718: @67917
     /* 67917 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(67932), // Rule ID 1867 //
     /* 67922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 67925 */     // (br (bb:{ *:[Other] }):$imm16)  =>  (Bimm16 (bb:{ *:[Other] }):$imm16)
     /* 67925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::Bimm16),
     /* 67930 */     GIR_RootConstrainSelectedInstOperands,
     /* 67931 */     // GIR_Coverage, 1867,
     /* 67931 */     GIR_Done,
     /* 67932 */   // Label 1719: @67932
     /* 67932 */   GIM_Reject,
     /* 67933 */ // Label 1713: @67933
     /* 67933 */ GIM_Reject,
     /* 67934 */ // Label 71: @67934
     /* 67934 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1724*/ GIMT_Encode4(68497),
     /* 67945 */ /*GILLT_v2s64*//*Label 1720*/ GIMT_Encode4(67965), GIMT_Encode4(0),
     /* 67953 */ /*GILLT_v4s32*//*Label 1721*/ GIMT_Encode4(68138),
     /* 67957 */ /*GILLT_v8s16*//*Label 1722*/ GIMT_Encode4(68311),
     /* 67961 */ /*GILLT_v16s8*//*Label 1723*/ GIMT_Encode4(68404),
     /* 67965 */ // Label 1720: @67965
     /* 67965 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(68137),
     /* 67970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 67976 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(68016), // Rule ID 821 //
     /* 67981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 67987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 67999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68003 */     // (vector_insert:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_D_VIDX_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR64Opnd:{ *:[i64] }:$fs)
     /* 68003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_D_VIDX_PSEUDO),
     /* 68006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68008 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68010 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68012 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68014 */     GIR_RootConstrainSelectedInstOperands,
     /* 68015 */     // GIR_Coverage, 821,
     /* 68015 */     GIR_EraseRootFromParent_Done,
     /* 68016 */   // Label 1726: @68016
     /* 68016 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(68056), // Rule ID 823 //
     /* 68021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 68039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68043 */     // (vector_insert:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, FGR64Opnd:{ *:[f64] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_FD_VIDX_PSEUDO:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, FGR64Opnd:{ *:[f64] }:$fs)
     /* 68043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FD_VIDX_PSEUDO),
     /* 68046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68048 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68050 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68052 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68054 */     GIR_RootConstrainSelectedInstOperands,
     /* 68055 */     // GIR_Coverage, 823,
     /* 68055 */     GIR_EraseRootFromParent_Done,
     /* 68056 */   // Label 1727: @68056
     /* 68056 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(68096), // Rule ID 827 //
     /* 68061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68083 */     // (vector_insert:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_D_VIDX64_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR64Opnd:{ *:[i64] }:$fs)
     /* 68083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_D_VIDX64_PSEUDO),
     /* 68086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68088 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68090 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68092 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68094 */     GIR_RootConstrainSelectedInstOperands,
     /* 68095 */     // GIR_Coverage, 827,
     /* 68095 */     GIR_EraseRootFromParent_Done,
     /* 68096 */   // Label 1728: @68096
     /* 68096 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(68136), // Rule ID 829 //
     /* 68101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 68119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68123 */     // (vector_insert:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, FGR64Opnd:{ *:[f64] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_FD_VIDX64_PSEUDO:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, FGR64Opnd:{ *:[f64] }:$fs)
     /* 68123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FD_VIDX64_PSEUDO),
     /* 68126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68128 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68130 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68132 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68134 */     GIR_RootConstrainSelectedInstOperands,
     /* 68135 */     // GIR_Coverage, 829,
     /* 68135 */     GIR_EraseRootFromParent_Done,
     /* 68136 */   // Label 1729: @68136
     /* 68136 */   GIM_Reject,
     /* 68137 */ // Label 1725: @68137
     /* 68137 */ GIM_Reject,
     /* 68138 */ // Label 1721: @68138
     /* 68138 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(68310),
     /* 68143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 68149 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(68189), // Rule ID 820 //
     /* 68154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68176 */     // (vector_insert:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_W_VIDX_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_W_VIDX_PSEUDO),
     /* 68179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68181 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68183 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68185 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68187 */     GIR_RootConstrainSelectedInstOperands,
     /* 68188 */     // GIR_Coverage, 820,
     /* 68188 */     GIR_EraseRootFromParent_Done,
     /* 68189 */   // Label 1731: @68189
     /* 68189 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(68229), // Rule ID 822 //
     /* 68194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 68212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68216 */     // (vector_insert:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, FGR32Opnd:{ *:[f32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_FW_VIDX_PSEUDO:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, FGR32Opnd:{ *:[f32] }:$fs)
     /* 68216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FW_VIDX_PSEUDO),
     /* 68219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68221 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68223 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68225 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68227 */     GIR_RootConstrainSelectedInstOperands,
     /* 68228 */     // GIR_Coverage, 822,
     /* 68228 */     GIR_EraseRootFromParent_Done,
     /* 68229 */   // Label 1732: @68229
     /* 68229 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(68269), // Rule ID 826 //
     /* 68234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68256 */     // (vector_insert:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_W_VIDX64_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_W_VIDX64_PSEUDO),
     /* 68259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68261 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68263 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68265 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68267 */     GIR_RootConstrainSelectedInstOperands,
     /* 68268 */     // GIR_Coverage, 826,
     /* 68268 */     GIR_EraseRootFromParent_Done,
     /* 68269 */   // Label 1733: @68269
     /* 68269 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(68309), // Rule ID 828 //
     /* 68274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 68292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68296 */     // (vector_insert:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, FGR32Opnd:{ *:[f32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_FW_VIDX64_PSEUDO:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, FGR32Opnd:{ *:[f32] }:$fs)
     /* 68296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FW_VIDX64_PSEUDO),
     /* 68299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68301 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68303 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68305 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68307 */     GIR_RootConstrainSelectedInstOperands,
     /* 68308 */     // GIR_Coverage, 828,
     /* 68308 */     GIR_EraseRootFromParent_Done,
     /* 68309 */   // Label 1734: @68309
     /* 68309 */   GIM_Reject,
     /* 68310 */ // Label 1730: @68310
     /* 68310 */ GIM_Reject,
     /* 68311 */ // Label 1722: @68311
     /* 68311 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(68403),
     /* 68316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 68319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 68322 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(68362), // Rule ID 819 //
     /* 68327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68349 */     // (vector_insert:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_H_VIDX_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_H_VIDX_PSEUDO),
     /* 68352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68354 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68356 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68358 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68360 */     GIR_RootConstrainSelectedInstOperands,
     /* 68361 */     // GIR_Coverage, 819,
     /* 68361 */     GIR_EraseRootFromParent_Done,
     /* 68362 */   // Label 1736: @68362
     /* 68362 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(68402), // Rule ID 825 //
     /* 68367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68389 */     // (vector_insert:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_H_VIDX64_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_H_VIDX64_PSEUDO),
     /* 68392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68394 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68396 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68398 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68400 */     GIR_RootConstrainSelectedInstOperands,
     /* 68401 */     // GIR_Coverage, 825,
     /* 68401 */     GIR_EraseRootFromParent_Done,
     /* 68402 */   // Label 1737: @68402
     /* 68402 */   GIM_Reject,
     /* 68403 */ // Label 1735: @68403
     /* 68403 */ GIM_Reject,
     /* 68404 */ // Label 1723: @68404
     /* 68404 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(68496),
     /* 68409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 68412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 68415 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(68455), // Rule ID 818 //
     /* 68420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68442 */     // (vector_insert:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_B_VIDX_PSEUDO:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_B_VIDX_PSEUDO),
     /* 68445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68447 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68449 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68451 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68453 */     GIR_RootConstrainSelectedInstOperands,
     /* 68454 */     // GIR_Coverage, 818,
     /* 68454 */     GIR_EraseRootFromParent_Done,
     /* 68455 */   // Label 1739: @68455
     /* 68455 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(68495), // Rule ID 824 //
     /* 68460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68482 */     // (vector_insert:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_B_VIDX64_PSEUDO:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_B_VIDX64_PSEUDO),
     /* 68485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68487 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68489 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68491 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68493 */     GIR_RootConstrainSelectedInstOperands,
     /* 68494 */     // GIR_Coverage, 824,
     /* 68494 */     GIR_EraseRootFromParent_Done,
     /* 68495 */   // Label 1740: @68495
     /* 68495 */   GIM_Reject,
     /* 68496 */ // Label 1738: @68496
     /* 68496 */ GIM_Reject,
     /* 68497 */ // Label 1724: @68497
     /* 68497 */ GIM_Reject,
     /* 68498 */ // Label 72: @68498
     /* 68498 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(68549), // Rule ID 1994 //
     /* 68503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 68506 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 68509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 68515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68523 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 68527 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 68531 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 68535 */   // MIs[1] Operand 1
     /* 68535 */   // No operand predicates
     /* 68535 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68537 */   // (extractelt:{ *:[i32] } MSA128W:{ *:[v4i32] }:$ws, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$idx)  =>  (COPY_S_W:{ *:[i32] } MSA128W:{ *:[v4i32] }:$ws, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$idx)
     /* 68537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::COPY_S_W),
     /* 68540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68542 */   GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 68544 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 68547 */   GIR_RootConstrainSelectedInstOperands,
     /* 68548 */   // GIR_Coverage, 1994,
     /* 68548 */   GIR_EraseRootFromParent_Done,
     /* 68549 */ // Label 1741: @68549
     /* 68549 */ GIM_Reject,
     /* 68550 */ // Label 73: @68550
     /* 68550 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1748*/ GIMT_Encode4(69054),
     /* 68561 */ /*GILLT_s32*//*Label 1742*/ GIMT_Encode4(68593),
     /* 68565 */ /*GILLT_s64*//*Label 1743*/ GIMT_Encode4(68802), GIMT_Encode4(0),
     /* 68573 */ /*GILLT_v2s64*//*Label 1744*/ GIMT_Encode4(68946), GIMT_Encode4(0),
     /* 68581 */ /*GILLT_v4s32*//*Label 1745*/ GIMT_Encode4(68973),
     /* 68585 */ /*GILLT_v8s16*//*Label 1746*/ GIMT_Encode4(69000),
     /* 68589 */ /*GILLT_v16s8*//*Label 1747*/ GIMT_Encode4(69027),
     /* 68593 */ // Label 1742: @68593
     /* 68593 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(68801),
     /* 68598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68605 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(68651), // Rule ID 109 //
     /* 68610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 68613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 68625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 68629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68634 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68640 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] }))  =>  (CLO:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CLO),
     /* 68643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68649 */     GIR_RootConstrainSelectedInstOperands,
     /* 68650 */     // GIR_Coverage, 109,
     /* 68650 */     GIR_EraseRootFromParent_Done,
     /* 68651 */   // Label 1750: @68651
     /* 68651 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(68697), // Rule ID 310 //
     /* 68656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc),
     /* 68659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 68671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 68675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68680 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68686 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] }))  =>  (CLO_R6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CLO_R6),
     /* 68689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68695 */     GIR_RootConstrainSelectedInstOperands,
     /* 68696 */     // GIR_Coverage, 310,
     /* 68696 */     GIR_EraseRootFromParent_Done,
     /* 68697 */   // Label 1751: @68697
     /* 68697 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(68743), // Rule ID 1100 //
     /* 68702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 68705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 68717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 68721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68726 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68732 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] }))  =>  (CLO_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CLO_MM),
     /* 68735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68741 */     GIR_RootConstrainSelectedInstOperands,
     /* 68742 */     // GIR_Coverage, 1100,
     /* 68742 */     GIR_EraseRootFromParent_Done,
     /* 68743 */   // Label 1752: @68743
     /* 68743 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(68762), // Rule ID 108 //
     /* 68748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 68751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68755 */     // (ctlz:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (CLZ:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CLZ),
     /* 68760 */     GIR_RootConstrainSelectedInstOperands,
     /* 68761 */     // GIR_Coverage, 108,
     /* 68761 */     GIR_Done,
     /* 68762 */   // Label 1753: @68762
     /* 68762 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(68781), // Rule ID 311 //
     /* 68767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc),
     /* 68770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68774 */     // (ctlz:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (CLZ_R6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CLZ_R6),
     /* 68779 */     GIR_RootConstrainSelectedInstOperands,
     /* 68780 */     // GIR_Coverage, 311,
     /* 68780 */     GIR_Done,
     /* 68781 */   // Label 1754: @68781
     /* 68781 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(68800), // Rule ID 1099 //
     /* 68786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 68789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68793 */     // (ctlz:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (CLZ_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CLZ_MM),
     /* 68798 */     GIR_RootConstrainSelectedInstOperands,
     /* 68799 */     // GIR_Coverage, 1099,
     /* 68799 */     GIR_Done,
     /* 68800 */   // Label 1755: @68800
     /* 68800 */   GIM_Reject,
     /* 68801 */ // Label 1749: @68801
     /* 68801 */ GIM_Reject,
     /* 68802 */ // Label 1743: @68802
     /* 68802 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(68945),
     /* 68807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68814 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(68860), // Rule ID 264 //
     /* 68819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips64r6),
     /* 68822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 68834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 68838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68843 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68849 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, -1:{ *:[i64] }))  =>  (DCLO:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DCLO),
     /* 68852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68858 */     GIR_RootConstrainSelectedInstOperands,
     /* 68859 */     // GIR_Coverage, 264,
     /* 68859 */     GIR_EraseRootFromParent_Done,
     /* 68860 */   // Label 1757: @68860
     /* 68860 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(68906), // Rule ID 339 //
     /* 68865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 68868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 68880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 68884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68889 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68895 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, -1:{ *:[i64] }))  =>  (DCLO_R6:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DCLO_R6),
     /* 68898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68904 */     GIR_RootConstrainSelectedInstOperands,
     /* 68905 */     // GIR_Coverage, 339,
     /* 68905 */     GIR_EraseRootFromParent_Done,
     /* 68906 */   // Label 1758: @68906
     /* 68906 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(68925), // Rule ID 263 //
     /* 68911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips64r6),
     /* 68914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68918 */     // (ctlz:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)  =>  (DCLZ:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DCLZ),
     /* 68923 */     GIR_RootConstrainSelectedInstOperands,
     /* 68924 */     // GIR_Coverage, 263,
     /* 68924 */     GIR_Done,
     /* 68925 */   // Label 1759: @68925
     /* 68925 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(68944), // Rule ID 340 //
     /* 68930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 68933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68937 */     // (ctlz:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)  =>  (DCLZ_R6:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DCLZ_R6),
     /* 68942 */     GIR_RootConstrainSelectedInstOperands,
     /* 68943 */     // GIR_Coverage, 340,
     /* 68943 */     GIR_Done,
     /* 68944 */   // Label 1760: @68944
     /* 68944 */   GIM_Reject,
     /* 68945 */ // Label 1756: @68945
     /* 68945 */ GIM_Reject,
     /* 68946 */ // Label 1744: @68946
     /* 68946 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(68972), // Rule ID 915 //
     /* 68951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 68957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68965 */   // (ctlz:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (NLZC_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 68965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_D),
     /* 68970 */   GIR_RootConstrainSelectedInstOperands,
     /* 68971 */   // GIR_Coverage, 915,
     /* 68971 */   GIR_Done,
     /* 68972 */ // Label 1761: @68972
     /* 68972 */ GIM_Reject,
     /* 68973 */ // Label 1745: @68973
     /* 68973 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(68999), // Rule ID 914 //
     /* 68978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68992 */   // (ctlz:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (NLZC_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 68992 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_W),
     /* 68997 */   GIR_RootConstrainSelectedInstOperands,
     /* 68998 */   // GIR_Coverage, 914,
     /* 68998 */   GIR_Done,
     /* 68999 */ // Label 1762: @68999
     /* 68999 */ GIM_Reject,
     /* 69000 */ // Label 1746: @69000
     /* 69000 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(69026), // Rule ID 913 //
     /* 69005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 69011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 69015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 69019 */   // (ctlz:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (NLZC_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 69019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_H),
     /* 69024 */   GIR_RootConstrainSelectedInstOperands,
     /* 69025 */   // GIR_Coverage, 913,
     /* 69025 */   GIR_Done,
     /* 69026 */ // Label 1763: @69026
     /* 69026 */ GIM_Reject,
     /* 69027 */ // Label 1747: @69027
     /* 69027 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(69053), // Rule ID 912 //
     /* 69032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 69038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 69042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 69046 */   // (ctlz:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (NLZC_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)
     /* 69046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_B),
     /* 69051 */   GIR_RootConstrainSelectedInstOperands,
     /* 69052 */   // GIR_Coverage, 912,
     /* 69052 */   GIR_Done,
     /* 69053 */ // Label 1764: @69053
     /* 69053 */ GIM_Reject,
     /* 69054 */ // Label 1748: @69054
     /* 69054 */ GIM_Reject,
     /* 69055 */ // Label 74: @69055
     /* 69055 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1771*/ GIMT_Encode4(69260),
     /* 69066 */ /*GILLT_s32*//*Label 1765*/ GIMT_Encode4(69098),
     /* 69070 */ /*GILLT_s64*//*Label 1766*/ GIMT_Encode4(69125), GIMT_Encode4(0),
     /* 69078 */ /*GILLT_v2s64*//*Label 1767*/ GIMT_Encode4(69152), GIMT_Encode4(0),
     /* 69086 */ /*GILLT_v4s32*//*Label 1768*/ GIMT_Encode4(69179),
     /* 69090 */ /*GILLT_v8s16*//*Label 1769*/ GIMT_Encode4(69206),
     /* 69094 */ /*GILLT_v16s8*//*Label 1770*/ GIMT_Encode4(69233),
     /* 69098 */ // Label 1765: @69098
     /* 69098 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(69124), // Rule ID 278 //
     /* 69103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 69106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 69113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 69117 */   // (ctpop:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (POP:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 69117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::POP),
     /* 69122 */   GIR_RootConstrainSelectedInstOperands,
     /* 69123 */   // GIR_Coverage, 278,
     /* 69123 */   GIR_Done,
     /* 69124 */ // Label 1772: @69124
     /* 69124 */ GIM_Reject,
     /* 69125 */ // Label 1766: @69125
     /* 69125 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(69151), // Rule ID 279 //
     /* 69130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 69133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 69140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 69144 */   // (ctpop:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)  =>  (DPOP:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 69144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DPOP),
     /* 69149 */   GIR_RootConstrainSelectedInstOperands,
     /* 69150 */   // GIR_Coverage, 279,
     /* 69150 */   GIR_Done,
     /* 69151 */ // Label 1773: @69151
     /* 69151 */ GIM_Reject,
     /* 69152 */ // Label 1767: @69152
     /* 69152 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(69178), // Rule ID 937 //
     /* 69157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 69163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69171 */   // (ctpop:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (PCNT_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 69171 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_D),
     /* 69176 */   GIR_RootConstrainSelectedInstOperands,
     /* 69177 */   // GIR_Coverage, 937,
     /* 69177 */   GIR_Done,
     /* 69178 */ // Label 1774: @69178
     /* 69178 */ GIM_Reject,
     /* 69179 */ // Label 1768: @69179
     /* 69179 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(69205), // Rule ID 936 //
     /* 69184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69198 */   // (ctpop:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (PCNT_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 69198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_W),
     /* 69203 */   GIR_RootConstrainSelectedInstOperands,
     /* 69204 */   // GIR_Coverage, 936,
     /* 69204 */   GIR_Done,
     /* 69205 */ // Label 1775: @69205
     /* 69205 */ GIM_Reject,
     /* 69206 */ // Label 1769: @69206
     /* 69206 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(69232), // Rule ID 935 //
     /* 69211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 69217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 69221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 69225 */   // (ctpop:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (PCNT_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 69225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_H),
     /* 69230 */   GIR_RootConstrainSelectedInstOperands,
     /* 69231 */   // GIR_Coverage, 935,
     /* 69231 */   GIR_Done,
     /* 69232 */ // Label 1776: @69232
     /* 69232 */ GIM_Reject,
     /* 69233 */ // Label 1770: @69233
     /* 69233 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(69259), // Rule ID 934 //
     /* 69238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 69244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 69248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 69252 */   // (ctpop:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (PCNT_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)
     /* 69252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_B),
     /* 69257 */   GIR_RootConstrainSelectedInstOperands,
     /* 69258 */   // GIR_Coverage, 934,
     /* 69258 */   GIR_Done,
     /* 69259 */ // Label 1777: @69259
     /* 69259 */ GIM_Reject,
     /* 69260 */ // Label 1771: @69260
     /* 69260 */ GIM_Reject,
     /* 69261 */ // Label 75: @69261
     /* 69261 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1780*/ GIMT_Encode4(69424),
     /* 69272 */ /*GILLT_s32*//*Label 1778*/ GIMT_Encode4(69280),
     /* 69276 */ /*GILLT_s64*//*Label 1779*/ GIMT_Encode4(69376),
     /* 69280 */ // Label 1778: @69280
     /* 69280 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(69375),
     /* 69285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 69292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 69296 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(69335), // Rule ID 1427 //
     /* 69301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 69304 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$rt)  =>  (ROTR:{ *:[i32] } (WSBH:{ *:[i32] } GPR32:{ *:[i32] }:$rt), 16:{ *:[i32] })
     /* 69304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 69307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::WSBH),
     /* 69311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rt
     /* 69320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR),
     /* 69325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 69327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 69333 */     GIR_RootConstrainSelectedInstOperands,
     /* 69334 */     // GIR_Coverage, 1427,
     /* 69334 */     GIR_EraseRootFromParent_Done,
     /* 69335 */   // Label 1782: @69335
     /* 69335 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(69374), // Rule ID 2191 //
     /* 69340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 69343 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$rt)  =>  (ROTR_MM:{ *:[i32] } (WSBH_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rt), 16:{ *:[i32] })
     /* 69343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 69346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::WSBH_MM),
     /* 69350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69355 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rt
     /* 69359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR_MM),
     /* 69364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 69366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 69372 */     GIR_RootConstrainSelectedInstOperands,
     /* 69373 */     // GIR_Coverage, 2191,
     /* 69373 */     GIR_EraseRootFromParent_Done,
     /* 69374 */   // Label 1783: @69374
     /* 69374 */   GIM_Reject,
     /* 69375 */ // Label 1781: @69375
     /* 69375 */ GIM_Reject,
     /* 69376 */ // Label 1779: @69376
     /* 69376 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(69423), // Rule ID 1589 //
     /* 69381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc),
     /* 69384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 69391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 69395 */   // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$rt)  =>  (DSHD:{ *:[i64] } (DSBH:{ *:[i64] } GPR64:{ *:[i64] }:$rt))
     /* 69395 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 69398 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::DSBH),
     /* 69402 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69407 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rt
     /* 69411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSHD),
     /* 69416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 69418 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69421 */   GIR_RootConstrainSelectedInstOperands,
     /* 69422 */   // GIR_Coverage, 1589,
     /* 69422 */   GIR_EraseRootFromParent_Done,
     /* 69423 */ // Label 1784: @69423
     /* 69423 */ GIM_Reject,
     /* 69424 */ // Label 1780: @69424
     /* 69424 */ GIM_Reject,
     /* 69425 */ // Label 76: @69425
     /* 69425 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1789*/ GIMT_Encode4(69664),
     /* 69436 */ /*GILLT_s32*//*Label 1785*/ GIMT_Encode4(69460),
     /* 69440 */ /*GILLT_s64*//*Label 1786*/ GIMT_Encode4(69508), GIMT_Encode4(0),
     /* 69448 */ /*GILLT_v2s64*//*Label 1787*/ GIMT_Encode4(69610), GIMT_Encode4(0),
     /* 69456 */ /*GILLT_v4s32*//*Label 1788*/ GIMT_Encode4(69637),
     /* 69460 */ // Label 1785: @69460
     /* 69460 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(69507),
     /* 69465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 69472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 69476 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(69491), // Rule ID 132 //
     /* 69481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 69484 */     // (fsqrt:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FSQRT_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 69484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_S),
     /* 69489 */     GIR_RootConstrainSelectedInstOperands,
     /* 69490 */     // GIR_Coverage, 132,
     /* 69490 */     GIR_Done,
     /* 69491 */   // Label 1791: @69491
     /* 69491 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(69506), // Rule ID 1162 //
     /* 69496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 69499 */     // (fsqrt:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FSQRT_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 69499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_S_MM),
     /* 69504 */     GIR_RootConstrainSelectedInstOperands,
     /* 69505 */     // GIR_Coverage, 1162,
     /* 69505 */     GIR_Done,
     /* 69506 */   // Label 1792: @69506
     /* 69506 */   GIM_Reject,
     /* 69507 */ // Label 1790: @69507
     /* 69507 */ GIM_Reject,
     /* 69508 */ // Label 1786: @69508
     /* 69508 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(69609),
     /* 69513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69516 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(69539), // Rule ID 133 //
     /* 69521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 69524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69532 */     // (fsqrt:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 69532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D32),
     /* 69537 */     GIR_RootConstrainSelectedInstOperands,
     /* 69538 */     // GIR_Coverage, 133,
     /* 69538 */     GIR_Done,
     /* 69539 */   // Label 1794: @69539
     /* 69539 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(69562), // Rule ID 134 //
     /* 69544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 69547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69555 */     // (fsqrt:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 69555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D64),
     /* 69560 */     GIR_RootConstrainSelectedInstOperands,
     /* 69561 */     // GIR_Coverage, 134,
     /* 69561 */     GIR_Done,
     /* 69562 */   // Label 1795: @69562
     /* 69562 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(69585), // Rule ID 1148 //
     /* 69567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 69570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69578 */     // (fsqrt:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 69578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D32_MM),
     /* 69583 */     GIR_RootConstrainSelectedInstOperands,
     /* 69584 */     // GIR_Coverage, 1148,
     /* 69584 */     GIR_Done,
     /* 69585 */   // Label 1796: @69585
     /* 69585 */   GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(69608), // Rule ID 1149 //
     /* 69590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 69593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69601 */     // (fsqrt:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 69601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D64_MM),
     /* 69606 */     GIR_RootConstrainSelectedInstOperands,
     /* 69607 */     // GIR_Coverage, 1149,
     /* 69607 */     GIR_Done,
     /* 69608 */   // Label 1797: @69608
     /* 69608 */   GIM_Reject,
     /* 69609 */ // Label 1793: @69609
     /* 69609 */ GIM_Reject,
     /* 69610 */ // Label 1787: @69610
     /* 69610 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(69636), // Rule ID 757 //
     /* 69615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 69621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69629 */   // (fsqrt:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FSQRT_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 69629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D),
     /* 69634 */   GIR_RootConstrainSelectedInstOperands,
     /* 69635 */   // GIR_Coverage, 757,
     /* 69635 */   GIR_Done,
     /* 69636 */ // Label 1798: @69636
     /* 69636 */ GIM_Reject,
     /* 69637 */ // Label 1788: @69637
     /* 69637 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(69663), // Rule ID 756 //
     /* 69642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69656 */   // (fsqrt:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FSQRT_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 69656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_W),
     /* 69661 */   GIR_RootConstrainSelectedInstOperands,
     /* 69662 */   // GIR_Coverage, 756,
     /* 69662 */   GIR_Done,
     /* 69663 */ // Label 1799: @69663
     /* 69663 */ GIM_Reject,
     /* 69664 */ // Label 1789: @69664
     /* 69664 */ GIM_Reject,
     /* 69665 */ // Label 77: @69665
     /* 69665 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1802*/ GIMT_Encode4(69742),
     /* 69676 */ /*GILLT_v2s64*//*Label 1800*/ GIMT_Encode4(69688), GIMT_Encode4(0),
     /* 69684 */ /*GILLT_v4s32*//*Label 1801*/ GIMT_Encode4(69715),
     /* 69688 */ // Label 1800: @69688
     /* 69688 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(69714), // Rule ID 739 //
     /* 69693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 69699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69707 */   // (frint:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FRINT_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 69707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FRINT_D),
     /* 69712 */   GIR_RootConstrainSelectedInstOperands,
     /* 69713 */   // GIR_Coverage, 739,
     /* 69713 */   GIR_Done,
     /* 69714 */ // Label 1803: @69714
     /* 69714 */ GIM_Reject,
     /* 69715 */ // Label 1801: @69715
     /* 69715 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(69741), // Rule ID 738 //
     /* 69720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69734 */   // (frint:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FRINT_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 69734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FRINT_W),
     /* 69739 */   GIR_RootConstrainSelectedInstOperands,
     /* 69740 */   // GIR_Coverage, 738,
     /* 69740 */   GIR_Done,
     /* 69741 */ // Label 1804: @69741
     /* 69741 */ GIM_Reject,
     /* 69742 */ // Label 1802: @69742
     /* 69742 */ GIM_Reject,
     /* 69743 */ // Label 78: @69743
     /* 69743 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(69758), // Rule ID 90 //
     /* 69748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 69751 */   // (trap)  =>  (TRAP)
     /* 69751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::TRAP),
     /* 69756 */   GIR_RootConstrainSelectedInstOperands,
     /* 69757 */   // GIR_Coverage, 90,
     /* 69757 */   GIR_Done,
     /* 69758 */ // Label 1805: @69758
     /* 69758 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(69773), // Rule ID 1115 //
     /* 69763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 69766 */   // (trap)  =>  (TRAP_MM)
     /* 69766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::TRAP_MM),
     /* 69771 */   GIR_RootConstrainSelectedInstOperands,
     /* 69772 */   // GIR_Coverage, 1115,
     /* 69772 */   GIR_Done,
     /* 69773 */ // Label 1806: @69773
     /* 69773 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(69788), // Rule ID 1910 //
     /* 69778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 69781 */   // (trap)  =>  (Break16)
     /* 69781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::Break16),
     /* 69786 */   GIR_RootConstrainSelectedInstOperands,
     /* 69787 */   // GIR_Coverage, 1910,
     /* 69787 */   GIR_Done,
     /* 69788 */ // Label 1807: @69788
     /* 69788 */ GIM_Reject,
     /* 69789 */ // Label 79: @69789
     /* 69789 */ GIM_Reject,
     /* 69790 */ }; // Size: 69790 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const MipsSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const MipsSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
